var searchIndex = {};
searchIndex['syntax'] = {"items":[[0,"","syntax","The Rust parser and macro expander.",null,null],[0,"util","","",null,null],[0,"interner","syntax::util","An \"interner\" is a data structure that associates values with usize tags and\nallows bidirectional lookup; i.e. given a value, one can easily find the\ntype, and vice versa.",null,null],[3,"Interner","syntax::util::interner","",null,null],[3,"RcStr","","",null,null],[3,"StrInterner","","A StrInterner differs from Interner<String> in that it accepts\n&str rather than RcStr, resulting in less allocation.",null,null],[11,"new","","",0,{"inputs":[{"name":"interner"}],"output":{"name":"interner"}}],[11,"prefill","","",0,null],[11,"intern","","",0,{"inputs":[{"name":"interner"},{"name":"t"}],"output":{"name":"name"}}],[11,"gensym","","",0,{"inputs":[{"name":"interner"},{"name":"t"}],"output":{"name":"name"}}],[11,"get","","",0,{"inputs":[{"name":"interner"},{"name":"name"}],"output":{"name":"t"}}],[11,"len","","",0,{"inputs":[{"name":"interner"}],"output":{"name":"usize"}}],[11,"find","","",0,{"inputs":[{"name":"interner"},{"name":"q"}],"output":{"name":"option"}}],[11,"clear","","",0,{"inputs":[{"name":"interner"}],"output":null}],[11,"partial_cmp","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"option"}}],[11,"lt","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"le","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"gt","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"ge","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"hash","","",1,null],[11,"eq","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"rcstr"}],"output":{"name":"rcstr"}}],[11,"new","","",1,{"inputs":[{"name":"rcstr"},{"name":"str"}],"output":{"name":"rcstr"}}],[11,"cmp","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"ordering"}}],[11,"fmt","","",1,{"inputs":[{"name":"rcstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"rcstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"borrow","","",1,{"inputs":[{"name":"rcstr"}],"output":{"name":"str"}}],[6,"Target","","",null,null],[11,"deref","","",1,{"inputs":[{"name":"rcstr"}],"output":{"name":"str"}}],[11,"new","","",2,{"inputs":[{"name":"strinterner"}],"output":{"name":"strinterner"}}],[11,"prefill","","",2,null],[11,"intern","","",2,{"inputs":[{"name":"strinterner"},{"name":"str"}],"output":{"name":"name"}}],[11,"gensym","","",2,{"inputs":[{"name":"strinterner"},{"name":"str"}],"output":{"name":"name"}}],[11,"gensym_copy","","Create a gensym with the same name as an existing\nentry.",2,{"inputs":[{"name":"strinterner"},{"name":"name"}],"output":{"name":"name"}}],[11,"get","","",2,{"inputs":[{"name":"strinterner"},{"name":"name"}],"output":{"name":"rcstr"}}],[11,"len","","",2,{"inputs":[{"name":"strinterner"}],"output":{"name":"usize"}}],[11,"find","","",2,{"inputs":[{"name":"strinterner"},{"name":"q"}],"output":{"name":"option"}}],[11,"clear","","",2,{"inputs":[{"name":"strinterner"}],"output":null}],[11,"reset","","",2,{"inputs":[{"name":"strinterner"},{"name":"strinterner"}],"output":null}],[0,"small_vector","syntax::util","",null,null],[3,"SmallVector","syntax::util::small_vector","A vector type optimized for cases where the size is almost always 0 or 1",null,null],[3,"IntoIter","","",null,null],[11,"from_iter","","",3,{"inputs":[{"name":"smallvector"},{"name":"i"}],"output":{"name":"smallvector"}}],[11,"extend","","",3,{"inputs":[{"name":"smallvector"},{"name":"i"}],"output":null}],[11,"zero","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"smallvector"}}],[11,"one","","",3,{"inputs":[{"name":"smallvector"},{"name":"t"}],"output":{"name":"smallvector"}}],[11,"many","","",3,{"inputs":[{"name":"smallvector"},{"name":"vec"}],"output":{"name":"smallvector"}}],[11,"as_slice","","",3,null],[11,"pop","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"option"}}],[11,"push","","",3,{"inputs":[{"name":"smallvector"},{"name":"t"}],"output":null}],[11,"push_all","","",3,{"inputs":[{"name":"smallvector"},{"name":"smallvector"}],"output":null}],[11,"get","","",3,{"inputs":[{"name":"smallvector"},{"name":"usize"}],"output":{"name":"t"}}],[11,"expect_one","","",3,{"inputs":[{"name":"smallvector"},{"name":"str"}],"output":{"name":"t"}}],[11,"move_iter","","Deprecated: use `into_iter`.",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"intoiter"}}],[11,"into_iter","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"intoiter"}}],[11,"len","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"usize"}}],[11,"is_empty","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"bool"}}],[6,"Item","","",null,null],[11,"next","","",4,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",4,null],[11,"move_map","","",3,{"inputs":[{"name":"smallvector"},{"name":"f"}],"output":{"name":"smallvector"}}],[0,"diagnostics","syntax","",null,null],[0,"plugin","syntax::diagnostics","",null,null],[5,"expand_diagnostic_used","syntax::diagnostics::plugin","",null,null],[5,"expand_register_diagnostic","","",null,null],[5,"expand_build_diagnostic_array","","",null,null],[0,"registry","syntax::diagnostics","",null,null],[3,"Registry","syntax::diagnostics::registry","",null,null],[11,"clone","","",5,{"inputs":[{"name":"registry"}],"output":{"name":"registry"}}],[11,"new","","",5,null],[11,"find_description","","",5,{"inputs":[{"name":"registry"},{"name":"str"}],"output":{"name":"option"}}],[0,"syntax","syntax","",null,null],[0,"abi","","",null,null],[3,"AbiData","syntax::abi","",null,null],[4,"Os","","",null,null],[13,"OsWindows","","",6,null],[13,"OsMacos","","",6,null],[13,"OsLinux","","",6,null],[13,"OsAndroid","","",6,null],[13,"OsFreebsd","","",6,null],[13,"OsiOS","","",6,null],[13,"OsDragonfly","","",6,null],[13,"OsBitrig","","",6,null],[13,"OsOpenbsd","","",6,null],[4,"Abi","","",null,null],[13,"Cdecl","","",7,null],[13,"Stdcall","","",7,null],[13,"Fastcall","","",7,null],[13,"Aapcs","","",7,null],[13,"Win64","","",7,null],[13,"Rust","","",7,null],[13,"C","","",7,null],[13,"System","","",7,null],[13,"RustIntrinsic","","",7,null],[13,"RustCall","","",7,null],[4,"Architecture","","",null,null],[13,"X86","","",8,null],[13,"X86_64","","",8,null],[13,"Arm","","",8,null],[13,"Mips","","",8,null],[13,"Mipsel","","",8,null],[4,"AbiArchitecture","","",null,null],[13,"RustArch","","Not a real ABI (e.g., intrinsic)",9,null],[13,"AllArch","","An ABI that specifies cross-platform defaults (e.g., \"C\")",9,null],[13,"Archs","","Multiple architectures (bitset)",9,null],[5,"lookup","","Returns the ABI with the given name (if any).",null,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[5,"all_names","","",null,{"inputs":[],"output":{"name":"vec"}}],[11,"fmt","","",6,{"inputs":[{"name":"os"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",6,{"inputs":[{"name":"os"},{"name":"os"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"os"},{"name":"os"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"os"}],"output":{"name":"os"}}],[11,"fmt","","",7,{"inputs":[{"name":"abi"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",7,{"inputs":[{"name":"abi"}],"output":{"name":"abi"}}],[11,"decode","","",7,{"inputs":[{"name":"abi"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",7,{"inputs":[{"name":"abi"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",7,null],[11,"eq","","",7,{"inputs":[{"name":"abi"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"abi"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"fmt","","",8,{"inputs":[{"name":"architecture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",8,{"inputs":[{"name":"architecture"},{"name":"architecture"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"architecture"},{"name":"architecture"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"architecture"}],"output":{"name":"architecture"}}],[11,"clone","","",10,{"inputs":[{"name":"abidata"}],"output":{"name":"abidata"}}],[11,"clone","","",9,{"inputs":[{"name":"abiarchitecture"}],"output":{"name":"abiarchitecture"}}],[11,"index","","",7,{"inputs":[{"name":"abi"}],"output":{"name":"usize"}}],[11,"data","","",7,{"inputs":[{"name":"abi"}],"output":{"name":"abidata"}}],[11,"name","","",7,{"inputs":[{"name":"abi"}],"output":{"name":"str"}}],[11,"fmt","","",7,{"inputs":[{"name":"abi"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",6,{"inputs":[{"name":"os"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"ast","syntax","",null,null],[3,"Ident","syntax::ast","An identifier contains a Name (index into the interner\ntable) and a SyntaxContext to track renaming and\nmacro expansion per Flatt et al., \"Macros\nThat Work Together\"",null,null],[12,"name","","",11,null],[12,"ctxt","","",11,null],[3,"Name","","A name is a part of an identifier, representing a string or gensym. It's\nthe result of interning.",null,null],[3,"Lifetime","","",null,null],[12,"id","","",12,null],[12,"span","","",12,null],[12,"name","","",12,null],[3,"LifetimeDef","","A lifetime definition, eg `'a: 'b+'c+'d`",null,null],[12,"lifetime","","",13,null],[12,"bounds","","",13,null],[3,"Path","","A \"Path\" is essentially Rust's notion of a name; for instance:\nstd::cmp::PartialEq  .  It's represented as a sequence of identifiers,\nalong with a bunch of supporting information.",null,null],[12,"span","","",14,null],[12,"global","","A `::foo` path, is relative to the crate root rather than current\nmodule (like paths in an import).",14,null],[12,"segments","","The segments in the path: the things separated by `::`.",14,null],[3,"PathSegment","","A segment of a path: an identifier, an optional lifetime, and a set of\ntypes.",null,null],[12,"identifier","","The identifier portion of this path segment.",15,null],[12,"parameters","","Type/lifetime parameters attached to this path. They come in\ntwo flavors: `Path<A,B,C>` and `Path(A,B) -> C`. Note that\nthis is more than just simple syntactic sugar; the use of\nparens affects the region binding rules, so we preserve the\ndistinction.",15,null],[3,"AngleBracketedParameterData","","A path like `Foo<'a, T>`",null,null],[12,"lifetimes","","The lifetime parameters for this path segment.",16,null],[12,"types","","The type parameters for this path segment, if present.",16,null],[12,"bindings","","Bindings (equality constraints) on associated types, if present.\nE.g., `Foo<A=Bar>`.",16,null],[3,"ParenthesizedParameterData","","A path like `Foo(A,B) -> C`",null,null],[12,"span","","Overall span",17,null],[12,"inputs","","`(A,B)`",17,null],[12,"output","","`C`",17,null],[3,"DefId","","",null,null],[12,"krate","","",18,null],[12,"node","","",18,null],[3,"TyParam","","",null,null],[12,"ident","","",19,null],[12,"id","","",19,null],[12,"bounds","","",19,null],[12,"default","","",19,null],[12,"span","","",19,null],[3,"Generics","","Represents lifetimes and type parameters attached to a declaration\nof a function, enum, trait, etc.",null,null],[12,"lifetimes","","",20,null],[12,"ty_params","","",20,null],[12,"where_clause","","",20,null],[3,"WhereClause","","A `where` clause in a definition",null,null],[12,"id","","",21,null],[12,"predicates","","",21,null],[3,"WhereBoundPredicate","","A type bound, eg `for<'c> Foo: Send+Clone+'c`",null,null],[12,"span","","",22,null],[12,"bound_lifetimes","","Any lifetimes from a `for` binding",22,null],[12,"bounded_ty","","The type being bounded",22,null],[12,"bounds","","Trait and lifetime bounds (`Clone+Send+'static`)",22,null],[3,"WhereRegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",null,null],[12,"span","","",23,null],[12,"lifetime","","",23,null],[12,"bounds","","",23,null],[3,"WhereEqPredicate","","An equality predicate (unsupported), e.g. `T=int`",null,null],[12,"id","","",24,null],[12,"span","","",24,null],[12,"path","","",24,null],[12,"ty","","",24,null],[3,"Crate","","",null,null],[12,"module","","",25,null],[12,"attrs","","",25,null],[12,"config","","",25,null],[12,"span","","",25,null],[12,"exported_macros","","",25,null],[3,"Block","","",null,null],[12,"stmts","","Statements in a block",26,null],[12,"expr","","An expression at the end of the block\nwithout a semicolon, if any",26,null],[12,"id","","",26,null],[12,"rules","","Distinguishes between `unsafe { ... }` and `{ ... }`",26,null],[12,"span","","",26,null],[3,"Pat","","",null,null],[12,"id","","",27,null],[12,"node","","",27,null],[12,"span","","",27,null],[3,"FieldPat","","A single field in a struct pattern",null,null],[12,"ident","","The identifier for the field",28,null],[12,"pat","","The pattern the field is destructured to",28,null],[12,"is_shorthand","","",28,null],[3,"Local","","Local represents a `let` statement, e.g., `let <pat>:<ty> = <expr>;`",null,null],[12,"pat","","",29,null],[12,"ty","","",29,null],[12,"init","","Initializer expression to set the value, if any",29,null],[12,"id","","",29,null],[12,"span","","",29,null],[12,"source","","",29,null],[3,"Arm","","represents one arm of a 'match'",null,null],[12,"attrs","","",30,null],[12,"pats","","",30,null],[12,"guard","","",30,null],[12,"body","","",30,null],[3,"Field","","",null,null],[12,"ident","","",31,null],[12,"expr","","",31,null],[12,"span","","",31,null],[3,"Expr","","An expression",null,null],[12,"id","","",32,null],[12,"node","","",32,null],[12,"span","","",32,null],[3,"QSelf","","The explicit Self type in a \"qualified path\". The actual\npath, including the trait and the associated item, is stored\nseparately. `position` represents the index of the associated\nitem qualified with this Self type.",null,null],[12,"ty","","",33,null],[12,"position","","",33,null],[3,"Delimited","","A delimited sequence of token trees",null,null],[12,"delim","","The type of delimiter",34,null],[12,"open_span","","The span covering the opening delimiter",34,null],[12,"tts","","The delimited sequence of token trees",34,null],[12,"close_span","","The span covering the closing delimiter",34,null],[3,"SequenceRepetition","","A sequence of token treesee",null,null],[12,"tts","","The sequence of token trees",35,null],[12,"separator","","The optional separator",35,null],[12,"op","","Whether the sequence can be repeated zero (*), or one or more times (+)",35,null],[12,"num_captures","","The number of `MatchNt`s that appear in the sequence (and subsequences)",35,null],[3,"MutTy","","",null,null],[12,"ty","","",36,null],[12,"mutbl","","",36,null],[3,"TypeField","","",null,null],[12,"ident","","",37,null],[12,"mt","","",37,null],[12,"span","","",37,null],[3,"MethodSig","","Represents a method's signature in a trait declaration,\nor in an implementation.",null,null],[12,"unsafety","","",38,null],[12,"abi","","",38,null],[12,"decl","","",38,null],[12,"generics","","",38,null],[12,"explicit_self","","",38,null],[3,"TraitItem","","Represents a method declaration in a trait declaration, possibly including\na default implementation A trait method is either required (meaning it\ndoesn't have an implementation, just a signature) or provided (meaning it\nhas a default implementation).",null,null],[12,"id","","",39,null],[12,"ident","","",39,null],[12,"attrs","","",39,null],[12,"node","","",39,null],[12,"span","","",39,null],[3,"ImplItem","","",null,null],[12,"id","","",40,null],[12,"ident","","",40,null],[12,"vis","","",40,null],[12,"attrs","","",40,null],[12,"node","","",40,null],[12,"span","","",40,null],[3,"TypeBinding","","",null,null],[12,"id","","",41,null],[12,"ident","","",41,null],[12,"ty","","",41,null],[12,"span","","",41,null],[3,"Ty","","",null,null],[12,"id","","",42,null],[12,"node","","",42,null],[12,"span","","",42,null],[3,"BareFnTy","","",null,null],[12,"unsafety","","",43,null],[12,"abi","","",43,null],[12,"lifetimes","","",43,null],[12,"decl","","",43,null],[3,"InlineAsm","","",null,null],[12,"asm","","",44,null],[12,"asm_str_style","","",44,null],[12,"outputs","","",44,null],[12,"inputs","","",44,null],[12,"clobbers","","",44,null],[12,"volatile","","",44,null],[12,"alignstack","","",44,null],[12,"dialect","","",44,null],[12,"expn_id","","",44,null],[3,"Arg","","represents an argument in a function header",null,null],[12,"ty","","",45,null],[12,"pat","","",45,null],[12,"id","","",45,null],[3,"FnDecl","","Represents the header (not the body) of a function declaration",null,null],[12,"inputs","","",46,null],[12,"output","","",46,null],[12,"variadic","","",46,null],[3,"Mod","","",null,null],[12,"inner","","A span from the first token past `{` to the last token until `}`.\nFor `mod foo;`, the inner span ranges from the first token\nto the last token in the external file.",47,null],[12,"items","","",47,null],[3,"ForeignMod","","",null,null],[12,"abi","","",48,null],[12,"items","","",48,null],[3,"VariantArg","","",null,null],[12,"ty","","",49,null],[12,"id","","",49,null],[3,"EnumDef","","",null,null],[12,"variants","","",50,null],[3,"Variant_","","",null,null],[12,"name","","",51,null],[12,"attrs","","",51,null],[12,"kind","","",51,null],[12,"id","","",51,null],[12,"disr_expr","","Explicit discriminant, eg `Foo = 1`",51,null],[12,"vis","","",51,null],[3,"AttrId","","",null,null],[3,"Attribute_","","Doc-comments are promoted to attributes that have is_sugared_doc = true",null,null],[12,"id","","",52,null],[12,"style","","",52,null],[12,"value","","",52,null],[12,"is_sugared_doc","","",52,null],[3,"TraitRef","","TraitRef's appear in impls.",null,null],[12,"path","","",53,null],[12,"ref_id","","",53,null],[3,"PolyTraitRef","","",null,null],[12,"bound_lifetimes","","The `'a` in `<'a> Foo<&'a T>`",54,null],[12,"trait_ref","","The `Foo<&'a T>` in `<'a> Foo<&'a T>`",54,null],[12,"span","","",54,null],[3,"StructField_","","",null,null],[12,"kind","","",55,null],[12,"id","","",55,null],[12,"ty","","",55,null],[12,"attrs","","",55,null],[3,"StructDef","","",null,null],[12,"fields","","Fields, not including ctor",56,null],[12,"ctor_id","","ID of the constructor. This is only used for tuple- or enum-like\nstructs.",56,null],[3,"Item","","An item",null,null],[12,"ident","","",57,null],[12,"attrs","","",57,null],[12,"id","","",57,null],[12,"node","","",57,null],[12,"vis","","",57,null],[12,"span","","",57,null],[3,"ForeignItem","","",null,null],[12,"ident","","",58,null],[12,"attrs","","",58,null],[12,"node","","",58,null],[12,"id","","",58,null],[12,"span","","",58,null],[12,"vis","","",58,null],[3,"MacroDef","","A macro definition, in this crate or imported from another.",null,null],[12,"ident","","",59,null],[12,"attrs","","",59,null],[12,"id","","",59,null],[12,"span","","",59,null],[12,"imported_from","","",59,null],[12,"export","","",59,null],[12,"use_locally","","",59,null],[12,"allow_internal_unstable","","",59,null],[12,"body","","",59,null],[4,"PathParameters","","",null,null],[13,"AngleBracketedParameters","","The `<'a, A,B,C>` in `foo::bar::baz::<'a, A,B,C>`",60,null],[13,"ParenthesizedParameters","","The `(A,B)` and `C` in `Foo(A,B) -> C`",60,null],[4,"TyParamBound","","The AST represents all type param bounds as types.\ntypeck::collect::compute_bounds matches these against\nthe \"special\" built-in traits (see middle::lang_items) and\ndetects Copy, Send and Sync.",null,null],[13,"TraitTyParamBound","","",61,null],[13,"RegionTyParamBound","","",61,null],[4,"TraitBoundModifier","","A modifier on a bound, currently this is only used for `?Sized`, where the\nmodifier is `Maybe`. Negative bounds should also be handled here.",null,null],[13,"None","","",62,null],[13,"Maybe","","",62,null],[4,"WherePredicate","","A single predicate in a `where` clause",null,null],[13,"BoundPredicate","","A type binding, eg `for<'c> Foo: Send+Clone+'c`",63,null],[13,"RegionPredicate","","A lifetime predicate, e.g. `'a: 'b+'c`",63,null],[13,"EqPredicate","","An equality predicate (unsupported)",63,null],[4,"MetaItem_","","",null,null],[13,"MetaWord","","",64,null],[13,"MetaList","","",64,null],[13,"MetaNameValue","","",64,null],[4,"BindingMode","","",null,null],[13,"BindByRef","","",65,null],[13,"BindByValue","","",65,null],[4,"PatWildKind","","",null,null],[13,"PatWildSingle","","Represents the wildcard pattern `_`",66,null],[13,"PatWildMulti","","Represents the wildcard pattern `..`",66,null],[4,"Pat_","","",null,null],[13,"PatWild","","Represents a wildcard pattern (either `_` or `..`)",67,null],[13,"PatIdent","","A PatIdent may either be a new bound variable,\nor a nullary enum (in which case the third field\nis None).",67,null],[13,"PatEnum","","\"None\" means a * pattern where we don't bind the fields to names.",67,null],[13,"PatStruct","","Destructuring of a struct, e.g. `Foo {x, y, ..}`\nThe `bool` is `true` in the presence of a `..`",67,null],[13,"PatTup","","A tuple pattern `(a, b)`",67,null],[13,"PatBox","","A `box` pattern",67,null],[13,"PatRegion","","A reference pattern, e.g. `&mut (a, b)`",67,null],[13,"PatLit","","A literal",67,null],[13,"PatRange","","A range pattern, e.g. `1...2`",67,null],[13,"PatVec","","[a, b, ..i, y, z] is represented as:\nPatVec(box [a, b], Some(i), box [y, z])",67,null],[13,"PatMac","","A macro pattern; pre-expansion",67,null],[4,"Mutability","","",null,null],[13,"MutMutable","","",68,null],[13,"MutImmutable","","",68,null],[4,"BinOp_","","",null,null],[13,"BiAdd","","The `+` operator (addition)",69,null],[13,"BiSub","","The `-` operator (subtraction)",69,null],[13,"BiMul","","The `*` operator (multiplication)",69,null],[13,"BiDiv","","The `/` operator (division)",69,null],[13,"BiRem","","The `%` operator (modulus)",69,null],[13,"BiAnd","","The `&&` operator (logical and)",69,null],[13,"BiOr","","The `||` operator (logical or)",69,null],[13,"BiBitXor","","The `^` operator (bitwise xor)",69,null],[13,"BiBitAnd","","The `&` operator (bitwise and)",69,null],[13,"BiBitOr","","The `|` operator (bitwise or)",69,null],[13,"BiShl","","The `<<` operator (shift left)",69,null],[13,"BiShr","","The `>>` operator (shift right)",69,null],[13,"BiEq","","The `==` operator (equality)",69,null],[13,"BiLt","","The `<` operator (less than)",69,null],[13,"BiLe","","The `<=` operator (less than or equal to)",69,null],[13,"BiNe","","The `!=` operator (not equal to)",69,null],[13,"BiGe","","The `>=` operator (greater than or equal to)",69,null],[13,"BiGt","","The `>` operator (greater than)",69,null],[4,"UnOp","","",null,null],[13,"UnUniq","","The `box` operator",70,null],[13,"UnDeref","","The `*` operator for dereferencing",70,null],[13,"UnNot","","The `!` operator for logical inversion",70,null],[13,"UnNeg","","The `-` operator for negation",70,null],[4,"Stmt_","","",null,null],[13,"StmtDecl","","Could be an item or a local (let) binding:",71,null],[13,"StmtExpr","","Expr without trailing semi-colon (must have unit type):",71,null],[13,"StmtSemi","","Expr with trailing semi-colon (may have any type):",71,null],[13,"StmtMac","","",71,null],[4,"MacStmtStyle","","",null,null],[13,"MacStmtWithSemicolon","","The macro statement had a trailing semicolon, e.g. `foo! { ... };`\n`foo!(...);`, `foo![...];`",72,null],[13,"MacStmtWithBraces","","The macro statement had braces; e.g. foo! { ... }",72,null],[13,"MacStmtWithoutBraces","","The macro statement had parentheses or brackets and no semicolon; e.g.\n`foo!(...)`. All of these will end up being converted into macro\nexpressions.",72,null],[4,"LocalSource","","Where a local declaration came from: either a true `let ... =\n...;`, or one desugared from the pattern of a for loop.",null,null],[13,"LocalLet","","",73,null],[13,"LocalFor","","",73,null],[4,"Decl_","","",null,null],[13,"DeclLocal","","A local (let) binding:",74,null],[13,"DeclItem","","An item binding:",74,null],[4,"BlockCheckMode","","",null,null],[13,"DefaultBlock","","",75,null],[13,"UnsafeBlock","","",75,null],[4,"UnsafeSource","","",null,null],[13,"CompilerGenerated","","",76,null],[13,"UserProvided","","",76,null],[4,"Expr_","","",null,null],[13,"ExprBox","","First expr is the place; second expr is the value.",77,null],[13,"ExprVec","","An array (`[a, b, c, d]`)",77,null],[13,"ExprCall","","A function call",77,null],[13,"ExprMethodCall","","A method call (`x.foo::<Bar, Baz>(a, b, c, d)`)",77,null],[13,"ExprTup","","A tuple (`(a, b, c ,d)`)",77,null],[13,"ExprBinary","","A binary operation (For example: `a + b`, `a * b`)",77,null],[13,"ExprUnary","","A unary operation (For example: `!x`, `*x`)",77,null],[13,"ExprLit","","A literal (For example: `1u8`, `\"foo\"`)",77,null],[13,"ExprCast","","A cast (`foo as f64`)",77,null],[13,"ExprIf","","An `if` block, with an optional else block",77,null],[13,"ExprIfLet","","An `if let` expression with an optional else block",77,null],[13,"ExprWhile","","A while loop, with an optional label",77,null],[13,"ExprWhileLet","","A while-let loop, with an optional label",77,null],[13,"ExprForLoop","","A for loop, with an optional label",77,null],[13,"ExprLoop","","Conditionless loop (can be exited with break, continue, or return)",77,null],[13,"ExprMatch","","A `match` block, with a source that indicates whether or not it is\nthe result of a desugaring, and if so, which kind.",77,null],[13,"ExprClosure","","A closure (for example, `move |a, b, c| {a + b + c}`)",77,null],[13,"ExprBlock","","A block (`{ ... }`)",77,null],[13,"ExprAssign","","An assignment (`a = foo()`)",77,null],[13,"ExprAssignOp","","An assignment with an operator",77,null],[13,"ExprField","","Access of a named struct field (`obj.foo`)",77,null],[13,"ExprTupField","","Access of an unnamed field of a struct or tuple-struct",77,null],[13,"ExprIndex","","An indexing operation (`foo[2]`)",77,null],[13,"ExprRange","","A range (`1..2`, `1..`, or `..2`)",77,null],[13,"ExprPath","","Variable reference, possibly containing `::` and/or type\nparameters, e.g. foo::bar::<baz>.",77,null],[13,"ExprAddrOf","","A referencing operation (`&a` or `&mut a`)",77,null],[13,"ExprBreak","","A `break`, with an optional label to break",77,null],[13,"ExprAgain","","A `continue`, with an optional label",77,null],[13,"ExprRet","","A `return`, with an optional value to be returned",77,null],[13,"ExprInlineAsm","","Output of the `asm!()` macro",77,null],[13,"ExprMac","","A macro invocation; pre-expansion",77,null],[13,"ExprStruct","","A struct literal expression.",77,null],[13,"ExprRepeat","","A vector literal constructed from one repeated element.",77,null],[13,"ExprParen","","No-op: used solely so we can pretty-print faithfully",77,null],[4,"MatchSource","","",null,null],[13,"Normal","","",78,null],[13,"IfLetDesugar","","",78,null],[12,"contains_else_clause","syntax::ast::MatchSource","",78,null],[13,"WhileLetDesugar","syntax::ast","",78,null],[13,"ForLoopDesugar","","",78,null],[4,"CaptureClause","","",null,null],[13,"CaptureByValue","","",79,null],[13,"CaptureByRef","","",79,null],[4,"KleeneOp","","A Kleene-style [repetition operator](http://en.wikipedia.org/wiki/Kleene_star)\nfor token sequences.",null,null],[13,"ZeroOrMore","","",80,null],[13,"OneOrMore","","",80,null],[4,"TokenTree","","When the main rust parser encounters a syntax-extension invocation, it\nparses the arguments to the invocation as a token-tree. This is a very\nloose structure, such that all sorts of different AST-fragments can\nbe passed to syntax extensions using a uniform type.",null,null],[13,"TtToken","","A single token",81,null],[13,"TtDelimited","","A delimited sequence of token trees",81,null],[13,"TtSequence","","A kleene-style repetition sequence with a span",81,null],[4,"Mac_","","Represents a macro invocation. The Path indicates which macro\nis being invoked, and the vector of token-trees contains the source\nof the macro invocation.",null,null],[13,"MacInvocTT","","",82,null],[4,"StrStyle","","",null,null],[13,"CookedStr","","A regular string, like `\"foo\"`",83,null],[13,"RawStr","","A raw string, like `r##\"foo\"##`",83,null],[4,"Sign","","",null,null],[13,"Minus","","",84,null],[13,"Plus","","",84,null],[4,"LitIntType","","",null,null],[13,"SignedIntLit","","",85,null],[13,"UnsignedIntLit","","",85,null],[13,"UnsuffixedIntLit","","",85,null],[4,"Lit_","","",null,null],[13,"LitStr","","A string literal (`\"foo\"`)",86,null],[13,"LitBinary","","A byte string (`b\"foo\"`)",86,null],[13,"LitByte","","A byte char (`b'f'`)",86,null],[13,"LitChar","","A character literal (`'a'`)",86,null],[13,"LitInt","","An integer literal (`1u8`)",86,null],[13,"LitFloat","","A float literal (`1f64` or `1E10f64`)",86,null],[13,"LitFloatUnsuffixed","","A float literal without a suffix (`1.0 or 1.0E10`)",86,null],[13,"LitBool","","A boolean literal",86,null],[4,"TraitItem_","","",null,null],[13,"MethodTraitItem","","",87,null],[13,"TypeTraitItem","","",87,null],[4,"ImplItem_","","",null,null],[13,"MethodImplItem","","",88,null],[13,"TypeImplItem","","",88,null],[13,"MacImplItem","","",88,null],[4,"IntTy","","",null,null],[13,"TyIs","","",89,null],[13,"TyI8","","",89,null],[13,"TyI16","","",89,null],[13,"TyI32","","",89,null],[13,"TyI64","","",89,null],[4,"UintTy","","",null,null],[13,"TyUs","","",90,null],[13,"TyU8","","",90,null],[13,"TyU16","","",90,null],[13,"TyU32","","",90,null],[13,"TyU64","","",90,null],[4,"FloatTy","","",null,null],[13,"TyF32","","",91,null],[13,"TyF64","","",91,null],[4,"PrimTy","","Not represented directly in the AST, referred to by name through a ty_path.",null,null],[13,"TyInt","","",92,null],[13,"TyUint","","",92,null],[13,"TyFloat","","",92,null],[13,"TyStr","","",92,null],[13,"TyBool","","",92,null],[13,"TyChar","","",92,null],[4,"Ty_","","The different kinds of types recognized by the compiler",null,null],[13,"TyVec","","",93,null],[13,"TyFixedLengthVec","","A fixed length array (`[T; n]`)",93,null],[13,"TyPtr","","A raw pointer (`*const T` or `*mut T`)",93,null],[13,"TyRptr","","A reference (`&'a T` or `&'a mut T`)",93,null],[13,"TyBareFn","","A bare function (e.g. `fn(usize) -> bool`)",93,null],[13,"TyTup","","A tuple (`(A, B, C, D,...)`)",93,null],[13,"TyPath","","A path (`module::module::...::Type`), optionally\n\"qualified\", e.g. `<Vec<T> as SomeTrait>::SomeType`.",93,null],[13,"TyObjectSum","","Something like `A+B`. Note that `B` must always be a path.",93,null],[13,"TyPolyTraitRef","","A type like `for<'a> Foo<&'a Bar>`",93,null],[13,"TyParen","","No-op; kept solely so that we can pretty-print faithfully",93,null],[13,"TyTypeof","","Unused for now",93,null],[13,"TyInfer","","TyInfer means the type should be inferred instead of it having been\nspecified. This can appear anywhere in a type.",93,null],[4,"AsmDialect","","",null,null],[13,"AsmAtt","","",94,null],[13,"AsmIntel","","",94,null],[4,"Unsafety","","",null,null],[13,"Unsafe","","",95,null],[13,"Normal","","",95,null],[4,"ImplPolarity","","",null,null],[13,"Positive","","`impl Trait for Type`",96,null],[13,"Negative","","`impl !Trait for Type`",96,null],[4,"FunctionRetTy","","",null,null],[13,"NoReturn","","Functions with return type `!`that always\nraise an error or exit (i.e. never return to the caller)",97,null],[13,"DefaultReturn","","Return type is not specified.",97,null],[13,"Return","","Everything else",97,null],[4,"ExplicitSelf_","","Represents the kind of 'self' associated with a method",null,null],[13,"SelfStatic","","No self",98,null],[13,"SelfValue","","`self`",98,null],[13,"SelfRegion","","`&'lt self`, `&'lt mut self`",98,null],[13,"SelfExplicit","","`self: TYPE`",98,null],[4,"VariantKind","","",null,null],[13,"TupleVariantKind","","Tuple variant, e.g. `Foo(A, B)`",99,null],[13,"StructVariantKind","","Struct variant, e.g. `Foo {x: A, y: B}`",99,null],[4,"PathListItem_","","",null,null],[13,"PathListIdent","","",100,null],[12,"name","syntax::ast::PathListItem_","",100,null],[12,"id","","",100,null],[13,"PathListMod","syntax::ast","",100,null],[12,"id","syntax::ast::PathListItem_","",100,null],[4,"ViewPath_","syntax::ast","",null,null],[13,"ViewPathSimple","","`foo::bar::baz as quux`",101,null],[13,"ViewPathGlob","","`foo::bar::*`",101,null],[13,"ViewPathList","","`foo::bar::{a,b,c}`",101,null],[4,"AttrStyle","","Distinguishes between Attributes that decorate items and Attributes that\nare contained as statements within items. These two cases need to be\ndistinguished for pretty-printing.",null,null],[13,"AttrOuter","","",102,null],[13,"AttrInner","","",102,null],[4,"Visibility","","",null,null],[13,"Public","","",103,null],[13,"Inherited","","",103,null],[4,"StructFieldKind","","",null,null],[13,"NamedField","","",104,null],[13,"UnnamedField","","Element of a tuple-like struct",104,null],[4,"Item_","","",null,null],[13,"ItemExternCrate","","An`extern crate` item, with optional original crate name,",105,null],[13,"ItemUse","","A `use` or `pub use` item",105,null],[13,"ItemStatic","","A `static` item",105,null],[13,"ItemConst","","A `const` item",105,null],[13,"ItemFn","","A function declaration",105,null],[13,"ItemMod","","A module",105,null],[13,"ItemForeignMod","","An external module",105,null],[13,"ItemTy","","A type alias, e.g. `type Foo = Bar<u8>`",105,null],[13,"ItemEnum","","An enum definition, e.g. `enum Foo<A, B> {C<A>, D<B>}`",105,null],[13,"ItemStruct","","A struct definition, e.g. `struct Foo<A> {x: A}`",105,null],[13,"ItemTrait","","Represents a Trait Declaration",105,null],[13,"ItemDefaultImpl","","",105,null],[13,"ItemImpl","","An implementation, eg `impl<A> Trait for Foo { .. }`",105,null],[13,"ItemMac","","A macro invocation (which includes macro definition)",105,null],[4,"ForeignItem_","","An item within an `extern` block",null,null],[13,"ForeignItemFn","","A foreign function",106,null],[13,"ForeignItemStatic","","A foreign static item (`static ext: u8`), with optional mutability\n(the boolean is true when mutable)",106,null],[4,"InlinedItem","","The data we save and restore about an inlined item or method.  This is not\npart of the AST that we parse from a file, but it becomes part of the tree\nthat we trans.",null,null],[13,"IIItem","","",107,null],[13,"IITraitItem","","",107,null],[13,"IIImplItem","","",107,null],[13,"IIForeign","","",107,null],[6,"SyntaxContext","","A SyntaxContext represents a chain of macro-expandings\nand renamings. Each macro expansion corresponds to\na fresh u32",null,null],[6,"Mrk","","A mark represents a unique id associated with a macro expansion",null,null],[6,"FnIdent","","Function name (not all functions have names)",null,null],[6,"CrateNum","","",null,null],[6,"NodeId","","",null,null],[6,"TyParamBounds","","",null,null],[6,"CrateConfig","","The set of MetaItems that define the compilation environment of the crate,\nused to drive conditional compilation",null,null],[6,"MetaItem","","",null,null],[6,"BinOp","","",null,null],[6,"Stmt","","A statement",null,null],[6,"Decl","","",null,null],[6,"SpannedIdent","","",null,null],[6,"Mac","","",null,null],[6,"Lit","","A literal",null,null],[6,"ExplicitSelf","","",null,null],[6,"Variant","","",null,null],[6,"PathListItem","","",null,null],[6,"ViewPath","","",null,null],[6,"Attribute","","Meta-data associated with an item",null,null],[6,"StructField","","",null,null],[17,"EMPTY_CTXT","","",null,null],[17,"ILLEGAL_CTXT","","",null,null],[17,"LOCAL_CRATE","","Item definitions in the currently-compiled crate would have the CrateNum\nLOCAL_CRATE in their DefId.",null,null],[17,"CRATE_NODE_ID","","",null,null],[17,"DUMMY_NODE_ID","","When parsing and doing expansions, we initially give all AST nodes this AST\nnode value. Then later, in the renumber pass, we renumber them to have\nsmall, positive ids.",null,null],[8,"IntSign","","",null,null],[10,"sign","","",108,{"inputs":[{"name":"intsign"}],"output":{"name":"sign"}}],[11,"cmp","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"option"}}],[11,"lt","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"le","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"gt","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"ge","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"hash","","",11,null],[11,"clone","","",11,{"inputs":[{"name":"ident"}],"output":{"name":"ident"}}],[11,"new","","Construct an identifier with the given name and an empty context:",11,{"inputs":[{"name":"ident"},{"name":"name"}],"output":{"name":"ident"}}],[11,"as_str","","",11,{"inputs":[{"name":"ident"}],"output":{"name":"str"}}],[11,"encode_with_hygiene","","",11,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"fmt","","",11,{"inputs":[{"name":"ident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",11,{"inputs":[{"name":"ident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",109,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",109,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"clone","","",109,{"inputs":[{"name":"name"}],"output":{"name":"name"}}],[11,"decode","","",109,{"inputs":[{"name":"name"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",109,{"inputs":[{"name":"name"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",109,null],[11,"partial_cmp","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"option"}}],[11,"lt","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"le","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"gt","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ge","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"eq","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ne","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"cmp","","",109,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"ordering"}}],[11,"as_str","","",109,{"inputs":[{"name":"name"}],"output":{"name":"str"}}],[11,"usize","","",109,{"inputs":[{"name":"name"}],"output":{"name":"usize"}}],[11,"ident","","",109,{"inputs":[{"name":"name"}],"output":{"name":"ident"}}],[11,"encode","","",11,{"inputs":[{"name":"ident"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",11,{"inputs":[{"name":"ident"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"lifetime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",12,null],[11,"decode","","",12,{"inputs":[{"name":"lifetime"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",12,{"inputs":[{"name":"lifetime"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"fmt","","",13,{"inputs":[{"name":"lifetimedef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",13,null],[11,"decode","","",13,{"inputs":[{"name":"lifetimedef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",13,{"inputs":[{"name":"lifetimedef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"lifetimedef"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"lifetimedef"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"lifetimedef"}],"output":{"name":"lifetimedef"}}],[11,"fmt","","",14,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",14,null],[11,"decode","","",14,{"inputs":[{"name":"path"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",14,{"inputs":[{"name":"path"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"fmt","","",15,{"inputs":[{"name":"pathsegment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",15,null],[11,"decode","","",15,{"inputs":[{"name":"pathsegment"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"pathsegment"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"pathsegment"}],"output":{"name":"pathsegment"}}],[11,"fmt","","",60,{"inputs":[{"name":"pathparameters"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",60,null],[11,"decode","","",60,{"inputs":[{"name":"pathparameters"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",60,{"inputs":[{"name":"pathparameters"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",60,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"ne","","",60,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"clone","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"none","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"is_empty","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"has_lifetimes","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"has_types","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"types","","Returns the types that the user wrote. Note that these do not necessarily map to the type\nparameters in the parenthesized case.",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"lifetimes","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"bindings","","",60,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"fmt","","",16,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",16,null],[11,"decode","","",16,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",16,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"anglebracketedparameterdata"}],"output":{"name":"anglebracketedparameterdata"}}],[11,"fmt","","",17,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",17,null],[11,"decode","","",17,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",17,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"parenthesizedparameterdata"}],"output":{"name":"parenthesizedparameterdata"}}],[11,"fmt","","",18,{"inputs":[{"name":"defid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",18,null],[11,"decode","","",18,{"inputs":[{"name":"defid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"defid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"cmp","","",18,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"ordering"}}],[11,"clone","","",18,{"inputs":[{"name":"defid"}],"output":{"name":"defid"}}],[11,"local_id","","Read the node id, asserting that this def-id is krate-local.",18,{"inputs":[{"name":"defid"}],"output":{"name":"nodeid"}}],[11,"fmt","","",61,{"inputs":[{"name":"typarambound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",61,null],[11,"decode","","",61,{"inputs":[{"name":"typarambound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",61,{"inputs":[{"name":"typarambound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",61,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"ne","","",61,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"clone","","",61,{"inputs":[{"name":"typarambound"}],"output":{"name":"typarambound"}}],[11,"fmt","","",62,{"inputs":[{"name":"traitboundmodifier"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",62,null],[11,"decode","","",62,{"inputs":[{"name":"traitboundmodifier"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",62,{"inputs":[{"name":"traitboundmodifier"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",62,{"inputs":[{"name":"traitboundmodifier"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"ne","","",62,{"inputs":[{"name":"traitboundmodifier"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"clone","","",62,{"inputs":[{"name":"traitboundmodifier"}],"output":{"name":"traitboundmodifier"}}],[11,"fmt","","",19,{"inputs":[{"name":"typaram"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",19,null],[11,"decode","","",19,{"inputs":[{"name":"typaram"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",19,{"inputs":[{"name":"typaram"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",19,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"typaram"}],"output":{"name":"typaram"}}],[11,"fmt","","",20,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",20,null],[11,"decode","","",20,{"inputs":[{"name":"generics"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",20,{"inputs":[{"name":"generics"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",20,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_lt_parameterized","","",20,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"is_type_parameterized","","",20,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"is_parameterized","","",20,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"fmt","","",21,{"inputs":[{"name":"whereclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",21,null],[11,"decode","","",21,{"inputs":[{"name":"whereclause"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",21,{"inputs":[{"name":"whereclause"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",21,{"inputs":[{"name":"whereclause"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"whereclause"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"clone","","",21,{"inputs":[{"name":"whereclause"}],"output":{"name":"whereclause"}}],[11,"fmt","","",63,{"inputs":[{"name":"wherepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",63,null],[11,"decode","","",63,{"inputs":[{"name":"wherepredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",63,{"inputs":[{"name":"wherepredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",63,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",63,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",63,{"inputs":[{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"fmt","","",22,{"inputs":[{"name":"whereboundpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",22,null],[11,"decode","","",22,{"inputs":[{"name":"whereboundpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"whereboundpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",22,{"inputs":[{"name":"whereboundpredicate"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"whereboundpredicate"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",22,{"inputs":[{"name":"whereboundpredicate"}],"output":{"name":"whereboundpredicate"}}],[11,"fmt","","",23,{"inputs":[{"name":"whereregionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",23,null],[11,"decode","","",23,{"inputs":[{"name":"whereregionpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"whereregionpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",23,{"inputs":[{"name":"whereregionpredicate"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"whereregionpredicate"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",23,{"inputs":[{"name":"whereregionpredicate"}],"output":{"name":"whereregionpredicate"}}],[11,"fmt","","",24,{"inputs":[{"name":"whereeqpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",24,null],[11,"decode","","",24,{"inputs":[{"name":"whereeqpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",24,{"inputs":[{"name":"whereeqpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",24,{"inputs":[{"name":"whereeqpredicate"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"whereeqpredicate"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"whereeqpredicate"}],"output":{"name":"whereeqpredicate"}}],[11,"fmt","","",25,{"inputs":[{"name":"crate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",25,null],[11,"decode","","",25,{"inputs":[{"name":"crate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",25,{"inputs":[{"name":"crate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",25,{"inputs":[{"name":"crate"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"crate"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"clone","","",25,{"inputs":[{"name":"crate"}],"output":{"name":"crate"}}],[11,"fmt","","",64,{"inputs":[{"name":"metaitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",64,null],[11,"decode","","",64,{"inputs":[{"name":"metaitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",64,{"inputs":[{"name":"metaitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",64,{"inputs":[{"name":"metaitem_"}],"output":{"name":"metaitem_"}}],[11,"eq","","",64,{"inputs":[{"name":"metaitem_"},{"name":"metaitem_"}],"output":{"name":"bool"}}],[11,"fmt","","",26,{"inputs":[{"name":"block"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",26,null],[11,"decode","","",26,{"inputs":[{"name":"block"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",26,{"inputs":[{"name":"block"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",26,{"inputs":[{"name":"block"},{"name":"block"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"block"},{"name":"block"}],"output":{"name":"bool"}}],[11,"clone","","",26,{"inputs":[{"name":"block"}],"output":{"name":"block"}}],[11,"fmt","","",27,{"inputs":[{"name":"pat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",27,null],[11,"decode","","",27,{"inputs":[{"name":"pat"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",27,{"inputs":[{"name":"pat"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",27,{"inputs":[{"name":"pat"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"ne","","",27,{"inputs":[{"name":"pat"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"clone","","",27,{"inputs":[{"name":"pat"}],"output":{"name":"pat"}}],[11,"fmt","","",28,{"inputs":[{"name":"fieldpat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",28,null],[11,"decode","","",28,{"inputs":[{"name":"fieldpat"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",28,{"inputs":[{"name":"fieldpat"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",28,{"inputs":[{"name":"fieldpat"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"ne","","",28,{"inputs":[{"name":"fieldpat"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"clone","","",28,{"inputs":[{"name":"fieldpat"}],"output":{"name":"fieldpat"}}],[11,"fmt","","",65,{"inputs":[{"name":"bindingmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",65,null],[11,"decode","","",65,{"inputs":[{"name":"bindingmode"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",65,{"inputs":[{"name":"bindingmode"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",65,{"inputs":[{"name":"bindingmode"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"bindingmode"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"bindingmode"}],"output":{"name":"bindingmode"}}],[11,"fmt","","",66,{"inputs":[{"name":"patwildkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",66,null],[11,"decode","","",66,{"inputs":[{"name":"patwildkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",66,{"inputs":[{"name":"patwildkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",66,{"inputs":[{"name":"patwildkind"},{"name":"patwildkind"}],"output":{"name":"bool"}}],[11,"ne","","",66,{"inputs":[{"name":"patwildkind"},{"name":"patwildkind"}],"output":{"name":"bool"}}],[11,"clone","","",66,{"inputs":[{"name":"patwildkind"}],"output":{"name":"patwildkind"}}],[11,"fmt","","",67,{"inputs":[{"name":"pat_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",67,null],[11,"decode","","",67,{"inputs":[{"name":"pat_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",67,{"inputs":[{"name":"pat_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",67,{"inputs":[{"name":"pat_"},{"name":"pat_"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"pat_"},{"name":"pat_"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"pat_"}],"output":{"name":"pat_"}}],[11,"fmt","","",68,{"inputs":[{"name":"mutability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",68,null],[11,"decode","","",68,{"inputs":[{"name":"mutability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",68,{"inputs":[{"name":"mutability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",68,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"clone","","",68,{"inputs":[{"name":"mutability"}],"output":{"name":"mutability"}}],[11,"fmt","","",69,{"inputs":[{"name":"binop_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",69,null],[11,"decode","","",69,{"inputs":[{"name":"binop_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",69,{"inputs":[{"name":"binop_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",69,{"inputs":[{"name":"binop_"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"ne","","",69,{"inputs":[{"name":"binop_"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"clone","","",69,{"inputs":[{"name":"binop_"}],"output":{"name":"binop_"}}],[11,"fmt","","",70,{"inputs":[{"name":"unop"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",70,null],[11,"decode","","",70,{"inputs":[{"name":"unop"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",70,{"inputs":[{"name":"unop"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",70,{"inputs":[{"name":"unop"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"unop"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"clone","","",70,{"inputs":[{"name":"unop"}],"output":{"name":"unop"}}],[11,"fmt","","",71,{"inputs":[{"name":"stmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",71,null],[11,"decode","","",71,{"inputs":[{"name":"stmt_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",71,{"inputs":[{"name":"stmt_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"stmt_"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"stmt_"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"stmt_"}],"output":{"name":"stmt_"}}],[11,"fmt","","",72,{"inputs":[{"name":"macstmtstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",72,null],[11,"decode","","",72,{"inputs":[{"name":"macstmtstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",72,{"inputs":[{"name":"macstmtstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"macstmtstyle"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"macstmtstyle"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"macstmtstyle"}],"output":{"name":"macstmtstyle"}}],[11,"fmt","","",73,{"inputs":[{"name":"localsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",73,null],[11,"decode","","",73,{"inputs":[{"name":"localsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",73,{"inputs":[{"name":"localsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"localsource"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"localsource"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"localsource"}],"output":{"name":"localsource"}}],[11,"fmt","","",29,{"inputs":[{"name":"local"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",29,null],[11,"decode","","",29,{"inputs":[{"name":"local"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",29,{"inputs":[{"name":"local"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",29,{"inputs":[{"name":"local"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"local"},{"name":"local"}],"output":{"name":"bool"}}],[11,"clone","","",29,{"inputs":[{"name":"local"}],"output":{"name":"local"}}],[11,"fmt","","",74,{"inputs":[{"name":"decl_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",74,null],[11,"decode","","",74,{"inputs":[{"name":"decl_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",74,{"inputs":[{"name":"decl_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"decl_"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"decl_"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"decl_"}],"output":{"name":"decl_"}}],[11,"fmt","","",30,{"inputs":[{"name":"arm"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",30,null],[11,"decode","","",30,{"inputs":[{"name":"arm"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",30,{"inputs":[{"name":"arm"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",30,{"inputs":[{"name":"arm"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"arm"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"clone","","",30,{"inputs":[{"name":"arm"}],"output":{"name":"arm"}}],[11,"fmt","","",31,{"inputs":[{"name":"field"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",31,null],[11,"decode","","",31,{"inputs":[{"name":"field"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",31,{"inputs":[{"name":"field"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",31,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",31,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",75,{"inputs":[{"name":"blockcheckmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",75,null],[11,"decode","","",75,{"inputs":[{"name":"blockcheckmode"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",75,{"inputs":[{"name":"blockcheckmode"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"blockcheckmode"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"blockcheckmode"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"blockcheckmode"}],"output":{"name":"blockcheckmode"}}],[11,"fmt","","",76,{"inputs":[{"name":"unsafesource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",76,null],[11,"decode","","",76,{"inputs":[{"name":"unsafesource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",76,{"inputs":[{"name":"unsafesource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",76,{"inputs":[{"name":"unsafesource"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"unsafesource"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"unsafesource"}],"output":{"name":"unsafesource"}}],[11,"fmt","","",32,{"inputs":[{"name":"expr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",32,null],[11,"decode","","",32,{"inputs":[{"name":"expr"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",32,{"inputs":[{"name":"expr"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",32,{"inputs":[{"name":"expr"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"expr"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"clone","","",32,{"inputs":[{"name":"expr"}],"output":{"name":"expr"}}],[11,"fmt","","",77,{"inputs":[{"name":"expr_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",77,null],[11,"decode","","",77,{"inputs":[{"name":"expr_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",77,{"inputs":[{"name":"expr_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",77,{"inputs":[{"name":"expr_"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"ne","","",77,{"inputs":[{"name":"expr_"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"clone","","",77,{"inputs":[{"name":"expr_"}],"output":{"name":"expr_"}}],[11,"fmt","","",33,{"inputs":[{"name":"qself"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",33,null],[11,"decode","","",33,{"inputs":[{"name":"qself"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",33,{"inputs":[{"name":"qself"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",33,{"inputs":[{"name":"qself"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"qself"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"clone","","",33,{"inputs":[{"name":"qself"}],"output":{"name":"qself"}}],[11,"fmt","","",78,{"inputs":[{"name":"matchsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",78,null],[11,"decode","","",78,{"inputs":[{"name":"matchsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",78,{"inputs":[{"name":"matchsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",78,{"inputs":[{"name":"matchsource"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"ne","","",78,{"inputs":[{"name":"matchsource"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"clone","","",78,{"inputs":[{"name":"matchsource"}],"output":{"name":"matchsource"}}],[11,"fmt","","",79,{"inputs":[{"name":"captureclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",79,null],[11,"decode","","",79,{"inputs":[{"name":"captureclause"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",79,{"inputs":[{"name":"captureclause"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",79,{"inputs":[{"name":"captureclause"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"captureclause"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"clone","","",79,{"inputs":[{"name":"captureclause"}],"output":{"name":"captureclause"}}],[11,"fmt","","",34,{"inputs":[{"name":"delimited"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",34,null],[11,"decode","","",34,{"inputs":[{"name":"delimited"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"delimited"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",34,{"inputs":[{"name":"delimited"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"delimited"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"clone","","",34,{"inputs":[{"name":"delimited"}],"output":{"name":"delimited"}}],[11,"open_token","","Returns the opening delimiter as a token.",34,{"inputs":[{"name":"delimited"}],"output":{"name":"token"}}],[11,"close_token","","Returns the closing delimiter as a token.",34,{"inputs":[{"name":"delimited"}],"output":{"name":"token"}}],[11,"open_tt","","Returns the opening delimiter as a token tree.",34,{"inputs":[{"name":"delimited"}],"output":{"name":"tokentree"}}],[11,"close_tt","","Returns the closing delimiter as a token tree.",34,{"inputs":[{"name":"delimited"}],"output":{"name":"tokentree"}}],[11,"fmt","","",35,{"inputs":[{"name":"sequencerepetition"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",35,null],[11,"decode","","",35,{"inputs":[{"name":"sequencerepetition"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",35,{"inputs":[{"name":"sequencerepetition"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",35,{"inputs":[{"name":"sequencerepetition"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"sequencerepetition"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"sequencerepetition"}],"output":{"name":"sequencerepetition"}}],[11,"fmt","","",80,{"inputs":[{"name":"kleeneop"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",80,null],[11,"decode","","",80,{"inputs":[{"name":"kleeneop"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",80,{"inputs":[{"name":"kleeneop"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",80,{"inputs":[{"name":"kleeneop"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"ne","","",80,{"inputs":[{"name":"kleeneop"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"clone","","",80,{"inputs":[{"name":"kleeneop"}],"output":{"name":"kleeneop"}}],[11,"fmt","","",81,{"inputs":[{"name":"tokentree"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",81,null],[11,"decode","","",81,{"inputs":[{"name":"tokentree"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",81,{"inputs":[{"name":"tokentree"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",81,{"inputs":[{"name":"tokentree"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"ne","","",81,{"inputs":[{"name":"tokentree"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"clone","","",81,{"inputs":[{"name":"tokentree"}],"output":{"name":"tokentree"}}],[11,"len","","",81,{"inputs":[{"name":"tokentree"}],"output":{"name":"usize"}}],[11,"get_tt","","",81,{"inputs":[{"name":"tokentree"},{"name":"usize"}],"output":{"name":"tokentree"}}],[11,"get_span","","Returns the `Span` corresponding to this token tree.",81,{"inputs":[{"name":"tokentree"}],"output":{"name":"span"}}],[11,"parse","","Use this token tree as a matcher to parse given tts.",81,null],[11,"fmt","","",82,{"inputs":[{"name":"mac_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",82,null],[11,"decode","","",82,{"inputs":[{"name":"mac_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",82,{"inputs":[{"name":"mac_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",82,{"inputs":[{"name":"mac_"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"mac_"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"mac_"}],"output":{"name":"mac_"}}],[11,"fmt","","",83,{"inputs":[{"name":"strstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",83,null],[11,"decode","","",83,{"inputs":[{"name":"strstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",83,{"inputs":[{"name":"strstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",83,{"inputs":[{"name":"strstyle"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"strstyle"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"clone","","",83,{"inputs":[{"name":"strstyle"}],"output":{"name":"strstyle"}}],[11,"fmt","","",84,{"inputs":[{"name":"sign"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",84,null],[11,"decode","","",84,{"inputs":[{"name":"sign"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",84,{"inputs":[{"name":"sign"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",84,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"ne","","",84,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"clone","","",84,{"inputs":[{"name":"sign"}],"output":{"name":"sign"}}],[11,"new","","",84,{"inputs":[{"name":"sign"},{"name":"t"}],"output":{"name":"sign"}}],[11,"fmt","","",85,{"inputs":[{"name":"litinttype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",85,null],[11,"decode","","",85,{"inputs":[{"name":"litinttype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",85,{"inputs":[{"name":"litinttype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",85,{"inputs":[{"name":"litinttype"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"ne","","",85,{"inputs":[{"name":"litinttype"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"clone","","",85,{"inputs":[{"name":"litinttype"}],"output":{"name":"litinttype"}}],[11,"suffix_len","","",85,{"inputs":[{"name":"litinttype"}],"output":{"name":"usize"}}],[11,"fmt","","",86,{"inputs":[{"name":"lit_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",86,null],[11,"decode","","",86,{"inputs":[{"name":"lit_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",86,{"inputs":[{"name":"lit_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",86,{"inputs":[{"name":"lit_"},{"name":"lit_"}],"output":{"name":"bool"}}],[11,"ne","","",86,{"inputs":[{"name":"lit_"},{"name":"lit_"}],"output":{"name":"bool"}}],[11,"clone","","",86,{"inputs":[{"name":"lit_"}],"output":{"name":"lit_"}}],[11,"fmt","","",36,{"inputs":[{"name":"mutty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",36,null],[11,"decode","","",36,{"inputs":[{"name":"mutty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",36,{"inputs":[{"name":"mutty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"mutty"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"mutty"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"mutty"}],"output":{"name":"mutty"}}],[11,"fmt","","",37,{"inputs":[{"name":"typefield"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",37,null],[11,"decode","","",37,{"inputs":[{"name":"typefield"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",37,{"inputs":[{"name":"typefield"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",37,{"inputs":[{"name":"typefield"},{"name":"typefield"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"typefield"},{"name":"typefield"}],"output":{"name":"bool"}}],[11,"clone","","",37,{"inputs":[{"name":"typefield"}],"output":{"name":"typefield"}}],[11,"fmt","","",38,{"inputs":[{"name":"methodsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",38,null],[11,"decode","","",38,{"inputs":[{"name":"methodsig"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",38,{"inputs":[{"name":"methodsig"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",38,{"inputs":[{"name":"methodsig"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"methodsig"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"clone","","",38,{"inputs":[{"name":"methodsig"}],"output":{"name":"methodsig"}}],[11,"fmt","","",39,{"inputs":[{"name":"traititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",39,null],[11,"decode","","",39,{"inputs":[{"name":"traititem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",39,{"inputs":[{"name":"traititem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",39,{"inputs":[{"name":"traititem"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"traititem"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"traititem"}],"output":{"name":"traititem"}}],[11,"fmt","","",87,{"inputs":[{"name":"traititem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",87,null],[11,"decode","","",87,{"inputs":[{"name":"traititem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",87,{"inputs":[{"name":"traititem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",87,{"inputs":[{"name":"traititem_"},{"name":"traititem_"}],"output":{"name":"bool"}}],[11,"ne","","",87,{"inputs":[{"name":"traititem_"},{"name":"traititem_"}],"output":{"name":"bool"}}],[11,"clone","","",87,{"inputs":[{"name":"traititem_"}],"output":{"name":"traititem_"}}],[11,"fmt","","",40,{"inputs":[{"name":"implitem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",40,null],[11,"decode","","",40,{"inputs":[{"name":"implitem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",40,{"inputs":[{"name":"implitem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",40,{"inputs":[{"name":"implitem"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"implitem"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"clone","","",40,{"inputs":[{"name":"implitem"}],"output":{"name":"implitem"}}],[11,"fmt","","",88,{"inputs":[{"name":"implitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",88,null],[11,"decode","","",88,{"inputs":[{"name":"implitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",88,{"inputs":[{"name":"implitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",88,{"inputs":[{"name":"implitem_"},{"name":"implitem_"}],"output":{"name":"bool"}}],[11,"ne","","",88,{"inputs":[{"name":"implitem_"},{"name":"implitem_"}],"output":{"name":"bool"}}],[11,"clone","","",88,{"inputs":[{"name":"implitem_"}],"output":{"name":"implitem_"}}],[11,"hash","","",89,null],[11,"decode","","",89,{"inputs":[{"name":"intty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",89,{"inputs":[{"name":"intty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",89,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",89,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",89,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",89,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",89,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"suffix_len","","",89,{"inputs":[{"name":"intty"}],"output":{"name":"usize"}}],[11,"hash","","",90,null],[11,"decode","","",90,{"inputs":[{"name":"uintty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",90,{"inputs":[{"name":"uintty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",90,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",90,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",90,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"suffix_len","","",90,{"inputs":[{"name":"uintty"}],"output":{"name":"usize"}}],[11,"fmt","","",90,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",90,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",91,null],[11,"decode","","",91,{"inputs":[{"name":"floatty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",91,{"inputs":[{"name":"floatty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",91,{"inputs":[{"name":"floatty"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"ne","","",91,{"inputs":[{"name":"floatty"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"clone","","",91,{"inputs":[{"name":"floatty"}],"output":{"name":"floatty"}}],[11,"fmt","","",91,{"inputs":[{"name":"floatty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",91,{"inputs":[{"name":"floatty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"suffix_len","","",91,{"inputs":[{"name":"floatty"}],"output":{"name":"usize"}}],[11,"fmt","","",41,{"inputs":[{"name":"typebinding"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",41,null],[11,"decode","","",41,{"inputs":[{"name":"typebinding"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",41,{"inputs":[{"name":"typebinding"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",41,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"clone","","",41,{"inputs":[{"name":"typebinding"}],"output":{"name":"typebinding"}}],[11,"fmt","","",42,{"inputs":[{"name":"ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",42,null],[11,"decode","","",42,{"inputs":[{"name":"ty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",42,{"inputs":[{"name":"ty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",42,{"inputs":[{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[11,"fmt","","",92,{"inputs":[{"name":"primty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",92,null],[11,"decode","","",92,{"inputs":[{"name":"primty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",92,{"inputs":[{"name":"primty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",92,{"inputs":[{"name":"primty"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"ne","","",92,{"inputs":[{"name":"primty"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"clone","","",92,{"inputs":[{"name":"primty"}],"output":{"name":"primty"}}],[11,"fmt","","",43,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",43,null],[11,"decode","","",43,{"inputs":[{"name":"barefnty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",43,{"inputs":[{"name":"barefnty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",43,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",93,{"inputs":[{"name":"ty_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",93,null],[11,"decode","","",93,{"inputs":[{"name":"ty_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",93,{"inputs":[{"name":"ty_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",93,{"inputs":[{"name":"ty_"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"ne","","",93,{"inputs":[{"name":"ty_"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"clone","","",93,{"inputs":[{"name":"ty_"}],"output":{"name":"ty_"}}],[11,"fmt","","",94,{"inputs":[{"name":"asmdialect"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",94,null],[11,"decode","","",94,{"inputs":[{"name":"asmdialect"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",94,{"inputs":[{"name":"asmdialect"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",94,{"inputs":[{"name":"asmdialect"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"ne","","",94,{"inputs":[{"name":"asmdialect"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"clone","","",94,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"fmt","","",44,{"inputs":[{"name":"inlineasm"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",44,null],[11,"decode","","",44,{"inputs":[{"name":"inlineasm"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",44,{"inputs":[{"name":"inlineasm"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",44,{"inputs":[{"name":"inlineasm"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"ne","","",44,{"inputs":[{"name":"inlineasm"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"clone","","",44,{"inputs":[{"name":"inlineasm"}],"output":{"name":"inlineasm"}}],[11,"fmt","","",45,{"inputs":[{"name":"arg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",45,null],[11,"decode","","",45,{"inputs":[{"name":"arg"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",45,{"inputs":[{"name":"arg"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",45,{"inputs":[{"name":"arg"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"ne","","",45,{"inputs":[{"name":"arg"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"clone","","",45,{"inputs":[{"name":"arg"}],"output":{"name":"arg"}}],[11,"new_self","","",45,{"inputs":[{"name":"arg"},{"name":"span"},{"name":"mutability"},{"name":"ident"}],"output":{"name":"arg"}}],[11,"fmt","","",46,{"inputs":[{"name":"fndecl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",46,null],[11,"decode","","",46,{"inputs":[{"name":"fndecl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",46,{"inputs":[{"name":"fndecl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",46,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"clone","","",46,{"inputs":[{"name":"fndecl"}],"output":{"name":"fndecl"}}],[11,"fmt","","",95,{"inputs":[{"name":"unsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",95,null],[11,"decode","","",95,{"inputs":[{"name":"unsafety"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",95,{"inputs":[{"name":"unsafety"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",95,{"inputs":[{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"ne","","",95,{"inputs":[{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"clone","","",95,{"inputs":[{"name":"unsafety"}],"output":{"name":"unsafety"}}],[11,"fmt","","",95,{"inputs":[{"name":"unsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",96,null],[11,"decode","","",96,{"inputs":[{"name":"implpolarity"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",96,{"inputs":[{"name":"implpolarity"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",96,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"ne","","",96,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"clone","","",96,{"inputs":[{"name":"implpolarity"}],"output":{"name":"implpolarity"}}],[11,"fmt","","",96,{"inputs":[{"name":"implpolarity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",97,{"inputs":[{"name":"functionretty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",97,null],[11,"decode","","",97,{"inputs":[{"name":"functionretty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",97,{"inputs":[{"name":"functionretty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",97,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"ne","","",97,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"clone","","",97,{"inputs":[{"name":"functionretty"}],"output":{"name":"functionretty"}}],[11,"span","","",97,{"inputs":[{"name":"functionretty"}],"output":{"name":"span"}}],[11,"fmt","","",98,{"inputs":[{"name":"explicitself_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",98,null],[11,"decode","","",98,{"inputs":[{"name":"explicitself_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",98,{"inputs":[{"name":"explicitself_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",98,{"inputs":[{"name":"explicitself_"},{"name":"explicitself_"}],"output":{"name":"bool"}}],[11,"ne","","",98,{"inputs":[{"name":"explicitself_"},{"name":"explicitself_"}],"output":{"name":"bool"}}],[11,"clone","","",98,{"inputs":[{"name":"explicitself_"}],"output":{"name":"explicitself_"}}],[11,"fmt","","",47,{"inputs":[{"name":"mod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",47,null],[11,"decode","","",47,{"inputs":[{"name":"mod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",47,{"inputs":[{"name":"mod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",47,{"inputs":[{"name":"mod"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"ne","","",47,{"inputs":[{"name":"mod"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"clone","","",47,{"inputs":[{"name":"mod"}],"output":{"name":"mod"}}],[11,"fmt","","",48,{"inputs":[{"name":"foreignmod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",48,null],[11,"decode","","",48,{"inputs":[{"name":"foreignmod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",48,{"inputs":[{"name":"foreignmod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",48,{"inputs":[{"name":"foreignmod"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"foreignmod"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"clone","","",48,{"inputs":[{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fmt","","",49,{"inputs":[{"name":"variantarg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",49,null],[11,"decode","","",49,{"inputs":[{"name":"variantarg"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",49,{"inputs":[{"name":"variantarg"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",49,{"inputs":[{"name":"variantarg"},{"name":"variantarg"}],"output":{"name":"bool"}}],[11,"ne","","",49,{"inputs":[{"name":"variantarg"},{"name":"variantarg"}],"output":{"name":"bool"}}],[11,"clone","","",49,{"inputs":[{"name":"variantarg"}],"output":{"name":"variantarg"}}],[11,"fmt","","",99,{"inputs":[{"name":"variantkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",99,null],[11,"decode","","",99,{"inputs":[{"name":"variantkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",99,{"inputs":[{"name":"variantkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",99,{"inputs":[{"name":"variantkind"},{"name":"variantkind"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"variantkind"},{"name":"variantkind"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"variantkind"}],"output":{"name":"variantkind"}}],[11,"fmt","","",50,{"inputs":[{"name":"enumdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",50,null],[11,"decode","","",50,{"inputs":[{"name":"enumdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",50,{"inputs":[{"name":"enumdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",50,{"inputs":[{"name":"enumdef"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"ne","","",50,{"inputs":[{"name":"enumdef"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"clone","","",50,{"inputs":[{"name":"enumdef"}],"output":{"name":"enumdef"}}],[11,"fmt","","",51,{"inputs":[{"name":"variant_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",51,null],[11,"decode","","",51,{"inputs":[{"name":"variant_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",51,{"inputs":[{"name":"variant_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",51,{"inputs":[{"name":"variant_"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"variant_"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"variant_"}],"output":{"name":"variant_"}}],[11,"fmt","","",100,{"inputs":[{"name":"pathlistitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",100,null],[11,"decode","","",100,{"inputs":[{"name":"pathlistitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",100,{"inputs":[{"name":"pathlistitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",100,{"inputs":[{"name":"pathlistitem_"},{"name":"pathlistitem_"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"pathlistitem_"},{"name":"pathlistitem_"}],"output":{"name":"bool"}}],[11,"clone","","",100,{"inputs":[{"name":"pathlistitem_"}],"output":{"name":"pathlistitem_"}}],[11,"id","","",100,{"inputs":[{"name":"pathlistitem_"}],"output":{"name":"nodeid"}}],[11,"fmt","","",101,{"inputs":[{"name":"viewpath_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",101,null],[11,"decode","","",101,{"inputs":[{"name":"viewpath_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",101,{"inputs":[{"name":"viewpath_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",101,{"inputs":[{"name":"viewpath_"},{"name":"viewpath_"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"viewpath_"},{"name":"viewpath_"}],"output":{"name":"bool"}}],[11,"clone","","",101,{"inputs":[{"name":"viewpath_"}],"output":{"name":"viewpath_"}}],[11,"fmt","","",102,{"inputs":[{"name":"attrstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",102,null],[11,"decode","","",102,{"inputs":[{"name":"attrstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",102,{"inputs":[{"name":"attrstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",102,{"inputs":[{"name":"attrstyle"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"ne","","",102,{"inputs":[{"name":"attrstyle"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"clone","","",102,{"inputs":[{"name":"attrstyle"}],"output":{"name":"attrstyle"}}],[11,"fmt","","",110,{"inputs":[{"name":"attrid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",110,null],[11,"decode","","",110,{"inputs":[{"name":"attrid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",110,{"inputs":[{"name":"attrid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",110,{"inputs":[{"name":"attrid"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"ne","","",110,{"inputs":[{"name":"attrid"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"clone","","",110,{"inputs":[{"name":"attrid"}],"output":{"name":"attrid"}}],[11,"fmt","","",52,{"inputs":[{"name":"attribute_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",52,null],[11,"decode","","",52,{"inputs":[{"name":"attribute_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",52,{"inputs":[{"name":"attribute_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",52,{"inputs":[{"name":"attribute_"},{"name":"attribute_"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"attribute_"},{"name":"attribute_"}],"output":{"name":"bool"}}],[11,"clone","","",52,{"inputs":[{"name":"attribute_"}],"output":{"name":"attribute_"}}],[11,"fmt","","",53,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",53,null],[11,"decode","","",53,{"inputs":[{"name":"traitref"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",53,{"inputs":[{"name":"traitref"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",53,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",53,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fmt","","",54,{"inputs":[{"name":"polytraitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",54,null],[11,"decode","","",54,{"inputs":[{"name":"polytraitref"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",54,{"inputs":[{"name":"polytraitref"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",54,{"inputs":[{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"ne","","",54,{"inputs":[{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"clone","","",54,{"inputs":[{"name":"polytraitref"}],"output":{"name":"polytraitref"}}],[11,"fmt","","",103,{"inputs":[{"name":"visibility"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",103,null],[11,"decode","","",103,{"inputs":[{"name":"visibility"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",103,{"inputs":[{"name":"visibility"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",103,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"clone","","",103,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"inherit_from","","",103,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"fmt","","",55,{"inputs":[{"name":"structfield_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",55,null],[11,"decode","","",55,{"inputs":[{"name":"structfield_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",55,{"inputs":[{"name":"structfield_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"structfield_"},{"name":"structfield_"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"structfield_"},{"name":"structfield_"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"structfield_"}],"output":{"name":"structfield_"}}],[11,"ident","","",55,{"inputs":[{"name":"structfield_"}],"output":{"name":"option"}}],[11,"fmt","","",104,{"inputs":[{"name":"structfieldkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",104,null],[11,"decode","","",104,{"inputs":[{"name":"structfieldkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",104,{"inputs":[{"name":"structfieldkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",104,{"inputs":[{"name":"structfieldkind"},{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"structfieldkind"},{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"clone","","",104,{"inputs":[{"name":"structfieldkind"}],"output":{"name":"structfieldkind"}}],[11,"is_unnamed","","",104,{"inputs":[{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"fmt","","",56,{"inputs":[{"name":"structdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",56,null],[11,"decode","","",56,{"inputs":[{"name":"structdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",56,{"inputs":[{"name":"structdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",56,{"inputs":[{"name":"structdef"},{"name":"structdef"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"structdef"},{"name":"structdef"}],"output":{"name":"bool"}}],[11,"clone","","",56,{"inputs":[{"name":"structdef"}],"output":{"name":"structdef"}}],[11,"fmt","","",57,{"inputs":[{"name":"item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",57,null],[11,"decode","","",57,{"inputs":[{"name":"item"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",57,{"inputs":[{"name":"item"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",57,{"inputs":[{"name":"item"},{"name":"item"}],"output":{"name":"bool"}}],[11,"ne","","",57,{"inputs":[{"name":"item"},{"name":"item"}],"output":{"name":"bool"}}],[11,"clone","","",57,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"fmt","","",105,{"inputs":[{"name":"item_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",105,null],[11,"decode","","",105,{"inputs":[{"name":"item_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",105,{"inputs":[{"name":"item_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",105,{"inputs":[{"name":"item_"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"item_"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"clone","","",105,{"inputs":[{"name":"item_"}],"output":{"name":"item_"}}],[11,"descriptive_variant","","",105,{"inputs":[{"name":"item_"}],"output":{"name":"str"}}],[11,"fmt","","",58,{"inputs":[{"name":"foreignitem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",58,null],[11,"decode","","",58,{"inputs":[{"name":"foreignitem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",58,{"inputs":[{"name":"foreignitem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",58,{"inputs":[{"name":"foreignitem"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"foreignitem"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"foreignitem"}],"output":{"name":"foreignitem"}}],[11,"fmt","","",106,{"inputs":[{"name":"foreignitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",106,null],[11,"decode","","",106,{"inputs":[{"name":"foreignitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",106,{"inputs":[{"name":"foreignitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",106,{"inputs":[{"name":"foreignitem_"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"ne","","",106,{"inputs":[{"name":"foreignitem_"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"clone","","",106,{"inputs":[{"name":"foreignitem_"}],"output":{"name":"foreignitem_"}}],[11,"descriptive_variant","","",106,{"inputs":[{"name":"foreignitem_"}],"output":{"name":"str"}}],[11,"fmt","","",107,{"inputs":[{"name":"inlineditem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",107,null],[11,"decode","","",107,{"inputs":[{"name":"inlineditem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",107,{"inputs":[{"name":"inlineditem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",107,{"inputs":[{"name":"inlineditem"},{"name":"inlineditem"}],"output":{"name":"bool"}}],[11,"ne","","",107,{"inputs":[{"name":"inlineditem"},{"name":"inlineditem"}],"output":{"name":"bool"}}],[11,"clone","","",107,{"inputs":[{"name":"inlineditem"}],"output":{"name":"inlineditem"}}],[11,"fmt","","",59,{"inputs":[{"name":"macrodef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",59,null],[11,"decode","","",59,{"inputs":[{"name":"macrodef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",59,{"inputs":[{"name":"macrodef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",59,{"inputs":[{"name":"macrodef"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"macrodef"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"clone","","",59,{"inputs":[{"name":"macrodef"}],"output":{"name":"macrodef"}}],[0,"ast_map","syntax","",null,null],[3,"LinkedPathNode","syntax::ast_map","",null,null],[3,"LinkedPath","","",null,null],[3,"Forest","","Stores a crate and any number of inlined items from other crates.",null,null],[3,"Map","","Represents a mapping from Node IDs to AST elements and their parent\nNode IDs",null,null],[3,"NodesMatchingSuffix","","",null,null],[4,"PathElem","","",null,null],[13,"PathMod","","",111,null],[13,"PathName","","",111,null],[4,"Node","","",null,null],[13,"NodeItem","","",112,null],[13,"NodeForeignItem","","",112,null],[13,"NodeTraitItem","","",112,null],[13,"NodeImplItem","","",112,null],[13,"NodeVariant","","",112,null],[13,"NodeExpr","","",112,null],[13,"NodeStmt","","",112,null],[13,"NodeArg","","",112,null],[13,"NodeLocal","","",112,null],[13,"NodePat","","",112,null],[13,"NodeBlock","","",112,null],[13,"NodeStructCtor","","NodeStructCtor represents a tuple struct.",112,null],[13,"NodeLifetime","","",112,null],[5,"path_to_string","","",null,{"inputs":[{"name":"pi"}],"output":{"name":"string"}}],[5,"map_crate","","",null,{"inputs":[{"name":"forest"},{"name":"f"}],"output":{"name":"map"}}],[5,"map_decoded_item","","Used for items loaded from external crate that are being inlined into this\ncrate.  The `path` should be the path to the item but should not include\nthe item itself.",null,{"inputs":[{"name":"map"},{"name":"vec"},{"name":"inlineditem"},{"name":"f"}],"output":{"name":"inlineditem"}}],[0,"blocks","","This module provides a simplified abstraction for working with\ncode blocks identified by their integer node-id.  In particular,\nit captures a common set of attributes that all \"function-like\nthings\" (represented by `FnLike` instances) share.  For example,\nall `FnLike` instances have a type signature (be it explicit or\ninferred).  And all `FnLike` instances have a body, i.e. the code\nthat is run when the function-like thing it represents is invoked.",null,null],[3,"FnLikeNode","syntax::ast_map::blocks","An FnLikeNode is a Node that is like a fn, in that it has a decl\nand a body (as well as a NodeId, a span, etc).",null,null],[3,"FnParts","","Components shared by fn-like things (fn items, methods, closures).",null,null],[12,"decl","","",113,null],[12,"body","","",113,null],[12,"kind","","",113,null],[12,"span","","",113,null],[12,"id","","",113,null],[4,"Code","","Carries either an FnLikeNode or a Block, as these are the two\nconstructs that correspond to \"code\" (as in, something from which\nwe can construct a control-flow graph).",null,null],[13,"FnLikeCode","","",114,null],[13,"BlockCode","","",114,null],[8,"MaybeFnLike","","MaybeFnLike wraps a method that indicates if an object\ncorresponds to some FnLikeNode.",null,null],[10,"is_fn_like","","",115,{"inputs":[{"name":"maybefnlike"}],"output":{"name":"bool"}}],[11,"clone","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnlikenode"}}],[11,"is_fn_like","syntax::ast","",57,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",39,{"inputs":[{"name":"traititem"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",32,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[11,"clone","syntax::ast_map::blocks","",114,{"inputs":[{"name":"code"}],"output":{"name":"code"}}],[11,"id","","",114,{"inputs":[{"name":"code"}],"output":{"name":"nodeid"}}],[11,"from_node","","Attempts to construct a Code from presumed FnLike or Block node input.",114,{"inputs":[{"name":"code"},{"name":"node"}],"output":{"name":"option"}}],[11,"to_fn_parts","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnparts"}}],[11,"body","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"block"}}],[11,"decl","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fndecl"}}],[11,"span","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"span"}}],[11,"id","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"nodeid"}}],[11,"kind","","",116,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnkind"}}],[6,"PathElems","syntax::ast_map","The type of the iterator used by with_path.",null,null],[8,"FoldOps","","",null,null],[11,"new_id","","",117,{"inputs":[{"name":"foldops"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"new_def_id","","",117,{"inputs":[{"name":"foldops"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"new_span","","",117,{"inputs":[{"name":"foldops"},{"name":"span"}],"output":{"name":"span"}}],[8,"NodePrinter","","",null,null],[10,"print_node","","",118,{"inputs":[{"name":"nodeprinter"},{"name":"node"}],"output":{"name":"result"}}],[11,"fmt","","",111,{"inputs":[{"name":"pathelem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",111,{"inputs":[{"name":"pathelem"},{"name":"pathelem"}],"output":{"name":"bool"}}],[11,"ne","","",111,{"inputs":[{"name":"pathelem"},{"name":"pathelem"}],"output":{"name":"bool"}}],[11,"clone","","",111,{"inputs":[{"name":"pathelem"}],"output":{"name":"pathelem"}}],[11,"name","","",111,{"inputs":[{"name":"pathelem"}],"output":{"name":"name"}}],[11,"fmt","","",111,{"inputs":[{"name":"pathelem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",119,{"inputs":[{"name":"linkedpathnode"}],"output":{"name":"linkedpathnode"}}],[11,"clone","","",120,{"inputs":[{"name":"linkedpath"}],"output":{"name":"linkedpath"}}],[11,"empty","","",120,{"inputs":[{"name":"linkedpath"}],"output":{"name":"linkedpath"}}],[11,"from","","",120,{"inputs":[{"name":"linkedpath"},{"name":"linkedpathnode"}],"output":{"name":"linkedpath"}}],[6,"Item","","",null,null],[11,"next","","",120,{"inputs":[{"name":"linkedpath"}],"output":{"name":"option"}}],[11,"fmt","","",112,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"new","","",121,{"inputs":[{"name":"forest"},{"name":"crate"}],"output":{"name":"forest"}}],[11,"krate","","",121,{"inputs":[{"name":"forest"}],"output":{"name":"crate"}}],[11,"krate","","",122,{"inputs":[{"name":"map"}],"output":{"name":"crate"}}],[11,"get","","Retrieve the Node corresponding to `id`, panicking if it cannot\nbe found.",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"node"}}],[11,"find","","Retrieve the Node corresponding to `id`, returning None if\ncannot be found.",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"get_parent","","Retrieve the parent NodeId for `id`, or `id` itself if no\nparent is registered in this map.",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"get_parent_did","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"defid"}}],[11,"get_foreign_abi","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"abi"}}],[11,"get_foreign_vis","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"visibility"}}],[11,"expect_item","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"item"}}],[11,"expect_struct","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"structdef"}}],[11,"expect_variant","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"variant"}}],[11,"expect_foreign_item","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"foreignitem"}}],[11,"expect_expr","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"expr"}}],[11,"get_path_elem","","returns the name associated with the given NodeId's AST",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"pathelem"}}],[11,"with_path","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[11,"path_to_string","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"string"}}],[11,"attrs","","Given a node ID, get a list of of attributes associated with the AST\ncorresponding to the Node ID",122,null],[11,"nodes_matching_suffix","","Returns an iterator that yields the node id's with paths that\nmatch `parts`.  (Requires `parts` is non-empty.)",122,null],[11,"opt_span","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"span","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"span"}}],[11,"def_id_span","","",122,{"inputs":[{"name":"map"},{"name":"defid"},{"name":"span"}],"output":{"name":"span"}}],[11,"node_to_string","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"string"}}],[11,"node_to_user_string","","",122,{"inputs":[{"name":"map"},{"name":"nodeid"}],"output":{"name":"string"}}],[6,"Item","","",null,null],[11,"next","","",123,{"inputs":[{"name":"nodesmatchingsuffix"}],"output":{"name":"option"}}],[0,"ast_util","syntax","",null,null],[3,"IdRange","syntax::ast_util","",null,null],[12,"min","","",124,null],[12,"max","","",124,null],[3,"IdVisitor","","A visitor that applies its operation to all of the node IDs\nin a visitable thing.",null,null],[12,"operation","","",125,null],[12,"pass_through_items","","",125,null],[12,"visited_outermost","","",125,null],[5,"path_name_i","","",null,null],[5,"local_def","","",null,{"inputs":[{"name":"nodeid"}],"output":{"name":"defid"}}],[5,"is_local","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"bool"}}],[5,"stmt_id","","",null,{"inputs":[{"name":"stmt"}],"output":{"name":"nodeid"}}],[5,"binop_to_string","","",null,{"inputs":[{"name":"binop_"}],"output":{"name":"str"}}],[5,"lazy_binop","","",null,{"inputs":[{"name":"binop_"}],"output":{"name":"bool"}}],[5,"is_shift_binop","","",null,{"inputs":[{"name":"binop_"}],"output":{"name":"bool"}}],[5,"is_comparison_binop","","",null,{"inputs":[{"name":"binop_"}],"output":{"name":"bool"}}],[5,"is_by_value_binop","","Returns `true` if the binary operator takes its arguments by value",null,{"inputs":[{"name":"binop_"}],"output":{"name":"bool"}}],[5,"is_by_value_unop","","Returns `true` if the unary operator takes its argument by value",null,{"inputs":[{"name":"unop"}],"output":{"name":"bool"}}],[5,"unop_to_string","","",null,{"inputs":[{"name":"unop"}],"output":{"name":"str"}}],[5,"is_path","","",null,{"inputs":[{"name":"p"}],"output":{"name":"bool"}}],[5,"int_ty_to_string","","Get a string representation of a signed int type, with its value.\nWe want to avoid \"45int\" and \"-3int\" in favor of \"45\" and \"-3\"",null,{"inputs":[{"name":"intty"},{"name":"option"}],"output":{"name":"string"}}],[5,"int_ty_max","","",null,{"inputs":[{"name":"intty"}],"output":{"name":"u64"}}],[5,"uint_ty_to_string","","Get a string representation of an unsigned int type, with its value.\nWe want to avoid \"42u\" in favor of \"42us\". \"42uint\" is right out.",null,{"inputs":[{"name":"uintty"},{"name":"option"}],"output":{"name":"string"}}],[5,"uint_ty_max","","",null,{"inputs":[{"name":"uintty"}],"output":{"name":"u64"}}],[5,"float_ty_to_string","","",null,{"inputs":[{"name":"floatty"}],"output":{"name":"string"}}],[5,"ident_to_path","","",null,{"inputs":[{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[5,"path_to_ident","","",null,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[5,"ident_to_pat","","",null,{"inputs":[{"name":"nodeid"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[5,"name_to_dummy_lifetime","","",null,{"inputs":[{"name":"name"}],"output":{"name":"lifetime"}}],[5,"impl_pretty_name","","Generate a \"pretty\" name for an `impl` from its type and trait.\nThis is designed so that symbols of `impl`'d methods give some\nhint of where they came from, (previously they would all just be\nlisted as `__extensions__::method_name::hash`, with no indication\nof the type).",null,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ident"}}],[5,"struct_field_visibility","","",null,{"inputs":[{"name":"structfield"}],"output":{"name":"visibility"}}],[5,"operator_prec","","Maps a binary operator to its precedence",null,{"inputs":[{"name":"binop_"}],"output":{"name":"usize"}}],[5,"empty_generics","","",null,{"inputs":[],"output":{"name":"generics"}}],[5,"visit_ids_for_inlined_item","","",null,{"inputs":[{"name":"inlineditem"},{"name":"o"}],"output":null}],[5,"compute_id_range_for_inlined_item","","",null,{"inputs":[{"name":"inlineditem"}],"output":{"name":"idrange"}}],[5,"compute_id_range_for_fn_body","","Computes the id range for a single fn body, ignoring nested items.",null,{"inputs":[{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":{"name":"idrange"}}],[5,"walk_pat","","",null,{"inputs":[{"name":"pat"},{"name":"f"}],"output":{"name":"bool"}}],[5,"struct_def_is_tuple_like","","Returns true if the given struct def is tuple-like; i.e. that its fields\nare unnamed.",null,{"inputs":[{"name":"structdef"}],"output":{"name":"bool"}}],[5,"pat_is_ident","","Returns true if the given pattern consists solely of an identifier\nand false otherwise.",null,{"inputs":[{"name":"p"}],"output":{"name":"bool"}}],[5,"path_name_eq","","",null,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[5,"segments_name_eq","","",null,null],[5,"lit_is_str","","Returns true if this literal is a string and false otherwise.",null,{"inputs":[{"name":"lit"}],"output":{"name":"bool"}}],[17,"AS_PREC","","Precedence of the `as` operator, which is a binary operator\nnot appearing in the prior table.",null,null],[8,"IdVisitingOperation","","",null,null],[10,"visit_id","","",126,{"inputs":[{"name":"idvisitingoperation"},{"name":"nodeid"}],"output":null}],[11,"fmt","","",124,{"inputs":[{"name":"idrange"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",124,{"inputs":[{"name":"idrange"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",124,{"inputs":[{"name":"idrange"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",124,{"inputs":[{"name":"idrange"}],"output":{"name":"idrange"}}],[11,"max","","",124,{"inputs":[{"name":"idrange"}],"output":{"name":"idrange"}}],[11,"empty","","",124,{"inputs":[{"name":"idrange"}],"output":{"name":"bool"}}],[11,"add","","",124,{"inputs":[{"name":"idrange"},{"name":"nodeid"}],"output":null}],[11,"visit_mod","","",125,{"inputs":[{"name":"idvisitor"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_foreign_item","","",125,{"inputs":[{"name":"idvisitor"},{"name":"foreignitem"}],"output":null}],[11,"visit_item","","",125,{"inputs":[{"name":"idvisitor"},{"name":"item"}],"output":null}],[11,"visit_local","","",125,{"inputs":[{"name":"idvisitor"},{"name":"local"}],"output":null}],[11,"visit_block","","",125,{"inputs":[{"name":"idvisitor"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",125,{"inputs":[{"name":"idvisitor"},{"name":"stmt"}],"output":null}],[11,"visit_pat","","",125,{"inputs":[{"name":"idvisitor"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",125,{"inputs":[{"name":"idvisitor"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",125,{"inputs":[{"name":"idvisitor"},{"name":"ty"}],"output":null}],[11,"visit_generics","","",125,{"inputs":[{"name":"idvisitor"},{"name":"generics"}],"output":null}],[11,"visit_fn","","",125,{"inputs":[{"name":"idvisitor"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",125,{"inputs":[{"name":"idvisitor"},{"name":"structfield"}],"output":null}],[11,"visit_struct_def","","",125,{"inputs":[{"name":"idvisitor"},{"name":"structdef"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",125,{"inputs":[{"name":"idvisitor"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",125,{"inputs":[{"name":"idvisitor"},{"name":"implitem"}],"output":null}],[11,"visit_lifetime_ref","","",125,{"inputs":[{"name":"idvisitor"},{"name":"lifetime"}],"output":null}],[11,"visit_lifetime_def","","",125,{"inputs":[{"name":"idvisitor"},{"name":"lifetimedef"}],"output":null}],[11,"visit_trait_ref","","",125,{"inputs":[{"name":"idvisitor"},{"name":"traitref"}],"output":null}],[0,"attr","syntax","",null,null],[3,"Stability","syntax::attr","Represents the #[deprecated] and friends attributes.",null,null],[12,"level","","",127,null],[12,"feature","","",127,null],[12,"since","","",127,null],[12,"deprecated_since","","",127,null],[12,"reason","","",127,null],[4,"InlineAttr","","",null,null],[13,"None","","",128,null],[13,"Hint","","",128,null],[13,"Always","","",128,null],[13,"Never","","",128,null],[4,"StabilityLevel","","The available stability levels.",null,null],[13,"Unstable","","",129,null],[13,"Stable","","",129,null],[4,"ReprAttr","","",null,null],[13,"ReprAny","","",130,null],[13,"ReprInt","","",130,null],[13,"ReprExtern","","",130,null],[13,"ReprPacked","","",130,null],[4,"IntType","","",null,null],[13,"SignedInt","","",131,null],[13,"UnsignedInt","","",131,null],[5,"mark_used","","",null,{"inputs":[{"name":"attribute"}],"output":null}],[5,"is_used","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[5,"mk_name_value_item_str","","",null,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"p"}}],[5,"mk_name_value_item","","",null,{"inputs":[{"name":"internedstring"},{"name":"lit"}],"output":{"name":"p"}}],[5,"mk_list_item","","",null,{"inputs":[{"name":"internedstring"},{"name":"vec"}],"output":{"name":"p"}}],[5,"mk_word_item","","",null,{"inputs":[{"name":"internedstring"}],"output":{"name":"p"}}],[5,"mk_attr_id","","",null,{"inputs":[],"output":{"name":"attrid"}}],[5,"mk_attr_inner","","Returns an inner attribute with the given value.",null,{"inputs":[{"name":"attrid"},{"name":"p"}],"output":{"name":"attribute"}}],[5,"mk_attr_outer","","Returns an outer attribute with the given value.",null,{"inputs":[{"name":"attrid"},{"name":"p"}],"output":{"name":"attribute"}}],[5,"mk_sugared_doc_attr","","",null,{"inputs":[{"name":"attrid"},{"name":"internedstring"},{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"attribute"}}],[5,"contains","","Check if `needle` occurs in `haystack` by a structural\ncomparison. This is slightly subtle, and relies on ignoring the\nspan included in the `==` comparison a plain MetaItem.",null,null],[5,"contains_name","","",null,null],[5,"first_attr_value_str_by_name","","",null,null],[5,"last_meta_item_value_str_by_name","","",null,null],[5,"sort_meta_items","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[5,"find_crate_name","","",null,null],[5,"find_export_name_attr","","Find the value of #[export_name=*] attribute and check its validity.",null,null],[5,"find_inline_attr","","Determine what `#[inline]` attribute is present in `attrs`, if any.",null,null],[5,"requests_inline","","True if `#[inline]` or `#[inline(always)]` is present in `attrs`.",null,null],[5,"cfg_matches","","Tests if a cfg-pattern matches the cfg set",null,null],[5,"find_stability","","Find the first stability attribute. `None` if none exists.",null,null],[5,"require_unique_names","","",null,null],[5,"find_repr_attrs","","Parse #[repr(...)] forms.",null,{"inputs":[{"name":"spanhandler"},{"name":"attribute"}],"output":{"name":"vec"}}],[8,"AttrMetaMethods","","",null,null],[11,"check_name","","",132,{"inputs":[{"name":"attrmetamethods"},{"name":"str"}],"output":{"name":"bool"}}],[10,"name","","Retrieve the name of the meta item, e.g. `foo` in `#[foo]`,\n`#[foo=\"bar\"]` and `#[foo(bar)]`",132,{"inputs":[{"name":"attrmetamethods"}],"output":{"name":"internedstring"}}],[10,"value_str","","Gets the string value if self is a MetaNameValue variant\ncontaining a string, otherwise None.",132,{"inputs":[{"name":"attrmetamethods"}],"output":{"name":"option"}}],[10,"meta_item_list","","Gets a list of inner meta items from a list MetaItem type.",132,{"inputs":[{"name":"attrmetamethods"}],"output":{"name":"option"}}],[10,"span","","",132,{"inputs":[{"name":"attrmetamethods"}],"output":{"name":"span"}}],[8,"AttributeMethods","","",null,null],[10,"meta","","",133,{"inputs":[{"name":"attributemethods"}],"output":{"name":"metaitem"}}],[10,"with_desugared_doc","","",133,{"inputs":[{"name":"attributemethods"},{"name":"f"}],"output":{"name":"t"}}],[11,"check_name","","",134,{"inputs":[{"name":"attribute"},{"name":"str"}],"output":{"name":"bool"}}],[11,"name","","",134,{"inputs":[{"name":"attribute"}],"output":{"name":"internedstring"}}],[11,"value_str","","",134,{"inputs":[{"name":"attribute"}],"output":{"name":"option"}}],[11,"meta_item_list","","",134,{"inputs":[{"name":"attribute"}],"output":{"name":"option"}}],[11,"span","","",134,{"inputs":[{"name":"attribute"}],"output":{"name":"span"}}],[11,"name","","",135,{"inputs":[{"name":"metaitem"}],"output":{"name":"internedstring"}}],[11,"value_str","","",135,{"inputs":[{"name":"metaitem"}],"output":{"name":"option"}}],[11,"meta_item_list","","",135,{"inputs":[{"name":"metaitem"}],"output":{"name":"option"}}],[11,"span","","",135,{"inputs":[{"name":"metaitem"}],"output":{"name":"span"}}],[11,"meta","","Extract the MetaItem from inside this Attribute.",134,{"inputs":[{"name":"attribute"}],"output":{"name":"metaitem"}}],[11,"with_desugared_doc","","Convert self to a normal #[doc=\"foo\"] comment, if it is a\ncomment like `///` or `/** */`. (Returns self unchanged for\nnon-sugared doc attributes.)",134,{"inputs":[{"name":"attribute"},{"name":"f"}],"output":{"name":"t"}}],[11,"eq","","",128,{"inputs":[{"name":"inlineattr"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"ne","","",128,{"inputs":[{"name":"inlineattr"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"clone","","",128,{"inputs":[{"name":"inlineattr"}],"output":{"name":"inlineattr"}}],[11,"fmt","","",127,{"inputs":[{"name":"stability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",127,{"inputs":[{"name":"stability"}],"output":{"name":"stability"}}],[11,"decode","","",127,{"inputs":[{"name":"stability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",127,{"inputs":[{"name":"stability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"stabilitylevel"}],"output":{"name":"stabilitylevel"}}],[11,"partial_cmp","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"option"}}],[11,"lt","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"le","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"gt","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ge","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"eq","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"decode","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",129,{"inputs":[{"name":"stabilitylevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"reprattr"}],"output":{"name":"reprattr"}}],[11,"decode","","",130,{"inputs":[{"name":"reprattr"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",130,{"inputs":[{"name":"reprattr"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",130,{"inputs":[{"name":"reprattr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",130,{"inputs":[{"name":"reprattr"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"ne","","",130,{"inputs":[{"name":"reprattr"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"is_ffi_safe","","",130,{"inputs":[{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"clone","","",131,{"inputs":[{"name":"inttype"}],"output":{"name":"inttype"}}],[11,"decode","","",131,{"inputs":[{"name":"inttype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",131,{"inputs":[{"name":"inttype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",131,{"inputs":[{"name":"inttype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",131,{"inputs":[{"name":"inttype"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"ne","","",131,{"inputs":[{"name":"inttype"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"hash","","",131,null],[11,"is_signed","","",131,{"inputs":[{"name":"inttype"}],"output":{"name":"bool"}}],[0,"codemap","syntax","The CodeMap tracks all the source code used within a single crate, mapping\nfrom integer byte positions to the original source code location. Each bit\nof source parsed during crate parsing (typically files, in-memory strings,\nor various bits of macro expansion) cover a continuous range of bytes in the\nCodeMap and are represented by FileMaps. Byte positions are stored in\n`spans` and used pervasively in the compiler. They are absolute positions\nwithin the CodeMap, which upon request can be converted to line and column\ninformation, source code snippets, etc.",null,null],[3,"BytePos","syntax::codemap","A byte offset. Keep this small (currently 32-bits), as AST contains\na lot of them.",null,null],[3,"CharPos","","A character offset. Because of multibyte utf8 characters, a byte offset\nis not equivalent to a character offset. The CodeMap will convert BytePos\nvalues to CharPos values as necessary.",null,null],[3,"Span","","Spans represent a region of code, used for error reporting. Positions in spans\nare *absolute* positions from the beginning of the codemap, not positions\nrelative to FileMaps. Methods on the CodeMap can be used to relate spans back\nto the original source.",null,null],[12,"lo","","",136,null],[12,"hi","","",136,null],[12,"expn_id","","Information about where the macro came from, if this piece of\ncode was created by a macro expansion.",136,null],[3,"Spanned","","",null,null],[12,"node","","",137,null],[12,"span","","",137,null],[3,"Loc","","A source code location used for error reporting",null,null],[12,"file","","Information about the original source",138,null],[12,"line","","The (1-based) line number",138,null],[12,"col","","The (0-based) column offset",138,null],[3,"LocWithOpt","","A source code location used as the result of lookup_char_pos_adj",null,null],[12,"filename","","",139,null],[12,"line","","",139,null],[12,"col","","",139,null],[12,"file","","",139,null],[3,"FileMapAndLine","","",null,null],[12,"fm","","",140,null],[12,"line","","",140,null],[3,"FileMapAndBytePos","","",null,null],[12,"fm","","",141,null],[12,"pos","","",141,null],[3,"NameAndSpan","","",null,null],[12,"name","","The name of the macro that was invoked to create the thing\nwith this Span.",142,null],[12,"format","","The format with which the macro was invoked.",142,null],[12,"allow_internal_unstable","","Whether the macro is allowed to use #[unstable]/feature-gated\nfeatures internally without forcing the whole crate to opt-in\nto them.",142,null],[12,"span","","The span of the macro definition itself. The macro may not\nhave a sensible definition span (e.g. something defined\ncompletely inside libsyntax) in which case this is None.",142,null],[3,"ExpnInfo","","Extra information for tracking macro expansion of spans",null,null],[12,"call_site","","The location of the actual macro invocation, e.g. `let x =\nfoo!();`",143,null],[12,"callee","","Information about the macro and its definition.",143,null],[3,"ExpnId","","",null,null],[3,"LineInfo","","",null,null],[12,"line_index","","Index of line, starting from 0.",144,null],[12,"start_col","","Column in line where span begins, starting from 0.",144,null],[12,"end_col","","Column in line where span ends, starting from 0, exclusive.",144,null],[3,"FileLines","","",null,null],[12,"file","","",145,null],[12,"lines","","",145,null],[3,"MultiByteChar","","Identifies an offset of a multi-byte character in a FileMap",null,null],[12,"pos","","The absolute offset of the character in the CodeMap",146,null],[12,"bytes","","The number of bytes, >=2",146,null],[3,"FileMap","","A single source in the CodeMap",null,null],[12,"name","","The name of the file that the source came from, source that doesn't\noriginate from files has names between angle brackets by convention,\ne.g. `<anon>`",147,null],[12,"src","","The complete source code",147,null],[12,"start_pos","","The start position of this source in the CodeMap",147,null],[12,"end_pos","","The end position of this source in the CodeMap",147,null],[12,"lines","","Locations of lines beginnings in the source code",147,null],[12,"multibyte_chars","","Locations of multi-byte characters in the source code",147,null],[3,"CodeMap","","",null,null],[12,"files","","",148,null],[3,"DistinctSources","","",null,null],[3,"MalformedCodemapPositions","","",null,null],[4,"MacroFormat","","The syntax with which a macro was invoked.",null,null],[13,"MacroAttribute","","e.g. #[derive(...)] <item>",149,null],[13,"MacroBang","","e.g. `format!()`",149,null],[4,"SpanSnippetError","","",null,null],[13,"IllFormedSpan","","",150,null],[13,"DistinctSources","","",150,null],[13,"MalformedForCodemap","","",150,null],[13,"SourceNotAvailable","","",150,null],[12,"filename","syntax::codemap::SpanSnippetError","",150,null],[5,"spanned","syntax::codemap","",null,{"inputs":[{"name":"bytepos"},{"name":"bytepos"},{"name":"t"}],"output":{"name":"spanned"}}],[5,"respan","","",null,{"inputs":[{"name":"span"},{"name":"t"}],"output":{"name":"spanned"}}],[5,"dummy_spanned","","",null,{"inputs":[{"name":"t"}],"output":{"name":"spanned"}}],[5,"mk_sp","","",null,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"span"}}],[5,"original_sp","","Return the span itself if it doesn't come from a macro expansion,\notherwise return the call site span up to the `enclosing_sp` by\nfollowing the `expn_info` chain.",null,{"inputs":[{"name":"codemap"},{"name":"span"},{"name":"span"}],"output":{"name":"span"}}],[6,"FileName","","",null,null],[17,"DUMMY_SP","","",null,null],[17,"COMMAND_LINE_SP","","",null,null],[17,"NO_EXPANSION","","",null,null],[17,"COMMAND_LINE_EXPN","","",null,null],[8,"Pos","","",null,null],[10,"from_usize","","",151,{"inputs":[{"name":"pos"},{"name":"usize"}],"output":{"name":"self"}}],[10,"to_usize","","",151,{"inputs":[{"name":"pos"}],"output":{"name":"usize"}}],[11,"fmt","","",152,{"inputs":[{"name":"bytepos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"option"}}],[11,"lt","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"le","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"gt","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ge","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"hash","","",152,null],[11,"eq","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"fmt","","",153,{"inputs":[{"name":"charpos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"option"}}],[11,"lt","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"le","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"gt","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ge","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"hash","","",153,null],[11,"eq","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"from_usize","","",152,{"inputs":[{"name":"bytepos"},{"name":"usize"}],"output":{"name":"bytepos"}}],[11,"to_usize","","",152,{"inputs":[{"name":"bytepos"}],"output":{"name":"usize"}}],[6,"Output","","",null,null],[11,"add","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[6,"Output","","",null,null],[11,"sub","","",152,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"encode","","",152,{"inputs":[{"name":"bytepos"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",152,{"inputs":[{"name":"bytepos"},{"name":"d"}],"output":{"name":"result"}}],[11,"from_usize","","",153,{"inputs":[{"name":"charpos"},{"name":"usize"}],"output":{"name":"charpos"}}],[11,"to_usize","","",153,{"inputs":[{"name":"charpos"}],"output":{"name":"usize"}}],[6,"Output","","",null,null],[11,"add","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"charpos"}}],[6,"Output","","",null,null],[11,"sub","","",153,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"hash","","",136,null],[11,"fmt","","",136,{"inputs":[{"name":"span"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",136,{"inputs":[{"name":"span"}],"output":{"name":"span"}}],[11,"fmt","","",137,{"inputs":[{"name":"spanned"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",137,null],[11,"decode","","",137,{"inputs":[{"name":"spanned"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",137,{"inputs":[{"name":"spanned"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",137,{"inputs":[{"name":"spanned"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"spanned"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"eq","","",136,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"ne","","",136,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"encode","","",136,{"inputs":[{"name":"span"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",136,{"inputs":[{"name":"span"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",138,{"inputs":[{"name":"loc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",139,{"inputs":[{"name":"locwithopt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",140,{"inputs":[{"name":"filemapandline"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",141,{"inputs":[{"name":"filemapandbytepos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",149,{"inputs":[{"name":"macroformat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",149,null],[11,"clone","","",149,{"inputs":[{"name":"macroformat"}],"output":{"name":"macroformat"}}],[11,"fmt","","",142,{"inputs":[{"name":"nameandspan"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",142,null],[11,"clone","","",142,{"inputs":[{"name":"nameandspan"}],"output":{"name":"nameandspan"}}],[11,"fmt","","",143,{"inputs":[{"name":"expninfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",143,null],[11,"decode","","",154,{"inputs":[{"name":"expnid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",154,{"inputs":[{"name":"expnid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",154,null],[11,"fmt","","",154,{"inputs":[{"name":"expnid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",154,{"inputs":[{"name":"expnid"}],"output":{"name":"expnid"}}],[11,"eq","","",154,{"inputs":[{"name":"expnid"},{"name":"expnid"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"expnid"},{"name":"expnid"}],"output":{"name":"bool"}}],[11,"from_llvm_cookie","","",154,{"inputs":[{"name":"expnid"},{"name":"c_uint"}],"output":{"name":"expnid"}}],[11,"to_llvm_cookie","","",154,{"inputs":[{"name":"expnid"}],"output":{"name":"i32"}}],[11,"eq","","",144,{"inputs":[{"name":"lineinfo"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"ne","","",144,{"inputs":[{"name":"lineinfo"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"fmt","","",144,{"inputs":[{"name":"lineinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"lineinfo"}],"output":{"name":"lineinfo"}}],[11,"eq","","",146,{"inputs":[{"name":"multibytechar"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"ne","","",146,{"inputs":[{"name":"multibytechar"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"decode","","",146,{"inputs":[{"name":"multibytechar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",146,{"inputs":[{"name":"multibytechar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",146,{"inputs":[{"name":"multibytechar"}],"output":{"name":"multibytechar"}}],[11,"encode","","",147,{"inputs":[{"name":"filemap"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",147,{"inputs":[{"name":"filemap"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",147,{"inputs":[{"name":"filemap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"next_line","","EFFECT: register a start-of-line offset in the\ntable of line-beginnings.\nUNCHECKED INVARIANT: these offsets must be added in the right\norder and must be in the right places; there is shared knowledge\nabout what ends a line between this file and parse.rs\nWARNING: pos param here is the offset relative to start of CodeMap,\nand CodeMap will append a newline when adding a filemap without a newline at the end,\nso the safe way to call this is with value calculated as\nfilemap.start_pos + newline_offset_relative_to_the_start_of_filemap.",147,{"inputs":[{"name":"filemap"},{"name":"bytepos"}],"output":null}],[11,"get_line","","get a line from the list of pre-computed line-beginnings.\nline-number here is 0-based.",147,{"inputs":[{"name":"filemap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"record_multibyte_char","","",147,{"inputs":[{"name":"filemap"},{"name":"bytepos"},{"name":"usize"}],"output":null}],[11,"is_real_file","","",147,{"inputs":[{"name":"filemap"}],"output":{"name":"bool"}}],[11,"is_imported","","",147,{"inputs":[{"name":"filemap"}],"output":{"name":"bool"}}],[11,"new","","",148,{"inputs":[{"name":"codemap"}],"output":{"name":"codemap"}}],[11,"new_filemap","","",148,{"inputs":[{"name":"codemap"},{"name":"filename"},{"name":"string"}],"output":{"name":"rc"}}],[11,"new_imported_filemap","","Allocates a new FileMap representing a source file from an external\ncrate. The source code of such an \"imported filemap\" is not available,\nbut we still know enough to generate accurate debuginfo location\ninformation for things inlined from other crates.",148,{"inputs":[{"name":"codemap"},{"name":"filename"},{"name":"usize"},{"name":"vec"},{"name":"vec"}],"output":{"name":"rc"}}],[11,"mk_substr_filename","","",148,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"lookup_char_pos","","Lookup source information about a BytePos",148,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"loc"}}],[11,"lookup_char_pos_adj","","",148,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"locwithopt"}}],[11,"span_to_string","","",148,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_filename","","",148,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"filename"}}],[11,"span_to_lines","","",148,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"filelines"}}],[11,"span_to_snippet","","",148,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"result"}}],[11,"get_filemap","","",148,{"inputs":[{"name":"codemap"},{"name":"str"}],"output":{"name":"rc"}}],[11,"lookup_byte_offset","","For a global BytePos compute the local offset within the containing FileMap",148,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"filemapandbytepos"}}],[11,"bytepos_to_file_charpos","","Converts an absolute BytePos to a CharPos relative to the filemap and above.",148,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"charpos"}}],[11,"record_expansion","","",148,{"inputs":[{"name":"codemap"},{"name":"expninfo"}],"output":{"name":"expnid"}}],[11,"with_expn_info","","",148,{"inputs":[{"name":"codemap"},{"name":"expnid"},{"name":"f"}],"output":{"name":"t"}}],[11,"span_allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable]\nitems can be used (that is, a macro marked with\n`#[allow_internal_unstable]`).",148,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"bool"}}],[11,"fmt","","",150,{"inputs":[{"name":"spansnippeterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",150,{"inputs":[{"name":"spansnippeterror"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"ne","","",150,{"inputs":[{"name":"spansnippeterror"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"clone","","",150,{"inputs":[{"name":"spansnippeterror"}],"output":{"name":"spansnippeterror"}}],[11,"fmt","","",155,{"inputs":[{"name":"distinctsources"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",155,{"inputs":[{"name":"distinctsources"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"distinctsources"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"distinctsources"}],"output":{"name":"distinctsources"}}],[11,"fmt","","",156,{"inputs":[{"name":"malformedcodemappositions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",156,{"inputs":[{"name":"malformedcodemappositions"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"malformedcodemappositions"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"malformedcodemappositions"}],"output":{"name":"malformedcodemappositions"}}],[0,"config","syntax","",null,null],[5,"strip_unconfigured_items","syntax::config","",null,{"inputs":[{"name":"spanhandler"},{"name":"crate"}],"output":{"name":"crate"}}],[5,"strip_items","","",null,{"inputs":[{"name":"crate"},{"name":"f"}],"output":{"name":"crate"}}],[0,"diagnostic","syntax","",null,null],[3,"FatalError","syntax::diagnostic","Used as a return value to signify a fatal error occurred. (It is also\nused as the argument to panic at the moment, but that will eventually\nnot be true.)",null,null],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug`\nor `.span_bug` rather than a failed assertion, etc.",null,null],[3,"SpanHandler","","A span-handler is like a handler but also\naccepts span information for source-location\nreporting.",null,null],[12,"handler","","",157,null],[12,"cm","","",157,null],[3,"Handler","","A handler deals with errors; certain errors\n(fatal, bug, unimpl) may cause immediate exit,\nothers log errors for later reporting.",null,null],[12,"can_emit_warnings","","",158,null],[3,"EmitterWriter","","",null,null],[4,"RenderSpan","","",null,null],[13,"FullSpan","","A FullSpan renders with both with an initial line for the\nmessage, prefixed by file:linenum, followed by a summary of\nthe source code covered by the span.",159,null],[13,"EndSpan","","Similar to a FullSpan, but the cited position is the end of\nthe span, instead of the start. Used, at least, for telling\ncompiletest/runtest to look at the last line of the span\n(since `end_highlight_lines` displays an arrow to the end\nof the span).",159,null],[13,"Suggestion","","A suggestion renders with both with an initial line for the\nmessage, prefixed by file:linenum, followed by a summary\nof hypothetical source code, where the `String` is spliced\ninto the lines in place of the code covered by the span.",159,null],[13,"FileLine","","A FileLine renders with just a line for the message prefixed\nby file:linenum.",159,null],[4,"ColorConfig","","",null,null],[13,"Auto","","",160,null],[13,"Always","","",160,null],[13,"Never","","",160,null],[4,"Level","","",null,null],[13,"Bug","","",161,null],[13,"Fatal","","",161,null],[13,"Error","","",161,null],[13,"Warning","","",161,null],[13,"Note","","",161,null],[13,"Help","","",161,null],[5,"mk_span_handler","","",null,{"inputs":[{"name":"handler"},{"name":"codemap"}],"output":{"name":"spanhandler"}}],[5,"default_handler","","",null,{"inputs":[{"name":"colorconfig"},{"name":"option"},{"name":"bool"}],"output":{"name":"handler"}}],[5,"mk_handler","","",null,{"inputs":[{"name":"bool"},{"name":"box"}],"output":{"name":"handler"}}],[5,"expect","","",null,{"inputs":[{"name":"spanhandler"},{"name":"option"},{"name":"m"}],"output":{"name":"t"}}],[8,"Emitter","","",null,null],[10,"emit","","",162,{"inputs":[{"name":"emitter"},{"name":"option"},{"name":"str"},{"name":"option"},{"name":"level"}],"output":null}],[10,"custom_emit","","",162,{"inputs":[{"name":"emitter"},{"name":"codemap"},{"name":"renderspan"},{"name":"str"},{"name":"level"}],"output":null}],[11,"clone","","",159,{"inputs":[{"name":"renderspan"}],"output":{"name":"renderspan"}}],[11,"clone","","",160,{"inputs":[{"name":"colorconfig"}],"output":{"name":"colorconfig"}}],[11,"clone","","",163,{"inputs":[{"name":"fatalerror"}],"output":{"name":"fatalerror"}}],[11,"clone","","",164,{"inputs":[{"name":"explicitbug"}],"output":{"name":"explicitbug"}}],[11,"span_fatal","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_with_code","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_err","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_err_with_code","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"span_warn","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_warn_with_code","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"span_note","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_end_note","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_help","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":null}],[11,"fileline_note","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"fileline_help","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_bug","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_unimpl","","",157,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":null}],[11,"handler","","",157,{"inputs":[{"name":"spanhandler"}],"output":{"name":"handler"}}],[11,"fatal","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"err","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"bump_err_count","","",158,{"inputs":[{"name":"handler"}],"output":null}],[11,"err_count","","",158,{"inputs":[{"name":"handler"}],"output":{"name":"usize"}}],[11,"has_errors","","",158,{"inputs":[{"name":"handler"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",158,{"inputs":[{"name":"handler"}],"output":null}],[11,"warn","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"note","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"help","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"bug","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"unimpl","","",158,{"inputs":[{"name":"handler"},{"name":"str"}],"output":null}],[11,"emit","","",158,{"inputs":[{"name":"handler"},{"name":"option"},{"name":"str"},{"name":"level"}],"output":null}],[11,"emit_with_code","","",158,{"inputs":[{"name":"handler"},{"name":"option"},{"name":"str"},{"name":"str"},{"name":"level"}],"output":null}],[11,"custom_emit","","",158,{"inputs":[{"name":"handler"},{"name":"codemap"},{"name":"renderspan"},{"name":"str"},{"name":"level"}],"output":null}],[11,"fmt","","",161,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",161,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"eq","","",161,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",161,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"fmt","","",161,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"stderr","","",165,{"inputs":[{"name":"emitterwriter"},{"name":"colorconfig"},{"name":"option"}],"output":{"name":"emitterwriter"}}],[11,"new","","",165,{"inputs":[{"name":"emitterwriter"},{"name":"box"},{"name":"option"}],"output":{"name":"emitterwriter"}}],[11,"emit","","",165,{"inputs":[{"name":"emitterwriter"},{"name":"option"},{"name":"str"},{"name":"option"},{"name":"level"}],"output":null}],[11,"custom_emit","","",165,{"inputs":[{"name":"emitterwriter"},{"name":"codemap"},{"name":"renderspan"},{"name":"str"},{"name":"level"}],"output":null}],[0,"feature_gate","syntax","Feature gating",null,null],[3,"Features","syntax::feature_gate","A set of features to be used by later passes.",null,null],[12,"unboxed_closures","","",166,null],[12,"rustc_diagnostic_macros","","",166,null],[12,"visible_private_types","","",166,null],[12,"allow_quote","","",166,null],[12,"allow_asm","","",166,null],[12,"allow_log_syntax","","",166,null],[12,"allow_concat_idents","","",166,null],[12,"allow_trace_macros","","",166,null],[12,"allow_internal_unstable","","",166,null],[12,"allow_custom_derive","","",166,null],[12,"simd_ffi","","",166,null],[12,"unmarked_api","","",166,null],[12,"negate_unsigned","","",166,null],[12,"declared_stable_lang_features","","spans of #![feature] attrs for stable language features. for error reporting",166,null],[12,"declared_lib_features","","#![feature] attrs for non-language (library) features",166,null],[4,"AttributeType","","",null,null],[13,"Normal","","Normal, builtin attribute that is consumed\nby the compiler before the unused_attribute check",167,null],[13,"Whitelisted","","Builtin attribute that may not be consumed by the compiler\nbefore the unused_attribute check. These attributes\nwill be ignored by the unused_attribute lint",167,null],[13,"Gated","","Is gated by a given feature gate and reason\nThese get whitelisted too",167,null],[13,"CrateLevel","","Builtin attribute that is only allowed at the crate level",167,null],[5,"emit_feature_err","","",null,{"inputs":[{"name":"spanhandler"},{"name":"str"},{"name":"span"},{"name":"str"}],"output":null}],[5,"emit_feature_warn","","",null,{"inputs":[{"name":"spanhandler"},{"name":"str"},{"name":"span"},{"name":"str"}],"output":null}],[5,"check_crate_macros","","",null,{"inputs":[{"name":"codemap"},{"name":"spanhandler"},{"name":"crate"}],"output":{"name":"features"}}],[5,"check_crate","","",null,{"inputs":[{"name":"codemap"},{"name":"spanhandler"},{"name":"crate"}],"output":{"name":"features"}}],[17,"KNOWN_ATTRIBUTES","","",null,null],[17,"EXPLAIN_ASM","","",null,null],[17,"EXPLAIN_LOG_SYNTAX","","",null,null],[17,"EXPLAIN_CONCAT_IDENTS","","",null,null],[17,"EXPLAIN_TRACE_MACROS","","",null,null],[17,"EXPLAIN_ALLOW_INTERNAL_UNSTABLE","","",null,null],[17,"EXPLAIN_CUSTOM_DERIVE","","",null,null],[11,"fmt","","",167,{"inputs":[{"name":"attributetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",167,{"inputs":[{"name":"attributetype"}],"output":{"name":"attributetype"}}],[11,"eq","","",167,{"inputs":[{"name":"attributetype"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"ne","","",167,{"inputs":[{"name":"attributetype"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"new","","",166,{"inputs":[{"name":"features"}],"output":{"name":"features"}}],[0,"fold","syntax","A Folder represents an AST->AST fold; it accepts an AST piece,\nand returns a piece of the same type. So, for instance, macro\nexpansion is a Folder that walks over an AST and produces another\nAST.",null,null],[5,"noop_fold_meta_items","syntax::fold","",null,{"inputs":[{"name":"vec"},{"name":"t"}],"output":{"name":"vec"}}],[5,"noop_fold_view_path","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"fold_attrs","","",null,{"inputs":[{"name":"vec"},{"name":"t"}],"output":{"name":"vec"}}],[5,"noop_fold_arm","","",null,{"inputs":[{"name":"arm"},{"name":"t"}],"output":{"name":"arm"}}],[5,"noop_fold_decl","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"smallvector"}}],[5,"noop_fold_ty_binding","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_ty","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_foreign_mod","","",null,{"inputs":[{"name":"foreignmod"},{"name":"t"}],"output":{"name":"foreignmod"}}],[5,"noop_fold_variant","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_ident","","",null,{"inputs":[{"name":"ident"},{"name":"t"}],"output":{"name":"ident"}}],[5,"noop_fold_usize","","",null,{"inputs":[{"name":"usize"},{"name":"t"}],"output":{"name":"usize"}}],[5,"noop_fold_path","","",null,{"inputs":[{"name":"path"},{"name":"t"}],"output":{"name":"path"}}],[5,"noop_fold_path_parameters","","",null,{"inputs":[{"name":"pathparameters"},{"name":"t"}],"output":{"name":"pathparameters"}}],[5,"noop_fold_angle_bracketed_parameter_data","","",null,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"t"}],"output":{"name":"anglebracketedparameterdata"}}],[5,"noop_fold_parenthesized_parameter_data","","",null,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"t"}],"output":{"name":"parenthesizedparameterdata"}}],[5,"noop_fold_local","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_attribute","","",null,{"inputs":[{"name":"attribute"},{"name":"t"}],"output":{"name":"option"}}],[5,"noop_fold_explicit_self_underscore","","",null,{"inputs":[{"name":"explicitself_"},{"name":"t"}],"output":{"name":"explicitself_"}}],[5,"noop_fold_explicit_self","","",null,{"inputs":[{"name":"explicitself"},{"name":"t"}],"output":{"name":"explicitself"}}],[5,"noop_fold_mac","","",null,{"inputs":[{"name":"mac"},{"name":"t"}],"output":{"name":"mac"}}],[5,"noop_fold_meta_item","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_arg","","",null,{"inputs":[{"name":"arg"},{"name":"t"}],"output":{"name":"arg"}}],[5,"noop_fold_tt","","",null,{"inputs":[{"name":"tokentree"},{"name":"t"}],"output":{"name":"tokentree"}}],[5,"noop_fold_tts","","",null,null],[5,"noop_fold_token","","",null,{"inputs":[{"name":"token"},{"name":"t"}],"output":{"name":"token"}}],[5,"noop_fold_interpolated","","apply folder to elements of interpolated nodes",null,{"inputs":[{"name":"nonterminal"},{"name":"t"}],"output":{"name":"nonterminal"}}],[5,"noop_fold_fn_decl","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_ty_param_bound","","",null,{"inputs":[{"name":"typarambound"},{"name":"t"}],"output":{"name":"typarambound"}}],[5,"noop_fold_ty_param","","",null,{"inputs":[{"name":"typaram"},{"name":"t"}],"output":{"name":"typaram"}}],[5,"noop_fold_ty_params","","",null,{"inputs":[{"name":"ownedslice"},{"name":"t"}],"output":{"name":"ownedslice"}}],[5,"noop_fold_lifetime","","",null,{"inputs":[{"name":"lifetime"},{"name":"t"}],"output":{"name":"lifetime"}}],[5,"noop_fold_lifetime_def","","",null,{"inputs":[{"name":"lifetimedef"},{"name":"t"}],"output":{"name":"lifetimedef"}}],[5,"noop_fold_lifetimes","","",null,{"inputs":[{"name":"vec"},{"name":"t"}],"output":{"name":"vec"}}],[5,"noop_fold_lifetime_defs","","",null,{"inputs":[{"name":"vec"},{"name":"t"}],"output":{"name":"vec"}}],[5,"noop_fold_opt_lifetime","","",null,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"option"}}],[5,"noop_fold_generics","","",null,{"inputs":[{"name":"generics"},{"name":"t"}],"output":{"name":"generics"}}],[5,"noop_fold_where_clause","","",null,{"inputs":[{"name":"whereclause"},{"name":"t"}],"output":{"name":"whereclause"}}],[5,"noop_fold_where_predicate","","",null,{"inputs":[{"name":"wherepredicate"},{"name":"t"}],"output":{"name":"wherepredicate"}}],[5,"noop_fold_struct_def","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_trait_ref","","",null,{"inputs":[{"name":"traitref"},{"name":"t"}],"output":{"name":"traitref"}}],[5,"noop_fold_poly_trait_ref","","",null,{"inputs":[{"name":"polytraitref"},{"name":"t"}],"output":{"name":"polytraitref"}}],[5,"noop_fold_struct_field","","",null,{"inputs":[{"name":"structfield"},{"name":"t"}],"output":{"name":"structfield"}}],[5,"noop_fold_field","","",null,{"inputs":[{"name":"field"},{"name":"t"}],"output":{"name":"field"}}],[5,"noop_fold_mt","","",null,{"inputs":[{"name":"mutty"},{"name":"t"}],"output":{"name":"mutty"}}],[5,"noop_fold_opt_bounds","","",null,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"option"}}],[5,"noop_fold_block","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_item_underscore","","",null,{"inputs":[{"name":"item_"},{"name":"t"}],"output":{"name":"item_"}}],[5,"noop_fold_trait_item","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"smallvector"}}],[5,"noop_fold_impl_item","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"smallvector"}}],[5,"noop_fold_mod","","",null,{"inputs":[{"name":"mod"},{"name":"t"}],"output":{"name":"mod"}}],[5,"noop_fold_crate","","",null,{"inputs":[{"name":"crate"},{"name":"t"}],"output":{"name":"crate"}}],[5,"noop_fold_item","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"smallvector"}}],[5,"noop_fold_item_simple","","",null,{"inputs":[{"name":"item"},{"name":"t"}],"output":{"name":"item"}}],[5,"noop_fold_foreign_item","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_method_sig","","",null,{"inputs":[{"name":"methodsig"},{"name":"t"}],"output":{"name":"methodsig"}}],[5,"noop_fold_pat","","",null,{"inputs":[{"name":"p"},{"name":"t"}],"output":{"name":"p"}}],[5,"noop_fold_expr","","",null,{"inputs":[{"name":"expr"},{"name":"t"}],"output":{"name":"expr"}}],[5,"noop_fold_stmt","","",null,{"inputs":[{"name":"stmt"},{"name":"t"}],"output":{"name":"smallvector"}}],[8,"MoveMap","","",null,null],[10,"move_map","","",168,{"inputs":[{"name":"movemap"},{"name":"f"}],"output":{"name":"self"}}],[8,"Folder","","",null,null],[11,"fold_crate","","",169,{"inputs":[{"name":"folder"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_meta_items","","",169,{"inputs":[{"name":"folder"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"fold_meta_item","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_view_path","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_foreign_item","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_item","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_item_simple","","",169,{"inputs":[{"name":"folder"},{"name":"item"}],"output":{"name":"item"}}],[11,"fold_struct_field","","",169,{"inputs":[{"name":"folder"},{"name":"structfield"}],"output":{"name":"structfield"}}],[11,"fold_item_underscore","","",169,{"inputs":[{"name":"folder"},{"name":"item_"}],"output":{"name":"item_"}}],[11,"fold_trait_item","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_impl_item","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_fn_decl","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_block","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_stmt","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_arm","","",169,{"inputs":[{"name":"folder"},{"name":"arm"}],"output":{"name":"arm"}}],[11,"fold_pat","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_decl","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_expr","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_ty","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_ty_binding","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mod","","",169,{"inputs":[{"name":"folder"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_foreign_mod","","",169,{"inputs":[{"name":"folder"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fold_variant","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_ident","","",169,{"inputs":[{"name":"folder"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_usize","","",169,{"inputs":[{"name":"folder"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"fold_path","","",169,{"inputs":[{"name":"folder"},{"name":"path"}],"output":{"name":"path"}}],[11,"fold_path_parameters","","",169,{"inputs":[{"name":"folder"},{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"fold_angle_bracketed_parameter_data","","",169,{"inputs":[{"name":"folder"},{"name":"anglebracketedparameterdata"}],"output":{"name":"anglebracketedparameterdata"}}],[11,"fold_parenthesized_parameter_data","","",169,{"inputs":[{"name":"folder"},{"name":"parenthesizedparameterdata"}],"output":{"name":"parenthesizedparameterdata"}}],[11,"fold_local","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mac","","",169,{"inputs":[{"name":"folder"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"fold_explicit_self","","",169,{"inputs":[{"name":"folder"},{"name":"explicitself"}],"output":{"name":"explicitself"}}],[11,"fold_explicit_self_underscore","","",169,{"inputs":[{"name":"folder"},{"name":"explicitself_"}],"output":{"name":"explicitself_"}}],[11,"fold_lifetime","","",169,{"inputs":[{"name":"folder"},{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"fold_lifetime_def","","",169,{"inputs":[{"name":"folder"},{"name":"lifetimedef"}],"output":{"name":"lifetimedef"}}],[11,"fold_attribute","","",169,{"inputs":[{"name":"folder"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"fold_arg","","",169,{"inputs":[{"name":"folder"},{"name":"arg"}],"output":{"name":"arg"}}],[11,"fold_generics","","",169,{"inputs":[{"name":"folder"},{"name":"generics"}],"output":{"name":"generics"}}],[11,"fold_trait_ref","","",169,{"inputs":[{"name":"folder"},{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fold_poly_trait_ref","","",169,{"inputs":[{"name":"folder"},{"name":"polytraitref"}],"output":{"name":"polytraitref"}}],[11,"fold_struct_def","","",169,{"inputs":[{"name":"folder"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_lifetimes","","",169,{"inputs":[{"name":"folder"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"fold_lifetime_defs","","",169,{"inputs":[{"name":"folder"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"fold_ty_param","","",169,{"inputs":[{"name":"folder"},{"name":"typaram"}],"output":{"name":"typaram"}}],[11,"fold_ty_params","","",169,{"inputs":[{"name":"folder"},{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"fold_tt","","",169,{"inputs":[{"name":"folder"},{"name":"tokentree"}],"output":{"name":"tokentree"}}],[11,"fold_tts","","",169,null],[11,"fold_token","","",169,{"inputs":[{"name":"folder"},{"name":"token"}],"output":{"name":"token"}}],[11,"fold_interpolated","","",169,{"inputs":[{"name":"folder"},{"name":"nonterminal"}],"output":{"name":"nonterminal"}}],[11,"fold_opt_lifetime","","",169,{"inputs":[{"name":"folder"},{"name":"option"}],"output":{"name":"option"}}],[11,"fold_variant_arg","","",169,{"inputs":[{"name":"folder"},{"name":"variantarg"}],"output":{"name":"variantarg"}}],[11,"fold_opt_bounds","","",169,{"inputs":[{"name":"folder"},{"name":"option"}],"output":{"name":"option"}}],[11,"fold_bounds","","",169,{"inputs":[{"name":"folder"},{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"fold_ty_param_bound","","",169,{"inputs":[{"name":"folder"},{"name":"typarambound"}],"output":{"name":"typarambound"}}],[11,"fold_mt","","",169,{"inputs":[{"name":"folder"},{"name":"mutty"}],"output":{"name":"mutty"}}],[11,"fold_field","","",169,{"inputs":[{"name":"folder"},{"name":"field"}],"output":{"name":"field"}}],[11,"fold_where_clause","","",169,{"inputs":[{"name":"folder"},{"name":"whereclause"}],"output":{"name":"whereclause"}}],[11,"fold_where_predicate","","",169,{"inputs":[{"name":"folder"},{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"new_id","","",169,{"inputs":[{"name":"folder"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"new_span","","",169,{"inputs":[{"name":"folder"},{"name":"span"}],"output":{"name":"span"}}],[11,"move_map","collections::vec","",170,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[0,"owned_slice","syntax","",null,null],[3,"OwnedSlice","syntax::owned_slice","A non-growable owned slice. This is a separate type to allow the\nrepresentation to change.",null,null],[11,"cmp","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"option"}}],[11,"lt","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"le","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"gt","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"ge","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"eq","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"ne","","",171,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"hash","","",171,null],[11,"fmt","","",171,{"inputs":[{"name":"ownedslice"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",171,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"from_vec","","",171,{"inputs":[{"name":"ownedslice"},{"name":"vec"}],"output":{"name":"ownedslice"}}],[11,"into_vec","","",171,{"inputs":[{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"as_slice","","",171,null],[11,"move_iter","","",171,{"inputs":[{"name":"ownedslice"}],"output":{"name":"intoiter"}}],[11,"map","","",171,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[6,"Target","","",null,null],[11,"deref","","",171,null],[11,"default","","",171,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"clone","","",171,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"from_iter","","",171,{"inputs":[{"name":"ownedslice"},{"name":"i"}],"output":{"name":"ownedslice"}}],[11,"encode","","",171,{"inputs":[{"name":"ownedslice"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",171,{"inputs":[{"name":"ownedslice"},{"name":"d"}],"output":{"name":"result"}}],[0,"parse","syntax","The main parser interface",null,null],[3,"ParseSess","syntax::parse","Info about a parsing session.",null,null],[12,"span_diagnostic","","",172,null],[12,"node_id","","",172,null],[5,"new_parse_sess","","",null,{"inputs":[],"output":{"name":"parsesess"}}],[5,"new_parse_sess_special_handler","","",null,{"inputs":[{"name":"spanhandler"}],"output":{"name":"parsesess"}}],[5,"parse_crate_from_file","","",null,{"inputs":[{"name":"path"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"crate"}}],[5,"parse_crate_attrs_from_file","","",null,{"inputs":[{"name":"path"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"vec"}}],[5,"parse_crate_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"crate"}}],[5,"parse_crate_attrs_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"vec"}}],[5,"parse_expr_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"p"}}],[5,"parse_item_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"option"}}],[5,"parse_meta_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"p"}}],[5,"parse_stmt_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"option"}}],[5,"parse_tts_from_source_str","","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"vec"}}],[5,"new_parser_from_source_str","","",null,{"inputs":[{"name":"parsesess"},{"name":"crateconfig"},{"name":"string"},{"name":"string"}],"output":{"name":"parser"}}],[5,"new_parser_from_file","","Create a new parser, handling errors as appropriate\nif the file doesn't exist",null,{"inputs":[{"name":"parsesess"},{"name":"crateconfig"},{"name":"path"}],"output":{"name":"parser"}}],[5,"new_sub_parser_from_file","","Given a session, a crate config, a path, and a span, add\nthe file at the given path to the codemap, and return a parser.\nOn an error, use the given span as the source of the problem.",null,{"inputs":[{"name":"parsesess"},{"name":"crateconfig"},{"name":"path"},{"name":"bool"},{"name":"option"},{"name":"span"}],"output":{"name":"parser"}}],[5,"filemap_to_parser","","Given a filemap and config, return a parser",null,{"inputs":[{"name":"parsesess"},{"name":"rc"},{"name":"crateconfig"}],"output":{"name":"parser"}}],[5,"new_parser_from_tts","","",null,{"inputs":[{"name":"parsesess"},{"name":"crateconfig"},{"name":"vec"}],"output":{"name":"parser"}}],[5,"file_to_filemap","","Given a session and a path and an optional span (for error reporting),\nadd the path to the session's codemap and return the new filemap.",null,{"inputs":[{"name":"parsesess"},{"name":"path"},{"name":"option"}],"output":{"name":"rc"}}],[5,"string_to_filemap","","Given a session and a string, add the string to\nthe session's codemap and return the new filemap",null,{"inputs":[{"name":"parsesess"},{"name":"string"},{"name":"string"}],"output":{"name":"rc"}}],[5,"filemap_to_tts","","Given a filemap, produce a sequence of token-trees",null,{"inputs":[{"name":"parsesess"},{"name":"rc"}],"output":{"name":"vec"}}],[5,"tts_to_parser","","Given tts and cfg, produce a parser",null,{"inputs":[{"name":"parsesess"},{"name":"vec"},{"name":"crateconfig"}],"output":{"name":"parser"}}],[5,"maybe_aborted","","Abort if necessary",null,{"inputs":[{"name":"t"},{"name":"parser"}],"output":{"name":"t"}}],[5,"char_lit","","Parse a string representing a character literal into its final form.\nRather than just accepting/rejecting a given literal, unescapes it as\nwell. Can take any slice prefixed by a character escape. Returns the\ncharacter and the number of characters consumed.",null,null],[5,"str_lit","","Parse a string representing a string literal into its final form. Does\nunescaping.",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"raw_str_lit","","Parse a string representing a raw string literal into its final form. The\nonly operation this does is convert embedded CRLF into a single LF.",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"float_lit","","",null,{"inputs":[{"name":"str"},{"name":"option"},{"name":"spanhandler"},{"name":"span"}],"output":{"name":"lit_"}}],[5,"byte_lit","","Parse a string representing a byte literal into its final form. Similar to `char_lit`",null,null],[5,"binary_lit","","",null,{"inputs":[{"name":"str"}],"output":{"name":"rc"}}],[5,"integer_lit","","",null,{"inputs":[{"name":"str"},{"name":"option"},{"name":"spanhandler"},{"name":"span"}],"output":{"name":"lit_"}}],[0,"parser","","",null,null],[3,"Restrictions","syntax::parse::parser","",null,null],[3,"Parser","","",null,null],[12,"sess","","",173,null],[12,"token","","the current token:",173,null],[12,"span","","the span of the current token:",173,null],[12,"last_span","","the span of the prior token:",173,null],[12,"cfg","","",173,null],[12,"last_token","","the previous token or None (only stashed sometimes).",173,null],[12,"buffer","","",173,null],[12,"buffer_start","","",173,null],[12,"buffer_end","","",173,null],[12,"tokens_consumed","","",173,null],[12,"restrictions","","",173,null],[12,"quote_depth","","",173,null],[12,"reader","","",173,null],[12,"interner","","",173,null],[12,"obsolete_set","","The set of seen errors about obsolete syntax. Used to suppress\nextra detail when the same error is seen twice",173,null],[12,"mod_path_stack","","Used to determine the path to externally loaded source files",173,null],[12,"open_braces","","Stack of spans of open delimiters. Used for error message.",173,null],[12,"owns_directory","","Flag if this parser \"owns\" the directory that it is currently parsing\nin. This will affect how nested files are looked up.",173,null],[12,"root_module_name","","Name of the root module this parser originated from. If `None`, then the\nname is not known. This does not change while the parser is descending\ninto modules, and sub-parsers have new values for this name.",173,null],[12,"expected_tokens","","",173,null],[4,"PathParsingMode","","How to parse a path. There are four different kinds of paths, all of which\nare parsed somewhat differently.",null,null],[13,"NoTypesAllowed","","A path with no type parameters; e.g. `foo::bar::Baz`",174,null],[13,"LifetimeAndTypesWithoutColons","","A path with a lifetime and type parameters, with no double colons\nbefore the type parameters; e.g. `foo::bar<'a>::Baz<T>`",174,null],[13,"LifetimeAndTypesWithColons","","A path with a lifetime and type parameters with double colons before\nthe type parameters; e.g. `foo::bar::<'a>::Baz::<T>`",174,null],[4,"BoundParsingMode","","How to parse a bound, whether to allow bound modifiers such as `?`.",null,null],[13,"Bare","","",175,null],[13,"Modified","","",175,null],[4,"TokenType","","",null,null],[13,"Token","","",176,null],[13,"Keyword","","",176,null],[13,"Operator","","",176,null],[17,"UNRESTRICTED","","",null,null],[17,"RESTRICTION_STMT_EXPR","","",null,null],[17,"RESTRICTION_NO_STRUCT_LITERAL","","",null,null],[11,"hash","","",177,null],[11,"cmp","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"option"}}],[11,"lt","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"le","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"gt","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ge","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"clone","","",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"eq","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ne","","",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"all","","Returns the set containing all flags.",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bits","","Returns the raw value of the flags currently stored.",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",177,{"inputs":[{"name":"restrictions"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",177,{"inputs":[{"name":"restrictions"},{"name":"u8"}],"output":{"name":"restrictions"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":null}],[6,"Output","","",null,null],[11,"bitor","","Returns the union of the two sets of flags.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","","",null,null],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","","",null,null],[11,"bitand","","Returns the intersection between the two sets of flags.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","","",null,null],[11,"sub","","Returns the set difference of the two sets of flags.",177,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","","",null,null],[11,"not","","Returns the complement of this set of flags.",177,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"eq","","",174,{"inputs":[{"name":"pathparsingmode"},{"name":"pathparsingmode"}],"output":{"name":"bool"}}],[11,"ne","","",174,{"inputs":[{"name":"pathparsingmode"},{"name":"pathparsingmode"}],"output":{"name":"bool"}}],[11,"clone","","",174,{"inputs":[{"name":"pathparsingmode"}],"output":{"name":"pathparsingmode"}}],[11,"eq","","",175,{"inputs":[{"name":"boundparsingmode"},{"name":"boundparsingmode"}],"output":{"name":"bool"}}],[11,"ne","","",175,{"inputs":[{"name":"boundparsingmode"},{"name":"boundparsingmode"}],"output":{"name":"bool"}}],[11,"clone","","",175,{"inputs":[{"name":"boundparsingmode"}],"output":{"name":"boundparsingmode"}}],[11,"clone","","",176,{"inputs":[{"name":"tokentype"}],"output":{"name":"tokentype"}}],[11,"eq","","",176,{"inputs":[{"name":"tokentype"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"ne","","",176,{"inputs":[{"name":"tokentype"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"new","","",173,{"inputs":[{"name":"parser"},{"name":"parsesess"},{"name":"crateconfig"},{"name":"box"}],"output":{"name":"parser"}}],[11,"parse_expr","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_item","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"parse_pat","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_arm","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"arm"}}],[11,"parse_ty","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_stmt","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"token_to_string","","Convert a token to a string using self's reader",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"string"}}],[11,"this_token_to_string","","Convert the current token to a string using self's reader",173,{"inputs":[{"name":"parser"}],"output":{"name":"string"}}],[11,"unexpected_last","","",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"fatalerror"}}],[11,"unexpected","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"fatalerror"}}],[11,"expect","","Expect and consume the token t. Signal an error if\nthe next token is not t.",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"presult"}}],[11,"expect_one_of","","Expect next token to be edible or inedible token.  If edible,\nthen consume it; if inedible, then return without consuming\nanything.  Signal a fatal error if next token is unexpected.",173,null],[11,"check_for_erroneous_unit_struct_expecting","","Check for erroneous `ident { }`; if matches, signal error and\nrecover (without consuming any expected input token).  Returns\ntrue if and only if input was consumed for recovery.",173,null],[11,"commit_expr","","Commit to parsing a complete expression `e` expected to be\nfollowed by some token from the set edible + inedible.  Recover\nfrom anticipated input errors, discarding erroneous characters.",173,null],[11,"commit_expr_expecting","","",173,{"inputs":[{"name":"parser"},{"name":"expr"},{"name":"token"}],"output":{"name":"presult"}}],[11,"commit_stmt","","Commit to parsing a complete statement `s`, which expects to be\nfollowed by some token from the set edible + inedible.  Check\nfor recoverable input errors, discarding erroneous characters.",173,null],[11,"commit_stmt_expecting","","",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"presult"}}],[11,"parse_ident","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ident_or_self_type","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_path_list_item","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"check","","Check if the next token is `tok`, and return `true` if so.",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"bool"}}],[11,"eat","","Consume token 'tok' if it exists. Returns true if the given\ntoken was present, false otherwise.",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"presult"}}],[11,"check_keyword","","",173,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"eat_keyword","","If the next token is the given keyword, eat it and return\ntrue. Otherwise, return false.",173,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"presult"}}],[11,"eat_keyword_noexpect","","",173,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"presult"}}],[11,"expect_keyword","","If the given word is not a keyword, signal an error.\nIf the next token is not the given word, signal an error.\nOtherwise, eat it.",173,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"presult"}}],[11,"check_strict_keywords","","Signal an error if the given string is a strict keyword",173,{"inputs":[{"name":"parser"}],"output":null}],[11,"check_reserved_keywords","","Signal an error if the current token is a reserved keyword",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"expect_no_suffix","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"},{"name":"option"}],"output":null}],[11,"expect_gt","","Expect and consume a GT. if a >> is seen, replace it\nwith a single > and continue. If a GT is not seen,\nsignal an error.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_seq_to_before_gt_or_return","","",173,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq_to_before_gt","","Parse a sequence bracketed by '<' and '>', stopping\nbefore the '>'.",173,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq_to_gt","","",173,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq_to_gt_or_return","","",173,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq_to_end","","Parse a sequence, including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",173,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq_to_before_end","","Parse a sequence, not including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",173,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_unspanned_seq","","Parse a sequence, including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",173,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_enum_variant_seq","","Parse a sequence parameter of enum variant. For consistency purposes,\nthese should not be empty.",173,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"presult"}}],[11,"parse_seq","","",173,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"presult"}}],[11,"bump","","Advance the parser by one token",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"bump_and_get","","Advance the parser by one token and return the bumped token.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"replace_token","","EFFECT: replace the current token and span with the given one",173,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"bytepos"},{"name":"bytepos"}],"output":null}],[11,"buffer_length","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"isize"}}],[11,"look_ahead","","",173,{"inputs":[{"name":"parser"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[11,"fatal","","",173,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_help","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_note","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_help","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":null}],[11,"fileline_help","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":null}],[11,"bug","","",173,{"inputs":[{"name":"parser"},{"name":"str"}],"output":null}],[11,"warn","","",173,{"inputs":[{"name":"parser"},{"name":"str"}],"output":null}],[11,"span_warn","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_err","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_bug","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":null}],[11,"abort_if_errors","","",173,{"inputs":[{"name":"parser"}],"output":null}],[11,"id_to_interned_str","","",173,{"inputs":[{"name":"parser"},{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"token_is_bare_fn_keyword","","Is the current token one of the keywords that signals a bare function\ntype?",173,{"inputs":[{"name":"parser"}],"output":{"name":"bool"}}],[11,"get_lifetime","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"ident"}}],[11,"parse_for_in_type","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ty_path","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ty_bare_fn","","parse a TyBareFn type:",173,{"inputs":[{"name":"parser"},{"name":"vec"}],"output":{"name":"presult"}}],[11,"parse_obsolete_closure_kind","","Parses an obsolete closure kind (`&:`, `&mut:`, or `:`).",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_unsafety","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_trait_items","","Parse the items in a trait declaration",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_mt","","Parse a possibly mutable type",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ret_ty","","Parse optional return type [ -> TY ] in function decl",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ty_sum","","Parse a type in a context where `T1+T2` is allowed.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ty_nopanic","","Parse a type.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_borrowed_pointee","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_ptr","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"is_named_argument","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"bool"}}],[11,"parse_arg_general","","This version of parse arg doesn't necessarily require\nidentifier names.",173,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"presult"}}],[11,"parse_arg","","Parse a single function argument",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_fn_block_arg","","Parse an argument in a lambda header e.g. |arg, arg|",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"maybe_parse_fixed_length_of_vec","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"lit_from_token","","Matches token_lit = LIT_INTEGER | ...",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"presult"}}],[11,"parse_lit","","Matches lit = true | false | token_lit",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_literal_maybe_minus","","matches '-' lit | lit",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_path","","Parses a path and optional type parameter bounds, depending on the\nmode. The `mode` parameter determines whether lifetimes, types, and/or\nbounds are permitted and whether `::` must precede type parameter\ngroups.",173,{"inputs":[{"name":"parser"},{"name":"pathparsingmode"}],"output":{"name":"presult"}}],[11,"parse_path_segments_without_colons","","Examples:\n- `a::b<T,U>::c<V,W>`\n- `a::b<T,U>::c(V) -> W`\n- `a::b<T,U>::c(V)`",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_path_segments_with_colons","","Examples:\n- `a::b::<T,U>::c`",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_path_segments_without_types","","Examples:\n- `a::b::c`",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_opt_lifetime","","parses 0 or 1 lifetime",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_lifetime","","Parses a single lifetime\nMatches lifetime = LIFETIME",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_lifetime_defs","","Parses `lifetime_defs = [ lifetime_defs { ',' lifetime_defs } ]` where `lifetime_def  =\nlifetime [':' lifetimes]`",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_lifetimes","","matches lifetimes = ( lifetime ) | ( lifetime , lifetimes ) actually, it matches the empty\none too, but putting that in there messes up the grammar....",173,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"presult"}}],[11,"parse_mutability","","Parse mutability declaration (mut/const/imm)",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_field","","Parse ident COLON expr",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"mk_expr","","",173,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"bytepos"},{"name":"expr_"}],"output":{"name":"p"}}],[11,"mk_unary","","",173,{"inputs":[{"name":"parser"},{"name":"unop"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_binary","","",173,{"inputs":[{"name":"parser"},{"name":"binop"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_call","","",173,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"vec"}],"output":{"name":"expr_"}}],[11,"mk_index","","",173,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_range","","",173,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"option"}],"output":{"name":"expr_"}}],[11,"mk_field","","",173,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"spannedident"}],"output":{"name":"expr_"}}],[11,"mk_tup_field","","",173,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"spanned"}],"output":{"name":"expr_"}}],[11,"mk_assign_op","","",173,{"inputs":[{"name":"parser"},{"name":"binop"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_mac_expr","","",173,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"bytepos"},{"name":"mac_"}],"output":{"name":"p"}}],[11,"mk_lit_u32","","",173,{"inputs":[{"name":"parser"},{"name":"u32"}],"output":{"name":"p"}}],[11,"parse_bottom_expr","","At the bottom (top?) of the precedence hierarchy,\nparse things like parenthesized exprs,\nmacros, return, etc.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_block_expr","","Parse a block or unsafe block",173,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"blockcheckmode"}],"output":{"name":"presult"}}],[11,"parse_dot_or_call_expr","","parse a.b or a(13) or a[4] or just a",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_dot_or_call_expr_with","","",173,{"inputs":[{"name":"parser"},{"name":"p"}],"output":{"name":"presult"}}],[11,"check_unknown_macro_variable","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_sep_and_kleene_op","","Parse an optional separator followed by a Kleene-style\nrepetition token (+ or *).",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_token_tree","","parse a single token tree from the input.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_all_token_trees","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_prefix_expr","","Parse a prefix-operator expr",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_binops","","Parse an expression of binops",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_more_binops","","Parse an expression of binops of at least min_prec precedence",173,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"usize"}],"output":{"name":"presult"}}],[11,"parse_assign_expr","","Parse an assignment expression....\nactually, this seems to be the main entry point for\nparsing an arbitrary expression.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_assign_expr_with","","",173,{"inputs":[{"name":"parser"},{"name":"p"}],"output":{"name":"presult"}}],[11,"parse_if_expr","","Parse an 'if' or 'if let' expression ('if' token already eaten)",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_if_let_expr","","Parse an 'if let' expression ('if' token already eaten)",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_lambda_expr","","",173,{"inputs":[{"name":"parser"},{"name":"captureclause"}],"output":{"name":"presult"}}],[11,"parse_else_expr","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_for_expr","","Parse a 'for' .. 'in' expression ('for' token already eaten)",173,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"presult"}}],[11,"parse_while_expr","","Parse a 'while' or 'while let' expression ('while' token already eaten)",173,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"presult"}}],[11,"parse_while_let_expr","","Parse a 'while let' expression ('while' token already eaten)",173,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"presult"}}],[11,"parse_loop_expr","","",173,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"presult"}}],[11,"parse_arm_nopanic","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_expr_nopanic","","Parse an expression",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_expr_res","","Parse an expression, subject to the given restrictions",173,{"inputs":[{"name":"parser"},{"name":"restrictions"}],"output":{"name":"presult"}}],[11,"parse_pat_nopanic","","Parse a pattern.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_stmt_nopanic","","Parse a statement. may include decl.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_block","","Parse a block. No inner attrs are allowed.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_generics","","Parse a set of optional generic type parameter declarations. Where\nclauses are not parsed here, and must be added later via\n`parse_where_clause()`.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_where_clause","","Parses an optional `where` clause and places it in `generics`.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_fn_decl","","Parse the argument list and result type of a function declaration",173,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"presult"}}],[11,"parse_impl_item","","Parse an impl item.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_record_struct_body","","",173,{"inputs":[{"name":"parser"},{"name":"ident"}],"output":{"name":"presult"}}],[11,"parse_tuple_struct_body","","",173,{"inputs":[{"name":"parser"},{"name":"ident"},{"name":"generics"}],"output":{"name":"presult"}}],[11,"parse_single_struct_field","","Parse a structure field declaration",173,{"inputs":[{"name":"parser"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"presult"}}],[11,"parse_item_nopanic","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_crate_mod","","Parses a source module as a crate. This is the main\nentry point for the parser.",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_optional_str","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[11,"parse_str","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"presult"}}],[0,"lexer","syntax::parse","",null,null],[3,"TokenAndSpan","syntax::parse::lexer","",null,null],[12,"tok","","",178,null],[12,"sp","","",178,null],[3,"StringReader","","",null,null],[12,"span_diagnostic","","",179,null],[12,"pos","","The absolute offset within the codemap of the next character to read",179,null],[12,"last_pos","","The absolute offset within the codemap of the last character read(curr)",179,null],[12,"col","","The column of the next character to read",179,null],[12,"curr","","The last character to be read",179,null],[12,"filemap","","",179,null],[12,"peek_tok","","",179,null],[12,"peek_span","","",179,null],[5,"make_reader_with_embedded_idents","","",null,{"inputs":[{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[5,"is_whitespace","","",null,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[5,"is_doc_comment","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"is_block_doc_comment","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[0,"comments","","",null,null],[3,"Comment","syntax::parse::lexer::comments","",null,null],[12,"style","","",180,null],[12,"lines","","",180,null],[12,"pos","","",180,null],[3,"Literal","","",null,null],[12,"lit","","",181,null],[12,"pos","","",181,null],[4,"CommentStyle","","",null,null],[13,"Isolated","","No code on either side of each line of the comment",182,null],[13,"Trailing","","Code exists to the left of the comment",182,null],[13,"Mixed","","Code before /* foo */ and after the comment",182,null],[13,"BlankLine","","Just a manual blank line \"\\n\\n\", for layout",182,null],[5,"is_doc_comment","","",null,{"inputs":[{"name":"str"}],"output":{"name":"bool"}}],[5,"doc_comment_style","","",null,{"inputs":[{"name":"str"}],"output":{"name":"attrstyle"}}],[5,"strip_doc_comment_decoration","","",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"gather_comments_and_literals","","",null,null],[11,"eq","","",182,{"inputs":[{"name":"commentstyle"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"ne","","",182,{"inputs":[{"name":"commentstyle"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"clone","","",182,{"inputs":[{"name":"commentstyle"}],"output":{"name":"commentstyle"}}],[11,"clone","","",180,{"inputs":[{"name":"comment"}],"output":{"name":"comment"}}],[11,"clone","","",181,{"inputs":[{"name":"literal"}],"output":{"name":"literal"}}],[8,"Reader","syntax::parse::lexer","",null,null],[10,"is_eof","","",183,{"inputs":[{"name":"reader"}],"output":{"name":"bool"}}],[10,"next_token","","",183,{"inputs":[{"name":"reader"}],"output":{"name":"tokenandspan"}}],[10,"fatal","","Report a fatal error with the current span.",183,{"inputs":[{"name":"reader"},{"name":"str"}],"output":null}],[10,"err","","Report a non-fatal error with the current span.",183,{"inputs":[{"name":"reader"},{"name":"str"}],"output":null}],[10,"peek","","",183,{"inputs":[{"name":"reader"}],"output":{"name":"tokenandspan"}}],[11,"real_token","","Get a token the parser cares about.",183,{"inputs":[{"name":"reader"}],"output":{"name":"tokenandspan"}}],[11,"fmt","","",178,{"inputs":[{"name":"tokenandspan"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",178,{"inputs":[{"name":"tokenandspan"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"ne","","",178,{"inputs":[{"name":"tokenandspan"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"clone","","",178,{"inputs":[{"name":"tokenandspan"}],"output":{"name":"tokenandspan"}}],[11,"is_eof","","",179,{"inputs":[{"name":"stringreader"}],"output":{"name":"bool"}}],[11,"next_token","","Return the next token. EFFECT: advances the string_reader.",179,{"inputs":[{"name":"stringreader"}],"output":{"name":"tokenandspan"}}],[11,"fatal","","",179,{"inputs":[{"name":"stringreader"},{"name":"str"}],"output":null}],[11,"err","","",179,{"inputs":[{"name":"stringreader"},{"name":"str"}],"output":null}],[11,"peek","","",179,{"inputs":[{"name":"stringreader"}],"output":{"name":"tokenandspan"}}],[11,"new_raw","","For comments.rs, which hackily pokes into pos and curr",179,{"inputs":[{"name":"stringreader"},{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[11,"new","","",179,{"inputs":[{"name":"stringreader"},{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[11,"curr_is","","",179,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"fatal_span","","Report a fatal lexical error with a given span.",179,{"inputs":[{"name":"stringreader"},{"name":"span"},{"name":"str"}],"output":null}],[11,"err_span","","Report a lexical error with a given span.",179,{"inputs":[{"name":"stringreader"},{"name":"span"},{"name":"str"}],"output":null}],[11,"with_str_from","","Calls `f` with a string slice of the source text spanning from `start`\nup to but excluding `self.last_pos`, meaning the slice does not include\nthe character `self.curr`.",179,{"inputs":[{"name":"stringreader"},{"name":"bytepos"},{"name":"f"}],"output":{"name":"t"}}],[11,"name_from","","Create a Name from a given offset to the current offset, each\nadjusted 1 towards each other (assumes that on either side there is a\nsingle-byte delimiter).",179,{"inputs":[{"name":"stringreader"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"name_from_to","","As name_from, with an explicit endpoint.",179,{"inputs":[{"name":"stringreader"},{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"bump","","Advance the StringReader by one character. If a newline is\ndiscovered, add it to the FileMap's list of line start offsets.",179,{"inputs":[{"name":"stringreader"}],"output":null}],[11,"nextch","","",179,{"inputs":[{"name":"stringreader"}],"output":{"name":"option"}}],[11,"nextch_is","","",179,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"nextnextch","","",179,{"inputs":[{"name":"stringreader"}],"output":{"name":"option"}}],[11,"nextnextch_is","","",179,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[0,"token","syntax::parse","",null,null],[3,"InternedString","syntax::parse::token","Represents a string stored in the thread-local interner. Because the\ninterner lives for the life of the thread, this can be safely treated as an\nimmortal string, as long as it never crosses between threads.",null,null],[4,"BinOpToken","","",null,null],[13,"Plus","","",184,null],[13,"Minus","","",184,null],[13,"Star","","",184,null],[13,"Slash","","",184,null],[13,"Percent","","",184,null],[13,"Caret","","",184,null],[13,"And","","",184,null],[13,"Or","","",184,null],[13,"Shl","","",184,null],[13,"Shr","","",184,null],[4,"DelimToken","","A delimiter token",null,null],[13,"Paren","","A round parenthesis: `(` or `)`",185,null],[13,"Bracket","","A square bracket: `[` or `]`",185,null],[13,"Brace","","A curly brace: `{` or `}`",185,null],[4,"IdentStyle","","",null,null],[13,"ModName","","`::` follows the identifier with no whitespace in-between.",186,null],[13,"Plain","","",186,null],[4,"SpecialMacroVar","","",null,null],[13,"CrateMacroVar","","`$crate` will be filled in with the name of the crate a macro was\nimported from, if any.",187,null],[4,"Lit","","",null,null],[13,"Byte","","",188,null],[13,"Char","","",188,null],[13,"Integer","","",188,null],[13,"Float","","",188,null],[13,"Str_","","",188,null],[13,"StrRaw","","",188,null],[13,"Binary","","",188,null],[13,"BinaryRaw","","",188,null],[4,"Token","","",null,null],[13,"Eq","","",189,null],[13,"Lt","","",189,null],[13,"Le","","",189,null],[13,"EqEq","","",189,null],[13,"Ne","","",189,null],[13,"Ge","","",189,null],[13,"Gt","","",189,null],[13,"AndAnd","","",189,null],[13,"OrOr","","",189,null],[13,"Not","","",189,null],[13,"Tilde","","",189,null],[13,"BinOp","","",189,null],[13,"BinOpEq","","",189,null],[13,"At","","",189,null],[13,"Dot","","",189,null],[13,"DotDot","","",189,null],[13,"DotDotDot","","",189,null],[13,"Comma","","",189,null],[13,"Semi","","",189,null],[13,"Colon","","",189,null],[13,"ModSep","","",189,null],[13,"RArrow","","",189,null],[13,"LArrow","","",189,null],[13,"FatArrow","","",189,null],[13,"Pound","","",189,null],[13,"Dollar","","",189,null],[13,"Question","","",189,null],[13,"OpenDelim","","An opening delimiter, eg. `{`",189,null],[13,"CloseDelim","","A closing delimiter, eg. `}`",189,null],[13,"Literal","","",189,null],[13,"Ident","","",189,null],[13,"Underscore","","",189,null],[13,"Lifetime","","",189,null],[13,"Interpolated","","",189,null],[13,"DocComment","","Doc comment",189,null],[13,"MatchNt","","Parse a nonterminal (name to bind, name of NT, styles of their idents)",189,null],[13,"SubstNt","","A syntactic variable that will be filled in by macro expansion.",189,null],[13,"SpecialVarNt","","A macro variable with special meaning.",189,null],[13,"Whitespace","","Whitespace",189,null],[13,"Comment","","Comment",189,null],[13,"Shebang","","",189,null],[13,"Eof","","",189,null],[4,"Nonterminal","","For interpolation during macro expansion.",null,null],[13,"NtItem","","",190,null],[13,"NtBlock","","",190,null],[13,"NtStmt","","",190,null],[13,"NtPat","","",190,null],[13,"NtExpr","","",190,null],[13,"NtTy","","",190,null],[13,"NtIdent","","",190,null],[13,"NtMeta","","Stuff inside brackets for attributes",190,null],[13,"NtPath","","",190,null],[13,"NtTT","","",190,null],[5,"get_ident_interner","","",null,{"inputs":[],"output":{"name":"rc"}}],[5,"reset_ident_interner","","Reset the ident interner to its initial state.",null,{"inputs":[],"output":null}],[5,"get_name","","Returns the string contents of a name, using the thread-local interner.",null,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[5,"get_ident","","Returns the string contents of an identifier, using the thread-local\ninterner.",null,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[5,"intern_and_get_ident","","Interns and returns the string contents of an identifier, using the\nthread-local interner.",null,{"inputs":[{"name":"str"}],"output":{"name":"internedstring"}}],[5,"intern","","Maps a string to its interned representation.",null,{"inputs":[{"name":"str"}],"output":{"name":"name"}}],[5,"gensym","","gensym's a new usize, using the current interner.",null,{"inputs":[{"name":"str"}],"output":{"name":"name"}}],[5,"str_to_ident","","Maps a string to an identifier with an empty syntax context.",null,{"inputs":[{"name":"str"}],"output":{"name":"ident"}}],[5,"gensym_ident","","Maps a string to a gensym'ed identifier.",null,{"inputs":[{"name":"str"}],"output":{"name":"ident"}}],[5,"fresh_name","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"name"}}],[5,"fresh_mark","","",null,{"inputs":[],"output":{"name":"mrk"}}],[0,"special_idents","","",null,null],[17,"invalid","syntax::parse::token::special_idents","",null,null],[17,"self_","","",null,null],[17,"statik","","",null,null],[17,"super_","","",null,null],[17,"static_lifetime","","",null,null],[17,"tt","","",null,null],[17,"matchers","","",null,null],[17,"clownshoe_abi","","",null,null],[17,"opaque","","",null,null],[17,"unnamed_field","","",null,null],[17,"type_self","","",null,null],[17,"prelude_import","","",null,null],[0,"special_names","syntax::parse::token","",null,null],[17,"invalid","syntax::parse::token::special_names","",null,null],[17,"self_","","",null,null],[17,"statik","","",null,null],[17,"super_","","",null,null],[17,"static_lifetime","","",null,null],[17,"tt","","",null,null],[17,"matchers","","",null,null],[17,"clownshoe_abi","","",null,null],[17,"opaque","","",null,null],[17,"unnamed_field","","",null,null],[17,"type_self","","",null,null],[17,"prelude_import","","",null,null],[0,"keywords","syntax::parse::token","All the valid words that have meaning in the Rust language.",null,null],[4,"Keyword","syntax::parse::token::keywords","",null,null],[13,"As","","",191,null],[13,"Break","","",191,null],[13,"Crate","","",191,null],[13,"Else","","",191,null],[13,"Enum","","",191,null],[13,"Extern","","",191,null],[13,"False","","",191,null],[13,"Fn","","",191,null],[13,"For","","",191,null],[13,"If","","",191,null],[13,"Impl","","",191,null],[13,"In","","",191,null],[13,"Let","","",191,null],[13,"Loop","","",191,null],[13,"Match","","",191,null],[13,"Mod","","",191,null],[13,"Move","","",191,null],[13,"Mut","","",191,null],[13,"Pub","","",191,null],[13,"Ref","","",191,null],[13,"Return","","",191,null],[13,"Static","","",191,null],[13,"SelfValue","","",191,null],[13,"SelfType","","",191,null],[13,"Struct","","",191,null],[13,"Super","","",191,null],[13,"True","","",191,null],[13,"Trait","","",191,null],[13,"Type","","",191,null],[13,"Unsafe","","",191,null],[13,"Use","","",191,null],[13,"Virtual","","",191,null],[13,"While","","",191,null],[13,"Continue","","",191,null],[13,"Box","","",191,null],[13,"Const","","",191,null],[13,"Where","","",191,null],[13,"Proc","","",191,null],[13,"Alignof","","",191,null],[13,"Become","","",191,null],[13,"Offsetof","","",191,null],[13,"Priv","","",191,null],[13,"Pure","","",191,null],[13,"Sizeof","","",191,null],[13,"Typeof","","",191,null],[13,"Unsized","","",191,null],[13,"Yield","","",191,null],[13,"Do","","",191,null],[13,"Abstract","","",191,null],[13,"Final","","",191,null],[13,"Override","","",191,null],[13,"Macro","","",191,null],[11,"eq","","",191,{"inputs":[{"name":"keyword"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"ne","","",191,{"inputs":[{"name":"keyword"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"clone","","",191,{"inputs":[{"name":"keyword"}],"output":{"name":"keyword"}}],[11,"to_name","","",191,{"inputs":[{"name":"keyword"}],"output":{"name":"name"}}],[6,"IdentInterner","syntax::parse::token","",null,null],[17,"SELF_KEYWORD_NAME","","",null,null],[17,"SELF_KEYWORD_NAME_NUM","","",null,null],[11,"fmt","","",184,{"inputs":[{"name":"binoptoken"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",184,null],[11,"eq","","",184,{"inputs":[{"name":"binoptoken"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"ne","","",184,{"inputs":[{"name":"binoptoken"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"decode","","",184,{"inputs":[{"name":"binoptoken"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",184,{"inputs":[{"name":"binoptoken"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",184,{"inputs":[{"name":"binoptoken"}],"output":{"name":"binoptoken"}}],[11,"fmt","","",185,{"inputs":[{"name":"delimtoken"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",185,null],[11,"eq","","",185,{"inputs":[{"name":"delimtoken"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"delimtoken"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"decode","","",185,{"inputs":[{"name":"delimtoken"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",185,{"inputs":[{"name":"delimtoken"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",185,{"inputs":[{"name":"delimtoken"}],"output":{"name":"delimtoken"}}],[11,"fmt","","",186,{"inputs":[{"name":"identstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",186,null],[11,"eq","","",186,{"inputs":[{"name":"identstyle"},{"name":"identstyle"}],"output":{"name":"bool"}}],[11,"ne","","",186,{"inputs":[{"name":"identstyle"},{"name":"identstyle"}],"output":{"name":"bool"}}],[11,"decode","","",186,{"inputs":[{"name":"identstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",186,{"inputs":[{"name":"identstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",186,{"inputs":[{"name":"identstyle"}],"output":{"name":"identstyle"}}],[11,"fmt","","",187,{"inputs":[{"name":"specialmacrovar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",187,null],[11,"eq","","",187,{"inputs":[{"name":"specialmacrovar"},{"name":"specialmacrovar"}],"output":{"name":"bool"}}],[11,"ne","","",187,{"inputs":[{"name":"specialmacrovar"},{"name":"specialmacrovar"}],"output":{"name":"bool"}}],[11,"decode","","",187,{"inputs":[{"name":"specialmacrovar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",187,{"inputs":[{"name":"specialmacrovar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",187,{"inputs":[{"name":"specialmacrovar"}],"output":{"name":"specialmacrovar"}}],[11,"as_str","","",187,{"inputs":[{"name":"specialmacrovar"}],"output":{"name":"str"}}],[11,"fmt","","",188,{"inputs":[{"name":"lit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",188,null],[11,"eq","","",188,{"inputs":[{"name":"lit"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"ne","","",188,{"inputs":[{"name":"lit"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"decode","","",188,{"inputs":[{"name":"lit"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",188,{"inputs":[{"name":"lit"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",188,{"inputs":[{"name":"lit"}],"output":{"name":"lit"}}],[11,"short_name","","",188,{"inputs":[{"name":"lit"}],"output":{"name":"str"}}],[11,"fmt","","",189,{"inputs":[{"name":"token"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",189,null],[11,"eq","","",189,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"ne","","",189,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"decode","","",189,{"inputs":[{"name":"token"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",189,{"inputs":[{"name":"token"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",189,{"inputs":[{"name":"token"}],"output":{"name":"token"}}],[11,"is_like_gt","","Returns `true` if the token starts with '>'.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"can_begin_expr","","Returns `true` if the token can appear at the start of an expression.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_lit","","Returns `true` if the token is any literal",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_ident","","Returns `true` if the token is an identifier.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_path","","Returns `true` if the token is an interpolated path.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_plain_ident","","Returns `true` if the token is a path that is not followed by a `::`\ntoken.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_lifetime","","Returns `true` if the token is a lifetime.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_mutability","","Returns `true` if the token is either the `mut` or `const` keyword.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"to_binop","","Maps a token to its corresponding binary operator.",189,{"inputs":[{"name":"token"}],"output":{"name":"option"}}],[11,"is_keyword","","Returns `true` if the token is a given keyword, `kw`.",189,{"inputs":[{"name":"token"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_keyword_allow_following_colon","","",189,{"inputs":[{"name":"token"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_any_keyword","","Returns `true` if the token is either a special identifier, or a strict\nor reserved keyword.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_strict_keyword","","Returns `true` if the token may not appear as an identifier.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_reserved_keyword","","Returns `true` if the token is a keyword that has been reserved for\npossible future use.",189,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"mtwt_eq","","Hygienic identifier equality comparison.",189,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"hash","","",190,null],[11,"eq","","",190,{"inputs":[{"name":"nonterminal"},{"name":"nonterminal"}],"output":{"name":"bool"}}],[11,"ne","","",190,{"inputs":[{"name":"nonterminal"},{"name":"nonterminal"}],"output":{"name":"bool"}}],[11,"decode","","",190,{"inputs":[{"name":"nonterminal"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",190,{"inputs":[{"name":"nonterminal"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",190,{"inputs":[{"name":"nonterminal"}],"output":{"name":"nonterminal"}}],[11,"fmt","","",190,{"inputs":[{"name":"nonterminal"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"option"}}],[11,"lt","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"le","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"gt","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"ge","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"hash","","",192,null],[11,"eq","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"ne","","",192,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"clone","","",192,{"inputs":[{"name":"internedstring"}],"output":{"name":"internedstring"}}],[11,"new","","",192,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"internedstring"}}],[6,"Target","","",null,null],[11,"deref","","",192,{"inputs":[{"name":"internedstring"}],"output":{"name":"str"}}],[11,"fmt","","",192,{"inputs":[{"name":"internedstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",192,{"inputs":[{"name":"internedstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",192,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",192,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"decode","","",192,{"inputs":[{"name":"internedstring"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",192,{"inputs":[{"name":"internedstring"},{"name":"s"}],"output":{"name":"result"}}],[0,"attr","syntax::parse","",null,null],[8,"ParserAttr","syntax::parse::attr","A parser that can parse attributes.",null,null],[10,"parse_outer_attributes","","",193,{"inputs":[{"name":"parserattr"}],"output":{"name":"vec"}}],[10,"parse_inner_attributes","","",193,{"inputs":[{"name":"parserattr"}],"output":{"name":"vec"}}],[10,"parse_attribute","","",193,{"inputs":[{"name":"parserattr"},{"name":"bool"}],"output":{"name":"attribute"}}],[10,"parse_meta_item","","",193,{"inputs":[{"name":"parserattr"}],"output":{"name":"p"}}],[10,"parse_meta_seq","","",193,{"inputs":[{"name":"parserattr"}],"output":{"name":"vec"}}],[10,"parse_optional_meta","","",193,{"inputs":[{"name":"parserattr"}],"output":{"name":"vec"}}],[11,"parse_outer_attributes","syntax::parse::parser","Parse attributes that appear before an item",173,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_attribute","","Matches `attribute = # ! [ meta_item ]`",173,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"attribute"}}],[11,"parse_inner_attributes","","Parse attributes that appear after the opening of an item. These should\nbe preceded by an exclamation mark, but we accept and warn about one\nterminated by a semicolon.\nmatches inner_attrs*",173,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_meta_item","","matches meta_item = IDENT\n| IDENT = lit\n| IDENT meta_seq",173,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_meta_seq","","matches meta_seq = ( COMMASEP(meta_item) )",173,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_optional_meta","","",173,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[0,"common","syntax::parse","Common routines shared by parser mods",null,null],[3,"SeqSep","syntax::parse::common","SeqSep : a sequence separator (token)\nand whether a trailing separator is allowed.",null,null],[12,"sep","","",194,null],[12,"trailing_sep_allowed","","",194,null],[5,"seq_sep_trailing_allowed","","",null,{"inputs":[{"name":"token"}],"output":{"name":"seqsep"}}],[5,"seq_sep_none","","",null,{"inputs":[],"output":{"name":"seqsep"}}],[0,"classify","syntax::parse","Routines the parser uses to classify AST nodes",null,null],[5,"expr_requires_semi_to_be_stmt","syntax::parse::classify","Does this expression require a semicolon to be treated\nas a statement? The negation of this: 'can this expression\nbe used as a statement without a semicolon' -- is used\nas an early-bail-out in the parser so that, for instance,\n    if true {...} else {...}\n     |x| 5\nisn't parsed as (if true {...} else {...} | x) | 5",null,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[5,"expr_is_simple_block","","",null,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[5,"stmt_ends_with_semi","","this statement requires a semicolon after it.\nnote that in one case (stmt_semi), we've already\nseen the semicolon, and thus don't need another.",null,{"inputs":[{"name":"stmt_"}],"output":{"name":"bool"}}],[0,"obsolete","syntax::parse","Support for parsing unsupported, old syntaxes, for the purpose of reporting errors. Parsing of\nthese syntaxes is tested by compile-test/obsolete-syntax.rs.",null,null],[4,"ObsoleteSyntax","syntax::parse::obsolete","The specific types of unsupported syntax",null,null],[13,"ClosureKind","","",195,null],[13,"ExternCrateString","","",195,null],[8,"ParserObsoleteMethods","","",null,null],[10,"obsolete","","Reports an obsolete syntax non-fatal error.",196,{"inputs":[{"name":"parserobsoletemethods"},{"name":"span"},{"name":"obsoletesyntax"}],"output":null}],[10,"obsolete_expr","","Reports an obsolete syntax non-fatal error, and returns\na placeholder expression",196,{"inputs":[{"name":"parserobsoletemethods"},{"name":"span"},{"name":"obsoletesyntax"}],"output":{"name":"p"}}],[10,"report","","",196,{"inputs":[{"name":"parserobsoletemethods"},{"name":"span"},{"name":"obsoletesyntax"},{"name":"str"},{"name":"str"},{"name":"bool"}],"output":null}],[10,"is_obsolete_ident","","",196,{"inputs":[{"name":"parserobsoletemethods"},{"name":"str"}],"output":{"name":"bool"}}],[10,"eat_obsolete_ident","","",196,{"inputs":[{"name":"parserobsoletemethods"},{"name":"str"}],"output":{"name":"bool"}}],[11,"hash","","",195,null],[11,"eq","","",195,{"inputs":[{"name":"obsoletesyntax"},{"name":"obsoletesyntax"}],"output":{"name":"bool"}}],[11,"ne","","",195,{"inputs":[{"name":"obsoletesyntax"},{"name":"obsoletesyntax"}],"output":{"name":"bool"}}],[11,"clone","","",195,{"inputs":[{"name":"obsoletesyntax"}],"output":{"name":"obsoletesyntax"}}],[11,"obsolete","syntax::parse::parser","Reports an obsolete syntax non-fatal error.",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"obsoletesyntax"}],"output":null}],[11,"obsolete_expr","","Reports an obsolete syntax non-fatal error, and returns\na placeholder expression",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"obsoletesyntax"}],"output":{"name":"p"}}],[11,"report","","",173,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"obsoletesyntax"},{"name":"str"},{"name":"str"},{"name":"bool"}],"output":null}],[11,"is_obsolete_ident","","",173,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eat_obsolete_ident","","",173,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"bool"}}],[0,"with_hygiene","syntax::parse","",null,null],[5,"parse_tts_from_source_str","syntax::parse::with_hygiene","",null,{"inputs":[{"name":"string"},{"name":"string"},{"name":"crateconfig"},{"name":"parsesess"}],"output":{"name":"vec"}}],[6,"PResult","syntax::parse","",null,null],[11,"next_node_id","","",172,{"inputs":[{"name":"parsesess"}],"output":{"name":"nodeid"}}],[11,"reserve_node_ids","","",172,{"inputs":[{"name":"parsesess"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[0,"ptr","syntax","The AST pointer",null,null],[3,"P","syntax::ptr","An owned smart pointer.",null,null],[5,"P","","Construct a `P<T>` from a `T` value.",null,{"inputs":[{"name":"t"}],"output":{"name":"p"}}],[11,"and_then","","Move out of the pointer.\nIntended for chaining transformations not covered by `map`.",197,{"inputs":[{"name":"p"},{"name":"f"}],"output":{"name":"u"}}],[11,"map","","Transform the inner value, consuming `self` and producing a new `P<T>`.",197,{"inputs":[{"name":"p"},{"name":"f"}],"output":{"name":"p"}}],[6,"Target","","",null,null],[11,"deref","","",197,{"inputs":[{"name":"p"}],"output":{"name":"t"}}],[11,"clone","","",197,{"inputs":[{"name":"p"}],"output":{"name":"p"}}],[11,"eq","","",197,{"inputs":[{"name":"p"},{"name":"p"}],"output":{"name":"bool"}}],[11,"fmt","","",197,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",197,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",197,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",197,{"inputs":[{"name":"p"},{"name":"h"}],"output":null}],[11,"decode","","",197,{"inputs":[{"name":"p"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",197,{"inputs":[{"name":"p"},{"name":"s"}],"output":{"name":"result"}}],[0,"show_span","syntax","Span debugger",null,null],[5,"run","syntax::show_span","",null,{"inputs":[{"name":"spanhandler"},{"name":"str"},{"name":"crate"}],"output":null}],[0,"std_inject","syntax","",null,null],[5,"maybe_inject_crates_ref","syntax::std_inject","",null,{"inputs":[{"name":"crate"},{"name":"option"}],"output":{"name":"crate"}}],[5,"maybe_inject_prelude","","",null,{"inputs":[{"name":"crate"}],"output":{"name":"crate"}}],[5,"use_std","","",null,{"inputs":[{"name":"crate"}],"output":{"name":"bool"}}],[0,"test","syntax","",null,null],[5,"modify_for_testing","syntax::test","",null,{"inputs":[{"name":"parsesess"},{"name":"crateconfig"},{"name":"crate"},{"name":"spanhandler"}],"output":{"name":"crate"}}],[0,"visit","syntax","AST walker. Each overridden visit method has full control over what\nhappens with its node, it can do its own traversal of the node's children,\ncall `visit::walk_*` to apply the default traversal algorithm, or prevent\ndeeper traversal by doing nothing.",null,null],[4,"FnKind","syntax::visit","",null,null],[13,"FkItemFn","","fn foo() or extern \"Abi\" fn foo()",198,null],[13,"FkMethod","","fn foo(&self)",198,null],[13,"FkFnBlock","","|x, y| ...\nproc(x, y) ...",198,null],[5,"walk_inlined_item","","",null,{"inputs":[{"name":"v"},{"name":"inlineditem"}],"output":null}],[5,"walk_crate","","",null,{"inputs":[{"name":"v"},{"name":"crate"}],"output":null}],[5,"walk_mod","","",null,{"inputs":[{"name":"v"},{"name":"mod"}],"output":null}],[5,"walk_local","","",null,{"inputs":[{"name":"v"},{"name":"local"}],"output":null}],[5,"walk_lifetime_def","","",null,{"inputs":[{"name":"v"},{"name":"lifetimedef"}],"output":null}],[5,"walk_lifetime_bound","","",null,{"inputs":[{"name":"v"},{"name":"lifetime"}],"output":null}],[5,"walk_lifetime_ref","","",null,{"inputs":[{"name":"v"},{"name":"lifetime"}],"output":null}],[5,"walk_explicit_self","","",null,{"inputs":[{"name":"v"},{"name":"explicitself"}],"output":null}],[5,"walk_poly_trait_ref","","",null,{"inputs":[{"name":"v"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[5,"walk_trait_ref","","",null,{"inputs":[{"name":"v"},{"name":"traitref"}],"output":null}],[5,"walk_item","","",null,{"inputs":[{"name":"v"},{"name":"item"}],"output":null}],[5,"walk_enum_def","","",null,{"inputs":[{"name":"v"},{"name":"enumdef"},{"name":"generics"}],"output":null}],[5,"walk_variant","","",null,{"inputs":[{"name":"v"},{"name":"variant"},{"name":"generics"}],"output":null}],[5,"skip_ty","","",null,{"inputs":[{"name":"v"},{"name":"ty"}],"output":null}],[5,"walk_ty_opt","","",null,{"inputs":[{"name":"v"},{"name":"option"}],"output":null}],[5,"walk_ty","","",null,{"inputs":[{"name":"v"},{"name":"ty"}],"output":null}],[5,"walk_lifetime_decls_helper","","",null,{"inputs":[{"name":"v"},{"name":"vec"}],"output":null}],[5,"walk_path","","",null,{"inputs":[{"name":"v"},{"name":"path"}],"output":null}],[5,"walk_path_segment","","",null,{"inputs":[{"name":"v"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[5,"walk_path_parameters","","",null,{"inputs":[{"name":"v"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[5,"walk_assoc_type_binding","","",null,{"inputs":[{"name":"v"},{"name":"typebinding"}],"output":null}],[5,"walk_pat","","",null,{"inputs":[{"name":"v"},{"name":"pat"}],"output":null}],[5,"walk_foreign_item","","",null,{"inputs":[{"name":"v"},{"name":"foreignitem"}],"output":null}],[5,"walk_ty_param_bounds_helper","","",null,{"inputs":[{"name":"v"},{"name":"ownedslice"}],"output":null}],[5,"walk_ty_param_bound","","",null,{"inputs":[{"name":"v"},{"name":"typarambound"}],"output":null}],[5,"walk_generics","","",null,{"inputs":[{"name":"v"},{"name":"generics"}],"output":null}],[5,"walk_fn_ret_ty","","",null,{"inputs":[{"name":"v"},{"name":"functionretty"}],"output":null}],[5,"walk_fn_decl","","",null,{"inputs":[{"name":"v"},{"name":"fndecl"}],"output":null}],[5,"walk_fn","","",null,{"inputs":[{"name":"v"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"}],"output":null}],[5,"walk_trait_item","","",null,{"inputs":[{"name":"v"},{"name":"traititem"}],"output":null}],[5,"walk_impl_item","","",null,{"inputs":[{"name":"v"},{"name":"implitem"}],"output":null}],[5,"walk_struct_def","","",null,{"inputs":[{"name":"v"},{"name":"structdef"}],"output":null}],[5,"walk_struct_field","","",null,{"inputs":[{"name":"v"},{"name":"structfield"}],"output":null}],[5,"walk_block","","",null,{"inputs":[{"name":"v"},{"name":"block"}],"output":null}],[5,"walk_stmt","","",null,{"inputs":[{"name":"v"},{"name":"stmt"}],"output":null}],[5,"walk_decl","","",null,{"inputs":[{"name":"v"},{"name":"decl"}],"output":null}],[5,"walk_expr_opt","","",null,{"inputs":[{"name":"v"},{"name":"option"}],"output":null}],[5,"walk_exprs","","",null,null],[5,"walk_mac","","",null,{"inputs":[{"name":"v"},{"name":"mac"}],"output":null}],[5,"walk_expr","","",null,{"inputs":[{"name":"v"},{"name":"expr"}],"output":null}],[5,"walk_arm","","",null,{"inputs":[{"name":"v"},{"name":"arm"}],"output":null}],[8,"Visitor","","Each method of the Visitor trait is a hook to be potentially\noverridden.  Each method's default implementation recursively visits\nthe substructure of the input via the corresponding `walk` method;\ne.g. the `visit_mod` method by default calls `visit::walk_mod`.",null,null],[11,"visit_name","","",199,{"inputs":[{"name":"visitor"},{"name":"span"},{"name":"name"}],"output":null}],[11,"visit_ident","","",199,{"inputs":[{"name":"visitor"},{"name":"span"},{"name":"ident"}],"output":null}],[11,"visit_mod","","",199,{"inputs":[{"name":"visitor"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_foreign_item","","",199,{"inputs":[{"name":"visitor"},{"name":"foreignitem"}],"output":null}],[11,"visit_item","","",199,{"inputs":[{"name":"visitor"},{"name":"item"}],"output":null}],[11,"visit_local","","",199,{"inputs":[{"name":"visitor"},{"name":"local"}],"output":null}],[11,"visit_block","","",199,{"inputs":[{"name":"visitor"},{"name":"block"}],"output":null}],[11,"visit_stmt","","",199,{"inputs":[{"name":"visitor"},{"name":"stmt"}],"output":null}],[11,"visit_arm","","",199,{"inputs":[{"name":"visitor"},{"name":"arm"}],"output":null}],[11,"visit_pat","","",199,{"inputs":[{"name":"visitor"},{"name":"pat"}],"output":null}],[11,"visit_decl","","",199,{"inputs":[{"name":"visitor"},{"name":"decl"}],"output":null}],[11,"visit_expr","","",199,{"inputs":[{"name":"visitor"},{"name":"expr"}],"output":null}],[11,"visit_expr_post","","",199,{"inputs":[{"name":"visitor"},{"name":"expr"}],"output":null}],[11,"visit_ty","","",199,{"inputs":[{"name":"visitor"},{"name":"ty"}],"output":null}],[11,"visit_generics","","",199,{"inputs":[{"name":"visitor"},{"name":"generics"}],"output":null}],[11,"visit_fn","","",199,{"inputs":[{"name":"visitor"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_trait_item","","",199,{"inputs":[{"name":"visitor"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",199,{"inputs":[{"name":"visitor"},{"name":"implitem"}],"output":null}],[11,"visit_trait_ref","","",199,{"inputs":[{"name":"visitor"},{"name":"traitref"}],"output":null}],[11,"visit_ty_param_bound","","",199,{"inputs":[{"name":"visitor"},{"name":"typarambound"}],"output":null}],[11,"visit_poly_trait_ref","","",199,{"inputs":[{"name":"visitor"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_struct_def","","",199,{"inputs":[{"name":"visitor"},{"name":"structdef"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",199,{"inputs":[{"name":"visitor"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",199,{"inputs":[{"name":"visitor"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"visit_opt_lifetime_ref","","Visits an optional reference to a lifetime. The `span` is the span of some surrounding\nreference should opt_lifetime be None.",199,{"inputs":[{"name":"visitor"},{"name":"span"},{"name":"option"}],"output":null}],[11,"visit_lifetime_bound","","",199,{"inputs":[{"name":"visitor"},{"name":"lifetime"}],"output":null}],[11,"visit_lifetime_ref","","",199,{"inputs":[{"name":"visitor"},{"name":"lifetime"}],"output":null}],[11,"visit_lifetime_def","","",199,{"inputs":[{"name":"visitor"},{"name":"lifetimedef"}],"output":null}],[11,"visit_explicit_self","","",199,{"inputs":[{"name":"visitor"},{"name":"explicitself"}],"output":null}],[11,"visit_mac","","",199,{"inputs":[{"name":"visitor"},{"name":"mac"}],"output":null}],[11,"visit_path","","",199,{"inputs":[{"name":"visitor"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_path_segment","","",199,{"inputs":[{"name":"visitor"},{"name":"span"},{"name":"pathsegment"}],"output":null}],[11,"visit_path_parameters","","",199,{"inputs":[{"name":"visitor"},{"name":"span"},{"name":"pathparameters"}],"output":null}],[11,"visit_assoc_type_binding","","",199,{"inputs":[{"name":"visitor"},{"name":"typebinding"}],"output":null}],[11,"visit_attribute","","",199,{"inputs":[{"name":"visitor"},{"name":"attribute"}],"output":null}],[11,"clone","","",198,{"inputs":[{"name":"fnkind"}],"output":{"name":"fnkind"}}],[0,"print","syntax","",null,null],[0,"pp","syntax::print","This pretty-printer is a direct reimplementation of Philip Karlton's\nMesa pretty-printer, as described in appendix A of",null,null],[3,"BreakToken","syntax::print::pp","",null,null],[3,"BeginToken","","",null,null],[3,"PrintStackElem","","",null,null],[3,"Printer","","In case you do not have the paper, here is an explanation of what's going\non.",null,null],[12,"out","","",200,null],[4,"Breaks","","",null,null],[13,"Consistent","","",201,null],[13,"Inconsistent","","",201,null],[4,"Token","","",null,null],[13,"String","","",202,null],[13,"Break","","",202,null],[13,"Begin","","",202,null],[13,"End","","",202,null],[13,"Eof","","",202,null],[4,"PrintStackBreak","","",null,null],[13,"Fits","","",203,null],[13,"Broken","","",203,null],[5,"tok_str","","",null,{"inputs":[{"name":"token"}],"output":{"name":"string"}}],[5,"buf_str","","",null,null],[5,"mk_printer","","",null,{"inputs":[{"name":"box"},{"name":"usize"}],"output":{"name":"printer"}}],[5,"rbox","","",null,{"inputs":[{"name":"printer"},{"name":"usize"},{"name":"breaks"}],"output":{"name":"result"}}],[5,"ibox","","",null,{"inputs":[{"name":"printer"},{"name":"usize"}],"output":{"name":"result"}}],[5,"cbox","","",null,{"inputs":[{"name":"printer"},{"name":"usize"}],"output":{"name":"result"}}],[5,"break_offset","","",null,{"inputs":[{"name":"printer"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[5,"end","","",null,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[5,"eof","","",null,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[5,"word","","",null,{"inputs":[{"name":"printer"},{"name":"str"}],"output":{"name":"result"}}],[5,"huge_word","","",null,{"inputs":[{"name":"printer"},{"name":"str"}],"output":{"name":"result"}}],[5,"zero_word","","",null,{"inputs":[{"name":"printer"},{"name":"str"}],"output":{"name":"result"}}],[5,"spaces","","",null,{"inputs":[{"name":"printer"},{"name":"usize"}],"output":{"name":"result"}}],[5,"zerobreak","","",null,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[5,"space","","",null,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[5,"hardbreak","","",null,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[5,"hardbreak_tok_offset","","",null,{"inputs":[{"name":"isize"}],"output":{"name":"token"}}],[5,"hardbreak_tok","","",null,{"inputs":[],"output":{"name":"token"}}],[11,"eq","","",201,{"inputs":[{"name":"breaks"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"ne","","",201,{"inputs":[{"name":"breaks"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"clone","","",201,{"inputs":[{"name":"breaks"}],"output":{"name":"breaks"}}],[11,"clone","","",204,{"inputs":[{"name":"breaktoken"}],"output":{"name":"breaktoken"}}],[11,"clone","","",205,{"inputs":[{"name":"begintoken"}],"output":{"name":"begintoken"}}],[11,"clone","","",202,{"inputs":[{"name":"token"}],"output":{"name":"token"}}],[11,"is_eof","","",202,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_hardbreak_tok","","",202,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"clone","","",203,{"inputs":[{"name":"printstackbreak"}],"output":{"name":"printstackbreak"}}],[11,"clone","","",206,{"inputs":[{"name":"printstackelem"}],"output":{"name":"printstackelem"}}],[11,"last_token","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"token"}}],[11,"replace_last_token","","",200,{"inputs":[{"name":"printer"},{"name":"token"}],"output":null}],[11,"pretty_print","","",200,{"inputs":[{"name":"printer"},{"name":"token"}],"output":{"name":"result"}}],[11,"check_stream","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[11,"scan_push","","",200,{"inputs":[{"name":"printer"},{"name":"usize"}],"output":null}],[11,"scan_pop","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"scan_top","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"scan_pop_bottom","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"advance_right","","",200,{"inputs":[{"name":"printer"}],"output":null}],[11,"advance_left","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[11,"check_stack","","",200,{"inputs":[{"name":"printer"},{"name":"isize"}],"output":null}],[11,"print_newline","","",200,{"inputs":[{"name":"printer"},{"name":"isize"}],"output":{"name":"result"}}],[11,"indent","","",200,{"inputs":[{"name":"printer"},{"name":"isize"}],"output":null}],[11,"get_top","","",200,{"inputs":[{"name":"printer"}],"output":{"name":"printstackelem"}}],[11,"print_str","","",200,{"inputs":[{"name":"printer"},{"name":"str"}],"output":{"name":"result"}}],[11,"print","","",200,{"inputs":[{"name":"printer"},{"name":"token"},{"name":"isize"}],"output":{"name":"result"}}],[0,"pprust","syntax::print","",null,null],[3,"NoAnn","syntax::print::pprust","",null,null],[3,"CurrentCommentAndLiteral","","",null,null],[3,"State","","",null,null],[12,"s","","",207,null],[4,"AnnNode","","",null,null],[13,"NodeIdent","","",208,null],[13,"NodeName","","",208,null],[13,"NodeBlock","","",208,null],[13,"NodeItem","","",208,null],[13,"NodeSubItem","","",208,null],[13,"NodeExpr","","",208,null],[13,"NodePat","","",208,null],[5,"rust_printer","","",null,{"inputs":[{"name":"box"}],"output":{"name":"state"}}],[5,"rust_printer_annotated","","",null,{"inputs":[{"name":"box"},{"name":"ppann"}],"output":{"name":"state"}}],[5,"print_crate","","Requires you to pass an input filename and reader so that\nit can scan the input text for comments and literals to\ncopy forward.",null,{"inputs":[{"name":"codemap"},{"name":"spanhandler"},{"name":"crate"},{"name":"string"},{"name":"read"},{"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"result"}}],[5,"to_string","","",null,{"inputs":[{"name":"f"}],"output":{"name":"string"}}],[5,"binop_to_string","","",null,{"inputs":[{"name":"binoptoken"}],"output":{"name":"str"}}],[5,"token_to_string","","",null,{"inputs":[{"name":"token"}],"output":{"name":"string"}}],[5,"ty_to_string","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[5,"bounds_to_string","","",null,null],[5,"pat_to_string","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"string"}}],[5,"arm_to_string","","",null,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[5,"expr_to_string","","",null,{"inputs":[{"name":"expr"}],"output":{"name":"string"}}],[5,"lifetime_to_string","","",null,{"inputs":[{"name":"lifetime"}],"output":{"name":"string"}}],[5,"tt_to_string","","",null,{"inputs":[{"name":"tokentree"}],"output":{"name":"string"}}],[5,"tts_to_string","","",null,null],[5,"stmt_to_string","","",null,{"inputs":[{"name":"stmt"}],"output":{"name":"string"}}],[5,"attr_to_string","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"string"}}],[5,"item_to_string","","",null,{"inputs":[{"name":"item"}],"output":{"name":"string"}}],[5,"impl_item_to_string","","",null,{"inputs":[{"name":"implitem"}],"output":{"name":"string"}}],[5,"trait_item_to_string","","",null,{"inputs":[{"name":"traititem"}],"output":{"name":"string"}}],[5,"generics_to_string","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[5,"where_clause_to_string","","",null,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[5,"fn_block_to_string","","",null,{"inputs":[{"name":"fndecl"}],"output":{"name":"string"}}],[5,"path_to_string","","",null,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[5,"ident_to_string","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[5,"fun_to_string","","",null,{"inputs":[{"name":"fndecl"},{"name":"unsafety"},{"name":"ident"},{"name":"option"},{"name":"generics"}],"output":{"name":"string"}}],[5,"block_to_string","","",null,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[5,"meta_item_to_string","","",null,{"inputs":[{"name":"metaitem"}],"output":{"name":"string"}}],[5,"attribute_to_string","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"string"}}],[5,"lit_to_string","","",null,{"inputs":[{"name":"lit"}],"output":{"name":"string"}}],[5,"explicit_self_to_string","","",null,{"inputs":[{"name":"explicitself_"}],"output":{"name":"string"}}],[5,"variant_to_string","","",null,{"inputs":[{"name":"variant"}],"output":{"name":"string"}}],[5,"arg_to_string","","",null,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[5,"mac_to_string","","",null,{"inputs":[{"name":"mac"}],"output":{"name":"string"}}],[5,"visibility_qualified","","",null,{"inputs":[{"name":"visibility"},{"name":"str"}],"output":{"name":"string"}}],[0,"with_hygiene","","",null,null],[5,"to_string_hyg","syntax::print::pprust::with_hygiene","",null,{"inputs":[{"name":"f"}],"output":{"name":"string"}}],[5,"ty_to_string","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[5,"bounds_to_string","","",null,null],[5,"pat_to_string","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"string"}}],[5,"arm_to_string","","",null,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[5,"expr_to_string","","",null,{"inputs":[{"name":"expr"}],"output":{"name":"string"}}],[5,"lifetime_to_string","","",null,{"inputs":[{"name":"lifetime"}],"output":{"name":"string"}}],[5,"tt_to_string","","",null,{"inputs":[{"name":"tokentree"}],"output":{"name":"string"}}],[5,"tts_to_string","","",null,null],[5,"stmt_to_string","","",null,{"inputs":[{"name":"stmt"}],"output":{"name":"string"}}],[5,"attr_to_string","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"string"}}],[5,"item_to_string","","",null,{"inputs":[{"name":"item"}],"output":{"name":"string"}}],[5,"impl_item_to_string","","",null,{"inputs":[{"name":"implitem"}],"output":{"name":"string"}}],[5,"trait_item_to_string","","",null,{"inputs":[{"name":"traititem"}],"output":{"name":"string"}}],[5,"generics_to_string","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[5,"where_clause_to_string","","",null,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[5,"fn_block_to_string","","",null,{"inputs":[{"name":"fndecl"}],"output":{"name":"string"}}],[5,"path_to_string","","",null,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[5,"ident_to_string","","",null,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[5,"fun_to_string","","",null,{"inputs":[{"name":"fndecl"},{"name":"unsafety"},{"name":"ident"},{"name":"option"},{"name":"generics"}],"output":{"name":"string"}}],[5,"block_to_string","","",null,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[5,"meta_item_to_string","","",null,{"inputs":[{"name":"metaitem"}],"output":{"name":"string"}}],[5,"attribute_to_string","","",null,{"inputs":[{"name":"attribute"}],"output":{"name":"string"}}],[5,"lit_to_string","","",null,{"inputs":[{"name":"lit"}],"output":{"name":"string"}}],[5,"explicit_self_to_string","","",null,{"inputs":[{"name":"explicitself_"}],"output":{"name":"string"}}],[5,"variant_to_string","","",null,{"inputs":[{"name":"variant"}],"output":{"name":"string"}}],[5,"arg_to_string","","",null,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[5,"mac_to_string","","",null,{"inputs":[{"name":"mac"}],"output":{"name":"string"}}],[17,"indent_unit","syntax::print::pprust","",null,null],[17,"default_columns","","",null,null],[8,"PpAnn","","",null,null],[11,"pre","","",209,{"inputs":[{"name":"ppann"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"post","","",209,{"inputs":[{"name":"ppann"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"clone","","",210,{"inputs":[{"name":"noann"}],"output":{"name":"noann"}}],[11,"clone","","",211,{"inputs":[{"name":"currentcommentandliteral"}],"output":{"name":"currentcommentandliteral"}}],[11,"new_from_input","","",207,{"inputs":[{"name":"state"},{"name":"codemap"},{"name":"spanhandler"},{"name":"string"},{"name":"read"},{"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"state"}}],[11,"new","","",207,{"inputs":[{"name":"state"},{"name":"codemap"},{"name":"box"},{"name":"ppann"},{"name":"option"},{"name":"option"}],"output":{"name":"state"}}],[11,"ibox","","",207,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"end","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"cbox","","",207,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"rbox","","",207,{"inputs":[{"name":"state"},{"name":"usize"},{"name":"breaks"}],"output":{"name":"result"}}],[11,"nbsp","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"word_nbsp","","",207,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"word_space","","",207,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"popen","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"pclose","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"head","","",207,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"bopen","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"bclose_","","",207,{"inputs":[{"name":"state"},{"name":"span"},{"name":"usize"}],"output":{"name":"result"}}],[11,"bclose_maybe_open","","",207,{"inputs":[{"name":"state"},{"name":"span"},{"name":"usize"},{"name":"bool"}],"output":{"name":"result"}}],[11,"bclose","","",207,{"inputs":[{"name":"state"},{"name":"span"}],"output":{"name":"result"}}],[11,"is_begin","","",207,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"is_end","","",207,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"is_bol","","",207,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"in_cbox","","",207,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"hardbreak_if_not_bol","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"space_if_not_bol","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"break_offset_if_not_bol","","",207,{"inputs":[{"name":"state"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[11,"synth_comment","","",207,{"inputs":[{"name":"state"},{"name":"string"}],"output":{"name":"result"}}],[11,"commasep","","",207,null],[11,"commasep_cmnt","","",207,null],[11,"commasep_exprs","","",207,null],[11,"print_mod","","",207,null],[11,"print_foreign_mod","","",207,null],[11,"print_opt_lifetime","","",207,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_type","","",207,{"inputs":[{"name":"state"},{"name":"ty"}],"output":{"name":"result"}}],[11,"print_foreign_item","","",207,{"inputs":[{"name":"state"},{"name":"foreignitem"}],"output":{"name":"result"}}],[11,"print_item","","Pretty-print an item",207,{"inputs":[{"name":"state"},{"name":"item"}],"output":{"name":"result"}}],[11,"print_enum_def","","",207,{"inputs":[{"name":"state"},{"name":"enumdef"},{"name":"generics"},{"name":"ident"},{"name":"span"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_variants","","",207,null],[11,"print_visibility","","",207,{"inputs":[{"name":"state"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_struct","","",207,{"inputs":[{"name":"state"},{"name":"structdef"},{"name":"generics"},{"name":"ident"},{"name":"span"}],"output":{"name":"result"}}],[11,"print_tt","","This doesn't deserve to be called \"pretty\" printing, but it should be\nmeaning-preserving. A quick hack that might help would be to look at the\nspans embedded in the TTs to decide where to put spaces and newlines.\nBut it'd be better to parse these according to the grammar of the\nappropriate macro, transcribe back into the grammar we just parsed from,\nand then pretty-print the resulting AST nodes (so, e.g., we print\nexpression arguments as expressions). It can be done! I think.",207,{"inputs":[{"name":"state"},{"name":"tokentree"}],"output":{"name":"result"}}],[11,"print_tts","","",207,null],[11,"print_variant","","",207,{"inputs":[{"name":"state"},{"name":"variant"}],"output":{"name":"result"}}],[11,"print_method_sig","","",207,{"inputs":[{"name":"state"},{"name":"ident"},{"name":"methodsig"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_trait_item","","",207,{"inputs":[{"name":"state"},{"name":"traititem"}],"output":{"name":"result"}}],[11,"print_impl_item","","",207,{"inputs":[{"name":"state"},{"name":"implitem"}],"output":{"name":"result"}}],[11,"print_outer_attributes","","",207,null],[11,"print_inner_attributes","","",207,null],[11,"print_attribute","","",207,{"inputs":[{"name":"state"},{"name":"attribute"}],"output":{"name":"result"}}],[11,"print_stmt","","",207,{"inputs":[{"name":"state"},{"name":"stmt"}],"output":{"name":"result"}}],[11,"print_block","","",207,{"inputs":[{"name":"state"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed","","",207,{"inputs":[{"name":"state"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed_indent","","",207,{"inputs":[{"name":"state"},{"name":"block"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_block_with_attrs","","",207,null],[11,"print_block_maybe_unclosed","","",207,null],[11,"print_if","","",207,{"inputs":[{"name":"state"},{"name":"expr"},{"name":"block"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_if_let","","",207,{"inputs":[{"name":"state"},{"name":"pat"},{"name":"expr"},{"name":"block"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_mac","","",207,{"inputs":[{"name":"state"},{"name":"mac"},{"name":"delimtoken"}],"output":{"name":"result"}}],[11,"print_expr_maybe_paren","","",207,{"inputs":[{"name":"state"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr","","",207,{"inputs":[{"name":"state"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_local_decl","","",207,{"inputs":[{"name":"state"},{"name":"local"}],"output":{"name":"result"}}],[11,"print_decl","","",207,{"inputs":[{"name":"state"},{"name":"decl"}],"output":{"name":"result"}}],[11,"print_ident","","",207,{"inputs":[{"name":"state"},{"name":"ident"}],"output":{"name":"result"}}],[11,"print_usize","","",207,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_name","","",207,{"inputs":[{"name":"state"},{"name":"name"}],"output":{"name":"result"}}],[11,"print_for_decl","","",207,{"inputs":[{"name":"state"},{"name":"local"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_pat","","",207,{"inputs":[{"name":"state"},{"name":"pat"}],"output":{"name":"result"}}],[11,"print_fn","","",207,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"unsafety"},{"name":"abi"},{"name":"option"},{"name":"generics"},{"name":"option"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_fn_args","","",207,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_args_and_ret","","",207,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_block_args","","",207,{"inputs":[{"name":"state"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_capture_clause","","",207,{"inputs":[{"name":"state"},{"name":"captureclause"}],"output":{"name":"result"}}],[11,"print_bounds","","",207,null],[11,"print_lifetime","","",207,{"inputs":[{"name":"state"},{"name":"lifetime"}],"output":{"name":"result"}}],[11,"print_lifetime_def","","",207,{"inputs":[{"name":"state"},{"name":"lifetimedef"}],"output":{"name":"result"}}],[11,"print_generics","","",207,{"inputs":[{"name":"state"},{"name":"generics"}],"output":{"name":"result"}}],[11,"print_ty_param","","",207,{"inputs":[{"name":"state"},{"name":"typaram"}],"output":{"name":"result"}}],[11,"print_where_clause","","",207,{"inputs":[{"name":"state"},{"name":"whereclause"}],"output":{"name":"result"}}],[11,"print_meta_item","","",207,{"inputs":[{"name":"state"},{"name":"metaitem"}],"output":{"name":"result"}}],[11,"print_view_path","","",207,{"inputs":[{"name":"state"},{"name":"viewpath"}],"output":{"name":"result"}}],[11,"print_mutability","","",207,{"inputs":[{"name":"state"},{"name":"mutability"}],"output":{"name":"result"}}],[11,"print_mt","","",207,{"inputs":[{"name":"state"},{"name":"mutty"}],"output":{"name":"result"}}],[11,"print_arg","","",207,{"inputs":[{"name":"state"},{"name":"arg"}],"output":{"name":"result"}}],[11,"print_fn_output","","",207,{"inputs":[{"name":"state"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_ty_fn","","",207,{"inputs":[{"name":"state"},{"name":"abi"},{"name":"unsafety"},{"name":"fndecl"},{"name":"option"},{"name":"generics"},{"name":"option"}],"output":{"name":"result"}}],[11,"maybe_print_trailing_comment","","",207,{"inputs":[{"name":"state"},{"name":"span"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_remaining_comments","","",207,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"print_literal","","",207,{"inputs":[{"name":"state"},{"name":"lit"}],"output":{"name":"result"}}],[11,"next_lit","","",207,{"inputs":[{"name":"state"},{"name":"bytepos"}],"output":{"name":"option"}}],[11,"maybe_print_comment","","",207,{"inputs":[{"name":"state"},{"name":"bytepos"}],"output":{"name":"result"}}],[11,"print_comment","","",207,{"inputs":[{"name":"state"},{"name":"comment"}],"output":{"name":"result"}}],[11,"print_string","","",207,{"inputs":[{"name":"state"},{"name":"str"},{"name":"strstyle"}],"output":{"name":"result"}}],[11,"next_comment","","",207,{"inputs":[{"name":"state"}],"output":{"name":"option"}}],[11,"print_opt_abi_and_extern_if_nondefault","","",207,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_extern_opt_abi","","",207,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_header_info","","",207,{"inputs":[{"name":"state"},{"name":"unsafety"},{"name":"abi"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_unsafety","","",207,{"inputs":[{"name":"state"},{"name":"unsafety"}],"output":{"name":"result"}}],[0,"ext","syntax","",null,null],[0,"asm","syntax::ext","",null,null],[5,"expand_asm","syntax::ext::asm","",null,null],[0,"base","syntax::ext","",null,null],[3,"MacEager","syntax::ext::base","`MacResult` implementation for the common case where you've already\nbuilt each form of AST that you might return.",null,null],[12,"expr","","",212,null],[12,"pat","","",212,null],[12,"items","","",212,null],[12,"impl_items","","",212,null],[12,"stmts","","",212,null],[3,"DummyResult","","Fill-in macro expansion result, to allow compilation to continue\nafter hitting errors.",null,null],[3,"BlockInfo","","",null,null],[12,"macros_escape","","Should macros escape from this scope?",213,null],[12,"pending_renames","","What are the pending renames?",213,null],[3,"ExtCtxt","","One of these is made during expansion and incrementally updated as we go;\nwhen a macro expansion occurs, the resulting nodes have the backtrace()\n-> expn_info of their expansion context stored into their span.",null,null],[12,"parse_sess","","",214,null],[12,"cfg","","",214,null],[12,"backtrace","","",214,null],[12,"ecfg","","",214,null],[12,"use_std","","",214,null],[12,"mod_path","","",214,null],[12,"trace_mac","","",214,null],[12,"exported_macros","","",214,null],[12,"syntax_env","","",214,null],[12,"recursion_count","","",214,null],[3,"SyntaxEnv","","In order to have some notion of scoping for macros,\nwe want to implement the notion of a transformation\nenvironment.",null,null],[4,"Annotatable","","",null,null],[13,"Item","","",215,null],[13,"TraitItem","","",215,null],[13,"ImplItem","","",215,null],[4,"SyntaxExtension","","An enum representing the different kinds of syntax extensions.",null,null],[13,"Decorator","","A syntax extension that is attached to an item and creates new items\nbased upon it.",216,null],[13,"Modifier","","A syntax extension that is attached to an item and modifies it\nin-place.",216,null],[13,"MultiModifier","","A syntax extension that is attached to an item and modifies it\nin-place. More flexible version than Modifier.",216,null],[13,"NormalTT","","A normal, function-like syntax extension.",216,null],[13,"IdentTT","","A function-like syntax extension that has an extra ident before\nthe block.",216,null],[13,"MacroRulesTT","","Represents `macro_rules!` itself.",216,null],[5,"expr_to_string","","Extract a string literal from the macro expanded version of `expr`,\nemitting `err_msg` if `expr` is not a string literal. This does not stop\ncompilation on error, merely emits a non-fatal error and returns None.",null,{"inputs":[{"name":"extctxt"},{"name":"p"},{"name":"str"}],"output":{"name":"option"}}],[5,"check_zero_tts","","Non-fatally assert that `tts` is empty. Note that this function\nreturns even when `tts` is non-empty, macros that *need* to stop\ncompilation should call\n`cx.parse_sess.span_diagnostic.abort_if_errors()` (this should be\ndone as rarely as possible).",null,null],[5,"get_single_str_from_tts","","Extract the string literal from the first token of `tts`. If this\nis not a string literal, emit an error and return None.",null,null],[5,"get_exprs_from_tts","","Extract comma-separated expressions from `tts`. If there is a\nparsing error, emit a non-fatal error and return None.",null,null],[6,"MacroExpanderFn","","",null,null],[6,"IdentMacroExpanderFn","","",null,null],[6,"NamedSyntaxExtension","","",null,null],[8,"ItemDecorator","","",null,null],[10,"expand","","",217,{"inputs":[{"name":"itemdecorator"},{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"fnmut"}],"output":null}],[8,"ItemModifier","","",null,null],[10,"expand","","",218,{"inputs":[{"name":"itemmodifier"},{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"p"}],"output":{"name":"p"}}],[8,"MultiItemModifier","","",null,null],[10,"expand","","",219,{"inputs":[{"name":"multiitemmodifier"},{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"annotatable"}],"output":{"name":"annotatable"}}],[8,"TTMacroExpander","","Represents a thing that maps token trees to Macro Results",null,null],[10,"expand","","",220,null],[8,"IdentMacroExpander","","",null,null],[10,"expand","","",221,{"inputs":[{"name":"identmacroexpander"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"box"}}],[8,"MacResult","","The result of a macro expansion. The return values of the various\nmethods are spliced into the AST at the callsite of the macro.",null,null],[11,"make_expr","","Create an expression.",222,{"inputs":[{"name":"macresult"}],"output":{"name":"option"}}],[11,"make_items","","Create zero or more items.",222,{"inputs":[{"name":"macresult"}],"output":{"name":"option"}}],[11,"make_impl_items","","Create zero or more impl items.",222,{"inputs":[{"name":"macresult"}],"output":{"name":"option"}}],[11,"make_pat","","Create a pattern.",222,{"inputs":[{"name":"macresult"}],"output":{"name":"option"}}],[11,"make_stmts","","Create zero or more statements.",222,{"inputs":[{"name":"macresult"}],"output":{"name":"option"}}],[11,"clone","","",215,{"inputs":[{"name":"annotatable"}],"output":{"name":"annotatable"}}],[11,"fmt","","",215,{"inputs":[{"name":"annotatable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"attrs","","",215,null],[11,"fold_attrs","","",215,{"inputs":[{"name":"annotatable"},{"name":"vec"}],"output":{"name":"annotatable"}}],[11,"expect_item","","",215,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"expect_trait_item","","",215,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"expect_impl_item","","",215,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"default","","",212,{"inputs":[{"name":"maceager"}],"output":{"name":"maceager"}}],[11,"expr","","",212,{"inputs":[{"name":"maceager"},{"name":"p"}],"output":{"name":"box"}}],[11,"pat","","",212,{"inputs":[{"name":"maceager"},{"name":"p"}],"output":{"name":"box"}}],[11,"items","","",212,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"impl_items","","",212,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"stmts","","",212,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"make_expr","","",212,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_items","","",212,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_impl_items","","",212,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_stmts","","",212,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_pat","","",212,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"clone","","",223,{"inputs":[{"name":"dummyresult"}],"output":{"name":"dummyresult"}}],[11,"any","","Create a default MacResult that can be anything.",223,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"box"}}],[11,"expr","","Create a default MacResult that can only be an expression.",223,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"box"}}],[11,"raw_expr","","A plain dummy expression.",223,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"p"}}],[11,"raw_pat","","A plain dummy pattern.",223,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"pat"}}],[11,"make_expr","","",223,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_pat","","",223,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_items","","",223,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_impl_items","","",223,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_stmts","","",223,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"new","","",213,{"inputs":[{"name":"blockinfo"}],"output":{"name":"blockinfo"}}],[11,"new","","",214,{"inputs":[{"name":"extctxt"},{"name":"parsesess"},{"name":"crateconfig"},{"name":"expansionconfig"}],"output":{"name":"extctxt"}}],[11,"expand_expr","","",214,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"expander","","Returns a `Folder` for deeply expanding all macros in a AST node.",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"macroexpander"}}],[11,"new_parser_from_tts","","",214,null],[11,"codemap","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"codemap"}}],[11,"parse_sess","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"parsesess"}}],[11,"cfg","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"crateconfig"}}],[11,"call_site","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"backtrace","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"expnid"}}],[11,"original_span","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"original_span_in_file","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"mod_push","","",214,{"inputs":[{"name":"extctxt"},{"name":"ident"}],"output":null}],[11,"mod_pop","","",214,{"inputs":[{"name":"extctxt"}],"output":null}],[11,"mod_path","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"bt_push","","",214,{"inputs":[{"name":"extctxt"},{"name":"expninfo"}],"output":null}],[11,"bt_pop","","",214,{"inputs":[{"name":"extctxt"}],"output":null}],[11,"insert_macro","","",214,{"inputs":[{"name":"extctxt"},{"name":"macrodef"}],"output":null}],[11,"span_fatal","","Emit `msg` attached to `sp`, and stop compilation immediately.",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_err","","Emit `msg` attached to `sp`, without immediately stopping\ncompilation.",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_warn","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_unimpl","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_bug","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_note","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_help","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"fileline_help","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"str"}],"output":null}],[11,"bug","","",214,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":null}],[11,"trace_macros","","",214,{"inputs":[{"name":"extctxt"}],"output":{"name":"bool"}}],[11,"set_trace_macros","","",214,{"inputs":[{"name":"extctxt"},{"name":"bool"}],"output":null}],[11,"ident_of","","",214,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"ident"}}],[11,"ident_of_std","","",214,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"ident"}}],[11,"name_of","","",214,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"name"}}],[11,"push_frame","","",224,{"inputs":[{"name":"syntaxenv"}],"output":null}],[11,"pop_frame","","",224,{"inputs":[{"name":"syntaxenv"}],"output":null}],[11,"find","","",224,{"inputs":[{"name":"syntaxenv"},{"name":"name"}],"output":{"name":"option"}}],[11,"insert","","",224,{"inputs":[{"name":"syntaxenv"},{"name":"name"},{"name":"syntaxextension"}],"output":null}],[11,"info","","",224,{"inputs":[{"name":"syntaxenv"}],"output":{"name":"blockinfo"}}],[0,"build","syntax::ext","",null,null],[8,"AstBuilder","syntax::ext::build","",null,null],[10,"path","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[10,"path_ident","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[10,"path_global","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[10,"path_all","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"bool"},{"name":"vec"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"path"}}],[10,"qpath","","",225,null],[10,"qpath_all","","",225,null],[10,"ty_mt","","",225,{"inputs":[{"name":"astbuilder"},{"name":"p"},{"name":"mutability"}],"output":{"name":"mutty"}}],[10,"ty","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ty_"}],"output":{"name":"p"}}],[10,"ty_path","","",225,{"inputs":[{"name":"astbuilder"},{"name":"path"}],"output":{"name":"p"}}],[10,"ty_sum","","",225,{"inputs":[{"name":"astbuilder"},{"name":"path"},{"name":"ownedslice"}],"output":{"name":"p"}}],[10,"ty_ident","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[10,"ty_rptr","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"option"},{"name":"mutability"}],"output":{"name":"p"}}],[10,"ty_ptr","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"mutability"}],"output":{"name":"p"}}],[10,"ty_option","","",225,{"inputs":[{"name":"astbuilder"},{"name":"p"}],"output":{"name":"p"}}],[10,"ty_infer","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"ty_vars","","",225,{"inputs":[{"name":"astbuilder"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[10,"ty_vars_global","","",225,{"inputs":[{"name":"astbuilder"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[10,"ty_field_imm","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"typefield"}}],[10,"typaram","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"ownedslice"},{"name":"option"}],"output":{"name":"typaram"}}],[10,"trait_ref","","",225,{"inputs":[{"name":"astbuilder"},{"name":"path"}],"output":{"name":"traitref"}}],[10,"poly_trait_ref","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"path"}],"output":{"name":"polytraitref"}}],[10,"typarambound","","",225,{"inputs":[{"name":"astbuilder"},{"name":"path"}],"output":{"name":"typarambound"}}],[10,"lifetime","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"name"}],"output":{"name":"lifetime"}}],[10,"lifetime_def","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"name"},{"name":"vec"}],"output":{"name":"lifetimedef"}}],[10,"stmt_expr","","",225,{"inputs":[{"name":"astbuilder"},{"name":"p"}],"output":{"name":"p"}}],[10,"stmt_let","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[10,"stmt_let_typed","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[10,"stmt_item","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"block","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[10,"block_expr","","",225,{"inputs":[{"name":"astbuilder"},{"name":"p"}],"output":{"name":"p"}}],[10,"block_all","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[10,"expr","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"expr_"}],"output":{"name":"p"}}],[10,"expr_path","","",225,{"inputs":[{"name":"astbuilder"},{"name":"path"}],"output":{"name":"p"}}],[10,"expr_qpath","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"qself"},{"name":"path"}],"output":{"name":"p"}}],[10,"expr_ident","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[10,"expr_self","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"expr_binary","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"binop_"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_deref","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_unary","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"unop"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_addr_of","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_mut_addr_of","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_field_access","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[10,"expr_tup_field_access","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"usize"}],"output":{"name":"p"}}],[10,"expr_call","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_call_ident","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_call_global","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_method_call","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_block","","",225,{"inputs":[{"name":"astbuilder"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_cast","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[10,"field_imm","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"field"}}],[10,"expr_struct","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_struct_ident","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_lit","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"lit_"}],"output":{"name":"p"}}],[10,"expr_usize","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"usize"}],"output":{"name":"p"}}],[10,"expr_int","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"isize"}],"output":{"name":"p"}}],[10,"expr_u8","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"u8"}],"output":{"name":"p"}}],[10,"expr_u32","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"u32"}],"output":{"name":"p"}}],[10,"expr_bool","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"bool"}],"output":{"name":"p"}}],[10,"expr_vec","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_vec_ng","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"expr_vec_slice","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_str","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[10,"expr_some","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_none","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"expr_break","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"expr_tuple","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_fail","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[10,"expr_unreachable","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"expr_ok","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_err","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"expr_try","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"pat","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"pat_"}],"output":{"name":"p"}}],[10,"pat_wild","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"pat_lit","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"pat_ident","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[10,"pat_ident_binding_mode","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"bindingmode"}],"output":{"name":"p"}}],[10,"pat_enum","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[10,"pat_struct","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[10,"pat_tuple","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[10,"pat_some","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"pat_none","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"p"}}],[10,"pat_ok","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"pat_err","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"arm","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"arm"}}],[10,"arm_unreachable","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"}],"output":{"name":"arm"}}],[10,"expr_match","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[10,"expr_if","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"p"},{"name":"option"}],"output":{"name":"p"}}],[10,"expr_loop","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"lambda_fn_decl","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[10,"lambda","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[10,"lambda0","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"lambda1","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[10,"lambda_expr","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[10,"lambda_expr_0","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[10,"lambda_expr_1","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[10,"lambda_stmts","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[10,"lambda_stmts_0","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[10,"lambda_stmts_1","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"vec"},{"name":"ident"}],"output":{"name":"p"}}],[10,"item","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"item_"}],"output":{"name":"p"}}],[10,"arg","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"arg"}}],[10,"fn_decl","","",225,{"inputs":[{"name":"astbuilder"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[10,"item_fn_poly","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"generics"},{"name":"p"}],"output":{"name":"p"}}],[10,"item_fn","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[10,"variant","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"variant"}}],[10,"item_enum_poly","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"name":"p"}}],[10,"item_enum","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"enumdef"}],"output":{"name":"p"}}],[10,"item_struct_poly","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"structdef"},{"name":"generics"}],"output":{"name":"p"}}],[10,"item_struct","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"structdef"}],"output":{"name":"p"}}],[10,"item_mod","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[10,"item_static","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"mutability"},{"name":"p"}],"output":{"name":"p"}}],[10,"item_const","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[10,"item_ty_poly","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"generics"}],"output":{"name":"p"}}],[10,"item_ty","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[10,"attribute","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"p"}],"output":{"name":"attribute"}}],[10,"meta_word","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[10,"meta_list","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"internedstring"},{"name":"vec"}],"output":{"name":"p"}}],[10,"meta_name_value","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"internedstring"},{"name":"lit_"}],"output":{"name":"p"}}],[10,"item_use","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"visibility"},{"name":"p"}],"output":{"name":"p"}}],[10,"item_use_simple","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"visibility"},{"name":"path"}],"output":{"name":"p"}}],[10,"item_use_simple_","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"visibility"},{"name":"ident"},{"name":"path"}],"output":{"name":"p"}}],[10,"item_use_list","","",225,null],[10,"item_use_glob","","",225,{"inputs":[{"name":"astbuilder"},{"name":"span"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"p"}}],[11,"path","syntax::ext::base","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[11,"path_ident","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[11,"path_global","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[11,"path_all","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"vec"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"path"}}],[11,"qpath","","Constructs a qualified path.",214,null],[11,"qpath_all","","Constructs a qualified path.",214,null],[11,"ty_mt","","",214,{"inputs":[{"name":"extctxt"},{"name":"p"},{"name":"mutability"}],"output":{"name":"mutty"}}],[11,"ty","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ty_"}],"output":{"name":"p"}}],[11,"ty_path","","",214,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"p"}}],[11,"ty_sum","","",214,{"inputs":[{"name":"extctxt"},{"name":"path"},{"name":"ownedslice"}],"output":{"name":"p"}}],[11,"ty_ident","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"ty_rptr","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"option"},{"name":"mutability"}],"output":{"name":"p"}}],[11,"ty_ptr","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"mutability"}],"output":{"name":"p"}}],[11,"ty_option","","",214,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"ty_field_imm","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"typefield"}}],[11,"ty_infer","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"typaram","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"ownedslice"},{"name":"option"}],"output":{"name":"typaram"}}],[11,"ty_vars","","",214,{"inputs":[{"name":"extctxt"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"ty_vars_global","","",214,{"inputs":[{"name":"extctxt"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"trait_ref","","",214,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"traitref"}}],[11,"poly_trait_ref","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"}],"output":{"name":"polytraitref"}}],[11,"typarambound","","",214,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"typarambound"}}],[11,"lifetime","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"name"}],"output":{"name":"lifetime"}}],[11,"lifetime_def","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"name"},{"name":"vec"}],"output":{"name":"lifetimedef"}}],[11,"stmt_expr","","",214,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"stmt_let","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[11,"stmt_let_typed","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"block","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[11,"stmt_item","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"block_expr","","",214,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"block_all","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[11,"expr","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"expr_"}],"output":{"name":"p"}}],[11,"expr_path","","",214,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"p"}}],[11,"expr_qpath","","Constructs a QPath expression.",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"qself"},{"name":"path"}],"output":{"name":"p"}}],[11,"expr_ident","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"expr_self","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_binary","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"binop_"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_deref","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_unary","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"unop"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_field_access","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"expr_tup_field_access","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"usize"}],"output":{"name":"p"}}],[11,"expr_addr_of","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_mut_addr_of","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_call","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_call_ident","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_call_global","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_method_call","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_block","","",214,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"field_imm","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"field"}}],[11,"expr_struct","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_struct_ident","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_lit","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"lit_"}],"output":{"name":"p"}}],[11,"expr_usize","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"usize"}],"output":{"name":"p"}}],[11,"expr_int","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"isize"}],"output":{"name":"p"}}],[11,"expr_u32","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"u32"}],"output":{"name":"p"}}],[11,"expr_u8","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"u8"}],"output":{"name":"p"}}],[11,"expr_bool","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"}],"output":{"name":"p"}}],[11,"expr_vec","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_vec_ng","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_vec_slice","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_str","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"expr_cast","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_some","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_none","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_break","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_tuple","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_fail","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"expr_unreachable","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_ok","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_err","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_try","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"pat_"}],"output":{"name":"p"}}],[11,"pat_wild","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"pat_lit","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_ident","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"pat_ident_binding_mode","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"bindingmode"}],"output":{"name":"p"}}],[11,"pat_enum","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_struct","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_tuple","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_some","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_none","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"pat_ok","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_err","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"arm","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"arm"}}],[11,"arm_unreachable","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"arm"}}],[11,"expr_match","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_if","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"},{"name":"option"}],"output":{"name":"p"}}],[11,"expr_loop","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_fn_decl","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda0","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda1","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"lambda_expr","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_expr_0","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_expr_1","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"lambda_stmts","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"lambda_stmts_0","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"lambda_stmts_1","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"ident"}],"output":{"name":"p"}}],[11,"arg","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"arg"}}],[11,"fn_decl","","",214,{"inputs":[{"name":"extctxt"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"item","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"item_"}],"output":{"name":"p"}}],[11,"item_fn_poly","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"generics"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_fn","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"variant","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"variant"}}],[11,"item_enum_poly","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_enum","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"enumdef"}],"output":{"name":"p"}}],[11,"item_struct","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"structdef"}],"output":{"name":"p"}}],[11,"item_struct_poly","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"structdef"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_mod","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"item_static","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"mutability"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_const","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_ty_poly","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_ty","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[11,"attribute","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"attribute"}}],[11,"meta_word","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"meta_list","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"},{"name":"vec"}],"output":{"name":"p"}}],[11,"meta_name_value","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"},{"name":"lit_"}],"output":{"name":"p"}}],[11,"item_use","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_use_simple","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"path"}],"output":{"name":"p"}}],[11,"item_use_simple_","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"ident"},{"name":"path"}],"output":{"name":"p"}}],[11,"item_use_list","","",214,null],[11,"item_use_glob","","",214,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"p"}}],[0,"cfg","syntax::ext","",null,null],[5,"expand_cfg","syntax::ext::cfg","",null,null],[0,"concat","syntax::ext","",null,null],[5,"expand_syntax_ext","syntax::ext::concat","",null,null],[0,"concat_idents","syntax::ext","",null,null],[5,"expand_syntax_ext","syntax::ext::concat_idents","",null,null],[0,"deriving","syntax::ext","The compiler code necessary to implement the `#[derive]` extensions.",null,null],[5,"register_all","syntax::ext::deriving","",null,{"inputs":[{"name":"syntaxenv"}],"output":null}],[0,"bounds","","",null,null],[5,"expand_deriving_unsafe_bound","syntax::ext::deriving::bounds","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[5,"expand_deriving_copy","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"clone","syntax::ext::deriving","",null,null],[5,"expand_deriving_clone","syntax::ext::deriving::clone","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"encodable","syntax::ext::deriving","The compiler code necessary to implement the `#[derive(Encodable)]`\n(and `Decodable`, in decodable.rs) extension.  The idea here is that\ntype-defining items may be tagged with `#[derive(Encodable, Decodable)]`.",null,null],[5,"expand_deriving_rustc_encodable","syntax::ext::deriving::encodable","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[5,"expand_deriving_encodable","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"decodable","syntax::ext::deriving","The compiler code necessary for `#[derive(Decodable)]`. See encodable.rs for more.",null,null],[5,"expand_deriving_rustc_decodable","syntax::ext::deriving::decodable","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[5,"expand_deriving_decodable","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"hash","syntax::ext::deriving","",null,null],[5,"expand_deriving_hash","syntax::ext::deriving::hash","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"show","syntax::ext::deriving","",null,null],[5,"expand_deriving_show","syntax::ext::deriving::show","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"default","syntax::ext::deriving","",null,null],[5,"expand_deriving_default","syntax::ext::deriving::default","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"primitive","syntax::ext::deriving","",null,null],[5,"expand_deriving_from_primitive","syntax::ext::deriving::primitive","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"eq","syntax::ext::deriving","",null,null],[5,"expand_deriving_eq","syntax::ext::deriving::eq","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"totaleq","syntax::ext::deriving","",null,null],[5,"expand_deriving_totaleq","syntax::ext::deriving::totaleq","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"ord","syntax::ext::deriving","",null,null],[4,"OrderingOp","syntax::ext::deriving::ord","",null,null],[13,"PartialCmpOp","","",226,null],[13,"LtOp","","",226,null],[13,"LeOp","","",226,null],[13,"GtOp","","",226,null],[13,"GeOp","","",226,null],[5,"expand_deriving_ord","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[5,"some_ordering_collapsed","","",null,null],[5,"cs_partial_cmp","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[11,"clone","","",226,{"inputs":[{"name":"orderingop"}],"output":{"name":"orderingop"}}],[0,"totalord","syntax::ext::deriving","",null,null],[5,"expand_deriving_totalord","syntax::ext::deriving::totalord","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[5,"ordering_collapsed","","",null,null],[5,"cs_cmp","","",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[0,"generic","syntax::ext::deriving","Some code that abstracts away much of the boilerplate of writing\n`derive` instances for traits. Among other things it manages getting\naccess to the fields of the 4 different sorts of structs and enum\nvariants, as well as creating the method and impl ast instances.",null,null],[3,"TraitDef","syntax::ext::deriving::generic","",null,null],[12,"span","","The span for the current #[derive(Foo)] header.",227,null],[12,"attributes","","",227,null],[12,"path","","Path of the trait, including any type parameters",227,null],[12,"additional_bounds","","Additional bounds required of any type parameters of the type,\nother than the current trait",227,null],[12,"generics","","Any extra lifetimes and/or bounds, e.g. `D: serialize::Decoder`",227,null],[12,"methods","","",227,null],[12,"associated_types","","",227,null],[3,"MethodDef","","",null,null],[12,"name","","name of the method",228,null],[12,"generics","","List of generics, e.g. `R: rand::Rng`",228,null],[12,"explicit_self","","Whether there is a self argument (outer Option) i.e. whether\nthis is a static function, and whether it is a pointer (inner\nOption)",228,null],[12,"args","","Arguments other than the self argument",228,null],[12,"ret_ty","","Return type",228,null],[12,"attributes","","",228,null],[12,"combine_substructure","","",228,null],[3,"Substructure","","All the data about the data structure/method being derived upon.",null,null],[12,"type_ident","","ident of self",229,null],[12,"method_ident","","ident of the method",229,null],[12,"self_args","","dereferenced access to any `Self_` or `Ptr(Self_, _)` arguments",229,null],[12,"nonself_args","","verbatim access to any other arguments",229,null],[12,"fields","","",229,null],[3,"FieldInfo","","Summary of the relevant parts of a struct/enum field.",null,null],[12,"span","","",230,null],[12,"name","","None for tuple structs/normal enum variants, Some for normal\nstructs/struct enum variants.",230,null],[12,"self_","","The expression corresponding to this field of `self`\n(specifically, a reference to it).",230,null],[12,"other","","The expressions corresponding to references to this field in\nthe other `Self` arguments.",230,null],[4,"StaticFields","","Fields for a static method",null,null],[13,"Unnamed","","Tuple structs/enum variants like this.",231,null],[13,"Named","","Normal structs/struct variants.",231,null],[4,"SubstructureFields","","A summary of the possible sets of fields.",null,null],[13,"Struct","","",232,null],[13,"EnumMatching","","Matching variants of the enum: variant index, ast::Variant,\nfields: the field name is only non-`None` in the case of a struct\nvariant.",232,null],[13,"EnumNonMatchingCollapsed","","Non-matching variants of the enum, but with all state hidden from\nthe consequent code.  The first component holds `Ident`s for all of\nthe `Self` arguments; the second component is a slice of all of the\nvariants for the enum itself, and the third component is a list of\n`Ident`s bound to the variant index values for each of the actual\ninput `Self` arguments.",232,null],[13,"StaticStruct","","A static method where `Self` is a struct.",232,null],[13,"StaticEnum","","A static method where `Self` is an enum.",232,null],[5,"combine_substructure","","",null,{"inputs":[{"name":"combinesubstructurefunc"}],"output":{"name":"refcell"}}],[5,"cs_fold","","Fold the fields. `use_foldl` controls whether this is done\nleft-to-right (`true`) or right-to-left (`false`).",null,{"inputs":[{"name":"bool"},{"name":"f"},{"name":"p"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[5,"cs_same_method","","Call the method that is being derived on all the fields, and then\nprocess the collected results. i.e.",null,{"inputs":[{"name":"f"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[5,"cs_same_method_fold","","Fold together the results of calling the derived method on all the\nfields. `use_foldl` controls whether this is done left-to-right\n(`true`) or right-to-left (`false`).",null,{"inputs":[{"name":"bool"},{"name":"f"},{"name":"p"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[5,"cs_binop","","Use a given binop to combine the result of calling the derived method\non all the fields.",null,{"inputs":[{"name":"binop_"},{"name":"p"},{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[5,"cs_or","","cs_binop with binop == or",null,{"inputs":[{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[5,"cs_and","","cs_binop with binop == and",null,{"inputs":[{"name":"enumnonmatchcollapsedfunc"},{"name":"extctxt"},{"name":"span"},{"name":"substructure"}],"output":{"name":"p"}}],[0,"ty","","A mini version of ast::Ty, which is easier to use, and features an explicit `Self` type to use\nwhen specifying impls to be derived.",null,null],[3,"Path","syntax::ext::deriving::generic::ty","A path, e.g. `::std::option::Option::<i32>` (global). Has support\nfor type parameters and a lifetime.",null,null],[12,"path","","",233,null],[12,"lifetime","","",233,null],[12,"params","","",233,null],[12,"global","","",233,null],[3,"LifetimeBounds","","Lifetimes and bounds on type parameters",null,null],[12,"lifetimes","","",234,null],[12,"bounds","","",234,null],[4,"PtrTy","","The types of pointers",null,null],[13,"Borrowed","","&'lifetime mut",235,null],[13,"Raw","","*mut",235,null],[4,"Ty","","A type. Supports pointers, Self, and literals",null,null],[13,"Self_","","",236,null],[13,"Ptr","","&/Box/ Ty",236,null],[13,"Literal","","mod::mod::Type<[lifetime], [Params...]>, including a plain type\nparameter, and things like `i32`",236,null],[13,"Tuple","","includes unit",236,null],[5,"borrowed_ptrty","","",null,{"inputs":[],"output":{"name":"ptrty"}}],[5,"borrowed","","",null,{"inputs":[{"name":"box"}],"output":{"name":"ty"}}],[5,"borrowed_explicit_self","","",null,{"inputs":[],"output":{"name":"option"}}],[5,"borrowed_self","","",null,{"inputs":[],"output":{"name":"ty"}}],[5,"nil_ty","","",null,{"inputs":[],"output":{"name":"ty"}}],[5,"get_explicit_self","","",null,null],[11,"clone","","",235,{"inputs":[{"name":"ptrty"}],"output":{"name":"ptrty"}}],[11,"clone","","",233,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"new","","",233,{"inputs":[{"name":"path"},{"name":"vec"}],"output":{"name":"path"}}],[11,"new_local","","",233,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"path"}}],[11,"new_","","",233,{"inputs":[{"name":"path"},{"name":"vec"},{"name":"option"},{"name":"vec"},{"name":"bool"}],"output":{"name":"path"}}],[11,"to_ty","","",233,{"inputs":[{"name":"path"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"p"}}],[11,"to_path","","",233,{"inputs":[{"name":"path"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",236,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[11,"to_ty","","",236,{"inputs":[{"name":"ty"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"p"}}],[11,"to_path","","",236,{"inputs":[{"name":"ty"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",234,{"inputs":[{"name":"lifetimebounds"}],"output":{"name":"lifetimebounds"}}],[11,"empty","","",234,{"inputs":[{"name":"lifetimebounds"}],"output":{"name":"lifetimebounds"}}],[11,"to_generics","","",234,{"inputs":[{"name":"lifetimebounds"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"generics"}}],[6,"CombineSubstructureFunc","syntax::ext::deriving::generic","Combine the values of all the fields together. The last argument is\nall the fields of all the structures.",null,null],[6,"EnumNonMatchCollapsedFunc","","Deal with non-matching enum variants.  The tuple is a list of\nidentifiers (one for each `Self` argument, which could be any of the\nvariants since they have been collapsed together) and the identifiers\nholding the variant index value for each of the `Self` arguments.  The\nlast argument is all the non-`Self` args of the method being derived.",null,null],[11,"expand","","",227,{"inputs":[{"name":"traitdef"},{"name":"extctxt"},{"name":"metaitem"},{"name":"item"},{"name":"f"}],"output":null}],[0,"env","syntax::ext","",null,null],[5,"expand_option_env","syntax::ext::env","",null,null],[5,"expand_env","","",null,null],[0,"expand","syntax::ext","",null,null],[3,"IdentRenamer","syntax::ext::expand","A tree-folder that applies every rename in its (mutable) list\nto every identifier, including both bindings and varrefs\n(and lots of things that will turn out to be neither)",null,null],[3,"PatIdentRenamer","","A tree-folder that applies every rename in its list to\nthe idents that are in PatIdent patterns. This is more narrowly\nfocused than IdentRenamer, and is needed for FnDecl,\nwhere we want to rename the args but not the fn name or the generics etc.",null,null],[3,"MacroExpander","","A tree-folder that performs macro expansion",null,null],[12,"cx","","",237,null],[3,"ExpansionConfig","","",null,null],[12,"crate_name","","",238,null],[12,"features","","",238,null],[12,"recursion_limit","","",238,null],[5,"expand_expr","","",null,{"inputs":[{"name":"p"},{"name":"macroexpander"}],"output":{"name":"p"}}],[5,"expand_item","","",null,{"inputs":[{"name":"p"},{"name":"macroexpander"}],"output":{"name":"smallvector"}}],[5,"expand_item_mac","","",null,{"inputs":[{"name":"p"},{"name":"macroexpander"}],"output":{"name":"smallvector"}}],[5,"expand_block","","",null,{"inputs":[{"name":"p"},{"name":"macroexpander"}],"output":{"name":"p"}}],[5,"expand_block_elts","","",null,{"inputs":[{"name":"p"},{"name":"macroexpander"}],"output":{"name":"p"}}],[5,"expand_crate","","",null,{"inputs":[{"name":"parsesess"},{"name":"expansionconfig"},{"name":"vec"},{"name":"vec"},{"name":"crate"}],"output":{"name":"crate"}}],[5,"check_for_macros","","Check that there are no macro invocations left in the AST:",null,{"inputs":[{"name":"parsesess"},{"name":"crate"}],"output":null}],[11,"fold_ident","","",239,{"inputs":[{"name":"identrenamer"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_mac","","",239,{"inputs":[{"name":"identrenamer"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"fold_pat","","",240,{"inputs":[{"name":"patidentrenamer"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mac","","",240,{"inputs":[{"name":"patidentrenamer"},{"name":"mac"}],"output":{"name":"mac"}}],[11,"new","","",237,{"inputs":[{"name":"macroexpander"},{"name":"extctxt"}],"output":{"name":"macroexpander"}}],[11,"fold_expr","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_pat","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_item","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_item_underscore","","",237,{"inputs":[{"name":"macroexpander"},{"name":"item_"}],"output":{"name":"item_"}}],[11,"fold_stmt","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_block","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_arm","","",237,{"inputs":[{"name":"macroexpander"},{"name":"arm"}],"output":{"name":"arm"}}],[11,"fold_trait_item","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_impl_item","","",237,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"new_span","","",237,{"inputs":[{"name":"macroexpander"},{"name":"span"}],"output":{"name":"span"}}],[11,"default","","",238,{"inputs":[{"name":"expansionconfig"},{"name":"string"}],"output":{"name":"expansionconfig"}}],[11,"enable_quotes","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_asm","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_log_syntax","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_concat_idents","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_trace_macros","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_allow_internal_unstable","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_custom_derive","","",238,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[0,"format","syntax::ext","",null,null],[5,"expand_format_args","syntax::ext::format","",null,null],[5,"expand_preparsed_format_args","","Take the various parts of `format_args!(efmt, args..., name=names...)`\nand construct the appropriate formatting expression.",null,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"},{"name":"vec"},{"name":"hashmap"}],"output":{"name":"p"}}],[0,"log_syntax","syntax::ext","",null,null],[5,"expand_syntax_ext","syntax::ext::log_syntax","",null,null],[0,"mtwt","syntax::ext","Machinery for hygienic macros, as described in the MTWT[1] paper.",null,null],[3,"SCTable","syntax::ext::mtwt","The SCTable contains a table of SyntaxContext_'s. It\nrepresents a flattened tree structure, to avoid having\nmanaged pointers everywhere (that caused an ICE).\nthe mark_memo and rename_memo fields are side-tables\nthat ensure that adding the same mark to the same context\ngives you back the same context as before. This shouldn't\nchange the semantics--everything here is immutable--but\nit should cut down on memory use *a lot*; applying a mark\nto a tree containing 50 identifiers would otherwise generate\n50 new contexts",null,null],[4,"SyntaxContext_","","",null,null],[13,"EmptyCtxt","","",241,null],[13,"Mark","","",241,null],[13,"Rename","","flattening the name and syntaxcontext into the rename...\nHIDDEN INVARIANTS:\n1) the first name in a Rename node\ncan only be a programmer-supplied name.\n2) Every Rename node with a given Name in the\n\"to\" slot must have the same name and context\nin the \"from\" slot. In essence, they're all\npointers to a single \"rename\" event node.",241,null],[13,"IllegalCtxt","","actually, IllegalCtxt may not be necessary.",241,null],[5,"apply_mark","","Extend a syntax context with a given mark",null,{"inputs":[{"name":"mrk"},{"name":"syntaxcontext"}],"output":{"name":"syntaxcontext"}}],[5,"apply_rename","","Extend a syntax context with a given rename",null,{"inputs":[{"name":"ident"},{"name":"name"},{"name":"syntaxcontext"}],"output":{"name":"syntaxcontext"}}],[5,"apply_renames","","Apply a list of renamings to a context",null,{"inputs":[{"name":"renamelist"},{"name":"syntaxcontext"}],"output":{"name":"syntaxcontext"}}],[5,"with_sctable","","Fetch the SCTable from TLS, create one if it doesn't yet exist.",null,{"inputs":[{"name":"f"}],"output":{"name":"t"}}],[5,"display_sctable","","Print out an SCTable for debugging",null,{"inputs":[{"name":"sctable"}],"output":null}],[5,"clear_tables","","Clear the tables from TLD to reclaim memory.",null,{"inputs":[],"output":null}],[5,"reset_tables","","Reset the tables to their initial state",null,{"inputs":[],"output":null}],[5,"resolve","","Resolve a syntax object to a name, per MTWT.",null,{"inputs":[{"name":"ident"}],"output":{"name":"name"}}],[5,"marksof","","Compute the marks associated with a syntax context.",null,{"inputs":[{"name":"syntaxcontext"},{"name":"name"}],"output":{"name":"vec"}}],[5,"outer_mark","","Return the outer mark for a context with a mark at the outside.\nFAILS when outside is not a mark.",null,{"inputs":[{"name":"syntaxcontext"}],"output":{"name":"mrk"}}],[6,"RenameList","","A list of ident->name renamings",null,null],[11,"clone","","",241,{"inputs":[{"name":"syntaxcontext_"}],"output":{"name":"syntaxcontext_"}}],[11,"fmt","","",241,{"inputs":[{"name":"syntaxcontext_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",241,null],[11,"decode","","",241,{"inputs":[{"name":"syntaxcontext_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",241,{"inputs":[{"name":"syntaxcontext_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",241,{"inputs":[{"name":"syntaxcontext_"},{"name":"syntaxcontext_"}],"output":{"name":"bool"}}],[11,"ne","","",241,{"inputs":[{"name":"syntaxcontext_"},{"name":"syntaxcontext_"}],"output":{"name":"bool"}}],[0,"quote","syntax::ext","",null,null],[5,"expand_quote_tokens","syntax::ext::quote","",null,null],[5,"expand_quote_expr","","",null,null],[5,"expand_quote_item","","",null,null],[5,"expand_quote_pat","","",null,null],[5,"expand_quote_arm","","",null,null],[5,"expand_quote_ty","","",null,null],[5,"expand_quote_stmt","","",null,null],[5,"expand_quote_attr","","",null,null],[5,"expand_quote_matcher","","",null,null],[0,"rt","","Quasiquoting works via token trees.",null,null],[8,"ToTokens","syntax::ext::quote::rt","",null,null],[10,"to_tokens","","",242,{"inputs":[{"name":"totokens"},{"name":"extctxt"}],"output":{"name":"vec"}}],[8,"ToSource","","",null,null],[10,"to_source","","",243,{"inputs":[{"name":"tosource"}],"output":{"name":"string"}}],[8,"ExtParseUtils","","",null,null],[10,"parse_item","","",244,{"inputs":[{"name":"extparseutils"},{"name":"string"}],"output":{"name":"p"}}],[10,"parse_expr","","",244,{"inputs":[{"name":"extparseutils"},{"name":"string"}],"output":{"name":"p"}}],[10,"parse_stmt","","",244,{"inputs":[{"name":"extparseutils"},{"name":"string"}],"output":{"name":"p"}}],[10,"parse_tts","","",244,{"inputs":[{"name":"extparseutils"},{"name":"string"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",81,{"inputs":[{"name":"tokentree"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","collections::vec","",170,{"inputs":[{"name":"vec"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::codemap","",137,{"inputs":[{"name":"spanned"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","core::option","",245,{"inputs":[{"name":"option"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_source","syntax::ast","",11,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"to_source","","",14,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[11,"to_source","","",42,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[11,"to_source","","",26,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[11,"to_source","","",45,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[11,"to_source","","",20,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[11,"to_source","","",21,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[11,"to_source","syntax::ptr","",197,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",197,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",197,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",197,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",197,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",197,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","syntax::ast","",30,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[11,"to_source","","",52,{"inputs":[{"name":"attribute_"}],"output":{"name":"string"}}],[11,"to_tokens","","",11,{"inputs":[{"name":"ident"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",14,{"inputs":[{"name":"path"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ptr","",197,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",197,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",197,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",197,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",30,{"inputs":[{"name":"arm"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",42,{"inputs":[{"name":"ty"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",20,{"inputs":[{"name":"generics"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",21,{"inputs":[{"name":"whereclause"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ptr","",197,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",197,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",26,{"inputs":[{"name":"block"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",45,{"inputs":[{"name":"arg"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",52,{"inputs":[{"name":"attribute_"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"parse_item","syntax::ext::base","",214,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_stmt","","",214,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_expr","","",214,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_tts","","",214,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"vec"}}],[0,"source_util","syntax::ext","",null,null],[5,"expand_line","syntax::ext::source_util","line!(): expands to the current line number",null,null],[5,"expand_column","","",null,null],[5,"expand_file","","file!(): expands to the current filename */\nThe filemap (`loc.file`) contains a bunch more information we could spit\nout if we wanted.",null,null],[5,"expand_stringify","","",null,null],[5,"expand_mod","","",null,null],[5,"expand_include","","include! : parse the given file as an expr\nThis is generally a bad idea because it's going to behave\nunhygienically.",null,null],[5,"expand_include_str","","",null,null],[5,"expand_include_bytes","","",null,null],[0,"trace_macros","syntax::ext","",null,null],[5,"expand_trace_macros","syntax::ext::trace_macros","",null,null],[0,"tt","syntax::ext","",null,null],[0,"transcribe","syntax::ext::tt","",null,null],[3,"TtReader","syntax::ext::tt::transcribe","",null,null],[12,"sp_diag","","",246,null],[12,"cur_tok","","",246,null],[12,"cur_span","","",246,null],[12,"desugar_doc_comments","","Transform doc comments. Only useful in macro invocations",246,null],[5,"new_tt_reader","","This can do Macro-By-Example transcription. On the other hand, if\n`src` contains no `TtSequence`s, `MatchNt`s or `SubstNt`s, `interp` can\n(and should) be None.",null,{"inputs":[{"name":"spanhandler"},{"name":"option"},{"name":"option"},{"name":"vec"}],"output":{"name":"ttreader"}}],[5,"new_tt_reader_with_doc_flag","","The extra `desugar_doc_comments` flag enables reading doc comments\nlike any other attribute which consists of `meta` and surrounding #[ ] tokens.",null,{"inputs":[{"name":"spanhandler"},{"name":"option"},{"name":"option"},{"name":"vec"},{"name":"bool"}],"output":{"name":"ttreader"}}],[5,"tt_next_token","","Return the next token from the TtReader.\nEFFECT: advances the reader's token field",null,{"inputs":[{"name":"ttreader"}],"output":{"name":"tokenandspan"}}],[11,"clone","","",246,{"inputs":[{"name":"ttreader"}],"output":{"name":"ttreader"}}],[0,"macro_parser","syntax::ext::tt","This is an Earley-like parser, without support for in-grammar nonterminals,\nonly by calling out to the main rust parser for named nonterminals (which it\ncommits to fully when it hits one in a grammar). This means that there are no\ncompleter or predictor rules, and therefore no need to store one column per\ntoken: instead, there's a set of current Earley items and a set of next\nones. Instead of NTs, we have a special case for Kleene star. The big-O, in\npathological cases, is worse than traditional Earley parsing, but it's an\neasier fit for Macro-by-Example-style rules, and I think the overhead is\nlower. (In order to prevent the pathological case, we'd need to lazily\nconstruct the resulting `NamedMatch`es at the very end. It'd be a pain,\nand require more memory to keep around old items, but it would also save\noverhead)",null,null],[3,"MatcherPos","syntax::ext::tt::macro_parser","",null,null],[4,"NamedMatch","","NamedMatch is a pattern-match result for a single token::MATCH_NONTERMINAL:\nso it is associated with a single ident in a parse, and all\n`MatchedNonterminal`s in the NamedMatch have the same nonterminal type\n(expr, item, etc). Each leaf in a single NamedMatch corresponds to a\nsingle token::MATCH_NONTERMINAL in the TokenTree that produced it.",null,null],[13,"MatchedSeq","","",247,null],[13,"MatchedNonterminal","","",247,null],[4,"ParseResult","","",null,null],[13,"Success","","",248,null],[13,"Failure","","",248,null],[13,"Error","","",248,null],[5,"count_names","","",null,null],[5,"initial_matcher_pos","","",null,{"inputs":[{"name":"rc"},{"name":"option"},{"name":"bytepos"}],"output":{"name":"box"}}],[5,"nameize","","",null,null],[5,"parse_or_else","","",null,{"inputs":[{"name":"parsesess"},{"name":"crateconfig"},{"name":"ttreader"},{"name":"vec"}],"output":{"name":"hashmap"}}],[5,"token_name_eq","","Perform a token equality check, ignoring syntax context (that is, an\nunhygienic comparison)",null,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[5,"parse","","",null,null],[5,"parse_nt","","",null,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":{"name":"nonterminal"}}],[6,"NamedParseResult","","",null,null],[6,"PositionalParseResult","","",null,null],[11,"clone","","",249,{"inputs":[{"name":"matcherpos"}],"output":{"name":"matcherpos"}}],[0,"macro_rules","syntax::ext::tt","",null,null],[5,"compile","syntax::ext::tt::macro_rules","Converts a `macro_rules!` invocation into a syntax extension.",null,{"inputs":[{"name":"extctxt"},{"name":"macrodef"}],"output":{"name":"syntaxextension"}}],[14,"register_diagnostic!","syntax","",null,null],[14,"span_fatal!","","",null,null],[14,"span_err!","","",null,null],[14,"span_warn!","","",null,null],[14,"span_note!","","",null,null],[14,"span_help!","","",null,null],[14,"fileline_help!","","",null,null],[14,"register_diagnostics!","","",null,null],[14,"register_long_diagnostics!","","",null,null],[11,"print_node","syntax::print::pprust","",207,null],[11,"name","syntax::ptr","",197,null],[11,"value_str","","",197,null],[11,"meta_item_list","","",197,null],[11,"span","","",197,null],[11,"move_map","syntax::owned_slice","",171,null],[11,"is_eof","syntax::ext::tt::transcribe","",246,null],[11,"next_token","","",246,null],[11,"fatal","","",246,null],[11,"err","","",246,null],[11,"peek","","",246,null]],"paths":[[3,"Interner"],[3,"RcStr"],[3,"StrInterner"],[3,"SmallVector"],[3,"IntoIter"],[3,"Registry"],[4,"Os"],[4,"Abi"],[4,"Architecture"],[4,"AbiArchitecture"],[3,"AbiData"],[3,"Ident"],[3,"Lifetime"],[3,"LifetimeDef"],[3,"Path"],[3,"PathSegment"],[3,"AngleBracketedParameterData"],[3,"ParenthesizedParameterData"],[3,"DefId"],[3,"TyParam"],[3,"Generics"],[3,"WhereClause"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[3,"Block"],[3,"Pat"],[3,"FieldPat"],[3,"Local"],[3,"Arm"],[3,"Field"],[3,"Expr"],[3,"QSelf"],[3,"Delimited"],[3,"SequenceRepetition"],[3,"MutTy"],[3,"TypeField"],[3,"MethodSig"],[3,"TraitItem"],[3,"ImplItem"],[3,"TypeBinding"],[3,"Ty"],[3,"BareFnTy"],[3,"InlineAsm"],[3,"Arg"],[3,"FnDecl"],[3,"Mod"],[3,"ForeignMod"],[3,"VariantArg"],[3,"EnumDef"],[3,"Variant_"],[3,"Attribute_"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField_"],[3,"StructDef"],[3,"Item"],[3,"ForeignItem"],[3,"MacroDef"],[4,"PathParameters"],[4,"TyParamBound"],[4,"TraitBoundModifier"],[4,"WherePredicate"],[4,"MetaItem_"],[4,"BindingMode"],[4,"PatWildKind"],[4,"Pat_"],[4,"Mutability"],[4,"BinOp_"],[4,"UnOp"],[4,"Stmt_"],[4,"MacStmtStyle"],[4,"LocalSource"],[4,"Decl_"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"Expr_"],[4,"MatchSource"],[4,"CaptureClause"],[4,"KleeneOp"],[4,"TokenTree"],[4,"Mac_"],[4,"StrStyle"],[4,"Sign"],[4,"LitIntType"],[4,"Lit_"],[4,"TraitItem_"],[4,"ImplItem_"],[4,"IntTy"],[4,"UintTy"],[4,"FloatTy"],[4,"PrimTy"],[4,"Ty_"],[4,"AsmDialect"],[4,"Unsafety"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"ExplicitSelf_"],[4,"VariantKind"],[4,"PathListItem_"],[4,"ViewPath_"],[4,"AttrStyle"],[4,"Visibility"],[4,"StructFieldKind"],[4,"Item_"],[4,"ForeignItem_"],[4,"InlinedItem"],[8,"IntSign"],[3,"Name"],[3,"AttrId"],[4,"PathElem"],[4,"Node"],[3,"FnParts"],[4,"Code"],[8,"MaybeFnLike"],[3,"FnLikeNode"],[8,"FoldOps"],[8,"NodePrinter"],[3,"LinkedPathNode"],[3,"LinkedPath"],[3,"Forest"],[3,"Map"],[3,"NodesMatchingSuffix"],[3,"IdRange"],[3,"IdVisitor"],[8,"IdVisitingOperation"],[3,"Stability"],[4,"InlineAttr"],[4,"StabilityLevel"],[4,"ReprAttr"],[4,"IntType"],[8,"AttrMetaMethods"],[8,"AttributeMethods"],[6,"Attribute"],[6,"MetaItem"],[3,"Span"],[3,"Spanned"],[3,"Loc"],[3,"LocWithOpt"],[3,"FileMapAndLine"],[3,"FileMapAndBytePos"],[3,"NameAndSpan"],[3,"ExpnInfo"],[3,"LineInfo"],[3,"FileLines"],[3,"MultiByteChar"],[3,"FileMap"],[3,"CodeMap"],[4,"MacroFormat"],[4,"SpanSnippetError"],[8,"Pos"],[3,"BytePos"],[3,"CharPos"],[3,"ExpnId"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[3,"SpanHandler"],[3,"Handler"],[4,"RenderSpan"],[4,"ColorConfig"],[4,"Level"],[8,"Emitter"],[3,"FatalError"],[3,"ExplicitBug"],[3,"EmitterWriter"],[3,"Features"],[4,"AttributeType"],[8,"MoveMap"],[8,"Folder"],[3,"Vec"],[3,"OwnedSlice"],[3,"ParseSess"],[3,"Parser"],[4,"PathParsingMode"],[4,"BoundParsingMode"],[4,"TokenType"],[3,"Restrictions"],[3,"TokenAndSpan"],[3,"StringReader"],[3,"Comment"],[3,"Literal"],[4,"CommentStyle"],[8,"Reader"],[4,"BinOpToken"],[4,"DelimToken"],[4,"IdentStyle"],[4,"SpecialMacroVar"],[4,"Lit"],[4,"Token"],[4,"Nonterminal"],[4,"Keyword"],[3,"InternedString"],[8,"ParserAttr"],[3,"SeqSep"],[4,"ObsoleteSyntax"],[8,"ParserObsoleteMethods"],[3,"P"],[4,"FnKind"],[8,"Visitor"],[3,"Printer"],[4,"Breaks"],[4,"Token"],[4,"PrintStackBreak"],[3,"BreakToken"],[3,"BeginToken"],[3,"PrintStackElem"],[3,"State"],[4,"AnnNode"],[8,"PpAnn"],[3,"NoAnn"],[3,"CurrentCommentAndLiteral"],[3,"MacEager"],[3,"BlockInfo"],[3,"ExtCtxt"],[4,"Annotatable"],[4,"SyntaxExtension"],[8,"ItemDecorator"],[8,"ItemModifier"],[8,"MultiItemModifier"],[8,"TTMacroExpander"],[8,"IdentMacroExpander"],[8,"MacResult"],[3,"DummyResult"],[3,"SyntaxEnv"],[8,"AstBuilder"],[4,"OrderingOp"],[3,"TraitDef"],[3,"MethodDef"],[3,"Substructure"],[3,"FieldInfo"],[4,"StaticFields"],[4,"SubstructureFields"],[3,"Path"],[3,"LifetimeBounds"],[4,"PtrTy"],[4,"Ty"],[3,"MacroExpander"],[3,"ExpansionConfig"],[3,"IdentRenamer"],[3,"PatIdentRenamer"],[4,"SyntaxContext_"],[8,"ToTokens"],[8,"ToSource"],[8,"ExtParseUtils"],[4,"Option"],[3,"TtReader"],[4,"NamedMatch"],[4,"ParseResult"],[3,"MatcherPos"]]};
searchIndex['rustdoc'] = {"items":[[0,"","rustdoc","",null,null],[5,"main","","",null,{"inputs":[],"output":null}],[5,"opts","","",null,{"inputs":[],"output":{"name":"vec"}}],[5,"usage","","",null,{"inputs":[{"name":"str"}],"output":null}],[5,"main_args","","",null,null],[0,"externalfiles","","",null,null],[3,"ExternalHtml","rustdoc::externalfiles","",null,null],[12,"in_header","","",0,null],[12,"before_content","","",0,null],[12,"after_content","","",0,null],[5,"load_string","","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[5,"load_external_files","","",null,null],[11,"clone","","",0,{"inputs":[{"name":"externalhtml"}],"output":{"name":"externalhtml"}}],[11,"load","","",0,null],[0,"clean","rustdoc","This module contains the \"cleaned\" pieces of the AST, and the functions\nthat clean them.",null,null],[3,"Crate","rustdoc::clean","",null,null],[12,"name","","",1,null],[12,"src","","",1,null],[12,"module","","",1,null],[12,"externs","","",1,null],[12,"primitives","","",1,null],[12,"external_traits","","",1,null],[3,"ExternalCrate","","",null,null],[12,"name","","",2,null],[12,"attrs","","",2,null],[12,"primitives","","",2,null],[3,"Item","","Anything with a source location and set of attributes and, optionally, a\nname. That is, anything that can be documented. This doesn't correspond\ndirectly to the AST's concept of an item; it's a strict superset.",null,null],[12,"source","","Stringified span",3,null],[12,"name","","Not everything has a name. E.g., impls",3,null],[12,"attrs","","",3,null],[12,"inner","","",3,null],[12,"visibility","","",3,null],[12,"def_id","","",3,null],[12,"stability","","",3,null],[3,"Module","","",null,null],[12,"items","","",4,null],[12,"is_crate","","",4,null],[3,"TyParam","","",null,null],[12,"name","","",5,null],[12,"did","","",5,null],[12,"bounds","","",5,null],[12,"default","","",5,null],[3,"Lifetime","","",null,null],[3,"Generics","","",null,null],[12,"lifetimes","","",6,null],[12,"type_params","","",6,null],[12,"where_predicates","","",6,null],[3,"Method","","",null,null],[12,"generics","","",7,null],[12,"self_","","",7,null],[12,"unsafety","","",7,null],[12,"decl","","",7,null],[12,"abi","","",7,null],[3,"TyMethod","","",null,null],[12,"unsafety","","",8,null],[12,"decl","","",8,null],[12,"generics","","",8,null],[12,"self_","","",8,null],[12,"abi","","",8,null],[3,"Function","","",null,null],[12,"decl","","",9,null],[12,"generics","","",9,null],[12,"unsafety","","",9,null],[12,"abi","","",9,null],[3,"FnDecl","","",null,null],[12,"inputs","","",10,null],[12,"output","","",10,null],[12,"attrs","","",10,null],[3,"Arguments","","",null,null],[12,"values","","",11,null],[3,"Argument","","",null,null],[12,"type_","","",12,null],[12,"name","","",12,null],[12,"id","","",12,null],[3,"Trait","","",null,null],[12,"unsafety","","",13,null],[12,"items","","",13,null],[12,"generics","","",13,null],[12,"bounds","","",13,null],[3,"PolyTrait","","A trait reference, which may have higher ranked lifetimes.",null,null],[12,"trait_","","",14,null],[12,"lifetimes","","",14,null],[3,"Struct","","",null,null],[12,"struct_type","","",15,null],[12,"generics","","",15,null],[12,"fields","","",15,null],[12,"fields_stripped","","",15,null],[3,"VariantStruct","","This is a more limited form of the standard Struct, different in that\nit lacks the things most items have (name, id, parameterization). Found\nonly as a variant in an enum.",null,null],[12,"struct_type","","",16,null],[12,"fields","","",16,null],[12,"fields_stripped","","",16,null],[3,"Enum","","",null,null],[12,"variants","","",17,null],[12,"generics","","",17,null],[12,"variants_stripped","","",17,null],[3,"Variant","","",null,null],[12,"kind","","",18,null],[3,"Span","","",null,null],[12,"filename","","",19,null],[12,"loline","","",19,null],[12,"locol","","",19,null],[12,"hiline","","",19,null],[12,"hicol","","",19,null],[3,"Path","","",null,null],[12,"global","","",20,null],[12,"segments","","",20,null],[3,"PathSegment","","",null,null],[12,"name","","",21,null],[12,"params","","",21,null],[3,"Typedef","","",null,null],[12,"type_","","",22,null],[12,"generics","","",22,null],[3,"BareFunctionDecl","","",null,null],[12,"unsafety","","",23,null],[12,"generics","","",23,null],[12,"decl","","",23,null],[12,"abi","","",23,null],[3,"Static","","",null,null],[12,"type_","","",24,null],[12,"mutability","","",24,null],[12,"expr","","It's useful to have the value of a static documented, but I have no\ndesire to represent expressions (that'd basically be all of the AST,\nwhich is huge!). So, have a string.",24,null],[3,"Constant","","",null,null],[12,"type_","","",25,null],[12,"expr","","",25,null],[3,"Impl","","",null,null],[12,"unsafety","","",26,null],[12,"generics","","",26,null],[12,"trait_","","",26,null],[12,"for_","","",26,null],[12,"items","","",26,null],[12,"derived","","",26,null],[12,"polarity","","",26,null],[3,"DefaultImpl","","",null,null],[12,"unsafety","","",27,null],[12,"trait_","","",27,null],[3,"ImportSource","","",null,null],[12,"path","","",28,null],[12,"did","","",28,null],[3,"ViewListIdent","","",null,null],[12,"name","","",29,null],[12,"source","","",29,null],[3,"Macro","","",null,null],[12,"source","","",30,null],[3,"Stability","","",null,null],[12,"level","","",31,null],[12,"feature","","",31,null],[12,"since","","",31,null],[12,"deprecated_since","","",31,null],[12,"reason","","",31,null],[3,"TypeBinding","","An equality constraint on an associated type, e.g. `A=Bar` in `Foo<A=Bar>`",null,null],[12,"name","","",32,null],[12,"ty","","",32,null],[4,"ItemEnum","","",null,null],[13,"ExternCrateItem","","",33,null],[13,"ImportItem","","",33,null],[13,"StructItem","","",33,null],[13,"EnumItem","","",33,null],[13,"FunctionItem","","",33,null],[13,"ModuleItem","","",33,null],[13,"TypedefItem","","",33,null],[13,"StaticItem","","",33,null],[13,"ConstantItem","","",33,null],[13,"TraitItem","","",33,null],[13,"ImplItem","","",33,null],[13,"TyMethodItem","","A method signature only. Used for required methods in traits (ie,\nnon-default-methods).",33,null],[13,"MethodItem","","A method with a body.",33,null],[13,"StructFieldItem","","",33,null],[13,"VariantItem","","",33,null],[13,"ForeignFunctionItem","","`fn`s from an extern block",33,null],[13,"ForeignStaticItem","","`static`s from an extern block",33,null],[13,"MacroItem","","",33,null],[13,"PrimitiveItem","","",33,null],[13,"AssociatedTypeItem","","",33,null],[13,"DefaultImplItem","","",33,null],[4,"Attribute","","",null,null],[13,"Word","","",34,null],[13,"List","","",34,null],[13,"NameValue","","",34,null],[4,"TyParamBound","","",null,null],[13,"RegionBound","","",35,null],[13,"TraitBound","","",35,null],[4,"WherePredicate","","",null,null],[13,"BoundPredicate","","",36,null],[12,"ty","rustdoc::clean::WherePredicate","",36,null],[12,"bounds","","",36,null],[13,"RegionPredicate","rustdoc::clean","",36,null],[12,"lifetime","rustdoc::clean::WherePredicate","",36,null],[12,"bounds","","",36,null],[13,"EqPredicate","rustdoc::clean","",36,null],[12,"lhs","rustdoc::clean::WherePredicate","",36,null],[12,"rhs","","",36,null],[4,"SelfTy","rustdoc::clean","",null,null],[13,"SelfStatic","","",37,null],[13,"SelfValue","","",37,null],[13,"SelfBorrowed","","",37,null],[13,"SelfExplicit","","",37,null],[4,"FunctionRetTy","","",null,null],[13,"Return","","",38,null],[13,"DefaultReturn","","",38,null],[13,"NoReturn","","",38,null],[4,"Type","","A representation of a Type suitable for hyperlinking purposes. Ideally one can get the original\ntype out of the AST/ty::ctxt given one of these, if more information is needed. Most importantly\nit does not preserve mutability or boxes.",null,null],[13,"ResolvedPath","","structs/enums/traits (anything that'd be an ast::TyPath)",39,null],[12,"path","rustdoc::clean::Type","",39,null],[12,"typarams","","",39,null],[12,"did","","",39,null],[13,"Generic","rustdoc::clean","For parameterized types, so the consumer of the JSON don't go\nlooking for types which don't exist anywhere.",39,null],[13,"Primitive","","Primitives are the fixed-size numeric types (plus int/usize/float), char,\narrays, slices, and tuples.",39,null],[13,"BareFunction","","extern \"ABI\" fn",39,null],[13,"Tuple","","",39,null],[13,"Vector","","",39,null],[13,"FixedVector","","",39,null],[13,"Bottom","","aka TyBot",39,null],[13,"Unique","","",39,null],[13,"RawPointer","","",39,null],[13,"BorrowedRef","","",39,null],[12,"lifetime","rustdoc::clean::Type","",39,null],[12,"mutability","","",39,null],[12,"type_","","",39,null],[13,"QPath","rustdoc::clean","",39,null],[12,"name","rustdoc::clean::Type","",39,null],[12,"self_type","","",39,null],[12,"trait_","","",39,null],[13,"Infer","rustdoc::clean","",39,null],[13,"PolyTraitRef","","",39,null],[4,"PrimitiveType","","",null,null],[13,"Isize","","",40,null],[13,"I8","","",40,null],[13,"I16","","",40,null],[13,"I32","","",40,null],[13,"I64","","",40,null],[13,"Usize","","",40,null],[13,"U8","","",40,null],[13,"U16","","",40,null],[13,"U32","","",40,null],[13,"U64","","",40,null],[13,"F32","","",40,null],[13,"F64","","",40,null],[13,"Char","","",40,null],[13,"Bool","","",40,null],[13,"Str","","",40,null],[13,"Slice","","",40,null],[13,"Array","","",40,null],[13,"PrimitiveTuple","","",40,null],[13,"PrimitiveRawPointer","","",40,null],[4,"TypeKind","","",null,null],[13,"TypeEnum","","",41,null],[13,"TypeFunction","","",41,null],[13,"TypeModule","","",41,null],[13,"TypeConst","","",41,null],[13,"TypeStatic","","",41,null],[13,"TypeStruct","","",41,null],[13,"TypeTrait","","",41,null],[13,"TypeVariant","","",41,null],[13,"TypeTypedef","","",41,null],[4,"StructField","","",null,null],[13,"HiddenStructField","","",42,null],[13,"TypedStructField","","",42,null],[4,"VariantKind","","",null,null],[13,"CLikeVariant","","",43,null],[13,"TupleVariant","","",43,null],[13,"StructVariant","","",43,null],[4,"PathParameters","","",null,null],[13,"AngleBracketed","","",44,null],[12,"lifetimes","rustdoc::clean::PathParameters","",44,null],[12,"types","","",44,null],[12,"bindings","","",44,null],[13,"Parenthesized","rustdoc::clean","",44,null],[12,"inputs","rustdoc::clean::PathParameters","",44,null],[12,"output","","",44,null],[4,"Mutability","rustdoc::clean","",null,null],[13,"Mutable","","",45,null],[13,"Immutable","","",45,null],[4,"ImplPolarity","","",null,null],[13,"Positive","","",46,null],[13,"Negative","","",46,null],[4,"Import","","",null,null],[13,"SimpleImport","","",47,null],[13,"GlobImport","","",47,null],[13,"ImportList","","",47,null],[6,"Visibility","","",null,null],[7,"SCHEMA_VERSION","","A stable identifier to the particular version of JSON output.\nIncrement this when the `Crate` and related structures change.",null,null],[8,"Clean","","",null,null],[10,"clean","","",48,{"inputs":[{"name":"clean"},{"name":"doccontext"}],"output":{"name":"t"}}],[11,"clean","rustc::middle::subst","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"doccontext"}],"output":{"name":"vecperparamspace"}}],[11,"clean","syntax::ptr","",50,{"inputs":[{"name":"p"},{"name":"doccontext"}],"output":{"name":"u"}}],[11,"clean","alloc::rc","",51,{"inputs":[{"name":"rc"},{"name":"doccontext"}],"output":{"name":"u"}}],[11,"clean","core::option","",52,{"inputs":[{"name":"option"},{"name":"doccontext"}],"output":{"name":"option"}}],[11,"clean","rustc::middle::ty","",53,{"inputs":[{"name":"binder"},{"name":"doccontext"}],"output":{"name":"u"}}],[11,"clean","syntax::owned_slice","",54,{"inputs":[{"name":"ownedslice"},{"name":"doccontext"}],"output":{"name":"vec"}}],[11,"fmt","rustdoc::clean","",1,{"inputs":[{"name":"crate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",1,{"inputs":[{"name":"crate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",1,{"inputs":[{"name":"crate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",1,{"inputs":[{"name":"crate"}],"output":{"name":"crate"}}],[11,"fmt","","",2,{"inputs":[{"name":"externalcrate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",2,{"inputs":[{"name":"externalcrate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",2,{"inputs":[{"name":"externalcrate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",2,{"inputs":[{"name":"externalcrate"}],"output":{"name":"externalcrate"}}],[11,"clean","rustc::metadata::cstore","",55,{"inputs":[{"name":"crate_metadata"},{"name":"doccontext"}],"output":{"name":"externalcrate"}}],[11,"fmt","rustdoc::clean","",3,{"inputs":[{"name":"item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",3,{"inputs":[{"name":"item"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",3,{"inputs":[{"name":"item"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",3,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"doc_list","","Finds the `doc` attribute as a List and returns the list of attributes\nnested inside.",3,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"doc_value","","Finds the `doc` attribute as a NameValue and returns the corresponding\nvalue found.",3,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"is_hidden_from_doc","","",3,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_mod","","",3,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_trait","","",3,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_struct","","",3,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_enum","","",3,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_fn","","",3,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"fmt","","",33,{"inputs":[{"name":"itemenum"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",33,{"inputs":[{"name":"itemenum"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",33,{"inputs":[{"name":"itemenum"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",33,{"inputs":[{"name":"itemenum"}],"output":{"name":"itemenum"}}],[11,"fmt","","",4,{"inputs":[{"name":"module"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",4,{"inputs":[{"name":"module"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",4,{"inputs":[{"name":"module"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",4,{"inputs":[{"name":"module"}],"output":{"name":"module"}}],[11,"fmt","","",34,{"inputs":[{"name":"attribute"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",34,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"decode","","",34,{"inputs":[{"name":"attribute"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"attribute"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",34,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clean","","",56,{"inputs":[{"name":"metaitem"},{"name":"doccontext"}],"output":{"name":"attribute"}}],[11,"clean","","",57,{"inputs":[{"name":"attribute"},{"name":"doccontext"}],"output":{"name":"attribute"}}],[11,"name","","",34,{"inputs":[{"name":"attribute"}],"output":{"name":"internedstring"}}],[11,"value_str","","",34,{"inputs":[{"name":"attribute"}],"output":{"name":"option"}}],[11,"meta_item_list","","",34,{"inputs":[{"name":"attribute"}],"output":{"name":"option"}}],[11,"span","","",34,{"inputs":[{"name":"attribute"}],"output":{"name":"span"}}],[11,"fmt","","",5,{"inputs":[{"name":"typaram"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",5,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"decode","","",5,{"inputs":[{"name":"typaram"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",5,{"inputs":[{"name":"typaram"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",5,{"inputs":[{"name":"typaram"}],"output":{"name":"typaram"}}],[11,"clean","syntax::ast","",58,{"inputs":[{"name":"typaram"},{"name":"doccontext"}],"output":{"name":"typaram"}}],[11,"clean","rustc::middle::ty","",59,{"inputs":[{"name":"typeparameterdef"},{"name":"doccontext"}],"output":{"name":"typaram"}}],[11,"fmt","rustdoc::clean","",35,{"inputs":[{"name":"typarambound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",35,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"decode","","",35,{"inputs":[{"name":"typarambound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",35,{"inputs":[{"name":"typarambound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",35,{"inputs":[{"name":"typarambound"}],"output":{"name":"typarambound"}}],[11,"clean","syntax::ast","",60,{"inputs":[{"name":"typarambound"},{"name":"doccontext"}],"output":{"name":"typarambound"}}],[11,"clean","rustc::middle::ty","",61,null],[11,"clean","","",62,{"inputs":[{"name":"builtinbound"},{"name":"doccontext"}],"output":{"name":"typarambound"}}],[11,"clean","","",63,{"inputs":[{"name":"traitref"},{"name":"doccontext"}],"output":{"name":"typarambound"}}],[11,"clean","","",64,{"inputs":[{"name":"parambounds"},{"name":"doccontext"}],"output":{"name":"vec"}}],[11,"clean","rustc::middle::subst","",65,{"inputs":[{"name":"substs"},{"name":"doccontext"}],"output":{"name":"option"}}],[11,"fmt","rustdoc::clean","",66,{"inputs":[{"name":"lifetime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",66,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"ne","","",66,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"decode","","",66,{"inputs":[{"name":"lifetime"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",66,{"inputs":[{"name":"lifetime"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",66,{"inputs":[{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"get_ref","","",66,{"inputs":[{"name":"lifetime"}],"output":{"name":"str"}}],[11,"statik","","",66,{"inputs":[{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"clean","syntax::ast","",67,{"inputs":[{"name":"lifetime"},{"name":"doccontext"}],"output":{"name":"lifetime"}}],[11,"clean","","",68,{"inputs":[{"name":"lifetimedef"},{"name":"doccontext"}],"output":{"name":"lifetime"}}],[11,"clean","rustc::middle::ty","",69,{"inputs":[{"name":"regionparameterdef"},{"name":"doccontext"}],"output":{"name":"lifetime"}}],[11,"clean","","",70,{"inputs":[{"name":"region"},{"name":"doccontext"}],"output":{"name":"option"}}],[11,"fmt","rustdoc::clean","",36,{"inputs":[{"name":"wherepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"decode","","",36,{"inputs":[{"name":"wherepredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",36,{"inputs":[{"name":"wherepredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",36,{"inputs":[{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"clean","syntax::ast","",71,{"inputs":[{"name":"wherepredicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","rustc::middle::ty","",72,{"inputs":[{"name":"predicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"doccontext"}],"output":{"name":"wherepredicate"}}],[11,"clean","","",77,{"inputs":[{"name":"projectionty"},{"name":"doccontext"}],"output":{"name":"type"}}],[11,"fmt","rustdoc::clean","",6,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",6,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"decode","","",6,{"inputs":[{"name":"generics"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",6,{"inputs":[{"name":"generics"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"clean","syntax::ast","",78,{"inputs":[{"name":"generics"},{"name":"doccontext"}],"output":{"name":"generics"}}],[11,"fmt","rustdoc::clean","",7,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",7,{"inputs":[{"name":"method"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",7,{"inputs":[{"name":"method"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",7,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"clean","syntax::ast","",79,{"inputs":[{"name":"methodsig"},{"name":"doccontext"}],"output":{"name":"method"}}],[11,"fmt","rustdoc::clean","",8,{"inputs":[{"name":"tymethod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",8,{"inputs":[{"name":"tymethod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",8,{"inputs":[{"name":"tymethod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",8,{"inputs":[{"name":"tymethod"}],"output":{"name":"tymethod"}}],[11,"clean","syntax::ast","",79,{"inputs":[{"name":"methodsig"},{"name":"doccontext"}],"output":{"name":"tymethod"}}],[11,"fmt","rustdoc::clean","",37,{"inputs":[{"name":"selfty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",37,{"inputs":[{"name":"selfty"},{"name":"selfty"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"selfty"},{"name":"selfty"}],"output":{"name":"bool"}}],[11,"decode","","",37,{"inputs":[{"name":"selfty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",37,{"inputs":[{"name":"selfty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",37,{"inputs":[{"name":"selfty"}],"output":{"name":"selfty"}}],[11,"clean","syntax::ast","",80,{"inputs":[{"name":"explicitself_"},{"name":"doccontext"}],"output":{"name":"selfty"}}],[11,"fmt","rustdoc::clean","",9,{"inputs":[{"name":"function"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",9,{"inputs":[{"name":"function"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",9,{"inputs":[{"name":"function"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"function"}],"output":{"name":"function"}}],[11,"fmt","","",10,{"inputs":[{"name":"fndecl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",10,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"decode","","",10,{"inputs":[{"name":"fndecl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",10,{"inputs":[{"name":"fndecl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",10,{"inputs":[{"name":"fndecl"}],"output":{"name":"fndecl"}}],[11,"fmt","","",11,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",11,{"inputs":[{"name":"arguments"},{"name":"arguments"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"arguments"},{"name":"arguments"}],"output":{"name":"bool"}}],[11,"decode","","",11,{"inputs":[{"name":"arguments"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",11,{"inputs":[{"name":"arguments"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",11,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"clean","syntax::ast","",81,{"inputs":[{"name":"fndecl"},{"name":"doccontext"}],"output":{"name":"fndecl"}}],[11,"clean","rustc::middle::ty","",82,{"inputs":[{"name":"fnoutput"},{"name":"doccontext"}],"output":{"name":"type"}}],[11,"fmt","rustdoc::clean","",12,{"inputs":[{"name":"argument"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"argument"},{"name":"argument"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"argument"},{"name":"argument"}],"output":{"name":"bool"}}],[11,"decode","","",12,{"inputs":[{"name":"argument"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",12,{"inputs":[{"name":"argument"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",12,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clean","syntax::ast","",83,{"inputs":[{"name":"arg"},{"name":"doccontext"}],"output":{"name":"argument"}}],[11,"fmt","rustdoc::clean","",38,{"inputs":[{"name":"functionretty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",38,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"decode","","",38,{"inputs":[{"name":"functionretty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",38,{"inputs":[{"name":"functionretty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",38,{"inputs":[{"name":"functionretty"}],"output":{"name":"functionretty"}}],[11,"clean","syntax::ast","",84,{"inputs":[{"name":"functionretty"},{"name":"doccontext"}],"output":{"name":"functionretty"}}],[11,"fmt","rustdoc::clean","",13,{"inputs":[{"name":"trait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",13,{"inputs":[{"name":"trait"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",13,{"inputs":[{"name":"trait"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",13,{"inputs":[{"name":"trait"}],"output":{"name":"trait"}}],[11,"clean","syntax::ast","",85,{"inputs":[{"name":"traitref"},{"name":"doccontext"}],"output":{"name":"type"}}],[11,"clean","","",86,{"inputs":[{"name":"polytraitref"},{"name":"doccontext"}],"output":{"name":"polytrait"}}],[11,"clean","","",87,{"inputs":[{"name":"traititem"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"clean","","",88,{"inputs":[{"name":"implitem"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"clean","rustc::middle::ty","",89,{"inputs":[{"name":"method"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"clean","","",90,{"inputs":[{"name":"implortraititem"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"fmt","rustdoc::clean","",14,{"inputs":[{"name":"polytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"polytrait"},{"name":"polytrait"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"polytrait"},{"name":"polytrait"}],"output":{"name":"bool"}}],[11,"decode","","",14,{"inputs":[{"name":"polytrait"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",14,{"inputs":[{"name":"polytrait"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",14,{"inputs":[{"name":"polytrait"}],"output":{"name":"polytrait"}}],[11,"fmt","","",39,{"inputs":[{"name":"type"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",39,{"inputs":[{"name":"type"},{"name":"type"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"type"},{"name":"type"}],"output":{"name":"bool"}}],[11,"decode","","",39,{"inputs":[{"name":"type"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",39,{"inputs":[{"name":"type"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",39,{"inputs":[{"name":"type"}],"output":{"name":"type"}}],[11,"fmt","","",40,{"inputs":[{"name":"primitivetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",40,null],[11,"eq","","",40,{"inputs":[{"name":"primitivetype"},{"name":"primitivetype"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"primitivetype"},{"name":"primitivetype"}],"output":{"name":"bool"}}],[11,"decode","","",40,{"inputs":[{"name":"primitivetype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",40,{"inputs":[{"name":"primitivetype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",40,{"inputs":[{"name":"primitivetype"}],"output":{"name":"primitivetype"}}],[11,"fmt","","",41,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",41,{"inputs":[{"name":"typekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",41,{"inputs":[{"name":"typekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",41,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"primitive_type","","",39,{"inputs":[{"name":"type"}],"output":{"name":"option"}}],[11,"to_string","","",40,{"inputs":[{"name":"primitivetype"}],"output":{"name":"str"}}],[11,"to_url_str","","",40,{"inputs":[{"name":"primitivetype"}],"output":{"name":"str"}}],[11,"to_node_id","","Creates a rustdoc-specific node id for primitive types.",40,{"inputs":[{"name":"primitivetype"}],"output":{"name":"nodeid"}}],[11,"clean","syntax::ast","",91,{"inputs":[{"name":"ty"},{"name":"doccontext"}],"output":{"name":"type"}}],[11,"clean","rustdoc::clean","",92,{"inputs":[{"name":"ty"},{"name":"doccontext"}],"output":{"name":"type"}}],[11,"fmt","","",42,{"inputs":[{"name":"structfield"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",42,{"inputs":[{"name":"structfield"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",42,{"inputs":[{"name":"structfield"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",42,{"inputs":[{"name":"structfield"}],"output":{"name":"structfield"}}],[11,"clean","","",93,{"inputs":[{"name":"structfield"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"clean","rustc::middle::ty","",94,{"inputs":[{"name":"field_ty"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"clean","syntax::ast","",95,{"inputs":[{"name":"visibility"},{"name":"doccontext"}],"output":{"name":"option"}}],[11,"fmt","rustdoc::clean","",15,{"inputs":[{"name":"struct"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",15,{"inputs":[{"name":"struct"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"struct"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",15,{"inputs":[{"name":"struct"}],"output":{"name":"struct"}}],[11,"fmt","","",16,{"inputs":[{"name":"variantstruct"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"variantstruct"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"variantstruct"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",16,{"inputs":[{"name":"variantstruct"}],"output":{"name":"variantstruct"}}],[11,"clean","syntax::ast","",96,{"inputs":[{"name":"structdef"},{"name":"doccontext"}],"output":{"name":"variantstruct"}}],[11,"fmt","rustdoc::clean","",17,{"inputs":[{"name":"enum"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"enum"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"enum"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",17,{"inputs":[{"name":"enum"}],"output":{"name":"enum"}}],[11,"fmt","","",18,{"inputs":[{"name":"variant"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",18,{"inputs":[{"name":"variant"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"variant"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",18,{"inputs":[{"name":"variant"}],"output":{"name":"variant"}}],[11,"clean","rustc::middle::ty","",97,{"inputs":[{"name":"variantinfo"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"fmt","rustdoc::clean","",43,{"inputs":[{"name":"variantkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",43,{"inputs":[{"name":"variantkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",43,{"inputs":[{"name":"variantkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",43,{"inputs":[{"name":"variantkind"}],"output":{"name":"variantkind"}}],[11,"clean","syntax::ast","",98,{"inputs":[{"name":"variantkind"},{"name":"doccontext"}],"output":{"name":"variantkind"}}],[11,"fmt","rustdoc::clean","",19,{"inputs":[{"name":"span"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"span"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",19,{"inputs":[{"name":"span"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",19,{"inputs":[{"name":"span"}],"output":{"name":"span"}}],[11,"clean","syntax::codemap","",99,{"inputs":[{"name":"span"},{"name":"doccontext"}],"output":{"name":"span"}}],[11,"fmt","rustdoc::clean","",20,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",20,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"decode","","",20,{"inputs":[{"name":"path"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",20,{"inputs":[{"name":"path"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",20,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"singleton","","",20,{"inputs":[{"name":"path"},{"name":"string"}],"output":{"name":"path"}}],[11,"clean","syntax::ast","",100,{"inputs":[{"name":"path"},{"name":"doccontext"}],"output":{"name":"path"}}],[11,"fmt","rustdoc::clean","",44,{"inputs":[{"name":"pathparameters"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",44,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"ne","","",44,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"decode","","",44,{"inputs":[{"name":"pathparameters"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",44,{"inputs":[{"name":"pathparameters"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",44,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"clean","syntax::ast","",101,{"inputs":[{"name":"pathparameters"},{"name":"doccontext"}],"output":{"name":"pathparameters"}}],[11,"fmt","rustdoc::clean","",21,{"inputs":[{"name":"pathsegment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",21,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"decode","","",21,{"inputs":[{"name":"pathsegment"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",21,{"inputs":[{"name":"pathsegment"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",21,{"inputs":[{"name":"pathsegment"}],"output":{"name":"pathsegment"}}],[11,"clean","syntax::ast","",102,{"inputs":[{"name":"pathsegment"},{"name":"doccontext"}],"output":{"name":"pathsegment"}}],[11,"clean","","",103,{"inputs":[{"name":"ident"},{"name":"doccontext"}],"output":{"name":"string"}}],[11,"clean","","",104,{"inputs":[{"name":"name"},{"name":"doccontext"}],"output":{"name":"string"}}],[11,"fmt","rustdoc::clean","",22,{"inputs":[{"name":"typedef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",22,{"inputs":[{"name":"typedef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"typedef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"typedef"}],"output":{"name":"typedef"}}],[11,"fmt","","",23,{"inputs":[{"name":"barefunctiondecl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",23,{"inputs":[{"name":"barefunctiondecl"},{"name":"barefunctiondecl"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"barefunctiondecl"},{"name":"barefunctiondecl"}],"output":{"name":"bool"}}],[11,"decode","","",23,{"inputs":[{"name":"barefunctiondecl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"barefunctiondecl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"barefunctiondecl"}],"output":{"name":"barefunctiondecl"}}],[11,"clean","syntax::ast","",105,{"inputs":[{"name":"barefnty"},{"name":"doccontext"}],"output":{"name":"barefunctiondecl"}}],[11,"fmt","rustdoc::clean","",24,{"inputs":[{"name":"static"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"static"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",24,{"inputs":[{"name":"static"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"static"}],"output":{"name":"static"}}],[11,"fmt","","",25,{"inputs":[{"name":"constant"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",25,{"inputs":[{"name":"constant"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",25,{"inputs":[{"name":"constant"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"constant"}],"output":{"name":"constant"}}],[11,"eq","","",45,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"ne","","",45,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"decode","","",45,{"inputs":[{"name":"mutability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",45,{"inputs":[{"name":"mutability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",45,{"inputs":[{"name":"mutability"}],"output":{"name":"mutability"}}],[11,"fmt","","",45,{"inputs":[{"name":"mutability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clean","syntax::ast","",106,{"inputs":[{"name":"mutability"},{"name":"doccontext"}],"output":{"name":"mutability"}}],[11,"fmt","rustdoc::clean","",46,{"inputs":[{"name":"implpolarity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",46,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"ne","","",46,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"decode","","",46,{"inputs":[{"name":"implpolarity"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",46,{"inputs":[{"name":"implpolarity"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",46,{"inputs":[{"name":"implpolarity"}],"output":{"name":"implpolarity"}}],[11,"clean","syntax::ast","",107,{"inputs":[{"name":"implpolarity"},{"name":"doccontext"}],"output":{"name":"implpolarity"}}],[11,"fmt","rustdoc::clean","",26,{"inputs":[{"name":"impl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",26,{"inputs":[{"name":"impl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",26,{"inputs":[{"name":"impl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",26,{"inputs":[{"name":"impl"}],"output":{"name":"impl"}}],[11,"fmt","","",27,{"inputs":[{"name":"defaultimpl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",27,{"inputs":[{"name":"defaultimpl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",27,{"inputs":[{"name":"defaultimpl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",27,{"inputs":[{"name":"defaultimpl"}],"output":{"name":"defaultimpl"}}],[11,"fmt","","",47,{"inputs":[{"name":"import"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",47,{"inputs":[{"name":"import"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",47,{"inputs":[{"name":"import"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",47,{"inputs":[{"name":"import"}],"output":{"name":"import"}}],[11,"fmt","","",28,{"inputs":[{"name":"importsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",28,{"inputs":[{"name":"importsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",28,{"inputs":[{"name":"importsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",28,{"inputs":[{"name":"importsource"}],"output":{"name":"importsource"}}],[11,"fmt","","",29,{"inputs":[{"name":"viewlistident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",29,{"inputs":[{"name":"viewlistident"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",29,{"inputs":[{"name":"viewlistident"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",29,{"inputs":[{"name":"viewlistident"}],"output":{"name":"viewlistident"}}],[11,"clean","","",108,{"inputs":[{"name":"pathlistitem"},{"name":"doccontext"}],"output":{"name":"viewlistident"}}],[11,"clean","syntax::ast","",109,{"inputs":[{"name":"foreignmod"},{"name":"doccontext"}],"output":{"name":"vec"}}],[11,"clean","","",110,{"inputs":[{"name":"foreignitem"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"fmt","rustdoc::clean","",30,{"inputs":[{"name":"macro"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",30,{"inputs":[{"name":"macro"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",30,{"inputs":[{"name":"macro"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",30,{"inputs":[{"name":"macro"}],"output":{"name":"macro"}}],[11,"fmt","","",31,{"inputs":[{"name":"stability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",31,{"inputs":[{"name":"stability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",31,{"inputs":[{"name":"stability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",31,{"inputs":[{"name":"stability"}],"output":{"name":"stability"}}],[11,"clean","syntax::attr","",111,{"inputs":[{"name":"stability"},{"name":"doccontext"}],"output":{"name":"stability"}}],[11,"clean","rustc::middle::ty","",112,{"inputs":[{"name":"associatedtype"},{"name":"doccontext"}],"output":{"name":"item"}}],[11,"fmt","rustdoc::clean","",32,{"inputs":[{"name":"typebinding"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",32,{"inputs":[{"name":"typebinding"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",32,{"inputs":[{"name":"typebinding"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",32,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"clone","","",32,{"inputs":[{"name":"typebinding"}],"output":{"name":"typebinding"}}],[11,"clean","syntax::ast","",113,{"inputs":[{"name":"typebinding"},{"name":"doccontext"}],"output":{"name":"typebinding"}}],[0,"core","rustdoc","",null,null],[11,"filestem","rustc::session::config","",114,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[11,"fmt","rustc_back::svh","",115,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",115,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",115,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",115,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",115,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",115,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",115,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",115,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","rustc_back::svh::svh_visitor","",116,null],[11,"hash","","",117,null],[11,"hash","","",118,null],[11,"get_content","syntax::ast","",103,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"get_content","","",104,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[11,"visit_mac","rustc_back::svh::svh_visitor","",119,null],[11,"visit_struct_def","","",119,null],[11,"visit_variant","","",119,null],[11,"visit_opt_lifetime_ref","","",119,null],[11,"visit_ident","","",119,null],[11,"visit_lifetime_ref","","",119,null],[11,"visit_lifetime_def","","",119,null],[11,"visit_expr","","",119,null],[11,"visit_stmt","","",119,null],[11,"visit_foreign_item","","",119,null],[11,"visit_item","","",119,null],[11,"visit_mod","","",119,null],[11,"visit_decl","","",119,null],[11,"visit_ty","","",119,null],[11,"visit_generics","","",119,null],[11,"visit_fn","","",119,null],[11,"visit_trait_item","","",119,null],[11,"visit_impl_item","","",119,null],[11,"visit_struct_field","","",119,null],[11,"visit_explicit_self","","",119,null],[11,"visit_path","","",119,null],[11,"visit_block","","",119,null],[11,"visit_pat","","",119,null],[11,"visit_local","","",119,null],[11,"visit_arm","","",119,null],[11,"open","rustc_back::archive","Opens an existing static archive",120,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",120,null],[11,"files","","Lists all files in an archive",120,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",120,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",121,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",121,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",121,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",121,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",121,null],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",121,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[11,"tr_id","rustc::middle::astencode","Translates an internal id, meaning a node id that is known to refer to some part of the\nitem currently being inlined, such as a local variable or argument.  All naked node-ids\nthat appear in types have this property, since if something might refer to an external item\nwe would use a def-id to allow for the possibility that the item resides in another crate.",122,{"inputs":[{"name":"decodecontext"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"tr_def_id","","Translates an EXTERNAL def-id, converting the crate number from the one used in the encoded\ndata to the current crate numbers..  By external, I mean that it be translated to a\nreference to the item in its original crate, as opposed to being translated to a reference\nto the inlined version of the item.  This is typically, but not always, what you want,\nbecause most def-ids refer to external things like types or other fns that may or may not\nbe inlined.  Note that even when the inlined function is referencing itself recursively, we\nwould want `tr_def_id` for that reference--- conceptually the function calls the original,\nnon-inlined version, and trans deals with linking that recursive call to the inlined copy.",122,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_intern_def_id","","Translates an INTERNAL def-id, meaning a def-id that is\nknown to refer to some part of the item currently being\ninlined.  In that case, we want to convert the def-id to\nrefer to the current crate and to the new, inlined node-id.",122,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_span","","Translates a `Span` from an extern crate to the corresponding `Span`\nwithin the local crate's codemap. `creader::import_codemap()` will\nalready have allocated any additionally needed FileMaps in the local\ncodemap as a side-effect of creating the crate_metadata's\n`codemap_import_info`.",122,{"inputs":[{"name":"decodecontext"},{"name":"span"}],"output":{"name":"span"}}],[11,"tr_intern","syntax::ast","",123,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","","",123,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","core::option","",52,{"inputs":[{"name":"option"},{"name":"decodecontext"}],"output":{"name":"option"}}],[11,"tr","syntax::codemap","",99,{"inputs":[{"name":"span"},{"name":"decodecontext"}],"output":{"name":"span"}}],[11,"fold_block","rustc::middle::astencode","",124,{"inputs":[{"name":"nesteditemsdropper"},{"name":"p"}],"output":{"name":"p"}}],[11,"tr","rustc::middle::def","",125,{"inputs":[{"name":"def"},{"name":"decodecontext"}],"output":{"name":"def"}}],[11,"tr","rustc::middle::ty","",70,{"inputs":[{"name":"region"},{"name":"decodecontext"}],"output":{"name":"region"}}],[11,"tr","","",126,{"inputs":[{"name":"freeregion"},{"name":"decodecontext"}],"output":{"name":"freeregion"}}],[11,"tr","rustc::middle::region","",127,{"inputs":[{"name":"codeextent"},{"name":"decodecontext"}],"output":{"name":"codeextent"}}],[11,"tr","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"decodecontext"}],"output":{"name":"destructionscopedata"}}],[11,"tr","rustc::middle::ty","",129,{"inputs":[{"name":"boundregion"},{"name":"decodecontext"}],"output":{"name":"boundregion"}}],[11,"read_freevar_entry","rbml::reader","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"read_capture_mode","","",130,{"inputs":[{"name":"decoder"}],"output":{"name":"captureclause"}}],[11,"tr","rustc::middle::ty","",131,{"inputs":[{"name":"freevar"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"tr","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"decodecontext"}],"output":{"name":"upvarborrow"}}],[11,"tr","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"decodecontext"}],"output":{"name":"upvarcapture"}}],[11,"read_method_callee","rbml::reader","",130,null],[11,"tr","rustc::middle::ty","",134,{"inputs":[{"name":"methodorigin"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_vec_per_param_space","rbml::reader","",130,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_res_with_key","","",130,null],[11,"read_vtable_res","","",130,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_param_res","","",130,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_vtable_origin","","",130,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[11,"ty_str_ctxt","rustc::metadata::encoder","",135,{"inputs":[{"name":"encodecontext"}],"output":{"name":"ctxt"}}],[11,"emit_closure_type","rbml::writer","",136,null],[11,"emit_method_origin","","",136,null],[11,"emit_ty","","",136,null],[11,"emit_tys","","",136,null],[11,"emit_trait_ref","","",136,null],[11,"emit_type_param_def","","",136,null],[11,"emit_predicate","","",136,null],[11,"emit_type_scheme","","",136,null],[11,"emit_existential_bounds","","",136,null],[11,"emit_builtin_bounds","","",136,null],[11,"emit_substs","","",136,null],[11,"emit_auto_adjustment","","",136,null],[11,"emit_autoref","","",136,null],[11,"emit_auto_deref_ref","","",136,null],[11,"tag","","",136,null],[11,"id","","",136,null],[11,"visit_id","rustc::middle::astencode","",137,null],[11,"as_int","rbml","",138,{"inputs":[{"name":"doc"}],"output":{"name":"isize"}}],[11,"opt_child","","",138,{"inputs":[{"name":"doc"},{"name":"astencode_tag"}],"output":{"name":"option"}}],[11,"read_ty_nodcx","rbml::reader","",130,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[11,"read_tys_nodcx","","",130,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_substs_nodcx","","",130,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"substs"}}],[11,"read_method_origin","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_ty","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"tys"}}],[11,"read_tys","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"vec"}}],[11,"read_trait_ref","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"rc"}}],[11,"read_poly_trait_ref","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"binder"}}],[11,"read_type_param_def","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typeparameterdef"}}],[11,"read_predicate","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"predicate"}}],[11,"read_type_scheme","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typescheme"}}],[11,"read_existential_bounds","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"existentialbounds"}}],[11,"read_substs","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"substs"}}],[11,"read_auto_adjustment","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoadjustment"}}],[11,"read_auto_deref_ref","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoderefref"}}],[11,"read_autoref","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoref"}}],[11,"read_closure_kind","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurekind"}}],[11,"read_closure_ty","","",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurety"}}],[11,"convert_def_id","","Converts a def-id that appears in a type.  The correct\ntranslation will depend on what kind of def-id this is.\nThis is a subtle point: type definitions are not\ninlined into the current crate, so if the def-id names\na nominal type or type alias, then it should be\ntranslated to refer to the source crate.",130,{"inputs":[{"name":"decoder"},{"name":"decodecontext"},{"name":"defidsource"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"clone","rustc::middle::cfg::construct","",139,{"inputs":[{"name":"loopscope"}],"output":{"name":"loopscope"}}],[11,"graph_id","rustc::middle::cfg::graphviz","",140,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"id"}}],[11,"node_id","","",140,null],[11,"node_label","","",140,null],[11,"edge_label","","",140,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",140,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"edges","","",140,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"source","","",140,null],[11,"target","","",140,null],[11,"eq","rustc::middle::cfg","",141,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"cfgnodedata"}}],[11,"id","","",141,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"u32"}}],[11,"new","","",142,{"inputs":[{"name":"cfg"},{"name":"ctxt"},{"name":"block"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",142,{"inputs":[{"name":"cfg"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"hash","rustc::middle::check_const","",143,null],[11,"cmp","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"option"}}],[11,"lt","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"le","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"gt","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ge","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"clone","","",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ne","","",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"decode","","",143,{"inputs":[{"name":"constqualif"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",143,{"inputs":[{"name":"constqualif"},{"name":"__s"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"all","","Returns the set containing all flags.",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",143,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",143,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"constqualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",143,null],[11,"remove","","Removes the specified flags in-place.",143,null],[11,"toggle","","Toggles the specified flags in-place.",143,null],[6,"Output","rustdoc::core","",null,null],[11,"bitor","rustc::middle::check_const","Returns the union of the two sets of flags.",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitxor","rustc::middle::check_const","Returns the left flags, but with all the right flags toggled.",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitand","rustc::middle::check_const","Returns the intersection between the two sets of flags.",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustdoc::core","",null,null],[11,"sub","rustc::middle::check_const","Returns the set difference of the two sets of flags.",143,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustdoc::core","",null,null],[11,"not","rustc::middle::check_const","Returns the complement of this set of flags.",143,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",144,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"ne","","",144,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"clone","","",144,{"inputs":[{"name":"mode"}],"output":{"name":"mode"}}],[11,"visit_item","","",145,null],[11,"visit_fn","","",145,null],[11,"visit_pat","","",145,null],[11,"visit_expr","","",145,null],[11,"consume","","",145,null],[11,"borrow","","",145,null],[11,"decl_without_init","","",145,null],[11,"mutate","","",145,null],[11,"matched_pat","","",145,null],[11,"consume_pat","","",145,null],[11,"visit_item","rustc::middle::check_static_recursion","",146,null],[11,"visit_item","","",147,null],[11,"visit_expr","","",147,null],[11,"eq","rustc::middle::check_loop","",148,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",148,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"clone","","",148,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"clone","","",149,{"inputs":[{"name":"checkloopvisitor"}],"output":{"name":"checkloopvisitor"}}],[11,"visit_item","","",149,null],[11,"visit_expr","","",149,null],[11,"fmt","rustc::middle::check_match","",150,{"inputs":[{"name":"matrix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",150,{"inputs":[{"name":"matrix"},{"name":"t"}],"output":{"name":"matrix"}}],[11,"eq","","",151,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"clone","","",151,{"inputs":[{"name":"constructor"}],"output":{"name":"constructor"}}],[11,"eq","","",152,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"usefulness"}],"output":{"name":"usefulness"}}],[11,"clone","","",153,{"inputs":[{"name":"witnesspreference"}],"output":{"name":"witnesspreference"}}],[11,"visit_expr","","",154,null],[11,"visit_local","","",154,null],[11,"visit_fn","","",154,null],[11,"new","","",155,{"inputs":[{"name":"staticinliner"},{"name":"ctxt"},{"name":"option"}],"output":{"name":"staticinliner"}}],[11,"visit_id","","",156,null],[11,"fold_pat","","",155,{"inputs":[{"name":"staticinliner"},{"name":"p"}],"output":{"name":"p"}}],[11,"matched_pat","","",157,null],[11,"consume","","",157,null],[11,"consume_pat","","",157,null],[11,"borrow","","",157,null],[11,"decl_without_init","","",157,null],[11,"mutate","","",157,null],[11,"visit_pat","","",158,null],[11,"visit_fn","rustc::middle::check_rvalues","",159,null],[11,"consume","","",160,null],[11,"matched_pat","","",160,null],[11,"consume_pat","","",160,null],[11,"borrow","","",160,null],[11,"decl_without_init","","",160,null],[11,"mutate","","",160,null],[11,"eq","rustc::middle::const_eval","",161,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"ne","","",161,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"clone","","",161,{"inputs":[{"name":"const_val"}],"output":{"name":"const_val"}}],[11,"clone","","",162,{"inputs":[{"name":"constevalerr"}],"output":{"name":"constevalerr"}}],[11,"clone","","",163,{"inputs":[{"name":"errkind"}],"output":{"name":"errkind"}}],[11,"description","","",162,{"inputs":[{"name":"constevalerr"}],"output":{"name":"cow"}}],[11,"fmt","","",164,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",164,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",164,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",164,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",165,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",165,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",165,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",165,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"from","","",164,{"inputs":[{"name":"intty"},{"name":"ctxt"},{"name":"intty"}],"output":{"name":"intty"}}],[11,"from","","",165,{"inputs":[{"name":"uintty"},{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"fmt","rustc::middle::dataflow","",166,{"inputs":[{"name":"entryorexit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",166,{"inputs":[{"name":"entryorexit"}],"output":{"name":"entryorexit"}}],[11,"clone","","",167,{"inputs":[{"name":"dataflowcontext"}],"output":{"name":"dataflowcontext"}}],[11,"pre","","",167,{"inputs":[{"name":"dataflowcontext"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"fmt","","",168,{"inputs":[{"name":"killfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",168,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"ne","","",168,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"clone","","",168,{"inputs":[{"name":"killfrom"}],"output":{"name":"killfrom"}}],[11,"new","","",167,{"inputs":[{"name":"dataflowcontext"},{"name":"ctxt"},{"name":"str"},{"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",167,null],[11,"add_kill","","Indicates that `id` kills `bit`",167,null],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`.\nOnly useful after `propagate()` has been called.",167,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`.\nOnly useful after `propagate()` has been called.",167,{"inputs":[{"name":"dataflowcontext"},{"name":"entryorexit"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",167,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow\nexits through any number of enclosing scopes on its way to\nthe new destination. This function infers the kill bits of\nthose control operators based on the kill bits associated\nwith those scopes.",167,null],[11,"propagate","","Performs the data flow analysis.",167,null],[11,"join","","",169,{"inputs":[{"name":"union"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",170,{"inputs":[{"name":"subtract"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"visit_struct_def","rustc::middle::dead","",171,null],[11,"visit_expr","","",171,null],[11,"visit_pat","","",171,null],[11,"visit_path","","",171,null],[11,"visit_item","","",171,null],[11,"visit_item","","",172,null],[11,"visit_item","","",173,null],[11,"visit_foreign_item","","",173,null],[11,"visit_fn","","",173,null],[11,"visit_struct_field","","",173,null],[11,"visit_trait_item","","",173,null],[11,"fmt","rustc::middle::def","",125,{"inputs":[{"name":"def"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",125,null],[11,"decode","","",125,{"inputs":[{"name":"def"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",125,{"inputs":[{"name":"def"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",125,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"def"}],"output":{"name":"def"}}],[11,"fmt","","",174,{"inputs":[{"name":"pathresolution"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",174,{"inputs":[{"name":"pathresolution"}],"output":{"name":"pathresolution"}}],[11,"full_def","","Get the definition, if fully resolved, otherwise panic.",174,{"inputs":[{"name":"pathresolution"}],"output":{"name":"def"}}],[11,"def_id","","Get the DefId, if fully resolved, otherwise panic.",174,{"inputs":[{"name":"pathresolution"}],"output":{"name":"defid"}}],[11,"new","","",174,{"inputs":[{"name":"pathresolution"},{"name":"def"},{"name":"lastprivate"},{"name":"usize"}],"output":{"name":"pathresolution"}}],[11,"clone","","",175,{"inputs":[{"name":"export"}],"output":{"name":"export"}}],[11,"fmt","","",176,{"inputs":[{"name":"methodprovenance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",176,null],[11,"decode","","",176,{"inputs":[{"name":"methodprovenance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",176,{"inputs":[{"name":"methodprovenance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",176,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"ne","","",176,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"clone","","",176,{"inputs":[{"name":"methodprovenance"}],"output":{"name":"methodprovenance"}}],[11,"map","","",176,{"inputs":[{"name":"methodprovenance"},{"name":"f"}],"output":{"name":"methodprovenance"}}],[11,"local_node_id","","",125,{"inputs":[{"name":"def"}],"output":{"name":"u32"}}],[11,"def_id","","",125,{"inputs":[{"name":"def"}],"output":{"name":"defid"}}],[11,"variant_def_ids","","",125,{"inputs":[{"name":"def"}],"output":{"name":"option"}}],[11,"eq","rustc::middle::effect","",177,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"ne","","",177,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"clone","","",177,{"inputs":[{"name":"unsafecontext"}],"output":{"name":"unsafecontext"}}],[11,"visit_fn","","",178,null],[11,"visit_block","","",178,null],[11,"visit_expr","","",178,null],[11,"visit_item","rustc::middle::entry","",179,null],[11,"fmt","rustc::middle::expr_use_visitor","",180,{"inputs":[{"name":"loancause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",180,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",180,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"clone","","",180,{"inputs":[{"name":"loancause"}],"output":{"name":"loancause"}}],[11,"fmt","","",181,{"inputs":[{"name":"consumemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",181,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",181,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"clone","","",181,{"inputs":[{"name":"consumemode"}],"output":{"name":"consumemode"}}],[11,"fmt","","",182,{"inputs":[{"name":"movereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",182,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"ne","","",182,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"clone","","",182,{"inputs":[{"name":"movereason"}],"output":{"name":"movereason"}}],[11,"fmt","","",183,{"inputs":[{"name":"matchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",183,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"ne","","",183,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"clone","","",183,{"inputs":[{"name":"matchmode"}],"output":{"name":"matchmode"}}],[11,"fmt","","",184,{"inputs":[{"name":"trackmatchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",184,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"ne","","",184,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"clone","","",184,{"inputs":[{"name":"trackmatchmode"}],"output":{"name":"trackmatchmode"}}],[11,"fmt","","",185,{"inputs":[{"name":"mutatemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",185,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"clone","","",185,{"inputs":[{"name":"mutatemode"}],"output":{"name":"mutatemode"}}],[11,"clone","","",186,{"inputs":[{"name":"overloadedcalltype"}],"output":{"name":"overloadedcalltype"}}],[11,"new","","",187,{"inputs":[{"name":"exprusevisitor"},{"name":"delegate"},{"name":"typer"}],"output":{"name":"exprusevisitor"}}],[11,"walk_fn","","",187,null],[11,"consume_expr","","",187,null],[11,"walk_expr","","",187,null],[11,"hash","rustc::middle::fast_reject","",188,null],[11,"eq","","",188,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"ne","","",188,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"clone","","",188,{"inputs":[{"name":"simplifiedtype"}],"output":{"name":"simplifiedtype"}}],[11,"clone","rustc::middle::free_region","",189,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"new","","",189,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"relate_free_regions_from_implications","","",189,null],[11,"relate_free_regions_from_predicates","","",189,null],[11,"relate_free_regions","","",189,null],[11,"sub_free_region","","Determines whether two free regions have a subregion relationship\nby walking the graph encoded in `map`.  Note that\nit is possible that `sub != sup` and `sub <= sup` and `sup <= sub`\n(that is, the user can give two different names to the same lifetime).",189,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run *after\ninference* and sadly the logic is somewhat duplicated with the code in infer.rs.",189,{"inputs":[{"name":"freeregionmap"},{"name":"ctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","rustc::middle::graph","",190,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",191,{"inputs":[{"name":"nodeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",191,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",191,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"clone","","",191,{"inputs":[{"name":"nodeindex"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",192,{"inputs":[{"name":"edgeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",192,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",192,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"clone","","",192,{"inputs":[{"name":"edgeindex"}],"output":{"name":"edgeindex"}}],[11,"fmt","","",193,{"inputs":[{"name":"direction"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",193,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",191,{"inputs":[{"name":"nodeindex"}],"output":{"name":"usize"}}],[11,"edge_id","","Returns unique id (unique with respect to the graph holding associated edge).",192,{"inputs":[{"name":"edgeindex"}],"output":{"name":"usize"}}],[11,"new","","",194,{"inputs":[{"name":"graph"}],"output":{"name":"graph"}}],[11,"with_capacity","","",194,{"inputs":[{"name":"graph"},{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",194,null],[11,"all_edges","","",194,null],[11,"next_node_index","","",194,{"inputs":[{"name":"graph"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",194,{"inputs":[{"name":"graph"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",194,{"inputs":[{"name":"graph"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"mut_edge_data","","",194,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge_data","","",194,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge","","",194,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"first_adjacent","","Accesses the index of the first edge adjacent to `node`.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"next_adjacent","","Accesses the next edge in a given direction.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",194,{"inputs":[{"name":"graph"},{"name":"edgeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"each_node","","Iterates over all edges defined in the graph.",194,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_edge","","Iterates over all edges defined in the graph",194,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_outgoing_edge","","Iterates over all outgoing edges from the node `from`",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_incoming_edge","","Iterates over all incoming edges to the node `target`",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_adjacent_edge","","Iterates over all edges adjacent to the node `node`\nin the direction `dir` (either `Outgoing` or `Incoming)",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"},{"name":"f"}],"output":{"name":"bool"}}],[11,"iterate_until_fixed_point","","",194,null],[11,"depth_traverse","","",194,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"depthfirsttraversal"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::graph","",195,{"inputs":[{"name":"depthfirsttraversal"}],"output":{"name":"option"}}],[11,"source","","",190,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"target","","",190,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"visit_fn","rustc::middle::intrinsicck","",196,null],[11,"visit_expr","","",196,null],[11,"repr","rustc::middle::ty","",197,{"inputs":[{"name":"transmuterestriction"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","rustc::middle::infer::bivariate","",198,{"inputs":[{"name":"bivariate"},{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"tag","","",198,{"inputs":[{"name":"bivariate"}],"output":{"name":"str"}}],[11,"tcx","","",198,{"inputs":[{"name":"bivariate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",198,{"inputs":[{"name":"bivariate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",198,{"inputs":[{"name":"bivariate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",198,{"inputs":[{"name":"bivariate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",198,{"inputs":[{"name":"bivariate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",198,{"inputs":[{"name":"bivariate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"clone","rustc::middle::infer::combine","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"tcx","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"ctxt"}}],[11,"switch_expected","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"equate","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"bivariate","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"sub","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"lub","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"glb","","",199,{"inputs":[{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"instantiate","","",199,{"inputs":[{"name":"combinefields"},{"name":"tys"},{"name":"relationdir"},{"name":"tyvid"}],"output":{"name":"result"}}],[11,"tcx","","",200,{"inputs":[{"name":"generalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",200,{"inputs":[{"name":"generalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",200,{"inputs":[{"name":"generalizer"},{"name":"region"}],"output":{"name":"region"}}],[11,"compare","core::result","",201,{"inputs":[{"name":"result"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[11,"new","rustc::middle::infer::equate","",202,{"inputs":[{"name":"equate"},{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"tag","","",202,{"inputs":[{"name":"equate"}],"output":{"name":"str"}}],[11,"tcx","","",202,{"inputs":[{"name":"equate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",202,{"inputs":[{"name":"equate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",202,{"inputs":[{"name":"equate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",202,{"inputs":[{"name":"equate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",202,{"inputs":[{"name":"equate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",202,{"inputs":[{"name":"equate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"report_region_errors","rustc::middle::infer","",203,null],[11,"process_errors","","",203,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"report_type_error","","",203,null],[11,"report_and_explain_type_error","","",203,null],[11,"values_str","","Returns a string of the form \"expected `{}`, found `{}`\", or None if this is a derived\nerror.",203,{"inputs":[{"name":"inferctxt"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str","","",203,{"inputs":[{"name":"inferctxt"},{"name":"expected_found"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",203,null],[11,"report_concrete_failure","","",203,null],[11,"report_sub_sup_conflict","","",203,null],[11,"report_sup_sup_conflict","","",203,null],[11,"report_processed_errors","","",203,null],[11,"give_suggestion","","",203,null],[11,"give_expl_lifetime_param","","",203,null],[11,"report_inference_failure","","",203,null],[11,"note_region_origin","","",203,null],[11,"resolve","alloc::rc","",51,{"inputs":[{"name":"rc"},{"name":"inferctxt"}],"output":{"name":"rc"}}],[11,"contains_error","","",51,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"resolve","rustc::middle::ty","",53,{"inputs":[{"name":"binder"},{"name":"inferctxt"}],"output":{"name":"binder"}}],[11,"contains_error","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"new","rustc::middle::infer::glb","",204,{"inputs":[{"name":"glb"},{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"tag","","",204,{"inputs":[{"name":"glb"}],"output":{"name":"str"}}],[11,"tcx","","",204,{"inputs":[{"name":"glb"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",204,{"inputs":[{"name":"glb"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",204,{"inputs":[{"name":"glb"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",204,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",204,{"inputs":[{"name":"glb"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",204,{"inputs":[{"name":"glb"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",204,{"inputs":[{"name":"glb"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",204,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"higher_ranked_sub","rustc::middle::infer::combine","",199,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_lub","","",199,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_glb","","",199,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"tainted_regions","rustc::middle::infer","",203,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any\ntypes/regions which existed before `snapshot` was\nstarted. This is used in the sub/lub/glb computations. The\nidea here is that when we are computing lub/glb of two\nregions, we sometimes create intermediate region variables.\nThose region variables may touch some of the skolemized or\nother \"forbidden\" regions we created to replace bound\nregions, but they don't really represent an \"external\"\nconstraint.",203,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"}],"output":{"name":"vec"}}],[11,"new","rustc::middle::infer::lub","",205,{"inputs":[{"name":"lub"},{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"tag","","",205,{"inputs":[{"name":"lub"}],"output":{"name":"str"}}],[11,"tcx","","",205,{"inputs":[{"name":"lub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",205,{"inputs":[{"name":"lub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",205,{"inputs":[{"name":"lub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",205,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",205,{"inputs":[{"name":"lub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",205,{"inputs":[{"name":"lub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",205,{"inputs":[{"name":"lub"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",205,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::region_inference::graphviz","",206,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",206,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"ne","","",206,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"hash","","",206,null],[11,"clone","","",206,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",207,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",207,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",207,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"clone","","",207,{"inputs":[{"name":"edge"}],"output":{"name":"edge"}}],[11,"graph_id","","",208,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"id"}}],[11,"node_id","","",208,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",208,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",208,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",208,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"edges","","",208,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"source","","",208,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",208,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"fmt","rustc::middle::infer::region_inference","",209,{"inputs":[{"name":"constraint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",209,null],[11,"eq","","",209,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",209,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"clone","","",209,{"inputs":[{"name":"constraint"}],"output":{"name":"constraint"}}],[11,"eq","","",210,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",210,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"fmt","","",210,{"inputs":[{"name":"generickind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",210,{"inputs":[{"name":"generickind"}],"output":{"name":"generickind"}}],[11,"hash","","",211,null],[11,"eq","","",211,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",211,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"clone","","",211,{"inputs":[{"name":"tworegions"}],"output":{"name":"tworegions"}}],[11,"eq","","",212,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",212,{"inputs":[{"name":"undologentry"}],"output":{"name":"undologentry"}}],[11,"eq","","",213,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"clone","","",213,{"inputs":[{"name":"combinemaptype"}],"output":{"name":"combinemaptype"}}],[11,"fmt","","",214,{"inputs":[{"name":"regionresolutionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",214,{"inputs":[{"name":"regionresolutionerror"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",215,{"inputs":[{"name":"sameregions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",215,{"inputs":[{"name":"sameregions"}],"output":{"name":"sameregions"}}],[11,"contains","","",215,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"push","","",215,null],[11,"fmt","","",216,{"inputs":[{"name":"regionsnapshot"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"ctxt"}],"output":{"name":"regionvarbindings"}}],[11,"start_snapshot","","",217,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",217,null],[11,"rollback_to","","",217,null],[11,"num_vars","","",217,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"u32"}}],[11,"new_region_var","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"new_skolemized","","Creates a new skolemized region. Skolemized regions are fresh\nregions used when performing higher-ranked computations. They\nmust be used in a very particular way and are never supposed\nto \"escape\" out into error messages or the code at large.",217,{"inputs":[{"name":"regionvarbindings"},{"name":"boundregion"},{"name":"regionsnapshot"}],"output":{"name":"region"}}],[11,"new_bound","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_given","","",217,null],[11,"make_eqregion","","",217,null],[11,"make_subregion","","",217,null],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",217,null],[11,"lub_regions","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"resolve_var","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_vars","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"},{"name":"f"}],"output":{"name":"region"}}],[11,"vars_created_since_snapshot","","",217,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":{"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` in any way since the mark `mark` was\nmade---`r0` itself will be the first entry. This is used when checking whether skolemized\nregions are being improperly related to other regions.",217,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"resolve_regions","","This function performs the actual region resolution.  It must be\ncalled after all constraints have been added.  It performs a\nfixed-point iteration to find region values which satisfy all\nconstraints, assuming such values can be found; if they cannot,\nerrors are reported.",217,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregionmap"},{"name":"u32"}],"output":{"name":"vec"}}],[11,"fmt","","",218,{"inputs":[{"name":"classification"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",218,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"ne","","",218,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"clone","","",218,{"inputs":[{"name":"classification"}],"output":{"name":"classification"}}],[11,"clone","","",219,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"repr","","",209,{"inputs":[{"name":"constraint"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",220,{"inputs":[{"name":"verify"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",219,{"inputs":[{"name":"varvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",221,{"inputs":[{"name":"regionandorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",210,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",210,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"to_ty","","",210,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::resolve","",222,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"inferctxt"}],"output":{"name":"opportunistictyperesolver"}}],[11,"tcx","","",222,{"inputs":[{"name":"opportunistictyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",222,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"tcx","","",223,{"inputs":[{"name":"fulltyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",223,{"inputs":[{"name":"fulltyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",223,{"inputs":[{"name":"fulltyperesolver"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::infer::freshen","",224,{"inputs":[{"name":"typefreshener"},{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"tcx","","",224,{"inputs":[{"name":"typefreshener"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",224,{"inputs":[{"name":"typefreshener"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",224,{"inputs":[{"name":"typefreshener"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::sub","",225,{"inputs":[{"name":"sub"},{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"tag","","",225,{"inputs":[{"name":"sub"}],"output":{"name":"str"}}],[11,"tcx","","",225,{"inputs":[{"name":"sub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",225,{"inputs":[{"name":"sub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",225,{"inputs":[{"name":"sub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",225,{"inputs":[{"name":"sub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",225,{"inputs":[{"name":"sub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",225,{"inputs":[{"name":"sub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::type_variable","",226,{"inputs":[{"name":"relationdir"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",226,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"ne","","",226,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"clone","","",226,{"inputs":[{"name":"relationdir"}],"output":{"name":"relationdir"}}],[11,"new","","",227,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","",227,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"relate_vars","","Records that `a <: b`, `a :> b`, or `a == b`, depending on `dir`.",227,null],[11,"instantiate_and_push","","Instantiates `vid` with the type `ty` and then pushes an entry onto `stack` for each of the\nrelations of `vid` to other variables. The relations will have the form `(ty, dir, vid1)`\nwhere `vid1` is some other variable id.",227,null],[11,"new_var","","",227,{"inputs":[{"name":"typevariabletable"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"probe","","",227,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"option"}}],[11,"replace_if_possible","","",227,{"inputs":[{"name":"typevariabletable"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"snapshot","","",227,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","",227,null],[11,"commit","","",227,null],[11,"types_escaping_snapshot","","Find the set of type variables that existed *before* `s`\nbut which have only been unified since `s` started, and\nreturn the types with which they were unified. So if we had\na type variable `V0`, then we started the snapshot, then we\ncreated a type variable `V1`, unifed `V0` with `T0`, and\nunified `V1` with `T1`, this function would return `{T0}`.",227,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":{"name":"vec"}}],[6,"Value","rustdoc::core","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::type_variable","",228,null],[11,"fmt","rustc::middle::infer::unify","",229,{"inputs":[{"name":"varvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",229,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"eq","","",229,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",229,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","","",230,{"inputs":[{"name":"delegate"}],"output":{"name":"delegate"}}],[11,"new","","",231,{"inputs":[{"name":"unificationtable"}],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either\nrolled back or committed in a \"LIFO\" (stack) order.",231,{"inputs":[{"name":"unificationtable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also\nremoves any keys that have been created since then.",231,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",231,null],[11,"new_key","","",231,null],[6,"Value","rustdoc::core","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::unify","",230,null],[11,"unify_var_var","","",231,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"k"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`. Because simple keys do not have any subtyping\nrelationships, if `a_id` already has a value, it must be the same as `b`.",231,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"v"}],"output":{"name":"result"}}],[11,"has_value","","",231,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"bool"}}],[11,"probe","","",231,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"option"}}],[6,"Value","rustdoc::core","",null,null],[11,"index","rustc::middle::ty","",232,{"inputs":[{"name":"intvid"}],"output":{"name":"u32"}}],[11,"from_index","","",232,{"inputs":[{"name":"intvid"},{"name":"u32"}],"output":{"name":"intvid"}}],[11,"tag","","",232,{"inputs":[{"name":"intvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","","",233,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Value","rustdoc::core","",null,null],[11,"index","rustc::middle::ty","",234,{"inputs":[{"name":"floatvid"}],"output":{"name":"u32"}}],[11,"from_index","","",234,{"inputs":[{"name":"floatvid"},{"name":"u32"}],"output":{"name":"floatvid"}}],[11,"tag","","",234,{"inputs":[{"name":"floatvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","syntax::ast","",235,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"fmt","rustc::middle::infer","",236,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",236,{"inputs":[{"name":"typeorigin"}],"output":{"name":"typeorigin"}}],[11,"fmt","","",236,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",237,{"inputs":[{"name":"valuepairs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",237,{"inputs":[{"name":"valuepairs"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",238,{"inputs":[{"name":"typetrace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"typetrace"}],"output":{"name":"typetrace"}}],[11,"fmt","","",239,{"inputs":[{"name":"subregionorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",239,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",240,{"inputs":[{"name":"lateboundregionconversiontime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",240,{"inputs":[{"name":"lateboundregionconversiontime"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",241,{"inputs":[{"name":"regionvariableorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",241,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",242,{"inputs":[{"name":"fixup_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",242,{"inputs":[{"name":"fixup_err"}],"output":{"name":"fixup_err"}}],[11,"freshen","","",203,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",203,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"freshener","","",203,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",203,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"unconstrainednumeric"}}],[11,"equate","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"equate"}}],[11,"sub","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"sub"}}],[11,"lub","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"lub"}}],[11,"glb","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"glb"}}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",203,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",203,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"commit_regions_if_ok","","Execute `f` and commit only the region bindings if successful.\nThe function f must be very careful not to leak any non-region\nvariables that get created.",203,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",203,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",203,null],[11,"sub_types","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"eq_types","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"sub_trait_refs","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"sub_poly_trait_refs","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"construct_skolemized_subst","","See `higher_ranked::construct_skolemized_subst`",203,null],[11,"skolemize_late_bound_regions","","See `higher_ranked::skolemize_late_bound_regions`",203,null],[11,"leak_check","","See `higher_ranked::leak_check`",203,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"}],"output":{"name":"result"}}],[11,"plug_leaks","","See `higher_ranked::plug_leaks`",203,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"equality_predicate","","",203,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"region_outlives_predicate","","",203,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"next_ty_var_id","","",203,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",203,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_diverging_ty_var","","",203,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_ty_vars","","",203,{"inputs":[{"name":"inferctxt"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"next_int_var_id","","",203,{"inputs":[{"name":"inferctxt"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",203,{"inputs":[{"name":"inferctxt"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","",203,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"region_vars_for_defs","","",203,null],[11,"fresh_substs_for_generics","","Given a set of generics defined on a type or impl, returns a substitution mapping each\ntype/region parameter to a fresh inference variable.",203,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"fresh_substs_for_trait","","Given a set of generics defined on a trait, returns a substitution mapping each output\ntype/region parameter to a fresh inference variable, and mapping the self type to\n`self_ty`.",203,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"fresh_bound_region","","",203,{"inputs":[{"name":"inferctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"resolve_regions_and_report_errors","","",203,null],[11,"ty_to_string","","",203,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"string"}}],[11,"tys_to_string","","",203,null],[11,"trait_ref_to_string","","",203,{"inputs":[{"name":"inferctxt"},{"name":"rc"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",203,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in\n`value` with their final value. Note that region variables\nare unaffected. If a type variable has not been unified, it\nis left as is.  This is an idempotent operation that does\nnot affect inference state in any way and so you can do it\nat will.",203,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in\n`value`. Region inference must have been run already (e.g.,\nby calling `resolve_regions_and_report_errors`).  If some\nvariable was never unified, an `Err` results.",203,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[11,"type_error_message_str","","",203,null],[11,"type_error_message_str_with_expected","","",203,null],[11,"type_error_message","","",203,null],[11,"report_mismatched_types","","",203,null],[11,"replace_late_bound_regions_with_fresh_var","","",203,null],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_inference`",203,null],[11,"can_equate","","",203,{"inputs":[{"name":"inferctxt"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"span","","",238,{"inputs":[{"name":"typetrace"}],"output":{"name":"span"}}],[11,"types","","",238,{"inputs":[{"name":"typetrace"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"typetrace"}}],[11,"dummy","","",238,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"typetrace"}}],[11,"repr","","",238,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",236,{"inputs":[{"name":"typeorigin"}],"output":{"name":"span"}}],[11,"repr","","",236,{"inputs":[{"name":"typeorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",239,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"span"}}],[11,"repr","","",239,{"inputs":[{"name":"subregionorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",241,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"span"}}],[11,"repr","","",241,{"inputs":[{"name":"regionvariableorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::implicator","",243,{"inputs":[{"name":"implication"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"hash","rustc::middle::lang_items","",244,null],[11,"eq","","",244,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"ne","","",244,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"clone","","",244,{"inputs":[{"name":"langitem"}],"output":{"name":"langitem"}}],[11,"from_u32","","",244,{"inputs":[{"name":"langitem"},{"name":"u32"}],"output":{"name":"option"}}],[11,"new","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"languageitems"}}],[11,"items","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"enumerate"}}],[11,"item_name","","",245,{"inputs":[{"name":"languageitems"},{"name":"usize"}],"output":{"name":"str"}}],[11,"require","","",245,{"inputs":[{"name":"languageitems"},{"name":"langitem"}],"output":{"name":"result"}}],[11,"from_builtin_kind","","",245,{"inputs":[{"name":"languageitems"},{"name":"builtinbound"}],"output":{"name":"result"}}],[11,"to_builtin_kind","","",245,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"fn_trait_kind","","",245,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"char_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"slice_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"const_ptr_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mut_ptr_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i8_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i16_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i32_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i64_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"isize_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u8_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u16_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u32_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u64_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"usize_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f32_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f64_impl","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"send_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sized_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"copy_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sync_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"drop_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"add_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sub_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mul_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"div_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"rem_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"neg_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"not_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitxor_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitand_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitor_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shl_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shr_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_mut_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_struct","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_from_struct","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_to_struct","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_full_struct","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"unsafe_cell_type","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_mut_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_mut_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_once_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eq_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"ord_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_eq_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_bounds_check_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fmt","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_malloc_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_free_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"strdup_uniq_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"start_fn","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eh_personality","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_heap","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"owned_box","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"phantom_data","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_type","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_type","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_type","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_lifetime","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_lifetime","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_lifetime","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"no_copy_bound","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"managed_bound","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"non_zero","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"stack_exhausted","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"debug_trait","","",245,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"visit_item","","",246,null],[11,"new","","",246,{"inputs":[{"name":"languageitemcollector"},{"name":"session"}],"output":{"name":"languageitemcollector"}}],[11,"collect_item","","",246,null],[11,"collect_local_language_items","","",246,null],[11,"collect_external_language_items","","",246,null],[11,"collect","","",246,null],[11,"eq","rustc::middle::liveness","",247,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"ne","","",247,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"clone","","",247,{"inputs":[{"name":"variable"}],"output":{"name":"variable"}}],[11,"eq","","",248,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"ne","","",248,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"clone","","",248,{"inputs":[{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"fmt","","",249,{"inputs":[{"name":"livenodekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",249,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"ne","","",249,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"clone","","",249,{"inputs":[{"name":"livenodekind"}],"output":{"name":"livenodekind"}}],[11,"visit_fn","","",250,null],[11,"visit_local","","",250,null],[11,"visit_expr","","",250,null],[11,"visit_arm","","",250,null],[11,"fmt","","",248,{"inputs":[{"name":"livenode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",247,{"inputs":[{"name":"variable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",251,{"inputs":[{"name":"localinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",251,{"inputs":[{"name":"localinfo"}],"output":{"name":"localinfo"}}],[11,"fmt","","",252,{"inputs":[{"name":"varkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",252,{"inputs":[{"name":"varkind"}],"output":{"name":"varkind"}}],[11,"visit_fn","","",253,null],[11,"visit_local","","",253,null],[11,"visit_expr","","",253,null],[11,"visit_arm","","",253,null],[11,"clone","","",254,{"inputs":[{"name":"users"}],"output":{"name":"users"}}],[11,"clone","","",255,{"inputs":[{"name":"specials"}],"output":{"name":"specials"}}],[11,"fmt","rustc::middle::mem_categorization","",256,{"inputs":[{"name":"categorization"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",256,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",256,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",256,{"inputs":[{"name":"categorization"}],"output":{"name":"categorization"}}],[11,"fmt","","",257,{"inputs":[{"name":"upvar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",257,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",257,{"inputs":[{"name":"upvar"}],"output":{"name":"upvar"}}],[11,"fmt","","",258,{"inputs":[{"name":"pointerkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",258,null],[11,"eq","","",258,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"clone","","",258,{"inputs":[{"name":"pointerkind"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",259,{"inputs":[{"name":"interiorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",259,null],[11,"eq","","",259,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"clone","","",259,{"inputs":[{"name":"interiorkind"}],"output":{"name":"interiorkind"}}],[11,"fmt","","",260,{"inputs":[{"name":"fieldname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",260,null],[11,"eq","","",260,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"ne","","",260,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"clone","","",260,{"inputs":[{"name":"fieldname"}],"output":{"name":"fieldname"}}],[11,"fmt","","",261,{"inputs":[{"name":"interioroffsetkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",261,null],[11,"eq","","",261,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"ne","","",261,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"clone","","",261,{"inputs":[{"name":"interioroffsetkind"}],"output":{"name":"interioroffsetkind"}}],[11,"fmt","","",262,{"inputs":[{"name":"elementkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",262,null],[11,"eq","","",262,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"ne","","",262,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"clone","","",262,{"inputs":[{"name":"elementkind"}],"output":{"name":"elementkind"}}],[11,"fmt","","",263,{"inputs":[{"name":"mutabilitycategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",263,null],[11,"eq","","",263,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"ne","","",263,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"clone","","",263,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"fmt","","",264,{"inputs":[{"name":"note"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",264,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",264,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"clone","","",264,{"inputs":[{"name":"note"}],"output":{"name":"note"}}],[11,"fmt","","",265,{"inputs":[{"name":"cmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",265,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"clone","","",265,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"clone","","",266,{"inputs":[{"name":"deref_kind"}],"output":{"name":"deref_kind"}}],[11,"id","syntax::ast","",267,{"inputs":[{"name":"expr"}],"output":{"name":"u32"}}],[11,"span","","",267,{"inputs":[{"name":"expr"}],"output":{"name":"span"}}],[11,"id","","",268,{"inputs":[{"name":"pat"}],"output":{"name":"u32"}}],[11,"span","","",268,{"inputs":[{"name":"pat"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",269,{"inputs":[{"name":"memcategorizationcontext"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",263,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",263,{"inputs":[{"name":"mutabilitycategory"},{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",263,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",263,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"is_immutable","","",263,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"to_user_str","","",263,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"str"}}],[11,"new","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"typer"}],"output":{"name":"memcategorizationcontext"}}],[11,"cat_expr","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_expr_autoderefd","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"},{"name":"usize"}],"output":{"name":"result"}}],[11,"cat_expr_unadjusted","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_def","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"},{"name":"def"}],"output":{"name":"result"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`.\nThis could be `'static` if `id` is part of a constant expression.",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_rvalue","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"region"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_field","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"name"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_tup_field","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"usize"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"interioroffsetkind"}],"output":{"name":"result"}}],[11,"cat_slice_pattern","","Given a pattern P like: `[_, ..Q, _]`, where `vec_cmt` is the cmt for `P`, `slice_pat` is\nthe pattern `Q`, returns:",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"}],"output":{"name":"result"}}],[11,"cat_imm_interior","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"interiorkind"}],"output":{"name":"rc"}}],[11,"cat_downcast","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"defid"}],"output":{"name":"rc"}}],[11,"cat_pattern","","",269,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"},{"name":"f"}],"output":{"name":"result"}}],[11,"fmt","","",270,{"inputs":[{"name":"interiorsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",270,{"inputs":[{"name":"interiorsafety"}],"output":{"name":"interiorsafety"}}],[11,"fmt","","",271,{"inputs":[{"name":"aliasability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",271,{"inputs":[{"name":"aliasability"}],"output":{"name":"aliasability"}}],[11,"fmt","","",272,{"inputs":[{"name":"aliasablereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",272,{"inputs":[{"name":"aliasablereason"}],"output":{"name":"aliasablereason"}}],[11,"guarantor","","Returns `self` after stripping away any owned pointer derefs or\ninterior content. The return value is basically the `cmt` which\ndetermines how long the value in `self` remains live.",265,{"inputs":[{"name":"cmt_"}],"output":{"name":"rc"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this lvalue represents a freely aliasable pointer type.",265,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"aliasability"}}],[11,"upvar","","",265,{"inputs":[{"name":"cmt_"}],"output":{"name":"option"}}],[11,"descriptive_string","","",265,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",265,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",256,{"inputs":[{"name":"categorization"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",258,{"inputs":[{"name":"pointerkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",259,{"inputs":[{"name":"interiorkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",273,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::mem_categorization","",257,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",257,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::privacy","",274,{"inputs":[{"name":"lastprivate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",274,{"inputs":[{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"fmt","","",275,{"inputs":[{"name":"privatedep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",275,{"inputs":[{"name":"privatedep"}],"output":{"name":"privatedep"}}],[11,"fmt","","",276,{"inputs":[{"name":"importuse"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",276,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"ne","","",276,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"clone","","",276,{"inputs":[{"name":"importuse"}],"output":{"name":"importuse"}}],[11,"or","","",274,{"inputs":[{"name":"lastprivate"},{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"visit_expr","rustc::middle::reachable","",277,null],[11,"visit_item","","",277,null],[11,"fmt","rustc::middle::region","",127,{"inputs":[{"name":"codeextent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",127,{"inputs":[{"name":"codeextent"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",127,{"inputs":[{"name":"codeextent"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",127,null],[11,"cmp","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"lt","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"le","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"gt","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ge","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"eq","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"fmt","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",128,null],[11,"cmp","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"option"}}],[11,"lt","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"le","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"gt","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ge","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"eq","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ne","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"clone","","",128,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"destructionscopedata"}}],[11,"new","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"u32"}],"output":{"name":"destructionscopedata"}}],[11,"to_code_extent","","",128,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"codeextent"}}],[11,"fmt","","",278,{"inputs":[{"name":"blockremainder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",278,{"inputs":[{"name":"blockremainder"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",278,{"inputs":[{"name":"blockremainder"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",278,null],[11,"cmp","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"option"}}],[11,"lt","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"eq","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",278,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"clone","","",278,{"inputs":[{"name":"blockremainder"}],"output":{"name":"blockremainder"}}],[11,"from_node_id","","Creates a scope that represents the dynamic extent associated\nwith `node_id`.",127,{"inputs":[{"name":"codeextent"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"node_id","","Returns a node id associated with this scope.",127,{"inputs":[{"name":"codeextent"}],"output":{"name":"u32"}}],[11,"map_id","","Maps this scope to a potentially new one according to the\nNodeId transformer `f_id`.",127,{"inputs":[{"name":"codeextent"},{"name":"f"}],"output":{"name":"codeextent"}}],[11,"span","","Returns the span of this CodeExtent.  Note that in general the\nreturned span may not correspond to the span of any node id in\nthe AST.",127,{"inputs":[{"name":"codeextent"},{"name":"map"}],"output":{"name":"option"}}],[11,"clone","","",279,{"inputs":[{"name":"innermostdeclaringblock"}],"output":{"name":"innermostdeclaringblock"}}],[11,"fmt","","",279,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",279,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"ne","","",279,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"clone","","",280,{"inputs":[{"name":"declaringstatementcontext"}],"output":{"name":"declaringstatementcontext"}}],[11,"fmt","","",280,{"inputs":[{"name":"declaringstatementcontext"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",280,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"ne","","",280,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"clone","","",281,{"inputs":[{"name":"innermostenclosingexpr"}],"output":{"name":"innermostenclosingexpr"}}],[11,"fmt","","",281,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",281,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"ne","","",281,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"clone","","",282,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"fmt","","",282,{"inputs":[{"name":"context"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"each_encl_scope","","",283,null],[11,"each_var_scope","","",283,null],[11,"each_rvalue_scope","","",283,null],[11,"each_terminating_scope","","",283,null],[11,"record_encl_scope","","",283,null],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",283,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",283,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",283,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",283,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",283,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"region"}}],[11,"scopes_intersect","","",283,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false\notherwise.",283,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest\nscope which is greater than or equal to both `scope_a` and `scope_b`.",283,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"visit_block","","",284,null],[11,"visit_item","","",284,null],[11,"visit_fn","","",284,null],[11,"visit_arm","","",284,null],[11,"visit_pat","","",284,null],[11,"visit_stmt","","",284,null],[11,"visit_expr","","",284,null],[11,"visit_local","","",284,null],[11,"fmt","rustc::middle::resolve_lifetime","",285,{"inputs":[{"name":"defregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",285,{"inputs":[{"name":"defregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",285,{"inputs":[{"name":"defregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",285,null],[11,"eq","","",285,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"ne","","",285,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"clone","","",285,{"inputs":[{"name":"defregion"}],"output":{"name":"defregion"}}],[11,"visit_item","","",286,null],[11,"visit_fn","","",286,null],[11,"visit_ty","","",286,null],[11,"visit_trait_item","","",286,null],[11,"visit_block","","",286,null],[11,"visit_lifetime_ref","","",286,null],[11,"visit_generics","","",286,null],[11,"visit_poly_trait_ref","","",286,null],[11,"eq","","",287,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"ne","","",287,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"clone","","",287,{"inputs":[{"name":"shadowkind"}],"output":{"name":"shadowkind"}}],[11,"fmt","","",288,{"inputs":[{"name":"scopechain"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"visit_item","rustc::middle::stability","",289,null],[11,"visit_fn","","",289,null],[11,"visit_trait_item","","",289,null],[11,"visit_impl_item","","",289,null],[11,"visit_variant","","",289,null],[11,"visit_struct_field","","",289,null],[11,"visit_foreign_item","","",289,null],[11,"build","","Construct the stability index for a crate being compiled.",290,null],[11,"new","","",290,{"inputs":[{"name":"index"},{"name":"crate"}],"output":{"name":"index"}}],[11,"visit_item","","",291,null],[11,"visit_expr","","",291,null],[11,"visit_path","","",291,null],[11,"visit_pat","","",291,null],[11,"fmt","rustc::middle::subst","",65,{"inputs":[{"name":"substs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",65,null],[11,"eq","","",65,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"fmt","","",292,{"inputs":[{"name":"regionsubsts"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",292,null],[11,"eq","","",292,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"ne","","",292,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"clone","","",292,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"regionsubsts"}}],[11,"new","","",65,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"new_type","","",65,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"new_trait","","",65,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erased","","",65,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"empty","","",65,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"trans_empty","","",65,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"is_noop","","",65,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"type_for_def","","",65,{"inputs":[{"name":"substs"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[11,"has_regions_escaping_depth","","",65,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"self_ty","","",65,{"inputs":[{"name":"substs"}],"output":{"name":"option"}}],[11,"with_self_ty","","",65,{"inputs":[{"name":"substs"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erase_regions","","",65,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",65,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"mut_regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",65,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"with_method","","",65,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"is_erased","","",292,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"fmt","","",293,{"inputs":[{"name":"paramspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",293,{"inputs":[{"name":"paramspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",293,{"inputs":[{"name":"paramspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",293,null],[11,"clone","","",293,{"inputs":[{"name":"paramspace"}],"output":{"name":"paramspace"}}],[11,"eq","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ne","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"cmp","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"lt","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"le","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"gt","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ge","","",293,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"all","","",293,null],[11,"to_uint","","",293,{"inputs":[{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"from_uint","","",293,{"inputs":[{"name":"paramspace"},{"name":"usize"}],"output":{"name":"paramspace"}}],[11,"decode","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",49,null],[11,"clone","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"eq","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"ne","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"fmt","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"params_from_type","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"new","","`t` is the type space.\n`s` is the self space.\n`a` is the assoc space.\n`f` is the fn space.",49,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"push","","Appends `value` to the vector associated with `space`.",49,null],[11,"extend","","Appends `values` to the vector associated with `space`.",49,null],[11,"pop","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"truncate","","",49,null],[11,"replace","","",49,null],[11,"get_self","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"option"}}],[11,"len","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"is_empty_in","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"get_slice","","",49,null],[11,"get_mut_slice","","",49,null],[11,"opt_get","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"t"}}],[11,"iter","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"iter"}}],[11,"into_iter","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[11,"iter_enumerated","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"enumerateditems"}}],[11,"as_slice","","",49,null],[11,"into_vec","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vec"}}],[11,"all_vecs","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"all","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"any","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"is_empty","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"map","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_enumerated","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_move","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"split","","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"separatevecsperparamspace"}}],[11,"with_vec","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"clone","","",294,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"enumerateditems"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::subst","",294,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"option"}}],[6,"Item","rustdoc::core","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","rustc::middle::subst","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[6,"Item","rustdoc::core","",null,null],[6,"IntoIter","","",null,null],[11,"tcx","rustc::middle::subst","",295,{"inputs":[{"name":"substfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",295,null],[11,"exit_region_binder","","",295,null],[11,"fold_region","","",295,{"inputs":[{"name":"substfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",295,{"inputs":[{"name":"substfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","rustc::middle::traits::coherence","",296,{"inputs":[{"name":"inferislocal"}],"output":{"name":"inferislocal"}}],[11,"clone","rustc::middle::traits::fulfill","",297,{"inputs":[{"name":"regionobligation"}],"output":{"name":"regionobligation"}}],[11,"new","","",298,{"inputs":[{"name":"fulfillmentcontext"}],"output":{"name":"fulfillmentcontext"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by\ncreating a fresh type variable `$0` as well as a projection\npredicate `<SomeType as SomeTrait>::X == $0`. When the\ninference engine runs, it will attempt to find an impl of\n`SomeTrait` or a where clause that lets us unify `$0` with\nsomething concrete. If this fails, we'll unify `$0` with\n`projection_ty` again.",298,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"tys"}}],[11,"register_builtin_bound","","",298,null],[11,"register_region_obligation","","",298,null],[11,"register_predicate_obligation","","",298,null],[11,"region_obligations","","",298,null],[11,"select_all_or_error","","",298,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_new_obligations","","Attempts to select obligations that were registered since the call to a selection routine.\nThis is used by the type checker to eagerly attempt to resolve obligations in hopes of\ngaining type information. It'd be equally valid to use `select_where_possible` but it\nresults in `O(n^2)` performance (#18208).",298,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_where_possible","","",298,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"pending_obligations","","",298,null],[11,"repr","","",297,{"inputs":[{"name":"regionobligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::project","",299,{"inputs":[{"name":"mismatchedprojectiontypes"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"eq","","",300,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"ne","","",300,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"tcx","","",301,{"inputs":[{"name":"associatedtypenormalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",301,{"inputs":[{"name":"associatedtypenormalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","","",302,{"inputs":[{"name":"normalized"}],"output":{"name":"normalized"}}],[11,"with","","",302,{"inputs":[{"name":"normalized"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"repr","","",303,{"inputs":[{"name":"projectiontyerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",300,{"inputs":[{"name":"projectiontycandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","","",302,{"inputs":[{"name":"normalized"},{"name":"f"}],"output":{"name":"normalized"}}],[11,"repr","","",302,{"inputs":[{"name":"normalized"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::traits::object_safety","",304,{"inputs":[{"name":"methodviolationcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",304,{"inputs":[{"name":"methodviolationcode"}],"output":{"name":"methodviolationcode"}}],[11,"repr","","",305,{"inputs":[{"name":"objectsafetyviolation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::select","",306,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"fmt","","",307,{"inputs":[{"name":"methodmatcheddata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",307,{"inputs":[{"name":"methodmatcheddata"}],"output":{"name":"methodmatcheddata"}}],[11,"clone","","",308,{"inputs":[{"name":"selectioncandidate"}],"output":{"name":"selectioncandidate"}}],[11,"fmt","","",308,{"inputs":[{"name":"selectioncandidate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",308,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"ne","","",308,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"fmt","","",309,{"inputs":[{"name":"evaluationresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",310,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",310,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"infcx","","",310,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",310,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"ctxt"}}],[11,"param_env","","",310,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"parameterenvironment"}}],[11,"closure_typer","","",310,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"closuretyper"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding\ntype environment by performing unification.",310,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"result"}}],[11,"evaluate_obligation","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",310,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"evaluate_impl","","Evaluates whether the impl with id `impl_def_id` could be applied to the self type\n`obligation_self_ty`. This can be used either for trait or inherent impls.",310,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"repr","","",308,{"inputs":[{"name":"selectioncandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","","",306,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"clone","","",311,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"traitobligationstacklist"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::traits::select","",311,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"option"}}],[11,"repr","","",312,{"inputs":[{"name":"traitobligationstack"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"may_apply","","",313,{"inputs":[{"name":"methodmatchresult"}],"output":{"name":"bool"}}],[11,"filter_to_traits","rustc::middle::traits::util","",314,{"inputs":[{"name":"elaborator"}],"output":{"name":"filtertotraits"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::traits::util","",314,{"inputs":[{"name":"elaborator"}],"output":{"name":"option"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::traits::util","",315,{"inputs":[{"name":"supertraitdefids"}],"output":{"name":"option"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::traits::util","",316,{"inputs":[{"name":"filtertotraits"}],"output":{"name":"option"}}],[11,"fmt","rustc::middle::traits","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",318,{"inputs":[{"name":"vtableobjectdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",319,{"inputs":[{"name":"obligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",320,{"inputs":[{"name":"vtable"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",321,{"inputs":[{"name":"vtablebuiltindata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",322,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",318,{"inputs":[{"name":"vtableobjectdata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",323,{"inputs":[{"name":"selectionerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",324,{"inputs":[{"name":"fulfillmenterror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",325,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",325,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","rustc::middle::traits::project","",299,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",299,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","rustc::middle::traits","",319,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",319,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"clone","","",319,{"inputs":[{"name":"obligation"}],"output":{"name":"obligation"}}],[11,"eq","","",326,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",326,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",326,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"eq","","",327,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",327,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"clone","","",327,{"inputs":[{"name":"obligationcausecode"}],"output":{"name":"obligationcausecode"}}],[11,"eq","","",328,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",328,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",328,{"inputs":[{"name":"derivedobligationcause"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",323,{"inputs":[{"name":"selectionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",323,{"inputs":[{"name":"selectionerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",325,{"inputs":[{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",320,{"inputs":[{"name":"vtable"}],"output":{"name":"vtable"}}],[11,"fmt","","",320,{"inputs":[{"name":"vtable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"clone","","",317,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"vtableimpldata"}}],[11,"clone","","",322,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fmt","","",322,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",321,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"vtablebuiltindata"}}],[11,"fmt","","",321,{"inputs":[{"name":"vtablebuiltindata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",318,{"inputs":[{"name":"vtableobjectdata"}],"output":{"name":"vtableobjectdata"}}],[11,"eq","","",318,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",318,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"new","","",319,{"inputs":[{"name":"obligation"},{"name":"obligationcause"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",319,{"inputs":[{"name":"obligation"},{"name":"span"},{"name":"u32"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",319,{"inputs":[{"name":"obligation"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",326,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",326,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",326,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"iter_nested","","",320,{"inputs":[{"name":"vtable"}],"output":{"name":"iter"}}],[11,"map_nested","","",320,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"map_move_nested","","",320,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"iter_nested","","",317,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"map_move_nested","","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"iter_nested","","",322,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",322,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"map_move_nested","","",322,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"iter_nested","","",321,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"iter"}}],[11,"map_nested","","",321,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"map_move_nested","","",321,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"hash","rustc::middle::ty","",329,null],[11,"eq","","",329,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",329,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",329,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",330,{"inputs":[{"name":"implortraititemcontainer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",330,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"implortraititemcontainer"}}],[11,"id","","",330,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"defid"}}],[11,"fmt","","",90,{"inputs":[{"name":"implortraititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",90,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititem"}}],[11,"def_id","","",90,{"inputs":[{"name":"implortraititem"}],"output":{"name":"defid"}}],[11,"name","","",90,{"inputs":[{"name":"implortraititem"}],"output":{"name":"name"}}],[11,"container","","",90,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititemcontainer"}}],[11,"as_opt_method","","",90,{"inputs":[{"name":"implortraititem"}],"output":{"name":"option"}}],[11,"fmt","","",331,{"inputs":[{"name":"implortraititemid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",331,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"implortraititemid"}}],[11,"def_id","","",331,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"defid"}}],[11,"fmt","","",89,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",89,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"new","","",89,{"inputs":[{"name":"method"},{"name":"name"},{"name":"generics"},{"name":"genericpredicates"},{"name":"barefnty"},{"name":"explicitselfcategory"},{"name":"visibility"},{"name":"defid"},{"name":"implortraititemcontainer"},{"name":"option"}],"output":{"name":"method"}}],[11,"container_id","","",89,{"inputs":[{"name":"method"}],"output":{"name":"defid"}}],[11,"fmt","","",112,{"inputs":[{"name":"associatedtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"associatedtype"}],"output":{"name":"associatedtype"}}],[11,"fmt","","",332,{"inputs":[{"name":"mt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",332,null],[11,"eq","","",332,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"ne","","",332,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"clone","","",332,{"inputs":[{"name":"mt"}],"output":{"name":"mt"}}],[11,"fmt","","",94,{"inputs":[{"name":"field_ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",94,{"inputs":[{"name":"field_ty"}],"output":{"name":"field_ty"}}],[11,"hash","","",333,null],[11,"eq","","",333,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"ne","","",333,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"clone","","",333,{"inputs":[{"name":"creader_cache_key"}],"output":{"name":"creader_cache_key"}}],[11,"encode","","",334,{"inputs":[{"name":"itemvariances"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",334,{"inputs":[{"name":"itemvariances"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",334,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"ne","","",334,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"clone","","",334,{"inputs":[{"name":"itemvariances"}],"output":{"name":"itemvariances"}}],[11,"fmt","","",335,{"inputs":[{"name":"variance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",335,{"inputs":[{"name":"variance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",335,{"inputs":[{"name":"variance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",335,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"ne","","",335,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"clone","","",335,{"inputs":[{"name":"variance"}],"output":{"name":"variance"}}],[11,"fmt","","",336,{"inputs":[{"name":"autoadjustment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",336,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"autoadjustment"}}],[11,"fmt","","",337,{"inputs":[{"name":"autoderefref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",337,{"inputs":[{"name":"autoderefref"}],"output":{"name":"autoderefref"}}],[11,"fmt","","",338,{"inputs":[{"name":"autoref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",338,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"ne","","",338,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"clone","","",338,{"inputs":[{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fmt","","",339,{"inputs":[{"name":"param_index"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"option"}}],[11,"lt","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"le","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"gt","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ge","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"eq","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ne","","",339,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"decode","","",339,{"inputs":[{"name":"param_index"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",339,{"inputs":[{"name":"param_index"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",339,{"inputs":[{"name":"param_index"}],"output":{"name":"param_index"}}],[11,"fmt","","",134,{"inputs":[{"name":"methodorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"methodorigin"}],"output":{"name":"methodorigin"}}],[11,"fmt","","",340,{"inputs":[{"name":"methodparam"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",340,{"inputs":[{"name":"methodparam"}],"output":{"name":"methodparam"}}],[11,"fmt","","",341,{"inputs":[{"name":"methodobject"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",341,{"inputs":[{"name":"methodobject"}],"output":{"name":"methodobject"}}],[11,"clone","","",342,{"inputs":[{"name":"methodcallee"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",343,{"inputs":[{"name":"methodcall"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",343,null],[11,"eq","","",343,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"ne","","",343,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"clone","","",343,{"inputs":[{"name":"methodcall"}],"output":{"name":"methodcall"}}],[11,"expr","","",343,{"inputs":[{"name":"methodcall"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"autoderef","","",343,{"inputs":[{"name":"methodcall"},{"name":"u32"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"clone","","",344,{"inputs":[{"name":"vtable_origin"}],"output":{"name":"vtable_origin"}}],[11,"clone","","",197,{"inputs":[{"name":"transmuterestriction"}],"output":{"name":"transmuterestriction"}}],[11,"new","","",345,{"inputs":[{"name":"ctxtarenas"}],"output":{"name":"ctxtarenas"}}],[11,"node_types","","",346,{"inputs":[{"name":"ctxt"}],"output":{"name":"ref"}}],[11,"node_type_insert","","",346,null],[11,"store_free_region_map","","",346,null],[11,"free_region_map","","",346,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"freeregionmap"}}],[11,"hash","","",347,null],[11,"cmp","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"option"}}],[11,"lt","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"clone","","",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"eq","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",347,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",347,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",347,null],[11,"remove","","Removes the specified flags in-place.",347,null],[11,"toggle","","Toggles the specified flags in-place.",347,null],[6,"Output","rustdoc::core","",null,null],[11,"bitor","rustc::middle::ty","Returns the union of the two sets of flags.",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitxor","rustc::middle::ty","Returns the left flags, but with all the right flags toggled.",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitand","rustc::middle::ty","Returns the intersection between the two sets of flags.",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustdoc::core","",null,null],[11,"sub","rustc::middle::ty","Returns the set difference of the two sets of flags.",347,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustdoc::core","",null,null],[11,"not","rustc::middle::ty","Returns the complement of this set of flags.",347,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"print_debug_stats","","",346,null],[11,"fmt","","",348,{"inputs":[{"name":"tys"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",347,{"inputs":[{"name":"typeflags"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",348,{"inputs":[{"name":"tys"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",348,null],[11,"eq","","",349,{"inputs":[{"name":"internedty"},{"name":"internedty"}],"output":{"name":"bool"}}],[11,"hash","","",349,null],[11,"borrow","","",349,{"inputs":[{"name":"internedty"}],"output":{"name":"sty"}}],[11,"fmt","","",350,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",350,null],[11,"eq","","",350,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",350,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",350,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",351,{"inputs":[{"name":"closurety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",351,null],[11,"eq","","",351,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"ne","","",351,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"clone","","",351,{"inputs":[{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fmt","","",82,{"inputs":[{"name":"fnoutput"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",82,null],[11,"eq","","",82,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"diverges","","",82,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"unwrap","","",82,{"inputs":[{"name":"fnoutput"}],"output":{"name":"tys"}}],[11,"unwrap_or","","",82,{"inputs":[{"name":"fnoutput"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"diverges","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"hash","","",352,null],[11,"eq","","",352,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",352,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"clone","","",352,{"inputs":[{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"inputs","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"input","","",53,{"inputs":[{"name":"binder"},{"name":"usize"}],"output":{"name":"binder"}}],[11,"output","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"variadic","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"fmt","","",353,{"inputs":[{"name":"paramty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",353,null],[11,"eq","","",353,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",353,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"clone","","",353,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"fmt","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",354,null],[11,"eq","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"clone","","",354,{"inputs":[{"name":"debruijnindex"}],"output":{"name":"debruijnindex"}}],[11,"fmt","","",70,{"inputs":[{"name":"region"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",70,{"inputs":[{"name":"region"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",70,{"inputs":[{"name":"region"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",70,null],[11,"eq","","",70,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",70,{"inputs":[{"name":"region"}],"output":{"name":"region"}}],[11,"fmt","","",355,{"inputs":[{"name":"earlyboundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",355,{"inputs":[{"name":"earlyboundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",355,{"inputs":[{"name":"earlyboundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",355,null],[11,"eq","","",355,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",355,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"clone","","",355,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"earlyboundregion"}}],[11,"fmt","","",356,{"inputs":[{"name":"upvarid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",356,null],[11,"eq","","",356,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",356,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"clone","","",356,{"inputs":[{"name":"upvarid"}],"output":{"name":"upvarid"}}],[11,"decode","","",357,{"inputs":[{"name":"borrowkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",357,{"inputs":[{"name":"borrowkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",357,{"inputs":[{"name":"borrowkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",357,null],[11,"eq","","",357,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",357,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"clone","","",357,{"inputs":[{"name":"borrowkind"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"upvarcapture"}],"output":{"name":"upvarcapture"}}],[11,"eq","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"fmt","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"upvarborrow"}],"output":{"name":"upvarborrow"}}],[11,"eq","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"is_bound","","",70,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",70,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"fmt","","",126,{"inputs":[{"name":"freeregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",126,{"inputs":[{"name":"freeregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",126,{"inputs":[{"name":"freeregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",126,null],[11,"cmp","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"option"}}],[11,"lt","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"eq","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"freeregion"}],"output":{"name":"freeregion"}}],[11,"fmt","","",129,{"inputs":[{"name":"boundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",129,{"inputs":[{"name":"boundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",129,{"inputs":[{"name":"boundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",129,null],[11,"cmp","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"lt","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"eq","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"clone","","",129,{"inputs":[{"name":"boundregion"}],"output":{"name":"boundregion"}}],[11,"fmt","","",358,{"inputs":[{"name":"sty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",358,null],[11,"eq","","",358,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"ne","","",358,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"clone","","",358,{"inputs":[{"name":"sty"}],"output":{"name":"sty"}}],[11,"fmt","","",359,{"inputs":[{"name":"tytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",359,null],[11,"eq","","",359,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"ne","","",359,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"clone","","",359,{"inputs":[{"name":"tytrait"}],"output":{"name":"tytrait"}}],[11,"principal_def_id","","",359,{"inputs":[{"name":"tytrait"}],"output":{"name":"defid"}}],[11,"principal_trait_ref_with_self_ty","","Object types don't have a self-type specified. Therefore, when\nwe convert the principal trait-ref into a normal trait-ref,\nyou must give *some* self-type. A common choice is `mk_err()`\nor some skolemized type.",359,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"binder"}}],[11,"projection_bounds_with_self_ty","","",359,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"vec"}}],[11,"fmt","","",63,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",63,null],[11,"eq","","",63,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",63,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",63,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"self_ty","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"tys"}}],[11,"def_id","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"substs","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"substs"}}],[11,"input_types","","",53,null],[11,"to_poly_trait_predicate","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"fmt","","",53,{"inputs":[{"name":"binder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",53,null],[11,"eq","","",53,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",53,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a\nrisky thing to do because it's easy to get confused about\ndebruijn indices and the like. It is usually better to\ndischarge the binder using `no_late_bound_regions` or\n`replace_late_bound_regions` or something like\nthat. `skip_binder` is only valid when you are either\nextracting data that has nothing to do with bound regions, you\nare doing some sort of test that does not involve bound\nregions, or you are being very careful about your depth\naccounting.",53,{"inputs":[{"name":"binder"}],"output":{"name":"t"}}],[11,"as_ref","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",53,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",53,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"eq","","",233,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",233,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"clone","","",233,{"inputs":[{"name":"intvarvalue"}],"output":{"name":"intvarvalue"}}],[11,"fmt","","",360,{"inputs":[{"name":"terr_vstore_kind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",360,{"inputs":[{"name":"terr_vstore_kind"}],"output":{"name":"terr_vstore_kind"}}],[11,"fmt","","",361,{"inputs":[{"name":"expected_found"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",361,{"inputs":[{"name":"expected_found"}],"output":{"name":"expected_found"}}],[11,"fmt","","",362,{"inputs":[{"name":"type_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",362,{"inputs":[{"name":"type_err"}],"output":{"name":"type_err"}}],[11,"fmt","","",64,{"inputs":[{"name":"parambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",64,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"hash","","",64,null],[11,"eq","","",64,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"ne","","",64,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"fmt","","",61,{"inputs":[{"name":"existentialbounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",61,{"inputs":[{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"hash","","",61,null],[11,"eq","","",61,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"ne","","",61,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"fmt","","",62,{"inputs":[{"name":"builtinbound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",62,null],[11,"decode","","",62,{"inputs":[{"name":"builtinbound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",62,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"ne","","",62,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"encode","","",62,{"inputs":[{"name":"builtinbound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",62,{"inputs":[{"name":"builtinbound"}],"output":{"name":"builtinbound"}}],[11,"to_usize","","",62,{"inputs":[{"name":"builtinbound"}],"output":{"name":"usize"}}],[11,"from_usize","","",62,{"inputs":[{"name":"builtinbound"},{"name":"usize"}],"output":{"name":"builtinbound"}}],[11,"hash","","",363,null],[11,"eq","","",363,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",363,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"clone","","",363,{"inputs":[{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"hash","","",232,null],[11,"eq","","",232,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",232,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"clone","","",232,{"inputs":[{"name":"intvid"}],"output":{"name":"intvid"}}],[11,"hash","","",234,null],[11,"eq","","",234,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",234,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"clone","","",234,{"inputs":[{"name":"floatvid"}],"output":{"name":"floatvid"}}],[11,"hash","","",364,null],[11,"decode","","",364,{"inputs":[{"name":"regionvid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",364,{"inputs":[{"name":"regionvid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",364,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",364,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"clone","","",364,{"inputs":[{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"hash","","",365,null],[11,"eq","","",365,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",365,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"clone","","",365,{"inputs":[{"name":"inferty"}],"output":{"name":"inferty"}}],[11,"fmt","","",366,{"inputs":[{"name":"unconstrainednumeric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",366,null],[11,"eq","","",366,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"ne","","",366,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"decode","","",366,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",366,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",366,{"inputs":[{"name":"unconstrainednumeric"}],"output":{"name":"unconstrainednumeric"}}],[11,"fmt","","",367,{"inputs":[{"name":"inferregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",367,null],[11,"decode","","",367,{"inputs":[{"name":"inferregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",367,{"inputs":[{"name":"inferregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",367,{"inputs":[{"name":"inferregion"}],"output":{"name":"inferregion"}}],[11,"eq","","",367,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"ne","","",367,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"fmt","","",363,{"inputs":[{"name":"tyvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",232,{"inputs":[{"name":"intvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",234,{"inputs":[{"name":"floatvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",364,{"inputs":[{"name":"regionvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",352,{"inputs":[{"name":"fnsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",365,{"inputs":[{"name":"inferty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",233,{"inputs":[{"name":"intvarvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",368,{"inputs":[{"name":"objectlifetimedefault"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",368,{"inputs":[{"name":"objectlifetimedefault"}],"output":{"name":"objectlifetimedefault"}}],[11,"fmt","","",59,{"inputs":[{"name":"typeparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",59,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"typeparameterdef"}}],[11,"fmt","","",69,{"inputs":[{"name":"regionparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",69,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"regionparameterdef"}}],[11,"decode","","",69,{"inputs":[{"name":"regionparameterdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",69,{"inputs":[{"name":"regionparameterdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"to_early_bound_region","","",69,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"to_bound_region","","",69,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"boundregion"}}],[11,"fmt","","",369,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",369,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"empty","","",369,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_empty","","",369,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"has_type_params","","",369,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"has_region_params","","",369,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"fmt","","",370,{"inputs":[{"name":"genericpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",370,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"empty","","",370,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",370,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_supertrait","","",370,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"instantiatedpredicates"}}],[11,"fmt","","",72,{"inputs":[{"name":"predicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",72,null],[11,"eq","","",72,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"predicate"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substituion suitable for going from a\npoly-trait-ref to supertraits that must hold if that\npoly-trait-ref holds. This is slightly different from a normal\nsubstitution in terms of what happens with bound regions.  See\nlengthy comment below for details.",72,{"inputs":[{"name":"predicate"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"predicate"}}],[11,"fmt","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",73,null],[11,"eq","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"traitpredicate"}}],[11,"def_id","","",73,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"defid"}}],[11,"input_types","","",73,null],[11,"self_ty","","",73,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"tys"}}],[11,"def_id","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"fmt","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",74,null],[11,"eq","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"equatepredicate"}}],[11,"fmt","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",75,null],[11,"eq","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"outlivespredicate"}}],[11,"fmt","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",76,null],[11,"eq","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"projectionpredicate"}}],[11,"item_name","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"name"}}],[11,"sort_key","","",53,null],[11,"fmt","","",77,{"inputs":[{"name":"projectionty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",77,null],[11,"eq","","",77,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",77,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"clone","","",77,{"inputs":[{"name":"projectionty"}],"output":{"name":"projectionty"}}],[11,"sort_key","","",77,null],[11,"to_poly_trait_ref","alloc::rc","",51,{"inputs":[{"name":"rc"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","rustc::middle::ty","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"as_predicate","alloc::rc","",51,{"inputs":[{"name":"rc"}],"output":{"name":"predicate"}}],[11,"as_predicate","rustc::middle::ty","",53,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all\ncases this is skipping over a binder, so late-bound regions\nwith depth 0 are bound by the predicate.",72,{"inputs":[{"name":"predicate"}],"output":{"name":"intoiter"}}],[11,"has_escaping_regions","","",72,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"to_opt_poly_trait_ref","","",72,{"inputs":[{"name":"predicate"}],"output":{"name":"option"}}],[11,"fmt","","",371,{"inputs":[{"name":"instantiatedpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",371,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",371,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"has_escaping_regions","","",371,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"is_empty","","",371,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"new","","",63,{"inputs":[{"name":"traitref"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",63,{"inputs":[{"name":"traitref"}],"output":{"name":"tys"}}],[11,"input_types","","",63,null],[11,"clone","","",372,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"with_caller_bounds","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"vec"}],"output":{"name":"parameterenvironment"}}],[11,"for_item","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[11,"fmt","","",373,{"inputs":[{"name":"typescheme"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",373,{"inputs":[{"name":"typescheme"}],"output":{"name":"typescheme"}}],[11,"clone","","",374,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"decode","","",273,{"inputs":[{"name":"closurekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",273,{"inputs":[{"name":"closurekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",273,{"inputs":[{"name":"closurekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ne","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"cmp","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"option"}}],[11,"lt","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"le","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"gt","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ge","","",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"clone","","",273,{"inputs":[{"name":"closurekind"}],"output":{"name":"closurekind"}}],[11,"trait_did","","",273,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind\nmust also implement `other`.",273,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"mk_substs","","",346,{"inputs":[{"name":"ctxt"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"safe_to_unsafe_fn_ty","","Create an unsafe fn ty based on a safe fn ty.",346,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"tys"}}],[11,"mk_bare_fn","","",346,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"mk_region","","",346,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"region"}}],[11,"closure_kind","","",346,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"closurekind"}}],[11,"closure_type","","",346,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"type_parameter_def","","",346,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"typeparameterdef"}}],[11,"pat_contains_ref_binding","","",346,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"arm_contains_ref_binding","","",346,{"inputs":[{"name":"ctxt"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"walk","","Iterator that walks `self` and any types reachable from\n`self`, in depth-first order. Note that just walks the types\nthat appear in `self`, it does not descend into the fields of\nstructs or variants. For example:",348,{"inputs":[{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence\n`Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]`\n(but not `i32`, like `walk`).",348,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[11,"as_opt_param_ty","","",348,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[11,"is_param","","",348,{"inputs":[{"name":"tys"},{"name":"paramspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"new","","",353,{"inputs":[{"name":"paramty"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"paramty"}}],[11,"for_self","","",353,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"for_def","","",353,{"inputs":[{"name":"paramty"},{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",353,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"is_self","","",353,{"inputs":[{"name":"paramty"}],"output":{"name":"bool"}}],[11,"empty","","",374,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"is_noop","","",374,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"bool"}}],[11,"empty","","",64,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"clone","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"when","","",375,{"inputs":[{"name":"typecontents"},{"name":"bool"}],"output":{"name":"typecontents"}}],[11,"intersects","","",375,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_managed","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_owned","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"is_sized","","",375,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"interior_param","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsafe","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsized","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"needs_drop","","",375,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"owned_pointer","","Includes only those bits that still apply when indirected through a `Box` pointer",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"reference","","Includes only those bits that still apply when indirected through a reference (`&`)",375,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"managed_pointer","","Includes only those bits that still apply when indirected through a managed pointer (`@`)",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"unsafe_pointer","","Includes only those bits that still apply when indirected through an unsafe pointer (`*`)",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"union","","",375,null],[11,"has_dtor","","",375,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitor","rustc::middle::ty","",375,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitand","rustc::middle::ty","",375,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustdoc::core","",null,null],[11,"sub","rustc::middle::ty","",375,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"fmt","","",375,{"inputs":[{"name":"typecontents"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",376,{"inputs":[{"name":"representability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"option"}}],[11,"lt","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",376,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"clone","","",376,{"inputs":[{"name":"representability"}],"output":{"name":"representability"}}],[11,"clone","","",377,{"inputs":[{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"repr","","",362,{"inputs":[{"name":"type_err"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",97,{"inputs":[{"name":"variantinfo"}],"output":{"name":"variantinfo"}}],[11,"from_ast_variant","","Creates a new VariantInfo from the corresponding ast representation.",97,{"inputs":[{"name":"variantinfo"},{"name":"ctxt"},{"name":"spanned"},{"name":"u64"}],"output":{"name":"variantinfo"}}],[11,"clone","","",378,{"inputs":[{"name":"dtorkind"}],"output":{"name":"dtorkind"}}],[11,"is_present","","",378,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"has_drop_flag","","",378,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"to_ty","syntax::attr","",379,{"inputs":[{"name":"inttype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"i64_to_disr","","",379,{"inputs":[{"name":"inttype"},{"name":"i64"}],"output":{"name":"option"}}],[11,"u64_to_disr","","",379,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_incr","","",379,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_string","","",379,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"string"}}],[11,"disr_wrap_incr","","",379,{"inputs":[{"name":"inttype"},{"name":"option"}],"output":{"name":"u64"}}],[11,"clone","rustc::middle::ty","",380,{"inputs":[{"name":"closureupvar"}],"output":{"name":"closureupvar"}}],[11,"to_string","","",335,{"inputs":[{"name":"variance"}],"output":{"name":"str"}}],[11,"from_mutbl","","",357,{"inputs":[{"name":"borrowkind"},{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow\nkind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a\nmutability that is stronger than necessary so that it at least *would permit* the borrow in\nquestion.",357,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",357,{"inputs":[{"name":"borrowkind"}],"output":{"name":"str"}}],[11,"is_method_call","","",346,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"upvar_capture","","",346,{"inputs":[{"name":"ctxt"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"node_ty","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"result"}}],[11,"expr_ty_adjusted","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"expr"}],"output":{"name":"result"}}],[11,"node_method_ty","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"node_method_origin","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"adjustments","","",372,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"refcell"}}],[11,"is_method_call","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"temporary_scope","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"option"}}],[11,"upvar_capture","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"type_moves_by_default","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"param_env","","",372,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"closure_kind","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"}],"output":{"name":"option"}}],[11,"closure_type","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"closure_upvars","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[11,"fmt","","",381,{"inputs":[{"name":"explicitselfcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",381,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"ne","","",381,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"clone","","",381,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"explicitselfcategory"}}],[11,"decode","","",131,{"inputs":[{"name":"freevar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",131,{"inputs":[{"name":"freevar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",131,{"inputs":[{"name":"freevar"}],"output":{"name":"freevar"}}],[11,"is_identity","","",336,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"bool"}}],[11,"is_identity","","",337,{"inputs":[{"name":"autoderefref"}],"output":{"name":"bool"}}],[11,"new","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",354,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"repr","","",336,{"inputs":[{"name":"autoadjustment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",337,{"inputs":[{"name":"autoderefref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",338,{"inputs":[{"name":"autoref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",359,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",72,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",344,{"inputs":[{"name":"vtable_origin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",382,{"inputs":[{"name":"copyimplementationerror"}],"output":{"name":"copyimplementationerror"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",65,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",373,{"inputs":[{"name":"typescheme"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",70,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",370,{"inputs":[{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",72,{"inputs":[{"name":"predicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::traits","",319,{"inputs":[{"name":"obligation"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",63,{"inputs":[{"name":"traitref"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",292,{"inputs":[{"name":"regionsubsts"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",53,{"inputs":[{"name":"binder"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",77,{"inputs":[{"name":"projectionty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"repr","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"has_projection_types","collections::vec","",383,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",49,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",351,{"inputs":[{"name":"closurety"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",380,{"inputs":[{"name":"closureupvar"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",371,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",72,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",73,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",74,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",70,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",75,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",76,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",77,{"inputs":[{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",63,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",65,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"has_projection_types","core::option","",52,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::rc","",51,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::boxed","",384,{"inputs":[{"name":"box"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",53,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",82,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",352,{"inputs":[{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",329,{"inputs":[{"name":"field"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",350,{"inputs":[{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"references_error","","",53,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"references_error","alloc::rc","",51,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"references_error","rustc::middle::ty","",73,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",76,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",63,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"references_error","","",72,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"references_error","","",75,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",74,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",70,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"repr","","",351,{"inputs":[{"name":"closurety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",380,{"inputs":[{"name":"closureupvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",329,{"inputs":[{"name":"field"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",368,{"inputs":[{"name":"objectlifetimedefault"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","syntax::ast","",385,{"inputs":[{"name":"unsafety"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"fold_with","syntax::abi","",386,{"inputs":[{"name":"abi"},{"name":"f"}],"output":{"name":"abi"}}],[11,"fold_with","core::option","",52,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"fold_with","alloc::rc","",51,{"inputs":[{"name":"rc"},{"name":"f"}],"output":{"name":"rc"}}],[11,"fold_with","alloc::boxed","",384,{"inputs":[{"name":"box"},{"name":"f"}],"output":{"name":"box"}}],[11,"fold_with","collections::vec","",383,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"fold_with","rustc::middle::ty","",53,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"fold_with","syntax::owned_slice","",54,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"fold_with","rustc::middle::subst","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"fold_with","rustc::middle::ty","",350,{"inputs":[{"name":"barefnty"},{"name":"f"}],"output":{"name":"barefnty"}}],[11,"fold_with","","",351,{"inputs":[{"name":"closurety"},{"name":"f"}],"output":{"name":"closurety"}}],[11,"fold_with","","",332,{"inputs":[{"name":"mt"},{"name":"f"}],"output":{"name":"mt"}}],[11,"fold_with","","",82,{"inputs":[{"name":"fnoutput"},{"name":"f"}],"output":{"name":"fnoutput"}}],[11,"fold_with","","",352,{"inputs":[{"name":"fnsig"},{"name":"f"}],"output":{"name":"fnsig"}}],[11,"fold_with","","",63,{"inputs":[{"name":"traitref"},{"name":"f"}],"output":{"name":"traitref"}}],[11,"fold_with","","",329,{"inputs":[{"name":"field"},{"name":"f"}],"output":{"name":"field"}}],[11,"fold_with","","",70,{"inputs":[{"name":"region"},{"name":"f"}],"output":{"name":"region"}}],[11,"fold_with","rustc::middle::subst","",65,{"inputs":[{"name":"substs"},{"name":"f"}],"output":{"name":"substs"}}],[11,"fold_with","rustc::middle::ty","",374,{"inputs":[{"name":"itemsubsts"},{"name":"f"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","","",338,{"inputs":[{"name":"autoref"},{"name":"f"}],"output":{"name":"autoref"}}],[11,"fold_with","","",134,{"inputs":[{"name":"methodorigin"},{"name":"f"}],"output":{"name":"methodorigin"}}],[11,"fold_with","","",344,{"inputs":[{"name":"vtable_origin"},{"name":"f"}],"output":{"name":"vtable_origin"}}],[11,"fold_with","collections::enum_set","",387,{"inputs":[{"name":"enumset"},{"name":"f"}],"output":{"name":"enumset"}}],[11,"fold_with","rustc::middle::ty","",61,{"inputs":[{"name":"existentialbounds"},{"name":"f"}],"output":{"name":"existentialbounds"}}],[11,"fold_with","","",64,{"inputs":[{"name":"parambounds"},{"name":"f"}],"output":{"name":"parambounds"}}],[11,"fold_with","","",59,{"inputs":[{"name":"typeparameterdef"},{"name":"f"}],"output":{"name":"typeparameterdef"}}],[11,"fold_with","","",368,{"inputs":[{"name":"objectlifetimedefault"},{"name":"f"}],"output":{"name":"objectlifetimedefault"}}],[11,"fold_with","","",69,{"inputs":[{"name":"regionparameterdef"},{"name":"f"}],"output":{"name":"regionparameterdef"}}],[11,"fold_with","","",369,{"inputs":[{"name":"generics"},{"name":"f"}],"output":{"name":"generics"}}],[11,"fold_with","","",370,{"inputs":[{"name":"genericpredicates"},{"name":"f"}],"output":{"name":"genericpredicates"}}],[11,"fold_with","","",72,{"inputs":[{"name":"predicate"},{"name":"f"}],"output":{"name":"predicate"}}],[11,"fold_with","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"f"}],"output":{"name":"projectionpredicate"}}],[11,"fold_with","","",77,{"inputs":[{"name":"projectionty"},{"name":"f"}],"output":{"name":"projectionty"}}],[11,"fold_with","","",371,{"inputs":[{"name":"instantiatedpredicates"},{"name":"f"}],"output":{"name":"instantiatedpredicates"}}],[11,"fold_with","rustc::middle::traits","",319,{"inputs":[{"name":"obligation"},{"name":"f"}],"output":{"name":"obligation"}}],[11,"fold_with","","",317,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"fold_with","","",322,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fold_with","","",321,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"fold_with","","",320,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"fold_with","","",318,{"inputs":[{"name":"vtableobjectdata"},{"name":"f"}],"output":{"name":"vtableobjectdata"}}],[11,"fold_with","rustc::middle::ty","",74,{"inputs":[{"name":"equatepredicate"},{"name":"f"}],"output":{"name":"equatepredicate"}}],[11,"fold_with","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"f"}],"output":{"name":"traitpredicate"}}],[11,"fold_with","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"f"}],"output":{"name":"outlivespredicate"}}],[11,"fold_with","","",380,{"inputs":[{"name":"closureupvar"},{"name":"f"}],"output":{"name":"closureupvar"}}],[11,"fold_with","","",372,{"inputs":[{"name":"parameterenvironment"},{"name":"f"}],"output":{"name":"parameterenvironment"}}],[11,"tcx","rustc::middle::ty_fold","",388,{"inputs":[{"name":"bottomupfolder"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",388,{"inputs":[{"name":"bottomupfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","","",389,{"inputs":[{"name":"regionfolder"},{"name":"ctxt"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",389,{"inputs":[{"name":"regionfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",389,null],[11,"exit_region_binder","","",389,null],[11,"fold_region","","",389,{"inputs":[{"name":"regionfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"tcx","","",390,{"inputs":[{"name":"regioneraser"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",390,{"inputs":[{"name":"regioneraser"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::ty_match","",391,{"inputs":[{"name":"match"},{"name":"ctxt"}],"output":{"name":"match"}}],[11,"tag","","",391,{"inputs":[{"name":"match"}],"output":{"name":"str"}}],[11,"tcx","","",391,{"inputs":[{"name":"match"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",391,{"inputs":[{"name":"match"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",391,{"inputs":[{"name":"match"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"regions","","",391,{"inputs":[{"name":"match"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"tys","","",391,{"inputs":[{"name":"match"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"binders","","",391,{"inputs":[{"name":"match"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",332,{"inputs":[{"name":"mt"},{"name":"r"},{"name":"mt"},{"name":"mt"}],"output":{"name":"result"}}],[11,"relate","","",350,{"inputs":[{"name":"barefnty"},{"name":"r"},{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"result"}}],[11,"relate","","",352,{"inputs":[{"name":"fnsig"},{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"result"}}],[11,"relate","syntax::ast","",385,{"inputs":[{"name":"unsafety"},{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"relate","syntax::abi","",386,{"inputs":[{"name":"abi"},{"name":"r"},{"name":"abi"},{"name":"abi"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",77,{"inputs":[{"name":"projectionty"},{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"result"}}],[11,"relate","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"r"},{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"result"}}],[11,"relate","collections::vec","",383,{"inputs":[{"name":"vec"},{"name":"r"},{"name":"vec"},{"name":"vec"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",61,{"inputs":[{"name":"existentialbounds"},{"name":"r"},{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"result"}}],[11,"relate","collections::enum_set","",387,{"inputs":[{"name":"enumset"},{"name":"r"},{"name":"enumset"},{"name":"enumset"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",63,{"inputs":[{"name":"traitref"},{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"relate","","",70,{"inputs":[{"name":"region"},{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"relate","","",53,{"inputs":[{"name":"binder"},{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","alloc::rc","",51,{"inputs":[{"name":"rc"},{"name":"r"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"relate","alloc::boxed","",384,{"inputs":[{"name":"box"},{"name":"r"},{"name":"box"},{"name":"box"}],"output":{"name":"result"}}],[11,"new","rustc::middle::ty_walk","",392,{"inputs":[{"name":"typewalker"},{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type\nreturned by `next()`.",392,null],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::middle::ty_walk","",392,{"inputs":[{"name":"typewalker"}],"output":{"name":"option"}}],[11,"visit_foreign_item","rustc::middle::weak_lang_items","",393,null],[11,"eq","rustc::metadata::common","",394,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"ne","","",394,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"clone","","",394,{"inputs":[{"name":"astencode_tag"}],"output":{"name":"astencode_tag"}}],[11,"from_u32","","",394,{"inputs":[{"name":"astencode_tag"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","","",395,{"inputs":[{"name":"linkmeta"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",395,{"inputs":[{"name":"linkmeta"}],"output":{"name":"linkmeta"}}],[11,"fmt","rustc::metadata::tydecode","",396,{"inputs":[{"name":"defidsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",396,{"inputs":[{"name":"defidsource"}],"output":{"name":"defidsource"}}],[11,"clone","rustc::metadata::encoder","",397,{"inputs":[{"name":"entry"}],"output":{"name":"entry"}}],[11,"visit_expr","","",398,null],[11,"visit_item","","",398,null],[11,"visit_foreign_item","","",398,null],[11,"visit_item","","",399,null],[11,"eq","rustc::metadata::decoder","",400,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"ne","","",400,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"fmt","","",401,{"inputs":[{"name":"deflike"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",401,{"inputs":[{"name":"deflike"}],"output":{"name":"deflike"}}],[11,"clone","","",402,{"inputs":[{"name":"cratedep"}],"output":{"name":"cratedep"}}],[11,"visit_item","rustc::metadata::creader","",403,null],[11,"as_slice","","",404,null],[11,"new","","",403,{"inputs":[{"name":"cratereader"},{"name":"session"}],"output":{"name":"cratereader"}}],[11,"read_crates","","",403,null],[11,"read_exported_macros","","Read exported macros.",403,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path and symbol name.",403,{"inputs":[{"name":"cratereader"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","rustc::metadata::cstore","",405,{"inputs":[{"name":"linkagepreference"}],"output":{"name":"linkagepreference"}}],[11,"eq","","",405,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"ne","","",405,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"fmt","","",405,{"inputs":[{"name":"linkagepreference"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",406,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"ne","","",406,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"clone","","",406,{"inputs":[{"name":"nativelibrarykind"}],"output":{"name":"nativelibrarykind"}}],[11,"from_u32","","",406,{"inputs":[{"name":"nativelibrarykind"},{"name":"u32"}],"output":{"name":"option"}}],[11,"clone","","",407,{"inputs":[{"name":"cratesource"}],"output":{"name":"cratesource"}}],[11,"eq","","",407,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",407,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"new","","",408,{"inputs":[{"name":"cstore"},{"name":"rc"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","",408,{"inputs":[{"name":"cstore"}],"output":{"name":"u32"}}],[11,"get_crate_data","","",408,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"rc"}}],[11,"get_crate_hash","","",408,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"svh"}}],[11,"set_crate_data","","",408,null],[11,"iter_crate_data","","",408,null],[11,"iter_crate_data_origins","","Like `iter_crate_data`, but passes source paths (if available) as well.",408,null],[11,"add_used_crate_source","","",408,null],[11,"get_used_crate_source","","",408,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"reset","","",408,null],[11,"get_used_crates","","",408,{"inputs":[{"name":"cstore"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[11,"add_used_library","","",408,null],[11,"get_used_libraries","","",408,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_used_link_args","","",408,null],[11,"get_used_link_args","","",408,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_extern_mod_stmt_cnum","","",408,null],[11,"find_extern_mod_stmt_cnum","","",408,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"data","","",55,null],[11,"name","","",55,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"string"}}],[11,"hash","","",55,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"svh"}}],[11,"as_slice","","",409,null],[11,"clone","rustc::metadata::csearch","",410,{"inputs":[{"name":"methodinfo"}],"output":{"name":"methodinfo"}}],[11,"maybe_load_library_crate","rustc::metadata::loader","",411,{"inputs":[{"name":"context"}],"output":{"name":"option"}}],[11,"load_library_crate","","",411,{"inputs":[{"name":"context"}],"output":{"name":"library"}}],[11,"report_load_errs","","",411,null],[11,"as_slice","","",412,null],[11,"clone","rustc::metadata::filesearch","",413,{"inputs":[{"name":"filematch"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",414,null],[11,"get_lib_path","","",414,{"inputs":[{"name":"filesearch"}],"output":{"name":"pathbuf"}}],[11,"search","","",414,null],[11,"new","","",414,{"inputs":[{"name":"filesearch"},{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",414,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"get_tools_search_paths","","",414,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"visit_item","rustc::metadata::macro_import","",415,null],[11,"visit_mac","","",415,null],[11,"eq","rustc::session::config","",416,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"ne","","",416,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"clone","","",416,{"inputs":[{"name":"optlevel"}],"output":{"name":"optlevel"}}],[11,"eq","","",417,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"ne","","",417,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"clone","","",417,{"inputs":[{"name":"debuginfolevel"}],"output":{"name":"debuginfolevel"}}],[11,"cmp","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",418,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",418,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[11,"clone","","",419,{"inputs":[{"name":"options"}],"output":{"name":"options"}}],[11,"clone","","",420,{"inputs":[{"name":"unstablefeatures"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",421,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"ne","","",421,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"clone","","",421,{"inputs":[{"name":"printrequest"}],"output":{"name":"printrequest"}}],[11,"clone","","",422,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"outputfilenames"}}],[11,"path","","",422,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","",422,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",422,{"inputs":[{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",422,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"string"}}],[11,"eq","","",423,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"ne","","",423,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"clone","","",423,{"inputs":[{"name":"entryfntype"}],"output":{"name":"entryfntype"}}],[11,"fmt","","",424,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",424,null],[11,"cmp","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"clone","","",424,{"inputs":[{"name":"cratetype"}],"output":{"name":"cratetype"}}],[11,"partial_cmp","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"option"}}],[11,"lt","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"le","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"gt","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ge","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"eq","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ne","","",424,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"clone","","",425,{"inputs":[{"name":"passes"}],"output":{"name":"passes"}}],[11,"is_empty","","",425,{"inputs":[{"name":"passes"}],"output":{"name":"bool"}}],[11,"clone","","",426,{"inputs":[{"name":"codegenoptions"}],"output":{"name":"codegenoptions"}}],[11,"clone","","",427,{"inputs":[{"name":"debuggingoptions"}],"output":{"name":"debuggingoptions"}}],[11,"fmt","","",428,{"inputs":[{"name":"optionstability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",428,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"ne","","",428,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"clone","","",428,{"inputs":[{"name":"optionstability"}],"output":{"name":"optionstability"}}],[11,"eq","","",429,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"ne","","",429,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"clone","","",429,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"rustcoptgroup"}}],[11,"is_stable","","",429,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"fmt","","",424,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::session::search_paths","",430,{"inputs":[{"name":"searchpaths"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",430,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",431,{"inputs":[{"name":"pathkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",431,{"inputs":[{"name":"pathkind"}],"output":{"name":"pathkind"}}],[11,"eq","","",431,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"ne","","",431,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",430,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"add_path","","",430,null],[11,"iter","","",430,{"inputs":[{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"iter"}}],[6,"Item","rustdoc::core","",null,null],[11,"next","rustc::session::search_paths","",432,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"span_fatal","rustc::session","",433,null],[11,"span_fatal_with_code","","",433,null],[11,"fatal","","",433,null],[11,"span_err","","",433,null],[11,"span_err_with_code","","",433,null],[11,"err","","",433,null],[11,"err_count","","",433,{"inputs":[{"name":"session"}],"output":{"name":"usize"}}],[11,"has_errors","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",433,null],[11,"span_warn","","",433,null],[11,"span_warn_with_code","","",433,null],[11,"warn","","",433,null],[11,"opt_span_warn","","",433,null],[11,"span_note","","",433,null],[11,"span_end_note","","",433,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",433,null],[11,"span_help","","",433,null],[11,"fileline_note","","",433,null],[11,"fileline_help","","",433,null],[11,"note","","",433,null],[11,"help","","",433,null],[11,"opt_span_bug","","",433,null],[11,"span_bug","","",433,null],[11,"bug","","",433,null],[11,"span_unimpl","","",433,null],[11,"unimpl","","",433,null],[11,"add_lint","","",433,null],[11,"next_node_id","","",433,{"inputs":[{"name":"session"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",433,{"inputs":[{"name":"session"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"diagnostic","","",433,{"inputs":[{"name":"session"}],"output":{"name":"spanhandler"}}],[11,"codemap","","",433,{"inputs":[{"name":"session"}],"output":{"name":"codemap"}}],[11,"impossible_case","","",433,null],[11,"verbose","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_passes","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_type_sizes","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"trans_stats","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"meta_stats","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"asm_comments","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_verify","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"lto","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"unstable_options","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_enum_sizes","","",433,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"sysroot","","",433,{"inputs":[{"name":"session"}],"output":{"name":"path"}}],[11,"target_filesearch","","",433,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",433,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"args","rustc::plugin::registry","Get the plugin's arguments, if any.",434,{"inputs":[{"name":"registry"}],"output":{"name":"vec"}}],[11,"register_syntax_extension","","Register a syntax extension of any kind.",434,null],[11,"register_macro","","Register a macro of the usual kind.",434,null],[11,"register_lint_pass","","Register a compiler lint pass.",434,null],[11,"register_lint_group","","Register a lint group.",434,null],[11,"register_llvm_pass","","Register an LLVM pass.",434,null],[11,"visit_item","rustc::plugin::build","",435,null],[11,"fmt","rustc::lint","",436,{"inputs":[{"name":"lint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",436,{"inputs":[{"name":"lint"}],"output":{"name":"lint"}}],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",436,{"inputs":[{"name":"lint"}],"output":{"name":"string"}}],[11,"clone","","",437,{"inputs":[{"name":"lintid"}],"output":{"name":"lintid"}}],[11,"eq","","",437,{"inputs":[{"name":"lintid"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",437,null],[11,"of","","Get the `LintId` for a `Lint`.",437,{"inputs":[{"name":"lintid"},{"name":"lint"}],"output":{"name":"lintid"}}],[11,"as_str","","Get the name of the lint.",437,{"inputs":[{"name":"lintid"}],"output":{"name":"string"}}],[11,"fmt","","",438,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"option"}}],[11,"lt","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"le","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"gt","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ge","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"eq","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",438,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",438,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"as_str","","Convert a level to a lower-case string.",438,{"inputs":[{"name":"level"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",438,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"option"}}],[11,"eq","","",439,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",439,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"clone","","",439,{"inputs":[{"name":"lintsource"}],"output":{"name":"lintsource"}}],[11,"clone","rustc::lint::builtin","",440,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",440,null],[11,"new","rustc::lint::context","",441,{"inputs":[{"name":"lintstore"}],"output":{"name":"lintstore"}}],[11,"get_lints","","",441,null],[11,"get_lint_groups","","",441,{"inputs":[{"name":"lintstore"}],"output":{"name":"vec"}}],[11,"register_pass","","",441,null],[11,"register_group","","",441,null],[11,"register_renamed","","",441,null],[11,"process_command_line","","",441,null],[11,"sess","","Get the overall compiler `Session` object.",442,{"inputs":[{"name":"context"}],"output":{"name":"session"}}],[11,"current_level","","Get the level of `lint` at the current position of the lint\ntraversal.",442,{"inputs":[{"name":"context"},{"name":"lint"}],"output":{"name":"level"}}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",442,null],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",442,null],[11,"visit_item","","",442,null],[11,"visit_foreign_item","","",442,null],[11,"visit_pat","","",442,null],[11,"visit_expr","","",442,null],[11,"visit_stmt","","",442,null],[11,"visit_fn","","",442,null],[11,"visit_struct_def","","",442,null],[11,"visit_struct_field","","",442,null],[11,"visit_variant","","",442,null],[11,"visit_ty","","",442,null],[11,"visit_ident","","",442,null],[11,"visit_mod","","",442,null],[11,"visit_local","","",442,null],[11,"visit_block","","",442,null],[11,"visit_arm","","",442,null],[11,"visit_decl","","",442,null],[11,"visit_expr_post","","",442,null],[11,"visit_generics","","",442,null],[11,"visit_trait_item","","",442,null],[11,"visit_impl_item","","",442,null],[11,"visit_opt_lifetime_ref","","",442,null],[11,"visit_lifetime_ref","","",442,null],[11,"visit_lifetime_def","","",442,null],[11,"visit_explicit_self","","",442,null],[11,"visit_mac","","",442,null],[11,"visit_path","","",442,null],[11,"visit_attribute","","",442,null],[11,"visit_id","","",442,null],[11,"get_lints","","",443,null],[11,"check_item","","",443,null],[11,"fmt","rustc::util::common","",444,{"inputs":[{"name":"errorreported"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",444,{"inputs":[{"name":"errorreported"}],"output":{"name":"errorreported"}}],[11,"drop","","",445,null],[11,"visit_expr","","",446,null],[11,"visit_expr","","",447,null],[11,"repr","core::option","",52,{"inputs":[{"name":"option"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ptr","",50,{"inputs":[{"name":"p"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::result","",201,{"inputs":[{"name":"result"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::rc","",51,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::boxed","",384,{"inputs":[{"name":"box"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::owned_slice","",54,{"inputs":[{"name":"ownedslice"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::vec","",383,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",383,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::def","",125,{"inputs":[{"name":"def"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",359,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",59,{"inputs":[{"name":"typeparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",69,{"inputs":[{"name":"regionparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",348,{"inputs":[{"name":"tys"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",332,{"inputs":[{"name":"mt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",65,{"inputs":[{"name":"substs"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",49,{"inputs":[{"name":"vecperparamspace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",374,{"inputs":[{"name":"itemsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",292,{"inputs":[{"name":"regionsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::enum_set","",387,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",64,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",63,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",448,{"inputs":[{"name":"traitdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",87,{"inputs":[{"name":"traititem"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",267,{"inputs":[{"name":"expr"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",100,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",100,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",91,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",449,{"inputs":[{"name":"item"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",67,{"inputs":[{"name":"lifetime"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",450,{"inputs":[{"name":"spanned"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",268,{"inputs":[{"name":"pat"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",129,{"inputs":[{"name":"boundregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",70,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",70,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",126,{"inputs":[{"name":"freeregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::region","",127,{"inputs":[{"name":"codeextent"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",128,{"inputs":[{"name":"destructionscopedata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",123,{"inputs":[{"name":"defid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",373,{"inputs":[{"name":"typescheme"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",369,{"inputs":[{"name":"generics"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",370,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",371,{"inputs":[{"name":"instantiatedpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",334,{"inputs":[{"name":"itemvariances"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",335,{"inputs":[{"name":"variance"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",89,{"inputs":[{"name":"method"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",104,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",104,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",103,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",80,{"inputs":[{"name":"explicitself_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",95,{"inputs":[{"name":"visibility"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",350,{"inputs":[{"name":"barefnty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",352,{"inputs":[{"name":"fnsig"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",82,{"inputs":[{"name":"fnoutput"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",342,{"inputs":[{"name":"methodcallee"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",134,{"inputs":[{"name":"methodorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",340,{"inputs":[{"name":"methodparam"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",341,{"inputs":[{"name":"methodobject"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",62,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",62,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",99,{"inputs":[{"name":"span"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","alloc::rc","",51,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",64,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",61,{"inputs":[{"name":"existentialbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","collections::enum_set","",387,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",53,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",63,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","syntax::ast","",103,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::abi","",386,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",386,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",356,{"inputs":[{"name":"upvarid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",106,{"inputs":[{"name":"mutability"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",357,{"inputs":[{"name":"borrowkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",132,{"inputs":[{"name":"upvarborrow"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",133,{"inputs":[{"name":"upvarcapture"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",232,{"inputs":[{"name":"intvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",234,{"inputs":[{"name":"floatvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",364,{"inputs":[{"name":"regionvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",363,{"inputs":[{"name":"tyvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",233,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",451,{"inputs":[{"name":"intty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",452,{"inputs":[{"name":"uintty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",235,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",381,{"inputs":[{"name":"explicitselfcategory"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",353,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",353,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",53,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","std::collections::hash::map","",453,{"inputs":[{"name":"hashmap"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",75,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",74,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",73,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",76,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",77,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",77,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",72,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",385,{"inputs":[{"name":"unsafety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"default","rustc::util::nodemap","",454,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"fnvhasher"}}],[11,"write","","",454,null],[11,"finish","","",454,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"u64"}}],[11,"new","rustc::util::snapshot_vec","",455,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"snapshotvec"}}],[11,"record","","",455,null],[11,"push","","",455,null],[11,"get","","",455,null],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone\nautomatically, so you should be sure call `record()` with some sort of suitable undo\naction.",455,null],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if\na snapshot is active.",455,null],[11,"start_snapshot","","",455,{"inputs":[{"name":"snapshotvec"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",455,null],[11,"rollback_to","","",455,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",455,null],[11,"input","rustc_back::sha2","",456,null],[11,"reset","","",456,null],[11,"zero_until","","",456,null],[11,"next","","",456,null],[11,"full_buffer","","",456,null],[11,"position","","",456,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"remaining","","",456,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"size","","",456,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",457,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",457,null],[11,"result","","",457,null],[11,"reset","","",457,null],[11,"output_bits","","",457,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[11,"open","rustc_llvm::archive_ro","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",458,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",458,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",458,null],[11,"clone","rustc_llvm::diagnostic","",459,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",459,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",460,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",461,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",462,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",462,null],[11,"eq","rustc_llvm","",463,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",463,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",463,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",464,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",465,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",466,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",466,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",467,null],[11,"cmp","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",467,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",467,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",467,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",467,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",467,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",467,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",467,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",467,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",467,null],[11,"remove","","Removes the specified flags in-place.",467,null],[11,"toggle","","Toggles the specified flags in-place.",467,null],[6,"Output","rustdoc::core","",null,null],[11,"bitor","rustc_llvm","Returns the union of the two sets of flags.",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitxor","rustc_llvm","Returns the left flags, but with all the right flags toggled.",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustdoc::core","",null,null],[11,"bitand","rustc_llvm","Returns the intersection between the two sets of flags.",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustdoc::core","",null,null],[11,"sub","rustc_llvm","Returns the set difference of the two sets of flags.",467,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustdoc::core","",null,null],[11,"not","rustc_llvm","Returns the complement of this set of flags.",467,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",468,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",469,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",470,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",467,null],[11,"apply_callsite","","",467,null],[11,"apply_llfn","","",468,null],[11,"apply_callsite","","",468,null],[11,"apply_llfn","","",469,null],[11,"apply_callsite","","",469,null],[11,"new","","",471,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",471,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",471,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",471,null],[11,"apply_callsite","","",471,null],[11,"clone","","",472,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",473,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",474,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",474,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",474,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",474,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",475,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",476,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",477,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",478,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",479,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",480,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",480,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",480,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",481,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",481,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",481,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",482,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",483,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"clone","rustc_llvm::debuginfo","",484,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[11,"drop","rustc_llvm","",485,null],[11,"new","","",486,null],[11,"drop","","",486,null],[11,"drop","","",487,null],[4,"Input","rustdoc::core","",null,null],[13,"File","","Load source from file",114,null],[13,"Str","","The string is the source",114,null],[3,"SearchPaths","","",null,null],[3,"DocContext","","",null,null],[12,"krate","","",488,null],[12,"maybe_typed","","",488,null],[12,"input","","",488,null],[12,"external_paths","","",488,null],[12,"external_traits","","",488,null],[12,"external_typarams","","",488,null],[12,"inlined","","",488,null],[12,"populated_crate_impls","","",488,null],[3,"CrateAnalysis","","",null,null],[12,"exported_items","","",489,null],[12,"public_items","","",489,null],[12,"external_paths","","",489,null],[12,"external_typarams","","",489,null],[12,"inlined","","",489,null],[4,"MaybeTyped","","Are we generating documentation (`Typed`) or tests (`NotTyped`)?",null,null],[13,"Typed","","",490,null],[13,"NotTyped","","",490,null],[5,"run_core","","",null,null],[6,"ExternalPaths","","",null,null],[6,"Externs","","",null,null],[11,"sess","","",488,{"inputs":[{"name":"doccontext"}],"output":{"name":"session"}}],[11,"tcx_opt","","",488,{"inputs":[{"name":"doccontext"}],"output":{"name":"option"}}],[11,"tcx","","",488,{"inputs":[{"name":"doccontext"}],"output":{"name":"ctxt"}}],[0,"doctree","rustdoc","This module is used to store stuff from Rust's AST in a more convenient\nmanner (and with prettier names) before cleaning.",null,null],[3,"Module","rustdoc::doctree","",null,null],[12,"name","","",491,null],[12,"attrs","","",491,null],[12,"where_outer","","",491,null],[12,"where_inner","","",491,null],[12,"extern_crates","","",491,null],[12,"imports","","",491,null],[12,"structs","","",491,null],[12,"enums","","",491,null],[12,"fns","","",491,null],[12,"mods","","",491,null],[12,"id","","",491,null],[12,"typedefs","","",491,null],[12,"statics","","",491,null],[12,"constants","","",491,null],[12,"traits","","",491,null],[12,"vis","","",491,null],[12,"stab","","",491,null],[12,"impls","","",491,null],[12,"def_traits","","",491,null],[12,"foreigns","","",491,null],[12,"macros","","",491,null],[12,"is_crate","","",491,null],[3,"Struct","","",null,null],[12,"vis","","",492,null],[12,"stab","","",492,null],[12,"id","","",492,null],[12,"struct_type","","",492,null],[12,"name","","",492,null],[12,"generics","","",492,null],[12,"attrs","","",492,null],[12,"fields","","",492,null],[12,"whence","","",492,null],[3,"Enum","","",null,null],[12,"vis","","",493,null],[12,"stab","","",493,null],[12,"variants","","",493,null],[12,"generics","","",493,null],[12,"attrs","","",493,null],[12,"id","","",493,null],[12,"whence","","",493,null],[12,"name","","",493,null],[3,"Variant","","",null,null],[12,"name","","",494,null],[12,"attrs","","",494,null],[12,"kind","","",494,null],[12,"id","","",494,null],[12,"vis","","",494,null],[12,"stab","","",494,null],[12,"whence","","",494,null],[3,"Function","","",null,null],[12,"decl","","",495,null],[12,"attrs","","",495,null],[12,"id","","",495,null],[12,"name","","",495,null],[12,"vis","","",495,null],[12,"stab","","",495,null],[12,"unsafety","","",495,null],[12,"whence","","",495,null],[12,"generics","","",495,null],[12,"abi","","",495,null],[3,"Typedef","","",null,null],[12,"ty","","",496,null],[12,"gen","","",496,null],[12,"name","","",496,null],[12,"id","","",496,null],[12,"attrs","","",496,null],[12,"whence","","",496,null],[12,"vis","","",496,null],[12,"stab","","",496,null],[3,"Static","","",null,null],[12,"type_","","",497,null],[12,"mutability","","",497,null],[12,"expr","","",497,null],[12,"name","","",497,null],[12,"attrs","","",497,null],[12,"vis","","",497,null],[12,"stab","","",497,null],[12,"id","","",497,null],[12,"whence","","",497,null],[3,"Constant","","",null,null],[12,"type_","","",498,null],[12,"expr","","",498,null],[12,"name","","",498,null],[12,"attrs","","",498,null],[12,"vis","","",498,null],[12,"stab","","",498,null],[12,"id","","",498,null],[12,"whence","","",498,null],[3,"Trait","","",null,null],[12,"unsafety","","",499,null],[12,"name","","",499,null],[12,"items","","",499,null],[12,"generics","","",499,null],[12,"bounds","","",499,null],[12,"attrs","","",499,null],[12,"id","","",499,null],[12,"whence","","",499,null],[12,"vis","","",499,null],[12,"stab","","",499,null],[3,"Impl","","",null,null],[12,"unsafety","","",500,null],[12,"polarity","","",500,null],[12,"generics","","",500,null],[12,"trait_","","",500,null],[12,"for_","","",500,null],[12,"items","","",500,null],[12,"attrs","","",500,null],[12,"whence","","",500,null],[12,"vis","","",500,null],[12,"stab","","",500,null],[12,"id","","",500,null],[3,"DefaultImpl","","",null,null],[12,"unsafety","","",501,null],[12,"trait_","","",501,null],[12,"id","","",501,null],[12,"attrs","","",501,null],[12,"whence","","",501,null],[3,"Macro","","",null,null],[12,"name","","",502,null],[12,"id","","",502,null],[12,"attrs","","",502,null],[12,"whence","","",502,null],[12,"stab","","",502,null],[3,"ExternCrate","","",null,null],[12,"name","","",503,null],[12,"path","","",503,null],[12,"vis","","",503,null],[12,"attrs","","",503,null],[12,"whence","","",503,null],[3,"Import","","",null,null],[12,"id","","",504,null],[12,"vis","","",504,null],[12,"attrs","","",504,null],[12,"node","","",504,null],[12,"whence","","",504,null],[4,"StructType","","",null,null],[13,"Plain","","A normal struct",505,null],[13,"Tuple","","A tuple struct",505,null],[13,"Newtype","","A newtype struct (tuple struct with one element)",505,null],[13,"Unit","","A unit struct",505,null],[4,"TypeBound","","",null,null],[13,"RegionBound","","",506,null],[13,"TraitBound","","",506,null],[5,"struct_type_from_def","","",null,{"inputs":[{"name":"structdef"}],"output":{"name":"structtype"}}],[11,"new","","",491,{"inputs":[{"name":"module"},{"name":"option"}],"output":{"name":"module"}}],[11,"decode","","",505,{"inputs":[{"name":"structtype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",505,{"inputs":[{"name":"structtype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",505,{"inputs":[{"name":"structtype"}],"output":{"name":"structtype"}}],[11,"fmt","","",505,{"inputs":[{"name":"structtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",497,{"inputs":[{"name":"static"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"fold","rustdoc","",null,null],[8,"DocFolder","rustdoc::fold","",null,null],[11,"fold_item","","",507,{"inputs":[{"name":"docfolder"},{"name":"item"}],"output":{"name":"option"}}],[11,"fold_item_recur","","don't override!",507,{"inputs":[{"name":"docfolder"},{"name":"item"}],"output":{"name":"option"}}],[11,"fold_mod","","",507,{"inputs":[{"name":"docfolder"},{"name":"module"}],"output":{"name":"module"}}],[11,"fold_crate","","",507,{"inputs":[{"name":"docfolder"},{"name":"crate"}],"output":{"name":"crate"}}],[0,"html","rustdoc","",null,null],[0,"highlight","rustdoc::html","Basic html highlighting functionality",null,null],[5,"highlight","rustdoc::html::highlight","Highlights some source code, returning the HTML output.",null,{"inputs":[{"name":"str"},{"name":"option"},{"name":"option"}],"output":{"name":"string"}}],[0,"escape","rustdoc::html","HTML Escaping",null,null],[3,"Escape","rustdoc::html::escape","Wrapper struct which will emit the HTML-escaped version of the contained\nstring when passed to a format string.",null,null],[11,"fmt","","",508,{"inputs":[{"name":"escape"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"item_type","rustdoc::html","Item types.",null,null],[4,"ItemType","rustdoc::html::item_type","Item type. Corresponds to `clean::ItemEnum` variants.",null,null],[13,"Module","","",509,null],[13,"ExternCrate","","",509,null],[13,"Import","","",509,null],[13,"Struct","","",509,null],[13,"Enum","","",509,null],[13,"Function","","",509,null],[13,"Typedef","","",509,null],[13,"Static","","",509,null],[13,"Trait","","",509,null],[13,"Impl","","",509,null],[13,"TyMethod","","",509,null],[13,"Method","","",509,null],[13,"StructField","","",509,null],[13,"Variant","","",509,null],[13,"Macro","","",509,null],[13,"Primitive","","",509,null],[13,"AssociatedType","","",509,null],[13,"Constant","","",509,null],[11,"clone","","",509,{"inputs":[{"name":"itemtype"}],"output":{"name":"itemtype"}}],[11,"eq","","",509,{"inputs":[{"name":"itemtype"},{"name":"itemtype"}],"output":{"name":"bool"}}],[11,"ne","","",509,{"inputs":[{"name":"itemtype"},{"name":"itemtype"}],"output":{"name":"bool"}}],[11,"from_item","","",509,{"inputs":[{"name":"itemtype"},{"name":"item"}],"output":{"name":"itemtype"}}],[11,"from_type_kind","","",509,{"inputs":[{"name":"itemtype"},{"name":"typekind"}],"output":{"name":"itemtype"}}],[11,"to_static_str","","",509,{"inputs":[{"name":"itemtype"}],"output":{"name":"str"}}],[11,"fmt","","",509,{"inputs":[{"name":"itemtype"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"format","rustdoc::html","HTML formatting module",null,null],[3,"VisSpace","rustdoc::html::format","Helper to render an optional visibility with a space after it (if the\nvisibility is preset)",null,null],[3,"UnsafetySpace","","Similarly to VisSpace, this structure is used to render a function style with a\nspace after it.",null,null],[3,"Method","","Wrapper struct for properly emitting a method declaration.",null,null],[3,"MutableSpace","","Similar to VisSpace, but used for mutability",null,null],[3,"RawMutableSpace","","Similar to VisSpace, but used for mutability",null,null],[3,"Stability","","Wrapper struct for properly emitting the stability level.",null,null],[3,"ConciseStability","","Wrapper struct for emitting the stability level concisely.",null,null],[3,"WhereClause","","Wrapper struct for emitting a where clause from Generics.",null,null],[3,"TyParamBounds","","Wrapper struct for emitting type parameter bounds.",null,null],[3,"CommaSep","","Wrapper struct for emitting a comma-separated list of items",null,null],[3,"AbiSpace","","",null,null],[5,"href","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"option"}}],[11,"clone","","",510,{"inputs":[{"name":"visspace"}],"output":{"name":"visspace"}}],[11,"clone","","",511,{"inputs":[{"name":"unsafetyspace"}],"output":{"name":"unsafetyspace"}}],[11,"clone","","",512,{"inputs":[{"name":"mutablespace"}],"output":{"name":"mutablespace"}}],[11,"clone","","",513,{"inputs":[{"name":"rawmutablespace"}],"output":{"name":"rawmutablespace"}}],[11,"get","","",510,{"inputs":[{"name":"visspace"}],"output":{"name":"option"}}],[11,"get","","",511,{"inputs":[{"name":"unsafetyspace"}],"output":{"name":"unsafety"}}],[11,"fmt","","",514,{"inputs":[{"name":"commasep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",515,{"inputs":[{"name":"typarambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustdoc::clean","",6,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustdoc::html::format","",516,{"inputs":[{"name":"whereclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustdoc::clean","",66,{"inputs":[{"name":"lifetime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",14,{"inputs":[{"name":"polytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",35,{"inputs":[{"name":"typarambound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",44,{"inputs":[{"name":"pathparameters"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",21,{"inputs":[{"name":"pathsegment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",20,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",39,{"inputs":[{"name":"type"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",11,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",38,{"inputs":[{"name":"functionretty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",10,{"inputs":[{"name":"fndecl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustdoc::html::format","",517,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",510,{"inputs":[{"name":"visspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",511,{"inputs":[{"name":"unsafetyspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustdoc::clean","",47,{"inputs":[{"name":"import"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",28,{"inputs":[{"name":"importsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",29,{"inputs":[{"name":"viewlistident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",32,{"inputs":[{"name":"typebinding"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustdoc::html::format","",512,{"inputs":[{"name":"mutablespace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",513,{"inputs":[{"name":"rawmutablespace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",518,{"inputs":[{"name":"abispace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",519,{"inputs":[{"name":"stability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",520,{"inputs":[{"name":"concisestability"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"layout","rustdoc::html","",null,null],[3,"Layout","rustdoc::html::layout","",null,null],[12,"logo","","",521,null],[12,"favicon","","",521,null],[12,"external_html","","",521,null],[12,"krate","","",521,null],[12,"playground_url","","",521,null],[3,"Page","","",null,null],[12,"title","","",522,null],[12,"ty","","",522,null],[12,"root_path","","",522,null],[12,"description","","",522,null],[12,"keywords","","",522,null],[5,"render","","",null,{"inputs":[{"name":"write"},{"name":"layout"},{"name":"page"},{"name":"s"},{"name":"t"}],"output":{"name":"result"}}],[5,"redirect","","",null,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"clone","","",521,{"inputs":[{"name":"layout"}],"output":{"name":"layout"}}],[0,"markdown","rustdoc::html","Markdown formatting for rustdoc",null,null],[3,"Markdown","rustdoc::html::markdown","A unit struct which has the `fmt::String` trait implemented. When\nformatted, this struct will emit the HTML corresponding to the rendered\nversion of the contained markdown string.",null,null],[3,"MarkdownWithToc","","A unit struct like `Markdown`, that renders the markdown with a\ntable of contents.",null,null],[5,"render","","",null,{"inputs":[{"name":"formatter"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[5,"find_testable_code","","",null,{"inputs":[{"name":"str"},{"name":"collector"}],"output":null}],[5,"reset_headers","","By default this markdown renderer generates anchors for each header in the\nrendered document. The anchor name is the contents of the header separated\nby hyphens, and a thread-local map is used to disambiguate among duplicate\nheaders (numbers are appended).",null,{"inputs":[],"output":null}],[5,"plain_summary_line","","",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[7,"PLAYGROUND_KRATE","","",null,null],[11,"fmt","","",523,{"inputs":[{"name":"markdown"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",524,{"inputs":[{"name":"markdownwithtoc"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"render","rustdoc::html","Rustdoc's HTML Rendering module",null,null],[3,"Context","rustdoc::html::render","Major driving force in all rustdoc rendering. This contains information\nabout where in the tree-like hierarchy rendering is occurring and controls\nhow the current page is being rendered.",null,null],[12,"current","","Current hierarchy of components leading down to what's currently being\nrendered",525,null],[12,"root_path","","String representation of how to get back to the root path of the 'doc/'\nfolder in terms of a relative URL.",525,null],[12,"src_root","","The path to the crate root source minus the file name.\nUsed for simplifying paths to the highlighted source code files.",525,null],[12,"dst","","The current destination folder of where HTML artifacts should be placed.\nThis changes as the context descends into the module hierarchy.",525,null],[12,"layout","","This describes the layout of each page, and is not modified after\ncreation of the context (contains info like the favicon and added html).",525,null],[12,"include_sources","","This flag indicates whether [src] links should be generated or not. If\nthe source files are present in the html rendering, then this will be\n`true`.",525,null],[12,"render_redirect_pages","","A flag, which when turned off, will render pages which redirect to the\nreal location of an item. This is used to allow external links to\npublicly reused items to redirect to the right location.",525,null],[12,"passes","","All the passes that were run on this crate.",525,null],[3,"Implementor","","Metadata about an implementor of a trait.",null,null],[12,"def_id","","",526,null],[12,"generics","","",526,null],[12,"trait_","","",526,null],[12,"for_","","",526,null],[12,"stability","","",526,null],[12,"polarity","","",526,null],[3,"Impl","","Metadata about implementations for a type.",null,null],[12,"impl_","","",527,null],[12,"dox","","",527,null],[12,"stability","","",527,null],[3,"Cache","","This cache is used to store information about the `clean::Crate` being\nrendered in order to provide more useful documentation. This contains\ninformation like all implementors of a trait, all traits a type implements,\ndocumentation for all known traits, etc.",null,null],[12,"typarams","","Mapping of typaram ids to the name of the type parameter. This is used\nwhen pretty-printing a type (so pretty printing doesn't have to\npainfully maintain a context like this)",528,null],[12,"impls","","Maps a type id to all known implementations for that type. This is only\nrecognized for intra-crate `ResolvedPath` types, and is used to print\nout extra documentation on the page of an enum/struct.",528,null],[12,"paths","","Maintains a mapping of local crate node ids to the fully qualified name\nand \"short type description\" of that node. This is used when generating\nURLs when a type is being linked to. External paths are not located in\nthis map because the `External` type itself has all the information\nnecessary.",528,null],[12,"external_paths","","Similar to `paths`, but only holds external paths. This is only used for\ngenerating explicit hyperlinks to other crates.",528,null],[12,"traits","","This map contains information about all known traits of this crate.\nImplementations of a crate should inherit the documentation of the\nparent trait if no extra documentation is specified, and default methods\nshould show up in documentation about trait implementations.",528,null],[12,"implementors","","When rendering traits, it's often useful to be able to list all\nimplementors of the trait, and this mapping is exactly, that: a mapping\nof trait ids to the list of known implementors of the trait",528,null],[12,"extern_locations","","Cache of where external crate documentation can be found.",528,null],[12,"primitive_locations","","Cache of where documentation for primitives can be found.",528,null],[12,"inlined","","Set of definitions which have been inlined from external crates.",528,null],[4,"ExternalLocation","","Indicates where an external crate can be found.",null,null],[13,"Remote","","Remote URL root of the external crate",529,null],[13,"Local","","This external crate can be found in the local doc/ folder",529,null],[13,"Unknown","","The external crate could not be found.",529,null],[5,"run","","Generates the documentation for `crate` into the directory `dst`",null,{"inputs":[{"name":"crate"},{"name":"externalhtml"},{"name":"pathbuf"},{"name":"hashset"}],"output":{"name":"result"}}],[5,"cache","","",null,{"inputs":[],"output":{"name":"arc"}}],[6,"NameDoc","","A pair of name and its optional document.",null,null],[7,"CURRENT_LOCATION_KEY","","",null,null],[11,"clone","","",525,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"clone","","",527,{"inputs":[{"name":"impl"}],"output":{"name":"impl"}}],[11,"default","","",528,{"inputs":[{"name":"cache"}],"output":{"name":"cache"}}],[11,"fold_item","","",528,{"inputs":[{"name":"cache"},{"name":"item"}],"output":{"name":"option"}}],[0,"toc","rustdoc::html","Table-of-contents creation.",null,null],[3,"Toc","rustdoc::html::toc","A (recursive) table of contents",null,null],[3,"TocEntry","","",null,null],[3,"TocBuilder","","Progressive construction of a table of contents.",null,null],[11,"eq","","",530,{"inputs":[{"name":"toc"},{"name":"toc"}],"output":{"name":"bool"}}],[11,"ne","","",530,{"inputs":[{"name":"toc"},{"name":"toc"}],"output":{"name":"bool"}}],[11,"eq","","",531,{"inputs":[{"name":"tocentry"},{"name":"tocentry"}],"output":{"name":"bool"}}],[11,"ne","","",531,{"inputs":[{"name":"tocentry"},{"name":"tocentry"}],"output":{"name":"bool"}}],[11,"eq","","",532,{"inputs":[{"name":"tocbuilder"},{"name":"tocbuilder"}],"output":{"name":"bool"}}],[11,"ne","","",532,{"inputs":[{"name":"tocbuilder"},{"name":"tocbuilder"}],"output":{"name":"bool"}}],[11,"new","","",532,{"inputs":[{"name":"tocbuilder"}],"output":{"name":"tocbuilder"}}],[11,"into_toc","","Convert into a true `Toc` struct.",532,{"inputs":[{"name":"tocbuilder"}],"output":{"name":"toc"}}],[11,"push","","Push a level `level` heading into the appropriate place in the\nhierarchy, returning a string containing the section number in\n`<num>.<num>.<num>` format.",532,{"inputs":[{"name":"tocbuilder"},{"name":"u32"},{"name":"string"},{"name":"string"}],"output":{"name":"str"}}],[11,"fmt","","",530,{"inputs":[{"name":"toc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",530,{"inputs":[{"name":"toc"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"markdown","rustdoc","",null,null],[5,"render","rustdoc::markdown","Render `input` (e.g. \"foo.md\") into an HTML file in `output`\n(e.g. output = \"bar\" => \"bar/foo.html\").",null,{"inputs":[{"name":"str"},{"name":"pathbuf"},{"name":"matches"},{"name":"externalhtml"},{"name":"bool"}],"output":{"name":"isize"}}],[5,"test","","Run any tests/code examples in the markdown file `input`.",null,{"inputs":[{"name":"str"},{"name":"searchpaths"},{"name":"externs"},{"name":"vec"}],"output":{"name":"isize"}}],[0,"passes","rustdoc","",null,null],[5,"strip_hidden","rustdoc::passes","Strip items marked `#[doc(hidden)]`",null,{"inputs":[{"name":"crate"}],"output":{"name":"pluginresult"}}],[5,"strip_private","","Strip private items from the point of view of a crate or externally from a\ncrate, specified by the `xcrate` flag.",null,{"inputs":[{"name":"crate"}],"output":{"name":"pluginresult"}}],[5,"unindent_comments","","",null,{"inputs":[{"name":"crate"}],"output":{"name":"pluginresult"}}],[5,"collapse_docs","","",null,{"inputs":[{"name":"crate"}],"output":{"name":"pluginresult"}}],[5,"unindent","","",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[0,"plugins","rustdoc","",null,null],[3,"PluginManager","rustdoc::plugins","Manages loading and running of plugins",null,null],[12,"prefix","","The directory plugins will be loaded from",533,null],[6,"PluginJson","","",null,null],[6,"PluginResult","","",null,null],[6,"PluginCallback","","",null,null],[11,"new","","Create a new plugin manager",533,{"inputs":[{"name":"pluginmanager"},{"name":"pathbuf"}],"output":{"name":"pluginmanager"}}],[11,"load_plugin","","Load a plugin with the given name.",533,{"inputs":[{"name":"pluginmanager"},{"name":"string"}],"output":null}],[11,"add_plugin","","Load a normal Rust function as a plugin.",533,{"inputs":[{"name":"pluginmanager"},{"name":"plugincallback"}],"output":null}],[11,"run_plugins","","Run all the loaded plugins over the crate, returning their results",533,null],[0,"stability_summary","rustdoc","This module crawls a `clean::Crate` and produces a summarization of the\nstability levels within the crate. The summary contains the module\nhierarchy, with item counts for every stability level per module. A parent\nmodule's count includes its children's.",null,null],[3,"Counts","rustdoc::stability_summary","The counts for each stability level.",null,null],[12,"deprecated","","",534,null],[12,"unstable","","",534,null],[12,"stable","","",534,null],[12,"unmarked","","No stability level, inherited or otherwise.",534,null],[3,"ModuleSummary","","A summarized module, which includes total counts and summarized children\nmodules.",null,null],[12,"name","","",535,null],[12,"counts","","",535,null],[12,"submodules","","",535,null],[5,"build","","Summarizes the stability levels in a crate.",null,{"inputs":[{"name":"crate"}],"output":{"name":"modulesummary"}}],[11,"eq","","",534,{"inputs":[{"name":"counts"},{"name":"counts"}],"output":{"name":"bool"}}],[11,"ne","","",534,{"inputs":[{"name":"counts"},{"name":"counts"}],"output":{"name":"bool"}}],[11,"decode","","",534,{"inputs":[{"name":"counts"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",534,{"inputs":[{"name":"counts"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",534,{"inputs":[{"name":"counts"}],"output":{"name":"counts"}}],[6,"Output","","",null,null],[11,"add","","",534,{"inputs":[{"name":"counts"},{"name":"counts"}],"output":{"name":"counts"}}],[11,"total","","",534,{"inputs":[{"name":"counts"}],"output":{"name":"u64"}}],[11,"eq","","",535,{"inputs":[{"name":"modulesummary"},{"name":"modulesummary"}],"output":{"name":"bool"}}],[11,"ne","","",535,{"inputs":[{"name":"modulesummary"},{"name":"modulesummary"}],"output":{"name":"bool"}}],[11,"decode","","",535,{"inputs":[{"name":"modulesummary"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",535,{"inputs":[{"name":"modulesummary"},{"name":"__s"}],"output":{"name":"result"}}],[11,"partial_cmp","","",535,{"inputs":[{"name":"modulesummary"},{"name":"modulesummary"}],"output":{"name":"option"}}],[11,"cmp","","",535,{"inputs":[{"name":"modulesummary"},{"name":"modulesummary"}],"output":{"name":"ordering"}}],[0,"visit_ast","rustdoc","Rust AST Visitor. Extracts useful information and massages it into a form\nusable for clean",null,null],[3,"RustdocVisitor","rustdoc::visit_ast","",null,null],[12,"module","","",536,null],[12,"attrs","","",536,null],[12,"cx","","",536,null],[12,"analysis","","",536,null],[11,"new","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"doccontext"},{"name":"option"}],"output":{"name":"rustdocvisitor"}}],[11,"visit","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"crate"}],"output":null}],[11,"visit_struct_def","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"item"},{"name":"ident"},{"name":"structdef"},{"name":"generics"}],"output":{"name":"struct"}}],[11,"visit_enum_def","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"item"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"name":"enum"}}],[11,"visit_fn","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"item"},{"name":"ident"},{"name":"fndecl"},{"name":"unsafety"},{"name":"abi"},{"name":"generics"}],"output":{"name":"function"}}],[11,"visit_mod_contents","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"span"},{"name":"vec"},{"name":"visibility"},{"name":"nodeid"},{"name":"mod"},{"name":"option"}],"output":{"name":"module"}}],[11,"visit_item","","",536,{"inputs":[{"name":"rustdocvisitor"},{"name":"item"},{"name":"option"},{"name":"module"}],"output":null}],[0,"test","rustdoc","",null,null],[3,"TestOptions","rustdoc::test","",null,null],[12,"no_crate_inject","","",537,null],[12,"attrs","","",537,null],[3,"Collector","","",null,null],[12,"tests","","",538,null],[5,"run","","",null,{"inputs":[{"name":"str"},{"name":"vec"},{"name":"searchpaths"},{"name":"externs"},{"name":"vec"},{"name":"option"}],"output":{"name":"isize"}}],[5,"maketest","","",null,{"inputs":[{"name":"str"},{"name":"option"},{"name":"bool"},{"name":"testoptions"}],"output":{"name":"string"}}],[11,"default","","",537,{"inputs":[{"name":"testoptions"}],"output":{"name":"testoptions"}}],[11,"clone","","",537,{"inputs":[{"name":"testoptions"}],"output":{"name":"testoptions"}}],[11,"new","","",538,{"inputs":[{"name":"collector"},{"name":"string"},{"name":"searchpaths"},{"name":"externs"},{"name":"bool"},{"name":"testoptions"}],"output":{"name":"collector"}}],[11,"add_test","","",538,{"inputs":[{"name":"collector"},{"name":"string"},{"name":"bool"},{"name":"bool"},{"name":"bool"},{"name":"bool"}],"output":null}],[11,"register_header","","",538,{"inputs":[{"name":"collector"},{"name":"str"},{"name":"u32"}],"output":null}],[11,"fold_item","","",538,{"inputs":[{"name":"collector"},{"name":"item"}],"output":{"name":"option"}}],[7,"ANALYSISKEY","rustdoc","",null,null],[11,"clean","rustdoc::visit_ast","",536,null],[11,"clean","rustdoc::doctree","",491,null],[11,"clean","","",495,null],[11,"clean","","",499,null],[11,"clean","","",492,null],[11,"clean","","",493,null],[11,"clean","","",494,null],[11,"clean","","",496,null],[11,"clean","","",497,null],[11,"clean","","",498,null],[11,"clean","","",500,null],[11,"clean","","",501,null],[11,"clean","","",503,null],[11,"clean","","",504,null],[11,"clean","","",502,null],[11,"fmt","rustdoc::stability_summary","",535,null]],"paths":[[3,"ExternalHtml"],[3,"Crate"],[3,"ExternalCrate"],[3,"Item"],[3,"Module"],[3,"TyParam"],[3,"Generics"],[3,"Method"],[3,"TyMethod"],[3,"Function"],[3,"FnDecl"],[3,"Arguments"],[3,"Argument"],[3,"Trait"],[3,"PolyTrait"],[3,"Struct"],[3,"VariantStruct"],[3,"Enum"],[3,"Variant"],[3,"Span"],[3,"Path"],[3,"PathSegment"],[3,"Typedef"],[3,"BareFunctionDecl"],[3,"Static"],[3,"Constant"],[3,"Impl"],[3,"DefaultImpl"],[3,"ImportSource"],[3,"ViewListIdent"],[3,"Macro"],[3,"Stability"],[3,"TypeBinding"],[4,"ItemEnum"],[4,"Attribute"],[4,"TyParamBound"],[4,"WherePredicate"],[4,"SelfTy"],[4,"FunctionRetTy"],[4,"Type"],[4,"PrimitiveType"],[4,"TypeKind"],[4,"StructField"],[4,"VariantKind"],[4,"PathParameters"],[4,"Mutability"],[4,"ImplPolarity"],[4,"Import"],[8,"Clean"],[3,"VecPerParamSpace"],[3,"P"],[3,"Rc"],[4,"Option"],[3,"Binder"],[3,"OwnedSlice"],[3,"crate_metadata"],[6,"MetaItem"],[6,"Attribute"],[3,"TyParam"],[3,"TypeParameterDef"],[4,"TyParamBound"],[3,"ExistentialBounds"],[4,"BuiltinBound"],[3,"TraitRef"],[3,"ParamBounds"],[3,"Substs"],[3,"Lifetime"],[3,"Lifetime"],[3,"LifetimeDef"],[3,"RegionParameterDef"],[4,"Region"],[4,"WherePredicate"],[4,"Predicate"],[3,"TraitPredicate"],[3,"EquatePredicate"],[3,"OutlivesPredicate"],[3,"ProjectionPredicate"],[3,"ProjectionTy"],[3,"Generics"],[3,"MethodSig"],[4,"ExplicitSelf_"],[3,"FnDecl"],[4,"FnOutput"],[3,"Arg"],[4,"FunctionRetTy"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"TraitItem"],[3,"ImplItem"],[3,"Method"],[4,"ImplOrTraitItem"],[3,"Ty"],[6,"Ty"],[6,"StructField"],[3,"field_ty"],[4,"Visibility"],[3,"StructDef"],[3,"VariantInfo"],[4,"VariantKind"],[3,"Span"],[3,"Path"],[4,"PathParameters"],[3,"PathSegment"],[3,"Ident"],[3,"Name"],[3,"BareFnTy"],[4,"Mutability"],[4,"ImplPolarity"],[6,"PathListItem"],[3,"ForeignMod"],[3,"ForeignItem"],[3,"Stability"],[3,"AssociatedType"],[3,"TypeBinding"],[4,"Input"],[3,"Svh"],[4,"SawAbiComponent"],[4,"SawExprComponent"],[4,"SawStmtComponent"],[3,"StrictVersionHashVisitor"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"DecodeContext"],[3,"DefId"],[3,"NestedItemsDropper"],[4,"Def"],[3,"FreeRegion"],[4,"CodeExtent"],[3,"DestructionScopeData"],[4,"BoundRegion"],[3,"Decoder"],[3,"Freevar"],[3,"UpvarBorrow"],[4,"UpvarCapture"],[4,"MethodOrigin"],[3,"EncodeContext"],[3,"Encoder"],[3,"SideTableEncodingIdVisitor"],[3,"Doc"],[3,"LoopScope"],[3,"LabelledCFG"],[4,"CFGNodeData"],[3,"CFG"],[3,"ConstQualif"],[4,"Mode"],[3,"CheckCrateVisitor"],[3,"CheckCrateVisitor"],[3,"CheckItemRecursionVisitor"],[4,"Context"],[3,"CheckLoopVisitor"],[3,"Matrix"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"MatchCheckCtxt"],[3,"StaticInliner"],[3,"RenamingRecorder"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[3,"RvalueContext"],[3,"RvalueContextDelegate"],[4,"const_val"],[3,"ConstEvalErr"],[4,"ErrKind"],[4,"IntTy"],[4,"UintTy"],[4,"EntryOrExit"],[3,"DataFlowContext"],[4,"KillFrom"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[3,"PathResolution"],[3,"Export"],[4,"MethodProvenance"],[4,"UnsafeContext"],[3,"EffectCheckVisitor"],[3,"EntryContext"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[3,"ExprUseVisitor"],[4,"SimplifiedType"],[3,"FreeRegionMap"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"Graph"],[3,"DepthFirstTraversal"],[3,"IntrinsicCheckingVisitor"],[3,"TransmuteRestriction"],[3,"Bivariate"],[3,"CombineFields"],[3,"Generalizer"],[4,"Result"],[3,"Equate"],[3,"InferCtxt"],[3,"Glb"],[3,"Lub"],[4,"Node"],[4,"Edge"],[3,"ConstraintGraph"],[4,"Constraint"],[4,"GenericKind"],[3,"TwoRegions"],[4,"UndoLogEntry"],[4,"CombineMapType"],[4,"RegionResolutionError"],[3,"SameRegions"],[3,"RegionSnapshot"],[3,"RegionVarBindings"],[4,"Classification"],[4,"VarValue"],[4,"Verify"],[3,"RegionAndOrigin"],[3,"OpportunisticTypeResolver"],[3,"FullTypeResolver"],[3,"TypeFreshener"],[3,"Sub"],[4,"RelationDir"],[3,"TypeVariableTable"],[3,"Delegate"],[4,"VarValue"],[3,"Delegate"],[3,"UnificationTable"],[3,"IntVid"],[4,"IntVarValue"],[3,"FloatVid"],[4,"FloatTy"],[4,"TypeOrigin"],[4,"ValuePairs"],[3,"TypeTrace"],[4,"SubregionOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"fixup_err"],[4,"Implication"],[4,"LangItem"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[3,"Variable"],[3,"LiveNode"],[4,"LiveNodeKind"],[3,"IrMaps"],[3,"LocalInfo"],[4,"VarKind"],[3,"Liveness"],[3,"Users"],[3,"Specials"],[4,"categorization"],[3,"Upvar"],[4,"PointerKind"],[4,"InteriorKind"],[4,"FieldName"],[4,"InteriorOffsetKind"],[4,"ElementKind"],[4,"MutabilityCategory"],[4,"Note"],[3,"cmt_"],[4,"deref_kind"],[3,"Expr"],[3,"Pat"],[3,"MemCategorizationContext"],[4,"InteriorSafety"],[4,"Aliasability"],[4,"AliasableReason"],[4,"ClosureKind"],[4,"LastPrivate"],[4,"PrivateDep"],[4,"ImportUse"],[3,"ReachableContext"],[3,"BlockRemainder"],[4,"InnermostDeclaringBlock"],[3,"DeclaringStatementContext"],[4,"InnermostEnclosingExpr"],[3,"Context"],[3,"RegionMaps"],[3,"RegionResolutionVisitor"],[4,"DefRegion"],[3,"LifetimeContext"],[4,"ShadowKind"],[4,"ScopeChain"],[3,"Annotator"],[3,"Index"],[3,"Checker"],[4,"RegionSubsts"],[4,"ParamSpace"],[3,"EnumeratedItems"],[3,"SubstFolder"],[3,"InferIsLocal"],[3,"RegionObligation"],[3,"FulfillmentContext"],[3,"MismatchedProjectionTypes"],[4,"ProjectionTyCandidate"],[3,"AssociatedTypeNormalizer"],[3,"Normalized"],[4,"ProjectionTyError"],[4,"MethodViolationCode"],[4,"ObjectSafetyViolation"],[3,"SelectionCache"],[4,"MethodMatchedData"],[4,"SelectionCandidate"],[4,"EvaluationResult"],[3,"SelectionContext"],[3,"TraitObligationStackList"],[3,"TraitObligationStack"],[4,"MethodMatchResult"],[3,"Elaborator"],[3,"SupertraitDefIds"],[3,"FilterToTraits"],[3,"VtableImplData"],[3,"VtableObjectData"],[3,"Obligation"],[4,"Vtable"],[3,"VtableBuiltinData"],[3,"VtableDefaultImplData"],[4,"SelectionError"],[3,"FulfillmentError"],[4,"FulfillmentErrorCode"],[3,"ObligationCause"],[4,"ObligationCauseCode"],[3,"DerivedObligationCause"],[3,"field"],[4,"ImplOrTraitItemContainer"],[4,"ImplOrTraitItemId"],[3,"mt"],[3,"creader_cache_key"],[3,"ItemVariances"],[4,"Variance"],[4,"AutoAdjustment"],[3,"AutoDerefRef"],[4,"AutoRef"],[3,"param_index"],[3,"MethodParam"],[3,"MethodObject"],[3,"MethodCallee"],[3,"MethodCall"],[4,"vtable_origin"],[3,"CtxtArenas"],[3,"ctxt"],[3,"TypeFlags"],[3,"TyS"],[3,"InternedTy"],[3,"BareFnTy"],[3,"ClosureTy"],[3,"FnSig"],[3,"ParamTy"],[3,"DebruijnIndex"],[3,"EarlyBoundRegion"],[3,"UpvarId"],[4,"BorrowKind"],[4,"sty"],[3,"TyTrait"],[4,"terr_vstore_kind"],[3,"expected_found"],[4,"type_err"],[3,"TyVid"],[3,"RegionVid"],[4,"InferTy"],[4,"UnconstrainedNumeric"],[4,"InferRegion"],[4,"ObjectLifetimeDefault"],[3,"Generics"],[3,"GenericPredicates"],[3,"InstantiatedPredicates"],[3,"ParameterEnvironment"],[3,"TypeScheme"],[3,"ItemSubsts"],[3,"TypeContents"],[4,"Representability"],[4,"ExprKind"],[4,"DtorKind"],[4,"IntType"],[3,"ClosureUpvar"],[4,"ExplicitSelfCategory"],[4,"CopyImplementationError"],[3,"Vec"],[3,"Box"],[4,"Unsafety"],[4,"Abi"],[3,"EnumSet"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionEraser"],[3,"Match"],[3,"TypeWalker"],[3,"Context"],[4,"astencode_tag"],[3,"LinkMeta"],[4,"DefIdSource"],[3,"entry"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[4,"Family"],[4,"DefLike"],[3,"CrateDep"],[3,"CrateReader"],[4,"PMDSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[3,"CrateSource"],[3,"CStore"],[4,"MetadataBlob"],[3,"MethodInfo"],[3,"Context"],[3,"ArchiveMetadata"],[4,"FileMatch"],[3,"FileSearch"],[3,"MacroLoader"],[4,"OptLevel"],[4,"DebugInfoLevel"],[4,"OutputType"],[3,"Options"],[4,"UnstableFeatures"],[4,"PrintRequest"],[3,"OutputFilenames"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[4,"OptionStability"],[3,"RustcOptGroup"],[3,"SearchPaths"],[4,"PathKind"],[3,"Iter"],[3,"Session"],[3,"Registry"],[3,"RegistrarFinder"],[3,"Lint"],[3,"LintId"],[4,"Level"],[4,"LintSource"],[3,"HardwiredLints"],[3,"LintStore"],[3,"Context"],[3,"GatherNodeLevels"],[3,"ErrorReported"],[3,"Indenter"],[3,"LoopQueryVisitor"],[3,"BlockQueryVisitor"],[3,"TraitDef"],[3,"Item"],[3,"Spanned"],[4,"IntTy"],[4,"UintTy"],[3,"HashMap"],[3,"FnvHasher"],[3,"SnapshotVec"],[3,"FixedBuffer64"],[3,"Sha256"],[3,"ArchiveRO"],[4,"OptimizationDiagnosticKind"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"Diagnostic"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[3,"Attribute"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[3,"AttrBuilder"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[4,"DIDescriptorFlags"],[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[3,"DocContext"],[3,"CrateAnalysis"],[4,"MaybeTyped"],[3,"Module"],[3,"Struct"],[3,"Enum"],[3,"Variant"],[3,"Function"],[3,"Typedef"],[3,"Static"],[3,"Constant"],[3,"Trait"],[3,"Impl"],[3,"DefaultImpl"],[3,"Macro"],[3,"ExternCrate"],[3,"Import"],[4,"StructType"],[4,"TypeBound"],[8,"DocFolder"],[3,"Escape"],[4,"ItemType"],[3,"VisSpace"],[3,"UnsafetySpace"],[3,"MutableSpace"],[3,"RawMutableSpace"],[3,"CommaSep"],[3,"TyParamBounds"],[3,"WhereClause"],[3,"Method"],[3,"AbiSpace"],[3,"Stability"],[3,"ConciseStability"],[3,"Layout"],[3,"Page"],[3,"Markdown"],[3,"MarkdownWithToc"],[3,"Context"],[3,"Implementor"],[3,"Impl"],[3,"Cache"],[4,"ExternalLocation"],[3,"Toc"],[3,"TocEntry"],[3,"TocBuilder"],[3,"PluginManager"],[3,"Counts"],[3,"ModuleSummary"],[3,"RustdocVisitor"],[3,"TestOptions"],[3,"Collector"]]};
searchIndex['rustc'] = {"items":[[0,"","rustc","The Rust compiler.",null,null],[0,"llvm","","",null,null],[0,"archive_ro","rustc::llvm","A wrapper around LLVM's archive (.a) code",null,null],[11,"open","rustc_llvm::archive_ro","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",0,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",0,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",0,null],[11,"clone","rustc_llvm::diagnostic","",1,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",1,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",2,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",3,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",4,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",4,null],[11,"eq","rustc_llvm","",5,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",6,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",7,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",8,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",8,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",9,null],[11,"cmp","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",9,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",9,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",9,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",9,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",9,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",9,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",9,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",9,null],[11,"remove","","Removes the specified flags in-place.",9,null],[11,"toggle","","Toggles the specified flags in-place.",9,null],[6,"Output","rustc::llvm::archive_ro","",null,null],[11,"bitor","rustc_llvm","Returns the union of the two sets of flags.",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc::llvm::archive_ro","",null,null],[11,"bitxor","rustc_llvm","Returns the left flags, but with all the right flags toggled.",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc::llvm::archive_ro","",null,null],[11,"bitand","rustc_llvm","Returns the intersection between the two sets of flags.",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc::llvm::archive_ro","",null,null],[11,"sub","rustc_llvm","Returns the set difference of the two sets of flags.",9,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc::llvm::archive_ro","",null,null],[11,"not","rustc_llvm","Returns the complement of this set of flags.",9,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",10,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",11,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",12,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",9,null],[11,"apply_callsite","","",9,null],[11,"apply_llfn","","",10,null],[11,"apply_callsite","","",10,null],[11,"apply_llfn","","",11,null],[11,"apply_callsite","","",11,null],[11,"new","","",13,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",13,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",13,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",13,null],[11,"apply_callsite","","",13,null],[11,"clone","","",14,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",15,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",16,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",16,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",17,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",18,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",19,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",20,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",21,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",22,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",22,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",23,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",23,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",24,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",25,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"clone","rustc_llvm::debuginfo","",26,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[11,"drop","rustc_llvm","",27,null],[11,"new","","",28,null],[11,"drop","","",28,null],[11,"drop","","",29,null],[3,"ArchiveRO","rustc::llvm::archive_ro","",null,null],[0,"diagnostic","rustc::llvm","LLVM diagnostic reports.",null,null],[4,"OptimizationDiagnosticKind","rustc::llvm::diagnostic","",null,null],[13,"OptimizationRemark","","",1,null],[13,"OptimizationMissed","","",1,null],[13,"OptimizationAnalysis","","",1,null],[13,"OptimizationFailure","","",1,null],[3,"OptimizationDiagnostic","","",null,null],[12,"kind","","",2,null],[12,"pass_name","","",2,null],[12,"function","","",2,null],[12,"debug_loc","","",2,null],[12,"message","","",2,null],[3,"InlineAsmDiagnostic","","",null,null],[12,"cookie","","",3,null],[12,"message","","",3,null],[12,"instruction","","",3,null],[4,"Diagnostic","","",null,null],[13,"Optimization","","",4,null],[13,"InlineAsm","","",4,null],[13,"UnknownDiagnostic","","LLVM has other types that we do not wrap here.",4,null],[6,"Opcode","rustc::llvm","",null,null],[6,"Bool","","",null,null],[17,"True","","",null,null],[17,"False","","",null,null],[4,"CallConv","","",null,null],[13,"CCallConv","","",5,null],[13,"FastCallConv","","",5,null],[13,"ColdCallConv","","",5,null],[13,"X86StdcallCallConv","","",5,null],[13,"X86FastcallCallConv","","",5,null],[13,"X86_64_Win64","","",5,null],[4,"Visibility","","",null,null],[13,"LLVMDefaultVisibility","","",6,null],[13,"HiddenVisibility","","",6,null],[13,"ProtectedVisibility","","",6,null],[4,"Linkage","","",null,null],[13,"ExternalLinkage","","",7,null],[13,"AvailableExternallyLinkage","","",7,null],[13,"LinkOnceAnyLinkage","","",7,null],[13,"LinkOnceODRLinkage","","",7,null],[13,"WeakAnyLinkage","","",7,null],[13,"WeakODRLinkage","","",7,null],[13,"AppendingLinkage","","",7,null],[13,"InternalLinkage","","",7,null],[13,"PrivateLinkage","","",7,null],[13,"ExternalWeakLinkage","","",7,null],[13,"CommonLinkage","","",7,null],[4,"DiagnosticSeverity","","",null,null],[13,"Error","","",8,null],[13,"Warning","","",8,null],[13,"Remark","","",8,null],[13,"Note","","",8,null],[3,"Attribute","","",null,null],[17,"ZExtAttribute","","",null,null],[17,"SExtAttribute","","",null,null],[17,"NoReturnAttribute","","",null,null],[17,"InRegAttribute","","",null,null],[17,"StructRetAttribute","","",null,null],[17,"NoUnwindAttribute","","",null,null],[17,"NoAliasAttribute","","",null,null],[17,"ByValAttribute","","",null,null],[17,"NestAttribute","","",null,null],[17,"ReadNoneAttribute","","",null,null],[17,"ReadOnlyAttribute","","",null,null],[17,"NoInlineAttribute","","",null,null],[17,"AlwaysInlineAttribute","","",null,null],[17,"OptimizeForSizeAttribute","","",null,null],[17,"StackProtectAttribute","","",null,null],[17,"StackProtectReqAttribute","","",null,null],[17,"AlignmentAttribute","","",null,null],[17,"NoCaptureAttribute","","",null,null],[17,"NoRedZoneAttribute","","",null,null],[17,"NoImplicitFloatAttribute","","",null,null],[17,"NakedAttribute","","",null,null],[17,"InlineHintAttribute","","",null,null],[17,"StackAttribute","","",null,null],[17,"ReturnsTwiceAttribute","","",null,null],[17,"UWTableAttribute","","",null,null],[17,"NonLazyBindAttribute","","",null,null],[4,"OtherAttribute","","",null,null],[13,"SanitizeAddressAttribute","","",10,null],[13,"MinSizeAttribute","","",10,null],[13,"NoDuplicateAttribute","","",10,null],[13,"StackProtectStrongAttribute","","",10,null],[13,"SanitizeThreadAttribute","","",10,null],[13,"SanitizeMemoryAttribute","","",10,null],[13,"NoBuiltinAttribute","","",10,null],[13,"ReturnedAttribute","","",10,null],[13,"ColdAttribute","","",10,null],[13,"BuiltinAttribute","","",10,null],[13,"OptimizeNoneAttribute","","",10,null],[13,"InAllocaAttribute","","",10,null],[13,"NonNullAttribute","","",10,null],[4,"SpecialAttribute","","",null,null],[13,"DereferenceableAttribute","","",11,null],[4,"AttributeSet","","",null,null],[13,"ReturnIndex","","",12,null],[13,"FunctionIndex","","",12,null],[8,"AttrHelper","","",null,null],[10,"apply_llfn","","",30,null],[10,"apply_callsite","","",30,null],[3,"AttrBuilder","","",null,null],[4,"IntPredicate","","",null,null],[13,"IntEQ","","",14,null],[13,"IntNE","","",14,null],[13,"IntUGT","","",14,null],[13,"IntUGE","","",14,null],[13,"IntULT","","",14,null],[13,"IntULE","","",14,null],[13,"IntSGT","","",14,null],[13,"IntSGE","","",14,null],[13,"IntSLT","","",14,null],[13,"IntSLE","","",14,null],[4,"RealPredicate","","",null,null],[13,"RealPredicateFalse","","",15,null],[13,"RealOEQ","","",15,null],[13,"RealOGT","","",15,null],[13,"RealOGE","","",15,null],[13,"RealOLT","","",15,null],[13,"RealOLE","","",15,null],[13,"RealONE","","",15,null],[13,"RealORD","","",15,null],[13,"RealUNO","","",15,null],[13,"RealUEQ","","",15,null],[13,"RealUGT","","",15,null],[13,"RealUGE","","",15,null],[13,"RealULT","","",15,null],[13,"RealULE","","",15,null],[13,"RealUNE","","",15,null],[13,"RealPredicateTrue","","",15,null],[4,"TypeKind","","",null,null],[13,"Void","","",16,null],[13,"Half","","",16,null],[13,"Float","","",16,null],[13,"Double","","",16,null],[13,"X86_FP80","","",16,null],[13,"FP128","","",16,null],[13,"PPC_FP128","","",16,null],[13,"Label","","",16,null],[13,"Integer","","",16,null],[13,"Function","","",16,null],[13,"Struct","","",16,null],[13,"Array","","",16,null],[13,"Pointer","","",16,null],[13,"Vector","","",16,null],[13,"Metadata","","",16,null],[13,"X86_MMX","","",16,null],[4,"AtomicBinOp","","",null,null],[13,"AtomicXchg","","",17,null],[13,"AtomicAdd","","",17,null],[13,"AtomicSub","","",17,null],[13,"AtomicAnd","","",17,null],[13,"AtomicNand","","",17,null],[13,"AtomicOr","","",17,null],[13,"AtomicXor","","",17,null],[13,"AtomicMax","","",17,null],[13,"AtomicMin","","",17,null],[13,"AtomicUMax","","",17,null],[13,"AtomicUMin","","",17,null],[4,"AtomicOrdering","","",null,null],[13,"NotAtomic","","",18,null],[13,"Unordered","","",18,null],[13,"Monotonic","","",18,null],[13,"Acquire","","",18,null],[13,"Release","","",18,null],[13,"AcquireRelease","","",18,null],[13,"SequentiallyConsistent","","",18,null],[4,"FileType","","",null,null],[13,"AssemblyFileType","","",19,null],[13,"ObjectFileType","","",19,null],[4,"MetadataType","","",null,null],[13,"MD_dbg","","",20,null],[13,"MD_tbaa","","",20,null],[13,"MD_prof","","",20,null],[13,"MD_fpmath","","",20,null],[13,"MD_range","","",20,null],[13,"MD_tbaa_struct","","",20,null],[13,"MD_invariant_load","","",20,null],[13,"MD_alias_scope","","",20,null],[13,"MD_noalias","","",20,null],[13,"MD_nontemporal","","",20,null],[13,"MD_mem_parallel_loop_access","","",20,null],[13,"MD_nonnull","","",20,null],[4,"AsmDialect","","",null,null],[13,"AD_ATT","","",21,null],[13,"AD_Intel","","",21,null],[4,"CodeGenOptLevel","","",null,null],[13,"CodeGenLevelNone","","",22,null],[13,"CodeGenLevelLess","","",22,null],[13,"CodeGenLevelDefault","","",22,null],[13,"CodeGenLevelAggressive","","",22,null],[4,"RelocMode","","",null,null],[13,"RelocDefault","","",23,null],[13,"RelocStatic","","",23,null],[13,"RelocPIC","","",23,null],[13,"RelocDynamicNoPic","","",23,null],[4,"CodeGenModel","","",null,null],[13,"CodeModelDefault","","",24,null],[13,"CodeModelJITDefault","","",24,null],[13,"CodeModelSmall","","",24,null],[13,"CodeModelKernel","","",24,null],[13,"CodeModelMedium","","",24,null],[13,"CodeModelLarge","","",24,null],[4,"DiagnosticKind","","",null,null],[13,"DK_InlineAsm","","",25,null],[13,"DK_StackSize","","",25,null],[13,"DK_DebugMetadataVersion","","",25,null],[13,"DK_SampleProfile","","",25,null],[13,"DK_OptimizationRemark","","",25,null],[13,"DK_OptimizationRemarkMissed","","",25,null],[13,"DK_OptimizationRemarkAnalysis","","",25,null],[13,"DK_OptimizationFailure","","",25,null],[4,"Module_opaque","","",null,null],[6,"ModuleRef","","",null,null],[4,"Context_opaque","","",null,null],[6,"ContextRef","","",null,null],[4,"Type_opaque","","",null,null],[6,"TypeRef","","",null,null],[4,"Value_opaque","","",null,null],[6,"ValueRef","","",null,null],[4,"Metadata_opaque","","",null,null],[6,"MetadataRef","","",null,null],[4,"BasicBlock_opaque","","",null,null],[6,"BasicBlockRef","","",null,null],[4,"Builder_opaque","","",null,null],[6,"BuilderRef","","",null,null],[4,"ExecutionEngine_opaque","","",null,null],[6,"ExecutionEngineRef","","",null,null],[4,"RustJITMemoryManager_opaque","","",null,null],[6,"RustJITMemoryManagerRef","","",null,null],[4,"MemoryBuffer_opaque","","",null,null],[6,"MemoryBufferRef","","",null,null],[4,"PassManager_opaque","","",null,null],[6,"PassManagerRef","","",null,null],[4,"PassManagerBuilder_opaque","","",null,null],[6,"PassManagerBuilderRef","","",null,null],[4,"Use_opaque","","",null,null],[6,"UseRef","","",null,null],[4,"TargetData_opaque","","",null,null],[6,"TargetDataRef","","",null,null],[4,"ObjectFile_opaque","","",null,null],[6,"ObjectFileRef","","",null,null],[4,"SectionIterator_opaque","","",null,null],[6,"SectionIteratorRef","","",null,null],[4,"Pass_opaque","","",null,null],[6,"PassRef","","",null,null],[4,"TargetMachine_opaque","","",null,null],[6,"TargetMachineRef","","",null,null],[4,"Archive_opaque","","",null,null],[6,"ArchiveRef","","",null,null],[4,"Twine_opaque","","",null,null],[6,"TwineRef","","",null,null],[4,"DiagnosticInfo_opaque","","",null,null],[6,"DiagnosticInfoRef","","",null,null],[4,"DebugLoc_opaque","","",null,null],[6,"DebugLocRef","","",null,null],[4,"SMDiagnostic_opaque","","",null,null],[6,"SMDiagnosticRef","","",null,null],[6,"DiagnosticHandler","","",null,null],[6,"InlineAsmDiagHandler","","",null,null],[0,"debuginfo","","",null,null],[4,"DIBuilder_opaque","rustc::llvm::debuginfo","",null,null],[6,"DIBuilderRef","","",null,null],[6,"DIDescriptor","","",null,null],[6,"DIScope","","",null,null],[6,"DILocation","","",null,null],[6,"DIFile","","",null,null],[6,"DILexicalBlock","","",null,null],[6,"DISubprogram","","",null,null],[6,"DINameSpace","","",null,null],[6,"DIType","","",null,null],[6,"DIBasicType","","",null,null],[6,"DIDerivedType","","",null,null],[6,"DICompositeType","","",null,null],[6,"DIVariable","","",null,null],[6,"DIGlobalVariable","","",null,null],[6,"DIArray","","",null,null],[6,"DISubrange","","",null,null],[6,"DIEnumerator","","",null,null],[6,"DITemplateTypeParameter","","",null,null],[4,"DIDescriptorFlags","","",null,null],[13,"FlagPrivate","","",26,null],[13,"FlagProtected","","",26,null],[13,"FlagFwdDecl","","",26,null],[13,"FlagAppleBlock","","",26,null],[13,"FlagBlockByrefStruct","","",26,null],[13,"FlagVirtual","","",26,null],[13,"FlagArtificial","","",26,null],[13,"FlagExplicit","","",26,null],[13,"FlagPrototyped","","",26,null],[13,"FlagObjcClassComplete","","",26,null],[13,"FlagObjectPointer","","",26,null],[13,"FlagVector","","",26,null],[13,"FlagStaticMember","","",26,null],[13,"FlagIndirectVariable","","",26,null],[13,"FlagLValueReference","","",26,null],[13,"FlagRValueReference","","",26,null],[5,"LLVMContextCreate","rustc::llvm","",null,null],[5,"LLVMContextDispose","","",null,null],[5,"LLVMGetMDKindIDInContext","","",null,null],[5,"LLVMModuleCreateWithNameInContext","","",null,null],[5,"LLVMGetModuleContext","","",null,null],[5,"LLVMDisposeModule","","",null,null],[5,"LLVMGetDataLayout","","Data layout. See Module::getDataLayout.",null,null],[5,"LLVMSetDataLayout","","",null,null],[5,"LLVMGetTarget","","Target triple. See Module::getTargetTriple.",null,null],[5,"LLVMSetTarget","","",null,null],[5,"LLVMDumpModule","","See Module::dump.",null,null],[5,"LLVMSetModuleInlineAsm","","See Module::setModuleInlineAsm.",null,null],[5,"LLVMGetTypeKind","","See llvm::LLVMTypeKind::getTypeID.",null,null],[5,"LLVMGetTypeContext","","See llvm::LLVMType::getContext.",null,null],[5,"LLVMInt1TypeInContext","","",null,null],[5,"LLVMInt8TypeInContext","","",null,null],[5,"LLVMInt16TypeInContext","","",null,null],[5,"LLVMInt32TypeInContext","","",null,null],[5,"LLVMInt64TypeInContext","","",null,null],[5,"LLVMIntTypeInContext","","",null,null],[5,"LLVMGetIntTypeWidth","","",null,null],[5,"LLVMFloatTypeInContext","","",null,null],[5,"LLVMDoubleTypeInContext","","",null,null],[5,"LLVMX86FP80TypeInContext","","",null,null],[5,"LLVMFP128TypeInContext","","",null,null],[5,"LLVMPPCFP128TypeInContext","","",null,null],[5,"LLVMFunctionType","","",null,null],[5,"LLVMIsFunctionVarArg","","",null,null],[5,"LLVMGetReturnType","","",null,null],[5,"LLVMCountParamTypes","","",null,null],[5,"LLVMGetParamTypes","","",null,null],[5,"LLVMStructTypeInContext","","",null,null],[5,"LLVMCountStructElementTypes","","",null,null],[5,"LLVMGetStructElementTypes","","",null,null],[5,"LLVMIsPackedStruct","","",null,null],[5,"LLVMRustArrayType","","",null,null],[5,"LLVMPointerType","","",null,null],[5,"LLVMVectorType","","",null,null],[5,"LLVMGetElementType","","",null,null],[5,"LLVMGetArrayLength","","",null,null],[5,"LLVMGetPointerAddressSpace","","",null,null],[5,"LLVMGetPointerToGlobal","","",null,null],[5,"LLVMGetVectorSize","","",null,null],[5,"LLVMVoidTypeInContext","","",null,null],[5,"LLVMLabelTypeInContext","","",null,null],[5,"LLVMMetadataTypeInContext","","",null,null],[5,"LLVMTypeOf","","",null,null],[5,"LLVMGetValueName","","",null,null],[5,"LLVMSetValueName","","",null,null],[5,"LLVMDumpValue","","",null,null],[5,"LLVMReplaceAllUsesWith","","",null,null],[5,"LLVMHasMetadata","","",null,null],[5,"LLVMGetMetadata","","",null,null],[5,"LLVMSetMetadata","","",null,null],[5,"LLVMGetFirstUse","","",null,null],[5,"LLVMGetNextUse","","",null,null],[5,"LLVMGetUser","","",null,null],[5,"LLVMGetUsedValue","","",null,null],[5,"LLVMGetNumOperands","","",null,null],[5,"LLVMGetOperand","","",null,null],[5,"LLVMSetOperand","","",null,null],[5,"LLVMConstNull","","",null,null],[5,"LLVMConstAllOnes","","",null,null],[5,"LLVMConstICmp","","",null,null],[5,"LLVMConstFCmp","","",null,null],[5,"LLVMGetUndef","","",null,null],[5,"LLVMIsConstant","","",null,null],[5,"LLVMIsNull","","",null,null],[5,"LLVMIsUndef","","",null,null],[5,"LLVMConstPointerNull","","",null,null],[5,"LLVMMDStringInContext","","",null,null],[5,"LLVMMDNodeInContext","","",null,null],[5,"LLVMAddNamedMetadataOperand","","",null,null],[5,"LLVMConstInt","","",null,null],[5,"LLVMConstIntOfString","","",null,null],[5,"LLVMConstIntOfStringAndSize","","",null,null],[5,"LLVMConstReal","","",null,null],[5,"LLVMConstRealOfString","","",null,null],[5,"LLVMConstRealOfStringAndSize","","",null,null],[5,"LLVMConstIntGetZExtValue","","",null,null],[5,"LLVMConstIntGetSExtValue","","",null,null],[5,"LLVMConstStringInContext","","",null,null],[5,"LLVMConstStructInContext","","",null,null],[5,"LLVMConstArray","","",null,null],[5,"LLVMConstVector","","",null,null],[5,"LLVMAlignOf","","",null,null],[5,"LLVMSizeOf","","",null,null],[5,"LLVMConstNeg","","",null,null],[5,"LLVMConstNSWNeg","","",null,null],[5,"LLVMConstNUWNeg","","",null,null],[5,"LLVMConstFNeg","","",null,null],[5,"LLVMConstNot","","",null,null],[5,"LLVMConstAdd","","",null,null],[5,"LLVMConstNSWAdd","","",null,null],[5,"LLVMConstNUWAdd","","",null,null],[5,"LLVMConstFAdd","","",null,null],[5,"LLVMConstSub","","",null,null],[5,"LLVMConstNSWSub","","",null,null],[5,"LLVMConstNUWSub","","",null,null],[5,"LLVMConstFSub","","",null,null],[5,"LLVMConstMul","","",null,null],[5,"LLVMConstNSWMul","","",null,null],[5,"LLVMConstNUWMul","","",null,null],[5,"LLVMConstFMul","","",null,null],[5,"LLVMConstUDiv","","",null,null],[5,"LLVMConstSDiv","","",null,null],[5,"LLVMConstExactSDiv","","",null,null],[5,"LLVMConstFDiv","","",null,null],[5,"LLVMConstURem","","",null,null],[5,"LLVMConstSRem","","",null,null],[5,"LLVMConstFRem","","",null,null],[5,"LLVMConstAnd","","",null,null],[5,"LLVMConstOr","","",null,null],[5,"LLVMConstXor","","",null,null],[5,"LLVMConstShl","","",null,null],[5,"LLVMConstLShr","","",null,null],[5,"LLVMConstAShr","","",null,null],[5,"LLVMConstGEP","","",null,null],[5,"LLVMConstInBoundsGEP","","",null,null],[5,"LLVMConstTrunc","","",null,null],[5,"LLVMConstSExt","","",null,null],[5,"LLVMConstZExt","","",null,null],[5,"LLVMConstFPTrunc","","",null,null],[5,"LLVMConstFPExt","","",null,null],[5,"LLVMConstUIToFP","","",null,null],[5,"LLVMConstSIToFP","","",null,null],[5,"LLVMConstFPToUI","","",null,null],[5,"LLVMConstFPToSI","","",null,null],[5,"LLVMConstPtrToInt","","",null,null],[5,"LLVMConstIntToPtr","","",null,null],[5,"LLVMConstBitCast","","",null,null],[5,"LLVMConstZExtOrBitCast","","",null,null],[5,"LLVMConstSExtOrBitCast","","",null,null],[5,"LLVMConstTruncOrBitCast","","",null,null],[5,"LLVMConstPointerCast","","",null,null],[5,"LLVMConstIntCast","","",null,null],[5,"LLVMConstFPCast","","",null,null],[5,"LLVMConstSelect","","",null,null],[5,"LLVMConstExtractElement","","",null,null],[5,"LLVMConstInsertElement","","",null,null],[5,"LLVMConstShuffleVector","","",null,null],[5,"LLVMConstExtractValue","","",null,null],[5,"LLVMConstInsertValue","","",null,null],[5,"LLVMConstInlineAsm","","",null,null],[5,"LLVMBlockAddress","","",null,null],[5,"LLVMGetGlobalParent","","",null,null],[5,"LLVMIsDeclaration","","",null,null],[5,"LLVMGetLinkage","","",null,null],[5,"LLVMSetLinkage","","",null,null],[5,"LLVMGetSection","","",null,null],[5,"LLVMSetSection","","",null,null],[5,"LLVMGetVisibility","","",null,null],[5,"LLVMSetVisibility","","",null,null],[5,"LLVMGetAlignment","","",null,null],[5,"LLVMSetAlignment","","",null,null],[5,"LLVMIsAGlobalVariable","","",null,null],[5,"LLVMAddGlobal","","",null,null],[5,"LLVMAddGlobalInAddressSpace","","",null,null],[5,"LLVMGetNamedGlobal","","",null,null],[5,"LLVMGetOrInsertGlobal","","",null,null],[5,"LLVMGetFirstGlobal","","",null,null],[5,"LLVMGetLastGlobal","","",null,null],[5,"LLVMGetNextGlobal","","",null,null],[5,"LLVMGetPreviousGlobal","","",null,null],[5,"LLVMDeleteGlobal","","",null,null],[5,"LLVMGetInitializer","","",null,null],[5,"LLVMSetInitializer","","",null,null],[5,"LLVMIsThreadLocal","","",null,null],[5,"LLVMSetThreadLocal","","",null,null],[5,"LLVMIsGlobalConstant","","",null,null],[5,"LLVMSetGlobalConstant","","",null,null],[5,"LLVMGetNamedValue","","",null,null],[5,"LLVMAddAlias","","",null,null],[5,"LLVMAddFunction","","",null,null],[5,"LLVMGetNamedFunction","","",null,null],[5,"LLVMGetFirstFunction","","",null,null],[5,"LLVMGetLastFunction","","",null,null],[5,"LLVMGetNextFunction","","",null,null],[5,"LLVMGetPreviousFunction","","",null,null],[5,"LLVMDeleteFunction","","",null,null],[5,"LLVMGetOrInsertFunction","","",null,null],[5,"LLVMGetIntrinsicID","","",null,null],[5,"LLVMGetFunctionCallConv","","",null,null],[5,"LLVMSetFunctionCallConv","","",null,null],[5,"LLVMGetGC","","",null,null],[5,"LLVMSetGC","","",null,null],[5,"LLVMAddDereferenceableAttr","","",null,null],[5,"LLVMAddFunctionAttribute","","",null,null],[5,"LLVMAddFunctionAttrString","","",null,null],[5,"LLVMRemoveFunctionAttrString","","",null,null],[5,"LLVMGetFunctionAttr","","",null,null],[5,"LLVMRemoveFunctionAttr","","",null,null],[5,"LLVMCountParams","","",null,null],[5,"LLVMGetParams","","",null,null],[5,"LLVMGetParam","","",null,null],[5,"LLVMGetParamParent","","",null,null],[5,"LLVMGetFirstParam","","",null,null],[5,"LLVMGetLastParam","","",null,null],[5,"LLVMGetNextParam","","",null,null],[5,"LLVMGetPreviousParam","","",null,null],[5,"LLVMAddAttribute","","",null,null],[5,"LLVMRemoveAttribute","","",null,null],[5,"LLVMGetAttribute","","",null,null],[5,"LLVMSetParamAlignment","","",null,null],[5,"LLVMBasicBlockAsValue","","",null,null],[5,"LLVMValueIsBasicBlock","","",null,null],[5,"LLVMValueAsBasicBlock","","",null,null],[5,"LLVMGetBasicBlockParent","","",null,null],[5,"LLVMCountBasicBlocks","","",null,null],[5,"LLVMGetBasicBlocks","","",null,null],[5,"LLVMGetFirstBasicBlock","","",null,null],[5,"LLVMGetLastBasicBlock","","",null,null],[5,"LLVMGetNextBasicBlock","","",null,null],[5,"LLVMGetPreviousBasicBlock","","",null,null],[5,"LLVMGetEntryBasicBlock","","",null,null],[5,"LLVMAppendBasicBlockInContext","","",null,null],[5,"LLVMInsertBasicBlockInContext","","",null,null],[5,"LLVMDeleteBasicBlock","","",null,null],[5,"LLVMMoveBasicBlockAfter","","",null,null],[5,"LLVMMoveBasicBlockBefore","","",null,null],[5,"LLVMGetInstructionParent","","",null,null],[5,"LLVMGetFirstInstruction","","",null,null],[5,"LLVMGetLastInstruction","","",null,null],[5,"LLVMGetNextInstruction","","",null,null],[5,"LLVMGetPreviousInstruction","","",null,null],[5,"LLVMInstructionEraseFromParent","","",null,null],[5,"LLVMSetInstructionCallConv","","",null,null],[5,"LLVMGetInstructionCallConv","","",null,null],[5,"LLVMAddInstrAttribute","","",null,null],[5,"LLVMRemoveInstrAttribute","","",null,null],[5,"LLVMSetInstrParamAlignment","","",null,null],[5,"LLVMAddCallSiteAttribute","","",null,null],[5,"LLVMAddDereferenceableCallSiteAttr","","",null,null],[5,"LLVMIsTailCall","","",null,null],[5,"LLVMSetTailCall","","",null,null],[5,"LLVMGetVolatile","","",null,null],[5,"LLVMSetVolatile","","",null,null],[5,"LLVMAddIncoming","","",null,null],[5,"LLVMCountIncoming","","",null,null],[5,"LLVMGetIncomingValue","","",null,null],[5,"LLVMGetIncomingBlock","","",null,null],[5,"LLVMCreateBuilderInContext","","",null,null],[5,"LLVMPositionBuilder","","",null,null],[5,"LLVMPositionBuilderBefore","","",null,null],[5,"LLVMPositionBuilderAtEnd","","",null,null],[5,"LLVMGetInsertBlock","","",null,null],[5,"LLVMClearInsertionPosition","","",null,null],[5,"LLVMInsertIntoBuilder","","",null,null],[5,"LLVMInsertIntoBuilderWithName","","",null,null],[5,"LLVMDisposeBuilder","","",null,null],[5,"LLVMRustCreateJITMemoryManager","","",null,null],[5,"LLVMBuildExecutionEngine","","",null,null],[5,"LLVMDisposeExecutionEngine","","",null,null],[5,"LLVMExecutionEngineFinalizeObject","","",null,null],[5,"LLVMRustLoadDynamicLibrary","","",null,null],[5,"LLVMExecutionEngineAddModule","","",null,null],[5,"LLVMExecutionEngineRemoveModule","","",null,null],[5,"LLVMSetCurrentDebugLocation","","",null,null],[5,"LLVMGetCurrentDebugLocation","","",null,null],[5,"LLVMSetInstDebugLocation","","",null,null],[5,"LLVMBuildRetVoid","","",null,null],[5,"LLVMBuildRet","","",null,null],[5,"LLVMBuildAggregateRet","","",null,null],[5,"LLVMBuildBr","","",null,null],[5,"LLVMBuildCondBr","","",null,null],[5,"LLVMBuildSwitch","","",null,null],[5,"LLVMBuildIndirectBr","","",null,null],[5,"LLVMBuildInvoke","","",null,null],[5,"LLVMBuildLandingPad","","",null,null],[5,"LLVMBuildResume","","",null,null],[5,"LLVMBuildUnreachable","","",null,null],[5,"LLVMAddCase","","",null,null],[5,"LLVMAddDestination","","",null,null],[5,"LLVMAddClause","","",null,null],[5,"LLVMSetCleanup","","",null,null],[5,"LLVMBuildAdd","","",null,null],[5,"LLVMBuildNSWAdd","","",null,null],[5,"LLVMBuildNUWAdd","","",null,null],[5,"LLVMBuildFAdd","","",null,null],[5,"LLVMBuildSub","","",null,null],[5,"LLVMBuildNSWSub","","",null,null],[5,"LLVMBuildNUWSub","","",null,null],[5,"LLVMBuildFSub","","",null,null],[5,"LLVMBuildMul","","",null,null],[5,"LLVMBuildNSWMul","","",null,null],[5,"LLVMBuildNUWMul","","",null,null],[5,"LLVMBuildFMul","","",null,null],[5,"LLVMBuildUDiv","","",null,null],[5,"LLVMBuildSDiv","","",null,null],[5,"LLVMBuildExactSDiv","","",null,null],[5,"LLVMBuildFDiv","","",null,null],[5,"LLVMBuildURem","","",null,null],[5,"LLVMBuildSRem","","",null,null],[5,"LLVMBuildFRem","","",null,null],[5,"LLVMBuildShl","","",null,null],[5,"LLVMBuildLShr","","",null,null],[5,"LLVMBuildAShr","","",null,null],[5,"LLVMBuildAnd","","",null,null],[5,"LLVMBuildOr","","",null,null],[5,"LLVMBuildXor","","",null,null],[5,"LLVMBuildBinOp","","",null,null],[5,"LLVMBuildNeg","","",null,null],[5,"LLVMBuildNSWNeg","","",null,null],[5,"LLVMBuildNUWNeg","","",null,null],[5,"LLVMBuildFNeg","","",null,null],[5,"LLVMBuildNot","","",null,null],[5,"LLVMBuildMalloc","","",null,null],[5,"LLVMBuildArrayMalloc","","",null,null],[5,"LLVMBuildAlloca","","",null,null],[5,"LLVMBuildArrayAlloca","","",null,null],[5,"LLVMBuildFree","","",null,null],[5,"LLVMBuildLoad","","",null,null],[5,"LLVMBuildStore","","",null,null],[5,"LLVMBuildGEP","","",null,null],[5,"LLVMBuildInBoundsGEP","","",null,null],[5,"LLVMBuildStructGEP","","",null,null],[5,"LLVMBuildGlobalString","","",null,null],[5,"LLVMBuildGlobalStringPtr","","",null,null],[5,"LLVMBuildTrunc","","",null,null],[5,"LLVMBuildZExt","","",null,null],[5,"LLVMBuildSExt","","",null,null],[5,"LLVMBuildFPToUI","","",null,null],[5,"LLVMBuildFPToSI","","",null,null],[5,"LLVMBuildUIToFP","","",null,null],[5,"LLVMBuildSIToFP","","",null,null],[5,"LLVMBuildFPTrunc","","",null,null],[5,"LLVMBuildFPExt","","",null,null],[5,"LLVMBuildPtrToInt","","",null,null],[5,"LLVMBuildIntToPtr","","",null,null],[5,"LLVMBuildBitCast","","",null,null],[5,"LLVMBuildZExtOrBitCast","","",null,null],[5,"LLVMBuildSExtOrBitCast","","",null,null],[5,"LLVMBuildTruncOrBitCast","","",null,null],[5,"LLVMBuildCast","","",null,null],[5,"LLVMBuildPointerCast","","",null,null],[5,"LLVMBuildIntCast","","",null,null],[5,"LLVMBuildFPCast","","",null,null],[5,"LLVMBuildICmp","","",null,null],[5,"LLVMBuildFCmp","","",null,null],[5,"LLVMBuildPhi","","",null,null],[5,"LLVMBuildCall","","",null,null],[5,"LLVMBuildSelect","","",null,null],[5,"LLVMBuildVAArg","","",null,null],[5,"LLVMBuildExtractElement","","",null,null],[5,"LLVMBuildInsertElement","","",null,null],[5,"LLVMBuildShuffleVector","","",null,null],[5,"LLVMBuildExtractValue","","",null,null],[5,"LLVMBuildInsertValue","","",null,null],[5,"LLVMBuildIsNull","","",null,null],[5,"LLVMBuildIsNotNull","","",null,null],[5,"LLVMBuildPtrDiff","","",null,null],[5,"LLVMBuildAtomicLoad","","",null,null],[5,"LLVMBuildAtomicStore","","",null,null],[5,"LLVMBuildAtomicCmpXchg","","",null,null],[5,"LLVMBuildAtomicRMW","","",null,null],[5,"LLVMBuildAtomicFence","","",null,null],[5,"LLVMIsATerminatorInst","","",null,null],[5,"LLVMIsAStoreInst","","",null,null],[5,"LLVMWriteBitcodeToFile","","Writes a module to the specified path. Returns 0 on success.",null,null],[5,"LLVMCreateTargetData","","Creates target data from a target layout string.",null,null],[5,"LLVMAddTargetData","","Adds the target data to the given pass manager. The pass manager\nreferences the target data only weakly.",null,null],[5,"LLVMStoreSizeOfType","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMSizeOfTypeInBits","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMABISizeOfType","","Distance between successive elements in an array of T. Includes ABI padding.",null,null],[5,"LLVMPreferredAlignmentOfType","","Returns the preferred alignment of a type.",null,null],[5,"LLVMABIAlignmentOfType","","Returns the minimum alignment of a type.",null,null],[5,"LLVMOffsetOfElement","","Computes the byte offset of the indexed struct element for a\ntarget.",null,null],[5,"LLVMCallFrameAlignmentOfType","","Returns the minimum alignment of a type when part of a call frame.",null,null],[5,"LLVMDisposeTargetData","","Disposes target data.",null,null],[5,"LLVMCreatePassManager","","Creates a pass manager.",null,null],[5,"LLVMCreateFunctionPassManagerForModule","","Creates a function-by-function pass manager",null,null],[5,"LLVMDisposePassManager","","Disposes a pass manager.",null,null],[5,"LLVMRunPassManager","","Runs a pass manager on a module.",null,null],[5,"LLVMRunFunctionPassManager","","Runs the function passes on the provided function.",null,null],[5,"LLVMInitializeFunctionPassManager","","Initializes all the function passes scheduled in the manager",null,null],[5,"LLVMFinalizeFunctionPassManager","","Finalizes all the function passes scheduled in the manager",null,null],[5,"LLVMInitializePasses","","",null,null],[5,"LLVMAddVerifierPass","","Adds a verification pass.",null,null],[5,"LLVMAddGlobalOptimizerPass","","",null,null],[5,"LLVMAddIPSCCPPass","","",null,null],[5,"LLVMAddDeadArgEliminationPass","","",null,null],[5,"LLVMAddInstructionCombiningPass","","",null,null],[5,"LLVMAddCFGSimplificationPass","","",null,null],[5,"LLVMAddFunctionInliningPass","","",null,null],[5,"LLVMAddFunctionAttrsPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPassSSA","","",null,null],[5,"LLVMAddJumpThreadingPass","","",null,null],[5,"LLVMAddConstantPropagationPass","","",null,null],[5,"LLVMAddReassociatePass","","",null,null],[5,"LLVMAddLoopRotatePass","","",null,null],[5,"LLVMAddLICMPass","","",null,null],[5,"LLVMAddLoopUnswitchPass","","",null,null],[5,"LLVMAddLoopDeletionPass","","",null,null],[5,"LLVMAddLoopUnrollPass","","",null,null],[5,"LLVMAddGVNPass","","",null,null],[5,"LLVMAddMemCpyOptPass","","",null,null],[5,"LLVMAddSCCPPass","","",null,null],[5,"LLVMAddDeadStoreEliminationPass","","",null,null],[5,"LLVMAddStripDeadPrototypesPass","","",null,null],[5,"LLVMAddConstantMergePass","","",null,null],[5,"LLVMAddArgumentPromotionPass","","",null,null],[5,"LLVMAddTailCallEliminationPass","","",null,null],[5,"LLVMAddIndVarSimplifyPass","","",null,null],[5,"LLVMAddAggressiveDCEPass","","",null,null],[5,"LLVMAddGlobalDCEPass","","",null,null],[5,"LLVMAddCorrelatedValuePropagationPass","","",null,null],[5,"LLVMAddPruneEHPass","","",null,null],[5,"LLVMAddSimplifyLibCallsPass","","",null,null],[5,"LLVMAddLoopIdiomPass","","",null,null],[5,"LLVMAddEarlyCSEPass","","",null,null],[5,"LLVMAddTypeBasedAliasAnalysisPass","","",null,null],[5,"LLVMAddBasicAliasAnalysisPass","","",null,null],[5,"LLVMPassManagerBuilderCreate","","",null,null],[5,"LLVMPassManagerBuilderDispose","","",null,null],[5,"LLVMPassManagerBuilderSetOptLevel","","",null,null],[5,"LLVMPassManagerBuilderSetSizeLevel","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnitAtATime","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnrollLoops","","",null,null],[5,"LLVMPassManagerBuilderSetDisableSimplifyLibCalls","","",null,null],[5,"LLVMPassManagerBuilderUseInlinerWithThreshold","","",null,null],[5,"LLVMPassManagerBuilderPopulateModulePassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateFunctionPassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateLTOPassManager","","",null,null],[5,"LLVMDisposeMemoryBuffer","","Destroys a memory buffer.",null,null],[5,"LLVMCreateObjectFile","","Opens an object file.",null,null],[5,"LLVMDisposeObjectFile","","Closes an object file.",null,null],[5,"LLVMGetSections","","Enumerates the sections in an object file.",null,null],[5,"LLVMDisposeSectionIterator","","Destroys a section iterator.",null,null],[5,"LLVMIsSectionIteratorAtEnd","","Returns true if the section iterator is at the end of the section\nlist:",null,null],[5,"LLVMMoveToNextSection","","Moves the section iterator to point to the next section.",null,null],[5,"LLVMGetSectionSize","","Returns the current section size.",null,null],[5,"LLVMGetSectionContents","","Returns the current section contents as a string buffer.",null,null],[5,"LLVMRustCreateMemoryBufferWithContentsOfFile","","Reads the given file and returns it as a memory buffer. Use\nLLVMDisposeMemoryBuffer() to get rid of it.",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRange","","Borrows the contents of the memory buffer (doesn't copy it)",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRangeCopy","","",null,null],[5,"LLVMIsMultithreaded","","",null,{"inputs":[],"output":{"name":"u32"}}],[5,"LLVMStartMultithreaded","","",null,{"inputs":[],"output":{"name":"u32"}}],[5,"LLVMRustGetLastError","","Returns a string describing the last error caused by an LLVMRust* call.",null,null],[5,"LLVMRustPrintPassTimings","","Print the pass timings since static dtors aren't picking them up.",null,null],[5,"LLVMStructCreateNamed","","",null,null],[5,"LLVMStructSetBody","","",null,null],[5,"LLVMConstNamedStruct","","",null,null],[5,"LLVMSetDebug","","Enables LLVM debug output.",null,null],[5,"LLVMInlineAsm","","Prepares inline assembly.",null,null],[7,"LLVMRustDebugMetadataVersion","","",null,null],[5,"LLVMRustAddModuleFlag","","",null,null],[5,"LLVMDIBuilderCreate","","",null,null],[5,"LLVMDIBuilderDispose","","",null,null],[5,"LLVMDIBuilderFinalize","","",null,null],[5,"LLVMDIBuilderCreateCompileUnit","","",null,null],[5,"LLVMDIBuilderCreateFile","","",null,null],[5,"LLVMDIBuilderCreateSubroutineType","","",null,null],[5,"LLVMDIBuilderCreateFunction","","",null,null],[5,"LLVMDIBuilderCreateBasicType","","",null,null],[5,"LLVMDIBuilderCreatePointerType","","",null,null],[5,"LLVMDIBuilderCreateStructType","","",null,null],[5,"LLVMDIBuilderCreateMemberType","","",null,null],[5,"LLVMDIBuilderCreateLexicalBlock","","",null,null],[5,"LLVMDIBuilderCreateStaticVariable","","",null,null],[5,"LLVMDIBuilderCreateVariable","","",null,null],[5,"LLVMDIBuilderCreateArrayType","","",null,null],[5,"LLVMDIBuilderCreateVectorType","","",null,null],[5,"LLVMDIBuilderGetOrCreateSubrange","","",null,null],[5,"LLVMDIBuilderGetOrCreateArray","","",null,null],[5,"LLVMDIBuilderInsertDeclareAtEnd","","",null,null],[5,"LLVMDIBuilderInsertDeclareBefore","","",null,null],[5,"LLVMDIBuilderCreateEnumerator","","",null,null],[5,"LLVMDIBuilderCreateEnumerationType","","",null,null],[5,"LLVMDIBuilderCreateUnionType","","",null,null],[5,"LLVMSetUnnamedAddr","","",null,null],[5,"LLVMDIBuilderCreateTemplateTypeParameter","","",null,null],[5,"LLVMDIBuilderCreateOpDeref","","",null,{"inputs":[],"output":{"name":"i64"}}],[5,"LLVMDIBuilderCreateOpPlus","","",null,{"inputs":[],"output":{"name":"i64"}}],[5,"LLVMDIBuilderCreateNameSpace","","",null,null],[5,"LLVMDIBuilderCreateDebugLocation","","",null,null],[5,"LLVMDICompositeTypeSetTypeArray","","",null,null],[5,"LLVMWriteTypeToString","","",null,null],[5,"LLVMWriteValueToString","","",null,null],[5,"LLVMIsAArgument","","",null,null],[5,"LLVMIsAAllocaInst","","",null,null],[5,"LLVMIsAConstantInt","","",null,null],[5,"LLVMInitializeX86TargetInfo","","",null,null],[5,"LLVMInitializeX86Target","","",null,null],[5,"LLVMInitializeX86TargetMC","","",null,null],[5,"LLVMInitializeX86AsmPrinter","","",null,null],[5,"LLVMInitializeX86AsmParser","","",null,null],[5,"LLVMInitializeARMTargetInfo","","",null,null],[5,"LLVMInitializeARMTarget","","",null,null],[5,"LLVMInitializeARMTargetMC","","",null,null],[5,"LLVMInitializeARMAsmPrinter","","",null,null],[5,"LLVMInitializeARMAsmParser","","",null,null],[5,"LLVMInitializeAArch64TargetInfo","","",null,null],[5,"LLVMInitializeAArch64Target","","",null,null],[5,"LLVMInitializeAArch64TargetMC","","",null,null],[5,"LLVMInitializeAArch64AsmPrinter","","",null,null],[5,"LLVMInitializeAArch64AsmParser","","",null,null],[5,"LLVMInitializeMipsTargetInfo","","",null,null],[5,"LLVMInitializeMipsTarget","","",null,null],[5,"LLVMInitializeMipsTargetMC","","",null,null],[5,"LLVMInitializeMipsAsmPrinter","","",null,null],[5,"LLVMInitializeMipsAsmParser","","",null,null],[5,"LLVMInitializePowerPCTargetInfo","","",null,null],[5,"LLVMInitializePowerPCTarget","","",null,null],[5,"LLVMInitializePowerPCTargetMC","","",null,null],[5,"LLVMInitializePowerPCAsmPrinter","","",null,null],[5,"LLVMInitializePowerPCAsmParser","","",null,null],[5,"LLVMRustAddPass","","",null,null],[5,"LLVMRustCreateTargetMachine","","",null,null],[5,"LLVMRustDisposeTargetMachine","","",null,null],[5,"LLVMRustAddAnalysisPasses","","",null,null],[5,"LLVMRustAddBuilderLibraryInfo","","",null,null],[5,"LLVMRustAddLibraryInfo","","",null,null],[5,"LLVMRustRunFunctionPassManager","","",null,null],[5,"LLVMRustWriteOutputFile","","",null,null],[5,"LLVMRustPrintModule","","",null,null],[5,"LLVMRustSetLLVMOptions","","",null,null],[5,"LLVMRustPrintPasses","","",null,null],[5,"LLVMRustSetNormalizedTarget","","",null,null],[5,"LLVMRustAddAlwaysInlinePass","","",null,null],[5,"LLVMRustLinkInExternalBitcode","","",null,null],[5,"LLVMRustRunRestrictionPass","","",null,null],[5,"LLVMRustMarkAllFunctionsNounwind","","",null,null],[5,"LLVMRustOpenArchive","","",null,null],[5,"LLVMRustArchiveReadSection","","",null,null],[5,"LLVMRustDestroyArchive","","",null,null],[5,"LLVMRustSetDLLExportStorageClass","","",null,null],[5,"LLVMVersionMajor","","",null,{"inputs":[],"output":{"name":"i32"}}],[5,"LLVMVersionMinor","","",null,{"inputs":[],"output":{"name":"i32"}}],[5,"LLVMRustGetSectionName","","",null,null],[5,"LLVMWriteTwineToString","","",null,null],[5,"LLVMContextSetDiagnosticHandler","","",null,null],[5,"LLVMUnpackOptimizationDiagnostic","","",null,null],[5,"LLVMUnpackInlineAsmDiagnostic","","",null,null],[5,"LLVMWriteDiagnosticInfoToString","","",null,null],[5,"LLVMGetDiagInfoSeverity","","",null,null],[5,"LLVMGetDiagInfoKind","","",null,null],[5,"LLVMWriteDebugLocToString","","",null,null],[5,"LLVMSetInlineAsmDiagnosticHandler","","",null,null],[5,"LLVMWriteSMDiagnosticToString","","",null,null],[5,"SetInstructionCallConv","","",null,null],[5,"SetFunctionCallConv","","",null,null],[5,"SetLinkage","","",null,null],[5,"SetUnnamedAddr","","",null,null],[5,"set_thread_local","","",null,null],[5,"ConstICmp","","",null,null],[5,"ConstFCmp","","",null,null],[5,"SetFunctionAttribute","","",null,null],[3,"TargetData","","",null,null],[12,"lltd","","",27,null],[5,"mk_target_data","","",null,{"inputs":[{"name":"str"}],"output":{"name":"targetdata"}}],[3,"ObjectFile","","",null,null],[12,"llof","","",28,null],[3,"SectionIter","","",null,null],[12,"llsi","","",29,null],[5,"mk_section_iter","","",null,null],[5,"get_param","","Safe wrapper around `LLVMGetParam`, because segfaults are no fun.",null,null],[4,"RustString_opaque","","",null,null],[6,"RustStringRef","","",null,null],[5,"rust_llvm_string_write_impl","","Appending to a Rust string -- used by raw_rust_string_ostream.",null,null],[5,"build_string","","",null,{"inputs":[{"name":"f"}],"output":{"name":"option"}}],[5,"twine_to_string","","",null,null],[5,"debug_loc_to_string","","",null,null],[0,"diagnostics","rustc","",null,null],[7,"DIAGNOSTICS","rustc::diagnostics","",null,null],[0,"back","rustc","",null,null],[0,"abi","rustc::back","",null,null],[17,"BOX_FIELD_DROP_GLUE","rustc::back::abi","",null,null],[17,"BOX_FIELD_BODY","","",null,null],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.\n- For a closure, this is the code address.\n- For an object or trait instance, this is the address of the box.\n- For a slice, this is the base address.",null,null],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.\n- For a closure, this is the address of the environment.\n- For an object or trait instance, this is the address of the vtable.\n- For a slice, this is the length.",null,null],[0,"archive","rustc::back","A helper class for dealing with static archives",null,null],[17,"METADATA_FILENAME","rustc::back::archive","",null,null],[11,"open","rustc_back::archive","Opens an existing static archive",31,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",31,null],[11,"files","","Lists all files in an archive",31,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",31,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",32,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",32,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",32,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",32,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",32,null],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",32,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[11,"new_in","rustc_back::tempdir","Attempts to make a temporary directory inside of `tmpdir` whose name\nwill have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",33,{"inputs":[{"name":"tempdir"},{"name":"p"},{"name":"str"}],"output":{"name":"result"}}],[11,"new","","Attempts to make a temporary directory inside of `env::temp_dir()` whose\nname will have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",33,{"inputs":[{"name":"tempdir"},{"name":"str"}],"output":{"name":"result"}}],[11,"into_path","","Unwrap the wrapped `std::path::Path` from the `TempDir` wrapper.\nThis discards the wrapper so that the automatic deletion of the\ntemporary directory is prevented.",33,{"inputs":[{"name":"tempdir"}],"output":{"name":"pathbuf"}}],[11,"path","","Access the wrapped `std::path::Path` to the temporary directory.",33,{"inputs":[{"name":"tempdir"}],"output":{"name":"path"}}],[11,"close","","Close and remove the temporary directory",33,{"inputs":[{"name":"tempdir"}],"output":{"name":"result"}}],[11,"drop","","",33,null],[11,"input","rustc_back::sha2","",34,null],[11,"reset","","",34,null],[11,"zero_until","","",34,null],[11,"next","","",34,null],[11,"full_buffer","","",34,null],[11,"position","","",34,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"remaining","","",34,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"size","","",34,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",35,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",35,null],[11,"result","","",35,null],[11,"reset","","",35,null],[11,"output_bits","","",35,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[11,"fmt","rustc_back::svh","",36,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",36,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",36,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",36,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",36,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","rustc_back::svh::svh_visitor","",37,null],[11,"hash","","",38,null],[11,"hash","","",39,null],[11,"get_content","syntax::ast","",40,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"get_content","","",41,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[11,"visit_mac","rustc_back::svh::svh_visitor","",42,null],[11,"visit_struct_def","","",42,null],[11,"visit_variant","","",42,null],[11,"visit_opt_lifetime_ref","","",42,null],[11,"visit_ident","","",42,null],[11,"visit_lifetime_ref","","",42,null],[11,"visit_lifetime_def","","",42,null],[11,"visit_expr","","",42,null],[11,"visit_stmt","","",42,null],[11,"visit_foreign_item","","",42,null],[11,"visit_item","","",42,null],[11,"visit_mod","","",42,null],[11,"visit_decl","","",42,null],[11,"visit_ty","","",42,null],[11,"visit_generics","","",42,null],[11,"visit_fn","","",42,null],[11,"visit_trait_item","","",42,null],[11,"visit_impl_item","","",42,null],[11,"visit_struct_field","","",42,null],[11,"visit_explicit_self","","",42,null],[11,"visit_path","","",42,null],[11,"visit_block","","",42,null],[11,"visit_pat","","",42,null],[11,"visit_local","","",42,null],[11,"visit_arm","","",42,null],[11,"clone","rustc_back::target::apple_ios_base","",43,{"inputs":[{"name":"arch"}],"output":{"name":"arch"}}],[11,"to_string","","",43,{"inputs":[{"name":"arch"}],"output":{"name":"str"}}],[11,"fmt","rustc_back::target","",44,{"inputs":[{"name":"target"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",44,{"inputs":[{"name":"target"}],"output":{"name":"target"}}],[11,"fmt","","",45,{"inputs":[{"name":"targetoptions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",45,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for\ncompilation, will certainly not work.",45,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",44,{"inputs":[{"name":"target"},{"name":"abi"}],"output":{"name":"abi"}}],[11,"from_json","","Load a target descriptor from a JSON object.",44,{"inputs":[{"name":"target"},{"name":"json"}],"output":{"name":"target"}}],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target\ntriple. Note that it could also just be a bare filename already, so also\ncheck for that. If one of the hardcoded targets we know about, just\nreturn it directly.",44,{"inputs":[{"name":"target"},{"name":"str"}],"output":{"name":"result"}}],[3,"ArchiveConfig","rustc::back::archive","",null,null],[12,"handler","","",46,null],[12,"dst","","",46,null],[12,"lib_search_paths","","",46,null],[12,"slib_prefix","","",46,null],[12,"slib_suffix","","",46,null],[12,"maybe_ar_prog","","",46,null],[3,"Archive","","",null,null],[3,"ArchiveBuilder","","Helper for adding many files to an archive with a single invocation of\n`ar`.",null,null],[5,"find_library","","",null,null],[0,"arm","rustc::back","",null,null],[5,"get_target_strs","rustc::back::arm","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"mips","rustc::back","",null,null],[5,"get_target_strs","rustc::back::mips","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"mipsel","rustc::back","",null,null],[5,"get_target_strs","rustc::back::mipsel","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"rpath","rustc::back","",null,null],[3,"RPathConfig","rustc::back::rpath","",null,null],[12,"used_crates","","",47,null],[12,"out_filename","","",47,null],[12,"is_like_osx","","",47,null],[12,"has_rpath","","",47,null],[12,"get_install_prefix_lib_path","","",47,null],[12,"realpath","","",47,null],[5,"get_rpath_flags","","",null,{"inputs":[{"name":"rpathconfig"}],"output":{"name":"vec"}}],[0,"svh","rustc::back","Calculation and management of a Strict Version Hash for crates",null,null],[3,"Svh","rustc::back::svh","",null,null],[0,"target_strs","rustc::back","",null,null],[3,"t","rustc::back::target_strs","",null,null],[12,"module_asm","","",48,null],[12,"data_layout","","",48,null],[12,"target_triple","","",48,null],[12,"cc_args","","",48,null],[0,"x86","rustc::back","",null,null],[5,"get_target_strs","rustc::back::x86","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"x86_64","rustc::back","",null,null],[5,"get_target_strs","rustc::back::x86_64","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"middle","rustc","",null,null],[0,"astconv_util","rustc::middle","This module contains a simple utility routine\nused by both `typeck` and `const_eval`.\nAlmost certainly this could (and should) be refactored out of existence.",null,null],[5,"check_path_args","rustc::middle::astconv_util","",null,null],[5,"prim_ty_to_ty","","",null,null],[5,"ast_ty_to_prim_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"option"}}],[17,"NO_REGIONS","","",null,null],[17,"NO_TPS","","",null,null],[0,"astencode","rustc::middle","",null,null],[5,"encode_inlined_item","rustc::middle::astencode","",null,{"inputs":[{"name":"encodecontext"},{"name":"encoder"},{"name":"inlineditemref"}],"output":null}],[5,"decode_inlined_item","","Decodes an item from its AST in the cdata's metadata and adds it to the\nast-map.",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"vec"},{"name":"doc"}],"output":{"name":"result"}}],[5,"encode_closure_kind","","",null,{"inputs":[{"name":"encoder"},{"name":"closurekind"}],"output":null}],[8,"vtable_decoder_helpers","","",null,null],[10,"read_vec_per_param_space","","",49,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_res_with_key","","",49,null],[10,"read_vtable_res","","",49,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_res"}}],[10,"read_vtable_param_res","","",49,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_param_res"}}],[10,"read_vtable_origin","","",49,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[11,"read_vec_per_param_space","rbml::reader","",50,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_res_with_key","","",50,null],[11,"read_vtable_res","","",50,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_res"}}],[11,"read_vtable_param_res","","",50,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_param_res"}}],[11,"read_vtable_origin","","",50,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[0,"cfg","rustc::middle","Module that constructs a control-flow graph representing an item.\nUses `Graph` as the underlying representation.",null,null],[3,"CFG","rustc::middle::cfg","",null,null],[12,"graph","","",51,null],[12,"entry","","",51,null],[12,"exit","","",51,null],[3,"CFGEdgeData","","",null,null],[12,"exiting_scopes","","",52,null],[4,"CFGNodeData","","",null,null],[13,"AST","","",53,null],[13,"Entry","","",53,null],[13,"Exit","","",53,null],[13,"Dummy","","",53,null],[13,"Unreachable","","",53,null],[0,"graphviz","","",null,null],[3,"LabelledCFG","rustc::middle::cfg::graphviz","",null,null],[12,"ast_map","","",54,null],[12,"cfg","","",54,null],[12,"name","","",54,null],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",54,null],[6,"Node","","",null,null],[6,"Edge","","",null,null],[11,"graph_id","","",54,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"id"}}],[11,"node_id","","",54,{"inputs":[{"name":"labelledcfg"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",54,{"inputs":[{"name":"labelledcfg"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",54,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",54,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"nodes"}}],[11,"edges","","",54,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"edges"}}],[11,"source","","",54,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",54,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"node"}}],[6,"CFGIndex","rustc::middle::cfg","",null,null],[6,"CFGGraph","","",null,null],[6,"CFGNode","","",null,null],[6,"CFGEdge","","",null,null],[11,"eq","","",53,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",53,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"cfgnodedata"}}],[11,"id","","",53,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"nodeid"}}],[11,"new","","",51,{"inputs":[{"name":"cfg"},{"name":"ctxt"},{"name":"block"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",51,{"inputs":[{"name":"cfg"},{"name":"nodeid"}],"output":{"name":"bool"}}],[0,"check_const","rustc::middle","",null,null],[3,"ConstQualif","rustc::middle::check_const","",null,null],[5,"check_crate","","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[17,"PURE_CONST","","",null,null],[17,"MUTABLE_MEM","","",null,null],[17,"NEEDS_DROP","","",null,null],[17,"PREFER_IN_PLACE","","",null,null],[17,"NON_ZERO_SIZED","","",null,null],[17,"HAS_STATIC_BORROWS","","",null,null],[17,"NOT_CONST","","",null,null],[17,"NON_STATIC_BORROWS","","",null,null],[11,"hash","","",55,null],[11,"cmp","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"option"}}],[11,"lt","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"le","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"gt","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ge","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"decode","","",55,{"inputs":[{"name":"constqualif"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",55,{"inputs":[{"name":"constqualif"},{"name":"__s"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"all","","Returns the set containing all flags.",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",55,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",55,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"constqualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":null}],[6,"Output","","",null,null],[11,"bitor","","Returns the union of the two sets of flags.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","","",null,null],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","","",null,null],[11,"bitand","","Returns the intersection between the two sets of flags.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","","",null,null],[11,"sub","","Returns the set difference of the two sets of flags.",55,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","","",null,null],[11,"not","","Returns the complement of this set of flags.",55,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[0,"check_static_recursion","rustc::middle","",null,null],[5,"check_crate","rustc::middle::check_static_recursion","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"defmap"},{"name":"map"}],"output":null}],[5,"check_item_recursion","","",null,{"inputs":[{"name":"session"},{"name":"map"},{"name":"defmap"},{"name":"item"}],"output":null}],[0,"check_loop","rustc::middle","",null,null],[5,"check_crate","rustc::middle::check_loop","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":null}],[0,"check_match","rustc::middle","",null,null],[3,"MatchCheckCtxt","rustc::middle::check_match","",null,null],[12,"tcx","","",56,null],[12,"param_env","","",56,null],[3,"StaticInliner","","",null,null],[12,"tcx","","",57,null],[12,"failed","","",57,null],[12,"renaming_map","","",57,null],[4,"Constructor","","",null,null],[13,"Single","","The constructor of all patterns that don't vary by constructor,\ne.g. struct patterns and fixed-length arrays.",58,null],[13,"Variant","","Enum variants.",58,null],[13,"ConstantValue","","Literal values.",58,null],[13,"ConstantRange","","Ranges of literal values (2..5).",58,null],[13,"Slice","","Array patterns of length n.",58,null],[13,"SliceWithSubslice","","Array patterns with a subslice.",58,null],[5,"check_crate","","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor\nis how many subpattern patterns of that constructor should be expanded to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"ty"}],"output":{"name":"usize"}}],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row\ninto `arity` patterns based on the constructor. For most patterns, the step is trivial,\nfor instance tuple patterns are flattened and box patterns expand into their inner pattern.",null,null],[17,"DUMMY_WILD_PAT","","",null,null],[11,"eq","","",58,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"constructor"}],"output":{"name":"constructor"}}],[11,"visit_expr","","",56,{"inputs":[{"name":"matchcheckctxt"},{"name":"expr"}],"output":null}],[11,"visit_local","","",56,{"inputs":[{"name":"matchcheckctxt"},{"name":"local"}],"output":null}],[11,"visit_fn","","",56,{"inputs":[{"name":"matchcheckctxt"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"new","","",57,{"inputs":[{"name":"staticinliner"},{"name":"ctxt"},{"name":"option"}],"output":{"name":"staticinliner"}}],[11,"fold_pat","","",57,{"inputs":[{"name":"staticinliner"},{"name":"p"}],"output":{"name":"p"}}],[0,"check_rvalues","rustc::middle","",null,null],[5,"check_crate","rustc::middle::check_rvalues","",null,{"inputs":[{"name":"ctxt"},{"name":"crate"}],"output":null}],[0,"const_eval","rustc::middle","",null,null],[3,"ConstEvalErr","rustc::middle::const_eval","",null,null],[12,"span","","",59,null],[12,"kind","","",59,null],[4,"const_val","","",null,null],[13,"const_float","","",60,null],[13,"const_int","","",60,null],[13,"const_uint","","",60,null],[13,"const_str","","",60,null],[13,"const_binary","","",60,null],[13,"const_bool","","",60,null],[13,"Struct","","",60,null],[13,"Tuple","","",60,null],[4,"ErrKind","","",null,null],[13,"CannotCast","","",61,null],[13,"CannotCastTo","","",61,null],[13,"InvalidOpForBools","","",61,null],[13,"InvalidOpForFloats","","",61,null],[13,"InvalidOpForIntUint","","",61,null],[13,"InvalidOpForUintInt","","",61,null],[13,"NegateOnString","","",61,null],[13,"NegateOnBoolean","","",61,null],[13,"NegateOnBinary","","",61,null],[13,"NegateOnStruct","","",61,null],[13,"NegateOnTuple","","",61,null],[13,"NotOnFloat","","",61,null],[13,"NotOnString","","",61,null],[13,"NotOnBinary","","",61,null],[13,"NotOnStruct","","",61,null],[13,"NotOnTuple","","",61,null],[13,"NegateWithOverflow","","",61,null],[13,"AddiWithOverflow","","",61,null],[13,"SubiWithOverflow","","",61,null],[13,"MuliWithOverflow","","",61,null],[13,"AdduWithOverflow","","",61,null],[13,"SubuWithOverflow","","",61,null],[13,"MuluWithOverflow","","",61,null],[13,"DivideByZero","","",61,null],[13,"DivideWithOverflow","","",61,null],[13,"ModuloByZero","","",61,null],[13,"ModuloWithOverflow","","",61,null],[13,"ShiftLeftWithOverflow","","",61,null],[13,"ShiftRightWithOverflow","","",61,null],[13,"MissingStructField","","",61,null],[13,"NonConstPath","","",61,null],[13,"ExpectedConstTuple","","",61,null],[13,"ExpectedConstStruct","","",61,null],[13,"TupleIndexOutOfBounds","","",61,null],[13,"MiscBinaryOp","","",61,null],[13,"MiscCatchAll","","",61,null],[4,"IntTy","","",null,null],[13,"I8","","",62,null],[13,"I16","","",62,null],[13,"I32","","",62,null],[13,"I64","","",62,null],[4,"UintTy","","",null,null],[13,"U8","","",63,null],[13,"U16","","",63,null],[13,"U32","","",63,null],[13,"U64","","",63,null],[5,"lookup_const_by_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"const_expr_to_pat","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"span"}],"output":{"name":"p"}}],[5,"eval_const_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"const_val"}}],[5,"const_int_checked_neg","","",null,{"inputs":[{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_neg","","",null,{"inputs":[{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_add","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_sub","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_mul","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_div","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_rem","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_shl","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_shl_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_shr","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_int_checked_shr_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_add","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_sub","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_mul","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_div","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_rem","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_shl","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_shl_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_shr","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"const_uint_checked_shr_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"eval_const_expr_partial","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"option"}],"output":{"name":"evalresult"}}],[5,"compare_const_vals","","",null,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"option"}}],[5,"compare_lit_exprs","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"expr"},{"name":"option"}],"output":{"name":"option"}}],[6,"EvalResult","","",null,null],[6,"CastResult","","",null,null],[11,"eq","","",60,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"ne","","",60,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"clone","","",60,{"inputs":[{"name":"const_val"}],"output":{"name":"const_val"}}],[11,"clone","","",59,{"inputs":[{"name":"constevalerr"}],"output":{"name":"constevalerr"}}],[11,"clone","","",61,{"inputs":[{"name":"errkind"}],"output":{"name":"errkind"}}],[11,"description","","",59,{"inputs":[{"name":"constevalerr"}],"output":{"name":"cow"}}],[11,"fmt","","",62,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",62,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",62,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",62,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",63,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",63,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",63,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",63,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"from","","",62,{"inputs":[{"name":"intty"},{"name":"ctxt"},{"name":"intty"}],"output":{"name":"intty"}}],[11,"from","","",63,{"inputs":[{"name":"uintty"},{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"uintty"}}],[0,"dataflow","rustc::middle","A module for propagating forward dataflow information. The analysis\nassumes that the items to be propagated can be represented as bits\nand thus uses bitvectors. Your job is simply to specify the so-called\nGEN and KILL bits for each expression.",null,null],[3,"DataFlowContext","rustc::middle::dataflow","",null,null],[4,"EntryOrExit","","",null,null],[13,"Entry","","",64,null],[13,"Exit","","",64,null],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill\ntakes effect only when control flows directly through the node in\nquestion, or if the kill's effect is associated with any\ncontrol-flow directly through or indirectly over the node.",null,null],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control\nflow goes over the node. A kill associated with the end of the\nscope of a variable declaration `let x;` is an example of a\n`ScopeEnd` kill.",65,null],[13,"Execution","","An `Execution` kill is one that takes effect only when control\nflow goes through the node to completion. A kill associated\nwith an assignment statement `x = expr;` is an example of an\n`Execution` kill.",65,null],[8,"BitwiseOperator","","",null,null],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",66,{"inputs":[{"name":"bitwiseoperator"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",null,null],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",67,{"inputs":[{"name":"dataflowoperator"}],"output":{"name":"bool"}}],[11,"fmt","","",64,{"inputs":[{"name":"entryorexit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",64,{"inputs":[{"name":"entryorexit"}],"output":{"name":"entryorexit"}}],[11,"clone","","",68,{"inputs":[{"name":"dataflowcontext"}],"output":{"name":"dataflowcontext"}}],[11,"pre","","",68,{"inputs":[{"name":"dataflowcontext"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"fmt","","",65,{"inputs":[{"name":"killfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",65,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"killfrom"}],"output":{"name":"killfrom"}}],[11,"new","","",68,{"inputs":[{"name":"dataflowcontext"},{"name":"ctxt"},{"name":"str"},{"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",68,{"inputs":[{"name":"dataflowcontext"},{"name":"nodeid"},{"name":"usize"}],"output":null}],[11,"add_kill","","Indicates that `id` kills `bit`",68,{"inputs":[{"name":"dataflowcontext"},{"name":"killfrom"},{"name":"nodeid"},{"name":"usize"}],"output":null}],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`.\nOnly useful after `propagate()` has been called.",68,{"inputs":[{"name":"dataflowcontext"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`.\nOnly useful after `propagate()` has been called.",68,{"inputs":[{"name":"dataflowcontext"},{"name":"entryorexit"},{"name":"cfgindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",68,{"inputs":[{"name":"dataflowcontext"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow\nexits through any number of enclosing scopes on its way to\nthe new destination. This function infers the kill bits of\nthose control operators based on the kill bits associated\nwith those scopes.",68,{"inputs":[{"name":"dataflowcontext"},{"name":"cfg"}],"output":null}],[11,"propagate","","Performs the data flow analysis.",68,{"inputs":[{"name":"dataflowcontext"},{"name":"cfg"},{"name":"block"}],"output":null}],[0,"dead","rustc::middle","",null,null],[5,"check_crate","rustc::middle::dead","",null,{"inputs":[{"name":"ctxt"},{"name":"exporteditems"},{"name":"nodeset"}],"output":null}],[0,"def","rustc::middle","",null,null],[3,"PathResolution","rustc::middle::def","The result of resolving a path.\nBefore type checking completes, `depth` represents the number of\ntrailing segments which are yet unresolved. Afterwards, if there\nwere no errors, all paths should be fully resolved, with `depth`\nset to `0` and `base_def` representing the final resolution.",null,null],[12,"base_def","","",69,null],[12,"last_private","","",69,null],[12,"depth","","",69,null],[3,"Export","","",null,null],[12,"name","","",70,null],[12,"def_id","","",70,null],[4,"Def","","",null,null],[13,"DefFn","","",71,null],[13,"DefSelfTy","","",71,null],[13,"DefMod","","",71,null],[13,"DefForeignMod","","",71,null],[13,"DefStatic","","",71,null],[13,"DefConst","","",71,null],[13,"DefLocal","","",71,null],[13,"DefVariant","","",71,null],[13,"DefTy","","",71,null],[13,"DefAssociatedTy","","",71,null],[13,"DefTrait","","",71,null],[13,"DefPrimTy","","",71,null],[13,"DefTyParam","","",71,null],[13,"DefUse","","",71,null],[13,"DefUpvar","","",71,null],[13,"DefStruct","","Note that if it's a tuple struct's definition, the node id of the ast::DefId\nmay either refer to the item definition's id or the StructDef.ctor_id.",71,null],[13,"DefRegion","","",71,null],[13,"DefLabel","","",71,null],[13,"DefMethod","","",71,null],[4,"MethodProvenance","","",null,null],[13,"FromTrait","","",72,null],[13,"FromImpl","","",72,null],[6,"DefMap","","",null,null],[6,"ExportMap","","",null,null],[11,"fmt","","",71,{"inputs":[{"name":"def"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",71,null],[11,"decode","","",71,{"inputs":[{"name":"def"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",71,{"inputs":[{"name":"def"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"def"}],"output":{"name":"def"}}],[11,"fmt","","",69,{"inputs":[{"name":"pathresolution"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",69,{"inputs":[{"name":"pathresolution"}],"output":{"name":"pathresolution"}}],[11,"full_def","","Get the definition, if fully resolved, otherwise panic.",69,{"inputs":[{"name":"pathresolution"}],"output":{"name":"def"}}],[11,"def_id","","Get the DefId, if fully resolved, otherwise panic.",69,{"inputs":[{"name":"pathresolution"}],"output":{"name":"defid"}}],[11,"new","","",69,{"inputs":[{"name":"pathresolution"},{"name":"def"},{"name":"lastprivate"},{"name":"usize"}],"output":{"name":"pathresolution"}}],[11,"clone","","",70,{"inputs":[{"name":"export"}],"output":{"name":"export"}}],[11,"fmt","","",72,{"inputs":[{"name":"methodprovenance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",72,null],[11,"decode","","",72,{"inputs":[{"name":"methodprovenance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",72,{"inputs":[{"name":"methodprovenance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"methodprovenance"}],"output":{"name":"methodprovenance"}}],[11,"map","","",72,{"inputs":[{"name":"methodprovenance"},{"name":"f"}],"output":{"name":"methodprovenance"}}],[11,"local_node_id","","",71,{"inputs":[{"name":"def"}],"output":{"name":"nodeid"}}],[11,"def_id","","",71,{"inputs":[{"name":"def"}],"output":{"name":"defid"}}],[11,"variant_def_ids","","",71,{"inputs":[{"name":"def"}],"output":{"name":"option"}}],[0,"dependency_format","rustc::middle","Resolution of mixing rlibs and dylibs",null,null],[5,"calculate","rustc::middle::dependency_format","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[6,"DependencyList","","A list of dependencies for a certain crate type.",null,null],[6,"Dependencies","","A mapping of all required dependencies for a particular flavor of output.",null,null],[0,"effect","rustc::middle","Enforces the Rust effect system. Currently there is just one effect,\n`unsafe`.",null,null],[5,"check_crate","rustc::middle::effect","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[0,"entry","rustc::middle","",null,null],[5,"find_entry_point","rustc::middle::entry","",null,{"inputs":[{"name":"session"},{"name":"map"}],"output":null}],[0,"expr_use_visitor","rustc::middle","A different sort of visitor for walking fn bodies.  Unlike the\nnormal visitor, which just walks the entire body in one shot, the\n`ExprUseVisitor` determines how expressions are being used.",null,null],[3,"ExprUseVisitor","rustc::middle::expr_use_visitor","",null,null],[4,"LoanCause","","",null,null],[13,"ClosureCapture","","",73,null],[13,"AddrOf","","",73,null],[13,"AutoRef","","",73,null],[13,"AutoUnsafe","","",73,null],[13,"RefBinding","","",73,null],[13,"OverloadedOperator","","",73,null],[13,"ClosureInvocation","","",73,null],[13,"ForLoop","","",73,null],[13,"MatchDiscriminant","","",73,null],[4,"ConsumeMode","","",null,null],[13,"Copy","","",74,null],[13,"Move","","",74,null],[4,"MoveReason","","",null,null],[13,"DirectRefMove","","",75,null],[13,"PatBindingMove","","",75,null],[13,"CaptureMove","","",75,null],[4,"MatchMode","","",null,null],[13,"NonBindingMatch","","",76,null],[13,"BorrowingMatch","","",76,null],[13,"CopyingMatch","","",76,null],[13,"MovingMatch","","",76,null],[4,"MutateMode","","",null,null],[13,"Init","","",77,null],[13,"JustWrite","","",77,null],[13,"WriteAndRead","","",77,null],[8,"Delegate","","This trait defines the callbacks you can expect to receive when\nemploying the ExprUseVisitor.",null,null],[10,"consume","","",78,{"inputs":[{"name":"delegate"},{"name":"nodeid"},{"name":"span"},{"name":"cmt"},{"name":"consumemode"}],"output":null}],[10,"matched_pat","","",78,{"inputs":[{"name":"delegate"},{"name":"pat"},{"name":"cmt"},{"name":"matchmode"}],"output":null}],[10,"consume_pat","","",78,{"inputs":[{"name":"delegate"},{"name":"pat"},{"name":"cmt"},{"name":"consumemode"}],"output":null}],[10,"borrow","","",78,{"inputs":[{"name":"delegate"},{"name":"nodeid"},{"name":"span"},{"name":"cmt"},{"name":"region"},{"name":"borrowkind"},{"name":"loancause"}],"output":null}],[10,"decl_without_init","","",78,{"inputs":[{"name":"delegate"},{"name":"nodeid"},{"name":"span"}],"output":null}],[10,"mutate","","",78,{"inputs":[{"name":"delegate"},{"name":"nodeid"},{"name":"span"},{"name":"cmt"},{"name":"mutatemode"}],"output":null}],[11,"fmt","","",73,{"inputs":[{"name":"loancause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"loancause"}],"output":{"name":"loancause"}}],[11,"fmt","","",74,{"inputs":[{"name":"consumemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"consumemode"}],"output":{"name":"consumemode"}}],[11,"fmt","","",75,{"inputs":[{"name":"movereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"movereason"}],"output":{"name":"movereason"}}],[11,"fmt","","",76,{"inputs":[{"name":"matchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",76,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"matchmode"}],"output":{"name":"matchmode"}}],[11,"fmt","","",77,{"inputs":[{"name":"mutatemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",77,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"ne","","",77,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"clone","","",77,{"inputs":[{"name":"mutatemode"}],"output":{"name":"mutatemode"}}],[11,"new","","",79,{"inputs":[{"name":"exprusevisitor"},{"name":"delegate"},{"name":"typer"}],"output":{"name":"exprusevisitor"}}],[11,"walk_fn","","",79,{"inputs":[{"name":"exprusevisitor"},{"name":"fndecl"},{"name":"block"}],"output":null}],[11,"consume_expr","","",79,{"inputs":[{"name":"exprusevisitor"},{"name":"expr"}],"output":null}],[11,"walk_expr","","",79,{"inputs":[{"name":"exprusevisitor"},{"name":"expr"}],"output":null}],[0,"fast_reject","rustc::middle","",null,null],[4,"SimplifiedType","rustc::middle::fast_reject","See `simplify_type",null,null],[13,"BoolSimplifiedType","","",80,null],[13,"CharSimplifiedType","","",80,null],[13,"IntSimplifiedType","","",80,null],[13,"UintSimplifiedType","","",80,null],[13,"FloatSimplifiedType","","",80,null],[13,"EnumSimplifiedType","","",80,null],[13,"StrSimplifiedType","","",80,null],[13,"VecSimplifiedType","","",80,null],[13,"PtrSimplifiedType","","",80,null],[13,"TupleSimplifiedType","","",80,null],[13,"TraitSimplifiedType","","",80,null],[13,"StructSimplifiedType","","",80,null],[13,"ClosureSimplifiedType","","",80,null],[13,"FunctionSimplifiedType","","",80,null],[13,"ParameterSimplifiedType","","",80,null],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc.\nThe idea is to get something simple that we can use to quickly decide if two types could unify\nduring method lookup.",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"bool"}],"output":{"name":"option"}}],[11,"hash","","",80,null],[11,"eq","","",80,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"ne","","",80,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"clone","","",80,{"inputs":[{"name":"simplifiedtype"}],"output":{"name":"simplifiedtype"}}],[0,"free_region","rustc::middle","This file defines",null,null],[3,"FreeRegionMap","rustc::middle::free_region","",null,null],[11,"clone","","",81,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"new","","",81,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"relate_free_regions_from_implications","","",81,null],[11,"relate_free_regions_from_predicates","","",81,null],[11,"relate_free_regions","","",81,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":null}],[11,"sub_free_region","","Determines whether two free regions have a subregion relationship\nby walking the graph encoded in `map`.  Note that\nit is possible that `sub != sup` and `sub <= sup` and `sup <= sub`\n(that is, the user can give two different names to the same lifetime).",81,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run *after\ninference* and sadly the logic is somewhat duplicated with the code in infer.rs.",81,{"inputs":[{"name":"freeregionmap"},{"name":"ctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[0,"graph","rustc::middle","A graph module for use in dataflow, region resolution, and elsewhere.",null,null],[3,"Graph","rustc::middle::graph","",null,null],[3,"Node","","",null,null],[12,"data","","",82,null],[3,"Edge","","",null,null],[12,"data","","",83,null],[3,"NodeIndex","","",null,null],[3,"EdgeIndex","","",null,null],[3,"Direction","","",null,null],[3,"DepthFirstTraversal","","",null,null],[5,"each_edge_index","","",null,{"inputs":[{"name":"edgeindex"},{"name":"f"}],"output":null}],[17,"InvalidNodeIndex","","",null,null],[17,"InvalidEdgeIndex","","",null,null],[17,"Outgoing","","",null,null],[17,"Incoming","","",null,null],[11,"fmt","","",83,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",84,{"inputs":[{"name":"nodeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",84,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",84,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"clone","","",84,{"inputs":[{"name":"nodeindex"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",85,{"inputs":[{"name":"edgeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",85,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",85,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"clone","","",85,{"inputs":[{"name":"edgeindex"}],"output":{"name":"edgeindex"}}],[11,"fmt","","",86,{"inputs":[{"name":"direction"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",86,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",84,{"inputs":[{"name":"nodeindex"}],"output":{"name":"usize"}}],[11,"edge_id","","Returns unique id (unique with respect to the graph holding associated edge).",85,{"inputs":[{"name":"edgeindex"}],"output":{"name":"usize"}}],[11,"new","","",87,{"inputs":[{"name":"graph"}],"output":{"name":"graph"}}],[11,"with_capacity","","",87,{"inputs":[{"name":"graph"},{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",87,null],[11,"all_edges","","",87,null],[11,"next_node_index","","",87,{"inputs":[{"name":"graph"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",87,{"inputs":[{"name":"graph"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",87,{"inputs":[{"name":"graph"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"mut_edge_data","","",87,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge_data","","",87,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge","","",87,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"first_adjacent","","Accesses the index of the first edge adjacent to `node`.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"next_adjacent","","Accesses the next edge in a given direction.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",87,{"inputs":[{"name":"graph"},{"name":"edgeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"each_node","","Iterates over all edges defined in the graph.",87,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_edge","","Iterates over all edges defined in the graph",87,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_outgoing_edge","","Iterates over all outgoing edges from the node `from`",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_incoming_edge","","Iterates over all incoming edges to the node `target`",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_adjacent_edge","","Iterates over all edges adjacent to the node `node`\nin the direction `dir` (either `Outgoing` or `Incoming)",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"},{"name":"f"}],"output":{"name":"bool"}}],[11,"iterate_until_fixed_point","","",87,{"inputs":[{"name":"graph"},{"name":"f"}],"output":null}],[11,"depth_traverse","","",87,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"depthfirsttraversal"}}],[6,"Item","","",null,null],[11,"next","","",88,{"inputs":[{"name":"depthfirsttraversal"}],"output":{"name":"option"}}],[11,"source","","",83,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"target","","",83,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[0,"intrinsicck","rustc::middle","",null,null],[5,"check_crate","rustc::middle::intrinsicck","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[0,"infer","rustc::middle","See the Book for more information.",null,null],[3,"TypeFreshener","rustc::middle::infer","",null,null],[3,"InferCtxt","","",null,null],[12,"tcx","","",89,null],[3,"TypeTrace","","The trace designates the path through inference that we took to\nencounter an error or subtyping constraint.",null,null],[3,"CombinedSnapshot","","",null,null],[4,"TypeOrigin","","Why did we require that the two types be related?",null,null],[13,"Misc","","",90,null],[13,"MethodCompatCheck","","",90,null],[13,"ExprAssignable","","",90,null],[13,"RelateTraitRefs","","",90,null],[13,"RelateSelfType","","",90,null],[13,"RelateOutputImplTypes","","",90,null],[13,"MatchExpressionArm","","",90,null],[13,"IfExpression","","",90,null],[13,"IfExpressionWithNoElse","","",90,null],[13,"RangeExpression","","",90,null],[13,"EquatePredicate","","",90,null],[4,"ValuePairs","","See `error_reporting.rs` for more details",null,null],[13,"Types","","",91,null],[13,"TraitRefs","","",91,null],[13,"PolyTraitRefs","","",91,null],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",null,null],[13,"Subtype","","",92,null],[13,"InfStackClosure","","",92,null],[13,"InvokeClosure","","",92,null],[13,"DerefPointer","","",92,null],[13,"FreeVariable","","",92,null],[13,"IndexSlice","","",92,null],[13,"RelateObjectBound","","",92,null],[13,"RelateParamBound","","",92,null],[13,"RelateRegionParamBound","","",92,null],[13,"RelateDefaultParamBound","","",92,null],[13,"Reborrow","","",92,null],[13,"ReborrowUpvar","","",92,null],[13,"ReferenceOutlivesReferent","","",92,null],[13,"ExprTypeIsNotInScope","","",92,null],[13,"BindingTypeIsNotValidAtDecl","","",92,null],[13,"CallRcvr","","",92,null],[13,"CallArg","","",92,null],[13,"CallReturn","","",92,null],[13,"Operand","","",92,null],[13,"AddrOf","","",92,null],[13,"AutoBorrow","","",92,null],[13,"SafeDestructor","","",92,null],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",null,null],[13,"FnCall","","when a fn is called",93,null],[13,"HigherRankedType","","when two higher-ranked types are compared",93,null],[13,"AssocTypeProjection","","when projecting an associated type",93,null],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",null,null],[13,"MiscVariable","","",94,null],[13,"PatternRegion","","",94,null],[13,"AddrOfRegion","","",94,null],[13,"Autoref","","",94,null],[13,"Coercion","","",94,null],[13,"EarlyBoundRegion","","",94,null],[13,"LateBoundRegion","","",94,null],[13,"UpvarRegion","","",94,null],[13,"BoundRegionInCoherence","","",94,null],[4,"fixup_err","","",null,null],[13,"unresolved_int_ty","","",95,null],[13,"unresolved_float_ty","","",95,null],[13,"unresolved_ty","","",95,null],[5,"fixup_err_to_string","","",null,{"inputs":[{"name":"fixup_err"}],"output":{"name":"string"}}],[5,"new_infer_ctxt","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"inferctxt"}}],[5,"common_supertype","","Computes the least upper-bound of `a` and `b`. If this is not possible, reports an error and\nreturns ty::err.",null,{"inputs":[{"name":"inferctxt"},{"name":"typeorigin"},{"name":"bool"},{"name":"ty"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"ty"},{"name":"ty"}],"output":{"name":"unitresult"}}],[5,"can_mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"ty"},{"name":"ty"}],"output":{"name":"unitresult"}}],[5,"can_mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"ty"},{"name":"ty"}],"output":{"name":"unitresult"}}],[5,"mk_subr","","",null,{"inputs":[{"name":"inferctxt"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[5,"mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"ty"},{"name":"ty"}],"output":{"name":"unitresult"}}],[5,"mk_sub_poly_trait_refs","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"unitresult"}}],[0,"bivariate","","Applies the \"bivariance relationship\" to two types and/or regions.\nIf (A,B) are bivariant then either A <: B or B <: A. It occurs\nwhen type/lifetime parameters are unconstrained. Usually this is\nan error, but we permit it in the specific case where a type\nparameter is constrained in a where-clause via an associated type.",null,null],[3,"Bivariate","rustc::middle::infer::bivariate","",null,null],[11,"new","","",96,{"inputs":[{"name":"bivariate"},{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"tag","","",96,{"inputs":[{"name":"bivariate"}],"output":{"name":"str"}}],[11,"tcx","","",96,{"inputs":[{"name":"bivariate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",96,{"inputs":[{"name":"bivariate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",96,{"inputs":[{"name":"bivariate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",96,{"inputs":[{"name":"bivariate"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"regions","","",96,{"inputs":[{"name":"bivariate"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"binders","","",96,{"inputs":[{"name":"bivariate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[0,"combine","rustc::middle::infer","",null,null],[3,"CombineFields","rustc::middle::infer::combine","",null,null],[12,"infcx","","",97,null],[12,"a_is_expected","","",97,null],[12,"trace","","",97,null],[5,"super_combine_tys","","",null,{"inputs":[{"name":"inferctxt"},{"name":"r"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[8,"RelateResultCompare","","",null,null],[10,"compare","","",98,{"inputs":[{"name":"relateresultcompare"},{"name":"t"},{"name":"f"}],"output":{"name":"relateresult"}}],[11,"clone","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"tcx","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"ctxt"}}],[11,"switch_expected","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"equate","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"bivariate","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"sub","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"lub","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"glb","","",97,{"inputs":[{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"instantiate","","",97,{"inputs":[{"name":"combinefields"},{"name":"ty"},{"name":"relationdir"},{"name":"tyvid"}],"output":{"name":"relateresult"}}],[0,"equate","rustc::middle::infer","",null,null],[3,"Equate","rustc::middle::infer::equate","",null,null],[11,"new","","",99,{"inputs":[{"name":"equate"},{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"tag","","",99,{"inputs":[{"name":"equate"}],"output":{"name":"str"}}],[11,"tcx","","",99,{"inputs":[{"name":"equate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",99,{"inputs":[{"name":"equate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",99,{"inputs":[{"name":"equate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",99,{"inputs":[{"name":"equate"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"regions","","",99,{"inputs":[{"name":"equate"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"binders","","",99,{"inputs":[{"name":"equate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[0,"error_reporting","rustc::middle::infer","Error Reporting Code for the inference engine",null,null],[8,"ErrorReporting","rustc::middle::infer::error_reporting","",null,null],[10,"report_region_errors","","",100,{"inputs":[{"name":"errorreporting"},{"name":"vec"}],"output":null}],[10,"process_errors","","",100,{"inputs":[{"name":"errorreporting"},{"name":"vec"}],"output":{"name":"vec"}}],[10,"report_type_error","","",100,{"inputs":[{"name":"errorreporting"},{"name":"typetrace"},{"name":"type_err"}],"output":null}],[10,"report_and_explain_type_error","","",100,{"inputs":[{"name":"errorreporting"},{"name":"typetrace"},{"name":"type_err"}],"output":null}],[10,"values_str","","",100,{"inputs":[{"name":"errorreporting"},{"name":"valuepairs"}],"output":{"name":"option"}}],[10,"expected_found_str","","",100,{"inputs":[{"name":"errorreporting"},{"name":"expected_found"}],"output":{"name":"option"}}],[10,"report_concrete_failure","","",100,{"inputs":[{"name":"errorreporting"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[10,"report_generic_bound_failure","","",100,{"inputs":[{"name":"errorreporting"},{"name":"subregionorigin"},{"name":"generickind"},{"name":"region"},{"name":"vec"}],"output":null}],[10,"report_sub_sup_conflict","","",100,{"inputs":[{"name":"errorreporting"},{"name":"regionvariableorigin"},{"name":"subregionorigin"},{"name":"region"},{"name":"subregionorigin"},{"name":"region"}],"output":null}],[10,"report_sup_sup_conflict","","",100,{"inputs":[{"name":"errorreporting"},{"name":"regionvariableorigin"},{"name":"subregionorigin"},{"name":"region"},{"name":"subregionorigin"},{"name":"region"}],"output":null}],[10,"report_processed_errors","","",100,null],[10,"give_suggestion","","",100,null],[8,"Resolvable","","",null,null],[10,"resolve","","",101,{"inputs":[{"name":"resolvable"},{"name":"inferctxt"}],"output":{"name":"self"}}],[10,"contains_error","","",101,{"inputs":[{"name":"resolvable"}],"output":{"name":"bool"}}],[11,"report_region_errors","rustc::middle::infer","",89,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":null}],[11,"process_errors","","",89,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"report_type_error","","",89,{"inputs":[{"name":"inferctxt"},{"name":"typetrace"},{"name":"type_err"}],"output":null}],[11,"report_and_explain_type_error","","",89,{"inputs":[{"name":"inferctxt"},{"name":"typetrace"},{"name":"type_err"}],"output":null}],[11,"values_str","","Returns a string of the form \"expected `{}`, found `{}`\", or None if this is a derived\nerror.",89,{"inputs":[{"name":"inferctxt"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str","","",89,{"inputs":[{"name":"inferctxt"},{"name":"expected_found"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",89,{"inputs":[{"name":"inferctxt"},{"name":"subregionorigin"},{"name":"generickind"},{"name":"region"},{"name":"vec"}],"output":null}],[11,"report_concrete_failure","","",89,{"inputs":[{"name":"inferctxt"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[11,"report_sub_sup_conflict","","",89,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"},{"name":"subregionorigin"},{"name":"region"},{"name":"subregionorigin"},{"name":"region"}],"output":null}],[11,"report_sup_sup_conflict","","",89,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"},{"name":"subregionorigin"},{"name":"region"},{"name":"subregionorigin"},{"name":"region"}],"output":null}],[11,"report_processed_errors","","",89,null],[11,"give_suggestion","","",89,null],[11,"resolve","alloc::rc","",102,{"inputs":[{"name":"rc"},{"name":"inferctxt"}],"output":{"name":"rc"}}],[11,"contains_error","","",102,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[0,"glb","rustc::middle::infer","",null,null],[3,"Glb","rustc::middle::infer::glb","\"Greatest lower bound\" (common subtype)",null,null],[11,"new","","",103,{"inputs":[{"name":"glb"},{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"tag","","",103,{"inputs":[{"name":"glb"}],"output":{"name":"str"}}],[11,"tcx","","",103,{"inputs":[{"name":"glb"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",103,{"inputs":[{"name":"glb"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",103,{"inputs":[{"name":"glb"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",103,{"inputs":[{"name":"glb"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"regions","","",103,{"inputs":[{"name":"glb"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"binders","","",103,{"inputs":[{"name":"glb"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[11,"infcx","","",103,{"inputs":[{"name":"glb"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",103,{"inputs":[{"name":"glb"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"higher_ranked_sub","rustc::middle::infer::combine","",97,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[11,"higher_ranked_lub","","",97,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[11,"higher_ranked_glb","","",97,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[0,"lattice","rustc::middle::infer","# Lattice Variables",null,null],[5,"super_lattice_tys","rustc::middle::infer::lattice","",null,{"inputs":[{"name":"l"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[8,"LatticeDir","","",null,null],[10,"infcx","","",104,{"inputs":[{"name":"latticedir"}],"output":{"name":"inferctxt"}}],[10,"relate_bound","","",104,{"inputs":[{"name":"latticedir"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[0,"lub","rustc::middle::infer","",null,null],[3,"Lub","rustc::middle::infer::lub","\"Least upper bound\" (common supertype)",null,null],[11,"new","","",105,{"inputs":[{"name":"lub"},{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"tag","","",105,{"inputs":[{"name":"lub"}],"output":{"name":"str"}}],[11,"tcx","","",105,{"inputs":[{"name":"lub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",105,{"inputs":[{"name":"lub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",105,{"inputs":[{"name":"lub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",105,{"inputs":[{"name":"lub"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"regions","","",105,{"inputs":[{"name":"lub"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"binders","","",105,{"inputs":[{"name":"lub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[11,"infcx","","",105,{"inputs":[{"name":"lub"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",105,{"inputs":[{"name":"lub"},{"name":"ty"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[0,"region_inference","rustc::middle::infer","See README.md",null,null],[3,"TwoRegions","rustc::middle::infer::region_inference","",null,null],[3,"SameRegions","","SameRegions is used to group regions that we think are the same and would\nlike to indicate so to the user.\nFor example, the following function\n```\nstruct Foo { bar: int }\nfn foo2<'a, 'b>(x: &'a Foo) -> &'b int {\n   &x.bar\n}\n```\nwould report an error because we expect 'a and 'b to match, and so we group\n'a and 'b together inside a SameRegions struct",null,null],[12,"scope_id","","",106,null],[12,"regions","","",106,null],[3,"RegionVarBindings","","",null,null],[3,"RegionSnapshot","","",null,null],[4,"Constraint","","",null,null],[13,"ConstrainVarSubVar","","",107,null],[13,"ConstrainRegSubVar","","",107,null],[13,"ConstrainVarSubReg","","",107,null],[4,"Verify","","",null,null],[13,"VerifyRegSubReg","","",108,null],[13,"VerifyGenericBound","","",108,null],[4,"GenericKind","","",null,null],[13,"Param","","",109,null],[13,"Projection","","",109,null],[4,"UndoLogEntry","","",null,null],[13,"OpenSnapshot","","",110,null],[13,"CommitedSnapshot","","",110,null],[13,"AddVar","","",110,null],[13,"AddConstraint","","",110,null],[13,"AddVerify","","",110,null],[13,"AddGiven","","",110,null],[13,"AddCombination","","",110,null],[4,"CombineMapType","","",null,null],[13,"Lub","","",111,null],[13,"Glb","","",111,null],[4,"RegionResolutionError","","",null,null],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",112,null],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a, bs)",112,null],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",112,null],[13,"SupSupConflict","","`SupSupConflict(v, origin1, r1, origin2, r2)`:",112,null],[13,"ProcessedErrors","","For subsets of `ConcreteFailure` and `SubSupConflict`, we can derive\nmore specific errors message by suggesting to the user where they\nshould put a lifetime. In those cases we process and put those errors\ninto `ProcessedErrors` before we do any reporting.",112,null],[4,"VarValue","","",null,null],[13,"NoValue","","",113,null],[13,"Value","","",113,null],[13,"ErrorValue","","",113,null],[6,"CombineMap","","",null,null],[11,"fmt","","",107,{"inputs":[{"name":"constraint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",107,null],[11,"eq","","",107,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",107,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"clone","","",107,{"inputs":[{"name":"constraint"}],"output":{"name":"constraint"}}],[11,"eq","","",109,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",109,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"fmt","","",109,{"inputs":[{"name":"generickind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",109,{"inputs":[{"name":"generickind"}],"output":{"name":"generickind"}}],[11,"hash","","",114,null],[11,"eq","","",114,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",114,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"clone","","",114,{"inputs":[{"name":"tworegions"}],"output":{"name":"tworegions"}}],[11,"eq","","",110,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",110,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",110,{"inputs":[{"name":"undologentry"}],"output":{"name":"undologentry"}}],[11,"eq","","",111,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"ne","","",111,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"clone","","",111,{"inputs":[{"name":"combinemaptype"}],"output":{"name":"combinemaptype"}}],[11,"fmt","","",112,{"inputs":[{"name":"regionresolutionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"regionresolutionerror"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",106,{"inputs":[{"name":"sameregions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"sameregions"}],"output":{"name":"sameregions"}}],[11,"contains","","",106,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"push","","",106,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":null}],[11,"fmt","","",115,{"inputs":[{"name":"regionsnapshot"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"ctxt"}],"output":{"name":"regionvarbindings"}}],[11,"start_snapshot","","",116,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":null}],[11,"rollback_to","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":null}],[11,"num_vars","","",116,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"u32"}}],[11,"new_region_var","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"new_skolemized","","Creates a new skolemized region. Skolemized regions are fresh\nregions used when performing higher-ranked computations. They\nmust be used in a very particular way and are never supposed\nto \"escape\" out into error messages or the code at large.",116,{"inputs":[{"name":"regionvarbindings"},{"name":"boundregion"},{"name":"regionsnapshot"}],"output":{"name":"region"}}],[11,"new_bound","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_given","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregion"},{"name":"regionvid"}],"output":null}],[11,"make_eqregion","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[11,"make_subregion","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":null}],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",116,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"generickind"},{"name":"region"},{"name":"vec"}],"output":null}],[11,"lub_regions","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"resolve_var","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_vars","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"},{"name":"f"}],"output":{"name":"region"}}],[11,"vars_created_since_snapshot","","",116,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":{"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` in any way since the mark `mark` was\nmade---`r0` itself will be the first entry. This is used when checking whether skolemized\nregions are being improperly related to other regions.",116,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"resolve_regions","","This function performs the actual region resolution.  It must be\ncalled after all constraints have been added.  It performs a\nfixed-point iteration to find region values which satisfy all\nconstraints, assuming such values can be found; if they cannot,\nerrors are reported.",116,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregionmap"},{"name":"nodeid"}],"output":{"name":"vec"}}],[11,"clone","","",113,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"repr","","",107,{"inputs":[{"name":"constraint"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",108,{"inputs":[{"name":"verify"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",113,{"inputs":[{"name":"varvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",109,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",109,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"to_ty","","",109,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"ty"}}],[0,"resolve","rustc::middle::infer","",null,null],[3,"OpportunisticTypeResolver","rustc::middle::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces\ntype variables that have been unified with the things they have\nbeen unified with (similar to `shallow_resolve`, but deep). This is\nuseful for printing messages etc but also required at various\npoints for correctness.",null,null],[5,"fully_resolve","","Full type resolution replaces all type and region variables with\ntheir concrete results. If any variable cannot be replaced (never unified, etc)\nthen an `Err` result is returned.",null,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"fres"}}],[11,"new","","",117,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"inferctxt"}],"output":{"name":"opportunistictyperesolver"}}],[11,"tcx","","",117,{"inputs":[{"name":"opportunistictyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",117,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"new","rustc::middle::infer","",118,{"inputs":[{"name":"typefreshener"},{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"tcx","","",118,{"inputs":[{"name":"typefreshener"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",118,{"inputs":[{"name":"typefreshener"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",118,{"inputs":[{"name":"typefreshener"},{"name":"ty"}],"output":{"name":"ty"}}],[0,"sub","","",null,null],[3,"Sub","rustc::middle::infer::sub","\"Greatest lower bound\" (common subtype)",null,null],[11,"new","","",119,{"inputs":[{"name":"sub"},{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"tag","","",119,{"inputs":[{"name":"sub"}],"output":{"name":"str"}}],[11,"tcx","","",119,{"inputs":[{"name":"sub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",119,{"inputs":[{"name":"sub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",119,{"inputs":[{"name":"sub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"tys","","",119,{"inputs":[{"name":"sub"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"regions","","",119,{"inputs":[{"name":"sub"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"binders","","",119,{"inputs":[{"name":"sub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[0,"type_variable","rustc::middle::infer","",null,null],[3,"TypeVariableTable","rustc::middle::infer::type_variable","",null,null],[3,"Snapshot","","",null,null],[4,"RelationDir","","",null,null],[13,"SubtypeOf","","",120,null],[13,"SupertypeOf","","",120,null],[13,"EqTo","","",120,null],[13,"BiTo","","",120,null],[11,"fmt","","",120,{"inputs":[{"name":"relationdir"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",120,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"ne","","",120,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"clone","","",120,{"inputs":[{"name":"relationdir"}],"output":{"name":"relationdir"}}],[11,"new","","",121,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","",121,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"relate_vars","","Records that `a <: b`, `a :> b`, or `a == b`, depending on `dir`.",121,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"},{"name":"relationdir"},{"name":"tyvid"}],"output":null}],[11,"instantiate_and_push","","Instantiates `vid` with the type `ty` and then pushes an entry onto `stack` for each of the\nrelations of `vid` to other variables. The relations will have the form `(ty, dir, vid1)`\nwhere `vid1` is some other variable id.",121,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"},{"name":"ty"},{"name":"vec"}],"output":null}],[11,"new_var","","",121,{"inputs":[{"name":"typevariabletable"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"probe","","",121,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"option"}}],[11,"replace_if_possible","","",121,{"inputs":[{"name":"typevariabletable"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"snapshot","","",121,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","",121,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":null}],[11,"commit","","",121,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":null}],[11,"types_escaping_snapshot","","Find the set of type variables that existed *before* `s`\nbut which have only been unified since `s` started, and\nreturn the types with which they were unified. So if we had\na type variable `V0`, then we started the snapshot, then we\ncreated a type variable `V1`, unifed `V0` with `T0`, and\nunified `V1` with `T1`, this function would return `{T0}`.",121,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":{"name":"vec"}}],[0,"unify","rustc::middle::infer","",null,null],[3,"UnificationTable","rustc::middle::infer::unify","Table of unification keys and their values.",null,null],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes\nmade during the snapshot may either be *committed* or *rolled back*.",null,null],[3,"Node","","Internal type used to represent the result of a `get()` operation.\nConveys the current root and value of the key.",null,null],[12,"key","","",122,null],[12,"value","","",122,null],[12,"rank","","",122,null],[3,"Delegate","","",null,null],[4,"VarValue","","Value of a unification key. We implement Tarjan's union-find\nalgorithm: when two keys are unified, one of them is converted\ninto a \"redirect\" pointing at the other. These redirects form a\nDAG: the roots of the DAG (nodes that are not redirected) are each\nassociated with a value of type `V` and a rank. The rank is used\nto keep the DAG relatively balanced, which helps keep the running\ntime of the algorithm under control. For more information, see\n<http://en.wikipedia.org/wiki/Disjoint-set_data_structure>.",null,null],[13,"Redirect","","",123,null],[13,"Root","","",123,null],[8,"UnifyKey","","This trait is implemented by any type that can serve as a type\nvariable. We call such variables *unification keys*. For example,\nthis trait is implemented by `IntVid`, which represents integral\nvariables.",null,null],[16,"Value","rustc::middle::infer::unify::UnifyKey","",null,null],[10,"index","rustc::middle::infer::unify","",124,{"inputs":[{"name":"unifykey"}],"output":{"name":"u32"}}],[10,"from_index","","",124,{"inputs":[{"name":"unifykey"},{"name":"u32"}],"output":{"name":"self"}}],[10,"tag","","",124,{"inputs":[{"name":"unifykey"},{"name":"option"}],"output":{"name":"str"}}],[8,"UnifyValue","","Trait for valid types that a type variable can be set to. Note that\nthis is typically not the end type that the value will take on, but\nrather an `Option` wrapper (where `None` represents a variable\nwhose value is not yet set).",null,null],[8,"ToType","","",null,null],[10,"to_type","","",125,{"inputs":[{"name":"totype"},{"name":"ctxt"}],"output":{"name":"ty"}}],[11,"fmt","","",123,{"inputs":[{"name":"varvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",123,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"eq","","",123,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",123,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"delegate"}],"output":{"name":"delegate"}}],[11,"new","","",127,{"inputs":[{"name":"unificationtable"}],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either\nrolled back or committed in a \"LIFO\" (stack) order.",127,{"inputs":[{"name":"unificationtable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also\nremoves any keys that have been created since then.",127,{"inputs":[{"name":"unificationtable"},{"name":"snapshot"}],"output":null}],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",127,{"inputs":[{"name":"unificationtable"},{"name":"snapshot"}],"output":null}],[11,"new_key","","",127,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"k"}}],[6,"Value","","",null,null],[6,"Undo","","",null,null],[11,"reverse","","",126,null],[11,"unify_var_var","","",127,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"k"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`. Because simple keys do not have any subtyping\nrelationships, if `a_id` already has a value, it must be the same as `b`.",127,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"v"}],"output":{"name":"result"}}],[11,"has_value","","",127,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"bool"}}],[11,"probe","","",127,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"option"}}],[6,"Value","","",null,null],[6,"Value","","",null,null],[11,"to_type","syntax::ast","",128,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"ty"}}],[6,"Bound","rustc::middle::infer","",null,null],[6,"UnitResult","","",null,null],[6,"fres","","",null,null],[6,"SkolemizationMap","","A map returned by `skolemize_late_bound_regions()` indicating the skolemized\nregion that each late-bound region was replaced with.",null,null],[11,"fmt","","",90,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",90,{"inputs":[{"name":"typeorigin"}],"output":{"name":"typeorigin"}}],[11,"fmt","","",90,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",91,{"inputs":[{"name":"valuepairs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",91,{"inputs":[{"name":"valuepairs"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",129,{"inputs":[{"name":"typetrace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"typetrace"}],"output":{"name":"typetrace"}}],[11,"fmt","","",92,{"inputs":[{"name":"subregionorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",92,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",93,{"inputs":[{"name":"lateboundregionconversiontime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",93,{"inputs":[{"name":"lateboundregionconversiontime"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",94,{"inputs":[{"name":"regionvariableorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",94,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",95,{"inputs":[{"name":"fixup_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",95,{"inputs":[{"name":"fixup_err"}],"output":{"name":"fixup_err"}}],[11,"freshen","","",89,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",89,{"inputs":[{"name":"inferctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"freshener","","",89,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",89,{"inputs":[{"name":"inferctxt"},{"name":"ty"}],"output":{"name":"unconstrainednumeric"}}],[11,"equate","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"equate"}}],[11,"sub","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"sub"}}],[11,"lub","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"lub"}}],[11,"glb","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"glb"}}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",89,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",89,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"commit_regions_if_ok","","Execute `f` and commit only the region bindings if successful.\nThe function f must be very careful not to leak any non-region\nvariables that get created.",89,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",89,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",89,{"inputs":[{"name":"inferctxt"},{"name":"freeregion"},{"name":"regionvid"}],"output":null}],[11,"sub_types","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"ty"},{"name":"ty"}],"output":{"name":"unitresult"}}],[11,"eq_types","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"ty"},{"name":"ty"}],"output":{"name":"unitresult"}}],[11,"sub_trait_refs","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"rc"},{"name":"rc"}],"output":{"name":"unitresult"}}],[11,"sub_poly_trait_refs","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"unitresult"}}],[11,"construct_skolemized_subst","","See `higher_ranked::construct_skolemized_subst`",89,null],[11,"skolemize_late_bound_regions","","See `higher_ranked::skolemize_late_bound_regions`",89,null],[11,"leak_check","","See `higher_ranked::leak_check`",89,{"inputs":[{"name":"inferctxt"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"}],"output":{"name":"unitresult"}}],[11,"plug_leaks","","See `higher_ranked::plug_leaks`",89,{"inputs":[{"name":"inferctxt"},{"name":"skolemizationmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"equality_predicate","","",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"polyequatepredicate"}],"output":{"name":"unitresult"}}],[11,"region_outlives_predicate","","",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"polyregionoutlivespredicate"}],"output":{"name":"unitresult"}}],[11,"next_ty_var_id","","",89,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",89,{"inputs":[{"name":"inferctxt"}],"output":{"name":"ty"}}],[11,"next_diverging_ty_var","","",89,{"inputs":[{"name":"inferctxt"}],"output":{"name":"ty"}}],[11,"next_ty_vars","","",89,{"inputs":[{"name":"inferctxt"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"next_int_var_id","","",89,{"inputs":[{"name":"inferctxt"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",89,{"inputs":[{"name":"inferctxt"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","",89,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"region_vars_for_defs","","",89,null],[11,"fresh_substs_for_generics","","Given a set of generics defined on a type or impl, returns a substitution mapping each\ntype/region parameter to a fresh inference variable.",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"fresh_substs_for_trait","","Given a set of generics defined on a trait, returns a substitution mapping each output\ntype/region parameter to a fresh inference variable, and mapping the self type to\n`self_ty`.",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"},{"name":"ty"}],"output":{"name":"substs"}}],[11,"fresh_bound_region","","",89,{"inputs":[{"name":"inferctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"resolve_regions_and_report_errors","","",89,{"inputs":[{"name":"inferctxt"},{"name":"freeregionmap"},{"name":"nodeid"}],"output":null}],[11,"ty_to_string","","",89,{"inputs":[{"name":"inferctxt"},{"name":"ty"}],"output":{"name":"string"}}],[11,"tys_to_string","","",89,null],[11,"trait_ref_to_string","","",89,{"inputs":[{"name":"inferctxt"},{"name":"rc"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",89,{"inputs":[{"name":"inferctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in\n`value` with their final value. Note that region variables\nare unaffected. If a type variable has not been unified, it\nis left as is.  This is an idempotent operation that does\nnot affect inference state in any way and so you can do it\nat will.",89,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in\n`value`. Region inference must have been run already (e.g.,\nby calling `resolve_regions_and_report_errors`).  If some\nvariable was never unified, an `Err` results.",89,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"fres"}}],[11,"type_error_message_str","","",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"m"},{"name":"string"},{"name":"option"}],"output":null}],[11,"type_error_message_str_with_expected","","",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"m"},{"name":"option"},{"name":"string"},{"name":"option"}],"output":null}],[11,"type_error_message","","",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"m"},{"name":"ty"},{"name":"option"}],"output":null}],[11,"report_mismatched_types","","",89,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"ty"},{"name":"ty"},{"name":"type_err"}],"output":null}],[11,"replace_late_bound_regions_with_fresh_var","","",89,null],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_inference`",89,{"inputs":[{"name":"inferctxt"},{"name":"subregionorigin"},{"name":"generickind"},{"name":"region"},{"name":"vec"}],"output":null}],[11,"can_equate","","",89,{"inputs":[{"name":"inferctxt"},{"name":"t"},{"name":"t"}],"output":{"name":"unitresult"}}],[11,"span","","",129,{"inputs":[{"name":"typetrace"}],"output":{"name":"span"}}],[11,"types","","",129,{"inputs":[{"name":"typetrace"},{"name":"typeorigin"},{"name":"bool"},{"name":"ty"},{"name":"ty"}],"output":{"name":"typetrace"}}],[11,"dummy","","",129,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"typetrace"}}],[11,"repr","","",129,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",90,{"inputs":[{"name":"typeorigin"}],"output":{"name":"span"}}],[11,"repr","","",90,{"inputs":[{"name":"typeorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",92,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"span"}}],[11,"repr","","",92,{"inputs":[{"name":"subregionorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",94,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"span"}}],[11,"repr","","",94,{"inputs":[{"name":"regionvariableorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[0,"implicator","rustc::middle","",null,null],[4,"Implication","rustc::middle::implicator","",null,null],[13,"RegionSubRegion","","",130,null],[13,"RegionSubGeneric","","",130,null],[13,"RegionSubClosure","","",130,null],[13,"Predicate","","",130,null],[5,"implications","","This routine computes the well-formedness constraints that must hold for the type `ty` to\nappear in a context with lifetime `outer_region`",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"nodeid"},{"name":"ty"},{"name":"region"},{"name":"span"}],"output":{"name":"vec"}}],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime\nbounds that must hold on the elided self type. These are derived\nfrom the declarations of `SomeTrait`, `Send`, and friends -- if\nthey declare `trait SomeTrait : 'static`, for example, then\n`'static` would appear in the list. The hard work is done by\n`ty::required_region_bounds`, see that for more information.",null,{"inputs":[{"name":"ctxt"},{"name":"polytraitref"},{"name":"builtinbounds"}],"output":{"name":"vec"}}],[11,"repr","","",130,{"inputs":[{"name":"implication"},{"name":"ctxt"}],"output":{"name":"string"}}],[0,"lang_items","rustc::middle","",null,null],[3,"LanguageItems","rustc::middle::lang_items","",null,null],[12,"items","","",131,null],[12,"missing","","",131,null],[4,"LangItem","","",null,null],[13,"CharImplItem","","",132,null],[13,"StrImplItem","","",132,null],[13,"SliceImplItem","","",132,null],[13,"ConstPtrImplItem","","",132,null],[13,"MutPtrImplItem","","",132,null],[13,"I8ImplItem","","",132,null],[13,"I16ImplItem","","",132,null],[13,"I32ImplItem","","",132,null],[13,"I64ImplItem","","",132,null],[13,"IsizeImplItem","","",132,null],[13,"U8ImplItem","","",132,null],[13,"U16ImplItem","","",132,null],[13,"U32ImplItem","","",132,null],[13,"U64ImplItem","","",132,null],[13,"UsizeImplItem","","",132,null],[13,"F32ImplItem","","",132,null],[13,"F64ImplItem","","",132,null],[13,"SendTraitLangItem","","",132,null],[13,"SizedTraitLangItem","","",132,null],[13,"CopyTraitLangItem","","",132,null],[13,"SyncTraitLangItem","","",132,null],[13,"DropTraitLangItem","","",132,null],[13,"AddTraitLangItem","","",132,null],[13,"SubTraitLangItem","","",132,null],[13,"MulTraitLangItem","","",132,null],[13,"DivTraitLangItem","","",132,null],[13,"RemTraitLangItem","","",132,null],[13,"NegTraitLangItem","","",132,null],[13,"NotTraitLangItem","","",132,null],[13,"BitXorTraitLangItem","","",132,null],[13,"BitAndTraitLangItem","","",132,null],[13,"BitOrTraitLangItem","","",132,null],[13,"ShlTraitLangItem","","",132,null],[13,"ShrTraitLangItem","","",132,null],[13,"IndexTraitLangItem","","",132,null],[13,"IndexMutTraitLangItem","","",132,null],[13,"RangeStructLangItem","","",132,null],[13,"RangeFromStructLangItem","","",132,null],[13,"RangeToStructLangItem","","",132,null],[13,"RangeFullStructLangItem","","",132,null],[13,"UnsafeCellTypeLangItem","","",132,null],[13,"DerefTraitLangItem","","",132,null],[13,"DerefMutTraitLangItem","","",132,null],[13,"FnTraitLangItem","","",132,null],[13,"FnMutTraitLangItem","","",132,null],[13,"FnOnceTraitLangItem","","",132,null],[13,"EqTraitLangItem","","",132,null],[13,"OrdTraitLangItem","","",132,null],[13,"StrEqFnLangItem","","",132,null],[13,"PanicFnLangItem","","",132,null],[13,"PanicBoundsCheckFnLangItem","","",132,null],[13,"PanicFmtLangItem","","",132,null],[13,"ExchangeMallocFnLangItem","","",132,null],[13,"ExchangeFreeFnLangItem","","",132,null],[13,"StrDupUniqFnLangItem","","",132,null],[13,"StartFnLangItem","","",132,null],[13,"EhPersonalityLangItem","","",132,null],[13,"ExchangeHeapLangItem","","",132,null],[13,"OwnedBoxLangItem","","",132,null],[13,"PhantomDataItem","","",132,null],[13,"CovariantTypeItem","","",132,null],[13,"ContravariantTypeItem","","",132,null],[13,"InvariantTypeItem","","",132,null],[13,"CovariantLifetimeItem","","",132,null],[13,"ContravariantLifetimeItem","","",132,null],[13,"InvariantLifetimeItem","","",132,null],[13,"NoCopyItem","","",132,null],[13,"ManagedItem","","",132,null],[13,"NonZeroItem","","",132,null],[13,"StackExhaustedLangItem","","",132,null],[13,"DebugTraitLangItem","","",132,null],[5,"extract","","",null,null],[5,"collect_language_items","","",null,{"inputs":[{"name":"crate"},{"name":"session"}],"output":{"name":"languageitems"}}],[11,"hash","","",132,null],[11,"eq","","",132,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"ne","","",132,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"clone","","",132,{"inputs":[{"name":"langitem"}],"output":{"name":"langitem"}}],[11,"from_u32","","",132,{"inputs":[{"name":"langitem"},{"name":"u32"}],"output":{"name":"option"}}],[11,"new","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"languageitems"}}],[11,"items","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"enumerate"}}],[11,"item_name","","",131,{"inputs":[{"name":"languageitems"},{"name":"usize"}],"output":{"name":"str"}}],[11,"require","","",131,{"inputs":[{"name":"languageitems"},{"name":"langitem"}],"output":{"name":"result"}}],[11,"from_builtin_kind","","",131,{"inputs":[{"name":"languageitems"},{"name":"builtinbound"}],"output":{"name":"result"}}],[11,"to_builtin_kind","","",131,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"fn_trait_kind","","",131,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"char_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"slice_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"const_ptr_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mut_ptr_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i8_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i16_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i32_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i64_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"isize_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u8_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u16_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u32_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u64_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"usize_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f32_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f64_impl","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"send_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sized_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"copy_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sync_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"drop_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"add_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sub_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mul_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"div_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"rem_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"neg_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"not_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitxor_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitand_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitor_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shl_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shr_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_mut_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_struct","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_from_struct","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_to_struct","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_full_struct","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"unsafe_cell_type","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_mut_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_mut_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_once_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eq_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"ord_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_eq_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_bounds_check_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fmt","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_malloc_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_free_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"strdup_uniq_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"start_fn","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eh_personality","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_heap","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"owned_box","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"phantom_data","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_type","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_type","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_type","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_lifetime","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_lifetime","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_lifetime","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"no_copy_bound","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"managed_bound","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"non_zero","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"stack_exhausted","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"debug_trait","","",131,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[0,"liveness","rustc::middle","A classic liveness analysis based on dataflow over the AST.  Computes,\nfor each local variable in a function, whether that variable is live\nat a given point.  Program execution points are identified by their\nid.",null,null],[5,"check_crate","rustc::middle::liveness","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[0,"mem_categorization","rustc::middle","# Categorization",null,null],[3,"Upvar","rustc::middle::mem_categorization","",null,null],[12,"id","","",133,null],[12,"kind","","",133,null],[3,"cmt_","","",null,null],[12,"id","","",134,null],[12,"span","","",134,null],[12,"cat","","",134,null],[12,"mutbl","","",134,null],[12,"ty","","",134,null],[12,"note","","",134,null],[3,"MemCategorizationContext","","",null,null],[4,"categorization","","",null,null],[13,"cat_rvalue","","",135,null],[13,"cat_static_item","","",135,null],[13,"cat_upvar","","",135,null],[13,"cat_local","","",135,null],[13,"cat_deref","","",135,null],[13,"cat_interior","","",135,null],[13,"cat_downcast","","",135,null],[4,"PointerKind","","",null,null],[13,"Unique","","`Box<T>`",136,null],[13,"BorrowedPtr","","`&T`",136,null],[13,"UnsafePtr","","`*T`",136,null],[13,"Implicit","","Implicit deref of the `&T` that results from an overloaded index `[]`.",136,null],[4,"InteriorKind","","",null,null],[13,"InteriorField","","",137,null],[13,"InteriorElement","","",137,null],[4,"FieldName","","",null,null],[13,"NamedField","","",138,null],[13,"PositionalField","","",138,null],[4,"InteriorOffsetKind","","",null,null],[13,"Index","","",139,null],[13,"Pattern","","",139,null],[4,"ElementKind","","",null,null],[13,"VecElement","","",140,null],[13,"OtherElement","","",140,null],[4,"MutabilityCategory","","",null,null],[13,"McImmutable","","",141,null],[13,"McDeclared","","",141,null],[13,"McInherited","","",141,null],[4,"Note","","",null,null],[13,"NoteClosureEnv","","",142,null],[13,"NoteUpvarRef","","",142,null],[13,"NoteNone","","",142,null],[4,"deref_kind","","",null,null],[13,"deref_ptr","","",143,null],[13,"deref_interior","","",143,null],[4,"InteriorSafety","","",null,null],[13,"InteriorUnsafe","","",144,null],[13,"InteriorSafe","","",144,null],[4,"Aliasability","","",null,null],[13,"FreelyAliasable","","",145,null],[13,"NonAliasable","","",145,null],[13,"ImmutableUnique","","",145,null],[4,"AliasableReason","","",null,null],[13,"AliasableBorrowed","","",146,null],[13,"AliasableClosure","","",146,null],[13,"AliasableOther","","",146,null],[13,"UnaliasableImmutable","","",146,null],[13,"AliasableStatic","","",146,null],[13,"AliasableStaticMut","","",146,null],[5,"ptr_sigil","","",null,{"inputs":[{"name":"pointerkind"}],"output":{"name":"str"}}],[6,"cmt","","",null,null],[6,"McResult","","",null,null],[8,"ast_node","","",null,null],[10,"id","","",147,{"inputs":[{"name":"ast_node"}],"output":{"name":"nodeid"}}],[10,"span","","",147,{"inputs":[{"name":"ast_node"}],"output":{"name":"span"}}],[8,"Typer","","The `Typer` trait provides the interface for the mem-categorization\nmodule to the results of the type check. It can be used to query\nthe type assigned to an expression node, to inquire after adjustments,\nand so on.",null,null],[10,"node_ty","","",148,{"inputs":[{"name":"typer"},{"name":"nodeid"}],"output":{"name":"mcresult"}}],[10,"expr_ty_adjusted","","",148,{"inputs":[{"name":"typer"},{"name":"expr"}],"output":{"name":"mcresult"}}],[10,"type_moves_by_default","","",148,{"inputs":[{"name":"typer"},{"name":"span"},{"name":"ty"}],"output":{"name":"bool"}}],[10,"node_method_ty","","",148,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"node_method_origin","","",148,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"adjustments","","",148,{"inputs":[{"name":"typer"}],"output":{"name":"refcell"}}],[10,"is_method_call","","",148,{"inputs":[{"name":"typer"},{"name":"nodeid"}],"output":{"name":"bool"}}],[10,"temporary_scope","","",148,{"inputs":[{"name":"typer"},{"name":"nodeid"}],"output":{"name":"option"}}],[10,"upvar_capture","","",148,{"inputs":[{"name":"typer"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"fmt","","",135,{"inputs":[{"name":"categorization"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",135,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",135,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",135,{"inputs":[{"name":"categorization"}],"output":{"name":"categorization"}}],[11,"fmt","","",133,{"inputs":[{"name":"upvar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",133,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",133,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",133,{"inputs":[{"name":"upvar"}],"output":{"name":"upvar"}}],[11,"fmt","","",136,{"inputs":[{"name":"pointerkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",136,null],[11,"eq","","",136,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",136,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"clone","","",136,{"inputs":[{"name":"pointerkind"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",137,{"inputs":[{"name":"interiorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",137,null],[11,"eq","","",137,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"interiorkind"}],"output":{"name":"interiorkind"}}],[11,"fmt","","",138,{"inputs":[{"name":"fieldname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",138,null],[11,"eq","","",138,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"clone","","",138,{"inputs":[{"name":"fieldname"}],"output":{"name":"fieldname"}}],[11,"fmt","","",139,{"inputs":[{"name":"interioroffsetkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",139,null],[11,"eq","","",139,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"interioroffsetkind"}],"output":{"name":"interioroffsetkind"}}],[11,"fmt","","",140,{"inputs":[{"name":"elementkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",140,null],[11,"eq","","",140,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"elementkind"}],"output":{"name":"elementkind"}}],[11,"fmt","","",141,{"inputs":[{"name":"mutabilitycategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",141,null],[11,"eq","","",141,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"fmt","","",142,{"inputs":[{"name":"note"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",142,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"clone","","",142,{"inputs":[{"name":"note"}],"output":{"name":"note"}}],[11,"fmt","","",134,{"inputs":[{"name":"cmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",134,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",134,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"clone","","",134,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"clone","","",143,{"inputs":[{"name":"deref_kind"}],"output":{"name":"deref_kind"}}],[11,"id","syntax::ast","",149,{"inputs":[{"name":"expr"}],"output":{"name":"nodeid"}}],[11,"span","","",149,{"inputs":[{"name":"expr"}],"output":{"name":"span"}}],[11,"id","","",150,{"inputs":[{"name":"pat"}],"output":{"name":"nodeid"}}],[11,"span","","",150,{"inputs":[{"name":"pat"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",151,{"inputs":[{"name":"memcategorizationcontext"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",141,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",141,{"inputs":[{"name":"mutabilitycategory"},{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",141,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",141,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"is_immutable","","",141,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"to_user_str","","",141,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"str"}}],[11,"new","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"typer"}],"output":{"name":"memcategorizationcontext"}}],[11,"cat_expr","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"mcresult"}}],[11,"cat_expr_autoderefd","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"},{"name":"usize"}],"output":{"name":"mcresult"}}],[11,"cat_expr_unadjusted","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"mcresult"}}],[11,"cat_def","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"nodeid"},{"name":"span"},{"name":"ty"},{"name":"def"}],"output":{"name":"mcresult"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`.\nThis could be `'static` if `id` is part of a constant expression.",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"nodeid"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"nodeid"},{"name":"span"},{"name":"ty"}],"output":{"name":"cmt"}}],[11,"cat_rvalue","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"nodeid"},{"name":"span"},{"name":"region"},{"name":"ty"}],"output":{"name":"cmt"}}],[11,"cat_field","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"cmt"},{"name":"name"},{"name":"ty"}],"output":{"name":"cmt"}}],[11,"cat_tup_field","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"cmt"},{"name":"usize"},{"name":"ty"}],"output":{"name":"cmt"}}],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"cmt"},{"name":"interioroffsetkind"}],"output":{"name":"mcresult"}}],[11,"cat_slice_pattern","","Given a pattern P like: `[_, ..Q, _]`, where `vec_cmt` is the cmt for `P`, `slice_pat` is\nthe pattern `Q`, returns:",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"cmt"},{"name":"pat"}],"output":{"name":"mcresult"}}],[11,"cat_imm_interior","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"cmt"},{"name":"ty"},{"name":"interiorkind"}],"output":{"name":"cmt"}}],[11,"cat_downcast","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"cmt"},{"name":"ty"},{"name":"defid"}],"output":{"name":"cmt"}}],[11,"cat_pattern","","",151,{"inputs":[{"name":"memcategorizationcontext"},{"name":"cmt"},{"name":"pat"},{"name":"f"}],"output":{"name":"mcresult"}}],[11,"fmt","","",144,{"inputs":[{"name":"interiorsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"interiorsafety"}],"output":{"name":"interiorsafety"}}],[11,"fmt","","",145,{"inputs":[{"name":"aliasability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",145,{"inputs":[{"name":"aliasability"}],"output":{"name":"aliasability"}}],[11,"fmt","","",146,{"inputs":[{"name":"aliasablereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",146,{"inputs":[{"name":"aliasablereason"}],"output":{"name":"aliasablereason"}}],[11,"guarantor","","Returns `self` after stripping away any owned pointer derefs or\ninterior content. The return value is basically the `cmt` which\ndetermines how long the value in `self` remains live.",134,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this lvalue represents a freely aliasable pointer type.",134,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"aliasability"}}],[11,"upvar","","",134,{"inputs":[{"name":"cmt_"}],"output":{"name":"option"}}],[11,"descriptive_string","","",134,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",134,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",135,{"inputs":[{"name":"categorization"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",136,{"inputs":[{"name":"pointerkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",137,{"inputs":[{"name":"interiorkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",133,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",133,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[0,"pat_util","rustc::middle","",null,null],[5,"pat_id_map","rustc::middle::pat_util","",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"patidmap"}}],[5,"pat_is_refutable","","",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_variant_or_struct","","",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_const","","",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding","","",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding_or_wild","","",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_bindings","","Call `it` on every \"binding\" in a pattern, e.g., on `a` in\n`match foo() { Some(a) => (), None => () }`",null,{"inputs":[{"name":"defmap"},{"name":"pat"},{"name":"i"}],"output":null}],[5,"pat_contains_bindings","","Checks if the pattern contains any patterns that bind something to\nan ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_contains_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings.",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"arm_contains_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut`\nbindings.",null,{"inputs":[{"name":"defmap"},{"name":"arm"}],"output":{"name":"bool"}}],[5,"pat_contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to\nan ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",null,{"inputs":[{"name":"defmap"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"simple_identifier","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"option"}}],[5,"def_to_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"path"}}],[6,"PatIdMap","","",null,null],[0,"privacy","rustc::middle","A pass that checks to make sure private fields and methods aren't used\noutside their scopes. This pass will also generate a set of exported items\nwhich are available for use externally when compiled as a library.",null,null],[4,"LastPrivate","rustc::middle::privacy","",null,null],[13,"LastMod","","",152,null],[13,"LastImport","","",152,null],[12,"value_priv","rustc::middle::privacy::LastPrivate","",152,null],[12,"value_used","","",152,null],[12,"type_priv","","",152,null],[12,"type_used","","",152,null],[4,"PrivateDep","rustc::middle::privacy","",null,null],[13,"AllPublic","","",153,null],[13,"DependsOn","","",153,null],[4,"ImportUse","","",null,null],[13,"Unused","","",154,null],[13,"Used","","",154,null],[6,"ExportedItems","","A set of AST nodes exported by the crate.",null,null],[6,"ExternalExports","","A set containing all exported definitions from external crates.\nThe set does not contain any entries from local crates.",null,null],[6,"PublicItems","","A set of AST nodes that are fully public in the crate. This map is used for\ndocumentation purposes (reexporting a private struct inlines the doc,\nreexporting a public struct doesn't inline the doc).",null,null],[11,"fmt","","",152,{"inputs":[{"name":"lastprivate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",152,{"inputs":[{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"fmt","","",153,{"inputs":[{"name":"privatedep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",153,{"inputs":[{"name":"privatedep"}],"output":{"name":"privatedep"}}],[11,"fmt","","",154,{"inputs":[{"name":"importuse"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",154,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"clone","","",154,{"inputs":[{"name":"importuse"}],"output":{"name":"importuse"}}],[11,"or","","",152,{"inputs":[{"name":"lastprivate"},{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[0,"reachable","rustc::middle","",null,null],[5,"find_reachable","rustc::middle::reachable","",null,{"inputs":[{"name":"ctxt"},{"name":"exporteditems"}],"output":{"name":"nodeset"}}],[0,"region","rustc::middle","This file actually contains two passes related to regions.  The first\npass builds up the `scope_map`, which describes the parent links in\nthe region hierarchy.  The second pass infers which types must be\nregion parameterized.",null,null],[3,"DestructionScopeData","rustc::middle::region","extent of destructors for temporaries of node-id",null,null],[12,"node_id","","",155,null],[3,"BlockRemainder","","Represents a subscope of `block` for a binding that is introduced\nby `block.stmts[first_statement_index]`. Such subscopes represent\na suffix of the block. Note that each subscope does not include\nthe initializer expression, if any, for the statement indexed by\n`first_statement_index`.",null,null],[12,"block","","",156,null],[12,"first_statement_index","","",156,null],[3,"RegionMaps","","The region maps encode information about region relationships.",null,null],[3,"Context","","",null,null],[4,"CodeExtent","","CodeExtent represents a statically-describable extent that can be\nused to bound the lifetime/region for values.",null,null],[13,"Misc","","",157,null],[13,"ParameterScope","","",157,null],[12,"fn_id","rustc::middle::region::CodeExtent","",157,null],[12,"body_id","","",157,null],[13,"DestructionScope","rustc::middle::region","",157,null],[13,"Remainder","","",157,null],[5,"resolve_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"regionmaps"}}],[5,"resolve_inlined_item","","",null,{"inputs":[{"name":"session"},{"name":"regionmaps"},{"name":"inlineditem"}],"output":null}],[11,"fmt","","",157,{"inputs":[{"name":"codeextent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",157,{"inputs":[{"name":"codeextent"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",157,{"inputs":[{"name":"codeextent"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",157,null],[11,"cmp","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"lt","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"le","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"gt","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ge","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"eq","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"clone","","",157,{"inputs":[{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"fmt","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",155,null],[11,"cmp","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"option"}}],[11,"lt","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"le","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"gt","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ge","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"eq","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"destructionscopedata"}}],[11,"new","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"nodeid"}],"output":{"name":"destructionscopedata"}}],[11,"to_code_extent","","",155,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"codeextent"}}],[11,"fmt","","",156,{"inputs":[{"name":"blockremainder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",156,{"inputs":[{"name":"blockremainder"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",156,{"inputs":[{"name":"blockremainder"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",156,null],[11,"cmp","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"option"}}],[11,"lt","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"eq","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"blockremainder"}],"output":{"name":"blockremainder"}}],[11,"from_node_id","","Creates a scope that represents the dynamic extent associated\nwith `node_id`.",157,{"inputs":[{"name":"codeextent"},{"name":"nodeid"}],"output":{"name":"codeextent"}}],[11,"node_id","","Returns a node id associated with this scope.",157,{"inputs":[{"name":"codeextent"}],"output":{"name":"nodeid"}}],[11,"map_id","","Maps this scope to a potentially new one according to the\nNodeId transformer `f_id`.",157,{"inputs":[{"name":"codeextent"},{"name":"f"}],"output":{"name":"codeextent"}}],[11,"span","","Returns the span of this CodeExtent.  Note that in general the\nreturned span may not correspond to the span of any node id in\nthe AST.",157,{"inputs":[{"name":"codeextent"},{"name":"map"}],"output":{"name":"option"}}],[11,"clone","","",158,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"fmt","","",158,{"inputs":[{"name":"context"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"each_encl_scope","","",159,{"inputs":[{"name":"regionmaps"},{"name":"e"}],"output":null}],[11,"each_var_scope","","",159,{"inputs":[{"name":"regionmaps"},{"name":"e"}],"output":null}],[11,"each_rvalue_scope","","",159,{"inputs":[{"name":"regionmaps"},{"name":"e"}],"output":null}],[11,"each_terminating_scope","","",159,{"inputs":[{"name":"regionmaps"},{"name":"e"}],"output":null}],[11,"record_encl_scope","","",159,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":null}],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",159,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",159,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",159,{"inputs":[{"name":"regionmaps"},{"name":"nodeid"}],"output":{"name":"codeextent"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",159,{"inputs":[{"name":"regionmaps"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",159,{"inputs":[{"name":"regionmaps"},{"name":"nodeid"}],"output":{"name":"region"}}],[11,"scopes_intersect","","",159,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false\notherwise.",159,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest\nscope which is greater than or equal to both `scope_a` and `scope_b`.",159,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[0,"recursion_limit","rustc::middle","",null,null],[5,"update_recursion_limit","rustc::middle::recursion_limit","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":null}],[0,"resolve_lifetime","rustc::middle","Name resolution for lifetimes.",null,null],[4,"DefRegion","rustc::middle::resolve_lifetime","",null,null],[13,"DefStaticRegion","","",160,null],[13,"DefEarlyBoundRegion","","",160,null],[13,"DefLateBoundRegion","","",160,null],[13,"DefFreeRegion","","",160,null],[5,"krate","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"defmap"}],"output":{"name":"namedregionmap"}}],[5,"early_bound_lifetimes","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"vec"}}],[6,"NamedRegionMap","","",null,null],[11,"fmt","","",160,{"inputs":[{"name":"defregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",160,{"inputs":[{"name":"defregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",160,{"inputs":[{"name":"defregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",160,null],[11,"eq","","",160,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"ne","","",160,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"clone","","",160,{"inputs":[{"name":"defregion"}],"output":{"name":"defregion"}}],[0,"stability","rustc::middle","A pass that annotates every item and method with its stability level,\npropagating default levels lexically from parent to children ast nodes.",null,null],[3,"Index","rustc::middle::stability","A stability index, giving the stability level for items and methods.",null,null],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled\nfeatures and possibly prints errors. Returns a list of all\nfeatures used.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"fnvhashmap"}}],[5,"check_item","","Helper for discovering nodes to check for stability",null,{"inputs":[{"name":"ctxt"},{"name":"item"},{"name":"bool"},{"name":"fnmut"}],"output":null}],[5,"check_expr","","Helper for discovering nodes to check for stability",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"fnmut"}],"output":null}],[5,"check_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"path"},{"name":"nodeid"},{"name":"fnmut"}],"output":null}],[5,"check_pat","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"},{"name":"fnmut"}],"output":null}],[5,"lookup","","Lookup the stability for a node, loading external crate\nmetadata as necessary.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that\nwere expected to be library features), and the list of features used from\nlibraries, identify activated features that don't exist and error about them.",null,{"inputs":[{"name":"session"},{"name":"fnvhashmap"}],"output":null}],[11,"build","","Construct the stability index for a crate being compiled.",161,{"inputs":[{"name":"index"},{"name":"session"},{"name":"crate"},{"name":"publicitems"}],"output":null}],[11,"new","","",161,{"inputs":[{"name":"index"},{"name":"crate"}],"output":{"name":"index"}}],[0,"subst","rustc::middle","",null,null],[3,"Substs","rustc::middle::subst","A substitution mapping type/region parameters to new values. We\nidentify each in-scope parameter by an *index* and a *parameter\nspace* (which indices where the parameter is defined; see\n`ParamSpace`).",null,null],[12,"types","","",162,null],[12,"regions","","",162,null],[3,"VecPerParamSpace","","Vector of things sorted by param space. Used to keep\nthe set of things declared on the type, self, or method\ndistinct.",null,null],[3,"SeparateVecsPerParamSpace","","The `split` function converts one `VecPerParamSpace` into this\n`SeparateVecsPerParamSpace` structure.",null,null],[12,"types","","",163,null],[12,"selfs","","",163,null],[12,"fns","","",163,null],[3,"EnumeratedItems","","",null,null],[4,"RegionSubsts","","Represents the values to use when substituting lifetime parameters.\nIf the value is `ErasedRegions`, then this subst is occurring during\ntrans, and all region parameters will be replaced with `ty::ReStatic`.",null,null],[13,"ErasedRegions","","",164,null],[13,"NonerasedRegions","","",164,null],[4,"ParamSpace","","",null,null],[13,"TypeSpace","","",165,null],[13,"SelfSpace","","",165,null],[13,"FnSpace","","",165,null],[8,"Subst","","",null,null],[11,"subst","","",166,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"self"}}],[10,"subst_spanned","","",166,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"},{"name":"option"}],"output":{"name":"self"}}],[11,"fmt","","",162,{"inputs":[{"name":"substs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",162,null],[11,"eq","","",162,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"ne","","",162,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",162,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"fmt","","",164,{"inputs":[{"name":"regionsubsts"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",164,null],[11,"eq","","",164,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"ne","","",164,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"clone","","",164,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"regionsubsts"}}],[11,"new","","",162,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"new_type","","",162,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"new_trait","","",162,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"},{"name":"ty"}],"output":{"name":"substs"}}],[11,"erased","","",162,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"empty","","",162,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"trans_empty","","",162,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"is_noop","","",162,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"type_for_def","","",162,{"inputs":[{"name":"substs"},{"name":"typeparameterdef"}],"output":{"name":"ty"}}],[11,"has_regions_escaping_depth","","",162,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"self_ty","","",162,{"inputs":[{"name":"substs"}],"output":{"name":"option"}}],[11,"with_self_ty","","",162,{"inputs":[{"name":"substs"},{"name":"ty"}],"output":{"name":"substs"}}],[11,"erase_regions","","",162,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",162,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"mut_regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",162,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"with_method","","",162,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"is_erased","","",164,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"fmt","","",165,{"inputs":[{"name":"paramspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",165,{"inputs":[{"name":"paramspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",165,{"inputs":[{"name":"paramspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",165,null],[11,"clone","","",165,{"inputs":[{"name":"paramspace"}],"output":{"name":"paramspace"}}],[11,"eq","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ne","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"cmp","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"lt","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"le","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"gt","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ge","","",165,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"all","","",165,null],[11,"to_uint","","",165,{"inputs":[{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"from_uint","","",165,{"inputs":[{"name":"paramspace"},{"name":"usize"}],"output":{"name":"paramspace"}}],[11,"decode","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",167,null],[11,"clone","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"eq","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"ne","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"fmt","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"params_from_type","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"new","","`t` is the type space.\n`s` is the self space.\n`a` is the assoc space.\n`f` is the fn space.",167,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"push","","Appends `value` to the vector associated with `space`.",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"t"}],"output":null}],[11,"extend","","Appends `values` to the vector associated with `space`.",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"i"}],"output":null}],[11,"pop","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"truncate","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":null}],[11,"replace","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":null}],[11,"get_self","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"option"}}],[11,"len","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"is_empty_in","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"get_slice","","",167,null],[11,"get_mut_slice","","",167,null],[11,"opt_get","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"t"}}],[11,"iter","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"iter"}}],[11,"into_iter","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[11,"iter_enumerated","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"enumerateditems"}}],[11,"as_slice","","",167,null],[11,"into_vec","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vec"}}],[11,"all_vecs","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"all","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"any","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"is_empty","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"map","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_enumerated","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_move","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"split","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"separatevecsperparamspace"}}],[11,"with_vec","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"clone","","",168,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"enumerateditems"}}],[6,"Item","","",null,null],[11,"next","","",168,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[0,"traits","rustc::middle","Trait Resolution. See the Book for more.",null,null],[3,"FulfillmentContext","rustc::middle::traits","The fulfillment context is used to drive trait resolution.  It\nconsists of a list of obligations that must be (eventually)\nsatisfied. The job is to track which are satisfied, which yielded\nerrors, and which are still pending. At any point, users can call\n`select_where_possible`, and the fulfilment context will try to do\nselection, retaining only those obligations that remain\nambiguous. This may be helpful in pushing type inference\nalong. Once all type inference constraints have been generated, the\nmethod `select_all_or_error` can be used to report any remaining\nambiguous cases as errors.",null,null],[3,"RegionObligation","","",null,null],[12,"sub_region","","",169,null],[12,"sup_type","","",169,null],[12,"cause","","",169,null],[3,"MismatchedProjectionTypes","","",null,null],[12,"err","","",170,null],[3,"Normalized","","",null,null],[12,"value","","",171,null],[12,"obligations","","",171,null],[3,"SelectionContext","","",null,null],[3,"SelectionCache","","",null,null],[3,"SupertraitDefIds","","",null,null],[3,"Obligation","","An `Obligation` represents some trait reference (e.g. `int:Eq`) for\nwhich the vtable must be found.  The process of finding a vtable is\ncalled \"resolving\" the `Obligation`. This process consists of\neither identifying an `impl` (e.g., `impl Eq for int`) that\nprovides the required vtable, or else finding a bound that is in\nscope. The eventual result is usually a `Selection` (defined below).",null,null],[12,"cause","","",172,null],[12,"recursion_depth","","",172,null],[12,"predicate","","",172,null],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",null,null],[12,"span","","",173,null],[12,"body_id","","",173,null],[12,"code","","",173,null],[3,"DerivedObligationCause","","",null,null],[3,"FulfillmentError","","",null,null],[12,"obligation","","",174,null],[12,"code","","",174,null],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of\nsubstitutions from the impl's type/lifetime parameters. The\n`nested` vector corresponds to the nested obligations attached to\nthe impl's type parameters.",null,null],[12,"impl_def_id","","",175,null],[12,"substs","","",175,null],[12,"nested","","",175,null],[3,"VtableDefaultImplData","","",null,null],[12,"trait_def_id","","",176,null],[12,"nested","","",176,null],[3,"VtableBuiltinData","","",null,null],[12,"nested","","",177,null],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived\nfor the object type `Foo`.",null,null],[12,"object_ty","","the object type `Foo`.",178,null],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",178,null],[4,"OrphanCheckErr","","",null,null],[13,"NoLocalInputType","","",179,null],[13,"UncoveredTy","","",179,null],[4,"ObjectSafetyViolation","","",null,null],[13,"SizedSelf","","Self : Sized declared on the trait",180,null],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location\n(e.g. `trait Foo : Bar<Self>`)",180,null],[13,"Method","","Method has something illegal",180,null],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",null,null],[13,"StaticMethod","","e.g., `fn foo()`",181,null],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",181,null],[13,"Generic","","e.g., `fn foo<A>()`",181,null],[4,"MethodMatchResult","","",null,null],[13,"MethodMatched","","",182,null],[13,"MethodAmbiguous","","",182,null],[13,"MethodDidNotMatch","","",182,null],[4,"MethodMatchedData","","",null,null],[13,"PreciseMethodMatch","","",183,null],[13,"CoerciveMethodMatch","","",183,null],[4,"ObligationCauseCode","","",null,null],[13,"MiscObligation","","Not well classified or should be obvious from span.",184,null],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must\nalso implement all supertraits of X.",184,null],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",184,null],[13,"AssignmentLhsSized","","Various cases where expressions must be sized/copy/etc:",184,null],[13,"StructInitializerSized","","",184,null],[13,"VariableType","","",184,null],[13,"ReturnType","","",184,null],[13,"RepeatVec","","",184,null],[13,"ClosureCapture","","",184,null],[13,"FieldSized","","",184,null],[13,"ObjectSized","","",184,null],[13,"SharedStatic","","",184,null],[13,"BuiltinDerivedObligation","","",184,null],[13,"ImplDerivedObligation","","",184,null],[13,"CompareImplMethodObligation","","",184,null],[4,"SelectionError","","",null,null],[13,"Unimplemented","","",185,null],[13,"OutputTypeParameterMismatch","","",185,null],[4,"FulfillmentErrorCode","","",null,null],[13,"CodeSelectionError","","",186,null],[13,"CodeProjectionError","","",186,null],[13,"CodeAmbiguity","","",186,null],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable`\nindicates where the vtable comes from. Note that while we call this\na \"vtable\", it does not necessarily indicate dynamic dispatch at\nruntime. `Vtable` instances just tell the compiler where to find\nmethods, but in generic code those methods are typically statically\ndispatched -- only when an object is constructed is a `Vtable`\ninstance reified into an actual vtable.",null,null],[5,"report_fulfillment_errors","","",null,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":null}],[5,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We\nhalt compilation unconditionally because it is important that\noverflows never be masked -- they basically represent computations\nwhose result could not be truly determined and thus we can't say\nif the program type checks or not -- and they are unusual\noccurrences in any case.",null,{"inputs":[{"name":"inferctxt"},{"name":"obligation"}],"output":null}],[5,"suggest_new_overflow_limit","","",null,{"inputs":[{"name":"ctxt"},{"name":"span"}],"output":null}],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the\ndef-id of a trait impl. To pass, either the trait must be local, or else\ntwo conditions must be satisfied:",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"result"}}],[5,"overlapping_impls","","True if there exist types that satisfy both of the two given impls.",null,{"inputs":[{"name":"inferctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"normalize","","Normalizes any associated type projections in `value`, replacing\nthem with a fully resolved type where possible. The return value\ncombines the normalized result and any additional obligations that\nwere incurred as result.",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"is_object_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"object_safety_violations","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_vtable_safe_method","","We say a method is *vtable safe* if it can be invoked on a trait\nobject.  Note that object-safe traits can have some\nnon-vtable-safe methods, so long as they require `Self:Sized` or\notherwise ensure that they cannot be used when `Self=Trait`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"method"}],"output":{"name":"bool"}}],[5,"elaborate_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"elaborator"}}],[5,"get_vtable_index_of_object_method","","Given an object of type `object_trait_ref`, returns the index of\nthe method `n_method` found in the trait `trait_def_id` (which\nshould be a supertrait of `object_trait_ref`) within the vtable\nfor `object_trait_ref`.",null,{"inputs":[{"name":"ctxt"},{"name":"polytraitref"},{"name":"defid"},{"name":"usize"}],"output":{"name":"usize"}}],[5,"trait_ref_for_builtin_bound","","",null,{"inputs":[{"name":"ctxt"},{"name":"builtinbound"},{"name":"ty"}],"output":{"name":"result"}}],[5,"supertraits","","",null,{"inputs":[{"name":"ctxt"},{"name":"polytraitref"}],"output":{"name":"supertraits"}}],[5,"supertrait_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"supertraitdefids"}}],[5,"transitive_bounds","","",null,null],[5,"upcast","","Cast a trait reference into a reference to one of its super\ntraits; returns `None` if `target_trait_def_id` is not a\nsupertrait.",null,{"inputs":[{"name":"ctxt"},{"name":"polytraitref"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",null,{"inputs":[{"name":"ctxt"},{"name":"obligationcause"},{"name":"instantiatedpredicates"}],"output":{"name":"predicateobligations"}}],[5,"evaluate_builtin_bound","","Determines whether the type `ty` is known to meet `bound` and\nreturns true if so. Returns false if `ty` either does not meet\n`bound` or is not known to meet bound (note that this is\nconservative towards *no impl*, which is the opposite of the\n`evaluate` methods).",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"ty"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"selectionresult"}}],[5,"type_known_to_meet_builtin_bound","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"ty"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"bool"}}],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",null,{"inputs":[{"name":"parameterenvironment"},{"name":"obligationcause"}],"output":{"name":"parameterenvironment"}}],[5,"fully_normalize","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"result"}}],[11,"clone","","",169,{"inputs":[{"name":"regionobligation"}],"output":{"name":"regionobligation"}}],[11,"new","","",187,{"inputs":[{"name":"fulfillmentcontext"}],"output":{"name":"fulfillmentcontext"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by\ncreating a fresh type variable `$0` as well as a projection\npredicate `<SomeType as SomeTrait>::X == $0`. When the\ninference engine runs, it will attempt to find an impl of\n`SomeTrait` or a where clause that lets us unify `$0` with\nsomething concrete. If this fails, we'll unify `$0` with\n`projection_ty` again.",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"ty"}}],[11,"register_builtin_bound","","",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"ty"},{"name":"builtinbound"},{"name":"obligationcause"}],"output":null}],[11,"register_region_obligation","","",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"ty"},{"name":"region"},{"name":"obligationcause"}],"output":null}],[11,"register_predicate_obligation","","",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"predicateobligation"}],"output":null}],[11,"region_obligations","","",187,null],[11,"select_all_or_error","","",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_new_obligations","","Attempts to select obligations that were registered since the call to a selection routine.\nThis is used by the type checker to eagerly attempt to resolve obligations in hopes of\ngaining type information. It'd be equally valid to use `select_where_possible` but it\nresults in `O(n^2)` performance (#18208).",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_where_possible","","",187,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"pending_obligations","","",187,null],[11,"repr","","",169,{"inputs":[{"name":"regionobligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",170,{"inputs":[{"name":"mismatchedprojectiontypes"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"clone","","",171,{"inputs":[{"name":"normalized"}],"output":{"name":"normalized"}}],[11,"with","","",171,{"inputs":[{"name":"normalized"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"fold_with","","",171,{"inputs":[{"name":"normalized"},{"name":"f"}],"output":{"name":"normalized"}}],[11,"repr","","",171,{"inputs":[{"name":"normalized"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",181,{"inputs":[{"name":"methodviolationcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",181,{"inputs":[{"name":"methodviolationcode"}],"output":{"name":"methodviolationcode"}}],[11,"repr","","",180,{"inputs":[{"name":"objectsafetyviolation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",188,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"fmt","","",183,{"inputs":[{"name":"methodmatcheddata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",183,{"inputs":[{"name":"methodmatcheddata"}],"output":{"name":"methodmatcheddata"}}],[11,"new","","",189,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",189,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"infcx","","",189,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",189,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"ctxt"}}],[11,"param_env","","",189,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"parameterenvironment"}}],[11,"closure_typer","","",189,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"closuretyper"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding\ntype environment by performing unification.",189,{"inputs":[{"name":"selectioncontext"},{"name":"traitobligation"}],"output":{"name":"selectionresult"}}],[11,"evaluate_obligation","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",189,{"inputs":[{"name":"selectioncontext"},{"name":"predicateobligation"}],"output":{"name":"bool"}}],[11,"evaluate_impl","","Evaluates whether the impl with id `impl_def_id` could be applied to the self type\n`obligation_self_ty`. This can be used either for trait or inherent impls.",189,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"traitobligation"}],"output":{"name":"bool"}}],[11,"new","","",188,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"may_apply","","",182,{"inputs":[{"name":"methodmatchresult"}],"output":{"name":"bool"}}],[11,"next","","",190,{"inputs":[{"name":"supertraitdefids"}],"output":{"name":"option"}}],[11,"fmt","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",178,{"inputs":[{"name":"vtableobjectdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",172,{"inputs":[{"name":"obligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",191,{"inputs":[{"name":"vtable"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",177,{"inputs":[{"name":"vtablebuiltindata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",176,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",178,{"inputs":[{"name":"vtableobjectdata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",185,{"inputs":[{"name":"selectionerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",174,{"inputs":[{"name":"fulfillmenterror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",186,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",186,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",170,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",170,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Supertraits","","",null,null],[6,"PredicateObligation","","",null,null],[6,"TraitObligation","","",null,null],[6,"Obligations","","",null,null],[6,"PredicateObligations","","",null,null],[6,"TraitObligations","","",null,null],[6,"Selection","","",null,null],[6,"SelectionResult","","When performing resolution, it is typically the case that there\ncan be one of three outcomes:",null,null],[11,"eq","","",172,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",172,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"clone","","",172,{"inputs":[{"name":"obligation"}],"output":{"name":"obligation"}}],[11,"eq","","",173,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",173,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",173,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"eq","","",184,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",184,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"clone","","",184,{"inputs":[{"name":"obligationcausecode"}],"output":{"name":"obligationcausecode"}}],[11,"eq","","",192,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",192,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",192,{"inputs":[{"name":"derivedobligationcause"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",185,{"inputs":[{"name":"selectionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",185,{"inputs":[{"name":"selectionerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",186,{"inputs":[{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",191,{"inputs":[{"name":"vtable"}],"output":{"name":"vtable"}}],[11,"fmt","","",191,{"inputs":[{"name":"vtable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"clone","","",175,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"vtableimpldata"}}],[11,"clone","","",176,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fmt","","",176,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",177,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"vtablebuiltindata"}}],[11,"fmt","","",177,{"inputs":[{"name":"vtablebuiltindata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",178,{"inputs":[{"name":"vtableobjectdata"}],"output":{"name":"vtableobjectdata"}}],[11,"eq","","",178,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",178,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"new","","",172,{"inputs":[{"name":"obligation"},{"name":"obligationcause"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",172,{"inputs":[{"name":"obligation"},{"name":"span"},{"name":"nodeid"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",172,{"inputs":[{"name":"obligation"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",173,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"nodeid"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",173,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"nodeid"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",173,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"iter_nested","","",191,{"inputs":[{"name":"vtable"}],"output":{"name":"iter"}}],[11,"map_nested","","",191,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"map_move_nested","","",191,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"iter_nested","","",175,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"map_move_nested","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"iter_nested","","",176,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",176,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"map_move_nested","","",176,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"iter_nested","","",177,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"iter"}}],[11,"map_nested","","",177,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"map_move_nested","","",177,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[0,"ty","rustc::middle","",null,null],[3,"CrateAnalysis","rustc::middle::ty","The complete set of all analyses described in this module. This is\nproduced by the driver and fed to trans and later passes.",null,null],[12,"export_map","","",193,null],[12,"exported_items","","",193,null],[12,"public_items","","",193,null],[12,"ty_cx","","",193,null],[12,"reachable","","",193,null],[12,"name","","",193,null],[12,"glob_map","","",193,null],[3,"field","","",null,null],[12,"name","","",194,null],[12,"mt","","",194,null],[3,"Method","","",null,null],[12,"name","","",195,null],[12,"generics","","",195,null],[12,"predicates","","",195,null],[12,"fty","","",195,null],[12,"explicit_self","","",195,null],[12,"vis","","",195,null],[12,"def_id","","",195,null],[12,"container","","",195,null],[12,"provided_source","","",195,null],[3,"AssociatedType","","",null,null],[12,"name","","",196,null],[12,"vis","","",196,null],[12,"def_id","","",196,null],[12,"container","","",196,null],[3,"mt","","",null,null],[12,"ty","","",197,null],[12,"mutbl","","",197,null],[3,"field_ty","","",null,null],[12,"name","","",198,null],[12,"id","","",198,null],[12,"vis","","",198,null],[12,"origin","","",198,null],[3,"creader_cache_key","","",null,null],[12,"cnum","","",199,null],[12,"pos","","",199,null],[12,"len","","",199,null],[3,"ItemVariances","","",null,null],[12,"types","","",200,null],[12,"regions","","",200,null],[3,"AutoDerefRef","","Represents coercing a pointer to a different kind of pointer - where 'kind'\nhere means either or both of raw vs borrowed vs unique and fat vs thin.",null,null],[12,"autoderefs","","Step 1. Apply a number of dereferences, producing an lvalue.",201,null],[12,"autoref","","Step 2. Optionally produce a pointer/reference from the value.",201,null],[12,"unsize","","Step 3. Unsize a pointer/reference value, e.g. `&[T; n]` to\n`&[T]`. The stored type is the target pointer type. Note that\nthe source could be a thin or fat pointer.",201,null],[3,"param_index","","",null,null],[12,"space","","",202,null],[12,"index","","",202,null],[3,"MethodParam","","",null,null],[12,"trait_ref","","",203,null],[12,"method_num","","",203,null],[12,"impl_def_id","","The impl for the trait from which the method comes. This\nshould only be used for certain linting/heuristic purposes\nsince there is no guarantee that this is Some in every\nsituation that it could/should be.",203,null],[3,"MethodObject","","",null,null],[12,"trait_ref","","",204,null],[12,"object_trait_id","","",204,null],[12,"method_num","","",204,null],[12,"vtable_index","","",204,null],[3,"MethodCallee","","",null,null],[12,"origin","","",205,null],[12,"ty","","",205,null],[12,"substs","","",205,null],[3,"MethodCall","","With method calls, we store some extra information in\nside tables (i.e method_map). We use\nMethodCall as a key to index into these tables instead of\njust directly using the expression's NodeId. The reason\nfor this being that we may apply adjustments (coercions)\nwith the resulting expression also needing to use the\nside tables. The problem with this is that we don't\nassign a separate NodeId to this new expression\nand so it would clash with the base expression if both\nneeded to add to the side tables. Thus to disambiguate\nwe also keep track of whether there's an adjustment in\nour key.",null,null],[12,"expr_id","","",206,null],[12,"autoderef","","",206,null],[3,"TransmuteRestriction","","A restriction that certain types must be the same size. The use of\n`transmute` gives rise to these restrictions. These generally\ncannot be checked until trans; therefore, each call to `transmute`\nwill push one or more such restriction into the\n`transmute_restrictions` vector during `intrinsicck`. They are\nthen checked during `trans` by the fn `check_intrinsics`.",null,null],[12,"span","","The span whence the restriction comes.",207,null],[12,"original_from","","The type being transmuted from.",207,null],[12,"original_to","","The type being transmuted to.",207,null],[12,"substituted_from","","The type being transmuted from, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",207,null],[12,"substituted_to","","The type being transmuted to, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",207,null],[12,"id","","NodeId of the transmute intrinsic.",207,null],[3,"CtxtArenas","","Internal storage",null,null],[3,"CommonTypes","","",null,null],[12,"bool","","",208,null],[12,"char","","",208,null],[12,"isize","","",208,null],[12,"i8","","",208,null],[12,"i16","","",208,null],[12,"i32","","",208,null],[12,"i64","","",208,null],[12,"usize","","",208,null],[12,"u8","","",208,null],[12,"u16","","",208,null],[12,"u32","","",208,null],[12,"u64","","",208,null],[12,"f32","","",208,null],[12,"f64","","",208,null],[12,"err","","",208,null],[3,"ctxt","","The data structure to keep track of all the information that typechecker\ngenerates so that so that it can be reused and doesn't have to be redone\nlater on.",null,null],[12,"types","","Common types, pre-interned for your convenience.",209,null],[12,"sess","","",209,null],[12,"def_map","","",209,null],[12,"named_region_map","","",209,null],[12,"region_maps","","",209,null],[12,"item_substs","","Stores the type parameters which were substituted to obtain the type\nof this node.  This only applies to nodes that refer to entities\nparameterized by type parameters, such as generic fns, types, or\nother items.",209,null],[12,"impl_or_trait_items","","Maps from a trait item to the trait item \"descriptor\"",209,null],[12,"trait_item_def_ids","","Maps from a trait def-id to a list of the def-ids of its trait items",209,null],[12,"trait_items_cache","","A cache for the trait_items() routine",209,null],[12,"impl_trait_cache","","",209,null],[12,"impl_trait_refs","","",209,null],[12,"trait_defs","","",209,null],[12,"predicates","","Maps from the def-id of an item (trait/struct/enum/fn) to its\nassociated predicates.",209,null],[12,"super_predicates","","Maps from the def-id of a trait to the list of\nsuper-predicates. This is a subset of the full list of\npredicates. We store these in a separate map because we must\nevaluate them even during type conversion, often before the\nfull predicates are available (note that supertraits have\nadditional acyclicity requirements).",209,null],[12,"object_cast_map","","Maps from node-id of a trait object cast (like `foo as\nBox<Trait>`) to the trait reference.",209,null],[12,"map","","",209,null],[12,"freevars","","",209,null],[12,"tcache","","",209,null],[12,"rcache","","",209,null],[12,"short_names_cache","","",209,null],[12,"tc_cache","","",209,null],[12,"ast_ty_to_ty_cache","","",209,null],[12,"enum_var_cache","","",209,null],[12,"ty_param_defs","","",209,null],[12,"adjustments","","",209,null],[12,"normalized_cache","","",209,null],[12,"lang_items","","",209,null],[12,"provided_method_sources","","A mapping of fake provided method def_ids to the default implementation",209,null],[12,"struct_fields","","",209,null],[12,"item_variance_map","","Maps from def-id of a type or region parameter to its\n(inferred) variance.",209,null],[12,"variance_computed","","True if the variance has been computed yet; false otherwise.",209,null],[12,"destructor_for_type","","A mapping from the def ID of an enum or struct type to the def ID\nof the method that implements its destructor. If the type is not\npresent in this map, it does not have a destructor. This map is\npopulated during the coherence phase of typechecking.",209,null],[12,"destructors","","A method will be in this list if and only if it is a destructor.",209,null],[12,"trait_impls","","Maps a trait onto a list of impls of that trait.",209,null],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls.\nContains implementations of methods that are inherent to a type.\nMethods in these implementations don't need to be exported.",209,null],[12,"impl_items","","Maps a DefId of an impl to a list of its items.\nNote that this contains all of the impls that we know about,\nincluding ones in other crates. It's not clear that this is the best\nway to do it.",209,null],[12,"used_unsafe","","Set of used unsafe nodes (functions or blocks). Unsafe nodes not\npresent in this set can be warned about.",209,null],[12,"used_mut_nodes","","Set of nodes which mark locals as mutable which end up getting used at\nsome point. Local variable definitions not in this set can be warned\nabout.",209,null],[12,"populated_external_types","","The set of external nominal types whose implementations have been read.\nThis is used for lazy resolution of methods.",209,null],[12,"populated_external_traits","","The set of external traits whose implementations have been read. This\nis used for lazy resolution of traits.",209,null],[12,"populated_external_primitive_impls","","The set of external primitive inherent implementations that have been read.",209,null],[12,"upvar_capture_map","","Borrows",209,null],[12,"extern_const_statics","","These two caches are used by const_eval when decoding external statics\nand variants that are found.",209,null],[12,"extern_const_variants","","",209,null],[12,"method_map","","",209,null],[12,"dependency_formats","","",209,null],[12,"closure_kinds","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",209,null],[12,"closure_tys","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",209,null],[12,"node_lint_levels","","",209,null],[12,"transmute_restrictions","","The types that must be asserted to be the same size for `transmute`\nto be valid. We gather up these restrictions in the intrinsicck pass\nand check them in trans.",209,null],[12,"stability","","Maps any item's def-id to its stability index.",209,null],[12,"associated_types","","Maps def IDs to true if and only if they're associated types.",209,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that do not have to do with the parameters in scope.",209,null],[12,"repr_hint_cache","","Caches the representation hints for struct definitions.",209,null],[12,"type_impls_copy_cache","","Caches whether types are known to impl Copy. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",209,null],[12,"type_impls_sized_cache","","Caches whether types are known to impl Sized. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",209,null],[12,"object_safety_cache","","Caches whether traits are object safe",209,null],[12,"const_qualif_map","","Maps Expr NodeId's to their constant qualification.",209,null],[3,"TypeFlags","","",null,null],[3,"TyS","","",null,null],[12,"sty","","",210,null],[12,"flags","","",210,null],[3,"InternedTy","","An entry in the type interner.",null,null],[3,"BareFnTy","","",null,null],[12,"unsafety","","",211,null],[12,"abi","","",211,null],[12,"sig","","",211,null],[3,"ClosureTy","","",null,null],[12,"unsafety","","",212,null],[12,"abi","","",212,null],[12,"sig","","",212,null],[3,"FnSig","","Signature of a function type, which I have arbitrarily\ndecided to use to refer to the input/output types.",null,null],[12,"inputs","","",213,null],[12,"output","","",213,null],[12,"variadic","","",213,null],[3,"ParamTy","","",null,null],[12,"space","","",214,null],[12,"idx","","",214,null],[12,"name","","",214,null],[3,"DebruijnIndex","","A [De Bruijn index][dbi] is a standard means of representing\nregions (and perhaps later types) in a higher-ranked setting. In\nparticular, imagine a type like this:",null,null],[12,"depth","","",215,null],[3,"EarlyBoundRegion","","",null,null],[12,"param_id","","",216,null],[12,"space","","",216,null],[12,"index","","",216,null],[12,"name","","",216,null],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of\nthe original var id (that is, the root variable that is referenced\nby the upvar) and the id of the closure expression.",null,null],[12,"var_id","","",217,null],[12,"closure_expr_id","","",217,null],[3,"UpvarBorrow","","",null,null],[12,"kind","","The kind of borrow: by-ref upvars have access to shared\nimmutable borrows, which are not part of the normal language\nsyntax.",218,null],[12,"region","","Region of the resulting reference.",218,null],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region\nat least as big as the scope `fr.scope`\".",null,null],[12,"scope","","",219,null],[12,"bound_region","","",219,null],[3,"TyTrait","","",null,null],[12,"principal","","",220,null],[12,"bounds","","",220,null],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax,\nbut perhaps the most recognizable form is in a where clause:",null,null],[12,"def_id","","",221,null],[12,"substs","","",221,null],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the\ncompiler's representation for things like `for<'a> Fn(&'a isize)`\n(which would be represented by the type `PolyTraitRef ==\nBinder<TraitRef>`). Note that when we skolemize, instantiate,\nerase, or otherwise \"discharge\" these bound regions, we change the\ntype from `Binder<T>` to just `T` (see\ne.g. `liberate_late_bound_regions`).",null,null],[3,"expected_found","","",null,null],[12,"expected","","",222,null],[12,"found","","",222,null],[3,"ParamBounds","","Bounds suitable for a named type parameter like `A` in `fn foo<A>`\nas well as the existential type parameter in an object type.",null,null],[12,"region_bounds","","",223,null],[12,"builtin_bounds","","",223,null],[12,"trait_bounds","","",223,null],[12,"projection_bounds","","",223,null],[3,"ExistentialBounds","","Bounds suitable for an existentially quantified type parameter\nsuch as those that appear in object types or closure types. The\nmajor difference between this case and `ParamBounds` is that\ngeneral purpose trait bounds are omitted and there must be\n*exactly one* region.",null,null],[12,"region_bound","","",224,null],[12,"builtin_bounds","","",224,null],[12,"projection_bounds","","",224,null],[3,"TyVid","","",null,null],[12,"index","","",225,null],[3,"IntVid","","",null,null],[12,"index","","",226,null],[3,"FloatVid","","",null,null],[12,"index","","",227,null],[3,"RegionVid","","",null,null],[12,"index","","",228,null],[3,"TypeParameterDef","","",null,null],[12,"name","","",229,null],[12,"def_id","","",229,null],[12,"space","","",229,null],[12,"index","","",229,null],[12,"default","","",229,null],[12,"object_lifetime_default","","",229,null],[3,"RegionParameterDef","","",null,null],[12,"name","","",230,null],[12,"def_id","","",230,null],[12,"space","","",230,null],[12,"index","","",230,null],[12,"bounds","","",230,null],[3,"Generics","","Information about the formal type/lifetime parameters associated\nwith an item or method. Analogous to ast::Generics.",null,null],[12,"types","","",231,null],[12,"regions","","",231,null],[3,"GenericPredicates","","Bounds on generics.",null,null],[12,"predicates","","",232,null],[3,"TraitPredicate","","",null,null],[12,"trait_ref","","",233,null],[3,"EquatePredicate","","",null,null],[3,"OutlivesPredicate","","",null,null],[3,"ProjectionPredicate","","This kind of predicate has no *direct* correspondent in the\nsyntax, but it roughly corresponds to the syntactic forms:",null,null],[12,"projection_ty","","",234,null],[12,"ty","","",234,null],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS\nform this would be written `<T as Trait<..>>::N`.",null,null],[12,"trait_ref","","The trait reference `T as Trait<..>`.",235,null],[12,"item_name","","The name `N` of the associated type.",235,null],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type\nparameters.  Should eventually be generalized into a flag list of\nwhere clauses.  You can obtain a `InstantiatedPredicates` list from a\n`GenericPredicates` by using the `instantiate` method. Note that this method\nreflects an important semantic invariant of `InstantiatedPredicates`: while\nthe `GenericPredicates` are expressed in terms of the bound type\nparameters of the impl/trait/whatever, an `InstantiatedPredicates` instance\nrepresented a set of bounds for some particular instantiation,\nmeaning that the generic parameters have been substituted with\ntheir values.",null,null],[12,"predicates","","",236,null],[3,"ParameterEnvironment","","When type checking, we use the `ParameterEnvironment` to track\ndetails about the type/lifetime parameters that are in scope.\nIt primarily stores the bounds information.",null,null],[12,"tcx","","",237,null],[12,"free_substs","","See `construct_free_substs` for details.",237,null],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that\nindicates it must outlive at least the function body (the user\nmay specify stronger requirements). This field indicates the\nregion of the callee.",237,null],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically\nthe set of bounds on the in-scope type parameters, translated\ninto Obligations.",237,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that have to do with the parameters in scope.",237,null],[3,"TypeScheme","","A \"type scheme\", in ML terminology, is a type combined with some\nset of generic types that the type is, well, generic over. In Rust\nterms, it is the \"type\" of a fn item or struct -- this type will\ninclude various generic parameters that must be substituted when\nthe item/struct is referenced. That is called converting the type\nscheme to a monotype.",null,null],[12,"generics","","",238,null],[12,"ty","","",238,null],[3,"TraitDef","","As `TypeScheme` but for a trait ref.",null,null],[12,"unsafety","","",239,null],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]`\nattribute, indicating that it should be used with `Foo()`\nsugar. This is a temporary thing -- eventually any trait wil\nbe usable with the sugar (or without it).",239,null],[12,"generics","","Generic type definitions. Note that `Self` is listed in here\nas having a single bound, the trait itself (e.g., in the trait\n`Eq`, there is a single bound `Self : Eq`). This is so that\ndefault methods get to assume that the `Self` parameters\nimplements the trait.",239,null],[12,"trait_ref","","",239,null],[12,"associated_type_names","","A list of the associated types defined in this trait. Useful\nfor resolving `X::Foo` type markers.",239,null],[3,"ItemSubsts","","Records the substitutions used to translate the polytype for an\nitem into the monotype of an item reference.",null,null],[12,"substs","","",240,null],[3,"TypeContents","","Type contents is how the type checker reasons about kinds.\nThey track what kinds of things are found within a type.  You can\nthink of them as kind of an \"anti-kind\".  They track the kinds of values\nand thinks that are contained in types.  Having a larger contents for\na type tends to rule that type *out* from various kinds.  For example,\na type that contains a reference is not sendable.",null,null],[12,"bits","","",241,null],[3,"VariantInfo","","",null,null],[12,"args","","",242,null],[12,"arg_names","","",242,null],[12,"ctor_ty","","",242,null],[12,"name","","",242,null],[12,"id","","",242,null],[12,"disr_val","","",242,null],[12,"vis","","",242,null],[3,"ClosureUpvar","","",null,null],[12,"def","","",243,null],[12,"span","","",243,null],[12,"ty","","",243,null],[3,"Freevar","","A free variable referred to in a function.",null,null],[12,"def","","The variable being accessed free.",244,null],[12,"span","","",244,null],[4,"ImplOrTraitItemContainer","","",null,null],[13,"TraitContainer","","",245,null],[13,"ImplContainer","","",245,null],[4,"ImplOrTraitItem","","",null,null],[13,"MethodTraitItem","","",246,null],[13,"TypeTraitItem","","",246,null],[4,"ImplOrTraitItemId","","",null,null],[13,"MethodTraitItemId","","",247,null],[13,"TypeTraitItemId","","",247,null],[4,"Variance","","",null,null],[13,"Covariant","","",248,null],[13,"Invariant","","",248,null],[13,"Contravariant","","",248,null],[13,"Bivariant","","",248,null],[4,"AutoAdjustment","","",null,null],[13,"AdjustReifyFnPointer","","",249,null],[13,"AdjustUnsafeFnPointer","","",249,null],[13,"AdjustDerefRef","","",249,null],[4,"AutoRef","","",null,null],[13,"AutoPtr","","Convert from T to &T.",250,null],[13,"AutoUnsafe","","Convert from T to *T.\nValue to thin pointer.",250,null],[4,"MethodOrigin","","",null,null],[13,"MethodStatic","","",251,null],[13,"MethodStaticClosure","","",251,null],[13,"MethodTypeParam","","",251,null],[13,"MethodTraitObject","","",251,null],[4,"vtable_origin","","",null,null],[13,"vtable_static","","",252,null],[13,"vtable_param","","",252,null],[13,"vtable_closure","","",252,null],[13,"vtable_error","","",252,null],[4,"FnOutput","","",null,null],[13,"FnConverging","","",253,null],[13,"FnDiverging","","",253,null],[4,"Region","","Representation of regions:",null,null],[13,"ReEarlyBound","","",254,null],[13,"ReLateBound","","",254,null],[13,"ReFree","","When checking a function body, the types of all arguments and so forth\nthat refer to bound region parameters are modified to refer to free\nregion parameters.",254,null],[13,"ReScope","","A concrete region naming some statically determined extent\n(e.g. an expression or sequence of statements) within the\ncurrent function.",254,null],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",254,null],[13,"ReInfer","","A region variable.  Should not exist after typeck.",254,null],[13,"ReEmpty","","Empty lifetime is for data that is never accessed.\nBottom in the region lattice. We treat ReEmpty somewhat\nspecially; at least right now, we do not generate instances of\nit during the GLB computations, but rather\ngenerate an error instead. This is to improve error messages.\nThe only way to get an instance of ReEmpty is to have a region\nvariable with no constraints.",254,null],[4,"BorrowKind","","",null,null],[13,"ImmBorrow","","Data must be immutable and is aliasable.",255,null],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow\ncannot currently be expressed by the user and is used only in\nimplicit closure bindings. It is needed when you the closure\nis borrowing or mutating a mutable referent, e.g.:",255,null],[13,"MutBorrow","","Data is mutable and not aliasable.",255,null],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed\nduring `typeck`, specifically by `regionck`.",null,null],[13,"ByValue","","Upvar is captured by value. This is always true when the\nclosure is labeled `move`, but can also be true in other cases\ndepending on inference.",256,null],[13,"ByRef","","Upvar is captured by reference.",256,null],[4,"BoundRegion","","",null,null],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",257,null],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",257,null],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",257,null],[13,"BrEnv","","",257,null],[4,"sty","","",null,null],[13,"ty_bool","","",258,null],[13,"ty_char","","",258,null],[13,"ty_int","","",258,null],[13,"ty_uint","","",258,null],[13,"ty_float","","",258,null],[13,"ty_enum","","Substs here, possibly against intuition, *may* contain `ty_param`s.\nThat is, even after substitution it is possible that there are type\nvariables. This happens when the `ty_enum` corresponds to an enum\ndefinition and not a concrete use of it. To get the correct `ty_enum`\nfrom the tcx, use the `NodeId` from the `ast::Ty` and look it up in\nthe `ast_ty_to_ty_cache`. This is probably true for `ty_struct` as\nwell.",258,null],[13,"ty_uniq","","",258,null],[13,"ty_str","","",258,null],[13,"ty_vec","","",258,null],[13,"ty_ptr","","",258,null],[13,"ty_rptr","","",258,null],[13,"ty_bare_fn","","",258,null],[13,"ty_trait","","",258,null],[13,"ty_struct","","",258,null],[13,"ty_closure","","",258,null],[13,"ty_tup","","",258,null],[13,"ty_projection","","",258,null],[13,"ty_param","","",258,null],[13,"ty_infer","","",258,null],[13,"ty_err","","",258,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",259,null],[13,"UintType","","",259,null],[4,"terr_vstore_kind","","",null,null],[13,"terr_vec","","",260,null],[13,"terr_str","","",260,null],[13,"terr_fn","","",260,null],[13,"terr_trait","","",260,null],[4,"type_err","","",null,null],[13,"terr_mismatch","","",261,null],[13,"terr_unsafety_mismatch","","",261,null],[13,"terr_abi_mismatch","","",261,null],[13,"terr_mutability","","",261,null],[13,"terr_box_mutability","","",261,null],[13,"terr_ptr_mutability","","",261,null],[13,"terr_ref_mutability","","",261,null],[13,"terr_vec_mutability","","",261,null],[13,"terr_tuple_size","","",261,null],[13,"terr_fixed_array_size","","",261,null],[13,"terr_ty_param_size","","",261,null],[13,"terr_arg_count","","",261,null],[13,"terr_regions_does_not_outlive","","",261,null],[13,"terr_regions_not_same","","",261,null],[13,"terr_regions_no_overlap","","",261,null],[13,"terr_regions_insufficiently_polymorphic","","",261,null],[13,"terr_regions_overly_polymorphic","","",261,null],[13,"terr_sorts","","",261,null],[13,"terr_integer_as_char","","",261,null],[13,"terr_int_mismatch","","",261,null],[13,"terr_float_mismatch","","",261,null],[13,"terr_traits","","",261,null],[13,"terr_builtin_bounds","","",261,null],[13,"terr_variadic_mismatch","","",261,null],[13,"terr_cyclic_ty","","",261,null],[13,"terr_convergence_mismatch","","",261,null],[13,"terr_projection_name_mismatched","","",261,null],[13,"terr_projection_bounds_length","","",261,null],[4,"BuiltinBound","","",null,null],[13,"BoundSend","","",262,null],[13,"BoundSized","","",262,null],[13,"BoundCopy","","",262,null],[13,"BoundSync","","",262,null],[4,"InferTy","","",null,null],[13,"TyVar","","",263,null],[13,"IntVar","","",263,null],[13,"FloatVar","","",263,null],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an\nunbound type variable. This is convenient for caching etc. See\n`middle::infer::freshen` for more details.",263,null],[13,"FreshIntTy","","",263,null],[4,"UnconstrainedNumeric","","",null,null],[13,"UnconstrainedFloat","","",264,null],[13,"UnconstrainedInt","","",264,null],[13,"Neither","","",264,null],[4,"InferRegion","","",null,null],[13,"ReVar","","",265,null],[13,"ReSkolemized","","",265,null],[4,"ObjectLifetimeDefault","","Default region to use for the bound of objects that are\nsupplied as the value for this type parameter. This is derived\nfrom `T:'a` annotations appearing in the type definition.  If\nthis is `None`, then the default is inherited from the\nsurrounding context. See RFC #599 for details.",null,null],[13,"Ambiguous","","Require an explicit annotation. Occurs when multiple\n`T:'a` constraints are found.",266,null],[13,"Specific","","Use the given region as the default.",266,null],[4,"Predicate","","",null,null],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be\nthe `Self` type of the trait reference and `A`, `B`, and `C`\nwould be the parameters in the `TypeSpace`.",267,null],[13,"Equate","","where `T1 == T2`.",267,null],[13,"RegionOutlives","","where 'a : 'b",267,null],[13,"TypeOutlives","","where T : 'a",267,null],[13,"Projection","","where <T as TraitRef>::Name == X, approximately.\nSee `ProjectionPredicate` struct for details.",267,null],[4,"ClosureKind","","",null,null],[13,"FnClosureKind","","",268,null],[13,"FnMutClosureKind","","",268,null],[13,"FnOnceClosureKind","","",268,null],[4,"Representability","","Describes whether a type is representable. For types that are not\nrepresentable, 'SelfRecursive' and 'ContainsRecursive' are used to\ndistinguish between types that are recursive with themselves and types that\ncontain a different recursive type. These cases can therefore be treated\ndifferently when reporting errors.",null,null],[13,"Representable","","",269,null],[13,"ContainsRecursive","","",269,null],[13,"SelfRecursive","","",269,null],[4,"ExprKind","","We categorize expressions into three kinds.  The distinction between\nlvalue/rvalue is fundamental to the language.  The distinction between the\ntwo kinds of rvalues is an artifact of trans which reflects how we will\ngenerate code for that kind of expression.  See trans/expr.rs for more\ninformation.",null,null],[13,"LvalueExpr","","",270,null],[13,"RvalueDpsExpr","","",270,null],[13,"RvalueDatumExpr","","",270,null],[13,"RvalueStmtExpr","","",270,null],[4,"DtorKind","","",null,null],[13,"NoDtor","","",271,null],[13,"TraitDtor","","",271,null],[4,"ExplicitSelfCategory","","The category of explicit self.",null,null],[13,"StaticExplicitSelfCategory","","",272,null],[13,"ByValueExplicitSelfCategory","","",272,null],[13,"ByReferenceExplicitSelfCategory","","",272,null],[13,"ByBoxExplicitSelfCategory","","",272,null],[4,"CopyImplementationError","","",null,null],[13,"FieldDoesNotImplementCopy","","",273,null],[13,"VariantDoesNotImplementCopy","","",273,null],[13,"TypeIsStructural","","",273,null],[13,"TypeHasDestructor","","",273,null],[5,"type_has_params","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_has_self","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_has_ty_infer","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_needs_infer","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_has_projection","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_has_late_bound_regions","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_has_escaping_regions","","An \"escaping region\" is a bound region whose binder is not part of `t`.",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_escapes_depth","","",null,{"inputs":[{"name":"ty"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"empty_builtin_bounds","","",null,{"inputs":[],"output":{"name":"builtinbounds"}}],[5,"all_builtin_bounds","","",null,{"inputs":[],"output":{"name":"builtinbounds"}}],[5,"region_existential_bound","","An existential bound that does not implement any traits.",null,{"inputs":[{"name":"region"}],"output":{"name":"existentialbounds"}}],[5,"mk_ctxt","","",null,{"inputs":[{"name":"session"},{"name":"ctxtarenas"},{"name":"defmap"},{"name":"namedregionmap"},{"name":"map"},{"name":"refcell"},{"name":"regionmaps"},{"name":"languageitems"},{"name":"index"}],"output":{"name":"ctxt"}}],[5,"mk_t","","",null,{"inputs":[{"name":"ctxt"},{"name":"sty"}],"output":{"name":"ty"}}],[5,"mk_mach_int","","",null,{"inputs":[{"name":"ctxt"},{"name":"intty"}],"output":{"name":"ty"}}],[5,"mk_mach_uint","","",null,{"inputs":[{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"ty"}}],[5,"mk_mach_float","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatty"}],"output":{"name":"ty"}}],[5,"mk_str","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"ty"}}],[5,"mk_str_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mutability"}],"output":{"name":"ty"}}],[5,"mk_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[5,"mk_uniq","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"mk_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"ty"}}],[5,"mk_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"ty"}}],[5,"mk_mut_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"mk_imm_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"mk_mut_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"mk_imm_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"mk_nil_ptr","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"ty"}}],[5,"mk_vec","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"option"}],"output":{"name":"ty"}}],[5,"mk_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"ty"}}],[5,"mk_tup","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"ty"}}],[5,"mk_nil","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"ty"}}],[5,"mk_bool","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"ty"}}],[5,"mk_bare_fn","","",null,{"inputs":[{"name":"ctxt"},{"name":"option"},{"name":"barefnty"}],"output":{"name":"ty"}}],[5,"mk_ctor_fn","","",null,null],[5,"mk_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"polytraitref"},{"name":"existentialbounds"}],"output":{"name":"ty"}}],[5,"sort_bounds_list","","",null,null],[5,"mk_projection","","",null,{"inputs":[{"name":"ctxt"},{"name":"rc"},{"name":"name"}],"output":{"name":"ty"}}],[5,"mk_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[5,"mk_closure","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[5,"mk_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"tyvid"}],"output":{"name":"ty"}}],[5,"mk_int_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"intvid"}],"output":{"name":"ty"}}],[5,"mk_float_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatvid"}],"output":{"name":"ty"}}],[5,"mk_infer","","",null,{"inputs":[{"name":"ctxt"},{"name":"inferty"}],"output":{"name":"ty"}}],[5,"mk_param","","",null,{"inputs":[{"name":"ctxt"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"ty"}}],[5,"mk_self_type","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"ty"}}],[5,"mk_param_from_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"typeparameterdef"}],"output":{"name":"ty"}}],[5,"walk_ty","","",null,{"inputs":[{"name":"ty"},{"name":"f"}],"output":null}],[5,"maybe_walk_ty","","Walks `ty` and any types appearing within `ty`, invoking the\ncallback `f` on each type. If the callback returns false, then the\nchildren of the current type are ignored.",null,{"inputs":[{"name":"ty"},{"name":"f"}],"output":null}],[5,"fold_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"f"}],"output":{"name":"ty"}}],[5,"type_is_nil","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_error","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_needs_subst","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"trait_ref_contains_error","","",null,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[5,"type_is_ty_var","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_bool","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_self","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_vec","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_structural","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_simd","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"sequence_element_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"simd_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"simd_size","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"usize"}}],[5,"type_is_region_ptr","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_unsafe_ptr","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_unique","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_scalar","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_floating_point","","Returns true if this type is a floating point type and false otherwise.",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_interior_is_unsafe","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_contents","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"typecontents"}}],[5,"type_moves_by_default","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_sized","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"is_ffi_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"is_instantiable","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"is_type_representable","","Check whether a type is representable. This means it cannot contain unboxed\nstructural recursion. This check is needed for structs and enums.",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"ty"}],"output":{"name":"representability"}}],[5,"type_is_trait","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_trait_info","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"option"}}],[5,"type_is_integral","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_fresh","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_uint","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_char","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn_item","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_fp","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_numeric","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_signed","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_machine","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"type_is_c_like_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"deref","","",null,{"inputs":[{"name":"ty"},{"name":"bool"}],"output":{"name":"option"}}],[5,"type_content","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[5,"index","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"option"}}],[5,"array_element_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"option"}}],[5,"positional_element_ty","","Returns the type of element at index `i` in tuple or tuple-like type `t`.\nFor an enum `t`, `variant` is None only if `t` is a univariant enum.",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"usize"},{"name":"option"}],"output":{"name":"option"}}],[5,"named_element_ty","","Returns the type of element at field `n` in struct or struct-like type `t`.\nFor an enum `t`, `variant` must be some def id.",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"name"},{"name":"option"}],"output":{"name":"option"}}],[5,"impl_id_to_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"rc"}}],[5,"node_id_to_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"ty"}}],[5,"node_id_to_type_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"node_id_item_substs","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"itemsubsts"}}],[5,"fn_is_variadic","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"ty_fn_sig","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"polyfnsig"}}],[5,"ty_fn_abi","","Returns the ABI of the given function.",null,{"inputs":[{"name":"ty"}],"output":{"name":"abi"}}],[5,"ty_fn_args","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"binder"}}],[5,"ty_fn_ret","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"binder"}}],[5,"is_fn_ty","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[5,"ty_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"ty"}],"output":{"name":"region"}}],[5,"free_region_from_def","","",null,{"inputs":[{"name":"destructionscopedata"},{"name":"regionparameterdef"}],"output":{"name":"region"}}],[5,"pat_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"ty"}}],[5,"pat_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"option"}}],[5,"expr_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"ty"}}],[5,"expr_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"option"}}],[5,"expr_ty_adjusted","","Returns the type of `expr`, considering any `AutoAdjustment`\nentry recorded for that expression.",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"ty"}}],[5,"expr_span","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"span"}}],[5,"local_var_name_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"internedstring"}}],[5,"adjust_ty","","See `expr_ty_adjusted`",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"nodeid"},{"name":"ty"},{"name":"option"},{"name":"f"}],"output":{"name":"ty"}}],[5,"adjust_ty_for_autoref","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"option"}],"output":{"name":"ty"}}],[5,"resolve_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"def"}}],[5,"expr_is_lval","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"bool"}}],[5,"expr_kind","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"exprkind"}}],[5,"stmt_node_id","","",null,{"inputs":[{"name":"stmt"}],"output":{"name":"nodeid"}}],[5,"field_idx_strict","","",null,null],[5,"impl_or_trait_item_idx","","",null,null],[5,"ty_sort_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"string"}}],[5,"type_err_to_str","","Explains the source of a type err in a short, human readable way. This is meant to be placed\nin parentheses after some larger message. You should also invoke `note_and_explain_type_err()`\nafterwards to present additional details, particularly when it comes to lifetime-related\nerrors.",null,{"inputs":[{"name":"ctxt"},{"name":"type_err"}],"output":{"name":"string"}}],[5,"note_and_explain_type_err","","",null,{"inputs":[{"name":"ctxt"},{"name":"type_err"},{"name":"span"}],"output":null}],[5,"provided_source","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"usize"}],"output":{"name":"implortraititem"}}],[5,"trait_items","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"is_associated_type","","Returns true if the given ID refers to an associated type and false if it\nrefers to anything else.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"associated_type_parameter_index","","Returns the parameter index that the given associated type corresponds to.",null,{"inputs":[{"name":"ctxt"},{"name":"traitdef"},{"name":"defid"}],"output":{"name":"usize"}}],[5,"trait_item_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"impl_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_ref_to_def_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"}],"output":{"name":"defid"}}],[5,"try_add_builtin_trait","","Checks whether `trait_ref` refers to one of the builtin\ntraits, like `Send`, and adds the corresponding\nbound to the set `builtin_bounds` if so. Returns true if `trait_ref`\nis a builtin trait.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"enumset"}],"output":{"name":"bool"}}],[5,"ty_to_def_id","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"option"}}],[5,"substd_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"item_path_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"string"}}],[5,"ty_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"dtorkind"}}],[5,"has_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"with_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"f"}],"output":{"name":"t"}}],[5,"enum_is_univariant","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"type_is_empty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"bool"}}],[5,"enum_repr_type","","Returns `(normalized_type, ty)`, where `normalized_type` is the\nIntType representation of one of {i64,i32,i16,i8,u64,u32,u16,u8},\nand `ty` is the original type (i.e. may include `isize` or\n`usize`).",null,null],[5,"enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"enum_variant_with_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_item_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"lookup_trait_def","","Given the did of a trait, returns its canonical trait ref.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_predicates","","Given the did of an item, returns its full set of predicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"lookup_super_predicates","","Given the did of a trait, returns its superpredicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"parambounds"}],"output":{"name":"vec"}}],[5,"get_attrs","","Get the attributes of a definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"cow"}}],[5,"has_attr","","Determine whether an item is annotated with an attribute",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"str"}],"output":{"name":"bool"}}],[5,"lookup_packed","","Determine whether an item is annotated with `#[repr(packed)]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_simd","","Determine whether an item is annotated with `#[simd]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_repr_hints","","Obtain the representation annotation for a struct definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"},{"name":"substs"}],"output":{"name":"ty"}}],[5,"lookup_struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_tuple_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"tup_fields","","",null,null],[5,"struct_tail","","Returns the deeply last field of nested structures, or the same type,\nif not a structure at all. Corresponds to the only possible unsized\nfield, and its type can be used to determine unsizing strategy.",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only\nkeeps going as long as the two types are instances of the same\nstructure definitions.\nFor `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`,\nwhereas struct_tail produces `T`, and `Trait`, respectively.",null,null],[5,"closure_upvars","","",null,{"inputs":[{"name":"typer"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"eval_repeat_count","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"usize"}}],[5,"each_bound_trait_and_supertraits","","",null,null],[5,"required_region_bounds","","Given a set of predicates that apply to an object type, returns\nthe region bounds that the (erased) `Self` type must\noutlive. Precisely *because* the `Self` type is erased, the\nparameter `erased_self_ty` must be supplied to indicate what type\nhas been used to represent `Self` in the predicates\nthemselves. This should really be a unique type; `FreshTy(0)` is a\npopular choice.",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"vec"}],"output":{"name":"vec"}}],[5,"item_variances","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_has_default_impl","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"record_trait_has_default_impl","","Records a trait-to-implementation mapping.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":null}],[5,"record_trait_implementation","","Records a trait-to-implementation mapping.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":null}],[5,"populate_implementations_for_primitive_if_necessary","","Load primitive inherent implementations if necessary",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":null}],[5,"populate_implementations_for_type_if_necessary","","Populates the type context with all the implementations for the given type\nif necessary.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":null}],[5,"populate_implementations_for_trait_if_necessary","","Populates the type context with all the implementations for the given\ntrait if necessary.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":null}],[5,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements.\nIf it implements no trait, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the\nID of the impl that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), return the ID of\nthe trait that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_item_of_item","","If the given def ID describes an item belonging to a trait, (either a\ndefault method or an implementation of a trait method), return the ID of\nthe method inside trait definition (this means that if the given def ID\nis already that of the original trait method, then the return value is\nthe same).\nOtherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"hash_crate_independent","","Creates a hash of the type `Ty` which will be the same no matter what crate\ncontext it's calculated within. This is used by the `type_id` intrinsic.",null,{"inputs":[{"name":"ctxt"},{"name":"ty"},{"name":"svh"}],"output":{"name":"u64"}}],[5,"empty_parameter_environment","","Construct a parameter environment suitable for static contexts or other contexts where there\nare no free type/lifetime parameters in scope.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"parameterenvironment"}}],[5,"construct_free_substs","","Constructs and returns a substitution that can be applied to move from\nthe \"outer\" view of a type or method to the \"inner\" view.\nIn general, this means converting from bound parameters to\nfree parameters. Since we currently represent bound/free type\nparameters in the same way, this only has an effect on regions.",null,{"inputs":[{"name":"ctxt"},{"name":"generics"},{"name":"nodeid"}],"output":{"name":"substs"}}],[5,"construct_parameter_environment","","See `ParameterEnvironment` struct def'n for details",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"generics"},{"name":"genericpredicates"},{"name":"nodeid"}],"output":{"name":"parameterenvironment"}}],[5,"accumulate_lifetimes_in_type","","Pushes all the lifetimes in the given type onto the given list. A\n\"lifetime in a type\" is a lifetime specified by a reference or a lifetime\nin a list of type substitutions. This does *not* traverse into nominal\ntypes, nor does it resolve fictitious types.",null,{"inputs":[{"name":"vec"},{"name":"ty"}],"output":null}],[5,"with_freevars","","",null,{"inputs":[{"name":"ctxt"},{"name":"nodeid"},{"name":"f"}],"output":{"name":"t"}}],[5,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to scope-id\n`scope_id`.",null,{"inputs":[{"name":"ctxt"},{"name":"destructionscopedata"},{"name":"binder"}],"output":{"name":"t"}}],[5,"count_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"usize"}}],[5,"binds_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"bool"}}],[5,"flatten_late_bound_regions","","Flattens two binding levels into one. So `for<'a> for<'b> Foo`\nbecomes `for<'a,'b> Foo`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"no_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"option"}}],[5,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'static`. Useful in trans but also\nmethod lookup and a few other places where precise region relationships are not required.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"t"}}],[5,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are\nassigned starting at 1 and increasing monotonically in the order traversed\nby the fold operation.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"replace_late_bound_regions","","Replaces the late-bound-regions in `value` that are bound by `value`.",null,null],[5,"make_substs_for_receiver_types","","Substitutes the values for the receiver's type parameters\nthat are found in method, leaving the method's type parameters\nintact.",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"},{"name":"method"}],"output":{"name":"substs"}}],[5,"can_type_implement_copy","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"ty"}],"output":{"name":"result"}}],[6,"Disr","","",null,null],[6,"MethodMap","","",null,null],[6,"vtable_param_res","","",null,null],[6,"vtable_res","","",null,null],[6,"ObjectCastMap","","",null,null],[6,"Ty","","",null,null],[6,"PolyFnOutput","","",null,null],[6,"PolyFnSig","","",null,null],[6,"UpvarCaptureMap","","",null,null],[6,"PolyTraitRef","","",null,null],[6,"BuiltinBounds","","",null,null],[6,"PolyTraitPredicate","","",null,null],[6,"PolyEquatePredicate","","",null,null],[6,"PolyOutlivesPredicate","","",null,null],[6,"PolyRegionOutlivesPredicate","","",null,null],[6,"PolyTypeOutlivesPredicate","","",null,null],[6,"PolyProjectionPredicate","","",null,null],[6,"FreevarMap","","",null,null],[6,"CaptureModeMap","","",null,null],[6,"TraitMap","","",null,null],[6,"GlobMap","","",null,null],[17,"INITIAL_DISCRIMINANT_VALUE","","",null,null],[17,"NO_TYPE_FLAGS","","",null,null],[17,"HAS_PARAMS","","",null,null],[17,"HAS_SELF","","",null,null],[17,"HAS_TY_INFER","","",null,null],[17,"HAS_RE_INFER","","",null,null],[17,"HAS_RE_LATE_BOUND","","",null,null],[17,"HAS_REGIONS","","",null,null],[17,"HAS_TY_ERR","","",null,null],[17,"HAS_PROJECTION","","",null,null],[17,"NEEDS_SUBST","","",null,null],[8,"ToPolyTraitRef","","",null,null],[10,"to_poly_trait_ref","","",274,{"inputs":[{"name":"topolytraitref"}],"output":{"name":"polytraitref"}}],[8,"AsPredicate","","",null,null],[10,"as_predicate","","",275,{"inputs":[{"name":"aspredicate"}],"output":{"name":"predicate"}}],[8,"ClosureTyper","","",null,null],[11,"tcx","","",276,{"inputs":[{"name":"closuretyper"}],"output":{"name":"ctxt"}}],[10,"param_env","","",276,{"inputs":[{"name":"closuretyper"}],"output":{"name":"parameterenvironment"}}],[10,"closure_kind","","Is this a `Fn`, `FnMut` or `FnOnce` closure? During typeck,\nreturns `None` if the kind of this closure has not yet been\ninferred.",276,{"inputs":[{"name":"closuretyper"},{"name":"defid"}],"output":{"name":"option"}}],[10,"closure_type","","Returns the argument/return types of this closure.",276,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[10,"closure_upvars","","Returns the set of all upvars and their transformed\ntypes. During typeck, maybe return `None` if the upvar types\nhave not yet been inferred.",276,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[8,"RegionEscape","","",null,null],[11,"has_escaping_regions","","",277,{"inputs":[{"name":"regionescape"}],"output":{"name":"bool"}}],[10,"has_regions_escaping_depth","","",277,{"inputs":[{"name":"regionescape"},{"name":"u32"}],"output":{"name":"bool"}}],[8,"HasProjectionTypes","","",null,null],[10,"has_projection_types","","",278,{"inputs":[{"name":"hasprojectiontypes"}],"output":{"name":"bool"}}],[8,"ReferencesError","","",null,null],[10,"references_error","","",279,{"inputs":[{"name":"referenceserror"}],"output":{"name":"bool"}}],[11,"hash","","",194,null],[11,"eq","","",194,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",194,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",194,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",245,{"inputs":[{"name":"implortraititemcontainer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",245,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"implortraititemcontainer"}}],[11,"id","","",245,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"defid"}}],[11,"fmt","","",246,{"inputs":[{"name":"implortraititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",246,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititem"}}],[11,"def_id","","",246,{"inputs":[{"name":"implortraititem"}],"output":{"name":"defid"}}],[11,"name","","",246,{"inputs":[{"name":"implortraititem"}],"output":{"name":"name"}}],[11,"container","","",246,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititemcontainer"}}],[11,"as_opt_method","","",246,{"inputs":[{"name":"implortraititem"}],"output":{"name":"option"}}],[11,"fmt","","",247,{"inputs":[{"name":"implortraititemid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",247,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"implortraititemid"}}],[11,"def_id","","",247,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"defid"}}],[11,"fmt","","",195,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",195,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"new","","",195,{"inputs":[{"name":"method"},{"name":"name"},{"name":"generics"},{"name":"genericpredicates"},{"name":"barefnty"},{"name":"explicitselfcategory"},{"name":"visibility"},{"name":"defid"},{"name":"implortraititemcontainer"},{"name":"option"}],"output":{"name":"method"}}],[11,"container_id","","",195,{"inputs":[{"name":"method"}],"output":{"name":"defid"}}],[11,"fmt","","",196,{"inputs":[{"name":"associatedtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",196,{"inputs":[{"name":"associatedtype"}],"output":{"name":"associatedtype"}}],[11,"fmt","","",197,{"inputs":[{"name":"mt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",197,null],[11,"eq","","",197,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"ne","","",197,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"clone","","",197,{"inputs":[{"name":"mt"}],"output":{"name":"mt"}}],[11,"fmt","","",198,{"inputs":[{"name":"field_ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",198,{"inputs":[{"name":"field_ty"}],"output":{"name":"field_ty"}}],[11,"hash","","",199,null],[11,"eq","","",199,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"ne","","",199,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"clone","","",199,{"inputs":[{"name":"creader_cache_key"}],"output":{"name":"creader_cache_key"}}],[11,"encode","","",200,{"inputs":[{"name":"itemvariances"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",200,{"inputs":[{"name":"itemvariances"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",200,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"ne","","",200,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"clone","","",200,{"inputs":[{"name":"itemvariances"}],"output":{"name":"itemvariances"}}],[11,"fmt","","",248,{"inputs":[{"name":"variance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",248,{"inputs":[{"name":"variance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",248,{"inputs":[{"name":"variance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",248,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"ne","","",248,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"clone","","",248,{"inputs":[{"name":"variance"}],"output":{"name":"variance"}}],[11,"fmt","","",249,{"inputs":[{"name":"autoadjustment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",249,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"autoadjustment"}}],[11,"fmt","","",201,{"inputs":[{"name":"autoderefref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",201,{"inputs":[{"name":"autoderefref"}],"output":{"name":"autoderefref"}}],[11,"fmt","","",250,{"inputs":[{"name":"autoref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",250,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"ne","","",250,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"clone","","",250,{"inputs":[{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fmt","","",202,{"inputs":[{"name":"param_index"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"option"}}],[11,"lt","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"le","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"gt","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ge","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"eq","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ne","","",202,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"decode","","",202,{"inputs":[{"name":"param_index"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",202,{"inputs":[{"name":"param_index"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",202,{"inputs":[{"name":"param_index"}],"output":{"name":"param_index"}}],[11,"fmt","","",251,{"inputs":[{"name":"methodorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",251,{"inputs":[{"name":"methodorigin"}],"output":{"name":"methodorigin"}}],[11,"fmt","","",203,{"inputs":[{"name":"methodparam"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",203,{"inputs":[{"name":"methodparam"}],"output":{"name":"methodparam"}}],[11,"fmt","","",204,{"inputs":[{"name":"methodobject"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",204,{"inputs":[{"name":"methodobject"}],"output":{"name":"methodobject"}}],[11,"clone","","",205,{"inputs":[{"name":"methodcallee"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",206,{"inputs":[{"name":"methodcall"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",206,null],[11,"eq","","",206,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"ne","","",206,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"clone","","",206,{"inputs":[{"name":"methodcall"}],"output":{"name":"methodcall"}}],[11,"expr","","",206,{"inputs":[{"name":"methodcall"},{"name":"nodeid"}],"output":{"name":"methodcall"}}],[11,"autoderef","","",206,{"inputs":[{"name":"methodcall"},{"name":"nodeid"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"clone","","",252,{"inputs":[{"name":"vtable_origin"}],"output":{"name":"vtable_origin"}}],[11,"clone","","",207,{"inputs":[{"name":"transmuterestriction"}],"output":{"name":"transmuterestriction"}}],[11,"new","","",280,{"inputs":[{"name":"ctxtarenas"}],"output":{"name":"ctxtarenas"}}],[11,"node_types","","",209,{"inputs":[{"name":"ctxt"}],"output":{"name":"ref"}}],[11,"node_type_insert","","",209,{"inputs":[{"name":"ctxt"},{"name":"nodeid"},{"name":"ty"}],"output":null}],[11,"store_free_region_map","","",209,{"inputs":[{"name":"ctxt"},{"name":"nodeid"},{"name":"freeregionmap"}],"output":null}],[11,"free_region_map","","",209,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"freeregionmap"}}],[11,"hash","","",281,null],[11,"cmp","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"option"}}],[11,"lt","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"clone","","",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"eq","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",281,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",281,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":null}],[6,"Output","","",null,null],[11,"bitor","","Returns the union of the two sets of flags.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","","",null,null],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","","",null,null],[11,"bitand","","Returns the intersection between the two sets of flags.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","","",null,null],[11,"sub","","Returns the set difference of the two sets of flags.",281,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","","",null,null],[11,"not","","Returns the complement of this set of flags.",281,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"print_debug_stats","","",209,{"inputs":[{"name":"ctxt"}],"output":null}],[11,"fmt","","",210,{"inputs":[{"name":"tys"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",281,{"inputs":[{"name":"typeflags"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",210,{"inputs":[{"name":"tys"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",210,{"inputs":[{"name":"tys"},{"name":"h"}],"output":null}],[11,"eq","","",282,{"inputs":[{"name":"internedty"},{"name":"internedty"}],"output":{"name":"bool"}}],[11,"hash","","",282,{"inputs":[{"name":"internedty"},{"name":"h"}],"output":null}],[11,"borrow","","",282,{"inputs":[{"name":"internedty"}],"output":{"name":"sty"}}],[11,"fmt","","",211,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",211,null],[11,"eq","","",211,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",211,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",211,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",212,{"inputs":[{"name":"closurety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",212,null],[11,"eq","","",212,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"clone","","",212,{"inputs":[{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fmt","","",253,{"inputs":[{"name":"fnoutput"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",253,null],[11,"eq","","",253,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"ne","","",253,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"clone","","",253,{"inputs":[{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"diverges","","",253,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"unwrap","","",253,{"inputs":[{"name":"fnoutput"}],"output":{"name":"ty"}}],[11,"unwrap_or","","",253,{"inputs":[{"name":"fnoutput"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"diverges","","",283,{"inputs":[{"name":"polyfnoutput"}],"output":{"name":"bool"}}],[11,"hash","","",213,null],[11,"eq","","",213,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"clone","","",213,{"inputs":[{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"inputs","","",284,{"inputs":[{"name":"polyfnsig"}],"output":{"name":"binder"}}],[11,"input","","",284,{"inputs":[{"name":"polyfnsig"},{"name":"usize"}],"output":{"name":"binder"}}],[11,"output","","",284,{"inputs":[{"name":"polyfnsig"}],"output":{"name":"binder"}}],[11,"variadic","","",284,{"inputs":[{"name":"polyfnsig"}],"output":{"name":"bool"}}],[11,"fmt","","",214,{"inputs":[{"name":"paramty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",214,null],[11,"eq","","",214,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",214,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"clone","","",214,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"fmt","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",215,null],[11,"eq","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"clone","","",215,{"inputs":[{"name":"debruijnindex"}],"output":{"name":"debruijnindex"}}],[11,"fmt","","",254,{"inputs":[{"name":"region"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",254,{"inputs":[{"name":"region"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",254,{"inputs":[{"name":"region"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",254,null],[11,"eq","","",254,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",254,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",254,{"inputs":[{"name":"region"}],"output":{"name":"region"}}],[11,"fmt","","",216,{"inputs":[{"name":"earlyboundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",216,{"inputs":[{"name":"earlyboundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",216,{"inputs":[{"name":"earlyboundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",216,null],[11,"eq","","",216,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",216,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"clone","","",216,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"earlyboundregion"}}],[11,"fmt","","",217,{"inputs":[{"name":"upvarid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",217,null],[11,"eq","","",217,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",217,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"clone","","",217,{"inputs":[{"name":"upvarid"}],"output":{"name":"upvarid"}}],[11,"decode","","",255,{"inputs":[{"name":"borrowkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",255,{"inputs":[{"name":"borrowkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",255,{"inputs":[{"name":"borrowkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",255,null],[11,"eq","","",255,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",255,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"clone","","",255,{"inputs":[{"name":"borrowkind"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",256,{"inputs":[{"name":"upvarcapture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",256,{"inputs":[{"name":"upvarcapture"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",256,{"inputs":[{"name":"upvarcapture"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",256,{"inputs":[{"name":"upvarcapture"}],"output":{"name":"upvarcapture"}}],[11,"eq","","",256,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",256,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"fmt","","",218,{"inputs":[{"name":"upvarborrow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",218,{"inputs":[{"name":"upvarborrow"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",218,{"inputs":[{"name":"upvarborrow"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",218,{"inputs":[{"name":"upvarborrow"}],"output":{"name":"upvarborrow"}}],[11,"eq","","",218,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",218,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"is_bound","","",254,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",254,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"fmt","","",219,{"inputs":[{"name":"freeregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",219,{"inputs":[{"name":"freeregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",219,{"inputs":[{"name":"freeregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",219,null],[11,"cmp","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"option"}}],[11,"lt","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"eq","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",219,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"clone","","",219,{"inputs":[{"name":"freeregion"}],"output":{"name":"freeregion"}}],[11,"fmt","","",257,{"inputs":[{"name":"boundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",257,{"inputs":[{"name":"boundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",257,{"inputs":[{"name":"boundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",257,null],[11,"cmp","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"lt","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"eq","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"clone","","",257,{"inputs":[{"name":"boundregion"}],"output":{"name":"boundregion"}}],[11,"fmt","","",258,{"inputs":[{"name":"sty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",258,null],[11,"eq","","",258,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"clone","","",258,{"inputs":[{"name":"sty"}],"output":{"name":"sty"}}],[11,"fmt","","",220,{"inputs":[{"name":"tytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",220,null],[11,"eq","","",220,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"ne","","",220,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"clone","","",220,{"inputs":[{"name":"tytrait"}],"output":{"name":"tytrait"}}],[11,"principal_def_id","","",220,{"inputs":[{"name":"tytrait"}],"output":{"name":"defid"}}],[11,"principal_trait_ref_with_self_ty","","Object types don't have a self-type specified. Therefore, when\nwe convert the principal trait-ref into a normal trait-ref,\nyou must give *some* self-type. A common choice is `mk_err()`\nor some skolemized type.",220,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"ty"}],"output":{"name":"polytraitref"}}],[11,"projection_bounds_with_self_ty","","",220,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"ty"}],"output":{"name":"vec"}}],[11,"fmt","","",221,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",221,null],[11,"eq","","",221,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",221,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",221,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"self_ty","","",285,{"inputs":[{"name":"polytraitref"}],"output":{"name":"ty"}}],[11,"def_id","","",285,{"inputs":[{"name":"polytraitref"}],"output":{"name":"defid"}}],[11,"substs","","",285,{"inputs":[{"name":"polytraitref"}],"output":{"name":"substs"}}],[11,"input_types","","",285,null],[11,"to_poly_trait_predicate","","",285,{"inputs":[{"name":"polytraitref"}],"output":{"name":"polytraitpredicate"}}],[11,"fmt","","",286,{"inputs":[{"name":"binder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",286,null],[11,"eq","","",286,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",286,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"clone","","",286,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a\nrisky thing to do because it's easy to get confused about\ndebruijn indices and the like. It is usually better to\ndischarge the binder using `no_late_bound_regions` or\n`replace_late_bound_regions` or something like\nthat. `skip_binder` is only valid when you are either\nextracting data that has nothing to do with bound regions, you\nare doing some sort of test that does not involve bound\nregions, or you are being very careful about your depth\naccounting.",286,{"inputs":[{"name":"binder"}],"output":{"name":"t"}}],[11,"as_ref","","",286,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",286,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",286,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"eq","","",259,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"clone","","",259,{"inputs":[{"name":"intvarvalue"}],"output":{"name":"intvarvalue"}}],[11,"fmt","","",260,{"inputs":[{"name":"terr_vstore_kind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",260,{"inputs":[{"name":"terr_vstore_kind"}],"output":{"name":"terr_vstore_kind"}}],[11,"fmt","","",222,{"inputs":[{"name":"expected_found"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",222,{"inputs":[{"name":"expected_found"}],"output":{"name":"expected_found"}}],[11,"fmt","","",261,{"inputs":[{"name":"type_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",261,{"inputs":[{"name":"type_err"}],"output":{"name":"type_err"}}],[11,"fmt","","",223,{"inputs":[{"name":"parambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",223,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"hash","","",223,null],[11,"eq","","",223,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"ne","","",223,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"fmt","","",224,{"inputs":[{"name":"existentialbounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",224,{"inputs":[{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"hash","","",224,null],[11,"eq","","",224,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"ne","","",224,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"fmt","","",262,{"inputs":[{"name":"builtinbound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",262,null],[11,"decode","","",262,{"inputs":[{"name":"builtinbound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",262,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"ne","","",262,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"encode","","",262,{"inputs":[{"name":"builtinbound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",262,{"inputs":[{"name":"builtinbound"}],"output":{"name":"builtinbound"}}],[11,"to_usize","","",262,{"inputs":[{"name":"builtinbound"}],"output":{"name":"usize"}}],[11,"from_usize","","",262,{"inputs":[{"name":"builtinbound"},{"name":"usize"}],"output":{"name":"builtinbound"}}],[11,"hash","","",225,null],[11,"eq","","",225,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",225,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"clone","","",225,{"inputs":[{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"hash","","",226,null],[11,"eq","","",226,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",226,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"clone","","",226,{"inputs":[{"name":"intvid"}],"output":{"name":"intvid"}}],[11,"hash","","",227,null],[11,"eq","","",227,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",227,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"clone","","",227,{"inputs":[{"name":"floatvid"}],"output":{"name":"floatvid"}}],[11,"hash","","",228,null],[11,"decode","","",228,{"inputs":[{"name":"regionvid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",228,{"inputs":[{"name":"regionvid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",228,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",228,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"clone","","",228,{"inputs":[{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"hash","","",263,null],[11,"eq","","",263,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",263,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"clone","","",263,{"inputs":[{"name":"inferty"}],"output":{"name":"inferty"}}],[11,"fmt","","",264,{"inputs":[{"name":"unconstrainednumeric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",264,null],[11,"eq","","",264,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"ne","","",264,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"decode","","",264,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",264,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",264,{"inputs":[{"name":"unconstrainednumeric"}],"output":{"name":"unconstrainednumeric"}}],[11,"fmt","","",265,{"inputs":[{"name":"inferregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",265,null],[11,"decode","","",265,{"inputs":[{"name":"inferregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",265,{"inputs":[{"name":"inferregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",265,{"inputs":[{"name":"inferregion"}],"output":{"name":"inferregion"}}],[11,"eq","","",265,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"fmt","","",225,{"inputs":[{"name":"tyvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",226,{"inputs":[{"name":"intvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",227,{"inputs":[{"name":"floatvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",228,{"inputs":[{"name":"regionvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",213,{"inputs":[{"name":"fnsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",263,{"inputs":[{"name":"inferty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",259,{"inputs":[{"name":"intvarvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",266,{"inputs":[{"name":"objectlifetimedefault"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",266,{"inputs":[{"name":"objectlifetimedefault"}],"output":{"name":"objectlifetimedefault"}}],[11,"fmt","","",229,{"inputs":[{"name":"typeparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",229,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"typeparameterdef"}}],[11,"fmt","","",230,{"inputs":[{"name":"regionparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",230,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"regionparameterdef"}}],[11,"decode","","",230,{"inputs":[{"name":"regionparameterdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",230,{"inputs":[{"name":"regionparameterdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"to_early_bound_region","","",230,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"to_bound_region","","",230,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"boundregion"}}],[11,"fmt","","",231,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",231,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"empty","","",231,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_empty","","",231,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"has_type_params","","",231,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"has_region_params","","",231,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"fmt","","",232,{"inputs":[{"name":"genericpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",232,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"empty","","",232,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",232,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_supertrait","","",232,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"polytraitref"}],"output":{"name":"instantiatedpredicates"}}],[11,"fmt","","",267,{"inputs":[{"name":"predicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",267,null],[11,"eq","","",267,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",267,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"clone","","",267,{"inputs":[{"name":"predicate"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substituion suitable for going from a\npoly-trait-ref to supertraits that must hold if that\npoly-trait-ref holds. This is slightly different from a normal\nsubstitution in terms of what happens with bound regions.  See\nlengthy comment below for details.",267,{"inputs":[{"name":"predicate"},{"name":"ctxt"},{"name":"polytraitref"}],"output":{"name":"predicate"}}],[11,"fmt","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",233,null],[11,"eq","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",233,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"traitpredicate"}}],[11,"def_id","","",233,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"defid"}}],[11,"input_types","","",233,null],[11,"self_ty","","",233,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"ty"}}],[11,"def_id","","",287,{"inputs":[{"name":"polytraitpredicate"}],"output":{"name":"defid"}}],[11,"fmt","","",288,{"inputs":[{"name":"equatepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",288,null],[11,"eq","","",288,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",288,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",288,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"equatepredicate"}}],[11,"fmt","","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",289,null],[11,"eq","","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"clone","","",289,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"outlivespredicate"}}],[11,"fmt","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",234,null],[11,"eq","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",234,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"projectionpredicate"}}],[11,"item_name","","",290,{"inputs":[{"name":"polyprojectionpredicate"}],"output":{"name":"name"}}],[11,"sort_key","","",290,null],[11,"fmt","","",235,{"inputs":[{"name":"projectionty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",235,null],[11,"eq","","",235,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",235,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"clone","","",235,{"inputs":[{"name":"projectionty"}],"output":{"name":"projectionty"}}],[11,"sort_key","","",235,null],[11,"to_poly_trait_ref","alloc::rc","",102,{"inputs":[{"name":"rc"}],"output":{"name":"polytraitref"}}],[11,"to_poly_trait_ref","rustc::middle::ty","",287,{"inputs":[{"name":"polytraitpredicate"}],"output":{"name":"polytraitref"}}],[11,"to_poly_trait_ref","","",290,{"inputs":[{"name":"polyprojectionpredicate"}],"output":{"name":"polytraitref"}}],[11,"as_predicate","alloc::rc","",102,{"inputs":[{"name":"rc"}],"output":{"name":"predicate"}}],[11,"as_predicate","rustc::middle::ty","",285,{"inputs":[{"name":"polytraitref"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",291,{"inputs":[{"name":"polyequatepredicate"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",292,{"inputs":[{"name":"polyregionoutlivespredicate"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",293,{"inputs":[{"name":"polytypeoutlivespredicate"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",290,{"inputs":[{"name":"polyprojectionpredicate"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all\ncases this is skipping over a binder, so late-bound regions\nwith depth 0 are bound by the predicate.",267,{"inputs":[{"name":"predicate"}],"output":{"name":"intoiter"}}],[11,"has_escaping_regions","","",267,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"to_opt_poly_trait_ref","","",267,{"inputs":[{"name":"predicate"}],"output":{"name":"option"}}],[11,"fmt","","",236,{"inputs":[{"name":"instantiatedpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",236,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",236,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"has_escaping_regions","","",236,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"is_empty","","",236,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"new","","",221,{"inputs":[{"name":"traitref"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",221,{"inputs":[{"name":"traitref"}],"output":{"name":"ty"}}],[11,"input_types","","",221,null],[11,"clone","","",237,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"with_caller_bounds","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"vec"}],"output":{"name":"parameterenvironment"}}],[11,"for_item","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"parameterenvironment"}}],[11,"fmt","","",238,{"inputs":[{"name":"typescheme"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"typescheme"}],"output":{"name":"typescheme"}}],[11,"clone","","",240,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"decode","","",268,{"inputs":[{"name":"closurekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",268,{"inputs":[{"name":"closurekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",268,{"inputs":[{"name":"closurekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ne","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"cmp","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"option"}}],[11,"lt","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"le","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"gt","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ge","","",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"clone","","",268,{"inputs":[{"name":"closurekind"}],"output":{"name":"closurekind"}}],[11,"trait_did","","",268,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind\nmust also implement `other`.",268,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"mk_substs","","",209,{"inputs":[{"name":"ctxt"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"safe_to_unsafe_fn_ty","","Create an unsafe fn ty based on a safe fn ty.",209,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"ty"}}],[11,"mk_bare_fn","","",209,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"mk_region","","",209,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"region"}}],[11,"closure_kind","","",209,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"closurekind"}}],[11,"closure_type","","",209,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"type_parameter_def","","",209,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"typeparameterdef"}}],[11,"pat_contains_ref_binding","","",209,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"arm_contains_ref_binding","","",209,{"inputs":[{"name":"ctxt"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"walk","","Iterator that walks `self` and any types reachable from\n`self`, in depth-first order. Note that just walks the types\nthat appear in `self`, it does not descend into the fields of\nstructs or variants. For example:",210,{"inputs":[{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence\n`Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]`\n(but not `i32`, like `walk`).",210,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[11,"as_opt_param_ty","","",210,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[11,"is_param","","",210,{"inputs":[{"name":"tys"},{"name":"paramspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"new","","",214,{"inputs":[{"name":"paramty"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"paramty"}}],[11,"for_self","","",214,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"for_def","","",214,{"inputs":[{"name":"paramty"},{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",214,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"ty"}}],[11,"is_self","","",214,{"inputs":[{"name":"paramty"}],"output":{"name":"bool"}}],[11,"empty","","",240,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"is_noop","","",240,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"bool"}}],[11,"empty","","",223,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"clone","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"when","","",241,{"inputs":[{"name":"typecontents"},{"name":"bool"}],"output":{"name":"typecontents"}}],[11,"intersects","","",241,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_managed","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_owned","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"is_sized","","",241,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"interior_param","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsafe","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsized","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"needs_drop","","",241,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"owned_pointer","","Includes only those bits that still apply when indirected through a `Box` pointer",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"reference","","Includes only those bits that still apply when indirected through a reference (`&`)",241,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"managed_pointer","","Includes only those bits that still apply when indirected through a managed pointer (`@`)",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"unsafe_pointer","","Includes only those bits that still apply when indirected through an unsafe pointer (`*`)",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"union","","",241,null],[11,"has_dtor","","",241,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[6,"Output","","",null,null],[11,"bitor","","",241,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","","",null,null],[11,"bitand","","",241,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","","",null,null],[11,"sub","","",241,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"fmt","","",241,{"inputs":[{"name":"typecontents"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",269,{"inputs":[{"name":"representability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"option"}}],[11,"lt","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",269,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"clone","","",269,{"inputs":[{"name":"representability"}],"output":{"name":"representability"}}],[11,"clone","","",270,{"inputs":[{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"repr","","",261,{"inputs":[{"name":"type_err"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",242,{"inputs":[{"name":"variantinfo"}],"output":{"name":"variantinfo"}}],[11,"from_ast_variant","","Creates a new VariantInfo from the corresponding ast representation.",242,{"inputs":[{"name":"variantinfo"},{"name":"ctxt"},{"name":"variant"},{"name":"disr"}],"output":{"name":"variantinfo"}}],[11,"clone","","",271,{"inputs":[{"name":"dtorkind"}],"output":{"name":"dtorkind"}}],[11,"is_present","","",271,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"has_drop_flag","","",271,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"clone","","",243,{"inputs":[{"name":"closureupvar"}],"output":{"name":"closureupvar"}}],[11,"to_string","","",248,{"inputs":[{"name":"variance"}],"output":{"name":"str"}}],[11,"from_mutbl","","",255,{"inputs":[{"name":"borrowkind"},{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow\nkind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a\nmutability that is stronger than necessary so that it at least *would permit* the borrow in\nquestion.",255,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",255,{"inputs":[{"name":"borrowkind"}],"output":{"name":"str"}}],[11,"is_method_call","","",209,{"inputs":[{"name":"ctxt"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"upvar_capture","","",209,{"inputs":[{"name":"ctxt"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"node_ty","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"nodeid"}],"output":{"name":"mcresult"}}],[11,"expr_ty_adjusted","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"expr"}],"output":{"name":"mcresult"}}],[11,"node_method_ty","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"node_method_origin","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"adjustments","","",237,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"refcell"}}],[11,"is_method_call","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"nodeid"}],"output":{"name":"bool"}}],[11,"temporary_scope","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"upvar_capture","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"type_moves_by_default","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"param_env","","",237,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"closure_kind","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"}],"output":{"name":"option"}}],[11,"closure_type","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"closure_upvars","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[11,"fmt","","",272,{"inputs":[{"name":"explicitselfcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",272,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"ne","","",272,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"clone","","",272,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"explicitselfcategory"}}],[11,"decode","","",244,{"inputs":[{"name":"freevar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",244,{"inputs":[{"name":"freevar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",244,{"inputs":[{"name":"freevar"}],"output":{"name":"freevar"}}],[11,"is_identity","","",249,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"bool"}}],[11,"is_identity","","",201,{"inputs":[{"name":"autoderefref"}],"output":{"name":"bool"}}],[11,"new","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",215,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"repr","","",249,{"inputs":[{"name":"autoadjustment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",201,{"inputs":[{"name":"autoderefref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",250,{"inputs":[{"name":"autoref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",220,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",267,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",252,{"inputs":[{"name":"vtable_origin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",273,{"inputs":[{"name":"copyimplementationerror"}],"output":{"name":"copyimplementationerror"}}],[11,"has_regions_escaping_depth","","",294,{"inputs":[{"name":"ty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",162,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",238,{"inputs":[{"name":"typescheme"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",254,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",232,{"inputs":[{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",267,{"inputs":[{"name":"predicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::traits","",172,{"inputs":[{"name":"obligation"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",221,{"inputs":[{"name":"traitref"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",164,{"inputs":[{"name":"regionsubsts"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",286,{"inputs":[{"name":"binder"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",288,{"inputs":[{"name":"equatepredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",235,{"inputs":[{"name":"projectionty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"repr","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"has_projection_types","collections::vec","",295,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",167,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",212,{"inputs":[{"name":"closurety"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",243,{"inputs":[{"name":"closureupvar"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",236,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",267,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",233,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",288,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",254,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",289,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",234,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",235,{"inputs":[{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",294,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",221,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",162,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"has_projection_types","core::option","",296,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::rc","",102,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::boxed","",297,{"inputs":[{"name":"box"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",286,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",253,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",213,{"inputs":[{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",194,{"inputs":[{"name":"field"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",211,{"inputs":[{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"references_error","","",286,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"references_error","alloc::rc","",102,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"references_error","rustc::middle::ty","",233,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",234,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",221,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"references_error","","",294,{"inputs":[{"name":"ty"}],"output":{"name":"bool"}}],[11,"references_error","","",267,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"references_error","","",289,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",288,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",254,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"repr","","",212,{"inputs":[{"name":"closurety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",243,{"inputs":[{"name":"closureupvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",194,{"inputs":[{"name":"field"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",266,{"inputs":[{"name":"objectlifetimedefault"},{"name":"ctxt"}],"output":{"name":"string"}}],[0,"ty_fold","rustc::middle","Generalized type folding mechanism. The setup is a bit convoluted\nbut allows for convenient usage. Let T be an instance of some\n\"foldable type\" (one which implements `TypeFoldable`) and F be an\ninstance of a \"folder\" (a type which implements `TypeFolder`). Then\nthe setup is intended to be:",null,null],[3,"BottomUpFolder","rustc::middle::ty_fold","",null,null],[12,"tcx","","",298,null],[12,"fldop","","",298,null],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component\ntypes and all regions that occur *free* within it.",null,null],[3,"RegionEraser","","",null,null],[5,"super_fold_binder","","",null,{"inputs":[{"name":"t"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"super_fold_ty","","",null,{"inputs":[{"name":"t"},{"name":"ty"}],"output":{"name":"ty"}}],[5,"super_fold_substs","","",null,{"inputs":[{"name":"t"},{"name":"substs"}],"output":{"name":"substs"}}],[5,"super_fold_fn_sig","","",null,{"inputs":[{"name":"t"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[5,"super_fold_output","","",null,{"inputs":[{"name":"t"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[5,"super_fold_bare_fn_ty","","",null,{"inputs":[{"name":"t"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[5,"super_fold_closure_ty","","",null,{"inputs":[{"name":"t"},{"name":"closurety"}],"output":{"name":"closurety"}}],[5,"super_fold_trait_ref","","",null,{"inputs":[{"name":"t"},{"name":"traitref"}],"output":{"name":"traitref"}}],[5,"super_fold_mt","","",null,{"inputs":[{"name":"t"},{"name":"mt"}],"output":{"name":"mt"}}],[5,"super_fold_existential_bounds","","",null,{"inputs":[{"name":"t"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[5,"super_fold_autoref","","",null,{"inputs":[{"name":"t"},{"name":"autoref"}],"output":{"name":"autoref"}}],[5,"super_fold_item_substs","","",null,{"inputs":[{"name":"t"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[5,"collect_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"vec"}}],[5,"fold_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"},{"name":"f"}],"output":{"name":"t"}}],[5,"erase_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"t"}}],[5,"shift_region","","",null,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"region"}}],[5,"shift_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"t"}],"output":{"name":"t"}}],[8,"TypeFoldable","","The TypeFoldable trait is implemented for every type that can be folded.\nBasically, every type that has a corresponding method in TypeFolder.",null,null],[10,"fold_with","","",299,{"inputs":[{"name":"typefoldable"},{"name":"f"}],"output":{"name":"self"}}],[8,"TypeFolder","","The TypeFolder trait defines the actual *folding*. There is a\nmethod defined for every foldable type. Each of these has a\ndefault implementation that does an \"identity\" fold. Within each\nidentity fold, it should invoke `foo.fold_with(self)` to fold each\nsub-item.",null,null],[10,"tcx","","",300,{"inputs":[{"name":"typefolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","Invoked by the `super_*` routines when we enter a region\nbinding level (for example, when entering a function\nsignature). This is used by clients that want to track the\nDebruijn index nesting level.",300,{"inputs":[{"name":"typefolder"}],"output":null}],[11,"exit_region_binder","","Invoked by the `super_*` routines when we exit a region\nbinding level. This is used by clients that want to\ntrack the Debruijn index nesting level.",300,{"inputs":[{"name":"typefolder"}],"output":null}],[11,"fold_binder","","",300,{"inputs":[{"name":"typefolder"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_ty","","",300,{"inputs":[{"name":"typefolder"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"fold_mt","","",300,{"inputs":[{"name":"typefolder"},{"name":"mt"}],"output":{"name":"mt"}}],[11,"fold_trait_ref","","",300,{"inputs":[{"name":"typefolder"},{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fold_substs","","",300,{"inputs":[{"name":"typefolder"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"fold_fn_sig","","",300,{"inputs":[{"name":"typefolder"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"fold_output","","",300,{"inputs":[{"name":"typefolder"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"fold_bare_fn_ty","","",300,{"inputs":[{"name":"typefolder"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fold_closure_ty","","",300,{"inputs":[{"name":"typefolder"},{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fold_region","","",300,{"inputs":[{"name":"typefolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_existential_bounds","","",300,{"inputs":[{"name":"typefolder"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"fold_autoref","","",300,{"inputs":[{"name":"typefolder"},{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fold_item_substs","","",300,{"inputs":[{"name":"typefolder"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","syntax::ast","",301,{"inputs":[{"name":"unsafety"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"fold_with","syntax::abi","",302,{"inputs":[{"name":"abi"},{"name":"f"}],"output":{"name":"abi"}}],[11,"fold_with","core::option","",296,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"fold_with","alloc::rc","",102,{"inputs":[{"name":"rc"},{"name":"f"}],"output":{"name":"rc"}}],[11,"fold_with","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"f"}],"output":{"name":"box"}}],[11,"fold_with","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"fold_with","rustc::middle::ty","",286,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"fold_with","syntax::owned_slice","",303,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"fold_with","rustc::middle::subst","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"fold_with","rustc::middle::ty_fold","",294,{"inputs":[{"name":"ty"},{"name":"f"}],"output":{"name":"ty"}}],[11,"fold_with","rustc::middle::ty","",211,{"inputs":[{"name":"barefnty"},{"name":"f"}],"output":{"name":"barefnty"}}],[11,"fold_with","","",212,{"inputs":[{"name":"closurety"},{"name":"f"}],"output":{"name":"closurety"}}],[11,"fold_with","","",197,{"inputs":[{"name":"mt"},{"name":"f"}],"output":{"name":"mt"}}],[11,"fold_with","","",253,{"inputs":[{"name":"fnoutput"},{"name":"f"}],"output":{"name":"fnoutput"}}],[11,"fold_with","","",213,{"inputs":[{"name":"fnsig"},{"name":"f"}],"output":{"name":"fnsig"}}],[11,"fold_with","","",221,{"inputs":[{"name":"traitref"},{"name":"f"}],"output":{"name":"traitref"}}],[11,"fold_with","","",194,{"inputs":[{"name":"field"},{"name":"f"}],"output":{"name":"field"}}],[11,"fold_with","","",254,{"inputs":[{"name":"region"},{"name":"f"}],"output":{"name":"region"}}],[11,"fold_with","rustc::middle::subst","",162,{"inputs":[{"name":"substs"},{"name":"f"}],"output":{"name":"substs"}}],[11,"fold_with","rustc::middle::ty","",240,{"inputs":[{"name":"itemsubsts"},{"name":"f"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","","",250,{"inputs":[{"name":"autoref"},{"name":"f"}],"output":{"name":"autoref"}}],[11,"fold_with","","",251,{"inputs":[{"name":"methodorigin"},{"name":"f"}],"output":{"name":"methodorigin"}}],[11,"fold_with","","",252,{"inputs":[{"name":"vtable_origin"},{"name":"f"}],"output":{"name":"vtable_origin"}}],[11,"fold_with","rustc::middle::ty_fold","",304,{"inputs":[{"name":"builtinbounds"},{"name":"f"}],"output":{"name":"builtinbounds"}}],[11,"fold_with","rustc::middle::ty","",224,{"inputs":[{"name":"existentialbounds"},{"name":"f"}],"output":{"name":"existentialbounds"}}],[11,"fold_with","","",223,{"inputs":[{"name":"parambounds"},{"name":"f"}],"output":{"name":"parambounds"}}],[11,"fold_with","","",229,{"inputs":[{"name":"typeparameterdef"},{"name":"f"}],"output":{"name":"typeparameterdef"}}],[11,"fold_with","","",266,{"inputs":[{"name":"objectlifetimedefault"},{"name":"f"}],"output":{"name":"objectlifetimedefault"}}],[11,"fold_with","","",230,{"inputs":[{"name":"regionparameterdef"},{"name":"f"}],"output":{"name":"regionparameterdef"}}],[11,"fold_with","","",231,{"inputs":[{"name":"generics"},{"name":"f"}],"output":{"name":"generics"}}],[11,"fold_with","","",232,{"inputs":[{"name":"genericpredicates"},{"name":"f"}],"output":{"name":"genericpredicates"}}],[11,"fold_with","","",267,{"inputs":[{"name":"predicate"},{"name":"f"}],"output":{"name":"predicate"}}],[11,"fold_with","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"f"}],"output":{"name":"projectionpredicate"}}],[11,"fold_with","","",235,{"inputs":[{"name":"projectionty"},{"name":"f"}],"output":{"name":"projectionty"}}],[11,"fold_with","","",236,{"inputs":[{"name":"instantiatedpredicates"},{"name":"f"}],"output":{"name":"instantiatedpredicates"}}],[11,"fold_with","rustc::middle::traits","",172,{"inputs":[{"name":"obligation"},{"name":"f"}],"output":{"name":"obligation"}}],[11,"fold_with","","",175,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"fold_with","","",176,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fold_with","","",177,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"fold_with","","",191,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"fold_with","","",178,{"inputs":[{"name":"vtableobjectdata"},{"name":"f"}],"output":{"name":"vtableobjectdata"}}],[11,"fold_with","rustc::middle::ty","",288,{"inputs":[{"name":"equatepredicate"},{"name":"f"}],"output":{"name":"equatepredicate"}}],[11,"fold_with","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"f"}],"output":{"name":"traitpredicate"}}],[11,"fold_with","","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"f"}],"output":{"name":"outlivespredicate"}}],[11,"fold_with","","",243,{"inputs":[{"name":"closureupvar"},{"name":"f"}],"output":{"name":"closureupvar"}}],[11,"fold_with","","",237,{"inputs":[{"name":"parameterenvironment"},{"name":"f"}],"output":{"name":"parameterenvironment"}}],[11,"tcx","rustc::middle::ty_fold","",298,{"inputs":[{"name":"bottomupfolder"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",298,{"inputs":[{"name":"bottomupfolder"},{"name":"ty"}],"output":{"name":"ty"}}],[11,"new","","",305,{"inputs":[{"name":"regionfolder"},{"name":"ctxt"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",305,{"inputs":[{"name":"regionfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",305,{"inputs":[{"name":"regionfolder"}],"output":null}],[11,"exit_region_binder","","",305,{"inputs":[{"name":"regionfolder"}],"output":null}],[11,"fold_region","","",305,{"inputs":[{"name":"regionfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"tcx","","",306,{"inputs":[{"name":"regioneraser"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",306,{"inputs":[{"name":"regioneraser"},{"name":"region"}],"output":{"name":"region"}}],[0,"ty_match","rustc::middle","",null,null],[3,"Match","rustc::middle::ty_match","A type \"A\" *matches* \"B\" if the fresh types in B could be\nsubstituted with values so as to make it equal to A. Matching is\nintended to be used only on freshened types, and it basically\nindicates if the non-freshened versions of A and B could have been\nunified.",null,null],[11,"new","","",307,{"inputs":[{"name":"match"},{"name":"ctxt"}],"output":{"name":"match"}}],[11,"tag","","",307,{"inputs":[{"name":"match"}],"output":{"name":"str"}}],[11,"tcx","","",307,{"inputs":[{"name":"match"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",307,{"inputs":[{"name":"match"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",307,{"inputs":[{"name":"match"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[11,"regions","","",307,{"inputs":[{"name":"match"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"tys","","",307,{"inputs":[{"name":"match"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"binders","","",307,{"inputs":[{"name":"match"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[0,"ty_relate","rustc::middle","Generalized type relating mechanism. A type relation R relates a\npair of values (A, B). A and B are usually types or regions but\ncan be other things. Examples of type relations are subtyping,\ntype equality, etc.",null,null],[5,"super_relate_tys","rustc::middle::ty_relate","The main \"type relation\" routine. Note that this does not handle\ninference artifacts, so you should filter those out before calling\nit.",null,{"inputs":[{"name":"r"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[5,"expected_found","","",null,{"inputs":[{"name":"r"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[5,"expected_found_bool","","",null,{"inputs":[{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[6,"RelateResult","","",null,null],[8,"TypeRelation","","",null,null],[10,"tcx","","",308,{"inputs":[{"name":"typerelation"}],"output":{"name":"ctxt"}}],[10,"tag","","Returns a static string we can use for printouts.",308,{"inputs":[{"name":"typerelation"}],"output":{"name":"str"}}],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the\nrelation. Just affects error messages.",308,{"inputs":[{"name":"typerelation"}],"output":{"name":"bool"}}],[11,"relate","","Generic relation routine suitable for most anything.",308,{"inputs":[{"name":"typerelation"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",308,{"inputs":[{"name":"typerelation"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"relateresult"}}],[10,"tys","","",308,{"inputs":[{"name":"typerelation"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[10,"regions","","",308,{"inputs":[{"name":"typerelation"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[10,"binders","","",308,{"inputs":[{"name":"typerelation"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[8,"Relate","","",null,null],[10,"relate","","",309,{"inputs":[{"name":"relate"},{"name":"r"},{"name":"self"},{"name":"self"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty","",197,{"inputs":[{"name":"mt"},{"name":"r"},{"name":"mt"},{"name":"mt"}],"output":{"name":"relateresult"}}],[11,"relate","","",211,{"inputs":[{"name":"barefnty"},{"name":"r"},{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"relateresult"}}],[11,"relate","","",213,{"inputs":[{"name":"fnsig"},{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"relateresult"}}],[11,"relate","syntax::ast","",301,{"inputs":[{"name":"unsafety"},{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"relateresult"}}],[11,"relate","syntax::abi","",302,{"inputs":[{"name":"abi"},{"name":"r"},{"name":"abi"},{"name":"abi"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty","",235,{"inputs":[{"name":"projectionty"},{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"relateresult"}}],[11,"relate","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"r"},{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"relateresult"}}],[11,"relate","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"r"},{"name":"vec"},{"name":"vec"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty","",224,{"inputs":[{"name":"existentialbounds"},{"name":"r"},{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty_relate","",304,{"inputs":[{"name":"builtinbounds"},{"name":"r"},{"name":"builtinbounds"},{"name":"builtinbounds"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty","",221,{"inputs":[{"name":"traitref"},{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty_relate","",294,{"inputs":[{"name":"ty"},{"name":"r"},{"name":"ty"},{"name":"ty"}],"output":{"name":"relateresult"}}],[11,"relate","rustc::middle::ty","",254,{"inputs":[{"name":"region"},{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"name":"relateresult"}}],[11,"relate","","",286,{"inputs":[{"name":"binder"},{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"name":"relateresult"}}],[11,"relate","alloc::rc","",102,{"inputs":[{"name":"rc"},{"name":"r"},{"name":"rc"},{"name":"rc"}],"output":{"name":"relateresult"}}],[11,"relate","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"r"},{"name":"box"},{"name":"box"}],"output":{"name":"relateresult"}}],[0,"ty_walk","rustc::middle","An iterator over the type substructure.",null,null],[3,"TypeWalker","rustc::middle::ty_walk","",null,null],[5,"walk_shallow","","",null,{"inputs":[{"name":"ty"}],"output":{"name":"intoiter"}}],[11,"new","","",310,{"inputs":[{"name":"typewalker"},{"name":"ty"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type\nreturned by `next()`.",310,{"inputs":[{"name":"typewalker"}],"output":null}],[6,"Item","","",null,null],[11,"next","","",310,{"inputs":[{"name":"typewalker"}],"output":{"name":"option"}}],[0,"weak_lang_items","rustc::middle","Validity checking for weak lang items",null,null],[5,"check_crate","rustc::middle::weak_lang_items","Checks the crate for usage of weak lang items, returning a vector of all the\nlanguage items required by this crate, but not defined yet.",null,{"inputs":[{"name":"crate"},{"name":"session"},{"name":"languageitems"}],"output":null}],[5,"link_name","","",null,null],[0,"metadata","rustc","",null,null],[0,"common","rustc::metadata","",null,null],[3,"LinkMeta","rustc::metadata::common","",null,null],[12,"crate_name","","",311,null],[12,"crate_hash","","",311,null],[4,"astencode_tag","","",null,null],[13,"tag_ast","","",312,null],[13,"tag_tree","","",312,null],[13,"tag_id_range","","",312,null],[13,"tag_table","","",312,null],[13,"tag_table_def","","",312,null],[13,"tag_table_node_type","","",312,null],[13,"tag_table_item_subst","","",312,null],[13,"tag_table_freevars","","",312,null],[13,"tag_table_tcache","","",312,null],[13,"tag_table_param_defs","","",312,null],[13,"tag_table_mutbl","","",312,null],[13,"tag_table_last_use","","",312,null],[13,"tag_table_spill","","",312,null],[13,"tag_table_method_map","","",312,null],[13,"tag_table_vtable_map","","",312,null],[13,"tag_table_adjustments","","",312,null],[13,"tag_table_moves_map","","",312,null],[13,"tag_table_capture_map","","",312,null],[13,"tag_table_closure_tys","","",312,null],[13,"tag_table_closure_kinds","","",312,null],[13,"tag_table_upvar_capture_map","","",312,null],[13,"tag_table_capture_modes","","",312,null],[13,"tag_table_object_cast_map","","",312,null],[13,"tag_table_const_qualif","","",312,null],[17,"tag_items","","",null,null],[17,"tag_paths_data_name","","",null,null],[17,"tag_def_id","","",null,null],[17,"tag_items_data","","",null,null],[17,"tag_items_data_item","","",null,null],[17,"tag_items_data_item_family","","",null,null],[17,"tag_items_data_item_type","","",null,null],[17,"tag_items_data_item_symbol","","",null,null],[17,"tag_items_data_item_variant","","",null,null],[17,"tag_items_data_parent_item","","",null,null],[17,"tag_items_data_item_is_tuple_struct_ctor","","",null,null],[17,"tag_index","","",null,null],[17,"tag_index_buckets","","",null,null],[17,"tag_index_buckets_bucket","","",null,null],[17,"tag_index_buckets_bucket_elt","","",null,null],[17,"tag_index_table","","",null,null],[17,"tag_meta_item_name_value","","",null,null],[17,"tag_meta_item_name","","",null,null],[17,"tag_meta_item_value","","",null,null],[17,"tag_attributes","","",null,null],[17,"tag_attribute","","",null,null],[17,"tag_meta_item_word","","",null,null],[17,"tag_meta_item_list","","",null,null],[17,"tag_crate_deps","","",null,null],[17,"tag_crate_dep","","",null,null],[17,"tag_crate_hash","","",null,null],[17,"tag_crate_crate_name","","",null,null],[17,"tag_crate_dep_crate_name","","",null,null],[17,"tag_crate_dep_hash","","",null,null],[17,"tag_mod_impl","","",null,null],[17,"tag_item_trait_item","","",null,null],[17,"tag_item_trait_ref","","",null,null],[17,"tag_disr_val","","",null,null],[17,"tag_path","","",null,null],[17,"tag_path_len","","",null,null],[17,"tag_path_elem_mod","","",null,null],[17,"tag_path_elem_name","","",null,null],[17,"tag_item_field","","",null,null],[17,"tag_item_field_origin","","",null,null],[17,"tag_item_variances","","",null,null],[17,"tag_item_impl_item","","",null,null],[17,"tag_item_trait_method_explicit_self","","",null,null],[17,"tag_items_data_item_reexport","","",null,null],[17,"tag_items_data_item_reexport_def_id","","",null,null],[17,"tag_items_data_item_reexport_name","","",null,null],[17,"tag_item_trait_item_sort","","",null,null],[17,"tag_item_trait_parent_sort","","",null,null],[17,"tag_item_impl_type_basename","","",null,null],[17,"tag_crate_triple","","",null,null],[17,"tag_dylib_dependency_formats","","",null,null],[17,"tag_lang_items","","",null,null],[17,"tag_lang_items_item","","",null,null],[17,"tag_lang_items_item_id","","",null,null],[17,"tag_lang_items_item_node_id","","",null,null],[17,"tag_lang_items_missing","","",null,null],[17,"tag_item_unnamed_field","","",null,null],[17,"tag_items_data_item_visibility","","",null,null],[17,"tag_item_method_tps","","",null,null],[17,"tag_item_method_fty","","",null,null],[17,"tag_mod_child","","",null,null],[17,"tag_misc_info","","",null,null],[17,"tag_misc_info_crate_items","","",null,null],[17,"tag_item_method_provided_source","","",null,null],[17,"tag_item_impl_vtables","","",null,null],[17,"tag_impls","","",null,null],[17,"tag_impls_impl","","",null,null],[17,"tag_items_data_item_inherent_impl","","",null,null],[17,"tag_items_data_item_extension_impl","","",null,null],[17,"tag_native_libraries","","",null,null],[17,"tag_native_libraries_lib","","",null,null],[17,"tag_native_libraries_name","","",null,null],[17,"tag_native_libraries_kind","","",null,null],[17,"tag_plugin_registrar_fn","","",null,null],[17,"tag_method_argument_names","","",null,null],[17,"tag_method_argument_name","","",null,null],[17,"tag_reachable_extern_fns","","",null,null],[17,"tag_reachable_extern_fn_id","","",null,null],[17,"tag_items_data_item_stability","","",null,null],[17,"tag_items_data_item_repr","","",null,null],[17,"tag_struct_fields","","",null,null],[17,"tag_struct_field","","",null,null],[17,"tag_struct_field_id","","",null,null],[17,"tag_attribute_is_sugared_doc","","",null,null],[17,"tag_items_data_region","","",null,null],[17,"tag_region_param_def","","",null,null],[17,"tag_region_param_def_ident","","",null,null],[17,"tag_region_param_def_def_id","","",null,null],[17,"tag_region_param_def_space","","",null,null],[17,"tag_region_param_def_index","","",null,null],[17,"tag_type_param_def","","",null,null],[17,"tag_item_generics","","",null,null],[17,"tag_method_ty_generics","","",null,null],[17,"tag_predicate","","",null,null],[17,"tag_predicate_space","","",null,null],[17,"tag_predicate_data","","",null,null],[17,"tag_unsafety","","",null,null],[17,"tag_associated_type_names","","",null,null],[17,"tag_associated_type_name","","",null,null],[17,"tag_polarity","","",null,null],[17,"tag_macro_defs","","",null,null],[17,"tag_macro_def","","",null,null],[17,"tag_macro_def_body","","",null,null],[17,"tag_paren_sugar","","",null,null],[17,"tag_codemap","","",null,null],[17,"tag_codemap_filemap","","",null,null],[17,"tag_item_super_predicates","","",null,null],[17,"tag_defaulted_trait","","",null,null],[11,"eq","","",312,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"ne","","",312,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"clone","","",312,{"inputs":[{"name":"astencode_tag"}],"output":{"name":"astencode_tag"}}],[11,"from_u32","","",312,{"inputs":[{"name":"astencode_tag"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","","",311,{"inputs":[{"name":"linkmeta"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",311,{"inputs":[{"name":"linkmeta"}],"output":{"name":"linkmeta"}}],[0,"tyencode","rustc::metadata","",null,null],[3,"ctxt","rustc::metadata::tyencode","",null,null],[12,"diag","","",313,null],[12,"ds","","",313,null],[12,"tcx","","",313,null],[12,"abbrevs","","",313,null],[3,"ty_abbrev","","",null,null],[5,"enc_ty","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"ty"}],"output":null}],[5,"enc_substs","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"substs"}],"output":null}],[5,"enc_region","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"region"}],"output":null}],[5,"enc_trait_ref","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"traitref"}],"output":null}],[5,"enc_bare_fn_ty","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"barefnty"}],"output":null}],[5,"enc_closure_ty","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"closurety"}],"output":null}],[5,"enc_builtin_bounds","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"builtinbounds"}],"output":null}],[5,"enc_existential_bounds","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"existentialbounds"}],"output":null}],[5,"enc_bounds","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"parambounds"}],"output":null}],[5,"enc_region_bounds","","",null,null],[5,"enc_type_param_def","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"typeparameterdef"}],"output":null}],[5,"enc_predicate","","",null,{"inputs":[{"name":"encoder"},{"name":"ctxt"},{"name":"predicate"}],"output":null}],[6,"abbrev_map","","",null,null],[0,"tydecode","rustc::metadata","",null,null],[3,"PState","rustc::metadata::tydecode","",null,null],[4,"DefIdSource","","",null,null],[13,"NominalType","","",314,null],[13,"TypeWithId","","",314,null],[13,"TypeParameter","","",314,null],[13,"RegionParameter","","",314,null],[13,"ClosureSource","","",314,null],[5,"parse_name","","",null,{"inputs":[{"name":"pstate"},{"name":"char"}],"output":{"name":"name"}}],[5,"parse_state_from_data","","",null,null],[5,"parse_ty_closure_data","","",null,null],[5,"parse_ty_data","","",null,null],[5,"parse_region_data","","",null,null],[5,"parse_bare_fn_ty_data","","",null,null],[5,"parse_trait_ref_data","","",null,null],[5,"parse_substs_data","","",null,null],[5,"parse_bounds_data","","",null,null],[5,"parse_existential_bounds_data","","",null,null],[5,"parse_builtin_bounds_data","","",null,null],[5,"parse_def_id","","",null,null],[5,"parse_predicate_data","","",null,null],[5,"parse_predicate","","",null,{"inputs":[{"name":"pstate"},{"name":"f"}],"output":{"name":"predicate"}}],[5,"parse_type_param_def_data","","",null,null],[11,"fmt","","",314,{"inputs":[{"name":"defidsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",314,{"inputs":[{"name":"defidsource"}],"output":{"name":"defidsource"}}],[0,"encoder","rustc::metadata","",null,null],[3,"EncodeParams","rustc::metadata::encoder","",null,null],[12,"diag","","",315,null],[12,"tcx","","",315,null],[12,"reexports","","",315,null],[12,"item_symbols","","",315,null],[12,"link_meta","","",315,null],[12,"cstore","","",315,null],[12,"encode_inlined_item","","",315,null],[12,"reachable","","",315,null],[3,"EncodeContext","","",null,null],[12,"diag","","",316,null],[12,"tcx","","",316,null],[12,"reexports","","",316,null],[12,"item_symbols","","",316,null],[12,"link_meta","","",316,null],[12,"cstore","","",316,null],[12,"encode_inlined_item","","",316,null],[12,"type_abbrevs","","",316,null],[12,"reachable","","",316,null],[4,"InlinedItemRef","","A borrowed version of `ast::InlinedItem`.",null,null],[13,"IIItemRef","","",317,null],[13,"IITraitItemRef","","",317,null],[13,"IIImplItemRef","","",317,null],[13,"IIForeignRef","","",317,null],[5,"encode_def_id","","",null,{"inputs":[{"name":"encoder"},{"name":"defid"}],"output":null}],[5,"def_to_string","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"string"}}],[5,"write_closure_type","","",null,{"inputs":[{"name":"encodecontext"},{"name":"encoder"},{"name":"closurety"}],"output":null}],[5,"write_type","","",null,{"inputs":[{"name":"encodecontext"},{"name":"encoder"},{"name":"ty"}],"output":null}],[5,"write_trait_ref","","",null,{"inputs":[{"name":"encodecontext"},{"name":"encoder"},{"name":"traitref"}],"output":null}],[5,"write_region","","",null,{"inputs":[{"name":"encodecontext"},{"name":"encoder"},{"name":"region"}],"output":null}],[5,"encode_metadata","","",null,{"inputs":[{"name":"encodeparams"},{"name":"crate"}],"output":{"name":"vec"}}],[5,"encoded_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"string"}}],[6,"EncodeInlinedItem","","",null,null],[17,"metadata_encoding_version","","",null,null],[0,"decoder","rustc::metadata","",null,null],[3,"CrateDep","rustc::metadata::decoder","",null,null],[12,"cnum","","",318,null],[12,"name","","",318,null],[12,"hash","","",318,null],[4,"DefLike","","",null,null],[13,"DlDef","","",319,null],[13,"DlImpl","","",319,null],[13,"DlField","","",319,null],[5,"maybe_find_item","","",null,{"inputs":[{"name":"nodeid"},{"name":"doc"}],"output":{"name":"option"}}],[5,"item_type","","",null,{"inputs":[{"name":"defid"},{"name":"doc"},{"name":"ctxt"},{"name":"cmd"}],"output":{"name":"ty"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_type","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"typescheme"}}],[5,"get_stability","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"vtable_res"}}],[5,"get_symbol","","",null,null],[5,"each_lang_item","","Iterates over the language items in the given crate.",null,{"inputs":[{"name":"cmd"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"},{"name":"g"},{"name":"f"}],"output":null}],[5,"each_top_level_item_of_crate","","Iterates over all the top-level crate items.",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"g"},{"name":"f"}],"output":null}],[5,"get_item_path","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"cmd"},{"name":"ctxt"},{"name":"nodeid"},{"name":"decodeinlineditem"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"identinterner"},{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns the def IDs of all the items in the given implementation.",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"implortraititem"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","If node_id is the constructor of a tuple struct, retrieve the NodeId of\nthe actual type definition, otherwise, return None",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"cmd"}],"output":{"name":"hashmap"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"rc"},{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_crate_attributes","","",null,null],[5,"get_crate_deps","","",null,null],[5,"maybe_get_crate_hash","","",null,null],[5,"get_crate_hash","","",null,null],[5,"maybe_get_crate_name","","",null,null],[5,"get_crate_triple","","",null,null],[5,"get_crate_name","","",null,null],[5,"list_crate_metadata","","",null,null],[5,"translate_def_id","","",null,{"inputs":[{"name":"cmd"},{"name":"defid"}],"output":{"name":"defid"}}],[5,"each_impl","","",null,{"inputs":[{"name":"cmd"},{"name":"f"}],"output":null}],[5,"each_implementation_for_type","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"f"}],"output":null}],[5,"each_implementation_for_trait","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"f"}],"output":null}],[5,"get_trait_of_item","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"cmd"}],"output":{"name":"vec"}}],[5,"get_plugin_registrar_fn","","",null,null],[5,"each_exported_macro","","",null,null],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"cmd"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"cmd"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"cmd"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"cmd"},{"name":"nodeid"}],"output":{"name":"bool"}}],[5,"get_imported_filemaps","","",null,null],[6,"Cmd","","",null,null],[6,"DecodeInlinedItem","","",null,null],[11,"fmt","","",319,{"inputs":[{"name":"deflike"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",319,{"inputs":[{"name":"deflike"}],"output":{"name":"deflike"}}],[11,"clone","","",318,{"inputs":[{"name":"cratedep"}],"output":{"name":"cratedep"}}],[0,"creader","rustc::metadata","Validates all used crates and extern libraries and loads their metadata",null,null],[3,"CrateReader","rustc::metadata::creader","",null,null],[5,"validate_crate_name","","",null,{"inputs":[{"name":"option"},{"name":"str"},{"name":"option"}],"output":null}],[11,"visit_item","","",320,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":null}],[11,"new","","",320,{"inputs":[{"name":"cratereader"},{"name":"session"}],"output":{"name":"cratereader"}}],[11,"read_crates","","",320,{"inputs":[{"name":"cratereader"},{"name":"crate"}],"output":null}],[11,"read_exported_macros","","Read exported macros.",320,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path and symbol name.",320,{"inputs":[{"name":"cratereader"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[0,"cstore","rustc::metadata","",null,null],[3,"ImportedFileMap","rustc::metadata::cstore","Holds information about a codemap::FileMap imported from another crate.\nSee creader::import_codemap() for more information.",null,null],[12,"original_start_pos","","This FileMap's byte-offset within the codemap of its original crate",321,null],[12,"original_end_pos","","The end of this FileMap within the codemap of its original crate",321,null],[12,"translated_filemap","","The imported FileMap's representation within the local codemap",321,null],[3,"crate_metadata","","",null,null],[12,"name","","",322,null],[12,"data","","",322,null],[12,"cnum_map","","",322,null],[12,"cnum","","",322,null],[12,"codemap_import_info","","",322,null],[12,"span","","",322,null],[3,"CrateSource","","",null,null],[12,"dylib","","",323,null],[12,"rlib","","",323,null],[12,"cnum","","",323,null],[3,"CStore","","",null,null],[12,"intr","","",324,null],[4,"MetadataBlob","","",null,null],[13,"MetadataVec","","",325,null],[13,"MetadataArchive","","",325,null],[4,"LinkagePreference","","",null,null],[13,"RequireDynamic","","",326,null],[13,"RequireStatic","","",326,null],[4,"NativeLibraryKind","","",null,null],[13,"NativeStatic","","",327,null],[13,"NativeFramework","","",327,null],[13,"NativeUnknown","","",327,null],[6,"cnum_map","","",null,null],[11,"clone","","",326,{"inputs":[{"name":"linkagepreference"}],"output":{"name":"linkagepreference"}}],[11,"eq","","",326,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"ne","","",326,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"fmt","","",326,{"inputs":[{"name":"linkagepreference"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",327,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"ne","","",327,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"clone","","",327,{"inputs":[{"name":"nativelibrarykind"}],"output":{"name":"nativelibrarykind"}}],[11,"from_u32","","",327,{"inputs":[{"name":"nativelibrarykind"},{"name":"u32"}],"output":{"name":"option"}}],[11,"clone","","",323,{"inputs":[{"name":"cratesource"}],"output":{"name":"cratesource"}}],[11,"eq","","",323,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",323,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"new","","",324,{"inputs":[{"name":"cstore"},{"name":"rc"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","",324,{"inputs":[{"name":"cstore"}],"output":{"name":"cratenum"}}],[11,"get_crate_data","","",324,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"rc"}}],[11,"get_crate_hash","","",324,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"svh"}}],[11,"set_crate_data","","",324,{"inputs":[{"name":"cstore"},{"name":"cratenum"},{"name":"rc"}],"output":null}],[11,"iter_crate_data","","",324,{"inputs":[{"name":"cstore"},{"name":"i"}],"output":null}],[11,"iter_crate_data_origins","","Like `iter_crate_data`, but passes source paths (if available) as well.",324,{"inputs":[{"name":"cstore"},{"name":"i"}],"output":null}],[11,"add_used_crate_source","","",324,{"inputs":[{"name":"cstore"},{"name":"cratesource"}],"output":null}],[11,"get_used_crate_source","","",324,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"option"}}],[11,"reset","","",324,{"inputs":[{"name":"cstore"}],"output":null}],[11,"get_used_crates","","",324,{"inputs":[{"name":"cstore"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[11,"add_used_library","","",324,{"inputs":[{"name":"cstore"},{"name":"string"},{"name":"nativelibrarykind"}],"output":null}],[11,"get_used_libraries","","",324,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_used_link_args","","",324,{"inputs":[{"name":"cstore"},{"name":"str"}],"output":null}],[11,"get_used_link_args","","",324,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_extern_mod_stmt_cnum","","",324,{"inputs":[{"name":"cstore"},{"name":"nodeid"},{"name":"cratenum"}],"output":null}],[11,"find_extern_mod_stmt_cnum","","",324,{"inputs":[{"name":"cstore"},{"name":"nodeid"}],"output":{"name":"option"}}],[11,"data","","",322,null],[11,"name","","",322,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"string"}}],[11,"hash","","",322,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"svh"}}],[11,"as_slice","","",325,null],[0,"csearch","rustc::metadata","",null,null],[3,"MethodInfo","rustc::metadata::csearch","",null,null],[12,"name","","",328,null],[12,"def_id","","",328,null],[12,"vis","","",328,null],[4,"FoundAst","","",null,null],[13,"Found","","",329,null],[13,"FoundParent","","",329,null],[13,"NotFound","","",329,null],[5,"get_symbol","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"string"}}],[5,"each_lang_item","","Iterates over all the language items in the given crate.",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"f"}],"output":null}],[5,"each_top_level_item_of_crate","","Iterates over each top-level crate item.",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"},{"name":"f"}],"output":null}],[5,"get_item_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"decodeinlineditem"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns information about the given implementation.",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"hashmap"}}],[5,"get_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vtable_res"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"vec"}}],[5,"each_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"},{"name":"f"}],"output":null}],[5,"each_implementation_for_type","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"f"}],"output":null}],[5,"each_implementation_for_trait","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"f"}],"output":null}],[5,"get_trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), returns the ID of\nthe trait that the method belongs to. Otherwise, returns `None`.",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"cstore"},{"name":"cratenum"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_stability","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"is_staged_api","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"clone","","",328,{"inputs":[{"name":"methodinfo"}],"output":{"name":"methodinfo"}}],[0,"loader","rustc::metadata","Finds crate binaries and loads their metadata",null,null],[3,"CrateMismatch","rustc::metadata::loader","",null,null],[3,"Context","","",null,null],[12,"sess","","",330,null],[12,"span","","",330,null],[12,"ident","","",330,null],[12,"crate_name","","",330,null],[12,"hash","","",330,null],[12,"target","","",330,null],[12,"triple","","",330,null],[12,"filesearch","","",330,null],[12,"root","","",330,null],[12,"rejected_via_hash","","",330,null],[12,"rejected_via_triple","","",330,null],[12,"rejected_via_kind","","",330,null],[12,"should_match_name","","",330,null],[3,"Library","","",null,null],[12,"dylib","","",331,null],[12,"rlib","","",331,null],[12,"metadata","","",331,null],[3,"ArchiveMetadata","","",null,null],[3,"CratePaths","","",null,null],[12,"ident","","",332,null],[12,"dylib","","",332,null],[12,"rlib","","",332,null],[5,"note_crate_name","","",null,{"inputs":[{"name":"spanhandler"},{"name":"str"}],"output":null}],[5,"meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"read_meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"list_file_metadata","","",null,{"inputs":[{"name":"bool"},{"name":"path"},{"name":"write"}],"output":{"name":"result"}}],[11,"maybe_load_library_crate","","",330,{"inputs":[{"name":"context"}],"output":{"name":"option"}}],[11,"load_library_crate","","",330,{"inputs":[{"name":"context"}],"output":{"name":"library"}}],[11,"report_load_errs","","",330,{"inputs":[{"name":"context"}],"output":null}],[11,"as_slice","","",333,null],[0,"filesearch","rustc::metadata","",null,null],[3,"FileSearch","rustc::metadata::filesearch","",null,null],[12,"sysroot","","",334,null],[12,"search_paths","","",334,null],[12,"triple","","",334,null],[12,"kind","","",334,null],[4,"FileMatch","","",null,null],[13,"FileMatches","","",335,null],[13,"FileDoesntMatch","","",335,null],[5,"relative_target_lib_path","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"get_or_default_sysroot","","",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"get_rust_path","","Returns RUST_PATH as a string, without default paths added",null,{"inputs":[],"output":{"name":"option"}}],[5,"rust_path","","Returns the value of RUST_PATH, as a list\nof Paths. Includes default entries for, if they exist:\n$HOME/.rust\nDIR/.rust for any DIR that's the current working directory\nor an ancestor of it",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustlibdir","","",null,{"inputs":[],"output":{"name":"string"}}],[11,"clone","","",335,{"inputs":[{"name":"filematch"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",334,{"inputs":[{"name":"filesearch"},{"name":"f"}],"output":null}],[11,"get_lib_path","","",334,{"inputs":[{"name":"filesearch"}],"output":{"name":"pathbuf"}}],[11,"search","","",334,{"inputs":[{"name":"filesearch"},{"name":"f"}],"output":null}],[11,"new","","",334,{"inputs":[{"name":"filesearch"},{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",334,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"get_tools_search_paths","","",334,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[0,"macro_import","rustc::metadata","Used by `rustc` when loading a crate with exported macros.",null,null],[5,"read_macro_defs","rustc::metadata::macro_import","Read exported macros.",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"vec"}}],[6,"MacroSelection","","",null,null],[0,"session","rustc","",null,null],[3,"Session","rustc::session","",null,null],[12,"target","","",336,null],[12,"host","","",336,null],[12,"opts","","",336,null],[12,"cstore","","",336,null],[12,"parse_sess","","",336,null],[12,"entry_fn","","",336,null],[12,"entry_type","","",336,null],[12,"plugin_registrar_fn","","",336,null],[12,"default_sysroot","","",336,null],[12,"local_crate_source_file","","",336,null],[12,"working_dir","","",336,null],[12,"lint_store","","",336,null],[12,"lints","","",336,null],[12,"plugin_llvm_passes","","",336,null],[12,"crate_types","","",336,null],[12,"crate_metadata","","",336,null],[12,"features","","",336,null],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive\noperations such as auto-dereference and monomorphization.",336,null],[12,"can_print_warnings","","",336,null],[5,"build_session","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"registry"}],"output":{"name":"session"}}],[5,"build_session_","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"spanhandler"}],"output":{"name":"session"}}],[5,"expect","","",null,{"inputs":[{"name":"session"},{"name":"option"},{"name":"m"}],"output":{"name":"t"}}],[5,"early_error","","",null,{"inputs":[{"name":"str"}],"output":null}],[5,"early_warn","","",null,{"inputs":[{"name":"str"}],"output":null}],[0,"config","","Contains infrastructure for configuring the compiler, including parsing\ncommand line options.",null,null],[3,"Config","rustc::session::config","",null,null],[12,"target","","",337,null],[12,"int_type","","",337,null],[12,"uint_type","","",337,null],[3,"Options","","",null,null],[12,"crate_types","","",338,null],[12,"gc","","",338,null],[12,"optimize","","",338,null],[12,"debug_assertions","","",338,null],[12,"debuginfo","","",338,null],[12,"lint_opts","","",338,null],[12,"describe_lints","","",338,null],[12,"output_types","","",338,null],[12,"search_paths","","",338,null],[12,"libs","","",338,null],[12,"maybe_sysroot","","",338,null],[12,"target_triple","","",338,null],[12,"cfg","","",338,null],[12,"test","","",338,null],[12,"parse_only","","",338,null],[12,"no_trans","","",338,null],[12,"treat_err_as_bug","","",338,null],[12,"no_analysis","","",338,null],[12,"debugging_opts","","",338,null],[12,"write_dependency_info","","Whether to write dependency files. It's (enabled, optional filename).",338,null],[12,"prints","","",338,null],[12,"cg","","",338,null],[12,"color","","",338,null],[12,"show_span","","",338,null],[12,"externs","","",338,null],[12,"crate_name","","",338,null],[12,"alt_std_name","","An optional name to use as the crate for std during std injection,\nwritten `extern crate std = \"name\"`. Default to \"std\". Used by\nout-of-tree drivers.",338,null],[12,"unstable_features","","Indicates how the compiler should treat unstable features",338,null],[3,"OutputFilenames","","",null,null],[12,"out_directory","","",339,null],[12,"out_filestem","","",339,null],[12,"single_output_file","","",339,null],[12,"extra","","",339,null],[3,"CodegenOptions","","",null,null],[12,"ar","","",340,null],[12,"linker","","",340,null],[12,"link_args","","",340,null],[12,"lto","","",340,null],[12,"target_cpu","","",340,null],[12,"target_feature","","",340,null],[12,"passes","","",340,null],[12,"llvm_args","","",340,null],[12,"save_temps","","",340,null],[12,"rpath","","",340,null],[12,"no_prepopulate_passes","","",340,null],[12,"no_vectorize_loops","","",340,null],[12,"no_vectorize_slp","","",340,null],[12,"soft_float","","",340,null],[12,"prefer_dynamic","","",340,null],[12,"no_integrated_as","","",340,null],[12,"no_redzone","","",340,null],[12,"relocation_model","","",340,null],[12,"code_model","","",340,null],[12,"metadata","","",340,null],[12,"extra_filename","","",340,null],[12,"codegen_units","","",340,null],[12,"remark","","",340,null],[12,"no_stack_check","","",340,null],[12,"debuginfo","","",340,null],[12,"opt_level","","",340,null],[12,"debug_assertions","","",340,null],[3,"DebuggingOptions","","",null,null],[12,"verbose","","",341,null],[12,"time_passes","","",341,null],[12,"count_llvm_insns","","",341,null],[12,"time_llvm_passes","","",341,null],[12,"trans_stats","","",341,null],[12,"asm_comments","","",341,null],[12,"no_verify","","",341,null],[12,"borrowck_stats","","",341,null],[12,"no_landing_pads","","",341,null],[12,"debug_llvm","","",341,null],[12,"count_type_sizes","","",341,null],[12,"meta_stats","","",341,null],[12,"print_link_args","","",341,null],[12,"gc","","",341,null],[12,"print_llvm_passes","","",341,null],[12,"ast_json","","",341,null],[12,"ast_json_noexpand","","",341,null],[12,"ls","","",341,null],[12,"save_analysis","","",341,null],[12,"print_move_fragments","","",341,null],[12,"flowgraph_print_loans","","",341,null],[12,"flowgraph_print_moves","","",341,null],[12,"flowgraph_print_assigns","","",341,null],[12,"flowgraph_print_all","","",341,null],[12,"print_region_graph","","",341,null],[12,"parse_only","","",341,null],[12,"no_trans","","",341,null],[12,"treat_err_as_bug","","",341,null],[12,"no_analysis","","",341,null],[12,"extra_plugins","","",341,null],[12,"unstable_options","","",341,null],[12,"print_enum_sizes","","",341,null],[12,"force_overflow_checks","","",341,null],[12,"force_dropflag_checks","","",341,null],[3,"RustcOptGroup","","",null,null],[12,"opt_group","","",342,null],[12,"stability","","",342,null],[4,"OptLevel","","",null,null],[13,"No","","",343,null],[13,"Less","","",343,null],[13,"Default","","",343,null],[13,"Aggressive","","",343,null],[4,"DebugInfoLevel","","",null,null],[13,"NoDebugInfo","","",344,null],[13,"LimitedDebugInfo","","",344,null],[13,"FullDebugInfo","","",344,null],[4,"OutputType","","",null,null],[13,"OutputTypeBitcode","","",345,null],[13,"OutputTypeAssembly","","",345,null],[13,"OutputTypeLlvmAssembly","","",345,null],[13,"OutputTypeObject","","",345,null],[13,"OutputTypeExe","","",345,null],[13,"OutputTypeDepInfo","","",345,null],[4,"UnstableFeatures","","",null,null],[13,"Disallow","","Hard errors for unstable features are active, as on\nbeta/stable channels.",346,null],[13,"Default","","Use the default lint levels",346,null],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time\nduring the build that feature-related lints are set to warn or above\nbecause the build turns on warnings-as-errors and uses lots of unstable\nfeatures. As a result, this this is always required for building Rust\nitself.",346,null],[4,"PrintRequest","","",null,null],[13,"FileNames","","",347,null],[13,"Sysroot","","",347,null],[13,"CrateName","","",347,null],[4,"Input","","",null,null],[13,"File","","Load source from file",348,null],[13,"Str","","The string is the source",348,null],[4,"EntryFnType","","",null,null],[13,"EntryMain","","",349,null],[13,"EntryStart","","",349,null],[13,"EntryNone","","",349,null],[4,"CrateType","","",null,null],[13,"CrateTypeExecutable","","",350,null],[13,"CrateTypeDylib","","",350,null],[13,"CrateTypeRlib","","",350,null],[13,"CrateTypeStaticlib","","",350,null],[4,"Passes","","",null,null],[13,"SomePasses","","",351,null],[13,"AllPasses","","",351,null],[4,"OptionStability","","",null,null],[13,"Stable","","",352,null],[13,"Unstable","","",352,null],[5,"host_triple","","",null,{"inputs":[],"output":{"name":"str"}}],[5,"basic_options","","Some reasonable defaults",null,{"inputs":[],"output":{"name":"options"}}],[5,"basic_codegen_options","","",null,{"inputs":[],"output":{"name":"codegenoptions"}}],[5,"build_codegen_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"codegenoptions"}}],[5,"basic_debugging_options","","",null,{"inputs":[],"output":{"name":"debuggingoptions"}}],[5,"build_debugging_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"debuggingoptions"}}],[5,"default_lib_output","","",null,{"inputs":[],"output":{"name":"cratetype"}}],[5,"default_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"crateconfig"}}],[5,"append_configuration","","",null,{"inputs":[{"name":"crateconfig"},{"name":"internedstring"}],"output":null}],[5,"build_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"crateconfig"}}],[5,"build_target_config","","",null,{"inputs":[{"name":"options"},{"name":"spanhandler"}],"output":{"name":"config"}}],[5,"short_optgroups","","Returns the \"short\" subset of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"optgroups","","Returns all of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options,\nincluding metadata for each option, such as whether the option is\npart of the stable long-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for\neach option, such as whether the option is part of the stable\nlong-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"parse_cfgspecs","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"crateconfig"}}],[5,"build_session_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"options"}}],[5,"get_unstable_features_setting","","",null,{"inputs":[],"output":{"name":"unstablefeatures"}}],[5,"parse_crate_types_from_list","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"result"}}],[6,"CodegenSetter","","",null,null],[6,"DebuggingSetter","","",null,null],[17,"CG_OPTIONS","","",null,null],[17,"DB_OPTIONS","","",null,null],[11,"eq","","",343,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"ne","","",343,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"clone","","",343,{"inputs":[{"name":"optlevel"}],"output":{"name":"optlevel"}}],[11,"eq","","",344,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"clone","","",344,{"inputs":[{"name":"debuginfolevel"}],"output":{"name":"debuginfolevel"}}],[11,"cmp","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",345,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",345,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[11,"clone","","",338,{"inputs":[{"name":"options"}],"output":{"name":"options"}}],[11,"clone","","",346,{"inputs":[{"name":"unstablefeatures"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",347,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"ne","","",347,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"clone","","",347,{"inputs":[{"name":"printrequest"}],"output":{"name":"printrequest"}}],[11,"filestem","","",348,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[11,"clone","","",339,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"outputfilenames"}}],[11,"path","","",339,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","",339,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",339,{"inputs":[{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",339,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"string"}}],[11,"eq","","",349,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"ne","","",349,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"clone","","",349,{"inputs":[{"name":"entryfntype"}],"output":{"name":"entryfntype"}}],[11,"fmt","","",350,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",350,null],[11,"cmp","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"clone","","",350,{"inputs":[{"name":"cratetype"}],"output":{"name":"cratetype"}}],[11,"partial_cmp","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"option"}}],[11,"lt","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"le","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"gt","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ge","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"eq","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ne","","",350,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"clone","","",351,{"inputs":[{"name":"passes"}],"output":{"name":"passes"}}],[11,"is_empty","","",351,{"inputs":[{"name":"passes"}],"output":{"name":"bool"}}],[11,"clone","","",340,{"inputs":[{"name":"codegenoptions"}],"output":{"name":"codegenoptions"}}],[11,"clone","","",341,{"inputs":[{"name":"debuggingoptions"}],"output":{"name":"debuggingoptions"}}],[11,"fmt","","",352,{"inputs":[{"name":"optionstability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",352,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"ne","","",352,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"clone","","",352,{"inputs":[{"name":"optionstability"}],"output":{"name":"optionstability"}}],[11,"eq","","",342,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"ne","","",342,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"clone","","",342,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"rustcoptgroup"}}],[11,"is_stable","","",342,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"fmt","","",350,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"search_paths","rustc::session","",null,null],[3,"SearchPaths","rustc::session::search_paths","",null,null],[3,"Iter","","",null,null],[4,"PathKind","","",null,null],[13,"Native","","",353,null],[13,"Crate","","",353,null],[13,"Dependency","","",353,null],[13,"Framework","","",353,null],[13,"ExternFlag","","",353,null],[13,"All","","",353,null],[11,"fmt","","",354,{"inputs":[{"name":"searchpaths"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",354,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",353,{"inputs":[{"name":"pathkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",353,{"inputs":[{"name":"pathkind"}],"output":{"name":"pathkind"}}],[11,"eq","","",353,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"ne","","",353,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",354,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"add_path","","",354,{"inputs":[{"name":"searchpaths"},{"name":"str"}],"output":null}],[11,"iter","","",354,{"inputs":[{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",355,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"span_fatal","rustc::session","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_fatal_with_code","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"fatal","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"span_err","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_err_with_code","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"err","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"err_count","","",336,{"inputs":[{"name":"session"}],"output":{"name":"usize"}}],[11,"has_errors","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",336,{"inputs":[{"name":"session"}],"output":null}],[11,"span_warn","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_warn_with_code","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":null}],[11,"warn","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"opt_span_warn","","",336,{"inputs":[{"name":"session"},{"name":"option"},{"name":"str"}],"output":null}],[11,"span_note","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_end_note","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"},{"name":"string"}],"output":null}],[11,"span_help","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"fileline_note","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"fileline_help","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"note","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"help","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"opt_span_bug","","",336,{"inputs":[{"name":"session"},{"name":"option"},{"name":"str"}],"output":null}],[11,"span_bug","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"bug","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"span_unimpl","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"unimpl","","",336,{"inputs":[{"name":"session"},{"name":"str"}],"output":null}],[11,"add_lint","","",336,{"inputs":[{"name":"session"},{"name":"lint"},{"name":"nodeid"},{"name":"span"},{"name":"string"}],"output":null}],[11,"next_node_id","","",336,{"inputs":[{"name":"session"}],"output":{"name":"nodeid"}}],[11,"reserve_node_ids","","",336,{"inputs":[{"name":"session"},{"name":"nodeid"}],"output":{"name":"nodeid"}}],[11,"diagnostic","","",336,{"inputs":[{"name":"session"}],"output":{"name":"spanhandler"}}],[11,"codemap","","",336,{"inputs":[{"name":"session"}],"output":{"name":"codemap"}}],[11,"impossible_case","","",336,{"inputs":[{"name":"session"},{"name":"span"},{"name":"str"}],"output":null}],[11,"verbose","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_passes","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_type_sizes","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"trans_stats","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"meta_stats","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"asm_comments","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_verify","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"lto","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"unstable_options","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_enum_sizes","","",336,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"sysroot","","",336,{"inputs":[{"name":"session"}],"output":{"name":"path"}}],[11,"target_filesearch","","",336,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",336,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[0,"plugin","rustc","Infrastructure for compiler plugins.",null,null],[0,"registry","rustc::plugin","Used by plugin crates to tell `rustc` about the plugins they provide.",null,null],[3,"Registry","rustc::plugin::registry","Structure used to register plugins.",null,null],[12,"sess","","Compiler session. Useful if you want to emit diagnostic messages\nfrom the plugin registrar.",356,null],[11,"args","","Get the plugin's arguments, if any.",356,{"inputs":[{"name":"registry"}],"output":{"name":"vec"}}],[11,"register_syntax_extension","","Register a syntax extension of any kind.",356,{"inputs":[{"name":"registry"},{"name":"name"},{"name":"syntaxextension"}],"output":null}],[11,"register_macro","","Register a macro of the usual kind.",356,{"inputs":[{"name":"registry"},{"name":"str"},{"name":"macroexpanderfn"}],"output":null}],[11,"register_lint_pass","","Register a compiler lint pass.",356,{"inputs":[{"name":"registry"},{"name":"lintpassobject"}],"output":null}],[11,"register_lint_group","","Register a lint group.",356,{"inputs":[{"name":"registry"},{"name":"str"},{"name":"vec"}],"output":null}],[11,"register_llvm_pass","","Register an LLVM pass.",356,{"inputs":[{"name":"registry"},{"name":"str"}],"output":null}],[0,"load","rustc::plugin","Used by `rustc` when loading a plugin.",null,null],[3,"PluginRegistrar","rustc::plugin::load","",null,null],[12,"fun","","",357,null],[12,"args","","",357,null],[5,"load_plugins","","Read plugin metadata and dynamically load registrar functions.",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"option"}],"output":{"name":"vec"}}],[6,"PluginRegistrarFun","","Pointer to a registrar function.",null,null],[0,"build","rustc::plugin","Used by `rustc` when compiling a plugin crate.",null,null],[5,"find_plugin_registrar","rustc::plugin::build","Find the function marked with `#[plugin_registrar]`, if any.",null,{"inputs":[{"name":"spanhandler"},{"name":"crate"}],"output":{"name":"option"}}],[0,"lint","rustc","Lints, aka compiler warnings.",null,null],[3,"Context","rustc::lint","Context for lint checking.",null,null],[12,"tcx","","Type context we're checking in.",358,null],[12,"krate","","The crate being checked.",358,null],[12,"exported_items","","Items exported from the crate being checked.",358,null],[3,"LintStore","","Information about the registered lints.",null,null],[3,"GatherNodeLevels","","",null,null],[3,"Lint","","Specification of a single lint.",null,null],[12,"name","","A string identifier for the lint.",359,null],[12,"default_level","","Default level for the lint.",359,null],[12,"desc","","Description of the lint or the issue it detects.",359,null],[3,"LintId","","Identifies a lint known to the compiler.",null,null],[4,"Level","","Setting for how to handle a lint.",null,null],[13,"Allow","","",360,null],[13,"Warn","","",360,null],[13,"Deny","","",360,null],[13,"Forbid","","",360,null],[4,"LintSource","","How a lint level was set.",null,null],[13,"Default","","Lint is at the default level as declared\nin rustc or a plugin.",361,null],[13,"Node","","Lint level was set by an attribute.",361,null],[13,"CommandLine","","Lint level was set by a command-line flag.",361,null],[13,"ReleaseChannel","","Lint level was set by the release channel.",361,null],[5,"raw_emit_lint","","Emit a lint as a warning or an error (or not at all)\naccording to `level`.",null,{"inputs":[{"name":"session"},{"name":"lint"},{"name":"levelsource"},{"name":"option"},{"name":"str"}],"output":null}],[5,"check_crate","","Perform lint checking on a crate.",null,{"inputs":[{"name":"ctxt"},{"name":"exporteditems"}],"output":null}],[5,"gather_attrs","","Parse the lint attributes into a vector, with `Err`s for malformed lint\nattributes. Writing this as an iterator is an enormous mess.",null,null],[0,"builtin","","Some lints that are built in to the compiler.",null,null],[3,"HardwiredLints","rustc::lint::builtin","Does nothing as a lint pass, but registers some `Lint`s\nwhich are used by other parts of the compiler.",null,null],[7,"UNUSED_IMPORTS","","",null,null],[7,"UNUSED_EXTERN_CRATES","","",null,null],[7,"UNUSED_QUALIFICATIONS","","",null,null],[7,"UNKNOWN_LINTS","","",null,null],[7,"UNUSED_VARIABLES","","",null,null],[7,"UNUSED_ASSIGNMENTS","","",null,null],[7,"DEAD_CODE","","",null,null],[7,"UNREACHABLE_CODE","","",null,null],[7,"WARNINGS","","",null,null],[7,"UNUSED_FEATURES","","",null,null],[7,"STABLE_FEATURES","","",null,null],[7,"UNKNOWN_CRATE_TYPES","","",null,null],[7,"VARIANT_SIZE_DIFFERENCES","","",null,null],[7,"FAT_PTR_TRANSMUTES","","",null,null],[7,"TRIVIAL_CASTS","","",null,null],[7,"TRIVIAL_NUMERIC_CASTS","","",null,null],[11,"clone","","",362,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",362,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"lintarray"}}],[11,"new","rustc::lint","",363,{"inputs":[{"name":"lintstore"}],"output":{"name":"lintstore"}}],[11,"get_lints","","",363,null],[11,"get_lint_groups","","",363,{"inputs":[{"name":"lintstore"}],"output":{"name":"vec"}}],[11,"register_pass","","",363,{"inputs":[{"name":"lintstore"},{"name":"option"},{"name":"bool"},{"name":"lintpassobject"}],"output":null}],[11,"register_group","","",363,{"inputs":[{"name":"lintstore"},{"name":"option"},{"name":"bool"},{"name":"str"},{"name":"vec"}],"output":null}],[11,"register_renamed","","",363,{"inputs":[{"name":"lintstore"},{"name":"str"},{"name":"str"}],"output":null}],[11,"process_command_line","","",363,{"inputs":[{"name":"lintstore"},{"name":"session"}],"output":null}],[11,"sess","","Get the overall compiler `Session` object.",358,{"inputs":[{"name":"context"}],"output":{"name":"session"}}],[11,"current_level","","Get the level of `lint` at the current position of the lint\ntraversal.",358,{"inputs":[{"name":"context"},{"name":"lint"}],"output":{"name":"level"}}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",358,{"inputs":[{"name":"context"},{"name":"lint"},{"name":"str"}],"output":null}],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",358,{"inputs":[{"name":"context"},{"name":"lint"},{"name":"span"},{"name":"str"}],"output":null}],[11,"visit_item","","",358,{"inputs":[{"name":"context"},{"name":"item"}],"output":null}],[11,"visit_foreign_item","","",358,{"inputs":[{"name":"context"},{"name":"foreignitem"}],"output":null}],[11,"visit_pat","","",358,{"inputs":[{"name":"context"},{"name":"pat"}],"output":null}],[11,"visit_expr","","",358,{"inputs":[{"name":"context"},{"name":"expr"}],"output":null}],[11,"visit_stmt","","",358,{"inputs":[{"name":"context"},{"name":"stmt"}],"output":null}],[11,"visit_fn","","",358,{"inputs":[{"name":"context"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_def","","",358,{"inputs":[{"name":"context"},{"name":"structdef"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"visit_struct_field","","",358,{"inputs":[{"name":"context"},{"name":"structfield"}],"output":null}],[11,"visit_variant","","",358,{"inputs":[{"name":"context"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"visit_ty","","",358,{"inputs":[{"name":"context"},{"name":"ty"}],"output":null}],[11,"visit_ident","","",358,{"inputs":[{"name":"context"},{"name":"span"},{"name":"ident"}],"output":null}],[11,"visit_mod","","",358,{"inputs":[{"name":"context"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"visit_local","","",358,{"inputs":[{"name":"context"},{"name":"local"}],"output":null}],[11,"visit_block","","",358,{"inputs":[{"name":"context"},{"name":"block"}],"output":null}],[11,"visit_arm","","",358,{"inputs":[{"name":"context"},{"name":"arm"}],"output":null}],[11,"visit_decl","","",358,{"inputs":[{"name":"context"},{"name":"decl"}],"output":null}],[11,"visit_expr_post","","",358,{"inputs":[{"name":"context"},{"name":"expr"}],"output":null}],[11,"visit_generics","","",358,{"inputs":[{"name":"context"},{"name":"generics"}],"output":null}],[11,"visit_trait_item","","",358,{"inputs":[{"name":"context"},{"name":"traititem"}],"output":null}],[11,"visit_impl_item","","",358,{"inputs":[{"name":"context"},{"name":"implitem"}],"output":null}],[11,"visit_opt_lifetime_ref","","",358,{"inputs":[{"name":"context"},{"name":"span"},{"name":"option"}],"output":null}],[11,"visit_lifetime_ref","","",358,{"inputs":[{"name":"context"},{"name":"lifetime"}],"output":null}],[11,"visit_lifetime_def","","",358,{"inputs":[{"name":"context"},{"name":"lifetimedef"}],"output":null}],[11,"visit_explicit_self","","",358,{"inputs":[{"name":"context"},{"name":"explicitself"}],"output":null}],[11,"visit_mac","","",358,{"inputs":[{"name":"context"},{"name":"mac"}],"output":null}],[11,"visit_path","","",358,{"inputs":[{"name":"context"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"visit_attribute","","",358,{"inputs":[{"name":"context"},{"name":"attribute"}],"output":null}],[11,"visit_id","","",358,{"inputs":[{"name":"context"},{"name":"nodeid"}],"output":null}],[11,"get_lints","","",364,{"inputs":[{"name":"gathernodelevels"}],"output":{"name":"lintarray"}}],[11,"check_item","","",364,{"inputs":[{"name":"gathernodelevels"},{"name":"context"},{"name":"item"}],"output":null}],[6,"LintArray","","",null,null],[6,"LintPassObject","","A lint pass boxed up as a trait object.",null,null],[6,"LevelSource","","",null,null],[8,"LintPass","","Trait for types providing lint checks.",null,null],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",365,{"inputs":[{"name":"lintpass"}],"output":{"name":"lintarray"}}],[11,"check_crate","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"crate"}],"output":null}],[11,"check_ident","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"span"},{"name":"ident"}],"output":null}],[11,"check_mod","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"mod"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_foreign_item","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"foreignitem"}],"output":null}],[11,"check_item","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"item"}],"output":null}],[11,"check_local","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"local"}],"output":null}],[11,"check_block","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"block"}],"output":null}],[11,"check_stmt","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"stmt"}],"output":null}],[11,"check_arm","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"arm"}],"output":null}],[11,"check_pat","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"pat"}],"output":null}],[11,"check_decl","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"decl"}],"output":null}],[11,"check_expr","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"expr"}],"output":null}],[11,"check_expr_post","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"expr"}],"output":null}],[11,"check_ty","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"ty"}],"output":null}],[11,"check_generics","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"generics"}],"output":null}],[11,"check_fn","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"check_trait_item","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"traititem"}],"output":null}],[11,"check_impl_item","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"implitem"}],"output":null}],[11,"check_struct_def","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"structdef"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"check_struct_def_post","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"structdef"},{"name":"ident"},{"name":"generics"},{"name":"nodeid"}],"output":null}],[11,"check_struct_field","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"structfield"}],"output":null}],[11,"check_variant","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_variant_post","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"check_opt_lifetime_ref","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"span"},{"name":"option"}],"output":null}],[11,"check_lifetime_ref","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"lifetime"}],"output":null}],[11,"check_lifetime_def","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"lifetimedef"}],"output":null}],[11,"check_explicit_self","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"explicitself"}],"output":null}],[11,"check_mac","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"mac"}],"output":null}],[11,"check_path","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"path"},{"name":"nodeid"}],"output":null}],[11,"check_attribute","","",365,{"inputs":[{"name":"lintpass"},{"name":"context"},{"name":"attribute"}],"output":null}],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such\nas `#[allow(...)]`. Called with *all* the attributes of that node.",365,null],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",365,null],[11,"fmt","","",359,{"inputs":[{"name":"lint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",359,{"inputs":[{"name":"lint"}],"output":{"name":"lint"}}],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",359,{"inputs":[{"name":"lint"}],"output":{"name":"string"}}],[11,"clone","","",366,{"inputs":[{"name":"lintid"}],"output":{"name":"lintid"}}],[11,"eq","","",366,{"inputs":[{"name":"lintid"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",366,{"inputs":[{"name":"lintid"},{"name":"h"}],"output":null}],[11,"of","","Get the `LintId` for a `Lint`.",366,{"inputs":[{"name":"lintid"},{"name":"lint"}],"output":{"name":"lintid"}}],[11,"as_str","","Get the name of the lint.",366,{"inputs":[{"name":"lintid"}],"output":{"name":"string"}}],[11,"fmt","","",360,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"option"}}],[11,"lt","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"le","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"gt","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ge","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"eq","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",360,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",360,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"as_str","","Convert a level to a lower-case string.",360,{"inputs":[{"name":"level"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",360,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"option"}}],[11,"eq","","",361,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",361,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"clone","","",361,{"inputs":[{"name":"lintsource"}],"output":{"name":"lintsource"}}],[0,"util","rustc","",null,null],[0,"fs","rustc::util","",null,null],[5,"realpath","rustc::util::fs","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[0,"sha2","rustc::util","This module implements only the Sha256 function since that is all that is needed for internal\nuse. This implementation is not intended for external use or for any use where security is\nimportant.",null,null],[8,"Digest","rustc::util::sha2","The Digest trait specifies an interface common to digest functions, such as SHA-1 and the SHA-2\nfamily of digest functions.",null,null],[10,"input","","Provide message data.",367,null],[10,"result","","Retrieve the digest result. This method may be called multiple times.",367,null],[10,"reset","","Reset the digest. This method must be called after result() and before supplying more\ndata.",367,null],[10,"output_bits","","Get the output size in bits.",367,{"inputs":[{"name":"digest"}],"output":{"name":"usize"}}],[11,"input_str","","Convenience function that feeds a string into a digest.",367,null],[11,"result_bytes","","Convenience function that retrieves the result of a digest as a\nnewly allocated vec of bytes.",367,{"inputs":[{"name":"digest"}],"output":{"name":"vec"}}],[11,"result_str","","Convenience function that retrieves the result of a digest as a\nString in hexadecimal format.",367,{"inputs":[{"name":"digest"}],"output":{"name":"string"}}],[3,"Sha256","","The SHA-256 hash algorithm",null,null],[0,"common","rustc::util","",null,null],[3,"ErrorReported","rustc::util::common","",null,null],[3,"Indenter","","",null,null],[5,"time","","",null,{"inputs":[{"name":"bool"},{"name":"str"},{"name":"u"},{"name":"f"}],"output":{"name":"t"}}],[5,"indent","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[5,"indenter","","",null,{"inputs":[],"output":{"name":"indenter"}}],[5,"loop_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"block_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"can_reach","","K: Eq + Hash<S>, V, S, H: Hasher<S>",null,{"inputs":[{"name":"hashmap"},{"name":"t"},{"name":"t"}],"output":{"name":"bool"}}],[5,"memoized","","Memoizes a one-argument closure using the given RefCell containing\na type implementing MutableMap to serve as a cache.",null,{"inputs":[{"name":"refcell"},{"name":"t"},{"name":"f"}],"output":{"name":"u"}}],[5,"path2cstr","","",null,{"inputs":[{"name":"path"}],"output":{"name":"cstring"}}],[17,"FN_OUTPUT_NAME","","",null,null],[11,"fmt","","",368,{"inputs":[{"name":"errorreported"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",368,{"inputs":[{"name":"errorreported"}],"output":{"name":"errorreported"}}],[11,"drop","","",369,{"inputs":[{"name":"indenter"}],"output":null}],[0,"ppaux","rustc::util","",null,null],[5,"note_and_explain_region","rustc::util::ppaux","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"region"},{"name":"str"}],"output":{"name":"option"}}],[5,"explain_region_and_span","","",null,null],[5,"bound_region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"bound_region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"string"}}],[5,"region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"region"}],"output":{"name":"string"}}],[5,"mutability_to_string","","",null,{"inputs":[{"name":"mutability"}],"output":{"name":"string"}}],[5,"mt_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"string"}}],[5,"vec_map_to_string","","",null,null],[5,"ty_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"explicit_self_category_to_str","","",null,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"str"}}],[5,"parameterized","","",null,null],[5,"ty_to_short_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"string"}}],[8,"Repr","","Produces a string suitable for debugging output.",null,null],[10,"repr","","",370,{"inputs":[{"name":"repr"},{"name":"ctxt"}],"output":{"name":"string"}}],[8,"UserString","","Produces a string suitable for showing to the user.",null,null],[10,"user_string","","",371,{"inputs":[{"name":"userstring"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::option","",296,{"inputs":[{"name":"option"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ptr","",372,{"inputs":[{"name":"p"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::result","",373,{"inputs":[{"name":"result"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::rc","",102,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::owned_slice","",303,{"inputs":[{"name":"ownedslice"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",295,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::def","",71,{"inputs":[{"name":"def"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",220,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",229,{"inputs":[{"name":"typeparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",230,{"inputs":[{"name":"regionparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",210,{"inputs":[{"name":"tys"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",197,{"inputs":[{"name":"mt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",162,{"inputs":[{"name":"substs"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",167,{"inputs":[{"name":"vecperparamspace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",240,{"inputs":[{"name":"itemsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",164,{"inputs":[{"name":"regionsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::util::ppaux","",304,{"inputs":[{"name":"builtinbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",223,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",221,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",239,{"inputs":[{"name":"traitdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",374,{"inputs":[{"name":"traititem"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",149,{"inputs":[{"name":"expr"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",375,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",375,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",376,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",377,{"inputs":[{"name":"item"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",378,{"inputs":[{"name":"lifetime"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::util::ppaux","",379,{"inputs":[{"name":"stmt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",150,{"inputs":[{"name":"pat"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",257,{"inputs":[{"name":"boundregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",254,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",254,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",219,{"inputs":[{"name":"freeregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::region","",157,{"inputs":[{"name":"codeextent"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",155,{"inputs":[{"name":"destructionscopedata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",380,{"inputs":[{"name":"defid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",238,{"inputs":[{"name":"typescheme"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",231,{"inputs":[{"name":"generics"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",232,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",236,{"inputs":[{"name":"instantiatedpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",200,{"inputs":[{"name":"itemvariances"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",248,{"inputs":[{"name":"variance"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",195,{"inputs":[{"name":"method"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",41,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",41,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",40,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",381,{"inputs":[{"name":"explicitself_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",382,{"inputs":[{"name":"visibility"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",211,{"inputs":[{"name":"barefnty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",213,{"inputs":[{"name":"fnsig"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",253,{"inputs":[{"name":"fnoutput"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",205,{"inputs":[{"name":"methodcallee"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",251,{"inputs":[{"name":"methodorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",203,{"inputs":[{"name":"methodparam"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",204,{"inputs":[{"name":"methodobject"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",262,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",262,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",383,{"inputs":[{"name":"span"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","alloc::rc","",102,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",223,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",224,{"inputs":[{"name":"existentialbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::util::ppaux","",304,{"inputs":[{"name":"builtinbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",286,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",221,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::util::ppaux","",294,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","syntax::ast","",40,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::abi","",302,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",302,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",217,{"inputs":[{"name":"upvarid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",384,{"inputs":[{"name":"mutability"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",255,{"inputs":[{"name":"borrowkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",218,{"inputs":[{"name":"upvarborrow"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",256,{"inputs":[{"name":"upvarcapture"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",226,{"inputs":[{"name":"intvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",227,{"inputs":[{"name":"floatvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",228,{"inputs":[{"name":"regionvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",225,{"inputs":[{"name":"tyvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",259,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",385,{"inputs":[{"name":"intty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",386,{"inputs":[{"name":"uintty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",128,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",272,{"inputs":[{"name":"explicitselfcategory"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",214,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",214,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",286,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","std::collections::hash::map","",387,{"inputs":[{"name":"hashmap"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",289,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",288,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",288,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",233,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",234,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",235,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",235,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",267,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",301,{"inputs":[{"name":"unsafety"},{"name":"ctxt"}],"output":{"name":"string"}}],[0,"nodemap","rustc::util","An efficient hash map for node IDs",null,null],[3,"FnvHasher","rustc::util::nodemap","A speedy hash algorithm for node ids and def ids. The hashmap in\nlibcollections by default uses SipHash which isn't quite as speedy as we\nwant. In the compiler we're not really worried about DOS attempts, so we\njust default to a non-cryptographic hash.",null,null],[5,"FnvHashMap","","",null,{"inputs":[],"output":{"name":"fnvhashmap"}}],[5,"FnvHashSet","","",null,{"inputs":[],"output":{"name":"fnvhashset"}}],[5,"NodeMap","","",null,{"inputs":[],"output":{"name":"nodemap"}}],[5,"DefIdMap","","",null,{"inputs":[],"output":{"name":"defidmap"}}],[5,"NodeSet","","",null,{"inputs":[],"output":{"name":"nodeset"}}],[5,"DefIdSet","","",null,{"inputs":[],"output":{"name":"defidset"}}],[6,"FnvHashMap","","",null,null],[6,"FnvHashSet","","",null,null],[6,"NodeMap","","",null,null],[6,"DefIdMap","","",null,null],[6,"NodeSet","","",null,null],[6,"DefIdSet","","",null,null],[11,"default","","",388,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"fnvhasher"}}],[11,"write","","",388,null],[11,"finish","","",388,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"u64"}}],[0,"snapshot_vec","rustc::util","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits\nyou to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either\nto rollback to the start of the snapshot or commit those changes.",null,null],[3,"SnapshotVec","rustc::util::snapshot_vec","",null,null],[3,"Snapshot","","",null,null],[4,"UndoLog","","",null,null],[13,"OpenSnapshot","","Indicates where a snapshot started.",389,null],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",389,null],[13,"NewElem","","New variable with given index was created.",389,null],[13,"SetElem","","Variable with given index was changed *from* the given value.",389,null],[13,"Other","","Extensible set of actions",389,null],[8,"SnapshotVecDelegate","","",null,null],[16,"Value","rustc::util::snapshot_vec::SnapshotVecDelegate","",null,null],[16,"Undo","","",null,null],[10,"reverse","rustc::util::snapshot_vec","",390,{"inputs":[{"name":"snapshotvecdelegate"},{"name":"vec"},{"name":"undo"}],"output":null}],[11,"new","","",391,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"snapshotvec"}}],[11,"record","","",391,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":null}],[11,"push","","",391,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"usize"}}],[11,"get","","",391,{"inputs":[{"name":"snapshotvec"},{"name":"usize"}],"output":{"name":"d"}}],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone\nautomatically, so you should be sure call `record()` with some sort of suitable undo\naction.",391,{"inputs":[{"name":"snapshotvec"},{"name":"usize"}],"output":{"name":"d"}}],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if\na snapshot is active.",391,{"inputs":[{"name":"snapshotvec"},{"name":"usize"},{"name":"d"}],"output":null}],[11,"start_snapshot","","",391,{"inputs":[{"name":"snapshotvec"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",391,null],[11,"rollback_to","","",391,{"inputs":[{"name":"snapshotvec"},{"name":"snapshot"}],"output":null}],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",391,{"inputs":[{"name":"snapshotvec"},{"name":"snapshot"}],"output":null}],[0,"lev_distance","rustc::util","",null,null],[5,"lev_distance","rustc::util::lev_distance","",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"usize"}}],[0,"num","rustc::util","",null,null],[8,"ToPrimitive","rustc::util::num","",null,null],[10,"to_i8","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i16","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i32","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i64","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u8","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u16","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u32","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u64","","",392,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[0,"lib","rustc","",null,null],[0,"llvm","rustc::lib","",null,null],[0,"archive_ro","rustc::lib::llvm","A wrapper around LLVM's archive (.a) code",null,null],[3,"ArchiveRO","rustc::lib::llvm::archive_ro","",null,null],[0,"diagnostic","rustc::lib::llvm","LLVM diagnostic reports.",null,null],[4,"OptimizationDiagnosticKind","rustc::lib::llvm::diagnostic","",null,null],[13,"OptimizationRemark","","",1,null],[13,"OptimizationMissed","","",1,null],[13,"OptimizationAnalysis","","",1,null],[13,"OptimizationFailure","","",1,null],[3,"OptimizationDiagnostic","","",null,null],[12,"kind","","",2,null],[12,"pass_name","","",2,null],[12,"function","","",2,null],[12,"debug_loc","","",2,null],[12,"message","","",2,null],[3,"InlineAsmDiagnostic","","",null,null],[12,"cookie","","",3,null],[12,"message","","",3,null],[12,"instruction","","",3,null],[4,"Diagnostic","","",null,null],[13,"Optimization","","",4,null],[13,"InlineAsm","","",4,null],[13,"UnknownDiagnostic","","LLVM has other types that we do not wrap here.",4,null],[6,"Opcode","rustc::lib::llvm","",null,null],[6,"Bool","","",null,null],[17,"True","","",null,null],[17,"False","","",null,null],[4,"CallConv","","",null,null],[13,"CCallConv","","",5,null],[13,"FastCallConv","","",5,null],[13,"ColdCallConv","","",5,null],[13,"X86StdcallCallConv","","",5,null],[13,"X86FastcallCallConv","","",5,null],[13,"X86_64_Win64","","",5,null],[4,"Visibility","","",null,null],[13,"LLVMDefaultVisibility","","",6,null],[13,"HiddenVisibility","","",6,null],[13,"ProtectedVisibility","","",6,null],[4,"Linkage","","",null,null],[13,"ExternalLinkage","","",7,null],[13,"AvailableExternallyLinkage","","",7,null],[13,"LinkOnceAnyLinkage","","",7,null],[13,"LinkOnceODRLinkage","","",7,null],[13,"WeakAnyLinkage","","",7,null],[13,"WeakODRLinkage","","",7,null],[13,"AppendingLinkage","","",7,null],[13,"InternalLinkage","","",7,null],[13,"PrivateLinkage","","",7,null],[13,"ExternalWeakLinkage","","",7,null],[13,"CommonLinkage","","",7,null],[4,"DiagnosticSeverity","","",null,null],[13,"Error","","",8,null],[13,"Warning","","",8,null],[13,"Remark","","",8,null],[13,"Note","","",8,null],[3,"Attribute","","",null,null],[17,"ZExtAttribute","","",null,null],[17,"SExtAttribute","","",null,null],[17,"NoReturnAttribute","","",null,null],[17,"InRegAttribute","","",null,null],[17,"StructRetAttribute","","",null,null],[17,"NoUnwindAttribute","","",null,null],[17,"NoAliasAttribute","","",null,null],[17,"ByValAttribute","","",null,null],[17,"NestAttribute","","",null,null],[17,"ReadNoneAttribute","","",null,null],[17,"ReadOnlyAttribute","","",null,null],[17,"NoInlineAttribute","","",null,null],[17,"AlwaysInlineAttribute","","",null,null],[17,"OptimizeForSizeAttribute","","",null,null],[17,"StackProtectAttribute","","",null,null],[17,"StackProtectReqAttribute","","",null,null],[17,"AlignmentAttribute","","",null,null],[17,"NoCaptureAttribute","","",null,null],[17,"NoRedZoneAttribute","","",null,null],[17,"NoImplicitFloatAttribute","","",null,null],[17,"NakedAttribute","","",null,null],[17,"InlineHintAttribute","","",null,null],[17,"StackAttribute","","",null,null],[17,"ReturnsTwiceAttribute","","",null,null],[17,"UWTableAttribute","","",null,null],[17,"NonLazyBindAttribute","","",null,null],[4,"OtherAttribute","","",null,null],[13,"SanitizeAddressAttribute","","",10,null],[13,"MinSizeAttribute","","",10,null],[13,"NoDuplicateAttribute","","",10,null],[13,"StackProtectStrongAttribute","","",10,null],[13,"SanitizeThreadAttribute","","",10,null],[13,"SanitizeMemoryAttribute","","",10,null],[13,"NoBuiltinAttribute","","",10,null],[13,"ReturnedAttribute","","",10,null],[13,"ColdAttribute","","",10,null],[13,"BuiltinAttribute","","",10,null],[13,"OptimizeNoneAttribute","","",10,null],[13,"InAllocaAttribute","","",10,null],[13,"NonNullAttribute","","",10,null],[4,"SpecialAttribute","","",null,null],[13,"DereferenceableAttribute","","",11,null],[4,"AttributeSet","","",null,null],[13,"ReturnIndex","","",12,null],[13,"FunctionIndex","","",12,null],[8,"AttrHelper","","",null,null],[10,"apply_llfn","","",30,null],[10,"apply_callsite","","",30,null],[3,"AttrBuilder","","",null,null],[4,"IntPredicate","","",null,null],[13,"IntEQ","","",14,null],[13,"IntNE","","",14,null],[13,"IntUGT","","",14,null],[13,"IntUGE","","",14,null],[13,"IntULT","","",14,null],[13,"IntULE","","",14,null],[13,"IntSGT","","",14,null],[13,"IntSGE","","",14,null],[13,"IntSLT","","",14,null],[13,"IntSLE","","",14,null],[4,"RealPredicate","","",null,null],[13,"RealPredicateFalse","","",15,null],[13,"RealOEQ","","",15,null],[13,"RealOGT","","",15,null],[13,"RealOGE","","",15,null],[13,"RealOLT","","",15,null],[13,"RealOLE","","",15,null],[13,"RealONE","","",15,null],[13,"RealORD","","",15,null],[13,"RealUNO","","",15,null],[13,"RealUEQ","","",15,null],[13,"RealUGT","","",15,null],[13,"RealUGE","","",15,null],[13,"RealULT","","",15,null],[13,"RealULE","","",15,null],[13,"RealUNE","","",15,null],[13,"RealPredicateTrue","","",15,null],[4,"TypeKind","","",null,null],[13,"Void","","",16,null],[13,"Half","","",16,null],[13,"Float","","",16,null],[13,"Double","","",16,null],[13,"X86_FP80","","",16,null],[13,"FP128","","",16,null],[13,"PPC_FP128","","",16,null],[13,"Label","","",16,null],[13,"Integer","","",16,null],[13,"Function","","",16,null],[13,"Struct","","",16,null],[13,"Array","","",16,null],[13,"Pointer","","",16,null],[13,"Vector","","",16,null],[13,"Metadata","","",16,null],[13,"X86_MMX","","",16,null],[4,"AtomicBinOp","","",null,null],[13,"AtomicXchg","","",17,null],[13,"AtomicAdd","","",17,null],[13,"AtomicSub","","",17,null],[13,"AtomicAnd","","",17,null],[13,"AtomicNand","","",17,null],[13,"AtomicOr","","",17,null],[13,"AtomicXor","","",17,null],[13,"AtomicMax","","",17,null],[13,"AtomicMin","","",17,null],[13,"AtomicUMax","","",17,null],[13,"AtomicUMin","","",17,null],[4,"AtomicOrdering","","",null,null],[13,"NotAtomic","","",18,null],[13,"Unordered","","",18,null],[13,"Monotonic","","",18,null],[13,"Acquire","","",18,null],[13,"Release","","",18,null],[13,"AcquireRelease","","",18,null],[13,"SequentiallyConsistent","","",18,null],[4,"FileType","","",null,null],[13,"AssemblyFileType","","",19,null],[13,"ObjectFileType","","",19,null],[4,"MetadataType","","",null,null],[13,"MD_dbg","","",20,null],[13,"MD_tbaa","","",20,null],[13,"MD_prof","","",20,null],[13,"MD_fpmath","","",20,null],[13,"MD_range","","",20,null],[13,"MD_tbaa_struct","","",20,null],[13,"MD_invariant_load","","",20,null],[13,"MD_alias_scope","","",20,null],[13,"MD_noalias","","",20,null],[13,"MD_nontemporal","","",20,null],[13,"MD_mem_parallel_loop_access","","",20,null],[13,"MD_nonnull","","",20,null],[4,"AsmDialect","","",null,null],[13,"AD_ATT","","",21,null],[13,"AD_Intel","","",21,null],[4,"CodeGenOptLevel","","",null,null],[13,"CodeGenLevelNone","","",22,null],[13,"CodeGenLevelLess","","",22,null],[13,"CodeGenLevelDefault","","",22,null],[13,"CodeGenLevelAggressive","","",22,null],[4,"RelocMode","","",null,null],[13,"RelocDefault","","",23,null],[13,"RelocStatic","","",23,null],[13,"RelocPIC","","",23,null],[13,"RelocDynamicNoPic","","",23,null],[4,"CodeGenModel","","",null,null],[13,"CodeModelDefault","","",24,null],[13,"CodeModelJITDefault","","",24,null],[13,"CodeModelSmall","","",24,null],[13,"CodeModelKernel","","",24,null],[13,"CodeModelMedium","","",24,null],[13,"CodeModelLarge","","",24,null],[4,"DiagnosticKind","","",null,null],[13,"DK_InlineAsm","","",25,null],[13,"DK_StackSize","","",25,null],[13,"DK_DebugMetadataVersion","","",25,null],[13,"DK_SampleProfile","","",25,null],[13,"DK_OptimizationRemark","","",25,null],[13,"DK_OptimizationRemarkMissed","","",25,null],[13,"DK_OptimizationRemarkAnalysis","","",25,null],[13,"DK_OptimizationFailure","","",25,null],[4,"Module_opaque","","",null,null],[6,"ModuleRef","","",null,null],[4,"Context_opaque","","",null,null],[6,"ContextRef","","",null,null],[4,"Type_opaque","","",null,null],[6,"TypeRef","","",null,null],[4,"Value_opaque","","",null,null],[6,"ValueRef","","",null,null],[4,"Metadata_opaque","","",null,null],[6,"MetadataRef","","",null,null],[4,"BasicBlock_opaque","","",null,null],[6,"BasicBlockRef","","",null,null],[4,"Builder_opaque","","",null,null],[6,"BuilderRef","","",null,null],[4,"ExecutionEngine_opaque","","",null,null],[6,"ExecutionEngineRef","","",null,null],[4,"RustJITMemoryManager_opaque","","",null,null],[6,"RustJITMemoryManagerRef","","",null,null],[4,"MemoryBuffer_opaque","","",null,null],[6,"MemoryBufferRef","","",null,null],[4,"PassManager_opaque","","",null,null],[6,"PassManagerRef","","",null,null],[4,"PassManagerBuilder_opaque","","",null,null],[6,"PassManagerBuilderRef","","",null,null],[4,"Use_opaque","","",null,null],[6,"UseRef","","",null,null],[4,"TargetData_opaque","","",null,null],[6,"TargetDataRef","","",null,null],[4,"ObjectFile_opaque","","",null,null],[6,"ObjectFileRef","","",null,null],[4,"SectionIterator_opaque","","",null,null],[6,"SectionIteratorRef","","",null,null],[4,"Pass_opaque","","",null,null],[6,"PassRef","","",null,null],[4,"TargetMachine_opaque","","",null,null],[6,"TargetMachineRef","","",null,null],[4,"Archive_opaque","","",null,null],[6,"ArchiveRef","","",null,null],[4,"Twine_opaque","","",null,null],[6,"TwineRef","","",null,null],[4,"DiagnosticInfo_opaque","","",null,null],[6,"DiagnosticInfoRef","","",null,null],[4,"DebugLoc_opaque","","",null,null],[6,"DebugLocRef","","",null,null],[4,"SMDiagnostic_opaque","","",null,null],[6,"SMDiagnosticRef","","",null,null],[6,"DiagnosticHandler","","",null,null],[6,"InlineAsmDiagHandler","","",null,null],[0,"debuginfo","","",null,null],[4,"DIBuilder_opaque","rustc::lib::llvm::debuginfo","",null,null],[6,"DIBuilderRef","","",null,null],[6,"DIDescriptor","","",null,null],[6,"DIScope","","",null,null],[6,"DILocation","","",null,null],[6,"DIFile","","",null,null],[6,"DILexicalBlock","","",null,null],[6,"DISubprogram","","",null,null],[6,"DINameSpace","","",null,null],[6,"DIType","","",null,null],[6,"DIBasicType","","",null,null],[6,"DIDerivedType","","",null,null],[6,"DICompositeType","","",null,null],[6,"DIVariable","","",null,null],[6,"DIGlobalVariable","","",null,null],[6,"DIArray","","",null,null],[6,"DISubrange","","",null,null],[6,"DIEnumerator","","",null,null],[6,"DITemplateTypeParameter","","",null,null],[4,"DIDescriptorFlags","","",null,null],[13,"FlagPrivate","","",26,null],[13,"FlagProtected","","",26,null],[13,"FlagFwdDecl","","",26,null],[13,"FlagAppleBlock","","",26,null],[13,"FlagBlockByrefStruct","","",26,null],[13,"FlagVirtual","","",26,null],[13,"FlagArtificial","","",26,null],[13,"FlagExplicit","","",26,null],[13,"FlagPrototyped","","",26,null],[13,"FlagObjcClassComplete","","",26,null],[13,"FlagObjectPointer","","",26,null],[13,"FlagVector","","",26,null],[13,"FlagStaticMember","","",26,null],[13,"FlagIndirectVariable","","",26,null],[13,"FlagLValueReference","","",26,null],[13,"FlagRValueReference","","",26,null],[5,"LLVMContextCreate","rustc::lib::llvm","",null,null],[5,"LLVMContextDispose","","",null,null],[5,"LLVMGetMDKindIDInContext","","",null,null],[5,"LLVMModuleCreateWithNameInContext","","",null,null],[5,"LLVMGetModuleContext","","",null,null],[5,"LLVMDisposeModule","","",null,null],[5,"LLVMGetDataLayout","","Data layout. See Module::getDataLayout.",null,null],[5,"LLVMSetDataLayout","","",null,null],[5,"LLVMGetTarget","","Target triple. See Module::getTargetTriple.",null,null],[5,"LLVMSetTarget","","",null,null],[5,"LLVMDumpModule","","See Module::dump.",null,null],[5,"LLVMSetModuleInlineAsm","","See Module::setModuleInlineAsm.",null,null],[5,"LLVMGetTypeKind","","See llvm::LLVMTypeKind::getTypeID.",null,null],[5,"LLVMGetTypeContext","","See llvm::LLVMType::getContext.",null,null],[5,"LLVMInt1TypeInContext","","",null,null],[5,"LLVMInt8TypeInContext","","",null,null],[5,"LLVMInt16TypeInContext","","",null,null],[5,"LLVMInt32TypeInContext","","",null,null],[5,"LLVMInt64TypeInContext","","",null,null],[5,"LLVMIntTypeInContext","","",null,null],[5,"LLVMGetIntTypeWidth","","",null,null],[5,"LLVMFloatTypeInContext","","",null,null],[5,"LLVMDoubleTypeInContext","","",null,null],[5,"LLVMX86FP80TypeInContext","","",null,null],[5,"LLVMFP128TypeInContext","","",null,null],[5,"LLVMPPCFP128TypeInContext","","",null,null],[5,"LLVMFunctionType","","",null,null],[5,"LLVMIsFunctionVarArg","","",null,null],[5,"LLVMGetReturnType","","",null,null],[5,"LLVMCountParamTypes","","",null,null],[5,"LLVMGetParamTypes","","",null,null],[5,"LLVMStructTypeInContext","","",null,null],[5,"LLVMCountStructElementTypes","","",null,null],[5,"LLVMGetStructElementTypes","","",null,null],[5,"LLVMIsPackedStruct","","",null,null],[5,"LLVMRustArrayType","","",null,null],[5,"LLVMPointerType","","",null,null],[5,"LLVMVectorType","","",null,null],[5,"LLVMGetElementType","","",null,null],[5,"LLVMGetArrayLength","","",null,null],[5,"LLVMGetPointerAddressSpace","","",null,null],[5,"LLVMGetPointerToGlobal","","",null,null],[5,"LLVMGetVectorSize","","",null,null],[5,"LLVMVoidTypeInContext","","",null,null],[5,"LLVMLabelTypeInContext","","",null,null],[5,"LLVMMetadataTypeInContext","","",null,null],[5,"LLVMTypeOf","","",null,null],[5,"LLVMGetValueName","","",null,null],[5,"LLVMSetValueName","","",null,null],[5,"LLVMDumpValue","","",null,null],[5,"LLVMReplaceAllUsesWith","","",null,null],[5,"LLVMHasMetadata","","",null,null],[5,"LLVMGetMetadata","","",null,null],[5,"LLVMSetMetadata","","",null,null],[5,"LLVMGetFirstUse","","",null,null],[5,"LLVMGetNextUse","","",null,null],[5,"LLVMGetUser","","",null,null],[5,"LLVMGetUsedValue","","",null,null],[5,"LLVMGetNumOperands","","",null,null],[5,"LLVMGetOperand","","",null,null],[5,"LLVMSetOperand","","",null,null],[5,"LLVMConstNull","","",null,null],[5,"LLVMConstAllOnes","","",null,null],[5,"LLVMConstICmp","","",null,null],[5,"LLVMConstFCmp","","",null,null],[5,"LLVMGetUndef","","",null,null],[5,"LLVMIsConstant","","",null,null],[5,"LLVMIsNull","","",null,null],[5,"LLVMIsUndef","","",null,null],[5,"LLVMConstPointerNull","","",null,null],[5,"LLVMMDStringInContext","","",null,null],[5,"LLVMMDNodeInContext","","",null,null],[5,"LLVMAddNamedMetadataOperand","","",null,null],[5,"LLVMConstInt","","",null,null],[5,"LLVMConstIntOfString","","",null,null],[5,"LLVMConstIntOfStringAndSize","","",null,null],[5,"LLVMConstReal","","",null,null],[5,"LLVMConstRealOfString","","",null,null],[5,"LLVMConstRealOfStringAndSize","","",null,null],[5,"LLVMConstIntGetZExtValue","","",null,null],[5,"LLVMConstIntGetSExtValue","","",null,null],[5,"LLVMConstStringInContext","","",null,null],[5,"LLVMConstStructInContext","","",null,null],[5,"LLVMConstArray","","",null,null],[5,"LLVMConstVector","","",null,null],[5,"LLVMAlignOf","","",null,null],[5,"LLVMSizeOf","","",null,null],[5,"LLVMConstNeg","","",null,null],[5,"LLVMConstNSWNeg","","",null,null],[5,"LLVMConstNUWNeg","","",null,null],[5,"LLVMConstFNeg","","",null,null],[5,"LLVMConstNot","","",null,null],[5,"LLVMConstAdd","","",null,null],[5,"LLVMConstNSWAdd","","",null,null],[5,"LLVMConstNUWAdd","","",null,null],[5,"LLVMConstFAdd","","",null,null],[5,"LLVMConstSub","","",null,null],[5,"LLVMConstNSWSub","","",null,null],[5,"LLVMConstNUWSub","","",null,null],[5,"LLVMConstFSub","","",null,null],[5,"LLVMConstMul","","",null,null],[5,"LLVMConstNSWMul","","",null,null],[5,"LLVMConstNUWMul","","",null,null],[5,"LLVMConstFMul","","",null,null],[5,"LLVMConstUDiv","","",null,null],[5,"LLVMConstSDiv","","",null,null],[5,"LLVMConstExactSDiv","","",null,null],[5,"LLVMConstFDiv","","",null,null],[5,"LLVMConstURem","","",null,null],[5,"LLVMConstSRem","","",null,null],[5,"LLVMConstFRem","","",null,null],[5,"LLVMConstAnd","","",null,null],[5,"LLVMConstOr","","",null,null],[5,"LLVMConstXor","","",null,null],[5,"LLVMConstShl","","",null,null],[5,"LLVMConstLShr","","",null,null],[5,"LLVMConstAShr","","",null,null],[5,"LLVMConstGEP","","",null,null],[5,"LLVMConstInBoundsGEP","","",null,null],[5,"LLVMConstTrunc","","",null,null],[5,"LLVMConstSExt","","",null,null],[5,"LLVMConstZExt","","",null,null],[5,"LLVMConstFPTrunc","","",null,null],[5,"LLVMConstFPExt","","",null,null],[5,"LLVMConstUIToFP","","",null,null],[5,"LLVMConstSIToFP","","",null,null],[5,"LLVMConstFPToUI","","",null,null],[5,"LLVMConstFPToSI","","",null,null],[5,"LLVMConstPtrToInt","","",null,null],[5,"LLVMConstIntToPtr","","",null,null],[5,"LLVMConstBitCast","","",null,null],[5,"LLVMConstZExtOrBitCast","","",null,null],[5,"LLVMConstSExtOrBitCast","","",null,null],[5,"LLVMConstTruncOrBitCast","","",null,null],[5,"LLVMConstPointerCast","","",null,null],[5,"LLVMConstIntCast","","",null,null],[5,"LLVMConstFPCast","","",null,null],[5,"LLVMConstSelect","","",null,null],[5,"LLVMConstExtractElement","","",null,null],[5,"LLVMConstInsertElement","","",null,null],[5,"LLVMConstShuffleVector","","",null,null],[5,"LLVMConstExtractValue","","",null,null],[5,"LLVMConstInsertValue","","",null,null],[5,"LLVMConstInlineAsm","","",null,null],[5,"LLVMBlockAddress","","",null,null],[5,"LLVMGetGlobalParent","","",null,null],[5,"LLVMIsDeclaration","","",null,null],[5,"LLVMGetLinkage","","",null,null],[5,"LLVMSetLinkage","","",null,null],[5,"LLVMGetSection","","",null,null],[5,"LLVMSetSection","","",null,null],[5,"LLVMGetVisibility","","",null,null],[5,"LLVMSetVisibility","","",null,null],[5,"LLVMGetAlignment","","",null,null],[5,"LLVMSetAlignment","","",null,null],[5,"LLVMIsAGlobalVariable","","",null,null],[5,"LLVMAddGlobal","","",null,null],[5,"LLVMAddGlobalInAddressSpace","","",null,null],[5,"LLVMGetNamedGlobal","","",null,null],[5,"LLVMGetOrInsertGlobal","","",null,null],[5,"LLVMGetFirstGlobal","","",null,null],[5,"LLVMGetLastGlobal","","",null,null],[5,"LLVMGetNextGlobal","","",null,null],[5,"LLVMGetPreviousGlobal","","",null,null],[5,"LLVMDeleteGlobal","","",null,null],[5,"LLVMGetInitializer","","",null,null],[5,"LLVMSetInitializer","","",null,null],[5,"LLVMIsThreadLocal","","",null,null],[5,"LLVMSetThreadLocal","","",null,null],[5,"LLVMIsGlobalConstant","","",null,null],[5,"LLVMSetGlobalConstant","","",null,null],[5,"LLVMGetNamedValue","","",null,null],[5,"LLVMAddAlias","","",null,null],[5,"LLVMAddFunction","","",null,null],[5,"LLVMGetNamedFunction","","",null,null],[5,"LLVMGetFirstFunction","","",null,null],[5,"LLVMGetLastFunction","","",null,null],[5,"LLVMGetNextFunction","","",null,null],[5,"LLVMGetPreviousFunction","","",null,null],[5,"LLVMDeleteFunction","","",null,null],[5,"LLVMGetOrInsertFunction","","",null,null],[5,"LLVMGetIntrinsicID","","",null,null],[5,"LLVMGetFunctionCallConv","","",null,null],[5,"LLVMSetFunctionCallConv","","",null,null],[5,"LLVMGetGC","","",null,null],[5,"LLVMSetGC","","",null,null],[5,"LLVMAddDereferenceableAttr","","",null,null],[5,"LLVMAddFunctionAttribute","","",null,null],[5,"LLVMAddFunctionAttrString","","",null,null],[5,"LLVMRemoveFunctionAttrString","","",null,null],[5,"LLVMGetFunctionAttr","","",null,null],[5,"LLVMRemoveFunctionAttr","","",null,null],[5,"LLVMCountParams","","",null,null],[5,"LLVMGetParams","","",null,null],[5,"LLVMGetParam","","",null,null],[5,"LLVMGetParamParent","","",null,null],[5,"LLVMGetFirstParam","","",null,null],[5,"LLVMGetLastParam","","",null,null],[5,"LLVMGetNextParam","","",null,null],[5,"LLVMGetPreviousParam","","",null,null],[5,"LLVMAddAttribute","","",null,null],[5,"LLVMRemoveAttribute","","",null,null],[5,"LLVMGetAttribute","","",null,null],[5,"LLVMSetParamAlignment","","",null,null],[5,"LLVMBasicBlockAsValue","","",null,null],[5,"LLVMValueIsBasicBlock","","",null,null],[5,"LLVMValueAsBasicBlock","","",null,null],[5,"LLVMGetBasicBlockParent","","",null,null],[5,"LLVMCountBasicBlocks","","",null,null],[5,"LLVMGetBasicBlocks","","",null,null],[5,"LLVMGetFirstBasicBlock","","",null,null],[5,"LLVMGetLastBasicBlock","","",null,null],[5,"LLVMGetNextBasicBlock","","",null,null],[5,"LLVMGetPreviousBasicBlock","","",null,null],[5,"LLVMGetEntryBasicBlock","","",null,null],[5,"LLVMAppendBasicBlockInContext","","",null,null],[5,"LLVMInsertBasicBlockInContext","","",null,null],[5,"LLVMDeleteBasicBlock","","",null,null],[5,"LLVMMoveBasicBlockAfter","","",null,null],[5,"LLVMMoveBasicBlockBefore","","",null,null],[5,"LLVMGetInstructionParent","","",null,null],[5,"LLVMGetFirstInstruction","","",null,null],[5,"LLVMGetLastInstruction","","",null,null],[5,"LLVMGetNextInstruction","","",null,null],[5,"LLVMGetPreviousInstruction","","",null,null],[5,"LLVMInstructionEraseFromParent","","",null,null],[5,"LLVMSetInstructionCallConv","","",null,null],[5,"LLVMGetInstructionCallConv","","",null,null],[5,"LLVMAddInstrAttribute","","",null,null],[5,"LLVMRemoveInstrAttribute","","",null,null],[5,"LLVMSetInstrParamAlignment","","",null,null],[5,"LLVMAddCallSiteAttribute","","",null,null],[5,"LLVMAddDereferenceableCallSiteAttr","","",null,null],[5,"LLVMIsTailCall","","",null,null],[5,"LLVMSetTailCall","","",null,null],[5,"LLVMGetVolatile","","",null,null],[5,"LLVMSetVolatile","","",null,null],[5,"LLVMAddIncoming","","",null,null],[5,"LLVMCountIncoming","","",null,null],[5,"LLVMGetIncomingValue","","",null,null],[5,"LLVMGetIncomingBlock","","",null,null],[5,"LLVMCreateBuilderInContext","","",null,null],[5,"LLVMPositionBuilder","","",null,null],[5,"LLVMPositionBuilderBefore","","",null,null],[5,"LLVMPositionBuilderAtEnd","","",null,null],[5,"LLVMGetInsertBlock","","",null,null],[5,"LLVMClearInsertionPosition","","",null,null],[5,"LLVMInsertIntoBuilder","","",null,null],[5,"LLVMInsertIntoBuilderWithName","","",null,null],[5,"LLVMDisposeBuilder","","",null,null],[5,"LLVMRustCreateJITMemoryManager","","",null,null],[5,"LLVMBuildExecutionEngine","","",null,null],[5,"LLVMDisposeExecutionEngine","","",null,null],[5,"LLVMExecutionEngineFinalizeObject","","",null,null],[5,"LLVMRustLoadDynamicLibrary","","",null,null],[5,"LLVMExecutionEngineAddModule","","",null,null],[5,"LLVMExecutionEngineRemoveModule","","",null,null],[5,"LLVMSetCurrentDebugLocation","","",null,null],[5,"LLVMGetCurrentDebugLocation","","",null,null],[5,"LLVMSetInstDebugLocation","","",null,null],[5,"LLVMBuildRetVoid","","",null,null],[5,"LLVMBuildRet","","",null,null],[5,"LLVMBuildAggregateRet","","",null,null],[5,"LLVMBuildBr","","",null,null],[5,"LLVMBuildCondBr","","",null,null],[5,"LLVMBuildSwitch","","",null,null],[5,"LLVMBuildIndirectBr","","",null,null],[5,"LLVMBuildInvoke","","",null,null],[5,"LLVMBuildLandingPad","","",null,null],[5,"LLVMBuildResume","","",null,null],[5,"LLVMBuildUnreachable","","",null,null],[5,"LLVMAddCase","","",null,null],[5,"LLVMAddDestination","","",null,null],[5,"LLVMAddClause","","",null,null],[5,"LLVMSetCleanup","","",null,null],[5,"LLVMBuildAdd","","",null,null],[5,"LLVMBuildNSWAdd","","",null,null],[5,"LLVMBuildNUWAdd","","",null,null],[5,"LLVMBuildFAdd","","",null,null],[5,"LLVMBuildSub","","",null,null],[5,"LLVMBuildNSWSub","","",null,null],[5,"LLVMBuildNUWSub","","",null,null],[5,"LLVMBuildFSub","","",null,null],[5,"LLVMBuildMul","","",null,null],[5,"LLVMBuildNSWMul","","",null,null],[5,"LLVMBuildNUWMul","","",null,null],[5,"LLVMBuildFMul","","",null,null],[5,"LLVMBuildUDiv","","",null,null],[5,"LLVMBuildSDiv","","",null,null],[5,"LLVMBuildExactSDiv","","",null,null],[5,"LLVMBuildFDiv","","",null,null],[5,"LLVMBuildURem","","",null,null],[5,"LLVMBuildSRem","","",null,null],[5,"LLVMBuildFRem","","",null,null],[5,"LLVMBuildShl","","",null,null],[5,"LLVMBuildLShr","","",null,null],[5,"LLVMBuildAShr","","",null,null],[5,"LLVMBuildAnd","","",null,null],[5,"LLVMBuildOr","","",null,null],[5,"LLVMBuildXor","","",null,null],[5,"LLVMBuildBinOp","","",null,null],[5,"LLVMBuildNeg","","",null,null],[5,"LLVMBuildNSWNeg","","",null,null],[5,"LLVMBuildNUWNeg","","",null,null],[5,"LLVMBuildFNeg","","",null,null],[5,"LLVMBuildNot","","",null,null],[5,"LLVMBuildMalloc","","",null,null],[5,"LLVMBuildArrayMalloc","","",null,null],[5,"LLVMBuildAlloca","","",null,null],[5,"LLVMBuildArrayAlloca","","",null,null],[5,"LLVMBuildFree","","",null,null],[5,"LLVMBuildLoad","","",null,null],[5,"LLVMBuildStore","","",null,null],[5,"LLVMBuildGEP","","",null,null],[5,"LLVMBuildInBoundsGEP","","",null,null],[5,"LLVMBuildStructGEP","","",null,null],[5,"LLVMBuildGlobalString","","",null,null],[5,"LLVMBuildGlobalStringPtr","","",null,null],[5,"LLVMBuildTrunc","","",null,null],[5,"LLVMBuildZExt","","",null,null],[5,"LLVMBuildSExt","","",null,null],[5,"LLVMBuildFPToUI","","",null,null],[5,"LLVMBuildFPToSI","","",null,null],[5,"LLVMBuildUIToFP","","",null,null],[5,"LLVMBuildSIToFP","","",null,null],[5,"LLVMBuildFPTrunc","","",null,null],[5,"LLVMBuildFPExt","","",null,null],[5,"LLVMBuildPtrToInt","","",null,null],[5,"LLVMBuildIntToPtr","","",null,null],[5,"LLVMBuildBitCast","","",null,null],[5,"LLVMBuildZExtOrBitCast","","",null,null],[5,"LLVMBuildSExtOrBitCast","","",null,null],[5,"LLVMBuildTruncOrBitCast","","",null,null],[5,"LLVMBuildCast","","",null,null],[5,"LLVMBuildPointerCast","","",null,null],[5,"LLVMBuildIntCast","","",null,null],[5,"LLVMBuildFPCast","","",null,null],[5,"LLVMBuildICmp","","",null,null],[5,"LLVMBuildFCmp","","",null,null],[5,"LLVMBuildPhi","","",null,null],[5,"LLVMBuildCall","","",null,null],[5,"LLVMBuildSelect","","",null,null],[5,"LLVMBuildVAArg","","",null,null],[5,"LLVMBuildExtractElement","","",null,null],[5,"LLVMBuildInsertElement","","",null,null],[5,"LLVMBuildShuffleVector","","",null,null],[5,"LLVMBuildExtractValue","","",null,null],[5,"LLVMBuildInsertValue","","",null,null],[5,"LLVMBuildIsNull","","",null,null],[5,"LLVMBuildIsNotNull","","",null,null],[5,"LLVMBuildPtrDiff","","",null,null],[5,"LLVMBuildAtomicLoad","","",null,null],[5,"LLVMBuildAtomicStore","","",null,null],[5,"LLVMBuildAtomicCmpXchg","","",null,null],[5,"LLVMBuildAtomicRMW","","",null,null],[5,"LLVMBuildAtomicFence","","",null,null],[5,"LLVMIsATerminatorInst","","",null,null],[5,"LLVMIsAStoreInst","","",null,null],[5,"LLVMWriteBitcodeToFile","","Writes a module to the specified path. Returns 0 on success.",null,null],[5,"LLVMCreateTargetData","","Creates target data from a target layout string.",null,null],[5,"LLVMAddTargetData","","Adds the target data to the given pass manager. The pass manager\nreferences the target data only weakly.",null,null],[5,"LLVMStoreSizeOfType","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMSizeOfTypeInBits","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMABISizeOfType","","Distance between successive elements in an array of T. Includes ABI padding.",null,null],[5,"LLVMPreferredAlignmentOfType","","Returns the preferred alignment of a type.",null,null],[5,"LLVMABIAlignmentOfType","","Returns the minimum alignment of a type.",null,null],[5,"LLVMOffsetOfElement","","Computes the byte offset of the indexed struct element for a\ntarget.",null,null],[5,"LLVMCallFrameAlignmentOfType","","Returns the minimum alignment of a type when part of a call frame.",null,null],[5,"LLVMDisposeTargetData","","Disposes target data.",null,null],[5,"LLVMCreatePassManager","","Creates a pass manager.",null,null],[5,"LLVMCreateFunctionPassManagerForModule","","Creates a function-by-function pass manager",null,null],[5,"LLVMDisposePassManager","","Disposes a pass manager.",null,null],[5,"LLVMRunPassManager","","Runs a pass manager on a module.",null,null],[5,"LLVMRunFunctionPassManager","","Runs the function passes on the provided function.",null,null],[5,"LLVMInitializeFunctionPassManager","","Initializes all the function passes scheduled in the manager",null,null],[5,"LLVMFinalizeFunctionPassManager","","Finalizes all the function passes scheduled in the manager",null,null],[5,"LLVMInitializePasses","","",null,null],[5,"LLVMAddVerifierPass","","Adds a verification pass.",null,null],[5,"LLVMAddGlobalOptimizerPass","","",null,null],[5,"LLVMAddIPSCCPPass","","",null,null],[5,"LLVMAddDeadArgEliminationPass","","",null,null],[5,"LLVMAddInstructionCombiningPass","","",null,null],[5,"LLVMAddCFGSimplificationPass","","",null,null],[5,"LLVMAddFunctionInliningPass","","",null,null],[5,"LLVMAddFunctionAttrsPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPassSSA","","",null,null],[5,"LLVMAddJumpThreadingPass","","",null,null],[5,"LLVMAddConstantPropagationPass","","",null,null],[5,"LLVMAddReassociatePass","","",null,null],[5,"LLVMAddLoopRotatePass","","",null,null],[5,"LLVMAddLICMPass","","",null,null],[5,"LLVMAddLoopUnswitchPass","","",null,null],[5,"LLVMAddLoopDeletionPass","","",null,null],[5,"LLVMAddLoopUnrollPass","","",null,null],[5,"LLVMAddGVNPass","","",null,null],[5,"LLVMAddMemCpyOptPass","","",null,null],[5,"LLVMAddSCCPPass","","",null,null],[5,"LLVMAddDeadStoreEliminationPass","","",null,null],[5,"LLVMAddStripDeadPrototypesPass","","",null,null],[5,"LLVMAddConstantMergePass","","",null,null],[5,"LLVMAddArgumentPromotionPass","","",null,null],[5,"LLVMAddTailCallEliminationPass","","",null,null],[5,"LLVMAddIndVarSimplifyPass","","",null,null],[5,"LLVMAddAggressiveDCEPass","","",null,null],[5,"LLVMAddGlobalDCEPass","","",null,null],[5,"LLVMAddCorrelatedValuePropagationPass","","",null,null],[5,"LLVMAddPruneEHPass","","",null,null],[5,"LLVMAddSimplifyLibCallsPass","","",null,null],[5,"LLVMAddLoopIdiomPass","","",null,null],[5,"LLVMAddEarlyCSEPass","","",null,null],[5,"LLVMAddTypeBasedAliasAnalysisPass","","",null,null],[5,"LLVMAddBasicAliasAnalysisPass","","",null,null],[5,"LLVMPassManagerBuilderCreate","","",null,null],[5,"LLVMPassManagerBuilderDispose","","",null,null],[5,"LLVMPassManagerBuilderSetOptLevel","","",null,null],[5,"LLVMPassManagerBuilderSetSizeLevel","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnitAtATime","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnrollLoops","","",null,null],[5,"LLVMPassManagerBuilderSetDisableSimplifyLibCalls","","",null,null],[5,"LLVMPassManagerBuilderUseInlinerWithThreshold","","",null,null],[5,"LLVMPassManagerBuilderPopulateModulePassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateFunctionPassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateLTOPassManager","","",null,null],[5,"LLVMDisposeMemoryBuffer","","Destroys a memory buffer.",null,null],[5,"LLVMCreateObjectFile","","Opens an object file.",null,null],[5,"LLVMDisposeObjectFile","","Closes an object file.",null,null],[5,"LLVMGetSections","","Enumerates the sections in an object file.",null,null],[5,"LLVMDisposeSectionIterator","","Destroys a section iterator.",null,null],[5,"LLVMIsSectionIteratorAtEnd","","Returns true if the section iterator is at the end of the section\nlist:",null,null],[5,"LLVMMoveToNextSection","","Moves the section iterator to point to the next section.",null,null],[5,"LLVMGetSectionSize","","Returns the current section size.",null,null],[5,"LLVMGetSectionContents","","Returns the current section contents as a string buffer.",null,null],[5,"LLVMRustCreateMemoryBufferWithContentsOfFile","","Reads the given file and returns it as a memory buffer. Use\nLLVMDisposeMemoryBuffer() to get rid of it.",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRange","","Borrows the contents of the memory buffer (doesn't copy it)",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRangeCopy","","",null,null],[5,"LLVMIsMultithreaded","","",null,{"inputs":[],"output":{"name":"u32"}}],[5,"LLVMStartMultithreaded","","",null,{"inputs":[],"output":{"name":"u32"}}],[5,"LLVMRustGetLastError","","Returns a string describing the last error caused by an LLVMRust* call.",null,null],[5,"LLVMRustPrintPassTimings","","Print the pass timings since static dtors aren't picking them up.",null,null],[5,"LLVMStructCreateNamed","","",null,null],[5,"LLVMStructSetBody","","",null,null],[5,"LLVMConstNamedStruct","","",null,null],[5,"LLVMSetDebug","","Enables LLVM debug output.",null,null],[5,"LLVMInlineAsm","","Prepares inline assembly.",null,null],[7,"LLVMRustDebugMetadataVersion","","",null,null],[5,"LLVMRustAddModuleFlag","","",null,null],[5,"LLVMDIBuilderCreate","","",null,null],[5,"LLVMDIBuilderDispose","","",null,null],[5,"LLVMDIBuilderFinalize","","",null,null],[5,"LLVMDIBuilderCreateCompileUnit","","",null,null],[5,"LLVMDIBuilderCreateFile","","",null,null],[5,"LLVMDIBuilderCreateSubroutineType","","",null,null],[5,"LLVMDIBuilderCreateFunction","","",null,null],[5,"LLVMDIBuilderCreateBasicType","","",null,null],[5,"LLVMDIBuilderCreatePointerType","","",null,null],[5,"LLVMDIBuilderCreateStructType","","",null,null],[5,"LLVMDIBuilderCreateMemberType","","",null,null],[5,"LLVMDIBuilderCreateLexicalBlock","","",null,null],[5,"LLVMDIBuilderCreateStaticVariable","","",null,null],[5,"LLVMDIBuilderCreateVariable","","",null,null],[5,"LLVMDIBuilderCreateArrayType","","",null,null],[5,"LLVMDIBuilderCreateVectorType","","",null,null],[5,"LLVMDIBuilderGetOrCreateSubrange","","",null,null],[5,"LLVMDIBuilderGetOrCreateArray","","",null,null],[5,"LLVMDIBuilderInsertDeclareAtEnd","","",null,null],[5,"LLVMDIBuilderInsertDeclareBefore","","",null,null],[5,"LLVMDIBuilderCreateEnumerator","","",null,null],[5,"LLVMDIBuilderCreateEnumerationType","","",null,null],[5,"LLVMDIBuilderCreateUnionType","","",null,null],[5,"LLVMSetUnnamedAddr","","",null,null],[5,"LLVMDIBuilderCreateTemplateTypeParameter","","",null,null],[5,"LLVMDIBuilderCreateOpDeref","","",null,{"inputs":[],"output":{"name":"i64"}}],[5,"LLVMDIBuilderCreateOpPlus","","",null,{"inputs":[],"output":{"name":"i64"}}],[5,"LLVMDIBuilderCreateNameSpace","","",null,null],[5,"LLVMDIBuilderCreateDebugLocation","","",null,null],[5,"LLVMDICompositeTypeSetTypeArray","","",null,null],[5,"LLVMWriteTypeToString","","",null,null],[5,"LLVMWriteValueToString","","",null,null],[5,"LLVMIsAArgument","","",null,null],[5,"LLVMIsAAllocaInst","","",null,null],[5,"LLVMIsAConstantInt","","",null,null],[5,"LLVMInitializeX86TargetInfo","","",null,null],[5,"LLVMInitializeX86Target","","",null,null],[5,"LLVMInitializeX86TargetMC","","",null,null],[5,"LLVMInitializeX86AsmPrinter","","",null,null],[5,"LLVMInitializeX86AsmParser","","",null,null],[5,"LLVMInitializeARMTargetInfo","","",null,null],[5,"LLVMInitializeARMTarget","","",null,null],[5,"LLVMInitializeARMTargetMC","","",null,null],[5,"LLVMInitializeARMAsmPrinter","","",null,null],[5,"LLVMInitializeARMAsmParser","","",null,null],[5,"LLVMInitializeAArch64TargetInfo","","",null,null],[5,"LLVMInitializeAArch64Target","","",null,null],[5,"LLVMInitializeAArch64TargetMC","","",null,null],[5,"LLVMInitializeAArch64AsmPrinter","","",null,null],[5,"LLVMInitializeAArch64AsmParser","","",null,null],[5,"LLVMInitializeMipsTargetInfo","","",null,null],[5,"LLVMInitializeMipsTarget","","",null,null],[5,"LLVMInitializeMipsTargetMC","","",null,null],[5,"LLVMInitializeMipsAsmPrinter","","",null,null],[5,"LLVMInitializeMipsAsmParser","","",null,null],[5,"LLVMInitializePowerPCTargetInfo","","",null,null],[5,"LLVMInitializePowerPCTarget","","",null,null],[5,"LLVMInitializePowerPCTargetMC","","",null,null],[5,"LLVMInitializePowerPCAsmPrinter","","",null,null],[5,"LLVMInitializePowerPCAsmParser","","",null,null],[5,"LLVMRustAddPass","","",null,null],[5,"LLVMRustCreateTargetMachine","","",null,null],[5,"LLVMRustDisposeTargetMachine","","",null,null],[5,"LLVMRustAddAnalysisPasses","","",null,null],[5,"LLVMRustAddBuilderLibraryInfo","","",null,null],[5,"LLVMRustAddLibraryInfo","","",null,null],[5,"LLVMRustRunFunctionPassManager","","",null,null],[5,"LLVMRustWriteOutputFile","","",null,null],[5,"LLVMRustPrintModule","","",null,null],[5,"LLVMRustSetLLVMOptions","","",null,null],[5,"LLVMRustPrintPasses","","",null,null],[5,"LLVMRustSetNormalizedTarget","","",null,null],[5,"LLVMRustAddAlwaysInlinePass","","",null,null],[5,"LLVMRustLinkInExternalBitcode","","",null,null],[5,"LLVMRustRunRestrictionPass","","",null,null],[5,"LLVMRustMarkAllFunctionsNounwind","","",null,null],[5,"LLVMRustOpenArchive","","",null,null],[5,"LLVMRustArchiveReadSection","","",null,null],[5,"LLVMRustDestroyArchive","","",null,null],[5,"LLVMRustSetDLLExportStorageClass","","",null,null],[5,"LLVMVersionMajor","","",null,{"inputs":[],"output":{"name":"i32"}}],[5,"LLVMVersionMinor","","",null,{"inputs":[],"output":{"name":"i32"}}],[5,"LLVMRustGetSectionName","","",null,null],[5,"LLVMWriteTwineToString","","",null,null],[5,"LLVMContextSetDiagnosticHandler","","",null,null],[5,"LLVMUnpackOptimizationDiagnostic","","",null,null],[5,"LLVMUnpackInlineAsmDiagnostic","","",null,null],[5,"LLVMWriteDiagnosticInfoToString","","",null,null],[5,"LLVMGetDiagInfoSeverity","","",null,null],[5,"LLVMGetDiagInfoKind","","",null,null],[5,"LLVMWriteDebugLocToString","","",null,null],[5,"LLVMSetInlineAsmDiagnosticHandler","","",null,null],[5,"LLVMWriteSMDiagnosticToString","","",null,null],[5,"SetInstructionCallConv","","",null,null],[5,"SetFunctionCallConv","","",null,null],[5,"SetLinkage","","",null,null],[5,"SetUnnamedAddr","","",null,null],[5,"set_thread_local","","",null,null],[5,"ConstICmp","","",null,null],[5,"ConstFCmp","","",null,null],[5,"SetFunctionAttribute","","",null,null],[3,"TargetData","","",null,null],[12,"lltd","","",27,null],[5,"mk_target_data","","",null,{"inputs":[{"name":"str"}],"output":{"name":"targetdata"}}],[3,"ObjectFile","","",null,null],[12,"llof","","",28,null],[3,"SectionIter","","",null,null],[12,"llsi","","",29,null],[5,"mk_section_iter","","",null,null],[5,"get_param","","Safe wrapper around `LLVMGetParam`, because segfaults are no fun.",null,null],[4,"RustString_opaque","","",null,null],[6,"RustStringRef","","",null,null],[5,"rust_llvm_string_write_impl","","Appending to a Rust string -- used by raw_rust_string_ostream.",null,null],[5,"build_string","","",null,{"inputs":[{"name":"f"}],"output":{"name":"option"}}],[5,"twine_to_string","","",null,null],[5,"debug_loc_to_string","","",null,null],[14,"lint_initializer!","rustc","Build a `Lint` initializer.",null,null],[14,"declare_lint!","","Declare a static item of type `&'static Lint`.",null,null],[14,"lint_array!","","Declare a static `LintArray` and return it as an expression.",null,null],[11,"ty_str_ctxt","rustc::metadata::encoder","",316,null],[11,"repr","rustc::middle::ty","",207,null],[11,"compare","rustc::middle::ty_relate","",393,null],[11,"resolve","rustc::middle::ty","",294,null],[11,"contains_error","","",294,null],[11,"resolve","","",285,null],[11,"contains_error","","",285,null],[11,"index","","",226,null],[11,"from_index","","",226,null],[11,"tag","","",226,null],[11,"to_type","","",259,null],[11,"index","","",227,null],[11,"from_index","","",227,null],[11,"tag","","",227,null],[11,"repr","","",268,null]],"paths":[[3,"ArchiveRO"],[4,"OptimizationDiagnosticKind"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"Diagnostic"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[3,"Attribute"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[3,"AttrBuilder"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[4,"DIDescriptorFlags"],[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[8,"AttrHelper"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"TempDir"],[3,"FixedBuffer64"],[3,"Sha256"],[3,"Svh"],[4,"SawAbiComponent"],[4,"SawExprComponent"],[4,"SawStmtComponent"],[3,"Ident"],[3,"Name"],[3,"StrictVersionHashVisitor"],[4,"Arch"],[3,"Target"],[3,"TargetOptions"],[3,"ArchiveConfig"],[3,"RPathConfig"],[3,"t"],[8,"vtable_decoder_helpers"],[3,"Decoder"],[3,"CFG"],[3,"CFGEdgeData"],[4,"CFGNodeData"],[3,"LabelledCFG"],[3,"ConstQualif"],[3,"MatchCheckCtxt"],[3,"StaticInliner"],[4,"Constructor"],[3,"ConstEvalErr"],[4,"const_val"],[4,"ErrKind"],[4,"IntTy"],[4,"UintTy"],[4,"EntryOrExit"],[4,"KillFrom"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[3,"DataFlowContext"],[3,"PathResolution"],[3,"Export"],[4,"Def"],[4,"MethodProvenance"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"MutateMode"],[8,"Delegate"],[3,"ExprUseVisitor"],[4,"SimplifiedType"],[3,"FreeRegionMap"],[3,"Node"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"Graph"],[3,"DepthFirstTraversal"],[3,"InferCtxt"],[4,"TypeOrigin"],[4,"ValuePairs"],[4,"SubregionOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"fixup_err"],[3,"Bivariate"],[3,"CombineFields"],[8,"RelateResultCompare"],[3,"Equate"],[8,"ErrorReporting"],[8,"Resolvable"],[3,"Rc"],[3,"Glb"],[8,"LatticeDir"],[3,"Lub"],[3,"SameRegions"],[4,"Constraint"],[4,"Verify"],[4,"GenericKind"],[4,"UndoLogEntry"],[4,"CombineMapType"],[4,"RegionResolutionError"],[4,"VarValue"],[3,"TwoRegions"],[3,"RegionSnapshot"],[3,"RegionVarBindings"],[3,"OpportunisticTypeResolver"],[3,"TypeFreshener"],[3,"Sub"],[4,"RelationDir"],[3,"TypeVariableTable"],[3,"Node"],[4,"VarValue"],[8,"UnifyKey"],[8,"ToType"],[3,"Delegate"],[3,"UnificationTable"],[4,"FloatTy"],[3,"TypeTrace"],[4,"Implication"],[3,"LanguageItems"],[4,"LangItem"],[3,"Upvar"],[3,"cmt_"],[4,"categorization"],[4,"PointerKind"],[4,"InteriorKind"],[4,"FieldName"],[4,"InteriorOffsetKind"],[4,"ElementKind"],[4,"MutabilityCategory"],[4,"Note"],[4,"deref_kind"],[4,"InteriorSafety"],[4,"Aliasability"],[4,"AliasableReason"],[8,"ast_node"],[8,"Typer"],[3,"Expr"],[3,"Pat"],[3,"MemCategorizationContext"],[4,"LastPrivate"],[4,"PrivateDep"],[4,"ImportUse"],[3,"DestructionScopeData"],[3,"BlockRemainder"],[4,"CodeExtent"],[3,"Context"],[3,"RegionMaps"],[4,"DefRegion"],[3,"Index"],[3,"Substs"],[3,"SeparateVecsPerParamSpace"],[4,"RegionSubsts"],[4,"ParamSpace"],[8,"Subst"],[3,"VecPerParamSpace"],[3,"EnumeratedItems"],[3,"RegionObligation"],[3,"MismatchedProjectionTypes"],[3,"Normalized"],[3,"Obligation"],[3,"ObligationCause"],[3,"FulfillmentError"],[3,"VtableImplData"],[3,"VtableDefaultImplData"],[3,"VtableBuiltinData"],[3,"VtableObjectData"],[4,"OrphanCheckErr"],[4,"ObjectSafetyViolation"],[4,"MethodViolationCode"],[4,"MethodMatchResult"],[4,"MethodMatchedData"],[4,"ObligationCauseCode"],[4,"SelectionError"],[4,"FulfillmentErrorCode"],[3,"FulfillmentContext"],[3,"SelectionCache"],[3,"SelectionContext"],[3,"SupertraitDefIds"],[4,"Vtable"],[3,"DerivedObligationCause"],[3,"CrateAnalysis"],[3,"field"],[3,"Method"],[3,"AssociatedType"],[3,"mt"],[3,"field_ty"],[3,"creader_cache_key"],[3,"ItemVariances"],[3,"AutoDerefRef"],[3,"param_index"],[3,"MethodParam"],[3,"MethodObject"],[3,"MethodCallee"],[3,"MethodCall"],[3,"TransmuteRestriction"],[3,"CommonTypes"],[3,"ctxt"],[3,"TyS"],[3,"BareFnTy"],[3,"ClosureTy"],[3,"FnSig"],[3,"ParamTy"],[3,"DebruijnIndex"],[3,"EarlyBoundRegion"],[3,"UpvarId"],[3,"UpvarBorrow"],[3,"FreeRegion"],[3,"TyTrait"],[3,"TraitRef"],[3,"expected_found"],[3,"ParamBounds"],[3,"ExistentialBounds"],[3,"TyVid"],[3,"IntVid"],[3,"FloatVid"],[3,"RegionVid"],[3,"TypeParameterDef"],[3,"RegionParameterDef"],[3,"Generics"],[3,"GenericPredicates"],[3,"TraitPredicate"],[3,"ProjectionPredicate"],[3,"ProjectionTy"],[3,"InstantiatedPredicates"],[3,"ParameterEnvironment"],[3,"TypeScheme"],[3,"TraitDef"],[3,"ItemSubsts"],[3,"TypeContents"],[3,"VariantInfo"],[3,"ClosureUpvar"],[3,"Freevar"],[4,"ImplOrTraitItemContainer"],[4,"ImplOrTraitItem"],[4,"ImplOrTraitItemId"],[4,"Variance"],[4,"AutoAdjustment"],[4,"AutoRef"],[4,"MethodOrigin"],[4,"vtable_origin"],[4,"FnOutput"],[4,"Region"],[4,"BorrowKind"],[4,"UpvarCapture"],[4,"BoundRegion"],[4,"sty"],[4,"IntVarValue"],[4,"terr_vstore_kind"],[4,"type_err"],[4,"BuiltinBound"],[4,"InferTy"],[4,"UnconstrainedNumeric"],[4,"InferRegion"],[4,"ObjectLifetimeDefault"],[4,"Predicate"],[4,"ClosureKind"],[4,"Representability"],[4,"ExprKind"],[4,"DtorKind"],[4,"ExplicitSelfCategory"],[4,"CopyImplementationError"],[8,"ToPolyTraitRef"],[8,"AsPredicate"],[8,"ClosureTyper"],[8,"RegionEscape"],[8,"HasProjectionTypes"],[8,"ReferencesError"],[3,"CtxtArenas"],[3,"TypeFlags"],[3,"InternedTy"],[6,"PolyFnOutput"],[6,"PolyFnSig"],[6,"PolyTraitRef"],[3,"Binder"],[6,"PolyTraitPredicate"],[3,"EquatePredicate"],[3,"OutlivesPredicate"],[6,"PolyProjectionPredicate"],[6,"PolyEquatePredicate"],[6,"PolyRegionOutlivesPredicate"],[6,"PolyTypeOutlivesPredicate"],[6,"Ty"],[3,"Vec"],[4,"Option"],[3,"Box"],[3,"BottomUpFolder"],[8,"TypeFoldable"],[8,"TypeFolder"],[4,"Unsafety"],[4,"Abi"],[3,"OwnedSlice"],[6,"BuiltinBounds"],[3,"RegionFolder"],[3,"RegionEraser"],[3,"Match"],[8,"TypeRelation"],[8,"Relate"],[3,"TypeWalker"],[3,"LinkMeta"],[4,"astencode_tag"],[3,"ctxt"],[4,"DefIdSource"],[3,"EncodeParams"],[3,"EncodeContext"],[4,"InlinedItemRef"],[3,"CrateDep"],[4,"DefLike"],[3,"CrateReader"],[3,"ImportedFileMap"],[3,"crate_metadata"],[3,"CrateSource"],[3,"CStore"],[4,"MetadataBlob"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[3,"MethodInfo"],[4,"FoundAst"],[3,"Context"],[3,"Library"],[3,"CratePaths"],[3,"ArchiveMetadata"],[3,"FileSearch"],[4,"FileMatch"],[3,"Session"],[3,"Config"],[3,"Options"],[3,"OutputFilenames"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[3,"RustcOptGroup"],[4,"OptLevel"],[4,"DebugInfoLevel"],[4,"OutputType"],[4,"UnstableFeatures"],[4,"PrintRequest"],[4,"Input"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[4,"OptionStability"],[4,"PathKind"],[3,"SearchPaths"],[3,"Iter"],[3,"Registry"],[3,"PluginRegistrar"],[3,"Context"],[3,"Lint"],[4,"Level"],[4,"LintSource"],[3,"HardwiredLints"],[3,"LintStore"],[3,"GatherNodeLevels"],[8,"LintPass"],[3,"LintId"],[8,"Digest"],[3,"ErrorReported"],[3,"Indenter"],[8,"Repr"],[8,"UserString"],[3,"P"],[4,"Result"],[3,"TraitItem"],[3,"Path"],[3,"Ty"],[3,"Item"],[3,"Lifetime"],[6,"Stmt"],[3,"DefId"],[4,"ExplicitSelf_"],[4,"Visibility"],[3,"Span"],[4,"Mutability"],[4,"IntTy"],[4,"UintTy"],[3,"HashMap"],[3,"FnvHasher"],[4,"UndoLog"],[8,"SnapshotVecDelegate"],[3,"SnapshotVec"],[8,"ToPrimitive"],[6,"RelateResult"]]};
searchIndex['rustc_trans'] = {"items":[[0,"","rustc_trans","The Rust compiler.",null,null],[0,"session","","",null,null],[0,"config","rustc_trans::session","Contains infrastructure for configuring the compiler, including parsing\ncommand line options.",null,null],[11,"fmt","rustc_back::svh","",0,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",0,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",0,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",0,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",0,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",0,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",0,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","rustc_back::svh::svh_visitor","",1,null],[11,"hash","","",2,null],[11,"hash","","",3,null],[11,"get_content","syntax::ast","",4,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"get_content","","",5,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[11,"visit_mac","rustc_back::svh::svh_visitor","",6,null],[11,"visit_struct_def","","",6,null],[11,"visit_variant","","",6,null],[11,"visit_opt_lifetime_ref","","",6,null],[11,"visit_ident","","",6,null],[11,"visit_lifetime_ref","","",6,null],[11,"visit_lifetime_def","","",6,null],[11,"visit_expr","","",6,null],[11,"visit_stmt","","",6,null],[11,"visit_foreign_item","","",6,null],[11,"visit_item","","",6,null],[11,"visit_mod","","",6,null],[11,"visit_decl","","",6,null],[11,"visit_ty","","",6,null],[11,"visit_generics","","",6,null],[11,"visit_fn","","",6,null],[11,"visit_trait_item","","",6,null],[11,"visit_impl_item","","",6,null],[11,"visit_struct_field","","",6,null],[11,"visit_explicit_self","","",6,null],[11,"visit_path","","",6,null],[11,"visit_block","","",6,null],[11,"visit_pat","","",6,null],[11,"visit_local","","",6,null],[11,"visit_arm","","",6,null],[11,"open","rustc_back::archive","Opens an existing static archive",7,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",7,null],[11,"files","","Lists all files in an archive",7,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",7,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",8,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",8,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",8,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",8,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",8,null],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",8,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[11,"tr_id","rustc::middle::astencode","Translates an internal id, meaning a node id that is known to refer to some part of the\nitem currently being inlined, such as a local variable or argument.  All naked node-ids\nthat appear in types have this property, since if something might refer to an external item\nwe would use a def-id to allow for the possibility that the item resides in another crate.",9,{"inputs":[{"name":"decodecontext"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"tr_def_id","","Translates an EXTERNAL def-id, converting the crate number from the one used in the encoded\ndata to the current crate numbers..  By external, I mean that it be translated to a\nreference to the item in its original crate, as opposed to being translated to a reference\nto the inlined version of the item.  This is typically, but not always, what you want,\nbecause most def-ids refer to external things like types or other fns that may or may not\nbe inlined.  Note that even when the inlined function is referencing itself recursively, we\nwould want `tr_def_id` for that reference--- conceptually the function calls the original,\nnon-inlined version, and trans deals with linking that recursive call to the inlined copy.",9,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_intern_def_id","","Translates an INTERNAL def-id, meaning a def-id that is\nknown to refer to some part of the item currently being\ninlined.  In that case, we want to convert the def-id to\nrefer to the current crate and to the new, inlined node-id.",9,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_span","","Translates a `Span` from an extern crate to the corresponding `Span`\nwithin the local crate's codemap. `creader::import_codemap()` will\nalready have allocated any additionally needed FileMaps in the local\ncodemap as a side-effect of creating the crate_metadata's\n`codemap_import_info`.",9,{"inputs":[{"name":"decodecontext"},{"name":"span"}],"output":{"name":"span"}}],[11,"tr_intern","syntax::ast","",10,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","","",10,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","core::option","",11,{"inputs":[{"name":"option"},{"name":"decodecontext"}],"output":{"name":"option"}}],[11,"tr","syntax::codemap","",12,{"inputs":[{"name":"span"},{"name":"decodecontext"}],"output":{"name":"span"}}],[11,"fold_block","rustc::middle::astencode","",13,{"inputs":[{"name":"nesteditemsdropper"},{"name":"p"}],"output":{"name":"p"}}],[11,"tr","rustc::middle::def","",14,{"inputs":[{"name":"def"},{"name":"decodecontext"}],"output":{"name":"def"}}],[11,"tr","rustc::middle::ty","",15,{"inputs":[{"name":"region"},{"name":"decodecontext"}],"output":{"name":"region"}}],[11,"tr","","",16,{"inputs":[{"name":"freeregion"},{"name":"decodecontext"}],"output":{"name":"freeregion"}}],[11,"tr","rustc::middle::region","",17,{"inputs":[{"name":"codeextent"},{"name":"decodecontext"}],"output":{"name":"codeextent"}}],[11,"tr","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"decodecontext"}],"output":{"name":"destructionscopedata"}}],[11,"tr","rustc::middle::ty","",19,{"inputs":[{"name":"boundregion"},{"name":"decodecontext"}],"output":{"name":"boundregion"}}],[11,"read_freevar_entry","rbml::reader","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"read_capture_mode","","",20,{"inputs":[{"name":"decoder"}],"output":{"name":"captureclause"}}],[11,"tr","rustc::middle::ty","",21,{"inputs":[{"name":"freevar"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"tr","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"decodecontext"}],"output":{"name":"upvarborrow"}}],[11,"tr","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"decodecontext"}],"output":{"name":"upvarcapture"}}],[11,"read_method_callee","rbml::reader","",20,null],[11,"tr","rustc::middle::ty","",24,{"inputs":[{"name":"methodorigin"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_vec_per_param_space","rbml::reader","",20,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_res_with_key","","",20,null],[11,"read_vtable_res","","",20,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_param_res","","",20,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_vtable_origin","","",20,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[11,"ty_str_ctxt","rustc::metadata::encoder","",25,{"inputs":[{"name":"encodecontext"}],"output":{"name":"ctxt"}}],[11,"emit_closure_type","rbml::writer","",26,null],[11,"emit_method_origin","","",26,null],[11,"emit_ty","","",26,null],[11,"emit_tys","","",26,null],[11,"emit_trait_ref","","",26,null],[11,"emit_type_param_def","","",26,null],[11,"emit_predicate","","",26,null],[11,"emit_type_scheme","","",26,null],[11,"emit_existential_bounds","","",26,null],[11,"emit_builtin_bounds","","",26,null],[11,"emit_substs","","",26,null],[11,"emit_auto_adjustment","","",26,null],[11,"emit_autoref","","",26,null],[11,"emit_auto_deref_ref","","",26,null],[11,"tag","","",26,null],[11,"id","","",26,null],[11,"visit_id","rustc::middle::astencode","",27,null],[11,"as_int","rbml","",28,{"inputs":[{"name":"doc"}],"output":{"name":"isize"}}],[11,"opt_child","","",28,{"inputs":[{"name":"doc"},{"name":"astencode_tag"}],"output":{"name":"option"}}],[11,"read_ty_nodcx","rbml::reader","",20,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[11,"read_tys_nodcx","","",20,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_substs_nodcx","","",20,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"substs"}}],[11,"read_method_origin","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_ty","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"tys"}}],[11,"read_tys","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"vec"}}],[11,"read_trait_ref","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"rc"}}],[11,"read_poly_trait_ref","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"binder"}}],[11,"read_type_param_def","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typeparameterdef"}}],[11,"read_predicate","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"predicate"}}],[11,"read_type_scheme","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typescheme"}}],[11,"read_existential_bounds","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"existentialbounds"}}],[11,"read_substs","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"substs"}}],[11,"read_auto_adjustment","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoadjustment"}}],[11,"read_auto_deref_ref","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoderefref"}}],[11,"read_autoref","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoref"}}],[11,"read_closure_kind","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurekind"}}],[11,"read_closure_ty","","",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurety"}}],[11,"convert_def_id","","Converts a def-id that appears in a type.  The correct\ntranslation will depend on what kind of def-id this is.\nThis is a subtle point: type definitions are not\ninlined into the current crate, so if the def-id names\na nominal type or type alias, then it should be\ntranslated to refer to the source crate.",20,{"inputs":[{"name":"decoder"},{"name":"decodecontext"},{"name":"defidsource"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"clone","rustc::middle::cfg::construct","",29,{"inputs":[{"name":"loopscope"}],"output":{"name":"loopscope"}}],[11,"graph_id","rustc::middle::cfg::graphviz","",30,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"id"}}],[11,"node_id","","",30,null],[11,"node_label","","",30,null],[11,"edge_label","","",30,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",30,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"edges","","",30,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"source","","",30,null],[11,"target","","",30,null],[11,"eq","rustc::middle::cfg","",31,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",31,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"clone","","",31,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"cfgnodedata"}}],[11,"id","","",31,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"u32"}}],[11,"new","","",32,{"inputs":[{"name":"cfg"},{"name":"ctxt"},{"name":"block"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",32,{"inputs":[{"name":"cfg"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"hash","rustc::middle::check_const","",33,null],[11,"cmp","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"option"}}],[11,"lt","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"le","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"gt","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ge","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"clone","","",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"decode","","",33,{"inputs":[{"name":"constqualif"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",33,{"inputs":[{"name":"constqualif"},{"name":"__s"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"all","","Returns the set containing all flags.",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",33,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",33,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"constqualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",33,null],[11,"remove","","Removes the specified flags in-place.",33,null],[11,"toggle","","Toggles the specified flags in-place.",33,null],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitor","rustc::middle::check_const","Returns the union of the two sets of flags.",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitxor","rustc::middle::check_const","Returns the left flags, but with all the right flags toggled.",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitand","rustc::middle::check_const","Returns the intersection between the two sets of flags.",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"sub","rustc::middle::check_const","Returns the set difference of the two sets of flags.",33,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"not","rustc::middle::check_const","Returns the complement of this set of flags.",33,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",34,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"clone","","",34,{"inputs":[{"name":"mode"}],"output":{"name":"mode"}}],[11,"visit_item","","",35,null],[11,"visit_fn","","",35,null],[11,"visit_pat","","",35,null],[11,"visit_expr","","",35,null],[11,"consume","","",35,null],[11,"borrow","","",35,null],[11,"decl_without_init","","",35,null],[11,"mutate","","",35,null],[11,"matched_pat","","",35,null],[11,"consume_pat","","",35,null],[11,"visit_item","rustc::middle::check_static_recursion","",36,null],[11,"visit_item","","",37,null],[11,"visit_expr","","",37,null],[11,"eq","rustc::middle::check_loop","",38,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"clone","","",38,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"clone","","",39,{"inputs":[{"name":"checkloopvisitor"}],"output":{"name":"checkloopvisitor"}}],[11,"visit_item","","",39,null],[11,"visit_expr","","",39,null],[11,"fmt","rustc::middle::check_match","",40,{"inputs":[{"name":"matrix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",40,{"inputs":[{"name":"matrix"},{"name":"t"}],"output":{"name":"matrix"}}],[11,"eq","","",41,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"clone","","",41,{"inputs":[{"name":"constructor"}],"output":{"name":"constructor"}}],[11,"eq","","",42,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"usefulness"}],"output":{"name":"usefulness"}}],[11,"clone","","",43,{"inputs":[{"name":"witnesspreference"}],"output":{"name":"witnesspreference"}}],[11,"visit_expr","","",44,null],[11,"visit_local","","",44,null],[11,"visit_fn","","",44,null],[11,"new","","",45,{"inputs":[{"name":"staticinliner"},{"name":"ctxt"},{"name":"option"}],"output":{"name":"staticinliner"}}],[11,"visit_id","","",46,null],[11,"fold_pat","","",45,{"inputs":[{"name":"staticinliner"},{"name":"p"}],"output":{"name":"p"}}],[11,"matched_pat","","",47,null],[11,"consume","","",47,null],[11,"consume_pat","","",47,null],[11,"borrow","","",47,null],[11,"decl_without_init","","",47,null],[11,"mutate","","",47,null],[11,"visit_pat","","",48,null],[11,"visit_fn","rustc::middle::check_rvalues","",49,null],[11,"consume","","",50,null],[11,"matched_pat","","",50,null],[11,"consume_pat","","",50,null],[11,"borrow","","",50,null],[11,"decl_without_init","","",50,null],[11,"mutate","","",50,null],[11,"eq","rustc::middle::const_eval","",51,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"const_val"}],"output":{"name":"const_val"}}],[11,"clone","","",52,{"inputs":[{"name":"constevalerr"}],"output":{"name":"constevalerr"}}],[11,"clone","","",53,{"inputs":[{"name":"errkind"}],"output":{"name":"errkind"}}],[11,"description","","",52,{"inputs":[{"name":"constevalerr"}],"output":{"name":"cow"}}],[11,"fmt","","",54,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",54,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",54,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",54,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",55,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"from","","",54,{"inputs":[{"name":"intty"},{"name":"ctxt"},{"name":"intty"}],"output":{"name":"intty"}}],[11,"from","","",55,{"inputs":[{"name":"uintty"},{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"fmt","rustc::middle::dataflow","",56,{"inputs":[{"name":"entryorexit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",56,{"inputs":[{"name":"entryorexit"}],"output":{"name":"entryorexit"}}],[11,"clone","","",57,{"inputs":[{"name":"dataflowcontext"}],"output":{"name":"dataflowcontext"}}],[11,"pre","","",57,{"inputs":[{"name":"dataflowcontext"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"fmt","","",58,{"inputs":[{"name":"killfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",58,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"killfrom"}],"output":{"name":"killfrom"}}],[11,"new","","",57,{"inputs":[{"name":"dataflowcontext"},{"name":"ctxt"},{"name":"str"},{"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",57,null],[11,"add_kill","","Indicates that `id` kills `bit`",57,null],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`.\nOnly useful after `propagate()` has been called.",57,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`.\nOnly useful after `propagate()` has been called.",57,{"inputs":[{"name":"dataflowcontext"},{"name":"entryorexit"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",57,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow\nexits through any number of enclosing scopes on its way to\nthe new destination. This function infers the kill bits of\nthose control operators based on the kill bits associated\nwith those scopes.",57,null],[11,"propagate","","Performs the data flow analysis.",57,null],[11,"join","","",59,{"inputs":[{"name":"union"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",60,{"inputs":[{"name":"subtract"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"visit_struct_def","rustc::middle::dead","",61,null],[11,"visit_expr","","",61,null],[11,"visit_pat","","",61,null],[11,"visit_path","","",61,null],[11,"visit_item","","",61,null],[11,"visit_item","","",62,null],[11,"visit_item","","",63,null],[11,"visit_foreign_item","","",63,null],[11,"visit_fn","","",63,null],[11,"visit_struct_field","","",63,null],[11,"visit_trait_item","","",63,null],[11,"fmt","rustc::middle::def","",14,{"inputs":[{"name":"def"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",14,null],[11,"decode","","",14,{"inputs":[{"name":"def"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",14,{"inputs":[{"name":"def"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"def"}],"output":{"name":"def"}}],[11,"fmt","","",64,{"inputs":[{"name":"pathresolution"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",64,{"inputs":[{"name":"pathresolution"}],"output":{"name":"pathresolution"}}],[11,"full_def","","Get the definition, if fully resolved, otherwise panic.",64,{"inputs":[{"name":"pathresolution"}],"output":{"name":"def"}}],[11,"def_id","","Get the DefId, if fully resolved, otherwise panic.",64,{"inputs":[{"name":"pathresolution"}],"output":{"name":"defid"}}],[11,"new","","",64,{"inputs":[{"name":"pathresolution"},{"name":"def"},{"name":"lastprivate"},{"name":"usize"}],"output":{"name":"pathresolution"}}],[11,"clone","","",65,{"inputs":[{"name":"export"}],"output":{"name":"export"}}],[11,"fmt","","",66,{"inputs":[{"name":"methodprovenance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",66,null],[11,"decode","","",66,{"inputs":[{"name":"methodprovenance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",66,{"inputs":[{"name":"methodprovenance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",66,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"ne","","",66,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"clone","","",66,{"inputs":[{"name":"methodprovenance"}],"output":{"name":"methodprovenance"}}],[11,"map","","",66,{"inputs":[{"name":"methodprovenance"},{"name":"f"}],"output":{"name":"methodprovenance"}}],[11,"local_node_id","","",14,{"inputs":[{"name":"def"}],"output":{"name":"u32"}}],[11,"def_id","","",14,{"inputs":[{"name":"def"}],"output":{"name":"defid"}}],[11,"variant_def_ids","","",14,{"inputs":[{"name":"def"}],"output":{"name":"option"}}],[11,"eq","rustc::middle::effect","",67,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"unsafecontext"}],"output":{"name":"unsafecontext"}}],[11,"visit_fn","","",68,null],[11,"visit_block","","",68,null],[11,"visit_expr","","",68,null],[11,"visit_item","rustc::middle::entry","",69,null],[11,"fmt","rustc::middle::expr_use_visitor","",70,{"inputs":[{"name":"loancause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",70,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"clone","","",70,{"inputs":[{"name":"loancause"}],"output":{"name":"loancause"}}],[11,"fmt","","",71,{"inputs":[{"name":"consumemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"consumemode"}],"output":{"name":"consumemode"}}],[11,"fmt","","",72,{"inputs":[{"name":"movereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"movereason"}],"output":{"name":"movereason"}}],[11,"fmt","","",73,{"inputs":[{"name":"matchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"matchmode"}],"output":{"name":"matchmode"}}],[11,"fmt","","",74,{"inputs":[{"name":"trackmatchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"trackmatchmode"}],"output":{"name":"trackmatchmode"}}],[11,"fmt","","",75,{"inputs":[{"name":"mutatemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"mutatemode"}],"output":{"name":"mutatemode"}}],[11,"clone","","",76,{"inputs":[{"name":"overloadedcalltype"}],"output":{"name":"overloadedcalltype"}}],[11,"new","","",77,{"inputs":[{"name":"exprusevisitor"},{"name":"delegate"},{"name":"typer"}],"output":{"name":"exprusevisitor"}}],[11,"walk_fn","","",77,null],[11,"consume_expr","","",77,null],[11,"walk_expr","","",77,null],[11,"hash","rustc::middle::fast_reject","",78,null],[11,"eq","","",78,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"ne","","",78,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"clone","","",78,{"inputs":[{"name":"simplifiedtype"}],"output":{"name":"simplifiedtype"}}],[11,"clone","rustc::middle::free_region","",79,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"new","","",79,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"relate_free_regions_from_implications","","",79,null],[11,"relate_free_regions_from_predicates","","",79,null],[11,"relate_free_regions","","",79,null],[11,"sub_free_region","","Determines whether two free regions have a subregion relationship\nby walking the graph encoded in `map`.  Note that\nit is possible that `sub != sup` and `sub <= sup` and `sup <= sub`\n(that is, the user can give two different names to the same lifetime).",79,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run *after\ninference* and sadly the logic is somewhat duplicated with the code in infer.rs.",79,{"inputs":[{"name":"freeregionmap"},{"name":"ctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","rustc::middle::graph","",80,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",81,{"inputs":[{"name":"nodeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",81,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",81,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"clone","","",81,{"inputs":[{"name":"nodeindex"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",82,{"inputs":[{"name":"edgeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",82,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"edgeindex"}],"output":{"name":"edgeindex"}}],[11,"fmt","","",83,{"inputs":[{"name":"direction"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",83,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",81,{"inputs":[{"name":"nodeindex"}],"output":{"name":"usize"}}],[11,"edge_id","","Returns unique id (unique with respect to the graph holding associated edge).",82,{"inputs":[{"name":"edgeindex"}],"output":{"name":"usize"}}],[11,"new","","",84,{"inputs":[{"name":"graph"}],"output":{"name":"graph"}}],[11,"with_capacity","","",84,{"inputs":[{"name":"graph"},{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",84,null],[11,"all_edges","","",84,null],[11,"next_node_index","","",84,{"inputs":[{"name":"graph"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",84,{"inputs":[{"name":"graph"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",84,{"inputs":[{"name":"graph"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"mut_edge_data","","",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge_data","","",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge","","",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"first_adjacent","","Accesses the index of the first edge adjacent to `node`.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"next_adjacent","","Accesses the next edge in a given direction.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"each_node","","Iterates over all edges defined in the graph.",84,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_edge","","Iterates over all edges defined in the graph",84,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_outgoing_edge","","Iterates over all outgoing edges from the node `from`",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_incoming_edge","","Iterates over all incoming edges to the node `target`",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_adjacent_edge","","Iterates over all edges adjacent to the node `node`\nin the direction `dir` (either `Outgoing` or `Incoming)",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"},{"name":"f"}],"output":{"name":"bool"}}],[11,"iterate_until_fixed_point","","",84,null],[11,"depth_traverse","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"depthfirsttraversal"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::graph","",85,{"inputs":[{"name":"depthfirsttraversal"}],"output":{"name":"option"}}],[11,"source","","",80,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"target","","",80,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"visit_fn","rustc::middle::intrinsicck","",86,null],[11,"visit_expr","","",86,null],[11,"repr","rustc::middle::ty","",87,{"inputs":[{"name":"transmuterestriction"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","rustc::middle::infer::bivariate","",88,{"inputs":[{"name":"bivariate"},{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"tag","","",88,{"inputs":[{"name":"bivariate"}],"output":{"name":"str"}}],[11,"tcx","","",88,{"inputs":[{"name":"bivariate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",88,{"inputs":[{"name":"bivariate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",88,{"inputs":[{"name":"bivariate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",88,{"inputs":[{"name":"bivariate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",88,{"inputs":[{"name":"bivariate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",88,{"inputs":[{"name":"bivariate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"clone","rustc::middle::infer::combine","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"tcx","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"ctxt"}}],[11,"switch_expected","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"equate","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"bivariate","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"sub","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"lub","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"glb","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"instantiate","","",89,{"inputs":[{"name":"combinefields"},{"name":"tys"},{"name":"relationdir"},{"name":"tyvid"}],"output":{"name":"result"}}],[11,"tcx","","",90,{"inputs":[{"name":"generalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",90,{"inputs":[{"name":"generalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",90,{"inputs":[{"name":"generalizer"},{"name":"region"}],"output":{"name":"region"}}],[11,"compare","core::result","",91,{"inputs":[{"name":"result"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[11,"new","rustc::middle::infer::equate","",92,{"inputs":[{"name":"equate"},{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"tag","","",92,{"inputs":[{"name":"equate"}],"output":{"name":"str"}}],[11,"tcx","","",92,{"inputs":[{"name":"equate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",92,{"inputs":[{"name":"equate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",92,{"inputs":[{"name":"equate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",92,{"inputs":[{"name":"equate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",92,{"inputs":[{"name":"equate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",92,{"inputs":[{"name":"equate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"report_region_errors","rustc::middle::infer","",93,null],[11,"process_errors","","",93,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"report_type_error","","",93,null],[11,"report_and_explain_type_error","","",93,null],[11,"values_str","","Returns a string of the form \"expected `{}`, found `{}`\", or None if this is a derived\nerror.",93,{"inputs":[{"name":"inferctxt"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str","","",93,{"inputs":[{"name":"inferctxt"},{"name":"expected_found"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",93,null],[11,"report_concrete_failure","","",93,null],[11,"report_sub_sup_conflict","","",93,null],[11,"report_sup_sup_conflict","","",93,null],[11,"report_processed_errors","","",93,null],[11,"give_suggestion","","",93,null],[11,"give_expl_lifetime_param","","",93,null],[11,"report_inference_failure","","",93,null],[11,"note_region_origin","","",93,null],[11,"resolve","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"inferctxt"}],"output":{"name":"rc"}}],[11,"contains_error","","",94,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"resolve","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"inferctxt"}],"output":{"name":"binder"}}],[11,"contains_error","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"new","rustc::middle::infer::glb","",96,{"inputs":[{"name":"glb"},{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"tag","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"str"}}],[11,"tcx","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",96,{"inputs":[{"name":"glb"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",96,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",96,{"inputs":[{"name":"glb"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",96,{"inputs":[{"name":"glb"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",96,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"higher_ranked_sub","rustc::middle::infer::combine","",89,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_lub","","",89,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_glb","","",89,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"tainted_regions","rustc::middle::infer","",93,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any\ntypes/regions which existed before `snapshot` was\nstarted. This is used in the sub/lub/glb computations. The\nidea here is that when we are computing lub/glb of two\nregions, we sometimes create intermediate region variables.\nThose region variables may touch some of the skolemized or\nother \"forbidden\" regions we created to replace bound\nregions, but they don't really represent an \"external\"\nconstraint.",93,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"}],"output":{"name":"vec"}}],[11,"new","rustc::middle::infer::lub","",97,{"inputs":[{"name":"lub"},{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"tag","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"str"}}],[11,"tcx","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",97,{"inputs":[{"name":"lub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",97,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",97,{"inputs":[{"name":"lub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",97,{"inputs":[{"name":"lub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",97,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::region_inference::graphviz","",98,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",98,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"ne","","",98,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"hash","","",98,null],[11,"clone","","",98,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",99,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",99,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"edge"}],"output":{"name":"edge"}}],[11,"graph_id","","",100,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"id"}}],[11,"node_id","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",100,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"edges","","",100,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"source","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"fmt","rustc::middle::infer::region_inference","",101,{"inputs":[{"name":"constraint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",101,null],[11,"eq","","",101,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"clone","","",101,{"inputs":[{"name":"constraint"}],"output":{"name":"constraint"}}],[11,"eq","","",102,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",102,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"fmt","","",102,{"inputs":[{"name":"generickind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",102,{"inputs":[{"name":"generickind"}],"output":{"name":"generickind"}}],[11,"hash","","",103,null],[11,"eq","","",103,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"clone","","",103,{"inputs":[{"name":"tworegions"}],"output":{"name":"tworegions"}}],[11,"eq","","",104,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",104,{"inputs":[{"name":"undologentry"}],"output":{"name":"undologentry"}}],[11,"eq","","",105,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"clone","","",105,{"inputs":[{"name":"combinemaptype"}],"output":{"name":"combinemaptype"}}],[11,"fmt","","",106,{"inputs":[{"name":"regionresolutionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"regionresolutionerror"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",107,{"inputs":[{"name":"sameregions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"sameregions"}],"output":{"name":"sameregions"}}],[11,"contains","","",107,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"push","","",107,null],[11,"fmt","","",108,{"inputs":[{"name":"regionsnapshot"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"ctxt"}],"output":{"name":"regionvarbindings"}}],[11,"start_snapshot","","",109,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",109,null],[11,"rollback_to","","",109,null],[11,"num_vars","","",109,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"u32"}}],[11,"new_region_var","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"new_skolemized","","Creates a new skolemized region. Skolemized regions are fresh\nregions used when performing higher-ranked computations. They\nmust be used in a very particular way and are never supposed\nto \"escape\" out into error messages or the code at large.",109,{"inputs":[{"name":"regionvarbindings"},{"name":"boundregion"},{"name":"regionsnapshot"}],"output":{"name":"region"}}],[11,"new_bound","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_given","","",109,null],[11,"make_eqregion","","",109,null],[11,"make_subregion","","",109,null],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",109,null],[11,"lub_regions","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"resolve_var","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_vars","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"},{"name":"f"}],"output":{"name":"region"}}],[11,"vars_created_since_snapshot","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":{"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` in any way since the mark `mark` was\nmade---`r0` itself will be the first entry. This is used when checking whether skolemized\nregions are being improperly related to other regions.",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"resolve_regions","","This function performs the actual region resolution.  It must be\ncalled after all constraints have been added.  It performs a\nfixed-point iteration to find region values which satisfy all\nconstraints, assuming such values can be found; if they cannot,\nerrors are reported.",109,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregionmap"},{"name":"u32"}],"output":{"name":"vec"}}],[11,"fmt","","",110,{"inputs":[{"name":"classification"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",110,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"ne","","",110,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"clone","","",110,{"inputs":[{"name":"classification"}],"output":{"name":"classification"}}],[11,"clone","","",111,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"repr","","",101,{"inputs":[{"name":"constraint"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",112,{"inputs":[{"name":"verify"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",111,{"inputs":[{"name":"varvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",113,{"inputs":[{"name":"regionandorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",102,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",102,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"to_ty","","",102,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::resolve","",114,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"inferctxt"}],"output":{"name":"opportunistictyperesolver"}}],[11,"tcx","","",114,{"inputs":[{"name":"opportunistictyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",114,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"tcx","","",115,{"inputs":[{"name":"fulltyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",115,{"inputs":[{"name":"fulltyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",115,{"inputs":[{"name":"fulltyperesolver"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::infer::freshen","",116,{"inputs":[{"name":"typefreshener"},{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"tcx","","",116,{"inputs":[{"name":"typefreshener"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",116,{"inputs":[{"name":"typefreshener"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",116,{"inputs":[{"name":"typefreshener"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::sub","",117,{"inputs":[{"name":"sub"},{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"tag","","",117,{"inputs":[{"name":"sub"}],"output":{"name":"str"}}],[11,"tcx","","",117,{"inputs":[{"name":"sub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",117,{"inputs":[{"name":"sub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",117,{"inputs":[{"name":"sub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",117,{"inputs":[{"name":"sub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",117,{"inputs":[{"name":"sub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",117,{"inputs":[{"name":"sub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::type_variable","",118,{"inputs":[{"name":"relationdir"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",118,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"ne","","",118,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"clone","","",118,{"inputs":[{"name":"relationdir"}],"output":{"name":"relationdir"}}],[11,"new","","",119,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"relate_vars","","Records that `a <: b`, `a :> b`, or `a == b`, depending on `dir`.",119,null],[11,"instantiate_and_push","","Instantiates `vid` with the type `ty` and then pushes an entry onto `stack` for each of the\nrelations of `vid` to other variables. The relations will have the form `(ty, dir, vid1)`\nwhere `vid1` is some other variable id.",119,null],[11,"new_var","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"probe","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"option"}}],[11,"replace_if_possible","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"snapshot","","",119,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","",119,null],[11,"commit","","",119,null],[11,"types_escaping_snapshot","","Find the set of type variables that existed *before* `s`\nbut which have only been unified since `s` started, and\nreturn the types with which they were unified. So if we had\na type variable `V0`, then we started the snapshot, then we\ncreated a type variable `V1`, unifed `V0` with `T0`, and\nunified `V1` with `T1`, this function would return `{T0}`.",119,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":{"name":"vec"}}],[6,"Value","rustc_trans::session::config","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::type_variable","",120,null],[11,"fmt","rustc::middle::infer::unify","",121,{"inputs":[{"name":"varvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",121,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"eq","","",121,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",121,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","","",122,{"inputs":[{"name":"delegate"}],"output":{"name":"delegate"}}],[11,"new","","",123,{"inputs":[{"name":"unificationtable"}],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either\nrolled back or committed in a \"LIFO\" (stack) order.",123,{"inputs":[{"name":"unificationtable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also\nremoves any keys that have been created since then.",123,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",123,null],[11,"new_key","","",123,null],[6,"Value","rustc_trans::session::config","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::unify","",122,null],[11,"unify_var_var","","",123,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"k"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`. Because simple keys do not have any subtyping\nrelationships, if `a_id` already has a value, it must be the same as `b`.",123,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"v"}],"output":{"name":"result"}}],[11,"has_value","","",123,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"bool"}}],[11,"probe","","",123,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"option"}}],[6,"Value","rustc_trans::session::config","",null,null],[11,"index","rustc::middle::ty","",124,{"inputs":[{"name":"intvid"}],"output":{"name":"u32"}}],[11,"from_index","","",124,{"inputs":[{"name":"intvid"},{"name":"u32"}],"output":{"name":"intvid"}}],[11,"tag","","",124,{"inputs":[{"name":"intvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Value","rustc_trans::session::config","",null,null],[11,"index","rustc::middle::ty","",126,{"inputs":[{"name":"floatvid"}],"output":{"name":"u32"}}],[11,"from_index","","",126,{"inputs":[{"name":"floatvid"},{"name":"u32"}],"output":{"name":"floatvid"}}],[11,"tag","","",126,{"inputs":[{"name":"floatvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","syntax::ast","",127,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"fmt","rustc::middle::infer","",128,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",128,{"inputs":[{"name":"typeorigin"}],"output":{"name":"typeorigin"}}],[11,"fmt","","",128,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",129,{"inputs":[{"name":"valuepairs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"valuepairs"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",130,{"inputs":[{"name":"typetrace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"typetrace"}],"output":{"name":"typetrace"}}],[11,"fmt","","",131,{"inputs":[{"name":"subregionorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",131,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",132,{"inputs":[{"name":"lateboundregionconversiontime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"lateboundregionconversiontime"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",133,{"inputs":[{"name":"regionvariableorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",134,{"inputs":[{"name":"fixup_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"fixup_err"}],"output":{"name":"fixup_err"}}],[11,"freshen","","",93,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"freshener","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"unconstrainednumeric"}}],[11,"equate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"equate"}}],[11,"sub","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"sub"}}],[11,"lub","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"lub"}}],[11,"glb","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"glb"}}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"commit_regions_if_ok","","Execute `f` and commit only the region bindings if successful.\nThe function f must be very careful not to leak any non-region\nvariables that get created.",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",93,null],[11,"sub_types","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"eq_types","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"sub_trait_refs","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"sub_poly_trait_refs","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"construct_skolemized_subst","","See `higher_ranked::construct_skolemized_subst`",93,null],[11,"skolemize_late_bound_regions","","See `higher_ranked::skolemize_late_bound_regions`",93,null],[11,"leak_check","","See `higher_ranked::leak_check`",93,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"}],"output":{"name":"result"}}],[11,"plug_leaks","","See `higher_ranked::plug_leaks`",93,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"equality_predicate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"region_outlives_predicate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"next_ty_var_id","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_diverging_ty_var","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_ty_vars","","",93,{"inputs":[{"name":"inferctxt"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"next_int_var_id","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","",93,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"region_vars_for_defs","","",93,null],[11,"fresh_substs_for_generics","","Given a set of generics defined on a type or impl, returns a substitution mapping each\ntype/region parameter to a fresh inference variable.",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"fresh_substs_for_trait","","Given a set of generics defined on a trait, returns a substitution mapping each output\ntype/region parameter to a fresh inference variable, and mapping the self type to\n`self_ty`.",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"fresh_bound_region","","",93,{"inputs":[{"name":"inferctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"resolve_regions_and_report_errors","","",93,null],[11,"ty_to_string","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"string"}}],[11,"tys_to_string","","",93,null],[11,"trait_ref_to_string","","",93,{"inputs":[{"name":"inferctxt"},{"name":"rc"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in\n`value` with their final value. Note that region variables\nare unaffected. If a type variable has not been unified, it\nis left as is.  This is an idempotent operation that does\nnot affect inference state in any way and so you can do it\nat will.",93,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in\n`value`. Region inference must have been run already (e.g.,\nby calling `resolve_regions_and_report_errors`).  If some\nvariable was never unified, an `Err` results.",93,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[11,"type_error_message_str","","",93,null],[11,"type_error_message_str_with_expected","","",93,null],[11,"type_error_message","","",93,null],[11,"report_mismatched_types","","",93,null],[11,"replace_late_bound_regions_with_fresh_var","","",93,null],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_inference`",93,null],[11,"can_equate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"span","","",130,{"inputs":[{"name":"typetrace"}],"output":{"name":"span"}}],[11,"types","","",130,{"inputs":[{"name":"typetrace"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"typetrace"}}],[11,"dummy","","",130,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"typetrace"}}],[11,"repr","","",130,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",128,{"inputs":[{"name":"typeorigin"}],"output":{"name":"span"}}],[11,"repr","","",128,{"inputs":[{"name":"typeorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",131,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"span"}}],[11,"repr","","",131,{"inputs":[{"name":"subregionorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",133,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"span"}}],[11,"repr","","",133,{"inputs":[{"name":"regionvariableorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::implicator","",135,{"inputs":[{"name":"implication"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"hash","rustc::middle::lang_items","",136,null],[11,"eq","","",136,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"ne","","",136,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"clone","","",136,{"inputs":[{"name":"langitem"}],"output":{"name":"langitem"}}],[11,"from_u32","","",136,{"inputs":[{"name":"langitem"},{"name":"u32"}],"output":{"name":"option"}}],[11,"new","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"languageitems"}}],[11,"items","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"enumerate"}}],[11,"item_name","","",137,{"inputs":[{"name":"languageitems"},{"name":"usize"}],"output":{"name":"str"}}],[11,"require","","",137,{"inputs":[{"name":"languageitems"},{"name":"langitem"}],"output":{"name":"result"}}],[11,"from_builtin_kind","","",137,{"inputs":[{"name":"languageitems"},{"name":"builtinbound"}],"output":{"name":"result"}}],[11,"to_builtin_kind","","",137,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"fn_trait_kind","","",137,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"char_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"slice_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"const_ptr_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mut_ptr_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i8_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i16_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i32_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i64_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"isize_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u8_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u16_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u32_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u64_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"usize_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f32_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f64_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"send_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sized_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"copy_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sync_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"drop_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"add_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sub_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mul_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"div_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"rem_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"neg_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"not_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitxor_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitand_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitor_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shl_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shr_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_mut_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_from_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_to_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_full_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"unsafe_cell_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_mut_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_mut_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_once_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eq_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"ord_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_eq_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_bounds_check_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fmt","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_malloc_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_free_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"strdup_uniq_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"start_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eh_personality","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_heap","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"owned_box","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"phantom_data","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_lifetime","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_lifetime","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_lifetime","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"no_copy_bound","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"managed_bound","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"non_zero","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"stack_exhausted","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"debug_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"visit_item","","",138,null],[11,"new","","",138,{"inputs":[{"name":"languageitemcollector"},{"name":"session"}],"output":{"name":"languageitemcollector"}}],[11,"collect_item","","",138,null],[11,"collect_local_language_items","","",138,null],[11,"collect_external_language_items","","",138,null],[11,"collect","","",138,null],[11,"eq","rustc::middle::liveness","",139,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"variable"}],"output":{"name":"variable"}}],[11,"eq","","",140,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"fmt","","",141,{"inputs":[{"name":"livenodekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",141,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"livenodekind"}],"output":{"name":"livenodekind"}}],[11,"visit_fn","","",142,null],[11,"visit_local","","",142,null],[11,"visit_expr","","",142,null],[11,"visit_arm","","",142,null],[11,"fmt","","",140,{"inputs":[{"name":"livenode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",139,{"inputs":[{"name":"variable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"localinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",143,{"inputs":[{"name":"localinfo"}],"output":{"name":"localinfo"}}],[11,"fmt","","",144,{"inputs":[{"name":"varkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"varkind"}],"output":{"name":"varkind"}}],[11,"visit_fn","","",145,null],[11,"visit_local","","",145,null],[11,"visit_expr","","",145,null],[11,"visit_arm","","",145,null],[11,"clone","","",146,{"inputs":[{"name":"users"}],"output":{"name":"users"}}],[11,"clone","","",147,{"inputs":[{"name":"specials"}],"output":{"name":"specials"}}],[11,"fmt","rustc::middle::mem_categorization","",148,{"inputs":[{"name":"categorization"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",148,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",148,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",148,{"inputs":[{"name":"categorization"}],"output":{"name":"categorization"}}],[11,"fmt","","",149,{"inputs":[{"name":"upvar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",149,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",149,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",149,{"inputs":[{"name":"upvar"}],"output":{"name":"upvar"}}],[11,"fmt","","",150,{"inputs":[{"name":"pointerkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",150,null],[11,"eq","","",150,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",150,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"clone","","",150,{"inputs":[{"name":"pointerkind"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",151,{"inputs":[{"name":"interiorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",151,null],[11,"eq","","",151,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"clone","","",151,{"inputs":[{"name":"interiorkind"}],"output":{"name":"interiorkind"}}],[11,"fmt","","",152,{"inputs":[{"name":"fieldname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",152,null],[11,"eq","","",152,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"fieldname"}],"output":{"name":"fieldname"}}],[11,"fmt","","",153,{"inputs":[{"name":"interioroffsetkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",153,null],[11,"eq","","",153,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"interioroffsetkind"}],"output":{"name":"interioroffsetkind"}}],[11,"fmt","","",154,{"inputs":[{"name":"elementkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",154,null],[11,"eq","","",154,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"clone","","",154,{"inputs":[{"name":"elementkind"}],"output":{"name":"elementkind"}}],[11,"fmt","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",155,null],[11,"eq","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"fmt","","",156,{"inputs":[{"name":"note"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",156,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"note"}],"output":{"name":"note"}}],[11,"fmt","","",157,{"inputs":[{"name":"cmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",157,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"clone","","",157,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"clone","","",158,{"inputs":[{"name":"deref_kind"}],"output":{"name":"deref_kind"}}],[11,"id","syntax::ast","",159,{"inputs":[{"name":"expr"}],"output":{"name":"u32"}}],[11,"span","","",159,{"inputs":[{"name":"expr"}],"output":{"name":"span"}}],[11,"id","","",160,{"inputs":[{"name":"pat"}],"output":{"name":"u32"}}],[11,"span","","",160,{"inputs":[{"name":"pat"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",161,{"inputs":[{"name":"memcategorizationcontext"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"is_immutable","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"to_user_str","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"str"}}],[11,"new","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"typer"}],"output":{"name":"memcategorizationcontext"}}],[11,"cat_expr","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_expr_autoderefd","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"},{"name":"usize"}],"output":{"name":"result"}}],[11,"cat_expr_unadjusted","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_def","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"},{"name":"def"}],"output":{"name":"result"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`.\nThis could be `'static` if `id` is part of a constant expression.",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_rvalue","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"region"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_field","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"name"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_tup_field","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"usize"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"interioroffsetkind"}],"output":{"name":"result"}}],[11,"cat_slice_pattern","","Given a pattern P like: `[_, ..Q, _]`, where `vec_cmt` is the cmt for `P`, `slice_pat` is\nthe pattern `Q`, returns:",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"}],"output":{"name":"result"}}],[11,"cat_imm_interior","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"interiorkind"}],"output":{"name":"rc"}}],[11,"cat_downcast","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"defid"}],"output":{"name":"rc"}}],[11,"cat_pattern","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"},{"name":"f"}],"output":{"name":"result"}}],[11,"fmt","","",162,{"inputs":[{"name":"interiorsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",162,{"inputs":[{"name":"interiorsafety"}],"output":{"name":"interiorsafety"}}],[11,"fmt","","",163,{"inputs":[{"name":"aliasability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",163,{"inputs":[{"name":"aliasability"}],"output":{"name":"aliasability"}}],[11,"fmt","","",164,{"inputs":[{"name":"aliasablereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",164,{"inputs":[{"name":"aliasablereason"}],"output":{"name":"aliasablereason"}}],[11,"guarantor","","Returns `self` after stripping away any owned pointer derefs or\ninterior content. The return value is basically the `cmt` which\ndetermines how long the value in `self` remains live.",157,{"inputs":[{"name":"cmt_"}],"output":{"name":"rc"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this lvalue represents a freely aliasable pointer type.",157,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"aliasability"}}],[11,"upvar","","",157,{"inputs":[{"name":"cmt_"}],"output":{"name":"option"}}],[11,"descriptive_string","","",157,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",157,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",148,{"inputs":[{"name":"categorization"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",150,{"inputs":[{"name":"pointerkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",151,{"inputs":[{"name":"interiorkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",165,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::mem_categorization","",149,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",149,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::privacy","",166,{"inputs":[{"name":"lastprivate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",166,{"inputs":[{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"fmt","","",167,{"inputs":[{"name":"privatedep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",167,{"inputs":[{"name":"privatedep"}],"output":{"name":"privatedep"}}],[11,"fmt","","",168,{"inputs":[{"name":"importuse"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",168,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"ne","","",168,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"clone","","",168,{"inputs":[{"name":"importuse"}],"output":{"name":"importuse"}}],[11,"or","","",166,{"inputs":[{"name":"lastprivate"},{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"visit_expr","rustc::middle::reachable","",169,null],[11,"visit_item","","",169,null],[11,"fmt","rustc::middle::region","",17,{"inputs":[{"name":"codeextent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"codeextent"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"codeextent"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",17,null],[11,"cmp","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"lt","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"le","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"gt","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ge","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"eq","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"fmt","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",18,null],[11,"cmp","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"eq","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"destructionscopedata"}}],[11,"new","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"u32"}],"output":{"name":"destructionscopedata"}}],[11,"to_code_extent","","",18,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"codeextent"}}],[11,"fmt","","",170,{"inputs":[{"name":"blockremainder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",170,{"inputs":[{"name":"blockremainder"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",170,{"inputs":[{"name":"blockremainder"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",170,null],[11,"cmp","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"option"}}],[11,"lt","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"eq","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"clone","","",170,{"inputs":[{"name":"blockremainder"}],"output":{"name":"blockremainder"}}],[11,"from_node_id","","Creates a scope that represents the dynamic extent associated\nwith `node_id`.",17,{"inputs":[{"name":"codeextent"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"node_id","","Returns a node id associated with this scope.",17,{"inputs":[{"name":"codeextent"}],"output":{"name":"u32"}}],[11,"map_id","","Maps this scope to a potentially new one according to the\nNodeId transformer `f_id`.",17,{"inputs":[{"name":"codeextent"},{"name":"f"}],"output":{"name":"codeextent"}}],[11,"span","","Returns the span of this CodeExtent.  Note that in general the\nreturned span may not correspond to the span of any node id in\nthe AST.",17,{"inputs":[{"name":"codeextent"},{"name":"map"}],"output":{"name":"option"}}],[11,"clone","","",171,{"inputs":[{"name":"innermostdeclaringblock"}],"output":{"name":"innermostdeclaringblock"}}],[11,"fmt","","",171,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",171,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"ne","","",171,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"clone","","",172,{"inputs":[{"name":"declaringstatementcontext"}],"output":{"name":"declaringstatementcontext"}}],[11,"fmt","","",172,{"inputs":[{"name":"declaringstatementcontext"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",172,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"ne","","",172,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"clone","","",173,{"inputs":[{"name":"innermostenclosingexpr"}],"output":{"name":"innermostenclosingexpr"}}],[11,"fmt","","",173,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",173,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"ne","","",173,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"clone","","",174,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"fmt","","",174,{"inputs":[{"name":"context"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"each_encl_scope","","",175,null],[11,"each_var_scope","","",175,null],[11,"each_rvalue_scope","","",175,null],[11,"each_terminating_scope","","",175,null],[11,"record_encl_scope","","",175,null],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",175,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",175,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",175,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"region"}}],[11,"scopes_intersect","","",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false\notherwise.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest\nscope which is greater than or equal to both `scope_a` and `scope_b`.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"visit_block","","",176,null],[11,"visit_item","","",176,null],[11,"visit_fn","","",176,null],[11,"visit_arm","","",176,null],[11,"visit_pat","","",176,null],[11,"visit_stmt","","",176,null],[11,"visit_expr","","",176,null],[11,"visit_local","","",176,null],[11,"fmt","rustc::middle::resolve_lifetime","",177,{"inputs":[{"name":"defregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",177,{"inputs":[{"name":"defregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",177,{"inputs":[{"name":"defregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",177,null],[11,"eq","","",177,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"ne","","",177,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"clone","","",177,{"inputs":[{"name":"defregion"}],"output":{"name":"defregion"}}],[11,"visit_item","","",178,null],[11,"visit_fn","","",178,null],[11,"visit_ty","","",178,null],[11,"visit_trait_item","","",178,null],[11,"visit_block","","",178,null],[11,"visit_lifetime_ref","","",178,null],[11,"visit_generics","","",178,null],[11,"visit_poly_trait_ref","","",178,null],[11,"eq","","",179,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"ne","","",179,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"clone","","",179,{"inputs":[{"name":"shadowkind"}],"output":{"name":"shadowkind"}}],[11,"fmt","","",180,{"inputs":[{"name":"scopechain"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"visit_item","rustc::middle::stability","",181,null],[11,"visit_fn","","",181,null],[11,"visit_trait_item","","",181,null],[11,"visit_impl_item","","",181,null],[11,"visit_variant","","",181,null],[11,"visit_struct_field","","",181,null],[11,"visit_foreign_item","","",181,null],[11,"build","","Construct the stability index for a crate being compiled.",182,null],[11,"new","","",182,{"inputs":[{"name":"index"},{"name":"crate"}],"output":{"name":"index"}}],[11,"visit_item","","",183,null],[11,"visit_expr","","",183,null],[11,"visit_path","","",183,null],[11,"visit_pat","","",183,null],[11,"fmt","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",184,null],[11,"eq","","",184,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"ne","","",184,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"fmt","","",185,{"inputs":[{"name":"regionsubsts"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",185,null],[11,"eq","","",185,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"clone","","",185,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"regionsubsts"}}],[11,"new","","",184,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"new_type","","",184,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"new_trait","","",184,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erased","","",184,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"empty","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"trans_empty","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"is_noop","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"type_for_def","","",184,{"inputs":[{"name":"substs"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[11,"has_regions_escaping_depth","","",184,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"self_ty","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"option"}}],[11,"with_self_ty","","",184,{"inputs":[{"name":"substs"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erase_regions","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",184,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"mut_regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",184,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"with_method","","",184,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"is_erased","","",185,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"fmt","","",186,{"inputs":[{"name":"paramspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",186,{"inputs":[{"name":"paramspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",186,{"inputs":[{"name":"paramspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",186,null],[11,"clone","","",186,{"inputs":[{"name":"paramspace"}],"output":{"name":"paramspace"}}],[11,"eq","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ne","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"cmp","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"lt","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"le","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"gt","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ge","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"all","","",186,null],[11,"to_uint","","",186,{"inputs":[{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"from_uint","","",186,{"inputs":[{"name":"paramspace"},{"name":"usize"}],"output":{"name":"paramspace"}}],[11,"decode","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",187,null],[11,"clone","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"eq","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"ne","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"fmt","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"params_from_type","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"new","","`t` is the type space.\n`s` is the self space.\n`a` is the assoc space.\n`f` is the fn space.",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"push","","Appends `value` to the vector associated with `space`.",187,null],[11,"extend","","Appends `values` to the vector associated with `space`.",187,null],[11,"pop","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"truncate","","",187,null],[11,"replace","","",187,null],[11,"get_self","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"option"}}],[11,"len","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"is_empty_in","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"get_slice","","",187,null],[11,"get_mut_slice","","",187,null],[11,"opt_get","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"t"}}],[11,"iter","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"iter"}}],[11,"into_iter","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[11,"iter_enumerated","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"enumerateditems"}}],[11,"as_slice","","",187,null],[11,"into_vec","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vec"}}],[11,"all_vecs","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"all","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"any","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"is_empty","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"map","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_enumerated","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_move","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"split","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"separatevecsperparamspace"}}],[11,"with_vec","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"clone","","",188,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"enumerateditems"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::subst","",188,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"option"}}],[6,"Item","rustc_trans::session::config","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","rustc::middle::subst","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[6,"Item","rustc_trans::session::config","",null,null],[6,"IntoIter","","",null,null],[11,"tcx","rustc::middle::subst","",189,{"inputs":[{"name":"substfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",189,null],[11,"exit_region_binder","","",189,null],[11,"fold_region","","",189,{"inputs":[{"name":"substfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",189,{"inputs":[{"name":"substfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","rustc::middle::traits::coherence","",190,{"inputs":[{"name":"inferislocal"}],"output":{"name":"inferislocal"}}],[11,"clone","rustc::middle::traits::fulfill","",191,{"inputs":[{"name":"regionobligation"}],"output":{"name":"regionobligation"}}],[11,"new","","",192,{"inputs":[{"name":"fulfillmentcontext"}],"output":{"name":"fulfillmentcontext"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by\ncreating a fresh type variable `$0` as well as a projection\npredicate `<SomeType as SomeTrait>::X == $0`. When the\ninference engine runs, it will attempt to find an impl of\n`SomeTrait` or a where clause that lets us unify `$0` with\nsomething concrete. If this fails, we'll unify `$0` with\n`projection_ty` again.",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"tys"}}],[11,"register_builtin_bound","","",192,null],[11,"register_region_obligation","","",192,null],[11,"register_predicate_obligation","","",192,null],[11,"region_obligations","","",192,null],[11,"select_all_or_error","","",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_new_obligations","","Attempts to select obligations that were registered since the call to a selection routine.\nThis is used by the type checker to eagerly attempt to resolve obligations in hopes of\ngaining type information. It'd be equally valid to use `select_where_possible` but it\nresults in `O(n^2)` performance (#18208).",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_where_possible","","",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"pending_obligations","","",192,null],[11,"repr","","",191,{"inputs":[{"name":"regionobligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::project","",193,{"inputs":[{"name":"mismatchedprojectiontypes"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"eq","","",194,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"ne","","",194,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"tcx","","",195,{"inputs":[{"name":"associatedtypenormalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",195,{"inputs":[{"name":"associatedtypenormalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","","",196,{"inputs":[{"name":"normalized"}],"output":{"name":"normalized"}}],[11,"with","","",196,{"inputs":[{"name":"normalized"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"repr","","",197,{"inputs":[{"name":"projectiontyerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",194,{"inputs":[{"name":"projectiontycandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","","",196,{"inputs":[{"name":"normalized"},{"name":"f"}],"output":{"name":"normalized"}}],[11,"repr","","",196,{"inputs":[{"name":"normalized"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::traits::object_safety","",198,{"inputs":[{"name":"methodviolationcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",198,{"inputs":[{"name":"methodviolationcode"}],"output":{"name":"methodviolationcode"}}],[11,"repr","","",199,{"inputs":[{"name":"objectsafetyviolation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::select","",200,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"fmt","","",201,{"inputs":[{"name":"methodmatcheddata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",201,{"inputs":[{"name":"methodmatcheddata"}],"output":{"name":"methodmatcheddata"}}],[11,"clone","","",202,{"inputs":[{"name":"selectioncandidate"}],"output":{"name":"selectioncandidate"}}],[11,"fmt","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"ne","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"fmt","","",203,{"inputs":[{"name":"evaluationresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",204,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",204,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"infcx","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"ctxt"}}],[11,"param_env","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"parameterenvironment"}}],[11,"closure_typer","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"closuretyper"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding\ntype environment by performing unification.",204,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"result"}}],[11,"evaluate_obligation","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",204,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"evaluate_impl","","Evaluates whether the impl with id `impl_def_id` could be applied to the self type\n`obligation_self_ty`. This can be used either for trait or inherent impls.",204,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"repr","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","","",200,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"clone","","",205,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"traitobligationstacklist"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::traits::select","",205,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"option"}}],[11,"repr","","",206,{"inputs":[{"name":"traitobligationstack"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"may_apply","","",207,{"inputs":[{"name":"methodmatchresult"}],"output":{"name":"bool"}}],[11,"filter_to_traits","rustc::middle::traits::util","",208,{"inputs":[{"name":"elaborator"}],"output":{"name":"filtertotraits"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::traits::util","",208,{"inputs":[{"name":"elaborator"}],"output":{"name":"option"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::traits::util","",209,{"inputs":[{"name":"supertraitdefids"}],"output":{"name":"option"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::traits::util","",210,{"inputs":[{"name":"filtertotraits"}],"output":{"name":"option"}}],[11,"fmt","rustc::middle::traits","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",213,{"inputs":[{"name":"obligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",214,{"inputs":[{"name":"vtable"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",217,{"inputs":[{"name":"selectionerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",218,{"inputs":[{"name":"fulfillmenterror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",219,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",219,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","rustc::middle::traits::project","",193,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",193,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","rustc::middle::traits","",213,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"clone","","",213,{"inputs":[{"name":"obligation"}],"output":{"name":"obligation"}}],[11,"eq","","",220,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",220,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",220,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"eq","","",221,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",221,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"clone","","",221,{"inputs":[{"name":"obligationcausecode"}],"output":{"name":"obligationcausecode"}}],[11,"eq","","",222,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",222,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",222,{"inputs":[{"name":"derivedobligationcause"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",217,{"inputs":[{"name":"selectionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",217,{"inputs":[{"name":"selectionerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",219,{"inputs":[{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",214,{"inputs":[{"name":"vtable"}],"output":{"name":"vtable"}}],[11,"fmt","","",214,{"inputs":[{"name":"vtable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"clone","","",211,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"vtableimpldata"}}],[11,"clone","","",216,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fmt","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",215,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"vtablebuiltindata"}}],[11,"fmt","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",212,{"inputs":[{"name":"vtableobjectdata"}],"output":{"name":"vtableobjectdata"}}],[11,"eq","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"new","","",213,{"inputs":[{"name":"obligation"},{"name":"obligationcause"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",213,{"inputs":[{"name":"obligation"},{"name":"span"},{"name":"u32"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",213,{"inputs":[{"name":"obligation"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",220,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",220,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",220,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"iter_nested","","",214,{"inputs":[{"name":"vtable"}],"output":{"name":"iter"}}],[11,"map_nested","","",214,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"map_move_nested","","",214,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"iter_nested","","",211,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"map_move_nested","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"iter_nested","","",216,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"map_move_nested","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"iter_nested","","",215,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"iter"}}],[11,"map_nested","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"map_move_nested","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"hash","rustc::middle::ty","",223,null],[11,"eq","","",223,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",223,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",223,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",224,{"inputs":[{"name":"implortraititemcontainer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",224,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"implortraititemcontainer"}}],[11,"id","","",224,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"defid"}}],[11,"fmt","","",225,{"inputs":[{"name":"implortraititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititem"}}],[11,"def_id","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"defid"}}],[11,"name","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"name"}}],[11,"container","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititemcontainer"}}],[11,"as_opt_method","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"option"}}],[11,"fmt","","",226,{"inputs":[{"name":"implortraititemid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",226,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"implortraititemid"}}],[11,"def_id","","",226,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"defid"}}],[11,"fmt","","",227,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",227,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"new","","",227,{"inputs":[{"name":"method"},{"name":"name"},{"name":"generics"},{"name":"genericpredicates"},{"name":"barefnty"},{"name":"explicitselfcategory"},{"name":"visibility"},{"name":"defid"},{"name":"implortraititemcontainer"},{"name":"option"}],"output":{"name":"method"}}],[11,"container_id","","",227,{"inputs":[{"name":"method"}],"output":{"name":"defid"}}],[11,"fmt","","",228,{"inputs":[{"name":"associatedtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",228,{"inputs":[{"name":"associatedtype"}],"output":{"name":"associatedtype"}}],[11,"fmt","","",229,{"inputs":[{"name":"mt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",229,null],[11,"eq","","",229,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"ne","","",229,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"clone","","",229,{"inputs":[{"name":"mt"}],"output":{"name":"mt"}}],[11,"fmt","","",230,{"inputs":[{"name":"field_ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",230,{"inputs":[{"name":"field_ty"}],"output":{"name":"field_ty"}}],[11,"hash","","",231,null],[11,"eq","","",231,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"ne","","",231,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"clone","","",231,{"inputs":[{"name":"creader_cache_key"}],"output":{"name":"creader_cache_key"}}],[11,"encode","","",232,{"inputs":[{"name":"itemvariances"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",232,{"inputs":[{"name":"itemvariances"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",232,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"ne","","",232,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"clone","","",232,{"inputs":[{"name":"itemvariances"}],"output":{"name":"itemvariances"}}],[11,"fmt","","",233,{"inputs":[{"name":"variance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",233,{"inputs":[{"name":"variance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",233,{"inputs":[{"name":"variance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",233,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"ne","","",233,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"clone","","",233,{"inputs":[{"name":"variance"}],"output":{"name":"variance"}}],[11,"fmt","","",234,{"inputs":[{"name":"autoadjustment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",234,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"autoadjustment"}}],[11,"fmt","","",235,{"inputs":[{"name":"autoderefref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",235,{"inputs":[{"name":"autoderefref"}],"output":{"name":"autoderefref"}}],[11,"fmt","","",236,{"inputs":[{"name":"autoref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",236,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"ne","","",236,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"clone","","",236,{"inputs":[{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fmt","","",237,{"inputs":[{"name":"param_index"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"option"}}],[11,"lt","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"le","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"gt","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ge","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"eq","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ne","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"decode","","",237,{"inputs":[{"name":"param_index"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",237,{"inputs":[{"name":"param_index"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",237,{"inputs":[{"name":"param_index"}],"output":{"name":"param_index"}}],[11,"fmt","","",24,{"inputs":[{"name":"methodorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"methodorigin"}],"output":{"name":"methodorigin"}}],[11,"fmt","","",238,{"inputs":[{"name":"methodparam"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"methodparam"}],"output":{"name":"methodparam"}}],[11,"fmt","","",239,{"inputs":[{"name":"methodobject"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",239,{"inputs":[{"name":"methodobject"}],"output":{"name":"methodobject"}}],[11,"clone","","",240,{"inputs":[{"name":"methodcallee"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",241,{"inputs":[{"name":"methodcall"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",241,null],[11,"eq","","",241,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"ne","","",241,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"clone","","",241,{"inputs":[{"name":"methodcall"}],"output":{"name":"methodcall"}}],[11,"expr","","",241,{"inputs":[{"name":"methodcall"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"autoderef","","",241,{"inputs":[{"name":"methodcall"},{"name":"u32"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"clone","","",242,{"inputs":[{"name":"vtable_origin"}],"output":{"name":"vtable_origin"}}],[11,"clone","","",87,{"inputs":[{"name":"transmuterestriction"}],"output":{"name":"transmuterestriction"}}],[11,"new","","",243,{"inputs":[{"name":"ctxtarenas"}],"output":{"name":"ctxtarenas"}}],[11,"node_types","","",244,{"inputs":[{"name":"ctxt"}],"output":{"name":"ref"}}],[11,"node_type_insert","","",244,null],[11,"store_free_region_map","","",244,null],[11,"free_region_map","","",244,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"freeregionmap"}}],[11,"hash","","",245,null],[11,"cmp","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"option"}}],[11,"lt","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"clone","","",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"eq","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",245,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",245,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",245,null],[11,"remove","","Removes the specified flags in-place.",245,null],[11,"toggle","","Toggles the specified flags in-place.",245,null],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitor","rustc::middle::ty","Returns the union of the two sets of flags.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitxor","rustc::middle::ty","Returns the left flags, but with all the right flags toggled.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitand","rustc::middle::ty","Returns the intersection between the two sets of flags.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"sub","rustc::middle::ty","Returns the set difference of the two sets of flags.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"not","rustc::middle::ty","Returns the complement of this set of flags.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"print_debug_stats","","",244,null],[11,"fmt","","",246,{"inputs":[{"name":"tys"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",245,{"inputs":[{"name":"typeflags"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",246,{"inputs":[{"name":"tys"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",246,null],[11,"eq","","",247,{"inputs":[{"name":"internedty"},{"name":"internedty"}],"output":{"name":"bool"}}],[11,"hash","","",247,null],[11,"borrow","","",247,{"inputs":[{"name":"internedty"}],"output":{"name":"sty"}}],[11,"fmt","","",248,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",248,null],[11,"eq","","",248,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",248,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",248,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",249,{"inputs":[{"name":"closurety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",249,null],[11,"eq","","",249,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"ne","","",249,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"clone","","",249,{"inputs":[{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fmt","","",250,{"inputs":[{"name":"fnoutput"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",250,null],[11,"eq","","",250,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"ne","","",250,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"clone","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"diverges","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"unwrap","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"tys"}}],[11,"unwrap_or","","",250,{"inputs":[{"name":"fnoutput"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"diverges","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"hash","","",251,null],[11,"eq","","",251,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",251,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"clone","","",251,{"inputs":[{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"inputs","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"input","","",95,{"inputs":[{"name":"binder"},{"name":"usize"}],"output":{"name":"binder"}}],[11,"output","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"variadic","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"fmt","","",252,{"inputs":[{"name":"paramty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",252,null],[11,"eq","","",252,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",252,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"clone","","",252,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"fmt","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",253,null],[11,"eq","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"clone","","",253,{"inputs":[{"name":"debruijnindex"}],"output":{"name":"debruijnindex"}}],[11,"fmt","","",15,{"inputs":[{"name":"region"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",15,{"inputs":[{"name":"region"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"region"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",15,null],[11,"eq","","",15,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"region"}],"output":{"name":"region"}}],[11,"fmt","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",254,null],[11,"eq","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"clone","","",254,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"earlyboundregion"}}],[11,"fmt","","",255,{"inputs":[{"name":"upvarid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",255,null],[11,"eq","","",255,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",255,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"clone","","",255,{"inputs":[{"name":"upvarid"}],"output":{"name":"upvarid"}}],[11,"decode","","",256,{"inputs":[{"name":"borrowkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",256,{"inputs":[{"name":"borrowkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",256,{"inputs":[{"name":"borrowkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",256,null],[11,"eq","","",256,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",256,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"clone","","",256,{"inputs":[{"name":"borrowkind"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"upvarcapture"}],"output":{"name":"upvarcapture"}}],[11,"eq","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"fmt","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"upvarborrow"}],"output":{"name":"upvarborrow"}}],[11,"eq","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"is_bound","","",15,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",15,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"fmt","","",16,{"inputs":[{"name":"freeregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"freeregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"freeregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",16,null],[11,"cmp","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"option"}}],[11,"lt","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"eq","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"freeregion"}],"output":{"name":"freeregion"}}],[11,"fmt","","",19,{"inputs":[{"name":"boundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"boundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",19,{"inputs":[{"name":"boundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",19,null],[11,"cmp","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"lt","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"eq","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"boundregion"}],"output":{"name":"boundregion"}}],[11,"fmt","","",257,{"inputs":[{"name":"sty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",257,null],[11,"eq","","",257,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"clone","","",257,{"inputs":[{"name":"sty"}],"output":{"name":"sty"}}],[11,"fmt","","",258,{"inputs":[{"name":"tytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",258,null],[11,"eq","","",258,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"clone","","",258,{"inputs":[{"name":"tytrait"}],"output":{"name":"tytrait"}}],[11,"principal_def_id","","",258,{"inputs":[{"name":"tytrait"}],"output":{"name":"defid"}}],[11,"principal_trait_ref_with_self_ty","","Object types don't have a self-type specified. Therefore, when\nwe convert the principal trait-ref into a normal trait-ref,\nyou must give *some* self-type. A common choice is `mk_err()`\nor some skolemized type.",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"binder"}}],[11,"projection_bounds_with_self_ty","","",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"vec"}}],[11,"fmt","","",259,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",259,null],[11,"eq","","",259,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"self_ty","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"tys"}}],[11,"def_id","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"substs","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"substs"}}],[11,"input_types","","",95,null],[11,"to_poly_trait_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"fmt","","",95,{"inputs":[{"name":"binder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",95,null],[11,"eq","","",95,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",95,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"clone","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a\nrisky thing to do because it's easy to get confused about\ndebruijn indices and the like. It is usually better to\ndischarge the binder using `no_late_bound_regions` or\n`replace_late_bound_regions` or something like\nthat. `skip_binder` is only valid when you are either\nextracting data that has nothing to do with bound regions, you\nare doing some sort of test that does not involve bound\nregions, or you are being very careful about your depth\naccounting.",95,{"inputs":[{"name":"binder"}],"output":{"name":"t"}}],[11,"as_ref","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",95,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",95,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"eq","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"intvarvalue"}],"output":{"name":"intvarvalue"}}],[11,"fmt","","",260,{"inputs":[{"name":"terr_vstore_kind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",260,{"inputs":[{"name":"terr_vstore_kind"}],"output":{"name":"terr_vstore_kind"}}],[11,"fmt","","",261,{"inputs":[{"name":"expected_found"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",261,{"inputs":[{"name":"expected_found"}],"output":{"name":"expected_found"}}],[11,"fmt","","",262,{"inputs":[{"name":"type_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",262,{"inputs":[{"name":"type_err"}],"output":{"name":"type_err"}}],[11,"fmt","","",263,{"inputs":[{"name":"parambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",263,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"hash","","",263,null],[11,"eq","","",263,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"ne","","",263,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"fmt","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",264,{"inputs":[{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"hash","","",264,null],[11,"eq","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"ne","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"fmt","","",265,{"inputs":[{"name":"builtinbound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",265,null],[11,"decode","","",265,{"inputs":[{"name":"builtinbound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",265,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"encode","","",265,{"inputs":[{"name":"builtinbound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",265,{"inputs":[{"name":"builtinbound"}],"output":{"name":"builtinbound"}}],[11,"to_usize","","",265,{"inputs":[{"name":"builtinbound"}],"output":{"name":"usize"}}],[11,"from_usize","","",265,{"inputs":[{"name":"builtinbound"},{"name":"usize"}],"output":{"name":"builtinbound"}}],[11,"hash","","",266,null],[11,"eq","","",266,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",266,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"clone","","",266,{"inputs":[{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"hash","","",124,null],[11,"eq","","",124,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",124,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"clone","","",124,{"inputs":[{"name":"intvid"}],"output":{"name":"intvid"}}],[11,"hash","","",126,null],[11,"eq","","",126,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"floatvid"}],"output":{"name":"floatvid"}}],[11,"hash","","",267,null],[11,"decode","","",267,{"inputs":[{"name":"regionvid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",267,{"inputs":[{"name":"regionvid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",267,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",267,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"clone","","",267,{"inputs":[{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"hash","","",268,null],[11,"eq","","",268,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",268,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"clone","","",268,{"inputs":[{"name":"inferty"}],"output":{"name":"inferty"}}],[11,"fmt","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",269,null],[11,"eq","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"ne","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"decode","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",269,{"inputs":[{"name":"unconstrainednumeric"}],"output":{"name":"unconstrainednumeric"}}],[11,"fmt","","",270,{"inputs":[{"name":"inferregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",270,null],[11,"decode","","",270,{"inputs":[{"name":"inferregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",270,{"inputs":[{"name":"inferregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",270,{"inputs":[{"name":"inferregion"}],"output":{"name":"inferregion"}}],[11,"eq","","",270,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"ne","","",270,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"fmt","","",266,{"inputs":[{"name":"tyvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",124,{"inputs":[{"name":"intvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",126,{"inputs":[{"name":"floatvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",267,{"inputs":[{"name":"regionvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",251,{"inputs":[{"name":"fnsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",268,{"inputs":[{"name":"inferty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",271,{"inputs":[{"name":"objectlifetimedefault"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",271,{"inputs":[{"name":"objectlifetimedefault"}],"output":{"name":"objectlifetimedefault"}}],[11,"fmt","","",272,{"inputs":[{"name":"typeparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",272,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"typeparameterdef"}}],[11,"fmt","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",273,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"regionparameterdef"}}],[11,"decode","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"to_early_bound_region","","",273,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"to_bound_region","","",273,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"boundregion"}}],[11,"fmt","","",274,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",274,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"empty","","",274,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_empty","","",274,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"has_type_params","","",274,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"has_region_params","","",274,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"fmt","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",275,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"empty","","",275,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_supertrait","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"instantiatedpredicates"}}],[11,"fmt","","",276,{"inputs":[{"name":"predicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",276,null],[11,"eq","","",276,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",276,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"clone","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substituion suitable for going from a\npoly-trait-ref to supertraits that must hold if that\npoly-trait-ref holds. This is slightly different from a normal\nsubstitution in terms of what happens with bound regions.  See\nlengthy comment below for details.",276,{"inputs":[{"name":"predicate"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"predicate"}}],[11,"fmt","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",277,null],[11,"eq","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"traitpredicate"}}],[11,"def_id","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"defid"}}],[11,"input_types","","",277,null],[11,"self_ty","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"tys"}}],[11,"def_id","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"fmt","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",278,null],[11,"eq","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",278,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"equatepredicate"}}],[11,"fmt","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",279,null],[11,"eq","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"clone","","",279,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"outlivespredicate"}}],[11,"fmt","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",280,null],[11,"eq","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",280,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"projectionpredicate"}}],[11,"item_name","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"name"}}],[11,"sort_key","","",95,null],[11,"fmt","","",281,{"inputs":[{"name":"projectionty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",281,null],[11,"eq","","",281,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",281,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"clone","","",281,{"inputs":[{"name":"projectionty"}],"output":{"name":"projectionty"}}],[11,"sort_key","","",281,null],[11,"to_poly_trait_ref","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","rustc::middle::ty","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"as_predicate","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"predicate"}}],[11,"as_predicate","rustc::middle::ty","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all\ncases this is skipping over a binder, so late-bound regions\nwith depth 0 are bound by the predicate.",276,{"inputs":[{"name":"predicate"}],"output":{"name":"intoiter"}}],[11,"has_escaping_regions","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"to_opt_poly_trait_ref","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"option"}}],[11,"fmt","","",282,{"inputs":[{"name":"instantiatedpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"has_escaping_regions","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"is_empty","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"new","","",259,{"inputs":[{"name":"traitref"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"tys"}}],[11,"input_types","","",259,null],[11,"clone","","",283,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"with_caller_bounds","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"vec"}],"output":{"name":"parameterenvironment"}}],[11,"for_item","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[11,"fmt","","",284,{"inputs":[{"name":"typescheme"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",284,{"inputs":[{"name":"typescheme"}],"output":{"name":"typescheme"}}],[11,"clone","","",285,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"decode","","",165,{"inputs":[{"name":"closurekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",165,{"inputs":[{"name":"closurekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",165,{"inputs":[{"name":"closurekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ne","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"cmp","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"option"}}],[11,"lt","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"le","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"gt","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ge","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"clone","","",165,{"inputs":[{"name":"closurekind"}],"output":{"name":"closurekind"}}],[11,"trait_did","","",165,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind\nmust also implement `other`.",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"mk_substs","","",244,{"inputs":[{"name":"ctxt"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"safe_to_unsafe_fn_ty","","Create an unsafe fn ty based on a safe fn ty.",244,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"tys"}}],[11,"mk_bare_fn","","",244,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"mk_region","","",244,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"region"}}],[11,"closure_kind","","",244,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"closurekind"}}],[11,"closure_type","","",244,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"type_parameter_def","","",244,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"typeparameterdef"}}],[11,"pat_contains_ref_binding","","",244,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"arm_contains_ref_binding","","",244,{"inputs":[{"name":"ctxt"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"walk","","Iterator that walks `self` and any types reachable from\n`self`, in depth-first order. Note that just walks the types\nthat appear in `self`, it does not descend into the fields of\nstructs or variants. For example:",246,{"inputs":[{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence\n`Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]`\n(but not `i32`, like `walk`).",246,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[11,"as_opt_param_ty","","",246,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[11,"is_param","","",246,{"inputs":[{"name":"tys"},{"name":"paramspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"new","","",252,{"inputs":[{"name":"paramty"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"paramty"}}],[11,"for_self","","",252,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"for_def","","",252,{"inputs":[{"name":"paramty"},{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",252,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"is_self","","",252,{"inputs":[{"name":"paramty"}],"output":{"name":"bool"}}],[11,"empty","","",285,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"is_noop","","",285,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"bool"}}],[11,"empty","","",263,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"clone","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"when","","",286,{"inputs":[{"name":"typecontents"},{"name":"bool"}],"output":{"name":"typecontents"}}],[11,"intersects","","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_managed","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_owned","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"is_sized","","",286,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"interior_param","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsafe","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsized","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"needs_drop","","",286,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"owned_pointer","","Includes only those bits that still apply when indirected through a `Box` pointer",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"reference","","Includes only those bits that still apply when indirected through a reference (`&`)",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"managed_pointer","","Includes only those bits that still apply when indirected through a managed pointer (`@`)",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"unsafe_pointer","","Includes only those bits that still apply when indirected through an unsafe pointer (`*`)",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"union","","",286,null],[11,"has_dtor","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitor","rustc::middle::ty","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitand","rustc::middle::ty","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"sub","rustc::middle::ty","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"fmt","","",286,{"inputs":[{"name":"typecontents"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",287,{"inputs":[{"name":"representability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"option"}}],[11,"lt","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"clone","","",287,{"inputs":[{"name":"representability"}],"output":{"name":"representability"}}],[11,"clone","","",288,{"inputs":[{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"repr","","",262,{"inputs":[{"name":"type_err"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",289,{"inputs":[{"name":"variantinfo"}],"output":{"name":"variantinfo"}}],[11,"from_ast_variant","","Creates a new VariantInfo from the corresponding ast representation.",289,{"inputs":[{"name":"variantinfo"},{"name":"ctxt"},{"name":"spanned"},{"name":"u64"}],"output":{"name":"variantinfo"}}],[11,"clone","","",290,{"inputs":[{"name":"dtorkind"}],"output":{"name":"dtorkind"}}],[11,"is_present","","",290,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"has_drop_flag","","",290,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"to_ty","syntax::attr","",291,{"inputs":[{"name":"inttype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"i64_to_disr","","",291,{"inputs":[{"name":"inttype"},{"name":"i64"}],"output":{"name":"option"}}],[11,"u64_to_disr","","",291,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_incr","","",291,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_string","","",291,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"string"}}],[11,"disr_wrap_incr","","",291,{"inputs":[{"name":"inttype"},{"name":"option"}],"output":{"name":"u64"}}],[11,"clone","rustc::middle::ty","",292,{"inputs":[{"name":"closureupvar"}],"output":{"name":"closureupvar"}}],[11,"to_string","","",233,{"inputs":[{"name":"variance"}],"output":{"name":"str"}}],[11,"from_mutbl","","",256,{"inputs":[{"name":"borrowkind"},{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow\nkind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a\nmutability that is stronger than necessary so that it at least *would permit* the borrow in\nquestion.",256,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",256,{"inputs":[{"name":"borrowkind"}],"output":{"name":"str"}}],[11,"is_method_call","","",244,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"upvar_capture","","",244,{"inputs":[{"name":"ctxt"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"node_ty","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"result"}}],[11,"expr_ty_adjusted","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"expr"}],"output":{"name":"result"}}],[11,"node_method_ty","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"node_method_origin","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"adjustments","","",283,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"refcell"}}],[11,"is_method_call","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"temporary_scope","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"option"}}],[11,"upvar_capture","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"type_moves_by_default","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"param_env","","",283,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"closure_kind","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"}],"output":{"name":"option"}}],[11,"closure_type","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"closure_upvars","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[11,"fmt","","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"ne","","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"clone","","",293,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"explicitselfcategory"}}],[11,"decode","","",21,{"inputs":[{"name":"freevar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",21,{"inputs":[{"name":"freevar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",21,{"inputs":[{"name":"freevar"}],"output":{"name":"freevar"}}],[11,"is_identity","","",234,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"bool"}}],[11,"is_identity","","",235,{"inputs":[{"name":"autoderefref"}],"output":{"name":"bool"}}],[11,"new","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"repr","","",234,{"inputs":[{"name":"autoadjustment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",235,{"inputs":[{"name":"autoderefref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",236,{"inputs":[{"name":"autoref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",276,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",242,{"inputs":[{"name":"vtable_origin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",294,{"inputs":[{"name":"copyimplementationerror"}],"output":{"name":"copyimplementationerror"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",284,{"inputs":[{"name":"typescheme"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",15,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",276,{"inputs":[{"name":"predicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::traits","",213,{"inputs":[{"name":"obligation"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",259,{"inputs":[{"name":"traitref"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",185,{"inputs":[{"name":"regionsubsts"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",281,{"inputs":[{"name":"projectionty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"repr","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"has_projection_types","collections::vec","",295,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",249,{"inputs":[{"name":"closurety"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",292,{"inputs":[{"name":"closureupvar"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",278,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",15,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",279,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",280,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",281,{"inputs":[{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",184,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"has_projection_types","core::option","",11,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::boxed","",296,{"inputs":[{"name":"box"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",251,{"inputs":[{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",223,{"inputs":[{"name":"field"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",248,{"inputs":[{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"references_error","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"references_error","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"references_error","rustc::middle::ty","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",280,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"references_error","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"references_error","","",279,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",278,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",15,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"repr","","",249,{"inputs":[{"name":"closurety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",292,{"inputs":[{"name":"closureupvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",223,{"inputs":[{"name":"field"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",271,{"inputs":[{"name":"objectlifetimedefault"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","syntax::ast","",297,{"inputs":[{"name":"unsafety"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"fold_with","syntax::abi","",298,{"inputs":[{"name":"abi"},{"name":"f"}],"output":{"name":"abi"}}],[11,"fold_with","core::option","",11,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"fold_with","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"f"}],"output":{"name":"rc"}}],[11,"fold_with","alloc::boxed","",296,{"inputs":[{"name":"box"},{"name":"f"}],"output":{"name":"box"}}],[11,"fold_with","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"fold_with","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"fold_with","syntax::owned_slice","",299,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"fold_with","rustc::middle::subst","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"fold_with","rustc::middle::ty","",248,{"inputs":[{"name":"barefnty"},{"name":"f"}],"output":{"name":"barefnty"}}],[11,"fold_with","","",249,{"inputs":[{"name":"closurety"},{"name":"f"}],"output":{"name":"closurety"}}],[11,"fold_with","","",229,{"inputs":[{"name":"mt"},{"name":"f"}],"output":{"name":"mt"}}],[11,"fold_with","","",250,{"inputs":[{"name":"fnoutput"},{"name":"f"}],"output":{"name":"fnoutput"}}],[11,"fold_with","","",251,{"inputs":[{"name":"fnsig"},{"name":"f"}],"output":{"name":"fnsig"}}],[11,"fold_with","","",259,{"inputs":[{"name":"traitref"},{"name":"f"}],"output":{"name":"traitref"}}],[11,"fold_with","","",223,{"inputs":[{"name":"field"},{"name":"f"}],"output":{"name":"field"}}],[11,"fold_with","","",15,{"inputs":[{"name":"region"},{"name":"f"}],"output":{"name":"region"}}],[11,"fold_with","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"f"}],"output":{"name":"substs"}}],[11,"fold_with","rustc::middle::ty","",285,{"inputs":[{"name":"itemsubsts"},{"name":"f"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","","",236,{"inputs":[{"name":"autoref"},{"name":"f"}],"output":{"name":"autoref"}}],[11,"fold_with","","",24,{"inputs":[{"name":"methodorigin"},{"name":"f"}],"output":{"name":"methodorigin"}}],[11,"fold_with","","",242,{"inputs":[{"name":"vtable_origin"},{"name":"f"}],"output":{"name":"vtable_origin"}}],[11,"fold_with","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"f"}],"output":{"name":"enumset"}}],[11,"fold_with","rustc::middle::ty","",264,{"inputs":[{"name":"existentialbounds"},{"name":"f"}],"output":{"name":"existentialbounds"}}],[11,"fold_with","","",263,{"inputs":[{"name":"parambounds"},{"name":"f"}],"output":{"name":"parambounds"}}],[11,"fold_with","","",272,{"inputs":[{"name":"typeparameterdef"},{"name":"f"}],"output":{"name":"typeparameterdef"}}],[11,"fold_with","","",271,{"inputs":[{"name":"objectlifetimedefault"},{"name":"f"}],"output":{"name":"objectlifetimedefault"}}],[11,"fold_with","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"f"}],"output":{"name":"regionparameterdef"}}],[11,"fold_with","","",274,{"inputs":[{"name":"generics"},{"name":"f"}],"output":{"name":"generics"}}],[11,"fold_with","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"f"}],"output":{"name":"genericpredicates"}}],[11,"fold_with","","",276,{"inputs":[{"name":"predicate"},{"name":"f"}],"output":{"name":"predicate"}}],[11,"fold_with","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"f"}],"output":{"name":"projectionpredicate"}}],[11,"fold_with","","",281,{"inputs":[{"name":"projectionty"},{"name":"f"}],"output":{"name":"projectionty"}}],[11,"fold_with","","",282,{"inputs":[{"name":"instantiatedpredicates"},{"name":"f"}],"output":{"name":"instantiatedpredicates"}}],[11,"fold_with","rustc::middle::traits","",213,{"inputs":[{"name":"obligation"},{"name":"f"}],"output":{"name":"obligation"}}],[11,"fold_with","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"fold_with","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fold_with","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"fold_with","","",214,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"fold_with","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"f"}],"output":{"name":"vtableobjectdata"}}],[11,"fold_with","rustc::middle::ty","",278,{"inputs":[{"name":"equatepredicate"},{"name":"f"}],"output":{"name":"equatepredicate"}}],[11,"fold_with","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"f"}],"output":{"name":"traitpredicate"}}],[11,"fold_with","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"f"}],"output":{"name":"outlivespredicate"}}],[11,"fold_with","","",292,{"inputs":[{"name":"closureupvar"},{"name":"f"}],"output":{"name":"closureupvar"}}],[11,"fold_with","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"f"}],"output":{"name":"parameterenvironment"}}],[11,"tcx","rustc::middle::ty_fold","",301,{"inputs":[{"name":"bottomupfolder"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",301,{"inputs":[{"name":"bottomupfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","","",302,{"inputs":[{"name":"regionfolder"},{"name":"ctxt"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",302,{"inputs":[{"name":"regionfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",302,null],[11,"exit_region_binder","","",302,null],[11,"fold_region","","",302,{"inputs":[{"name":"regionfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"tcx","","",303,{"inputs":[{"name":"regioneraser"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",303,{"inputs":[{"name":"regioneraser"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::ty_match","",304,{"inputs":[{"name":"match"},{"name":"ctxt"}],"output":{"name":"match"}}],[11,"tag","","",304,{"inputs":[{"name":"match"}],"output":{"name":"str"}}],[11,"tcx","","",304,{"inputs":[{"name":"match"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",304,{"inputs":[{"name":"match"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",304,{"inputs":[{"name":"match"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"regions","","",304,{"inputs":[{"name":"match"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"tys","","",304,{"inputs":[{"name":"match"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"binders","","",304,{"inputs":[{"name":"match"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",229,{"inputs":[{"name":"mt"},{"name":"r"},{"name":"mt"},{"name":"mt"}],"output":{"name":"result"}}],[11,"relate","","",248,{"inputs":[{"name":"barefnty"},{"name":"r"},{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"result"}}],[11,"relate","","",251,{"inputs":[{"name":"fnsig"},{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"result"}}],[11,"relate","syntax::ast","",297,{"inputs":[{"name":"unsafety"},{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"relate","syntax::abi","",298,{"inputs":[{"name":"abi"},{"name":"r"},{"name":"abi"},{"name":"abi"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",281,{"inputs":[{"name":"projectionty"},{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"result"}}],[11,"relate","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"r"},{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"result"}}],[11,"relate","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"r"},{"name":"vec"},{"name":"vec"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",264,{"inputs":[{"name":"existentialbounds"},{"name":"r"},{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"result"}}],[11,"relate","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"r"},{"name":"enumset"},{"name":"enumset"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",259,{"inputs":[{"name":"traitref"},{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"relate","","",15,{"inputs":[{"name":"region"},{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"relate","","",95,{"inputs":[{"name":"binder"},{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"r"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"relate","alloc::boxed","",296,{"inputs":[{"name":"box"},{"name":"r"},{"name":"box"},{"name":"box"}],"output":{"name":"result"}}],[11,"new","rustc::middle::ty_walk","",305,{"inputs":[{"name":"typewalker"},{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type\nreturned by `next()`.",305,null],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::middle::ty_walk","",305,{"inputs":[{"name":"typewalker"}],"output":{"name":"option"}}],[11,"visit_foreign_item","rustc::middle::weak_lang_items","",306,null],[11,"eq","rustc::metadata::common","",307,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"ne","","",307,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"clone","","",307,{"inputs":[{"name":"astencode_tag"}],"output":{"name":"astencode_tag"}}],[11,"from_u32","","",307,{"inputs":[{"name":"astencode_tag"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","","",308,{"inputs":[{"name":"linkmeta"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",308,{"inputs":[{"name":"linkmeta"}],"output":{"name":"linkmeta"}}],[11,"fmt","rustc::metadata::tydecode","",309,{"inputs":[{"name":"defidsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",309,{"inputs":[{"name":"defidsource"}],"output":{"name":"defidsource"}}],[11,"clone","rustc::metadata::encoder","",310,{"inputs":[{"name":"entry"}],"output":{"name":"entry"}}],[11,"visit_expr","","",311,null],[11,"visit_item","","",311,null],[11,"visit_foreign_item","","",311,null],[11,"visit_item","","",312,null],[11,"eq","rustc::metadata::decoder","",313,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"ne","","",313,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"fmt","","",314,{"inputs":[{"name":"deflike"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",314,{"inputs":[{"name":"deflike"}],"output":{"name":"deflike"}}],[11,"clone","","",315,{"inputs":[{"name":"cratedep"}],"output":{"name":"cratedep"}}],[11,"visit_item","rustc::metadata::creader","",316,null],[11,"as_slice","","",317,null],[11,"new","","",316,{"inputs":[{"name":"cratereader"},{"name":"session"}],"output":{"name":"cratereader"}}],[11,"read_crates","","",316,null],[11,"read_exported_macros","","Read exported macros.",316,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path and symbol name.",316,{"inputs":[{"name":"cratereader"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","rustc::metadata::cstore","",318,{"inputs":[{"name":"linkagepreference"}],"output":{"name":"linkagepreference"}}],[11,"eq","","",318,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"ne","","",318,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"fmt","","",318,{"inputs":[{"name":"linkagepreference"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",319,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"ne","","",319,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"clone","","",319,{"inputs":[{"name":"nativelibrarykind"}],"output":{"name":"nativelibrarykind"}}],[11,"from_u32","","",319,{"inputs":[{"name":"nativelibrarykind"},{"name":"u32"}],"output":{"name":"option"}}],[11,"clone","","",320,{"inputs":[{"name":"cratesource"}],"output":{"name":"cratesource"}}],[11,"eq","","",320,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",320,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"new","","",321,{"inputs":[{"name":"cstore"},{"name":"rc"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","",321,{"inputs":[{"name":"cstore"}],"output":{"name":"u32"}}],[11,"get_crate_data","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"rc"}}],[11,"get_crate_hash","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"svh"}}],[11,"set_crate_data","","",321,null],[11,"iter_crate_data","","",321,null],[11,"iter_crate_data_origins","","Like `iter_crate_data`, but passes source paths (if available) as well.",321,null],[11,"add_used_crate_source","","",321,null],[11,"get_used_crate_source","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"reset","","",321,null],[11,"get_used_crates","","",321,{"inputs":[{"name":"cstore"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[11,"add_used_library","","",321,null],[11,"get_used_libraries","","",321,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_used_link_args","","",321,null],[11,"get_used_link_args","","",321,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_extern_mod_stmt_cnum","","",321,null],[11,"find_extern_mod_stmt_cnum","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"data","","",322,null],[11,"name","","",322,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"string"}}],[11,"hash","","",322,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"svh"}}],[11,"as_slice","","",323,null],[11,"clone","rustc::metadata::csearch","",324,{"inputs":[{"name":"methodinfo"}],"output":{"name":"methodinfo"}}],[11,"maybe_load_library_crate","rustc::metadata::loader","",325,{"inputs":[{"name":"context"}],"output":{"name":"option"}}],[11,"load_library_crate","","",325,{"inputs":[{"name":"context"}],"output":{"name":"library"}}],[11,"report_load_errs","","",325,null],[11,"as_slice","","",326,null],[11,"clone","rustc::metadata::filesearch","",327,{"inputs":[{"name":"filematch"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",328,null],[11,"get_lib_path","","",328,{"inputs":[{"name":"filesearch"}],"output":{"name":"pathbuf"}}],[11,"search","","",328,null],[11,"new","","",328,{"inputs":[{"name":"filesearch"},{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",328,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"get_tools_search_paths","","",328,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"visit_item","rustc::metadata::macro_import","",329,null],[11,"visit_mac","","",329,null],[11,"eq","rustc::session::config","",330,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"ne","","",330,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"clone","","",330,{"inputs":[{"name":"optlevel"}],"output":{"name":"optlevel"}}],[11,"eq","","",331,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"ne","","",331,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"clone","","",331,{"inputs":[{"name":"debuginfolevel"}],"output":{"name":"debuginfolevel"}}],[11,"cmp","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",332,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[11,"clone","","",333,{"inputs":[{"name":"options"}],"output":{"name":"options"}}],[11,"clone","","",334,{"inputs":[{"name":"unstablefeatures"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",335,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"ne","","",335,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"clone","","",335,{"inputs":[{"name":"printrequest"}],"output":{"name":"printrequest"}}],[11,"filestem","","",336,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[11,"clone","","",337,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"outputfilenames"}}],[11,"path","","",337,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","",337,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",337,{"inputs":[{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",337,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"string"}}],[11,"eq","","",338,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"ne","","",338,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"clone","","",338,{"inputs":[{"name":"entryfntype"}],"output":{"name":"entryfntype"}}],[11,"fmt","","",339,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",339,null],[11,"cmp","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"clone","","",339,{"inputs":[{"name":"cratetype"}],"output":{"name":"cratetype"}}],[11,"partial_cmp","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"option"}}],[11,"lt","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"le","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"gt","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ge","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"eq","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ne","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"clone","","",340,{"inputs":[{"name":"passes"}],"output":{"name":"passes"}}],[11,"is_empty","","",340,{"inputs":[{"name":"passes"}],"output":{"name":"bool"}}],[11,"clone","","",341,{"inputs":[{"name":"codegenoptions"}],"output":{"name":"codegenoptions"}}],[11,"clone","","",342,{"inputs":[{"name":"debuggingoptions"}],"output":{"name":"debuggingoptions"}}],[11,"fmt","","",343,{"inputs":[{"name":"optionstability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",343,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"ne","","",343,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"clone","","",343,{"inputs":[{"name":"optionstability"}],"output":{"name":"optionstability"}}],[11,"eq","","",344,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"clone","","",344,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"rustcoptgroup"}}],[11,"is_stable","","",344,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"fmt","","",339,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::session::search_paths","",345,{"inputs":[{"name":"searchpaths"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",345,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",346,{"inputs":[{"name":"pathkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",346,{"inputs":[{"name":"pathkind"}],"output":{"name":"pathkind"}}],[11,"eq","","",346,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"ne","","",346,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",345,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"add_path","","",345,null],[11,"iter","","",345,{"inputs":[{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"iter"}}],[6,"Item","rustc_trans::session::config","",null,null],[11,"next","rustc::session::search_paths","",347,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"span_fatal","rustc::session","",348,null],[11,"span_fatal_with_code","","",348,null],[11,"fatal","","",348,null],[11,"span_err","","",348,null],[11,"span_err_with_code","","",348,null],[11,"err","","",348,null],[11,"err_count","","",348,{"inputs":[{"name":"session"}],"output":{"name":"usize"}}],[11,"has_errors","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",348,null],[11,"span_warn","","",348,null],[11,"span_warn_with_code","","",348,null],[11,"warn","","",348,null],[11,"opt_span_warn","","",348,null],[11,"span_note","","",348,null],[11,"span_end_note","","",348,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",348,null],[11,"span_help","","",348,null],[11,"fileline_note","","",348,null],[11,"fileline_help","","",348,null],[11,"note","","",348,null],[11,"help","","",348,null],[11,"opt_span_bug","","",348,null],[11,"span_bug","","",348,null],[11,"bug","","",348,null],[11,"span_unimpl","","",348,null],[11,"unimpl","","",348,null],[11,"add_lint","","",348,null],[11,"next_node_id","","",348,{"inputs":[{"name":"session"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",348,{"inputs":[{"name":"session"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"diagnostic","","",348,{"inputs":[{"name":"session"}],"output":{"name":"spanhandler"}}],[11,"codemap","","",348,{"inputs":[{"name":"session"}],"output":{"name":"codemap"}}],[11,"impossible_case","","",348,null],[11,"verbose","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_passes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_type_sizes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"trans_stats","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"meta_stats","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"asm_comments","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_verify","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"lto","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"unstable_options","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_enum_sizes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"sysroot","","",348,{"inputs":[{"name":"session"}],"output":{"name":"path"}}],[11,"target_filesearch","","",348,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",348,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"args","rustc::plugin::registry","Get the plugin's arguments, if any.",349,{"inputs":[{"name":"registry"}],"output":{"name":"vec"}}],[11,"register_syntax_extension","","Register a syntax extension of any kind.",349,null],[11,"register_macro","","Register a macro of the usual kind.",349,null],[11,"register_lint_pass","","Register a compiler lint pass.",349,null],[11,"register_lint_group","","Register a lint group.",349,null],[11,"register_llvm_pass","","Register an LLVM pass.",349,null],[11,"visit_item","rustc::plugin::build","",350,null],[11,"fmt","rustc::lint","",351,{"inputs":[{"name":"lint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",351,{"inputs":[{"name":"lint"}],"output":{"name":"lint"}}],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",351,{"inputs":[{"name":"lint"}],"output":{"name":"string"}}],[11,"clone","","",352,{"inputs":[{"name":"lintid"}],"output":{"name":"lintid"}}],[11,"eq","","",352,{"inputs":[{"name":"lintid"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",352,null],[11,"of","","Get the `LintId` for a `Lint`.",352,{"inputs":[{"name":"lintid"},{"name":"lint"}],"output":{"name":"lintid"}}],[11,"as_str","","Get the name of the lint.",352,{"inputs":[{"name":"lintid"}],"output":{"name":"string"}}],[11,"fmt","","",353,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"option"}}],[11,"lt","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"le","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"gt","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ge","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"eq","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",353,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"as_str","","Convert a level to a lower-case string.",353,{"inputs":[{"name":"level"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",353,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"option"}}],[11,"eq","","",354,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",354,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"clone","","",354,{"inputs":[{"name":"lintsource"}],"output":{"name":"lintsource"}}],[11,"clone","rustc::lint::builtin","",355,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",355,null],[11,"new","rustc::lint::context","",356,{"inputs":[{"name":"lintstore"}],"output":{"name":"lintstore"}}],[11,"get_lints","","",356,null],[11,"get_lint_groups","","",356,{"inputs":[{"name":"lintstore"}],"output":{"name":"vec"}}],[11,"register_pass","","",356,null],[11,"register_group","","",356,null],[11,"register_renamed","","",356,null],[11,"process_command_line","","",356,null],[11,"sess","","Get the overall compiler `Session` object.",357,{"inputs":[{"name":"context"}],"output":{"name":"session"}}],[11,"current_level","","Get the level of `lint` at the current position of the lint\ntraversal.",357,{"inputs":[{"name":"context"},{"name":"lint"}],"output":{"name":"level"}}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",357,null],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",357,null],[11,"visit_item","","",357,null],[11,"visit_foreign_item","","",357,null],[11,"visit_pat","","",357,null],[11,"visit_expr","","",357,null],[11,"visit_stmt","","",357,null],[11,"visit_fn","","",357,null],[11,"visit_struct_def","","",357,null],[11,"visit_struct_field","","",357,null],[11,"visit_variant","","",357,null],[11,"visit_ty","","",357,null],[11,"visit_ident","","",357,null],[11,"visit_mod","","",357,null],[11,"visit_local","","",357,null],[11,"visit_block","","",357,null],[11,"visit_arm","","",357,null],[11,"visit_decl","","",357,null],[11,"visit_expr_post","","",357,null],[11,"visit_generics","","",357,null],[11,"visit_trait_item","","",357,null],[11,"visit_impl_item","","",357,null],[11,"visit_opt_lifetime_ref","","",357,null],[11,"visit_lifetime_ref","","",357,null],[11,"visit_lifetime_def","","",357,null],[11,"visit_explicit_self","","",357,null],[11,"visit_mac","","",357,null],[11,"visit_path","","",357,null],[11,"visit_attribute","","",357,null],[11,"visit_id","","",357,null],[11,"get_lints","","",358,null],[11,"check_item","","",358,null],[11,"fmt","rustc::util::common","",359,{"inputs":[{"name":"errorreported"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",359,{"inputs":[{"name":"errorreported"}],"output":{"name":"errorreported"}}],[11,"drop","","",360,null],[11,"visit_expr","","",361,null],[11,"visit_expr","","",362,null],[11,"repr","core::option","",11,{"inputs":[{"name":"option"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ptr","",363,{"inputs":[{"name":"p"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::result","",91,{"inputs":[{"name":"result"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::boxed","",296,{"inputs":[{"name":"box"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::owned_slice","",299,{"inputs":[{"name":"ownedslice"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",295,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::def","",14,{"inputs":[{"name":"def"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",272,{"inputs":[{"name":"typeparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",246,{"inputs":[{"name":"tys"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",229,{"inputs":[{"name":"mt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",285,{"inputs":[{"name":"itemsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",185,{"inputs":[{"name":"regionsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",263,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",259,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",364,{"inputs":[{"name":"traitdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",365,{"inputs":[{"name":"traititem"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",159,{"inputs":[{"name":"expr"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",366,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",366,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",367,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",368,{"inputs":[{"name":"item"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",369,{"inputs":[{"name":"lifetime"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",370,{"inputs":[{"name":"spanned"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",160,{"inputs":[{"name":"pat"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",19,{"inputs":[{"name":"boundregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",15,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",15,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",16,{"inputs":[{"name":"freeregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::region","",17,{"inputs":[{"name":"codeextent"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",18,{"inputs":[{"name":"destructionscopedata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",10,{"inputs":[{"name":"defid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",284,{"inputs":[{"name":"typescheme"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",274,{"inputs":[{"name":"generics"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",282,{"inputs":[{"name":"instantiatedpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",232,{"inputs":[{"name":"itemvariances"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",233,{"inputs":[{"name":"variance"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",227,{"inputs":[{"name":"method"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",5,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",5,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",4,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",371,{"inputs":[{"name":"explicitself_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",372,{"inputs":[{"name":"visibility"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",248,{"inputs":[{"name":"barefnty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",251,{"inputs":[{"name":"fnsig"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",250,{"inputs":[{"name":"fnoutput"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",240,{"inputs":[{"name":"methodcallee"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",24,{"inputs":[{"name":"methodorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",238,{"inputs":[{"name":"methodparam"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",239,{"inputs":[{"name":"methodobject"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",265,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",265,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",12,{"inputs":[{"name":"span"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",263,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",259,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","syntax::ast","",4,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::abi","",298,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",298,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",255,{"inputs":[{"name":"upvarid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",373,{"inputs":[{"name":"mutability"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",256,{"inputs":[{"name":"borrowkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",22,{"inputs":[{"name":"upvarborrow"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",23,{"inputs":[{"name":"upvarcapture"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",124,{"inputs":[{"name":"intvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",126,{"inputs":[{"name":"floatvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",267,{"inputs":[{"name":"regionvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",266,{"inputs":[{"name":"tyvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",374,{"inputs":[{"name":"intty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",375,{"inputs":[{"name":"uintty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",127,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",252,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",252,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",95,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","std::collections::hash::map","",376,{"inputs":[{"name":"hashmap"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",281,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",281,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",276,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",297,{"inputs":[{"name":"unsafety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"default","rustc::util::nodemap","",377,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"fnvhasher"}}],[11,"write","","",377,null],[11,"finish","","",377,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"u64"}}],[11,"new","rustc::util::snapshot_vec","",378,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"snapshotvec"}}],[11,"record","","",378,null],[11,"push","","",378,null],[11,"get","","",378,null],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone\nautomatically, so you should be sure call `record()` with some sort of suitable undo\naction.",378,null],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if\na snapshot is active.",378,null],[11,"start_snapshot","","",378,{"inputs":[{"name":"snapshotvec"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",378,null],[11,"rollback_to","","",378,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",378,null],[11,"input","rustc_back::sha2","",379,null],[11,"reset","","",379,null],[11,"zero_until","","",379,null],[11,"next","","",379,null],[11,"full_buffer","","",379,null],[11,"position","","",379,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"remaining","","",379,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"size","","",379,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",380,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",380,null],[11,"result","","",380,null],[11,"reset","","",380,null],[11,"output_bits","","",380,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[11,"open","rustc_llvm::archive_ro","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",381,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",381,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",381,null],[11,"clone","rustc_llvm::diagnostic","",382,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",382,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",383,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",384,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",385,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",385,null],[11,"eq","rustc_llvm","",386,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",386,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",386,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",387,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",388,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",389,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",389,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",390,null],[11,"cmp","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",390,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",390,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",390,null],[11,"remove","","Removes the specified flags in-place.",390,null],[11,"toggle","","Toggles the specified flags in-place.",390,null],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitor","rustc_llvm","Returns the union of the two sets of flags.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitxor","rustc_llvm","Returns the left flags, but with all the right flags toggled.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"bitand","rustc_llvm","Returns the intersection between the two sets of flags.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"sub","rustc_llvm","Returns the set difference of the two sets of flags.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_trans::session::config","",null,null],[11,"not","rustc_llvm","Returns the complement of this set of flags.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",391,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",392,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",393,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",390,null],[11,"apply_callsite","","",390,null],[11,"apply_llfn","","",391,null],[11,"apply_callsite","","",391,null],[11,"apply_llfn","","",392,null],[11,"apply_callsite","","",392,null],[11,"new","","",394,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",394,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",394,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",394,null],[11,"apply_callsite","","",394,null],[11,"clone","","",395,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",396,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",397,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",397,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",397,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",397,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",398,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",399,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",400,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",401,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",402,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",403,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",403,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",403,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",404,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",404,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",404,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",405,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",406,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"clone","rustc_llvm::debuginfo","",407,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[11,"drop","rustc_llvm","",408,null],[11,"new","","",409,null],[11,"drop","","",409,null],[11,"drop","","",410,null],[3,"Config","rustc_trans::session::config","",null,null],[12,"target","","",411,null],[12,"int_type","","",411,null],[12,"uint_type","","",411,null],[4,"OptLevel","","",null,null],[13,"No","","",330,null],[13,"Less","","",330,null],[13,"Default","","",330,null],[13,"Aggressive","","",330,null],[4,"DebugInfoLevel","","",null,null],[13,"NoDebugInfo","","",331,null],[13,"LimitedDebugInfo","","",331,null],[13,"FullDebugInfo","","",331,null],[4,"OutputType","","",null,null],[13,"OutputTypeBitcode","","",332,null],[13,"OutputTypeAssembly","","",332,null],[13,"OutputTypeLlvmAssembly","","",332,null],[13,"OutputTypeObject","","",332,null],[13,"OutputTypeExe","","",332,null],[13,"OutputTypeDepInfo","","",332,null],[3,"Options","","",null,null],[12,"crate_types","","",333,null],[12,"gc","","",333,null],[12,"optimize","","",333,null],[12,"debug_assertions","","",333,null],[12,"debuginfo","","",333,null],[12,"lint_opts","","",333,null],[12,"describe_lints","","",333,null],[12,"output_types","","",333,null],[12,"search_paths","","",333,null],[12,"libs","","",333,null],[12,"maybe_sysroot","","",333,null],[12,"target_triple","","",333,null],[12,"cfg","","",333,null],[12,"test","","",333,null],[12,"parse_only","","",333,null],[12,"no_trans","","",333,null],[12,"treat_err_as_bug","","",333,null],[12,"no_analysis","","",333,null],[12,"debugging_opts","","",333,null],[12,"write_dependency_info","","Whether to write dependency files. It's (enabled, optional filename).",333,null],[12,"prints","","",333,null],[12,"cg","","",333,null],[12,"color","","",333,null],[12,"show_span","","",333,null],[12,"externs","","",333,null],[12,"crate_name","","",333,null],[12,"alt_std_name","","An optional name to use as the crate for std during std injection,\nwritten `extern crate std = \"name\"`. Default to \"std\". Used by\nout-of-tree drivers.",333,null],[12,"unstable_features","","Indicates how the compiler should treat unstable features",333,null],[4,"UnstableFeatures","","",null,null],[13,"Disallow","","Hard errors for unstable features are active, as on\nbeta/stable channels.",334,null],[13,"Default","","Use the default lint levels",334,null],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time\nduring the build that feature-related lints are set to warn or above\nbecause the build turns on warnings-as-errors and uses lots of unstable\nfeatures. As a result, this this is always required for building Rust\nitself.",334,null],[4,"PrintRequest","","",null,null],[13,"FileNames","","",335,null],[13,"Sysroot","","",335,null],[13,"CrateName","","",335,null],[4,"Input","","",null,null],[13,"File","","Load source from file",336,null],[13,"Str","","The string is the source",336,null],[3,"OutputFilenames","","",null,null],[12,"out_directory","","",337,null],[12,"out_filestem","","",337,null],[12,"single_output_file","","",337,null],[12,"extra","","",337,null],[5,"host_triple","","",null,{"inputs":[],"output":{"name":"str"}}],[5,"basic_options","","Some reasonable defaults",null,{"inputs":[],"output":{"name":"options"}}],[4,"EntryFnType","","",null,null],[13,"EntryMain","","",338,null],[13,"EntryStart","","",338,null],[13,"EntryNone","","",338,null],[4,"CrateType","","",null,null],[13,"CrateTypeExecutable","","",339,null],[13,"CrateTypeDylib","","",339,null],[13,"CrateTypeRlib","","",339,null],[13,"CrateTypeStaticlib","","",339,null],[4,"Passes","","",null,null],[13,"SomePasses","","",340,null],[13,"AllPasses","","",340,null],[3,"CodegenOptions","","",null,null],[12,"ar","","",341,null],[12,"linker","","",341,null],[12,"link_args","","",341,null],[12,"lto","","",341,null],[12,"target_cpu","","",341,null],[12,"target_feature","","",341,null],[12,"passes","","",341,null],[12,"llvm_args","","",341,null],[12,"save_temps","","",341,null],[12,"rpath","","",341,null],[12,"no_prepopulate_passes","","",341,null],[12,"no_vectorize_loops","","",341,null],[12,"no_vectorize_slp","","",341,null],[12,"soft_float","","",341,null],[12,"prefer_dynamic","","",341,null],[12,"no_integrated_as","","",341,null],[12,"no_redzone","","",341,null],[12,"relocation_model","","",341,null],[12,"code_model","","",341,null],[12,"metadata","","",341,null],[12,"extra_filename","","",341,null],[12,"codegen_units","","",341,null],[12,"remark","","",341,null],[12,"no_stack_check","","",341,null],[12,"debuginfo","","",341,null],[12,"opt_level","","",341,null],[12,"debug_assertions","","",341,null],[5,"basic_codegen_options","","",null,{"inputs":[],"output":{"name":"codegenoptions"}}],[5,"build_codegen_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"codegenoptions"}}],[6,"CodegenSetter","","",null,null],[17,"CG_OPTIONS","","",null,null],[3,"DebuggingOptions","","",null,null],[12,"verbose","","",342,null],[12,"time_passes","","",342,null],[12,"count_llvm_insns","","",342,null],[12,"time_llvm_passes","","",342,null],[12,"trans_stats","","",342,null],[12,"asm_comments","","",342,null],[12,"no_verify","","",342,null],[12,"borrowck_stats","","",342,null],[12,"no_landing_pads","","",342,null],[12,"debug_llvm","","",342,null],[12,"count_type_sizes","","",342,null],[12,"meta_stats","","",342,null],[12,"print_link_args","","",342,null],[12,"gc","","",342,null],[12,"print_llvm_passes","","",342,null],[12,"ast_json","","",342,null],[12,"ast_json_noexpand","","",342,null],[12,"ls","","",342,null],[12,"save_analysis","","",342,null],[12,"print_move_fragments","","",342,null],[12,"flowgraph_print_loans","","",342,null],[12,"flowgraph_print_moves","","",342,null],[12,"flowgraph_print_assigns","","",342,null],[12,"flowgraph_print_all","","",342,null],[12,"print_region_graph","","",342,null],[12,"parse_only","","",342,null],[12,"no_trans","","",342,null],[12,"treat_err_as_bug","","",342,null],[12,"no_analysis","","",342,null],[12,"extra_plugins","","",342,null],[12,"unstable_options","","",342,null],[12,"print_enum_sizes","","",342,null],[12,"force_overflow_checks","","",342,null],[12,"force_dropflag_checks","","",342,null],[5,"basic_debugging_options","","",null,{"inputs":[],"output":{"name":"debuggingoptions"}}],[5,"build_debugging_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"debuggingoptions"}}],[6,"DebuggingSetter","","",null,null],[17,"DB_OPTIONS","","",null,null],[5,"default_lib_output","","",null,{"inputs":[],"output":{"name":"cratetype"}}],[5,"default_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"vec"}}],[5,"append_configuration","","",null,null],[5,"build_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"vec"}}],[5,"build_target_config","","",null,{"inputs":[{"name":"options"},{"name":"spanhandler"}],"output":{"name":"config"}}],[5,"short_optgroups","","Returns the \"short\" subset of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"optgroups","","Returns all of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[4,"OptionStability","","",null,null],[13,"Stable","","",343,null],[13,"Unstable","","",343,null],[3,"RustcOptGroup","","",null,null],[12,"opt_group","","",344,null],[12,"stability","","",344,null],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options,\nincluding metadata for each option, such as whether the option is\npart of the stable long-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for\neach option, such as whether the option is part of the stable\nlong-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"parse_cfgspecs","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[5,"build_session_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"options"}}],[5,"get_unstable_features_setting","","",null,{"inputs":[],"output":{"name":"unstablefeatures"}}],[5,"parse_crate_types_from_list","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"result"}}],[0,"search_paths","rustc_trans::session","",null,null],[3,"SearchPaths","rustc_trans::session::search_paths","",null,null],[3,"Iter","","",null,null],[4,"PathKind","","",null,null],[13,"Native","","",346,null],[13,"Crate","","",346,null],[13,"Dependency","","",346,null],[13,"Framework","","",346,null],[13,"ExternFlag","","",346,null],[13,"All","","",346,null],[3,"Session","rustc_trans::session","",null,null],[12,"target","","",348,null],[12,"host","","",348,null],[12,"opts","","",348,null],[12,"cstore","","",348,null],[12,"parse_sess","","",348,null],[12,"entry_fn","","",348,null],[12,"entry_type","","",348,null],[12,"plugin_registrar_fn","","",348,null],[12,"default_sysroot","","",348,null],[12,"local_crate_source_file","","",348,null],[12,"working_dir","","",348,null],[12,"lint_store","","",348,null],[12,"lints","","",348,null],[12,"plugin_llvm_passes","","",348,null],[12,"crate_types","","",348,null],[12,"crate_metadata","","",348,null],[12,"features","","",348,null],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive\noperations such as auto-dereference and monomorphization.",348,null],[12,"can_print_warnings","","",348,null],[5,"build_session","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"registry"}],"output":{"name":"session"}}],[5,"build_session_","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"spanhandler"}],"output":{"name":"session"}}],[5,"expect","","",null,{"inputs":[{"name":"session"},{"name":"option"},{"name":"m"}],"output":{"name":"t"}}],[5,"early_error","","",null,null],[5,"early_warn","","",null,null],[0,"metadata","rustc_trans","",null,null],[0,"common","rustc_trans::metadata","",null,null],[17,"tag_items","rustc_trans::metadata::common","",null,null],[17,"tag_paths_data_name","","",null,null],[17,"tag_def_id","","",null,null],[17,"tag_items_data","","",null,null],[17,"tag_items_data_item","","",null,null],[17,"tag_items_data_item_family","","",null,null],[17,"tag_items_data_item_type","","",null,null],[17,"tag_items_data_item_symbol","","",null,null],[17,"tag_items_data_item_variant","","",null,null],[17,"tag_items_data_parent_item","","",null,null],[17,"tag_items_data_item_is_tuple_struct_ctor","","",null,null],[17,"tag_index","","",null,null],[17,"tag_index_buckets","","",null,null],[17,"tag_index_buckets_bucket","","",null,null],[17,"tag_index_buckets_bucket_elt","","",null,null],[17,"tag_index_table","","",null,null],[17,"tag_meta_item_name_value","","",null,null],[17,"tag_meta_item_name","","",null,null],[17,"tag_meta_item_value","","",null,null],[17,"tag_attributes","","",null,null],[17,"tag_attribute","","",null,null],[17,"tag_meta_item_word","","",null,null],[17,"tag_meta_item_list","","",null,null],[17,"tag_crate_deps","","",null,null],[17,"tag_crate_dep","","",null,null],[17,"tag_crate_hash","","",null,null],[17,"tag_crate_crate_name","","",null,null],[17,"tag_crate_dep_crate_name","","",null,null],[17,"tag_crate_dep_hash","","",null,null],[17,"tag_mod_impl","","",null,null],[17,"tag_item_trait_item","","",null,null],[17,"tag_item_trait_ref","","",null,null],[17,"tag_disr_val","","",null,null],[17,"tag_path","","",null,null],[17,"tag_path_len","","",null,null],[17,"tag_path_elem_mod","","",null,null],[17,"tag_path_elem_name","","",null,null],[17,"tag_item_field","","",null,null],[17,"tag_item_field_origin","","",null,null],[17,"tag_item_variances","","",null,null],[17,"tag_item_impl_item","","",null,null],[17,"tag_item_trait_method_explicit_self","","",null,null],[17,"tag_items_data_item_reexport","","",null,null],[17,"tag_items_data_item_reexport_def_id","","",null,null],[17,"tag_items_data_item_reexport_name","","",null,null],[4,"astencode_tag","","",null,null],[13,"tag_ast","","",307,null],[13,"tag_tree","","",307,null],[13,"tag_id_range","","",307,null],[13,"tag_table","","",307,null],[13,"tag_table_def","","",307,null],[13,"tag_table_node_type","","",307,null],[13,"tag_table_item_subst","","",307,null],[13,"tag_table_freevars","","",307,null],[13,"tag_table_tcache","","",307,null],[13,"tag_table_param_defs","","",307,null],[13,"tag_table_mutbl","","",307,null],[13,"tag_table_last_use","","",307,null],[13,"tag_table_spill","","",307,null],[13,"tag_table_method_map","","",307,null],[13,"tag_table_vtable_map","","",307,null],[13,"tag_table_adjustments","","",307,null],[13,"tag_table_moves_map","","",307,null],[13,"tag_table_capture_map","","",307,null],[13,"tag_table_closure_tys","","",307,null],[13,"tag_table_closure_kinds","","",307,null],[13,"tag_table_upvar_capture_map","","",307,null],[13,"tag_table_capture_modes","","",307,null],[13,"tag_table_object_cast_map","","",307,null],[13,"tag_table_const_qualif","","",307,null],[17,"tag_item_trait_item_sort","","",null,null],[17,"tag_item_trait_parent_sort","","",null,null],[17,"tag_item_impl_type_basename","","",null,null],[17,"tag_crate_triple","","",null,null],[17,"tag_dylib_dependency_formats","","",null,null],[17,"tag_lang_items","","",null,null],[17,"tag_lang_items_item","","",null,null],[17,"tag_lang_items_item_id","","",null,null],[17,"tag_lang_items_item_node_id","","",null,null],[17,"tag_lang_items_missing","","",null,null],[17,"tag_item_unnamed_field","","",null,null],[17,"tag_items_data_item_visibility","","",null,null],[17,"tag_item_method_tps","","",null,null],[17,"tag_item_method_fty","","",null,null],[17,"tag_mod_child","","",null,null],[17,"tag_misc_info","","",null,null],[17,"tag_misc_info_crate_items","","",null,null],[17,"tag_item_method_provided_source","","",null,null],[17,"tag_item_impl_vtables","","",null,null],[17,"tag_impls","","",null,null],[17,"tag_impls_impl","","",null,null],[17,"tag_items_data_item_inherent_impl","","",null,null],[17,"tag_items_data_item_extension_impl","","",null,null],[17,"tag_native_libraries","","",null,null],[17,"tag_native_libraries_lib","","",null,null],[17,"tag_native_libraries_name","","",null,null],[17,"tag_native_libraries_kind","","",null,null],[17,"tag_plugin_registrar_fn","","",null,null],[17,"tag_method_argument_names","","",null,null],[17,"tag_method_argument_name","","",null,null],[17,"tag_reachable_extern_fns","","",null,null],[17,"tag_reachable_extern_fn_id","","",null,null],[17,"tag_items_data_item_stability","","",null,null],[17,"tag_items_data_item_repr","","",null,null],[3,"LinkMeta","","",null,null],[12,"crate_name","","",308,null],[12,"crate_hash","","",308,null],[17,"tag_struct_fields","","",null,null],[17,"tag_struct_field","","",null,null],[17,"tag_struct_field_id","","",null,null],[17,"tag_attribute_is_sugared_doc","","",null,null],[17,"tag_items_data_region","","",null,null],[17,"tag_region_param_def","","",null,null],[17,"tag_region_param_def_ident","","",null,null],[17,"tag_region_param_def_def_id","","",null,null],[17,"tag_region_param_def_space","","",null,null],[17,"tag_region_param_def_index","","",null,null],[17,"tag_type_param_def","","",null,null],[17,"tag_item_generics","","",null,null],[17,"tag_method_ty_generics","","",null,null],[17,"tag_predicate","","",null,null],[17,"tag_predicate_space","","",null,null],[17,"tag_predicate_data","","",null,null],[17,"tag_unsafety","","",null,null],[17,"tag_associated_type_names","","",null,null],[17,"tag_associated_type_name","","",null,null],[17,"tag_polarity","","",null,null],[17,"tag_macro_defs","","",null,null],[17,"tag_macro_def","","",null,null],[17,"tag_macro_def_body","","",null,null],[17,"tag_paren_sugar","","",null,null],[17,"tag_codemap","","",null,null],[17,"tag_codemap_filemap","","",null,null],[17,"tag_item_super_predicates","","",null,null],[17,"tag_defaulted_trait","","",null,null],[0,"tyencode","rustc_trans::metadata","",null,null],[3,"ctxt","rustc_trans::metadata::tyencode","",null,null],[12,"diag","","",412,null],[12,"ds","","",412,null],[12,"tcx","","",412,null],[12,"abbrevs","","",412,null],[3,"ty_abbrev","","",null,null],[6,"abbrev_map","","",null,null],[5,"enc_ty","","",null,null],[5,"enc_substs","","",null,null],[5,"enc_region","","",null,null],[5,"enc_trait_ref","","",null,null],[5,"enc_bare_fn_ty","","",null,null],[5,"enc_closure_ty","","",null,null],[5,"enc_builtin_bounds","","",null,null],[5,"enc_existential_bounds","","",null,null],[5,"enc_bounds","","",null,null],[5,"enc_region_bounds","","",null,null],[5,"enc_type_param_def","","",null,null],[5,"enc_predicate","","",null,null],[0,"tydecode","rustc_trans::metadata","",null,null],[4,"DefIdSource","rustc_trans::metadata::tydecode","",null,null],[13,"NominalType","","",309,null],[13,"TypeWithId","","",309,null],[13,"TypeParameter","","",309,null],[13,"RegionParameter","","",309,null],[13,"ClosureSource","","",309,null],[3,"PState","","",null,null],[5,"parse_name","","",null,{"inputs":[{"name":"pstate"},{"name":"char"}],"output":{"name":"name"}}],[5,"parse_state_from_data","","",null,null],[5,"parse_ty_closure_data","","",null,null],[5,"parse_ty_data","","",null,null],[5,"parse_region_data","","",null,null],[5,"parse_bare_fn_ty_data","","",null,null],[5,"parse_trait_ref_data","","",null,null],[5,"parse_substs_data","","",null,null],[5,"parse_bounds_data","","",null,null],[5,"parse_existential_bounds_data","","",null,null],[5,"parse_builtin_bounds_data","","",null,null],[5,"parse_def_id","","",null,null],[5,"parse_predicate_data","","",null,null],[5,"parse_predicate","","",null,{"inputs":[{"name":"pstate"},{"name":"f"}],"output":{"name":"predicate"}}],[5,"parse_type_param_def_data","","",null,null],[0,"encoder","rustc_trans::metadata","",null,null],[4,"InlinedItemRef","rustc_trans::metadata::encoder","A borrowed version of `ast::InlinedItem`.",null,null],[13,"IIItemRef","","",413,null],[13,"IITraitItemRef","","",413,null],[13,"IIImplItemRef","","",413,null],[13,"IIForeignRef","","",413,null],[6,"EncodeInlinedItem","","",null,null],[3,"EncodeParams","","",null,null],[12,"diag","","",414,null],[12,"tcx","","",414,null],[12,"reexports","","",414,null],[12,"item_symbols","","",414,null],[12,"link_meta","","",414,null],[12,"cstore","","",414,null],[12,"encode_inlined_item","","",414,null],[12,"reachable","","",414,null],[3,"EncodeContext","","",null,null],[12,"diag","","",25,null],[12,"tcx","","",25,null],[12,"reexports","","",25,null],[12,"item_symbols","","",25,null],[12,"link_meta","","",25,null],[12,"cstore","","",25,null],[12,"encode_inlined_item","","",25,null],[12,"type_abbrevs","","",25,null],[12,"reachable","","",25,null],[5,"encode_def_id","","",null,null],[5,"def_to_string","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"string"}}],[5,"write_closure_type","","",null,null],[5,"write_type","","",null,null],[5,"write_trait_ref","","",null,null],[5,"write_region","","",null,null],[17,"metadata_encoding_version","","",null,null],[5,"encode_metadata","","",null,{"inputs":[{"name":"encodeparams"},{"name":"crate"}],"output":{"name":"vec"}}],[5,"encoded_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[0,"decoder","rustc_trans::metadata","",null,null],[6,"Cmd","rustc_trans::metadata::decoder","",null,null],[5,"maybe_find_item","","",null,{"inputs":[{"name":"u32"},{"name":"doc"}],"output":{"name":"option"}}],[5,"item_type","","",null,{"inputs":[{"name":"defid"},{"name":"doc"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_type","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"typescheme"}}],[5,"get_stability","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vecperparamspace"}}],[5,"get_symbol","","",null,null],[4,"DefLike","","",null,null],[13,"DlDef","","",314,null],[13,"DlImpl","","",314,null],[13,"DlField","","",314,null],[5,"each_lang_item","","Iterates over the language items in the given crate.",null,{"inputs":[{"name":"crate_metadata"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,null],[5,"each_top_level_item_of_crate","","Iterates over all the top-level crate items.",null,null],[5,"get_item_path","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[6,"DecodeInlinedItem","","",null,null],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"u32"},{"name":"box"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"strinterner"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns the def IDs of all the items in the given implementation.",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"implortraititem"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","If node_id is the constructor of a tuple struct, retrieve the NodeId of\nthe actual type definition, otherwise, return None",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"hashmap"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_crate_attributes","","",null,null],[3,"CrateDep","","",null,null],[12,"cnum","","",315,null],[12,"name","","",315,null],[12,"hash","","",315,null],[5,"get_crate_deps","","",null,null],[5,"maybe_get_crate_hash","","",null,null],[5,"get_crate_hash","","",null,null],[5,"maybe_get_crate_name","","",null,null],[5,"get_crate_triple","","",null,null],[5,"get_crate_name","","",null,null],[5,"list_crate_metadata","","",null,null],[5,"translate_def_id","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"defid"}],"output":{"name":"defid"}}],[5,"each_impl","","",null,null],[5,"each_implementation_for_type","","",null,null],[5,"each_implementation_for_trait","","",null,null],[5,"get_trait_of_item","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_plugin_registrar_fn","","",null,null],[5,"each_exported_macro","","",null,null],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"get_imported_filemaps","","",null,null],[0,"creader","rustc_trans::metadata","Validates all used crates and extern libraries and loads their metadata",null,null],[3,"CrateReader","rustc_trans::metadata::creader","",null,null],[5,"validate_crate_name","","",null,null],[0,"cstore","rustc_trans::metadata","",null,null],[6,"cnum_map","rustc_trans::metadata::cstore","",null,null],[4,"MetadataBlob","","",null,null],[13,"MetadataVec","","",323,null],[13,"MetadataArchive","","",323,null],[3,"ImportedFileMap","","Holds information about a codemap::FileMap imported from another crate.\nSee creader::import_codemap() for more information.",null,null],[12,"original_start_pos","","This FileMap's byte-offset within the codemap of its original crate",415,null],[12,"original_end_pos","","The end of this FileMap within the codemap of its original crate",415,null],[12,"translated_filemap","","The imported FileMap's representation within the local codemap",415,null],[3,"crate_metadata","","",null,null],[12,"name","","",322,null],[12,"data","","",322,null],[12,"cnum_map","","",322,null],[12,"cnum","","",322,null],[12,"codemap_import_info","","",322,null],[12,"span","","",322,null],[4,"LinkagePreference","","",null,null],[13,"RequireDynamic","","",318,null],[13,"RequireStatic","","",318,null],[4,"NativeLibraryKind","","",null,null],[13,"NativeStatic","","",319,null],[13,"NativeFramework","","",319,null],[13,"NativeUnknown","","",319,null],[3,"CrateSource","","",null,null],[12,"dylib","","",320,null],[12,"rlib","","",320,null],[12,"cnum","","",320,null],[3,"CStore","","",null,null],[12,"intr","","",321,null],[0,"csearch","rustc_trans::metadata","",null,null],[3,"MethodInfo","rustc_trans::metadata::csearch","",null,null],[12,"name","","",324,null],[12,"def_id","","",324,null],[12,"vis","","",324,null],[5,"get_symbol","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"string"}}],[5,"each_lang_item","","Iterates over all the language items in the given crate.",null,{"inputs":[{"name":"cstore"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,null],[5,"each_top_level_item_of_crate","","Iterates over each top-level crate item.",null,null],[5,"get_item_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[4,"FoundAst","","",null,null],[13,"Found","","",416,null],[13,"FoundParent","","",416,null],[13,"NotFound","","",416,null],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"box"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns information about the given implementation.",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"hashmap"}}],[5,"get_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vecperparamspace"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"each_impl","","",null,null],[5,"each_implementation_for_type","","",null,null],[5,"each_implementation_for_trait","","",null,null],[5,"get_trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), returns the ID of\nthe trait that the method belongs to. Otherwise, returns `None`.",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_stability","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"is_staged_api","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[0,"loader","rustc_trans::metadata","Finds crate binaries and loads their metadata",null,null],[3,"CrateMismatch","rustc_trans::metadata::loader","",null,null],[3,"Context","","",null,null],[12,"sess","","",325,null],[12,"span","","",325,null],[12,"ident","","",325,null],[12,"crate_name","","",325,null],[12,"hash","","",325,null],[12,"target","","",325,null],[12,"triple","","",325,null],[12,"filesearch","","",325,null],[12,"root","","",325,null],[12,"rejected_via_hash","","",325,null],[12,"rejected_via_triple","","",325,null],[12,"rejected_via_kind","","",325,null],[12,"should_match_name","","",325,null],[3,"Library","","",null,null],[12,"dylib","","",417,null],[12,"rlib","","",417,null],[12,"metadata","","",417,null],[3,"ArchiveMetadata","","",null,null],[3,"CratePaths","","",null,null],[12,"ident","","",418,null],[12,"dylib","","",418,null],[12,"rlib","","",418,null],[5,"note_crate_name","","",null,null],[5,"meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"read_meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"list_file_metadata","","",null,{"inputs":[{"name":"bool"},{"name":"path"},{"name":"write"}],"output":{"name":"result"}}],[0,"filesearch","rustc_trans::metadata","",null,null],[4,"FileMatch","rustc_trans::metadata::filesearch","",null,null],[13,"FileMatches","","",327,null],[13,"FileDoesntMatch","","",327,null],[3,"FileSearch","","",null,null],[12,"sysroot","","",328,null],[12,"search_paths","","",328,null],[12,"triple","","",328,null],[12,"kind","","",328,null],[5,"relative_target_lib_path","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"get_or_default_sysroot","","",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"get_rust_path","","Returns RUST_PATH as a string, without default paths added",null,{"inputs":[],"output":{"name":"option"}}],[5,"rust_path","","Returns the value of RUST_PATH, as a list\nof Paths. Includes default entries for, if they exist:\n$HOME/.rust\nDIR/.rust for any DIR that's the current working directory\nor an ancestor of it",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustlibdir","","",null,{"inputs":[],"output":{"name":"string"}}],[0,"macro_import","rustc_trans::metadata","Used by `rustc` when loading a crate with exported macros.",null,null],[5,"read_macro_defs","rustc_trans::metadata::macro_import","Read exported macros.",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"vec"}}],[6,"MacroSelection","","",null,null],[0,"middle","rustc_trans","",null,null],[0,"astconv_util","rustc_trans::middle","This module contains a simple utility routine\nused by both `typeck` and `const_eval`.\nAlmost certainly this could (and should) be refactored out of existence.",null,null],[17,"NO_REGIONS","rustc_trans::middle::astconv_util","",null,null],[17,"NO_TPS","","",null,null],[5,"check_path_args","","",null,null],[5,"prim_ty_to_ty","","",null,null],[5,"ast_ty_to_prim_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"option"}}],[0,"astencode","rustc_trans::middle","",null,null],[5,"encode_inlined_item","rustc_trans::middle::astencode","",null,null],[5,"decode_inlined_item","","Decodes an item from its AST in the cdata's metadata and adds it to the\nast-map.",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"vec"},{"name":"doc"}],"output":{"name":"result"}}],[5,"encode_closure_kind","","",null,null],[8,"vtable_decoder_helpers","","",null,null],[10,"read_vec_per_param_space","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_res_with_key","","",419,null],[10,"read_vtable_res","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_param_res","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[10,"read_vtable_origin","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[0,"cfg","rustc_trans::middle","Module that constructs a control-flow graph representing an item.\nUses `Graph` as the underlying representation.",null,null],[0,"graphviz","rustc_trans::middle::cfg","",null,null],[6,"Node","rustc_trans::middle::cfg::graphviz","",null,null],[6,"Edge","","",null,null],[3,"LabelledCFG","","",null,null],[12,"ast_map","","",30,null],[12,"cfg","","",30,null],[12,"name","","",30,null],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",30,null],[3,"CFG","rustc_trans::middle::cfg","",null,null],[12,"graph","","",32,null],[12,"entry","","",32,null],[12,"exit","","",32,null],[4,"CFGNodeData","","",null,null],[13,"AST","","",31,null],[13,"Entry","","",31,null],[13,"Exit","","",31,null],[13,"Dummy","","",31,null],[13,"Unreachable","","",31,null],[3,"CFGEdgeData","","",null,null],[12,"exiting_scopes","","",420,null],[6,"CFGIndex","","",null,null],[6,"CFGGraph","","",null,null],[6,"CFGNode","","",null,null],[6,"CFGEdge","","",null,null],[0,"check_const","rustc_trans::middle","",null,null],[3,"ConstQualif","rustc_trans::middle::check_const","",null,null],[17,"PURE_CONST","","",null,null],[17,"MUTABLE_MEM","","",null,null],[17,"NEEDS_DROP","","",null,null],[17,"PREFER_IN_PLACE","","",null,null],[17,"NON_ZERO_SIZED","","",null,null],[17,"HAS_STATIC_BORROWS","","",null,null],[17,"NOT_CONST","","",null,null],[17,"NON_STATIC_BORROWS","","",null,null],[5,"check_crate","","",null,null],[0,"check_static_recursion","rustc_trans::middle","",null,null],[5,"check_crate","rustc_trans::middle::check_static_recursion","",null,null],[5,"check_item_recursion","","",null,null],[0,"check_loop","rustc_trans::middle","",null,null],[5,"check_crate","rustc_trans::middle::check_loop","",null,null],[0,"check_match","rustc_trans::middle","",null,null],[17,"DUMMY_WILD_PAT","rustc_trans::middle::check_match","",null,null],[3,"MatchCheckCtxt","","",null,null],[12,"tcx","","",44,null],[12,"param_env","","",44,null],[4,"Constructor","","",null,null],[13,"Single","","The constructor of all patterns that don't vary by constructor,\ne.g. struct patterns and fixed-length arrays.",41,null],[13,"Variant","","Enum variants.",41,null],[13,"ConstantValue","","Literal values.",41,null],[13,"ConstantRange","","Ranges of literal values (2..5).",41,null],[13,"Slice","","Array patterns of length n.",41,null],[13,"SliceWithSubslice","","Array patterns with a subslice.",41,null],[5,"check_crate","","",null,null],[3,"StaticInliner","","",null,null],[12,"tcx","","",45,null],[12,"failed","","",45,null],[12,"renaming_map","","",45,null],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor\nis how many subpattern patterns of that constructor should be expanded to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"tys"}],"output":{"name":"usize"}}],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row\ninto `arity` patterns based on the constructor. For most patterns, the step is trivial,\nfor instance tuple patterns are flattened and box patterns expand into their inner pattern.",null,null],[0,"check_rvalues","rustc_trans::middle","",null,null],[5,"check_crate","rustc_trans::middle::check_rvalues","",null,null],[0,"const_eval","rustc_trans::middle","",null,null],[5,"lookup_const_by_id","rustc_trans::middle::const_eval","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[4,"const_val","","",null,null],[13,"const_float","","",51,null],[13,"const_int","","",51,null],[13,"const_uint","","",51,null],[13,"const_str","","",51,null],[13,"const_binary","","",51,null],[13,"const_bool","","",51,null],[13,"Struct","","",51,null],[13,"Tuple","","",51,null],[5,"const_expr_to_pat","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"span"}],"output":{"name":"p"}}],[5,"eval_const_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"const_val"}}],[3,"ConstEvalErr","","",null,null],[12,"span","","",52,null],[12,"kind","","",52,null],[4,"ErrKind","","",null,null],[13,"CannotCast","","",53,null],[13,"CannotCastTo","","",53,null],[13,"InvalidOpForBools","","",53,null],[13,"InvalidOpForFloats","","",53,null],[13,"InvalidOpForIntUint","","",53,null],[13,"InvalidOpForUintInt","","",53,null],[13,"NegateOnString","","",53,null],[13,"NegateOnBoolean","","",53,null],[13,"NegateOnBinary","","",53,null],[13,"NegateOnStruct","","",53,null],[13,"NegateOnTuple","","",53,null],[13,"NotOnFloat","","",53,null],[13,"NotOnString","","",53,null],[13,"NotOnBinary","","",53,null],[13,"NotOnStruct","","",53,null],[13,"NotOnTuple","","",53,null],[13,"NegateWithOverflow","","",53,null],[13,"AddiWithOverflow","","",53,null],[13,"SubiWithOverflow","","",53,null],[13,"MuliWithOverflow","","",53,null],[13,"AdduWithOverflow","","",53,null],[13,"SubuWithOverflow","","",53,null],[13,"MuluWithOverflow","","",53,null],[13,"DivideByZero","","",53,null],[13,"DivideWithOverflow","","",53,null],[13,"ModuloByZero","","",53,null],[13,"ModuloWithOverflow","","",53,null],[13,"ShiftLeftWithOverflow","","",53,null],[13,"ShiftRightWithOverflow","","",53,null],[13,"MissingStructField","","",53,null],[13,"NonConstPath","","",53,null],[13,"ExpectedConstTuple","","",53,null],[13,"ExpectedConstStruct","","",53,null],[13,"TupleIndexOutOfBounds","","",53,null],[13,"MiscBinaryOp","","",53,null],[13,"MiscCatchAll","","",53,null],[6,"EvalResult","","",null,null],[6,"CastResult","","",null,null],[4,"IntTy","","",null,null],[13,"I8","","",54,null],[13,"I16","","",54,null],[13,"I32","","",54,null],[13,"I64","","",54,null],[4,"UintTy","","",null,null],[13,"U8","","",55,null],[13,"U16","","",55,null],[13,"U32","","",55,null],[13,"U64","","",55,null],[5,"const_int_checked_neg","","",null,{"inputs":[{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_neg","","",null,{"inputs":[{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_add","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_sub","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_mul","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_div","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_rem","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shl","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shl_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shr","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shr_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_add","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_sub","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_mul","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_div","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_rem","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shl","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shl_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shr","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shr_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"eval_const_expr_partial","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"compare_const_vals","","",null,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"option"}}],[5,"compare_lit_exprs","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"expr"},{"name":"option"}],"output":{"name":"option"}}],[0,"dataflow","rustc_trans::middle","A module for propagating forward dataflow information. The analysis\nassumes that the items to be propagated can be represented as bits\nand thus uses bitvectors. Your job is simply to specify the so-called\nGEN and KILL bits for each expression.",null,null],[4,"EntryOrExit","rustc_trans::middle::dataflow","",null,null],[13,"Entry","","",56,null],[13,"Exit","","",56,null],[3,"DataFlowContext","","",null,null],[8,"BitwiseOperator","","",null,null],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",421,{"inputs":[{"name":"bitwiseoperator"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",null,null],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",422,{"inputs":[{"name":"dataflowoperator"}],"output":{"name":"bool"}}],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill\ntakes effect only when control flows directly through the node in\nquestion, or if the kill's effect is associated with any\ncontrol-flow directly through or indirectly over the node.",null,null],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control\nflow goes over the node. A kill associated with the end of the\nscope of a variable declaration `let x;` is an example of a\n`ScopeEnd` kill.",58,null],[13,"Execution","","An `Execution` kill is one that takes effect only when control\nflow goes through the node to completion. A kill associated\nwith an assignment statement `x = expr;` is an example of an\n`Execution` kill.",58,null],[0,"dead","rustc_trans::middle","",null,null],[5,"check_crate","rustc_trans::middle::dead","",null,null],[0,"def","rustc_trans::middle","",null,null],[4,"Def","rustc_trans::middle::def","",null,null],[13,"DefFn","","",14,null],[13,"DefSelfTy","","",14,null],[13,"DefMod","","",14,null],[13,"DefForeignMod","","",14,null],[13,"DefStatic","","",14,null],[13,"DefConst","","",14,null],[13,"DefLocal","","",14,null],[13,"DefVariant","","",14,null],[13,"DefTy","","",14,null],[13,"DefAssociatedTy","","",14,null],[13,"DefTrait","","",14,null],[13,"DefPrimTy","","",14,null],[13,"DefTyParam","","",14,null],[13,"DefUse","","",14,null],[13,"DefUpvar","","",14,null],[13,"DefStruct","","Note that if it's a tuple struct's definition, the node id of the ast::DefId\nmay either refer to the item definition's id or the StructDef.ctor_id.",14,null],[13,"DefRegion","","",14,null],[13,"DefLabel","","",14,null],[13,"DefMethod","","",14,null],[3,"PathResolution","","The result of resolving a path.\nBefore type checking completes, `depth` represents the number of\ntrailing segments which are yet unresolved. Afterwards, if there\nwere no errors, all paths should be fully resolved, with `depth`\nset to `0` and `base_def` representing the final resolution.",null,null],[12,"base_def","","",64,null],[12,"last_private","","",64,null],[12,"depth","","",64,null],[6,"DefMap","","",null,null],[6,"ExportMap","","",null,null],[3,"Export","","",null,null],[12,"name","","",65,null],[12,"def_id","","",65,null],[4,"MethodProvenance","","",null,null],[13,"FromTrait","","",66,null],[13,"FromImpl","","",66,null],[0,"dependency_format","rustc_trans::middle","Resolution of mixing rlibs and dylibs",null,null],[6,"DependencyList","rustc_trans::middle::dependency_format","",null,null],[6,"Dependencies","","",null,null],[5,"calculate","","",null,null],[0,"effect","rustc_trans::middle","Enforces the Rust effect system. Currently there is just one effect,\n`unsafe`.",null,null],[5,"check_crate","rustc_trans::middle::effect","",null,null],[0,"entry","rustc_trans::middle","",null,null],[5,"find_entry_point","rustc_trans::middle::entry","",null,null],[0,"expr_use_visitor","rustc_trans::middle","A different sort of visitor for walking fn bodies.  Unlike the\nnormal visitor, which just walks the entire body in one shot, the\n`ExprUseVisitor` determines how expressions are being used.",null,null],[8,"Delegate","rustc_trans::middle::expr_use_visitor","This trait defines the callbacks you can expect to receive when\nemploying the ExprUseVisitor.",null,null],[10,"consume","","",423,null],[10,"matched_pat","","",423,null],[10,"consume_pat","","",423,null],[10,"borrow","","",423,null],[10,"decl_without_init","","",423,null],[10,"mutate","","",423,null],[4,"LoanCause","","",null,null],[13,"ClosureCapture","","",70,null],[13,"AddrOf","","",70,null],[13,"AutoRef","","",70,null],[13,"AutoUnsafe","","",70,null],[13,"RefBinding","","",70,null],[13,"OverloadedOperator","","",70,null],[13,"ClosureInvocation","","",70,null],[13,"ForLoop","","",70,null],[13,"MatchDiscriminant","","",70,null],[4,"ConsumeMode","","",null,null],[13,"Copy","","",71,null],[13,"Move","","",71,null],[4,"MoveReason","","",null,null],[13,"DirectRefMove","","",72,null],[13,"PatBindingMove","","",72,null],[13,"CaptureMove","","",72,null],[4,"MatchMode","","",null,null],[13,"NonBindingMatch","","",73,null],[13,"BorrowingMatch","","",73,null],[13,"CopyingMatch","","",73,null],[13,"MovingMatch","","",73,null],[4,"MutateMode","","",null,null],[13,"Init","","",75,null],[13,"JustWrite","","",75,null],[13,"WriteAndRead","","",75,null],[3,"ExprUseVisitor","","",null,null],[0,"fast_reject","rustc_trans::middle","",null,null],[4,"SimplifiedType","rustc_trans::middle::fast_reject","See `simplify_type",null,null],[13,"BoolSimplifiedType","","",78,null],[13,"CharSimplifiedType","","",78,null],[13,"IntSimplifiedType","","",78,null],[13,"UintSimplifiedType","","",78,null],[13,"FloatSimplifiedType","","",78,null],[13,"EnumSimplifiedType","","",78,null],[13,"StrSimplifiedType","","",78,null],[13,"VecSimplifiedType","","",78,null],[13,"PtrSimplifiedType","","",78,null],[13,"TupleSimplifiedType","","",78,null],[13,"TraitSimplifiedType","","",78,null],[13,"StructSimplifiedType","","",78,null],[13,"ClosureSimplifiedType","","",78,null],[13,"FunctionSimplifiedType","","",78,null],[13,"ParameterSimplifiedType","","",78,null],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc.\nThe idea is to get something simple that we can use to quickly decide if two types could unify\nduring method lookup.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"bool"}],"output":{"name":"option"}}],[0,"free_region","rustc_trans::middle","This file defines",null,null],[3,"FreeRegionMap","rustc_trans::middle::free_region","",null,null],[0,"graph","rustc_trans::middle","A graph module for use in dataflow, region resolution, and elsewhere.",null,null],[3,"Graph","rustc_trans::middle::graph","",null,null],[3,"Node","","",null,null],[12,"data","","",424,null],[3,"Edge","","",null,null],[12,"data","","",80,null],[3,"NodeIndex","","",null,null],[17,"InvalidNodeIndex","","",null,null],[3,"EdgeIndex","","",null,null],[17,"InvalidEdgeIndex","","",null,null],[3,"Direction","","",null,null],[17,"Outgoing","","",null,null],[17,"Incoming","","",null,null],[3,"DepthFirstTraversal","","",null,null],[5,"each_edge_index","","",null,null],[0,"intrinsicck","rustc_trans::middle","",null,null],[5,"check_crate","rustc_trans::middle::intrinsicck","",null,null],[0,"infer","rustc_trans::middle","See the Book for more information.",null,null],[0,"bivariate","rustc_trans::middle::infer","Applies the \"bivariance relationship\" to two types and/or regions.\nIf (A,B) are bivariant then either A <: B or B <: A. It occurs\nwhen type/lifetime parameters are unconstrained. Usually this is\nan error, but we permit it in the specific case where a type\nparameter is constrained in a where-clause via an associated type.",null,null],[3,"Bivariate","rustc_trans::middle::infer::bivariate","",null,null],[0,"combine","rustc_trans::middle::infer","",null,null],[3,"CombineFields","rustc_trans::middle::infer::combine","",null,null],[12,"infcx","","",89,null],[12,"a_is_expected","","",89,null],[12,"trace","","",89,null],[5,"super_combine_tys","","",null,{"inputs":[{"name":"inferctxt"},{"name":"r"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[8,"RelateResultCompare","","",null,null],[10,"compare","","",425,{"inputs":[{"name":"relateresultcompare"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[0,"equate","rustc_trans::middle::infer","",null,null],[3,"Equate","rustc_trans::middle::infer::equate","",null,null],[0,"error_reporting","rustc_trans::middle::infer","Error Reporting Code for the inference engine",null,null],[8,"ErrorReporting","rustc_trans::middle::infer::error_reporting","",null,null],[10,"report_region_errors","","",426,null],[10,"process_errors","","",426,{"inputs":[{"name":"errorreporting"},{"name":"vec"}],"output":{"name":"vec"}}],[10,"report_type_error","","",426,null],[10,"report_and_explain_type_error","","",426,null],[10,"values_str","","",426,{"inputs":[{"name":"errorreporting"},{"name":"valuepairs"}],"output":{"name":"option"}}],[10,"expected_found_str","","",426,{"inputs":[{"name":"errorreporting"},{"name":"expected_found"}],"output":{"name":"option"}}],[10,"report_concrete_failure","","",426,null],[10,"report_generic_bound_failure","","",426,null],[10,"report_sub_sup_conflict","","",426,null],[10,"report_sup_sup_conflict","","",426,null],[10,"report_processed_errors","","",426,null],[10,"give_suggestion","","",426,null],[8,"Resolvable","","",null,null],[10,"resolve","","",427,{"inputs":[{"name":"resolvable"},{"name":"inferctxt"}],"output":{"name":"self"}}],[10,"contains_error","","",427,{"inputs":[{"name":"resolvable"}],"output":{"name":"bool"}}],[0,"glb","rustc_trans::middle::infer","",null,null],[3,"Glb","rustc_trans::middle::infer::glb","\"Greatest lower bound\" (common subtype)",null,null],[0,"lattice","rustc_trans::middle::infer","# Lattice Variables",null,null],[8,"LatticeDir","rustc_trans::middle::infer::lattice","",null,null],[10,"infcx","","",428,{"inputs":[{"name":"latticedir"}],"output":{"name":"inferctxt"}}],[10,"relate_bound","","",428,{"inputs":[{"name":"latticedir"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"super_lattice_tys","","",null,{"inputs":[{"name":"l"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[0,"lub","rustc_trans::middle::infer","",null,null],[3,"Lub","rustc_trans::middle::infer::lub","\"Least upper bound\" (common supertype)",null,null],[0,"region_inference","rustc_trans::middle::infer","See README.md",null,null],[4,"Constraint","rustc_trans::middle::infer::region_inference","",null,null],[13,"ConstrainVarSubVar","","",101,null],[13,"ConstrainRegSubVar","","",101,null],[13,"ConstrainVarSubReg","","",101,null],[4,"Verify","","",null,null],[13,"VerifyRegSubReg","","",112,null],[13,"VerifyGenericBound","","",112,null],[4,"GenericKind","","",null,null],[13,"Param","","",102,null],[13,"Projection","","",102,null],[3,"TwoRegions","","",null,null],[4,"UndoLogEntry","","",null,null],[13,"OpenSnapshot","","",104,null],[13,"CommitedSnapshot","","",104,null],[13,"AddVar","","",104,null],[13,"AddConstraint","","",104,null],[13,"AddVerify","","",104,null],[13,"AddGiven","","",104,null],[13,"AddCombination","","",104,null],[4,"CombineMapType","","",null,null],[13,"Lub","","",105,null],[13,"Glb","","",105,null],[4,"RegionResolutionError","","",null,null],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",106,null],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a, bs)",106,null],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",106,null],[13,"SupSupConflict","","`SupSupConflict(v, origin1, r1, origin2, r2)`:",106,null],[13,"ProcessedErrors","","For subsets of `ConcreteFailure` and `SubSupConflict`, we can derive\nmore specific errors message by suggesting to the user where they\nshould put a lifetime. In those cases we process and put those errors\ninto `ProcessedErrors` before we do any reporting.",106,null],[3,"SameRegions","","SameRegions is used to group regions that we think are the same and would\nlike to indicate so to the user.\nFor example, the following function\n```\nstruct Foo { bar: int }\nfn foo2<'a, 'b>(x: &'a Foo) -> &'b int {\n   &x.bar\n}\n```\nwould report an error because we expect 'a and 'b to match, and so we group\n'a and 'b together inside a SameRegions struct",null,null],[12,"scope_id","","",107,null],[12,"regions","","",107,null],[6,"CombineMap","","",null,null],[3,"RegionVarBindings","","",null,null],[3,"RegionSnapshot","","",null,null],[4,"VarValue","","",null,null],[13,"NoValue","","",111,null],[13,"Value","","",111,null],[13,"ErrorValue","","",111,null],[0,"resolve","rustc_trans::middle::infer","",null,null],[3,"OpportunisticTypeResolver","rustc_trans::middle::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces\ntype variables that have been unified with the things they have\nbeen unified with (similar to `shallow_resolve`, but deep). This is\nuseful for printing messages etc but also required at various\npoints for correctness.",null,null],[5,"fully_resolve","","Full type resolution replaces all type and region variables with\ntheir concrete results. If any variable cannot be replaced (never unified, etc)\nthen an `Err` result is returned.",null,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[0,"sub","rustc_trans::middle::infer","",null,null],[3,"Sub","rustc_trans::middle::infer::sub","\"Greatest lower bound\" (common subtype)",null,null],[0,"type_variable","rustc_trans::middle::infer","",null,null],[3,"TypeVariableTable","rustc_trans::middle::infer::type_variable","",null,null],[3,"Snapshot","","",null,null],[4,"RelationDir","","",null,null],[13,"SubtypeOf","","",118,null],[13,"SupertypeOf","","",118,null],[13,"EqTo","","",118,null],[13,"BiTo","","",118,null],[0,"unify","rustc_trans::middle::infer","",null,null],[8,"UnifyKey","rustc_trans::middle::infer::unify","This trait is implemented by any type that can serve as a type\nvariable. We call such variables *unification keys*. For example,\nthis trait is implemented by `IntVid`, which represents integral\nvariables.",null,null],[16,"Value","rustc_trans::middle::infer::unify::UnifyKey","",null,null],[10,"index","rustc_trans::middle::infer::unify","",429,{"inputs":[{"name":"unifykey"}],"output":{"name":"u32"}}],[10,"from_index","","",429,{"inputs":[{"name":"unifykey"},{"name":"u32"}],"output":{"name":"self"}}],[10,"tag","","",429,{"inputs":[{"name":"unifykey"},{"name":"option"}],"output":{"name":"str"}}],[8,"UnifyValue","","Trait for valid types that a type variable can be set to. Note that\nthis is typically not the end type that the value will take on, but\nrather an `Option` wrapper (where `None` represents a variable\nwhose value is not yet set).",null,null],[4,"VarValue","","Value of a unification key. We implement Tarjan's union-find\nalgorithm: when two keys are unified, one of them is converted\ninto a \"redirect\" pointing at the other. These redirects form a\nDAG: the roots of the DAG (nodes that are not redirected) are each\nassociated with a value of type `V` and a rank. The rank is used\nto keep the DAG relatively balanced, which helps keep the running\ntime of the algorithm under control. For more information, see\n<http://en.wikipedia.org/wiki/Disjoint-set_data_structure>.",null,null],[13,"Redirect","","",121,null],[13,"Root","","",121,null],[3,"UnificationTable","","Table of unification keys and their values.",null,null],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes\nmade during the snapshot may either be *committed* or *rolled back*.",null,null],[3,"Node","","Internal type used to represent the result of a `get()` operation.\nConveys the current root and value of the key.",null,null],[12,"key","","",430,null],[12,"value","","",430,null],[12,"rank","","",430,null],[3,"Delegate","","",null,null],[8,"ToType","","",null,null],[10,"to_type","","",431,{"inputs":[{"name":"totype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Bound","rustc_trans::middle::infer","",null,null],[6,"UnitResult","","",null,null],[6,"fres","","",null,null],[3,"InferCtxt","","",null,null],[12,"tcx","","",93,null],[6,"SkolemizationMap","","",null,null],[4,"TypeOrigin","","Why did we require that the two types be related?",null,null],[13,"Misc","","",128,null],[13,"MethodCompatCheck","","",128,null],[13,"ExprAssignable","","",128,null],[13,"RelateTraitRefs","","",128,null],[13,"RelateSelfType","","",128,null],[13,"RelateOutputImplTypes","","",128,null],[13,"MatchExpressionArm","","",128,null],[13,"IfExpression","","",128,null],[13,"IfExpressionWithNoElse","","",128,null],[13,"RangeExpression","","",128,null],[13,"EquatePredicate","","",128,null],[4,"ValuePairs","","See `error_reporting.rs` for more details",null,null],[13,"Types","","",129,null],[13,"TraitRefs","","",129,null],[13,"PolyTraitRefs","","",129,null],[3,"TypeTrace","","The trace designates the path through inference that we took to\nencounter an error or subtyping constraint.",null,null],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",null,null],[13,"Subtype","","",131,null],[13,"InfStackClosure","","",131,null],[13,"InvokeClosure","","",131,null],[13,"DerefPointer","","",131,null],[13,"FreeVariable","","",131,null],[13,"IndexSlice","","",131,null],[13,"RelateObjectBound","","",131,null],[13,"RelateParamBound","","",131,null],[13,"RelateRegionParamBound","","",131,null],[13,"RelateDefaultParamBound","","",131,null],[13,"Reborrow","","",131,null],[13,"ReborrowUpvar","","",131,null],[13,"ReferenceOutlivesReferent","","",131,null],[13,"ExprTypeIsNotInScope","","",131,null],[13,"BindingTypeIsNotValidAtDecl","","",131,null],[13,"CallRcvr","","",131,null],[13,"CallArg","","",131,null],[13,"CallReturn","","",131,null],[13,"Operand","","",131,null],[13,"AddrOf","","",131,null],[13,"AutoBorrow","","",131,null],[13,"SafeDestructor","","",131,null],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",null,null],[13,"FnCall","","when a fn is called",132,null],[13,"HigherRankedType","","when two higher-ranked types are compared",132,null],[13,"AssocTypeProjection","","when projecting an associated type",132,null],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",null,null],[13,"MiscVariable","","",133,null],[13,"PatternRegion","","",133,null],[13,"AddrOfRegion","","",133,null],[13,"Autoref","","",133,null],[13,"Coercion","","",133,null],[13,"EarlyBoundRegion","","",133,null],[13,"LateBoundRegion","","",133,null],[13,"UpvarRegion","","",133,null],[13,"BoundRegionInCoherence","","",133,null],[4,"fixup_err","","",null,null],[13,"unresolved_int_ty","","",134,null],[13,"unresolved_float_ty","","",134,null],[13,"unresolved_ty","","",134,null],[5,"fixup_err_to_string","","",null,{"inputs":[{"name":"fixup_err"}],"output":{"name":"string"}}],[5,"new_infer_ctxt","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"inferctxt"}}],[5,"common_supertype","","Computes the least upper-bound of `a` and `b`. If this is not possible, reports an error and\nreturns ty::err.",null,{"inputs":[{"name":"inferctxt"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"can_mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"can_mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"mk_subr","","",null,null],[5,"mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"mk_sub_poly_trait_refs","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[3,"CombinedSnapshot","","",null,null],[4,"GenericKind","","",null,null],[13,"Param","","",102,null],[13,"Projection","","",102,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",125,null],[13,"UintType","","",125,null],[3,"TypeFreshener","","",null,null],[0,"implicator","rustc_trans::middle","",null,null],[4,"Implication","rustc_trans::middle::implicator","",null,null],[13,"RegionSubRegion","","",135,null],[13,"RegionSubGeneric","","",135,null],[13,"RegionSubClosure","","",135,null],[13,"Predicate","","",135,null],[5,"implications","","This routine computes the well-formedness constraints that must hold for the type `ty` to\nappear in a context with lifetime `outer_region`",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"u32"},{"name":"tys"},{"name":"region"},{"name":"span"}],"output":{"name":"vec"}}],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime\nbounds that must hold on the elided self type. These are derived\nfrom the declarations of `SomeTrait`, `Send`, and friends -- if\nthey declare `trait SomeTrait : 'static`, for example, then\n`'static` would appear in the list. The hard work is done by\n`ty::required_region_bounds`, see that for more information.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"enumset"}],"output":{"name":"vec"}}],[0,"lang_items","rustc_trans::middle","",null,null],[4,"LangItem","rustc_trans::middle::lang_items","",null,null],[13,"CharImplItem","","",136,null],[13,"StrImplItem","","",136,null],[13,"SliceImplItem","","",136,null],[13,"ConstPtrImplItem","","",136,null],[13,"MutPtrImplItem","","",136,null],[13,"I8ImplItem","","",136,null],[13,"I16ImplItem","","",136,null],[13,"I32ImplItem","","",136,null],[13,"I64ImplItem","","",136,null],[13,"IsizeImplItem","","",136,null],[13,"U8ImplItem","","",136,null],[13,"U16ImplItem","","",136,null],[13,"U32ImplItem","","",136,null],[13,"U64ImplItem","","",136,null],[13,"UsizeImplItem","","",136,null],[13,"F32ImplItem","","",136,null],[13,"F64ImplItem","","",136,null],[13,"SendTraitLangItem","","",136,null],[13,"SizedTraitLangItem","","",136,null],[13,"CopyTraitLangItem","","",136,null],[13,"SyncTraitLangItem","","",136,null],[13,"DropTraitLangItem","","",136,null],[13,"AddTraitLangItem","","",136,null],[13,"SubTraitLangItem","","",136,null],[13,"MulTraitLangItem","","",136,null],[13,"DivTraitLangItem","","",136,null],[13,"RemTraitLangItem","","",136,null],[13,"NegTraitLangItem","","",136,null],[13,"NotTraitLangItem","","",136,null],[13,"BitXorTraitLangItem","","",136,null],[13,"BitAndTraitLangItem","","",136,null],[13,"BitOrTraitLangItem","","",136,null],[13,"ShlTraitLangItem","","",136,null],[13,"ShrTraitLangItem","","",136,null],[13,"IndexTraitLangItem","","",136,null],[13,"IndexMutTraitLangItem","","",136,null],[13,"RangeStructLangItem","","",136,null],[13,"RangeFromStructLangItem","","",136,null],[13,"RangeToStructLangItem","","",136,null],[13,"RangeFullStructLangItem","","",136,null],[13,"UnsafeCellTypeLangItem","","",136,null],[13,"DerefTraitLangItem","","",136,null],[13,"DerefMutTraitLangItem","","",136,null],[13,"FnTraitLangItem","","",136,null],[13,"FnMutTraitLangItem","","",136,null],[13,"FnOnceTraitLangItem","","",136,null],[13,"EqTraitLangItem","","",136,null],[13,"OrdTraitLangItem","","",136,null],[13,"StrEqFnLangItem","","",136,null],[13,"PanicFnLangItem","","",136,null],[13,"PanicBoundsCheckFnLangItem","","",136,null],[13,"PanicFmtLangItem","","",136,null],[13,"ExchangeMallocFnLangItem","","",136,null],[13,"ExchangeFreeFnLangItem","","",136,null],[13,"StrDupUniqFnLangItem","","",136,null],[13,"StartFnLangItem","","",136,null],[13,"EhPersonalityLangItem","","",136,null],[13,"ExchangeHeapLangItem","","",136,null],[13,"OwnedBoxLangItem","","",136,null],[13,"PhantomDataItem","","",136,null],[13,"CovariantTypeItem","","",136,null],[13,"ContravariantTypeItem","","",136,null],[13,"InvariantTypeItem","","",136,null],[13,"CovariantLifetimeItem","","",136,null],[13,"ContravariantLifetimeItem","","",136,null],[13,"InvariantLifetimeItem","","",136,null],[13,"NoCopyItem","","",136,null],[13,"ManagedItem","","",136,null],[13,"NonZeroItem","","",136,null],[13,"StackExhaustedLangItem","","",136,null],[13,"DebugTraitLangItem","","",136,null],[3,"LanguageItems","","",null,null],[12,"items","","",137,null],[12,"missing","","",137,null],[5,"extract","","",null,null],[5,"collect_language_items","","",null,{"inputs":[{"name":"crate"},{"name":"session"}],"output":{"name":"languageitems"}}],[0,"liveness","rustc_trans::middle","A classic liveness analysis based on dataflow over the AST.  Computes,\nfor each local variable in a function, whether that variable is live\nat a given point.  Program execution points are identified by their\nid.",null,null],[5,"check_crate","rustc_trans::middle::liveness","",null,null],[0,"mem_categorization","rustc_trans::middle","# Categorization",null,null],[4,"categorization","rustc_trans::middle::mem_categorization","",null,null],[13,"cat_rvalue","","",148,null],[13,"cat_static_item","","",148,null],[13,"cat_upvar","","",148,null],[13,"cat_local","","",148,null],[13,"cat_deref","","",148,null],[13,"cat_interior","","",148,null],[13,"cat_downcast","","",148,null],[3,"Upvar","","",null,null],[12,"id","","",149,null],[12,"kind","","",149,null],[4,"PointerKind","","",null,null],[13,"Unique","","`Box<T>`",150,null],[13,"BorrowedPtr","","`&T`",150,null],[13,"UnsafePtr","","`*T`",150,null],[13,"Implicit","","Implicit deref of the `&T` that results from an overloaded index `[]`.",150,null],[4,"InteriorKind","","",null,null],[13,"InteriorField","","",151,null],[13,"InteriorElement","","",151,null],[4,"FieldName","","",null,null],[13,"NamedField","","",152,null],[13,"PositionalField","","",152,null],[4,"InteriorOffsetKind","","",null,null],[13,"Index","","",153,null],[13,"Pattern","","",153,null],[4,"ElementKind","","",null,null],[13,"VecElement","","",154,null],[13,"OtherElement","","",154,null],[4,"MutabilityCategory","","",null,null],[13,"McImmutable","","",155,null],[13,"McDeclared","","",155,null],[13,"McInherited","","",155,null],[4,"Note","","",null,null],[13,"NoteClosureEnv","","",156,null],[13,"NoteUpvarRef","","",156,null],[13,"NoteNone","","",156,null],[3,"cmt_","","",null,null],[12,"id","","",157,null],[12,"span","","",157,null],[12,"cat","","",157,null],[12,"mutbl","","",157,null],[12,"ty","","",157,null],[12,"note","","",157,null],[6,"cmt","","",null,null],[4,"deref_kind","","",null,null],[13,"deref_ptr","","",158,null],[13,"deref_interior","","",158,null],[8,"ast_node","","",null,null],[10,"id","","",432,{"inputs":[{"name":"ast_node"}],"output":{"name":"u32"}}],[10,"span","","",432,{"inputs":[{"name":"ast_node"}],"output":{"name":"span"}}],[3,"MemCategorizationContext","","",null,null],[6,"McResult","","",null,null],[8,"Typer","","The `Typer` trait provides the interface for the mem-categorization\nmodule to the results of the type check. It can be used to query\nthe type assigned to an expression node, to inquire after adjustments,\nand so on.",null,null],[10,"node_ty","","",433,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"result"}}],[10,"expr_ty_adjusted","","",433,{"inputs":[{"name":"typer"},{"name":"expr"}],"output":{"name":"result"}}],[10,"type_moves_by_default","","",433,{"inputs":[{"name":"typer"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[10,"node_method_ty","","",433,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"node_method_origin","","",433,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"adjustments","","",433,{"inputs":[{"name":"typer"}],"output":{"name":"refcell"}}],[10,"is_method_call","","",433,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"bool"}}],[10,"temporary_scope","","",433,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"option"}}],[10,"upvar_capture","","",433,{"inputs":[{"name":"typer"},{"name":"upvarid"}],"output":{"name":"option"}}],[4,"InteriorSafety","","",null,null],[13,"InteriorUnsafe","","",162,null],[13,"InteriorSafe","","",162,null],[4,"Aliasability","","",null,null],[13,"FreelyAliasable","","",163,null],[13,"NonAliasable","","",163,null],[13,"ImmutableUnique","","",163,null],[4,"AliasableReason","","",null,null],[13,"AliasableBorrowed","","",164,null],[13,"AliasableClosure","","",164,null],[13,"AliasableOther","","",164,null],[13,"UnaliasableImmutable","","",164,null],[13,"AliasableStatic","","",164,null],[13,"AliasableStaticMut","","",164,null],[5,"ptr_sigil","","",null,{"inputs":[{"name":"pointerkind"}],"output":{"name":"str"}}],[0,"pat_util","rustc_trans::middle","",null,null],[6,"PatIdMap","rustc_trans::middle::pat_util","",null,null],[5,"pat_id_map","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"hashmap"}}],[5,"pat_is_refutable","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_variant_or_struct","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_const","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding_or_wild","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_bindings","","Call `it` on every \"binding\" in a pattern, e.g., on `a` in\n`match foo() { Some(a) => (), None => () }`",null,null],[5,"pat_contains_bindings","","Checks if the pattern contains any patterns that bind something to\nan ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_contains_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings.",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"arm_contains_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut`\nbindings.",null,{"inputs":[{"name":"refcell"},{"name":"arm"}],"output":{"name":"bool"}}],[5,"pat_contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to\nan ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"simple_identifier","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"option"}}],[5,"def_to_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"path"}}],[0,"privacy","rustc_trans::middle","A pass that checks to make sure private fields and methods aren't used\noutside their scopes. This pass will also generate a set of exported items\nwhich are available for use externally when compiled as a library.",null,null],[6,"ExportedItems","rustc_trans::middle::privacy","",null,null],[6,"ExternalExports","","",null,null],[6,"PublicItems","","",null,null],[4,"LastPrivate","","",null,null],[13,"LastMod","","",166,null],[13,"LastImport","","",166,null],[12,"value_priv","rustc_trans::middle::privacy::LastPrivate","",166,null],[12,"value_used","","",166,null],[12,"type_priv","","",166,null],[12,"type_used","","",166,null],[4,"PrivateDep","rustc_trans::middle::privacy","",null,null],[13,"AllPublic","","",167,null],[13,"DependsOn","","",167,null],[4,"ImportUse","","",null,null],[13,"Unused","","",168,null],[13,"Used","","",168,null],[0,"reachable","rustc_trans::middle","",null,null],[5,"find_reachable","rustc_trans::middle::reachable","",null,{"inputs":[{"name":"ctxt"},{"name":"hashset"}],"output":{"name":"hashset"}}],[0,"region","rustc_trans::middle","This file actually contains two passes related to regions.  The first\npass builds up the `scope_map`, which describes the parent links in\nthe region hierarchy.  The second pass infers which types must be\nregion parameterized.",null,null],[4,"CodeExtent","rustc_trans::middle::region","CodeExtent represents a statically-describable extent that can be\nused to bound the lifetime/region for values.",null,null],[13,"Misc","","",17,null],[13,"ParameterScope","","",17,null],[12,"fn_id","rustc_trans::middle::region::CodeExtent","",17,null],[12,"body_id","","",17,null],[13,"DestructionScope","rustc_trans::middle::region","",17,null],[13,"Remainder","","",17,null],[3,"DestructionScopeData","","extent of destructors for temporaries of node-id",null,null],[12,"node_id","","",18,null],[3,"BlockRemainder","","Represents a subscope of `block` for a binding that is introduced\nby `block.stmts[first_statement_index]`. Such subscopes represent\na suffix of the block. Note that each subscope does not include\nthe initializer expression, if any, for the statement indexed by\n`first_statement_index`.",null,null],[12,"block","","",170,null],[12,"first_statement_index","","",170,null],[3,"RegionMaps","","The region maps encode information about region relationships.",null,null],[3,"Context","","",null,null],[5,"resolve_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"regionmaps"}}],[5,"resolve_inlined_item","","",null,null],[0,"recursion_limit","rustc_trans::middle","",null,null],[5,"update_recursion_limit","rustc_trans::middle::recursion_limit","",null,null],[0,"resolve_lifetime","rustc_trans::middle","Name resolution for lifetimes.",null,null],[4,"DefRegion","rustc_trans::middle::resolve_lifetime","",null,null],[13,"DefStaticRegion","","",177,null],[13,"DefEarlyBoundRegion","","",177,null],[13,"DefLateBoundRegion","","",177,null],[13,"DefFreeRegion","","",177,null],[6,"NamedRegionMap","","",null,null],[5,"krate","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"refcell"}],"output":{"name":"hashmap"}}],[5,"early_bound_lifetimes","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"vec"}}],[0,"stability","rustc_trans::middle","A pass that annotates every item and method with its stability level,\npropagating default levels lexically from parent to children ast nodes.",null,null],[3,"Index","rustc_trans::middle::stability","A stability index, giving the stability level for items and methods.",null,null],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled\nfeatures and possibly prints errors. Returns a list of all\nfeatures used.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"hashmap"}}],[5,"check_item","","Helper for discovering nodes to check for stability",null,null],[5,"check_expr","","Helper for discovering nodes to check for stability",null,null],[5,"check_path","","",null,null],[5,"check_pat","","",null,null],[5,"lookup","","Lookup the stability for a node, loading external crate\nmetadata as necessary.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that\nwere expected to be library features), and the list of features used from\nlibraries, identify activated features that don't exist and error about them.",null,null],[0,"subst","rustc_trans::middle","",null,null],[3,"Substs","rustc_trans::middle::subst","A substitution mapping type/region parameters to new values. We\nidentify each in-scope parameter by an *index* and a *parameter\nspace* (which indices where the parameter is defined; see\n`ParamSpace`).",null,null],[12,"types","","",184,null],[12,"regions","","",184,null],[4,"RegionSubsts","","Represents the values to use when substituting lifetime parameters.\nIf the value is `ErasedRegions`, then this subst is occurring during\ntrans, and all region parameters will be replaced with `ty::ReStatic`.",null,null],[13,"ErasedRegions","","",185,null],[13,"NonerasedRegions","","",185,null],[4,"ParamSpace","","",null,null],[13,"TypeSpace","","",186,null],[13,"SelfSpace","","",186,null],[13,"FnSpace","","",186,null],[3,"VecPerParamSpace","","Vector of things sorted by param space. Used to keep\nthe set of things declared on the type, self, or method\ndistinct.",null,null],[3,"SeparateVecsPerParamSpace","","The `split` function converts one `VecPerParamSpace` into this\n`SeparateVecsPerParamSpace` structure.",null,null],[12,"types","","",434,null],[12,"selfs","","",434,null],[12,"fns","","",434,null],[3,"EnumeratedItems","","",null,null],[8,"Subst","","",null,null],[11,"subst","","",435,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"self"}}],[10,"subst_spanned","","",435,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"},{"name":"option"}],"output":{"name":"self"}}],[0,"traits","rustc_trans::middle","Trait Resolution. See the Book for more.",null,null],[3,"Obligation","rustc_trans::middle::traits","An `Obligation` represents some trait reference (e.g. `int:Eq`) for\nwhich the vtable must be found.  The process of finding a vtable is\ncalled \"resolving\" the `Obligation`. This process consists of\neither identifying an `impl` (e.g., `impl Eq for int`) that\nprovides the required vtable, or else finding a bound that is in\nscope. The eventual result is usually a `Selection` (defined below).",null,null],[12,"cause","","",213,null],[12,"recursion_depth","","",213,null],[12,"predicate","","",213,null],[6,"PredicateObligation","","",null,null],[6,"TraitObligation","","",null,null],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",null,null],[12,"span","","",220,null],[12,"body_id","","",220,null],[12,"code","","",220,null],[4,"ObligationCauseCode","","",null,null],[13,"MiscObligation","","Not well classified or should be obvious from span.",221,null],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must\nalso implement all supertraits of X.",221,null],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",221,null],[13,"AssignmentLhsSized","","Various cases where expressions must be sized/copy/etc:",221,null],[13,"StructInitializerSized","","",221,null],[13,"VariableType","","",221,null],[13,"ReturnType","","",221,null],[13,"RepeatVec","","",221,null],[13,"ClosureCapture","","",221,null],[13,"FieldSized","","",221,null],[13,"ObjectSized","","",221,null],[13,"SharedStatic","","",221,null],[13,"BuiltinDerivedObligation","","",221,null],[13,"ImplDerivedObligation","","",221,null],[13,"CompareImplMethodObligation","","",221,null],[3,"DerivedObligationCause","","",null,null],[6,"Obligations","","",null,null],[6,"PredicateObligations","","",null,null],[6,"TraitObligations","","",null,null],[6,"Selection","","",null,null],[4,"SelectionError","","",null,null],[13,"Unimplemented","","",217,null],[13,"OutputTypeParameterMismatch","","",217,null],[3,"FulfillmentError","","",null,null],[12,"obligation","","",218,null],[12,"code","","",218,null],[4,"FulfillmentErrorCode","","",null,null],[13,"CodeSelectionError","","",219,null],[13,"CodeProjectionError","","",219,null],[13,"CodeAmbiguity","","",219,null],[6,"SelectionResult","","",null,null],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable`\nindicates where the vtable comes from. Note that while we call this\na \"vtable\", it does not necessarily indicate dynamic dispatch at\nruntime. `Vtable` instances just tell the compiler where to find\nmethods, but in generic code those methods are typically statically\ndispatched -- only when an object is constructed is a `Vtable`\ninstance reified into an actual vtable.",null,null],[13,"VtableImpl","","Vtable identifying a particular impl.",214,null],[13,"VtableDefaultImpl","","Vtable for default trait implementations\nThis carries the information and nested obligations with regards\nto a default implementation for a trait `Trait`. The nested obligations\nensure the trait implementation holds for all the constituent types.",214,null],[13,"VtableParam","","Successful resolution to an obligation provided by the caller\nfor some type parameter. The `Vec<N>` represents the\nobligations incurred from normalizing the where-clause (if\nany).",214,null],[13,"VtableObject","","Virtual calls through an object",214,null],[13,"VtableBuiltin","","Successful resolution for a builtin trait.",214,null],[13,"VtableClosure","","Vtable automatically generated for a closure. The def ID is the ID\nof the closure expression. This is a `VtableImpl` in spirit, but the\nimpl is generated by the compiler and does not appear in the source.",214,null],[13,"VtableFnPointer","","Same as above, but for a fn pointer type with the given signature.",214,null],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of\nsubstitutions from the impl's type/lifetime parameters. The\n`nested` vector corresponds to the nested obligations attached to\nthe impl's type parameters.",null,null],[12,"impl_def_id","","",211,null],[12,"substs","","",211,null],[12,"nested","","",211,null],[3,"VtableDefaultImplData","","",null,null],[12,"trait_def_id","","",216,null],[12,"nested","","",216,null],[3,"VtableBuiltinData","","",null,null],[12,"nested","","",215,null],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived\nfor the object type `Foo`.",null,null],[12,"object_ty","","the object type `Foo`.",212,null],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",212,null],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",null,{"inputs":[{"name":"ctxt"},{"name":"obligationcause"},{"name":"instantiatedpredicates"}],"output":{"name":"vecperparamspace"}}],[5,"evaluate_builtin_bound","","Determines whether the type `ty` is known to meet `bound` and\nreturns true if so. Returns false if `ty` either does not meet\n`bound` or is not known to meet bound (note that this is\nconservative towards *no impl*, which is the opposite of the\n`evaluate` methods).",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"tys"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"result"}}],[5,"type_known_to_meet_builtin_bound","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"tys"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"bool"}}],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",null,{"inputs":[{"name":"parameterenvironment"},{"name":"obligationcause"}],"output":{"name":"parameterenvironment"}}],[5,"fully_normalize","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"result"}}],[5,"report_fulfillment_errors","","",null,null],[5,"transitive_bounds","","",null,null],[6,"Supertraits","","",null,null],[3,"SelectionCache","","",null,null],[5,"is_object_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[3,"FulfillmentContext","","The fulfillment context is used to drive trait resolution.  It\nconsists of a list of obligations that must be (eventually)\nsatisfied. The job is to track which are satisfied, which yielded\nerrors, and which are still pending. At any point, users can call\n`select_where_possible`, and the fulfilment context will try to do\nselection, retaining only those obligations that remain\nambiguous. This may be helpful in pushing type inference\nalong. Once all type inference constraints have been generated, the\nmethod `select_all_or_error` can be used to report any remaining\nambiguous cases as errors.",null,null],[5,"normalize","","Normalizes any associated type projections in `value`, replacing\nthem with a fully resolved type where possible. The return value\ncombines the normalized result and any additional obligations that\nwere incurred as result.",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"supertraits","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"filtertotraits"}}],[5,"elaborate_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"elaborator"}}],[5,"suggest_new_overflow_limit","","",null,null],[5,"upcast","","Cast a trait reference into a reference to one of its super\ntraits; returns `None` if `target_trait_def_id` is not a\nsupertrait.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_ref_for_builtin_bound","","",null,{"inputs":[{"name":"ctxt"},{"name":"builtinbound"},{"name":"tys"}],"output":{"name":"result"}}],[5,"supertrait_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"supertraitdefids"}}],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the\ndef-id of a trait impl. To pass, either the trait must be local, or else\ntwo conditions must be satisfied:",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"result"}}],[3,"SelectionContext","","",null,null],[5,"overlapping_impls","","True if there exist types that satisfy both of the two given impls.",null,{"inputs":[{"name":"inferctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We\nhalt compilation unconditionally because it is important that\noverflows never be masked -- they basically represent computations\nwhose result could not be truly determined and thus we can't say\nif the program type checks or not -- and they are unusual\noccurrences in any case.",null,null],[4,"MethodMatchedData","","",null,null],[13,"PreciseMethodMatch","","",201,null],[13,"CoerciveMethodMatch","","",201,null],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",null,null],[13,"StaticMethod","","e.g., `fn foo()`",198,null],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",198,null],[13,"Generic","","e.g., `fn foo<A>()`",198,null],[3,"RegionObligation","","",null,null],[12,"sub_region","","",191,null],[12,"sup_type","","",191,null],[12,"cause","","",191,null],[5,"is_vtable_safe_method","","We say a method is *vtable safe* if it can be invoked on a trait\nobject.  Note that object-safe traits can have some\nnon-vtable-safe methods, so long as they require `Self:Sized` or\notherwise ensure that they cannot be used when `Self=Trait`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"method"}],"output":{"name":"bool"}}],[4,"OrphanCheckErr","","",null,null],[13,"NoLocalInputType","","",436,null],[13,"UncoveredTy","","",436,null],[3,"MismatchedProjectionTypes","","",null,null],[12,"err","","",193,null],[4,"ObjectSafetyViolation","","",null,null],[13,"SizedSelf","","Self : Sized declared on the trait",199,null],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location\n(e.g. `trait Foo : Bar<Self>`)",199,null],[13,"Method","","Method has something illegal",199,null],[5,"object_safety_violations","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[4,"MethodMatchResult","","",null,null],[13,"MethodMatched","","",207,null],[13,"MethodAmbiguous","","",207,null],[13,"MethodDidNotMatch","","",207,null],[3,"SupertraitDefIds","","",null,null],[5,"get_vtable_index_of_object_method","","Given an object of type `object_trait_ref`, returns the index of\nthe method `n_method` found in the trait `trait_def_id` (which\nshould be a supertrait of `object_trait_ref`) within the vtable\nfor `object_trait_ref`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"defid"},{"name":"usize"}],"output":{"name":"usize"}}],[3,"Normalized","","",null,null],[12,"value","","",196,null],[12,"obligations","","",196,null],[0,"ty","rustc_trans::middle","",null,null],[6,"Disr","rustc_trans::middle::ty","",null,null],[17,"INITIAL_DISCRIMINANT_VALUE","","",null,null],[3,"CrateAnalysis","","The complete set of all analyses described in this module. This is\nproduced by the driver and fed to trans and later passes.",null,null],[12,"export_map","","",437,null],[12,"exported_items","","",437,null],[12,"public_items","","",437,null],[12,"ty_cx","","",437,null],[12,"reachable","","",437,null],[12,"name","","",437,null],[12,"glob_map","","",437,null],[3,"field","","",null,null],[12,"name","","",223,null],[12,"mt","","",223,null],[4,"ImplOrTraitItemContainer","","",null,null],[13,"TraitContainer","","",224,null],[13,"ImplContainer","","",224,null],[4,"ImplOrTraitItem","","",null,null],[13,"MethodTraitItem","","",225,null],[13,"TypeTraitItem","","",225,null],[4,"ImplOrTraitItemId","","",null,null],[13,"MethodTraitItemId","","",226,null],[13,"TypeTraitItemId","","",226,null],[3,"Method","","",null,null],[12,"name","","",227,null],[12,"generics","","",227,null],[12,"predicates","","",227,null],[12,"fty","","",227,null],[12,"explicit_self","","",227,null],[12,"vis","","",227,null],[12,"def_id","","",227,null],[12,"container","","",227,null],[12,"provided_source","","",227,null],[3,"AssociatedType","","",null,null],[12,"name","","",228,null],[12,"vis","","",228,null],[12,"def_id","","",228,null],[12,"container","","",228,null],[3,"mt","","",null,null],[12,"ty","","",229,null],[12,"mutbl","","",229,null],[3,"field_ty","","",null,null],[12,"name","","",230,null],[12,"id","","",230,null],[12,"vis","","",230,null],[12,"origin","","",230,null],[3,"creader_cache_key","","",null,null],[12,"cnum","","",231,null],[12,"pos","","",231,null],[12,"len","","",231,null],[3,"ItemVariances","","",null,null],[12,"types","","",232,null],[12,"regions","","",232,null],[4,"Variance","","",null,null],[13,"Covariant","","",233,null],[13,"Invariant","","",233,null],[13,"Contravariant","","",233,null],[13,"Bivariant","","",233,null],[4,"AutoAdjustment","","",null,null],[13,"AdjustReifyFnPointer","","",234,null],[13,"AdjustUnsafeFnPointer","","",234,null],[13,"AdjustDerefRef","","",234,null],[3,"AutoDerefRef","","Represents coercing a pointer to a different kind of pointer - where 'kind'\nhere means either or both of raw vs borrowed vs unique and fat vs thin.",null,null],[12,"autoderefs","","Step 1. Apply a number of dereferences, producing an lvalue.",235,null],[12,"autoref","","Step 2. Optionally produce a pointer/reference from the value.",235,null],[12,"unsize","","Step 3. Unsize a pointer/reference value, e.g. `&[T; n]` to\n`&[T]`. The stored type is the target pointer type. Note that\nthe source could be a thin or fat pointer.",235,null],[4,"AutoRef","","",null,null],[13,"AutoPtr","","Convert from T to &T.",236,null],[13,"AutoUnsafe","","Convert from T to *T.\nValue to thin pointer.",236,null],[3,"param_index","","",null,null],[12,"space","","",237,null],[12,"index","","",237,null],[4,"MethodOrigin","","",null,null],[13,"MethodStatic","","",24,null],[13,"MethodStaticClosure","","",24,null],[13,"MethodTypeParam","","",24,null],[13,"MethodTraitObject","","",24,null],[3,"MethodParam","","",null,null],[12,"trait_ref","","",238,null],[12,"method_num","","",238,null],[12,"impl_def_id","","The impl for the trait from which the method comes. This\nshould only be used for certain linting/heuristic purposes\nsince there is no guarantee that this is Some in every\nsituation that it could/should be.",238,null],[3,"MethodObject","","",null,null],[12,"trait_ref","","",239,null],[12,"object_trait_id","","",239,null],[12,"method_num","","",239,null],[12,"vtable_index","","",239,null],[3,"MethodCallee","","",null,null],[12,"origin","","",240,null],[12,"ty","","",240,null],[12,"substs","","",240,null],[3,"MethodCall","","With method calls, we store some extra information in\nside tables (i.e method_map). We use\nMethodCall as a key to index into these tables instead of\njust directly using the expression's NodeId. The reason\nfor this being that we may apply adjustments (coercions)\nwith the resulting expression also needing to use the\nside tables. The problem with this is that we don't\nassign a separate NodeId to this new expression\nand so it would clash with the base expression if both\nneeded to add to the side tables. Thus to disambiguate\nwe also keep track of whether there's an adjustment in\nour key.",null,null],[12,"expr_id","","",241,null],[12,"autoderef","","",241,null],[6,"MethodMap","","",null,null],[6,"vtable_param_res","","",null,null],[6,"vtable_res","","",null,null],[4,"vtable_origin","","",null,null],[13,"vtable_static","","",242,null],[13,"vtable_param","","",242,null],[13,"vtable_closure","","",242,null],[13,"vtable_error","","",242,null],[6,"ObjectCastMap","","",null,null],[3,"TransmuteRestriction","","A restriction that certain types must be the same size. The use of\n`transmute` gives rise to these restrictions. These generally\ncannot be checked until trans; therefore, each call to `transmute`\nwill push one or more such restriction into the\n`transmute_restrictions` vector during `intrinsicck`. They are\nthen checked during `trans` by the fn `check_intrinsics`.",null,null],[12,"span","","The span whence the restriction comes.",87,null],[12,"original_from","","The type being transmuted from.",87,null],[12,"original_to","","The type being transmuted to.",87,null],[12,"substituted_from","","The type being transmuted from, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",87,null],[12,"substituted_to","","The type being transmuted to, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",87,null],[12,"id","","NodeId of the transmute intrinsic.",87,null],[3,"CtxtArenas","","Internal storage",null,null],[3,"CommonTypes","","",null,null],[12,"bool","","",438,null],[12,"char","","",438,null],[12,"isize","","",438,null],[12,"i8","","",438,null],[12,"i16","","",438,null],[12,"i32","","",438,null],[12,"i64","","",438,null],[12,"usize","","",438,null],[12,"u8","","",438,null],[12,"u16","","",438,null],[12,"u32","","",438,null],[12,"u64","","",438,null],[12,"f32","","",438,null],[12,"f64","","",438,null],[12,"err","","",438,null],[3,"ctxt","","The data structure to keep track of all the information that typechecker\ngenerates so that so that it can be reused and doesn't have to be redone\nlater on.",null,null],[12,"types","","Common types, pre-interned for your convenience.",244,null],[12,"sess","","",244,null],[12,"def_map","","",244,null],[12,"named_region_map","","",244,null],[12,"region_maps","","",244,null],[12,"item_substs","","Stores the type parameters which were substituted to obtain the type\nof this node.  This only applies to nodes that refer to entities\nparameterized by type parameters, such as generic fns, types, or\nother items.",244,null],[12,"impl_or_trait_items","","Maps from a trait item to the trait item \"descriptor\"",244,null],[12,"trait_item_def_ids","","Maps from a trait def-id to a list of the def-ids of its trait items",244,null],[12,"trait_items_cache","","A cache for the trait_items() routine",244,null],[12,"impl_trait_cache","","",244,null],[12,"impl_trait_refs","","",244,null],[12,"trait_defs","","",244,null],[12,"predicates","","Maps from the def-id of an item (trait/struct/enum/fn) to its\nassociated predicates.",244,null],[12,"super_predicates","","Maps from the def-id of a trait to the list of\nsuper-predicates. This is a subset of the full list of\npredicates. We store these in a separate map because we must\nevaluate them even during type conversion, often before the\nfull predicates are available (note that supertraits have\nadditional acyclicity requirements).",244,null],[12,"object_cast_map","","Maps from node-id of a trait object cast (like `foo as\nBox<Trait>`) to the trait reference.",244,null],[12,"map","","",244,null],[12,"freevars","","",244,null],[12,"tcache","","",244,null],[12,"rcache","","",244,null],[12,"short_names_cache","","",244,null],[12,"tc_cache","","",244,null],[12,"ast_ty_to_ty_cache","","",244,null],[12,"enum_var_cache","","",244,null],[12,"ty_param_defs","","",244,null],[12,"adjustments","","",244,null],[12,"normalized_cache","","",244,null],[12,"lang_items","","",244,null],[12,"provided_method_sources","","A mapping of fake provided method def_ids to the default implementation",244,null],[12,"struct_fields","","",244,null],[12,"item_variance_map","","Maps from def-id of a type or region parameter to its\n(inferred) variance.",244,null],[12,"variance_computed","","True if the variance has been computed yet; false otherwise.",244,null],[12,"destructor_for_type","","A mapping from the def ID of an enum or struct type to the def ID\nof the method that implements its destructor. If the type is not\npresent in this map, it does not have a destructor. This map is\npopulated during the coherence phase of typechecking.",244,null],[12,"destructors","","A method will be in this list if and only if it is a destructor.",244,null],[12,"trait_impls","","Maps a trait onto a list of impls of that trait.",244,null],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls.\nContains implementations of methods that are inherent to a type.\nMethods in these implementations don't need to be exported.",244,null],[12,"impl_items","","Maps a DefId of an impl to a list of its items.\nNote that this contains all of the impls that we know about,\nincluding ones in other crates. It's not clear that this is the best\nway to do it.",244,null],[12,"used_unsafe","","Set of used unsafe nodes (functions or blocks). Unsafe nodes not\npresent in this set can be warned about.",244,null],[12,"used_mut_nodes","","Set of nodes which mark locals as mutable which end up getting used at\nsome point. Local variable definitions not in this set can be warned\nabout.",244,null],[12,"populated_external_types","","The set of external nominal types whose implementations have been read.\nThis is used for lazy resolution of methods.",244,null],[12,"populated_external_traits","","The set of external traits whose implementations have been read. This\nis used for lazy resolution of traits.",244,null],[12,"populated_external_primitive_impls","","The set of external primitive inherent implementations that have been read.",244,null],[12,"upvar_capture_map","","Borrows",244,null],[12,"extern_const_statics","","These two caches are used by const_eval when decoding external statics\nand variants that are found.",244,null],[12,"extern_const_variants","","",244,null],[12,"method_map","","",244,null],[12,"dependency_formats","","",244,null],[12,"closure_kinds","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",244,null],[12,"closure_tys","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",244,null],[12,"node_lint_levels","","",244,null],[12,"transmute_restrictions","","The types that must be asserted to be the same size for `transmute`\nto be valid. We gather up these restrictions in the intrinsicck pass\nand check them in trans.",244,null],[12,"stability","","Maps any item's def-id to its stability index.",244,null],[12,"associated_types","","Maps def IDs to true if and only if they're associated types.",244,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that do not have to do with the parameters in scope.",244,null],[12,"repr_hint_cache","","Caches the representation hints for struct definitions.",244,null],[12,"type_impls_copy_cache","","Caches whether types are known to impl Copy. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",244,null],[12,"type_impls_sized_cache","","Caches whether types are known to impl Sized. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",244,null],[12,"object_safety_cache","","Caches whether traits are object safe",244,null],[12,"const_qualif_map","","Maps Expr NodeId's to their constant qualification.",244,null],[3,"TypeFlags","","",null,null],[17,"NO_TYPE_FLAGS","","",null,null],[17,"HAS_PARAMS","","",null,null],[17,"HAS_SELF","","",null,null],[17,"HAS_TY_INFER","","",null,null],[17,"HAS_RE_INFER","","",null,null],[17,"HAS_RE_LATE_BOUND","","",null,null],[17,"HAS_REGIONS","","",null,null],[17,"HAS_TY_ERR","","",null,null],[17,"HAS_PROJECTION","","",null,null],[17,"NEEDS_SUBST","","",null,null],[3,"TyS","","",null,null],[12,"sty","","",246,null],[12,"flags","","",246,null],[6,"Ty","","",null,null],[3,"InternedTy","","An entry in the type interner.",null,null],[5,"type_has_params","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_self","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_ty_infer","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_needs_infer","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_projection","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_late_bound_regions","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_escaping_regions","","An \"escaping region\" is a bound region whose binder is not part of `t`.",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_escapes_depth","","",null,{"inputs":[{"name":"tys"},{"name":"u32"}],"output":{"name":"bool"}}],[3,"BareFnTy","","",null,null],[12,"unsafety","","",248,null],[12,"abi","","",248,null],[12,"sig","","",248,null],[3,"ClosureTy","","",null,null],[12,"unsafety","","",249,null],[12,"abi","","",249,null],[12,"sig","","",249,null],[4,"FnOutput","","",null,null],[13,"FnConverging","","",250,null],[13,"FnDiverging","","",250,null],[6,"PolyFnOutput","","",null,null],[3,"FnSig","","Signature of a function type, which I have arbitrarily\ndecided to use to refer to the input/output types.",null,null],[12,"inputs","","",251,null],[12,"output","","",251,null],[12,"variadic","","",251,null],[6,"PolyFnSig","","",null,null],[3,"ParamTy","","",null,null],[12,"space","","",252,null],[12,"idx","","",252,null],[12,"name","","",252,null],[3,"DebruijnIndex","","A [De Bruijn index][dbi] is a standard means of representing\nregions (and perhaps later types) in a higher-ranked setting. In\nparticular, imagine a type like this:",null,null],[12,"depth","","",253,null],[4,"Region","","Representation of regions:",null,null],[13,"ReEarlyBound","","",15,null],[13,"ReLateBound","","",15,null],[13,"ReFree","","When checking a function body, the types of all arguments and so forth\nthat refer to bound region parameters are modified to refer to free\nregion parameters.",15,null],[13,"ReScope","","A concrete region naming some statically determined extent\n(e.g. an expression or sequence of statements) within the\ncurrent function.",15,null],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",15,null],[13,"ReInfer","","A region variable.  Should not exist after typeck.",15,null],[13,"ReEmpty","","Empty lifetime is for data that is never accessed.\nBottom in the region lattice. We treat ReEmpty somewhat\nspecially; at least right now, we do not generate instances of\nit during the GLB computations, but rather\ngenerate an error instead. This is to improve error messages.\nThe only way to get an instance of ReEmpty is to have a region\nvariable with no constraints.",15,null],[3,"EarlyBoundRegion","","",null,null],[12,"param_id","","",254,null],[12,"space","","",254,null],[12,"index","","",254,null],[12,"name","","",254,null],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of\nthe original var id (that is, the root variable that is referenced\nby the upvar) and the id of the closure expression.",null,null],[12,"var_id","","",255,null],[12,"closure_expr_id","","",255,null],[4,"BorrowKind","","",null,null],[13,"ImmBorrow","","Data must be immutable and is aliasable.",256,null],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow\ncannot currently be expressed by the user and is used only in\nimplicit closure bindings. It is needed when you the closure\nis borrowing or mutating a mutable referent, e.g.:",256,null],[13,"MutBorrow","","Data is mutable and not aliasable.",256,null],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed\nduring `typeck`, specifically by `regionck`.",null,null],[13,"ByValue","","Upvar is captured by value. This is always true when the\nclosure is labeled `move`, but can also be true in other cases\ndepending on inference.",23,null],[13,"ByRef","","Upvar is captured by reference.",23,null],[3,"UpvarBorrow","","",null,null],[12,"kind","","The kind of borrow: by-ref upvars have access to shared\nimmutable borrows, which are not part of the normal language\nsyntax.",22,null],[12,"region","","Region of the resulting reference.",22,null],[6,"UpvarCaptureMap","","",null,null],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region\nat least as big as the scope `fr.scope`\".",null,null],[12,"scope","","",16,null],[12,"bound_region","","",16,null],[4,"BoundRegion","","",null,null],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",19,null],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",19,null],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",19,null],[13,"BrEnv","","",19,null],[4,"sty","","",null,null],[13,"ty_bool","","",257,null],[13,"ty_char","","",257,null],[13,"ty_int","","",257,null],[13,"ty_uint","","",257,null],[13,"ty_float","","",257,null],[13,"ty_enum","","Substs here, possibly against intuition, *may* contain `ty_param`s.\nThat is, even after substitution it is possible that there are type\nvariables. This happens when the `ty_enum` corresponds to an enum\ndefinition and not a concrete use of it. To get the correct `ty_enum`\nfrom the tcx, use the `NodeId` from the `ast::Ty` and look it up in\nthe `ast_ty_to_ty_cache`. This is probably true for `ty_struct` as\nwell.",257,null],[13,"ty_uniq","","",257,null],[13,"ty_str","","",257,null],[13,"ty_vec","","",257,null],[13,"ty_ptr","","",257,null],[13,"ty_rptr","","",257,null],[13,"ty_bare_fn","","",257,null],[13,"ty_trait","","",257,null],[13,"ty_struct","","",257,null],[13,"ty_closure","","",257,null],[13,"ty_tup","","",257,null],[13,"ty_projection","","",257,null],[13,"ty_param","","",257,null],[13,"ty_infer","","",257,null],[13,"ty_err","","",257,null],[3,"TyTrait","","",null,null],[12,"principal","","",258,null],[12,"bounds","","",258,null],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax,\nbut perhaps the most recognizable form is in a where clause:",null,null],[12,"def_id","","",259,null],[12,"substs","","",259,null],[6,"PolyTraitRef","","",null,null],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the\ncompiler's representation for things like `for<'a> Fn(&'a isize)`\n(which would be represented by the type `PolyTraitRef ==\nBinder<TraitRef>`). Note that when we skolemize, instantiate,\nerase, or otherwise \"discharge\" these bound regions, we change the\ntype from `Binder<T>` to just `T` (see\ne.g. `liberate_late_bound_regions`).",null,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",125,null],[13,"UintType","","",125,null],[4,"terr_vstore_kind","","",null,null],[13,"terr_vec","","",260,null],[13,"terr_str","","",260,null],[13,"terr_fn","","",260,null],[13,"terr_trait","","",260,null],[3,"expected_found","","",null,null],[12,"expected","","",261,null],[12,"found","","",261,null],[4,"type_err","","",null,null],[13,"terr_mismatch","","",262,null],[13,"terr_unsafety_mismatch","","",262,null],[13,"terr_abi_mismatch","","",262,null],[13,"terr_mutability","","",262,null],[13,"terr_box_mutability","","",262,null],[13,"terr_ptr_mutability","","",262,null],[13,"terr_ref_mutability","","",262,null],[13,"terr_vec_mutability","","",262,null],[13,"terr_tuple_size","","",262,null],[13,"terr_fixed_array_size","","",262,null],[13,"terr_ty_param_size","","",262,null],[13,"terr_arg_count","","",262,null],[13,"terr_regions_does_not_outlive","","",262,null],[13,"terr_regions_not_same","","",262,null],[13,"terr_regions_no_overlap","","",262,null],[13,"terr_regions_insufficiently_polymorphic","","",262,null],[13,"terr_regions_overly_polymorphic","","",262,null],[13,"terr_sorts","","",262,null],[13,"terr_integer_as_char","","",262,null],[13,"terr_int_mismatch","","",262,null],[13,"terr_float_mismatch","","",262,null],[13,"terr_traits","","",262,null],[13,"terr_builtin_bounds","","",262,null],[13,"terr_variadic_mismatch","","",262,null],[13,"terr_cyclic_ty","","",262,null],[13,"terr_convergence_mismatch","","",262,null],[13,"terr_projection_name_mismatched","","",262,null],[13,"terr_projection_bounds_length","","",262,null],[3,"ParamBounds","","Bounds suitable for a named type parameter like `A` in `fn foo<A>`\nas well as the existential type parameter in an object type.",null,null],[12,"region_bounds","","",263,null],[12,"builtin_bounds","","",263,null],[12,"trait_bounds","","",263,null],[12,"projection_bounds","","",263,null],[3,"ExistentialBounds","","Bounds suitable for an existentially quantified type parameter\nsuch as those that appear in object types or closure types. The\nmajor difference between this case and `ParamBounds` is that\ngeneral purpose trait bounds are omitted and there must be\n*exactly one* region.",null,null],[12,"region_bound","","",264,null],[12,"builtin_bounds","","",264,null],[12,"projection_bounds","","",264,null],[6,"BuiltinBounds","","",null,null],[4,"BuiltinBound","","",null,null],[13,"BoundSend","","",265,null],[13,"BoundSized","","",265,null],[13,"BoundCopy","","",265,null],[13,"BoundSync","","",265,null],[5,"empty_builtin_bounds","","",null,{"inputs":[],"output":{"name":"enumset"}}],[5,"all_builtin_bounds","","",null,{"inputs":[],"output":{"name":"enumset"}}],[5,"region_existential_bound","","An existential bound that does not implement any traits.",null,{"inputs":[{"name":"region"}],"output":{"name":"existentialbounds"}}],[3,"TyVid","","",null,null],[12,"index","","",266,null],[3,"IntVid","","",null,null],[12,"index","","",124,null],[3,"FloatVid","","",null,null],[12,"index","","",126,null],[3,"RegionVid","","",null,null],[12,"index","","",267,null],[4,"InferTy","","",null,null],[13,"TyVar","","",268,null],[13,"IntVar","","",268,null],[13,"FloatVar","","",268,null],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an\nunbound type variable. This is convenient for caching etc. See\n`middle::infer::freshen` for more details.",268,null],[13,"FreshIntTy","","",268,null],[4,"UnconstrainedNumeric","","",null,null],[13,"UnconstrainedFloat","","",269,null],[13,"UnconstrainedInt","","",269,null],[13,"Neither","","",269,null],[4,"InferRegion","","",null,null],[13,"ReVar","","",270,null],[13,"ReSkolemized","","",270,null],[4,"ObjectLifetimeDefault","","Default region to use for the bound of objects that are\nsupplied as the value for this type parameter. This is derived\nfrom `T:'a` annotations appearing in the type definition.  If\nthis is `None`, then the default is inherited from the\nsurrounding context. See RFC #599 for details.",null,null],[13,"Ambiguous","","Require an explicit annotation. Occurs when multiple\n`T:'a` constraints are found.",271,null],[13,"Specific","","Use the given region as the default.",271,null],[3,"TypeParameterDef","","",null,null],[12,"name","","",272,null],[12,"def_id","","",272,null],[12,"space","","",272,null],[12,"index","","",272,null],[12,"default","","",272,null],[12,"object_lifetime_default","","",272,null],[3,"RegionParameterDef","","",null,null],[12,"name","","",273,null],[12,"def_id","","",273,null],[12,"space","","",273,null],[12,"index","","",273,null],[12,"bounds","","",273,null],[3,"Generics","","Information about the formal type/lifetime parameters associated\nwith an item or method. Analogous to ast::Generics.",null,null],[12,"types","","",274,null],[12,"regions","","",274,null],[3,"GenericPredicates","","Bounds on generics.",null,null],[12,"predicates","","",275,null],[4,"Predicate","","",null,null],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be\nthe `Self` type of the trait reference and `A`, `B`, and `C`\nwould be the parameters in the `TypeSpace`.",276,null],[13,"Equate","","where `T1 == T2`.",276,null],[13,"RegionOutlives","","where 'a : 'b",276,null],[13,"TypeOutlives","","where T : 'a",276,null],[13,"Projection","","where <T as TraitRef>::Name == X, approximately.\nSee `ProjectionPredicate` struct for details.",276,null],[3,"TraitPredicate","","",null,null],[12,"trait_ref","","",277,null],[6,"PolyTraitPredicate","","",null,null],[3,"EquatePredicate","","",null,null],[6,"PolyEquatePredicate","","",null,null],[3,"OutlivesPredicate","","",null,null],[6,"PolyOutlivesPredicate","","",null,null],[6,"PolyRegionOutlivesPredicate","","",null,null],[6,"PolyTypeOutlivesPredicate","","",null,null],[3,"ProjectionPredicate","","This kind of predicate has no *direct* correspondent in the\nsyntax, but it roughly corresponds to the syntactic forms:",null,null],[12,"projection_ty","","",280,null],[12,"ty","","",280,null],[6,"PolyProjectionPredicate","","",null,null],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS\nform this would be written `<T as Trait<..>>::N`.",null,null],[12,"trait_ref","","The trait reference `T as Trait<..>`.",281,null],[12,"item_name","","The name `N` of the associated type.",281,null],[8,"ToPolyTraitRef","","",null,null],[10,"to_poly_trait_ref","","",439,{"inputs":[{"name":"topolytraitref"}],"output":{"name":"binder"}}],[8,"AsPredicate","","",null,null],[10,"as_predicate","","",440,{"inputs":[{"name":"aspredicate"}],"output":{"name":"predicate"}}],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type\nparameters.  Should eventually be generalized into a flag list of\nwhere clauses.  You can obtain a `InstantiatedPredicates` list from a\n`GenericPredicates` by using the `instantiate` method. Note that this method\nreflects an important semantic invariant of `InstantiatedPredicates`: while\nthe `GenericPredicates` are expressed in terms of the bound type\nparameters of the impl/trait/whatever, an `InstantiatedPredicates` instance\nrepresented a set of bounds for some particular instantiation,\nmeaning that the generic parameters have been substituted with\ntheir values.",null,null],[12,"predicates","","",282,null],[3,"ParameterEnvironment","","When type checking, we use the `ParameterEnvironment` to track\ndetails about the type/lifetime parameters that are in scope.\nIt primarily stores the bounds information.",null,null],[12,"tcx","","",283,null],[12,"free_substs","","See `construct_free_substs` for details.",283,null],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that\nindicates it must outlive at least the function body (the user\nmay specify stronger requirements). This field indicates the\nregion of the callee.",283,null],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically\nthe set of bounds on the in-scope type parameters, translated\ninto Obligations.",283,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that have to do with the parameters in scope.",283,null],[3,"TypeScheme","","A \"type scheme\", in ML terminology, is a type combined with some\nset of generic types that the type is, well, generic over. In Rust\nterms, it is the \"type\" of a fn item or struct -- this type will\ninclude various generic parameters that must be substituted when\nthe item/struct is referenced. That is called converting the type\nscheme to a monotype.",null,null],[12,"generics","","",284,null],[12,"ty","","",284,null],[3,"TraitDef","","As `TypeScheme` but for a trait ref.",null,null],[12,"unsafety","","",364,null],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]`\nattribute, indicating that it should be used with `Foo()`\nsugar. This is a temporary thing -- eventually any trait wil\nbe usable with the sugar (or without it).",364,null],[12,"generics","","Generic type definitions. Note that `Self` is listed in here\nas having a single bound, the trait itself (e.g., in the trait\n`Eq`, there is a single bound `Self : Eq`). This is so that\ndefault methods get to assume that the `Self` parameters\nimplements the trait.",364,null],[12,"trait_ref","","",364,null],[12,"associated_type_names","","A list of the associated types defined in this trait. Useful\nfor resolving `X::Foo` type markers.",364,null],[3,"ItemSubsts","","Records the substitutions used to translate the polytype for an\nitem into the monotype of an item reference.",null,null],[12,"substs","","",285,null],[4,"ClosureKind","","",null,null],[13,"FnClosureKind","","",165,null],[13,"FnMutClosureKind","","",165,null],[13,"FnOnceClosureKind","","",165,null],[8,"ClosureTyper","","",null,null],[11,"tcx","","",441,{"inputs":[{"name":"closuretyper"}],"output":{"name":"ctxt"}}],[10,"param_env","","",441,{"inputs":[{"name":"closuretyper"}],"output":{"name":"parameterenvironment"}}],[10,"closure_kind","","Is this a `Fn`, `FnMut` or `FnOnce` closure? During typeck,\nreturns `None` if the kind of this closure has not yet been\ninferred.",441,{"inputs":[{"name":"closuretyper"},{"name":"defid"}],"output":{"name":"option"}}],[10,"closure_type","","Returns the argument/return types of this closure.",441,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[10,"closure_upvars","","Returns the set of all upvars and their transformed\ntypes. During typeck, maybe return `None` if the upvar types\nhave not yet been inferred.",441,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"mk_ctxt","","",null,{"inputs":[{"name":"session"},{"name":"ctxtarenas"},{"name":"refcell"},{"name":"hashmap"},{"name":"map"},{"name":"refcell"},{"name":"regionmaps"},{"name":"languageitems"},{"name":"index"}],"output":{"name":"ctxt"}}],[5,"mk_t","","",null,{"inputs":[{"name":"ctxt"},{"name":"sty"}],"output":{"name":"tys"}}],[5,"mk_mach_int","","",null,{"inputs":[{"name":"ctxt"},{"name":"intty"}],"output":{"name":"tys"}}],[5,"mk_mach_uint","","",null,{"inputs":[{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"tys"}}],[5,"mk_mach_float","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatty"}],"output":{"name":"tys"}}],[5,"mk_str","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_str_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mutability"}],"output":{"name":"tys"}}],[5,"mk_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_uniq","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_mut_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_imm_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_mut_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_imm_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_nil_ptr","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_vec","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"option"}],"output":{"name":"tys"}}],[5,"mk_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_tup","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"tys"}}],[5,"mk_nil","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_bool","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_bare_fn","","",null,{"inputs":[{"name":"ctxt"},{"name":"option"},{"name":"barefnty"}],"output":{"name":"tys"}}],[5,"mk_ctor_fn","","",null,null],[5,"mk_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"existentialbounds"}],"output":{"name":"tys"}}],[5,"sort_bounds_list","","",null,null],[5,"mk_projection","","",null,{"inputs":[{"name":"ctxt"},{"name":"rc"},{"name":"name"}],"output":{"name":"tys"}}],[5,"mk_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_closure","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"tyvid"}],"output":{"name":"tys"}}],[5,"mk_int_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"intvid"}],"output":{"name":"tys"}}],[5,"mk_float_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatvid"}],"output":{"name":"tys"}}],[5,"mk_infer","","",null,{"inputs":[{"name":"ctxt"},{"name":"inferty"}],"output":{"name":"tys"}}],[5,"mk_param","","",null,{"inputs":[{"name":"ctxt"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"tys"}}],[5,"mk_self_type","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_param_from_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[5,"walk_ty","","",null,null],[5,"maybe_walk_ty","","Walks `ty` and any types appearing within `ty`, invoking the\ncallback `f` on each type. If the callback returns false, then the\nchildren of the current type are ignored.",null,null],[5,"fold_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"f"}],"output":{"name":"tys"}}],[5,"type_is_nil","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_error","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_needs_subst","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"trait_ref_contains_error","","",null,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[5,"type_is_ty_var","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bool","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_self","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_vec","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_structural","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_simd","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"sequence_element_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"simd_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"simd_size","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"usize"}}],[5,"type_is_region_ptr","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_unsafe_ptr","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_unique","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_scalar","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_floating_point","","Returns true if this type is a floating point type and false otherwise.",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[3,"TypeContents","","Type contents is how the type checker reasons about kinds.\nThey track what kinds of things are found within a type.  You can\nthink of them as kind of an \"anti-kind\".  They track the kinds of values\nand thinks that are contained in types.  Having a larger contents for\na type tends to rule that type *out* from various kinds.  For example,\na type that contains a reference is not sendable.",null,null],[12,"bits","","",286,null],[5,"type_interior_is_unsafe","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_contents","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"typecontents"}}],[5,"type_moves_by_default","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_sized","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"is_ffi_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"is_instantiable","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[4,"Representability","","Describes whether a type is representable. For types that are not\nrepresentable, 'SelfRecursive' and 'ContainsRecursive' are used to\ndistinguish between types that are recursive with themselves and types that\ncontain a different recursive type. These cases can therefore be treated\ndifferently when reporting errors.",null,null],[13,"Representable","","",287,null],[13,"ContainsRecursive","","",287,null],[13,"SelfRecursive","","",287,null],[5,"is_type_representable","","Check whether a type is representable. This means it cannot contain unboxed\nstructural recursion. This check is needed for structs and enums.",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"tys"}],"output":{"name":"representability"}}],[5,"type_is_trait","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_trait_info","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[5,"type_is_integral","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_fresh","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_uint","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_char","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn_item","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_fp","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_numeric","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_signed","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_machine","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_c_like_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"deref","","",null,{"inputs":[{"name":"tys"},{"name":"bool"}],"output":{"name":"option"}}],[5,"type_content","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"tys"}}],[5,"index","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[5,"array_element_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"option"}}],[5,"positional_element_ty","","Returns the type of element at index `i` in tuple or tuple-like type `t`.\nFor an enum `t`, `variant` is None only if `t` is a univariant enum.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"usize"},{"name":"option"}],"output":{"name":"option"}}],[5,"named_element_ty","","Returns the type of element at field `n` in struct or struct-like type `t`.\nFor an enum `t`, `variant` must be some def id.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"name"},{"name":"option"}],"output":{"name":"option"}}],[5,"impl_id_to_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"rc"}}],[5,"node_id_to_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"tys"}}],[5,"node_id_to_type_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"option"}}],[5,"node_id_item_substs","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"itemsubsts"}}],[5,"fn_is_variadic","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"ty_fn_sig","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"ty_fn_abi","","Returns the ABI of the given function.",null,{"inputs":[{"name":"tys"}],"output":{"name":"abi"}}],[5,"ty_fn_args","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"ty_fn_ret","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"is_fn_ty","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"ty_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"tys"}],"output":{"name":"region"}}],[5,"free_region_from_def","","",null,{"inputs":[{"name":"destructionscopedata"},{"name":"regionparameterdef"}],"output":{"name":"region"}}],[5,"pat_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"tys"}}],[5,"pat_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"option"}}],[5,"expr_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"tys"}}],[5,"expr_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"option"}}],[5,"expr_ty_adjusted","","Returns the type of `expr`, considering any `AutoAdjustment`\nentry recorded for that expression.",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"tys"}}],[5,"expr_span","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"span"}}],[5,"local_var_name_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"internedstring"}}],[5,"adjust_ty","","See `expr_ty_adjusted`",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"u32"},{"name":"tys"},{"name":"option"},{"name":"f"}],"output":{"name":"tys"}}],[5,"adjust_ty_for_autoref","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"option"}],"output":{"name":"tys"}}],[5,"resolve_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"def"}}],[5,"expr_is_lval","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"bool"}}],[4,"ExprKind","","We categorize expressions into three kinds.  The distinction between\nlvalue/rvalue is fundamental to the language.  The distinction between the\ntwo kinds of rvalues is an artifact of trans which reflects how we will\ngenerate code for that kind of expression.  See trans/expr.rs for more\ninformation.",null,null],[13,"LvalueExpr","","",288,null],[13,"RvalueDpsExpr","","",288,null],[13,"RvalueDatumExpr","","",288,null],[13,"RvalueStmtExpr","","",288,null],[5,"expr_kind","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"exprkind"}}],[5,"stmt_node_id","","",null,{"inputs":[{"name":"spanned"}],"output":{"name":"u32"}}],[5,"field_idx_strict","","",null,null],[5,"impl_or_trait_item_idx","","",null,null],[5,"ty_sort_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"type_err_to_str","","Explains the source of a type err in a short, human readable way. This is meant to be placed\nin parentheses after some larger message. You should also invoke `note_and_explain_type_err()`\nafterwards to present additional details, particularly when it comes to lifetime-related\nerrors.",null,{"inputs":[{"name":"ctxt"},{"name":"type_err"}],"output":{"name":"string"}}],[5,"note_and_explain_type_err","","",null,null],[5,"provided_source","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"usize"}],"output":{"name":"implortraititem"}}],[5,"trait_items","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"is_associated_type","","Returns true if the given ID refers to an associated type and false if it\nrefers to anything else.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"associated_type_parameter_index","","Returns the parameter index that the given associated type corresponds to.",null,{"inputs":[{"name":"ctxt"},{"name":"traitdef"},{"name":"defid"}],"output":{"name":"usize"}}],[5,"trait_item_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"impl_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_ref_to_def_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"}],"output":{"name":"defid"}}],[5,"try_add_builtin_trait","","Checks whether `trait_ref` refers to one of the builtin\ntraits, like `Send`, and adds the corresponding\nbound to the set `builtin_bounds` if so. Returns true if `trait_ref`\nis a builtin trait.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"enumset"}],"output":{"name":"bool"}}],[5,"ty_to_def_id","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[3,"VariantInfo","","",null,null],[12,"args","","",289,null],[12,"arg_names","","",289,null],[12,"ctor_ty","","",289,null],[12,"name","","",289,null],[12,"id","","",289,null],[12,"disr_val","","",289,null],[12,"vis","","",289,null],[5,"substd_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"item_path_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"string"}}],[4,"DtorKind","","",null,null],[13,"NoDtor","","",290,null],[13,"TraitDtor","","",290,null],[5,"ty_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"dtorkind"}}],[5,"has_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"with_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"f"}],"output":{"name":"t"}}],[5,"enum_is_univariant","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"type_is_empty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"enum_repr_type","","Returns `(normalized_type, ty)`, where `normalized_type` is the\nIntType representation of one of {i64,i32,i16,i8,u64,u32,u16,u8},\nand `ty` is the original type (i.e. may include `isize` or\n`usize`).",null,null],[5,"enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"enum_variant_with_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_item_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"lookup_trait_def","","Given the did of a trait, returns its canonical trait ref.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_predicates","","Given the did of an item, returns its full set of predicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"lookup_super_predicates","","Given the did of a trait, returns its superpredicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"parambounds"}],"output":{"name":"vec"}}],[5,"get_attrs","","Get the attributes of a definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"cow"}}],[5,"has_attr","","Determine whether an item is annotated with an attribute",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"str"}],"output":{"name":"bool"}}],[5,"lookup_packed","","Determine whether an item is annotated with `#[repr(packed)]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_simd","","Determine whether an item is annotated with `#[simd]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_repr_hints","","Obtain the representation annotation for a struct definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"lookup_struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_tuple_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"tup_fields","","",null,null],[5,"struct_tail","","Returns the deeply last field of nested structures, or the same type,\nif not a structure at all. Corresponds to the only possible unsized\nfield, and its type can be used to determine unsizing strategy.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only\nkeeps going as long as the two types are instances of the same\nstructure definitions.\nFor `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`,\nwhereas struct_tail produces `T`, and `Trait`, respectively.",null,null],[3,"ClosureUpvar","","",null,null],[12,"def","","",292,null],[12,"span","","",292,null],[12,"ty","","",292,null],[5,"closure_upvars","","",null,{"inputs":[{"name":"typer"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"eval_repeat_count","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"usize"}}],[5,"each_bound_trait_and_supertraits","","",null,null],[5,"required_region_bounds","","Given a set of predicates that apply to an object type, returns\nthe region bounds that the (erased) `Self` type must\noutlive. Precisely *because* the `Self` type is erased, the\nparameter `erased_self_ty` must be supplied to indicate what type\nhas been used to represent `Self` in the predicates\nthemselves. This should really be a unique type; `FreshTy(0)` is a\npopular choice.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"vec"}],"output":{"name":"vec"}}],[5,"item_variances","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_has_default_impl","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"record_trait_has_default_impl","","Records a trait-to-implementation mapping.",null,null],[5,"record_trait_implementation","","Records a trait-to-implementation mapping.",null,null],[5,"populate_implementations_for_primitive_if_necessary","","Load primitive inherent implementations if necessary",null,null],[5,"populate_implementations_for_type_if_necessary","","Populates the type context with all the implementations for the given type\nif necessary.",null,null],[5,"populate_implementations_for_trait_if_necessary","","Populates the type context with all the implementations for the given\ntrait if necessary.",null,null],[5,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements.\nIf it implements no trait, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the\nID of the impl that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), return the ID of\nthe trait that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_item_of_item","","If the given def ID describes an item belonging to a trait, (either a\ndefault method or an implementation of a trait method), return the ID of\nthe method inside trait definition (this means that if the given def ID\nis already that of the original trait method, then the return value is\nthe same).\nOtherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"hash_crate_independent","","Creates a hash of the type `Ty` which will be the same no matter what crate\ncontext it's calculated within. This is used by the `type_id` intrinsic.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"svh"}],"output":{"name":"u64"}}],[5,"empty_parameter_environment","","Construct a parameter environment suitable for static contexts or other contexts where there\nare no free type/lifetime parameters in scope.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"parameterenvironment"}}],[5,"construct_free_substs","","Constructs and returns a substitution that can be applied to move from\nthe \"outer\" view of a type or method to the \"inner\" view.\nIn general, this means converting from bound parameters to\nfree parameters. Since we currently represent bound/free type\nparameters in the same way, this only has an effect on regions.",null,{"inputs":[{"name":"ctxt"},{"name":"generics"},{"name":"u32"}],"output":{"name":"substs"}}],[5,"construct_parameter_environment","","See `ParameterEnvironment` struct def'n for details",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"generics"},{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[4,"ExplicitSelfCategory","","The category of explicit self.",null,null],[13,"StaticExplicitSelfCategory","","",293,null],[13,"ByValueExplicitSelfCategory","","",293,null],[13,"ByReferenceExplicitSelfCategory","","",293,null],[13,"ByBoxExplicitSelfCategory","","",293,null],[5,"accumulate_lifetimes_in_type","","Pushes all the lifetimes in the given type onto the given list. A\n\"lifetime in a type\" is a lifetime specified by a reference or a lifetime\nin a list of type substitutions. This does *not* traverse into nominal\ntypes, nor does it resolve fictitious types.",null,null],[3,"Freevar","","A free variable referred to in a function.",null,null],[12,"def","","The variable being accessed free.",21,null],[12,"span","","",21,null],[6,"FreevarMap","","",null,null],[6,"CaptureModeMap","","",null,null],[6,"TraitMap","","",null,null],[6,"GlobMap","","",null,null],[5,"with_freevars","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"f"}],"output":{"name":"t"}}],[5,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to scope-id\n`scope_id`.",null,{"inputs":[{"name":"ctxt"},{"name":"destructionscopedata"},{"name":"binder"}],"output":{"name":"t"}}],[5,"count_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"usize"}}],[5,"binds_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"bool"}}],[5,"flatten_late_bound_regions","","Flattens two binding levels into one. So `for<'a> for<'b> Foo`\nbecomes `for<'a,'b> Foo`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"no_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"option"}}],[5,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'static`. Useful in trans but also\nmethod lookup and a few other places where precise region relationships are not required.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"t"}}],[5,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are\nassigned starting at 1 and increasing monotonically in the order traversed\nby the fold operation.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"replace_late_bound_regions","","Replaces the late-bound-regions in `value` that are bound by `value`.",null,null],[5,"make_substs_for_receiver_types","","Substitutes the values for the receiver's type parameters\nthat are found in method, leaving the method's type parameters\nintact.",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"},{"name":"method"}],"output":{"name":"substs"}}],[4,"CopyImplementationError","","",null,null],[13,"FieldDoesNotImplementCopy","","",294,null],[13,"VariantDoesNotImplementCopy","","",294,null],[13,"TypeIsStructural","","",294,null],[13,"TypeHasDestructor","","",294,null],[5,"can_type_implement_copy","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"result"}}],[8,"RegionEscape","","",null,null],[11,"has_escaping_regions","","",442,{"inputs":[{"name":"regionescape"}],"output":{"name":"bool"}}],[10,"has_regions_escaping_depth","","",442,{"inputs":[{"name":"regionescape"},{"name":"u32"}],"output":{"name":"bool"}}],[8,"HasProjectionTypes","","",null,null],[10,"has_projection_types","","",443,{"inputs":[{"name":"hasprojectiontypes"}],"output":{"name":"bool"}}],[8,"ReferencesError","","",null,null],[10,"references_error","","",444,{"inputs":[{"name":"referenceserror"}],"output":{"name":"bool"}}],[0,"ty_fold","rustc_trans::middle","Generalized type folding mechanism. The setup is a bit convoluted\nbut allows for convenient usage. Let T be an instance of some\n\"foldable type\" (one which implements `TypeFoldable`) and F be an\ninstance of a \"folder\" (a type which implements `TypeFolder`). Then\nthe setup is intended to be:",null,null],[8,"TypeFoldable","rustc_trans::middle::ty_fold","The TypeFoldable trait is implemented for every type that can be folded.\nBasically, every type that has a corresponding method in TypeFolder.",null,null],[10,"fold_with","","",445,{"inputs":[{"name":"typefoldable"},{"name":"f"}],"output":{"name":"self"}}],[8,"TypeFolder","","The TypeFolder trait defines the actual *folding*. There is a\nmethod defined for every foldable type. Each of these has a\ndefault implementation that does an \"identity\" fold. Within each\nidentity fold, it should invoke `foo.fold_with(self)` to fold each\nsub-item.",null,null],[10,"tcx","","",446,{"inputs":[{"name":"typefolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","Invoked by the `super_*` routines when we enter a region\nbinding level (for example, when entering a function\nsignature). This is used by clients that want to track the\nDebruijn index nesting level.",446,null],[11,"exit_region_binder","","Invoked by the `super_*` routines when we exit a region\nbinding level. This is used by clients that want to\ntrack the Debruijn index nesting level.",446,null],[11,"fold_binder","","",446,{"inputs":[{"name":"typefolder"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_ty","","",446,{"inputs":[{"name":"typefolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_mt","","",446,{"inputs":[{"name":"typefolder"},{"name":"mt"}],"output":{"name":"mt"}}],[11,"fold_trait_ref","","",446,{"inputs":[{"name":"typefolder"},{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fold_substs","","",446,{"inputs":[{"name":"typefolder"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"fold_fn_sig","","",446,{"inputs":[{"name":"typefolder"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"fold_output","","",446,{"inputs":[{"name":"typefolder"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"fold_bare_fn_ty","","",446,{"inputs":[{"name":"typefolder"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fold_closure_ty","","",446,{"inputs":[{"name":"typefolder"},{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fold_region","","",446,{"inputs":[{"name":"typefolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_existential_bounds","","",446,{"inputs":[{"name":"typefolder"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"fold_autoref","","",446,{"inputs":[{"name":"typefolder"},{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fold_item_substs","","",446,{"inputs":[{"name":"typefolder"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[5,"super_fold_binder","","",null,{"inputs":[{"name":"t"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"super_fold_ty","","",null,{"inputs":[{"name":"t"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"super_fold_substs","","",null,{"inputs":[{"name":"t"},{"name":"substs"}],"output":{"name":"substs"}}],[5,"super_fold_fn_sig","","",null,{"inputs":[{"name":"t"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[5,"super_fold_output","","",null,{"inputs":[{"name":"t"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[5,"super_fold_bare_fn_ty","","",null,{"inputs":[{"name":"t"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[5,"super_fold_closure_ty","","",null,{"inputs":[{"name":"t"},{"name":"closurety"}],"output":{"name":"closurety"}}],[5,"super_fold_trait_ref","","",null,{"inputs":[{"name":"t"},{"name":"traitref"}],"output":{"name":"traitref"}}],[5,"super_fold_mt","","",null,{"inputs":[{"name":"t"},{"name":"mt"}],"output":{"name":"mt"}}],[5,"super_fold_existential_bounds","","",null,{"inputs":[{"name":"t"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[5,"super_fold_autoref","","",null,{"inputs":[{"name":"t"},{"name":"autoref"}],"output":{"name":"autoref"}}],[5,"super_fold_item_substs","","",null,{"inputs":[{"name":"t"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[3,"BottomUpFolder","","",null,null],[12,"tcx","","",301,null],[12,"fldop","","",301,null],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component\ntypes and all regions that occur *free* within it.",null,null],[5,"collect_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"vec"}}],[5,"fold_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"},{"name":"f"}],"output":{"name":"t"}}],[3,"RegionEraser","","",null,null],[5,"erase_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"t"}}],[5,"shift_region","","",null,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"region"}}],[5,"shift_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"t"}],"output":{"name":"t"}}],[0,"ty_match","rustc_trans::middle","",null,null],[3,"Match","rustc_trans::middle::ty_match","A type \"A\" *matches* \"B\" if the fresh types in B could be\nsubstituted with values so as to make it equal to A. Matching is\nintended to be used only on freshened types, and it basically\nindicates if the non-freshened versions of A and B could have been\nunified.",null,null],[0,"ty_relate","rustc_trans::middle","Generalized type relating mechanism. A type relation R relates a\npair of values (A, B). A and B are usually types or regions but\ncan be other things. Examples of type relations are subtyping,\ntype equality, etc.",null,null],[6,"RelateResult","rustc_trans::middle::ty_relate","",null,null],[8,"TypeRelation","","",null,null],[10,"tcx","","",447,{"inputs":[{"name":"typerelation"}],"output":{"name":"ctxt"}}],[10,"tag","","Returns a static string we can use for printouts.",447,{"inputs":[{"name":"typerelation"}],"output":{"name":"str"}}],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the\nrelation. Just affects error messages.",447,{"inputs":[{"name":"typerelation"}],"output":{"name":"bool"}}],[11,"relate","","Generic relation routine suitable for most anything.",447,{"inputs":[{"name":"typerelation"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",447,{"inputs":[{"name":"typerelation"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[10,"tys","","",447,{"inputs":[{"name":"typerelation"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[10,"regions","","",447,{"inputs":[{"name":"typerelation"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[10,"binders","","",447,{"inputs":[{"name":"typerelation"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[8,"Relate","","",null,null],[10,"relate","","",448,{"inputs":[{"name":"relate"},{"name":"r"},{"name":"self"},{"name":"self"}],"output":{"name":"result"}}],[5,"super_relate_tys","","The main \"type relation\" routine. Note that this does not handle\ninference artifacts, so you should filter those out before calling\nit.",null,{"inputs":[{"name":"r"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"expected_found","","",null,{"inputs":[{"name":"r"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[5,"expected_found_bool","","",null,{"inputs":[{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[0,"ty_walk","rustc_trans::middle","An iterator over the type substructure.",null,null],[3,"TypeWalker","rustc_trans::middle::ty_walk","",null,null],[5,"walk_shallow","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[0,"weak_lang_items","rustc_trans::middle","Validity checking for weak lang items",null,null],[5,"check_crate","rustc_trans::middle::weak_lang_items","Checks the crate for usage of weak lang items, returning a vector of all the\nlanguage items required by this crate, but not defined yet.",null,null],[5,"link_name","","",null,null],[0,"lint","rustc_trans","Lints, aka compiler warnings.",null,null],[3,"Lint","rustc_trans::lint","Specification of a single lint.",null,null],[12,"name","","A string identifier for the lint.",351,null],[12,"default_level","","Default level for the lint.",351,null],[12,"desc","","Description of the lint or the issue it detects.",351,null],[6,"LintArray","","",null,null],[8,"LintPass","","Trait for types providing lint checks.",null,null],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",449,null],[11,"check_crate","","",449,null],[11,"check_ident","","",449,null],[11,"check_mod","","",449,null],[11,"check_foreign_item","","",449,null],[11,"check_item","","",449,null],[11,"check_local","","",449,null],[11,"check_block","","",449,null],[11,"check_stmt","","",449,null],[11,"check_arm","","",449,null],[11,"check_pat","","",449,null],[11,"check_decl","","",449,null],[11,"check_expr","","",449,null],[11,"check_expr_post","","",449,null],[11,"check_ty","","",449,null],[11,"check_generics","","",449,null],[11,"check_fn","","",449,null],[11,"check_trait_item","","",449,null],[11,"check_impl_item","","",449,null],[11,"check_struct_def","","",449,null],[11,"check_struct_def_post","","",449,null],[11,"check_struct_field","","",449,null],[11,"check_variant","","",449,null],[11,"check_variant_post","","",449,null],[11,"check_opt_lifetime_ref","","",449,null],[11,"check_lifetime_ref","","",449,null],[11,"check_lifetime_def","","",449,null],[11,"check_explicit_self","","",449,null],[11,"check_mac","","",449,null],[11,"check_path","","",449,null],[11,"check_attribute","","",449,null],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such\nas `#[allow(...)]`. Called with *all* the attributes of that node.",449,null],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",449,null],[6,"LintPassObject","","",null,null],[3,"LintId","","Identifies a lint known to the compiler.",null,null],[4,"Level","","Setting for how to handle a lint.",null,null],[13,"Allow","","",353,null],[13,"Warn","","",353,null],[13,"Deny","","",353,null],[13,"Forbid","","",353,null],[4,"LintSource","","How a lint level was set.",null,null],[13,"Default","","Lint is at the default level as declared\nin rustc or a plugin.",354,null],[13,"Node","","Lint level was set by an attribute.",354,null],[13,"CommandLine","","Lint level was set by a command-line flag.",354,null],[13,"ReleaseChannel","","Lint level was set by the release channel.",354,null],[6,"LevelSource","","",null,null],[0,"builtin","","Some lints that are built in to the compiler.",null,null],[7,"UNUSED_IMPORTS","rustc_trans::lint::builtin","",null,null],[7,"UNUSED_EXTERN_CRATES","","",null,null],[7,"UNUSED_QUALIFICATIONS","","",null,null],[7,"UNKNOWN_LINTS","","",null,null],[7,"UNUSED_VARIABLES","","",null,null],[7,"UNUSED_ASSIGNMENTS","","",null,null],[7,"DEAD_CODE","","",null,null],[7,"UNREACHABLE_CODE","","",null,null],[7,"WARNINGS","","",null,null],[7,"UNUSED_FEATURES","","",null,null],[7,"STABLE_FEATURES","","",null,null],[7,"UNKNOWN_CRATE_TYPES","","",null,null],[7,"VARIANT_SIZE_DIFFERENCES","","",null,null],[7,"FAT_PTR_TRANSMUTES","","",null,null],[7,"TRIVIAL_CASTS","","",null,null],[7,"TRIVIAL_NUMERIC_CASTS","","",null,null],[3,"HardwiredLints","","Does nothing as a lint pass, but registers some `Lint`s\nwhich are used by other parts of the compiler.",null,null],[5,"gather_attrs","rustc_trans::lint","Parse the lint attributes into a vector, with `Err`s for malformed lint\nattributes. Writing this as an iterator is an enormous mess.",null,null],[3,"Context","","Context for lint checking.",null,null],[12,"tcx","","Type context we're checking in.",357,null],[12,"krate","","The crate being checked.",357,null],[12,"exported_items","","Items exported from the crate being checked.",357,null],[3,"GatherNodeLevels","","",null,null],[3,"LintStore","","Information about the registered lints.",null,null],[5,"check_crate","","Perform lint checking on a crate.",null,null],[5,"raw_emit_lint","","Emit a lint as a warning or an error (or not at all)\naccording to `level`.",null,null],[0,"plugin","rustc_trans","Infrastructure for compiler plugins.",null,null],[0,"registry","rustc_trans::plugin","Used by plugin crates to tell `rustc` about the plugins they provide.",null,null],[3,"Registry","rustc_trans::plugin::registry","Structure used to register plugins.",null,null],[12,"sess","","Compiler session. Useful if you want to emit diagnostic messages\nfrom the plugin registrar.",349,null],[0,"load","rustc_trans::plugin","Used by `rustc` when loading a plugin.",null,null],[6,"PluginRegistrarFun","rustc_trans::plugin::load","",null,null],[3,"PluginRegistrar","","",null,null],[12,"fun","","",450,null],[12,"args","","",450,null],[5,"load_plugins","","Read plugin metadata and dynamically load registrar functions.",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"option"}],"output":{"name":"vec"}}],[0,"build","rustc_trans::plugin","Used by `rustc` when compiling a plugin crate.",null,null],[5,"find_plugin_registrar","rustc_trans::plugin::build","Find the function marked with `#[plugin_registrar]`, if any.",null,{"inputs":[{"name":"spanhandler"},{"name":"crate"}],"output":{"name":"option"}}],[3,"Registry","rustc_trans::plugin","Structure used to register plugins.",null,null],[12,"sess","","Compiler session. Useful if you want to emit diagnostic messages\nfrom the plugin registrar.",349,null],[0,"util","rustc_trans","",null,null],[0,"common","rustc_trans::util","",null,null],[17,"FN_OUTPUT_NAME","rustc_trans::util::common","",null,null],[3,"ErrorReported","","",null,null],[5,"time","","",null,{"inputs":[{"name":"bool"},{"name":"str"},{"name":"u"},{"name":"f"}],"output":{"name":"t"}}],[5,"indent","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[3,"Indenter","","",null,null],[5,"indenter","","",null,{"inputs":[],"output":{"name":"indenter"}}],[5,"loop_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"block_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"can_reach","","K: Eq + Hash<S>, V, S, H: Hasher<S>",null,{"inputs":[{"name":"hashmap"},{"name":"t"},{"name":"t"}],"output":{"name":"bool"}}],[5,"memoized","","Memoizes a one-argument closure using the given RefCell containing\na type implementing MutableMap to serve as a cache.",null,{"inputs":[{"name":"refcell"},{"name":"t"},{"name":"f"}],"output":{"name":"u"}}],[5,"path2cstr","","",null,{"inputs":[{"name":"path"}],"output":{"name":"cstring"}}],[0,"ppaux","rustc_trans::util","",null,null],[8,"Repr","rustc_trans::util::ppaux","Produces a string suitable for debugging output.",null,null],[10,"repr","","",451,{"inputs":[{"name":"repr"},{"name":"ctxt"}],"output":{"name":"string"}}],[8,"UserString","","Produces a string suitable for showing to the user.",null,null],[10,"user_string","","",452,{"inputs":[{"name":"userstring"},{"name":"ctxt"}],"output":{"name":"string"}}],[5,"note_and_explain_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"region"},{"name":"str"}],"output":{"name":"option"}}],[5,"explain_region_and_span","","",null,null],[5,"bound_region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"bound_region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"string"}}],[5,"region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"region"}],"output":{"name":"string"}}],[5,"mutability_to_string","","",null,{"inputs":[{"name":"mutability"}],"output":{"name":"string"}}],[5,"mt_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"string"}}],[5,"vec_map_to_string","","",null,null],[5,"ty_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"explicit_self_category_to_str","","",null,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"str"}}],[5,"parameterized","","",null,null],[5,"ty_to_short_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[0,"nodemap","rustc_trans::util","An efficient hash map for node IDs",null,null],[6,"FnvHashMap","rustc_trans::util::nodemap","",null,null],[6,"FnvHashSet","","",null,null],[6,"NodeMap","","",null,null],[6,"DefIdMap","","",null,null],[6,"NodeSet","","",null,null],[6,"DefIdSet","","",null,null],[5,"FnvHashMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"FnvHashSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[5,"NodeMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"DefIdMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"NodeSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[5,"DefIdSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[3,"FnvHasher","","A speedy hash algorithm for node ids and def ids. The hashmap in\nlibcollections by default uses SipHash which isn't quite as speedy as we\nwant. In the compiler we're not really worried about DOS attempts, so we\njust default to a non-cryptographic hash.",null,null],[0,"snapshot_vec","rustc_trans::util","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits\nyou to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either\nto rollback to the start of the snapshot or commit those changes.",null,null],[4,"UndoLog","rustc_trans::util::snapshot_vec","",null,null],[13,"OpenSnapshot","","Indicates where a snapshot started.",453,null],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",453,null],[13,"NewElem","","New variable with given index was created.",453,null],[13,"SetElem","","Variable with given index was changed *from* the given value.",453,null],[13,"Other","","Extensible set of actions",453,null],[3,"SnapshotVec","","",null,null],[3,"Snapshot","","",null,null],[8,"SnapshotVecDelegate","","",null,null],[16,"Value","rustc_trans::util::snapshot_vec::SnapshotVecDelegate","",null,null],[16,"Undo","","",null,null],[10,"reverse","rustc_trans::util::snapshot_vec","",454,null],[0,"lev_distance","rustc_trans::util","",null,null],[5,"lev_distance","rustc_trans::util::lev_distance","",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"usize"}}],[0,"num","rustc_trans::util","",null,null],[8,"ToPrimitive","rustc_trans::util::num","",null,null],[10,"to_i8","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i16","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i32","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i64","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u8","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u16","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u32","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u64","","",455,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[0,"fs","rustc_trans::util","",null,null],[5,"realpath","rustc_trans::util::fs","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[0,"sha2","rustc_trans::util","This module implements only the Sha256 function since that is all that is needed for internal\nuse. This implementation is not intended for external use or for any use where security is\nimportant.",null,null],[8,"Digest","rustc_trans::util::sha2","The Digest trait specifies an interface common to digest functions, such as SHA-1 and the SHA-2\nfamily of digest functions.",null,null],[10,"input","","Provide message data.",456,null],[10,"result","","Retrieve the digest result. This method may be called multiple times.",456,null],[10,"reset","","Reset the digest. This method must be called after result() and before supplying more\ndata.",456,null],[10,"output_bits","","Get the output size in bits.",456,{"inputs":[{"name":"digest"}],"output":{"name":"usize"}}],[11,"input_str","","Convenience function that feeds a string into a digest.",456,null],[11,"result_bytes","","Convenience function that retrieves the result of a digest as a\nnewly allocated vec of bytes.",456,{"inputs":[{"name":"digest"}],"output":{"name":"vec"}}],[11,"result_str","","Convenience function that retrieves the result of a digest as a\nString in hexadecimal format.",456,{"inputs":[{"name":"digest"}],"output":{"name":"string"}}],[11,"new_in","rustc_back::tempdir","Attempts to make a temporary directory inside of `tmpdir` whose name\nwill have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",457,{"inputs":[{"name":"tempdir"},{"name":"p"},{"name":"str"}],"output":{"name":"result"}}],[11,"new","","Attempts to make a temporary directory inside of `env::temp_dir()` whose\nname will have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",457,{"inputs":[{"name":"tempdir"},{"name":"str"}],"output":{"name":"result"}}],[11,"into_path","","Unwrap the wrapped `std::path::Path` from the `TempDir` wrapper.\nThis discards the wrapper so that the automatic deletion of the\ntemporary directory is prevented.",457,{"inputs":[{"name":"tempdir"}],"output":{"name":"pathbuf"}}],[11,"path","","Access the wrapped `std::path::Path` to the temporary directory.",457,{"inputs":[{"name":"tempdir"}],"output":{"name":"path"}}],[11,"close","","Close and remove the temporary directory",457,{"inputs":[{"name":"tempdir"}],"output":{"name":"result"}}],[11,"drop","","",457,null],[11,"clone","rustc_back::target::apple_ios_base","",458,{"inputs":[{"name":"arch"}],"output":{"name":"arch"}}],[11,"to_string","","",458,{"inputs":[{"name":"arch"}],"output":{"name":"str"}}],[11,"fmt","rustc_back::target","",459,{"inputs":[{"name":"target"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",459,{"inputs":[{"name":"target"}],"output":{"name":"target"}}],[11,"fmt","","",460,{"inputs":[{"name":"targetoptions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",460,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for\ncompilation, will certainly not work.",460,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",459,{"inputs":[{"name":"target"},{"name":"abi"}],"output":{"name":"abi"}}],[11,"from_json","","Load a target descriptor from a JSON object.",459,{"inputs":[{"name":"target"},{"name":"json"}],"output":{"name":"target"}}],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target\ntriple. Note that it could also just be a bare filename already, so also\ncheck for that. If one of the hardcoded targets we know about, just\nreturn it directly.",459,{"inputs":[{"name":"target"},{"name":"str"}],"output":{"name":"result"}}],[3,"Sha256","rustc_trans::util::sha2","The SHA-256 hash algorithm",null,null],[0,"back","rustc_trans","",null,null],[0,"abi","rustc_trans::back","",null,null],[17,"BOX_FIELD_DROP_GLUE","rustc_trans::back::abi","",null,null],[17,"BOX_FIELD_BODY","","",null,null],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.\n- For a closure, this is the code address.\n- For an object or trait instance, this is the address of the box.\n- For a slice, this is the base address.",null,null],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.\n- For a closure, this is the address of the environment.\n- For an object or trait instance, this is the address of the vtable.\n- For a slice, this is the length.",null,null],[0,"archive","rustc_trans::back","A helper class for dealing with static archives",null,null],[17,"METADATA_FILENAME","rustc_trans::back::archive","",null,null],[3,"ArchiveConfig","","",null,null],[12,"handler","","",461,null],[12,"dst","","",461,null],[12,"lib_search_paths","","",461,null],[12,"slib_prefix","","",461,null],[12,"slib_suffix","","",461,null],[12,"maybe_ar_prog","","",461,null],[3,"Archive","","",null,null],[3,"ArchiveBuilder","","Helper for adding many files to an archive with a single invocation of\n`ar`.",null,null],[5,"find_library","","",null,null],[0,"arm","rustc_trans::back","",null,null],[5,"get_target_strs","rustc_trans::back::arm","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"mips","rustc_trans::back","",null,null],[5,"get_target_strs","rustc_trans::back::mips","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"mipsel","rustc_trans::back","",null,null],[5,"get_target_strs","rustc_trans::back::mipsel","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"rpath","rustc_trans::back","",null,null],[3,"RPathConfig","rustc_trans::back::rpath","",null,null],[12,"used_crates","","",462,null],[12,"out_filename","","",462,null],[12,"is_like_osx","","",462,null],[12,"has_rpath","","",462,null],[12,"get_install_prefix_lib_path","","",462,null],[12,"realpath","","",462,null],[5,"get_rpath_flags","","",null,{"inputs":[{"name":"rpathconfig"}],"output":{"name":"vec"}}],[0,"svh","rustc_trans::back","Calculation and management of a Strict Version Hash for crates",null,null],[3,"Svh","rustc_trans::back::svh","",null,null],[0,"target_strs","rustc_trans::back","",null,null],[3,"t","rustc_trans::back::target_strs","",null,null],[12,"module_asm","","",463,null],[12,"data_layout","","",463,null],[12,"target_triple","","",463,null],[12,"cc_args","","",463,null],[0,"x86","rustc_trans::back","",null,null],[5,"get_target_strs","rustc_trans::back::x86","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"x86_64","rustc_trans::back","",null,null],[5,"get_target_strs","rustc_trans::back::x86_64","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"link","rustc_trans::back","",null,null],[5,"find_crate_name","rustc_trans::back::link","",null,null],[5,"build_link_meta","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"string"}],"output":{"name":"linkmeta"}}],[5,"sanitize","","",null,{"inputs":[{"name":"str"}],"output":{"name":"string"}}],[5,"mangle","","",null,{"inputs":[{"name":"pi"},{"name":"option"}],"output":{"name":"string"}}],[5,"exported_name","","",null,{"inputs":[{"name":"pathelems"},{"name":"str"}],"output":{"name":"string"}}],[5,"mangle_exported_name","","",null,{"inputs":[{"name":"cratecontext"},{"name":"pathelems"},{"name":"ty"},{"name":"nodeid"}],"output":{"name":"string"}}],[5,"mangle_internal_name_by_type_and_seq","","",null,{"inputs":[{"name":"cratecontext"},{"name":"ty"},{"name":"str"}],"output":{"name":"string"}}],[5,"mangle_internal_name_by_path_and_seq","","",null,{"inputs":[{"name":"pathelems"},{"name":"str"}],"output":{"name":"string"}}],[5,"get_cc_prog","","",null,{"inputs":[{"name":"session"}],"output":{"name":"string"}}],[5,"remove","","",null,{"inputs":[{"name":"session"},{"name":"path"}],"output":null}],[5,"link_binary","","Perform the linkage portion of the compilation phase. This will generate all\nof the requested outputs for this compilation session.",null,{"inputs":[{"name":"session"},{"name":"cratetranslation"},{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"vec"}}],[5,"default_output_for_target","","Returns default crate type for target",null,{"inputs":[{"name":"session"}],"output":{"name":"cratetype"}}],[5,"invalid_output_for_target","","Checks if target supports crate_type as output",null,{"inputs":[{"name":"session"},{"name":"cratetype"}],"output":{"name":"bool"}}],[5,"filename_for_input","","",null,{"inputs":[{"name":"session"},{"name":"cratetype"},{"name":"str"},{"name":"path"}],"output":{"name":"pathbuf"}}],[17,"RLIB_BYTECODE_OBJECT_MAGIC","","",null,null],[17,"RLIB_BYTECODE_OBJECT_VERSION","","",null,null],[17,"RLIB_BYTECODE_OBJECT_VERSION_OFFSET","","",null,null],[17,"RLIB_BYTECODE_OBJECT_V1_DATASIZE_OFFSET","","",null,null],[17,"RLIB_BYTECODE_OBJECT_V1_DATA_OFFSET","","",null,null],[0,"lto","rustc_trans::back","",null,null],[5,"run","rustc_trans::back::lto","",null,null],[0,"write","rustc_trans::back","",null,null],[4,"OutputType","rustc_trans::back::write","",null,null],[13,"OutputTypeBitcode","","",464,null],[13,"OutputTypeAssembly","","",464,null],[13,"OutputTypeLlvmAssembly","","",464,null],[13,"OutputTypeObject","","",464,null],[13,"OutputTypeExe","","",464,null],[5,"llvm_err","","",null,{"inputs":[{"name":"handler"},{"name":"string"}],"output":null}],[5,"write_output_file","","",null,{"inputs":[{"name":"handler"},{"name":"targetmachineref"},{"name":"passmanagerref"},{"name":"moduleref"},{"name":"path"},{"name":"filetype"}],"output":null}],[5,"run_passes","","",null,null],[5,"run_assembler","","",null,{"inputs":[{"name":"session"},{"name":"outputfilenames"}],"output":null}],[11,"cmp","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",464,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",464,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[0,"trans","rustc_trans","",null,null],[3,"CrateContext","rustc_trans::trans","",null,null],[3,"ModuleTranslation","","",null,null],[12,"llcx","","",465,null],[12,"llmod","","",465,null],[3,"CrateTranslation","","",null,null],[12,"modules","","",466,null],[12,"metadata_module","","",466,null],[12,"link","","",466,null],[12,"metadata","","",466,null],[12,"reachable","","",466,null],[12,"crate_formats","","",466,null],[12,"no_builtins","","",466,null],[5,"trans_crate","","",null,null],[5,"gensym_name","","Generates a unique symbol based off the name given. This is used to create\nunique symbols for things like closures.",null,{"inputs":[{"name":"str"}],"output":{"name":"pathelem"}}],[11,"dtor_type","rustc_trans::middle::ty","",244,{"inputs":[{"name":"ctxt"}],"output":{"name":"ty"}}],[11,"new","syntax::util::interner","",467,{"inputs":[{"name":"interner"}],"output":{"name":"interner"}}],[11,"prefill","","",467,null],[11,"intern","","",467,{"inputs":[{"name":"interner"},{"name":"t"}],"output":{"name":"name"}}],[11,"gensym","","",467,{"inputs":[{"name":"interner"},{"name":"t"}],"output":{"name":"name"}}],[11,"get","","",467,{"inputs":[{"name":"interner"},{"name":"name"}],"output":{"name":"t"}}],[11,"len","","",467,{"inputs":[{"name":"interner"}],"output":{"name":"usize"}}],[11,"find","","",467,{"inputs":[{"name":"interner"},{"name":"q"}],"output":{"name":"option"}}],[11,"clear","","",467,null],[11,"partial_cmp","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"option"}}],[11,"lt","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"le","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"gt","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"ge","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"hash","","",468,null],[11,"eq","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"ne","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"clone","","",468,{"inputs":[{"name":"rcstr"}],"output":{"name":"rcstr"}}],[11,"new","","",468,{"inputs":[{"name":"rcstr"},{"name":"str"}],"output":{"name":"rcstr"}}],[11,"cmp","","",468,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"ordering"}}],[11,"fmt","","",468,{"inputs":[{"name":"rcstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",468,{"inputs":[{"name":"rcstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"borrow","","",468,{"inputs":[{"name":"rcstr"}],"output":{"name":"str"}}],[11,"deref","","",468,{"inputs":[{"name":"rcstr"}],"output":{"name":"str"}}],[11,"new","","",469,{"inputs":[{"name":"strinterner"}],"output":{"name":"strinterner"}}],[11,"prefill","","",469,null],[11,"intern","","",469,{"inputs":[{"name":"strinterner"},{"name":"str"}],"output":{"name":"name"}}],[11,"gensym","","",469,{"inputs":[{"name":"strinterner"},{"name":"str"}],"output":{"name":"name"}}],[11,"gensym_copy","","Create a gensym with the same name as an existing\nentry.",469,{"inputs":[{"name":"strinterner"},{"name":"name"}],"output":{"name":"name"}}],[11,"get","","",469,{"inputs":[{"name":"strinterner"},{"name":"name"}],"output":{"name":"rcstr"}}],[11,"len","","",469,{"inputs":[{"name":"strinterner"}],"output":{"name":"usize"}}],[11,"find","","",469,{"inputs":[{"name":"strinterner"},{"name":"q"}],"output":{"name":"option"}}],[11,"clear","","",469,null],[11,"reset","","",469,null],[11,"from_iter","syntax::util::small_vector","",470,{"inputs":[{"name":"smallvector"},{"name":"i"}],"output":{"name":"smallvector"}}],[11,"extend","","",470,null],[11,"zero","","",470,{"inputs":[{"name":"smallvector"}],"output":{"name":"smallvector"}}],[11,"one","","",470,{"inputs":[{"name":"smallvector"},{"name":"t"}],"output":{"name":"smallvector"}}],[11,"many","","",470,{"inputs":[{"name":"smallvector"},{"name":"vec"}],"output":{"name":"smallvector"}}],[11,"as_slice","","",470,null],[11,"pop","","",470,{"inputs":[{"name":"smallvector"}],"output":{"name":"option"}}],[11,"push","","",470,null],[11,"push_all","","",470,null],[11,"get","","",470,{"inputs":[{"name":"smallvector"},{"name":"usize"}],"output":{"name":"t"}}],[11,"expect_one","","",470,{"inputs":[{"name":"smallvector"},{"name":"str"}],"output":{"name":"t"}}],[11,"move_iter","","Deprecated: use `into_iter`.",470,{"inputs":[{"name":"smallvector"}],"output":{"name":"intoiter"}}],[11,"into_iter","","",470,{"inputs":[{"name":"smallvector"}],"output":{"name":"intoiter"}}],[11,"len","","",470,{"inputs":[{"name":"smallvector"}],"output":{"name":"usize"}}],[11,"is_empty","","",470,{"inputs":[{"name":"smallvector"}],"output":{"name":"bool"}}],[11,"next","","",471,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",471,null],[11,"move_map","","",470,{"inputs":[{"name":"smallvector"},{"name":"f"}],"output":{"name":"smallvector"}}],[11,"clone","syntax::diagnostics::registry","",472,{"inputs":[{"name":"registry"}],"output":{"name":"registry"}}],[11,"new","","",472,null],[11,"find_description","","",472,{"inputs":[{"name":"registry"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","syntax::ext::base","",473,{"inputs":[{"name":"annotatable"}],"output":{"name":"annotatable"}}],[11,"fmt","","",473,{"inputs":[{"name":"annotatable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"attrs","","",473,null],[11,"fold_attrs","","",473,{"inputs":[{"name":"annotatable"},{"name":"vec"}],"output":{"name":"annotatable"}}],[11,"expect_item","","",473,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"expect_trait_item","","",473,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"expect_impl_item","","",473,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"default","","",474,{"inputs":[{"name":"maceager"}],"output":{"name":"maceager"}}],[11,"expr","","",474,{"inputs":[{"name":"maceager"},{"name":"p"}],"output":{"name":"box"}}],[11,"pat","","",474,{"inputs":[{"name":"maceager"},{"name":"p"}],"output":{"name":"box"}}],[11,"items","","",474,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"impl_items","","",474,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"stmts","","",474,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"make_expr","","",474,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_items","","",474,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_impl_items","","",474,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_stmts","","",474,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_pat","","",474,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"clone","","",475,{"inputs":[{"name":"dummyresult"}],"output":{"name":"dummyresult"}}],[11,"any","","Create a default MacResult that can be anything.",475,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"box"}}],[11,"expr","","Create a default MacResult that can only be an expression.",475,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"box"}}],[11,"raw_expr","","A plain dummy expression.",475,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"p"}}],[11,"raw_pat","","A plain dummy pattern.",475,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"pat"}}],[11,"make_expr","","",475,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_pat","","",475,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_items","","",475,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_impl_items","","",475,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_stmts","","",475,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"new","","",476,{"inputs":[{"name":"blockinfo"}],"output":{"name":"blockinfo"}}],[11,"new","","",477,{"inputs":[{"name":"extctxt"},{"name":"parsesess"},{"name":"vec"},{"name":"expansionconfig"}],"output":{"name":"extctxt"}}],[11,"expand_expr","","",477,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"expander","","Returns a `Folder` for deeply expanding all macros in a AST node.",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"macroexpander"}}],[11,"new_parser_from_tts","","",477,null],[11,"codemap","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"codemap"}}],[11,"parse_sess","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"parsesess"}}],[11,"cfg","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"call_site","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"backtrace","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"expnid"}}],[11,"original_span","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"original_span_in_file","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"mod_push","","",477,null],[11,"mod_pop","","",477,null],[11,"mod_path","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"bt_push","","",477,null],[11,"bt_pop","","",477,null],[11,"insert_macro","","",477,null],[11,"span_fatal","","Emit `msg` attached to `sp`, and stop compilation immediately.",477,null],[11,"span_err","","Emit `msg` attached to `sp`, without immediately stopping\ncompilation.",477,null],[11,"span_warn","","",477,null],[11,"span_unimpl","","",477,null],[11,"span_bug","","",477,null],[11,"span_note","","",477,null],[11,"span_help","","",477,null],[11,"fileline_help","","",477,null],[11,"bug","","",477,null],[11,"trace_macros","","",477,{"inputs":[{"name":"extctxt"}],"output":{"name":"bool"}}],[11,"set_trace_macros","","",477,null],[11,"ident_of","","",477,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"ident"}}],[11,"ident_of_std","","",477,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"ident"}}],[11,"name_of","","",477,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"name"}}],[11,"push_frame","","",478,null],[11,"pop_frame","","",478,null],[11,"find","","",478,{"inputs":[{"name":"syntaxenv"},{"name":"name"}],"output":{"name":"option"}}],[11,"insert","","",478,null],[11,"info","","",478,{"inputs":[{"name":"syntaxenv"}],"output":{"name":"blockinfo"}}],[11,"path","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[11,"path_ident","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[11,"path_global","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[11,"path_all","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"vec"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"path"}}],[11,"qpath","","Constructs a qualified path.",477,null],[11,"qpath_all","","Constructs a qualified path.",477,null],[11,"ty_mt","","",477,{"inputs":[{"name":"extctxt"},{"name":"p"},{"name":"mutability"}],"output":{"name":"mutty"}}],[11,"ty","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ty_"}],"output":{"name":"p"}}],[11,"ty_path","","",477,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"p"}}],[11,"ty_sum","","",477,{"inputs":[{"name":"extctxt"},{"name":"path"},{"name":"ownedslice"}],"output":{"name":"p"}}],[11,"ty_ident","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"ty_rptr","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"option"},{"name":"mutability"}],"output":{"name":"p"}}],[11,"ty_ptr","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"mutability"}],"output":{"name":"p"}}],[11,"ty_option","","",477,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"ty_field_imm","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"typefield"}}],[11,"ty_infer","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"typaram","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"ownedslice"},{"name":"option"}],"output":{"name":"typaram"}}],[11,"ty_vars","","",477,{"inputs":[{"name":"extctxt"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"ty_vars_global","","",477,{"inputs":[{"name":"extctxt"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"trait_ref","","",477,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"traitref"}}],[11,"poly_trait_ref","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"}],"output":{"name":"polytraitref"}}],[11,"typarambound","","",477,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"typarambound"}}],[11,"lifetime","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"name"}],"output":{"name":"lifetime"}}],[11,"lifetime_def","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"name"},{"name":"vec"}],"output":{"name":"lifetimedef"}}],[11,"stmt_expr","","",477,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"stmt_let","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[11,"stmt_let_typed","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"block","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[11,"stmt_item","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"block_expr","","",477,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"block_all","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[11,"expr","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"expr_"}],"output":{"name":"p"}}],[11,"expr_path","","",477,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"p"}}],[11,"expr_qpath","","Constructs a QPath expression.",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"qself"},{"name":"path"}],"output":{"name":"p"}}],[11,"expr_ident","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"expr_self","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_binary","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"binop_"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_deref","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_unary","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"unop"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_field_access","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"expr_tup_field_access","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"usize"}],"output":{"name":"p"}}],[11,"expr_addr_of","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_mut_addr_of","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_call","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_call_ident","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_call_global","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_method_call","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_block","","",477,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"field_imm","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"field"}}],[11,"expr_struct","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_struct_ident","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_lit","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"lit_"}],"output":{"name":"p"}}],[11,"expr_usize","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"usize"}],"output":{"name":"p"}}],[11,"expr_int","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"isize"}],"output":{"name":"p"}}],[11,"expr_u32","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"u32"}],"output":{"name":"p"}}],[11,"expr_u8","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"u8"}],"output":{"name":"p"}}],[11,"expr_bool","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"}],"output":{"name":"p"}}],[11,"expr_vec","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_vec_ng","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_vec_slice","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_str","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"expr_cast","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_some","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_none","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_break","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_tuple","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_fail","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"expr_unreachable","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_ok","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_err","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_try","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"pat_"}],"output":{"name":"p"}}],[11,"pat_wild","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"pat_lit","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_ident","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"pat_ident_binding_mode","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"bindingmode"}],"output":{"name":"p"}}],[11,"pat_enum","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_struct","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_tuple","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_some","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_none","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"pat_ok","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_err","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"arm","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"arm"}}],[11,"arm_unreachable","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"arm"}}],[11,"expr_match","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_if","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"},{"name":"option"}],"output":{"name":"p"}}],[11,"expr_loop","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_fn_decl","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda0","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda1","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"lambda_expr","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_expr_0","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_expr_1","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"lambda_stmts","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"lambda_stmts_0","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"lambda_stmts_1","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"ident"}],"output":{"name":"p"}}],[11,"arg","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"arg"}}],[11,"fn_decl","","",477,{"inputs":[{"name":"extctxt"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"item","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"item_"}],"output":{"name":"p"}}],[11,"item_fn_poly","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"generics"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_fn","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"variant","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"spanned"}}],[11,"item_enum_poly","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_enum","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"enumdef"}],"output":{"name":"p"}}],[11,"item_struct","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"structdef"}],"output":{"name":"p"}}],[11,"item_struct_poly","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"structdef"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_mod","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"item_static","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"mutability"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_const","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_ty_poly","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_ty","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[11,"attribute","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"spanned"}}],[11,"meta_word","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"meta_list","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"},{"name":"vec"}],"output":{"name":"p"}}],[11,"meta_name_value","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"},{"name":"lit_"}],"output":{"name":"p"}}],[11,"item_use","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_use_simple","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"path"}],"output":{"name":"p"}}],[11,"item_use_simple_","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"ident"},{"name":"path"}],"output":{"name":"p"}}],[11,"item_use_list","","",477,null],[11,"item_use_glob","","",477,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"p"}}],[11,"clone","syntax::ext::deriving::ord","",479,{"inputs":[{"name":"orderingop"}],"output":{"name":"orderingop"}}],[11,"clone","syntax::ext::deriving::generic::ty","",480,{"inputs":[{"name":"ptrty"}],"output":{"name":"ptrty"}}],[11,"clone","","",481,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"new","","",481,{"inputs":[{"name":"path"},{"name":"vec"}],"output":{"name":"path"}}],[11,"new_local","","",481,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"path"}}],[11,"new_","","",481,{"inputs":[{"name":"path"},{"name":"vec"},{"name":"option"},{"name":"vec"},{"name":"bool"}],"output":{"name":"path"}}],[11,"to_ty","","",481,{"inputs":[{"name":"path"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"p"}}],[11,"to_path","","",481,{"inputs":[{"name":"path"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",482,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[11,"to_ty","","",482,{"inputs":[{"name":"ty"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"p"}}],[11,"to_path","","",482,{"inputs":[{"name":"ty"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",483,{"inputs":[{"name":"lifetimebounds"}],"output":{"name":"lifetimebounds"}}],[11,"empty","","",483,{"inputs":[{"name":"lifetimebounds"}],"output":{"name":"lifetimebounds"}}],[11,"to_generics","","",483,{"inputs":[{"name":"lifetimebounds"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"generics"}}],[11,"expand","syntax::ext::deriving::generic","",484,null],[11,"eq","","",485,{"inputs":[{"name":"structtype"},{"name":"structtype"}],"output":{"name":"bool"}}],[11,"ne","","",485,{"inputs":[{"name":"structtype"},{"name":"structtype"}],"output":{"name":"bool"}}],[11,"clone","syntax::ext::expand","",486,{"inputs":[{"name":"patidentfinder"}],"output":{"name":"patidentfinder"}}],[11,"visit_pat","","",486,null],[11,"fold_ident","","",487,{"inputs":[{"name":"identrenamer"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_mac","","",487,{"inputs":[{"name":"identrenamer"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"fold_pat","","",488,{"inputs":[{"name":"patidentrenamer"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mac","","",488,{"inputs":[{"name":"patidentrenamer"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"new","","",489,{"inputs":[{"name":"macroexpander"},{"name":"extctxt"}],"output":{"name":"macroexpander"}}],[11,"fold_expr","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_pat","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_item","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_item_underscore","","",489,{"inputs":[{"name":"macroexpander"},{"name":"item_"}],"output":{"name":"item_"}}],[11,"fold_stmt","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_block","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_arm","","",489,{"inputs":[{"name":"macroexpander"},{"name":"arm"}],"output":{"name":"arm"}}],[11,"fold_trait_item","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_impl_item","","",489,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"new_span","","",489,{"inputs":[{"name":"macroexpander"},{"name":"span"}],"output":{"name":"span"}}],[11,"default","","",490,{"inputs":[{"name":"expansionconfig"},{"name":"string"}],"output":{"name":"expansionconfig"}}],[11,"enable_quotes","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_asm","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_log_syntax","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_concat_idents","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_trace_macros","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_allow_internal_unstable","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_custom_derive","","",490,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"fold_ident","","",491,{"inputs":[{"name":"marker"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_mac","","",491,{"inputs":[{"name":"marker"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"visit_mac","","",492,null],[11,"eq","syntax::ext::format","",493,{"inputs":[{"name":"argumenttype"},{"name":"argumenttype"}],"output":{"name":"bool"}}],[11,"ne","","",493,{"inputs":[{"name":"argumenttype"},{"name":"argumenttype"}],"output":{"name":"bool"}}],[11,"clone","syntax::ext::mtwt","",494,{"inputs":[{"name":"syntaxcontext_"}],"output":{"name":"syntaxcontext_"}}],[11,"fmt","","",494,{"inputs":[{"name":"syntaxcontext_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",494,null],[11,"decode","","",494,{"inputs":[{"name":"syntaxcontext_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",494,{"inputs":[{"name":"syntaxcontext_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",494,{"inputs":[{"name":"syntaxcontext_"},{"name":"syntaxcontext_"}],"output":{"name":"bool"}}],[11,"ne","","",494,{"inputs":[{"name":"syntaxcontext_"},{"name":"syntaxcontext_"}],"output":{"name":"bool"}}],[11,"to_tokens","syntax::ast","",495,{"inputs":[{"name":"tokentree"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::codemap","",370,{"inputs":[{"name":"spanned"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","core::option","",11,{"inputs":[{"name":"option"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_source","syntax::ast","",4,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",4,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"to_source","","",366,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",366,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[11,"to_source","","",367,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",367,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[11,"to_source","","",496,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",496,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[11,"to_source","","",497,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",497,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[11,"to_source","","",498,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",498,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[11,"to_source","","",499,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",499,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[11,"to_source","syntax::ptr","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",363,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","syntax::ast","",500,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",500,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[11,"to_source","","",501,{"inputs":[{"name":"attribute_"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",501,{"inputs":[{"name":"attribute_"}],"output":{"name":"string"}}],[11,"to_tokens","","",4,{"inputs":[{"name":"ident"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",366,{"inputs":[{"name":"path"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ptr","",363,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",363,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",363,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",363,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",500,{"inputs":[{"name":"arm"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",367,{"inputs":[{"name":"ty"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",498,{"inputs":[{"name":"generics"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",499,{"inputs":[{"name":"whereclause"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ptr","",363,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",363,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",496,{"inputs":[{"name":"block"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",497,{"inputs":[{"name":"arg"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",501,{"inputs":[{"name":"attribute_"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"parse_item","syntax::ext::base","",477,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_stmt","","",477,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_expr","","",477,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_tts","","",477,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"vec"}}],[11,"parse_tts_with_hygiene","","",477,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"vec"}}],[11,"clone","syntax::ext::tt::transcribe","",502,{"inputs":[{"name":"ttframe"}],"output":{"name":"ttframe"}}],[11,"clone","","",503,{"inputs":[{"name":"ttreader"}],"output":{"name":"ttreader"}}],[11,"clone","","",504,{"inputs":[{"name":"lockstepitersize"}],"output":{"name":"lockstepitersize"}}],[11,"add","","",504,{"inputs":[{"name":"lockstepitersize"},{"name":"lockstepitersize"}],"output":{"name":"lockstepitersize"}}],[11,"clone","syntax::ext::tt::macro_parser","",505,{"inputs":[{"name":"tokentreeortokentreevec"}],"output":{"name":"tokentreeortokentreevec"}}],[11,"clone","","",506,{"inputs":[{"name":"matcherttframe"}],"output":{"name":"matcherttframe"}}],[11,"clone","","",507,{"inputs":[{"name":"matcherpos"}],"output":{"name":"matcherpos"}}],[11,"make_expr","syntax::ext::tt::macro_rules","",508,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_pat","","",508,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_items","","",508,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_impl_items","","",508,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_stmts","","",508,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"expand","","",509,null],[11,"cmp","syntax::ast","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"option"}}],[11,"lt","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"le","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"gt","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"ge","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"hash","","",4,null],[11,"clone","","",4,{"inputs":[{"name":"ident"}],"output":{"name":"ident"}}],[11,"new","","Construct an identifier with the given name and an empty context:",4,{"inputs":[{"name":"ident"},{"name":"name"}],"output":{"name":"ident"}}],[11,"as_str","","",4,{"inputs":[{"name":"ident"}],"output":{"name":"str"}}],[11,"encode_with_hygiene","","",4,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"fmt","","",4,{"inputs":[{"name":"ident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",4,{"inputs":[{"name":"ident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"name"}],"output":{"name":"name"}}],[11,"decode","","",5,{"inputs":[{"name":"name"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",5,{"inputs":[{"name":"name"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",5,null],[11,"partial_cmp","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"option"}}],[11,"lt","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"le","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"gt","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ge","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"eq","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"cmp","","",5,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"ordering"}}],[11,"as_str","","",5,{"inputs":[{"name":"name"}],"output":{"name":"str"}}],[11,"usize","","",5,{"inputs":[{"name":"name"}],"output":{"name":"usize"}}],[11,"ident","","",5,{"inputs":[{"name":"name"}],"output":{"name":"ident"}}],[11,"encode","","",4,{"inputs":[{"name":"ident"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",4,{"inputs":[{"name":"ident"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",369,{"inputs":[{"name":"lifetime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",369,null],[11,"decode","","",369,{"inputs":[{"name":"lifetime"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",369,{"inputs":[{"name":"lifetime"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",369,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"ne","","",369,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"clone","","",369,{"inputs":[{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"fmt","","",510,{"inputs":[{"name":"lifetimedef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",510,null],[11,"decode","","",510,{"inputs":[{"name":"lifetimedef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",510,{"inputs":[{"name":"lifetimedef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",510,{"inputs":[{"name":"lifetimedef"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"ne","","",510,{"inputs":[{"name":"lifetimedef"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"clone","","",510,{"inputs":[{"name":"lifetimedef"}],"output":{"name":"lifetimedef"}}],[11,"fmt","","",366,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",366,null],[11,"decode","","",366,{"inputs":[{"name":"path"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",366,{"inputs":[{"name":"path"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",366,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",366,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"clone","","",366,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"fmt","","",511,{"inputs":[{"name":"pathsegment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",511,null],[11,"decode","","",511,{"inputs":[{"name":"pathsegment"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",511,{"inputs":[{"name":"pathsegment"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",511,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"ne","","",511,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"clone","","",511,{"inputs":[{"name":"pathsegment"}],"output":{"name":"pathsegment"}}],[11,"fmt","","",512,{"inputs":[{"name":"pathparameters"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",512,null],[11,"decode","","",512,{"inputs":[{"name":"pathparameters"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",512,{"inputs":[{"name":"pathparameters"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",512,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"ne","","",512,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"clone","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"none","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"is_empty","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"has_lifetimes","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"has_types","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"types","","Returns the types that the user wrote. Note that these do not necessarily map to the type\nparameters in the parenthesized case.",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"lifetimes","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"bindings","","",512,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"fmt","","",513,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",513,null],[11,"decode","","",513,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",513,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",513,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",513,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"clone","","",513,{"inputs":[{"name":"anglebracketedparameterdata"}],"output":{"name":"anglebracketedparameterdata"}}],[11,"fmt","","",514,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",514,null],[11,"decode","","",514,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",514,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",514,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",514,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"clone","","",514,{"inputs":[{"name":"parenthesizedparameterdata"}],"output":{"name":"parenthesizedparameterdata"}}],[11,"fmt","","",10,{"inputs":[{"name":"defid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",10,null],[11,"decode","","",10,{"inputs":[{"name":"defid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",10,{"inputs":[{"name":"defid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"option"}}],[11,"lt","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"le","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"gt","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ge","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"cmp","","",10,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"ordering"}}],[11,"clone","","",10,{"inputs":[{"name":"defid"}],"output":{"name":"defid"}}],[11,"local_id","","Read the node id, asserting that this def-id is krate-local.",10,{"inputs":[{"name":"defid"}],"output":{"name":"u32"}}],[11,"fmt","","",515,{"inputs":[{"name":"typarambound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",515,null],[11,"decode","","",515,{"inputs":[{"name":"typarambound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",515,{"inputs":[{"name":"typarambound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",515,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"ne","","",515,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"clone","","",515,{"inputs":[{"name":"typarambound"}],"output":{"name":"typarambound"}}],[11,"fmt","","",516,{"inputs":[{"name":"traitboundmodifier"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",516,null],[11,"decode","","",516,{"inputs":[{"name":"traitboundmodifier"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",516,{"inputs":[{"name":"traitboundmodifier"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",516,{"inputs":[{"name":"traitboundmodifier"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"ne","","",516,{"inputs":[{"name":"traitboundmodifier"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"clone","","",516,{"inputs":[{"name":"traitboundmodifier"}],"output":{"name":"traitboundmodifier"}}],[11,"fmt","","",517,{"inputs":[{"name":"typaram"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",517,null],[11,"decode","","",517,{"inputs":[{"name":"typaram"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",517,{"inputs":[{"name":"typaram"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",517,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"ne","","",517,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"clone","","",517,{"inputs":[{"name":"typaram"}],"output":{"name":"typaram"}}],[11,"fmt","","",498,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",498,null],[11,"decode","","",498,{"inputs":[{"name":"generics"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",498,{"inputs":[{"name":"generics"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",498,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"ne","","",498,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"clone","","",498,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_lt_parameterized","","",498,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"is_type_parameterized","","",498,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"is_parameterized","","",498,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"fmt","","",499,{"inputs":[{"name":"whereclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",499,null],[11,"decode","","",499,{"inputs":[{"name":"whereclause"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",499,{"inputs":[{"name":"whereclause"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",499,{"inputs":[{"name":"whereclause"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"ne","","",499,{"inputs":[{"name":"whereclause"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"clone","","",499,{"inputs":[{"name":"whereclause"}],"output":{"name":"whereclause"}}],[11,"fmt","","",518,{"inputs":[{"name":"wherepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",518,null],[11,"decode","","",518,{"inputs":[{"name":"wherepredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",518,{"inputs":[{"name":"wherepredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",518,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",518,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",518,{"inputs":[{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"fmt","","",519,{"inputs":[{"name":"whereboundpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",519,null],[11,"decode","","",519,{"inputs":[{"name":"whereboundpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",519,{"inputs":[{"name":"whereboundpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",519,{"inputs":[{"name":"whereboundpredicate"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",519,{"inputs":[{"name":"whereboundpredicate"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",519,{"inputs":[{"name":"whereboundpredicate"}],"output":{"name":"whereboundpredicate"}}],[11,"fmt","","",520,{"inputs":[{"name":"whereregionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",520,null],[11,"decode","","",520,{"inputs":[{"name":"whereregionpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",520,{"inputs":[{"name":"whereregionpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",520,{"inputs":[{"name":"whereregionpredicate"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",520,{"inputs":[{"name":"whereregionpredicate"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",520,{"inputs":[{"name":"whereregionpredicate"}],"output":{"name":"whereregionpredicate"}}],[11,"fmt","","",521,{"inputs":[{"name":"whereeqpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",521,null],[11,"decode","","",521,{"inputs":[{"name":"whereeqpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",521,{"inputs":[{"name":"whereeqpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",521,{"inputs":[{"name":"whereeqpredicate"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",521,{"inputs":[{"name":"whereeqpredicate"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",521,{"inputs":[{"name":"whereeqpredicate"}],"output":{"name":"whereeqpredicate"}}],[11,"fmt","","",522,{"inputs":[{"name":"crate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",522,null],[11,"decode","","",522,{"inputs":[{"name":"crate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",522,{"inputs":[{"name":"crate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",522,{"inputs":[{"name":"crate"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"ne","","",522,{"inputs":[{"name":"crate"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"clone","","",522,{"inputs":[{"name":"crate"}],"output":{"name":"crate"}}],[11,"fmt","","",523,{"inputs":[{"name":"metaitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",523,null],[11,"decode","","",523,{"inputs":[{"name":"metaitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",523,{"inputs":[{"name":"metaitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",523,{"inputs":[{"name":"metaitem_"}],"output":{"name":"metaitem_"}}],[11,"eq","","",523,{"inputs":[{"name":"metaitem_"},{"name":"metaitem_"}],"output":{"name":"bool"}}],[11,"fmt","","",496,{"inputs":[{"name":"block"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",496,null],[11,"decode","","",496,{"inputs":[{"name":"block"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",496,{"inputs":[{"name":"block"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",496,{"inputs":[{"name":"block"},{"name":"block"}],"output":{"name":"bool"}}],[11,"ne","","",496,{"inputs":[{"name":"block"},{"name":"block"}],"output":{"name":"bool"}}],[11,"clone","","",496,{"inputs":[{"name":"block"}],"output":{"name":"block"}}],[11,"fmt","","",160,{"inputs":[{"name":"pat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",160,null],[11,"decode","","",160,{"inputs":[{"name":"pat"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",160,{"inputs":[{"name":"pat"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",160,{"inputs":[{"name":"pat"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"ne","","",160,{"inputs":[{"name":"pat"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"clone","","",160,{"inputs":[{"name":"pat"}],"output":{"name":"pat"}}],[11,"fmt","","",524,{"inputs":[{"name":"fieldpat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",524,null],[11,"decode","","",524,{"inputs":[{"name":"fieldpat"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",524,{"inputs":[{"name":"fieldpat"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",524,{"inputs":[{"name":"fieldpat"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"ne","","",524,{"inputs":[{"name":"fieldpat"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"clone","","",524,{"inputs":[{"name":"fieldpat"}],"output":{"name":"fieldpat"}}],[11,"fmt","","",525,{"inputs":[{"name":"bindingmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",525,null],[11,"decode","","",525,{"inputs":[{"name":"bindingmode"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",525,{"inputs":[{"name":"bindingmode"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",525,{"inputs":[{"name":"bindingmode"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"ne","","",525,{"inputs":[{"name":"bindingmode"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"clone","","",525,{"inputs":[{"name":"bindingmode"}],"output":{"name":"bindingmode"}}],[11,"fmt","","",526,{"inputs":[{"name":"patwildkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",526,null],[11,"decode","","",526,{"inputs":[{"name":"patwildkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",526,{"inputs":[{"name":"patwildkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",526,{"inputs":[{"name":"patwildkind"},{"name":"patwildkind"}],"output":{"name":"bool"}}],[11,"ne","","",526,{"inputs":[{"name":"patwildkind"},{"name":"patwildkind"}],"output":{"name":"bool"}}],[11,"clone","","",526,{"inputs":[{"name":"patwildkind"}],"output":{"name":"patwildkind"}}],[11,"fmt","","",527,{"inputs":[{"name":"pat_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",527,null],[11,"decode","","",527,{"inputs":[{"name":"pat_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",527,{"inputs":[{"name":"pat_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",527,{"inputs":[{"name":"pat_"},{"name":"pat_"}],"output":{"name":"bool"}}],[11,"ne","","",527,{"inputs":[{"name":"pat_"},{"name":"pat_"}],"output":{"name":"bool"}}],[11,"clone","","",527,{"inputs":[{"name":"pat_"}],"output":{"name":"pat_"}}],[11,"fmt","","",373,{"inputs":[{"name":"mutability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",373,null],[11,"decode","","",373,{"inputs":[{"name":"mutability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",373,{"inputs":[{"name":"mutability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",373,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"ne","","",373,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"clone","","",373,{"inputs":[{"name":"mutability"}],"output":{"name":"mutability"}}],[11,"fmt","","",528,{"inputs":[{"name":"binop_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",528,null],[11,"decode","","",528,{"inputs":[{"name":"binop_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",528,{"inputs":[{"name":"binop_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",528,{"inputs":[{"name":"binop_"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"ne","","",528,{"inputs":[{"name":"binop_"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"clone","","",528,{"inputs":[{"name":"binop_"}],"output":{"name":"binop_"}}],[11,"fmt","","",529,{"inputs":[{"name":"unop"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",529,null],[11,"decode","","",529,{"inputs":[{"name":"unop"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",529,{"inputs":[{"name":"unop"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",529,{"inputs":[{"name":"unop"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"ne","","",529,{"inputs":[{"name":"unop"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"clone","","",529,{"inputs":[{"name":"unop"}],"output":{"name":"unop"}}],[11,"fmt","","",530,{"inputs":[{"name":"stmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",530,null],[11,"decode","","",530,{"inputs":[{"name":"stmt_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",530,{"inputs":[{"name":"stmt_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",530,{"inputs":[{"name":"stmt_"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"ne","","",530,{"inputs":[{"name":"stmt_"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"clone","","",530,{"inputs":[{"name":"stmt_"}],"output":{"name":"stmt_"}}],[11,"fmt","","",531,{"inputs":[{"name":"macstmtstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",531,null],[11,"decode","","",531,{"inputs":[{"name":"macstmtstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",531,{"inputs":[{"name":"macstmtstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",531,{"inputs":[{"name":"macstmtstyle"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"ne","","",531,{"inputs":[{"name":"macstmtstyle"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"clone","","",531,{"inputs":[{"name":"macstmtstyle"}],"output":{"name":"macstmtstyle"}}],[11,"fmt","","",532,{"inputs":[{"name":"localsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",532,null],[11,"decode","","",532,{"inputs":[{"name":"localsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",532,{"inputs":[{"name":"localsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",532,{"inputs":[{"name":"localsource"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"ne","","",532,{"inputs":[{"name":"localsource"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"clone","","",532,{"inputs":[{"name":"localsource"}],"output":{"name":"localsource"}}],[11,"fmt","","",533,{"inputs":[{"name":"local"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",533,null],[11,"decode","","",533,{"inputs":[{"name":"local"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",533,{"inputs":[{"name":"local"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",533,{"inputs":[{"name":"local"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ne","","",533,{"inputs":[{"name":"local"},{"name":"local"}],"output":{"name":"bool"}}],[11,"clone","","",533,{"inputs":[{"name":"local"}],"output":{"name":"local"}}],[11,"fmt","","",534,{"inputs":[{"name":"decl_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",534,null],[11,"decode","","",534,{"inputs":[{"name":"decl_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",534,{"inputs":[{"name":"decl_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",534,{"inputs":[{"name":"decl_"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"ne","","",534,{"inputs":[{"name":"decl_"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"clone","","",534,{"inputs":[{"name":"decl_"}],"output":{"name":"decl_"}}],[11,"fmt","","",500,{"inputs":[{"name":"arm"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",500,null],[11,"decode","","",500,{"inputs":[{"name":"arm"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",500,{"inputs":[{"name":"arm"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",500,{"inputs":[{"name":"arm"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"ne","","",500,{"inputs":[{"name":"arm"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"clone","","",500,{"inputs":[{"name":"arm"}],"output":{"name":"arm"}}],[11,"fmt","","",535,{"inputs":[{"name":"field"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",535,null],[11,"decode","","",535,{"inputs":[{"name":"field"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",535,{"inputs":[{"name":"field"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",535,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",535,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",535,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",536,{"inputs":[{"name":"blockcheckmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",536,null],[11,"decode","","",536,{"inputs":[{"name":"blockcheckmode"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",536,{"inputs":[{"name":"blockcheckmode"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",536,{"inputs":[{"name":"blockcheckmode"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"ne","","",536,{"inputs":[{"name":"blockcheckmode"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"clone","","",536,{"inputs":[{"name":"blockcheckmode"}],"output":{"name":"blockcheckmode"}}],[11,"fmt","","",537,{"inputs":[{"name":"unsafesource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",537,null],[11,"decode","","",537,{"inputs":[{"name":"unsafesource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",537,{"inputs":[{"name":"unsafesource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",537,{"inputs":[{"name":"unsafesource"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"ne","","",537,{"inputs":[{"name":"unsafesource"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"clone","","",537,{"inputs":[{"name":"unsafesource"}],"output":{"name":"unsafesource"}}],[11,"fmt","","",159,{"inputs":[{"name":"expr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",159,null],[11,"decode","","",159,{"inputs":[{"name":"expr"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",159,{"inputs":[{"name":"expr"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",159,{"inputs":[{"name":"expr"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"ne","","",159,{"inputs":[{"name":"expr"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"clone","","",159,{"inputs":[{"name":"expr"}],"output":{"name":"expr"}}],[11,"fmt","","",538,{"inputs":[{"name":"expr_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",538,null],[11,"decode","","",538,{"inputs":[{"name":"expr_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",538,{"inputs":[{"name":"expr_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",538,{"inputs":[{"name":"expr_"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"ne","","",538,{"inputs":[{"name":"expr_"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"clone","","",538,{"inputs":[{"name":"expr_"}],"output":{"name":"expr_"}}],[11,"fmt","","",539,{"inputs":[{"name":"qself"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",539,null],[11,"decode","","",539,{"inputs":[{"name":"qself"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",539,{"inputs":[{"name":"qself"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",539,{"inputs":[{"name":"qself"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"ne","","",539,{"inputs":[{"name":"qself"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"clone","","",539,{"inputs":[{"name":"qself"}],"output":{"name":"qself"}}],[11,"fmt","","",540,{"inputs":[{"name":"matchsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",540,null],[11,"decode","","",540,{"inputs":[{"name":"matchsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",540,{"inputs":[{"name":"matchsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",540,{"inputs":[{"name":"matchsource"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"ne","","",540,{"inputs":[{"name":"matchsource"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"clone","","",540,{"inputs":[{"name":"matchsource"}],"output":{"name":"matchsource"}}],[11,"fmt","","",541,{"inputs":[{"name":"captureclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",541,null],[11,"decode","","",541,{"inputs":[{"name":"captureclause"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",541,{"inputs":[{"name":"captureclause"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",541,{"inputs":[{"name":"captureclause"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"ne","","",541,{"inputs":[{"name":"captureclause"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"clone","","",541,{"inputs":[{"name":"captureclause"}],"output":{"name":"captureclause"}}],[11,"fmt","","",542,{"inputs":[{"name":"delimited"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",542,null],[11,"decode","","",542,{"inputs":[{"name":"delimited"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",542,{"inputs":[{"name":"delimited"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",542,{"inputs":[{"name":"delimited"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"ne","","",542,{"inputs":[{"name":"delimited"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"clone","","",542,{"inputs":[{"name":"delimited"}],"output":{"name":"delimited"}}],[11,"open_token","","Returns the opening delimiter as a token.",542,{"inputs":[{"name":"delimited"}],"output":{"name":"token"}}],[11,"close_token","","Returns the closing delimiter as a token.",542,{"inputs":[{"name":"delimited"}],"output":{"name":"token"}}],[11,"open_tt","","Returns the opening delimiter as a token tree.",542,{"inputs":[{"name":"delimited"}],"output":{"name":"tokentree"}}],[11,"close_tt","","Returns the closing delimiter as a token tree.",542,{"inputs":[{"name":"delimited"}],"output":{"name":"tokentree"}}],[11,"fmt","","",543,{"inputs":[{"name":"sequencerepetition"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",543,null],[11,"decode","","",543,{"inputs":[{"name":"sequencerepetition"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",543,{"inputs":[{"name":"sequencerepetition"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",543,{"inputs":[{"name":"sequencerepetition"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"ne","","",543,{"inputs":[{"name":"sequencerepetition"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"clone","","",543,{"inputs":[{"name":"sequencerepetition"}],"output":{"name":"sequencerepetition"}}],[11,"fmt","","",544,{"inputs":[{"name":"kleeneop"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",544,null],[11,"decode","","",544,{"inputs":[{"name":"kleeneop"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",544,{"inputs":[{"name":"kleeneop"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",544,{"inputs":[{"name":"kleeneop"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"ne","","",544,{"inputs":[{"name":"kleeneop"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"clone","","",544,{"inputs":[{"name":"kleeneop"}],"output":{"name":"kleeneop"}}],[11,"fmt","","",495,{"inputs":[{"name":"tokentree"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",495,null],[11,"decode","","",495,{"inputs":[{"name":"tokentree"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",495,{"inputs":[{"name":"tokentree"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",495,{"inputs":[{"name":"tokentree"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"ne","","",495,{"inputs":[{"name":"tokentree"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"clone","","",495,{"inputs":[{"name":"tokentree"}],"output":{"name":"tokentree"}}],[11,"len","","",495,{"inputs":[{"name":"tokentree"}],"output":{"name":"usize"}}],[11,"get_tt","","",495,{"inputs":[{"name":"tokentree"},{"name":"usize"}],"output":{"name":"tokentree"}}],[11,"get_span","","Returns the `Span` corresponding to this token tree.",495,{"inputs":[{"name":"tokentree"}],"output":{"name":"span"}}],[11,"parse","","Use this token tree as a matcher to parse given tts.",495,null],[11,"fmt","","",545,{"inputs":[{"name":"mac_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",545,null],[11,"decode","","",545,{"inputs":[{"name":"mac_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",545,{"inputs":[{"name":"mac_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",545,{"inputs":[{"name":"mac_"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"ne","","",545,{"inputs":[{"name":"mac_"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"clone","","",545,{"inputs":[{"name":"mac_"}],"output":{"name":"mac_"}}],[11,"fmt","","",546,{"inputs":[{"name":"strstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",546,null],[11,"decode","","",546,{"inputs":[{"name":"strstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",546,{"inputs":[{"name":"strstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",546,{"inputs":[{"name":"strstyle"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"ne","","",546,{"inputs":[{"name":"strstyle"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"clone","","",546,{"inputs":[{"name":"strstyle"}],"output":{"name":"strstyle"}}],[11,"fmt","","",547,{"inputs":[{"name":"sign"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",547,null],[11,"decode","","",547,{"inputs":[{"name":"sign"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",547,{"inputs":[{"name":"sign"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",547,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"ne","","",547,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"clone","","",547,{"inputs":[{"name":"sign"}],"output":{"name":"sign"}}],[11,"new","","",547,{"inputs":[{"name":"sign"},{"name":"t"}],"output":{"name":"sign"}}],[11,"fmt","","",548,{"inputs":[{"name":"litinttype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",548,null],[11,"decode","","",548,{"inputs":[{"name":"litinttype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",548,{"inputs":[{"name":"litinttype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",548,{"inputs":[{"name":"litinttype"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"ne","","",548,{"inputs":[{"name":"litinttype"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"clone","","",548,{"inputs":[{"name":"litinttype"}],"output":{"name":"litinttype"}}],[11,"suffix_len","","",548,{"inputs":[{"name":"litinttype"}],"output":{"name":"usize"}}],[11,"fmt","","",549,{"inputs":[{"name":"lit_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",549,null],[11,"decode","","",549,{"inputs":[{"name":"lit_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",549,{"inputs":[{"name":"lit_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",549,{"inputs":[{"name":"lit_"},{"name":"lit_"}],"output":{"name":"bool"}}],[11,"ne","","",549,{"inputs":[{"name":"lit_"},{"name":"lit_"}],"output":{"name":"bool"}}],[11,"clone","","",549,{"inputs":[{"name":"lit_"}],"output":{"name":"lit_"}}],[11,"fmt","","",550,{"inputs":[{"name":"mutty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",550,null],[11,"decode","","",550,{"inputs":[{"name":"mutty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",550,{"inputs":[{"name":"mutty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",550,{"inputs":[{"name":"mutty"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"ne","","",550,{"inputs":[{"name":"mutty"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"clone","","",550,{"inputs":[{"name":"mutty"}],"output":{"name":"mutty"}}],[11,"fmt","","",551,{"inputs":[{"name":"typefield"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",551,null],[11,"decode","","",551,{"inputs":[{"name":"typefield"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",551,{"inputs":[{"name":"typefield"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",551,{"inputs":[{"name":"typefield"},{"name":"typefield"}],"output":{"name":"bool"}}],[11,"ne","","",551,{"inputs":[{"name":"typefield"},{"name":"typefield"}],"output":{"name":"bool"}}],[11,"clone","","",551,{"inputs":[{"name":"typefield"}],"output":{"name":"typefield"}}],[11,"fmt","","",552,{"inputs":[{"name":"methodsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",552,null],[11,"decode","","",552,{"inputs":[{"name":"methodsig"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",552,{"inputs":[{"name":"methodsig"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",552,{"inputs":[{"name":"methodsig"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"ne","","",552,{"inputs":[{"name":"methodsig"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"clone","","",552,{"inputs":[{"name":"methodsig"}],"output":{"name":"methodsig"}}],[11,"fmt","","",365,{"inputs":[{"name":"traititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",365,null],[11,"decode","","",365,{"inputs":[{"name":"traititem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",365,{"inputs":[{"name":"traititem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",365,{"inputs":[{"name":"traititem"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"ne","","",365,{"inputs":[{"name":"traititem"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"clone","","",365,{"inputs":[{"name":"traititem"}],"output":{"name":"traititem"}}],[11,"fmt","","",553,{"inputs":[{"name":"traititem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",553,null],[11,"decode","","",553,{"inputs":[{"name":"traititem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",553,{"inputs":[{"name":"traititem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",553,{"inputs":[{"name":"traititem_"},{"name":"traititem_"}],"output":{"name":"bool"}}],[11,"ne","","",553,{"inputs":[{"name":"traititem_"},{"name":"traititem_"}],"output":{"name":"bool"}}],[11,"clone","","",553,{"inputs":[{"name":"traititem_"}],"output":{"name":"traititem_"}}],[11,"fmt","","",554,{"inputs":[{"name":"implitem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",554,null],[11,"decode","","",554,{"inputs":[{"name":"implitem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",554,{"inputs":[{"name":"implitem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",554,{"inputs":[{"name":"implitem"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"ne","","",554,{"inputs":[{"name":"implitem"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"clone","","",554,{"inputs":[{"name":"implitem"}],"output":{"name":"implitem"}}],[11,"fmt","","",555,{"inputs":[{"name":"implitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",555,null],[11,"decode","","",555,{"inputs":[{"name":"implitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",555,{"inputs":[{"name":"implitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",555,{"inputs":[{"name":"implitem_"},{"name":"implitem_"}],"output":{"name":"bool"}}],[11,"ne","","",555,{"inputs":[{"name":"implitem_"},{"name":"implitem_"}],"output":{"name":"bool"}}],[11,"clone","","",555,{"inputs":[{"name":"implitem_"}],"output":{"name":"implitem_"}}],[11,"hash","","",374,null],[11,"decode","","",374,{"inputs":[{"name":"intty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",374,{"inputs":[{"name":"intty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",374,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",374,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",374,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",374,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",374,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"suffix_len","","",374,{"inputs":[{"name":"intty"}],"output":{"name":"usize"}}],[11,"hash","","",375,null],[11,"decode","","",375,{"inputs":[{"name":"uintty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",375,{"inputs":[{"name":"uintty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",375,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",375,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",375,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"suffix_len","","",375,{"inputs":[{"name":"uintty"}],"output":{"name":"usize"}}],[11,"fmt","","",375,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",375,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",127,null],[11,"decode","","",127,{"inputs":[{"name":"floatty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",127,{"inputs":[{"name":"floatty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",127,{"inputs":[{"name":"floatty"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"floatty"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"floatty"}],"output":{"name":"floatty"}}],[11,"fmt","","",127,{"inputs":[{"name":"floatty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",127,{"inputs":[{"name":"floatty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"suffix_len","","",127,{"inputs":[{"name":"floatty"}],"output":{"name":"usize"}}],[11,"fmt","","",556,{"inputs":[{"name":"typebinding"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",556,null],[11,"decode","","",556,{"inputs":[{"name":"typebinding"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",556,{"inputs":[{"name":"typebinding"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",556,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"ne","","",556,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"clone","","",556,{"inputs":[{"name":"typebinding"}],"output":{"name":"typebinding"}}],[11,"fmt","","",367,{"inputs":[{"name":"ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",367,null],[11,"decode","","",367,{"inputs":[{"name":"ty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",367,{"inputs":[{"name":"ty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",367,{"inputs":[{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ne","","",367,{"inputs":[{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"clone","","",367,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[11,"fmt","","",557,{"inputs":[{"name":"primty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",557,null],[11,"decode","","",557,{"inputs":[{"name":"primty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",557,{"inputs":[{"name":"primty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",557,{"inputs":[{"name":"primty"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"ne","","",557,{"inputs":[{"name":"primty"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"clone","","",557,{"inputs":[{"name":"primty"}],"output":{"name":"primty"}}],[11,"fmt","","",558,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",558,null],[11,"decode","","",558,{"inputs":[{"name":"barefnty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",558,{"inputs":[{"name":"barefnty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",558,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",558,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",558,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",559,{"inputs":[{"name":"ty_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",559,null],[11,"decode","","",559,{"inputs":[{"name":"ty_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",559,{"inputs":[{"name":"ty_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",559,{"inputs":[{"name":"ty_"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"ne","","",559,{"inputs":[{"name":"ty_"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"clone","","",559,{"inputs":[{"name":"ty_"}],"output":{"name":"ty_"}}],[11,"fmt","","",560,{"inputs":[{"name":"asmdialect"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",560,null],[11,"decode","","",560,{"inputs":[{"name":"asmdialect"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",560,{"inputs":[{"name":"asmdialect"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",560,{"inputs":[{"name":"asmdialect"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"ne","","",560,{"inputs":[{"name":"asmdialect"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"clone","","",560,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"fmt","","",561,{"inputs":[{"name":"inlineasm"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",561,null],[11,"decode","","",561,{"inputs":[{"name":"inlineasm"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",561,{"inputs":[{"name":"inlineasm"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",561,{"inputs":[{"name":"inlineasm"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"ne","","",561,{"inputs":[{"name":"inlineasm"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"clone","","",561,{"inputs":[{"name":"inlineasm"}],"output":{"name":"inlineasm"}}],[11,"fmt","","",497,{"inputs":[{"name":"arg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",497,null],[11,"decode","","",497,{"inputs":[{"name":"arg"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",497,{"inputs":[{"name":"arg"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",497,{"inputs":[{"name":"arg"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"ne","","",497,{"inputs":[{"name":"arg"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"clone","","",497,{"inputs":[{"name":"arg"}],"output":{"name":"arg"}}],[11,"new_self","","",497,{"inputs":[{"name":"arg"},{"name":"span"},{"name":"mutability"},{"name":"ident"}],"output":{"name":"arg"}}],[11,"fmt","","",562,{"inputs":[{"name":"fndecl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",562,null],[11,"decode","","",562,{"inputs":[{"name":"fndecl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",562,{"inputs":[{"name":"fndecl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",562,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"ne","","",562,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"clone","","",562,{"inputs":[{"name":"fndecl"}],"output":{"name":"fndecl"}}],[11,"fmt","","",297,{"inputs":[{"name":"unsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",297,null],[11,"decode","","",297,{"inputs":[{"name":"unsafety"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",297,{"inputs":[{"name":"unsafety"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",297,{"inputs":[{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"ne","","",297,{"inputs":[{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"clone","","",297,{"inputs":[{"name":"unsafety"}],"output":{"name":"unsafety"}}],[11,"fmt","","",297,{"inputs":[{"name":"unsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",563,null],[11,"decode","","",563,{"inputs":[{"name":"implpolarity"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",563,{"inputs":[{"name":"implpolarity"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",563,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"ne","","",563,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"clone","","",563,{"inputs":[{"name":"implpolarity"}],"output":{"name":"implpolarity"}}],[11,"fmt","","",563,{"inputs":[{"name":"implpolarity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",564,{"inputs":[{"name":"functionretty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",564,null],[11,"decode","","",564,{"inputs":[{"name":"functionretty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",564,{"inputs":[{"name":"functionretty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",564,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"ne","","",564,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"clone","","",564,{"inputs":[{"name":"functionretty"}],"output":{"name":"functionretty"}}],[11,"span","","",564,{"inputs":[{"name":"functionretty"}],"output":{"name":"span"}}],[11,"fmt","","",371,{"inputs":[{"name":"explicitself_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",371,null],[11,"decode","","",371,{"inputs":[{"name":"explicitself_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",371,{"inputs":[{"name":"explicitself_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",371,{"inputs":[{"name":"explicitself_"},{"name":"explicitself_"}],"output":{"name":"bool"}}],[11,"ne","","",371,{"inputs":[{"name":"explicitself_"},{"name":"explicitself_"}],"output":{"name":"bool"}}],[11,"clone","","",371,{"inputs":[{"name":"explicitself_"}],"output":{"name":"explicitself_"}}],[11,"fmt","","",565,{"inputs":[{"name":"mod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",565,null],[11,"decode","","",565,{"inputs":[{"name":"mod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",565,{"inputs":[{"name":"mod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",565,{"inputs":[{"name":"mod"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"ne","","",565,{"inputs":[{"name":"mod"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"clone","","",565,{"inputs":[{"name":"mod"}],"output":{"name":"mod"}}],[11,"fmt","","",566,{"inputs":[{"name":"foreignmod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",566,null],[11,"decode","","",566,{"inputs":[{"name":"foreignmod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",566,{"inputs":[{"name":"foreignmod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",566,{"inputs":[{"name":"foreignmod"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"ne","","",566,{"inputs":[{"name":"foreignmod"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"clone","","",566,{"inputs":[{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fmt","","",567,{"inputs":[{"name":"variantarg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",567,null],[11,"decode","","",567,{"inputs":[{"name":"variantarg"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",567,{"inputs":[{"name":"variantarg"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",567,{"inputs":[{"name":"variantarg"},{"name":"variantarg"}],"output":{"name":"bool"}}],[11,"ne","","",567,{"inputs":[{"name":"variantarg"},{"name":"variantarg"}],"output":{"name":"bool"}}],[11,"clone","","",567,{"inputs":[{"name":"variantarg"}],"output":{"name":"variantarg"}}],[11,"fmt","","",568,{"inputs":[{"name":"variantkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",568,null],[11,"decode","","",568,{"inputs":[{"name":"variantkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",568,{"inputs":[{"name":"variantkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",568,{"inputs":[{"name":"variantkind"},{"name":"variantkind"}],"output":{"name":"bool"}}],[11,"ne","","",568,{"inputs":[{"name":"variantkind"},{"name":"variantkind"}],"output":{"name":"bool"}}],[11,"clone","","",568,{"inputs":[{"name":"variantkind"}],"output":{"name":"variantkind"}}],[11,"fmt","","",569,{"inputs":[{"name":"enumdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",569,null],[11,"decode","","",569,{"inputs":[{"name":"enumdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",569,{"inputs":[{"name":"enumdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",569,{"inputs":[{"name":"enumdef"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"ne","","",569,{"inputs":[{"name":"enumdef"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"clone","","",569,{"inputs":[{"name":"enumdef"}],"output":{"name":"enumdef"}}],[11,"fmt","","",570,{"inputs":[{"name":"variant_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",570,null],[11,"decode","","",570,{"inputs":[{"name":"variant_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",570,{"inputs":[{"name":"variant_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",570,{"inputs":[{"name":"variant_"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"ne","","",570,{"inputs":[{"name":"variant_"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"clone","","",570,{"inputs":[{"name":"variant_"}],"output":{"name":"variant_"}}],[11,"fmt","","",571,{"inputs":[{"name":"pathlistitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",571,null],[11,"decode","","",571,{"inputs":[{"name":"pathlistitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",571,{"inputs":[{"name":"pathlistitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",571,{"inputs":[{"name":"pathlistitem_"},{"name":"pathlistitem_"}],"output":{"name":"bool"}}],[11,"ne","","",571,{"inputs":[{"name":"pathlistitem_"},{"name":"pathlistitem_"}],"output":{"name":"bool"}}],[11,"clone","","",571,{"inputs":[{"name":"pathlistitem_"}],"output":{"name":"pathlistitem_"}}],[11,"id","","",571,{"inputs":[{"name":"pathlistitem_"}],"output":{"name":"u32"}}],[11,"fmt","","",572,{"inputs":[{"name":"viewpath_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",572,null],[11,"decode","","",572,{"inputs":[{"name":"viewpath_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",572,{"inputs":[{"name":"viewpath_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",572,{"inputs":[{"name":"viewpath_"},{"name":"viewpath_"}],"output":{"name":"bool"}}],[11,"ne","","",572,{"inputs":[{"name":"viewpath_"},{"name":"viewpath_"}],"output":{"name":"bool"}}],[11,"clone","","",572,{"inputs":[{"name":"viewpath_"}],"output":{"name":"viewpath_"}}],[11,"fmt","","",573,{"inputs":[{"name":"attrstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",573,null],[11,"decode","","",573,{"inputs":[{"name":"attrstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",573,{"inputs":[{"name":"attrstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",573,{"inputs":[{"name":"attrstyle"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"ne","","",573,{"inputs":[{"name":"attrstyle"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"clone","","",573,{"inputs":[{"name":"attrstyle"}],"output":{"name":"attrstyle"}}],[11,"fmt","","",574,{"inputs":[{"name":"attrid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",574,null],[11,"decode","","",574,{"inputs":[{"name":"attrid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",574,{"inputs":[{"name":"attrid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",574,{"inputs":[{"name":"attrid"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"ne","","",574,{"inputs":[{"name":"attrid"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"clone","","",574,{"inputs":[{"name":"attrid"}],"output":{"name":"attrid"}}],[11,"fmt","","",501,{"inputs":[{"name":"attribute_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",501,null],[11,"decode","","",501,{"inputs":[{"name":"attribute_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",501,{"inputs":[{"name":"attribute_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",501,{"inputs":[{"name":"attribute_"},{"name":"attribute_"}],"output":{"name":"bool"}}],[11,"ne","","",501,{"inputs":[{"name":"attribute_"},{"name":"attribute_"}],"output":{"name":"bool"}}],[11,"clone","","",501,{"inputs":[{"name":"attribute_"}],"output":{"name":"attribute_"}}],[11,"fmt","","",575,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",575,null],[11,"decode","","",575,{"inputs":[{"name":"traitref"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",575,{"inputs":[{"name":"traitref"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",575,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",575,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",575,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fmt","","",576,{"inputs":[{"name":"polytraitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",576,null],[11,"decode","","",576,{"inputs":[{"name":"polytraitref"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",576,{"inputs":[{"name":"polytraitref"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",576,{"inputs":[{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"ne","","",576,{"inputs":[{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"clone","","",576,{"inputs":[{"name":"polytraitref"}],"output":{"name":"polytraitref"}}],[11,"fmt","","",372,{"inputs":[{"name":"visibility"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",372,null],[11,"decode","","",372,{"inputs":[{"name":"visibility"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",372,{"inputs":[{"name":"visibility"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",372,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"ne","","",372,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"clone","","",372,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"inherit_from","","",372,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"fmt","","",577,{"inputs":[{"name":"structfield_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",577,null],[11,"decode","","",577,{"inputs":[{"name":"structfield_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",577,{"inputs":[{"name":"structfield_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",577,{"inputs":[{"name":"structfield_"},{"name":"structfield_"}],"output":{"name":"bool"}}],[11,"ne","","",577,{"inputs":[{"name":"structfield_"},{"name":"structfield_"}],"output":{"name":"bool"}}],[11,"clone","","",577,{"inputs":[{"name":"structfield_"}],"output":{"name":"structfield_"}}],[11,"ident","","",577,{"inputs":[{"name":"structfield_"}],"output":{"name":"option"}}],[11,"fmt","","",578,{"inputs":[{"name":"structfieldkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",578,null],[11,"decode","","",578,{"inputs":[{"name":"structfieldkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",578,{"inputs":[{"name":"structfieldkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",578,{"inputs":[{"name":"structfieldkind"},{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"ne","","",578,{"inputs":[{"name":"structfieldkind"},{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"clone","","",578,{"inputs":[{"name":"structfieldkind"}],"output":{"name":"structfieldkind"}}],[11,"is_unnamed","","",578,{"inputs":[{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"fmt","","",579,{"inputs":[{"name":"structdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",579,null],[11,"decode","","",579,{"inputs":[{"name":"structdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",579,{"inputs":[{"name":"structdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",579,{"inputs":[{"name":"structdef"},{"name":"structdef"}],"output":{"name":"bool"}}],[11,"ne","","",579,{"inputs":[{"name":"structdef"},{"name":"structdef"}],"output":{"name":"bool"}}],[11,"clone","","",579,{"inputs":[{"name":"structdef"}],"output":{"name":"structdef"}}],[11,"fmt","","",368,{"inputs":[{"name":"item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",368,null],[11,"decode","","",368,{"inputs":[{"name":"item"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",368,{"inputs":[{"name":"item"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",368,{"inputs":[{"name":"item"},{"name":"item"}],"output":{"name":"bool"}}],[11,"ne","","",368,{"inputs":[{"name":"item"},{"name":"item"}],"output":{"name":"bool"}}],[11,"clone","","",368,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"fmt","","",580,{"inputs":[{"name":"item_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",580,null],[11,"decode","","",580,{"inputs":[{"name":"item_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",580,{"inputs":[{"name":"item_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",580,{"inputs":[{"name":"item_"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"ne","","",580,{"inputs":[{"name":"item_"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"clone","","",580,{"inputs":[{"name":"item_"}],"output":{"name":"item_"}}],[11,"descriptive_variant","","",580,{"inputs":[{"name":"item_"}],"output":{"name":"str"}}],[11,"fmt","","",581,{"inputs":[{"name":"foreignitem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",581,null],[11,"decode","","",581,{"inputs":[{"name":"foreignitem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",581,{"inputs":[{"name":"foreignitem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",581,{"inputs":[{"name":"foreignitem"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"ne","","",581,{"inputs":[{"name":"foreignitem"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"clone","","",581,{"inputs":[{"name":"foreignitem"}],"output":{"name":"foreignitem"}}],[11,"fmt","","",582,{"inputs":[{"name":"foreignitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",582,null],[11,"decode","","",582,{"inputs":[{"name":"foreignitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",582,{"inputs":[{"name":"foreignitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",582,{"inputs":[{"name":"foreignitem_"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"ne","","",582,{"inputs":[{"name":"foreignitem_"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"clone","","",582,{"inputs":[{"name":"foreignitem_"}],"output":{"name":"foreignitem_"}}],[11,"descriptive_variant","","",582,{"inputs":[{"name":"foreignitem_"}],"output":{"name":"str"}}],[11,"fmt","","",583,{"inputs":[{"name":"inlineditem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",583,null],[11,"decode","","",583,{"inputs":[{"name":"inlineditem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",583,{"inputs":[{"name":"inlineditem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",583,{"inputs":[{"name":"inlineditem"},{"name":"inlineditem"}],"output":{"name":"bool"}}],[11,"ne","","",583,{"inputs":[{"name":"inlineditem"},{"name":"inlineditem"}],"output":{"name":"bool"}}],[11,"clone","","",583,{"inputs":[{"name":"inlineditem"}],"output":{"name":"inlineditem"}}],[11,"fmt","","",584,{"inputs":[{"name":"macrodef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",584,null],[11,"decode","","",584,{"inputs":[{"name":"macrodef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",584,{"inputs":[{"name":"macrodef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",584,{"inputs":[{"name":"macrodef"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"ne","","",584,{"inputs":[{"name":"macrodef"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"clone","","",584,{"inputs":[{"name":"macrodef"}],"output":{"name":"macrodef"}}],[11,"hash","syntax::parse::parser","",585,null],[11,"cmp","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"option"}}],[11,"lt","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"le","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"gt","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ge","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"clone","","",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"eq","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ne","","",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"all","","Returns the set containing all flags.",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bits","","Returns the raw value of the flags currently stored.",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",585,{"inputs":[{"name":"restrictions"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",585,{"inputs":[{"name":"restrictions"},{"name":"u8"}],"output":{"name":"restrictions"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",585,null],[11,"remove","","Removes the specified flags in-place.",585,null],[11,"toggle","","Toggles the specified flags in-place.",585,null],[11,"bitor","","Returns the union of the two sets of flags.",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bitand","","Returns the intersection between the two sets of flags.",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"sub","","Returns the set difference of the two sets of flags.",585,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"not","","Returns the complement of this set of flags.",585,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"eq","","",586,{"inputs":[{"name":"pathparsingmode"},{"name":"pathparsingmode"}],"output":{"name":"bool"}}],[11,"ne","","",586,{"inputs":[{"name":"pathparsingmode"},{"name":"pathparsingmode"}],"output":{"name":"bool"}}],[11,"clone","","",586,{"inputs":[{"name":"pathparsingmode"}],"output":{"name":"pathparsingmode"}}],[11,"eq","","",587,{"inputs":[{"name":"boundparsingmode"},{"name":"boundparsingmode"}],"output":{"name":"bool"}}],[11,"ne","","",587,{"inputs":[{"name":"boundparsingmode"},{"name":"boundparsingmode"}],"output":{"name":"bool"}}],[11,"clone","","",587,{"inputs":[{"name":"boundparsingmode"}],"output":{"name":"boundparsingmode"}}],[11,"clone","","",588,{"inputs":[{"name":"tokentype"}],"output":{"name":"tokentype"}}],[11,"eq","","",588,{"inputs":[{"name":"tokentype"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"ne","","",588,{"inputs":[{"name":"tokentype"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"new","","",589,{"inputs":[{"name":"parser"},{"name":"parsesess"},{"name":"vec"},{"name":"box"}],"output":{"name":"parser"}}],[11,"parse_expr","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_item","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"parse_pat","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_arm","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"arm"}}],[11,"parse_ty","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_stmt","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"token_to_string","","Convert a token to a string using self's reader",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"string"}}],[11,"this_token_to_string","","Convert the current token to a string using self's reader",589,{"inputs":[{"name":"parser"}],"output":{"name":"string"}}],[11,"unexpected_last","","",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"fatalerror"}}],[11,"unexpected","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"fatalerror"}}],[11,"expect","","Expect and consume the token t. Signal an error if\nthe next token is not t.",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"expect_one_of","","Expect next token to be edible or inedible token.  If edible,\nthen consume it; if inedible, then return without consuming\nanything.  Signal a fatal error if next token is unexpected.",589,null],[11,"check_for_erroneous_unit_struct_expecting","","Check for erroneous `ident { }`; if matches, signal error and\nrecover (without consuming any expected input token).  Returns\ntrue if and only if input was consumed for recovery.",589,null],[11,"commit_expr","","Commit to parsing a complete expression `e` expected to be\nfollowed by some token from the set edible + inedible.  Recover\nfrom anticipated input errors, discarding erroneous characters.",589,null],[11,"commit_expr_expecting","","",589,{"inputs":[{"name":"parser"},{"name":"expr"},{"name":"token"}],"output":{"name":"result"}}],[11,"commit_stmt","","Commit to parsing a complete statement `s`, which expects to be\nfollowed by some token from the set edible + inedible.  Check\nfor recoverable input errors, discarding erroneous characters.",589,null],[11,"commit_stmt_expecting","","",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"parse_ident","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ident_or_self_type","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path_list_item","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"check","","Check if the next token is `tok`, and return `true` if so.",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"bool"}}],[11,"eat","","Consume token 'tok' if it exists. Returns true if the given\ntoken was present, false otherwise.",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"check_keyword","","",589,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"eat_keyword","","If the next token is the given keyword, eat it and return\ntrue. Otherwise, return false.",589,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"result"}}],[11,"eat_keyword_noexpect","","",589,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"result"}}],[11,"expect_keyword","","If the given word is not a keyword, signal an error.\nIf the next token is not the given word, signal an error.\nOtherwise, eat it.",589,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"result"}}],[11,"check_strict_keywords","","Signal an error if the given string is a strict keyword",589,null],[11,"check_reserved_keywords","","Signal an error if the current token is a reserved keyword",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"expect_no_suffix","","",589,null],[11,"expect_gt","","Expect and consume a GT. if a >> is seen, replace it\nwith a single > and continue. If a GT is not seen,\nsignal an error.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_seq_to_before_gt_or_return","","",589,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_before_gt","","Parse a sequence bracketed by '<' and '>', stopping\nbefore the '>'.",589,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_gt","","",589,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_gt_or_return","","",589,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_end","","Parse a sequence, including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",589,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_before_end","","Parse a sequence, not including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",589,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_unspanned_seq","","Parse a sequence, including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",589,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_enum_variant_seq","","Parse a sequence parameter of enum variant. For consistency purposes,\nthese should not be empty.",589,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq","","",589,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"bump","","Advance the parser by one token",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"bump_and_get","","Advance the parser by one token and return the bumped token.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"replace_token","","EFFECT: replace the current token and span with the given one",589,null],[11,"buffer_length","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"isize"}}],[11,"look_ahead","","",589,{"inputs":[{"name":"parser"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[11,"fatal","","",589,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal","","",589,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_help","","",589,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_note","","",589,null],[11,"span_help","","",589,null],[11,"fileline_help","","",589,null],[11,"bug","","",589,null],[11,"warn","","",589,null],[11,"span_warn","","",589,null],[11,"span_err","","",589,null],[11,"span_bug","","",589,null],[11,"abort_if_errors","","",589,null],[11,"id_to_interned_str","","",589,{"inputs":[{"name":"parser"},{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"token_is_bare_fn_keyword","","Is the current token one of the keywords that signals a bare function\ntype?",589,{"inputs":[{"name":"parser"}],"output":{"name":"bool"}}],[11,"get_lifetime","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"ident"}}],[11,"parse_for_in_type","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_path","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_bare_fn","","parse a TyBareFn type:",589,{"inputs":[{"name":"parser"},{"name":"vec"}],"output":{"name":"result"}}],[11,"parse_obsolete_closure_kind","","Parses an obsolete closure kind (`&:`, `&mut:`, or `:`).",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_unsafety","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_trait_items","","Parse the items in a trait declaration",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_mt","","Parse a possibly mutable type",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ret_ty","","Parse optional return type [ -> TY ] in function decl",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_sum","","Parse a type in a context where `T1+T2` is allowed.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_nopanic","","Parse a type.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_borrowed_pointee","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ptr","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"is_named_argument","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"bool"}}],[11,"parse_arg_general","","This version of parse arg doesn't necessarily require\nidentifier names.",589,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"result"}}],[11,"parse_arg","","Parse a single function argument",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_fn_block_arg","","Parse an argument in a lambda header e.g. |arg, arg|",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"maybe_parse_fixed_length_of_vec","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"lit_from_token","","Matches token_lit = LIT_INTEGER | ...",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"parse_lit","","Matches lit = true | false | token_lit",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_literal_maybe_minus","","matches '-' lit | lit",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path","","Parses a path and optional type parameter bounds, depending on the\nmode. The `mode` parameter determines whether lifetimes, types, and/or\nbounds are permitted and whether `::` must precede type parameter\ngroups.",589,{"inputs":[{"name":"parser"},{"name":"pathparsingmode"}],"output":{"name":"result"}}],[11,"parse_path_segments_without_colons","","Examples:\n- `a::b<T,U>::c<V,W>`\n- `a::b<T,U>::c(V) -> W`\n- `a::b<T,U>::c(V)`",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path_segments_with_colons","","Examples:\n- `a::b::<T,U>::c`",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path_segments_without_types","","Examples:\n- `a::b::c`",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_opt_lifetime","","parses 0 or 1 lifetime",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lifetime","","Parses a single lifetime\nMatches lifetime = LIFETIME",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lifetime_defs","","Parses `lifetime_defs = [ lifetime_defs { ',' lifetime_defs } ]` where `lifetime_def  =\nlifetime [':' lifetimes]`",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lifetimes","","matches lifetimes = ( lifetime ) | ( lifetime , lifetimes ) actually, it matches the empty\none too, but putting that in there messes up the grammar....",589,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"parse_mutability","","Parse mutability declaration (mut/const/imm)",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_field","","Parse ident COLON expr",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"mk_expr","","",589,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"bytepos"},{"name":"expr_"}],"output":{"name":"p"}}],[11,"mk_unary","","",589,{"inputs":[{"name":"parser"},{"name":"unop"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_binary","","",589,{"inputs":[{"name":"parser"},{"name":"spanned"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_call","","",589,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"vec"}],"output":{"name":"expr_"}}],[11,"mk_index","","",589,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_range","","",589,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"option"}],"output":{"name":"expr_"}}],[11,"mk_field","","",589,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"spanned"}],"output":{"name":"expr_"}}],[11,"mk_tup_field","","",589,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"spanned"}],"output":{"name":"expr_"}}],[11,"mk_assign_op","","",589,{"inputs":[{"name":"parser"},{"name":"spanned"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_mac_expr","","",589,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"bytepos"},{"name":"mac_"}],"output":{"name":"p"}}],[11,"mk_lit_u32","","",589,{"inputs":[{"name":"parser"},{"name":"u32"}],"output":{"name":"p"}}],[11,"parse_bottom_expr","","At the bottom (top?) of the precedence hierarchy,\nparse things like parenthesized exprs,\nmacros, return, etc.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_block_expr","","Parse a block or unsafe block",589,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"blockcheckmode"}],"output":{"name":"result"}}],[11,"parse_dot_or_call_expr","","parse a.b or a(13) or a[4] or just a",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_dot_or_call_expr_with","","",589,{"inputs":[{"name":"parser"},{"name":"p"}],"output":{"name":"result"}}],[11,"check_unknown_macro_variable","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_sep_and_kleene_op","","Parse an optional separator followed by a Kleene-style\nrepetition token (+ or *).",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_token_tree","","parse a single token tree from the input.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_all_token_trees","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_prefix_expr","","Parse a prefix-operator expr",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_binops","","Parse an expression of binops",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_more_binops","","Parse an expression of binops of at least min_prec precedence",589,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"usize"}],"output":{"name":"result"}}],[11,"parse_assign_expr","","Parse an assignment expression....\nactually, this seems to be the main entry point for\nparsing an arbitrary expression.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_assign_expr_with","","",589,{"inputs":[{"name":"parser"},{"name":"p"}],"output":{"name":"result"}}],[11,"parse_if_expr","","Parse an 'if' or 'if let' expression ('if' token already eaten)",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_if_let_expr","","Parse an 'if let' expression ('if' token already eaten)",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lambda_expr","","",589,{"inputs":[{"name":"parser"},{"name":"captureclause"}],"output":{"name":"result"}}],[11,"parse_else_expr","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_for_expr","","Parse a 'for' .. 'in' expression ('for' token already eaten)",589,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_while_expr","","Parse a 'while' or 'while let' expression ('while' token already eaten)",589,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_while_let_expr","","Parse a 'while let' expression ('while' token already eaten)",589,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_loop_expr","","",589,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_arm_nopanic","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_expr_nopanic","","Parse an expression",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_expr_res","","Parse an expression, subject to the given restrictions",589,{"inputs":[{"name":"parser"},{"name":"restrictions"}],"output":{"name":"result"}}],[11,"parse_pat_nopanic","","Parse a pattern.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_stmt_nopanic","","Parse a statement. may include decl.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_block","","Parse a block. No inner attrs are allowed.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_generics","","Parse a set of optional generic type parameter declarations. Where\nclauses are not parsed here, and must be added later via\n`parse_where_clause()`.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_where_clause","","Parses an optional `where` clause and places it in `generics`.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_fn_decl","","Parse the argument list and result type of a function declaration",589,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"result"}}],[11,"parse_impl_item","","Parse an impl item.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_record_struct_body","","",589,{"inputs":[{"name":"parser"},{"name":"ident"}],"output":{"name":"result"}}],[11,"parse_tuple_struct_body","","",589,{"inputs":[{"name":"parser"},{"name":"ident"},{"name":"generics"}],"output":{"name":"result"}}],[11,"parse_single_struct_field","","Parse a structure field declaration",589,{"inputs":[{"name":"parser"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"result"}}],[11,"parse_item_nopanic","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_crate_mod","","Parses a source module as a crate. This is the main\nentry point for the parser.",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_optional_str","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_str","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"eq","syntax::parse::lexer::comments","",590,{"inputs":[{"name":"commentstyle"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"ne","","",590,{"inputs":[{"name":"commentstyle"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"clone","","",590,{"inputs":[{"name":"commentstyle"}],"output":{"name":"commentstyle"}}],[11,"clone","","",591,{"inputs":[{"name":"comment"}],"output":{"name":"comment"}}],[11,"clone","","",592,{"inputs":[{"name":"literal"}],"output":{"name":"literal"}}],[11,"fmt","syntax::parse::lexer","",593,{"inputs":[{"name":"tokenandspan"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",593,{"inputs":[{"name":"tokenandspan"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"ne","","",593,{"inputs":[{"name":"tokenandspan"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"clone","","",593,{"inputs":[{"name":"tokenandspan"}],"output":{"name":"tokenandspan"}}],[11,"is_eof","","",594,{"inputs":[{"name":"stringreader"}],"output":{"name":"bool"}}],[11,"next_token","","Return the next token. EFFECT: advances the string_reader.",594,{"inputs":[{"name":"stringreader"}],"output":{"name":"tokenandspan"}}],[11,"fatal","","",594,null],[11,"err","","",594,null],[11,"peek","","",594,{"inputs":[{"name":"stringreader"}],"output":{"name":"tokenandspan"}}],[11,"is_eof","syntax::ext::tt::transcribe","",503,{"inputs":[{"name":"ttreader"}],"output":{"name":"bool"}}],[11,"next_token","","",503,{"inputs":[{"name":"ttreader"}],"output":{"name":"tokenandspan"}}],[11,"fatal","","",503,null],[11,"err","","",503,null],[11,"peek","","",503,{"inputs":[{"name":"ttreader"}],"output":{"name":"tokenandspan"}}],[11,"new_raw","syntax::parse::lexer","For comments.rs, which hackily pokes into pos and curr",594,{"inputs":[{"name":"stringreader"},{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[11,"new","","",594,{"inputs":[{"name":"stringreader"},{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[11,"curr_is","","",594,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"fatal_span","","Report a fatal lexical error with a given span.",594,null],[11,"err_span","","Report a lexical error with a given span.",594,null],[11,"with_str_from","","Calls `f` with a string slice of the source text spanning from `start`\nup to but excluding `self.last_pos`, meaning the slice does not include\nthe character `self.curr`.",594,{"inputs":[{"name":"stringreader"},{"name":"bytepos"},{"name":"f"}],"output":{"name":"t"}}],[11,"name_from","","Create a Name from a given offset to the current offset, each\nadjusted 1 towards each other (assumes that on either side there is a\nsingle-byte delimiter).",594,{"inputs":[{"name":"stringreader"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"name_from_to","","As name_from, with an explicit endpoint.",594,{"inputs":[{"name":"stringreader"},{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"bump","","Advance the StringReader by one character. If a newline is\ndiscovered, add it to the FileMap's list of line start offsets.",594,null],[11,"nextch","","",594,{"inputs":[{"name":"stringreader"}],"output":{"name":"option"}}],[11,"nextch_is","","",594,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"nextnextch","","",594,{"inputs":[{"name":"stringreader"}],"output":{"name":"option"}}],[11,"nextnextch_is","","",594,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"fmt","syntax::parse::token","",595,{"inputs":[{"name":"binoptoken"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",595,null],[11,"eq","","",595,{"inputs":[{"name":"binoptoken"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"ne","","",595,{"inputs":[{"name":"binoptoken"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"decode","","",595,{"inputs":[{"name":"binoptoken"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",595,{"inputs":[{"name":"binoptoken"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",595,{"inputs":[{"name":"binoptoken"}],"output":{"name":"binoptoken"}}],[11,"fmt","","",596,{"inputs":[{"name":"delimtoken"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",596,null],[11,"eq","","",596,{"inputs":[{"name":"delimtoken"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"ne","","",596,{"inputs":[{"name":"delimtoken"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"decode","","",596,{"inputs":[{"name":"delimtoken"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",596,{"inputs":[{"name":"delimtoken"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",596,{"inputs":[{"name":"delimtoken"}],"output":{"name":"delimtoken"}}],[11,"fmt","","",597,{"inputs":[{"name":"identstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",597,null],[11,"eq","","",597,{"inputs":[{"name":"identstyle"},{"name":"identstyle"}],"output":{"name":"bool"}}],[11,"ne","","",597,{"inputs":[{"name":"identstyle"},{"name":"identstyle"}],"output":{"name":"bool"}}],[11,"decode","","",597,{"inputs":[{"name":"identstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",597,{"inputs":[{"name":"identstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",597,{"inputs":[{"name":"identstyle"}],"output":{"name":"identstyle"}}],[11,"fmt","","",598,{"inputs":[{"name":"specialmacrovar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",598,null],[11,"eq","","",598,{"inputs":[{"name":"specialmacrovar"},{"name":"specialmacrovar"}],"output":{"name":"bool"}}],[11,"ne","","",598,{"inputs":[{"name":"specialmacrovar"},{"name":"specialmacrovar"}],"output":{"name":"bool"}}],[11,"decode","","",598,{"inputs":[{"name":"specialmacrovar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",598,{"inputs":[{"name":"specialmacrovar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",598,{"inputs":[{"name":"specialmacrovar"}],"output":{"name":"specialmacrovar"}}],[11,"as_str","","",598,{"inputs":[{"name":"specialmacrovar"}],"output":{"name":"str"}}],[11,"fmt","","",599,{"inputs":[{"name":"lit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",599,null],[11,"eq","","",599,{"inputs":[{"name":"lit"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"ne","","",599,{"inputs":[{"name":"lit"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"decode","","",599,{"inputs":[{"name":"lit"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",599,{"inputs":[{"name":"lit"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",599,{"inputs":[{"name":"lit"}],"output":{"name":"lit"}}],[11,"short_name","","",599,{"inputs":[{"name":"lit"}],"output":{"name":"str"}}],[11,"fmt","","",600,{"inputs":[{"name":"token"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",600,null],[11,"eq","","",600,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"ne","","",600,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"decode","","",600,{"inputs":[{"name":"token"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",600,{"inputs":[{"name":"token"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",600,{"inputs":[{"name":"token"}],"output":{"name":"token"}}],[11,"is_like_gt","","Returns `true` if the token starts with '>'.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"can_begin_expr","","Returns `true` if the token can appear at the start of an expression.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_lit","","Returns `true` if the token is any literal",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_ident","","Returns `true` if the token is an identifier.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_path","","Returns `true` if the token is an interpolated path.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_plain_ident","","Returns `true` if the token is a path that is not followed by a `::`\ntoken.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_lifetime","","Returns `true` if the token is a lifetime.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_mutability","","Returns `true` if the token is either the `mut` or `const` keyword.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"to_binop","","Maps a token to its corresponding binary operator.",600,{"inputs":[{"name":"token"}],"output":{"name":"option"}}],[11,"is_keyword","","Returns `true` if the token is a given keyword, `kw`.",600,{"inputs":[{"name":"token"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_keyword_allow_following_colon","","",600,{"inputs":[{"name":"token"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_any_keyword","","Returns `true` if the token is either a special identifier, or a strict\nor reserved keyword.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_strict_keyword","","Returns `true` if the token may not appear as an identifier.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_reserved_keyword","","Returns `true` if the token is a keyword that has been reserved for\npossible future use.",600,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"mtwt_eq","","Hygienic identifier equality comparison.",600,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"hash","","",601,null],[11,"eq","","",601,{"inputs":[{"name":"nonterminal"},{"name":"nonterminal"}],"output":{"name":"bool"}}],[11,"ne","","",601,{"inputs":[{"name":"nonterminal"},{"name":"nonterminal"}],"output":{"name":"bool"}}],[11,"decode","","",601,{"inputs":[{"name":"nonterminal"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",601,{"inputs":[{"name":"nonterminal"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",601,{"inputs":[{"name":"nonterminal"}],"output":{"name":"nonterminal"}}],[11,"fmt","","",601,{"inputs":[{"name":"nonterminal"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","syntax::parse::token::keywords","",602,{"inputs":[{"name":"keyword"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"ne","","",602,{"inputs":[{"name":"keyword"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"clone","","",602,{"inputs":[{"name":"keyword"}],"output":{"name":"keyword"}}],[11,"to_name","","",602,{"inputs":[{"name":"keyword"}],"output":{"name":"name"}}],[11,"cmp","syntax::parse::token","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"option"}}],[11,"lt","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"le","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"gt","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"ge","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"hash","","",603,null],[11,"eq","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"ne","","",603,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"clone","","",603,{"inputs":[{"name":"internedstring"}],"output":{"name":"internedstring"}}],[11,"new","","",603,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"internedstring"}}],[11,"deref","","",603,{"inputs":[{"name":"internedstring"}],"output":{"name":"str"}}],[11,"fmt","","",603,{"inputs":[{"name":"internedstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",603,{"inputs":[{"name":"internedstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",603,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",603,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"decode","","",603,{"inputs":[{"name":"internedstring"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",603,{"inputs":[{"name":"internedstring"},{"name":"s"}],"output":{"name":"result"}}],[11,"parse_outer_attributes","syntax::parse::parser","Parse attributes that appear before an item",589,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_attribute","","Matches `attribute = # ! [ meta_item ]`",589,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"spanned"}}],[11,"parse_inner_attributes","","Parse attributes that appear after the opening of an item. These should\nbe preceded by an exclamation mark, but we accept and warn about one\nterminated by a semicolon.\nmatches inner_attrs*",589,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_meta_item","","matches meta_item = IDENT\n| IDENT = lit\n| IDENT meta_seq",589,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_meta_seq","","matches meta_seq = ( COMMASEP(meta_item) )",589,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_optional_meta","","",589,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"hash","syntax::parse::obsolete","",604,null],[11,"eq","","",604,{"inputs":[{"name":"obsoletesyntax"},{"name":"obsoletesyntax"}],"output":{"name":"bool"}}],[11,"ne","","",604,{"inputs":[{"name":"obsoletesyntax"},{"name":"obsoletesyntax"}],"output":{"name":"bool"}}],[11,"clone","","",604,{"inputs":[{"name":"obsoletesyntax"}],"output":{"name":"obsoletesyntax"}}],[11,"obsolete","syntax::parse::parser","Reports an obsolete syntax non-fatal error.",589,null],[11,"obsolete_expr","","Reports an obsolete syntax non-fatal error, and returns\na placeholder expression",589,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"obsoletesyntax"}],"output":{"name":"p"}}],[11,"report","","",589,null],[11,"is_obsolete_ident","","",589,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eat_obsolete_ident","","",589,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"bool"}}],[11,"next_node_id","syntax::parse","",605,{"inputs":[{"name":"parsesess"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",605,{"inputs":[{"name":"parsesess"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"fmt","syntax::abi","",606,{"inputs":[{"name":"os"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",606,{"inputs":[{"name":"os"},{"name":"os"}],"output":{"name":"bool"}}],[11,"ne","","",606,{"inputs":[{"name":"os"},{"name":"os"}],"output":{"name":"bool"}}],[11,"clone","","",606,{"inputs":[{"name":"os"}],"output":{"name":"os"}}],[11,"fmt","","",298,{"inputs":[{"name":"abi"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",298,{"inputs":[{"name":"abi"}],"output":{"name":"abi"}}],[11,"decode","","",298,{"inputs":[{"name":"abi"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",298,{"inputs":[{"name":"abi"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",298,null],[11,"eq","","",298,{"inputs":[{"name":"abi"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"ne","","",298,{"inputs":[{"name":"abi"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"fmt","","",607,{"inputs":[{"name":"architecture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",607,{"inputs":[{"name":"architecture"},{"name":"architecture"}],"output":{"name":"bool"}}],[11,"ne","","",607,{"inputs":[{"name":"architecture"},{"name":"architecture"}],"output":{"name":"bool"}}],[11,"clone","","",607,{"inputs":[{"name":"architecture"}],"output":{"name":"architecture"}}],[11,"clone","","",608,{"inputs":[{"name":"abidata"}],"output":{"name":"abidata"}}],[11,"clone","","",609,{"inputs":[{"name":"abiarchitecture"}],"output":{"name":"abiarchitecture"}}],[11,"index","","",298,{"inputs":[{"name":"abi"}],"output":{"name":"usize"}}],[11,"data","","",298,{"inputs":[{"name":"abi"}],"output":{"name":"abidata"}}],[11,"name","","",298,{"inputs":[{"name":"abi"}],"output":{"name":"str"}}],[11,"fmt","","",298,{"inputs":[{"name":"abi"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",606,{"inputs":[{"name":"os"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","syntax::ast_map::blocks","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnlikenode"}}],[11,"is_fn_like","syntax::ast","",368,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",365,{"inputs":[{"name":"traititem"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",159,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[11,"clone","syntax::ast_map::blocks","",611,{"inputs":[{"name":"code"}],"output":{"name":"code"}}],[11,"id","","",611,{"inputs":[{"name":"code"}],"output":{"name":"u32"}}],[11,"from_node","","Attempts to construct a Code from presumed FnLike or Block node input.",611,{"inputs":[{"name":"code"},{"name":"node"}],"output":{"name":"option"}}],[11,"to_fn_parts","","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnparts"}}],[11,"body","","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"block"}}],[11,"decl","","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fndecl"}}],[11,"span","","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"span"}}],[11,"id","","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"u32"}}],[11,"kind","","",610,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnkind"}}],[11,"fmt","syntax::ast_map","",612,{"inputs":[{"name":"pathelem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",612,{"inputs":[{"name":"pathelem"},{"name":"pathelem"}],"output":{"name":"bool"}}],[11,"ne","","",612,{"inputs":[{"name":"pathelem"},{"name":"pathelem"}],"output":{"name":"bool"}}],[11,"clone","","",612,{"inputs":[{"name":"pathelem"}],"output":{"name":"pathelem"}}],[11,"name","","",612,{"inputs":[{"name":"pathelem"}],"output":{"name":"name"}}],[11,"fmt","","",612,{"inputs":[{"name":"pathelem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",613,{"inputs":[{"name":"linkedpathnode"}],"output":{"name":"linkedpathnode"}}],[11,"clone","","",614,{"inputs":[{"name":"linkedpath"}],"output":{"name":"linkedpath"}}],[11,"empty","","",614,{"inputs":[{"name":"linkedpath"}],"output":{"name":"linkedpath"}}],[11,"from","","",614,{"inputs":[{"name":"linkedpath"},{"name":"linkedpathnode"}],"output":{"name":"linkedpath"}}],[11,"next","","",614,{"inputs":[{"name":"linkedpath"}],"output":{"name":"option"}}],[11,"fmt","","",615,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",615,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",616,{"inputs":[{"name":"mapentry"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",616,{"inputs":[{"name":"mapentry"}],"output":{"name":"mapentry"}}],[11,"fmt","","",617,{"inputs":[{"name":"inlinedparent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",618,{"inputs":[{"name":"forest"},{"name":"crate"}],"output":{"name":"forest"}}],[11,"krate","","",618,{"inputs":[{"name":"forest"}],"output":{"name":"crate"}}],[11,"krate","","",619,{"inputs":[{"name":"map"}],"output":{"name":"crate"}}],[11,"get","","Retrieve the Node corresponding to `id`, panicking if it cannot\nbe found.",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"node"}}],[11,"find","","Retrieve the Node corresponding to `id`, returning None if\ncannot be found.",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"option"}}],[11,"get_parent","","Retrieve the parent NodeId for `id`, or `id` itself if no\nparent is registered in this map.",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"get_parent_did","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"defid"}}],[11,"get_foreign_abi","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"abi"}}],[11,"get_foreign_vis","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"visibility"}}],[11,"expect_item","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"item"}}],[11,"expect_struct","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"structdef"}}],[11,"expect_variant","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"spanned"}}],[11,"expect_foreign_item","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"foreignitem"}}],[11,"expect_expr","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"expr"}}],[11,"get_path_elem","","returns the name associated with the given NodeId's AST",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"pathelem"}}],[11,"with_path","","",619,{"inputs":[{"name":"map"},{"name":"u32"},{"name":"f"}],"output":{"name":"t"}}],[11,"path_to_string","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"string"}}],[11,"attrs","","Given a node ID, get a list of of attributes associated with the AST\ncorresponding to the Node ID",619,null],[11,"nodes_matching_suffix","","Returns an iterator that yields the node id's with paths that\nmatch `parts`.  (Requires `parts` is non-empty.)",619,null],[11,"opt_span","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"option"}}],[11,"span","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"span"}}],[11,"def_id_span","","",619,{"inputs":[{"name":"map"},{"name":"defid"},{"name":"span"}],"output":{"name":"span"}}],[11,"node_to_string","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"string"}}],[11,"node_to_user_string","","",619,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"string"}}],[11,"next","","",620,{"inputs":[{"name":"nodesmatchingsuffix"}],"output":{"name":"option"}}],[11,"name","syntax::codemap","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"name"}}],[11,"name","syntax::ast","",368,{"inputs":[{"name":"item"}],"output":{"name":"name"}}],[11,"name","","",581,{"inputs":[{"name":"foreignitem"}],"output":{"name":"name"}}],[11,"name","","",570,{"inputs":[{"name":"variant_"}],"output":{"name":"name"}}],[11,"name","","",365,{"inputs":[{"name":"traititem"}],"output":{"name":"name"}}],[11,"name","","",554,{"inputs":[{"name":"implitem"}],"output":{"name":"name"}}],[11,"new_id","syntax::ast_map","",621,{"inputs":[{"name":"idandspanupdater"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"new_span","","",621,{"inputs":[{"name":"idandspanupdater"},{"name":"span"}],"output":{"name":"span"}}],[11,"visit_item","","",622,null],[11,"visit_trait_item","","",622,null],[11,"visit_impl_item","","",622,null],[11,"visit_pat","","",622,null],[11,"visit_expr","","",622,null],[11,"visit_stmt","","",622,null],[11,"visit_fn","","",622,null],[11,"visit_ty","","",622,null],[11,"visit_block","","",622,null],[11,"visit_lifetime_ref","","",622,null],[11,"visit_lifetime_def","","",622,null],[11,"print_node","syntax::print::pprust","",623,{"inputs":[{"name":"state"},{"name":"node"}],"output":{"name":"result"}}],[11,"fmt","syntax::ast_util","",624,{"inputs":[{"name":"idrange"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",624,{"inputs":[{"name":"idrange"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",624,{"inputs":[{"name":"idrange"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",624,{"inputs":[{"name":"idrange"}],"output":{"name":"idrange"}}],[11,"max","","",624,{"inputs":[{"name":"idrange"}],"output":{"name":"idrange"}}],[11,"empty","","",624,{"inputs":[{"name":"idrange"}],"output":{"name":"bool"}}],[11,"add","","",624,null],[11,"visit_mod","","",625,null],[11,"visit_foreign_item","","",625,null],[11,"visit_item","","",625,null],[11,"visit_local","","",625,null],[11,"visit_block","","",625,null],[11,"visit_stmt","","",625,null],[11,"visit_pat","","",625,null],[11,"visit_expr","","",625,null],[11,"visit_ty","","",625,null],[11,"visit_generics","","",625,null],[11,"visit_fn","","",625,null],[11,"visit_struct_field","","",625,null],[11,"visit_struct_def","","",625,null],[11,"visit_trait_item","","",625,null],[11,"visit_impl_item","","",625,null],[11,"visit_lifetime_ref","","",625,null],[11,"visit_lifetime_def","","",625,null],[11,"visit_trait_ref","","",625,null],[11,"visit_id","","",626,null],[11,"check_name","syntax::codemap","",370,{"inputs":[{"name":"spanned"},{"name":"str"}],"output":{"name":"bool"}}],[11,"name","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"internedstring"}}],[11,"value_str","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"meta_item_list","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"span","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"span"}}],[11,"name","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"internedstring"}}],[11,"value_str","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"meta_item_list","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"span","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"span"}}],[11,"name","syntax::ptr","",363,{"inputs":[{"name":"p"}],"output":{"name":"internedstring"}}],[11,"value_str","","",363,{"inputs":[{"name":"p"}],"output":{"name":"option"}}],[11,"meta_item_list","","",363,{"inputs":[{"name":"p"}],"output":{"name":"option"}}],[11,"span","","",363,{"inputs":[{"name":"p"}],"output":{"name":"span"}}],[11,"meta","syntax::codemap","Extract the MetaItem from inside this Attribute.",370,{"inputs":[{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"with_desugared_doc","","Convert self to a normal #[doc=\"foo\"] comment, if it is a\ncomment like `///` or `/** */`. (Returns self unchanged for\nnon-sugared doc attributes.)",370,{"inputs":[{"name":"spanned"},{"name":"f"}],"output":{"name":"t"}}],[11,"eq","syntax::attr","",627,{"inputs":[{"name":"inlineattr"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"ne","","",627,{"inputs":[{"name":"inlineattr"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"clone","","",627,{"inputs":[{"name":"inlineattr"}],"output":{"name":"inlineattr"}}],[11,"fmt","","",628,{"inputs":[{"name":"stability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",628,{"inputs":[{"name":"stability"}],"output":{"name":"stability"}}],[11,"decode","","",628,{"inputs":[{"name":"stability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",628,{"inputs":[{"name":"stability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",629,{"inputs":[{"name":"stabilitylevel"}],"output":{"name":"stabilitylevel"}}],[11,"partial_cmp","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"option"}}],[11,"lt","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"le","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"gt","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ge","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"eq","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ne","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"decode","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",629,{"inputs":[{"name":"stabilitylevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",630,{"inputs":[{"name":"reprattr"}],"output":{"name":"reprattr"}}],[11,"decode","","",630,{"inputs":[{"name":"reprattr"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",630,{"inputs":[{"name":"reprattr"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",630,{"inputs":[{"name":"reprattr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",630,{"inputs":[{"name":"reprattr"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"ne","","",630,{"inputs":[{"name":"reprattr"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"is_ffi_safe","","",630,{"inputs":[{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"clone","","",291,{"inputs":[{"name":"inttype"}],"output":{"name":"inttype"}}],[11,"decode","","",291,{"inputs":[{"name":"inttype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",291,{"inputs":[{"name":"inttype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",291,{"inputs":[{"name":"inttype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",291,{"inputs":[{"name":"inttype"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"ne","","",291,{"inputs":[{"name":"inttype"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"hash","","",291,null],[11,"is_signed","","",291,{"inputs":[{"name":"inttype"}],"output":{"name":"bool"}}],[11,"fmt","syntax::codemap","",631,{"inputs":[{"name":"bytepos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"option"}}],[11,"lt","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"le","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"gt","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ge","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"hash","","",631,null],[11,"eq","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ne","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"clone","","",631,{"inputs":[{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"fmt","","",632,{"inputs":[{"name":"charpos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"option"}}],[11,"lt","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"le","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"gt","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ge","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"hash","","",632,null],[11,"eq","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ne","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"clone","","",632,{"inputs":[{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"from_usize","","",631,{"inputs":[{"name":"bytepos"},{"name":"usize"}],"output":{"name":"bytepos"}}],[11,"to_usize","","",631,{"inputs":[{"name":"bytepos"}],"output":{"name":"usize"}}],[11,"add","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"sub","","",631,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"encode","","",631,{"inputs":[{"name":"bytepos"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",631,{"inputs":[{"name":"bytepos"},{"name":"d"}],"output":{"name":"result"}}],[11,"from_usize","","",632,{"inputs":[{"name":"charpos"},{"name":"usize"}],"output":{"name":"charpos"}}],[11,"to_usize","","",632,{"inputs":[{"name":"charpos"}],"output":{"name":"usize"}}],[11,"add","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"sub","","",632,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"hash","","",12,null],[11,"fmt","","",12,{"inputs":[{"name":"span"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",12,{"inputs":[{"name":"span"}],"output":{"name":"span"}}],[11,"fmt","","",370,{"inputs":[{"name":"spanned"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",370,null],[11,"decode","","",370,{"inputs":[{"name":"spanned"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",370,{"inputs":[{"name":"spanned"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",370,{"inputs":[{"name":"spanned"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"ne","","",370,{"inputs":[{"name":"spanned"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"clone","","",370,{"inputs":[{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"eq","","",12,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"encode","","",12,{"inputs":[{"name":"span"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",12,{"inputs":[{"name":"span"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",633,{"inputs":[{"name":"loc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",634,{"inputs":[{"name":"locwithopt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",635,{"inputs":[{"name":"filemapandline"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",636,{"inputs":[{"name":"filemapandbytepos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",637,{"inputs":[{"name":"macroformat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",637,null],[11,"clone","","",637,{"inputs":[{"name":"macroformat"}],"output":{"name":"macroformat"}}],[11,"fmt","","",638,{"inputs":[{"name":"nameandspan"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",638,null],[11,"clone","","",638,{"inputs":[{"name":"nameandspan"}],"output":{"name":"nameandspan"}}],[11,"fmt","","",639,{"inputs":[{"name":"expninfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",639,null],[11,"decode","","",640,{"inputs":[{"name":"expnid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",640,{"inputs":[{"name":"expnid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",640,null],[11,"fmt","","",640,{"inputs":[{"name":"expnid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",640,{"inputs":[{"name":"expnid"}],"output":{"name":"expnid"}}],[11,"eq","","",640,{"inputs":[{"name":"expnid"},{"name":"expnid"}],"output":{"name":"bool"}}],[11,"ne","","",640,{"inputs":[{"name":"expnid"},{"name":"expnid"}],"output":{"name":"bool"}}],[11,"from_llvm_cookie","","",640,{"inputs":[{"name":"expnid"},{"name":"u32"}],"output":{"name":"expnid"}}],[11,"to_llvm_cookie","","",640,{"inputs":[{"name":"expnid"}],"output":{"name":"i32"}}],[11,"eq","","",641,{"inputs":[{"name":"lineinfo"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"ne","","",641,{"inputs":[{"name":"lineinfo"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"fmt","","",641,{"inputs":[{"name":"lineinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",641,{"inputs":[{"name":"lineinfo"}],"output":{"name":"lineinfo"}}],[11,"eq","","",642,{"inputs":[{"name":"multibytechar"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"ne","","",642,{"inputs":[{"name":"multibytechar"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"decode","","",642,{"inputs":[{"name":"multibytechar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",642,{"inputs":[{"name":"multibytechar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",642,{"inputs":[{"name":"multibytechar"}],"output":{"name":"multibytechar"}}],[11,"encode","","",643,{"inputs":[{"name":"filemap"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",643,{"inputs":[{"name":"filemap"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",643,{"inputs":[{"name":"filemap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"next_line","","EFFECT: register a start-of-line offset in the\ntable of line-beginnings.\nUNCHECKED INVARIANT: these offsets must be added in the right\norder and must be in the right places; there is shared knowledge\nabout what ends a line between this file and parse.rs\nWARNING: pos param here is the offset relative to start of CodeMap,\nand CodeMap will append a newline when adding a filemap without a newline at the end,\nso the safe way to call this is with value calculated as\nfilemap.start_pos + newline_offset_relative_to_the_start_of_filemap.",643,null],[11,"get_line","","get a line from the list of pre-computed line-beginnings.\nline-number here is 0-based.",643,{"inputs":[{"name":"filemap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"record_multibyte_char","","",643,null],[11,"is_real_file","","",643,{"inputs":[{"name":"filemap"}],"output":{"name":"bool"}}],[11,"is_imported","","",643,{"inputs":[{"name":"filemap"}],"output":{"name":"bool"}}],[11,"new","","",644,{"inputs":[{"name":"codemap"}],"output":{"name":"codemap"}}],[11,"new_filemap","","",644,{"inputs":[{"name":"codemap"},{"name":"string"},{"name":"string"}],"output":{"name":"rc"}}],[11,"new_imported_filemap","","Allocates a new FileMap representing a source file from an external\ncrate. The source code of such an \"imported filemap\" is not available,\nbut we still know enough to generate accurate debuginfo location\ninformation for things inlined from other crates.",644,{"inputs":[{"name":"codemap"},{"name":"string"},{"name":"usize"},{"name":"vec"},{"name":"vec"}],"output":{"name":"rc"}}],[11,"mk_substr_filename","","",644,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"lookup_char_pos","","Lookup source information about a BytePos",644,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"loc"}}],[11,"lookup_char_pos_adj","","",644,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"locwithopt"}}],[11,"span_to_string","","",644,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_filename","","",644,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_lines","","",644,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"filelines"}}],[11,"span_to_snippet","","",644,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"result"}}],[11,"get_filemap","","",644,{"inputs":[{"name":"codemap"},{"name":"str"}],"output":{"name":"rc"}}],[11,"lookup_byte_offset","","For a global BytePos compute the local offset within the containing FileMap",644,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"filemapandbytepos"}}],[11,"bytepos_to_file_charpos","","Converts an absolute BytePos to a CharPos relative to the filemap and above.",644,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"charpos"}}],[11,"record_expansion","","",644,{"inputs":[{"name":"codemap"},{"name":"expninfo"}],"output":{"name":"expnid"}}],[11,"with_expn_info","","",644,{"inputs":[{"name":"codemap"},{"name":"expnid"},{"name":"f"}],"output":{"name":"t"}}],[11,"span_allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable]\nitems can be used (that is, a macro marked with\n`#[allow_internal_unstable]`).",644,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"bool"}}],[11,"fmt","","",645,{"inputs":[{"name":"spansnippeterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",645,{"inputs":[{"name":"spansnippeterror"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"ne","","",645,{"inputs":[{"name":"spansnippeterror"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"clone","","",645,{"inputs":[{"name":"spansnippeterror"}],"output":{"name":"spansnippeterror"}}],[11,"fmt","","",646,{"inputs":[{"name":"distinctsources"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",646,{"inputs":[{"name":"distinctsources"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"ne","","",646,{"inputs":[{"name":"distinctsources"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"clone","","",646,{"inputs":[{"name":"distinctsources"}],"output":{"name":"distinctsources"}}],[11,"fmt","","",647,{"inputs":[{"name":"malformedcodemappositions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",647,{"inputs":[{"name":"malformedcodemappositions"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"ne","","",647,{"inputs":[{"name":"malformedcodemappositions"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"clone","","",647,{"inputs":[{"name":"malformedcodemappositions"}],"output":{"name":"malformedcodemappositions"}}],[11,"fold_mod","syntax::config","",648,{"inputs":[{"name":"context"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_block","","",648,{"inputs":[{"name":"context"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_foreign_mod","","",648,{"inputs":[{"name":"context"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fold_item_underscore","","",648,{"inputs":[{"name":"context"},{"name":"item_"}],"output":{"name":"item_"}}],[11,"fold_expr","","",648,{"inputs":[{"name":"context"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mac","","",648,{"inputs":[{"name":"context"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"fold_item","","",648,{"inputs":[{"name":"context"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_attribute","","",649,{"inputs":[{"name":"cfgattrfolder"},{"name":"spanned"}],"output":{"name":"option"}}],[11,"fold_mac","","",649,{"inputs":[{"name":"cfgattrfolder"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"clone","syntax::diagnostic","",650,{"inputs":[{"name":"renderspan"}],"output":{"name":"renderspan"}}],[11,"clone","","",651,{"inputs":[{"name":"colorconfig"}],"output":{"name":"colorconfig"}}],[11,"clone","","",652,{"inputs":[{"name":"fatalerror"}],"output":{"name":"fatalerror"}}],[11,"clone","","",653,{"inputs":[{"name":"explicitbug"}],"output":{"name":"explicitbug"}}],[11,"span_fatal","","",654,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_with_code","","",654,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_err","","",654,null],[11,"span_err_with_code","","",654,null],[11,"span_warn","","",654,null],[11,"span_warn_with_code","","",654,null],[11,"span_note","","",654,null],[11,"span_end_note","","",654,null],[11,"span_help","","",654,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",654,null],[11,"fileline_note","","",654,null],[11,"fileline_help","","",654,null],[11,"span_bug","","",654,null],[11,"span_unimpl","","",654,null],[11,"handler","","",654,{"inputs":[{"name":"spanhandler"}],"output":{"name":"handler"}}],[11,"fatal","","",655,null],[11,"err","","",655,null],[11,"bump_err_count","","",655,null],[11,"err_count","","",655,{"inputs":[{"name":"handler"}],"output":{"name":"usize"}}],[11,"has_errors","","",655,{"inputs":[{"name":"handler"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",655,null],[11,"warn","","",655,null],[11,"note","","",655,null],[11,"help","","",655,null],[11,"bug","","",655,null],[11,"unimpl","","",655,null],[11,"emit","","",655,null],[11,"emit_with_code","","",655,null],[11,"custom_emit","","",655,null],[11,"fmt","","",656,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",656,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"eq","","",656,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",656,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"fmt","","",656,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"stderr","","",657,{"inputs":[{"name":"emitterwriter"},{"name":"colorconfig"},{"name":"option"}],"output":{"name":"emitterwriter"}}],[11,"new","","",657,{"inputs":[{"name":"emitterwriter"},{"name":"box"},{"name":"option"}],"output":{"name":"emitterwriter"}}],[11,"write","","",658,null],[11,"flush","","",658,{"inputs":[{"name":"destination"}],"output":{"name":"result"}}],[11,"emit","","",657,null],[11,"custom_emit","","",657,null],[11,"fmt","syntax::feature_gate","",659,{"inputs":[{"name":"attributetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",659,{"inputs":[{"name":"attributetype"}],"output":{"name":"attributetype"}}],[11,"eq","","",659,{"inputs":[{"name":"attributetype"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"ne","","",659,{"inputs":[{"name":"attributetype"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"new","","",660,{"inputs":[{"name":"features"}],"output":{"name":"features"}}],[11,"visit_mac","","",661,null],[11,"visit_attribute","","",661,null],[11,"visit_attribute","","",662,null],[11,"visit_name","","",662,null],[11,"visit_item","","",662,null],[11,"visit_foreign_item","","",662,null],[11,"visit_expr","","",662,null],[11,"visit_pat","","",662,null],[11,"visit_fn","","",662,null],[11,"move_map","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"move_map","syntax::owned_slice","",299,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"cmp","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"option"}}],[11,"lt","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"le","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"gt","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"ge","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"eq","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"ne","","",299,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"hash","","",299,null],[11,"fmt","","",299,{"inputs":[{"name":"ownedslice"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",299,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"from_vec","","",299,{"inputs":[{"name":"ownedslice"},{"name":"vec"}],"output":{"name":"ownedslice"}}],[11,"into_vec","","",299,{"inputs":[{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"as_slice","","",299,null],[11,"move_iter","","",299,{"inputs":[{"name":"ownedslice"}],"output":{"name":"intoiter"}}],[11,"map","","",299,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"deref","","",299,null],[11,"default","","",299,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"clone","","",299,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"from_iter","","",299,{"inputs":[{"name":"ownedslice"},{"name":"i"}],"output":{"name":"ownedslice"}}],[11,"encode","","",299,{"inputs":[{"name":"ownedslice"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",299,{"inputs":[{"name":"ownedslice"},{"name":"d"}],"output":{"name":"result"}}],[11,"and_then","syntax::ptr","Move out of the pointer.\nIntended for chaining transformations not covered by `map`.",363,{"inputs":[{"name":"p"},{"name":"f"}],"output":{"name":"u"}}],[11,"map","","Transform the inner value, consuming `self` and producing a new `P<T>`.",363,{"inputs":[{"name":"p"},{"name":"f"}],"output":{"name":"p"}}],[11,"deref","","",363,{"inputs":[{"name":"p"}],"output":{"name":"t"}}],[11,"clone","","",363,{"inputs":[{"name":"p"}],"output":{"name":"p"}}],[11,"eq","","",363,{"inputs":[{"name":"p"},{"name":"p"}],"output":{"name":"bool"}}],[11,"fmt","","",363,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",363,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",363,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",363,null],[11,"decode","","",363,{"inputs":[{"name":"p"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",363,{"inputs":[{"name":"p"},{"name":"s"}],"output":{"name":"result"}}],[11,"from_str","syntax::show_span","",663,{"inputs":[{"name":"mode"},{"name":"str"}],"output":{"name":"result"}}],[11,"visit_expr","","",664,null],[11,"visit_pat","","",664,null],[11,"visit_ty","","",664,null],[11,"visit_mac","","",664,null],[11,"fold_crate","syntax::std_inject","",665,{"inputs":[{"name":"standardlibraryinjector"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_crate","","",666,{"inputs":[{"name":"preludeinjector"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_item","","",666,{"inputs":[{"name":"preludeinjector"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_mod","","",666,{"inputs":[{"name":"preludeinjector"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_crate","syntax::test","",667,{"inputs":[{"name":"testharnessgenerator"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_item","","",667,{"inputs":[{"name":"testharnessgenerator"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_mod","","",667,{"inputs":[{"name":"testharnessgenerator"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"eq","","",668,{"inputs":[{"name":"hastestsignature"},{"name":"hastestsignature"}],"output":{"name":"bool"}}],[11,"ne","","",668,{"inputs":[{"name":"hastestsignature"},{"name":"hastestsignature"}],"output":{"name":"bool"}}],[11,"clone","syntax::visit","",669,{"inputs":[{"name":"fnkind"}],"output":{"name":"fnkind"}}],[11,"eq","syntax::print::pp","",670,{"inputs":[{"name":"breaks"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"ne","","",670,{"inputs":[{"name":"breaks"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"clone","","",670,{"inputs":[{"name":"breaks"}],"output":{"name":"breaks"}}],[11,"clone","","",671,{"inputs":[{"name":"breaktoken"}],"output":{"name":"breaktoken"}}],[11,"clone","","",672,{"inputs":[{"name":"begintoken"}],"output":{"name":"begintoken"}}],[11,"clone","","",673,{"inputs":[{"name":"token"}],"output":{"name":"token"}}],[11,"is_eof","","",673,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_hardbreak_tok","","",673,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"clone","","",674,{"inputs":[{"name":"printstackbreak"}],"output":{"name":"printstackbreak"}}],[11,"clone","","",675,{"inputs":[{"name":"printstackelem"}],"output":{"name":"printstackelem"}}],[11,"last_token","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"token"}}],[11,"replace_last_token","","",676,null],[11,"pretty_print","","",676,{"inputs":[{"name":"printer"},{"name":"token"}],"output":{"name":"result"}}],[11,"check_stream","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[11,"scan_push","","",676,null],[11,"scan_pop","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"scan_top","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"scan_pop_bottom","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"advance_right","","",676,null],[11,"advance_left","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[11,"check_stack","","",676,null],[11,"print_newline","","",676,{"inputs":[{"name":"printer"},{"name":"isize"}],"output":{"name":"result"}}],[11,"indent","","",676,null],[11,"get_top","","",676,{"inputs":[{"name":"printer"}],"output":{"name":"printstackelem"}}],[11,"print_str","","",676,{"inputs":[{"name":"printer"},{"name":"str"}],"output":{"name":"result"}}],[11,"print","","",676,{"inputs":[{"name":"printer"},{"name":"token"},{"name":"isize"}],"output":{"name":"result"}}],[11,"clone","syntax::print::pprust","",677,{"inputs":[{"name":"noann"}],"output":{"name":"noann"}}],[11,"clone","","",678,{"inputs":[{"name":"currentcommentandliteral"}],"output":{"name":"currentcommentandliteral"}}],[11,"new_from_input","","",623,{"inputs":[{"name":"state"},{"name":"codemap"},{"name":"spanhandler"},{"name":"string"},{"name":"read"},{"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"state"}}],[11,"new","","",623,{"inputs":[{"name":"state"},{"name":"codemap"},{"name":"box"},{"name":"ppann"},{"name":"option"},{"name":"option"}],"output":{"name":"state"}}],[11,"ibox","","",623,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"end","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"cbox","","",623,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"rbox","","",623,{"inputs":[{"name":"state"},{"name":"usize"},{"name":"breaks"}],"output":{"name":"result"}}],[11,"nbsp","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"word_nbsp","","",623,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"word_space","","",623,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"popen","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"pclose","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"head","","",623,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"bopen","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"bclose_","","",623,{"inputs":[{"name":"state"},{"name":"span"},{"name":"usize"}],"output":{"name":"result"}}],[11,"bclose_maybe_open","","",623,{"inputs":[{"name":"state"},{"name":"span"},{"name":"usize"},{"name":"bool"}],"output":{"name":"result"}}],[11,"bclose","","",623,{"inputs":[{"name":"state"},{"name":"span"}],"output":{"name":"result"}}],[11,"is_begin","","",623,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"is_end","","",623,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"is_bol","","",623,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"in_cbox","","",623,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"hardbreak_if_not_bol","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"space_if_not_bol","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"break_offset_if_not_bol","","",623,{"inputs":[{"name":"state"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[11,"synth_comment","","",623,{"inputs":[{"name":"state"},{"name":"string"}],"output":{"name":"result"}}],[11,"commasep","","",623,null],[11,"commasep_cmnt","","",623,null],[11,"commasep_exprs","","",623,null],[11,"print_mod","","",623,null],[11,"print_foreign_mod","","",623,null],[11,"print_opt_lifetime","","",623,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_type","","",623,{"inputs":[{"name":"state"},{"name":"ty"}],"output":{"name":"result"}}],[11,"print_foreign_item","","",623,{"inputs":[{"name":"state"},{"name":"foreignitem"}],"output":{"name":"result"}}],[11,"print_item","","Pretty-print an item",623,{"inputs":[{"name":"state"},{"name":"item"}],"output":{"name":"result"}}],[11,"print_enum_def","","",623,{"inputs":[{"name":"state"},{"name":"enumdef"},{"name":"generics"},{"name":"ident"},{"name":"span"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_variants","","",623,null],[11,"print_visibility","","",623,{"inputs":[{"name":"state"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_struct","","",623,{"inputs":[{"name":"state"},{"name":"structdef"},{"name":"generics"},{"name":"ident"},{"name":"span"}],"output":{"name":"result"}}],[11,"print_tt","","This doesn't deserve to be called \"pretty\" printing, but it should be\nmeaning-preserving. A quick hack that might help would be to look at the\nspans embedded in the TTs to decide where to put spaces and newlines.\nBut it'd be better to parse these according to the grammar of the\nappropriate macro, transcribe back into the grammar we just parsed from,\nand then pretty-print the resulting AST nodes (so, e.g., we print\nexpression arguments as expressions). It can be done! I think.",623,{"inputs":[{"name":"state"},{"name":"tokentree"}],"output":{"name":"result"}}],[11,"print_tts","","",623,null],[11,"print_variant","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_method_sig","","",623,{"inputs":[{"name":"state"},{"name":"ident"},{"name":"methodsig"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_trait_item","","",623,{"inputs":[{"name":"state"},{"name":"traititem"}],"output":{"name":"result"}}],[11,"print_impl_item","","",623,{"inputs":[{"name":"state"},{"name":"implitem"}],"output":{"name":"result"}}],[11,"print_outer_attributes","","",623,null],[11,"print_inner_attributes","","",623,null],[11,"print_attribute","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_stmt","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_block","","",623,{"inputs":[{"name":"state"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed","","",623,{"inputs":[{"name":"state"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed_indent","","",623,{"inputs":[{"name":"state"},{"name":"block"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_block_with_attrs","","",623,null],[11,"print_block_maybe_unclosed","","",623,null],[11,"print_if","","",623,{"inputs":[{"name":"state"},{"name":"expr"},{"name":"block"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_if_let","","",623,{"inputs":[{"name":"state"},{"name":"pat"},{"name":"expr"},{"name":"block"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_mac","","",623,{"inputs":[{"name":"state"},{"name":"spanned"},{"name":"delimtoken"}],"output":{"name":"result"}}],[11,"print_expr_maybe_paren","","",623,{"inputs":[{"name":"state"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr","","",623,{"inputs":[{"name":"state"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_local_decl","","",623,{"inputs":[{"name":"state"},{"name":"local"}],"output":{"name":"result"}}],[11,"print_decl","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_ident","","",623,{"inputs":[{"name":"state"},{"name":"ident"}],"output":{"name":"result"}}],[11,"print_usize","","",623,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_name","","",623,{"inputs":[{"name":"state"},{"name":"name"}],"output":{"name":"result"}}],[11,"print_for_decl","","",623,{"inputs":[{"name":"state"},{"name":"local"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_pat","","",623,{"inputs":[{"name":"state"},{"name":"pat"}],"output":{"name":"result"}}],[11,"print_fn","","",623,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"unsafety"},{"name":"abi"},{"name":"option"},{"name":"generics"},{"name":"option"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_fn_args","","",623,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_args_and_ret","","",623,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_block_args","","",623,{"inputs":[{"name":"state"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_capture_clause","","",623,{"inputs":[{"name":"state"},{"name":"captureclause"}],"output":{"name":"result"}}],[11,"print_bounds","","",623,null],[11,"print_lifetime","","",623,{"inputs":[{"name":"state"},{"name":"lifetime"}],"output":{"name":"result"}}],[11,"print_lifetime_def","","",623,{"inputs":[{"name":"state"},{"name":"lifetimedef"}],"output":{"name":"result"}}],[11,"print_generics","","",623,{"inputs":[{"name":"state"},{"name":"generics"}],"output":{"name":"result"}}],[11,"print_ty_param","","",623,{"inputs":[{"name":"state"},{"name":"typaram"}],"output":{"name":"result"}}],[11,"print_where_clause","","",623,{"inputs":[{"name":"state"},{"name":"whereclause"}],"output":{"name":"result"}}],[11,"print_meta_item","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_view_path","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_mutability","","",623,{"inputs":[{"name":"state"},{"name":"mutability"}],"output":{"name":"result"}}],[11,"print_mt","","",623,{"inputs":[{"name":"state"},{"name":"mutty"}],"output":{"name":"result"}}],[11,"print_arg","","",623,{"inputs":[{"name":"state"},{"name":"arg"}],"output":{"name":"result"}}],[11,"print_fn_output","","",623,{"inputs":[{"name":"state"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_ty_fn","","",623,{"inputs":[{"name":"state"},{"name":"abi"},{"name":"unsafety"},{"name":"fndecl"},{"name":"option"},{"name":"generics"},{"name":"option"}],"output":{"name":"result"}}],[11,"maybe_print_trailing_comment","","",623,{"inputs":[{"name":"state"},{"name":"span"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_remaining_comments","","",623,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"print_literal","","",623,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"next_lit","","",623,{"inputs":[{"name":"state"},{"name":"bytepos"}],"output":{"name":"option"}}],[11,"maybe_print_comment","","",623,{"inputs":[{"name":"state"},{"name":"bytepos"}],"output":{"name":"result"}}],[11,"print_comment","","",623,{"inputs":[{"name":"state"},{"name":"comment"}],"output":{"name":"result"}}],[11,"print_string","","",623,{"inputs":[{"name":"state"},{"name":"str"},{"name":"strstyle"}],"output":{"name":"result"}}],[11,"next_comment","","",623,{"inputs":[{"name":"state"}],"output":{"name":"option"}}],[11,"print_opt_abi_and_extern_if_nondefault","","",623,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_extern_opt_abi","","",623,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_header_info","","",623,{"inputs":[{"name":"state"},{"name":"unsafety"},{"name":"abi"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_unsafety","","",623,{"inputs":[{"name":"state"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"shared","rustc_trans::trans","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"sharedcratecontext"}}],[11,"local","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"localcratecontext"}}],[11,"rotate","","Get a (possibly) different `CrateContext` from the same\n`SharedCrateContext`.",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"cratecontext"}}],[11,"maybe_iter","","Either iterate over only `self`, or iterate over all `CrateContext`s in\nthe `SharedCrateContext`.  The iterator produces `(ccx, is_origin)`\npairs, where `is_origin` is `true` if `ccx` is `self` and `false`\notherwise.  This method is useful for avoiding code duplication in\ncases where it may or may not be necessary to translate code into every\ncontext.",679,{"inputs":[{"name":"cratecontext"},{"name":"bool"}],"output":{"name":"cratecontextmaybeiterator"}}],[11,"tcx","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"ctxt"}}],[11,"sess","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"session"}}],[11,"builder","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"builder"}}],[11,"raw_builder","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"builderref"}}],[11,"get_intrinsic","","",679,{"inputs":[{"name":"cratecontext"},{"name":"str"}],"output":{"name":"valueref"}}],[11,"is_split_stack_supported","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"bool"}}],[11,"llmod","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"moduleref"}}],[11,"llcx","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"contextref"}}],[11,"td","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"targetdata"}}],[11,"tn","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"typenames"}}],[11,"externs","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"item_vals","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"export_map","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"exportmap"}}],[11,"reachable","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"nodeset"}}],[11,"item_symbols","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"link_meta","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"linkmeta"}}],[11,"needs_unwind_cleanup_cache","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"fn_pointer_shims","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"drop_glues","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"external","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"external_srcs","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"monomorphized","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"monomorphizing","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"vtables","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"const_cstr_cache","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"const_unsized","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"const_globals","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"const_values","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"static_values","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"extern_const_values","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"impl_method_cache","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"closure_bare_wrapper_cache","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"lltypes","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"llsizingtypes","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"adt_reprs","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"symbol_hasher","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"type_hashcodes","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"stats","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"stats"}}],[11,"available_monomorphizations","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"available_drop_glues","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"int_type","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"type"}}],[11,"opaque_vec_type","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"type"}}],[11,"closure_vals","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"dbg_cx","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"option"}}],[11,"eh_personality","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"count_llvm_insn","","",679,{"inputs":[{"name":"cratecontext"}],"output":null}],[11,"trait_cache","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"refcell"}}],[11,"obj_size_bound","","Return exclusive upper bound on object size.",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"u64"}}],[11,"report_overbig_object","","",679,{"inputs":[{"name":"cratecontext"},{"name":"ty"}],"output":null}],[11,"check_overflow","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"bool"}}],[11,"check_drop_flag_for_sanity","","",679,{"inputs":[{"name":"cratecontext"}],"output":{"name":"bool"}}],[11,"debug_loc","syntax::ast","",159,{"inputs":[{"name":"expr"}],"output":{"name":"debugloc"}}],[11,"debug_loc","core::option","",11,{"inputs":[{"name":"option"}],"output":{"name":"debugloc"}}],[11,"llrepr","rustc_trans::trans::llrepr","",680,{"inputs":[{"name":"valueref"},{"name":"cratecontext"}],"output":{"name":"string"}}],[11,"clone","rustc_trans::trans","",465,{"inputs":[{"name":"moduletranslation"}],"output":{"name":"moduletranslation"}}],[0,"save","rustc_trans","Output a CSV file containing the output from rustc's analysis. The data is\nprimarily designed to be used as input to the DXR tool, specifically its\nRust plugin. It could also be used by IDEs or other code browsing, search, or\ncross-referencing tools.",null,null],[5,"process_crate","rustc_trans::save","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"crateanalysis"},{"name":"option"}],"output":null}],[0,"lib","rustc_trans","",null,null],[0,"llvm","rustc_trans::lib","",null,null],[0,"archive_ro","rustc_trans::lib::llvm","A wrapper around LLVM's archive (.a) code",null,null],[3,"ArchiveRO","rustc_trans::lib::llvm::archive_ro","",null,null],[0,"diagnostic","rustc_trans::lib::llvm","LLVM diagnostic reports.",null,null],[4,"OptimizationDiagnosticKind","rustc_trans::lib::llvm::diagnostic","",null,null],[13,"OptimizationRemark","","",382,null],[13,"OptimizationMissed","","",382,null],[13,"OptimizationAnalysis","","",382,null],[13,"OptimizationFailure","","",382,null],[3,"OptimizationDiagnostic","","",null,null],[12,"kind","","",383,null],[12,"pass_name","","",383,null],[12,"function","","",383,null],[12,"debug_loc","","",383,null],[12,"message","","",383,null],[3,"InlineAsmDiagnostic","","",null,null],[12,"cookie","","",384,null],[12,"message","","",384,null],[12,"instruction","","",384,null],[4,"Diagnostic","","",null,null],[13,"Optimization","","",385,null],[13,"InlineAsm","","",385,null],[13,"UnknownDiagnostic","","LLVM has other types that we do not wrap here.",385,null],[6,"Opcode","rustc_trans::lib::llvm","",null,null],[6,"Bool","","",null,null],[17,"True","","",null,null],[17,"False","","",null,null],[4,"CallConv","","",null,null],[13,"CCallConv","","",386,null],[13,"FastCallConv","","",386,null],[13,"ColdCallConv","","",386,null],[13,"X86StdcallCallConv","","",386,null],[13,"X86FastcallCallConv","","",386,null],[13,"X86_64_Win64","","",386,null],[4,"Visibility","","",null,null],[13,"LLVMDefaultVisibility","","",387,null],[13,"HiddenVisibility","","",387,null],[13,"ProtectedVisibility","","",387,null],[4,"Linkage","","",null,null],[13,"ExternalLinkage","","",388,null],[13,"AvailableExternallyLinkage","","",388,null],[13,"LinkOnceAnyLinkage","","",388,null],[13,"LinkOnceODRLinkage","","",388,null],[13,"WeakAnyLinkage","","",388,null],[13,"WeakODRLinkage","","",388,null],[13,"AppendingLinkage","","",388,null],[13,"InternalLinkage","","",388,null],[13,"PrivateLinkage","","",388,null],[13,"ExternalWeakLinkage","","",388,null],[13,"CommonLinkage","","",388,null],[4,"DiagnosticSeverity","","",null,null],[13,"Error","","",389,null],[13,"Warning","","",389,null],[13,"Remark","","",389,null],[13,"Note","","",389,null],[3,"Attribute","","",null,null],[17,"ZExtAttribute","","",null,null],[17,"SExtAttribute","","",null,null],[17,"NoReturnAttribute","","",null,null],[17,"InRegAttribute","","",null,null],[17,"StructRetAttribute","","",null,null],[17,"NoUnwindAttribute","","",null,null],[17,"NoAliasAttribute","","",null,null],[17,"ByValAttribute","","",null,null],[17,"NestAttribute","","",null,null],[17,"ReadNoneAttribute","","",null,null],[17,"ReadOnlyAttribute","","",null,null],[17,"NoInlineAttribute","","",null,null],[17,"AlwaysInlineAttribute","","",null,null],[17,"OptimizeForSizeAttribute","","",null,null],[17,"StackProtectAttribute","","",null,null],[17,"StackProtectReqAttribute","","",null,null],[17,"AlignmentAttribute","","",null,null],[17,"NoCaptureAttribute","","",null,null],[17,"NoRedZoneAttribute","","",null,null],[17,"NoImplicitFloatAttribute","","",null,null],[17,"NakedAttribute","","",null,null],[17,"InlineHintAttribute","","",null,null],[17,"StackAttribute","","",null,null],[17,"ReturnsTwiceAttribute","","",null,null],[17,"UWTableAttribute","","",null,null],[17,"NonLazyBindAttribute","","",null,null],[4,"OtherAttribute","","",null,null],[13,"SanitizeAddressAttribute","","",391,null],[13,"MinSizeAttribute","","",391,null],[13,"NoDuplicateAttribute","","",391,null],[13,"StackProtectStrongAttribute","","",391,null],[13,"SanitizeThreadAttribute","","",391,null],[13,"SanitizeMemoryAttribute","","",391,null],[13,"NoBuiltinAttribute","","",391,null],[13,"ReturnedAttribute","","",391,null],[13,"ColdAttribute","","",391,null],[13,"BuiltinAttribute","","",391,null],[13,"OptimizeNoneAttribute","","",391,null],[13,"InAllocaAttribute","","",391,null],[13,"NonNullAttribute","","",391,null],[4,"SpecialAttribute","","",null,null],[13,"DereferenceableAttribute","","",392,null],[4,"AttributeSet","","",null,null],[13,"ReturnIndex","","",393,null],[13,"FunctionIndex","","",393,null],[8,"AttrHelper","","",null,null],[10,"apply_llfn","","",681,null],[10,"apply_callsite","","",681,null],[3,"AttrBuilder","","",null,null],[4,"IntPredicate","","",null,null],[13,"IntEQ","","",395,null],[13,"IntNE","","",395,null],[13,"IntUGT","","",395,null],[13,"IntUGE","","",395,null],[13,"IntULT","","",395,null],[13,"IntULE","","",395,null],[13,"IntSGT","","",395,null],[13,"IntSGE","","",395,null],[13,"IntSLT","","",395,null],[13,"IntSLE","","",395,null],[4,"RealPredicate","","",null,null],[13,"RealPredicateFalse","","",396,null],[13,"RealOEQ","","",396,null],[13,"RealOGT","","",396,null],[13,"RealOGE","","",396,null],[13,"RealOLT","","",396,null],[13,"RealOLE","","",396,null],[13,"RealONE","","",396,null],[13,"RealORD","","",396,null],[13,"RealUNO","","",396,null],[13,"RealUEQ","","",396,null],[13,"RealUGT","","",396,null],[13,"RealUGE","","",396,null],[13,"RealULT","","",396,null],[13,"RealULE","","",396,null],[13,"RealUNE","","",396,null],[13,"RealPredicateTrue","","",396,null],[4,"TypeKind","","",null,null],[13,"Void","","",397,null],[13,"Half","","",397,null],[13,"Float","","",397,null],[13,"Double","","",397,null],[13,"X86_FP80","","",397,null],[13,"FP128","","",397,null],[13,"PPC_FP128","","",397,null],[13,"Label","","",397,null],[13,"Integer","","",397,null],[13,"Function","","",397,null],[13,"Struct","","",397,null],[13,"Array","","",397,null],[13,"Pointer","","",397,null],[13,"Vector","","",397,null],[13,"Metadata","","",397,null],[13,"X86_MMX","","",397,null],[4,"AtomicBinOp","","",null,null],[13,"AtomicXchg","","",398,null],[13,"AtomicAdd","","",398,null],[13,"AtomicSub","","",398,null],[13,"AtomicAnd","","",398,null],[13,"AtomicNand","","",398,null],[13,"AtomicOr","","",398,null],[13,"AtomicXor","","",398,null],[13,"AtomicMax","","",398,null],[13,"AtomicMin","","",398,null],[13,"AtomicUMax","","",398,null],[13,"AtomicUMin","","",398,null],[4,"AtomicOrdering","","",null,null],[13,"NotAtomic","","",399,null],[13,"Unordered","","",399,null],[13,"Monotonic","","",399,null],[13,"Acquire","","",399,null],[13,"Release","","",399,null],[13,"AcquireRelease","","",399,null],[13,"SequentiallyConsistent","","",399,null],[4,"FileType","","",null,null],[13,"AssemblyFileType","","",400,null],[13,"ObjectFileType","","",400,null],[4,"MetadataType","","",null,null],[13,"MD_dbg","","",401,null],[13,"MD_tbaa","","",401,null],[13,"MD_prof","","",401,null],[13,"MD_fpmath","","",401,null],[13,"MD_range","","",401,null],[13,"MD_tbaa_struct","","",401,null],[13,"MD_invariant_load","","",401,null],[13,"MD_alias_scope","","",401,null],[13,"MD_noalias","","",401,null],[13,"MD_nontemporal","","",401,null],[13,"MD_mem_parallel_loop_access","","",401,null],[13,"MD_nonnull","","",401,null],[4,"AsmDialect","","",null,null],[13,"AD_ATT","","",402,null],[13,"AD_Intel","","",402,null],[4,"CodeGenOptLevel","","",null,null],[13,"CodeGenLevelNone","","",403,null],[13,"CodeGenLevelLess","","",403,null],[13,"CodeGenLevelDefault","","",403,null],[13,"CodeGenLevelAggressive","","",403,null],[4,"RelocMode","","",null,null],[13,"RelocDefault","","",404,null],[13,"RelocStatic","","",404,null],[13,"RelocPIC","","",404,null],[13,"RelocDynamicNoPic","","",404,null],[4,"CodeGenModel","","",null,null],[13,"CodeModelDefault","","",405,null],[13,"CodeModelJITDefault","","",405,null],[13,"CodeModelSmall","","",405,null],[13,"CodeModelKernel","","",405,null],[13,"CodeModelMedium","","",405,null],[13,"CodeModelLarge","","",405,null],[4,"DiagnosticKind","","",null,null],[13,"DK_InlineAsm","","",406,null],[13,"DK_StackSize","","",406,null],[13,"DK_DebugMetadataVersion","","",406,null],[13,"DK_SampleProfile","","",406,null],[13,"DK_OptimizationRemark","","",406,null],[13,"DK_OptimizationRemarkMissed","","",406,null],[13,"DK_OptimizationRemarkAnalysis","","",406,null],[13,"DK_OptimizationFailure","","",406,null],[4,"Module_opaque","","",null,null],[6,"ModuleRef","","",null,null],[4,"Context_opaque","","",null,null],[6,"ContextRef","","",null,null],[4,"Type_opaque","","",null,null],[6,"TypeRef","","",null,null],[4,"Value_opaque","","",null,null],[6,"ValueRef","","",null,null],[4,"Metadata_opaque","","",null,null],[6,"MetadataRef","","",null,null],[4,"BasicBlock_opaque","","",null,null],[6,"BasicBlockRef","","",null,null],[4,"Builder_opaque","","",null,null],[6,"BuilderRef","","",null,null],[4,"ExecutionEngine_opaque","","",null,null],[6,"ExecutionEngineRef","","",null,null],[4,"RustJITMemoryManager_opaque","","",null,null],[6,"RustJITMemoryManagerRef","","",null,null],[4,"MemoryBuffer_opaque","","",null,null],[6,"MemoryBufferRef","","",null,null],[4,"PassManager_opaque","","",null,null],[6,"PassManagerRef","","",null,null],[4,"PassManagerBuilder_opaque","","",null,null],[6,"PassManagerBuilderRef","","",null,null],[4,"Use_opaque","","",null,null],[6,"UseRef","","",null,null],[4,"TargetData_opaque","","",null,null],[6,"TargetDataRef","","",null,null],[4,"ObjectFile_opaque","","",null,null],[6,"ObjectFileRef","","",null,null],[4,"SectionIterator_opaque","","",null,null],[6,"SectionIteratorRef","","",null,null],[4,"Pass_opaque","","",null,null],[6,"PassRef","","",null,null],[4,"TargetMachine_opaque","","",null,null],[6,"TargetMachineRef","","",null,null],[4,"Archive_opaque","","",null,null],[6,"ArchiveRef","","",null,null],[4,"Twine_opaque","","",null,null],[6,"TwineRef","","",null,null],[4,"DiagnosticInfo_opaque","","",null,null],[6,"DiagnosticInfoRef","","",null,null],[4,"DebugLoc_opaque","","",null,null],[6,"DebugLocRef","","",null,null],[4,"SMDiagnostic_opaque","","",null,null],[6,"SMDiagnosticRef","","",null,null],[6,"DiagnosticHandler","","",null,null],[6,"InlineAsmDiagHandler","","",null,null],[0,"debuginfo","","",null,null],[4,"DIBuilder_opaque","rustc_trans::lib::llvm::debuginfo","",null,null],[6,"DIBuilderRef","","",null,null],[6,"DIDescriptor","","",null,null],[6,"DIScope","","",null,null],[6,"DILocation","","",null,null],[6,"DIFile","","",null,null],[6,"DILexicalBlock","","",null,null],[6,"DISubprogram","","",null,null],[6,"DINameSpace","","",null,null],[6,"DIType","","",null,null],[6,"DIBasicType","","",null,null],[6,"DIDerivedType","","",null,null],[6,"DICompositeType","","",null,null],[6,"DIVariable","","",null,null],[6,"DIGlobalVariable","","",null,null],[6,"DIArray","","",null,null],[6,"DISubrange","","",null,null],[6,"DIEnumerator","","",null,null],[6,"DITemplateTypeParameter","","",null,null],[4,"DIDescriptorFlags","","",null,null],[13,"FlagPrivate","","",407,null],[13,"FlagProtected","","",407,null],[13,"FlagFwdDecl","","",407,null],[13,"FlagAppleBlock","","",407,null],[13,"FlagBlockByrefStruct","","",407,null],[13,"FlagVirtual","","",407,null],[13,"FlagArtificial","","",407,null],[13,"FlagExplicit","","",407,null],[13,"FlagPrototyped","","",407,null],[13,"FlagObjcClassComplete","","",407,null],[13,"FlagObjectPointer","","",407,null],[13,"FlagVector","","",407,null],[13,"FlagStaticMember","","",407,null],[13,"FlagIndirectVariable","","",407,null],[13,"FlagLValueReference","","",407,null],[13,"FlagRValueReference","","",407,null],[5,"LLVMContextCreate","rustc_trans::lib::llvm","",null,null],[5,"LLVMContextDispose","","",null,null],[5,"LLVMGetMDKindIDInContext","","",null,null],[5,"LLVMModuleCreateWithNameInContext","","",null,null],[5,"LLVMGetModuleContext","","",null,null],[5,"LLVMDisposeModule","","",null,null],[5,"LLVMGetDataLayout","","Data layout. See Module::getDataLayout.",null,null],[5,"LLVMSetDataLayout","","",null,null],[5,"LLVMGetTarget","","Target triple. See Module::getTargetTriple.",null,null],[5,"LLVMSetTarget","","",null,null],[5,"LLVMDumpModule","","See Module::dump.",null,null],[5,"LLVMSetModuleInlineAsm","","See Module::setModuleInlineAsm.",null,null],[5,"LLVMGetTypeKind","","See llvm::LLVMTypeKind::getTypeID.",null,null],[5,"LLVMGetTypeContext","","See llvm::LLVMType::getContext.",null,null],[5,"LLVMInt1TypeInContext","","",null,null],[5,"LLVMInt8TypeInContext","","",null,null],[5,"LLVMInt16TypeInContext","","",null,null],[5,"LLVMInt32TypeInContext","","",null,null],[5,"LLVMInt64TypeInContext","","",null,null],[5,"LLVMIntTypeInContext","","",null,null],[5,"LLVMGetIntTypeWidth","","",null,null],[5,"LLVMFloatTypeInContext","","",null,null],[5,"LLVMDoubleTypeInContext","","",null,null],[5,"LLVMX86FP80TypeInContext","","",null,null],[5,"LLVMFP128TypeInContext","","",null,null],[5,"LLVMPPCFP128TypeInContext","","",null,null],[5,"LLVMFunctionType","","",null,null],[5,"LLVMIsFunctionVarArg","","",null,null],[5,"LLVMGetReturnType","","",null,null],[5,"LLVMCountParamTypes","","",null,null],[5,"LLVMGetParamTypes","","",null,null],[5,"LLVMStructTypeInContext","","",null,null],[5,"LLVMCountStructElementTypes","","",null,null],[5,"LLVMGetStructElementTypes","","",null,null],[5,"LLVMIsPackedStruct","","",null,null],[5,"LLVMRustArrayType","","",null,null],[5,"LLVMPointerType","","",null,null],[5,"LLVMVectorType","","",null,null],[5,"LLVMGetElementType","","",null,null],[5,"LLVMGetArrayLength","","",null,null],[5,"LLVMGetPointerAddressSpace","","",null,null],[5,"LLVMGetPointerToGlobal","","",null,null],[5,"LLVMGetVectorSize","","",null,null],[5,"LLVMVoidTypeInContext","","",null,null],[5,"LLVMLabelTypeInContext","","",null,null],[5,"LLVMMetadataTypeInContext","","",null,null],[5,"LLVMTypeOf","","",null,null],[5,"LLVMGetValueName","","",null,null],[5,"LLVMSetValueName","","",null,null],[5,"LLVMDumpValue","","",null,null],[5,"LLVMReplaceAllUsesWith","","",null,null],[5,"LLVMHasMetadata","","",null,null],[5,"LLVMGetMetadata","","",null,null],[5,"LLVMSetMetadata","","",null,null],[5,"LLVMGetFirstUse","","",null,null],[5,"LLVMGetNextUse","","",null,null],[5,"LLVMGetUser","","",null,null],[5,"LLVMGetUsedValue","","",null,null],[5,"LLVMGetNumOperands","","",null,null],[5,"LLVMGetOperand","","",null,null],[5,"LLVMSetOperand","","",null,null],[5,"LLVMConstNull","","",null,null],[5,"LLVMConstAllOnes","","",null,null],[5,"LLVMConstICmp","","",null,null],[5,"LLVMConstFCmp","","",null,null],[5,"LLVMGetUndef","","",null,null],[5,"LLVMIsConstant","","",null,null],[5,"LLVMIsNull","","",null,null],[5,"LLVMIsUndef","","",null,null],[5,"LLVMConstPointerNull","","",null,null],[5,"LLVMMDStringInContext","","",null,null],[5,"LLVMMDNodeInContext","","",null,null],[5,"LLVMAddNamedMetadataOperand","","",null,null],[5,"LLVMConstInt","","",null,null],[5,"LLVMConstIntOfString","","",null,null],[5,"LLVMConstIntOfStringAndSize","","",null,null],[5,"LLVMConstReal","","",null,null],[5,"LLVMConstRealOfString","","",null,null],[5,"LLVMConstRealOfStringAndSize","","",null,null],[5,"LLVMConstIntGetZExtValue","","",null,null],[5,"LLVMConstIntGetSExtValue","","",null,null],[5,"LLVMConstStringInContext","","",null,null],[5,"LLVMConstStructInContext","","",null,null],[5,"LLVMConstArray","","",null,null],[5,"LLVMConstVector","","",null,null],[5,"LLVMAlignOf","","",null,null],[5,"LLVMSizeOf","","",null,null],[5,"LLVMConstNeg","","",null,null],[5,"LLVMConstNSWNeg","","",null,null],[5,"LLVMConstNUWNeg","","",null,null],[5,"LLVMConstFNeg","","",null,null],[5,"LLVMConstNot","","",null,null],[5,"LLVMConstAdd","","",null,null],[5,"LLVMConstNSWAdd","","",null,null],[5,"LLVMConstNUWAdd","","",null,null],[5,"LLVMConstFAdd","","",null,null],[5,"LLVMConstSub","","",null,null],[5,"LLVMConstNSWSub","","",null,null],[5,"LLVMConstNUWSub","","",null,null],[5,"LLVMConstFSub","","",null,null],[5,"LLVMConstMul","","",null,null],[5,"LLVMConstNSWMul","","",null,null],[5,"LLVMConstNUWMul","","",null,null],[5,"LLVMConstFMul","","",null,null],[5,"LLVMConstUDiv","","",null,null],[5,"LLVMConstSDiv","","",null,null],[5,"LLVMConstExactSDiv","","",null,null],[5,"LLVMConstFDiv","","",null,null],[5,"LLVMConstURem","","",null,null],[5,"LLVMConstSRem","","",null,null],[5,"LLVMConstFRem","","",null,null],[5,"LLVMConstAnd","","",null,null],[5,"LLVMConstOr","","",null,null],[5,"LLVMConstXor","","",null,null],[5,"LLVMConstShl","","",null,null],[5,"LLVMConstLShr","","",null,null],[5,"LLVMConstAShr","","",null,null],[5,"LLVMConstGEP","","",null,null],[5,"LLVMConstInBoundsGEP","","",null,null],[5,"LLVMConstTrunc","","",null,null],[5,"LLVMConstSExt","","",null,null],[5,"LLVMConstZExt","","",null,null],[5,"LLVMConstFPTrunc","","",null,null],[5,"LLVMConstFPExt","","",null,null],[5,"LLVMConstUIToFP","","",null,null],[5,"LLVMConstSIToFP","","",null,null],[5,"LLVMConstFPToUI","","",null,null],[5,"LLVMConstFPToSI","","",null,null],[5,"LLVMConstPtrToInt","","",null,null],[5,"LLVMConstIntToPtr","","",null,null],[5,"LLVMConstBitCast","","",null,null],[5,"LLVMConstZExtOrBitCast","","",null,null],[5,"LLVMConstSExtOrBitCast","","",null,null],[5,"LLVMConstTruncOrBitCast","","",null,null],[5,"LLVMConstPointerCast","","",null,null],[5,"LLVMConstIntCast","","",null,null],[5,"LLVMConstFPCast","","",null,null],[5,"LLVMConstSelect","","",null,null],[5,"LLVMConstExtractElement","","",null,null],[5,"LLVMConstInsertElement","","",null,null],[5,"LLVMConstShuffleVector","","",null,null],[5,"LLVMConstExtractValue","","",null,null],[5,"LLVMConstInsertValue","","",null,null],[5,"LLVMConstInlineAsm","","",null,null],[5,"LLVMBlockAddress","","",null,null],[5,"LLVMGetGlobalParent","","",null,null],[5,"LLVMIsDeclaration","","",null,null],[5,"LLVMGetLinkage","","",null,null],[5,"LLVMSetLinkage","","",null,null],[5,"LLVMGetSection","","",null,null],[5,"LLVMSetSection","","",null,null],[5,"LLVMGetVisibility","","",null,null],[5,"LLVMSetVisibility","","",null,null],[5,"LLVMGetAlignment","","",null,null],[5,"LLVMSetAlignment","","",null,null],[5,"LLVMIsAGlobalVariable","","",null,null],[5,"LLVMAddGlobal","","",null,null],[5,"LLVMAddGlobalInAddressSpace","","",null,null],[5,"LLVMGetNamedGlobal","","",null,null],[5,"LLVMGetOrInsertGlobal","","",null,null],[5,"LLVMGetFirstGlobal","","",null,null],[5,"LLVMGetLastGlobal","","",null,null],[5,"LLVMGetNextGlobal","","",null,null],[5,"LLVMGetPreviousGlobal","","",null,null],[5,"LLVMDeleteGlobal","","",null,null],[5,"LLVMGetInitializer","","",null,null],[5,"LLVMSetInitializer","","",null,null],[5,"LLVMIsThreadLocal","","",null,null],[5,"LLVMSetThreadLocal","","",null,null],[5,"LLVMIsGlobalConstant","","",null,null],[5,"LLVMSetGlobalConstant","","",null,null],[5,"LLVMGetNamedValue","","",null,null],[5,"LLVMAddAlias","","",null,null],[5,"LLVMAddFunction","","",null,null],[5,"LLVMGetNamedFunction","","",null,null],[5,"LLVMGetFirstFunction","","",null,null],[5,"LLVMGetLastFunction","","",null,null],[5,"LLVMGetNextFunction","","",null,null],[5,"LLVMGetPreviousFunction","","",null,null],[5,"LLVMDeleteFunction","","",null,null],[5,"LLVMGetOrInsertFunction","","",null,null],[5,"LLVMGetIntrinsicID","","",null,null],[5,"LLVMGetFunctionCallConv","","",null,null],[5,"LLVMSetFunctionCallConv","","",null,null],[5,"LLVMGetGC","","",null,null],[5,"LLVMSetGC","","",null,null],[5,"LLVMAddDereferenceableAttr","","",null,null],[5,"LLVMAddFunctionAttribute","","",null,null],[5,"LLVMAddFunctionAttrString","","",null,null],[5,"LLVMRemoveFunctionAttrString","","",null,null],[5,"LLVMGetFunctionAttr","","",null,null],[5,"LLVMRemoveFunctionAttr","","",null,null],[5,"LLVMCountParams","","",null,null],[5,"LLVMGetParams","","",null,null],[5,"LLVMGetParam","","",null,null],[5,"LLVMGetParamParent","","",null,null],[5,"LLVMGetFirstParam","","",null,null],[5,"LLVMGetLastParam","","",null,null],[5,"LLVMGetNextParam","","",null,null],[5,"LLVMGetPreviousParam","","",null,null],[5,"LLVMAddAttribute","","",null,null],[5,"LLVMRemoveAttribute","","",null,null],[5,"LLVMGetAttribute","","",null,null],[5,"LLVMSetParamAlignment","","",null,null],[5,"LLVMBasicBlockAsValue","","",null,null],[5,"LLVMValueIsBasicBlock","","",null,null],[5,"LLVMValueAsBasicBlock","","",null,null],[5,"LLVMGetBasicBlockParent","","",null,null],[5,"LLVMCountBasicBlocks","","",null,null],[5,"LLVMGetBasicBlocks","","",null,null],[5,"LLVMGetFirstBasicBlock","","",null,null],[5,"LLVMGetLastBasicBlock","","",null,null],[5,"LLVMGetNextBasicBlock","","",null,null],[5,"LLVMGetPreviousBasicBlock","","",null,null],[5,"LLVMGetEntryBasicBlock","","",null,null],[5,"LLVMAppendBasicBlockInContext","","",null,null],[5,"LLVMInsertBasicBlockInContext","","",null,null],[5,"LLVMDeleteBasicBlock","","",null,null],[5,"LLVMMoveBasicBlockAfter","","",null,null],[5,"LLVMMoveBasicBlockBefore","","",null,null],[5,"LLVMGetInstructionParent","","",null,null],[5,"LLVMGetFirstInstruction","","",null,null],[5,"LLVMGetLastInstruction","","",null,null],[5,"LLVMGetNextInstruction","","",null,null],[5,"LLVMGetPreviousInstruction","","",null,null],[5,"LLVMInstructionEraseFromParent","","",null,null],[5,"LLVMSetInstructionCallConv","","",null,null],[5,"LLVMGetInstructionCallConv","","",null,null],[5,"LLVMAddInstrAttribute","","",null,null],[5,"LLVMRemoveInstrAttribute","","",null,null],[5,"LLVMSetInstrParamAlignment","","",null,null],[5,"LLVMAddCallSiteAttribute","","",null,null],[5,"LLVMAddDereferenceableCallSiteAttr","","",null,null],[5,"LLVMIsTailCall","","",null,null],[5,"LLVMSetTailCall","","",null,null],[5,"LLVMGetVolatile","","",null,null],[5,"LLVMSetVolatile","","",null,null],[5,"LLVMAddIncoming","","",null,null],[5,"LLVMCountIncoming","","",null,null],[5,"LLVMGetIncomingValue","","",null,null],[5,"LLVMGetIncomingBlock","","",null,null],[5,"LLVMCreateBuilderInContext","","",null,null],[5,"LLVMPositionBuilder","","",null,null],[5,"LLVMPositionBuilderBefore","","",null,null],[5,"LLVMPositionBuilderAtEnd","","",null,null],[5,"LLVMGetInsertBlock","","",null,null],[5,"LLVMClearInsertionPosition","","",null,null],[5,"LLVMInsertIntoBuilder","","",null,null],[5,"LLVMInsertIntoBuilderWithName","","",null,null],[5,"LLVMDisposeBuilder","","",null,null],[5,"LLVMRustCreateJITMemoryManager","","",null,null],[5,"LLVMBuildExecutionEngine","","",null,null],[5,"LLVMDisposeExecutionEngine","","",null,null],[5,"LLVMExecutionEngineFinalizeObject","","",null,null],[5,"LLVMRustLoadDynamicLibrary","","",null,null],[5,"LLVMExecutionEngineAddModule","","",null,null],[5,"LLVMExecutionEngineRemoveModule","","",null,null],[5,"LLVMSetCurrentDebugLocation","","",null,null],[5,"LLVMGetCurrentDebugLocation","","",null,null],[5,"LLVMSetInstDebugLocation","","",null,null],[5,"LLVMBuildRetVoid","","",null,null],[5,"LLVMBuildRet","","",null,null],[5,"LLVMBuildAggregateRet","","",null,null],[5,"LLVMBuildBr","","",null,null],[5,"LLVMBuildCondBr","","",null,null],[5,"LLVMBuildSwitch","","",null,null],[5,"LLVMBuildIndirectBr","","",null,null],[5,"LLVMBuildInvoke","","",null,null],[5,"LLVMBuildLandingPad","","",null,null],[5,"LLVMBuildResume","","",null,null],[5,"LLVMBuildUnreachable","","",null,null],[5,"LLVMAddCase","","",null,null],[5,"LLVMAddDestination","","",null,null],[5,"LLVMAddClause","","",null,null],[5,"LLVMSetCleanup","","",null,null],[5,"LLVMBuildAdd","","",null,null],[5,"LLVMBuildNSWAdd","","",null,null],[5,"LLVMBuildNUWAdd","","",null,null],[5,"LLVMBuildFAdd","","",null,null],[5,"LLVMBuildSub","","",null,null],[5,"LLVMBuildNSWSub","","",null,null],[5,"LLVMBuildNUWSub","","",null,null],[5,"LLVMBuildFSub","","",null,null],[5,"LLVMBuildMul","","",null,null],[5,"LLVMBuildNSWMul","","",null,null],[5,"LLVMBuildNUWMul","","",null,null],[5,"LLVMBuildFMul","","",null,null],[5,"LLVMBuildUDiv","","",null,null],[5,"LLVMBuildSDiv","","",null,null],[5,"LLVMBuildExactSDiv","","",null,null],[5,"LLVMBuildFDiv","","",null,null],[5,"LLVMBuildURem","","",null,null],[5,"LLVMBuildSRem","","",null,null],[5,"LLVMBuildFRem","","",null,null],[5,"LLVMBuildShl","","",null,null],[5,"LLVMBuildLShr","","",null,null],[5,"LLVMBuildAShr","","",null,null],[5,"LLVMBuildAnd","","",null,null],[5,"LLVMBuildOr","","",null,null],[5,"LLVMBuildXor","","",null,null],[5,"LLVMBuildBinOp","","",null,null],[5,"LLVMBuildNeg","","",null,null],[5,"LLVMBuildNSWNeg","","",null,null],[5,"LLVMBuildNUWNeg","","",null,null],[5,"LLVMBuildFNeg","","",null,null],[5,"LLVMBuildNot","","",null,null],[5,"LLVMBuildMalloc","","",null,null],[5,"LLVMBuildArrayMalloc","","",null,null],[5,"LLVMBuildAlloca","","",null,null],[5,"LLVMBuildArrayAlloca","","",null,null],[5,"LLVMBuildFree","","",null,null],[5,"LLVMBuildLoad","","",null,null],[5,"LLVMBuildStore","","",null,null],[5,"LLVMBuildGEP","","",null,null],[5,"LLVMBuildInBoundsGEP","","",null,null],[5,"LLVMBuildStructGEP","","",null,null],[5,"LLVMBuildGlobalString","","",null,null],[5,"LLVMBuildGlobalStringPtr","","",null,null],[5,"LLVMBuildTrunc","","",null,null],[5,"LLVMBuildZExt","","",null,null],[5,"LLVMBuildSExt","","",null,null],[5,"LLVMBuildFPToUI","","",null,null],[5,"LLVMBuildFPToSI","","",null,null],[5,"LLVMBuildUIToFP","","",null,null],[5,"LLVMBuildSIToFP","","",null,null],[5,"LLVMBuildFPTrunc","","",null,null],[5,"LLVMBuildFPExt","","",null,null],[5,"LLVMBuildPtrToInt","","",null,null],[5,"LLVMBuildIntToPtr","","",null,null],[5,"LLVMBuildBitCast","","",null,null],[5,"LLVMBuildZExtOrBitCast","","",null,null],[5,"LLVMBuildSExtOrBitCast","","",null,null],[5,"LLVMBuildTruncOrBitCast","","",null,null],[5,"LLVMBuildCast","","",null,null],[5,"LLVMBuildPointerCast","","",null,null],[5,"LLVMBuildIntCast","","",null,null],[5,"LLVMBuildFPCast","","",null,null],[5,"LLVMBuildICmp","","",null,null],[5,"LLVMBuildFCmp","","",null,null],[5,"LLVMBuildPhi","","",null,null],[5,"LLVMBuildCall","","",null,null],[5,"LLVMBuildSelect","","",null,null],[5,"LLVMBuildVAArg","","",null,null],[5,"LLVMBuildExtractElement","","",null,null],[5,"LLVMBuildInsertElement","","",null,null],[5,"LLVMBuildShuffleVector","","",null,null],[5,"LLVMBuildExtractValue","","",null,null],[5,"LLVMBuildInsertValue","","",null,null],[5,"LLVMBuildIsNull","","",null,null],[5,"LLVMBuildIsNotNull","","",null,null],[5,"LLVMBuildPtrDiff","","",null,null],[5,"LLVMBuildAtomicLoad","","",null,null],[5,"LLVMBuildAtomicStore","","",null,null],[5,"LLVMBuildAtomicCmpXchg","","",null,null],[5,"LLVMBuildAtomicRMW","","",null,null],[5,"LLVMBuildAtomicFence","","",null,null],[5,"LLVMIsATerminatorInst","","",null,null],[5,"LLVMIsAStoreInst","","",null,null],[5,"LLVMWriteBitcodeToFile","","Writes a module to the specified path. Returns 0 on success.",null,null],[5,"LLVMCreateTargetData","","Creates target data from a target layout string.",null,null],[5,"LLVMAddTargetData","","Adds the target data to the given pass manager. The pass manager\nreferences the target data only weakly.",null,null],[5,"LLVMStoreSizeOfType","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMSizeOfTypeInBits","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMABISizeOfType","","Distance between successive elements in an array of T. Includes ABI padding.",null,null],[5,"LLVMPreferredAlignmentOfType","","Returns the preferred alignment of a type.",null,null],[5,"LLVMABIAlignmentOfType","","Returns the minimum alignment of a type.",null,null],[5,"LLVMOffsetOfElement","","Computes the byte offset of the indexed struct element for a\ntarget.",null,null],[5,"LLVMCallFrameAlignmentOfType","","Returns the minimum alignment of a type when part of a call frame.",null,null],[5,"LLVMDisposeTargetData","","Disposes target data.",null,null],[5,"LLVMCreatePassManager","","Creates a pass manager.",null,null],[5,"LLVMCreateFunctionPassManagerForModule","","Creates a function-by-function pass manager",null,null],[5,"LLVMDisposePassManager","","Disposes a pass manager.",null,null],[5,"LLVMRunPassManager","","Runs a pass manager on a module.",null,null],[5,"LLVMRunFunctionPassManager","","Runs the function passes on the provided function.",null,null],[5,"LLVMInitializeFunctionPassManager","","Initializes all the function passes scheduled in the manager",null,null],[5,"LLVMFinalizeFunctionPassManager","","Finalizes all the function passes scheduled in the manager",null,null],[5,"LLVMInitializePasses","","",null,null],[5,"LLVMAddVerifierPass","","Adds a verification pass.",null,null],[5,"LLVMAddGlobalOptimizerPass","","",null,null],[5,"LLVMAddIPSCCPPass","","",null,null],[5,"LLVMAddDeadArgEliminationPass","","",null,null],[5,"LLVMAddInstructionCombiningPass","","",null,null],[5,"LLVMAddCFGSimplificationPass","","",null,null],[5,"LLVMAddFunctionInliningPass","","",null,null],[5,"LLVMAddFunctionAttrsPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPassSSA","","",null,null],[5,"LLVMAddJumpThreadingPass","","",null,null],[5,"LLVMAddConstantPropagationPass","","",null,null],[5,"LLVMAddReassociatePass","","",null,null],[5,"LLVMAddLoopRotatePass","","",null,null],[5,"LLVMAddLICMPass","","",null,null],[5,"LLVMAddLoopUnswitchPass","","",null,null],[5,"LLVMAddLoopDeletionPass","","",null,null],[5,"LLVMAddLoopUnrollPass","","",null,null],[5,"LLVMAddGVNPass","","",null,null],[5,"LLVMAddMemCpyOptPass","","",null,null],[5,"LLVMAddSCCPPass","","",null,null],[5,"LLVMAddDeadStoreEliminationPass","","",null,null],[5,"LLVMAddStripDeadPrototypesPass","","",null,null],[5,"LLVMAddConstantMergePass","","",null,null],[5,"LLVMAddArgumentPromotionPass","","",null,null],[5,"LLVMAddTailCallEliminationPass","","",null,null],[5,"LLVMAddIndVarSimplifyPass","","",null,null],[5,"LLVMAddAggressiveDCEPass","","",null,null],[5,"LLVMAddGlobalDCEPass","","",null,null],[5,"LLVMAddCorrelatedValuePropagationPass","","",null,null],[5,"LLVMAddPruneEHPass","","",null,null],[5,"LLVMAddSimplifyLibCallsPass","","",null,null],[5,"LLVMAddLoopIdiomPass","","",null,null],[5,"LLVMAddEarlyCSEPass","","",null,null],[5,"LLVMAddTypeBasedAliasAnalysisPass","","",null,null],[5,"LLVMAddBasicAliasAnalysisPass","","",null,null],[5,"LLVMPassManagerBuilderCreate","","",null,null],[5,"LLVMPassManagerBuilderDispose","","",null,null],[5,"LLVMPassManagerBuilderSetOptLevel","","",null,null],[5,"LLVMPassManagerBuilderSetSizeLevel","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnitAtATime","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnrollLoops","","",null,null],[5,"LLVMPassManagerBuilderSetDisableSimplifyLibCalls","","",null,null],[5,"LLVMPassManagerBuilderUseInlinerWithThreshold","","",null,null],[5,"LLVMPassManagerBuilderPopulateModulePassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateFunctionPassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateLTOPassManager","","",null,null],[5,"LLVMDisposeMemoryBuffer","","Destroys a memory buffer.",null,null],[5,"LLVMCreateObjectFile","","Opens an object file.",null,null],[5,"LLVMDisposeObjectFile","","Closes an object file.",null,null],[5,"LLVMGetSections","","Enumerates the sections in an object file.",null,null],[5,"LLVMDisposeSectionIterator","","Destroys a section iterator.",null,null],[5,"LLVMIsSectionIteratorAtEnd","","Returns true if the section iterator is at the end of the section\nlist:",null,null],[5,"LLVMMoveToNextSection","","Moves the section iterator to point to the next section.",null,null],[5,"LLVMGetSectionSize","","Returns the current section size.",null,null],[5,"LLVMGetSectionContents","","Returns the current section contents as a string buffer.",null,null],[5,"LLVMRustCreateMemoryBufferWithContentsOfFile","","Reads the given file and returns it as a memory buffer. Use\nLLVMDisposeMemoryBuffer() to get rid of it.",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRange","","Borrows the contents of the memory buffer (doesn't copy it)",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRangeCopy","","",null,null],[5,"LLVMIsMultithreaded","","",null,{"inputs":[],"output":{"name":"u32"}}],[5,"LLVMStartMultithreaded","","",null,{"inputs":[],"output":{"name":"u32"}}],[5,"LLVMRustGetLastError","","Returns a string describing the last error caused by an LLVMRust* call.",null,null],[5,"LLVMRustPrintPassTimings","","Print the pass timings since static dtors aren't picking them up.",null,null],[5,"LLVMStructCreateNamed","","",null,null],[5,"LLVMStructSetBody","","",null,null],[5,"LLVMConstNamedStruct","","",null,null],[5,"LLVMSetDebug","","Enables LLVM debug output.",null,null],[5,"LLVMInlineAsm","","Prepares inline assembly.",null,null],[7,"LLVMRustDebugMetadataVersion","","",null,null],[5,"LLVMRustAddModuleFlag","","",null,null],[5,"LLVMDIBuilderCreate","","",null,null],[5,"LLVMDIBuilderDispose","","",null,null],[5,"LLVMDIBuilderFinalize","","",null,null],[5,"LLVMDIBuilderCreateCompileUnit","","",null,null],[5,"LLVMDIBuilderCreateFile","","",null,null],[5,"LLVMDIBuilderCreateSubroutineType","","",null,null],[5,"LLVMDIBuilderCreateFunction","","",null,null],[5,"LLVMDIBuilderCreateBasicType","","",null,null],[5,"LLVMDIBuilderCreatePointerType","","",null,null],[5,"LLVMDIBuilderCreateStructType","","",null,null],[5,"LLVMDIBuilderCreateMemberType","","",null,null],[5,"LLVMDIBuilderCreateLexicalBlock","","",null,null],[5,"LLVMDIBuilderCreateStaticVariable","","",null,null],[5,"LLVMDIBuilderCreateVariable","","",null,null],[5,"LLVMDIBuilderCreateArrayType","","",null,null],[5,"LLVMDIBuilderCreateVectorType","","",null,null],[5,"LLVMDIBuilderGetOrCreateSubrange","","",null,null],[5,"LLVMDIBuilderGetOrCreateArray","","",null,null],[5,"LLVMDIBuilderInsertDeclareAtEnd","","",null,null],[5,"LLVMDIBuilderInsertDeclareBefore","","",null,null],[5,"LLVMDIBuilderCreateEnumerator","","",null,null],[5,"LLVMDIBuilderCreateEnumerationType","","",null,null],[5,"LLVMDIBuilderCreateUnionType","","",null,null],[5,"LLVMSetUnnamedAddr","","",null,null],[5,"LLVMDIBuilderCreateTemplateTypeParameter","","",null,null],[5,"LLVMDIBuilderCreateOpDeref","","",null,{"inputs":[],"output":{"name":"i64"}}],[5,"LLVMDIBuilderCreateOpPlus","","",null,{"inputs":[],"output":{"name":"i64"}}],[5,"LLVMDIBuilderCreateNameSpace","","",null,null],[5,"LLVMDIBuilderCreateDebugLocation","","",null,null],[5,"LLVMDICompositeTypeSetTypeArray","","",null,null],[5,"LLVMWriteTypeToString","","",null,null],[5,"LLVMWriteValueToString","","",null,null],[5,"LLVMIsAArgument","","",null,null],[5,"LLVMIsAAllocaInst","","",null,null],[5,"LLVMIsAConstantInt","","",null,null],[5,"LLVMInitializeX86TargetInfo","","",null,null],[5,"LLVMInitializeX86Target","","",null,null],[5,"LLVMInitializeX86TargetMC","","",null,null],[5,"LLVMInitializeX86AsmPrinter","","",null,null],[5,"LLVMInitializeX86AsmParser","","",null,null],[5,"LLVMInitializeARMTargetInfo","","",null,null],[5,"LLVMInitializeARMTarget","","",null,null],[5,"LLVMInitializeARMTargetMC","","",null,null],[5,"LLVMInitializeARMAsmPrinter","","",null,null],[5,"LLVMInitializeARMAsmParser","","",null,null],[5,"LLVMInitializeAArch64TargetInfo","","",null,null],[5,"LLVMInitializeAArch64Target","","",null,null],[5,"LLVMInitializeAArch64TargetMC","","",null,null],[5,"LLVMInitializeAArch64AsmPrinter","","",null,null],[5,"LLVMInitializeAArch64AsmParser","","",null,null],[5,"LLVMInitializeMipsTargetInfo","","",null,null],[5,"LLVMInitializeMipsTarget","","",null,null],[5,"LLVMInitializeMipsTargetMC","","",null,null],[5,"LLVMInitializeMipsAsmPrinter","","",null,null],[5,"LLVMInitializeMipsAsmParser","","",null,null],[5,"LLVMInitializePowerPCTargetInfo","","",null,null],[5,"LLVMInitializePowerPCTarget","","",null,null],[5,"LLVMInitializePowerPCTargetMC","","",null,null],[5,"LLVMInitializePowerPCAsmPrinter","","",null,null],[5,"LLVMInitializePowerPCAsmParser","","",null,null],[5,"LLVMRustAddPass","","",null,null],[5,"LLVMRustCreateTargetMachine","","",null,null],[5,"LLVMRustDisposeTargetMachine","","",null,null],[5,"LLVMRustAddAnalysisPasses","","",null,null],[5,"LLVMRustAddBuilderLibraryInfo","","",null,null],[5,"LLVMRustAddLibraryInfo","","",null,null],[5,"LLVMRustRunFunctionPassManager","","",null,null],[5,"LLVMRustWriteOutputFile","","",null,null],[5,"LLVMRustPrintModule","","",null,null],[5,"LLVMRustSetLLVMOptions","","",null,null],[5,"LLVMRustPrintPasses","","",null,null],[5,"LLVMRustSetNormalizedTarget","","",null,null],[5,"LLVMRustAddAlwaysInlinePass","","",null,null],[5,"LLVMRustLinkInExternalBitcode","","",null,null],[5,"LLVMRustRunRestrictionPass","","",null,null],[5,"LLVMRustMarkAllFunctionsNounwind","","",null,null],[5,"LLVMRustOpenArchive","","",null,null],[5,"LLVMRustArchiveReadSection","","",null,null],[5,"LLVMRustDestroyArchive","","",null,null],[5,"LLVMRustSetDLLExportStorageClass","","",null,null],[5,"LLVMVersionMajor","","",null,{"inputs":[],"output":{"name":"i32"}}],[5,"LLVMVersionMinor","","",null,{"inputs":[],"output":{"name":"i32"}}],[5,"LLVMRustGetSectionName","","",null,null],[5,"LLVMWriteTwineToString","","",null,null],[5,"LLVMContextSetDiagnosticHandler","","",null,null],[5,"LLVMUnpackOptimizationDiagnostic","","",null,null],[5,"LLVMUnpackInlineAsmDiagnostic","","",null,null],[5,"LLVMWriteDiagnosticInfoToString","","",null,null],[5,"LLVMGetDiagInfoSeverity","","",null,null],[5,"LLVMGetDiagInfoKind","","",null,null],[5,"LLVMWriteDebugLocToString","","",null,null],[5,"LLVMSetInlineAsmDiagnosticHandler","","",null,null],[5,"LLVMWriteSMDiagnosticToString","","",null,null],[5,"SetInstructionCallConv","","",null,null],[5,"SetFunctionCallConv","","",null,null],[5,"SetLinkage","","",null,null],[5,"SetUnnamedAddr","","",null,null],[5,"set_thread_local","","",null,null],[5,"ConstICmp","","",null,null],[5,"ConstFCmp","","",null,null],[5,"SetFunctionAttribute","","",null,null],[3,"TargetData","","",null,null],[12,"lltd","","",408,null],[5,"mk_target_data","","",null,{"inputs":[{"name":"str"}],"output":{"name":"targetdata"}}],[3,"ObjectFile","","",null,null],[12,"llof","","",409,null],[3,"SectionIter","","",null,null],[12,"llsi","","",410,null],[5,"mk_section_iter","","",null,null],[5,"get_param","","Safe wrapper around `LLVMGetParam`, because segfaults are no fun.",null,null],[4,"RustString_opaque","","",null,null],[6,"RustStringRef","","",null,null],[5,"rust_llvm_string_write_impl","","Appending to a Rust string -- used by raw_rust_string_ostream.",null,null],[5,"build_string","","",null,{"inputs":[{"name":"f"}],"output":{"name":"option"}}],[5,"twine_to_string","","",null,null],[5,"debug_loc_to_string","","",null,null]],"paths":[[3,"Svh"],[4,"SawAbiComponent"],[4,"SawExprComponent"],[4,"SawStmtComponent"],[3,"Ident"],[3,"Name"],[3,"StrictVersionHashVisitor"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"DecodeContext"],[3,"DefId"],[4,"Option"],[3,"Span"],[3,"NestedItemsDropper"],[4,"Def"],[4,"Region"],[3,"FreeRegion"],[4,"CodeExtent"],[3,"DestructionScopeData"],[4,"BoundRegion"],[3,"Decoder"],[3,"Freevar"],[3,"UpvarBorrow"],[4,"UpvarCapture"],[4,"MethodOrigin"],[3,"EncodeContext"],[3,"Encoder"],[3,"SideTableEncodingIdVisitor"],[3,"Doc"],[3,"LoopScope"],[3,"LabelledCFG"],[4,"CFGNodeData"],[3,"CFG"],[3,"ConstQualif"],[4,"Mode"],[3,"CheckCrateVisitor"],[3,"CheckCrateVisitor"],[3,"CheckItemRecursionVisitor"],[4,"Context"],[3,"CheckLoopVisitor"],[3,"Matrix"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"MatchCheckCtxt"],[3,"StaticInliner"],[3,"RenamingRecorder"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[3,"RvalueContext"],[3,"RvalueContextDelegate"],[4,"const_val"],[3,"ConstEvalErr"],[4,"ErrKind"],[4,"IntTy"],[4,"UintTy"],[4,"EntryOrExit"],[3,"DataFlowContext"],[4,"KillFrom"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[3,"PathResolution"],[3,"Export"],[4,"MethodProvenance"],[4,"UnsafeContext"],[3,"EffectCheckVisitor"],[3,"EntryContext"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[3,"ExprUseVisitor"],[4,"SimplifiedType"],[3,"FreeRegionMap"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"Graph"],[3,"DepthFirstTraversal"],[3,"IntrinsicCheckingVisitor"],[3,"TransmuteRestriction"],[3,"Bivariate"],[3,"CombineFields"],[3,"Generalizer"],[4,"Result"],[3,"Equate"],[3,"InferCtxt"],[3,"Rc"],[3,"Binder"],[3,"Glb"],[3,"Lub"],[4,"Node"],[4,"Edge"],[3,"ConstraintGraph"],[4,"Constraint"],[4,"GenericKind"],[3,"TwoRegions"],[4,"UndoLogEntry"],[4,"CombineMapType"],[4,"RegionResolutionError"],[3,"SameRegions"],[3,"RegionSnapshot"],[3,"RegionVarBindings"],[4,"Classification"],[4,"VarValue"],[4,"Verify"],[3,"RegionAndOrigin"],[3,"OpportunisticTypeResolver"],[3,"FullTypeResolver"],[3,"TypeFreshener"],[3,"Sub"],[4,"RelationDir"],[3,"TypeVariableTable"],[3,"Delegate"],[4,"VarValue"],[3,"Delegate"],[3,"UnificationTable"],[3,"IntVid"],[4,"IntVarValue"],[3,"FloatVid"],[4,"FloatTy"],[4,"TypeOrigin"],[4,"ValuePairs"],[3,"TypeTrace"],[4,"SubregionOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"fixup_err"],[4,"Implication"],[4,"LangItem"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[3,"Variable"],[3,"LiveNode"],[4,"LiveNodeKind"],[3,"IrMaps"],[3,"LocalInfo"],[4,"VarKind"],[3,"Liveness"],[3,"Users"],[3,"Specials"],[4,"categorization"],[3,"Upvar"],[4,"PointerKind"],[4,"InteriorKind"],[4,"FieldName"],[4,"InteriorOffsetKind"],[4,"ElementKind"],[4,"MutabilityCategory"],[4,"Note"],[3,"cmt_"],[4,"deref_kind"],[3,"Expr"],[3,"Pat"],[3,"MemCategorizationContext"],[4,"InteriorSafety"],[4,"Aliasability"],[4,"AliasableReason"],[4,"ClosureKind"],[4,"LastPrivate"],[4,"PrivateDep"],[4,"ImportUse"],[3,"ReachableContext"],[3,"BlockRemainder"],[4,"InnermostDeclaringBlock"],[3,"DeclaringStatementContext"],[4,"InnermostEnclosingExpr"],[3,"Context"],[3,"RegionMaps"],[3,"RegionResolutionVisitor"],[4,"DefRegion"],[3,"LifetimeContext"],[4,"ShadowKind"],[4,"ScopeChain"],[3,"Annotator"],[3,"Index"],[3,"Checker"],[3,"Substs"],[4,"RegionSubsts"],[4,"ParamSpace"],[3,"VecPerParamSpace"],[3,"EnumeratedItems"],[3,"SubstFolder"],[3,"InferIsLocal"],[3,"RegionObligation"],[3,"FulfillmentContext"],[3,"MismatchedProjectionTypes"],[4,"ProjectionTyCandidate"],[3,"AssociatedTypeNormalizer"],[3,"Normalized"],[4,"ProjectionTyError"],[4,"MethodViolationCode"],[4,"ObjectSafetyViolation"],[3,"SelectionCache"],[4,"MethodMatchedData"],[4,"SelectionCandidate"],[4,"EvaluationResult"],[3,"SelectionContext"],[3,"TraitObligationStackList"],[3,"TraitObligationStack"],[4,"MethodMatchResult"],[3,"Elaborator"],[3,"SupertraitDefIds"],[3,"FilterToTraits"],[3,"VtableImplData"],[3,"VtableObjectData"],[3,"Obligation"],[4,"Vtable"],[3,"VtableBuiltinData"],[3,"VtableDefaultImplData"],[4,"SelectionError"],[3,"FulfillmentError"],[4,"FulfillmentErrorCode"],[3,"ObligationCause"],[4,"ObligationCauseCode"],[3,"DerivedObligationCause"],[3,"field"],[4,"ImplOrTraitItemContainer"],[4,"ImplOrTraitItem"],[4,"ImplOrTraitItemId"],[3,"Method"],[3,"AssociatedType"],[3,"mt"],[3,"field_ty"],[3,"creader_cache_key"],[3,"ItemVariances"],[4,"Variance"],[4,"AutoAdjustment"],[3,"AutoDerefRef"],[4,"AutoRef"],[3,"param_index"],[3,"MethodParam"],[3,"MethodObject"],[3,"MethodCallee"],[3,"MethodCall"],[4,"vtable_origin"],[3,"CtxtArenas"],[3,"ctxt"],[3,"TypeFlags"],[3,"TyS"],[3,"InternedTy"],[3,"BareFnTy"],[3,"ClosureTy"],[4,"FnOutput"],[3,"FnSig"],[3,"ParamTy"],[3,"DebruijnIndex"],[3,"EarlyBoundRegion"],[3,"UpvarId"],[4,"BorrowKind"],[4,"sty"],[3,"TyTrait"],[3,"TraitRef"],[4,"terr_vstore_kind"],[3,"expected_found"],[4,"type_err"],[3,"ParamBounds"],[3,"ExistentialBounds"],[4,"BuiltinBound"],[3,"TyVid"],[3,"RegionVid"],[4,"InferTy"],[4,"UnconstrainedNumeric"],[4,"InferRegion"],[4,"ObjectLifetimeDefault"],[3,"TypeParameterDef"],[3,"RegionParameterDef"],[3,"Generics"],[3,"GenericPredicates"],[4,"Predicate"],[3,"TraitPredicate"],[3,"EquatePredicate"],[3,"OutlivesPredicate"],[3,"ProjectionPredicate"],[3,"ProjectionTy"],[3,"InstantiatedPredicates"],[3,"ParameterEnvironment"],[3,"TypeScheme"],[3,"ItemSubsts"],[3,"TypeContents"],[4,"Representability"],[4,"ExprKind"],[3,"VariantInfo"],[4,"DtorKind"],[4,"IntType"],[3,"ClosureUpvar"],[4,"ExplicitSelfCategory"],[4,"CopyImplementationError"],[3,"Vec"],[3,"Box"],[4,"Unsafety"],[4,"Abi"],[3,"OwnedSlice"],[3,"EnumSet"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionEraser"],[3,"Match"],[3,"TypeWalker"],[3,"Context"],[4,"astencode_tag"],[3,"LinkMeta"],[4,"DefIdSource"],[3,"entry"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[4,"Family"],[4,"DefLike"],[3,"CrateDep"],[3,"CrateReader"],[4,"PMDSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[3,"CrateSource"],[3,"CStore"],[3,"crate_metadata"],[4,"MetadataBlob"],[3,"MethodInfo"],[3,"Context"],[3,"ArchiveMetadata"],[4,"FileMatch"],[3,"FileSearch"],[3,"MacroLoader"],[4,"OptLevel"],[4,"DebugInfoLevel"],[4,"OutputType"],[3,"Options"],[4,"UnstableFeatures"],[4,"PrintRequest"],[4,"Input"],[3,"OutputFilenames"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[4,"OptionStability"],[3,"RustcOptGroup"],[3,"SearchPaths"],[4,"PathKind"],[3,"Iter"],[3,"Session"],[3,"Registry"],[3,"RegistrarFinder"],[3,"Lint"],[3,"LintId"],[4,"Level"],[4,"LintSource"],[3,"HardwiredLints"],[3,"LintStore"],[3,"Context"],[3,"GatherNodeLevels"],[3,"ErrorReported"],[3,"Indenter"],[3,"LoopQueryVisitor"],[3,"BlockQueryVisitor"],[3,"P"],[3,"TraitDef"],[3,"TraitItem"],[3,"Path"],[3,"Ty"],[3,"Item"],[3,"Lifetime"],[3,"Spanned"],[4,"ExplicitSelf_"],[4,"Visibility"],[4,"Mutability"],[4,"IntTy"],[4,"UintTy"],[3,"HashMap"],[3,"FnvHasher"],[3,"SnapshotVec"],[3,"FixedBuffer64"],[3,"Sha256"],[3,"ArchiveRO"],[4,"OptimizationDiagnosticKind"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"Diagnostic"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[3,"Attribute"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[3,"AttrBuilder"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[4,"DIDescriptorFlags"],[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[3,"Config"],[3,"ctxt"],[4,"InlinedItemRef"],[3,"EncodeParams"],[3,"ImportedFileMap"],[4,"FoundAst"],[3,"Library"],[3,"CratePaths"],[8,"vtable_decoder_helpers"],[3,"CFGEdgeData"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[8,"Delegate"],[3,"Node"],[8,"RelateResultCompare"],[8,"ErrorReporting"],[8,"Resolvable"],[8,"LatticeDir"],[8,"UnifyKey"],[3,"Node"],[8,"ToType"],[8,"ast_node"],[8,"Typer"],[3,"SeparateVecsPerParamSpace"],[8,"Subst"],[4,"OrphanCheckErr"],[3,"CrateAnalysis"],[3,"CommonTypes"],[8,"ToPolyTraitRef"],[8,"AsPredicate"],[8,"ClosureTyper"],[8,"RegionEscape"],[8,"HasProjectionTypes"],[8,"ReferencesError"],[8,"TypeFoldable"],[8,"TypeFolder"],[8,"TypeRelation"],[8,"Relate"],[8,"LintPass"],[3,"PluginRegistrar"],[8,"Repr"],[8,"UserString"],[4,"UndoLog"],[8,"SnapshotVecDelegate"],[8,"ToPrimitive"],[8,"Digest"],[3,"TempDir"],[4,"Arch"],[3,"Target"],[3,"TargetOptions"],[3,"ArchiveConfig"],[3,"RPathConfig"],[3,"t"],[4,"OutputType"],[3,"ModuleTranslation"],[3,"CrateTranslation"],[3,"Interner"],[3,"RcStr"],[3,"StrInterner"],[3,"SmallVector"],[3,"IntoIter"],[3,"Registry"],[4,"Annotatable"],[3,"MacEager"],[3,"DummyResult"],[3,"BlockInfo"],[3,"ExtCtxt"],[3,"SyntaxEnv"],[4,"OrderingOp"],[4,"PtrTy"],[3,"Path"],[4,"Ty"],[3,"LifetimeBounds"],[3,"TraitDef"],[4,"StructType"],[3,"PatIdentFinder"],[3,"IdentRenamer"],[3,"PatIdentRenamer"],[3,"MacroExpander"],[3,"ExpansionConfig"],[3,"Marker"],[3,"MacroExterminator"],[4,"ArgumentType"],[4,"SyntaxContext_"],[4,"TokenTree"],[3,"Block"],[3,"Arg"],[3,"Generics"],[3,"WhereClause"],[3,"Arm"],[3,"Attribute_"],[3,"TtFrame"],[3,"TtReader"],[4,"LockstepIterSize"],[4,"TokenTreeOrTokenTreeVec"],[3,"MatcherTtFrame"],[3,"MatcherPos"],[3,"ParserAnyMacro"],[3,"MacroRulesMacroExpander"],[3,"LifetimeDef"],[3,"PathSegment"],[4,"PathParameters"],[3,"AngleBracketedParameterData"],[3,"ParenthesizedParameterData"],[4,"TyParamBound"],[4,"TraitBoundModifier"],[3,"TyParam"],[4,"WherePredicate"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[4,"MetaItem_"],[3,"FieldPat"],[4,"BindingMode"],[4,"PatWildKind"],[4,"Pat_"],[4,"BinOp_"],[4,"UnOp"],[4,"Stmt_"],[4,"MacStmtStyle"],[4,"LocalSource"],[3,"Local"],[4,"Decl_"],[3,"Field"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[4,"Expr_"],[3,"QSelf"],[4,"MatchSource"],[4,"CaptureClause"],[3,"Delimited"],[3,"SequenceRepetition"],[4,"KleeneOp"],[4,"Mac_"],[4,"StrStyle"],[4,"Sign"],[4,"LitIntType"],[4,"Lit_"],[3,"MutTy"],[3,"TypeField"],[3,"MethodSig"],[4,"TraitItem_"],[3,"ImplItem"],[4,"ImplItem_"],[3,"TypeBinding"],[4,"PrimTy"],[3,"BareFnTy"],[4,"Ty_"],[4,"AsmDialect"],[3,"InlineAsm"],[3,"FnDecl"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[3,"Mod"],[3,"ForeignMod"],[3,"VariantArg"],[4,"VariantKind"],[3,"EnumDef"],[3,"Variant_"],[4,"PathListItem_"],[4,"ViewPath_"],[4,"AttrStyle"],[3,"AttrId"],[3,"TraitRef"],[3,"PolyTraitRef"],[3,"StructField_"],[4,"StructFieldKind"],[3,"StructDef"],[4,"Item_"],[3,"ForeignItem"],[4,"ForeignItem_"],[4,"InlinedItem"],[3,"MacroDef"],[3,"Restrictions"],[4,"PathParsingMode"],[4,"BoundParsingMode"],[4,"TokenType"],[3,"Parser"],[4,"CommentStyle"],[3,"Comment"],[3,"Literal"],[3,"TokenAndSpan"],[3,"StringReader"],[4,"BinOpToken"],[4,"DelimToken"],[4,"IdentStyle"],[4,"SpecialMacroVar"],[4,"Lit"],[4,"Token"],[4,"Nonterminal"],[4,"Keyword"],[3,"InternedString"],[4,"ObsoleteSyntax"],[3,"ParseSess"],[4,"Os"],[4,"Architecture"],[3,"AbiData"],[4,"AbiArchitecture"],[3,"FnLikeNode"],[4,"Code"],[4,"PathElem"],[3,"LinkedPathNode"],[3,"LinkedPath"],[4,"Node"],[4,"MapEntry"],[3,"InlinedParent"],[3,"Forest"],[3,"Map"],[3,"NodesMatchingSuffix"],[3,"IdAndSpanUpdater"],[3,"NodeCollector"],[3,"State"],[3,"IdRange"],[3,"IdVisitor"],[3,"IdRangeComputingVisitor"],[4,"InlineAttr"],[3,"Stability"],[4,"StabilityLevel"],[4,"ReprAttr"],[3,"BytePos"],[3,"CharPos"],[3,"Loc"],[3,"LocWithOpt"],[3,"FileMapAndLine"],[3,"FileMapAndBytePos"],[4,"MacroFormat"],[3,"NameAndSpan"],[3,"ExpnInfo"],[3,"ExpnId"],[3,"LineInfo"],[3,"MultiByteChar"],[3,"FileMap"],[3,"CodeMap"],[4,"SpanSnippetError"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[3,"Context"],[3,"CfgAttrFolder"],[4,"RenderSpan"],[4,"ColorConfig"],[3,"FatalError"],[3,"ExplicitBug"],[3,"SpanHandler"],[3,"Handler"],[4,"Level"],[3,"EmitterWriter"],[4,"Destination"],[4,"AttributeType"],[3,"Features"],[3,"MacroVisitor"],[3,"PostExpansionVisitor"],[4,"Mode"],[3,"ShowSpanVisitor"],[3,"StandardLibraryInjector"],[3,"PreludeInjector"],[3,"TestHarnessGenerator"],[4,"HasTestSignature"],[4,"FnKind"],[4,"Breaks"],[3,"BreakToken"],[3,"BeginToken"],[4,"Token"],[4,"PrintStackBreak"],[3,"PrintStackElem"],[3,"Printer"],[3,"NoAnn"],[3,"CurrentCommentAndLiteral"],[3,"CrateContext"],[6,"ValueRef"],[8,"AttrHelper"]]};
searchIndex['fmt_macros'] = {"items":[[0,"","fmt_macros","Macro support for format strings",null,null],[3,"Argument","","Representation of an argument specification.",null,null],[12,"position","","Where to find this argument",0,null],[12,"format","","How to format the argument",0,null],[3,"FormatSpec","","Specification for the formatting of an argument in the format string.",null,null],[12,"fill","","Optionally specified character to fill alignment with",1,null],[12,"align","","Optionally specified alignment",1,null],[12,"flags","","Packed version of various flags provided",1,null],[12,"precision","","The integer precision to use",1,null],[12,"width","","The string width requested for the resulting format",1,null],[12,"ty","","The descriptor string representing the name of the format desired for\nthis argument, this can be empty or any number of characters, although\nit is required to be one word.",1,null],[3,"Parser","","The parser structure for interpreting the input format string. This is\nmodelled as an iterator over `Piece` structures to form a stream of tokens\nbeing output.",null,null],[12,"errors","","Error messages accumulated during parsing",2,null],[4,"Piece","","A piece is a portion of the format string which represents the next part\nto emit. These are emitted as a stream by the `Parser` class.",null,null],[13,"String","","A literal string which should directly be emitted",3,null],[13,"NextArgument","","This describes that formatting should process the next argument (as\nspecified inside) for emission.",3,null],[4,"Position","","Enum describing where an argument for a format can be located.",null,null],[13,"ArgumentNext","","The argument will be in the next position. This is the default.",4,null],[13,"ArgumentIs","","The argument is located at a specific index.",4,null],[13,"ArgumentNamed","","The argument has a name.",4,null],[4,"Alignment","","Enum of alignments which are supported.",null,null],[13,"AlignLeft","","The value will be aligned to the left.",5,null],[13,"AlignRight","","The value will be aligned to the right.",5,null],[13,"AlignCenter","","The value will be aligned in the center.",5,null],[13,"AlignUnknown","","The value will take on a default alignment.",5,null],[4,"Flag","","Various flags which can be applied to format strings. The meaning of these\nflags is defined by the formatters themselves.",null,null],[13,"FlagSignPlus","","A `+` will be used to denote positive numbers.",6,null],[13,"FlagSignMinus","","A `-` will be used to denote negative numbers. This is the default.",6,null],[13,"FlagAlternate","","An alternate form will be used for the value. In the case of numbers,\nthis means that the number will be prefixed with the supplied string.",6,null],[13,"FlagSignAwareZeroPad","","For numbers, this means that the number will be padded with zeroes,\nand the sign (`+` or `-`) will precede them.",6,null],[4,"Count","","A count is used for the precision and width parameters of an integer, and\ncan reference either an argument or a literal integer.",null,null],[13,"CountIs","","The count is specified explicitly.",7,null],[13,"CountIsName","","The count is specified by the argument with the given name.",7,null],[13,"CountIsParam","","The count is specified by the argument at the given index.",7,null],[13,"CountIsNextParam","","The count is specified by the next parameter.",7,null],[13,"CountImplied","","The count is implied and cannot be explicitly specified.",7,null],[11,"eq","","",3,{"inputs":[{"name":"piece"},{"name":"piece"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"piece"},{"name":"piece"}],"output":{"name":"bool"}}],[11,"clone","","",3,{"inputs":[{"name":"piece"}],"output":{"name":"piece"}}],[11,"eq","","",0,{"inputs":[{"name":"argument"},{"name":"argument"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"argument"},{"name":"argument"}],"output":{"name":"bool"}}],[11,"clone","","",0,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"eq","","",1,{"inputs":[{"name":"formatspec"},{"name":"formatspec"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"formatspec"},{"name":"formatspec"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",4,{"inputs":[{"name":"position"},{"name":"position"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"position"},{"name":"position"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"eq","","",5,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"eq","","",6,{"inputs":[{"name":"flag"},{"name":"flag"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"flag"},{"name":"flag"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"flag"}],"output":{"name":"flag"}}],[11,"eq","","",7,{"inputs":[{"name":"count"},{"name":"count"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"count"},{"name":"count"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[6,"Item","","",null,null],[11,"next","","",2,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"new","","Creates a new parser for the given format string",2,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"parser"}}]],"paths":[[3,"Argument"],[3,"FormatSpec"],[3,"Parser"],[4,"Piece"],[4,"Position"],[4,"Alignment"],[4,"Flag"],[4,"Count"]]};
searchIndex['rustc_typeck'] = {"items":[[0,"","rustc_typeck","typeck.rs, an introduction",null,null],[0,"lint","","Lints, aka compiler warnings.",null,null],[11,"name_lower","rustc::lint","Get the lint's name, with ASCII letters converted to lowercase.",0,{"inputs":[{"name":"lint"}],"output":{"name":"string"}}],[11,"fmt","rustc_back::svh","",1,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",1,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",1,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",1,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",1,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","rustc_back::svh::svh_visitor","",2,null],[11,"hash","","",3,null],[11,"hash","","",4,null],[11,"get_content","syntax::ast","",5,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"get_content","","",6,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[11,"visit_mac","rustc_back::svh::svh_visitor","",7,null],[11,"visit_struct_def","","",7,null],[11,"visit_variant","","",7,null],[11,"visit_opt_lifetime_ref","","",7,null],[11,"visit_ident","","",7,null],[11,"visit_lifetime_ref","","",7,null],[11,"visit_lifetime_def","","",7,null],[11,"visit_expr","","",7,null],[11,"visit_stmt","","",7,null],[11,"visit_foreign_item","","",7,null],[11,"visit_item","","",7,null],[11,"visit_mod","","",7,null],[11,"visit_decl","","",7,null],[11,"visit_ty","","",7,null],[11,"visit_generics","","",7,null],[11,"visit_fn","","",7,null],[11,"visit_trait_item","","",7,null],[11,"visit_impl_item","","",7,null],[11,"visit_struct_field","","",7,null],[11,"visit_explicit_self","","",7,null],[11,"visit_path","","",7,null],[11,"visit_block","","",7,null],[11,"visit_pat","","",7,null],[11,"visit_local","","",7,null],[11,"visit_arm","","",7,null],[11,"open","rustc_back::archive","Opens an existing static archive",8,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",8,null],[11,"files","","Lists all files in an archive",8,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",8,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",9,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",9,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",9,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",9,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",9,null],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",9,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[11,"tr_id","rustc::middle::astencode","Translates an internal id, meaning a node id that is known to refer to some part of the\nitem currently being inlined, such as a local variable or argument.  All naked node-ids\nthat appear in types have this property, since if something might refer to an external item\nwe would use a def-id to allow for the possibility that the item resides in another crate.",10,{"inputs":[{"name":"decodecontext"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"tr_def_id","","Translates an EXTERNAL def-id, converting the crate number from the one used in the encoded\ndata to the current crate numbers..  By external, I mean that it be translated to a\nreference to the item in its original crate, as opposed to being translated to a reference\nto the inlined version of the item.  This is typically, but not always, what you want,\nbecause most def-ids refer to external things like types or other fns that may or may not\nbe inlined.  Note that even when the inlined function is referencing itself recursively, we\nwould want `tr_def_id` for that reference--- conceptually the function calls the original,\nnon-inlined version, and trans deals with linking that recursive call to the inlined copy.",10,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_intern_def_id","","Translates an INTERNAL def-id, meaning a def-id that is\nknown to refer to some part of the item currently being\ninlined.  In that case, we want to convert the def-id to\nrefer to the current crate and to the new, inlined node-id.",10,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_span","","Translates a `Span` from an extern crate to the corresponding `Span`\nwithin the local crate's codemap. `creader::import_codemap()` will\nalready have allocated any additionally needed FileMaps in the local\ncodemap as a side-effect of creating the crate_metadata's\n`codemap_import_info`.",10,{"inputs":[{"name":"decodecontext"},{"name":"span"}],"output":{"name":"span"}}],[11,"tr_intern","syntax::ast","",11,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","","",11,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","core::option","",12,{"inputs":[{"name":"option"},{"name":"decodecontext"}],"output":{"name":"option"}}],[11,"tr","syntax::codemap","",13,{"inputs":[{"name":"span"},{"name":"decodecontext"}],"output":{"name":"span"}}],[11,"fold_block","rustc::middle::astencode","",14,{"inputs":[{"name":"nesteditemsdropper"},{"name":"p"}],"output":{"name":"p"}}],[11,"tr","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"decodecontext"}],"output":{"name":"def"}}],[11,"tr","rustc::middle::ty","",16,{"inputs":[{"name":"region"},{"name":"decodecontext"}],"output":{"name":"region"}}],[11,"tr","","",17,{"inputs":[{"name":"freeregion"},{"name":"decodecontext"}],"output":{"name":"freeregion"}}],[11,"tr","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"decodecontext"}],"output":{"name":"codeextent"}}],[11,"tr","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"decodecontext"}],"output":{"name":"destructionscopedata"}}],[11,"tr","rustc::middle::ty","",20,{"inputs":[{"name":"boundregion"},{"name":"decodecontext"}],"output":{"name":"boundregion"}}],[11,"read_freevar_entry","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"read_capture_mode","","",21,{"inputs":[{"name":"decoder"}],"output":{"name":"captureclause"}}],[11,"tr","rustc::middle::ty","",22,{"inputs":[{"name":"freevar"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"tr","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"decodecontext"}],"output":{"name":"upvarborrow"}}],[11,"tr","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"decodecontext"}],"output":{"name":"upvarcapture"}}],[11,"read_method_callee","rbml::reader","",21,null],[11,"tr","rustc::middle::ty","",25,{"inputs":[{"name":"methodorigin"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_vec_per_param_space","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_res_with_key","","",21,null],[11,"read_vtable_res","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_param_res","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_vtable_origin","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[11,"ty_str_ctxt","rustc::metadata::encoder","",26,{"inputs":[{"name":"encodecontext"}],"output":{"name":"ctxt"}}],[11,"emit_closure_type","rbml::writer","",27,null],[11,"emit_method_origin","","",27,null],[11,"emit_ty","","",27,null],[11,"emit_tys","","",27,null],[11,"emit_trait_ref","","",27,null],[11,"emit_type_param_def","","",27,null],[11,"emit_predicate","","",27,null],[11,"emit_type_scheme","","",27,null],[11,"emit_existential_bounds","","",27,null],[11,"emit_builtin_bounds","","",27,null],[11,"emit_substs","","",27,null],[11,"emit_auto_adjustment","","",27,null],[11,"emit_autoref","","",27,null],[11,"emit_auto_deref_ref","","",27,null],[11,"tag","","",27,null],[11,"id","","",27,null],[11,"visit_id","rustc::middle::astencode","",28,null],[11,"as_int","rbml","",29,{"inputs":[{"name":"doc"}],"output":{"name":"isize"}}],[11,"opt_child","","",29,{"inputs":[{"name":"doc"},{"name":"astencode_tag"}],"output":{"name":"option"}}],[11,"read_ty_nodcx","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[11,"read_tys_nodcx","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_substs_nodcx","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"substs"}}],[11,"read_method_origin","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_ty","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"tys"}}],[11,"read_tys","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"vec"}}],[11,"read_trait_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"rc"}}],[11,"read_poly_trait_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"binder"}}],[11,"read_type_param_def","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typeparameterdef"}}],[11,"read_predicate","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"predicate"}}],[11,"read_type_scheme","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typescheme"}}],[11,"read_existential_bounds","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"existentialbounds"}}],[11,"read_substs","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"substs"}}],[11,"read_auto_adjustment","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoadjustment"}}],[11,"read_auto_deref_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoderefref"}}],[11,"read_autoref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoref"}}],[11,"read_closure_kind","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurekind"}}],[11,"read_closure_ty","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurety"}}],[11,"convert_def_id","","Converts a def-id that appears in a type.  The correct\ntranslation will depend on what kind of def-id this is.\nThis is a subtle point: type definitions are not\ninlined into the current crate, so if the def-id names\na nominal type or type alias, then it should be\ntranslated to refer to the source crate.",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"},{"name":"defidsource"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"clone","rustc::middle::cfg::construct","",30,{"inputs":[{"name":"loopscope"}],"output":{"name":"loopscope"}}],[11,"graph_id","rustc::middle::cfg::graphviz","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"id"}}],[11,"node_id","","",31,null],[11,"node_label","","",31,null],[11,"edge_label","","",31,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"edges","","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"source","","",31,null],[11,"target","","",31,null],[11,"eq","rustc::middle::cfg","",32,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"clone","","",32,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"cfgnodedata"}}],[11,"id","","",32,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"u32"}}],[11,"new","","",33,{"inputs":[{"name":"cfg"},{"name":"ctxt"},{"name":"block"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",33,{"inputs":[{"name":"cfg"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"hash","rustc::middle::check_const","",34,null],[11,"cmp","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"option"}}],[11,"lt","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"le","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"gt","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ge","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"clone","","",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"decode","","",34,{"inputs":[{"name":"constqualif"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"constqualif"},{"name":"__s"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"all","","Returns the set containing all flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",34,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",34,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"constqualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",34,null],[11,"remove","","Removes the specified flags in-place.",34,null],[11,"toggle","","Toggles the specified flags in-place.",34,null],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitor","rustc::middle::check_const","Returns the union of the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitxor","rustc::middle::check_const","Returns the left flags, but with all the right flags toggled.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitand","rustc::middle::check_const","Returns the intersection between the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"sub","rustc::middle::check_const","Returns the set difference of the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"not","rustc::middle::check_const","Returns the complement of this set of flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",35,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"mode"}],"output":{"name":"mode"}}],[11,"visit_item","","",36,null],[11,"visit_fn","","",36,null],[11,"visit_pat","","",36,null],[11,"visit_expr","","",36,null],[11,"consume","","",36,null],[11,"borrow","","",36,null],[11,"decl_without_init","","",36,null],[11,"mutate","","",36,null],[11,"matched_pat","","",36,null],[11,"consume_pat","","",36,null],[11,"visit_item","rustc::middle::check_static_recursion","",37,null],[11,"visit_item","","",38,null],[11,"visit_expr","","",38,null],[11,"eq","rustc::middle::check_loop","",39,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"clone","","",40,{"inputs":[{"name":"checkloopvisitor"}],"output":{"name":"checkloopvisitor"}}],[11,"visit_item","","",40,null],[11,"visit_expr","","",40,null],[11,"fmt","rustc::middle::check_match","",41,{"inputs":[{"name":"matrix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",41,{"inputs":[{"name":"matrix"},{"name":"t"}],"output":{"name":"matrix"}}],[11,"eq","","",42,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"constructor"}],"output":{"name":"constructor"}}],[11,"eq","","",43,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"usefulness"}],"output":{"name":"usefulness"}}],[11,"clone","","",44,{"inputs":[{"name":"witnesspreference"}],"output":{"name":"witnesspreference"}}],[11,"visit_expr","","",45,null],[11,"visit_local","","",45,null],[11,"visit_fn","","",45,null],[11,"new","","",46,{"inputs":[{"name":"staticinliner"},{"name":"ctxt"},{"name":"option"}],"output":{"name":"staticinliner"}}],[11,"visit_id","","",47,null],[11,"fold_pat","","",46,{"inputs":[{"name":"staticinliner"},{"name":"p"}],"output":{"name":"p"}}],[11,"matched_pat","","",48,null],[11,"consume","","",48,null],[11,"consume_pat","","",48,null],[11,"borrow","","",48,null],[11,"decl_without_init","","",48,null],[11,"mutate","","",48,null],[11,"visit_pat","","",49,null],[11,"visit_fn","rustc::middle::check_rvalues","",50,null],[11,"consume","","",51,null],[11,"matched_pat","","",51,null],[11,"consume_pat","","",51,null],[11,"borrow","","",51,null],[11,"decl_without_init","","",51,null],[11,"mutate","","",51,null],[11,"eq","rustc::middle::const_eval","",52,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"clone","","",52,{"inputs":[{"name":"const_val"}],"output":{"name":"const_val"}}],[11,"clone","","",53,{"inputs":[{"name":"constevalerr"}],"output":{"name":"constevalerr"}}],[11,"clone","","",54,{"inputs":[{"name":"errkind"}],"output":{"name":"errkind"}}],[11,"description","","",53,{"inputs":[{"name":"constevalerr"}],"output":{"name":"cow"}}],[11,"fmt","","",55,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",56,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",56,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",56,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"from","","",55,{"inputs":[{"name":"intty"},{"name":"ctxt"},{"name":"intty"}],"output":{"name":"intty"}}],[11,"from","","",56,{"inputs":[{"name":"uintty"},{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"fmt","rustc::middle::dataflow","",57,{"inputs":[{"name":"entryorexit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",57,{"inputs":[{"name":"entryorexit"}],"output":{"name":"entryorexit"}}],[11,"clone","","",58,{"inputs":[{"name":"dataflowcontext"}],"output":{"name":"dataflowcontext"}}],[11,"pre","","",58,{"inputs":[{"name":"dataflowcontext"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"fmt","","",59,{"inputs":[{"name":"killfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",59,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"clone","","",59,{"inputs":[{"name":"killfrom"}],"output":{"name":"killfrom"}}],[11,"new","","",58,{"inputs":[{"name":"dataflowcontext"},{"name":"ctxt"},{"name":"str"},{"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",58,null],[11,"add_kill","","Indicates that `id` kills `bit`",58,null],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`.\nOnly useful after `propagate()` has been called.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`.\nOnly useful after `propagate()` has been called.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"entryorexit"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow\nexits through any number of enclosing scopes on its way to\nthe new destination. This function infers the kill bits of\nthose control operators based on the kill bits associated\nwith those scopes.",58,null],[11,"propagate","","Performs the data flow analysis.",58,null],[11,"join","","",60,{"inputs":[{"name":"union"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",61,{"inputs":[{"name":"subtract"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"visit_struct_def","rustc::middle::dead","",62,null],[11,"visit_expr","","",62,null],[11,"visit_pat","","",62,null],[11,"visit_path","","",62,null],[11,"visit_item","","",62,null],[11,"visit_item","","",63,null],[11,"visit_item","","",64,null],[11,"visit_foreign_item","","",64,null],[11,"visit_fn","","",64,null],[11,"visit_struct_field","","",64,null],[11,"visit_trait_item","","",64,null],[11,"fmt","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",15,null],[11,"decode","","",15,{"inputs":[{"name":"def"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"def"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"def"}],"output":{"name":"def"}}],[11,"fmt","","",65,{"inputs":[{"name":"pathresolution"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"pathresolution"}}],[11,"full_def","","Get the definition, if fully resolved, otherwise panic.",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"def"}}],[11,"def_id","","Get the DefId, if fully resolved, otherwise panic.",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"defid"}}],[11,"new","","",65,{"inputs":[{"name":"pathresolution"},{"name":"def"},{"name":"lastprivate"},{"name":"usize"}],"output":{"name":"pathresolution"}}],[11,"clone","","",66,{"inputs":[{"name":"export"}],"output":{"name":"export"}}],[11,"fmt","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",67,null],[11,"decode","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"methodprovenance"}],"output":{"name":"methodprovenance"}}],[11,"map","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"f"}],"output":{"name":"methodprovenance"}}],[11,"local_node_id","","",15,{"inputs":[{"name":"def"}],"output":{"name":"u32"}}],[11,"def_id","","",15,{"inputs":[{"name":"def"}],"output":{"name":"defid"}}],[11,"variant_def_ids","","",15,{"inputs":[{"name":"def"}],"output":{"name":"option"}}],[11,"eq","rustc::middle::effect","",68,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"clone","","",68,{"inputs":[{"name":"unsafecontext"}],"output":{"name":"unsafecontext"}}],[11,"visit_fn","","",69,null],[11,"visit_block","","",69,null],[11,"visit_expr","","",69,null],[11,"visit_item","rustc::middle::entry","",70,null],[11,"fmt","rustc::middle::expr_use_visitor","",71,{"inputs":[{"name":"loancause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"loancause"}],"output":{"name":"loancause"}}],[11,"fmt","","",72,{"inputs":[{"name":"consumemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"consumemode"}],"output":{"name":"consumemode"}}],[11,"fmt","","",73,{"inputs":[{"name":"movereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"movereason"}],"output":{"name":"movereason"}}],[11,"fmt","","",74,{"inputs":[{"name":"matchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"matchmode"}],"output":{"name":"matchmode"}}],[11,"fmt","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"trackmatchmode"}],"output":{"name":"trackmatchmode"}}],[11,"fmt","","",76,{"inputs":[{"name":"mutatemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",76,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"mutatemode"}],"output":{"name":"mutatemode"}}],[11,"clone","","",77,{"inputs":[{"name":"overloadedcalltype"}],"output":{"name":"overloadedcalltype"}}],[11,"new","","",78,{"inputs":[{"name":"exprusevisitor"},{"name":"delegate"},{"name":"typer"}],"output":{"name":"exprusevisitor"}}],[11,"walk_fn","","",78,null],[11,"consume_expr","","",78,null],[11,"walk_expr","","",78,null],[11,"hash","rustc::middle::fast_reject","",79,null],[11,"eq","","",79,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"clone","","",79,{"inputs":[{"name":"simplifiedtype"}],"output":{"name":"simplifiedtype"}}],[11,"clone","rustc::middle::free_region","",80,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"new","","",80,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"relate_free_regions_from_implications","","",80,null],[11,"relate_free_regions_from_predicates","","",80,null],[11,"relate_free_regions","","",80,null],[11,"sub_free_region","","Determines whether two free regions have a subregion relationship\nby walking the graph encoded in `map`.  Note that\nit is possible that `sub != sup` and `sub <= sup` and `sup <= sub`\n(that is, the user can give two different names to the same lifetime).",80,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run *after\ninference* and sadly the logic is somewhat duplicated with the code in infer.rs.",80,{"inputs":[{"name":"freeregionmap"},{"name":"ctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","rustc::middle::graph","",81,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",82,{"inputs":[{"name":"nodeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",82,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"nodeindex"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",83,{"inputs":[{"name":"edgeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",83,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"clone","","",83,{"inputs":[{"name":"edgeindex"}],"output":{"name":"edgeindex"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",82,{"inputs":[{"name":"nodeindex"}],"output":{"name":"usize"}}],[11,"edge_id","","Returns unique id (unique with respect to the graph holding associated edge).",83,{"inputs":[{"name":"edgeindex"}],"output":{"name":"usize"}}],[11,"new","","",84,{"inputs":[{"name":"graph"}],"output":{"name":"graph"}}],[11,"with_capacity","","",84,{"inputs":[{"name":"graph"},{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",84,null],[11,"all_edges","","",84,null],[11,"next_node_index","","",84,{"inputs":[{"name":"graph"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",84,{"inputs":[{"name":"graph"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",84,{"inputs":[{"name":"graph"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"mut_edge_data","","",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge_data","","",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge","","",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"first_adjacent","","Accesses the index of the first edge adjacent to `node`.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"next_adjacent","","Accesses the next edge in a given direction.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",84,{"inputs":[{"name":"graph"},{"name":"edgeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"each_node","","Iterates over all edges defined in the graph.",84,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_edge","","Iterates over all edges defined in the graph",84,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_outgoing_edge","","Iterates over all outgoing edges from the node `from`",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_incoming_edge","","Iterates over all incoming edges to the node `target`",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_adjacent_edge","","Iterates over all edges adjacent to the node `node`\nin the direction `dir` (either `Outgoing` or `Incoming)",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"},{"name":"f"}],"output":{"name":"bool"}}],[11,"iterate_until_fixed_point","","",84,null],[11,"depth_traverse","","",84,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"depthfirsttraversal"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::graph","",85,{"inputs":[{"name":"depthfirsttraversal"}],"output":{"name":"option"}}],[11,"source","","",81,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"target","","",81,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"visit_fn","rustc::middle::intrinsicck","",86,null],[11,"visit_expr","","",86,null],[11,"repr","rustc::middle::ty","",87,{"inputs":[{"name":"transmuterestriction"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","rustc::middle::infer::bivariate","",88,{"inputs":[{"name":"bivariate"},{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"tag","","",88,{"inputs":[{"name":"bivariate"}],"output":{"name":"str"}}],[11,"tcx","","",88,{"inputs":[{"name":"bivariate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",88,{"inputs":[{"name":"bivariate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",88,{"inputs":[{"name":"bivariate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",88,{"inputs":[{"name":"bivariate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",88,{"inputs":[{"name":"bivariate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",88,{"inputs":[{"name":"bivariate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"clone","rustc::middle::infer::combine","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"tcx","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"ctxt"}}],[11,"switch_expected","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"equate","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"bivariate","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"sub","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"lub","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"glb","","",89,{"inputs":[{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"instantiate","","",89,{"inputs":[{"name":"combinefields"},{"name":"tys"},{"name":"relationdir"},{"name":"tyvid"}],"output":{"name":"result"}}],[11,"tcx","","",90,{"inputs":[{"name":"generalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",90,{"inputs":[{"name":"generalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",90,{"inputs":[{"name":"generalizer"},{"name":"region"}],"output":{"name":"region"}}],[11,"compare","core::result","",91,{"inputs":[{"name":"result"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[11,"new","rustc::middle::infer::equate","",92,{"inputs":[{"name":"equate"},{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"tag","","",92,{"inputs":[{"name":"equate"}],"output":{"name":"str"}}],[11,"tcx","","",92,{"inputs":[{"name":"equate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",92,{"inputs":[{"name":"equate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",92,{"inputs":[{"name":"equate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",92,{"inputs":[{"name":"equate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",92,{"inputs":[{"name":"equate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",92,{"inputs":[{"name":"equate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"report_region_errors","rustc::middle::infer","",93,null],[11,"process_errors","","",93,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"report_type_error","","",93,null],[11,"report_and_explain_type_error","","",93,null],[11,"values_str","","Returns a string of the form \"expected `{}`, found `{}`\", or None if this is a derived\nerror.",93,{"inputs":[{"name":"inferctxt"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str","","",93,{"inputs":[{"name":"inferctxt"},{"name":"expected_found"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",93,null],[11,"report_concrete_failure","","",93,null],[11,"report_sub_sup_conflict","","",93,null],[11,"report_sup_sup_conflict","","",93,null],[11,"report_processed_errors","","",93,null],[11,"give_suggestion","","",93,null],[11,"give_expl_lifetime_param","","",93,null],[11,"report_inference_failure","","",93,null],[11,"note_region_origin","","",93,null],[11,"resolve","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"inferctxt"}],"output":{"name":"rc"}}],[11,"contains_error","","",94,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"resolve","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"inferctxt"}],"output":{"name":"binder"}}],[11,"contains_error","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"new","rustc::middle::infer::glb","",96,{"inputs":[{"name":"glb"},{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"tag","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"str"}}],[11,"tcx","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",96,{"inputs":[{"name":"glb"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",96,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",96,{"inputs":[{"name":"glb"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",96,{"inputs":[{"name":"glb"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",96,{"inputs":[{"name":"glb"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",96,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"higher_ranked_sub","rustc::middle::infer::combine","",89,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_lub","","",89,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_glb","","",89,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"tainted_regions","rustc::middle::infer","",93,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any\ntypes/regions which existed before `snapshot` was\nstarted. This is used in the sub/lub/glb computations. The\nidea here is that when we are computing lub/glb of two\nregions, we sometimes create intermediate region variables.\nThose region variables may touch some of the skolemized or\nother \"forbidden\" regions we created to replace bound\nregions, but they don't really represent an \"external\"\nconstraint.",93,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"}],"output":{"name":"vec"}}],[11,"new","rustc::middle::infer::lub","",97,{"inputs":[{"name":"lub"},{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"tag","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"str"}}],[11,"tcx","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",97,{"inputs":[{"name":"lub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",97,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",97,{"inputs":[{"name":"lub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",97,{"inputs":[{"name":"lub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",97,{"inputs":[{"name":"lub"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",97,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::region_inference::graphviz","",98,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",98,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"ne","","",98,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"hash","","",98,null],[11,"clone","","",98,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",99,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",99,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"edge"}],"output":{"name":"edge"}}],[11,"graph_id","","",100,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"id"}}],[11,"node_id","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",100,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"edges","","",100,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"source","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",100,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"fmt","rustc::middle::infer::region_inference","",101,{"inputs":[{"name":"constraint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",101,null],[11,"eq","","",101,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"clone","","",101,{"inputs":[{"name":"constraint"}],"output":{"name":"constraint"}}],[11,"eq","","",102,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",102,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"fmt","","",102,{"inputs":[{"name":"generickind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",102,{"inputs":[{"name":"generickind"}],"output":{"name":"generickind"}}],[11,"hash","","",103,null],[11,"eq","","",103,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"clone","","",103,{"inputs":[{"name":"tworegions"}],"output":{"name":"tworegions"}}],[11,"eq","","",104,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",104,{"inputs":[{"name":"undologentry"}],"output":{"name":"undologentry"}}],[11,"eq","","",105,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"clone","","",105,{"inputs":[{"name":"combinemaptype"}],"output":{"name":"combinemaptype"}}],[11,"fmt","","",106,{"inputs":[{"name":"regionresolutionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"regionresolutionerror"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",107,{"inputs":[{"name":"sameregions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"sameregions"}],"output":{"name":"sameregions"}}],[11,"contains","","",107,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"push","","",107,null],[11,"fmt","","",108,{"inputs":[{"name":"regionsnapshot"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"ctxt"}],"output":{"name":"regionvarbindings"}}],[11,"start_snapshot","","",109,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",109,null],[11,"rollback_to","","",109,null],[11,"num_vars","","",109,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"u32"}}],[11,"new_region_var","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"new_skolemized","","Creates a new skolemized region. Skolemized regions are fresh\nregions used when performing higher-ranked computations. They\nmust be used in a very particular way and are never supposed\nto \"escape\" out into error messages or the code at large.",109,{"inputs":[{"name":"regionvarbindings"},{"name":"boundregion"},{"name":"regionsnapshot"}],"output":{"name":"region"}}],[11,"new_bound","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_given","","",109,null],[11,"make_eqregion","","",109,null],[11,"make_subregion","","",109,null],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",109,null],[11,"lub_regions","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"resolve_var","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_vars","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"},{"name":"f"}],"output":{"name":"region"}}],[11,"vars_created_since_snapshot","","",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":{"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` in any way since the mark `mark` was\nmade---`r0` itself will be the first entry. This is used when checking whether skolemized\nregions are being improperly related to other regions.",109,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"resolve_regions","","This function performs the actual region resolution.  It must be\ncalled after all constraints have been added.  It performs a\nfixed-point iteration to find region values which satisfy all\nconstraints, assuming such values can be found; if they cannot,\nerrors are reported.",109,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregionmap"},{"name":"u32"}],"output":{"name":"vec"}}],[11,"fmt","","",110,{"inputs":[{"name":"classification"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",110,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"ne","","",110,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"clone","","",110,{"inputs":[{"name":"classification"}],"output":{"name":"classification"}}],[11,"clone","","",111,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"repr","","",101,{"inputs":[{"name":"constraint"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",112,{"inputs":[{"name":"verify"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",111,{"inputs":[{"name":"varvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",113,{"inputs":[{"name":"regionandorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",102,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",102,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"to_ty","","",102,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::resolve","",114,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"inferctxt"}],"output":{"name":"opportunistictyperesolver"}}],[11,"tcx","","",114,{"inputs":[{"name":"opportunistictyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",114,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"tcx","","",115,{"inputs":[{"name":"fulltyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",115,{"inputs":[{"name":"fulltyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",115,{"inputs":[{"name":"fulltyperesolver"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::infer::freshen","",116,{"inputs":[{"name":"typefreshener"},{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"tcx","","",116,{"inputs":[{"name":"typefreshener"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",116,{"inputs":[{"name":"typefreshener"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",116,{"inputs":[{"name":"typefreshener"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::sub","",117,{"inputs":[{"name":"sub"},{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"tag","","",117,{"inputs":[{"name":"sub"}],"output":{"name":"str"}}],[11,"tcx","","",117,{"inputs":[{"name":"sub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",117,{"inputs":[{"name":"sub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",117,{"inputs":[{"name":"sub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",117,{"inputs":[{"name":"sub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",117,{"inputs":[{"name":"sub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",117,{"inputs":[{"name":"sub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::type_variable","",118,{"inputs":[{"name":"relationdir"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",118,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"ne","","",118,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"clone","","",118,{"inputs":[{"name":"relationdir"}],"output":{"name":"relationdir"}}],[11,"new","","",119,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"relate_vars","","Records that `a <: b`, `a :> b`, or `a == b`, depending on `dir`.",119,null],[11,"instantiate_and_push","","Instantiates `vid` with the type `ty` and then pushes an entry onto `stack` for each of the\nrelations of `vid` to other variables. The relations will have the form `(ty, dir, vid1)`\nwhere `vid1` is some other variable id.",119,null],[11,"new_var","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"probe","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"option"}}],[11,"replace_if_possible","","",119,{"inputs":[{"name":"typevariabletable"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"snapshot","","",119,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","",119,null],[11,"commit","","",119,null],[11,"types_escaping_snapshot","","Find the set of type variables that existed *before* `s`\nbut which have only been unified since `s` started, and\nreturn the types with which they were unified. So if we had\na type variable `V0`, then we started the snapshot, then we\ncreated a type variable `V1`, unifed `V0` with `T0`, and\nunified `V1` with `T1`, this function would return `{T0}`.",119,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":{"name":"vec"}}],[6,"Value","rustc_typeck::lint","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::type_variable","",120,null],[11,"fmt","rustc::middle::infer::unify","",121,{"inputs":[{"name":"varvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",121,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"eq","","",121,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",121,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","","",122,{"inputs":[{"name":"delegate"}],"output":{"name":"delegate"}}],[11,"new","","",123,{"inputs":[{"name":"unificationtable"}],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either\nrolled back or committed in a \"LIFO\" (stack) order.",123,{"inputs":[{"name":"unificationtable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also\nremoves any keys that have been created since then.",123,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",123,null],[11,"new_key","","",123,null],[6,"Value","rustc_typeck::lint","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::unify","",122,null],[11,"unify_var_var","","",123,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"k"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`. Because simple keys do not have any subtyping\nrelationships, if `a_id` already has a value, it must be the same as `b`.",123,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"v"}],"output":{"name":"result"}}],[11,"has_value","","",123,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"bool"}}],[11,"probe","","",123,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"option"}}],[6,"Value","rustc_typeck::lint","",null,null],[11,"index","rustc::middle::ty","",124,{"inputs":[{"name":"intvid"}],"output":{"name":"u32"}}],[11,"from_index","","",124,{"inputs":[{"name":"intvid"},{"name":"u32"}],"output":{"name":"intvid"}}],[11,"tag","","",124,{"inputs":[{"name":"intvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Value","rustc_typeck::lint","",null,null],[11,"index","rustc::middle::ty","",126,{"inputs":[{"name":"floatvid"}],"output":{"name":"u32"}}],[11,"from_index","","",126,{"inputs":[{"name":"floatvid"},{"name":"u32"}],"output":{"name":"floatvid"}}],[11,"tag","","",126,{"inputs":[{"name":"floatvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","syntax::ast","",127,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"fmt","rustc::middle::infer","",128,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",128,{"inputs":[{"name":"typeorigin"}],"output":{"name":"typeorigin"}}],[11,"fmt","","",128,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",129,{"inputs":[{"name":"valuepairs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"valuepairs"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",130,{"inputs":[{"name":"typetrace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"typetrace"}],"output":{"name":"typetrace"}}],[11,"fmt","","",131,{"inputs":[{"name":"subregionorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",131,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",132,{"inputs":[{"name":"lateboundregionconversiontime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"lateboundregionconversiontime"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",133,{"inputs":[{"name":"regionvariableorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",134,{"inputs":[{"name":"fixup_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"fixup_err"}],"output":{"name":"fixup_err"}}],[11,"freshen","","",93,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"freshener","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"unconstrainednumeric"}}],[11,"equate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"equate"}}],[11,"sub","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"sub"}}],[11,"lub","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"lub"}}],[11,"glb","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"glb"}}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"commit_regions_if_ok","","Execute `f` and commit only the region bindings if successful.\nThe function f must be very careful not to leak any non-region\nvariables that get created.",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",93,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",93,null],[11,"sub_types","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"eq_types","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"sub_trait_refs","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"sub_poly_trait_refs","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"construct_skolemized_subst","","See `higher_ranked::construct_skolemized_subst`",93,null],[11,"skolemize_late_bound_regions","","See `higher_ranked::skolemize_late_bound_regions`",93,null],[11,"leak_check","","See `higher_ranked::leak_check`",93,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"}],"output":{"name":"result"}}],[11,"plug_leaks","","See `higher_ranked::plug_leaks`",93,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"equality_predicate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"region_outlives_predicate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"next_ty_var_id","","",93,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_diverging_ty_var","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_ty_vars","","",93,{"inputs":[{"name":"inferctxt"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"next_int_var_id","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",93,{"inputs":[{"name":"inferctxt"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","",93,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"region_vars_for_defs","","",93,null],[11,"fresh_substs_for_generics","","Given a set of generics defined on a type or impl, returns a substitution mapping each\ntype/region parameter to a fresh inference variable.",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"fresh_substs_for_trait","","Given a set of generics defined on a trait, returns a substitution mapping each output\ntype/region parameter to a fresh inference variable, and mapping the self type to\n`self_ty`.",93,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"fresh_bound_region","","",93,{"inputs":[{"name":"inferctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"resolve_regions_and_report_errors","","",93,null],[11,"ty_to_string","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"string"}}],[11,"tys_to_string","","",93,null],[11,"trait_ref_to_string","","",93,{"inputs":[{"name":"inferctxt"},{"name":"rc"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",93,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in\n`value` with their final value. Note that region variables\nare unaffected. If a type variable has not been unified, it\nis left as is.  This is an idempotent operation that does\nnot affect inference state in any way and so you can do it\nat will.",93,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in\n`value`. Region inference must have been run already (e.g.,\nby calling `resolve_regions_and_report_errors`).  If some\nvariable was never unified, an `Err` results.",93,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[11,"type_error_message_str","","",93,null],[11,"type_error_message_str_with_expected","","",93,null],[11,"type_error_message","","",93,null],[11,"report_mismatched_types","","",93,null],[11,"replace_late_bound_regions_with_fresh_var","","",93,null],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_inference`",93,null],[11,"can_equate","","",93,{"inputs":[{"name":"inferctxt"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"span","","",130,{"inputs":[{"name":"typetrace"}],"output":{"name":"span"}}],[11,"types","","",130,{"inputs":[{"name":"typetrace"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"typetrace"}}],[11,"dummy","","",130,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"typetrace"}}],[11,"repr","","",130,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",128,{"inputs":[{"name":"typeorigin"}],"output":{"name":"span"}}],[11,"repr","","",128,{"inputs":[{"name":"typeorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",131,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"span"}}],[11,"repr","","",131,{"inputs":[{"name":"subregionorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",133,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"span"}}],[11,"repr","","",133,{"inputs":[{"name":"regionvariableorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::implicator","",135,{"inputs":[{"name":"implication"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"hash","rustc::middle::lang_items","",136,null],[11,"eq","","",136,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"ne","","",136,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"clone","","",136,{"inputs":[{"name":"langitem"}],"output":{"name":"langitem"}}],[11,"from_u32","","",136,{"inputs":[{"name":"langitem"},{"name":"u32"}],"output":{"name":"option"}}],[11,"new","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"languageitems"}}],[11,"items","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"enumerate"}}],[11,"item_name","","",137,{"inputs":[{"name":"languageitems"},{"name":"usize"}],"output":{"name":"str"}}],[11,"require","","",137,{"inputs":[{"name":"languageitems"},{"name":"langitem"}],"output":{"name":"result"}}],[11,"from_builtin_kind","","",137,{"inputs":[{"name":"languageitems"},{"name":"builtinbound"}],"output":{"name":"result"}}],[11,"to_builtin_kind","","",137,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"fn_trait_kind","","",137,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"char_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"slice_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"const_ptr_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mut_ptr_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i8_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i16_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i32_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i64_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"isize_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u8_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u16_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u32_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u64_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"usize_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f32_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f64_impl","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"send_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sized_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"copy_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sync_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"drop_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"add_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sub_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mul_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"div_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"rem_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"neg_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"not_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitxor_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitand_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitor_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shl_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shr_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_mut_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_from_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_to_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_full_struct","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"unsafe_cell_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_mut_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_mut_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_once_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eq_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"ord_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_eq_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_bounds_check_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fmt","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_malloc_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_free_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"strdup_uniq_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"start_fn","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eh_personality","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_heap","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"owned_box","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"phantom_data","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_type","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_lifetime","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_lifetime","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_lifetime","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"no_copy_bound","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"managed_bound","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"non_zero","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"stack_exhausted","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"debug_trait","","",137,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"visit_item","","",138,null],[11,"new","","",138,{"inputs":[{"name":"languageitemcollector"},{"name":"session"}],"output":{"name":"languageitemcollector"}}],[11,"collect_item","","",138,null],[11,"collect_local_language_items","","",138,null],[11,"collect_external_language_items","","",138,null],[11,"collect","","",138,null],[11,"eq","rustc::middle::liveness","",139,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"variable"}],"output":{"name":"variable"}}],[11,"eq","","",140,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"fmt","","",141,{"inputs":[{"name":"livenodekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",141,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"livenodekind"}],"output":{"name":"livenodekind"}}],[11,"visit_fn","","",142,null],[11,"visit_local","","",142,null],[11,"visit_expr","","",142,null],[11,"visit_arm","","",142,null],[11,"fmt","","",140,{"inputs":[{"name":"livenode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",139,{"inputs":[{"name":"variable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",143,{"inputs":[{"name":"localinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",143,{"inputs":[{"name":"localinfo"}],"output":{"name":"localinfo"}}],[11,"fmt","","",144,{"inputs":[{"name":"varkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"varkind"}],"output":{"name":"varkind"}}],[11,"visit_fn","","",145,null],[11,"visit_local","","",145,null],[11,"visit_expr","","",145,null],[11,"visit_arm","","",145,null],[11,"clone","","",146,{"inputs":[{"name":"users"}],"output":{"name":"users"}}],[11,"clone","","",147,{"inputs":[{"name":"specials"}],"output":{"name":"specials"}}],[11,"fmt","rustc::middle::mem_categorization","",148,{"inputs":[{"name":"categorization"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",148,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",148,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",148,{"inputs":[{"name":"categorization"}],"output":{"name":"categorization"}}],[11,"fmt","","",149,{"inputs":[{"name":"upvar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",149,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",149,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",149,{"inputs":[{"name":"upvar"}],"output":{"name":"upvar"}}],[11,"fmt","","",150,{"inputs":[{"name":"pointerkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",150,null],[11,"eq","","",150,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",150,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"clone","","",150,{"inputs":[{"name":"pointerkind"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",151,{"inputs":[{"name":"interiorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",151,null],[11,"eq","","",151,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"clone","","",151,{"inputs":[{"name":"interiorkind"}],"output":{"name":"interiorkind"}}],[11,"fmt","","",152,{"inputs":[{"name":"fieldname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",152,null],[11,"eq","","",152,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"fieldname"}],"output":{"name":"fieldname"}}],[11,"fmt","","",153,{"inputs":[{"name":"interioroffsetkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",153,null],[11,"eq","","",153,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"interioroffsetkind"}],"output":{"name":"interioroffsetkind"}}],[11,"fmt","","",154,{"inputs":[{"name":"elementkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",154,null],[11,"eq","","",154,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"clone","","",154,{"inputs":[{"name":"elementkind"}],"output":{"name":"elementkind"}}],[11,"fmt","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",155,null],[11,"eq","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"fmt","","",156,{"inputs":[{"name":"note"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",156,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"note"}],"output":{"name":"note"}}],[11,"fmt","","",157,{"inputs":[{"name":"cmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",157,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"clone","","",157,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"clone","","",158,{"inputs":[{"name":"deref_kind"}],"output":{"name":"deref_kind"}}],[11,"id","syntax::ast","",159,{"inputs":[{"name":"expr"}],"output":{"name":"u32"}}],[11,"span","","",159,{"inputs":[{"name":"expr"}],"output":{"name":"span"}}],[11,"id","","",160,{"inputs":[{"name":"pat"}],"output":{"name":"u32"}}],[11,"span","","",160,{"inputs":[{"name":"pat"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",161,{"inputs":[{"name":"memcategorizationcontext"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",155,{"inputs":[{"name":"mutabilitycategory"},{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"is_immutable","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"to_user_str","","",155,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"str"}}],[11,"new","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"typer"}],"output":{"name":"memcategorizationcontext"}}],[11,"cat_expr","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_expr_autoderefd","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"},{"name":"usize"}],"output":{"name":"result"}}],[11,"cat_expr_unadjusted","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_def","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"},{"name":"def"}],"output":{"name":"result"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`.\nThis could be `'static` if `id` is part of a constant expression.",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_rvalue","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"region"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_field","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"name"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_tup_field","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"usize"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"interioroffsetkind"}],"output":{"name":"result"}}],[11,"cat_slice_pattern","","Given a pattern P like: `[_, ..Q, _]`, where `vec_cmt` is the cmt for `P`, `slice_pat` is\nthe pattern `Q`, returns:",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"}],"output":{"name":"result"}}],[11,"cat_imm_interior","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"interiorkind"}],"output":{"name":"rc"}}],[11,"cat_downcast","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"defid"}],"output":{"name":"rc"}}],[11,"cat_pattern","","",161,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"},{"name":"f"}],"output":{"name":"result"}}],[11,"fmt","","",162,{"inputs":[{"name":"interiorsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",162,{"inputs":[{"name":"interiorsafety"}],"output":{"name":"interiorsafety"}}],[11,"fmt","","",163,{"inputs":[{"name":"aliasability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",163,{"inputs":[{"name":"aliasability"}],"output":{"name":"aliasability"}}],[11,"fmt","","",164,{"inputs":[{"name":"aliasablereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",164,{"inputs":[{"name":"aliasablereason"}],"output":{"name":"aliasablereason"}}],[11,"guarantor","","Returns `self` after stripping away any owned pointer derefs or\ninterior content. The return value is basically the `cmt` which\ndetermines how long the value in `self` remains live.",157,{"inputs":[{"name":"cmt_"}],"output":{"name":"rc"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this lvalue represents a freely aliasable pointer type.",157,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"aliasability"}}],[11,"upvar","","",157,{"inputs":[{"name":"cmt_"}],"output":{"name":"option"}}],[11,"descriptive_string","","",157,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",157,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",148,{"inputs":[{"name":"categorization"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",150,{"inputs":[{"name":"pointerkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",151,{"inputs":[{"name":"interiorkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",165,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::mem_categorization","",149,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",149,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::privacy","",166,{"inputs":[{"name":"lastprivate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",166,{"inputs":[{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"fmt","","",167,{"inputs":[{"name":"privatedep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",167,{"inputs":[{"name":"privatedep"}],"output":{"name":"privatedep"}}],[11,"fmt","","",168,{"inputs":[{"name":"importuse"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",168,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"ne","","",168,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"clone","","",168,{"inputs":[{"name":"importuse"}],"output":{"name":"importuse"}}],[11,"or","","",166,{"inputs":[{"name":"lastprivate"},{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"visit_expr","rustc::middle::reachable","",169,null],[11,"visit_item","","",169,null],[11,"fmt","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",18,{"inputs":[{"name":"codeextent"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"codeextent"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",18,null],[11,"cmp","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"eq","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"fmt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",19,null],[11,"cmp","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"option"}}],[11,"lt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"le","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"gt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ge","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"eq","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"destructionscopedata"}}],[11,"new","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"u32"}],"output":{"name":"destructionscopedata"}}],[11,"to_code_extent","","",19,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"codeextent"}}],[11,"fmt","","",170,{"inputs":[{"name":"blockremainder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",170,{"inputs":[{"name":"blockremainder"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",170,{"inputs":[{"name":"blockremainder"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",170,null],[11,"cmp","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"option"}}],[11,"lt","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"eq","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",170,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"clone","","",170,{"inputs":[{"name":"blockremainder"}],"output":{"name":"blockremainder"}}],[11,"from_node_id","","Creates a scope that represents the dynamic extent associated\nwith `node_id`.",18,{"inputs":[{"name":"codeextent"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"node_id","","Returns a node id associated with this scope.",18,{"inputs":[{"name":"codeextent"}],"output":{"name":"u32"}}],[11,"map_id","","Maps this scope to a potentially new one according to the\nNodeId transformer `f_id`.",18,{"inputs":[{"name":"codeextent"},{"name":"f"}],"output":{"name":"codeextent"}}],[11,"span","","Returns the span of this CodeExtent.  Note that in general the\nreturned span may not correspond to the span of any node id in\nthe AST.",18,{"inputs":[{"name":"codeextent"},{"name":"map"}],"output":{"name":"option"}}],[11,"clone","","",171,{"inputs":[{"name":"innermostdeclaringblock"}],"output":{"name":"innermostdeclaringblock"}}],[11,"fmt","","",171,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",171,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"ne","","",171,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"clone","","",172,{"inputs":[{"name":"declaringstatementcontext"}],"output":{"name":"declaringstatementcontext"}}],[11,"fmt","","",172,{"inputs":[{"name":"declaringstatementcontext"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",172,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"ne","","",172,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"clone","","",173,{"inputs":[{"name":"innermostenclosingexpr"}],"output":{"name":"innermostenclosingexpr"}}],[11,"fmt","","",173,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",173,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"ne","","",173,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"clone","","",174,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"fmt","","",174,{"inputs":[{"name":"context"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"each_encl_scope","","",175,null],[11,"each_var_scope","","",175,null],[11,"each_rvalue_scope","","",175,null],[11,"each_terminating_scope","","",175,null],[11,"record_encl_scope","","",175,null],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",175,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",175,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",175,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"region"}}],[11,"scopes_intersect","","",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false\notherwise.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest\nscope which is greater than or equal to both `scope_a` and `scope_b`.",175,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"visit_block","","",176,null],[11,"visit_item","","",176,null],[11,"visit_fn","","",176,null],[11,"visit_arm","","",176,null],[11,"visit_pat","","",176,null],[11,"visit_stmt","","",176,null],[11,"visit_expr","","",176,null],[11,"visit_local","","",176,null],[11,"fmt","rustc::middle::resolve_lifetime","",177,{"inputs":[{"name":"defregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",177,{"inputs":[{"name":"defregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",177,{"inputs":[{"name":"defregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",177,null],[11,"eq","","",177,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"ne","","",177,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"clone","","",177,{"inputs":[{"name":"defregion"}],"output":{"name":"defregion"}}],[11,"visit_item","","",178,null],[11,"visit_fn","","",178,null],[11,"visit_ty","","",178,null],[11,"visit_trait_item","","",178,null],[11,"visit_block","","",178,null],[11,"visit_lifetime_ref","","",178,null],[11,"visit_generics","","",178,null],[11,"visit_poly_trait_ref","","",178,null],[11,"eq","","",179,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"ne","","",179,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"clone","","",179,{"inputs":[{"name":"shadowkind"}],"output":{"name":"shadowkind"}}],[11,"fmt","","",180,{"inputs":[{"name":"scopechain"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"visit_item","rustc::middle::stability","",181,null],[11,"visit_fn","","",181,null],[11,"visit_trait_item","","",181,null],[11,"visit_impl_item","","",181,null],[11,"visit_variant","","",181,null],[11,"visit_struct_field","","",181,null],[11,"visit_foreign_item","","",181,null],[11,"build","","Construct the stability index for a crate being compiled.",182,null],[11,"new","","",182,{"inputs":[{"name":"index"},{"name":"crate"}],"output":{"name":"index"}}],[11,"visit_item","","",183,null],[11,"visit_expr","","",183,null],[11,"visit_path","","",183,null],[11,"visit_pat","","",183,null],[11,"fmt","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",184,null],[11,"eq","","",184,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"ne","","",184,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"fmt","","",185,{"inputs":[{"name":"regionsubsts"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",185,null],[11,"eq","","",185,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"clone","","",185,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"regionsubsts"}}],[11,"new","","",184,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"new_type","","",184,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"new_trait","","",184,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erased","","",184,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"empty","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"trans_empty","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"is_noop","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"type_for_def","","",184,{"inputs":[{"name":"substs"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[11,"has_regions_escaping_depth","","",184,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"self_ty","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"option"}}],[11,"with_self_ty","","",184,{"inputs":[{"name":"substs"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erase_regions","","",184,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",184,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"mut_regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",184,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"with_method","","",184,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"is_erased","","",185,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"fmt","","",186,{"inputs":[{"name":"paramspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",186,{"inputs":[{"name":"paramspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",186,{"inputs":[{"name":"paramspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",186,null],[11,"clone","","",186,{"inputs":[{"name":"paramspace"}],"output":{"name":"paramspace"}}],[11,"eq","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ne","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"cmp","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"lt","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"le","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"gt","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ge","","",186,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"all","","",186,null],[11,"to_uint","","",186,{"inputs":[{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"from_uint","","",186,{"inputs":[{"name":"paramspace"},{"name":"usize"}],"output":{"name":"paramspace"}}],[11,"decode","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",187,null],[11,"clone","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"eq","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"ne","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"fmt","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"params_from_type","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"new","","`t` is the type space.\n`s` is the self space.\n`a` is the assoc space.\n`f` is the fn space.",187,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"push","","Appends `value` to the vector associated with `space`.",187,null],[11,"extend","","Appends `values` to the vector associated with `space`.",187,null],[11,"pop","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"truncate","","",187,null],[11,"replace","","",187,null],[11,"get_self","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"option"}}],[11,"len","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"is_empty_in","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"get_slice","","",187,null],[11,"get_mut_slice","","",187,null],[11,"opt_get","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"t"}}],[11,"iter","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"iter"}}],[11,"into_iter","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[11,"iter_enumerated","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"enumerateditems"}}],[11,"as_slice","","",187,null],[11,"into_vec","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vec"}}],[11,"all_vecs","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"all","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"any","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"is_empty","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"map","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_enumerated","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_move","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"split","","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"separatevecsperparamspace"}}],[11,"with_vec","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"clone","","",188,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"enumerateditems"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::subst","",188,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"option"}}],[6,"Item","rustc_typeck::lint","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","rustc::middle::subst","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[6,"Item","rustc_typeck::lint","",null,null],[6,"IntoIter","","",null,null],[11,"tcx","rustc::middle::subst","",189,{"inputs":[{"name":"substfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",189,null],[11,"exit_region_binder","","",189,null],[11,"fold_region","","",189,{"inputs":[{"name":"substfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",189,{"inputs":[{"name":"substfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","rustc::middle::traits::coherence","",190,{"inputs":[{"name":"inferislocal"}],"output":{"name":"inferislocal"}}],[11,"clone","rustc::middle::traits::fulfill","",191,{"inputs":[{"name":"regionobligation"}],"output":{"name":"regionobligation"}}],[11,"new","","",192,{"inputs":[{"name":"fulfillmentcontext"}],"output":{"name":"fulfillmentcontext"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by\ncreating a fresh type variable `$0` as well as a projection\npredicate `<SomeType as SomeTrait>::X == $0`. When the\ninference engine runs, it will attempt to find an impl of\n`SomeTrait` or a where clause that lets us unify `$0` with\nsomething concrete. If this fails, we'll unify `$0` with\n`projection_ty` again.",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"tys"}}],[11,"register_builtin_bound","","",192,null],[11,"register_region_obligation","","",192,null],[11,"register_predicate_obligation","","",192,null],[11,"region_obligations","","",192,null],[11,"select_all_or_error","","",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_new_obligations","","Attempts to select obligations that were registered since the call to a selection routine.\nThis is used by the type checker to eagerly attempt to resolve obligations in hopes of\ngaining type information. It'd be equally valid to use `select_where_possible` but it\nresults in `O(n^2)` performance (#18208).",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_where_possible","","",192,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"pending_obligations","","",192,null],[11,"repr","","",191,{"inputs":[{"name":"regionobligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::project","",193,{"inputs":[{"name":"mismatchedprojectiontypes"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"eq","","",194,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"ne","","",194,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"tcx","","",195,{"inputs":[{"name":"associatedtypenormalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",195,{"inputs":[{"name":"associatedtypenormalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","","",196,{"inputs":[{"name":"normalized"}],"output":{"name":"normalized"}}],[11,"with","","",196,{"inputs":[{"name":"normalized"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"repr","","",197,{"inputs":[{"name":"projectiontyerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",194,{"inputs":[{"name":"projectiontycandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","","",196,{"inputs":[{"name":"normalized"},{"name":"f"}],"output":{"name":"normalized"}}],[11,"repr","","",196,{"inputs":[{"name":"normalized"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::traits::object_safety","",198,{"inputs":[{"name":"methodviolationcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",198,{"inputs":[{"name":"methodviolationcode"}],"output":{"name":"methodviolationcode"}}],[11,"repr","","",199,{"inputs":[{"name":"objectsafetyviolation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::select","",200,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"fmt","","",201,{"inputs":[{"name":"methodmatcheddata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",201,{"inputs":[{"name":"methodmatcheddata"}],"output":{"name":"methodmatcheddata"}}],[11,"clone","","",202,{"inputs":[{"name":"selectioncandidate"}],"output":{"name":"selectioncandidate"}}],[11,"fmt","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"ne","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"fmt","","",203,{"inputs":[{"name":"evaluationresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",204,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",204,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"infcx","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"ctxt"}}],[11,"param_env","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"parameterenvironment"}}],[11,"closure_typer","","",204,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"closuretyper"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding\ntype environment by performing unification.",204,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"result"}}],[11,"evaluate_obligation","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",204,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"evaluate_impl","","Evaluates whether the impl with id `impl_def_id` could be applied to the self type\n`obligation_self_ty`. This can be used either for trait or inherent impls.",204,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"repr","","",202,{"inputs":[{"name":"selectioncandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","","",200,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"clone","","",205,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"traitobligationstacklist"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::traits::select","",205,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"option"}}],[11,"repr","","",206,{"inputs":[{"name":"traitobligationstack"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"may_apply","","",207,{"inputs":[{"name":"methodmatchresult"}],"output":{"name":"bool"}}],[11,"filter_to_traits","rustc::middle::traits::util","",208,{"inputs":[{"name":"elaborator"}],"output":{"name":"filtertotraits"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::traits::util","",208,{"inputs":[{"name":"elaborator"}],"output":{"name":"option"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::traits::util","",209,{"inputs":[{"name":"supertraitdefids"}],"output":{"name":"option"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::traits::util","",210,{"inputs":[{"name":"filtertotraits"}],"output":{"name":"option"}}],[11,"fmt","rustc::middle::traits","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",213,{"inputs":[{"name":"obligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",214,{"inputs":[{"name":"vtable"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",217,{"inputs":[{"name":"selectionerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",218,{"inputs":[{"name":"fulfillmenterror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",219,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",219,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","rustc::middle::traits::project","",193,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",193,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","rustc::middle::traits","",213,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"clone","","",213,{"inputs":[{"name":"obligation"}],"output":{"name":"obligation"}}],[11,"eq","","",220,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",220,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",220,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"eq","","",221,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",221,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"clone","","",221,{"inputs":[{"name":"obligationcausecode"}],"output":{"name":"obligationcausecode"}}],[11,"eq","","",222,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",222,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",222,{"inputs":[{"name":"derivedobligationcause"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",217,{"inputs":[{"name":"selectionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",217,{"inputs":[{"name":"selectionerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",219,{"inputs":[{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",214,{"inputs":[{"name":"vtable"}],"output":{"name":"vtable"}}],[11,"fmt","","",214,{"inputs":[{"name":"vtable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"clone","","",211,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"vtableimpldata"}}],[11,"clone","","",216,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fmt","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",215,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"vtablebuiltindata"}}],[11,"fmt","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",212,{"inputs":[{"name":"vtableobjectdata"}],"output":{"name":"vtableobjectdata"}}],[11,"eq","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"new","","",213,{"inputs":[{"name":"obligation"},{"name":"obligationcause"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",213,{"inputs":[{"name":"obligation"},{"name":"span"},{"name":"u32"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",213,{"inputs":[{"name":"obligation"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",220,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",220,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",220,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"iter_nested","","",214,{"inputs":[{"name":"vtable"}],"output":{"name":"iter"}}],[11,"map_nested","","",214,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"map_move_nested","","",214,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"iter_nested","","",211,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"map_move_nested","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"iter_nested","","",216,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"map_move_nested","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"iter_nested","","",215,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"iter"}}],[11,"map_nested","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"map_move_nested","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"hash","rustc::middle::ty","",223,null],[11,"eq","","",223,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",223,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",223,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",224,{"inputs":[{"name":"implortraititemcontainer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",224,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"implortraititemcontainer"}}],[11,"id","","",224,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"defid"}}],[11,"fmt","","",225,{"inputs":[{"name":"implortraititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititem"}}],[11,"def_id","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"defid"}}],[11,"name","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"name"}}],[11,"container","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititemcontainer"}}],[11,"as_opt_method","","",225,{"inputs":[{"name":"implortraititem"}],"output":{"name":"option"}}],[11,"fmt","","",226,{"inputs":[{"name":"implortraititemid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",226,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"implortraititemid"}}],[11,"def_id","","",226,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"defid"}}],[11,"fmt","","",227,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",227,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"new","","",227,{"inputs":[{"name":"method"},{"name":"name"},{"name":"generics"},{"name":"genericpredicates"},{"name":"barefnty"},{"name":"explicitselfcategory"},{"name":"visibility"},{"name":"defid"},{"name":"implortraititemcontainer"},{"name":"option"}],"output":{"name":"method"}}],[11,"container_id","","",227,{"inputs":[{"name":"method"}],"output":{"name":"defid"}}],[11,"fmt","","",228,{"inputs":[{"name":"associatedtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",228,{"inputs":[{"name":"associatedtype"}],"output":{"name":"associatedtype"}}],[11,"fmt","","",229,{"inputs":[{"name":"mt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",229,null],[11,"eq","","",229,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"ne","","",229,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"clone","","",229,{"inputs":[{"name":"mt"}],"output":{"name":"mt"}}],[11,"fmt","","",230,{"inputs":[{"name":"field_ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",230,{"inputs":[{"name":"field_ty"}],"output":{"name":"field_ty"}}],[11,"hash","","",231,null],[11,"eq","","",231,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"ne","","",231,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"clone","","",231,{"inputs":[{"name":"creader_cache_key"}],"output":{"name":"creader_cache_key"}}],[11,"encode","","",232,{"inputs":[{"name":"itemvariances"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",232,{"inputs":[{"name":"itemvariances"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",232,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"ne","","",232,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"clone","","",232,{"inputs":[{"name":"itemvariances"}],"output":{"name":"itemvariances"}}],[11,"fmt","","",233,{"inputs":[{"name":"variance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",233,{"inputs":[{"name":"variance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",233,{"inputs":[{"name":"variance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",233,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"ne","","",233,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"clone","","",233,{"inputs":[{"name":"variance"}],"output":{"name":"variance"}}],[11,"fmt","","",234,{"inputs":[{"name":"autoadjustment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",234,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"autoadjustment"}}],[11,"fmt","","",235,{"inputs":[{"name":"autoderefref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",235,{"inputs":[{"name":"autoderefref"}],"output":{"name":"autoderefref"}}],[11,"fmt","","",236,{"inputs":[{"name":"autoref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",236,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"ne","","",236,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"clone","","",236,{"inputs":[{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fmt","","",237,{"inputs":[{"name":"param_index"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"option"}}],[11,"lt","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"le","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"gt","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ge","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"eq","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ne","","",237,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"decode","","",237,{"inputs":[{"name":"param_index"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",237,{"inputs":[{"name":"param_index"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",237,{"inputs":[{"name":"param_index"}],"output":{"name":"param_index"}}],[11,"fmt","","",25,{"inputs":[{"name":"methodorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"methodorigin"}],"output":{"name":"methodorigin"}}],[11,"fmt","","",238,{"inputs":[{"name":"methodparam"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"methodparam"}],"output":{"name":"methodparam"}}],[11,"fmt","","",239,{"inputs":[{"name":"methodobject"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",239,{"inputs":[{"name":"methodobject"}],"output":{"name":"methodobject"}}],[11,"clone","","",240,{"inputs":[{"name":"methodcallee"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",241,{"inputs":[{"name":"methodcall"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",241,null],[11,"eq","","",241,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"ne","","",241,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"clone","","",241,{"inputs":[{"name":"methodcall"}],"output":{"name":"methodcall"}}],[11,"expr","","",241,{"inputs":[{"name":"methodcall"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"autoderef","","",241,{"inputs":[{"name":"methodcall"},{"name":"u32"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"clone","","",242,{"inputs":[{"name":"vtable_origin"}],"output":{"name":"vtable_origin"}}],[11,"clone","","",87,{"inputs":[{"name":"transmuterestriction"}],"output":{"name":"transmuterestriction"}}],[11,"new","","",243,{"inputs":[{"name":"ctxtarenas"}],"output":{"name":"ctxtarenas"}}],[11,"node_types","","",244,{"inputs":[{"name":"ctxt"}],"output":{"name":"ref"}}],[11,"node_type_insert","","",244,null],[11,"store_free_region_map","","",244,null],[11,"free_region_map","","",244,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"freeregionmap"}}],[11,"hash","","",245,null],[11,"cmp","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"option"}}],[11,"lt","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"clone","","",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"eq","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",245,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",245,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",245,null],[11,"remove","","Removes the specified flags in-place.",245,null],[11,"toggle","","Toggles the specified flags in-place.",245,null],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitor","rustc::middle::ty","Returns the union of the two sets of flags.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitxor","rustc::middle::ty","Returns the left flags, but with all the right flags toggled.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitand","rustc::middle::ty","Returns the intersection between the two sets of flags.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"sub","rustc::middle::ty","Returns the set difference of the two sets of flags.",245,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"not","rustc::middle::ty","Returns the complement of this set of flags.",245,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"print_debug_stats","","",244,null],[11,"fmt","","",246,{"inputs":[{"name":"tys"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",245,{"inputs":[{"name":"typeflags"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",246,{"inputs":[{"name":"tys"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",246,null],[11,"eq","","",247,{"inputs":[{"name":"internedty"},{"name":"internedty"}],"output":{"name":"bool"}}],[11,"hash","","",247,null],[11,"borrow","","",247,{"inputs":[{"name":"internedty"}],"output":{"name":"sty"}}],[11,"fmt","","",248,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",248,null],[11,"eq","","",248,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",248,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",248,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",249,{"inputs":[{"name":"closurety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",249,null],[11,"eq","","",249,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"ne","","",249,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"clone","","",249,{"inputs":[{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fmt","","",250,{"inputs":[{"name":"fnoutput"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",250,null],[11,"eq","","",250,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"ne","","",250,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"clone","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"diverges","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"unwrap","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"tys"}}],[11,"unwrap_or","","",250,{"inputs":[{"name":"fnoutput"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"diverges","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"hash","","",251,null],[11,"eq","","",251,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",251,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"clone","","",251,{"inputs":[{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"inputs","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"input","","",95,{"inputs":[{"name":"binder"},{"name":"usize"}],"output":{"name":"binder"}}],[11,"output","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"variadic","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"fmt","","",252,{"inputs":[{"name":"paramty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",252,null],[11,"eq","","",252,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",252,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"clone","","",252,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"fmt","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",253,null],[11,"eq","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"clone","","",253,{"inputs":[{"name":"debruijnindex"}],"output":{"name":"debruijnindex"}}],[11,"fmt","","",16,{"inputs":[{"name":"region"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"region"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"region"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",16,null],[11,"eq","","",16,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"region"}],"output":{"name":"region"}}],[11,"fmt","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",254,null],[11,"eq","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",254,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"clone","","",254,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"earlyboundregion"}}],[11,"fmt","","",255,{"inputs":[{"name":"upvarid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",255,null],[11,"eq","","",255,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",255,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"clone","","",255,{"inputs":[{"name":"upvarid"}],"output":{"name":"upvarid"}}],[11,"decode","","",256,{"inputs":[{"name":"borrowkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",256,{"inputs":[{"name":"borrowkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",256,{"inputs":[{"name":"borrowkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",256,null],[11,"eq","","",256,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",256,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"clone","","",256,{"inputs":[{"name":"borrowkind"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"upvarcapture"}],"output":{"name":"upvarcapture"}}],[11,"eq","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"fmt","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"upvarborrow"}],"output":{"name":"upvarborrow"}}],[11,"eq","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"is_bound","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",16,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"fmt","","",17,{"inputs":[{"name":"freeregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"freeregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"freeregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",17,null],[11,"cmp","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"option"}}],[11,"lt","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"eq","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"freeregion"}],"output":{"name":"freeregion"}}],[11,"fmt","","",20,{"inputs":[{"name":"boundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",20,{"inputs":[{"name":"boundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",20,{"inputs":[{"name":"boundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",20,null],[11,"cmp","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"lt","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"eq","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"boundregion"}],"output":{"name":"boundregion"}}],[11,"fmt","","",257,{"inputs":[{"name":"sty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",257,null],[11,"eq","","",257,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"clone","","",257,{"inputs":[{"name":"sty"}],"output":{"name":"sty"}}],[11,"fmt","","",258,{"inputs":[{"name":"tytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",258,null],[11,"eq","","",258,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"clone","","",258,{"inputs":[{"name":"tytrait"}],"output":{"name":"tytrait"}}],[11,"principal_def_id","","",258,{"inputs":[{"name":"tytrait"}],"output":{"name":"defid"}}],[11,"principal_trait_ref_with_self_ty","","Object types don't have a self-type specified. Therefore, when\nwe convert the principal trait-ref into a normal trait-ref,\nyou must give *some* self-type. A common choice is `mk_err()`\nor some skolemized type.",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"binder"}}],[11,"projection_bounds_with_self_ty","","",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"vec"}}],[11,"fmt","","",259,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",259,null],[11,"eq","","",259,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"self_ty","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"tys"}}],[11,"def_id","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"substs","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"substs"}}],[11,"input_types","","",95,null],[11,"to_poly_trait_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"fmt","","",95,{"inputs":[{"name":"binder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",95,null],[11,"eq","","",95,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",95,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"clone","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a\nrisky thing to do because it's easy to get confused about\ndebruijn indices and the like. It is usually better to\ndischarge the binder using `no_late_bound_regions` or\n`replace_late_bound_regions` or something like\nthat. `skip_binder` is only valid when you are either\nextracting data that has nothing to do with bound regions, you\nare doing some sort of test that does not involve bound\nregions, or you are being very careful about your depth\naccounting.",95,{"inputs":[{"name":"binder"}],"output":{"name":"t"}}],[11,"as_ref","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",95,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",95,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"eq","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"intvarvalue"}],"output":{"name":"intvarvalue"}}],[11,"fmt","","",260,{"inputs":[{"name":"terr_vstore_kind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",260,{"inputs":[{"name":"terr_vstore_kind"}],"output":{"name":"terr_vstore_kind"}}],[11,"fmt","","",261,{"inputs":[{"name":"expected_found"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",261,{"inputs":[{"name":"expected_found"}],"output":{"name":"expected_found"}}],[11,"fmt","","",262,{"inputs":[{"name":"type_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",262,{"inputs":[{"name":"type_err"}],"output":{"name":"type_err"}}],[11,"fmt","","",263,{"inputs":[{"name":"parambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",263,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"hash","","",263,null],[11,"eq","","",263,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"ne","","",263,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"fmt","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",264,{"inputs":[{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"hash","","",264,null],[11,"eq","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"ne","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"fmt","","",265,{"inputs":[{"name":"builtinbound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",265,null],[11,"decode","","",265,{"inputs":[{"name":"builtinbound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",265,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"encode","","",265,{"inputs":[{"name":"builtinbound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",265,{"inputs":[{"name":"builtinbound"}],"output":{"name":"builtinbound"}}],[11,"to_usize","","",265,{"inputs":[{"name":"builtinbound"}],"output":{"name":"usize"}}],[11,"from_usize","","",265,{"inputs":[{"name":"builtinbound"},{"name":"usize"}],"output":{"name":"builtinbound"}}],[11,"hash","","",266,null],[11,"eq","","",266,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",266,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"clone","","",266,{"inputs":[{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"hash","","",124,null],[11,"eq","","",124,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",124,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"clone","","",124,{"inputs":[{"name":"intvid"}],"output":{"name":"intvid"}}],[11,"hash","","",126,null],[11,"eq","","",126,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"floatvid"}],"output":{"name":"floatvid"}}],[11,"hash","","",267,null],[11,"decode","","",267,{"inputs":[{"name":"regionvid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",267,{"inputs":[{"name":"regionvid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",267,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",267,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"clone","","",267,{"inputs":[{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"hash","","",268,null],[11,"eq","","",268,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",268,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"clone","","",268,{"inputs":[{"name":"inferty"}],"output":{"name":"inferty"}}],[11,"fmt","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",269,null],[11,"eq","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"ne","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"decode","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",269,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",269,{"inputs":[{"name":"unconstrainednumeric"}],"output":{"name":"unconstrainednumeric"}}],[11,"fmt","","",270,{"inputs":[{"name":"inferregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",270,null],[11,"decode","","",270,{"inputs":[{"name":"inferregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",270,{"inputs":[{"name":"inferregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",270,{"inputs":[{"name":"inferregion"}],"output":{"name":"inferregion"}}],[11,"eq","","",270,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"ne","","",270,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"fmt","","",266,{"inputs":[{"name":"tyvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",124,{"inputs":[{"name":"intvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",126,{"inputs":[{"name":"floatvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",267,{"inputs":[{"name":"regionvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",251,{"inputs":[{"name":"fnsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",268,{"inputs":[{"name":"inferty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",271,{"inputs":[{"name":"objectlifetimedefault"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",271,{"inputs":[{"name":"objectlifetimedefault"}],"output":{"name":"objectlifetimedefault"}}],[11,"fmt","","",272,{"inputs":[{"name":"typeparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",272,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"typeparameterdef"}}],[11,"fmt","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",273,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"regionparameterdef"}}],[11,"decode","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"to_early_bound_region","","",273,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"to_bound_region","","",273,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"boundregion"}}],[11,"fmt","","",274,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",274,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"empty","","",274,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_empty","","",274,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"has_type_params","","",274,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"has_region_params","","",274,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"fmt","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",275,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"empty","","",275,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_supertrait","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"instantiatedpredicates"}}],[11,"fmt","","",276,{"inputs":[{"name":"predicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",276,null],[11,"eq","","",276,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",276,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"clone","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substituion suitable for going from a\npoly-trait-ref to supertraits that must hold if that\npoly-trait-ref holds. This is slightly different from a normal\nsubstitution in terms of what happens with bound regions.  See\nlengthy comment below for details.",276,{"inputs":[{"name":"predicate"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"predicate"}}],[11,"fmt","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",277,null],[11,"eq","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"traitpredicate"}}],[11,"def_id","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"defid"}}],[11,"input_types","","",277,null],[11,"self_ty","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"tys"}}],[11,"def_id","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"fmt","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",278,null],[11,"eq","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",278,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"equatepredicate"}}],[11,"fmt","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",279,null],[11,"eq","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"clone","","",279,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"outlivespredicate"}}],[11,"fmt","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",280,null],[11,"eq","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",280,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"projectionpredicate"}}],[11,"item_name","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"name"}}],[11,"sort_key","","",95,null],[11,"fmt","","",281,{"inputs":[{"name":"projectionty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",281,null],[11,"eq","","",281,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",281,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"clone","","",281,{"inputs":[{"name":"projectionty"}],"output":{"name":"projectionty"}}],[11,"sort_key","","",281,null],[11,"to_poly_trait_ref","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","rustc::middle::ty","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"as_predicate","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"predicate"}}],[11,"as_predicate","rustc::middle::ty","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all\ncases this is skipping over a binder, so late-bound regions\nwith depth 0 are bound by the predicate.",276,{"inputs":[{"name":"predicate"}],"output":{"name":"intoiter"}}],[11,"has_escaping_regions","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"to_opt_poly_trait_ref","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"option"}}],[11,"fmt","","",282,{"inputs":[{"name":"instantiatedpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"has_escaping_regions","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"is_empty","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"new","","",259,{"inputs":[{"name":"traitref"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"tys"}}],[11,"input_types","","",259,null],[11,"clone","","",283,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"with_caller_bounds","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"vec"}],"output":{"name":"parameterenvironment"}}],[11,"for_item","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[11,"fmt","","",284,{"inputs":[{"name":"typescheme"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",284,{"inputs":[{"name":"typescheme"}],"output":{"name":"typescheme"}}],[11,"clone","","",285,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"decode","","",165,{"inputs":[{"name":"closurekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",165,{"inputs":[{"name":"closurekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",165,{"inputs":[{"name":"closurekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ne","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"cmp","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"option"}}],[11,"lt","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"le","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"gt","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ge","","",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"clone","","",165,{"inputs":[{"name":"closurekind"}],"output":{"name":"closurekind"}}],[11,"trait_did","","",165,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind\nmust also implement `other`.",165,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"mk_substs","","",244,{"inputs":[{"name":"ctxt"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"safe_to_unsafe_fn_ty","","Create an unsafe fn ty based on a safe fn ty.",244,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"tys"}}],[11,"mk_bare_fn","","",244,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"mk_region","","",244,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"region"}}],[11,"closure_kind","","",244,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"closurekind"}}],[11,"closure_type","","",244,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"type_parameter_def","","",244,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"typeparameterdef"}}],[11,"pat_contains_ref_binding","","",244,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"arm_contains_ref_binding","","",244,{"inputs":[{"name":"ctxt"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"walk","","Iterator that walks `self` and any types reachable from\n`self`, in depth-first order. Note that just walks the types\nthat appear in `self`, it does not descend into the fields of\nstructs or variants. For example:",246,{"inputs":[{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence\n`Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]`\n(but not `i32`, like `walk`).",246,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[11,"as_opt_param_ty","","",246,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[11,"is_param","","",246,{"inputs":[{"name":"tys"},{"name":"paramspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"new","","",252,{"inputs":[{"name":"paramty"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"paramty"}}],[11,"for_self","","",252,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"for_def","","",252,{"inputs":[{"name":"paramty"},{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",252,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"is_self","","",252,{"inputs":[{"name":"paramty"}],"output":{"name":"bool"}}],[11,"empty","","",285,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"is_noop","","",285,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"bool"}}],[11,"empty","","",263,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"clone","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"when","","",286,{"inputs":[{"name":"typecontents"},{"name":"bool"}],"output":{"name":"typecontents"}}],[11,"intersects","","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_managed","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_owned","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"is_sized","","",286,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"interior_param","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsafe","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsized","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"needs_drop","","",286,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"owned_pointer","","Includes only those bits that still apply when indirected through a `Box` pointer",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"reference","","Includes only those bits that still apply when indirected through a reference (`&`)",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"managed_pointer","","Includes only those bits that still apply when indirected through a managed pointer (`@`)",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"unsafe_pointer","","Includes only those bits that still apply when indirected through an unsafe pointer (`*`)",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"union","","",286,null],[11,"has_dtor","","",286,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitor","rustc::middle::ty","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitand","rustc::middle::ty","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"sub","rustc::middle::ty","",286,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"fmt","","",286,{"inputs":[{"name":"typecontents"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",287,{"inputs":[{"name":"representability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"option"}}],[11,"lt","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",287,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"clone","","",287,{"inputs":[{"name":"representability"}],"output":{"name":"representability"}}],[11,"clone","","",288,{"inputs":[{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"repr","","",262,{"inputs":[{"name":"type_err"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",289,{"inputs":[{"name":"variantinfo"}],"output":{"name":"variantinfo"}}],[11,"from_ast_variant","","Creates a new VariantInfo from the corresponding ast representation.",289,{"inputs":[{"name":"variantinfo"},{"name":"ctxt"},{"name":"spanned"},{"name":"u64"}],"output":{"name":"variantinfo"}}],[11,"clone","","",290,{"inputs":[{"name":"dtorkind"}],"output":{"name":"dtorkind"}}],[11,"is_present","","",290,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"has_drop_flag","","",290,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"to_ty","syntax::attr","",291,{"inputs":[{"name":"inttype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"i64_to_disr","","",291,{"inputs":[{"name":"inttype"},{"name":"i64"}],"output":{"name":"option"}}],[11,"u64_to_disr","","",291,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_incr","","",291,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_string","","",291,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"string"}}],[11,"disr_wrap_incr","","",291,{"inputs":[{"name":"inttype"},{"name":"option"}],"output":{"name":"u64"}}],[11,"clone","rustc::middle::ty","",292,{"inputs":[{"name":"closureupvar"}],"output":{"name":"closureupvar"}}],[11,"to_string","","",233,{"inputs":[{"name":"variance"}],"output":{"name":"str"}}],[11,"from_mutbl","","",256,{"inputs":[{"name":"borrowkind"},{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow\nkind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a\nmutability that is stronger than necessary so that it at least *would permit* the borrow in\nquestion.",256,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",256,{"inputs":[{"name":"borrowkind"}],"output":{"name":"str"}}],[11,"is_method_call","","",244,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"upvar_capture","","",244,{"inputs":[{"name":"ctxt"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"node_ty","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"result"}}],[11,"expr_ty_adjusted","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"expr"}],"output":{"name":"result"}}],[11,"node_method_ty","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"node_method_origin","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"adjustments","","",283,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"refcell"}}],[11,"is_method_call","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"temporary_scope","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"option"}}],[11,"upvar_capture","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"type_moves_by_default","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"param_env","","",283,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"closure_kind","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"}],"output":{"name":"option"}}],[11,"closure_type","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"closure_upvars","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[11,"fmt","","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"ne","","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"clone","","",293,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"explicitselfcategory"}}],[11,"decode","","",22,{"inputs":[{"name":"freevar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"freevar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"freevar"}],"output":{"name":"freevar"}}],[11,"is_identity","","",234,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"bool"}}],[11,"is_identity","","",235,{"inputs":[{"name":"autoderefref"}],"output":{"name":"bool"}}],[11,"new","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",253,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"repr","","",234,{"inputs":[{"name":"autoadjustment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",235,{"inputs":[{"name":"autoderefref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",236,{"inputs":[{"name":"autoref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",276,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",242,{"inputs":[{"name":"vtable_origin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",294,{"inputs":[{"name":"copyimplementationerror"}],"output":{"name":"copyimplementationerror"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",284,{"inputs":[{"name":"typescheme"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",16,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",276,{"inputs":[{"name":"predicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::traits","",213,{"inputs":[{"name":"obligation"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",259,{"inputs":[{"name":"traitref"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",185,{"inputs":[{"name":"regionsubsts"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",281,{"inputs":[{"name":"projectionty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"repr","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"has_projection_types","collections::vec","",295,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",187,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",249,{"inputs":[{"name":"closurety"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",292,{"inputs":[{"name":"closureupvar"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",282,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",278,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",279,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",280,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",281,{"inputs":[{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",184,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"has_projection_types","core::option","",12,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::boxed","",296,{"inputs":[{"name":"box"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",250,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",251,{"inputs":[{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",223,{"inputs":[{"name":"field"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",248,{"inputs":[{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"references_error","","",95,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"references_error","alloc::rc","",94,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"references_error","rustc::middle::ty","",277,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",280,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",259,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"references_error","","",276,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"references_error","","",279,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",278,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"repr","","",249,{"inputs":[{"name":"closurety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",292,{"inputs":[{"name":"closureupvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",223,{"inputs":[{"name":"field"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",271,{"inputs":[{"name":"objectlifetimedefault"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","syntax::ast","",297,{"inputs":[{"name":"unsafety"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"fold_with","syntax::abi","",298,{"inputs":[{"name":"abi"},{"name":"f"}],"output":{"name":"abi"}}],[11,"fold_with","core::option","",12,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"fold_with","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"f"}],"output":{"name":"rc"}}],[11,"fold_with","alloc::boxed","",296,{"inputs":[{"name":"box"},{"name":"f"}],"output":{"name":"box"}}],[11,"fold_with","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"fold_with","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"fold_with","syntax::owned_slice","",299,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"fold_with","rustc::middle::subst","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"fold_with","rustc::middle::ty","",248,{"inputs":[{"name":"barefnty"},{"name":"f"}],"output":{"name":"barefnty"}}],[11,"fold_with","","",249,{"inputs":[{"name":"closurety"},{"name":"f"}],"output":{"name":"closurety"}}],[11,"fold_with","","",229,{"inputs":[{"name":"mt"},{"name":"f"}],"output":{"name":"mt"}}],[11,"fold_with","","",250,{"inputs":[{"name":"fnoutput"},{"name":"f"}],"output":{"name":"fnoutput"}}],[11,"fold_with","","",251,{"inputs":[{"name":"fnsig"},{"name":"f"}],"output":{"name":"fnsig"}}],[11,"fold_with","","",259,{"inputs":[{"name":"traitref"},{"name":"f"}],"output":{"name":"traitref"}}],[11,"fold_with","","",223,{"inputs":[{"name":"field"},{"name":"f"}],"output":{"name":"field"}}],[11,"fold_with","","",16,{"inputs":[{"name":"region"},{"name":"f"}],"output":{"name":"region"}}],[11,"fold_with","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"f"}],"output":{"name":"substs"}}],[11,"fold_with","rustc::middle::ty","",285,{"inputs":[{"name":"itemsubsts"},{"name":"f"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","","",236,{"inputs":[{"name":"autoref"},{"name":"f"}],"output":{"name":"autoref"}}],[11,"fold_with","","",25,{"inputs":[{"name":"methodorigin"},{"name":"f"}],"output":{"name":"methodorigin"}}],[11,"fold_with","","",242,{"inputs":[{"name":"vtable_origin"},{"name":"f"}],"output":{"name":"vtable_origin"}}],[11,"fold_with","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"f"}],"output":{"name":"enumset"}}],[11,"fold_with","rustc::middle::ty","",264,{"inputs":[{"name":"existentialbounds"},{"name":"f"}],"output":{"name":"existentialbounds"}}],[11,"fold_with","","",263,{"inputs":[{"name":"parambounds"},{"name":"f"}],"output":{"name":"parambounds"}}],[11,"fold_with","","",272,{"inputs":[{"name":"typeparameterdef"},{"name":"f"}],"output":{"name":"typeparameterdef"}}],[11,"fold_with","","",271,{"inputs":[{"name":"objectlifetimedefault"},{"name":"f"}],"output":{"name":"objectlifetimedefault"}}],[11,"fold_with","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"f"}],"output":{"name":"regionparameterdef"}}],[11,"fold_with","","",274,{"inputs":[{"name":"generics"},{"name":"f"}],"output":{"name":"generics"}}],[11,"fold_with","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"f"}],"output":{"name":"genericpredicates"}}],[11,"fold_with","","",276,{"inputs":[{"name":"predicate"},{"name":"f"}],"output":{"name":"predicate"}}],[11,"fold_with","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"f"}],"output":{"name":"projectionpredicate"}}],[11,"fold_with","","",281,{"inputs":[{"name":"projectionty"},{"name":"f"}],"output":{"name":"projectionty"}}],[11,"fold_with","","",282,{"inputs":[{"name":"instantiatedpredicates"},{"name":"f"}],"output":{"name":"instantiatedpredicates"}}],[11,"fold_with","rustc::middle::traits","",213,{"inputs":[{"name":"obligation"},{"name":"f"}],"output":{"name":"obligation"}}],[11,"fold_with","","",211,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"fold_with","","",216,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fold_with","","",215,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"fold_with","","",214,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"fold_with","","",212,{"inputs":[{"name":"vtableobjectdata"},{"name":"f"}],"output":{"name":"vtableobjectdata"}}],[11,"fold_with","rustc::middle::ty","",278,{"inputs":[{"name":"equatepredicate"},{"name":"f"}],"output":{"name":"equatepredicate"}}],[11,"fold_with","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"f"}],"output":{"name":"traitpredicate"}}],[11,"fold_with","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"f"}],"output":{"name":"outlivespredicate"}}],[11,"fold_with","","",292,{"inputs":[{"name":"closureupvar"},{"name":"f"}],"output":{"name":"closureupvar"}}],[11,"fold_with","","",283,{"inputs":[{"name":"parameterenvironment"},{"name":"f"}],"output":{"name":"parameterenvironment"}}],[11,"tcx","rustc::middle::ty_fold","",301,{"inputs":[{"name":"bottomupfolder"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",301,{"inputs":[{"name":"bottomupfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","","",302,{"inputs":[{"name":"regionfolder"},{"name":"ctxt"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",302,{"inputs":[{"name":"regionfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",302,null],[11,"exit_region_binder","","",302,null],[11,"fold_region","","",302,{"inputs":[{"name":"regionfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"tcx","","",303,{"inputs":[{"name":"regioneraser"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",303,{"inputs":[{"name":"regioneraser"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::ty_match","",304,{"inputs":[{"name":"match"},{"name":"ctxt"}],"output":{"name":"match"}}],[11,"tag","","",304,{"inputs":[{"name":"match"}],"output":{"name":"str"}}],[11,"tcx","","",304,{"inputs":[{"name":"match"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",304,{"inputs":[{"name":"match"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",304,{"inputs":[{"name":"match"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"regions","","",304,{"inputs":[{"name":"match"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"tys","","",304,{"inputs":[{"name":"match"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"binders","","",304,{"inputs":[{"name":"match"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",229,{"inputs":[{"name":"mt"},{"name":"r"},{"name":"mt"},{"name":"mt"}],"output":{"name":"result"}}],[11,"relate","","",248,{"inputs":[{"name":"barefnty"},{"name":"r"},{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"result"}}],[11,"relate","","",251,{"inputs":[{"name":"fnsig"},{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"result"}}],[11,"relate","syntax::ast","",297,{"inputs":[{"name":"unsafety"},{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"relate","syntax::abi","",298,{"inputs":[{"name":"abi"},{"name":"r"},{"name":"abi"},{"name":"abi"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",281,{"inputs":[{"name":"projectionty"},{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"result"}}],[11,"relate","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"r"},{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"result"}}],[11,"relate","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"r"},{"name":"vec"},{"name":"vec"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",264,{"inputs":[{"name":"existentialbounds"},{"name":"r"},{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"result"}}],[11,"relate","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"r"},{"name":"enumset"},{"name":"enumset"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",259,{"inputs":[{"name":"traitref"},{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"relate","","",16,{"inputs":[{"name":"region"},{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"relate","","",95,{"inputs":[{"name":"binder"},{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"r"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"relate","alloc::boxed","",296,{"inputs":[{"name":"box"},{"name":"r"},{"name":"box"},{"name":"box"}],"output":{"name":"result"}}],[11,"new","rustc::middle::ty_walk","",305,{"inputs":[{"name":"typewalker"},{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type\nreturned by `next()`.",305,null],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::middle::ty_walk","",305,{"inputs":[{"name":"typewalker"}],"output":{"name":"option"}}],[11,"visit_foreign_item","rustc::middle::weak_lang_items","",306,null],[11,"eq","rustc::metadata::common","",307,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"ne","","",307,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"clone","","",307,{"inputs":[{"name":"astencode_tag"}],"output":{"name":"astencode_tag"}}],[11,"from_u32","","",307,{"inputs":[{"name":"astencode_tag"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","","",308,{"inputs":[{"name":"linkmeta"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",308,{"inputs":[{"name":"linkmeta"}],"output":{"name":"linkmeta"}}],[11,"fmt","rustc::metadata::tydecode","",309,{"inputs":[{"name":"defidsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",309,{"inputs":[{"name":"defidsource"}],"output":{"name":"defidsource"}}],[11,"clone","rustc::metadata::encoder","",310,{"inputs":[{"name":"entry"}],"output":{"name":"entry"}}],[11,"visit_expr","","",311,null],[11,"visit_item","","",311,null],[11,"visit_foreign_item","","",311,null],[11,"visit_item","","",312,null],[11,"eq","rustc::metadata::decoder","",313,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"ne","","",313,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"fmt","","",314,{"inputs":[{"name":"deflike"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",314,{"inputs":[{"name":"deflike"}],"output":{"name":"deflike"}}],[11,"clone","","",315,{"inputs":[{"name":"cratedep"}],"output":{"name":"cratedep"}}],[11,"visit_item","rustc::metadata::creader","",316,null],[11,"as_slice","","",317,null],[11,"new","","",316,{"inputs":[{"name":"cratereader"},{"name":"session"}],"output":{"name":"cratereader"}}],[11,"read_crates","","",316,null],[11,"read_exported_macros","","Read exported macros.",316,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path and symbol name.",316,{"inputs":[{"name":"cratereader"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","rustc::metadata::cstore","",318,{"inputs":[{"name":"linkagepreference"}],"output":{"name":"linkagepreference"}}],[11,"eq","","",318,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"ne","","",318,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"fmt","","",318,{"inputs":[{"name":"linkagepreference"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",319,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"ne","","",319,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"clone","","",319,{"inputs":[{"name":"nativelibrarykind"}],"output":{"name":"nativelibrarykind"}}],[11,"from_u32","","",319,{"inputs":[{"name":"nativelibrarykind"},{"name":"u32"}],"output":{"name":"option"}}],[11,"clone","","",320,{"inputs":[{"name":"cratesource"}],"output":{"name":"cratesource"}}],[11,"eq","","",320,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",320,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"new","","",321,{"inputs":[{"name":"cstore"},{"name":"rc"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","",321,{"inputs":[{"name":"cstore"}],"output":{"name":"u32"}}],[11,"get_crate_data","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"rc"}}],[11,"get_crate_hash","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"svh"}}],[11,"set_crate_data","","",321,null],[11,"iter_crate_data","","",321,null],[11,"iter_crate_data_origins","","Like `iter_crate_data`, but passes source paths (if available) as well.",321,null],[11,"add_used_crate_source","","",321,null],[11,"get_used_crate_source","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"reset","","",321,null],[11,"get_used_crates","","",321,{"inputs":[{"name":"cstore"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[11,"add_used_library","","",321,null],[11,"get_used_libraries","","",321,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_used_link_args","","",321,null],[11,"get_used_link_args","","",321,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_extern_mod_stmt_cnum","","",321,null],[11,"find_extern_mod_stmt_cnum","","",321,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"data","","",322,null],[11,"name","","",322,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"string"}}],[11,"hash","","",322,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"svh"}}],[11,"as_slice","","",323,null],[11,"clone","rustc::metadata::csearch","",324,{"inputs":[{"name":"methodinfo"}],"output":{"name":"methodinfo"}}],[11,"maybe_load_library_crate","rustc::metadata::loader","",325,{"inputs":[{"name":"context"}],"output":{"name":"option"}}],[11,"load_library_crate","","",325,{"inputs":[{"name":"context"}],"output":{"name":"library"}}],[11,"report_load_errs","","",325,null],[11,"as_slice","","",326,null],[11,"clone","rustc::metadata::filesearch","",327,{"inputs":[{"name":"filematch"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",328,null],[11,"get_lib_path","","",328,{"inputs":[{"name":"filesearch"}],"output":{"name":"pathbuf"}}],[11,"search","","",328,null],[11,"new","","",328,{"inputs":[{"name":"filesearch"},{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",328,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"get_tools_search_paths","","",328,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"visit_item","rustc::metadata::macro_import","",329,null],[11,"visit_mac","","",329,null],[11,"eq","rustc::session::config","",330,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"ne","","",330,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"clone","","",330,{"inputs":[{"name":"optlevel"}],"output":{"name":"optlevel"}}],[11,"eq","","",331,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"ne","","",331,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"clone","","",331,{"inputs":[{"name":"debuginfolevel"}],"output":{"name":"debuginfolevel"}}],[11,"cmp","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",332,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",332,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[11,"clone","","",333,{"inputs":[{"name":"options"}],"output":{"name":"options"}}],[11,"clone","","",334,{"inputs":[{"name":"unstablefeatures"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",335,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"ne","","",335,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"clone","","",335,{"inputs":[{"name":"printrequest"}],"output":{"name":"printrequest"}}],[11,"filestem","","",336,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[11,"clone","","",337,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"outputfilenames"}}],[11,"path","","",337,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","",337,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",337,{"inputs":[{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",337,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"string"}}],[11,"eq","","",338,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"ne","","",338,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"clone","","",338,{"inputs":[{"name":"entryfntype"}],"output":{"name":"entryfntype"}}],[11,"fmt","","",339,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",339,null],[11,"cmp","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"clone","","",339,{"inputs":[{"name":"cratetype"}],"output":{"name":"cratetype"}}],[11,"partial_cmp","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"option"}}],[11,"lt","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"le","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"gt","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ge","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"eq","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ne","","",339,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"clone","","",340,{"inputs":[{"name":"passes"}],"output":{"name":"passes"}}],[11,"is_empty","","",340,{"inputs":[{"name":"passes"}],"output":{"name":"bool"}}],[11,"clone","","",341,{"inputs":[{"name":"codegenoptions"}],"output":{"name":"codegenoptions"}}],[11,"clone","","",342,{"inputs":[{"name":"debuggingoptions"}],"output":{"name":"debuggingoptions"}}],[11,"fmt","","",343,{"inputs":[{"name":"optionstability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",343,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"ne","","",343,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"clone","","",343,{"inputs":[{"name":"optionstability"}],"output":{"name":"optionstability"}}],[11,"eq","","",344,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"clone","","",344,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"rustcoptgroup"}}],[11,"is_stable","","",344,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"fmt","","",339,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::session::search_paths","",345,{"inputs":[{"name":"searchpaths"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",345,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",346,{"inputs":[{"name":"pathkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",346,{"inputs":[{"name":"pathkind"}],"output":{"name":"pathkind"}}],[11,"eq","","",346,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"ne","","",346,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",345,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"add_path","","",345,null],[11,"iter","","",345,{"inputs":[{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"iter"}}],[6,"Item","rustc_typeck::lint","",null,null],[11,"next","rustc::session::search_paths","",347,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"span_fatal","rustc::session","",348,null],[11,"span_fatal_with_code","","",348,null],[11,"fatal","","",348,null],[11,"span_err","","",348,null],[11,"span_err_with_code","","",348,null],[11,"err","","",348,null],[11,"err_count","","",348,{"inputs":[{"name":"session"}],"output":{"name":"usize"}}],[11,"has_errors","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",348,null],[11,"span_warn","","",348,null],[11,"span_warn_with_code","","",348,null],[11,"warn","","",348,null],[11,"opt_span_warn","","",348,null],[11,"span_note","","",348,null],[11,"span_end_note","","",348,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",348,null],[11,"span_help","","",348,null],[11,"fileline_note","","",348,null],[11,"fileline_help","","",348,null],[11,"note","","",348,null],[11,"help","","",348,null],[11,"opt_span_bug","","",348,null],[11,"span_bug","","",348,null],[11,"bug","","",348,null],[11,"span_unimpl","","",348,null],[11,"unimpl","","",348,null],[11,"add_lint","","",348,null],[11,"next_node_id","","",348,{"inputs":[{"name":"session"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",348,{"inputs":[{"name":"session"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"diagnostic","","",348,{"inputs":[{"name":"session"}],"output":{"name":"spanhandler"}}],[11,"codemap","","",348,{"inputs":[{"name":"session"}],"output":{"name":"codemap"}}],[11,"impossible_case","","",348,null],[11,"verbose","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_passes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_type_sizes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"trans_stats","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"meta_stats","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"asm_comments","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_verify","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"lto","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"unstable_options","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_enum_sizes","","",348,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"sysroot","","",348,{"inputs":[{"name":"session"}],"output":{"name":"path"}}],[11,"target_filesearch","","",348,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",348,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"args","rustc::plugin::registry","Get the plugin's arguments, if any.",349,{"inputs":[{"name":"registry"}],"output":{"name":"vec"}}],[11,"register_syntax_extension","","Register a syntax extension of any kind.",349,null],[11,"register_macro","","Register a macro of the usual kind.",349,null],[11,"register_lint_pass","","Register a compiler lint pass.",349,null],[11,"register_lint_group","","Register a lint group.",349,null],[11,"register_llvm_pass","","Register an LLVM pass.",349,null],[11,"visit_item","rustc::plugin::build","",350,null],[11,"fmt","rustc::lint","",0,{"inputs":[{"name":"lint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"lint"}],"output":{"name":"lint"}}],[11,"clone","","",351,{"inputs":[{"name":"lintid"}],"output":{"name":"lintid"}}],[11,"eq","","",351,{"inputs":[{"name":"lintid"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",351,null],[11,"of","","Get the `LintId` for a `Lint`.",351,{"inputs":[{"name":"lintid"},{"name":"lint"}],"output":{"name":"lintid"}}],[11,"as_str","","Get the name of the lint.",351,{"inputs":[{"name":"lintid"}],"output":{"name":"string"}}],[11,"fmt","","",352,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"option"}}],[11,"lt","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"le","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"gt","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ge","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"eq","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",352,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",352,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"as_str","","Convert a level to a lower-case string.",352,{"inputs":[{"name":"level"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",352,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"option"}}],[11,"eq","","",353,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",353,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"clone","","",353,{"inputs":[{"name":"lintsource"}],"output":{"name":"lintsource"}}],[11,"clone","rustc::lint::builtin","",354,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",354,null],[11,"new","rustc::lint::context","",355,{"inputs":[{"name":"lintstore"}],"output":{"name":"lintstore"}}],[11,"get_lints","","",355,null],[11,"get_lint_groups","","",355,{"inputs":[{"name":"lintstore"}],"output":{"name":"vec"}}],[11,"register_pass","","",355,null],[11,"register_group","","",355,null],[11,"register_renamed","","",355,null],[11,"process_command_line","","",355,null],[11,"sess","","Get the overall compiler `Session` object.",356,{"inputs":[{"name":"context"}],"output":{"name":"session"}}],[11,"current_level","","Get the level of `lint` at the current position of the lint\ntraversal.",356,{"inputs":[{"name":"context"},{"name":"lint"}],"output":{"name":"level"}}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",356,null],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",356,null],[11,"visit_item","","",356,null],[11,"visit_foreign_item","","",356,null],[11,"visit_pat","","",356,null],[11,"visit_expr","","",356,null],[11,"visit_stmt","","",356,null],[11,"visit_fn","","",356,null],[11,"visit_struct_def","","",356,null],[11,"visit_struct_field","","",356,null],[11,"visit_variant","","",356,null],[11,"visit_ty","","",356,null],[11,"visit_ident","","",356,null],[11,"visit_mod","","",356,null],[11,"visit_local","","",356,null],[11,"visit_block","","",356,null],[11,"visit_arm","","",356,null],[11,"visit_decl","","",356,null],[11,"visit_expr_post","","",356,null],[11,"visit_generics","","",356,null],[11,"visit_trait_item","","",356,null],[11,"visit_impl_item","","",356,null],[11,"visit_opt_lifetime_ref","","",356,null],[11,"visit_lifetime_ref","","",356,null],[11,"visit_lifetime_def","","",356,null],[11,"visit_explicit_self","","",356,null],[11,"visit_mac","","",356,null],[11,"visit_path","","",356,null],[11,"visit_attribute","","",356,null],[11,"visit_id","","",356,null],[11,"get_lints","","",357,null],[11,"check_item","","",357,null],[11,"fmt","rustc::util::common","",358,{"inputs":[{"name":"errorreported"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",358,{"inputs":[{"name":"errorreported"}],"output":{"name":"errorreported"}}],[11,"drop","","",359,null],[11,"visit_expr","","",360,null],[11,"visit_expr","","",361,null],[11,"repr","core::option","",12,{"inputs":[{"name":"option"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ptr","",362,{"inputs":[{"name":"p"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::result","",91,{"inputs":[{"name":"result"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::boxed","",296,{"inputs":[{"name":"box"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::owned_slice","",299,{"inputs":[{"name":"ownedslice"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::vec","",295,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",295,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",258,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",272,{"inputs":[{"name":"typeparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",273,{"inputs":[{"name":"regionparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",246,{"inputs":[{"name":"tys"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",229,{"inputs":[{"name":"mt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",184,{"inputs":[{"name":"substs"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",187,{"inputs":[{"name":"vecperparamspace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",285,{"inputs":[{"name":"itemsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",185,{"inputs":[{"name":"regionsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",263,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",259,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",363,{"inputs":[{"name":"traitdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",364,{"inputs":[{"name":"traititem"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",159,{"inputs":[{"name":"expr"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",365,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",365,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",366,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",367,{"inputs":[{"name":"item"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",368,{"inputs":[{"name":"lifetime"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",369,{"inputs":[{"name":"spanned"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",160,{"inputs":[{"name":"pat"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",20,{"inputs":[{"name":"boundregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",16,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",16,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",17,{"inputs":[{"name":"freeregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",11,{"inputs":[{"name":"defid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",284,{"inputs":[{"name":"typescheme"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",274,{"inputs":[{"name":"generics"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",275,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",282,{"inputs":[{"name":"instantiatedpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",232,{"inputs":[{"name":"itemvariances"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",233,{"inputs":[{"name":"variance"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",227,{"inputs":[{"name":"method"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",6,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",6,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",5,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",370,{"inputs":[{"name":"explicitself_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",371,{"inputs":[{"name":"visibility"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",248,{"inputs":[{"name":"barefnty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",251,{"inputs":[{"name":"fnsig"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",250,{"inputs":[{"name":"fnoutput"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",240,{"inputs":[{"name":"methodcallee"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",25,{"inputs":[{"name":"methodorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",238,{"inputs":[{"name":"methodparam"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",239,{"inputs":[{"name":"methodobject"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",265,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",265,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",13,{"inputs":[{"name":"span"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","alloc::rc","",94,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",263,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",264,{"inputs":[{"name":"existentialbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","collections::enum_set","",300,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",95,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",259,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","syntax::ast","",5,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::abi","",298,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",298,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",255,{"inputs":[{"name":"upvarid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",372,{"inputs":[{"name":"mutability"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",256,{"inputs":[{"name":"borrowkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",124,{"inputs":[{"name":"intvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",126,{"inputs":[{"name":"floatvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",267,{"inputs":[{"name":"regionvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",266,{"inputs":[{"name":"tyvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",125,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",373,{"inputs":[{"name":"intty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",374,{"inputs":[{"name":"uintty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",127,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",293,{"inputs":[{"name":"explicitselfcategory"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",252,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",252,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",95,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","std::collections::hash::map","",375,{"inputs":[{"name":"hashmap"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",279,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",278,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",277,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",280,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",281,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",281,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",276,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",297,{"inputs":[{"name":"unsafety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"default","rustc::util::nodemap","",376,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"fnvhasher"}}],[11,"write","","",376,null],[11,"finish","","",376,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"u64"}}],[11,"new","rustc::util::snapshot_vec","",377,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"snapshotvec"}}],[11,"record","","",377,null],[11,"push","","",377,null],[11,"get","","",377,null],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone\nautomatically, so you should be sure call `record()` with some sort of suitable undo\naction.",377,null],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if\na snapshot is active.",377,null],[11,"start_snapshot","","",377,{"inputs":[{"name":"snapshotvec"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",377,null],[11,"rollback_to","","",377,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",377,null],[11,"input","rustc_back::sha2","",378,null],[11,"reset","","",378,null],[11,"zero_until","","",378,null],[11,"next","","",378,null],[11,"full_buffer","","",378,null],[11,"position","","",378,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"remaining","","",378,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"size","","",378,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",379,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",379,null],[11,"result","","",379,null],[11,"reset","","",379,null],[11,"output_bits","","",379,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[11,"open","rustc_llvm::archive_ro","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",380,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",380,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",380,null],[11,"clone","rustc_llvm::diagnostic","",381,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",381,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",382,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",383,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",384,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",384,null],[11,"eq","rustc_llvm","",385,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",385,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",385,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",386,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",387,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",388,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",388,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",389,null],[11,"cmp","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",389,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",389,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",389,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",389,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",389,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",389,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",389,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",389,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",389,null],[11,"remove","","Removes the specified flags in-place.",389,null],[11,"toggle","","Toggles the specified flags in-place.",389,null],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitor","rustc_llvm","Returns the union of the two sets of flags.",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitxor","rustc_llvm","Returns the left flags, but with all the right flags toggled.",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"bitand","rustc_llvm","Returns the intersection between the two sets of flags.",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"sub","rustc_llvm","Returns the set difference of the two sets of flags.",389,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_typeck::lint","",null,null],[11,"not","rustc_llvm","Returns the complement of this set of flags.",389,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",390,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",391,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",392,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",389,null],[11,"apply_callsite","","",389,null],[11,"apply_llfn","","",390,null],[11,"apply_callsite","","",390,null],[11,"apply_llfn","","",391,null],[11,"apply_callsite","","",391,null],[11,"new","","",393,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",393,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",393,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",393,null],[11,"apply_callsite","","",393,null],[11,"clone","","",394,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",395,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",396,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",396,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",396,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",396,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",397,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",398,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",399,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",400,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",401,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",402,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",402,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",402,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",403,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",403,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",403,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",404,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",405,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"clone","rustc_llvm::debuginfo","",406,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[11,"drop","rustc_llvm","",407,null],[11,"new","","",408,null],[11,"drop","","",408,null],[11,"drop","","",409,null],[3,"Lint","rustc_typeck::lint","Specification of a single lint.",null,null],[12,"name","","A string identifier for the lint.",0,null],[12,"default_level","","Default level for the lint.",0,null],[12,"desc","","Description of the lint or the issue it detects.",0,null],[6,"LintArray","","",null,null],[8,"LintPass","","Trait for types providing lint checks.",null,null],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",410,null],[11,"check_crate","","",410,null],[11,"check_ident","","",410,null],[11,"check_mod","","",410,null],[11,"check_foreign_item","","",410,null],[11,"check_item","","",410,null],[11,"check_local","","",410,null],[11,"check_block","","",410,null],[11,"check_stmt","","",410,null],[11,"check_arm","","",410,null],[11,"check_pat","","",410,null],[11,"check_decl","","",410,null],[11,"check_expr","","",410,null],[11,"check_expr_post","","",410,null],[11,"check_ty","","",410,null],[11,"check_generics","","",410,null],[11,"check_fn","","",410,null],[11,"check_trait_item","","",410,null],[11,"check_impl_item","","",410,null],[11,"check_struct_def","","",410,null],[11,"check_struct_def_post","","",410,null],[11,"check_struct_field","","",410,null],[11,"check_variant","","",410,null],[11,"check_variant_post","","",410,null],[11,"check_opt_lifetime_ref","","",410,null],[11,"check_lifetime_ref","","",410,null],[11,"check_lifetime_def","","",410,null],[11,"check_explicit_self","","",410,null],[11,"check_mac","","",410,null],[11,"check_path","","",410,null],[11,"check_attribute","","",410,null],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such\nas `#[allow(...)]`. Called with *all* the attributes of that node.",410,null],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",410,null],[6,"LintPassObject","","",null,null],[3,"LintId","","Identifies a lint known to the compiler.",null,null],[4,"Level","","Setting for how to handle a lint.",null,null],[13,"Allow","","",352,null],[13,"Warn","","",352,null],[13,"Deny","","",352,null],[13,"Forbid","","",352,null],[4,"LintSource","","How a lint level was set.",null,null],[13,"Default","","Lint is at the default level as declared\nin rustc or a plugin.",353,null],[13,"Node","","Lint level was set by an attribute.",353,null],[13,"CommandLine","","Lint level was set by a command-line flag.",353,null],[13,"ReleaseChannel","","Lint level was set by the release channel.",353,null],[6,"LevelSource","","",null,null],[0,"builtin","","Some lints that are built in to the compiler.",null,null],[7,"UNUSED_IMPORTS","rustc_typeck::lint::builtin","",null,null],[7,"UNUSED_EXTERN_CRATES","","",null,null],[7,"UNUSED_QUALIFICATIONS","","",null,null],[7,"UNKNOWN_LINTS","","",null,null],[7,"UNUSED_VARIABLES","","",null,null],[7,"UNUSED_ASSIGNMENTS","","",null,null],[7,"DEAD_CODE","","",null,null],[7,"UNREACHABLE_CODE","","",null,null],[7,"WARNINGS","","",null,null],[7,"UNUSED_FEATURES","","",null,null],[7,"STABLE_FEATURES","","",null,null],[7,"UNKNOWN_CRATE_TYPES","","",null,null],[7,"VARIANT_SIZE_DIFFERENCES","","",null,null],[7,"FAT_PTR_TRANSMUTES","","",null,null],[7,"TRIVIAL_CASTS","","",null,null],[7,"TRIVIAL_NUMERIC_CASTS","","",null,null],[3,"HardwiredLints","","Does nothing as a lint pass, but registers some `Lint`s\nwhich are used by other parts of the compiler.",null,null],[5,"gather_attrs","rustc_typeck::lint","Parse the lint attributes into a vector, with `Err`s for malformed lint\nattributes. Writing this as an iterator is an enormous mess.",null,null],[3,"Context","","Context for lint checking.",null,null],[12,"tcx","","Type context we're checking in.",356,null],[12,"krate","","The crate being checked.",356,null],[12,"exported_items","","Items exported from the crate being checked.",356,null],[3,"GatherNodeLevels","","",null,null],[3,"LintStore","","Information about the registered lints.",null,null],[5,"check_crate","","Perform lint checking on a crate.",null,null],[5,"raw_emit_lint","","Emit a lint as a warning or an error (or not at all)\naccording to `level`.",null,null],[0,"metadata","rustc_typeck","",null,null],[0,"common","rustc_typeck::metadata","",null,null],[17,"tag_items","rustc_typeck::metadata::common","",null,null],[17,"tag_paths_data_name","","",null,null],[17,"tag_def_id","","",null,null],[17,"tag_items_data","","",null,null],[17,"tag_items_data_item","","",null,null],[17,"tag_items_data_item_family","","",null,null],[17,"tag_items_data_item_type","","",null,null],[17,"tag_items_data_item_symbol","","",null,null],[17,"tag_items_data_item_variant","","",null,null],[17,"tag_items_data_parent_item","","",null,null],[17,"tag_items_data_item_is_tuple_struct_ctor","","",null,null],[17,"tag_index","","",null,null],[17,"tag_index_buckets","","",null,null],[17,"tag_index_buckets_bucket","","",null,null],[17,"tag_index_buckets_bucket_elt","","",null,null],[17,"tag_index_table","","",null,null],[17,"tag_meta_item_name_value","","",null,null],[17,"tag_meta_item_name","","",null,null],[17,"tag_meta_item_value","","",null,null],[17,"tag_attributes","","",null,null],[17,"tag_attribute","","",null,null],[17,"tag_meta_item_word","","",null,null],[17,"tag_meta_item_list","","",null,null],[17,"tag_crate_deps","","",null,null],[17,"tag_crate_dep","","",null,null],[17,"tag_crate_hash","","",null,null],[17,"tag_crate_crate_name","","",null,null],[17,"tag_crate_dep_crate_name","","",null,null],[17,"tag_crate_dep_hash","","",null,null],[17,"tag_mod_impl","","",null,null],[17,"tag_item_trait_item","","",null,null],[17,"tag_item_trait_ref","","",null,null],[17,"tag_disr_val","","",null,null],[17,"tag_path","","",null,null],[17,"tag_path_len","","",null,null],[17,"tag_path_elem_mod","","",null,null],[17,"tag_path_elem_name","","",null,null],[17,"tag_item_field","","",null,null],[17,"tag_item_field_origin","","",null,null],[17,"tag_item_variances","","",null,null],[17,"tag_item_impl_item","","",null,null],[17,"tag_item_trait_method_explicit_self","","",null,null],[17,"tag_items_data_item_reexport","","",null,null],[17,"tag_items_data_item_reexport_def_id","","",null,null],[17,"tag_items_data_item_reexport_name","","",null,null],[4,"astencode_tag","","",null,null],[13,"tag_ast","","",307,null],[13,"tag_tree","","",307,null],[13,"tag_id_range","","",307,null],[13,"tag_table","","",307,null],[13,"tag_table_def","","",307,null],[13,"tag_table_node_type","","",307,null],[13,"tag_table_item_subst","","",307,null],[13,"tag_table_freevars","","",307,null],[13,"tag_table_tcache","","",307,null],[13,"tag_table_param_defs","","",307,null],[13,"tag_table_mutbl","","",307,null],[13,"tag_table_last_use","","",307,null],[13,"tag_table_spill","","",307,null],[13,"tag_table_method_map","","",307,null],[13,"tag_table_vtable_map","","",307,null],[13,"tag_table_adjustments","","",307,null],[13,"tag_table_moves_map","","",307,null],[13,"tag_table_capture_map","","",307,null],[13,"tag_table_closure_tys","","",307,null],[13,"tag_table_closure_kinds","","",307,null],[13,"tag_table_upvar_capture_map","","",307,null],[13,"tag_table_capture_modes","","",307,null],[13,"tag_table_object_cast_map","","",307,null],[13,"tag_table_const_qualif","","",307,null],[17,"tag_item_trait_item_sort","","",null,null],[17,"tag_item_trait_parent_sort","","",null,null],[17,"tag_item_impl_type_basename","","",null,null],[17,"tag_crate_triple","","",null,null],[17,"tag_dylib_dependency_formats","","",null,null],[17,"tag_lang_items","","",null,null],[17,"tag_lang_items_item","","",null,null],[17,"tag_lang_items_item_id","","",null,null],[17,"tag_lang_items_item_node_id","","",null,null],[17,"tag_lang_items_missing","","",null,null],[17,"tag_item_unnamed_field","","",null,null],[17,"tag_items_data_item_visibility","","",null,null],[17,"tag_item_method_tps","","",null,null],[17,"tag_item_method_fty","","",null,null],[17,"tag_mod_child","","",null,null],[17,"tag_misc_info","","",null,null],[17,"tag_misc_info_crate_items","","",null,null],[17,"tag_item_method_provided_source","","",null,null],[17,"tag_item_impl_vtables","","",null,null],[17,"tag_impls","","",null,null],[17,"tag_impls_impl","","",null,null],[17,"tag_items_data_item_inherent_impl","","",null,null],[17,"tag_items_data_item_extension_impl","","",null,null],[17,"tag_native_libraries","","",null,null],[17,"tag_native_libraries_lib","","",null,null],[17,"tag_native_libraries_name","","",null,null],[17,"tag_native_libraries_kind","","",null,null],[17,"tag_plugin_registrar_fn","","",null,null],[17,"tag_method_argument_names","","",null,null],[17,"tag_method_argument_name","","",null,null],[17,"tag_reachable_extern_fns","","",null,null],[17,"tag_reachable_extern_fn_id","","",null,null],[17,"tag_items_data_item_stability","","",null,null],[17,"tag_items_data_item_repr","","",null,null],[3,"LinkMeta","","",null,null],[12,"crate_name","","",308,null],[12,"crate_hash","","",308,null],[17,"tag_struct_fields","","",null,null],[17,"tag_struct_field","","",null,null],[17,"tag_struct_field_id","","",null,null],[17,"tag_attribute_is_sugared_doc","","",null,null],[17,"tag_items_data_region","","",null,null],[17,"tag_region_param_def","","",null,null],[17,"tag_region_param_def_ident","","",null,null],[17,"tag_region_param_def_def_id","","",null,null],[17,"tag_region_param_def_space","","",null,null],[17,"tag_region_param_def_index","","",null,null],[17,"tag_type_param_def","","",null,null],[17,"tag_item_generics","","",null,null],[17,"tag_method_ty_generics","","",null,null],[17,"tag_predicate","","",null,null],[17,"tag_predicate_space","","",null,null],[17,"tag_predicate_data","","",null,null],[17,"tag_unsafety","","",null,null],[17,"tag_associated_type_names","","",null,null],[17,"tag_associated_type_name","","",null,null],[17,"tag_polarity","","",null,null],[17,"tag_macro_defs","","",null,null],[17,"tag_macro_def","","",null,null],[17,"tag_macro_def_body","","",null,null],[17,"tag_paren_sugar","","",null,null],[17,"tag_codemap","","",null,null],[17,"tag_codemap_filemap","","",null,null],[17,"tag_item_super_predicates","","",null,null],[17,"tag_defaulted_trait","","",null,null],[0,"tyencode","rustc_typeck::metadata","",null,null],[3,"ctxt","rustc_typeck::metadata::tyencode","",null,null],[12,"diag","","",411,null],[12,"ds","","",411,null],[12,"tcx","","",411,null],[12,"abbrevs","","",411,null],[3,"ty_abbrev","","",null,null],[6,"abbrev_map","","",null,null],[5,"enc_ty","","",null,null],[5,"enc_substs","","",null,null],[5,"enc_region","","",null,null],[5,"enc_trait_ref","","",null,null],[5,"enc_bare_fn_ty","","",null,null],[5,"enc_closure_ty","","",null,null],[5,"enc_builtin_bounds","","",null,null],[5,"enc_existential_bounds","","",null,null],[5,"enc_bounds","","",null,null],[5,"enc_region_bounds","","",null,null],[5,"enc_type_param_def","","",null,null],[5,"enc_predicate","","",null,null],[0,"tydecode","rustc_typeck::metadata","",null,null],[4,"DefIdSource","rustc_typeck::metadata::tydecode","",null,null],[13,"NominalType","","",309,null],[13,"TypeWithId","","",309,null],[13,"TypeParameter","","",309,null],[13,"RegionParameter","","",309,null],[13,"ClosureSource","","",309,null],[3,"PState","","",null,null],[5,"parse_name","","",null,{"inputs":[{"name":"pstate"},{"name":"char"}],"output":{"name":"name"}}],[5,"parse_state_from_data","","",null,null],[5,"parse_ty_closure_data","","",null,null],[5,"parse_ty_data","","",null,null],[5,"parse_region_data","","",null,null],[5,"parse_bare_fn_ty_data","","",null,null],[5,"parse_trait_ref_data","","",null,null],[5,"parse_substs_data","","",null,null],[5,"parse_bounds_data","","",null,null],[5,"parse_existential_bounds_data","","",null,null],[5,"parse_builtin_bounds_data","","",null,null],[5,"parse_def_id","","",null,null],[5,"parse_predicate_data","","",null,null],[5,"parse_predicate","","",null,{"inputs":[{"name":"pstate"},{"name":"f"}],"output":{"name":"predicate"}}],[5,"parse_type_param_def_data","","",null,null],[0,"encoder","rustc_typeck::metadata","",null,null],[4,"InlinedItemRef","rustc_typeck::metadata::encoder","A borrowed version of `ast::InlinedItem`.",null,null],[13,"IIItemRef","","",412,null],[13,"IITraitItemRef","","",412,null],[13,"IIImplItemRef","","",412,null],[13,"IIForeignRef","","",412,null],[6,"EncodeInlinedItem","","",null,null],[3,"EncodeParams","","",null,null],[12,"diag","","",413,null],[12,"tcx","","",413,null],[12,"reexports","","",413,null],[12,"item_symbols","","",413,null],[12,"link_meta","","",413,null],[12,"cstore","","",413,null],[12,"encode_inlined_item","","",413,null],[12,"reachable","","",413,null],[3,"EncodeContext","","",null,null],[12,"diag","","",26,null],[12,"tcx","","",26,null],[12,"reexports","","",26,null],[12,"item_symbols","","",26,null],[12,"link_meta","","",26,null],[12,"cstore","","",26,null],[12,"encode_inlined_item","","",26,null],[12,"type_abbrevs","","",26,null],[12,"reachable","","",26,null],[5,"encode_def_id","","",null,null],[5,"def_to_string","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"string"}}],[5,"write_closure_type","","",null,null],[5,"write_type","","",null,null],[5,"write_trait_ref","","",null,null],[5,"write_region","","",null,null],[17,"metadata_encoding_version","","",null,null],[5,"encode_metadata","","",null,{"inputs":[{"name":"encodeparams"},{"name":"crate"}],"output":{"name":"vec"}}],[5,"encoded_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[0,"decoder","rustc_typeck::metadata","",null,null],[6,"Cmd","rustc_typeck::metadata::decoder","",null,null],[5,"maybe_find_item","","",null,{"inputs":[{"name":"u32"},{"name":"doc"}],"output":{"name":"option"}}],[5,"item_type","","",null,{"inputs":[{"name":"defid"},{"name":"doc"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_type","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"typescheme"}}],[5,"get_stability","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vecperparamspace"}}],[5,"get_symbol","","",null,null],[4,"DefLike","","",null,null],[13,"DlDef","","",314,null],[13,"DlImpl","","",314,null],[13,"DlField","","",314,null],[5,"each_lang_item","","Iterates over the language items in the given crate.",null,{"inputs":[{"name":"crate_metadata"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,null],[5,"each_top_level_item_of_crate","","Iterates over all the top-level crate items.",null,null],[5,"get_item_path","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[6,"DecodeInlinedItem","","",null,null],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"u32"},{"name":"box"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"strinterner"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns the def IDs of all the items in the given implementation.",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"implortraititem"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","If node_id is the constructor of a tuple struct, retrieve the NodeId of\nthe actual type definition, otherwise, return None",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"hashmap"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_crate_attributes","","",null,null],[3,"CrateDep","","",null,null],[12,"cnum","","",315,null],[12,"name","","",315,null],[12,"hash","","",315,null],[5,"get_crate_deps","","",null,null],[5,"maybe_get_crate_hash","","",null,null],[5,"get_crate_hash","","",null,null],[5,"maybe_get_crate_name","","",null,null],[5,"get_crate_triple","","",null,null],[5,"get_crate_name","","",null,null],[5,"list_crate_metadata","","",null,null],[5,"translate_def_id","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"defid"}],"output":{"name":"defid"}}],[5,"each_impl","","",null,null],[5,"each_implementation_for_type","","",null,null],[5,"each_implementation_for_trait","","",null,null],[5,"get_trait_of_item","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_plugin_registrar_fn","","",null,null],[5,"each_exported_macro","","",null,null],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"get_imported_filemaps","","",null,null],[0,"creader","rustc_typeck::metadata","Validates all used crates and extern libraries and loads their metadata",null,null],[3,"CrateReader","rustc_typeck::metadata::creader","",null,null],[5,"validate_crate_name","","",null,null],[0,"cstore","rustc_typeck::metadata","",null,null],[6,"cnum_map","rustc_typeck::metadata::cstore","",null,null],[4,"MetadataBlob","","",null,null],[13,"MetadataVec","","",323,null],[13,"MetadataArchive","","",323,null],[3,"ImportedFileMap","","Holds information about a codemap::FileMap imported from another crate.\nSee creader::import_codemap() for more information.",null,null],[12,"original_start_pos","","This FileMap's byte-offset within the codemap of its original crate",414,null],[12,"original_end_pos","","The end of this FileMap within the codemap of its original crate",414,null],[12,"translated_filemap","","The imported FileMap's representation within the local codemap",414,null],[3,"crate_metadata","","",null,null],[12,"name","","",322,null],[12,"data","","",322,null],[12,"cnum_map","","",322,null],[12,"cnum","","",322,null],[12,"codemap_import_info","","",322,null],[12,"span","","",322,null],[4,"LinkagePreference","","",null,null],[13,"RequireDynamic","","",318,null],[13,"RequireStatic","","",318,null],[4,"NativeLibraryKind","","",null,null],[13,"NativeStatic","","",319,null],[13,"NativeFramework","","",319,null],[13,"NativeUnknown","","",319,null],[3,"CrateSource","","",null,null],[12,"dylib","","",320,null],[12,"rlib","","",320,null],[12,"cnum","","",320,null],[3,"CStore","","",null,null],[12,"intr","","",321,null],[0,"csearch","rustc_typeck::metadata","",null,null],[3,"MethodInfo","rustc_typeck::metadata::csearch","",null,null],[12,"name","","",324,null],[12,"def_id","","",324,null],[12,"vis","","",324,null],[5,"get_symbol","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"string"}}],[5,"each_lang_item","","Iterates over all the language items in the given crate.",null,{"inputs":[{"name":"cstore"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,null],[5,"each_top_level_item_of_crate","","Iterates over each top-level crate item.",null,null],[5,"get_item_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[4,"FoundAst","","",null,null],[13,"Found","","",415,null],[13,"FoundParent","","",415,null],[13,"NotFound","","",415,null],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"box"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns information about the given implementation.",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"hashmap"}}],[5,"get_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vecperparamspace"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"each_impl","","",null,null],[5,"each_implementation_for_type","","",null,null],[5,"each_implementation_for_trait","","",null,null],[5,"get_trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), returns the ID of\nthe trait that the method belongs to. Otherwise, returns `None`.",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_stability","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"is_staged_api","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[0,"loader","rustc_typeck::metadata","Finds crate binaries and loads their metadata",null,null],[3,"CrateMismatch","rustc_typeck::metadata::loader","",null,null],[3,"Context","","",null,null],[12,"sess","","",325,null],[12,"span","","",325,null],[12,"ident","","",325,null],[12,"crate_name","","",325,null],[12,"hash","","",325,null],[12,"target","","",325,null],[12,"triple","","",325,null],[12,"filesearch","","",325,null],[12,"root","","",325,null],[12,"rejected_via_hash","","",325,null],[12,"rejected_via_triple","","",325,null],[12,"rejected_via_kind","","",325,null],[12,"should_match_name","","",325,null],[3,"Library","","",null,null],[12,"dylib","","",416,null],[12,"rlib","","",416,null],[12,"metadata","","",416,null],[3,"ArchiveMetadata","","",null,null],[3,"CratePaths","","",null,null],[12,"ident","","",417,null],[12,"dylib","","",417,null],[12,"rlib","","",417,null],[5,"note_crate_name","","",null,null],[5,"meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"read_meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"list_file_metadata","","",null,{"inputs":[{"name":"bool"},{"name":"path"},{"name":"write"}],"output":{"name":"result"}}],[0,"filesearch","rustc_typeck::metadata","",null,null],[4,"FileMatch","rustc_typeck::metadata::filesearch","",null,null],[13,"FileMatches","","",327,null],[13,"FileDoesntMatch","","",327,null],[3,"FileSearch","","",null,null],[12,"sysroot","","",328,null],[12,"search_paths","","",328,null],[12,"triple","","",328,null],[12,"kind","","",328,null],[5,"relative_target_lib_path","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"get_or_default_sysroot","","",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"get_rust_path","","Returns RUST_PATH as a string, without default paths added",null,{"inputs":[],"output":{"name":"option"}}],[5,"rust_path","","Returns the value of RUST_PATH, as a list\nof Paths. Includes default entries for, if they exist:\n$HOME/.rust\nDIR/.rust for any DIR that's the current working directory\nor an ancestor of it",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustlibdir","","",null,{"inputs":[],"output":{"name":"string"}}],[0,"macro_import","rustc_typeck::metadata","Used by `rustc` when loading a crate with exported macros.",null,null],[5,"read_macro_defs","rustc_typeck::metadata::macro_import","Read exported macros.",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"vec"}}],[6,"MacroSelection","","",null,null],[0,"middle","rustc_typeck","",null,null],[0,"astconv_util","rustc_typeck::middle","This module contains a simple utility routine\nused by both `typeck` and `const_eval`.\nAlmost certainly this could (and should) be refactored out of existence.",null,null],[17,"NO_REGIONS","rustc_typeck::middle::astconv_util","",null,null],[17,"NO_TPS","","",null,null],[5,"check_path_args","","",null,null],[5,"prim_ty_to_ty","","",null,null],[5,"ast_ty_to_prim_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"option"}}],[0,"astencode","rustc_typeck::middle","",null,null],[5,"encode_inlined_item","rustc_typeck::middle::astencode","",null,null],[5,"decode_inlined_item","","Decodes an item from its AST in the cdata's metadata and adds it to the\nast-map.",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"vec"},{"name":"doc"}],"output":{"name":"result"}}],[5,"encode_closure_kind","","",null,null],[8,"vtable_decoder_helpers","","",null,null],[10,"read_vec_per_param_space","","",418,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_res_with_key","","",418,null],[10,"read_vtable_res","","",418,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_param_res","","",418,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[10,"read_vtable_origin","","",418,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[0,"cfg","rustc_typeck::middle","Module that constructs a control-flow graph representing an item.\nUses `Graph` as the underlying representation.",null,null],[0,"graphviz","rustc_typeck::middle::cfg","",null,null],[6,"Node","rustc_typeck::middle::cfg::graphviz","",null,null],[6,"Edge","","",null,null],[3,"LabelledCFG","","",null,null],[12,"ast_map","","",31,null],[12,"cfg","","",31,null],[12,"name","","",31,null],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",31,null],[3,"CFG","rustc_typeck::middle::cfg","",null,null],[12,"graph","","",33,null],[12,"entry","","",33,null],[12,"exit","","",33,null],[4,"CFGNodeData","","",null,null],[13,"AST","","",32,null],[13,"Entry","","",32,null],[13,"Exit","","",32,null],[13,"Dummy","","",32,null],[13,"Unreachable","","",32,null],[3,"CFGEdgeData","","",null,null],[12,"exiting_scopes","","",419,null],[6,"CFGIndex","","",null,null],[6,"CFGGraph","","",null,null],[6,"CFGNode","","",null,null],[6,"CFGEdge","","",null,null],[0,"check_const","rustc_typeck::middle","",null,null],[3,"ConstQualif","rustc_typeck::middle::check_const","",null,null],[17,"PURE_CONST","","",null,null],[17,"MUTABLE_MEM","","",null,null],[17,"NEEDS_DROP","","",null,null],[17,"PREFER_IN_PLACE","","",null,null],[17,"NON_ZERO_SIZED","","",null,null],[17,"HAS_STATIC_BORROWS","","",null,null],[17,"NOT_CONST","","",null,null],[17,"NON_STATIC_BORROWS","","",null,null],[5,"check_crate","","",null,null],[0,"check_static_recursion","rustc_typeck::middle","",null,null],[5,"check_crate","rustc_typeck::middle::check_static_recursion","",null,null],[5,"check_item_recursion","","",null,null],[0,"check_loop","rustc_typeck::middle","",null,null],[5,"check_crate","rustc_typeck::middle::check_loop","",null,null],[0,"check_match","rustc_typeck::middle","",null,null],[17,"DUMMY_WILD_PAT","rustc_typeck::middle::check_match","",null,null],[3,"MatchCheckCtxt","","",null,null],[12,"tcx","","",45,null],[12,"param_env","","",45,null],[4,"Constructor","","",null,null],[13,"Single","","The constructor of all patterns that don't vary by constructor,\ne.g. struct patterns and fixed-length arrays.",42,null],[13,"Variant","","Enum variants.",42,null],[13,"ConstantValue","","Literal values.",42,null],[13,"ConstantRange","","Ranges of literal values (2..5).",42,null],[13,"Slice","","Array patterns of length n.",42,null],[13,"SliceWithSubslice","","Array patterns with a subslice.",42,null],[5,"check_crate","","",null,null],[3,"StaticInliner","","",null,null],[12,"tcx","","",46,null],[12,"failed","","",46,null],[12,"renaming_map","","",46,null],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor\nis how many subpattern patterns of that constructor should be expanded to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"tys"}],"output":{"name":"usize"}}],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row\ninto `arity` patterns based on the constructor. For most patterns, the step is trivial,\nfor instance tuple patterns are flattened and box patterns expand into their inner pattern.",null,null],[0,"check_rvalues","rustc_typeck::middle","",null,null],[5,"check_crate","rustc_typeck::middle::check_rvalues","",null,null],[0,"const_eval","rustc_typeck::middle","",null,null],[5,"lookup_const_by_id","rustc_typeck::middle::const_eval","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[4,"const_val","","",null,null],[13,"const_float","","",52,null],[13,"const_int","","",52,null],[13,"const_uint","","",52,null],[13,"const_str","","",52,null],[13,"const_binary","","",52,null],[13,"const_bool","","",52,null],[13,"Struct","","",52,null],[13,"Tuple","","",52,null],[5,"const_expr_to_pat","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"span"}],"output":{"name":"p"}}],[5,"eval_const_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"const_val"}}],[3,"ConstEvalErr","","",null,null],[12,"span","","",53,null],[12,"kind","","",53,null],[4,"ErrKind","","",null,null],[13,"CannotCast","","",54,null],[13,"CannotCastTo","","",54,null],[13,"InvalidOpForBools","","",54,null],[13,"InvalidOpForFloats","","",54,null],[13,"InvalidOpForIntUint","","",54,null],[13,"InvalidOpForUintInt","","",54,null],[13,"NegateOnString","","",54,null],[13,"NegateOnBoolean","","",54,null],[13,"NegateOnBinary","","",54,null],[13,"NegateOnStruct","","",54,null],[13,"NegateOnTuple","","",54,null],[13,"NotOnFloat","","",54,null],[13,"NotOnString","","",54,null],[13,"NotOnBinary","","",54,null],[13,"NotOnStruct","","",54,null],[13,"NotOnTuple","","",54,null],[13,"NegateWithOverflow","","",54,null],[13,"AddiWithOverflow","","",54,null],[13,"SubiWithOverflow","","",54,null],[13,"MuliWithOverflow","","",54,null],[13,"AdduWithOverflow","","",54,null],[13,"SubuWithOverflow","","",54,null],[13,"MuluWithOverflow","","",54,null],[13,"DivideByZero","","",54,null],[13,"DivideWithOverflow","","",54,null],[13,"ModuloByZero","","",54,null],[13,"ModuloWithOverflow","","",54,null],[13,"ShiftLeftWithOverflow","","",54,null],[13,"ShiftRightWithOverflow","","",54,null],[13,"MissingStructField","","",54,null],[13,"NonConstPath","","",54,null],[13,"ExpectedConstTuple","","",54,null],[13,"ExpectedConstStruct","","",54,null],[13,"TupleIndexOutOfBounds","","",54,null],[13,"MiscBinaryOp","","",54,null],[13,"MiscCatchAll","","",54,null],[6,"EvalResult","","",null,null],[6,"CastResult","","",null,null],[4,"IntTy","","",null,null],[13,"I8","","",55,null],[13,"I16","","",55,null],[13,"I32","","",55,null],[13,"I64","","",55,null],[4,"UintTy","","",null,null],[13,"U8","","",56,null],[13,"U16","","",56,null],[13,"U32","","",56,null],[13,"U64","","",56,null],[5,"const_int_checked_neg","","",null,{"inputs":[{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_neg","","",null,{"inputs":[{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_add","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_sub","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_mul","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_div","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_rem","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shl","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shl_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shr","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shr_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_add","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_sub","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_mul","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_div","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_rem","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shl","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shl_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shr","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shr_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"eval_const_expr_partial","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"compare_const_vals","","",null,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"option"}}],[5,"compare_lit_exprs","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"expr"},{"name":"option"}],"output":{"name":"option"}}],[0,"dataflow","rustc_typeck::middle","A module for propagating forward dataflow information. The analysis\nassumes that the items to be propagated can be represented as bits\nand thus uses bitvectors. Your job is simply to specify the so-called\nGEN and KILL bits for each expression.",null,null],[4,"EntryOrExit","rustc_typeck::middle::dataflow","",null,null],[13,"Entry","","",57,null],[13,"Exit","","",57,null],[3,"DataFlowContext","","",null,null],[8,"BitwiseOperator","","",null,null],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",420,{"inputs":[{"name":"bitwiseoperator"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",null,null],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",421,{"inputs":[{"name":"dataflowoperator"}],"output":{"name":"bool"}}],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill\ntakes effect only when control flows directly through the node in\nquestion, or if the kill's effect is associated with any\ncontrol-flow directly through or indirectly over the node.",null,null],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control\nflow goes over the node. A kill associated with the end of the\nscope of a variable declaration `let x;` is an example of a\n`ScopeEnd` kill.",59,null],[13,"Execution","","An `Execution` kill is one that takes effect only when control\nflow goes through the node to completion. A kill associated\nwith an assignment statement `x = expr;` is an example of an\n`Execution` kill.",59,null],[0,"dead","rustc_typeck::middle","",null,null],[5,"check_crate","rustc_typeck::middle::dead","",null,null],[0,"def","rustc_typeck::middle","",null,null],[4,"Def","rustc_typeck::middle::def","",null,null],[13,"DefFn","","",15,null],[13,"DefSelfTy","","",15,null],[13,"DefMod","","",15,null],[13,"DefForeignMod","","",15,null],[13,"DefStatic","","",15,null],[13,"DefConst","","",15,null],[13,"DefLocal","","",15,null],[13,"DefVariant","","",15,null],[13,"DefTy","","",15,null],[13,"DefAssociatedTy","","",15,null],[13,"DefTrait","","",15,null],[13,"DefPrimTy","","",15,null],[13,"DefTyParam","","",15,null],[13,"DefUse","","",15,null],[13,"DefUpvar","","",15,null],[13,"DefStruct","","Note that if it's a tuple struct's definition, the node id of the ast::DefId\nmay either refer to the item definition's id or the StructDef.ctor_id.",15,null],[13,"DefRegion","","",15,null],[13,"DefLabel","","",15,null],[13,"DefMethod","","",15,null],[3,"PathResolution","","The result of resolving a path.\nBefore type checking completes, `depth` represents the number of\ntrailing segments which are yet unresolved. Afterwards, if there\nwere no errors, all paths should be fully resolved, with `depth`\nset to `0` and `base_def` representing the final resolution.",null,null],[12,"base_def","","",65,null],[12,"last_private","","",65,null],[12,"depth","","",65,null],[6,"DefMap","","",null,null],[6,"ExportMap","","",null,null],[3,"Export","","",null,null],[12,"name","","",66,null],[12,"def_id","","",66,null],[4,"MethodProvenance","","",null,null],[13,"FromTrait","","",67,null],[13,"FromImpl","","",67,null],[0,"dependency_format","rustc_typeck::middle","Resolution of mixing rlibs and dylibs",null,null],[6,"DependencyList","rustc_typeck::middle::dependency_format","",null,null],[6,"Dependencies","","",null,null],[5,"calculate","","",null,null],[0,"effect","rustc_typeck::middle","Enforces the Rust effect system. Currently there is just one effect,\n`unsafe`.",null,null],[5,"check_crate","rustc_typeck::middle::effect","",null,null],[0,"entry","rustc_typeck::middle","",null,null],[5,"find_entry_point","rustc_typeck::middle::entry","",null,null],[0,"expr_use_visitor","rustc_typeck::middle","A different sort of visitor for walking fn bodies.  Unlike the\nnormal visitor, which just walks the entire body in one shot, the\n`ExprUseVisitor` determines how expressions are being used.",null,null],[8,"Delegate","rustc_typeck::middle::expr_use_visitor","This trait defines the callbacks you can expect to receive when\nemploying the ExprUseVisitor.",null,null],[10,"consume","","",422,null],[10,"matched_pat","","",422,null],[10,"consume_pat","","",422,null],[10,"borrow","","",422,null],[10,"decl_without_init","","",422,null],[10,"mutate","","",422,null],[4,"LoanCause","","",null,null],[13,"ClosureCapture","","",71,null],[13,"AddrOf","","",71,null],[13,"AutoRef","","",71,null],[13,"AutoUnsafe","","",71,null],[13,"RefBinding","","",71,null],[13,"OverloadedOperator","","",71,null],[13,"ClosureInvocation","","",71,null],[13,"ForLoop","","",71,null],[13,"MatchDiscriminant","","",71,null],[4,"ConsumeMode","","",null,null],[13,"Copy","","",72,null],[13,"Move","","",72,null],[4,"MoveReason","","",null,null],[13,"DirectRefMove","","",73,null],[13,"PatBindingMove","","",73,null],[13,"CaptureMove","","",73,null],[4,"MatchMode","","",null,null],[13,"NonBindingMatch","","",74,null],[13,"BorrowingMatch","","",74,null],[13,"CopyingMatch","","",74,null],[13,"MovingMatch","","",74,null],[4,"MutateMode","","",null,null],[13,"Init","","",76,null],[13,"JustWrite","","",76,null],[13,"WriteAndRead","","",76,null],[3,"ExprUseVisitor","","",null,null],[0,"fast_reject","rustc_typeck::middle","",null,null],[4,"SimplifiedType","rustc_typeck::middle::fast_reject","See `simplify_type",null,null],[13,"BoolSimplifiedType","","",79,null],[13,"CharSimplifiedType","","",79,null],[13,"IntSimplifiedType","","",79,null],[13,"UintSimplifiedType","","",79,null],[13,"FloatSimplifiedType","","",79,null],[13,"EnumSimplifiedType","","",79,null],[13,"StrSimplifiedType","","",79,null],[13,"VecSimplifiedType","","",79,null],[13,"PtrSimplifiedType","","",79,null],[13,"TupleSimplifiedType","","",79,null],[13,"TraitSimplifiedType","","",79,null],[13,"StructSimplifiedType","","",79,null],[13,"ClosureSimplifiedType","","",79,null],[13,"FunctionSimplifiedType","","",79,null],[13,"ParameterSimplifiedType","","",79,null],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc.\nThe idea is to get something simple that we can use to quickly decide if two types could unify\nduring method lookup.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"bool"}],"output":{"name":"option"}}],[0,"free_region","rustc_typeck::middle","This file defines",null,null],[3,"FreeRegionMap","rustc_typeck::middle::free_region","",null,null],[0,"graph","rustc_typeck::middle","A graph module for use in dataflow, region resolution, and elsewhere.",null,null],[3,"Graph","rustc_typeck::middle::graph","",null,null],[3,"Node","","",null,null],[12,"data","","",423,null],[3,"Edge","","",null,null],[12,"data","","",81,null],[3,"NodeIndex","","",null,null],[17,"InvalidNodeIndex","","",null,null],[3,"EdgeIndex","","",null,null],[17,"InvalidEdgeIndex","","",null,null],[3,"Direction","","",null,null],[17,"Outgoing","","",null,null],[17,"Incoming","","",null,null],[3,"DepthFirstTraversal","","",null,null],[5,"each_edge_index","","",null,null],[0,"intrinsicck","rustc_typeck::middle","",null,null],[5,"check_crate","rustc_typeck::middle::intrinsicck","",null,null],[0,"infer","rustc_typeck::middle","See the Book for more information.",null,null],[0,"bivariate","rustc_typeck::middle::infer","Applies the \"bivariance relationship\" to two types and/or regions.\nIf (A,B) are bivariant then either A <: B or B <: A. It occurs\nwhen type/lifetime parameters are unconstrained. Usually this is\nan error, but we permit it in the specific case where a type\nparameter is constrained in a where-clause via an associated type.",null,null],[3,"Bivariate","rustc_typeck::middle::infer::bivariate","",null,null],[0,"combine","rustc_typeck::middle::infer","",null,null],[3,"CombineFields","rustc_typeck::middle::infer::combine","",null,null],[12,"infcx","","",89,null],[12,"a_is_expected","","",89,null],[12,"trace","","",89,null],[5,"super_combine_tys","","",null,{"inputs":[{"name":"inferctxt"},{"name":"r"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[8,"RelateResultCompare","","",null,null],[10,"compare","","",424,{"inputs":[{"name":"relateresultcompare"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[0,"equate","rustc_typeck::middle::infer","",null,null],[3,"Equate","rustc_typeck::middle::infer::equate","",null,null],[0,"error_reporting","rustc_typeck::middle::infer","Error Reporting Code for the inference engine",null,null],[8,"ErrorReporting","rustc_typeck::middle::infer::error_reporting","",null,null],[10,"report_region_errors","","",425,null],[10,"process_errors","","",425,{"inputs":[{"name":"errorreporting"},{"name":"vec"}],"output":{"name":"vec"}}],[10,"report_type_error","","",425,null],[10,"report_and_explain_type_error","","",425,null],[10,"values_str","","",425,{"inputs":[{"name":"errorreporting"},{"name":"valuepairs"}],"output":{"name":"option"}}],[10,"expected_found_str","","",425,{"inputs":[{"name":"errorreporting"},{"name":"expected_found"}],"output":{"name":"option"}}],[10,"report_concrete_failure","","",425,null],[10,"report_generic_bound_failure","","",425,null],[10,"report_sub_sup_conflict","","",425,null],[10,"report_sup_sup_conflict","","",425,null],[10,"report_processed_errors","","",425,null],[10,"give_suggestion","","",425,null],[8,"Resolvable","","",null,null],[10,"resolve","","",426,{"inputs":[{"name":"resolvable"},{"name":"inferctxt"}],"output":{"name":"self"}}],[10,"contains_error","","",426,{"inputs":[{"name":"resolvable"}],"output":{"name":"bool"}}],[0,"glb","rustc_typeck::middle::infer","",null,null],[3,"Glb","rustc_typeck::middle::infer::glb","\"Greatest lower bound\" (common subtype)",null,null],[0,"lattice","rustc_typeck::middle::infer","# Lattice Variables",null,null],[8,"LatticeDir","rustc_typeck::middle::infer::lattice","",null,null],[10,"infcx","","",427,{"inputs":[{"name":"latticedir"}],"output":{"name":"inferctxt"}}],[10,"relate_bound","","",427,{"inputs":[{"name":"latticedir"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"super_lattice_tys","","",null,{"inputs":[{"name":"l"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[0,"lub","rustc_typeck::middle::infer","",null,null],[3,"Lub","rustc_typeck::middle::infer::lub","\"Least upper bound\" (common supertype)",null,null],[0,"region_inference","rustc_typeck::middle::infer","See README.md",null,null],[4,"Constraint","rustc_typeck::middle::infer::region_inference","",null,null],[13,"ConstrainVarSubVar","","",101,null],[13,"ConstrainRegSubVar","","",101,null],[13,"ConstrainVarSubReg","","",101,null],[4,"Verify","","",null,null],[13,"VerifyRegSubReg","","",112,null],[13,"VerifyGenericBound","","",112,null],[4,"GenericKind","","",null,null],[13,"Param","","",102,null],[13,"Projection","","",102,null],[3,"TwoRegions","","",null,null],[4,"UndoLogEntry","","",null,null],[13,"OpenSnapshot","","",104,null],[13,"CommitedSnapshot","","",104,null],[13,"AddVar","","",104,null],[13,"AddConstraint","","",104,null],[13,"AddVerify","","",104,null],[13,"AddGiven","","",104,null],[13,"AddCombination","","",104,null],[4,"CombineMapType","","",null,null],[13,"Lub","","",105,null],[13,"Glb","","",105,null],[4,"RegionResolutionError","","",null,null],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",106,null],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a, bs)",106,null],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",106,null],[13,"SupSupConflict","","`SupSupConflict(v, origin1, r1, origin2, r2)`:",106,null],[13,"ProcessedErrors","","For subsets of `ConcreteFailure` and `SubSupConflict`, we can derive\nmore specific errors message by suggesting to the user where they\nshould put a lifetime. In those cases we process and put those errors\ninto `ProcessedErrors` before we do any reporting.",106,null],[3,"SameRegions","","SameRegions is used to group regions that we think are the same and would\nlike to indicate so to the user.\nFor example, the following function\n```\nstruct Foo { bar: int }\nfn foo2<'a, 'b>(x: &'a Foo) -> &'b int {\n   &x.bar\n}\n```\nwould report an error because we expect 'a and 'b to match, and so we group\n'a and 'b together inside a SameRegions struct",null,null],[12,"scope_id","","",107,null],[12,"regions","","",107,null],[6,"CombineMap","","",null,null],[3,"RegionVarBindings","","",null,null],[3,"RegionSnapshot","","",null,null],[4,"VarValue","","",null,null],[13,"NoValue","","",111,null],[13,"Value","","",111,null],[13,"ErrorValue","","",111,null],[0,"resolve","rustc_typeck::middle::infer","",null,null],[3,"OpportunisticTypeResolver","rustc_typeck::middle::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces\ntype variables that have been unified with the things they have\nbeen unified with (similar to `shallow_resolve`, but deep). This is\nuseful for printing messages etc but also required at various\npoints for correctness.",null,null],[5,"fully_resolve","","Full type resolution replaces all type and region variables with\ntheir concrete results. If any variable cannot be replaced (never unified, etc)\nthen an `Err` result is returned.",null,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[0,"sub","rustc_typeck::middle::infer","",null,null],[3,"Sub","rustc_typeck::middle::infer::sub","\"Greatest lower bound\" (common subtype)",null,null],[0,"type_variable","rustc_typeck::middle::infer","",null,null],[3,"TypeVariableTable","rustc_typeck::middle::infer::type_variable","",null,null],[3,"Snapshot","","",null,null],[4,"RelationDir","","",null,null],[13,"SubtypeOf","","",118,null],[13,"SupertypeOf","","",118,null],[13,"EqTo","","",118,null],[13,"BiTo","","",118,null],[0,"unify","rustc_typeck::middle::infer","",null,null],[8,"UnifyKey","rustc_typeck::middle::infer::unify","This trait is implemented by any type that can serve as a type\nvariable. We call such variables *unification keys*. For example,\nthis trait is implemented by `IntVid`, which represents integral\nvariables.",null,null],[16,"Value","rustc_typeck::middle::infer::unify::UnifyKey","",null,null],[10,"index","rustc_typeck::middle::infer::unify","",428,{"inputs":[{"name":"unifykey"}],"output":{"name":"u32"}}],[10,"from_index","","",428,{"inputs":[{"name":"unifykey"},{"name":"u32"}],"output":{"name":"self"}}],[10,"tag","","",428,{"inputs":[{"name":"unifykey"},{"name":"option"}],"output":{"name":"str"}}],[8,"UnifyValue","","Trait for valid types that a type variable can be set to. Note that\nthis is typically not the end type that the value will take on, but\nrather an `Option` wrapper (where `None` represents a variable\nwhose value is not yet set).",null,null],[4,"VarValue","","Value of a unification key. We implement Tarjan's union-find\nalgorithm: when two keys are unified, one of them is converted\ninto a \"redirect\" pointing at the other. These redirects form a\nDAG: the roots of the DAG (nodes that are not redirected) are each\nassociated with a value of type `V` and a rank. The rank is used\nto keep the DAG relatively balanced, which helps keep the running\ntime of the algorithm under control. For more information, see\n<http://en.wikipedia.org/wiki/Disjoint-set_data_structure>.",null,null],[13,"Redirect","","",121,null],[13,"Root","","",121,null],[3,"UnificationTable","","Table of unification keys and their values.",null,null],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes\nmade during the snapshot may either be *committed* or *rolled back*.",null,null],[3,"Node","","Internal type used to represent the result of a `get()` operation.\nConveys the current root and value of the key.",null,null],[12,"key","","",429,null],[12,"value","","",429,null],[12,"rank","","",429,null],[3,"Delegate","","",null,null],[8,"ToType","","",null,null],[10,"to_type","","",430,{"inputs":[{"name":"totype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Bound","rustc_typeck::middle::infer","",null,null],[6,"UnitResult","","",null,null],[6,"fres","","",null,null],[3,"InferCtxt","","",null,null],[12,"tcx","","",93,null],[6,"SkolemizationMap","","",null,null],[4,"TypeOrigin","","Why did we require that the two types be related?",null,null],[13,"Misc","","",128,null],[13,"MethodCompatCheck","","",128,null],[13,"ExprAssignable","","",128,null],[13,"RelateTraitRefs","","",128,null],[13,"RelateSelfType","","",128,null],[13,"RelateOutputImplTypes","","",128,null],[13,"MatchExpressionArm","","",128,null],[13,"IfExpression","","",128,null],[13,"IfExpressionWithNoElse","","",128,null],[13,"RangeExpression","","",128,null],[13,"EquatePredicate","","",128,null],[4,"ValuePairs","","See `error_reporting.rs` for more details",null,null],[13,"Types","","",129,null],[13,"TraitRefs","","",129,null],[13,"PolyTraitRefs","","",129,null],[3,"TypeTrace","","The trace designates the path through inference that we took to\nencounter an error or subtyping constraint.",null,null],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",null,null],[13,"Subtype","","",131,null],[13,"InfStackClosure","","",131,null],[13,"InvokeClosure","","",131,null],[13,"DerefPointer","","",131,null],[13,"FreeVariable","","",131,null],[13,"IndexSlice","","",131,null],[13,"RelateObjectBound","","",131,null],[13,"RelateParamBound","","",131,null],[13,"RelateRegionParamBound","","",131,null],[13,"RelateDefaultParamBound","","",131,null],[13,"Reborrow","","",131,null],[13,"ReborrowUpvar","","",131,null],[13,"ReferenceOutlivesReferent","","",131,null],[13,"ExprTypeIsNotInScope","","",131,null],[13,"BindingTypeIsNotValidAtDecl","","",131,null],[13,"CallRcvr","","",131,null],[13,"CallArg","","",131,null],[13,"CallReturn","","",131,null],[13,"Operand","","",131,null],[13,"AddrOf","","",131,null],[13,"AutoBorrow","","",131,null],[13,"SafeDestructor","","",131,null],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",null,null],[13,"FnCall","","when a fn is called",132,null],[13,"HigherRankedType","","when two higher-ranked types are compared",132,null],[13,"AssocTypeProjection","","when projecting an associated type",132,null],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",null,null],[13,"MiscVariable","","",133,null],[13,"PatternRegion","","",133,null],[13,"AddrOfRegion","","",133,null],[13,"Autoref","","",133,null],[13,"Coercion","","",133,null],[13,"EarlyBoundRegion","","",133,null],[13,"LateBoundRegion","","",133,null],[13,"UpvarRegion","","",133,null],[13,"BoundRegionInCoherence","","",133,null],[4,"fixup_err","","",null,null],[13,"unresolved_int_ty","","",134,null],[13,"unresolved_float_ty","","",134,null],[13,"unresolved_ty","","",134,null],[5,"fixup_err_to_string","","",null,{"inputs":[{"name":"fixup_err"}],"output":{"name":"string"}}],[5,"new_infer_ctxt","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"inferctxt"}}],[5,"common_supertype","","Computes the least upper-bound of `a` and `b`. If this is not possible, reports an error and\nreturns ty::err.",null,{"inputs":[{"name":"inferctxt"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"can_mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"can_mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"mk_subr","","",null,null],[5,"mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"mk_sub_poly_trait_refs","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[3,"CombinedSnapshot","","",null,null],[4,"GenericKind","","",null,null],[13,"Param","","",102,null],[13,"Projection","","",102,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",125,null],[13,"UintType","","",125,null],[3,"TypeFreshener","","",null,null],[0,"implicator","rustc_typeck::middle","",null,null],[4,"Implication","rustc_typeck::middle::implicator","",null,null],[13,"RegionSubRegion","","",135,null],[13,"RegionSubGeneric","","",135,null],[13,"RegionSubClosure","","",135,null],[13,"Predicate","","",135,null],[5,"implications","","This routine computes the well-formedness constraints that must hold for the type `ty` to\nappear in a context with lifetime `outer_region`",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"u32"},{"name":"tys"},{"name":"region"},{"name":"span"}],"output":{"name":"vec"}}],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime\nbounds that must hold on the elided self type. These are derived\nfrom the declarations of `SomeTrait`, `Send`, and friends -- if\nthey declare `trait SomeTrait : 'static`, for example, then\n`'static` would appear in the list. The hard work is done by\n`ty::required_region_bounds`, see that for more information.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"enumset"}],"output":{"name":"vec"}}],[0,"lang_items","rustc_typeck::middle","",null,null],[4,"LangItem","rustc_typeck::middle::lang_items","",null,null],[13,"CharImplItem","","",136,null],[13,"StrImplItem","","",136,null],[13,"SliceImplItem","","",136,null],[13,"ConstPtrImplItem","","",136,null],[13,"MutPtrImplItem","","",136,null],[13,"I8ImplItem","","",136,null],[13,"I16ImplItem","","",136,null],[13,"I32ImplItem","","",136,null],[13,"I64ImplItem","","",136,null],[13,"IsizeImplItem","","",136,null],[13,"U8ImplItem","","",136,null],[13,"U16ImplItem","","",136,null],[13,"U32ImplItem","","",136,null],[13,"U64ImplItem","","",136,null],[13,"UsizeImplItem","","",136,null],[13,"F32ImplItem","","",136,null],[13,"F64ImplItem","","",136,null],[13,"SendTraitLangItem","","",136,null],[13,"SizedTraitLangItem","","",136,null],[13,"CopyTraitLangItem","","",136,null],[13,"SyncTraitLangItem","","",136,null],[13,"DropTraitLangItem","","",136,null],[13,"AddTraitLangItem","","",136,null],[13,"SubTraitLangItem","","",136,null],[13,"MulTraitLangItem","","",136,null],[13,"DivTraitLangItem","","",136,null],[13,"RemTraitLangItem","","",136,null],[13,"NegTraitLangItem","","",136,null],[13,"NotTraitLangItem","","",136,null],[13,"BitXorTraitLangItem","","",136,null],[13,"BitAndTraitLangItem","","",136,null],[13,"BitOrTraitLangItem","","",136,null],[13,"ShlTraitLangItem","","",136,null],[13,"ShrTraitLangItem","","",136,null],[13,"IndexTraitLangItem","","",136,null],[13,"IndexMutTraitLangItem","","",136,null],[13,"RangeStructLangItem","","",136,null],[13,"RangeFromStructLangItem","","",136,null],[13,"RangeToStructLangItem","","",136,null],[13,"RangeFullStructLangItem","","",136,null],[13,"UnsafeCellTypeLangItem","","",136,null],[13,"DerefTraitLangItem","","",136,null],[13,"DerefMutTraitLangItem","","",136,null],[13,"FnTraitLangItem","","",136,null],[13,"FnMutTraitLangItem","","",136,null],[13,"FnOnceTraitLangItem","","",136,null],[13,"EqTraitLangItem","","",136,null],[13,"OrdTraitLangItem","","",136,null],[13,"StrEqFnLangItem","","",136,null],[13,"PanicFnLangItem","","",136,null],[13,"PanicBoundsCheckFnLangItem","","",136,null],[13,"PanicFmtLangItem","","",136,null],[13,"ExchangeMallocFnLangItem","","",136,null],[13,"ExchangeFreeFnLangItem","","",136,null],[13,"StrDupUniqFnLangItem","","",136,null],[13,"StartFnLangItem","","",136,null],[13,"EhPersonalityLangItem","","",136,null],[13,"ExchangeHeapLangItem","","",136,null],[13,"OwnedBoxLangItem","","",136,null],[13,"PhantomDataItem","","",136,null],[13,"CovariantTypeItem","","",136,null],[13,"ContravariantTypeItem","","",136,null],[13,"InvariantTypeItem","","",136,null],[13,"CovariantLifetimeItem","","",136,null],[13,"ContravariantLifetimeItem","","",136,null],[13,"InvariantLifetimeItem","","",136,null],[13,"NoCopyItem","","",136,null],[13,"ManagedItem","","",136,null],[13,"NonZeroItem","","",136,null],[13,"StackExhaustedLangItem","","",136,null],[13,"DebugTraitLangItem","","",136,null],[3,"LanguageItems","","",null,null],[12,"items","","",137,null],[12,"missing","","",137,null],[5,"extract","","",null,null],[5,"collect_language_items","","",null,{"inputs":[{"name":"crate"},{"name":"session"}],"output":{"name":"languageitems"}}],[0,"liveness","rustc_typeck::middle","A classic liveness analysis based on dataflow over the AST.  Computes,\nfor each local variable in a function, whether that variable is live\nat a given point.  Program execution points are identified by their\nid.",null,null],[5,"check_crate","rustc_typeck::middle::liveness","",null,null],[0,"mem_categorization","rustc_typeck::middle","# Categorization",null,null],[4,"categorization","rustc_typeck::middle::mem_categorization","",null,null],[13,"cat_rvalue","","",148,null],[13,"cat_static_item","","",148,null],[13,"cat_upvar","","",148,null],[13,"cat_local","","",148,null],[13,"cat_deref","","",148,null],[13,"cat_interior","","",148,null],[13,"cat_downcast","","",148,null],[3,"Upvar","","",null,null],[12,"id","","",149,null],[12,"kind","","",149,null],[4,"PointerKind","","",null,null],[13,"Unique","","`Box<T>`",150,null],[13,"BorrowedPtr","","`&T`",150,null],[13,"UnsafePtr","","`*T`",150,null],[13,"Implicit","","Implicit deref of the `&T` that results from an overloaded index `[]`.",150,null],[4,"InteriorKind","","",null,null],[13,"InteriorField","","",151,null],[13,"InteriorElement","","",151,null],[4,"FieldName","","",null,null],[13,"NamedField","","",152,null],[13,"PositionalField","","",152,null],[4,"InteriorOffsetKind","","",null,null],[13,"Index","","",153,null],[13,"Pattern","","",153,null],[4,"ElementKind","","",null,null],[13,"VecElement","","",154,null],[13,"OtherElement","","",154,null],[4,"MutabilityCategory","","",null,null],[13,"McImmutable","","",155,null],[13,"McDeclared","","",155,null],[13,"McInherited","","",155,null],[4,"Note","","",null,null],[13,"NoteClosureEnv","","",156,null],[13,"NoteUpvarRef","","",156,null],[13,"NoteNone","","",156,null],[3,"cmt_","","",null,null],[12,"id","","",157,null],[12,"span","","",157,null],[12,"cat","","",157,null],[12,"mutbl","","",157,null],[12,"ty","","",157,null],[12,"note","","",157,null],[6,"cmt","","",null,null],[4,"deref_kind","","",null,null],[13,"deref_ptr","","",158,null],[13,"deref_interior","","",158,null],[8,"ast_node","","",null,null],[10,"id","","",431,{"inputs":[{"name":"ast_node"}],"output":{"name":"u32"}}],[10,"span","","",431,{"inputs":[{"name":"ast_node"}],"output":{"name":"span"}}],[3,"MemCategorizationContext","","",null,null],[6,"McResult","","",null,null],[8,"Typer","","The `Typer` trait provides the interface for the mem-categorization\nmodule to the results of the type check. It can be used to query\nthe type assigned to an expression node, to inquire after adjustments,\nand so on.",null,null],[10,"node_ty","","",432,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"result"}}],[10,"expr_ty_adjusted","","",432,{"inputs":[{"name":"typer"},{"name":"expr"}],"output":{"name":"result"}}],[10,"type_moves_by_default","","",432,{"inputs":[{"name":"typer"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[10,"node_method_ty","","",432,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"node_method_origin","","",432,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"adjustments","","",432,{"inputs":[{"name":"typer"}],"output":{"name":"refcell"}}],[10,"is_method_call","","",432,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"bool"}}],[10,"temporary_scope","","",432,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"option"}}],[10,"upvar_capture","","",432,{"inputs":[{"name":"typer"},{"name":"upvarid"}],"output":{"name":"option"}}],[4,"InteriorSafety","","",null,null],[13,"InteriorUnsafe","","",162,null],[13,"InteriorSafe","","",162,null],[4,"Aliasability","","",null,null],[13,"FreelyAliasable","","",163,null],[13,"NonAliasable","","",163,null],[13,"ImmutableUnique","","",163,null],[4,"AliasableReason","","",null,null],[13,"AliasableBorrowed","","",164,null],[13,"AliasableClosure","","",164,null],[13,"AliasableOther","","",164,null],[13,"UnaliasableImmutable","","",164,null],[13,"AliasableStatic","","",164,null],[13,"AliasableStaticMut","","",164,null],[5,"ptr_sigil","","",null,{"inputs":[{"name":"pointerkind"}],"output":{"name":"str"}}],[0,"pat_util","rustc_typeck::middle","",null,null],[6,"PatIdMap","rustc_typeck::middle::pat_util","",null,null],[5,"pat_id_map","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"hashmap"}}],[5,"pat_is_refutable","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_variant_or_struct","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_const","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding_or_wild","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_bindings","","Call `it` on every \"binding\" in a pattern, e.g., on `a` in\n`match foo() { Some(a) => (), None => () }`",null,null],[5,"pat_contains_bindings","","Checks if the pattern contains any patterns that bind something to\nan ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_contains_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings.",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"arm_contains_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut`\nbindings.",null,{"inputs":[{"name":"refcell"},{"name":"arm"}],"output":{"name":"bool"}}],[5,"pat_contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to\nan ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"simple_identifier","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"option"}}],[5,"def_to_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"path"}}],[0,"privacy","rustc_typeck::middle","A pass that checks to make sure private fields and methods aren't used\noutside their scopes. This pass will also generate a set of exported items\nwhich are available for use externally when compiled as a library.",null,null],[6,"ExportedItems","rustc_typeck::middle::privacy","",null,null],[6,"ExternalExports","","",null,null],[6,"PublicItems","","",null,null],[4,"LastPrivate","","",null,null],[13,"LastMod","","",166,null],[13,"LastImport","","",166,null],[12,"value_priv","rustc_typeck::middle::privacy::LastPrivate","",166,null],[12,"value_used","","",166,null],[12,"type_priv","","",166,null],[12,"type_used","","",166,null],[4,"PrivateDep","rustc_typeck::middle::privacy","",null,null],[13,"AllPublic","","",167,null],[13,"DependsOn","","",167,null],[4,"ImportUse","","",null,null],[13,"Unused","","",168,null],[13,"Used","","",168,null],[0,"reachable","rustc_typeck::middle","",null,null],[5,"find_reachable","rustc_typeck::middle::reachable","",null,{"inputs":[{"name":"ctxt"},{"name":"hashset"}],"output":{"name":"hashset"}}],[0,"region","rustc_typeck::middle","This file actually contains two passes related to regions.  The first\npass builds up the `scope_map`, which describes the parent links in\nthe region hierarchy.  The second pass infers which types must be\nregion parameterized.",null,null],[4,"CodeExtent","rustc_typeck::middle::region","CodeExtent represents a statically-describable extent that can be\nused to bound the lifetime/region for values.",null,null],[13,"Misc","","",18,null],[13,"ParameterScope","","",18,null],[12,"fn_id","rustc_typeck::middle::region::CodeExtent","",18,null],[12,"body_id","","",18,null],[13,"DestructionScope","rustc_typeck::middle::region","",18,null],[13,"Remainder","","",18,null],[3,"DestructionScopeData","","extent of destructors for temporaries of node-id",null,null],[12,"node_id","","",19,null],[3,"BlockRemainder","","Represents a subscope of `block` for a binding that is introduced\nby `block.stmts[first_statement_index]`. Such subscopes represent\na suffix of the block. Note that each subscope does not include\nthe initializer expression, if any, for the statement indexed by\n`first_statement_index`.",null,null],[12,"block","","",170,null],[12,"first_statement_index","","",170,null],[3,"RegionMaps","","The region maps encode information about region relationships.",null,null],[3,"Context","","",null,null],[5,"resolve_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"regionmaps"}}],[5,"resolve_inlined_item","","",null,null],[0,"recursion_limit","rustc_typeck::middle","",null,null],[5,"update_recursion_limit","rustc_typeck::middle::recursion_limit","",null,null],[0,"resolve_lifetime","rustc_typeck::middle","Name resolution for lifetimes.",null,null],[4,"DefRegion","rustc_typeck::middle::resolve_lifetime","",null,null],[13,"DefStaticRegion","","",177,null],[13,"DefEarlyBoundRegion","","",177,null],[13,"DefLateBoundRegion","","",177,null],[13,"DefFreeRegion","","",177,null],[6,"NamedRegionMap","","",null,null],[5,"krate","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"refcell"}],"output":{"name":"hashmap"}}],[5,"early_bound_lifetimes","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"vec"}}],[0,"stability","rustc_typeck::middle","A pass that annotates every item and method with its stability level,\npropagating default levels lexically from parent to children ast nodes.",null,null],[3,"Index","rustc_typeck::middle::stability","A stability index, giving the stability level for items and methods.",null,null],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled\nfeatures and possibly prints errors. Returns a list of all\nfeatures used.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"hashmap"}}],[5,"check_item","","Helper for discovering nodes to check for stability",null,null],[5,"check_expr","","Helper for discovering nodes to check for stability",null,null],[5,"check_path","","",null,null],[5,"check_pat","","",null,null],[5,"lookup","","Lookup the stability for a node, loading external crate\nmetadata as necessary.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that\nwere expected to be library features), and the list of features used from\nlibraries, identify activated features that don't exist and error about them.",null,null],[0,"subst","rustc_typeck::middle","",null,null],[3,"Substs","rustc_typeck::middle::subst","A substitution mapping type/region parameters to new values. We\nidentify each in-scope parameter by an *index* and a *parameter\nspace* (which indices where the parameter is defined; see\n`ParamSpace`).",null,null],[12,"types","","",184,null],[12,"regions","","",184,null],[4,"RegionSubsts","","Represents the values to use when substituting lifetime parameters.\nIf the value is `ErasedRegions`, then this subst is occurring during\ntrans, and all region parameters will be replaced with `ty::ReStatic`.",null,null],[13,"ErasedRegions","","",185,null],[13,"NonerasedRegions","","",185,null],[4,"ParamSpace","","",null,null],[13,"TypeSpace","","",186,null],[13,"SelfSpace","","",186,null],[13,"FnSpace","","",186,null],[3,"VecPerParamSpace","","Vector of things sorted by param space. Used to keep\nthe set of things declared on the type, self, or method\ndistinct.",null,null],[3,"SeparateVecsPerParamSpace","","The `split` function converts one `VecPerParamSpace` into this\n`SeparateVecsPerParamSpace` structure.",null,null],[12,"types","","",433,null],[12,"selfs","","",433,null],[12,"fns","","",433,null],[3,"EnumeratedItems","","",null,null],[8,"Subst","","",null,null],[11,"subst","","",434,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"self"}}],[10,"subst_spanned","","",434,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"},{"name":"option"}],"output":{"name":"self"}}],[0,"traits","rustc_typeck::middle","Trait Resolution. See the Book for more.",null,null],[3,"Obligation","rustc_typeck::middle::traits","An `Obligation` represents some trait reference (e.g. `int:Eq`) for\nwhich the vtable must be found.  The process of finding a vtable is\ncalled \"resolving\" the `Obligation`. This process consists of\neither identifying an `impl` (e.g., `impl Eq for int`) that\nprovides the required vtable, or else finding a bound that is in\nscope. The eventual result is usually a `Selection` (defined below).",null,null],[12,"cause","","",213,null],[12,"recursion_depth","","",213,null],[12,"predicate","","",213,null],[6,"PredicateObligation","","",null,null],[6,"TraitObligation","","",null,null],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",null,null],[12,"span","","",220,null],[12,"body_id","","",220,null],[12,"code","","",220,null],[4,"ObligationCauseCode","","",null,null],[13,"MiscObligation","","Not well classified or should be obvious from span.",221,null],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must\nalso implement all supertraits of X.",221,null],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",221,null],[13,"AssignmentLhsSized","","Various cases where expressions must be sized/copy/etc:",221,null],[13,"StructInitializerSized","","",221,null],[13,"VariableType","","",221,null],[13,"ReturnType","","",221,null],[13,"RepeatVec","","",221,null],[13,"ClosureCapture","","",221,null],[13,"FieldSized","","",221,null],[13,"ObjectSized","","",221,null],[13,"SharedStatic","","",221,null],[13,"BuiltinDerivedObligation","","",221,null],[13,"ImplDerivedObligation","","",221,null],[13,"CompareImplMethodObligation","","",221,null],[3,"DerivedObligationCause","","",null,null],[6,"Obligations","","",null,null],[6,"PredicateObligations","","",null,null],[6,"TraitObligations","","",null,null],[6,"Selection","","",null,null],[4,"SelectionError","","",null,null],[13,"Unimplemented","","",217,null],[13,"OutputTypeParameterMismatch","","",217,null],[3,"FulfillmentError","","",null,null],[12,"obligation","","",218,null],[12,"code","","",218,null],[4,"FulfillmentErrorCode","","",null,null],[13,"CodeSelectionError","","",219,null],[13,"CodeProjectionError","","",219,null],[13,"CodeAmbiguity","","",219,null],[6,"SelectionResult","","",null,null],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable`\nindicates where the vtable comes from. Note that while we call this\na \"vtable\", it does not necessarily indicate dynamic dispatch at\nruntime. `Vtable` instances just tell the compiler where to find\nmethods, but in generic code those methods are typically statically\ndispatched -- only when an object is constructed is a `Vtable`\ninstance reified into an actual vtable.",null,null],[13,"VtableImpl","","Vtable identifying a particular impl.",214,null],[13,"VtableDefaultImpl","","Vtable for default trait implementations\nThis carries the information and nested obligations with regards\nto a default implementation for a trait `Trait`. The nested obligations\nensure the trait implementation holds for all the constituent types.",214,null],[13,"VtableParam","","Successful resolution to an obligation provided by the caller\nfor some type parameter. The `Vec<N>` represents the\nobligations incurred from normalizing the where-clause (if\nany).",214,null],[13,"VtableObject","","Virtual calls through an object",214,null],[13,"VtableBuiltin","","Successful resolution for a builtin trait.",214,null],[13,"VtableClosure","","Vtable automatically generated for a closure. The def ID is the ID\nof the closure expression. This is a `VtableImpl` in spirit, but the\nimpl is generated by the compiler and does not appear in the source.",214,null],[13,"VtableFnPointer","","Same as above, but for a fn pointer type with the given signature.",214,null],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of\nsubstitutions from the impl's type/lifetime parameters. The\n`nested` vector corresponds to the nested obligations attached to\nthe impl's type parameters.",null,null],[12,"impl_def_id","","",211,null],[12,"substs","","",211,null],[12,"nested","","",211,null],[3,"VtableDefaultImplData","","",null,null],[12,"trait_def_id","","",216,null],[12,"nested","","",216,null],[3,"VtableBuiltinData","","",null,null],[12,"nested","","",215,null],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived\nfor the object type `Foo`.",null,null],[12,"object_ty","","the object type `Foo`.",212,null],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",212,null],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",null,{"inputs":[{"name":"ctxt"},{"name":"obligationcause"},{"name":"instantiatedpredicates"}],"output":{"name":"vecperparamspace"}}],[5,"evaluate_builtin_bound","","Determines whether the type `ty` is known to meet `bound` and\nreturns true if so. Returns false if `ty` either does not meet\n`bound` or is not known to meet bound (note that this is\nconservative towards *no impl*, which is the opposite of the\n`evaluate` methods).",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"tys"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"result"}}],[5,"type_known_to_meet_builtin_bound","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"tys"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"bool"}}],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",null,{"inputs":[{"name":"parameterenvironment"},{"name":"obligationcause"}],"output":{"name":"parameterenvironment"}}],[5,"fully_normalize","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"result"}}],[5,"report_fulfillment_errors","","",null,null],[5,"transitive_bounds","","",null,null],[6,"Supertraits","","",null,null],[3,"SelectionCache","","",null,null],[5,"is_object_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[3,"FulfillmentContext","","The fulfillment context is used to drive trait resolution.  It\nconsists of a list of obligations that must be (eventually)\nsatisfied. The job is to track which are satisfied, which yielded\nerrors, and which are still pending. At any point, users can call\n`select_where_possible`, and the fulfilment context will try to do\nselection, retaining only those obligations that remain\nambiguous. This may be helpful in pushing type inference\nalong. Once all type inference constraints have been generated, the\nmethod `select_all_or_error` can be used to report any remaining\nambiguous cases as errors.",null,null],[5,"normalize","","Normalizes any associated type projections in `value`, replacing\nthem with a fully resolved type where possible. The return value\ncombines the normalized result and any additional obligations that\nwere incurred as result.",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"supertraits","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"filtertotraits"}}],[5,"elaborate_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"elaborator"}}],[5,"suggest_new_overflow_limit","","",null,null],[5,"upcast","","Cast a trait reference into a reference to one of its super\ntraits; returns `None` if `target_trait_def_id` is not a\nsupertrait.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_ref_for_builtin_bound","","",null,{"inputs":[{"name":"ctxt"},{"name":"builtinbound"},{"name":"tys"}],"output":{"name":"result"}}],[5,"supertrait_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"supertraitdefids"}}],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the\ndef-id of a trait impl. To pass, either the trait must be local, or else\ntwo conditions must be satisfied:",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"result"}}],[3,"SelectionContext","","",null,null],[5,"overlapping_impls","","True if there exist types that satisfy both of the two given impls.",null,{"inputs":[{"name":"inferctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We\nhalt compilation unconditionally because it is important that\noverflows never be masked -- they basically represent computations\nwhose result could not be truly determined and thus we can't say\nif the program type checks or not -- and they are unusual\noccurrences in any case.",null,null],[4,"MethodMatchedData","","",null,null],[13,"PreciseMethodMatch","","",201,null],[13,"CoerciveMethodMatch","","",201,null],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",null,null],[13,"StaticMethod","","e.g., `fn foo()`",198,null],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",198,null],[13,"Generic","","e.g., `fn foo<A>()`",198,null],[3,"RegionObligation","","",null,null],[12,"sub_region","","",191,null],[12,"sup_type","","",191,null],[12,"cause","","",191,null],[5,"is_vtable_safe_method","","We say a method is *vtable safe* if it can be invoked on a trait\nobject.  Note that object-safe traits can have some\nnon-vtable-safe methods, so long as they require `Self:Sized` or\notherwise ensure that they cannot be used when `Self=Trait`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"method"}],"output":{"name":"bool"}}],[4,"OrphanCheckErr","","",null,null],[13,"NoLocalInputType","","",435,null],[13,"UncoveredTy","","",435,null],[3,"MismatchedProjectionTypes","","",null,null],[12,"err","","",193,null],[4,"ObjectSafetyViolation","","",null,null],[13,"SizedSelf","","Self : Sized declared on the trait",199,null],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location\n(e.g. `trait Foo : Bar<Self>`)",199,null],[13,"Method","","Method has something illegal",199,null],[5,"object_safety_violations","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[4,"MethodMatchResult","","",null,null],[13,"MethodMatched","","",207,null],[13,"MethodAmbiguous","","",207,null],[13,"MethodDidNotMatch","","",207,null],[3,"SupertraitDefIds","","",null,null],[5,"get_vtable_index_of_object_method","","Given an object of type `object_trait_ref`, returns the index of\nthe method `n_method` found in the trait `trait_def_id` (which\nshould be a supertrait of `object_trait_ref`) within the vtable\nfor `object_trait_ref`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"defid"},{"name":"usize"}],"output":{"name":"usize"}}],[3,"Normalized","","",null,null],[12,"value","","",196,null],[12,"obligations","","",196,null],[0,"ty","rustc_typeck::middle","",null,null],[6,"Disr","rustc_typeck::middle::ty","",null,null],[17,"INITIAL_DISCRIMINANT_VALUE","","",null,null],[3,"CrateAnalysis","","The complete set of all analyses described in this module. This is\nproduced by the driver and fed to trans and later passes.",null,null],[12,"export_map","","",436,null],[12,"exported_items","","",436,null],[12,"public_items","","",436,null],[12,"ty_cx","","",436,null],[12,"reachable","","",436,null],[12,"name","","",436,null],[12,"glob_map","","",436,null],[3,"field","","",null,null],[12,"name","","",223,null],[12,"mt","","",223,null],[4,"ImplOrTraitItemContainer","","",null,null],[13,"TraitContainer","","",224,null],[13,"ImplContainer","","",224,null],[4,"ImplOrTraitItem","","",null,null],[13,"MethodTraitItem","","",225,null],[13,"TypeTraitItem","","",225,null],[4,"ImplOrTraitItemId","","",null,null],[13,"MethodTraitItemId","","",226,null],[13,"TypeTraitItemId","","",226,null],[3,"Method","","",null,null],[12,"name","","",227,null],[12,"generics","","",227,null],[12,"predicates","","",227,null],[12,"fty","","",227,null],[12,"explicit_self","","",227,null],[12,"vis","","",227,null],[12,"def_id","","",227,null],[12,"container","","",227,null],[12,"provided_source","","",227,null],[3,"AssociatedType","","",null,null],[12,"name","","",228,null],[12,"vis","","",228,null],[12,"def_id","","",228,null],[12,"container","","",228,null],[3,"mt","","",null,null],[12,"ty","","",229,null],[12,"mutbl","","",229,null],[3,"field_ty","","",null,null],[12,"name","","",230,null],[12,"id","","",230,null],[12,"vis","","",230,null],[12,"origin","","",230,null],[3,"creader_cache_key","","",null,null],[12,"cnum","","",231,null],[12,"pos","","",231,null],[12,"len","","",231,null],[3,"ItemVariances","","",null,null],[12,"types","","",232,null],[12,"regions","","",232,null],[4,"Variance","","",null,null],[13,"Covariant","","",233,null],[13,"Invariant","","",233,null],[13,"Contravariant","","",233,null],[13,"Bivariant","","",233,null],[4,"AutoAdjustment","","",null,null],[13,"AdjustReifyFnPointer","","",234,null],[13,"AdjustUnsafeFnPointer","","",234,null],[13,"AdjustDerefRef","","",234,null],[3,"AutoDerefRef","","Represents coercing a pointer to a different kind of pointer - where 'kind'\nhere means either or both of raw vs borrowed vs unique and fat vs thin.",null,null],[12,"autoderefs","","Step 1. Apply a number of dereferences, producing an lvalue.",235,null],[12,"autoref","","Step 2. Optionally produce a pointer/reference from the value.",235,null],[12,"unsize","","Step 3. Unsize a pointer/reference value, e.g. `&[T; n]` to\n`&[T]`. The stored type is the target pointer type. Note that\nthe source could be a thin or fat pointer.",235,null],[4,"AutoRef","","",null,null],[13,"AutoPtr","","Convert from T to &T.",236,null],[13,"AutoUnsafe","","Convert from T to *T.\nValue to thin pointer.",236,null],[3,"param_index","","",null,null],[12,"space","","",237,null],[12,"index","","",237,null],[4,"MethodOrigin","","",null,null],[13,"MethodStatic","","",25,null],[13,"MethodStaticClosure","","",25,null],[13,"MethodTypeParam","","",25,null],[13,"MethodTraitObject","","",25,null],[3,"MethodParam","","",null,null],[12,"trait_ref","","",238,null],[12,"method_num","","",238,null],[12,"impl_def_id","","The impl for the trait from which the method comes. This\nshould only be used for certain linting/heuristic purposes\nsince there is no guarantee that this is Some in every\nsituation that it could/should be.",238,null],[3,"MethodObject","","",null,null],[12,"trait_ref","","",239,null],[12,"object_trait_id","","",239,null],[12,"method_num","","",239,null],[12,"vtable_index","","",239,null],[3,"MethodCallee","","",null,null],[12,"origin","","",240,null],[12,"ty","","",240,null],[12,"substs","","",240,null],[3,"MethodCall","","With method calls, we store some extra information in\nside tables (i.e method_map). We use\nMethodCall as a key to index into these tables instead of\njust directly using the expression's NodeId. The reason\nfor this being that we may apply adjustments (coercions)\nwith the resulting expression also needing to use the\nside tables. The problem with this is that we don't\nassign a separate NodeId to this new expression\nand so it would clash with the base expression if both\nneeded to add to the side tables. Thus to disambiguate\nwe also keep track of whether there's an adjustment in\nour key.",null,null],[12,"expr_id","","",241,null],[12,"autoderef","","",241,null],[6,"MethodMap","","",null,null],[6,"vtable_param_res","","",null,null],[6,"vtable_res","","",null,null],[4,"vtable_origin","","",null,null],[13,"vtable_static","","",242,null],[13,"vtable_param","","",242,null],[13,"vtable_closure","","",242,null],[13,"vtable_error","","",242,null],[6,"ObjectCastMap","","",null,null],[3,"TransmuteRestriction","","A restriction that certain types must be the same size. The use of\n`transmute` gives rise to these restrictions. These generally\ncannot be checked until trans; therefore, each call to `transmute`\nwill push one or more such restriction into the\n`transmute_restrictions` vector during `intrinsicck`. They are\nthen checked during `trans` by the fn `check_intrinsics`.",null,null],[12,"span","","The span whence the restriction comes.",87,null],[12,"original_from","","The type being transmuted from.",87,null],[12,"original_to","","The type being transmuted to.",87,null],[12,"substituted_from","","The type being transmuted from, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",87,null],[12,"substituted_to","","The type being transmuted to, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",87,null],[12,"id","","NodeId of the transmute intrinsic.",87,null],[3,"CtxtArenas","","Internal storage",null,null],[3,"CommonTypes","","",null,null],[12,"bool","","",437,null],[12,"char","","",437,null],[12,"isize","","",437,null],[12,"i8","","",437,null],[12,"i16","","",437,null],[12,"i32","","",437,null],[12,"i64","","",437,null],[12,"usize","","",437,null],[12,"u8","","",437,null],[12,"u16","","",437,null],[12,"u32","","",437,null],[12,"u64","","",437,null],[12,"f32","","",437,null],[12,"f64","","",437,null],[12,"err","","",437,null],[3,"ctxt","","The data structure to keep track of all the information that typechecker\ngenerates so that so that it can be reused and doesn't have to be redone\nlater on.",null,null],[12,"types","","Common types, pre-interned for your convenience.",244,null],[12,"sess","","",244,null],[12,"def_map","","",244,null],[12,"named_region_map","","",244,null],[12,"region_maps","","",244,null],[12,"item_substs","","Stores the type parameters which were substituted to obtain the type\nof this node.  This only applies to nodes that refer to entities\nparameterized by type parameters, such as generic fns, types, or\nother items.",244,null],[12,"impl_or_trait_items","","Maps from a trait item to the trait item \"descriptor\"",244,null],[12,"trait_item_def_ids","","Maps from a trait def-id to a list of the def-ids of its trait items",244,null],[12,"trait_items_cache","","A cache for the trait_items() routine",244,null],[12,"impl_trait_cache","","",244,null],[12,"impl_trait_refs","","",244,null],[12,"trait_defs","","",244,null],[12,"predicates","","Maps from the def-id of an item (trait/struct/enum/fn) to its\nassociated predicates.",244,null],[12,"super_predicates","","Maps from the def-id of a trait to the list of\nsuper-predicates. This is a subset of the full list of\npredicates. We store these in a separate map because we must\nevaluate them even during type conversion, often before the\nfull predicates are available (note that supertraits have\nadditional acyclicity requirements).",244,null],[12,"object_cast_map","","Maps from node-id of a trait object cast (like `foo as\nBox<Trait>`) to the trait reference.",244,null],[12,"map","","",244,null],[12,"freevars","","",244,null],[12,"tcache","","",244,null],[12,"rcache","","",244,null],[12,"short_names_cache","","",244,null],[12,"tc_cache","","",244,null],[12,"ast_ty_to_ty_cache","","",244,null],[12,"enum_var_cache","","",244,null],[12,"ty_param_defs","","",244,null],[12,"adjustments","","",244,null],[12,"normalized_cache","","",244,null],[12,"lang_items","","",244,null],[12,"provided_method_sources","","A mapping of fake provided method def_ids to the default implementation",244,null],[12,"struct_fields","","",244,null],[12,"item_variance_map","","Maps from def-id of a type or region parameter to its\n(inferred) variance.",244,null],[12,"variance_computed","","True if the variance has been computed yet; false otherwise.",244,null],[12,"destructor_for_type","","A mapping from the def ID of an enum or struct type to the def ID\nof the method that implements its destructor. If the type is not\npresent in this map, it does not have a destructor. This map is\npopulated during the coherence phase of typechecking.",244,null],[12,"destructors","","A method will be in this list if and only if it is a destructor.",244,null],[12,"trait_impls","","Maps a trait onto a list of impls of that trait.",244,null],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls.\nContains implementations of methods that are inherent to a type.\nMethods in these implementations don't need to be exported.",244,null],[12,"impl_items","","Maps a DefId of an impl to a list of its items.\nNote that this contains all of the impls that we know about,\nincluding ones in other crates. It's not clear that this is the best\nway to do it.",244,null],[12,"used_unsafe","","Set of used unsafe nodes (functions or blocks). Unsafe nodes not\npresent in this set can be warned about.",244,null],[12,"used_mut_nodes","","Set of nodes which mark locals as mutable which end up getting used at\nsome point. Local variable definitions not in this set can be warned\nabout.",244,null],[12,"populated_external_types","","The set of external nominal types whose implementations have been read.\nThis is used for lazy resolution of methods.",244,null],[12,"populated_external_traits","","The set of external traits whose implementations have been read. This\nis used for lazy resolution of traits.",244,null],[12,"populated_external_primitive_impls","","The set of external primitive inherent implementations that have been read.",244,null],[12,"upvar_capture_map","","Borrows",244,null],[12,"extern_const_statics","","These two caches are used by const_eval when decoding external statics\nand variants that are found.",244,null],[12,"extern_const_variants","","",244,null],[12,"method_map","","",244,null],[12,"dependency_formats","","",244,null],[12,"closure_kinds","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",244,null],[12,"closure_tys","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",244,null],[12,"node_lint_levels","","",244,null],[12,"transmute_restrictions","","The types that must be asserted to be the same size for `transmute`\nto be valid. We gather up these restrictions in the intrinsicck pass\nand check them in trans.",244,null],[12,"stability","","Maps any item's def-id to its stability index.",244,null],[12,"associated_types","","Maps def IDs to true if and only if they're associated types.",244,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that do not have to do with the parameters in scope.",244,null],[12,"repr_hint_cache","","Caches the representation hints for struct definitions.",244,null],[12,"type_impls_copy_cache","","Caches whether types are known to impl Copy. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",244,null],[12,"type_impls_sized_cache","","Caches whether types are known to impl Sized. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",244,null],[12,"object_safety_cache","","Caches whether traits are object safe",244,null],[12,"const_qualif_map","","Maps Expr NodeId's to their constant qualification.",244,null],[3,"TypeFlags","","",null,null],[17,"NO_TYPE_FLAGS","","",null,null],[17,"HAS_PARAMS","","",null,null],[17,"HAS_SELF","","",null,null],[17,"HAS_TY_INFER","","",null,null],[17,"HAS_RE_INFER","","",null,null],[17,"HAS_RE_LATE_BOUND","","",null,null],[17,"HAS_REGIONS","","",null,null],[17,"HAS_TY_ERR","","",null,null],[17,"HAS_PROJECTION","","",null,null],[17,"NEEDS_SUBST","","",null,null],[3,"TyS","","",null,null],[12,"sty","","",246,null],[12,"flags","","",246,null],[6,"Ty","","",null,null],[3,"InternedTy","","An entry in the type interner.",null,null],[5,"type_has_params","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_self","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_ty_infer","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_needs_infer","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_projection","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_late_bound_regions","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_escaping_regions","","An \"escaping region\" is a bound region whose binder is not part of `t`.",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_escapes_depth","","",null,{"inputs":[{"name":"tys"},{"name":"u32"}],"output":{"name":"bool"}}],[3,"BareFnTy","","",null,null],[12,"unsafety","","",248,null],[12,"abi","","",248,null],[12,"sig","","",248,null],[3,"ClosureTy","","",null,null],[12,"unsafety","","",249,null],[12,"abi","","",249,null],[12,"sig","","",249,null],[4,"FnOutput","","",null,null],[13,"FnConverging","","",250,null],[13,"FnDiverging","","",250,null],[6,"PolyFnOutput","","",null,null],[3,"FnSig","","Signature of a function type, which I have arbitrarily\ndecided to use to refer to the input/output types.",null,null],[12,"inputs","","",251,null],[12,"output","","",251,null],[12,"variadic","","",251,null],[6,"PolyFnSig","","",null,null],[3,"ParamTy","","",null,null],[12,"space","","",252,null],[12,"idx","","",252,null],[12,"name","","",252,null],[3,"DebruijnIndex","","A [De Bruijn index][dbi] is a standard means of representing\nregions (and perhaps later types) in a higher-ranked setting. In\nparticular, imagine a type like this:",null,null],[12,"depth","","",253,null],[4,"Region","","Representation of regions:",null,null],[13,"ReEarlyBound","","",16,null],[13,"ReLateBound","","",16,null],[13,"ReFree","","When checking a function body, the types of all arguments and so forth\nthat refer to bound region parameters are modified to refer to free\nregion parameters.",16,null],[13,"ReScope","","A concrete region naming some statically determined extent\n(e.g. an expression or sequence of statements) within the\ncurrent function.",16,null],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",16,null],[13,"ReInfer","","A region variable.  Should not exist after typeck.",16,null],[13,"ReEmpty","","Empty lifetime is for data that is never accessed.\nBottom in the region lattice. We treat ReEmpty somewhat\nspecially; at least right now, we do not generate instances of\nit during the GLB computations, but rather\ngenerate an error instead. This is to improve error messages.\nThe only way to get an instance of ReEmpty is to have a region\nvariable with no constraints.",16,null],[3,"EarlyBoundRegion","","",null,null],[12,"param_id","","",254,null],[12,"space","","",254,null],[12,"index","","",254,null],[12,"name","","",254,null],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of\nthe original var id (that is, the root variable that is referenced\nby the upvar) and the id of the closure expression.",null,null],[12,"var_id","","",255,null],[12,"closure_expr_id","","",255,null],[4,"BorrowKind","","",null,null],[13,"ImmBorrow","","Data must be immutable and is aliasable.",256,null],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow\ncannot currently be expressed by the user and is used only in\nimplicit closure bindings. It is needed when you the closure\nis borrowing or mutating a mutable referent, e.g.:",256,null],[13,"MutBorrow","","Data is mutable and not aliasable.",256,null],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed\nduring `typeck`, specifically by `regionck`.",null,null],[13,"ByValue","","Upvar is captured by value. This is always true when the\nclosure is labeled `move`, but can also be true in other cases\ndepending on inference.",24,null],[13,"ByRef","","Upvar is captured by reference.",24,null],[3,"UpvarBorrow","","",null,null],[12,"kind","","The kind of borrow: by-ref upvars have access to shared\nimmutable borrows, which are not part of the normal language\nsyntax.",23,null],[12,"region","","Region of the resulting reference.",23,null],[6,"UpvarCaptureMap","","",null,null],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region\nat least as big as the scope `fr.scope`\".",null,null],[12,"scope","","",17,null],[12,"bound_region","","",17,null],[4,"BoundRegion","","",null,null],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",20,null],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",20,null],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",20,null],[13,"BrEnv","","",20,null],[4,"sty","","",null,null],[13,"ty_bool","","",257,null],[13,"ty_char","","",257,null],[13,"ty_int","","",257,null],[13,"ty_uint","","",257,null],[13,"ty_float","","",257,null],[13,"ty_enum","","Substs here, possibly against intuition, *may* contain `ty_param`s.\nThat is, even after substitution it is possible that there are type\nvariables. This happens when the `ty_enum` corresponds to an enum\ndefinition and not a concrete use of it. To get the correct `ty_enum`\nfrom the tcx, use the `NodeId` from the `ast::Ty` and look it up in\nthe `ast_ty_to_ty_cache`. This is probably true for `ty_struct` as\nwell.",257,null],[13,"ty_uniq","","",257,null],[13,"ty_str","","",257,null],[13,"ty_vec","","",257,null],[13,"ty_ptr","","",257,null],[13,"ty_rptr","","",257,null],[13,"ty_bare_fn","","",257,null],[13,"ty_trait","","",257,null],[13,"ty_struct","","",257,null],[13,"ty_closure","","",257,null],[13,"ty_tup","","",257,null],[13,"ty_projection","","",257,null],[13,"ty_param","","",257,null],[13,"ty_infer","","",257,null],[13,"ty_err","","",257,null],[3,"TyTrait","","",null,null],[12,"principal","","",258,null],[12,"bounds","","",258,null],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax,\nbut perhaps the most recognizable form is in a where clause:",null,null],[12,"def_id","","",259,null],[12,"substs","","",259,null],[6,"PolyTraitRef","","",null,null],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the\ncompiler's representation for things like `for<'a> Fn(&'a isize)`\n(which would be represented by the type `PolyTraitRef ==\nBinder<TraitRef>`). Note that when we skolemize, instantiate,\nerase, or otherwise \"discharge\" these bound regions, we change the\ntype from `Binder<T>` to just `T` (see\ne.g. `liberate_late_bound_regions`).",null,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",125,null],[13,"UintType","","",125,null],[4,"terr_vstore_kind","","",null,null],[13,"terr_vec","","",260,null],[13,"terr_str","","",260,null],[13,"terr_fn","","",260,null],[13,"terr_trait","","",260,null],[3,"expected_found","","",null,null],[12,"expected","","",261,null],[12,"found","","",261,null],[4,"type_err","","",null,null],[13,"terr_mismatch","","",262,null],[13,"terr_unsafety_mismatch","","",262,null],[13,"terr_abi_mismatch","","",262,null],[13,"terr_mutability","","",262,null],[13,"terr_box_mutability","","",262,null],[13,"terr_ptr_mutability","","",262,null],[13,"terr_ref_mutability","","",262,null],[13,"terr_vec_mutability","","",262,null],[13,"terr_tuple_size","","",262,null],[13,"terr_fixed_array_size","","",262,null],[13,"terr_ty_param_size","","",262,null],[13,"terr_arg_count","","",262,null],[13,"terr_regions_does_not_outlive","","",262,null],[13,"terr_regions_not_same","","",262,null],[13,"terr_regions_no_overlap","","",262,null],[13,"terr_regions_insufficiently_polymorphic","","",262,null],[13,"terr_regions_overly_polymorphic","","",262,null],[13,"terr_sorts","","",262,null],[13,"terr_integer_as_char","","",262,null],[13,"terr_int_mismatch","","",262,null],[13,"terr_float_mismatch","","",262,null],[13,"terr_traits","","",262,null],[13,"terr_builtin_bounds","","",262,null],[13,"terr_variadic_mismatch","","",262,null],[13,"terr_cyclic_ty","","",262,null],[13,"terr_convergence_mismatch","","",262,null],[13,"terr_projection_name_mismatched","","",262,null],[13,"terr_projection_bounds_length","","",262,null],[3,"ParamBounds","","Bounds suitable for a named type parameter like `A` in `fn foo<A>`\nas well as the existential type parameter in an object type.",null,null],[12,"region_bounds","","",263,null],[12,"builtin_bounds","","",263,null],[12,"trait_bounds","","",263,null],[12,"projection_bounds","","",263,null],[3,"ExistentialBounds","","Bounds suitable for an existentially quantified type parameter\nsuch as those that appear in object types or closure types. The\nmajor difference between this case and `ParamBounds` is that\ngeneral purpose trait bounds are omitted and there must be\n*exactly one* region.",null,null],[12,"region_bound","","",264,null],[12,"builtin_bounds","","",264,null],[12,"projection_bounds","","",264,null],[6,"BuiltinBounds","","",null,null],[4,"BuiltinBound","","",null,null],[13,"BoundSend","","",265,null],[13,"BoundSized","","",265,null],[13,"BoundCopy","","",265,null],[13,"BoundSync","","",265,null],[5,"empty_builtin_bounds","","",null,{"inputs":[],"output":{"name":"enumset"}}],[5,"all_builtin_bounds","","",null,{"inputs":[],"output":{"name":"enumset"}}],[5,"region_existential_bound","","An existential bound that does not implement any traits.",null,{"inputs":[{"name":"region"}],"output":{"name":"existentialbounds"}}],[3,"TyVid","","",null,null],[12,"index","","",266,null],[3,"IntVid","","",null,null],[12,"index","","",124,null],[3,"FloatVid","","",null,null],[12,"index","","",126,null],[3,"RegionVid","","",null,null],[12,"index","","",267,null],[4,"InferTy","","",null,null],[13,"TyVar","","",268,null],[13,"IntVar","","",268,null],[13,"FloatVar","","",268,null],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an\nunbound type variable. This is convenient for caching etc. See\n`middle::infer::freshen` for more details.",268,null],[13,"FreshIntTy","","",268,null],[4,"UnconstrainedNumeric","","",null,null],[13,"UnconstrainedFloat","","",269,null],[13,"UnconstrainedInt","","",269,null],[13,"Neither","","",269,null],[4,"InferRegion","","",null,null],[13,"ReVar","","",270,null],[13,"ReSkolemized","","",270,null],[4,"ObjectLifetimeDefault","","Default region to use for the bound of objects that are\nsupplied as the value for this type parameter. This is derived\nfrom `T:'a` annotations appearing in the type definition.  If\nthis is `None`, then the default is inherited from the\nsurrounding context. See RFC #599 for details.",null,null],[13,"Ambiguous","","Require an explicit annotation. Occurs when multiple\n`T:'a` constraints are found.",271,null],[13,"Specific","","Use the given region as the default.",271,null],[3,"TypeParameterDef","","",null,null],[12,"name","","",272,null],[12,"def_id","","",272,null],[12,"space","","",272,null],[12,"index","","",272,null],[12,"default","","",272,null],[12,"object_lifetime_default","","",272,null],[3,"RegionParameterDef","","",null,null],[12,"name","","",273,null],[12,"def_id","","",273,null],[12,"space","","",273,null],[12,"index","","",273,null],[12,"bounds","","",273,null],[3,"Generics","","Information about the formal type/lifetime parameters associated\nwith an item or method. Analogous to ast::Generics.",null,null],[12,"types","","",274,null],[12,"regions","","",274,null],[3,"GenericPredicates","","Bounds on generics.",null,null],[12,"predicates","","",275,null],[4,"Predicate","","",null,null],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be\nthe `Self` type of the trait reference and `A`, `B`, and `C`\nwould be the parameters in the `TypeSpace`.",276,null],[13,"Equate","","where `T1 == T2`.",276,null],[13,"RegionOutlives","","where 'a : 'b",276,null],[13,"TypeOutlives","","where T : 'a",276,null],[13,"Projection","","where <T as TraitRef>::Name == X, approximately.\nSee `ProjectionPredicate` struct for details.",276,null],[3,"TraitPredicate","","",null,null],[12,"trait_ref","","",277,null],[6,"PolyTraitPredicate","","",null,null],[3,"EquatePredicate","","",null,null],[6,"PolyEquatePredicate","","",null,null],[3,"OutlivesPredicate","","",null,null],[6,"PolyOutlivesPredicate","","",null,null],[6,"PolyRegionOutlivesPredicate","","",null,null],[6,"PolyTypeOutlivesPredicate","","",null,null],[3,"ProjectionPredicate","","This kind of predicate has no *direct* correspondent in the\nsyntax, but it roughly corresponds to the syntactic forms:",null,null],[12,"projection_ty","","",280,null],[12,"ty","","",280,null],[6,"PolyProjectionPredicate","","",null,null],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS\nform this would be written `<T as Trait<..>>::N`.",null,null],[12,"trait_ref","","The trait reference `T as Trait<..>`.",281,null],[12,"item_name","","The name `N` of the associated type.",281,null],[8,"ToPolyTraitRef","","",null,null],[10,"to_poly_trait_ref","","",438,{"inputs":[{"name":"topolytraitref"}],"output":{"name":"binder"}}],[8,"AsPredicate","","",null,null],[10,"as_predicate","","",439,{"inputs":[{"name":"aspredicate"}],"output":{"name":"predicate"}}],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type\nparameters.  Should eventually be generalized into a flag list of\nwhere clauses.  You can obtain a `InstantiatedPredicates` list from a\n`GenericPredicates` by using the `instantiate` method. Note that this method\nreflects an important semantic invariant of `InstantiatedPredicates`: while\nthe `GenericPredicates` are expressed in terms of the bound type\nparameters of the impl/trait/whatever, an `InstantiatedPredicates` instance\nrepresented a set of bounds for some particular instantiation,\nmeaning that the generic parameters have been substituted with\ntheir values.",null,null],[12,"predicates","","",282,null],[3,"ParameterEnvironment","","When type checking, we use the `ParameterEnvironment` to track\ndetails about the type/lifetime parameters that are in scope.\nIt primarily stores the bounds information.",null,null],[12,"tcx","","",283,null],[12,"free_substs","","See `construct_free_substs` for details.",283,null],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that\nindicates it must outlive at least the function body (the user\nmay specify stronger requirements). This field indicates the\nregion of the callee.",283,null],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically\nthe set of bounds on the in-scope type parameters, translated\ninto Obligations.",283,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that have to do with the parameters in scope.",283,null],[3,"TypeScheme","","A \"type scheme\", in ML terminology, is a type combined with some\nset of generic types that the type is, well, generic over. In Rust\nterms, it is the \"type\" of a fn item or struct -- this type will\ninclude various generic parameters that must be substituted when\nthe item/struct is referenced. That is called converting the type\nscheme to a monotype.",null,null],[12,"generics","","",284,null],[12,"ty","","",284,null],[3,"TraitDef","","As `TypeScheme` but for a trait ref.",null,null],[12,"unsafety","","",363,null],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]`\nattribute, indicating that it should be used with `Foo()`\nsugar. This is a temporary thing -- eventually any trait wil\nbe usable with the sugar (or without it).",363,null],[12,"generics","","Generic type definitions. Note that `Self` is listed in here\nas having a single bound, the trait itself (e.g., in the trait\n`Eq`, there is a single bound `Self : Eq`). This is so that\ndefault methods get to assume that the `Self` parameters\nimplements the trait.",363,null],[12,"trait_ref","","",363,null],[12,"associated_type_names","","A list of the associated types defined in this trait. Useful\nfor resolving `X::Foo` type markers.",363,null],[3,"ItemSubsts","","Records the substitutions used to translate the polytype for an\nitem into the monotype of an item reference.",null,null],[12,"substs","","",285,null],[4,"ClosureKind","","",null,null],[13,"FnClosureKind","","",165,null],[13,"FnMutClosureKind","","",165,null],[13,"FnOnceClosureKind","","",165,null],[8,"ClosureTyper","","",null,null],[11,"tcx","","",440,{"inputs":[{"name":"closuretyper"}],"output":{"name":"ctxt"}}],[10,"param_env","","",440,{"inputs":[{"name":"closuretyper"}],"output":{"name":"parameterenvironment"}}],[10,"closure_kind","","Is this a `Fn`, `FnMut` or `FnOnce` closure? During typeck,\nreturns `None` if the kind of this closure has not yet been\ninferred.",440,{"inputs":[{"name":"closuretyper"},{"name":"defid"}],"output":{"name":"option"}}],[10,"closure_type","","Returns the argument/return types of this closure.",440,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[10,"closure_upvars","","Returns the set of all upvars and their transformed\ntypes. During typeck, maybe return `None` if the upvar types\nhave not yet been inferred.",440,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"mk_ctxt","","",null,{"inputs":[{"name":"session"},{"name":"ctxtarenas"},{"name":"refcell"},{"name":"hashmap"},{"name":"map"},{"name":"refcell"},{"name":"regionmaps"},{"name":"languageitems"},{"name":"index"}],"output":{"name":"ctxt"}}],[5,"mk_t","","",null,{"inputs":[{"name":"ctxt"},{"name":"sty"}],"output":{"name":"tys"}}],[5,"mk_mach_int","","",null,{"inputs":[{"name":"ctxt"},{"name":"intty"}],"output":{"name":"tys"}}],[5,"mk_mach_uint","","",null,{"inputs":[{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"tys"}}],[5,"mk_mach_float","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatty"}],"output":{"name":"tys"}}],[5,"mk_str","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_str_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mutability"}],"output":{"name":"tys"}}],[5,"mk_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_uniq","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_mut_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_imm_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_mut_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_imm_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_nil_ptr","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_vec","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"option"}],"output":{"name":"tys"}}],[5,"mk_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_tup","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"tys"}}],[5,"mk_nil","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_bool","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_bare_fn","","",null,{"inputs":[{"name":"ctxt"},{"name":"option"},{"name":"barefnty"}],"output":{"name":"tys"}}],[5,"mk_ctor_fn","","",null,null],[5,"mk_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"existentialbounds"}],"output":{"name":"tys"}}],[5,"sort_bounds_list","","",null,null],[5,"mk_projection","","",null,{"inputs":[{"name":"ctxt"},{"name":"rc"},{"name":"name"}],"output":{"name":"tys"}}],[5,"mk_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_closure","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"tyvid"}],"output":{"name":"tys"}}],[5,"mk_int_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"intvid"}],"output":{"name":"tys"}}],[5,"mk_float_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatvid"}],"output":{"name":"tys"}}],[5,"mk_infer","","",null,{"inputs":[{"name":"ctxt"},{"name":"inferty"}],"output":{"name":"tys"}}],[5,"mk_param","","",null,{"inputs":[{"name":"ctxt"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"tys"}}],[5,"mk_self_type","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_param_from_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[5,"walk_ty","","",null,null],[5,"maybe_walk_ty","","Walks `ty` and any types appearing within `ty`, invoking the\ncallback `f` on each type. If the callback returns false, then the\nchildren of the current type are ignored.",null,null],[5,"fold_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"f"}],"output":{"name":"tys"}}],[5,"type_is_nil","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_error","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_needs_subst","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"trait_ref_contains_error","","",null,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[5,"type_is_ty_var","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bool","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_self","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_vec","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_structural","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_simd","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"sequence_element_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"simd_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"simd_size","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"usize"}}],[5,"type_is_region_ptr","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_unsafe_ptr","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_unique","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_scalar","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_floating_point","","Returns true if this type is a floating point type and false otherwise.",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[3,"TypeContents","","Type contents is how the type checker reasons about kinds.\nThey track what kinds of things are found within a type.  You can\nthink of them as kind of an \"anti-kind\".  They track the kinds of values\nand thinks that are contained in types.  Having a larger contents for\na type tends to rule that type *out* from various kinds.  For example,\na type that contains a reference is not sendable.",null,null],[12,"bits","","",286,null],[5,"type_interior_is_unsafe","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_contents","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"typecontents"}}],[5,"type_moves_by_default","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_sized","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"is_ffi_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"is_instantiable","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[4,"Representability","","Describes whether a type is representable. For types that are not\nrepresentable, 'SelfRecursive' and 'ContainsRecursive' are used to\ndistinguish between types that are recursive with themselves and types that\ncontain a different recursive type. These cases can therefore be treated\ndifferently when reporting errors.",null,null],[13,"Representable","","",287,null],[13,"ContainsRecursive","","",287,null],[13,"SelfRecursive","","",287,null],[5,"is_type_representable","","Check whether a type is representable. This means it cannot contain unboxed\nstructural recursion. This check is needed for structs and enums.",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"tys"}],"output":{"name":"representability"}}],[5,"type_is_trait","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_trait_info","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[5,"type_is_integral","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_fresh","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_uint","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_char","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn_item","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_fp","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_numeric","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_signed","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_machine","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_c_like_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"deref","","",null,{"inputs":[{"name":"tys"},{"name":"bool"}],"output":{"name":"option"}}],[5,"type_content","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"tys"}}],[5,"index","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[5,"array_element_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"option"}}],[5,"positional_element_ty","","Returns the type of element at index `i` in tuple or tuple-like type `t`.\nFor an enum `t`, `variant` is None only if `t` is a univariant enum.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"usize"},{"name":"option"}],"output":{"name":"option"}}],[5,"named_element_ty","","Returns the type of element at field `n` in struct or struct-like type `t`.\nFor an enum `t`, `variant` must be some def id.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"name"},{"name":"option"}],"output":{"name":"option"}}],[5,"impl_id_to_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"rc"}}],[5,"node_id_to_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"tys"}}],[5,"node_id_to_type_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"option"}}],[5,"node_id_item_substs","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"itemsubsts"}}],[5,"fn_is_variadic","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"ty_fn_sig","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"ty_fn_abi","","Returns the ABI of the given function.",null,{"inputs":[{"name":"tys"}],"output":{"name":"abi"}}],[5,"ty_fn_args","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"ty_fn_ret","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"is_fn_ty","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"ty_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"tys"}],"output":{"name":"region"}}],[5,"free_region_from_def","","",null,{"inputs":[{"name":"destructionscopedata"},{"name":"regionparameterdef"}],"output":{"name":"region"}}],[5,"pat_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"tys"}}],[5,"pat_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"option"}}],[5,"expr_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"tys"}}],[5,"expr_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"option"}}],[5,"expr_ty_adjusted","","Returns the type of `expr`, considering any `AutoAdjustment`\nentry recorded for that expression.",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"tys"}}],[5,"expr_span","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"span"}}],[5,"local_var_name_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"internedstring"}}],[5,"adjust_ty","","See `expr_ty_adjusted`",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"u32"},{"name":"tys"},{"name":"option"},{"name":"f"}],"output":{"name":"tys"}}],[5,"adjust_ty_for_autoref","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"option"}],"output":{"name":"tys"}}],[5,"resolve_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"def"}}],[5,"expr_is_lval","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"bool"}}],[4,"ExprKind","","We categorize expressions into three kinds.  The distinction between\nlvalue/rvalue is fundamental to the language.  The distinction between the\ntwo kinds of rvalues is an artifact of trans which reflects how we will\ngenerate code for that kind of expression.  See trans/expr.rs for more\ninformation.",null,null],[13,"LvalueExpr","","",288,null],[13,"RvalueDpsExpr","","",288,null],[13,"RvalueDatumExpr","","",288,null],[13,"RvalueStmtExpr","","",288,null],[5,"expr_kind","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"exprkind"}}],[5,"stmt_node_id","","",null,{"inputs":[{"name":"spanned"}],"output":{"name":"u32"}}],[5,"field_idx_strict","","",null,null],[5,"impl_or_trait_item_idx","","",null,null],[5,"ty_sort_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"type_err_to_str","","Explains the source of a type err in a short, human readable way. This is meant to be placed\nin parentheses after some larger message. You should also invoke `note_and_explain_type_err()`\nafterwards to present additional details, particularly when it comes to lifetime-related\nerrors.",null,{"inputs":[{"name":"ctxt"},{"name":"type_err"}],"output":{"name":"string"}}],[5,"note_and_explain_type_err","","",null,null],[5,"provided_source","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"usize"}],"output":{"name":"implortraititem"}}],[5,"trait_items","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"is_associated_type","","Returns true if the given ID refers to an associated type and false if it\nrefers to anything else.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"associated_type_parameter_index","","Returns the parameter index that the given associated type corresponds to.",null,{"inputs":[{"name":"ctxt"},{"name":"traitdef"},{"name":"defid"}],"output":{"name":"usize"}}],[5,"trait_item_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"impl_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_ref_to_def_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"}],"output":{"name":"defid"}}],[5,"try_add_builtin_trait","","Checks whether `trait_ref` refers to one of the builtin\ntraits, like `Send`, and adds the corresponding\nbound to the set `builtin_bounds` if so. Returns true if `trait_ref`\nis a builtin trait.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"enumset"}],"output":{"name":"bool"}}],[5,"ty_to_def_id","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[3,"VariantInfo","","",null,null],[12,"args","","",289,null],[12,"arg_names","","",289,null],[12,"ctor_ty","","",289,null],[12,"name","","",289,null],[12,"id","","",289,null],[12,"disr_val","","",289,null],[12,"vis","","",289,null],[5,"substd_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"item_path_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"string"}}],[4,"DtorKind","","",null,null],[13,"NoDtor","","",290,null],[13,"TraitDtor","","",290,null],[5,"ty_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"dtorkind"}}],[5,"has_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"with_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"f"}],"output":{"name":"t"}}],[5,"enum_is_univariant","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"type_is_empty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"enum_repr_type","","Returns `(normalized_type, ty)`, where `normalized_type` is the\nIntType representation of one of {i64,i32,i16,i8,u64,u32,u16,u8},\nand `ty` is the original type (i.e. may include `isize` or\n`usize`).",null,null],[5,"enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"enum_variant_with_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_item_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"lookup_trait_def","","Given the did of a trait, returns its canonical trait ref.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_predicates","","Given the did of an item, returns its full set of predicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"lookup_super_predicates","","Given the did of a trait, returns its superpredicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"parambounds"}],"output":{"name":"vec"}}],[5,"get_attrs","","Get the attributes of a definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"cow"}}],[5,"has_attr","","Determine whether an item is annotated with an attribute",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"str"}],"output":{"name":"bool"}}],[5,"lookup_packed","","Determine whether an item is annotated with `#[repr(packed)]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_simd","","Determine whether an item is annotated with `#[simd]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_repr_hints","","Obtain the representation annotation for a struct definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"lookup_struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_tuple_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"tup_fields","","",null,null],[5,"struct_tail","","Returns the deeply last field of nested structures, or the same type,\nif not a structure at all. Corresponds to the only possible unsized\nfield, and its type can be used to determine unsizing strategy.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only\nkeeps going as long as the two types are instances of the same\nstructure definitions.\nFor `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`,\nwhereas struct_tail produces `T`, and `Trait`, respectively.",null,null],[3,"ClosureUpvar","","",null,null],[12,"def","","",292,null],[12,"span","","",292,null],[12,"ty","","",292,null],[5,"closure_upvars","","",null,{"inputs":[{"name":"typer"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"eval_repeat_count","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"usize"}}],[5,"each_bound_trait_and_supertraits","","",null,null],[5,"required_region_bounds","","Given a set of predicates that apply to an object type, returns\nthe region bounds that the (erased) `Self` type must\noutlive. Precisely *because* the `Self` type is erased, the\nparameter `erased_self_ty` must be supplied to indicate what type\nhas been used to represent `Self` in the predicates\nthemselves. This should really be a unique type; `FreshTy(0)` is a\npopular choice.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"vec"}],"output":{"name":"vec"}}],[5,"item_variances","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_has_default_impl","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"record_trait_has_default_impl","","Records a trait-to-implementation mapping.",null,null],[5,"record_trait_implementation","","Records a trait-to-implementation mapping.",null,null],[5,"populate_implementations_for_primitive_if_necessary","","Load primitive inherent implementations if necessary",null,null],[5,"populate_implementations_for_type_if_necessary","","Populates the type context with all the implementations for the given type\nif necessary.",null,null],[5,"populate_implementations_for_trait_if_necessary","","Populates the type context with all the implementations for the given\ntrait if necessary.",null,null],[5,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements.\nIf it implements no trait, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the\nID of the impl that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), return the ID of\nthe trait that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_item_of_item","","If the given def ID describes an item belonging to a trait, (either a\ndefault method or an implementation of a trait method), return the ID of\nthe method inside trait definition (this means that if the given def ID\nis already that of the original trait method, then the return value is\nthe same).\nOtherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"hash_crate_independent","","Creates a hash of the type `Ty` which will be the same no matter what crate\ncontext it's calculated within. This is used by the `type_id` intrinsic.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"svh"}],"output":{"name":"u64"}}],[5,"empty_parameter_environment","","Construct a parameter environment suitable for static contexts or other contexts where there\nare no free type/lifetime parameters in scope.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"parameterenvironment"}}],[5,"construct_free_substs","","Constructs and returns a substitution that can be applied to move from\nthe \"outer\" view of a type or method to the \"inner\" view.\nIn general, this means converting from bound parameters to\nfree parameters. Since we currently represent bound/free type\nparameters in the same way, this only has an effect on regions.",null,{"inputs":[{"name":"ctxt"},{"name":"generics"},{"name":"u32"}],"output":{"name":"substs"}}],[5,"construct_parameter_environment","","See `ParameterEnvironment` struct def'n for details",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"generics"},{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[4,"ExplicitSelfCategory","","The category of explicit self.",null,null],[13,"StaticExplicitSelfCategory","","",293,null],[13,"ByValueExplicitSelfCategory","","",293,null],[13,"ByReferenceExplicitSelfCategory","","",293,null],[13,"ByBoxExplicitSelfCategory","","",293,null],[5,"accumulate_lifetimes_in_type","","Pushes all the lifetimes in the given type onto the given list. A\n\"lifetime in a type\" is a lifetime specified by a reference or a lifetime\nin a list of type substitutions. This does *not* traverse into nominal\ntypes, nor does it resolve fictitious types.",null,null],[3,"Freevar","","A free variable referred to in a function.",null,null],[12,"def","","The variable being accessed free.",22,null],[12,"span","","",22,null],[6,"FreevarMap","","",null,null],[6,"CaptureModeMap","","",null,null],[6,"TraitMap","","",null,null],[6,"GlobMap","","",null,null],[5,"with_freevars","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"f"}],"output":{"name":"t"}}],[5,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to scope-id\n`scope_id`.",null,{"inputs":[{"name":"ctxt"},{"name":"destructionscopedata"},{"name":"binder"}],"output":{"name":"t"}}],[5,"count_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"usize"}}],[5,"binds_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"bool"}}],[5,"flatten_late_bound_regions","","Flattens two binding levels into one. So `for<'a> for<'b> Foo`\nbecomes `for<'a,'b> Foo`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"no_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"option"}}],[5,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'static`. Useful in trans but also\nmethod lookup and a few other places where precise region relationships are not required.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"t"}}],[5,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are\nassigned starting at 1 and increasing monotonically in the order traversed\nby the fold operation.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"replace_late_bound_regions","","Replaces the late-bound-regions in `value` that are bound by `value`.",null,null],[5,"make_substs_for_receiver_types","","Substitutes the values for the receiver's type parameters\nthat are found in method, leaving the method's type parameters\nintact.",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"},{"name":"method"}],"output":{"name":"substs"}}],[4,"CopyImplementationError","","",null,null],[13,"FieldDoesNotImplementCopy","","",294,null],[13,"VariantDoesNotImplementCopy","","",294,null],[13,"TypeIsStructural","","",294,null],[13,"TypeHasDestructor","","",294,null],[5,"can_type_implement_copy","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"result"}}],[8,"RegionEscape","","",null,null],[11,"has_escaping_regions","","",441,{"inputs":[{"name":"regionescape"}],"output":{"name":"bool"}}],[10,"has_regions_escaping_depth","","",441,{"inputs":[{"name":"regionescape"},{"name":"u32"}],"output":{"name":"bool"}}],[8,"HasProjectionTypes","","",null,null],[10,"has_projection_types","","",442,{"inputs":[{"name":"hasprojectiontypes"}],"output":{"name":"bool"}}],[8,"ReferencesError","","",null,null],[10,"references_error","","",443,{"inputs":[{"name":"referenceserror"}],"output":{"name":"bool"}}],[0,"ty_fold","rustc_typeck::middle","Generalized type folding mechanism. The setup is a bit convoluted\nbut allows for convenient usage. Let T be an instance of some\n\"foldable type\" (one which implements `TypeFoldable`) and F be an\ninstance of a \"folder\" (a type which implements `TypeFolder`). Then\nthe setup is intended to be:",null,null],[8,"TypeFoldable","rustc_typeck::middle::ty_fold","The TypeFoldable trait is implemented for every type that can be folded.\nBasically, every type that has a corresponding method in TypeFolder.",null,null],[10,"fold_with","","",444,{"inputs":[{"name":"typefoldable"},{"name":"f"}],"output":{"name":"self"}}],[8,"TypeFolder","","The TypeFolder trait defines the actual *folding*. There is a\nmethod defined for every foldable type. Each of these has a\ndefault implementation that does an \"identity\" fold. Within each\nidentity fold, it should invoke `foo.fold_with(self)` to fold each\nsub-item.",null,null],[10,"tcx","","",445,{"inputs":[{"name":"typefolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","Invoked by the `super_*` routines when we enter a region\nbinding level (for example, when entering a function\nsignature). This is used by clients that want to track the\nDebruijn index nesting level.",445,null],[11,"exit_region_binder","","Invoked by the `super_*` routines when we exit a region\nbinding level. This is used by clients that want to\ntrack the Debruijn index nesting level.",445,null],[11,"fold_binder","","",445,{"inputs":[{"name":"typefolder"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_ty","","",445,{"inputs":[{"name":"typefolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_mt","","",445,{"inputs":[{"name":"typefolder"},{"name":"mt"}],"output":{"name":"mt"}}],[11,"fold_trait_ref","","",445,{"inputs":[{"name":"typefolder"},{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fold_substs","","",445,{"inputs":[{"name":"typefolder"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"fold_fn_sig","","",445,{"inputs":[{"name":"typefolder"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"fold_output","","",445,{"inputs":[{"name":"typefolder"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"fold_bare_fn_ty","","",445,{"inputs":[{"name":"typefolder"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fold_closure_ty","","",445,{"inputs":[{"name":"typefolder"},{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fold_region","","",445,{"inputs":[{"name":"typefolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_existential_bounds","","",445,{"inputs":[{"name":"typefolder"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"fold_autoref","","",445,{"inputs":[{"name":"typefolder"},{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fold_item_substs","","",445,{"inputs":[{"name":"typefolder"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[5,"super_fold_binder","","",null,{"inputs":[{"name":"t"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"super_fold_ty","","",null,{"inputs":[{"name":"t"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"super_fold_substs","","",null,{"inputs":[{"name":"t"},{"name":"substs"}],"output":{"name":"substs"}}],[5,"super_fold_fn_sig","","",null,{"inputs":[{"name":"t"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[5,"super_fold_output","","",null,{"inputs":[{"name":"t"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[5,"super_fold_bare_fn_ty","","",null,{"inputs":[{"name":"t"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[5,"super_fold_closure_ty","","",null,{"inputs":[{"name":"t"},{"name":"closurety"}],"output":{"name":"closurety"}}],[5,"super_fold_trait_ref","","",null,{"inputs":[{"name":"t"},{"name":"traitref"}],"output":{"name":"traitref"}}],[5,"super_fold_mt","","",null,{"inputs":[{"name":"t"},{"name":"mt"}],"output":{"name":"mt"}}],[5,"super_fold_existential_bounds","","",null,{"inputs":[{"name":"t"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[5,"super_fold_autoref","","",null,{"inputs":[{"name":"t"},{"name":"autoref"}],"output":{"name":"autoref"}}],[5,"super_fold_item_substs","","",null,{"inputs":[{"name":"t"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[3,"BottomUpFolder","","",null,null],[12,"tcx","","",301,null],[12,"fldop","","",301,null],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component\ntypes and all regions that occur *free* within it.",null,null],[5,"collect_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"vec"}}],[5,"fold_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"},{"name":"f"}],"output":{"name":"t"}}],[3,"RegionEraser","","",null,null],[5,"erase_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"t"}}],[5,"shift_region","","",null,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"region"}}],[5,"shift_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"t"}],"output":{"name":"t"}}],[0,"ty_match","rustc_typeck::middle","",null,null],[3,"Match","rustc_typeck::middle::ty_match","A type \"A\" *matches* \"B\" if the fresh types in B could be\nsubstituted with values so as to make it equal to A. Matching is\nintended to be used only on freshened types, and it basically\nindicates if the non-freshened versions of A and B could have been\nunified.",null,null],[0,"ty_relate","rustc_typeck::middle","Generalized type relating mechanism. A type relation R relates a\npair of values (A, B). A and B are usually types or regions but\ncan be other things. Examples of type relations are subtyping,\ntype equality, etc.",null,null],[6,"RelateResult","rustc_typeck::middle::ty_relate","",null,null],[8,"TypeRelation","","",null,null],[10,"tcx","","",446,{"inputs":[{"name":"typerelation"}],"output":{"name":"ctxt"}}],[10,"tag","","Returns a static string we can use for printouts.",446,{"inputs":[{"name":"typerelation"}],"output":{"name":"str"}}],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the\nrelation. Just affects error messages.",446,{"inputs":[{"name":"typerelation"}],"output":{"name":"bool"}}],[11,"relate","","Generic relation routine suitable for most anything.",446,{"inputs":[{"name":"typerelation"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",446,{"inputs":[{"name":"typerelation"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[10,"tys","","",446,{"inputs":[{"name":"typerelation"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[10,"regions","","",446,{"inputs":[{"name":"typerelation"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[10,"binders","","",446,{"inputs":[{"name":"typerelation"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[8,"Relate","","",null,null],[10,"relate","","",447,{"inputs":[{"name":"relate"},{"name":"r"},{"name":"self"},{"name":"self"}],"output":{"name":"result"}}],[5,"super_relate_tys","","The main \"type relation\" routine. Note that this does not handle\ninference artifacts, so you should filter those out before calling\nit.",null,{"inputs":[{"name":"r"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"expected_found","","",null,{"inputs":[{"name":"r"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[5,"expected_found_bool","","",null,{"inputs":[{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[0,"ty_walk","rustc_typeck::middle","An iterator over the type substructure.",null,null],[3,"TypeWalker","rustc_typeck::middle::ty_walk","",null,null],[5,"walk_shallow","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[0,"weak_lang_items","rustc_typeck::middle","Validity checking for weak lang items",null,null],[5,"check_crate","rustc_typeck::middle::weak_lang_items","Checks the crate for usage of weak lang items, returning a vector of all the\nlanguage items required by this crate, but not defined yet.",null,null],[5,"link_name","","",null,null],[0,"session","rustc_typeck","",null,null],[0,"config","rustc_typeck::session","Contains infrastructure for configuring the compiler, including parsing\ncommand line options.",null,null],[3,"Config","rustc_typeck::session::config","",null,null],[12,"target","","",448,null],[12,"int_type","","",448,null],[12,"uint_type","","",448,null],[4,"OptLevel","","",null,null],[13,"No","","",330,null],[13,"Less","","",330,null],[13,"Default","","",330,null],[13,"Aggressive","","",330,null],[4,"DebugInfoLevel","","",null,null],[13,"NoDebugInfo","","",331,null],[13,"LimitedDebugInfo","","",331,null],[13,"FullDebugInfo","","",331,null],[4,"OutputType","","",null,null],[13,"OutputTypeBitcode","","",332,null],[13,"OutputTypeAssembly","","",332,null],[13,"OutputTypeLlvmAssembly","","",332,null],[13,"OutputTypeObject","","",332,null],[13,"OutputTypeExe","","",332,null],[13,"OutputTypeDepInfo","","",332,null],[3,"Options","","",null,null],[12,"crate_types","","",333,null],[12,"gc","","",333,null],[12,"optimize","","",333,null],[12,"debug_assertions","","",333,null],[12,"debuginfo","","",333,null],[12,"lint_opts","","",333,null],[12,"describe_lints","","",333,null],[12,"output_types","","",333,null],[12,"search_paths","","",333,null],[12,"libs","","",333,null],[12,"maybe_sysroot","","",333,null],[12,"target_triple","","",333,null],[12,"cfg","","",333,null],[12,"test","","",333,null],[12,"parse_only","","",333,null],[12,"no_trans","","",333,null],[12,"treat_err_as_bug","","",333,null],[12,"no_analysis","","",333,null],[12,"debugging_opts","","",333,null],[12,"write_dependency_info","","Whether to write dependency files. It's (enabled, optional filename).",333,null],[12,"prints","","",333,null],[12,"cg","","",333,null],[12,"color","","",333,null],[12,"show_span","","",333,null],[12,"externs","","",333,null],[12,"crate_name","","",333,null],[12,"alt_std_name","","An optional name to use as the crate for std during std injection,\nwritten `extern crate std = \"name\"`. Default to \"std\". Used by\nout-of-tree drivers.",333,null],[12,"unstable_features","","Indicates how the compiler should treat unstable features",333,null],[4,"UnstableFeatures","","",null,null],[13,"Disallow","","Hard errors for unstable features are active, as on\nbeta/stable channels.",334,null],[13,"Default","","Use the default lint levels",334,null],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time\nduring the build that feature-related lints are set to warn or above\nbecause the build turns on warnings-as-errors and uses lots of unstable\nfeatures. As a result, this this is always required for building Rust\nitself.",334,null],[4,"PrintRequest","","",null,null],[13,"FileNames","","",335,null],[13,"Sysroot","","",335,null],[13,"CrateName","","",335,null],[4,"Input","","",null,null],[13,"File","","Load source from file",336,null],[13,"Str","","The string is the source",336,null],[3,"OutputFilenames","","",null,null],[12,"out_directory","","",337,null],[12,"out_filestem","","",337,null],[12,"single_output_file","","",337,null],[12,"extra","","",337,null],[5,"host_triple","","",null,{"inputs":[],"output":{"name":"str"}}],[5,"basic_options","","Some reasonable defaults",null,{"inputs":[],"output":{"name":"options"}}],[4,"EntryFnType","","",null,null],[13,"EntryMain","","",338,null],[13,"EntryStart","","",338,null],[13,"EntryNone","","",338,null],[4,"CrateType","","",null,null],[13,"CrateTypeExecutable","","",339,null],[13,"CrateTypeDylib","","",339,null],[13,"CrateTypeRlib","","",339,null],[13,"CrateTypeStaticlib","","",339,null],[4,"Passes","","",null,null],[13,"SomePasses","","",340,null],[13,"AllPasses","","",340,null],[3,"CodegenOptions","","",null,null],[12,"ar","","",341,null],[12,"linker","","",341,null],[12,"link_args","","",341,null],[12,"lto","","",341,null],[12,"target_cpu","","",341,null],[12,"target_feature","","",341,null],[12,"passes","","",341,null],[12,"llvm_args","","",341,null],[12,"save_temps","","",341,null],[12,"rpath","","",341,null],[12,"no_prepopulate_passes","","",341,null],[12,"no_vectorize_loops","","",341,null],[12,"no_vectorize_slp","","",341,null],[12,"soft_float","","",341,null],[12,"prefer_dynamic","","",341,null],[12,"no_integrated_as","","",341,null],[12,"no_redzone","","",341,null],[12,"relocation_model","","",341,null],[12,"code_model","","",341,null],[12,"metadata","","",341,null],[12,"extra_filename","","",341,null],[12,"codegen_units","","",341,null],[12,"remark","","",341,null],[12,"no_stack_check","","",341,null],[12,"debuginfo","","",341,null],[12,"opt_level","","",341,null],[12,"debug_assertions","","",341,null],[5,"basic_codegen_options","","",null,{"inputs":[],"output":{"name":"codegenoptions"}}],[5,"build_codegen_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"codegenoptions"}}],[6,"CodegenSetter","","",null,null],[17,"CG_OPTIONS","","",null,null],[3,"DebuggingOptions","","",null,null],[12,"verbose","","",342,null],[12,"time_passes","","",342,null],[12,"count_llvm_insns","","",342,null],[12,"time_llvm_passes","","",342,null],[12,"trans_stats","","",342,null],[12,"asm_comments","","",342,null],[12,"no_verify","","",342,null],[12,"borrowck_stats","","",342,null],[12,"no_landing_pads","","",342,null],[12,"debug_llvm","","",342,null],[12,"count_type_sizes","","",342,null],[12,"meta_stats","","",342,null],[12,"print_link_args","","",342,null],[12,"gc","","",342,null],[12,"print_llvm_passes","","",342,null],[12,"ast_json","","",342,null],[12,"ast_json_noexpand","","",342,null],[12,"ls","","",342,null],[12,"save_analysis","","",342,null],[12,"print_move_fragments","","",342,null],[12,"flowgraph_print_loans","","",342,null],[12,"flowgraph_print_moves","","",342,null],[12,"flowgraph_print_assigns","","",342,null],[12,"flowgraph_print_all","","",342,null],[12,"print_region_graph","","",342,null],[12,"parse_only","","",342,null],[12,"no_trans","","",342,null],[12,"treat_err_as_bug","","",342,null],[12,"no_analysis","","",342,null],[12,"extra_plugins","","",342,null],[12,"unstable_options","","",342,null],[12,"print_enum_sizes","","",342,null],[12,"force_overflow_checks","","",342,null],[12,"force_dropflag_checks","","",342,null],[5,"basic_debugging_options","","",null,{"inputs":[],"output":{"name":"debuggingoptions"}}],[5,"build_debugging_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"debuggingoptions"}}],[6,"DebuggingSetter","","",null,null],[17,"DB_OPTIONS","","",null,null],[5,"default_lib_output","","",null,{"inputs":[],"output":{"name":"cratetype"}}],[5,"default_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"vec"}}],[5,"append_configuration","","",null,null],[5,"build_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"vec"}}],[5,"build_target_config","","",null,{"inputs":[{"name":"options"},{"name":"spanhandler"}],"output":{"name":"config"}}],[5,"short_optgroups","","Returns the \"short\" subset of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"optgroups","","Returns all of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[4,"OptionStability","","",null,null],[13,"Stable","","",343,null],[13,"Unstable","","",343,null],[3,"RustcOptGroup","","",null,null],[12,"opt_group","","",344,null],[12,"stability","","",344,null],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options,\nincluding metadata for each option, such as whether the option is\npart of the stable long-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for\neach option, such as whether the option is part of the stable\nlong-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"parse_cfgspecs","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[5,"build_session_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"options"}}],[5,"get_unstable_features_setting","","",null,{"inputs":[],"output":{"name":"unstablefeatures"}}],[5,"parse_crate_types_from_list","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"result"}}],[0,"search_paths","rustc_typeck::session","",null,null],[3,"SearchPaths","rustc_typeck::session::search_paths","",null,null],[3,"Iter","","",null,null],[4,"PathKind","","",null,null],[13,"Native","","",346,null],[13,"Crate","","",346,null],[13,"Dependency","","",346,null],[13,"Framework","","",346,null],[13,"ExternFlag","","",346,null],[13,"All","","",346,null],[3,"Session","rustc_typeck::session","",null,null],[12,"target","","",348,null],[12,"host","","",348,null],[12,"opts","","",348,null],[12,"cstore","","",348,null],[12,"parse_sess","","",348,null],[12,"entry_fn","","",348,null],[12,"entry_type","","",348,null],[12,"plugin_registrar_fn","","",348,null],[12,"default_sysroot","","",348,null],[12,"local_crate_source_file","","",348,null],[12,"working_dir","","",348,null],[12,"lint_store","","",348,null],[12,"lints","","",348,null],[12,"plugin_llvm_passes","","",348,null],[12,"crate_types","","",348,null],[12,"crate_metadata","","",348,null],[12,"features","","",348,null],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive\noperations such as auto-dereference and monomorphization.",348,null],[12,"can_print_warnings","","",348,null],[5,"build_session","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"registry"}],"output":{"name":"session"}}],[5,"build_session_","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"spanhandler"}],"output":{"name":"session"}}],[5,"expect","","",null,{"inputs":[{"name":"session"},{"name":"option"},{"name":"m"}],"output":{"name":"t"}}],[5,"early_error","","",null,null],[5,"early_warn","","",null,null],[0,"util","rustc_typeck","",null,null],[0,"common","rustc_typeck::util","",null,null],[17,"FN_OUTPUT_NAME","rustc_typeck::util::common","",null,null],[3,"ErrorReported","","",null,null],[5,"time","","",null,{"inputs":[{"name":"bool"},{"name":"str"},{"name":"u"},{"name":"f"}],"output":{"name":"t"}}],[5,"indent","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[3,"Indenter","","",null,null],[5,"indenter","","",null,{"inputs":[],"output":{"name":"indenter"}}],[5,"loop_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"block_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"can_reach","","K: Eq + Hash<S>, V, S, H: Hasher<S>",null,{"inputs":[{"name":"hashmap"},{"name":"t"},{"name":"t"}],"output":{"name":"bool"}}],[5,"memoized","","Memoizes a one-argument closure using the given RefCell containing\na type implementing MutableMap to serve as a cache.",null,{"inputs":[{"name":"refcell"},{"name":"t"},{"name":"f"}],"output":{"name":"u"}}],[5,"path2cstr","","",null,{"inputs":[{"name":"path"}],"output":{"name":"cstring"}}],[0,"ppaux","rustc_typeck::util","",null,null],[8,"Repr","rustc_typeck::util::ppaux","Produces a string suitable for debugging output.",null,null],[10,"repr","","",449,{"inputs":[{"name":"repr"},{"name":"ctxt"}],"output":{"name":"string"}}],[8,"UserString","","Produces a string suitable for showing to the user.",null,null],[10,"user_string","","",450,{"inputs":[{"name":"userstring"},{"name":"ctxt"}],"output":{"name":"string"}}],[5,"note_and_explain_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"region"},{"name":"str"}],"output":{"name":"option"}}],[5,"explain_region_and_span","","",null,null],[5,"bound_region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"bound_region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"string"}}],[5,"region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"region"}],"output":{"name":"string"}}],[5,"mutability_to_string","","",null,{"inputs":[{"name":"mutability"}],"output":{"name":"string"}}],[5,"mt_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"string"}}],[5,"vec_map_to_string","","",null,null],[5,"ty_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"explicit_self_category_to_str","","",null,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"str"}}],[5,"parameterized","","",null,null],[5,"ty_to_short_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[0,"nodemap","rustc_typeck::util","An efficient hash map for node IDs",null,null],[6,"FnvHashMap","rustc_typeck::util::nodemap","",null,null],[6,"FnvHashSet","","",null,null],[6,"NodeMap","","",null,null],[6,"DefIdMap","","",null,null],[6,"NodeSet","","",null,null],[6,"DefIdSet","","",null,null],[5,"FnvHashMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"FnvHashSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[5,"NodeMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"DefIdMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"NodeSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[5,"DefIdSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[3,"FnvHasher","","A speedy hash algorithm for node ids and def ids. The hashmap in\nlibcollections by default uses SipHash which isn't quite as speedy as we\nwant. In the compiler we're not really worried about DOS attempts, so we\njust default to a non-cryptographic hash.",null,null],[0,"snapshot_vec","rustc_typeck::util","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits\nyou to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either\nto rollback to the start of the snapshot or commit those changes.",null,null],[4,"UndoLog","rustc_typeck::util::snapshot_vec","",null,null],[13,"OpenSnapshot","","Indicates where a snapshot started.",451,null],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",451,null],[13,"NewElem","","New variable with given index was created.",451,null],[13,"SetElem","","Variable with given index was changed *from* the given value.",451,null],[13,"Other","","Extensible set of actions",451,null],[3,"SnapshotVec","","",null,null],[3,"Snapshot","","",null,null],[8,"SnapshotVecDelegate","","",null,null],[16,"Value","rustc_typeck::util::snapshot_vec::SnapshotVecDelegate","",null,null],[16,"Undo","","",null,null],[10,"reverse","rustc_typeck::util::snapshot_vec","",452,null],[0,"lev_distance","rustc_typeck::util","",null,null],[5,"lev_distance","rustc_typeck::util::lev_distance","",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"usize"}}],[0,"num","rustc_typeck::util","",null,null],[8,"ToPrimitive","rustc_typeck::util::num","",null,null],[10,"to_i8","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i16","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i32","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i64","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u8","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u16","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u32","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u64","","",453,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[0,"fs","rustc_typeck::util","",null,null],[5,"realpath","rustc_typeck::util::fs","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[0,"sha2","rustc_typeck::util","This module implements only the Sha256 function since that is all that is needed for internal\nuse. This implementation is not intended for external use or for any use where security is\nimportant.",null,null],[8,"Digest","rustc_typeck::util::sha2","The Digest trait specifies an interface common to digest functions, such as SHA-1 and the SHA-2\nfamily of digest functions.",null,null],[10,"input","","Provide message data.",454,null],[10,"result","","Retrieve the digest result. This method may be called multiple times.",454,null],[10,"reset","","Reset the digest. This method must be called after result() and before supplying more\ndata.",454,null],[10,"output_bits","","Get the output size in bits.",454,{"inputs":[{"name":"digest"}],"output":{"name":"usize"}}],[11,"input_str","","Convenience function that feeds a string into a digest.",454,null],[11,"result_bytes","","Convenience function that retrieves the result of a digest as a\nnewly allocated vec of bytes.",454,{"inputs":[{"name":"digest"}],"output":{"name":"vec"}}],[11,"result_str","","Convenience function that retrieves the result of a digest as a\nString in hexadecimal format.",454,{"inputs":[{"name":"digest"}],"output":{"name":"string"}}],[11,"new_in","rustc_back::tempdir","Attempts to make a temporary directory inside of `tmpdir` whose name\nwill have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",455,{"inputs":[{"name":"tempdir"},{"name":"p"},{"name":"str"}],"output":{"name":"result"}}],[11,"new","","Attempts to make a temporary directory inside of `env::temp_dir()` whose\nname will have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",455,{"inputs":[{"name":"tempdir"},{"name":"str"}],"output":{"name":"result"}}],[11,"into_path","","Unwrap the wrapped `std::path::Path` from the `TempDir` wrapper.\nThis discards the wrapper so that the automatic deletion of the\ntemporary directory is prevented.",455,{"inputs":[{"name":"tempdir"}],"output":{"name":"pathbuf"}}],[11,"path","","Access the wrapped `std::path::Path` to the temporary directory.",455,{"inputs":[{"name":"tempdir"}],"output":{"name":"path"}}],[11,"close","","Close and remove the temporary directory",455,{"inputs":[{"name":"tempdir"}],"output":{"name":"result"}}],[11,"drop","","",455,null],[11,"clone","rustc_back::target::apple_ios_base","",456,{"inputs":[{"name":"arch"}],"output":{"name":"arch"}}],[11,"to_string","","",456,{"inputs":[{"name":"arch"}],"output":{"name":"str"}}],[11,"fmt","rustc_back::target","",457,{"inputs":[{"name":"target"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",457,{"inputs":[{"name":"target"}],"output":{"name":"target"}}],[11,"fmt","","",458,{"inputs":[{"name":"targetoptions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",458,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for\ncompilation, will certainly not work.",458,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",457,{"inputs":[{"name":"target"},{"name":"abi"}],"output":{"name":"abi"}}],[11,"from_json","","Load a target descriptor from a JSON object.",457,{"inputs":[{"name":"target"},{"name":"json"}],"output":{"name":"target"}}],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target\ntriple. Note that it could also just be a bare filename already, so also\ncheck for that. If one of the hardcoded targets we know about, just\nreturn it directly.",457,{"inputs":[{"name":"target"},{"name":"str"}],"output":{"name":"result"}}],[3,"Sha256","rustc_typeck::util::sha2","The SHA-256 hash algorithm",null,null],[3,"TypeAndSubsts","rustc_typeck","",null,null],[12,"substs","","",459,null],[12,"ty","","",459,null],[3,"CrateCtxt","","",null,null],[5,"check_crate","","",null,{"inputs":[{"name":"ctxt"},{"name":"traitmap"}],"output":null}],[0,"diagnostics","","",null,null],[7,"DIAGNOSTICS","rustc_typeck::diagnostics","",null,null]],"paths":[[3,"Lint"],[3,"Svh"],[4,"SawAbiComponent"],[4,"SawExprComponent"],[4,"SawStmtComponent"],[3,"Ident"],[3,"Name"],[3,"StrictVersionHashVisitor"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"DecodeContext"],[3,"DefId"],[4,"Option"],[3,"Span"],[3,"NestedItemsDropper"],[4,"Def"],[4,"Region"],[3,"FreeRegion"],[4,"CodeExtent"],[3,"DestructionScopeData"],[4,"BoundRegion"],[3,"Decoder"],[3,"Freevar"],[3,"UpvarBorrow"],[4,"UpvarCapture"],[4,"MethodOrigin"],[3,"EncodeContext"],[3,"Encoder"],[3,"SideTableEncodingIdVisitor"],[3,"Doc"],[3,"LoopScope"],[3,"LabelledCFG"],[4,"CFGNodeData"],[3,"CFG"],[3,"ConstQualif"],[4,"Mode"],[3,"CheckCrateVisitor"],[3,"CheckCrateVisitor"],[3,"CheckItemRecursionVisitor"],[4,"Context"],[3,"CheckLoopVisitor"],[3,"Matrix"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"MatchCheckCtxt"],[3,"StaticInliner"],[3,"RenamingRecorder"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[3,"RvalueContext"],[3,"RvalueContextDelegate"],[4,"const_val"],[3,"ConstEvalErr"],[4,"ErrKind"],[4,"IntTy"],[4,"UintTy"],[4,"EntryOrExit"],[3,"DataFlowContext"],[4,"KillFrom"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[3,"PathResolution"],[3,"Export"],[4,"MethodProvenance"],[4,"UnsafeContext"],[3,"EffectCheckVisitor"],[3,"EntryContext"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[3,"ExprUseVisitor"],[4,"SimplifiedType"],[3,"FreeRegionMap"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Graph"],[3,"DepthFirstTraversal"],[3,"IntrinsicCheckingVisitor"],[3,"TransmuteRestriction"],[3,"Bivariate"],[3,"CombineFields"],[3,"Generalizer"],[4,"Result"],[3,"Equate"],[3,"InferCtxt"],[3,"Rc"],[3,"Binder"],[3,"Glb"],[3,"Lub"],[4,"Node"],[4,"Edge"],[3,"ConstraintGraph"],[4,"Constraint"],[4,"GenericKind"],[3,"TwoRegions"],[4,"UndoLogEntry"],[4,"CombineMapType"],[4,"RegionResolutionError"],[3,"SameRegions"],[3,"RegionSnapshot"],[3,"RegionVarBindings"],[4,"Classification"],[4,"VarValue"],[4,"Verify"],[3,"RegionAndOrigin"],[3,"OpportunisticTypeResolver"],[3,"FullTypeResolver"],[3,"TypeFreshener"],[3,"Sub"],[4,"RelationDir"],[3,"TypeVariableTable"],[3,"Delegate"],[4,"VarValue"],[3,"Delegate"],[3,"UnificationTable"],[3,"IntVid"],[4,"IntVarValue"],[3,"FloatVid"],[4,"FloatTy"],[4,"TypeOrigin"],[4,"ValuePairs"],[3,"TypeTrace"],[4,"SubregionOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"fixup_err"],[4,"Implication"],[4,"LangItem"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[3,"Variable"],[3,"LiveNode"],[4,"LiveNodeKind"],[3,"IrMaps"],[3,"LocalInfo"],[4,"VarKind"],[3,"Liveness"],[3,"Users"],[3,"Specials"],[4,"categorization"],[3,"Upvar"],[4,"PointerKind"],[4,"InteriorKind"],[4,"FieldName"],[4,"InteriorOffsetKind"],[4,"ElementKind"],[4,"MutabilityCategory"],[4,"Note"],[3,"cmt_"],[4,"deref_kind"],[3,"Expr"],[3,"Pat"],[3,"MemCategorizationContext"],[4,"InteriorSafety"],[4,"Aliasability"],[4,"AliasableReason"],[4,"ClosureKind"],[4,"LastPrivate"],[4,"PrivateDep"],[4,"ImportUse"],[3,"ReachableContext"],[3,"BlockRemainder"],[4,"InnermostDeclaringBlock"],[3,"DeclaringStatementContext"],[4,"InnermostEnclosingExpr"],[3,"Context"],[3,"RegionMaps"],[3,"RegionResolutionVisitor"],[4,"DefRegion"],[3,"LifetimeContext"],[4,"ShadowKind"],[4,"ScopeChain"],[3,"Annotator"],[3,"Index"],[3,"Checker"],[3,"Substs"],[4,"RegionSubsts"],[4,"ParamSpace"],[3,"VecPerParamSpace"],[3,"EnumeratedItems"],[3,"SubstFolder"],[3,"InferIsLocal"],[3,"RegionObligation"],[3,"FulfillmentContext"],[3,"MismatchedProjectionTypes"],[4,"ProjectionTyCandidate"],[3,"AssociatedTypeNormalizer"],[3,"Normalized"],[4,"ProjectionTyError"],[4,"MethodViolationCode"],[4,"ObjectSafetyViolation"],[3,"SelectionCache"],[4,"MethodMatchedData"],[4,"SelectionCandidate"],[4,"EvaluationResult"],[3,"SelectionContext"],[3,"TraitObligationStackList"],[3,"TraitObligationStack"],[4,"MethodMatchResult"],[3,"Elaborator"],[3,"SupertraitDefIds"],[3,"FilterToTraits"],[3,"VtableImplData"],[3,"VtableObjectData"],[3,"Obligation"],[4,"Vtable"],[3,"VtableBuiltinData"],[3,"VtableDefaultImplData"],[4,"SelectionError"],[3,"FulfillmentError"],[4,"FulfillmentErrorCode"],[3,"ObligationCause"],[4,"ObligationCauseCode"],[3,"DerivedObligationCause"],[3,"field"],[4,"ImplOrTraitItemContainer"],[4,"ImplOrTraitItem"],[4,"ImplOrTraitItemId"],[3,"Method"],[3,"AssociatedType"],[3,"mt"],[3,"field_ty"],[3,"creader_cache_key"],[3,"ItemVariances"],[4,"Variance"],[4,"AutoAdjustment"],[3,"AutoDerefRef"],[4,"AutoRef"],[3,"param_index"],[3,"MethodParam"],[3,"MethodObject"],[3,"MethodCallee"],[3,"MethodCall"],[4,"vtable_origin"],[3,"CtxtArenas"],[3,"ctxt"],[3,"TypeFlags"],[3,"TyS"],[3,"InternedTy"],[3,"BareFnTy"],[3,"ClosureTy"],[4,"FnOutput"],[3,"FnSig"],[3,"ParamTy"],[3,"DebruijnIndex"],[3,"EarlyBoundRegion"],[3,"UpvarId"],[4,"BorrowKind"],[4,"sty"],[3,"TyTrait"],[3,"TraitRef"],[4,"terr_vstore_kind"],[3,"expected_found"],[4,"type_err"],[3,"ParamBounds"],[3,"ExistentialBounds"],[4,"BuiltinBound"],[3,"TyVid"],[3,"RegionVid"],[4,"InferTy"],[4,"UnconstrainedNumeric"],[4,"InferRegion"],[4,"ObjectLifetimeDefault"],[3,"TypeParameterDef"],[3,"RegionParameterDef"],[3,"Generics"],[3,"GenericPredicates"],[4,"Predicate"],[3,"TraitPredicate"],[3,"EquatePredicate"],[3,"OutlivesPredicate"],[3,"ProjectionPredicate"],[3,"ProjectionTy"],[3,"InstantiatedPredicates"],[3,"ParameterEnvironment"],[3,"TypeScheme"],[3,"ItemSubsts"],[3,"TypeContents"],[4,"Representability"],[4,"ExprKind"],[3,"VariantInfo"],[4,"DtorKind"],[4,"IntType"],[3,"ClosureUpvar"],[4,"ExplicitSelfCategory"],[4,"CopyImplementationError"],[3,"Vec"],[3,"Box"],[4,"Unsafety"],[4,"Abi"],[3,"OwnedSlice"],[3,"EnumSet"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionEraser"],[3,"Match"],[3,"TypeWalker"],[3,"Context"],[4,"astencode_tag"],[3,"LinkMeta"],[4,"DefIdSource"],[3,"entry"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[4,"Family"],[4,"DefLike"],[3,"CrateDep"],[3,"CrateReader"],[4,"PMDSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[3,"CrateSource"],[3,"CStore"],[3,"crate_metadata"],[4,"MetadataBlob"],[3,"MethodInfo"],[3,"Context"],[3,"ArchiveMetadata"],[4,"FileMatch"],[3,"FileSearch"],[3,"MacroLoader"],[4,"OptLevel"],[4,"DebugInfoLevel"],[4,"OutputType"],[3,"Options"],[4,"UnstableFeatures"],[4,"PrintRequest"],[4,"Input"],[3,"OutputFilenames"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[4,"OptionStability"],[3,"RustcOptGroup"],[3,"SearchPaths"],[4,"PathKind"],[3,"Iter"],[3,"Session"],[3,"Registry"],[3,"RegistrarFinder"],[3,"LintId"],[4,"Level"],[4,"LintSource"],[3,"HardwiredLints"],[3,"LintStore"],[3,"Context"],[3,"GatherNodeLevels"],[3,"ErrorReported"],[3,"Indenter"],[3,"LoopQueryVisitor"],[3,"BlockQueryVisitor"],[3,"P"],[3,"TraitDef"],[3,"TraitItem"],[3,"Path"],[3,"Ty"],[3,"Item"],[3,"Lifetime"],[3,"Spanned"],[4,"ExplicitSelf_"],[4,"Visibility"],[4,"Mutability"],[4,"IntTy"],[4,"UintTy"],[3,"HashMap"],[3,"FnvHasher"],[3,"SnapshotVec"],[3,"FixedBuffer64"],[3,"Sha256"],[3,"ArchiveRO"],[4,"OptimizationDiagnosticKind"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"Diagnostic"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[3,"Attribute"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[3,"AttrBuilder"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[4,"DIDescriptorFlags"],[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[8,"LintPass"],[3,"ctxt"],[4,"InlinedItemRef"],[3,"EncodeParams"],[3,"ImportedFileMap"],[4,"FoundAst"],[3,"Library"],[3,"CratePaths"],[8,"vtable_decoder_helpers"],[3,"CFGEdgeData"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[8,"Delegate"],[3,"Node"],[8,"RelateResultCompare"],[8,"ErrorReporting"],[8,"Resolvable"],[8,"LatticeDir"],[8,"UnifyKey"],[3,"Node"],[8,"ToType"],[8,"ast_node"],[8,"Typer"],[3,"SeparateVecsPerParamSpace"],[8,"Subst"],[4,"OrphanCheckErr"],[3,"CrateAnalysis"],[3,"CommonTypes"],[8,"ToPolyTraitRef"],[8,"AsPredicate"],[8,"ClosureTyper"],[8,"RegionEscape"],[8,"HasProjectionTypes"],[8,"ReferencesError"],[8,"TypeFoldable"],[8,"TypeFolder"],[8,"TypeRelation"],[8,"Relate"],[3,"Config"],[8,"Repr"],[8,"UserString"],[4,"UndoLog"],[8,"SnapshotVecDelegate"],[8,"ToPrimitive"],[8,"Digest"],[3,"TempDir"],[4,"Arch"],[3,"Target"],[3,"TargetOptions"],[3,"TypeAndSubsts"]]};
searchIndex['rustc_lint'] = {"items":[[0,"","rustc_lint","Lints in the Rust compiler.",null,null],[0,"lint","","Lints, aka compiler warnings.",null,null],[11,"name_lower","rustc::lint","Get the lint's name, with ASCII letters converted to lowercase.",0,{"inputs":[{"name":"lint"}],"output":{"name":"string"}}],[11,"fmt","rustc_back::svh","",1,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",1,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",1,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",1,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",1,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","rustc_back::svh::svh_visitor","",2,null],[11,"hash","","",3,null],[11,"hash","","",4,null],[11,"get_content","syntax::ast","",5,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"get_content","","",6,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[11,"visit_mac","rustc_back::svh::svh_visitor","",7,null],[11,"visit_struct_def","","",7,null],[11,"visit_variant","","",7,null],[11,"visit_opt_lifetime_ref","","",7,null],[11,"visit_ident","","",7,null],[11,"visit_lifetime_ref","","",7,null],[11,"visit_lifetime_def","","",7,null],[11,"visit_expr","","",7,null],[11,"visit_stmt","","",7,null],[11,"visit_foreign_item","","",7,null],[11,"visit_item","","",7,null],[11,"visit_mod","","",7,null],[11,"visit_decl","","",7,null],[11,"visit_ty","","",7,null],[11,"visit_generics","","",7,null],[11,"visit_fn","","",7,null],[11,"visit_trait_item","","",7,null],[11,"visit_impl_item","","",7,null],[11,"visit_struct_field","","",7,null],[11,"visit_explicit_self","","",7,null],[11,"visit_path","","",7,null],[11,"visit_block","","",7,null],[11,"visit_pat","","",7,null],[11,"visit_local","","",7,null],[11,"visit_arm","","",7,null],[11,"open","rustc_back::archive","Opens an existing static archive",8,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",8,null],[11,"files","","Lists all files in an archive",8,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",8,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",9,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",9,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",9,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",9,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",9,null],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",9,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[11,"tr_id","rustc::middle::astencode","Translates an internal id, meaning a node id that is known to refer to some part of the\nitem currently being inlined, such as a local variable or argument.  All naked node-ids\nthat appear in types have this property, since if something might refer to an external item\nwe would use a def-id to allow for the possibility that the item resides in another crate.",10,{"inputs":[{"name":"decodecontext"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"tr_def_id","","Translates an EXTERNAL def-id, converting the crate number from the one used in the encoded\ndata to the current crate numbers..  By external, I mean that it be translated to a\nreference to the item in its original crate, as opposed to being translated to a reference\nto the inlined version of the item.  This is typically, but not always, what you want,\nbecause most def-ids refer to external things like types or other fns that may or may not\nbe inlined.  Note that even when the inlined function is referencing itself recursively, we\nwould want `tr_def_id` for that reference--- conceptually the function calls the original,\nnon-inlined version, and trans deals with linking that recursive call to the inlined copy.",10,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_intern_def_id","","Translates an INTERNAL def-id, meaning a def-id that is\nknown to refer to some part of the item currently being\ninlined.  In that case, we want to convert the def-id to\nrefer to the current crate and to the new, inlined node-id.",10,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_span","","Translates a `Span` from an extern crate to the corresponding `Span`\nwithin the local crate's codemap. `creader::import_codemap()` will\nalready have allocated any additionally needed FileMaps in the local\ncodemap as a side-effect of creating the crate_metadata's\n`codemap_import_info`.",10,{"inputs":[{"name":"decodecontext"},{"name":"span"}],"output":{"name":"span"}}],[11,"tr_intern","syntax::ast","",11,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","","",11,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","core::option","",12,{"inputs":[{"name":"option"},{"name":"decodecontext"}],"output":{"name":"option"}}],[11,"tr","syntax::codemap","",13,{"inputs":[{"name":"span"},{"name":"decodecontext"}],"output":{"name":"span"}}],[11,"fold_block","rustc::middle::astencode","",14,{"inputs":[{"name":"nesteditemsdropper"},{"name":"p"}],"output":{"name":"p"}}],[11,"tr","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"decodecontext"}],"output":{"name":"def"}}],[11,"tr","rustc::middle::ty","",16,{"inputs":[{"name":"region"},{"name":"decodecontext"}],"output":{"name":"region"}}],[11,"tr","","",17,{"inputs":[{"name":"freeregion"},{"name":"decodecontext"}],"output":{"name":"freeregion"}}],[11,"tr","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"decodecontext"}],"output":{"name":"codeextent"}}],[11,"tr","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"decodecontext"}],"output":{"name":"destructionscopedata"}}],[11,"tr","rustc::middle::ty","",20,{"inputs":[{"name":"boundregion"},{"name":"decodecontext"}],"output":{"name":"boundregion"}}],[11,"read_freevar_entry","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"read_capture_mode","","",21,{"inputs":[{"name":"decoder"}],"output":{"name":"captureclause"}}],[11,"tr","rustc::middle::ty","",22,{"inputs":[{"name":"freevar"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"tr","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"decodecontext"}],"output":{"name":"upvarborrow"}}],[11,"tr","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"decodecontext"}],"output":{"name":"upvarcapture"}}],[11,"read_method_callee","rbml::reader","",21,null],[11,"tr","rustc::middle::ty","",25,{"inputs":[{"name":"methodorigin"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_vec_per_param_space","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_res_with_key","","",21,null],[11,"read_vtable_res","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_param_res","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_vtable_origin","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[11,"ty_str_ctxt","rustc::metadata::encoder","",26,{"inputs":[{"name":"encodecontext"}],"output":{"name":"ctxt"}}],[11,"emit_closure_type","rbml::writer","",27,null],[11,"emit_method_origin","","",27,null],[11,"emit_ty","","",27,null],[11,"emit_tys","","",27,null],[11,"emit_trait_ref","","",27,null],[11,"emit_type_param_def","","",27,null],[11,"emit_predicate","","",27,null],[11,"emit_type_scheme","","",27,null],[11,"emit_existential_bounds","","",27,null],[11,"emit_builtin_bounds","","",27,null],[11,"emit_substs","","",27,null],[11,"emit_auto_adjustment","","",27,null],[11,"emit_autoref","","",27,null],[11,"emit_auto_deref_ref","","",27,null],[11,"tag","","",27,null],[11,"id","","",27,null],[11,"visit_id","rustc::middle::astencode","",28,null],[11,"as_int","rbml","",29,{"inputs":[{"name":"doc"}],"output":{"name":"isize"}}],[11,"opt_child","","",29,{"inputs":[{"name":"doc"},{"name":"astencode_tag"}],"output":{"name":"option"}}],[11,"read_ty_nodcx","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[11,"read_tys_nodcx","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_substs_nodcx","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"substs"}}],[11,"read_method_origin","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_ty","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"tys"}}],[11,"read_tys","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"vec"}}],[11,"read_trait_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"rc"}}],[11,"read_poly_trait_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"binder"}}],[11,"read_type_param_def","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typeparameterdef"}}],[11,"read_predicate","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"predicate"}}],[11,"read_type_scheme","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typescheme"}}],[11,"read_existential_bounds","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"existentialbounds"}}],[11,"read_substs","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"substs"}}],[11,"read_auto_adjustment","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoadjustment"}}],[11,"read_auto_deref_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoderefref"}}],[11,"read_autoref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoref"}}],[11,"read_closure_kind","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurekind"}}],[11,"read_closure_ty","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurety"}}],[11,"convert_def_id","","Converts a def-id that appears in a type.  The correct\ntranslation will depend on what kind of def-id this is.\nThis is a subtle point: type definitions are not\ninlined into the current crate, so if the def-id names\na nominal type or type alias, then it should be\ntranslated to refer to the source crate.",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"},{"name":"defidsource"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"clone","rustc::middle::cfg::construct","",30,{"inputs":[{"name":"loopscope"}],"output":{"name":"loopscope"}}],[11,"graph_id","rustc::middle::cfg::graphviz","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"id"}}],[11,"node_id","","",31,null],[11,"node_label","","",31,null],[11,"edge_label","","",31,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"edges","","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"source","","",31,null],[11,"target","","",31,null],[11,"eq","rustc::middle::cfg","",32,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"clone","","",32,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"cfgnodedata"}}],[11,"id","","",32,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"u32"}}],[11,"new","","",33,{"inputs":[{"name":"cfg"},{"name":"ctxt"},{"name":"block"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",33,{"inputs":[{"name":"cfg"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"hash","rustc::middle::check_const","",34,null],[11,"cmp","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"option"}}],[11,"lt","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"le","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"gt","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ge","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"clone","","",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"decode","","",34,{"inputs":[{"name":"constqualif"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"constqualif"},{"name":"__s"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"all","","Returns the set containing all flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",34,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",34,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"constqualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",34,null],[11,"remove","","Removes the specified flags in-place.",34,null],[11,"toggle","","Toggles the specified flags in-place.",34,null],[6,"Output","rustc_lint::lint","",null,null],[11,"bitor","rustc::middle::check_const","Returns the union of the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitxor","rustc::middle::check_const","Returns the left flags, but with all the right flags toggled.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitand","rustc::middle::check_const","Returns the intersection between the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"sub","rustc::middle::check_const","Returns the set difference of the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"not","rustc::middle::check_const","Returns the complement of this set of flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",35,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"mode"}],"output":{"name":"mode"}}],[11,"visit_item","","",36,null],[11,"visit_fn","","",36,null],[11,"visit_pat","","",36,null],[11,"visit_expr","","",36,null],[11,"consume","","",36,null],[11,"borrow","","",36,null],[11,"decl_without_init","","",36,null],[11,"mutate","","",36,null],[11,"matched_pat","","",36,null],[11,"consume_pat","","",36,null],[11,"visit_item","rustc::middle::check_static_recursion","",37,null],[11,"visit_item","","",38,null],[11,"visit_expr","","",38,null],[11,"eq","rustc::middle::check_loop","",39,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"clone","","",40,{"inputs":[{"name":"checkloopvisitor"}],"output":{"name":"checkloopvisitor"}}],[11,"visit_item","","",40,null],[11,"visit_expr","","",40,null],[11,"fmt","rustc::middle::check_match","",41,{"inputs":[{"name":"matrix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",41,{"inputs":[{"name":"matrix"},{"name":"t"}],"output":{"name":"matrix"}}],[11,"eq","","",42,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"constructor"}],"output":{"name":"constructor"}}],[11,"eq","","",43,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"usefulness"}],"output":{"name":"usefulness"}}],[11,"clone","","",44,{"inputs":[{"name":"witnesspreference"}],"output":{"name":"witnesspreference"}}],[11,"visit_expr","","",45,null],[11,"visit_local","","",45,null],[11,"visit_fn","","",45,null],[11,"new","","",46,{"inputs":[{"name":"staticinliner"},{"name":"ctxt"},{"name":"option"}],"output":{"name":"staticinliner"}}],[11,"visit_id","","",47,null],[11,"fold_pat","","",46,{"inputs":[{"name":"staticinliner"},{"name":"p"}],"output":{"name":"p"}}],[11,"matched_pat","","",48,null],[11,"consume","","",48,null],[11,"consume_pat","","",48,null],[11,"borrow","","",48,null],[11,"decl_without_init","","",48,null],[11,"mutate","","",48,null],[11,"visit_pat","","",49,null],[11,"visit_fn","rustc::middle::check_rvalues","",50,null],[11,"consume","","",51,null],[11,"matched_pat","","",51,null],[11,"consume_pat","","",51,null],[11,"borrow","","",51,null],[11,"decl_without_init","","",51,null],[11,"mutate","","",51,null],[11,"eq","rustc::middle::const_eval","",52,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"clone","","",52,{"inputs":[{"name":"const_val"}],"output":{"name":"const_val"}}],[11,"clone","","",53,{"inputs":[{"name":"constevalerr"}],"output":{"name":"constevalerr"}}],[11,"clone","","",54,{"inputs":[{"name":"errkind"}],"output":{"name":"errkind"}}],[11,"description","","",53,{"inputs":[{"name":"constevalerr"}],"output":{"name":"cow"}}],[11,"fmt","","",55,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",56,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",56,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",56,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"from","","",55,{"inputs":[{"name":"intty"},{"name":"ctxt"},{"name":"intty"}],"output":{"name":"intty"}}],[11,"from","","",56,{"inputs":[{"name":"uintty"},{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"fmt","rustc::middle::dataflow","",57,{"inputs":[{"name":"entryorexit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",57,{"inputs":[{"name":"entryorexit"}],"output":{"name":"entryorexit"}}],[11,"clone","","",58,{"inputs":[{"name":"dataflowcontext"}],"output":{"name":"dataflowcontext"}}],[11,"pre","","",58,{"inputs":[{"name":"dataflowcontext"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"fmt","","",59,{"inputs":[{"name":"killfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",59,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"clone","","",59,{"inputs":[{"name":"killfrom"}],"output":{"name":"killfrom"}}],[11,"new","","",58,{"inputs":[{"name":"dataflowcontext"},{"name":"ctxt"},{"name":"str"},{"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",58,null],[11,"add_kill","","Indicates that `id` kills `bit`",58,null],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`.\nOnly useful after `propagate()` has been called.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`.\nOnly useful after `propagate()` has been called.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"entryorexit"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow\nexits through any number of enclosing scopes on its way to\nthe new destination. This function infers the kill bits of\nthose control operators based on the kill bits associated\nwith those scopes.",58,null],[11,"propagate","","Performs the data flow analysis.",58,null],[11,"join","","",60,{"inputs":[{"name":"union"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",61,{"inputs":[{"name":"subtract"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"visit_struct_def","rustc::middle::dead","",62,null],[11,"visit_expr","","",62,null],[11,"visit_pat","","",62,null],[11,"visit_path","","",62,null],[11,"visit_item","","",62,null],[11,"visit_item","","",63,null],[11,"visit_item","","",64,null],[11,"visit_foreign_item","","",64,null],[11,"visit_fn","","",64,null],[11,"visit_struct_field","","",64,null],[11,"visit_trait_item","","",64,null],[11,"fmt","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",15,null],[11,"decode","","",15,{"inputs":[{"name":"def"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"def"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"def"}],"output":{"name":"def"}}],[11,"fmt","","",65,{"inputs":[{"name":"pathresolution"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"pathresolution"}}],[11,"full_def","","Get the definition, if fully resolved, otherwise panic.",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"def"}}],[11,"def_id","","Get the DefId, if fully resolved, otherwise panic.",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"defid"}}],[11,"new","","",65,{"inputs":[{"name":"pathresolution"},{"name":"def"},{"name":"lastprivate"},{"name":"usize"}],"output":{"name":"pathresolution"}}],[11,"clone","","",66,{"inputs":[{"name":"export"}],"output":{"name":"export"}}],[11,"fmt","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",67,null],[11,"decode","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"methodprovenance"}],"output":{"name":"methodprovenance"}}],[11,"map","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"f"}],"output":{"name":"methodprovenance"}}],[11,"local_node_id","","",15,{"inputs":[{"name":"def"}],"output":{"name":"u32"}}],[11,"def_id","","",15,{"inputs":[{"name":"def"}],"output":{"name":"defid"}}],[11,"variant_def_ids","","",15,{"inputs":[{"name":"def"}],"output":{"name":"option"}}],[11,"eq","rustc::middle::effect","",68,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"clone","","",68,{"inputs":[{"name":"unsafecontext"}],"output":{"name":"unsafecontext"}}],[11,"visit_fn","","",69,null],[11,"visit_block","","",69,null],[11,"visit_expr","","",69,null],[11,"visit_item","rustc::middle::entry","",70,null],[11,"fmt","rustc::middle::expr_use_visitor","",71,{"inputs":[{"name":"loancause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"loancause"}],"output":{"name":"loancause"}}],[11,"fmt","","",72,{"inputs":[{"name":"consumemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"consumemode"}],"output":{"name":"consumemode"}}],[11,"fmt","","",73,{"inputs":[{"name":"movereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"movereason"}],"output":{"name":"movereason"}}],[11,"fmt","","",74,{"inputs":[{"name":"matchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"matchmode"}],"output":{"name":"matchmode"}}],[11,"fmt","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"trackmatchmode"}],"output":{"name":"trackmatchmode"}}],[11,"fmt","","",76,{"inputs":[{"name":"mutatemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",76,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"mutatemode"}],"output":{"name":"mutatemode"}}],[11,"clone","","",77,{"inputs":[{"name":"overloadedcalltype"}],"output":{"name":"overloadedcalltype"}}],[11,"new","","",78,{"inputs":[{"name":"exprusevisitor"},{"name":"delegate"},{"name":"typer"}],"output":{"name":"exprusevisitor"}}],[11,"walk_fn","","",78,null],[11,"consume_expr","","",78,null],[11,"walk_expr","","",78,null],[11,"hash","rustc::middle::fast_reject","",79,null],[11,"eq","","",79,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"clone","","",79,{"inputs":[{"name":"simplifiedtype"}],"output":{"name":"simplifiedtype"}}],[11,"clone","rustc::middle::free_region","",80,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"new","","",80,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"relate_free_regions_from_implications","","",80,null],[11,"relate_free_regions_from_predicates","","",80,null],[11,"relate_free_regions","","",80,null],[11,"sub_free_region","","Determines whether two free regions have a subregion relationship\nby walking the graph encoded in `map`.  Note that\nit is possible that `sub != sup` and `sub <= sup` and `sup <= sub`\n(that is, the user can give two different names to the same lifetime).",80,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run *after\ninference* and sadly the logic is somewhat duplicated with the code in infer.rs.",80,{"inputs":[{"name":"freeregionmap"},{"name":"ctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","rustc::middle::graph","",81,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",82,{"inputs":[{"name":"nodeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",82,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"nodeindex"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",83,{"inputs":[{"name":"edgeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",83,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"clone","","",83,{"inputs":[{"name":"edgeindex"}],"output":{"name":"edgeindex"}}],[11,"fmt","","",84,{"inputs":[{"name":"direction"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",84,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",82,{"inputs":[{"name":"nodeindex"}],"output":{"name":"usize"}}],[11,"edge_id","","Returns unique id (unique with respect to the graph holding associated edge).",83,{"inputs":[{"name":"edgeindex"}],"output":{"name":"usize"}}],[11,"new","","",85,{"inputs":[{"name":"graph"}],"output":{"name":"graph"}}],[11,"with_capacity","","",85,{"inputs":[{"name":"graph"},{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",85,null],[11,"all_edges","","",85,null],[11,"next_node_index","","",85,{"inputs":[{"name":"graph"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",85,{"inputs":[{"name":"graph"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",85,{"inputs":[{"name":"graph"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"mut_edge_data","","",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge_data","","",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge","","",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"first_adjacent","","Accesses the index of the first edge adjacent to `node`.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"next_adjacent","","Accesses the next edge in a given direction.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"each_node","","Iterates over all edges defined in the graph.",85,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_edge","","Iterates over all edges defined in the graph",85,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_outgoing_edge","","Iterates over all outgoing edges from the node `from`",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_incoming_edge","","Iterates over all incoming edges to the node `target`",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_adjacent_edge","","Iterates over all edges adjacent to the node `node`\nin the direction `dir` (either `Outgoing` or `Incoming)",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"},{"name":"f"}],"output":{"name":"bool"}}],[11,"iterate_until_fixed_point","","",85,null],[11,"depth_traverse","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"depthfirsttraversal"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::graph","",86,{"inputs":[{"name":"depthfirsttraversal"}],"output":{"name":"option"}}],[11,"source","","",81,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"target","","",81,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"visit_fn","rustc::middle::intrinsicck","",87,null],[11,"visit_expr","","",87,null],[11,"repr","rustc::middle::ty","",88,{"inputs":[{"name":"transmuterestriction"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","rustc::middle::infer::bivariate","",89,{"inputs":[{"name":"bivariate"},{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"tag","","",89,{"inputs":[{"name":"bivariate"}],"output":{"name":"str"}}],[11,"tcx","","",89,{"inputs":[{"name":"bivariate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",89,{"inputs":[{"name":"bivariate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",89,{"inputs":[{"name":"bivariate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",89,{"inputs":[{"name":"bivariate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",89,{"inputs":[{"name":"bivariate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",89,{"inputs":[{"name":"bivariate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"clone","rustc::middle::infer::combine","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"tcx","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"ctxt"}}],[11,"switch_expected","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"equate","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"bivariate","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"sub","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"lub","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"glb","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"instantiate","","",90,{"inputs":[{"name":"combinefields"},{"name":"tys"},{"name":"relationdir"},{"name":"tyvid"}],"output":{"name":"result"}}],[11,"tcx","","",91,{"inputs":[{"name":"generalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",91,{"inputs":[{"name":"generalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",91,{"inputs":[{"name":"generalizer"},{"name":"region"}],"output":{"name":"region"}}],[11,"compare","core::result","",92,{"inputs":[{"name":"result"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[11,"new","rustc::middle::infer::equate","",93,{"inputs":[{"name":"equate"},{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"tag","","",93,{"inputs":[{"name":"equate"}],"output":{"name":"str"}}],[11,"tcx","","",93,{"inputs":[{"name":"equate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",93,{"inputs":[{"name":"equate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",93,{"inputs":[{"name":"equate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",93,{"inputs":[{"name":"equate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",93,{"inputs":[{"name":"equate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",93,{"inputs":[{"name":"equate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"report_region_errors","rustc::middle::infer","",94,null],[11,"process_errors","","",94,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"report_type_error","","",94,null],[11,"report_and_explain_type_error","","",94,null],[11,"values_str","","Returns a string of the form \"expected `{}`, found `{}`\", or None if this is a derived\nerror.",94,{"inputs":[{"name":"inferctxt"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str","","",94,{"inputs":[{"name":"inferctxt"},{"name":"expected_found"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",94,null],[11,"report_concrete_failure","","",94,null],[11,"report_sub_sup_conflict","","",94,null],[11,"report_sup_sup_conflict","","",94,null],[11,"report_processed_errors","","",94,null],[11,"give_suggestion","","",94,null],[11,"give_expl_lifetime_param","","",94,null],[11,"report_inference_failure","","",94,null],[11,"note_region_origin","","",94,null],[11,"resolve","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"inferctxt"}],"output":{"name":"rc"}}],[11,"contains_error","","",95,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"resolve","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"inferctxt"}],"output":{"name":"binder"}}],[11,"contains_error","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"new","rustc::middle::infer::glb","",97,{"inputs":[{"name":"glb"},{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"tag","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"str"}}],[11,"tcx","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",97,{"inputs":[{"name":"glb"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",97,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",97,{"inputs":[{"name":"glb"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",97,{"inputs":[{"name":"glb"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",97,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"higher_ranked_sub","rustc::middle::infer::combine","",90,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_lub","","",90,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_glb","","",90,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"tainted_regions","rustc::middle::infer","",94,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any\ntypes/regions which existed before `snapshot` was\nstarted. This is used in the sub/lub/glb computations. The\nidea here is that when we are computing lub/glb of two\nregions, we sometimes create intermediate region variables.\nThose region variables may touch some of the skolemized or\nother \"forbidden\" regions we created to replace bound\nregions, but they don't really represent an \"external\"\nconstraint.",94,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"}],"output":{"name":"vec"}}],[11,"new","rustc::middle::infer::lub","",98,{"inputs":[{"name":"lub"},{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"tag","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"str"}}],[11,"tcx","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",98,{"inputs":[{"name":"lub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",98,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",98,{"inputs":[{"name":"lub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",98,{"inputs":[{"name":"lub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",98,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::region_inference::graphviz","",99,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",99,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"hash","","",99,null],[11,"clone","","",99,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",100,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",100,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"clone","","",100,{"inputs":[{"name":"edge"}],"output":{"name":"edge"}}],[11,"graph_id","","",101,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"id"}}],[11,"node_id","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",101,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"edges","","",101,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"source","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"fmt","rustc::middle::infer::region_inference","",102,{"inputs":[{"name":"constraint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",102,null],[11,"eq","","",102,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",102,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"clone","","",102,{"inputs":[{"name":"constraint"}],"output":{"name":"constraint"}}],[11,"eq","","",103,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"fmt","","",103,{"inputs":[{"name":"generickind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",103,{"inputs":[{"name":"generickind"}],"output":{"name":"generickind"}}],[11,"hash","","",104,null],[11,"eq","","",104,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"clone","","",104,{"inputs":[{"name":"tworegions"}],"output":{"name":"tworegions"}}],[11,"eq","","",105,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",105,{"inputs":[{"name":"undologentry"}],"output":{"name":"undologentry"}}],[11,"eq","","",106,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"ne","","",106,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"clone","","",106,{"inputs":[{"name":"combinemaptype"}],"output":{"name":"combinemaptype"}}],[11,"fmt","","",107,{"inputs":[{"name":"regionresolutionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"regionresolutionerror"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",108,{"inputs":[{"name":"sameregions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"sameregions"}],"output":{"name":"sameregions"}}],[11,"contains","","",108,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"push","","",108,null],[11,"fmt","","",109,{"inputs":[{"name":"regionsnapshot"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"ctxt"}],"output":{"name":"regionvarbindings"}}],[11,"start_snapshot","","",110,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",110,null],[11,"rollback_to","","",110,null],[11,"num_vars","","",110,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"u32"}}],[11,"new_region_var","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"new_skolemized","","Creates a new skolemized region. Skolemized regions are fresh\nregions used when performing higher-ranked computations. They\nmust be used in a very particular way and are never supposed\nto \"escape\" out into error messages or the code at large.",110,{"inputs":[{"name":"regionvarbindings"},{"name":"boundregion"},{"name":"regionsnapshot"}],"output":{"name":"region"}}],[11,"new_bound","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_given","","",110,null],[11,"make_eqregion","","",110,null],[11,"make_subregion","","",110,null],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",110,null],[11,"lub_regions","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"resolve_var","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_vars","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"},{"name":"f"}],"output":{"name":"region"}}],[11,"vars_created_since_snapshot","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":{"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` in any way since the mark `mark` was\nmade---`r0` itself will be the first entry. This is used when checking whether skolemized\nregions are being improperly related to other regions.",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"resolve_regions","","This function performs the actual region resolution.  It must be\ncalled after all constraints have been added.  It performs a\nfixed-point iteration to find region values which satisfy all\nconstraints, assuming such values can be found; if they cannot,\nerrors are reported.",110,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregionmap"},{"name":"u32"}],"output":{"name":"vec"}}],[11,"fmt","","",111,{"inputs":[{"name":"classification"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",111,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"ne","","",111,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"clone","","",111,{"inputs":[{"name":"classification"}],"output":{"name":"classification"}}],[11,"clone","","",112,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"repr","","",102,{"inputs":[{"name":"constraint"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",113,{"inputs":[{"name":"verify"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",112,{"inputs":[{"name":"varvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",114,{"inputs":[{"name":"regionandorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",103,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",103,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"to_ty","","",103,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::resolve","",115,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"inferctxt"}],"output":{"name":"opportunistictyperesolver"}}],[11,"tcx","","",115,{"inputs":[{"name":"opportunistictyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",115,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"tcx","","",116,{"inputs":[{"name":"fulltyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",116,{"inputs":[{"name":"fulltyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",116,{"inputs":[{"name":"fulltyperesolver"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::infer::freshen","",117,{"inputs":[{"name":"typefreshener"},{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"tcx","","",117,{"inputs":[{"name":"typefreshener"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",117,{"inputs":[{"name":"typefreshener"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",117,{"inputs":[{"name":"typefreshener"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::sub","",118,{"inputs":[{"name":"sub"},{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"tag","","",118,{"inputs":[{"name":"sub"}],"output":{"name":"str"}}],[11,"tcx","","",118,{"inputs":[{"name":"sub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",118,{"inputs":[{"name":"sub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",118,{"inputs":[{"name":"sub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",118,{"inputs":[{"name":"sub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",118,{"inputs":[{"name":"sub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",118,{"inputs":[{"name":"sub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::type_variable","",119,{"inputs":[{"name":"relationdir"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",119,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"ne","","",119,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"clone","","",119,{"inputs":[{"name":"relationdir"}],"output":{"name":"relationdir"}}],[11,"new","","",120,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"relate_vars","","Records that `a <: b`, `a :> b`, or `a == b`, depending on `dir`.",120,null],[11,"instantiate_and_push","","Instantiates `vid` with the type `ty` and then pushes an entry onto `stack` for each of the\nrelations of `vid` to other variables. The relations will have the form `(ty, dir, vid1)`\nwhere `vid1` is some other variable id.",120,null],[11,"new_var","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"probe","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"option"}}],[11,"replace_if_possible","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"snapshot","","",120,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","",120,null],[11,"commit","","",120,null],[11,"types_escaping_snapshot","","Find the set of type variables that existed *before* `s`\nbut which have only been unified since `s` started, and\nreturn the types with which they were unified. So if we had\na type variable `V0`, then we started the snapshot, then we\ncreated a type variable `V1`, unifed `V0` with `T0`, and\nunified `V1` with `T1`, this function would return `{T0}`.",120,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":{"name":"vec"}}],[6,"Value","rustc_lint::lint","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::type_variable","",121,null],[11,"fmt","rustc::middle::infer::unify","",122,{"inputs":[{"name":"varvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",122,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"eq","","",122,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",122,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","","",123,{"inputs":[{"name":"delegate"}],"output":{"name":"delegate"}}],[11,"new","","",124,{"inputs":[{"name":"unificationtable"}],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either\nrolled back or committed in a \"LIFO\" (stack) order.",124,{"inputs":[{"name":"unificationtable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also\nremoves any keys that have been created since then.",124,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",124,null],[11,"new_key","","",124,null],[6,"Value","rustc_lint::lint","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::unify","",123,null],[11,"unify_var_var","","",124,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"k"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`. Because simple keys do not have any subtyping\nrelationships, if `a_id` already has a value, it must be the same as `b`.",124,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"v"}],"output":{"name":"result"}}],[11,"has_value","","",124,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"bool"}}],[11,"probe","","",124,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"option"}}],[6,"Value","rustc_lint::lint","",null,null],[11,"index","rustc::middle::ty","",125,{"inputs":[{"name":"intvid"}],"output":{"name":"u32"}}],[11,"from_index","","",125,{"inputs":[{"name":"intvid"},{"name":"u32"}],"output":{"name":"intvid"}}],[11,"tag","","",125,{"inputs":[{"name":"intvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Value","rustc_lint::lint","",null,null],[11,"index","rustc::middle::ty","",127,{"inputs":[{"name":"floatvid"}],"output":{"name":"u32"}}],[11,"from_index","","",127,{"inputs":[{"name":"floatvid"},{"name":"u32"}],"output":{"name":"floatvid"}}],[11,"tag","","",127,{"inputs":[{"name":"floatvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","syntax::ast","",128,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"fmt","rustc::middle::infer","",129,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"typeorigin"}],"output":{"name":"typeorigin"}}],[11,"fmt","","",129,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",130,{"inputs":[{"name":"valuepairs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"valuepairs"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",131,{"inputs":[{"name":"typetrace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",131,{"inputs":[{"name":"typetrace"}],"output":{"name":"typetrace"}}],[11,"fmt","","",132,{"inputs":[{"name":"subregionorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",133,{"inputs":[{"name":"lateboundregionconversiontime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"lateboundregionconversiontime"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",134,{"inputs":[{"name":"regionvariableorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",135,{"inputs":[{"name":"fixup_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",135,{"inputs":[{"name":"fixup_err"}],"output":{"name":"fixup_err"}}],[11,"freshen","","",94,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"freshener","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"unconstrainednumeric"}}],[11,"equate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"equate"}}],[11,"sub","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"sub"}}],[11,"lub","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"lub"}}],[11,"glb","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"glb"}}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"commit_regions_if_ok","","Execute `f` and commit only the region bindings if successful.\nThe function f must be very careful not to leak any non-region\nvariables that get created.",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",94,null],[11,"sub_types","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"eq_types","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"sub_trait_refs","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"sub_poly_trait_refs","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"construct_skolemized_subst","","See `higher_ranked::construct_skolemized_subst`",94,null],[11,"skolemize_late_bound_regions","","See `higher_ranked::skolemize_late_bound_regions`",94,null],[11,"leak_check","","See `higher_ranked::leak_check`",94,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"}],"output":{"name":"result"}}],[11,"plug_leaks","","See `higher_ranked::plug_leaks`",94,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"equality_predicate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"region_outlives_predicate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"next_ty_var_id","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_diverging_ty_var","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_ty_vars","","",94,{"inputs":[{"name":"inferctxt"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"next_int_var_id","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","",94,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"region_vars_for_defs","","",94,null],[11,"fresh_substs_for_generics","","Given a set of generics defined on a type or impl, returns a substitution mapping each\ntype/region parameter to a fresh inference variable.",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"fresh_substs_for_trait","","Given a set of generics defined on a trait, returns a substitution mapping each output\ntype/region parameter to a fresh inference variable, and mapping the self type to\n`self_ty`.",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"fresh_bound_region","","",94,{"inputs":[{"name":"inferctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"resolve_regions_and_report_errors","","",94,null],[11,"ty_to_string","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"string"}}],[11,"tys_to_string","","",94,null],[11,"trait_ref_to_string","","",94,{"inputs":[{"name":"inferctxt"},{"name":"rc"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in\n`value` with their final value. Note that region variables\nare unaffected. If a type variable has not been unified, it\nis left as is.  This is an idempotent operation that does\nnot affect inference state in any way and so you can do it\nat will.",94,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in\n`value`. Region inference must have been run already (e.g.,\nby calling `resolve_regions_and_report_errors`).  If some\nvariable was never unified, an `Err` results.",94,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[11,"type_error_message_str","","",94,null],[11,"type_error_message_str_with_expected","","",94,null],[11,"type_error_message","","",94,null],[11,"report_mismatched_types","","",94,null],[11,"replace_late_bound_regions_with_fresh_var","","",94,null],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_inference`",94,null],[11,"can_equate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"span","","",131,{"inputs":[{"name":"typetrace"}],"output":{"name":"span"}}],[11,"types","","",131,{"inputs":[{"name":"typetrace"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"typetrace"}}],[11,"dummy","","",131,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"typetrace"}}],[11,"repr","","",131,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",129,{"inputs":[{"name":"typeorigin"}],"output":{"name":"span"}}],[11,"repr","","",129,{"inputs":[{"name":"typeorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",132,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"span"}}],[11,"repr","","",132,{"inputs":[{"name":"subregionorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",134,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"span"}}],[11,"repr","","",134,{"inputs":[{"name":"regionvariableorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::implicator","",136,{"inputs":[{"name":"implication"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"hash","rustc::middle::lang_items","",137,null],[11,"eq","","",137,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"langitem"}],"output":{"name":"langitem"}}],[11,"from_u32","","",137,{"inputs":[{"name":"langitem"},{"name":"u32"}],"output":{"name":"option"}}],[11,"new","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"languageitems"}}],[11,"items","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"enumerate"}}],[11,"item_name","","",138,{"inputs":[{"name":"languageitems"},{"name":"usize"}],"output":{"name":"str"}}],[11,"require","","",138,{"inputs":[{"name":"languageitems"},{"name":"langitem"}],"output":{"name":"result"}}],[11,"from_builtin_kind","","",138,{"inputs":[{"name":"languageitems"},{"name":"builtinbound"}],"output":{"name":"result"}}],[11,"to_builtin_kind","","",138,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"fn_trait_kind","","",138,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"char_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"slice_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"const_ptr_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mut_ptr_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i8_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i16_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i32_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i64_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"isize_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u8_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u16_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u32_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u64_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"usize_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f32_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f64_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"send_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sized_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"copy_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sync_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"drop_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"add_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sub_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mul_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"div_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"rem_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"neg_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"not_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitxor_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitand_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitor_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shl_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shr_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_mut_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_from_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_to_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_full_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"unsafe_cell_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_mut_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_mut_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_once_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eq_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"ord_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_eq_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_bounds_check_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fmt","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_malloc_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_free_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"strdup_uniq_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"start_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eh_personality","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_heap","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"owned_box","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"phantom_data","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_lifetime","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_lifetime","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_lifetime","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"no_copy_bound","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"managed_bound","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"non_zero","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"stack_exhausted","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"debug_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"visit_item","","",139,null],[11,"new","","",139,{"inputs":[{"name":"languageitemcollector"},{"name":"session"}],"output":{"name":"languageitemcollector"}}],[11,"collect_item","","",139,null],[11,"collect_local_language_items","","",139,null],[11,"collect_external_language_items","","",139,null],[11,"collect","","",139,null],[11,"eq","rustc::middle::liveness","",140,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"variable"}],"output":{"name":"variable"}}],[11,"eq","","",141,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"fmt","","",142,{"inputs":[{"name":"livenodekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",142,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"clone","","",142,{"inputs":[{"name":"livenodekind"}],"output":{"name":"livenodekind"}}],[11,"visit_fn","","",143,null],[11,"visit_local","","",143,null],[11,"visit_expr","","",143,null],[11,"visit_arm","","",143,null],[11,"fmt","","",141,{"inputs":[{"name":"livenode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",140,{"inputs":[{"name":"variable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",144,{"inputs":[{"name":"localinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"localinfo"}],"output":{"name":"localinfo"}}],[11,"fmt","","",145,{"inputs":[{"name":"varkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",145,{"inputs":[{"name":"varkind"}],"output":{"name":"varkind"}}],[11,"visit_fn","","",146,null],[11,"visit_local","","",146,null],[11,"visit_expr","","",146,null],[11,"visit_arm","","",146,null],[11,"clone","","",147,{"inputs":[{"name":"users"}],"output":{"name":"users"}}],[11,"clone","","",148,{"inputs":[{"name":"specials"}],"output":{"name":"specials"}}],[11,"fmt","rustc::middle::mem_categorization","",149,{"inputs":[{"name":"categorization"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",149,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",149,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",149,{"inputs":[{"name":"categorization"}],"output":{"name":"categorization"}}],[11,"fmt","","",150,{"inputs":[{"name":"upvar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",150,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",150,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",150,{"inputs":[{"name":"upvar"}],"output":{"name":"upvar"}}],[11,"fmt","","",151,{"inputs":[{"name":"pointerkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",151,null],[11,"eq","","",151,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"clone","","",151,{"inputs":[{"name":"pointerkind"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",152,{"inputs":[{"name":"interiorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",152,null],[11,"eq","","",152,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"interiorkind"}],"output":{"name":"interiorkind"}}],[11,"fmt","","",153,{"inputs":[{"name":"fieldname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",153,null],[11,"eq","","",153,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"fieldname"}],"output":{"name":"fieldname"}}],[11,"fmt","","",154,{"inputs":[{"name":"interioroffsetkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",154,null],[11,"eq","","",154,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"clone","","",154,{"inputs":[{"name":"interioroffsetkind"}],"output":{"name":"interioroffsetkind"}}],[11,"fmt","","",155,{"inputs":[{"name":"elementkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",155,null],[11,"eq","","",155,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"elementkind"}],"output":{"name":"elementkind"}}],[11,"fmt","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",156,null],[11,"eq","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"fmt","","",157,{"inputs":[{"name":"note"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",157,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"clone","","",157,{"inputs":[{"name":"note"}],"output":{"name":"note"}}],[11,"fmt","","",158,{"inputs":[{"name":"cmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",158,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",158,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"clone","","",158,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"clone","","",159,{"inputs":[{"name":"deref_kind"}],"output":{"name":"deref_kind"}}],[11,"id","syntax::ast","",160,{"inputs":[{"name":"expr"}],"output":{"name":"u32"}}],[11,"span","","",160,{"inputs":[{"name":"expr"}],"output":{"name":"span"}}],[11,"id","","",161,{"inputs":[{"name":"pat"}],"output":{"name":"u32"}}],[11,"span","","",161,{"inputs":[{"name":"pat"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",162,{"inputs":[{"name":"memcategorizationcontext"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"is_immutable","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"to_user_str","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"str"}}],[11,"new","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"typer"}],"output":{"name":"memcategorizationcontext"}}],[11,"cat_expr","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_expr_autoderefd","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"},{"name":"usize"}],"output":{"name":"result"}}],[11,"cat_expr_unadjusted","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_def","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"},{"name":"def"}],"output":{"name":"result"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`.\nThis could be `'static` if `id` is part of a constant expression.",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_rvalue","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"region"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_field","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"name"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_tup_field","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"usize"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"interioroffsetkind"}],"output":{"name":"result"}}],[11,"cat_slice_pattern","","Given a pattern P like: `[_, ..Q, _]`, where `vec_cmt` is the cmt for `P`, `slice_pat` is\nthe pattern `Q`, returns:",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"}],"output":{"name":"result"}}],[11,"cat_imm_interior","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"interiorkind"}],"output":{"name":"rc"}}],[11,"cat_downcast","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"defid"}],"output":{"name":"rc"}}],[11,"cat_pattern","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"},{"name":"f"}],"output":{"name":"result"}}],[11,"fmt","","",163,{"inputs":[{"name":"interiorsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",163,{"inputs":[{"name":"interiorsafety"}],"output":{"name":"interiorsafety"}}],[11,"fmt","","",164,{"inputs":[{"name":"aliasability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",164,{"inputs":[{"name":"aliasability"}],"output":{"name":"aliasability"}}],[11,"fmt","","",165,{"inputs":[{"name":"aliasablereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",165,{"inputs":[{"name":"aliasablereason"}],"output":{"name":"aliasablereason"}}],[11,"guarantor","","Returns `self` after stripping away any owned pointer derefs or\ninterior content. The return value is basically the `cmt` which\ndetermines how long the value in `self` remains live.",158,{"inputs":[{"name":"cmt_"}],"output":{"name":"rc"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this lvalue represents a freely aliasable pointer type.",158,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"aliasability"}}],[11,"upvar","","",158,{"inputs":[{"name":"cmt_"}],"output":{"name":"option"}}],[11,"descriptive_string","","",158,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",158,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",149,{"inputs":[{"name":"categorization"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",151,{"inputs":[{"name":"pointerkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",152,{"inputs":[{"name":"interiorkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",166,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::mem_categorization","",150,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",150,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::privacy","",167,{"inputs":[{"name":"lastprivate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",167,{"inputs":[{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"fmt","","",168,{"inputs":[{"name":"privatedep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",168,{"inputs":[{"name":"privatedep"}],"output":{"name":"privatedep"}}],[11,"fmt","","",169,{"inputs":[{"name":"importuse"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",169,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"ne","","",169,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"clone","","",169,{"inputs":[{"name":"importuse"}],"output":{"name":"importuse"}}],[11,"or","","",167,{"inputs":[{"name":"lastprivate"},{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"visit_expr","rustc::middle::reachable","",170,null],[11,"visit_item","","",170,null],[11,"fmt","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",18,{"inputs":[{"name":"codeextent"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"codeextent"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",18,null],[11,"cmp","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"eq","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"fmt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",19,null],[11,"cmp","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"option"}}],[11,"lt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"le","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"gt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ge","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"eq","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"destructionscopedata"}}],[11,"new","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"u32"}],"output":{"name":"destructionscopedata"}}],[11,"to_code_extent","","",19,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"codeextent"}}],[11,"fmt","","",171,{"inputs":[{"name":"blockremainder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",171,{"inputs":[{"name":"blockremainder"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",171,{"inputs":[{"name":"blockremainder"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",171,null],[11,"cmp","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"option"}}],[11,"lt","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"eq","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"clone","","",171,{"inputs":[{"name":"blockremainder"}],"output":{"name":"blockremainder"}}],[11,"from_node_id","","Creates a scope that represents the dynamic extent associated\nwith `node_id`.",18,{"inputs":[{"name":"codeextent"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"node_id","","Returns a node id associated with this scope.",18,{"inputs":[{"name":"codeextent"}],"output":{"name":"u32"}}],[11,"map_id","","Maps this scope to a potentially new one according to the\nNodeId transformer `f_id`.",18,{"inputs":[{"name":"codeextent"},{"name":"f"}],"output":{"name":"codeextent"}}],[11,"span","","Returns the span of this CodeExtent.  Note that in general the\nreturned span may not correspond to the span of any node id in\nthe AST.",18,{"inputs":[{"name":"codeextent"},{"name":"map"}],"output":{"name":"option"}}],[11,"clone","","",172,{"inputs":[{"name":"innermostdeclaringblock"}],"output":{"name":"innermostdeclaringblock"}}],[11,"fmt","","",172,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",172,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"ne","","",172,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"clone","","",173,{"inputs":[{"name":"declaringstatementcontext"}],"output":{"name":"declaringstatementcontext"}}],[11,"fmt","","",173,{"inputs":[{"name":"declaringstatementcontext"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",173,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"ne","","",173,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"clone","","",174,{"inputs":[{"name":"innermostenclosingexpr"}],"output":{"name":"innermostenclosingexpr"}}],[11,"fmt","","",174,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",174,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"ne","","",174,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"clone","","",175,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"fmt","","",175,{"inputs":[{"name":"context"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"each_encl_scope","","",176,null],[11,"each_var_scope","","",176,null],[11,"each_rvalue_scope","","",176,null],[11,"each_terminating_scope","","",176,null],[11,"record_encl_scope","","",176,null],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",176,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",176,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",176,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"region"}}],[11,"scopes_intersect","","",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false\notherwise.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest\nscope which is greater than or equal to both `scope_a` and `scope_b`.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"visit_block","","",177,null],[11,"visit_item","","",177,null],[11,"visit_fn","","",177,null],[11,"visit_arm","","",177,null],[11,"visit_pat","","",177,null],[11,"visit_stmt","","",177,null],[11,"visit_expr","","",177,null],[11,"visit_local","","",177,null],[11,"fmt","rustc::middle::resolve_lifetime","",178,{"inputs":[{"name":"defregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",178,{"inputs":[{"name":"defregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",178,{"inputs":[{"name":"defregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",178,null],[11,"eq","","",178,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"ne","","",178,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"clone","","",178,{"inputs":[{"name":"defregion"}],"output":{"name":"defregion"}}],[11,"visit_item","","",179,null],[11,"visit_fn","","",179,null],[11,"visit_ty","","",179,null],[11,"visit_trait_item","","",179,null],[11,"visit_block","","",179,null],[11,"visit_lifetime_ref","","",179,null],[11,"visit_generics","","",179,null],[11,"visit_poly_trait_ref","","",179,null],[11,"eq","","",180,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"ne","","",180,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"clone","","",180,{"inputs":[{"name":"shadowkind"}],"output":{"name":"shadowkind"}}],[11,"fmt","","",181,{"inputs":[{"name":"scopechain"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"visit_item","rustc::middle::stability","",182,null],[11,"visit_fn","","",182,null],[11,"visit_trait_item","","",182,null],[11,"visit_impl_item","","",182,null],[11,"visit_variant","","",182,null],[11,"visit_struct_field","","",182,null],[11,"visit_foreign_item","","",182,null],[11,"build","","Construct the stability index for a crate being compiled.",183,null],[11,"new","","",183,{"inputs":[{"name":"index"},{"name":"crate"}],"output":{"name":"index"}}],[11,"visit_item","","",184,null],[11,"visit_expr","","",184,null],[11,"visit_path","","",184,null],[11,"visit_pat","","",184,null],[11,"fmt","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",185,null],[11,"eq","","",185,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"fmt","","",186,{"inputs":[{"name":"regionsubsts"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",186,null],[11,"eq","","",186,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"ne","","",186,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"clone","","",186,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"regionsubsts"}}],[11,"new","","",185,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"new_type","","",185,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"new_trait","","",185,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erased","","",185,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"empty","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"trans_empty","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"is_noop","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"type_for_def","","",185,{"inputs":[{"name":"substs"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[11,"has_regions_escaping_depth","","",185,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"self_ty","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"option"}}],[11,"with_self_ty","","",185,{"inputs":[{"name":"substs"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erase_regions","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",185,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"mut_regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",185,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"with_method","","",185,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"is_erased","","",186,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"fmt","","",187,{"inputs":[{"name":"paramspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",187,{"inputs":[{"name":"paramspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",187,{"inputs":[{"name":"paramspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",187,null],[11,"clone","","",187,{"inputs":[{"name":"paramspace"}],"output":{"name":"paramspace"}}],[11,"eq","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ne","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"cmp","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"lt","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"le","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"gt","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ge","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"all","","",187,null],[11,"to_uint","","",187,{"inputs":[{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"from_uint","","",187,{"inputs":[{"name":"paramspace"},{"name":"usize"}],"output":{"name":"paramspace"}}],[11,"decode","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",188,null],[11,"clone","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"eq","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"ne","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"fmt","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"params_from_type","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"new","","`t` is the type space.\n`s` is the self space.\n`a` is the assoc space.\n`f` is the fn space.",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"push","","Appends `value` to the vector associated with `space`.",188,null],[11,"extend","","Appends `values` to the vector associated with `space`.",188,null],[11,"pop","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"truncate","","",188,null],[11,"replace","","",188,null],[11,"get_self","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"option"}}],[11,"len","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"is_empty_in","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"get_slice","","",188,null],[11,"get_mut_slice","","",188,null],[11,"opt_get","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"t"}}],[11,"iter","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"iter"}}],[11,"into_iter","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[11,"iter_enumerated","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"enumerateditems"}}],[11,"as_slice","","",188,null],[11,"into_vec","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vec"}}],[11,"all_vecs","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"all","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"any","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"is_empty","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"map","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_enumerated","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_move","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"split","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"separatevecsperparamspace"}}],[11,"with_vec","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"clone","","",189,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"enumerateditems"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::subst","",189,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"option"}}],[6,"Item","rustc_lint::lint","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","rustc::middle::subst","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[6,"Item","rustc_lint::lint","",null,null],[6,"IntoIter","","",null,null],[11,"tcx","rustc::middle::subst","",190,{"inputs":[{"name":"substfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",190,null],[11,"exit_region_binder","","",190,null],[11,"fold_region","","",190,{"inputs":[{"name":"substfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",190,{"inputs":[{"name":"substfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","rustc::middle::traits::coherence","",191,{"inputs":[{"name":"inferislocal"}],"output":{"name":"inferislocal"}}],[11,"clone","rustc::middle::traits::fulfill","",192,{"inputs":[{"name":"regionobligation"}],"output":{"name":"regionobligation"}}],[11,"new","","",193,{"inputs":[{"name":"fulfillmentcontext"}],"output":{"name":"fulfillmentcontext"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by\ncreating a fresh type variable `$0` as well as a projection\npredicate `<SomeType as SomeTrait>::X == $0`. When the\ninference engine runs, it will attempt to find an impl of\n`SomeTrait` or a where clause that lets us unify `$0` with\nsomething concrete. If this fails, we'll unify `$0` with\n`projection_ty` again.",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"tys"}}],[11,"register_builtin_bound","","",193,null],[11,"register_region_obligation","","",193,null],[11,"register_predicate_obligation","","",193,null],[11,"region_obligations","","",193,null],[11,"select_all_or_error","","",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_new_obligations","","Attempts to select obligations that were registered since the call to a selection routine.\nThis is used by the type checker to eagerly attempt to resolve obligations in hopes of\ngaining type information. It'd be equally valid to use `select_where_possible` but it\nresults in `O(n^2)` performance (#18208).",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_where_possible","","",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"pending_obligations","","",193,null],[11,"repr","","",192,{"inputs":[{"name":"regionobligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::project","",194,{"inputs":[{"name":"mismatchedprojectiontypes"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"eq","","",195,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"ne","","",195,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"tcx","","",196,{"inputs":[{"name":"associatedtypenormalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",196,{"inputs":[{"name":"associatedtypenormalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","","",197,{"inputs":[{"name":"normalized"}],"output":{"name":"normalized"}}],[11,"with","","",197,{"inputs":[{"name":"normalized"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"repr","","",198,{"inputs":[{"name":"projectiontyerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",195,{"inputs":[{"name":"projectiontycandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","","",197,{"inputs":[{"name":"normalized"},{"name":"f"}],"output":{"name":"normalized"}}],[11,"repr","","",197,{"inputs":[{"name":"normalized"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::traits::object_safety","",199,{"inputs":[{"name":"methodviolationcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",199,{"inputs":[{"name":"methodviolationcode"}],"output":{"name":"methodviolationcode"}}],[11,"repr","","",200,{"inputs":[{"name":"objectsafetyviolation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::select","",201,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"fmt","","",202,{"inputs":[{"name":"methodmatcheddata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",202,{"inputs":[{"name":"methodmatcheddata"}],"output":{"name":"methodmatcheddata"}}],[11,"clone","","",203,{"inputs":[{"name":"selectioncandidate"}],"output":{"name":"selectioncandidate"}}],[11,"fmt","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"ne","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"fmt","","",204,{"inputs":[{"name":"evaluationresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",205,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",205,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"infcx","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"ctxt"}}],[11,"param_env","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"parameterenvironment"}}],[11,"closure_typer","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"closuretyper"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding\ntype environment by performing unification.",205,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"result"}}],[11,"evaluate_obligation","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",205,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"evaluate_impl","","Evaluates whether the impl with id `impl_def_id` could be applied to the self type\n`obligation_self_ty`. This can be used either for trait or inherent impls.",205,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"repr","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","","",201,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"clone","","",206,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"traitobligationstacklist"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::traits::select","",206,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"option"}}],[11,"repr","","",207,{"inputs":[{"name":"traitobligationstack"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"may_apply","","",208,{"inputs":[{"name":"methodmatchresult"}],"output":{"name":"bool"}}],[11,"filter_to_traits","rustc::middle::traits::util","",209,{"inputs":[{"name":"elaborator"}],"output":{"name":"filtertotraits"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::traits::util","",209,{"inputs":[{"name":"elaborator"}],"output":{"name":"option"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::traits::util","",210,{"inputs":[{"name":"supertraitdefids"}],"output":{"name":"option"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::traits::util","",211,{"inputs":[{"name":"filtertotraits"}],"output":{"name":"option"}}],[11,"fmt","rustc::middle::traits","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",214,{"inputs":[{"name":"obligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",215,{"inputs":[{"name":"vtable"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",218,{"inputs":[{"name":"selectionerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",219,{"inputs":[{"name":"fulfillmenterror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",220,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",220,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","rustc::middle::traits::project","",194,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",194,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","rustc::middle::traits","",214,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",214,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"clone","","",214,{"inputs":[{"name":"obligation"}],"output":{"name":"obligation"}}],[11,"eq","","",221,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",221,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",221,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"eq","","",222,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",222,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"clone","","",222,{"inputs":[{"name":"obligationcausecode"}],"output":{"name":"obligationcausecode"}}],[11,"eq","","",223,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",223,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",223,{"inputs":[{"name":"derivedobligationcause"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",218,{"inputs":[{"name":"selectionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",218,{"inputs":[{"name":"selectionerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",220,{"inputs":[{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",215,{"inputs":[{"name":"vtable"}],"output":{"name":"vtable"}}],[11,"fmt","","",215,{"inputs":[{"name":"vtable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"clone","","",212,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"vtableimpldata"}}],[11,"clone","","",217,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fmt","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",216,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"vtablebuiltindata"}}],[11,"fmt","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",213,{"inputs":[{"name":"vtableobjectdata"}],"output":{"name":"vtableobjectdata"}}],[11,"eq","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"new","","",214,{"inputs":[{"name":"obligation"},{"name":"obligationcause"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",214,{"inputs":[{"name":"obligation"},{"name":"span"},{"name":"u32"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",214,{"inputs":[{"name":"obligation"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",221,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",221,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",221,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"iter_nested","","",215,{"inputs":[{"name":"vtable"}],"output":{"name":"iter"}}],[11,"map_nested","","",215,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"map_move_nested","","",215,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"iter_nested","","",212,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"map_move_nested","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"iter_nested","","",217,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"map_move_nested","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"iter_nested","","",216,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"iter"}}],[11,"map_nested","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"map_move_nested","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"hash","rustc::middle::ty","",224,null],[11,"eq","","",224,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",224,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",224,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",225,{"inputs":[{"name":"implortraititemcontainer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",225,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"implortraititemcontainer"}}],[11,"id","","",225,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"defid"}}],[11,"fmt","","",226,{"inputs":[{"name":"implortraititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititem"}}],[11,"def_id","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"defid"}}],[11,"name","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"name"}}],[11,"container","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititemcontainer"}}],[11,"as_opt_method","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"option"}}],[11,"fmt","","",227,{"inputs":[{"name":"implortraititemid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",227,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"implortraititemid"}}],[11,"def_id","","",227,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"defid"}}],[11,"fmt","","",228,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",228,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"new","","",228,{"inputs":[{"name":"method"},{"name":"name"},{"name":"generics"},{"name":"genericpredicates"},{"name":"barefnty"},{"name":"explicitselfcategory"},{"name":"visibility"},{"name":"defid"},{"name":"implortraititemcontainer"},{"name":"option"}],"output":{"name":"method"}}],[11,"container_id","","",228,{"inputs":[{"name":"method"}],"output":{"name":"defid"}}],[11,"fmt","","",229,{"inputs":[{"name":"associatedtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",229,{"inputs":[{"name":"associatedtype"}],"output":{"name":"associatedtype"}}],[11,"fmt","","",230,{"inputs":[{"name":"mt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",230,null],[11,"eq","","",230,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"ne","","",230,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"clone","","",230,{"inputs":[{"name":"mt"}],"output":{"name":"mt"}}],[11,"fmt","","",231,{"inputs":[{"name":"field_ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",231,{"inputs":[{"name":"field_ty"}],"output":{"name":"field_ty"}}],[11,"hash","","",232,null],[11,"eq","","",232,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"ne","","",232,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"clone","","",232,{"inputs":[{"name":"creader_cache_key"}],"output":{"name":"creader_cache_key"}}],[11,"encode","","",233,{"inputs":[{"name":"itemvariances"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",233,{"inputs":[{"name":"itemvariances"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",233,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"ne","","",233,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"clone","","",233,{"inputs":[{"name":"itemvariances"}],"output":{"name":"itemvariances"}}],[11,"fmt","","",234,{"inputs":[{"name":"variance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",234,{"inputs":[{"name":"variance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",234,{"inputs":[{"name":"variance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",234,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"ne","","",234,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"clone","","",234,{"inputs":[{"name":"variance"}],"output":{"name":"variance"}}],[11,"fmt","","",235,{"inputs":[{"name":"autoadjustment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",235,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"autoadjustment"}}],[11,"fmt","","",236,{"inputs":[{"name":"autoderefref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",236,{"inputs":[{"name":"autoderefref"}],"output":{"name":"autoderefref"}}],[11,"fmt","","",237,{"inputs":[{"name":"autoref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",237,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"ne","","",237,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"clone","","",237,{"inputs":[{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fmt","","",238,{"inputs":[{"name":"param_index"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"option"}}],[11,"lt","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"le","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"gt","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ge","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"eq","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ne","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"decode","","",238,{"inputs":[{"name":"param_index"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",238,{"inputs":[{"name":"param_index"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"param_index"}],"output":{"name":"param_index"}}],[11,"fmt","","",25,{"inputs":[{"name":"methodorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"methodorigin"}],"output":{"name":"methodorigin"}}],[11,"fmt","","",239,{"inputs":[{"name":"methodparam"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",239,{"inputs":[{"name":"methodparam"}],"output":{"name":"methodparam"}}],[11,"fmt","","",240,{"inputs":[{"name":"methodobject"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",240,{"inputs":[{"name":"methodobject"}],"output":{"name":"methodobject"}}],[11,"clone","","",241,{"inputs":[{"name":"methodcallee"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",242,{"inputs":[{"name":"methodcall"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",242,null],[11,"eq","","",242,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"ne","","",242,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"clone","","",242,{"inputs":[{"name":"methodcall"}],"output":{"name":"methodcall"}}],[11,"expr","","",242,{"inputs":[{"name":"methodcall"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"autoderef","","",242,{"inputs":[{"name":"methodcall"},{"name":"u32"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"clone","","",243,{"inputs":[{"name":"vtable_origin"}],"output":{"name":"vtable_origin"}}],[11,"clone","","",88,{"inputs":[{"name":"transmuterestriction"}],"output":{"name":"transmuterestriction"}}],[11,"new","","",244,{"inputs":[{"name":"ctxtarenas"}],"output":{"name":"ctxtarenas"}}],[11,"node_types","","",245,{"inputs":[{"name":"ctxt"}],"output":{"name":"ref"}}],[11,"node_type_insert","","",245,null],[11,"store_free_region_map","","",245,null],[11,"free_region_map","","",245,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"freeregionmap"}}],[11,"hash","","",246,null],[11,"cmp","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"option"}}],[11,"lt","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"clone","","",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"eq","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",246,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",246,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",246,null],[11,"remove","","Removes the specified flags in-place.",246,null],[11,"toggle","","Toggles the specified flags in-place.",246,null],[6,"Output","rustc_lint::lint","",null,null],[11,"bitor","rustc::middle::ty","Returns the union of the two sets of flags.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitxor","rustc::middle::ty","Returns the left flags, but with all the right flags toggled.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitand","rustc::middle::ty","Returns the intersection between the two sets of flags.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"sub","rustc::middle::ty","Returns the set difference of the two sets of flags.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"not","rustc::middle::ty","Returns the complement of this set of flags.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"print_debug_stats","","",245,null],[11,"fmt","","",247,{"inputs":[{"name":"tys"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",246,{"inputs":[{"name":"typeflags"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",247,{"inputs":[{"name":"tys"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",247,null],[11,"eq","","",248,{"inputs":[{"name":"internedty"},{"name":"internedty"}],"output":{"name":"bool"}}],[11,"hash","","",248,null],[11,"borrow","","",248,{"inputs":[{"name":"internedty"}],"output":{"name":"sty"}}],[11,"fmt","","",249,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",249,null],[11,"eq","","",249,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",249,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",249,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",250,{"inputs":[{"name":"closurety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",250,null],[11,"eq","","",250,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"ne","","",250,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"clone","","",250,{"inputs":[{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fmt","","",251,{"inputs":[{"name":"fnoutput"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",251,null],[11,"eq","","",251,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"ne","","",251,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"clone","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"diverges","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"unwrap","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"tys"}}],[11,"unwrap_or","","",251,{"inputs":[{"name":"fnoutput"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"diverges","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"hash","","",252,null],[11,"eq","","",252,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",252,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"clone","","",252,{"inputs":[{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"inputs","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"input","","",96,{"inputs":[{"name":"binder"},{"name":"usize"}],"output":{"name":"binder"}}],[11,"output","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"variadic","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"fmt","","",253,{"inputs":[{"name":"paramty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",253,null],[11,"eq","","",253,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",253,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"clone","","",253,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"fmt","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",254,null],[11,"eq","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"clone","","",254,{"inputs":[{"name":"debruijnindex"}],"output":{"name":"debruijnindex"}}],[11,"fmt","","",16,{"inputs":[{"name":"region"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"region"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"region"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",16,null],[11,"eq","","",16,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"region"}],"output":{"name":"region"}}],[11,"fmt","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",255,null],[11,"eq","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"clone","","",255,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"earlyboundregion"}}],[11,"fmt","","",256,{"inputs":[{"name":"upvarid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",256,null],[11,"eq","","",256,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",256,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"clone","","",256,{"inputs":[{"name":"upvarid"}],"output":{"name":"upvarid"}}],[11,"decode","","",257,{"inputs":[{"name":"borrowkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",257,{"inputs":[{"name":"borrowkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",257,{"inputs":[{"name":"borrowkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",257,null],[11,"eq","","",257,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"clone","","",257,{"inputs":[{"name":"borrowkind"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"upvarcapture"}],"output":{"name":"upvarcapture"}}],[11,"eq","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"fmt","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"upvarborrow"}],"output":{"name":"upvarborrow"}}],[11,"eq","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"is_bound","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",16,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"fmt","","",17,{"inputs":[{"name":"freeregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"freeregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"freeregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",17,null],[11,"cmp","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"option"}}],[11,"lt","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"eq","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"freeregion"}],"output":{"name":"freeregion"}}],[11,"fmt","","",20,{"inputs":[{"name":"boundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",20,{"inputs":[{"name":"boundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",20,{"inputs":[{"name":"boundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",20,null],[11,"cmp","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"lt","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"eq","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"boundregion"}],"output":{"name":"boundregion"}}],[11,"fmt","","",258,{"inputs":[{"name":"sty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",258,null],[11,"eq","","",258,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"clone","","",258,{"inputs":[{"name":"sty"}],"output":{"name":"sty"}}],[11,"fmt","","",259,{"inputs":[{"name":"tytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",259,null],[11,"eq","","",259,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"clone","","",259,{"inputs":[{"name":"tytrait"}],"output":{"name":"tytrait"}}],[11,"principal_def_id","","",259,{"inputs":[{"name":"tytrait"}],"output":{"name":"defid"}}],[11,"principal_trait_ref_with_self_ty","","Object types don't have a self-type specified. Therefore, when\nwe convert the principal trait-ref into a normal trait-ref,\nyou must give *some* self-type. A common choice is `mk_err()`\nor some skolemized type.",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"binder"}}],[11,"projection_bounds_with_self_ty","","",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"vec"}}],[11,"fmt","","",260,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",260,null],[11,"eq","","",260,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",260,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"self_ty","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"tys"}}],[11,"def_id","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"substs","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"substs"}}],[11,"input_types","","",96,null],[11,"to_poly_trait_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"fmt","","",96,{"inputs":[{"name":"binder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",96,null],[11,"eq","","",96,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",96,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"clone","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a\nrisky thing to do because it's easy to get confused about\ndebruijn indices and the like. It is usually better to\ndischarge the binder using `no_late_bound_regions` or\n`replace_late_bound_regions` or something like\nthat. `skip_binder` is only valid when you are either\nextracting data that has nothing to do with bound regions, you\nare doing some sort of test that does not involve bound\nregions, or you are being very careful about your depth\naccounting.",96,{"inputs":[{"name":"binder"}],"output":{"name":"t"}}],[11,"as_ref","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",96,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",96,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"eq","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"intvarvalue"}],"output":{"name":"intvarvalue"}}],[11,"fmt","","",261,{"inputs":[{"name":"terr_vstore_kind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",261,{"inputs":[{"name":"terr_vstore_kind"}],"output":{"name":"terr_vstore_kind"}}],[11,"fmt","","",262,{"inputs":[{"name":"expected_found"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",262,{"inputs":[{"name":"expected_found"}],"output":{"name":"expected_found"}}],[11,"fmt","","",263,{"inputs":[{"name":"type_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",263,{"inputs":[{"name":"type_err"}],"output":{"name":"type_err"}}],[11,"fmt","","",264,{"inputs":[{"name":"parambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",264,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"hash","","",264,null],[11,"eq","","",264,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"ne","","",264,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"fmt","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",265,{"inputs":[{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"hash","","",265,null],[11,"eq","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"fmt","","",266,{"inputs":[{"name":"builtinbound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",266,null],[11,"decode","","",266,{"inputs":[{"name":"builtinbound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",266,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"ne","","",266,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"encode","","",266,{"inputs":[{"name":"builtinbound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",266,{"inputs":[{"name":"builtinbound"}],"output":{"name":"builtinbound"}}],[11,"to_usize","","",266,{"inputs":[{"name":"builtinbound"}],"output":{"name":"usize"}}],[11,"from_usize","","",266,{"inputs":[{"name":"builtinbound"},{"name":"usize"}],"output":{"name":"builtinbound"}}],[11,"hash","","",267,null],[11,"eq","","",267,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",267,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"clone","","",267,{"inputs":[{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"hash","","",125,null],[11,"eq","","",125,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"intvid"}],"output":{"name":"intvid"}}],[11,"hash","","",127,null],[11,"eq","","",127,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"floatvid"}],"output":{"name":"floatvid"}}],[11,"hash","","",268,null],[11,"decode","","",268,{"inputs":[{"name":"regionvid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",268,{"inputs":[{"name":"regionvid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",268,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",268,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"clone","","",268,{"inputs":[{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"hash","","",269,null],[11,"eq","","",269,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",269,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"clone","","",269,{"inputs":[{"name":"inferty"}],"output":{"name":"inferty"}}],[11,"fmt","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",270,null],[11,"eq","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"ne","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"decode","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",270,{"inputs":[{"name":"unconstrainednumeric"}],"output":{"name":"unconstrainednumeric"}}],[11,"fmt","","",271,{"inputs":[{"name":"inferregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",271,null],[11,"decode","","",271,{"inputs":[{"name":"inferregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",271,{"inputs":[{"name":"inferregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",271,{"inputs":[{"name":"inferregion"}],"output":{"name":"inferregion"}}],[11,"eq","","",271,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"ne","","",271,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"fmt","","",267,{"inputs":[{"name":"tyvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",125,{"inputs":[{"name":"intvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",127,{"inputs":[{"name":"floatvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",268,{"inputs":[{"name":"regionvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",252,{"inputs":[{"name":"fnsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",269,{"inputs":[{"name":"inferty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",272,{"inputs":[{"name":"objectlifetimedefault"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",272,{"inputs":[{"name":"objectlifetimedefault"}],"output":{"name":"objectlifetimedefault"}}],[11,"fmt","","",273,{"inputs":[{"name":"typeparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",273,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"typeparameterdef"}}],[11,"fmt","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",274,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"regionparameterdef"}}],[11,"decode","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"to_early_bound_region","","",274,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"to_bound_region","","",274,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"boundregion"}}],[11,"fmt","","",275,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",275,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"empty","","",275,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_empty","","",275,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"has_type_params","","",275,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"has_region_params","","",275,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"fmt","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",276,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"empty","","",276,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_supertrait","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"instantiatedpredicates"}}],[11,"fmt","","",277,{"inputs":[{"name":"predicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",277,null],[11,"eq","","",277,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",277,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"clone","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substituion suitable for going from a\npoly-trait-ref to supertraits that must hold if that\npoly-trait-ref holds. This is slightly different from a normal\nsubstitution in terms of what happens with bound regions.  See\nlengthy comment below for details.",277,{"inputs":[{"name":"predicate"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"predicate"}}],[11,"fmt","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",278,null],[11,"eq","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"traitpredicate"}}],[11,"def_id","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"defid"}}],[11,"input_types","","",278,null],[11,"self_ty","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"tys"}}],[11,"def_id","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"fmt","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",279,null],[11,"eq","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",279,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"equatepredicate"}}],[11,"fmt","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",280,null],[11,"eq","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"clone","","",280,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"outlivespredicate"}}],[11,"fmt","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",281,null],[11,"eq","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",281,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"projectionpredicate"}}],[11,"item_name","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"name"}}],[11,"sort_key","","",96,null],[11,"fmt","","",282,{"inputs":[{"name":"projectionty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",282,null],[11,"eq","","",282,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",282,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"clone","","",282,{"inputs":[{"name":"projectionty"}],"output":{"name":"projectionty"}}],[11,"sort_key","","",282,null],[11,"to_poly_trait_ref","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","rustc::middle::ty","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"as_predicate","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"predicate"}}],[11,"as_predicate","rustc::middle::ty","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all\ncases this is skipping over a binder, so late-bound regions\nwith depth 0 are bound by the predicate.",277,{"inputs":[{"name":"predicate"}],"output":{"name":"intoiter"}}],[11,"has_escaping_regions","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"to_opt_poly_trait_ref","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"option"}}],[11,"fmt","","",283,{"inputs":[{"name":"instantiatedpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"has_escaping_regions","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"is_empty","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"new","","",260,{"inputs":[{"name":"traitref"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"tys"}}],[11,"input_types","","",260,null],[11,"clone","","",284,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"with_caller_bounds","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"vec"}],"output":{"name":"parameterenvironment"}}],[11,"for_item","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[11,"fmt","","",285,{"inputs":[{"name":"typescheme"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",285,{"inputs":[{"name":"typescheme"}],"output":{"name":"typescheme"}}],[11,"clone","","",286,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"decode","","",166,{"inputs":[{"name":"closurekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",166,{"inputs":[{"name":"closurekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",166,{"inputs":[{"name":"closurekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ne","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"cmp","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"option"}}],[11,"lt","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"le","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"gt","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ge","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"clone","","",166,{"inputs":[{"name":"closurekind"}],"output":{"name":"closurekind"}}],[11,"trait_did","","",166,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind\nmust also implement `other`.",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"mk_substs","","",245,{"inputs":[{"name":"ctxt"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"safe_to_unsafe_fn_ty","","Create an unsafe fn ty based on a safe fn ty.",245,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"tys"}}],[11,"mk_bare_fn","","",245,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"mk_region","","",245,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"region"}}],[11,"closure_kind","","",245,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"closurekind"}}],[11,"closure_type","","",245,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"type_parameter_def","","",245,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"typeparameterdef"}}],[11,"pat_contains_ref_binding","","",245,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"arm_contains_ref_binding","","",245,{"inputs":[{"name":"ctxt"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"walk","","Iterator that walks `self` and any types reachable from\n`self`, in depth-first order. Note that just walks the types\nthat appear in `self`, it does not descend into the fields of\nstructs or variants. For example:",247,{"inputs":[{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence\n`Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]`\n(but not `i32`, like `walk`).",247,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[11,"as_opt_param_ty","","",247,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[11,"is_param","","",247,{"inputs":[{"name":"tys"},{"name":"paramspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"new","","",253,{"inputs":[{"name":"paramty"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"paramty"}}],[11,"for_self","","",253,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"for_def","","",253,{"inputs":[{"name":"paramty"},{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",253,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"is_self","","",253,{"inputs":[{"name":"paramty"}],"output":{"name":"bool"}}],[11,"empty","","",286,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"is_noop","","",286,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"bool"}}],[11,"empty","","",264,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"clone","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"when","","",287,{"inputs":[{"name":"typecontents"},{"name":"bool"}],"output":{"name":"typecontents"}}],[11,"intersects","","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_managed","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_owned","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"is_sized","","",287,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"interior_param","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsafe","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsized","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"needs_drop","","",287,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"owned_pointer","","Includes only those bits that still apply when indirected through a `Box` pointer",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"reference","","Includes only those bits that still apply when indirected through a reference (`&`)",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"managed_pointer","","Includes only those bits that still apply when indirected through a managed pointer (`@`)",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"unsafe_pointer","","Includes only those bits that still apply when indirected through an unsafe pointer (`*`)",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"union","","",287,null],[11,"has_dtor","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitor","rustc::middle::ty","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitand","rustc::middle::ty","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"sub","rustc::middle::ty","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"fmt","","",287,{"inputs":[{"name":"typecontents"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",288,{"inputs":[{"name":"representability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"option"}}],[11,"lt","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"clone","","",288,{"inputs":[{"name":"representability"}],"output":{"name":"representability"}}],[11,"clone","","",289,{"inputs":[{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"repr","","",263,{"inputs":[{"name":"type_err"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",290,{"inputs":[{"name":"variantinfo"}],"output":{"name":"variantinfo"}}],[11,"from_ast_variant","","Creates a new VariantInfo from the corresponding ast representation.",290,{"inputs":[{"name":"variantinfo"},{"name":"ctxt"},{"name":"spanned"},{"name":"u64"}],"output":{"name":"variantinfo"}}],[11,"clone","","",291,{"inputs":[{"name":"dtorkind"}],"output":{"name":"dtorkind"}}],[11,"is_present","","",291,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"has_drop_flag","","",291,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"to_ty","syntax::attr","",292,{"inputs":[{"name":"inttype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"i64_to_disr","","",292,{"inputs":[{"name":"inttype"},{"name":"i64"}],"output":{"name":"option"}}],[11,"u64_to_disr","","",292,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_incr","","",292,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_string","","",292,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"string"}}],[11,"disr_wrap_incr","","",292,{"inputs":[{"name":"inttype"},{"name":"option"}],"output":{"name":"u64"}}],[11,"clone","rustc::middle::ty","",293,{"inputs":[{"name":"closureupvar"}],"output":{"name":"closureupvar"}}],[11,"to_string","","",234,{"inputs":[{"name":"variance"}],"output":{"name":"str"}}],[11,"from_mutbl","","",257,{"inputs":[{"name":"borrowkind"},{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow\nkind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a\nmutability that is stronger than necessary so that it at least *would permit* the borrow in\nquestion.",257,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",257,{"inputs":[{"name":"borrowkind"}],"output":{"name":"str"}}],[11,"is_method_call","","",245,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"upvar_capture","","",245,{"inputs":[{"name":"ctxt"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"node_ty","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"result"}}],[11,"expr_ty_adjusted","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"expr"}],"output":{"name":"result"}}],[11,"node_method_ty","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"node_method_origin","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"adjustments","","",284,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"refcell"}}],[11,"is_method_call","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"temporary_scope","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"option"}}],[11,"upvar_capture","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"type_moves_by_default","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"param_env","","",284,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"closure_kind","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"}],"output":{"name":"option"}}],[11,"closure_type","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"closure_upvars","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[11,"fmt","","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"ne","","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"clone","","",294,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"explicitselfcategory"}}],[11,"decode","","",22,{"inputs":[{"name":"freevar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"freevar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"freevar"}],"output":{"name":"freevar"}}],[11,"is_identity","","",235,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"bool"}}],[11,"is_identity","","",236,{"inputs":[{"name":"autoderefref"}],"output":{"name":"bool"}}],[11,"new","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"repr","","",235,{"inputs":[{"name":"autoadjustment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",236,{"inputs":[{"name":"autoderefref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",237,{"inputs":[{"name":"autoref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",277,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",243,{"inputs":[{"name":"vtable_origin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",295,{"inputs":[{"name":"copyimplementationerror"}],"output":{"name":"copyimplementationerror"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",285,{"inputs":[{"name":"typescheme"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",16,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",277,{"inputs":[{"name":"predicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::traits","",214,{"inputs":[{"name":"obligation"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",260,{"inputs":[{"name":"traitref"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",186,{"inputs":[{"name":"regionsubsts"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",282,{"inputs":[{"name":"projectionty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"repr","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"has_projection_types","collections::vec","",296,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",250,{"inputs":[{"name":"closurety"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",293,{"inputs":[{"name":"closureupvar"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",279,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",280,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",281,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",282,{"inputs":[{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",185,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"has_projection_types","core::option","",12,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::boxed","",297,{"inputs":[{"name":"box"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",252,{"inputs":[{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",224,{"inputs":[{"name":"field"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",249,{"inputs":[{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"references_error","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"references_error","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"references_error","rustc::middle::ty","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",281,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"references_error","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"references_error","","",280,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",279,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"repr","","",250,{"inputs":[{"name":"closurety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",293,{"inputs":[{"name":"closureupvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",224,{"inputs":[{"name":"field"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",272,{"inputs":[{"name":"objectlifetimedefault"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","syntax::ast","",298,{"inputs":[{"name":"unsafety"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"fold_with","syntax::abi","",299,{"inputs":[{"name":"abi"},{"name":"f"}],"output":{"name":"abi"}}],[11,"fold_with","core::option","",12,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"fold_with","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"f"}],"output":{"name":"rc"}}],[11,"fold_with","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"f"}],"output":{"name":"box"}}],[11,"fold_with","collections::vec","",296,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"fold_with","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"fold_with","syntax::owned_slice","",300,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"fold_with","rustc::middle::subst","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"fold_with","rustc::middle::ty","",249,{"inputs":[{"name":"barefnty"},{"name":"f"}],"output":{"name":"barefnty"}}],[11,"fold_with","","",250,{"inputs":[{"name":"closurety"},{"name":"f"}],"output":{"name":"closurety"}}],[11,"fold_with","","",230,{"inputs":[{"name":"mt"},{"name":"f"}],"output":{"name":"mt"}}],[11,"fold_with","","",251,{"inputs":[{"name":"fnoutput"},{"name":"f"}],"output":{"name":"fnoutput"}}],[11,"fold_with","","",252,{"inputs":[{"name":"fnsig"},{"name":"f"}],"output":{"name":"fnsig"}}],[11,"fold_with","","",260,{"inputs":[{"name":"traitref"},{"name":"f"}],"output":{"name":"traitref"}}],[11,"fold_with","","",224,{"inputs":[{"name":"field"},{"name":"f"}],"output":{"name":"field"}}],[11,"fold_with","","",16,{"inputs":[{"name":"region"},{"name":"f"}],"output":{"name":"region"}}],[11,"fold_with","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"f"}],"output":{"name":"substs"}}],[11,"fold_with","rustc::middle::ty","",286,{"inputs":[{"name":"itemsubsts"},{"name":"f"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","","",237,{"inputs":[{"name":"autoref"},{"name":"f"}],"output":{"name":"autoref"}}],[11,"fold_with","","",25,{"inputs":[{"name":"methodorigin"},{"name":"f"}],"output":{"name":"methodorigin"}}],[11,"fold_with","","",243,{"inputs":[{"name":"vtable_origin"},{"name":"f"}],"output":{"name":"vtable_origin"}}],[11,"fold_with","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"f"}],"output":{"name":"enumset"}}],[11,"fold_with","rustc::middle::ty","",265,{"inputs":[{"name":"existentialbounds"},{"name":"f"}],"output":{"name":"existentialbounds"}}],[11,"fold_with","","",264,{"inputs":[{"name":"parambounds"},{"name":"f"}],"output":{"name":"parambounds"}}],[11,"fold_with","","",273,{"inputs":[{"name":"typeparameterdef"},{"name":"f"}],"output":{"name":"typeparameterdef"}}],[11,"fold_with","","",272,{"inputs":[{"name":"objectlifetimedefault"},{"name":"f"}],"output":{"name":"objectlifetimedefault"}}],[11,"fold_with","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"f"}],"output":{"name":"regionparameterdef"}}],[11,"fold_with","","",275,{"inputs":[{"name":"generics"},{"name":"f"}],"output":{"name":"generics"}}],[11,"fold_with","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"f"}],"output":{"name":"genericpredicates"}}],[11,"fold_with","","",277,{"inputs":[{"name":"predicate"},{"name":"f"}],"output":{"name":"predicate"}}],[11,"fold_with","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"f"}],"output":{"name":"projectionpredicate"}}],[11,"fold_with","","",282,{"inputs":[{"name":"projectionty"},{"name":"f"}],"output":{"name":"projectionty"}}],[11,"fold_with","","",283,{"inputs":[{"name":"instantiatedpredicates"},{"name":"f"}],"output":{"name":"instantiatedpredicates"}}],[11,"fold_with","rustc::middle::traits","",214,{"inputs":[{"name":"obligation"},{"name":"f"}],"output":{"name":"obligation"}}],[11,"fold_with","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"fold_with","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fold_with","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"fold_with","","",215,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"fold_with","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"f"}],"output":{"name":"vtableobjectdata"}}],[11,"fold_with","rustc::middle::ty","",279,{"inputs":[{"name":"equatepredicate"},{"name":"f"}],"output":{"name":"equatepredicate"}}],[11,"fold_with","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"f"}],"output":{"name":"traitpredicate"}}],[11,"fold_with","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"f"}],"output":{"name":"outlivespredicate"}}],[11,"fold_with","","",293,{"inputs":[{"name":"closureupvar"},{"name":"f"}],"output":{"name":"closureupvar"}}],[11,"fold_with","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"f"}],"output":{"name":"parameterenvironment"}}],[11,"tcx","rustc::middle::ty_fold","",302,{"inputs":[{"name":"bottomupfolder"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",302,{"inputs":[{"name":"bottomupfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","","",303,{"inputs":[{"name":"regionfolder"},{"name":"ctxt"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",303,{"inputs":[{"name":"regionfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",303,null],[11,"exit_region_binder","","",303,null],[11,"fold_region","","",303,{"inputs":[{"name":"regionfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"tcx","","",304,{"inputs":[{"name":"regioneraser"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",304,{"inputs":[{"name":"regioneraser"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::ty_match","",305,{"inputs":[{"name":"match"},{"name":"ctxt"}],"output":{"name":"match"}}],[11,"tag","","",305,{"inputs":[{"name":"match"}],"output":{"name":"str"}}],[11,"tcx","","",305,{"inputs":[{"name":"match"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",305,{"inputs":[{"name":"match"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",305,{"inputs":[{"name":"match"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"regions","","",305,{"inputs":[{"name":"match"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"tys","","",305,{"inputs":[{"name":"match"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"binders","","",305,{"inputs":[{"name":"match"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",230,{"inputs":[{"name":"mt"},{"name":"r"},{"name":"mt"},{"name":"mt"}],"output":{"name":"result"}}],[11,"relate","","",249,{"inputs":[{"name":"barefnty"},{"name":"r"},{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"result"}}],[11,"relate","","",252,{"inputs":[{"name":"fnsig"},{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"result"}}],[11,"relate","syntax::ast","",298,{"inputs":[{"name":"unsafety"},{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"relate","syntax::abi","",299,{"inputs":[{"name":"abi"},{"name":"r"},{"name":"abi"},{"name":"abi"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",282,{"inputs":[{"name":"projectionty"},{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"result"}}],[11,"relate","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"r"},{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"result"}}],[11,"relate","collections::vec","",296,{"inputs":[{"name":"vec"},{"name":"r"},{"name":"vec"},{"name":"vec"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",265,{"inputs":[{"name":"existentialbounds"},{"name":"r"},{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"result"}}],[11,"relate","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"r"},{"name":"enumset"},{"name":"enumset"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",260,{"inputs":[{"name":"traitref"},{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"relate","","",16,{"inputs":[{"name":"region"},{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"relate","","",96,{"inputs":[{"name":"binder"},{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"r"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"relate","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"r"},{"name":"box"},{"name":"box"}],"output":{"name":"result"}}],[11,"new","rustc::middle::ty_walk","",306,{"inputs":[{"name":"typewalker"},{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type\nreturned by `next()`.",306,null],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::middle::ty_walk","",306,{"inputs":[{"name":"typewalker"}],"output":{"name":"option"}}],[11,"visit_foreign_item","rustc::middle::weak_lang_items","",307,null],[11,"eq","rustc::metadata::common","",308,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"ne","","",308,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"clone","","",308,{"inputs":[{"name":"astencode_tag"}],"output":{"name":"astencode_tag"}}],[11,"from_u32","","",308,{"inputs":[{"name":"astencode_tag"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","","",309,{"inputs":[{"name":"linkmeta"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",309,{"inputs":[{"name":"linkmeta"}],"output":{"name":"linkmeta"}}],[11,"fmt","rustc::metadata::tydecode","",310,{"inputs":[{"name":"defidsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",310,{"inputs":[{"name":"defidsource"}],"output":{"name":"defidsource"}}],[11,"clone","rustc::metadata::encoder","",311,{"inputs":[{"name":"entry"}],"output":{"name":"entry"}}],[11,"visit_expr","","",312,null],[11,"visit_item","","",312,null],[11,"visit_foreign_item","","",312,null],[11,"visit_item","","",313,null],[11,"eq","rustc::metadata::decoder","",314,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"ne","","",314,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"fmt","","",315,{"inputs":[{"name":"deflike"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",315,{"inputs":[{"name":"deflike"}],"output":{"name":"deflike"}}],[11,"clone","","",316,{"inputs":[{"name":"cratedep"}],"output":{"name":"cratedep"}}],[11,"visit_item","rustc::metadata::creader","",317,null],[11,"as_slice","","",318,null],[11,"new","","",317,{"inputs":[{"name":"cratereader"},{"name":"session"}],"output":{"name":"cratereader"}}],[11,"read_crates","","",317,null],[11,"read_exported_macros","","Read exported macros.",317,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path and symbol name.",317,{"inputs":[{"name":"cratereader"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","rustc::metadata::cstore","",319,{"inputs":[{"name":"linkagepreference"}],"output":{"name":"linkagepreference"}}],[11,"eq","","",319,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"ne","","",319,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"fmt","","",319,{"inputs":[{"name":"linkagepreference"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",320,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"ne","","",320,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"clone","","",320,{"inputs":[{"name":"nativelibrarykind"}],"output":{"name":"nativelibrarykind"}}],[11,"from_u32","","",320,{"inputs":[{"name":"nativelibrarykind"},{"name":"u32"}],"output":{"name":"option"}}],[11,"clone","","",321,{"inputs":[{"name":"cratesource"}],"output":{"name":"cratesource"}}],[11,"eq","","",321,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",321,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"new","","",322,{"inputs":[{"name":"cstore"},{"name":"rc"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","",322,{"inputs":[{"name":"cstore"}],"output":{"name":"u32"}}],[11,"get_crate_data","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"rc"}}],[11,"get_crate_hash","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"svh"}}],[11,"set_crate_data","","",322,null],[11,"iter_crate_data","","",322,null],[11,"iter_crate_data_origins","","Like `iter_crate_data`, but passes source paths (if available) as well.",322,null],[11,"add_used_crate_source","","",322,null],[11,"get_used_crate_source","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"reset","","",322,null],[11,"get_used_crates","","",322,{"inputs":[{"name":"cstore"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[11,"add_used_library","","",322,null],[11,"get_used_libraries","","",322,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_used_link_args","","",322,null],[11,"get_used_link_args","","",322,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_extern_mod_stmt_cnum","","",322,null],[11,"find_extern_mod_stmt_cnum","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"data","","",323,null],[11,"name","","",323,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"string"}}],[11,"hash","","",323,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"svh"}}],[11,"as_slice","","",324,null],[11,"clone","rustc::metadata::csearch","",325,{"inputs":[{"name":"methodinfo"}],"output":{"name":"methodinfo"}}],[11,"maybe_load_library_crate","rustc::metadata::loader","",326,{"inputs":[{"name":"context"}],"output":{"name":"option"}}],[11,"load_library_crate","","",326,{"inputs":[{"name":"context"}],"output":{"name":"library"}}],[11,"report_load_errs","","",326,null],[11,"as_slice","","",327,null],[11,"clone","rustc::metadata::filesearch","",328,{"inputs":[{"name":"filematch"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",329,null],[11,"get_lib_path","","",329,{"inputs":[{"name":"filesearch"}],"output":{"name":"pathbuf"}}],[11,"search","","",329,null],[11,"new","","",329,{"inputs":[{"name":"filesearch"},{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",329,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"get_tools_search_paths","","",329,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"visit_item","rustc::metadata::macro_import","",330,null],[11,"visit_mac","","",330,null],[11,"eq","rustc::session::config","",331,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"ne","","",331,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"clone","","",331,{"inputs":[{"name":"optlevel"}],"output":{"name":"optlevel"}}],[11,"eq","","",332,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"ne","","",332,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"clone","","",332,{"inputs":[{"name":"debuginfolevel"}],"output":{"name":"debuginfolevel"}}],[11,"cmp","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",333,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[11,"clone","","",334,{"inputs":[{"name":"options"}],"output":{"name":"options"}}],[11,"clone","","",335,{"inputs":[{"name":"unstablefeatures"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",336,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"ne","","",336,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"clone","","",336,{"inputs":[{"name":"printrequest"}],"output":{"name":"printrequest"}}],[11,"filestem","","",337,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[11,"clone","","",338,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"outputfilenames"}}],[11,"path","","",338,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","",338,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",338,{"inputs":[{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",338,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"string"}}],[11,"eq","","",339,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"ne","","",339,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"clone","","",339,{"inputs":[{"name":"entryfntype"}],"output":{"name":"entryfntype"}}],[11,"fmt","","",340,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",340,null],[11,"cmp","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"clone","","",340,{"inputs":[{"name":"cratetype"}],"output":{"name":"cratetype"}}],[11,"partial_cmp","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"option"}}],[11,"lt","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"le","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"gt","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ge","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"eq","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ne","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"clone","","",341,{"inputs":[{"name":"passes"}],"output":{"name":"passes"}}],[11,"is_empty","","",341,{"inputs":[{"name":"passes"}],"output":{"name":"bool"}}],[11,"clone","","",342,{"inputs":[{"name":"codegenoptions"}],"output":{"name":"codegenoptions"}}],[11,"clone","","",343,{"inputs":[{"name":"debuggingoptions"}],"output":{"name":"debuggingoptions"}}],[11,"fmt","","",344,{"inputs":[{"name":"optionstability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",344,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"clone","","",344,{"inputs":[{"name":"optionstability"}],"output":{"name":"optionstability"}}],[11,"eq","","",345,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"ne","","",345,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"clone","","",345,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"rustcoptgroup"}}],[11,"is_stable","","",345,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"fmt","","",340,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::session::search_paths","",346,{"inputs":[{"name":"searchpaths"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",346,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",347,{"inputs":[{"name":"pathkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",347,{"inputs":[{"name":"pathkind"}],"output":{"name":"pathkind"}}],[11,"eq","","",347,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"ne","","",347,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",346,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"add_path","","",346,null],[11,"iter","","",346,{"inputs":[{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"iter"}}],[6,"Item","rustc_lint::lint","",null,null],[11,"next","rustc::session::search_paths","",348,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"span_fatal","rustc::session","",349,null],[11,"span_fatal_with_code","","",349,null],[11,"fatal","","",349,null],[11,"span_err","","",349,null],[11,"span_err_with_code","","",349,null],[11,"err","","",349,null],[11,"err_count","","",349,{"inputs":[{"name":"session"}],"output":{"name":"usize"}}],[11,"has_errors","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",349,null],[11,"span_warn","","",349,null],[11,"span_warn_with_code","","",349,null],[11,"warn","","",349,null],[11,"opt_span_warn","","",349,null],[11,"span_note","","",349,null],[11,"span_end_note","","",349,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",349,null],[11,"span_help","","",349,null],[11,"fileline_note","","",349,null],[11,"fileline_help","","",349,null],[11,"note","","",349,null],[11,"help","","",349,null],[11,"opt_span_bug","","",349,null],[11,"span_bug","","",349,null],[11,"bug","","",349,null],[11,"span_unimpl","","",349,null],[11,"unimpl","","",349,null],[11,"add_lint","","",349,null],[11,"next_node_id","","",349,{"inputs":[{"name":"session"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",349,{"inputs":[{"name":"session"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"diagnostic","","",349,{"inputs":[{"name":"session"}],"output":{"name":"spanhandler"}}],[11,"codemap","","",349,{"inputs":[{"name":"session"}],"output":{"name":"codemap"}}],[11,"impossible_case","","",349,null],[11,"verbose","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_passes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_type_sizes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"trans_stats","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"meta_stats","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"asm_comments","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_verify","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"lto","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"unstable_options","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_enum_sizes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"sysroot","","",349,{"inputs":[{"name":"session"}],"output":{"name":"path"}}],[11,"target_filesearch","","",349,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",349,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"args","rustc::plugin::registry","Get the plugin's arguments, if any.",350,{"inputs":[{"name":"registry"}],"output":{"name":"vec"}}],[11,"register_syntax_extension","","Register a syntax extension of any kind.",350,null],[11,"register_macro","","Register a macro of the usual kind.",350,null],[11,"register_lint_pass","","Register a compiler lint pass.",350,null],[11,"register_lint_group","","Register a lint group.",350,null],[11,"register_llvm_pass","","Register an LLVM pass.",350,null],[11,"visit_item","rustc::plugin::build","",351,null],[11,"fmt","rustc::lint","",0,{"inputs":[{"name":"lint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"lint"}],"output":{"name":"lint"}}],[11,"clone","","",352,{"inputs":[{"name":"lintid"}],"output":{"name":"lintid"}}],[11,"eq","","",352,{"inputs":[{"name":"lintid"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",352,null],[11,"of","","Get the `LintId` for a `Lint`.",352,{"inputs":[{"name":"lintid"},{"name":"lint"}],"output":{"name":"lintid"}}],[11,"as_str","","Get the name of the lint.",352,{"inputs":[{"name":"lintid"}],"output":{"name":"string"}}],[11,"fmt","","",353,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"option"}}],[11,"lt","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"le","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"gt","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ge","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"eq","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",353,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",353,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"as_str","","Convert a level to a lower-case string.",353,{"inputs":[{"name":"level"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",353,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"option"}}],[11,"eq","","",354,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",354,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"clone","","",354,{"inputs":[{"name":"lintsource"}],"output":{"name":"lintsource"}}],[11,"clone","rustc::lint::builtin","",355,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",355,null],[11,"new","rustc::lint::context","",356,{"inputs":[{"name":"lintstore"}],"output":{"name":"lintstore"}}],[11,"get_lints","","",356,null],[11,"get_lint_groups","","",356,{"inputs":[{"name":"lintstore"}],"output":{"name":"vec"}}],[11,"register_pass","","",356,null],[11,"register_group","","",356,null],[11,"register_renamed","","",356,null],[11,"process_command_line","","",356,null],[11,"sess","","Get the overall compiler `Session` object.",357,{"inputs":[{"name":"context"}],"output":{"name":"session"}}],[11,"current_level","","Get the level of `lint` at the current position of the lint\ntraversal.",357,{"inputs":[{"name":"context"},{"name":"lint"}],"output":{"name":"level"}}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",357,null],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",357,null],[11,"visit_item","","",357,null],[11,"visit_foreign_item","","",357,null],[11,"visit_pat","","",357,null],[11,"visit_expr","","",357,null],[11,"visit_stmt","","",357,null],[11,"visit_fn","","",357,null],[11,"visit_struct_def","","",357,null],[11,"visit_struct_field","","",357,null],[11,"visit_variant","","",357,null],[11,"visit_ty","","",357,null],[11,"visit_ident","","",357,null],[11,"visit_mod","","",357,null],[11,"visit_local","","",357,null],[11,"visit_block","","",357,null],[11,"visit_arm","","",357,null],[11,"visit_decl","","",357,null],[11,"visit_expr_post","","",357,null],[11,"visit_generics","","",357,null],[11,"visit_trait_item","","",357,null],[11,"visit_impl_item","","",357,null],[11,"visit_opt_lifetime_ref","","",357,null],[11,"visit_lifetime_ref","","",357,null],[11,"visit_lifetime_def","","",357,null],[11,"visit_explicit_self","","",357,null],[11,"visit_mac","","",357,null],[11,"visit_path","","",357,null],[11,"visit_attribute","","",357,null],[11,"visit_id","","",357,null],[11,"get_lints","","",358,null],[11,"check_item","","",358,null],[11,"fmt","rustc::util::common","",359,{"inputs":[{"name":"errorreported"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",359,{"inputs":[{"name":"errorreported"}],"output":{"name":"errorreported"}}],[11,"drop","","",360,null],[11,"visit_expr","","",361,null],[11,"visit_expr","","",362,null],[11,"repr","core::option","",12,{"inputs":[{"name":"option"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ptr","",363,{"inputs":[{"name":"p"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::result","",92,{"inputs":[{"name":"result"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::owned_slice","",300,{"inputs":[{"name":"ownedslice"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::vec","",296,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",296,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",273,{"inputs":[{"name":"typeparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",247,{"inputs":[{"name":"tys"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",230,{"inputs":[{"name":"mt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",286,{"inputs":[{"name":"itemsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",186,{"inputs":[{"name":"regionsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",264,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",260,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",364,{"inputs":[{"name":"traitdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",365,{"inputs":[{"name":"traititem"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",160,{"inputs":[{"name":"expr"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",366,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",366,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",367,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",368,{"inputs":[{"name":"item"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",369,{"inputs":[{"name":"lifetime"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",370,{"inputs":[{"name":"spanned"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",161,{"inputs":[{"name":"pat"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",20,{"inputs":[{"name":"boundregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",16,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",16,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",17,{"inputs":[{"name":"freeregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",11,{"inputs":[{"name":"defid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",285,{"inputs":[{"name":"typescheme"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",275,{"inputs":[{"name":"generics"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",283,{"inputs":[{"name":"instantiatedpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",233,{"inputs":[{"name":"itemvariances"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",234,{"inputs":[{"name":"variance"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",228,{"inputs":[{"name":"method"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",6,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",6,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",5,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",371,{"inputs":[{"name":"explicitself_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",372,{"inputs":[{"name":"visibility"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",249,{"inputs":[{"name":"barefnty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",252,{"inputs":[{"name":"fnsig"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",251,{"inputs":[{"name":"fnoutput"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",241,{"inputs":[{"name":"methodcallee"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",25,{"inputs":[{"name":"methodorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",239,{"inputs":[{"name":"methodparam"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",240,{"inputs":[{"name":"methodobject"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",266,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",266,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",13,{"inputs":[{"name":"span"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",264,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",260,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","syntax::ast","",5,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::abi","",299,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",299,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",256,{"inputs":[{"name":"upvarid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",373,{"inputs":[{"name":"mutability"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",257,{"inputs":[{"name":"borrowkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",125,{"inputs":[{"name":"intvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",127,{"inputs":[{"name":"floatvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",268,{"inputs":[{"name":"regionvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",267,{"inputs":[{"name":"tyvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",374,{"inputs":[{"name":"intty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",375,{"inputs":[{"name":"uintty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",128,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",253,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",253,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",96,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","std::collections::hash::map","",376,{"inputs":[{"name":"hashmap"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",282,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",282,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",277,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",298,{"inputs":[{"name":"unsafety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"default","rustc::util::nodemap","",377,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"fnvhasher"}}],[11,"write","","",377,null],[11,"finish","","",377,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"u64"}}],[11,"new","rustc::util::snapshot_vec","",378,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"snapshotvec"}}],[11,"record","","",378,null],[11,"push","","",378,null],[11,"get","","",378,null],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone\nautomatically, so you should be sure call `record()` with some sort of suitable undo\naction.",378,null],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if\na snapshot is active.",378,null],[11,"start_snapshot","","",378,{"inputs":[{"name":"snapshotvec"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",378,null],[11,"rollback_to","","",378,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",378,null],[11,"input","rustc_back::sha2","",379,null],[11,"reset","","",379,null],[11,"zero_until","","",379,null],[11,"next","","",379,null],[11,"full_buffer","","",379,null],[11,"position","","",379,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"remaining","","",379,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"size","","",379,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",380,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",380,null],[11,"result","","",380,null],[11,"reset","","",380,null],[11,"output_bits","","",380,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[11,"open","rustc_llvm::archive_ro","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",381,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",381,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",381,null],[11,"clone","rustc_llvm::diagnostic","",382,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",382,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",383,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",384,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",385,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",385,null],[11,"eq","rustc_llvm","",386,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",386,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",386,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",387,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",388,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",389,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",389,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",390,null],[11,"cmp","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",390,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",390,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",390,null],[11,"remove","","Removes the specified flags in-place.",390,null],[11,"toggle","","Toggles the specified flags in-place.",390,null],[6,"Output","rustc_lint::lint","",null,null],[11,"bitor","rustc_llvm","Returns the union of the two sets of flags.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitxor","rustc_llvm","Returns the left flags, but with all the right flags toggled.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"bitand","rustc_llvm","Returns the intersection between the two sets of flags.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"sub","rustc_llvm","Returns the set difference of the two sets of flags.",390,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_lint::lint","",null,null],[11,"not","rustc_llvm","Returns the complement of this set of flags.",390,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",391,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",392,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",393,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",390,null],[11,"apply_callsite","","",390,null],[11,"apply_llfn","","",391,null],[11,"apply_callsite","","",391,null],[11,"apply_llfn","","",392,null],[11,"apply_callsite","","",392,null],[11,"new","","",394,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",394,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",394,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",394,null],[11,"apply_callsite","","",394,null],[11,"clone","","",395,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",396,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",397,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",397,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",397,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",397,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",398,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",399,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",400,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",401,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",402,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",403,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",403,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",403,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",404,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",404,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",404,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",405,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",406,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"clone","rustc_llvm::debuginfo","",407,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[11,"drop","rustc_llvm","",408,null],[11,"new","","",409,null],[11,"drop","","",409,null],[11,"drop","","",410,null],[3,"Lint","rustc_lint::lint","Specification of a single lint.",null,null],[12,"name","","A string identifier for the lint.",0,null],[12,"default_level","","Default level for the lint.",0,null],[12,"desc","","Description of the lint or the issue it detects.",0,null],[6,"LintArray","","",null,null],[8,"LintPass","","Trait for types providing lint checks.",null,null],[10,"get_lints","","Get descriptions of the lints this `LintPass` object can emit.",411,null],[11,"check_crate","","",411,null],[11,"check_ident","","",411,null],[11,"check_mod","","",411,null],[11,"check_foreign_item","","",411,null],[11,"check_item","","",411,null],[11,"check_local","","",411,null],[11,"check_block","","",411,null],[11,"check_stmt","","",411,null],[11,"check_arm","","",411,null],[11,"check_pat","","",411,null],[11,"check_decl","","",411,null],[11,"check_expr","","",411,null],[11,"check_expr_post","","",411,null],[11,"check_ty","","",411,null],[11,"check_generics","","",411,null],[11,"check_fn","","",411,null],[11,"check_trait_item","","",411,null],[11,"check_impl_item","","",411,null],[11,"check_struct_def","","",411,null],[11,"check_struct_def_post","","",411,null],[11,"check_struct_field","","",411,null],[11,"check_variant","","",411,null],[11,"check_variant_post","","",411,null],[11,"check_opt_lifetime_ref","","",411,null],[11,"check_lifetime_ref","","",411,null],[11,"check_lifetime_def","","",411,null],[11,"check_explicit_self","","",411,null],[11,"check_mac","","",411,null],[11,"check_path","","",411,null],[11,"check_attribute","","",411,null],[11,"enter_lint_attrs","","Called when entering a syntax node that can have lint attributes such\nas `#[allow(...)]`. Called with *all* the attributes of that node.",411,null],[11,"exit_lint_attrs","","Counterpart to `enter_lint_attrs`.",411,null],[6,"LintPassObject","","",null,null],[3,"LintId","","Identifies a lint known to the compiler.",null,null],[4,"Level","","Setting for how to handle a lint.",null,null],[13,"Allow","","",353,null],[13,"Warn","","",353,null],[13,"Deny","","",353,null],[13,"Forbid","","",353,null],[4,"LintSource","","How a lint level was set.",null,null],[13,"Default","","Lint is at the default level as declared\nin rustc or a plugin.",354,null],[13,"Node","","Lint level was set by an attribute.",354,null],[13,"CommandLine","","Lint level was set by a command-line flag.",354,null],[13,"ReleaseChannel","","Lint level was set by the release channel.",354,null],[6,"LevelSource","","",null,null],[0,"builtin","","Some lints that are built in to the compiler.",null,null],[7,"UNUSED_IMPORTS","rustc_lint::lint::builtin","",null,null],[7,"UNUSED_EXTERN_CRATES","","",null,null],[7,"UNUSED_QUALIFICATIONS","","",null,null],[7,"UNKNOWN_LINTS","","",null,null],[7,"UNUSED_VARIABLES","","",null,null],[7,"UNUSED_ASSIGNMENTS","","",null,null],[7,"DEAD_CODE","","",null,null],[7,"UNREACHABLE_CODE","","",null,null],[7,"WARNINGS","","",null,null],[7,"UNUSED_FEATURES","","",null,null],[7,"STABLE_FEATURES","","",null,null],[7,"UNKNOWN_CRATE_TYPES","","",null,null],[7,"VARIANT_SIZE_DIFFERENCES","","",null,null],[7,"FAT_PTR_TRANSMUTES","","",null,null],[7,"TRIVIAL_CASTS","","",null,null],[7,"TRIVIAL_NUMERIC_CASTS","","",null,null],[3,"HardwiredLints","","Does nothing as a lint pass, but registers some `Lint`s\nwhich are used by other parts of the compiler.",null,null],[5,"gather_attrs","rustc_lint::lint","Parse the lint attributes into a vector, with `Err`s for malformed lint\nattributes. Writing this as an iterator is an enormous mess.",null,null],[3,"Context","","Context for lint checking.",null,null],[12,"tcx","","Type context we're checking in.",357,null],[12,"krate","","The crate being checked.",357,null],[12,"exported_items","","Items exported from the crate being checked.",357,null],[3,"GatherNodeLevels","","",null,null],[3,"LintStore","","Information about the registered lints.",null,null],[5,"check_crate","","Perform lint checking on a crate.",null,null],[5,"raw_emit_lint","","Emit a lint as a warning or an error (or not at all)\naccording to `level`.",null,null],[0,"metadata","rustc_lint","",null,null],[0,"common","rustc_lint::metadata","",null,null],[17,"tag_items","rustc_lint::metadata::common","",null,null],[17,"tag_paths_data_name","","",null,null],[17,"tag_def_id","","",null,null],[17,"tag_items_data","","",null,null],[17,"tag_items_data_item","","",null,null],[17,"tag_items_data_item_family","","",null,null],[17,"tag_items_data_item_type","","",null,null],[17,"tag_items_data_item_symbol","","",null,null],[17,"tag_items_data_item_variant","","",null,null],[17,"tag_items_data_parent_item","","",null,null],[17,"tag_items_data_item_is_tuple_struct_ctor","","",null,null],[17,"tag_index","","",null,null],[17,"tag_index_buckets","","",null,null],[17,"tag_index_buckets_bucket","","",null,null],[17,"tag_index_buckets_bucket_elt","","",null,null],[17,"tag_index_table","","",null,null],[17,"tag_meta_item_name_value","","",null,null],[17,"tag_meta_item_name","","",null,null],[17,"tag_meta_item_value","","",null,null],[17,"tag_attributes","","",null,null],[17,"tag_attribute","","",null,null],[17,"tag_meta_item_word","","",null,null],[17,"tag_meta_item_list","","",null,null],[17,"tag_crate_deps","","",null,null],[17,"tag_crate_dep","","",null,null],[17,"tag_crate_hash","","",null,null],[17,"tag_crate_crate_name","","",null,null],[17,"tag_crate_dep_crate_name","","",null,null],[17,"tag_crate_dep_hash","","",null,null],[17,"tag_mod_impl","","",null,null],[17,"tag_item_trait_item","","",null,null],[17,"tag_item_trait_ref","","",null,null],[17,"tag_disr_val","","",null,null],[17,"tag_path","","",null,null],[17,"tag_path_len","","",null,null],[17,"tag_path_elem_mod","","",null,null],[17,"tag_path_elem_name","","",null,null],[17,"tag_item_field","","",null,null],[17,"tag_item_field_origin","","",null,null],[17,"tag_item_variances","","",null,null],[17,"tag_item_impl_item","","",null,null],[17,"tag_item_trait_method_explicit_self","","",null,null],[17,"tag_items_data_item_reexport","","",null,null],[17,"tag_items_data_item_reexport_def_id","","",null,null],[17,"tag_items_data_item_reexport_name","","",null,null],[4,"astencode_tag","","",null,null],[13,"tag_ast","","",308,null],[13,"tag_tree","","",308,null],[13,"tag_id_range","","",308,null],[13,"tag_table","","",308,null],[13,"tag_table_def","","",308,null],[13,"tag_table_node_type","","",308,null],[13,"tag_table_item_subst","","",308,null],[13,"tag_table_freevars","","",308,null],[13,"tag_table_tcache","","",308,null],[13,"tag_table_param_defs","","",308,null],[13,"tag_table_mutbl","","",308,null],[13,"tag_table_last_use","","",308,null],[13,"tag_table_spill","","",308,null],[13,"tag_table_method_map","","",308,null],[13,"tag_table_vtable_map","","",308,null],[13,"tag_table_adjustments","","",308,null],[13,"tag_table_moves_map","","",308,null],[13,"tag_table_capture_map","","",308,null],[13,"tag_table_closure_tys","","",308,null],[13,"tag_table_closure_kinds","","",308,null],[13,"tag_table_upvar_capture_map","","",308,null],[13,"tag_table_capture_modes","","",308,null],[13,"tag_table_object_cast_map","","",308,null],[13,"tag_table_const_qualif","","",308,null],[17,"tag_item_trait_item_sort","","",null,null],[17,"tag_item_trait_parent_sort","","",null,null],[17,"tag_item_impl_type_basename","","",null,null],[17,"tag_crate_triple","","",null,null],[17,"tag_dylib_dependency_formats","","",null,null],[17,"tag_lang_items","","",null,null],[17,"tag_lang_items_item","","",null,null],[17,"tag_lang_items_item_id","","",null,null],[17,"tag_lang_items_item_node_id","","",null,null],[17,"tag_lang_items_missing","","",null,null],[17,"tag_item_unnamed_field","","",null,null],[17,"tag_items_data_item_visibility","","",null,null],[17,"tag_item_method_tps","","",null,null],[17,"tag_item_method_fty","","",null,null],[17,"tag_mod_child","","",null,null],[17,"tag_misc_info","","",null,null],[17,"tag_misc_info_crate_items","","",null,null],[17,"tag_item_method_provided_source","","",null,null],[17,"tag_item_impl_vtables","","",null,null],[17,"tag_impls","","",null,null],[17,"tag_impls_impl","","",null,null],[17,"tag_items_data_item_inherent_impl","","",null,null],[17,"tag_items_data_item_extension_impl","","",null,null],[17,"tag_native_libraries","","",null,null],[17,"tag_native_libraries_lib","","",null,null],[17,"tag_native_libraries_name","","",null,null],[17,"tag_native_libraries_kind","","",null,null],[17,"tag_plugin_registrar_fn","","",null,null],[17,"tag_method_argument_names","","",null,null],[17,"tag_method_argument_name","","",null,null],[17,"tag_reachable_extern_fns","","",null,null],[17,"tag_reachable_extern_fn_id","","",null,null],[17,"tag_items_data_item_stability","","",null,null],[17,"tag_items_data_item_repr","","",null,null],[3,"LinkMeta","","",null,null],[12,"crate_name","","",309,null],[12,"crate_hash","","",309,null],[17,"tag_struct_fields","","",null,null],[17,"tag_struct_field","","",null,null],[17,"tag_struct_field_id","","",null,null],[17,"tag_attribute_is_sugared_doc","","",null,null],[17,"tag_items_data_region","","",null,null],[17,"tag_region_param_def","","",null,null],[17,"tag_region_param_def_ident","","",null,null],[17,"tag_region_param_def_def_id","","",null,null],[17,"tag_region_param_def_space","","",null,null],[17,"tag_region_param_def_index","","",null,null],[17,"tag_type_param_def","","",null,null],[17,"tag_item_generics","","",null,null],[17,"tag_method_ty_generics","","",null,null],[17,"tag_predicate","","",null,null],[17,"tag_predicate_space","","",null,null],[17,"tag_predicate_data","","",null,null],[17,"tag_unsafety","","",null,null],[17,"tag_associated_type_names","","",null,null],[17,"tag_associated_type_name","","",null,null],[17,"tag_polarity","","",null,null],[17,"tag_macro_defs","","",null,null],[17,"tag_macro_def","","",null,null],[17,"tag_macro_def_body","","",null,null],[17,"tag_paren_sugar","","",null,null],[17,"tag_codemap","","",null,null],[17,"tag_codemap_filemap","","",null,null],[17,"tag_item_super_predicates","","",null,null],[17,"tag_defaulted_trait","","",null,null],[0,"tyencode","rustc_lint::metadata","",null,null],[3,"ctxt","rustc_lint::metadata::tyencode","",null,null],[12,"diag","","",412,null],[12,"ds","","",412,null],[12,"tcx","","",412,null],[12,"abbrevs","","",412,null],[3,"ty_abbrev","","",null,null],[6,"abbrev_map","","",null,null],[5,"enc_ty","","",null,null],[5,"enc_substs","","",null,null],[5,"enc_region","","",null,null],[5,"enc_trait_ref","","",null,null],[5,"enc_bare_fn_ty","","",null,null],[5,"enc_closure_ty","","",null,null],[5,"enc_builtin_bounds","","",null,null],[5,"enc_existential_bounds","","",null,null],[5,"enc_bounds","","",null,null],[5,"enc_region_bounds","","",null,null],[5,"enc_type_param_def","","",null,null],[5,"enc_predicate","","",null,null],[0,"tydecode","rustc_lint::metadata","",null,null],[4,"DefIdSource","rustc_lint::metadata::tydecode","",null,null],[13,"NominalType","","",310,null],[13,"TypeWithId","","",310,null],[13,"TypeParameter","","",310,null],[13,"RegionParameter","","",310,null],[13,"ClosureSource","","",310,null],[3,"PState","","",null,null],[5,"parse_name","","",null,{"inputs":[{"name":"pstate"},{"name":"char"}],"output":{"name":"name"}}],[5,"parse_state_from_data","","",null,null],[5,"parse_ty_closure_data","","",null,null],[5,"parse_ty_data","","",null,null],[5,"parse_region_data","","",null,null],[5,"parse_bare_fn_ty_data","","",null,null],[5,"parse_trait_ref_data","","",null,null],[5,"parse_substs_data","","",null,null],[5,"parse_bounds_data","","",null,null],[5,"parse_existential_bounds_data","","",null,null],[5,"parse_builtin_bounds_data","","",null,null],[5,"parse_def_id","","",null,null],[5,"parse_predicate_data","","",null,null],[5,"parse_predicate","","",null,{"inputs":[{"name":"pstate"},{"name":"f"}],"output":{"name":"predicate"}}],[5,"parse_type_param_def_data","","",null,null],[0,"encoder","rustc_lint::metadata","",null,null],[4,"InlinedItemRef","rustc_lint::metadata::encoder","A borrowed version of `ast::InlinedItem`.",null,null],[13,"IIItemRef","","",413,null],[13,"IITraitItemRef","","",413,null],[13,"IIImplItemRef","","",413,null],[13,"IIForeignRef","","",413,null],[6,"EncodeInlinedItem","","",null,null],[3,"EncodeParams","","",null,null],[12,"diag","","",414,null],[12,"tcx","","",414,null],[12,"reexports","","",414,null],[12,"item_symbols","","",414,null],[12,"link_meta","","",414,null],[12,"cstore","","",414,null],[12,"encode_inlined_item","","",414,null],[12,"reachable","","",414,null],[3,"EncodeContext","","",null,null],[12,"diag","","",26,null],[12,"tcx","","",26,null],[12,"reexports","","",26,null],[12,"item_symbols","","",26,null],[12,"link_meta","","",26,null],[12,"cstore","","",26,null],[12,"encode_inlined_item","","",26,null],[12,"type_abbrevs","","",26,null],[12,"reachable","","",26,null],[5,"encode_def_id","","",null,null],[5,"def_to_string","","",null,{"inputs":[{"name":"defid"}],"output":{"name":"string"}}],[5,"write_closure_type","","",null,null],[5,"write_type","","",null,null],[5,"write_trait_ref","","",null,null],[5,"write_region","","",null,null],[17,"metadata_encoding_version","","",null,null],[5,"encode_metadata","","",null,{"inputs":[{"name":"encodeparams"},{"name":"crate"}],"output":{"name":"vec"}}],[5,"encoded_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[0,"decoder","rustc_lint::metadata","",null,null],[6,"Cmd","rustc_lint::metadata::decoder","",null,null],[5,"maybe_find_item","","",null,{"inputs":[{"name":"u32"},{"name":"doc"}],"output":{"name":"option"}}],[5,"item_type","","",null,{"inputs":[{"name":"defid"},{"name":"doc"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"genericpredicates"}}],[5,"get_type","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"typescheme"}}],[5,"get_stability","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vecperparamspace"}}],[5,"get_symbol","","",null,null],[4,"DefLike","","",null,null],[13,"DlDef","","",315,null],[13,"DlImpl","","",315,null],[13,"DlField","","",315,null],[5,"each_lang_item","","Iterates over the language items in the given crate.",null,{"inputs":[{"name":"crate_metadata"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,null],[5,"each_top_level_item_of_crate","","Iterates over all the top-level crate items.",null,null],[5,"get_item_path","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[6,"DecodeInlinedItem","","",null,null],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"u32"},{"name":"box"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"strinterner"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns the def IDs of all the items in the given implementation.",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"implortraititem"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","If node_id is the constructor of a tuple struct, retrieve the NodeId of\nthe actual type definition, otherwise, return None",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"hashmap"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"rc"},{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_crate_attributes","","",null,null],[3,"CrateDep","","",null,null],[12,"cnum","","",316,null],[12,"name","","",316,null],[12,"hash","","",316,null],[5,"get_crate_deps","","",null,null],[5,"maybe_get_crate_hash","","",null,null],[5,"get_crate_hash","","",null,null],[5,"maybe_get_crate_name","","",null,null],[5,"get_crate_triple","","",null,null],[5,"get_crate_name","","",null,null],[5,"list_crate_metadata","","",null,null],[5,"translate_def_id","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"defid"}],"output":{"name":"defid"}}],[5,"each_impl","","",null,null],[5,"each_implementation_for_type","","",null,null],[5,"each_implementation_for_trait","","",null,null],[5,"get_trait_of_item","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_plugin_registrar_fn","","",null,null],[5,"each_exported_macro","","",null,null],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"crate_metadata"},{"name":"u32"}],"output":{"name":"bool"}}],[5,"get_imported_filemaps","","",null,null],[0,"creader","rustc_lint::metadata","Validates all used crates and extern libraries and loads their metadata",null,null],[3,"CrateReader","rustc_lint::metadata::creader","",null,null],[5,"validate_crate_name","","",null,null],[0,"cstore","rustc_lint::metadata","",null,null],[6,"cnum_map","rustc_lint::metadata::cstore","",null,null],[4,"MetadataBlob","","",null,null],[13,"MetadataVec","","",324,null],[13,"MetadataArchive","","",324,null],[3,"ImportedFileMap","","Holds information about a codemap::FileMap imported from another crate.\nSee creader::import_codemap() for more information.",null,null],[12,"original_start_pos","","This FileMap's byte-offset within the codemap of its original crate",415,null],[12,"original_end_pos","","The end of this FileMap within the codemap of its original crate",415,null],[12,"translated_filemap","","The imported FileMap's representation within the local codemap",415,null],[3,"crate_metadata","","",null,null],[12,"name","","",323,null],[12,"data","","",323,null],[12,"cnum_map","","",323,null],[12,"cnum","","",323,null],[12,"codemap_import_info","","",323,null],[12,"span","","",323,null],[4,"LinkagePreference","","",null,null],[13,"RequireDynamic","","",319,null],[13,"RequireStatic","","",319,null],[4,"NativeLibraryKind","","",null,null],[13,"NativeStatic","","",320,null],[13,"NativeFramework","","",320,null],[13,"NativeUnknown","","",320,null],[3,"CrateSource","","",null,null],[12,"dylib","","",321,null],[12,"rlib","","",321,null],[12,"cnum","","",321,null],[3,"CStore","","",null,null],[12,"intr","","",322,null],[0,"csearch","rustc_lint::metadata","",null,null],[3,"MethodInfo","rustc_lint::metadata::csearch","",null,null],[12,"name","","",325,null],[12,"def_id","","",325,null],[12,"vis","","",325,null],[5,"get_symbol","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"string"}}],[5,"each_lang_item","","Iterates over all the language items in the given crate.",null,{"inputs":[{"name":"cstore"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[5,"each_child_of_item","","Iterates over each child of the given item.",null,null],[5,"each_top_level_item_of_crate","","Iterates over each top-level crate item.",null,null],[5,"get_item_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[4,"FoundAst","","",null,null],[13,"Found","","",416,null],[13,"FoundParent","","",416,null],[13,"NotFound","","",416,null],[5,"maybe_get_item_ast","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"box"}],"output":{"name":"foundast"}}],[5,"get_enum_variant_defs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_items","","Returns information about the given implementation.",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"get_trait_name","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"name"}}],[5,"is_static_method","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_trait_item_def_ids","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_item_variances","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"itemvariances"}}],[5,"get_provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_type_name_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_methods_if_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_item_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_fields","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_struct_field_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"hashmap"}}],[5,"get_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_trait_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"traitdef"}}],[5,"get_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_super_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"get_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"get_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_impl_vtables","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vecperparamspace"}}],[5,"get_native_libraries","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"each_impl","","",null,null],[5,"each_implementation_for_type","","",null,null],[5,"each_implementation_for_trait","","",null,null],[5,"get_trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), returns the ID of\nthe trait that the method belongs to. Otherwise, returns `None`.",null,{"inputs":[{"name":"cstore"},{"name":"defid"},{"name":"ctxt"}],"output":{"name":"option"}}],[5,"get_tuple_struct_definition_if_ctor","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"get_dylib_dependency_formats","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_missing_lang_items","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"get_method_arg_names","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"get_reachable_extern_fns","","",null,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"vec"}}],[5,"is_typedef","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_stability","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"option"}}],[5,"is_staged_api","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"get_repr_attrs","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_associated_type","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_defaulted_trait","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"is_default_impl","","",null,{"inputs":[{"name":"cstore"},{"name":"defid"}],"output":{"name":"bool"}}],[0,"loader","rustc_lint::metadata","Finds crate binaries and loads their metadata",null,null],[3,"CrateMismatch","rustc_lint::metadata::loader","",null,null],[3,"Context","","",null,null],[12,"sess","","",326,null],[12,"span","","",326,null],[12,"ident","","",326,null],[12,"crate_name","","",326,null],[12,"hash","","",326,null],[12,"target","","",326,null],[12,"triple","","",326,null],[12,"filesearch","","",326,null],[12,"root","","",326,null],[12,"rejected_via_hash","","",326,null],[12,"rejected_via_triple","","",326,null],[12,"rejected_via_kind","","",326,null],[12,"should_match_name","","",326,null],[3,"Library","","",null,null],[12,"dylib","","",417,null],[12,"rlib","","",417,null],[12,"metadata","","",417,null],[3,"ArchiveMetadata","","",null,null],[3,"CratePaths","","",null,null],[12,"ident","","",418,null],[12,"dylib","","",418,null],[12,"rlib","","",418,null],[5,"note_crate_name","","",null,null],[5,"meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"read_meta_section_name","","",null,{"inputs":[{"name":"bool"}],"output":{"name":"str"}}],[5,"list_file_metadata","","",null,{"inputs":[{"name":"bool"},{"name":"path"},{"name":"write"}],"output":{"name":"result"}}],[0,"filesearch","rustc_lint::metadata","",null,null],[4,"FileMatch","rustc_lint::metadata::filesearch","",null,null],[13,"FileMatches","","",328,null],[13,"FileDoesntMatch","","",328,null],[3,"FileSearch","","",null,null],[12,"sysroot","","",329,null],[12,"search_paths","","",329,null],[12,"triple","","",329,null],[12,"kind","","",329,null],[5,"relative_target_lib_path","","",null,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"pathbuf"}}],[5,"get_or_default_sysroot","","",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"get_rust_path","","Returns RUST_PATH as a string, without default paths added",null,{"inputs":[],"output":{"name":"option"}}],[5,"rust_path","","Returns the value of RUST_PATH, as a list\nof Paths. Includes default entries for, if they exist:\n$HOME/.rust\nDIR/.rust for any DIR that's the current working directory\nor an ancestor of it",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustlibdir","","",null,{"inputs":[],"output":{"name":"string"}}],[0,"macro_import","rustc_lint::metadata","Used by `rustc` when loading a crate with exported macros.",null,null],[5,"read_macro_defs","rustc_lint::metadata::macro_import","Read exported macros.",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"vec"}}],[6,"MacroSelection","","",null,null],[0,"middle","rustc_lint","",null,null],[0,"astconv_util","rustc_lint::middle","This module contains a simple utility routine\nused by both `typeck` and `const_eval`.\nAlmost certainly this could (and should) be refactored out of existence.",null,null],[17,"NO_REGIONS","rustc_lint::middle::astconv_util","",null,null],[17,"NO_TPS","","",null,null],[5,"check_path_args","","",null,null],[5,"prim_ty_to_ty","","",null,null],[5,"ast_ty_to_prim_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"ty"}],"output":{"name":"option"}}],[0,"astencode","rustc_lint::middle","",null,null],[5,"encode_inlined_item","rustc_lint::middle::astencode","",null,null],[5,"decode_inlined_item","","Decodes an item from its AST in the cdata's metadata and adds it to the\nast-map.",null,{"inputs":[{"name":"crate_metadata"},{"name":"ctxt"},{"name":"vec"},{"name":"doc"}],"output":{"name":"result"}}],[5,"encode_closure_kind","","",null,null],[8,"vtable_decoder_helpers","","",null,null],[10,"read_vec_per_param_space","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_res_with_key","","",419,null],[10,"read_vtable_res","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[10,"read_vtable_param_res","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[10,"read_vtable_origin","","",419,{"inputs":[{"name":"vtable_decoder_helpers"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[0,"cfg","rustc_lint::middle","Module that constructs a control-flow graph representing an item.\nUses `Graph` as the underlying representation.",null,null],[0,"graphviz","rustc_lint::middle::cfg","",null,null],[6,"Node","rustc_lint::middle::cfg::graphviz","",null,null],[6,"Edge","","",null,null],[3,"LabelledCFG","","",null,null],[12,"ast_map","","",31,null],[12,"cfg","","",31,null],[12,"name","","",31,null],[12,"labelled_edges","","`labelled_edges` controls whether we emit labels on the edges",31,null],[3,"CFG","rustc_lint::middle::cfg","",null,null],[12,"graph","","",33,null],[12,"entry","","",33,null],[12,"exit","","",33,null],[4,"CFGNodeData","","",null,null],[13,"AST","","",32,null],[13,"Entry","","",32,null],[13,"Exit","","",32,null],[13,"Dummy","","",32,null],[13,"Unreachable","","",32,null],[3,"CFGEdgeData","","",null,null],[12,"exiting_scopes","","",420,null],[6,"CFGIndex","","",null,null],[6,"CFGGraph","","",null,null],[6,"CFGNode","","",null,null],[6,"CFGEdge","","",null,null],[0,"check_const","rustc_lint::middle","",null,null],[3,"ConstQualif","rustc_lint::middle::check_const","",null,null],[17,"PURE_CONST","","",null,null],[17,"MUTABLE_MEM","","",null,null],[17,"NEEDS_DROP","","",null,null],[17,"PREFER_IN_PLACE","","",null,null],[17,"NON_ZERO_SIZED","","",null,null],[17,"HAS_STATIC_BORROWS","","",null,null],[17,"NOT_CONST","","",null,null],[17,"NON_STATIC_BORROWS","","",null,null],[5,"check_crate","","",null,null],[0,"check_static_recursion","rustc_lint::middle","",null,null],[5,"check_crate","rustc_lint::middle::check_static_recursion","",null,null],[5,"check_item_recursion","","",null,null],[0,"check_loop","rustc_lint::middle","",null,null],[5,"check_crate","rustc_lint::middle::check_loop","",null,null],[0,"check_match","rustc_lint::middle","",null,null],[17,"DUMMY_WILD_PAT","rustc_lint::middle::check_match","",null,null],[3,"MatchCheckCtxt","","",null,null],[12,"tcx","","",45,null],[12,"param_env","","",45,null],[4,"Constructor","","",null,null],[13,"Single","","The constructor of all patterns that don't vary by constructor,\ne.g. struct patterns and fixed-length arrays.",42,null],[13,"Variant","","Enum variants.",42,null],[13,"ConstantValue","","Literal values.",42,null],[13,"ConstantRange","","Ranges of literal values (2..5).",42,null],[13,"Slice","","Array patterns of length n.",42,null],[13,"SliceWithSubslice","","Array patterns with a subslice.",42,null],[5,"check_crate","","",null,null],[3,"StaticInliner","","",null,null],[12,"tcx","","",46,null],[12,"failed","","",46,null],[12,"renaming_map","","",46,null],[5,"constructor_arity","","This computes the arity of a constructor. The arity of a constructor\nis how many subpattern patterns of that constructor should be expanded to.",null,{"inputs":[{"name":"matchcheckctxt"},{"name":"constructor"},{"name":"tys"}],"output":{"name":"usize"}}],[5,"specialize","","This is the main specialization step. It expands the first pattern in the given row\ninto `arity` patterns based on the constructor. For most patterns, the step is trivial,\nfor instance tuple patterns are flattened and box patterns expand into their inner pattern.",null,null],[0,"check_rvalues","rustc_lint::middle","",null,null],[5,"check_crate","rustc_lint::middle::check_rvalues","",null,null],[0,"const_eval","rustc_lint::middle","",null,null],[5,"lookup_const_by_id","rustc_lint::middle::const_eval","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[4,"const_val","","",null,null],[13,"const_float","","",52,null],[13,"const_int","","",52,null],[13,"const_uint","","",52,null],[13,"const_str","","",52,null],[13,"const_binary","","",52,null],[13,"const_bool","","",52,null],[13,"Struct","","",52,null],[13,"Tuple","","",52,null],[5,"const_expr_to_pat","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"span"}],"output":{"name":"p"}}],[5,"eval_const_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"const_val"}}],[3,"ConstEvalErr","","",null,null],[12,"span","","",53,null],[12,"kind","","",53,null],[4,"ErrKind","","",null,null],[13,"CannotCast","","",54,null],[13,"CannotCastTo","","",54,null],[13,"InvalidOpForBools","","",54,null],[13,"InvalidOpForFloats","","",54,null],[13,"InvalidOpForIntUint","","",54,null],[13,"InvalidOpForUintInt","","",54,null],[13,"NegateOnString","","",54,null],[13,"NegateOnBoolean","","",54,null],[13,"NegateOnBinary","","",54,null],[13,"NegateOnStruct","","",54,null],[13,"NegateOnTuple","","",54,null],[13,"NotOnFloat","","",54,null],[13,"NotOnString","","",54,null],[13,"NotOnBinary","","",54,null],[13,"NotOnStruct","","",54,null],[13,"NotOnTuple","","",54,null],[13,"NegateWithOverflow","","",54,null],[13,"AddiWithOverflow","","",54,null],[13,"SubiWithOverflow","","",54,null],[13,"MuliWithOverflow","","",54,null],[13,"AdduWithOverflow","","",54,null],[13,"SubuWithOverflow","","",54,null],[13,"MuluWithOverflow","","",54,null],[13,"DivideByZero","","",54,null],[13,"DivideWithOverflow","","",54,null],[13,"ModuloByZero","","",54,null],[13,"ModuloWithOverflow","","",54,null],[13,"ShiftLeftWithOverflow","","",54,null],[13,"ShiftRightWithOverflow","","",54,null],[13,"MissingStructField","","",54,null],[13,"NonConstPath","","",54,null],[13,"ExpectedConstTuple","","",54,null],[13,"ExpectedConstStruct","","",54,null],[13,"TupleIndexOutOfBounds","","",54,null],[13,"MiscBinaryOp","","",54,null],[13,"MiscCatchAll","","",54,null],[6,"EvalResult","","",null,null],[6,"CastResult","","",null,null],[4,"IntTy","","",null,null],[13,"I8","","",55,null],[13,"I16","","",55,null],[13,"I32","","",55,null],[13,"I64","","",55,null],[4,"UintTy","","",null,null],[13,"U8","","",56,null],[13,"U16","","",56,null],[13,"U32","","",56,null],[13,"U64","","",56,null],[5,"const_int_checked_neg","","",null,{"inputs":[{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_neg","","",null,{"inputs":[{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_add","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_sub","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_mul","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_div","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_rem","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shl","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shl_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shr","","",null,{"inputs":[{"name":"i64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_int_checked_shr_via_uint","","",null,{"inputs":[{"name":"i64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_add","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_sub","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_mul","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_div","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_rem","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shl","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shl_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shr","","",null,{"inputs":[{"name":"u64"},{"name":"u64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"const_uint_checked_shr_via_int","","",null,{"inputs":[{"name":"u64"},{"name":"i64"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"eval_const_expr_partial","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"option"}],"output":{"name":"result"}}],[5,"compare_const_vals","","",null,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"option"}}],[5,"compare_lit_exprs","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"},{"name":"expr"},{"name":"option"}],"output":{"name":"option"}}],[0,"dataflow","rustc_lint::middle","A module for propagating forward dataflow information. The analysis\nassumes that the items to be propagated can be represented as bits\nand thus uses bitvectors. Your job is simply to specify the so-called\nGEN and KILL bits for each expression.",null,null],[4,"EntryOrExit","rustc_lint::middle::dataflow","",null,null],[13,"Entry","","",57,null],[13,"Exit","","",57,null],[3,"DataFlowContext","","",null,null],[8,"BitwiseOperator","","",null,null],[10,"join","","Joins two predecessor bits together, typically either `|` or `&`",421,{"inputs":[{"name":"bitwiseoperator"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[8,"DataFlowOperator","","Parameterization for the precise form of data flow that is used.",null,null],[10,"initial_value","","Specifies the initial value for each bit in the `on_entry` set",422,{"inputs":[{"name":"dataflowoperator"}],"output":{"name":"bool"}}],[4,"KillFrom","","Flag used by `add_kill` to indicate whether the provided kill\ntakes effect only when control flows directly through the node in\nquestion, or if the kill's effect is associated with any\ncontrol-flow directly through or indirectly over the node.",null,null],[13,"ScopeEnd","","A `ScopeEnd` kill is one that takes effect when any control\nflow goes over the node. A kill associated with the end of the\nscope of a variable declaration `let x;` is an example of a\n`ScopeEnd` kill.",59,null],[13,"Execution","","An `Execution` kill is one that takes effect only when control\nflow goes through the node to completion. A kill associated\nwith an assignment statement `x = expr;` is an example of an\n`Execution` kill.",59,null],[0,"dead","rustc_lint::middle","",null,null],[5,"check_crate","rustc_lint::middle::dead","",null,null],[0,"def","rustc_lint::middle","",null,null],[4,"Def","rustc_lint::middle::def","",null,null],[13,"DefFn","","",15,null],[13,"DefSelfTy","","",15,null],[13,"DefMod","","",15,null],[13,"DefForeignMod","","",15,null],[13,"DefStatic","","",15,null],[13,"DefConst","","",15,null],[13,"DefLocal","","",15,null],[13,"DefVariant","","",15,null],[13,"DefTy","","",15,null],[13,"DefAssociatedTy","","",15,null],[13,"DefTrait","","",15,null],[13,"DefPrimTy","","",15,null],[13,"DefTyParam","","",15,null],[13,"DefUse","","",15,null],[13,"DefUpvar","","",15,null],[13,"DefStruct","","Note that if it's a tuple struct's definition, the node id of the ast::DefId\nmay either refer to the item definition's id or the StructDef.ctor_id.",15,null],[13,"DefRegion","","",15,null],[13,"DefLabel","","",15,null],[13,"DefMethod","","",15,null],[3,"PathResolution","","The result of resolving a path.\nBefore type checking completes, `depth` represents the number of\ntrailing segments which are yet unresolved. Afterwards, if there\nwere no errors, all paths should be fully resolved, with `depth`\nset to `0` and `base_def` representing the final resolution.",null,null],[12,"base_def","","",65,null],[12,"last_private","","",65,null],[12,"depth","","",65,null],[6,"DefMap","","",null,null],[6,"ExportMap","","",null,null],[3,"Export","","",null,null],[12,"name","","",66,null],[12,"def_id","","",66,null],[4,"MethodProvenance","","",null,null],[13,"FromTrait","","",67,null],[13,"FromImpl","","",67,null],[0,"dependency_format","rustc_lint::middle","Resolution of mixing rlibs and dylibs",null,null],[6,"DependencyList","rustc_lint::middle::dependency_format","",null,null],[6,"Dependencies","","",null,null],[5,"calculate","","",null,null],[0,"effect","rustc_lint::middle","Enforces the Rust effect system. Currently there is just one effect,\n`unsafe`.",null,null],[5,"check_crate","rustc_lint::middle::effect","",null,null],[0,"entry","rustc_lint::middle","",null,null],[5,"find_entry_point","rustc_lint::middle::entry","",null,null],[0,"expr_use_visitor","rustc_lint::middle","A different sort of visitor for walking fn bodies.  Unlike the\nnormal visitor, which just walks the entire body in one shot, the\n`ExprUseVisitor` determines how expressions are being used.",null,null],[8,"Delegate","rustc_lint::middle::expr_use_visitor","This trait defines the callbacks you can expect to receive when\nemploying the ExprUseVisitor.",null,null],[10,"consume","","",423,null],[10,"matched_pat","","",423,null],[10,"consume_pat","","",423,null],[10,"borrow","","",423,null],[10,"decl_without_init","","",423,null],[10,"mutate","","",423,null],[4,"LoanCause","","",null,null],[13,"ClosureCapture","","",71,null],[13,"AddrOf","","",71,null],[13,"AutoRef","","",71,null],[13,"AutoUnsafe","","",71,null],[13,"RefBinding","","",71,null],[13,"OverloadedOperator","","",71,null],[13,"ClosureInvocation","","",71,null],[13,"ForLoop","","",71,null],[13,"MatchDiscriminant","","",71,null],[4,"ConsumeMode","","",null,null],[13,"Copy","","",72,null],[13,"Move","","",72,null],[4,"MoveReason","","",null,null],[13,"DirectRefMove","","",73,null],[13,"PatBindingMove","","",73,null],[13,"CaptureMove","","",73,null],[4,"MatchMode","","",null,null],[13,"NonBindingMatch","","",74,null],[13,"BorrowingMatch","","",74,null],[13,"CopyingMatch","","",74,null],[13,"MovingMatch","","",74,null],[4,"MutateMode","","",null,null],[13,"Init","","",76,null],[13,"JustWrite","","",76,null],[13,"WriteAndRead","","",76,null],[3,"ExprUseVisitor","","",null,null],[0,"fast_reject","rustc_lint::middle","",null,null],[4,"SimplifiedType","rustc_lint::middle::fast_reject","See `simplify_type",null,null],[13,"BoolSimplifiedType","","",79,null],[13,"CharSimplifiedType","","",79,null],[13,"IntSimplifiedType","","",79,null],[13,"UintSimplifiedType","","",79,null],[13,"FloatSimplifiedType","","",79,null],[13,"EnumSimplifiedType","","",79,null],[13,"StrSimplifiedType","","",79,null],[13,"VecSimplifiedType","","",79,null],[13,"PtrSimplifiedType","","",79,null],[13,"TupleSimplifiedType","","",79,null],[13,"TraitSimplifiedType","","",79,null],[13,"StructSimplifiedType","","",79,null],[13,"ClosureSimplifiedType","","",79,null],[13,"FunctionSimplifiedType","","",79,null],[13,"ParameterSimplifiedType","","",79,null],[5,"simplify_type","","Tries to simplify a type by dropping type parameters, deref'ing away any reference types, etc.\nThe idea is to get something simple that we can use to quickly decide if two types could unify\nduring method lookup.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"bool"}],"output":{"name":"option"}}],[0,"free_region","rustc_lint::middle","This file defines",null,null],[3,"FreeRegionMap","rustc_lint::middle::free_region","",null,null],[0,"graph","rustc_lint::middle","A graph module for use in dataflow, region resolution, and elsewhere.",null,null],[3,"Graph","rustc_lint::middle::graph","",null,null],[3,"Node","","",null,null],[12,"data","","",424,null],[3,"Edge","","",null,null],[12,"data","","",81,null],[3,"NodeIndex","","",null,null],[17,"InvalidNodeIndex","","",null,null],[3,"EdgeIndex","","",null,null],[17,"InvalidEdgeIndex","","",null,null],[3,"Direction","","",null,null],[17,"Outgoing","","",null,null],[17,"Incoming","","",null,null],[3,"DepthFirstTraversal","","",null,null],[5,"each_edge_index","","",null,null],[0,"intrinsicck","rustc_lint::middle","",null,null],[5,"check_crate","rustc_lint::middle::intrinsicck","",null,null],[0,"infer","rustc_lint::middle","See the Book for more information.",null,null],[0,"bivariate","rustc_lint::middle::infer","Applies the \"bivariance relationship\" to two types and/or regions.\nIf (A,B) are bivariant then either A <: B or B <: A. It occurs\nwhen type/lifetime parameters are unconstrained. Usually this is\nan error, but we permit it in the specific case where a type\nparameter is constrained in a where-clause via an associated type.",null,null],[3,"Bivariate","rustc_lint::middle::infer::bivariate","",null,null],[0,"combine","rustc_lint::middle::infer","",null,null],[3,"CombineFields","rustc_lint::middle::infer::combine","",null,null],[12,"infcx","","",90,null],[12,"a_is_expected","","",90,null],[12,"trace","","",90,null],[5,"super_combine_tys","","",null,{"inputs":[{"name":"inferctxt"},{"name":"r"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[8,"RelateResultCompare","","",null,null],[10,"compare","","",425,{"inputs":[{"name":"relateresultcompare"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[0,"equate","rustc_lint::middle::infer","",null,null],[3,"Equate","rustc_lint::middle::infer::equate","",null,null],[0,"error_reporting","rustc_lint::middle::infer","Error Reporting Code for the inference engine",null,null],[8,"ErrorReporting","rustc_lint::middle::infer::error_reporting","",null,null],[10,"report_region_errors","","",426,null],[10,"process_errors","","",426,{"inputs":[{"name":"errorreporting"},{"name":"vec"}],"output":{"name":"vec"}}],[10,"report_type_error","","",426,null],[10,"report_and_explain_type_error","","",426,null],[10,"values_str","","",426,{"inputs":[{"name":"errorreporting"},{"name":"valuepairs"}],"output":{"name":"option"}}],[10,"expected_found_str","","",426,{"inputs":[{"name":"errorreporting"},{"name":"expected_found"}],"output":{"name":"option"}}],[10,"report_concrete_failure","","",426,null],[10,"report_generic_bound_failure","","",426,null],[10,"report_sub_sup_conflict","","",426,null],[10,"report_sup_sup_conflict","","",426,null],[10,"report_processed_errors","","",426,null],[10,"give_suggestion","","",426,null],[8,"Resolvable","","",null,null],[10,"resolve","","",427,{"inputs":[{"name":"resolvable"},{"name":"inferctxt"}],"output":{"name":"self"}}],[10,"contains_error","","",427,{"inputs":[{"name":"resolvable"}],"output":{"name":"bool"}}],[0,"glb","rustc_lint::middle::infer","",null,null],[3,"Glb","rustc_lint::middle::infer::glb","\"Greatest lower bound\" (common subtype)",null,null],[0,"lattice","rustc_lint::middle::infer","# Lattice Variables",null,null],[8,"LatticeDir","rustc_lint::middle::infer::lattice","",null,null],[10,"infcx","","",428,{"inputs":[{"name":"latticedir"}],"output":{"name":"inferctxt"}}],[10,"relate_bound","","",428,{"inputs":[{"name":"latticedir"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"super_lattice_tys","","",null,{"inputs":[{"name":"l"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[0,"lub","rustc_lint::middle::infer","",null,null],[3,"Lub","rustc_lint::middle::infer::lub","\"Least upper bound\" (common supertype)",null,null],[0,"region_inference","rustc_lint::middle::infer","See README.md",null,null],[4,"Constraint","rustc_lint::middle::infer::region_inference","",null,null],[13,"ConstrainVarSubVar","","",102,null],[13,"ConstrainRegSubVar","","",102,null],[13,"ConstrainVarSubReg","","",102,null],[4,"Verify","","",null,null],[13,"VerifyRegSubReg","","",113,null],[13,"VerifyGenericBound","","",113,null],[4,"GenericKind","","",null,null],[13,"Param","","",103,null],[13,"Projection","","",103,null],[3,"TwoRegions","","",null,null],[4,"UndoLogEntry","","",null,null],[13,"OpenSnapshot","","",105,null],[13,"CommitedSnapshot","","",105,null],[13,"AddVar","","",105,null],[13,"AddConstraint","","",105,null],[13,"AddVerify","","",105,null],[13,"AddGiven","","",105,null],[13,"AddCombination","","",105,null],[4,"CombineMapType","","",null,null],[13,"Lub","","",106,null],[13,"Glb","","",106,null],[4,"RegionResolutionError","","",null,null],[13,"ConcreteFailure","","`ConcreteFailure(o, a, b)`:",107,null],[13,"GenericBoundFailure","","`GenericBoundFailure(p, s, a, bs)",107,null],[13,"SubSupConflict","","`SubSupConflict(v, sub_origin, sub_r, sup_origin, sup_r)`:",107,null],[13,"SupSupConflict","","`SupSupConflict(v, origin1, r1, origin2, r2)`:",107,null],[13,"ProcessedErrors","","For subsets of `ConcreteFailure` and `SubSupConflict`, we can derive\nmore specific errors message by suggesting to the user where they\nshould put a lifetime. In those cases we process and put those errors\ninto `ProcessedErrors` before we do any reporting.",107,null],[3,"SameRegions","","SameRegions is used to group regions that we think are the same and would\nlike to indicate so to the user.\nFor example, the following function\n```\nstruct Foo { bar: int }\nfn foo2<'a, 'b>(x: &'a Foo) -> &'b int {\n   &x.bar\n}\n```\nwould report an error because we expect 'a and 'b to match, and so we group\n'a and 'b together inside a SameRegions struct",null,null],[12,"scope_id","","",108,null],[12,"regions","","",108,null],[6,"CombineMap","","",null,null],[3,"RegionVarBindings","","",null,null],[3,"RegionSnapshot","","",null,null],[4,"VarValue","","",null,null],[13,"NoValue","","",112,null],[13,"Value","","",112,null],[13,"ErrorValue","","",112,null],[0,"resolve","rustc_lint::middle::infer","",null,null],[3,"OpportunisticTypeResolver","rustc_lint::middle::infer::resolve","The opportunistic type resolver can be used at any time. It simply replaces\ntype variables that have been unified with the things they have\nbeen unified with (similar to `shallow_resolve`, but deep). This is\nuseful for printing messages etc but also required at various\npoints for correctness.",null,null],[5,"fully_resolve","","Full type resolution replaces all type and region variables with\ntheir concrete results. If any variable cannot be replaced (never unified, etc)\nthen an `Err` result is returned.",null,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[0,"sub","rustc_lint::middle::infer","",null,null],[3,"Sub","rustc_lint::middle::infer::sub","\"Greatest lower bound\" (common subtype)",null,null],[0,"type_variable","rustc_lint::middle::infer","",null,null],[3,"TypeVariableTable","rustc_lint::middle::infer::type_variable","",null,null],[3,"Snapshot","","",null,null],[4,"RelationDir","","",null,null],[13,"SubtypeOf","","",119,null],[13,"SupertypeOf","","",119,null],[13,"EqTo","","",119,null],[13,"BiTo","","",119,null],[0,"unify","rustc_lint::middle::infer","",null,null],[8,"UnifyKey","rustc_lint::middle::infer::unify","This trait is implemented by any type that can serve as a type\nvariable. We call such variables *unification keys*. For example,\nthis trait is implemented by `IntVid`, which represents integral\nvariables.",null,null],[16,"Value","rustc_lint::middle::infer::unify::UnifyKey","",null,null],[10,"index","rustc_lint::middle::infer::unify","",429,{"inputs":[{"name":"unifykey"}],"output":{"name":"u32"}}],[10,"from_index","","",429,{"inputs":[{"name":"unifykey"},{"name":"u32"}],"output":{"name":"self"}}],[10,"tag","","",429,{"inputs":[{"name":"unifykey"},{"name":"option"}],"output":{"name":"str"}}],[8,"UnifyValue","","Trait for valid types that a type variable can be set to. Note that\nthis is typically not the end type that the value will take on, but\nrather an `Option` wrapper (where `None` represents a variable\nwhose value is not yet set).",null,null],[4,"VarValue","","Value of a unification key. We implement Tarjan's union-find\nalgorithm: when two keys are unified, one of them is converted\ninto a \"redirect\" pointing at the other. These redirects form a\nDAG: the roots of the DAG (nodes that are not redirected) are each\nassociated with a value of type `V` and a rank. The rank is used\nto keep the DAG relatively balanced, which helps keep the running\ntime of the algorithm under control. For more information, see\n<http://en.wikipedia.org/wiki/Disjoint-set_data_structure>.",null,null],[13,"Redirect","","",122,null],[13,"Root","","",122,null],[3,"UnificationTable","","Table of unification keys and their values.",null,null],[3,"Snapshot","","At any time, users may snapshot a unification table.  The changes\nmade during the snapshot may either be *committed* or *rolled back*.",null,null],[3,"Node","","Internal type used to represent the result of a `get()` operation.\nConveys the current root and value of the key.",null,null],[12,"key","","",430,null],[12,"value","","",430,null],[12,"rank","","",430,null],[3,"Delegate","","",null,null],[8,"ToType","","",null,null],[10,"to_type","","",431,{"inputs":[{"name":"totype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Bound","rustc_lint::middle::infer","",null,null],[6,"UnitResult","","",null,null],[6,"fres","","",null,null],[3,"InferCtxt","","",null,null],[12,"tcx","","",94,null],[6,"SkolemizationMap","","",null,null],[4,"TypeOrigin","","Why did we require that the two types be related?",null,null],[13,"Misc","","",129,null],[13,"MethodCompatCheck","","",129,null],[13,"ExprAssignable","","",129,null],[13,"RelateTraitRefs","","",129,null],[13,"RelateSelfType","","",129,null],[13,"RelateOutputImplTypes","","",129,null],[13,"MatchExpressionArm","","",129,null],[13,"IfExpression","","",129,null],[13,"IfExpressionWithNoElse","","",129,null],[13,"RangeExpression","","",129,null],[13,"EquatePredicate","","",129,null],[4,"ValuePairs","","See `error_reporting.rs` for more details",null,null],[13,"Types","","",130,null],[13,"TraitRefs","","",130,null],[13,"PolyTraitRefs","","",130,null],[3,"TypeTrace","","The trace designates the path through inference that we took to\nencounter an error or subtyping constraint.",null,null],[4,"SubregionOrigin","","The origin of a `r1 <= r2` constraint.",null,null],[13,"Subtype","","",132,null],[13,"InfStackClosure","","",132,null],[13,"InvokeClosure","","",132,null],[13,"DerefPointer","","",132,null],[13,"FreeVariable","","",132,null],[13,"IndexSlice","","",132,null],[13,"RelateObjectBound","","",132,null],[13,"RelateParamBound","","",132,null],[13,"RelateRegionParamBound","","",132,null],[13,"RelateDefaultParamBound","","",132,null],[13,"Reborrow","","",132,null],[13,"ReborrowUpvar","","",132,null],[13,"ReferenceOutlivesReferent","","",132,null],[13,"ExprTypeIsNotInScope","","",132,null],[13,"BindingTypeIsNotValidAtDecl","","",132,null],[13,"CallRcvr","","",132,null],[13,"CallArg","","",132,null],[13,"CallReturn","","",132,null],[13,"Operand","","",132,null],[13,"AddrOf","","",132,null],[13,"AutoBorrow","","",132,null],[13,"SafeDestructor","","",132,null],[4,"LateBoundRegionConversionTime","","Times when we replace late-bound regions with variables:",null,null],[13,"FnCall","","when a fn is called",133,null],[13,"HigherRankedType","","when two higher-ranked types are compared",133,null],[13,"AssocTypeProjection","","when projecting an associated type",133,null],[4,"RegionVariableOrigin","","Reasons to create a region inference variable",null,null],[13,"MiscVariable","","",134,null],[13,"PatternRegion","","",134,null],[13,"AddrOfRegion","","",134,null],[13,"Autoref","","",134,null],[13,"Coercion","","",134,null],[13,"EarlyBoundRegion","","",134,null],[13,"LateBoundRegion","","",134,null],[13,"UpvarRegion","","",134,null],[13,"BoundRegionInCoherence","","",134,null],[4,"fixup_err","","",null,null],[13,"unresolved_int_ty","","",135,null],[13,"unresolved_float_ty","","",135,null],[13,"unresolved_ty","","",135,null],[5,"fixup_err_to_string","","",null,{"inputs":[{"name":"fixup_err"}],"output":{"name":"string"}}],[5,"new_infer_ctxt","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"inferctxt"}}],[5,"common_supertype","","Computes the least upper-bound of `a` and `b`. If this is not possible, reports an error and\nreturns ty::err.",null,{"inputs":[{"name":"inferctxt"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"can_mk_subty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"can_mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"mk_subr","","",null,null],[5,"mk_eqty","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"mk_sub_poly_trait_refs","","",null,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[3,"CombinedSnapshot","","",null,null],[4,"GenericKind","","",null,null],[13,"Param","","",103,null],[13,"Projection","","",103,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",126,null],[13,"UintType","","",126,null],[3,"TypeFreshener","","",null,null],[0,"implicator","rustc_lint::middle","",null,null],[4,"Implication","rustc_lint::middle::implicator","",null,null],[13,"RegionSubRegion","","",136,null],[13,"RegionSubGeneric","","",136,null],[13,"RegionSubClosure","","",136,null],[13,"Predicate","","",136,null],[5,"implications","","This routine computes the well-formedness constraints that must hold for the type `ty` to\nappear in a context with lifetime `outer_region`",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"u32"},{"name":"tys"},{"name":"region"},{"name":"span"}],"output":{"name":"vec"}}],[5,"object_region_bounds","","Given an object type like `SomeTrait+Send`, computes the lifetime\nbounds that must hold on the elided self type. These are derived\nfrom the declarations of `SomeTrait`, `Send`, and friends -- if\nthey declare `trait SomeTrait : 'static`, for example, then\n`'static` would appear in the list. The hard work is done by\n`ty::required_region_bounds`, see that for more information.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"enumset"}],"output":{"name":"vec"}}],[0,"lang_items","rustc_lint::middle","",null,null],[4,"LangItem","rustc_lint::middle::lang_items","",null,null],[13,"CharImplItem","","",137,null],[13,"StrImplItem","","",137,null],[13,"SliceImplItem","","",137,null],[13,"ConstPtrImplItem","","",137,null],[13,"MutPtrImplItem","","",137,null],[13,"I8ImplItem","","",137,null],[13,"I16ImplItem","","",137,null],[13,"I32ImplItem","","",137,null],[13,"I64ImplItem","","",137,null],[13,"IsizeImplItem","","",137,null],[13,"U8ImplItem","","",137,null],[13,"U16ImplItem","","",137,null],[13,"U32ImplItem","","",137,null],[13,"U64ImplItem","","",137,null],[13,"UsizeImplItem","","",137,null],[13,"F32ImplItem","","",137,null],[13,"F64ImplItem","","",137,null],[13,"SendTraitLangItem","","",137,null],[13,"SizedTraitLangItem","","",137,null],[13,"CopyTraitLangItem","","",137,null],[13,"SyncTraitLangItem","","",137,null],[13,"DropTraitLangItem","","",137,null],[13,"AddTraitLangItem","","",137,null],[13,"SubTraitLangItem","","",137,null],[13,"MulTraitLangItem","","",137,null],[13,"DivTraitLangItem","","",137,null],[13,"RemTraitLangItem","","",137,null],[13,"NegTraitLangItem","","",137,null],[13,"NotTraitLangItem","","",137,null],[13,"BitXorTraitLangItem","","",137,null],[13,"BitAndTraitLangItem","","",137,null],[13,"BitOrTraitLangItem","","",137,null],[13,"ShlTraitLangItem","","",137,null],[13,"ShrTraitLangItem","","",137,null],[13,"IndexTraitLangItem","","",137,null],[13,"IndexMutTraitLangItem","","",137,null],[13,"RangeStructLangItem","","",137,null],[13,"RangeFromStructLangItem","","",137,null],[13,"RangeToStructLangItem","","",137,null],[13,"RangeFullStructLangItem","","",137,null],[13,"UnsafeCellTypeLangItem","","",137,null],[13,"DerefTraitLangItem","","",137,null],[13,"DerefMutTraitLangItem","","",137,null],[13,"FnTraitLangItem","","",137,null],[13,"FnMutTraitLangItem","","",137,null],[13,"FnOnceTraitLangItem","","",137,null],[13,"EqTraitLangItem","","",137,null],[13,"OrdTraitLangItem","","",137,null],[13,"StrEqFnLangItem","","",137,null],[13,"PanicFnLangItem","","",137,null],[13,"PanicBoundsCheckFnLangItem","","",137,null],[13,"PanicFmtLangItem","","",137,null],[13,"ExchangeMallocFnLangItem","","",137,null],[13,"ExchangeFreeFnLangItem","","",137,null],[13,"StrDupUniqFnLangItem","","",137,null],[13,"StartFnLangItem","","",137,null],[13,"EhPersonalityLangItem","","",137,null],[13,"ExchangeHeapLangItem","","",137,null],[13,"OwnedBoxLangItem","","",137,null],[13,"PhantomDataItem","","",137,null],[13,"CovariantTypeItem","","",137,null],[13,"ContravariantTypeItem","","",137,null],[13,"InvariantTypeItem","","",137,null],[13,"CovariantLifetimeItem","","",137,null],[13,"ContravariantLifetimeItem","","",137,null],[13,"InvariantLifetimeItem","","",137,null],[13,"NoCopyItem","","",137,null],[13,"ManagedItem","","",137,null],[13,"NonZeroItem","","",137,null],[13,"StackExhaustedLangItem","","",137,null],[13,"DebugTraitLangItem","","",137,null],[3,"LanguageItems","","",null,null],[12,"items","","",138,null],[12,"missing","","",138,null],[5,"extract","","",null,null],[5,"collect_language_items","","",null,{"inputs":[{"name":"crate"},{"name":"session"}],"output":{"name":"languageitems"}}],[0,"liveness","rustc_lint::middle","A classic liveness analysis based on dataflow over the AST.  Computes,\nfor each local variable in a function, whether that variable is live\nat a given point.  Program execution points are identified by their\nid.",null,null],[5,"check_crate","rustc_lint::middle::liveness","",null,null],[0,"mem_categorization","rustc_lint::middle","# Categorization",null,null],[4,"categorization","rustc_lint::middle::mem_categorization","",null,null],[13,"cat_rvalue","","",149,null],[13,"cat_static_item","","",149,null],[13,"cat_upvar","","",149,null],[13,"cat_local","","",149,null],[13,"cat_deref","","",149,null],[13,"cat_interior","","",149,null],[13,"cat_downcast","","",149,null],[3,"Upvar","","",null,null],[12,"id","","",150,null],[12,"kind","","",150,null],[4,"PointerKind","","",null,null],[13,"Unique","","`Box<T>`",151,null],[13,"BorrowedPtr","","`&T`",151,null],[13,"UnsafePtr","","`*T`",151,null],[13,"Implicit","","Implicit deref of the `&T` that results from an overloaded index `[]`.",151,null],[4,"InteriorKind","","",null,null],[13,"InteriorField","","",152,null],[13,"InteriorElement","","",152,null],[4,"FieldName","","",null,null],[13,"NamedField","","",153,null],[13,"PositionalField","","",153,null],[4,"InteriorOffsetKind","","",null,null],[13,"Index","","",154,null],[13,"Pattern","","",154,null],[4,"ElementKind","","",null,null],[13,"VecElement","","",155,null],[13,"OtherElement","","",155,null],[4,"MutabilityCategory","","",null,null],[13,"McImmutable","","",156,null],[13,"McDeclared","","",156,null],[13,"McInherited","","",156,null],[4,"Note","","",null,null],[13,"NoteClosureEnv","","",157,null],[13,"NoteUpvarRef","","",157,null],[13,"NoteNone","","",157,null],[3,"cmt_","","",null,null],[12,"id","","",158,null],[12,"span","","",158,null],[12,"cat","","",158,null],[12,"mutbl","","",158,null],[12,"ty","","",158,null],[12,"note","","",158,null],[6,"cmt","","",null,null],[4,"deref_kind","","",null,null],[13,"deref_ptr","","",159,null],[13,"deref_interior","","",159,null],[8,"ast_node","","",null,null],[10,"id","","",432,{"inputs":[{"name":"ast_node"}],"output":{"name":"u32"}}],[10,"span","","",432,{"inputs":[{"name":"ast_node"}],"output":{"name":"span"}}],[3,"MemCategorizationContext","","",null,null],[6,"McResult","","",null,null],[8,"Typer","","The `Typer` trait provides the interface for the mem-categorization\nmodule to the results of the type check. It can be used to query\nthe type assigned to an expression node, to inquire after adjustments,\nand so on.",null,null],[10,"node_ty","","",433,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"result"}}],[10,"expr_ty_adjusted","","",433,{"inputs":[{"name":"typer"},{"name":"expr"}],"output":{"name":"result"}}],[10,"type_moves_by_default","","",433,{"inputs":[{"name":"typer"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[10,"node_method_ty","","",433,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"node_method_origin","","",433,{"inputs":[{"name":"typer"},{"name":"methodcall"}],"output":{"name":"option"}}],[10,"adjustments","","",433,{"inputs":[{"name":"typer"}],"output":{"name":"refcell"}}],[10,"is_method_call","","",433,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"bool"}}],[10,"temporary_scope","","",433,{"inputs":[{"name":"typer"},{"name":"u32"}],"output":{"name":"option"}}],[10,"upvar_capture","","",433,{"inputs":[{"name":"typer"},{"name":"upvarid"}],"output":{"name":"option"}}],[4,"InteriorSafety","","",null,null],[13,"InteriorUnsafe","","",163,null],[13,"InteriorSafe","","",163,null],[4,"Aliasability","","",null,null],[13,"FreelyAliasable","","",164,null],[13,"NonAliasable","","",164,null],[13,"ImmutableUnique","","",164,null],[4,"AliasableReason","","",null,null],[13,"AliasableBorrowed","","",165,null],[13,"AliasableClosure","","",165,null],[13,"AliasableOther","","",165,null],[13,"UnaliasableImmutable","","",165,null],[13,"AliasableStatic","","",165,null],[13,"AliasableStaticMut","","",165,null],[5,"ptr_sigil","","",null,{"inputs":[{"name":"pointerkind"}],"output":{"name":"str"}}],[0,"pat_util","rustc_lint::middle","",null,null],[6,"PatIdMap","rustc_lint::middle::pat_util","",null,null],[5,"pat_id_map","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"hashmap"}}],[5,"pat_is_refutable","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_variant_or_struct","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_const","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_is_binding_or_wild","","",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_bindings","","Call `it` on every \"binding\" in a pattern, e.g., on `a` in\n`match foo() { Some(a) => (), None => () }`",null,null],[5,"pat_contains_bindings","","Checks if the pattern contains any patterns that bind something to\nan ident, e.g. `foo`, or `Foo(foo)` or `foo @ Bar(..)`.",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"pat_contains_ref_binding","","Checks if the pattern contains any `ref` or `ref mut` bindings.",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"arm_contains_ref_binding","","Checks if the patterns for this arm contain any `ref` or `ref mut`\nbindings.",null,{"inputs":[{"name":"refcell"},{"name":"arm"}],"output":{"name":"bool"}}],[5,"pat_contains_bindings_or_wild","","Checks if the pattern contains any patterns that bind something to\nan ident or wildcard, e.g. `foo`, or `Foo(_)`, `foo @ Bar(..)`,",null,{"inputs":[{"name":"refcell"},{"name":"pat"}],"output":{"name":"bool"}}],[5,"simple_identifier","","",null,{"inputs":[{"name":"pat"}],"output":{"name":"option"}}],[5,"def_to_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"path"}}],[0,"privacy","rustc_lint::middle","A pass that checks to make sure private fields and methods aren't used\noutside their scopes. This pass will also generate a set of exported items\nwhich are available for use externally when compiled as a library.",null,null],[6,"ExportedItems","rustc_lint::middle::privacy","",null,null],[6,"ExternalExports","","",null,null],[6,"PublicItems","","",null,null],[4,"LastPrivate","","",null,null],[13,"LastMod","","",167,null],[13,"LastImport","","",167,null],[12,"value_priv","rustc_lint::middle::privacy::LastPrivate","",167,null],[12,"value_used","","",167,null],[12,"type_priv","","",167,null],[12,"type_used","","",167,null],[4,"PrivateDep","rustc_lint::middle::privacy","",null,null],[13,"AllPublic","","",168,null],[13,"DependsOn","","",168,null],[4,"ImportUse","","",null,null],[13,"Unused","","",169,null],[13,"Used","","",169,null],[0,"reachable","rustc_lint::middle","",null,null],[5,"find_reachable","rustc_lint::middle::reachable","",null,{"inputs":[{"name":"ctxt"},{"name":"hashset"}],"output":{"name":"hashset"}}],[0,"region","rustc_lint::middle","This file actually contains two passes related to regions.  The first\npass builds up the `scope_map`, which describes the parent links in\nthe region hierarchy.  The second pass infers which types must be\nregion parameterized.",null,null],[4,"CodeExtent","rustc_lint::middle::region","CodeExtent represents a statically-describable extent that can be\nused to bound the lifetime/region for values.",null,null],[13,"Misc","","",18,null],[13,"ParameterScope","","",18,null],[12,"fn_id","rustc_lint::middle::region::CodeExtent","",18,null],[12,"body_id","","",18,null],[13,"DestructionScope","rustc_lint::middle::region","",18,null],[13,"Remainder","","",18,null],[3,"DestructionScopeData","","extent of destructors for temporaries of node-id",null,null],[12,"node_id","","",19,null],[3,"BlockRemainder","","Represents a subscope of `block` for a binding that is introduced\nby `block.stmts[first_statement_index]`. Such subscopes represent\na suffix of the block. Note that each subscope does not include\nthe initializer expression, if any, for the statement indexed by\n`first_statement_index`.",null,null],[12,"block","","",171,null],[12,"first_statement_index","","",171,null],[3,"RegionMaps","","The region maps encode information about region relationships.",null,null],[3,"Context","","",null,null],[5,"resolve_crate","","",null,{"inputs":[{"name":"session"},{"name":"crate"}],"output":{"name":"regionmaps"}}],[5,"resolve_inlined_item","","",null,null],[0,"recursion_limit","rustc_lint::middle","",null,null],[5,"update_recursion_limit","rustc_lint::middle::recursion_limit","",null,null],[0,"resolve_lifetime","rustc_lint::middle","Name resolution for lifetimes.",null,null],[4,"DefRegion","rustc_lint::middle::resolve_lifetime","",null,null],[13,"DefStaticRegion","","",178,null],[13,"DefEarlyBoundRegion","","",178,null],[13,"DefLateBoundRegion","","",178,null],[13,"DefFreeRegion","","",178,null],[6,"NamedRegionMap","","",null,null],[5,"krate","","",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"refcell"}],"output":{"name":"hashmap"}}],[5,"early_bound_lifetimes","","",null,{"inputs":[{"name":"generics"}],"output":{"name":"vec"}}],[0,"stability","rustc_lint::middle","A pass that annotates every item and method with its stability level,\npropagating default levels lexically from parent to children ast nodes.",null,null],[3,"Index","rustc_lint::middle::stability","A stability index, giving the stability level for items and methods.",null,null],[5,"check_unstable_api_usage","","Cross-references the feature names of unstable APIs with enabled\nfeatures and possibly prints errors. Returns a list of all\nfeatures used.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"hashmap"}}],[5,"check_item","","Helper for discovering nodes to check for stability",null,null],[5,"check_expr","","Helper for discovering nodes to check for stability",null,null],[5,"check_path","","",null,null],[5,"check_pat","","",null,null],[5,"lookup","","Lookup the stability for a node, loading external crate\nmetadata as necessary.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"check_unused_or_stable_features","","Given the list of enabled features that were not language features (i.e. that\nwere expected to be library features), and the list of features used from\nlibraries, identify activated features that don't exist and error about them.",null,null],[0,"subst","rustc_lint::middle","",null,null],[3,"Substs","rustc_lint::middle::subst","A substitution mapping type/region parameters to new values. We\nidentify each in-scope parameter by an *index* and a *parameter\nspace* (which indices where the parameter is defined; see\n`ParamSpace`).",null,null],[12,"types","","",185,null],[12,"regions","","",185,null],[4,"RegionSubsts","","Represents the values to use when substituting lifetime parameters.\nIf the value is `ErasedRegions`, then this subst is occurring during\ntrans, and all region parameters will be replaced with `ty::ReStatic`.",null,null],[13,"ErasedRegions","","",186,null],[13,"NonerasedRegions","","",186,null],[4,"ParamSpace","","",null,null],[13,"TypeSpace","","",187,null],[13,"SelfSpace","","",187,null],[13,"FnSpace","","",187,null],[3,"VecPerParamSpace","","Vector of things sorted by param space. Used to keep\nthe set of things declared on the type, self, or method\ndistinct.",null,null],[3,"SeparateVecsPerParamSpace","","The `split` function converts one `VecPerParamSpace` into this\n`SeparateVecsPerParamSpace` structure.",null,null],[12,"types","","",434,null],[12,"selfs","","",434,null],[12,"fns","","",434,null],[3,"EnumeratedItems","","",null,null],[8,"Subst","","",null,null],[11,"subst","","",435,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"self"}}],[10,"subst_spanned","","",435,{"inputs":[{"name":"subst"},{"name":"ctxt"},{"name":"substs"},{"name":"option"}],"output":{"name":"self"}}],[0,"traits","rustc_lint::middle","Trait Resolution. See the Book for more.",null,null],[3,"Obligation","rustc_lint::middle::traits","An `Obligation` represents some trait reference (e.g. `int:Eq`) for\nwhich the vtable must be found.  The process of finding a vtable is\ncalled \"resolving\" the `Obligation`. This process consists of\neither identifying an `impl` (e.g., `impl Eq for int`) that\nprovides the required vtable, or else finding a bound that is in\nscope. The eventual result is usually a `Selection` (defined below).",null,null],[12,"cause","","",214,null],[12,"recursion_depth","","",214,null],[12,"predicate","","",214,null],[6,"PredicateObligation","","",null,null],[6,"TraitObligation","","",null,null],[3,"ObligationCause","","Why did we incur this obligation? Used for error reporting.",null,null],[12,"span","","",221,null],[12,"body_id","","",221,null],[12,"code","","",221,null],[4,"ObligationCauseCode","","",null,null],[13,"MiscObligation","","Not well classified or should be obvious from span.",222,null],[13,"ItemObligation","","In an impl of trait X for type Y, type Y must\nalso implement all supertraits of X.",222,null],[13,"ObjectCastObligation","","Obligation incurred due to an object cast.",222,null],[13,"AssignmentLhsSized","","Various cases where expressions must be sized/copy/etc:",222,null],[13,"StructInitializerSized","","",222,null],[13,"VariableType","","",222,null],[13,"ReturnType","","",222,null],[13,"RepeatVec","","",222,null],[13,"ClosureCapture","","",222,null],[13,"FieldSized","","",222,null],[13,"ObjectSized","","",222,null],[13,"SharedStatic","","",222,null],[13,"BuiltinDerivedObligation","","",222,null],[13,"ImplDerivedObligation","","",222,null],[13,"CompareImplMethodObligation","","",222,null],[3,"DerivedObligationCause","","",null,null],[6,"Obligations","","",null,null],[6,"PredicateObligations","","",null,null],[6,"TraitObligations","","",null,null],[6,"Selection","","",null,null],[4,"SelectionError","","",null,null],[13,"Unimplemented","","",218,null],[13,"OutputTypeParameterMismatch","","",218,null],[3,"FulfillmentError","","",null,null],[12,"obligation","","",219,null],[12,"code","","",219,null],[4,"FulfillmentErrorCode","","",null,null],[13,"CodeSelectionError","","",220,null],[13,"CodeProjectionError","","",220,null],[13,"CodeAmbiguity","","",220,null],[6,"SelectionResult","","",null,null],[4,"Vtable","","Given the successful resolution of an obligation, the `Vtable`\nindicates where the vtable comes from. Note that while we call this\na \"vtable\", it does not necessarily indicate dynamic dispatch at\nruntime. `Vtable` instances just tell the compiler where to find\nmethods, but in generic code those methods are typically statically\ndispatched -- only when an object is constructed is a `Vtable`\ninstance reified into an actual vtable.",null,null],[13,"VtableImpl","","Vtable identifying a particular impl.",215,null],[13,"VtableDefaultImpl","","Vtable for default trait implementations\nThis carries the information and nested obligations with regards\nto a default implementation for a trait `Trait`. The nested obligations\nensure the trait implementation holds for all the constituent types.",215,null],[13,"VtableParam","","Successful resolution to an obligation provided by the caller\nfor some type parameter. The `Vec<N>` represents the\nobligations incurred from normalizing the where-clause (if\nany).",215,null],[13,"VtableObject","","Virtual calls through an object",215,null],[13,"VtableBuiltin","","Successful resolution for a builtin trait.",215,null],[13,"VtableClosure","","Vtable automatically generated for a closure. The def ID is the ID\nof the closure expression. This is a `VtableImpl` in spirit, but the\nimpl is generated by the compiler and does not appear in the source.",215,null],[13,"VtableFnPointer","","Same as above, but for a fn pointer type with the given signature.",215,null],[3,"VtableImplData","","Identifies a particular impl in the source, along with a set of\nsubstitutions from the impl's type/lifetime parameters. The\n`nested` vector corresponds to the nested obligations attached to\nthe impl's type parameters.",null,null],[12,"impl_def_id","","",212,null],[12,"substs","","",212,null],[12,"nested","","",212,null],[3,"VtableDefaultImplData","","",null,null],[12,"trait_def_id","","",217,null],[12,"nested","","",217,null],[3,"VtableBuiltinData","","",null,null],[12,"nested","","",216,null],[3,"VtableObjectData","","A vtable for some object-safe trait `Foo` automatically derived\nfor the object type `Foo`.",null,null],[12,"object_ty","","the object type `Foo`.",213,null],[12,"upcast_trait_ref","","`Foo` upcast to the obligation trait. This will be some supertrait of `Foo`.",213,null],[5,"predicates_for_generics","","Creates predicate obligations from the generic bounds.",null,{"inputs":[{"name":"ctxt"},{"name":"obligationcause"},{"name":"instantiatedpredicates"}],"output":{"name":"vecperparamspace"}}],[5,"evaluate_builtin_bound","","Determines whether the type `ty` is known to meet `bound` and\nreturns true if so. Returns false if `ty` either does not meet\n`bound` or is not known to meet bound (note that this is\nconservative towards *no impl*, which is the opposite of the\n`evaluate` methods).",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"tys"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"result"}}],[5,"type_known_to_meet_builtin_bound","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"tys"},{"name":"builtinbound"},{"name":"span"}],"output":{"name":"bool"}}],[5,"normalize_param_env_or_error","","Normalizes the parameter environment, reporting errors if they occur.",null,{"inputs":[{"name":"parameterenvironment"},{"name":"obligationcause"}],"output":{"name":"parameterenvironment"}}],[5,"fully_normalize","","",null,{"inputs":[{"name":"inferctxt"},{"name":"closuretyper"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"result"}}],[5,"report_fulfillment_errors","","",null,null],[5,"transitive_bounds","","",null,null],[6,"Supertraits","","",null,null],[3,"SelectionCache","","",null,null],[5,"is_object_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[3,"FulfillmentContext","","The fulfillment context is used to drive trait resolution.  It\nconsists of a list of obligations that must be (eventually)\nsatisfied. The job is to track which are satisfied, which yielded\nerrors, and which are still pending. At any point, users can call\n`select_where_possible`, and the fulfilment context will try to do\nselection, retaining only those obligations that remain\nambiguous. This may be helpful in pushing type inference\nalong. Once all type inference constraints have been generated, the\nmethod `select_all_or_error` can be used to report any remaining\nambiguous cases as errors.",null,null],[5,"normalize","","Normalizes any associated type projections in `value`, replacing\nthem with a fully resolved type where possible. The return value\ncombines the normalized result and any additional obligations that\nwere incurred as result.",null,{"inputs":[{"name":"selectioncontext"},{"name":"obligationcause"},{"name":"t"}],"output":{"name":"normalized"}}],[5,"supertraits","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"filtertotraits"}}],[5,"elaborate_predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"elaborator"}}],[5,"suggest_new_overflow_limit","","",null,null],[5,"upcast","","Cast a trait reference into a reference to one of its super\ntraits; returns `None` if `target_trait_def_id` is not a\nsupertrait.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_ref_for_builtin_bound","","",null,{"inputs":[{"name":"ctxt"},{"name":"builtinbound"},{"name":"tys"}],"output":{"name":"result"}}],[5,"supertrait_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"supertraitdefids"}}],[5,"orphan_check","","Checks the coherence orphan rules. `impl_def_id` should be the\ndef-id of a trait impl. To pass, either the trait must be local, or else\ntwo conditions must be satisfied:",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"result"}}],[3,"SelectionContext","","",null,null],[5,"overlapping_impls","","True if there exist types that satisfy both of the two given impls.",null,{"inputs":[{"name":"inferctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"report_overflow_error","","Reports that an overflow has occurred and halts compilation. We\nhalt compilation unconditionally because it is important that\noverflows never be masked -- they basically represent computations\nwhose result could not be truly determined and thus we can't say\nif the program type checks or not -- and they are unusual\noccurrences in any case.",null,null],[4,"MethodMatchedData","","",null,null],[13,"PreciseMethodMatch","","",202,null],[13,"CoerciveMethodMatch","","",202,null],[4,"MethodViolationCode","","Reasons a method might not be object-safe.",null,null],[13,"StaticMethod","","e.g., `fn foo()`",199,null],[13,"ReferencesSelf","","e.g., `fn foo(&self, x: Self)` or `fn foo(&self) -> Self`",199,null],[13,"Generic","","e.g., `fn foo<A>()`",199,null],[3,"RegionObligation","","",null,null],[12,"sub_region","","",192,null],[12,"sup_type","","",192,null],[12,"cause","","",192,null],[5,"is_vtable_safe_method","","We say a method is *vtable safe* if it can be invoked on a trait\nobject.  Note that object-safe traits can have some\nnon-vtable-safe methods, so long as they require `Self:Sized` or\notherwise ensure that they cannot be used when `Self=Trait`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"method"}],"output":{"name":"bool"}}],[4,"OrphanCheckErr","","",null,null],[13,"NoLocalInputType","","",436,null],[13,"UncoveredTy","","",436,null],[3,"MismatchedProjectionTypes","","",null,null],[12,"err","","",194,null],[4,"ObjectSafetyViolation","","",null,null],[13,"SizedSelf","","Self : Sized declared on the trait",200,null],[13,"SupertraitSelf","","Supertrait reference references `Self` an in illegal location\n(e.g. `trait Foo : Bar<Self>`)",200,null],[13,"Method","","Method has something illegal",200,null],[5,"object_safety_violations","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[4,"MethodMatchResult","","",null,null],[13,"MethodMatched","","",208,null],[13,"MethodAmbiguous","","",208,null],[13,"MethodDidNotMatch","","",208,null],[3,"SupertraitDefIds","","",null,null],[5,"get_vtable_index_of_object_method","","Given an object of type `object_trait_ref`, returns the index of\nthe method `n_method` found in the trait `trait_def_id` (which\nshould be a supertrait of `object_trait_ref`) within the vtable\nfor `object_trait_ref`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"defid"},{"name":"usize"}],"output":{"name":"usize"}}],[3,"Normalized","","",null,null],[12,"value","","",197,null],[12,"obligations","","",197,null],[0,"ty","rustc_lint::middle","",null,null],[6,"Disr","rustc_lint::middle::ty","",null,null],[17,"INITIAL_DISCRIMINANT_VALUE","","",null,null],[3,"CrateAnalysis","","The complete set of all analyses described in this module. This is\nproduced by the driver and fed to trans and later passes.",null,null],[12,"export_map","","",437,null],[12,"exported_items","","",437,null],[12,"public_items","","",437,null],[12,"ty_cx","","",437,null],[12,"reachable","","",437,null],[12,"name","","",437,null],[12,"glob_map","","",437,null],[3,"field","","",null,null],[12,"name","","",224,null],[12,"mt","","",224,null],[4,"ImplOrTraitItemContainer","","",null,null],[13,"TraitContainer","","",225,null],[13,"ImplContainer","","",225,null],[4,"ImplOrTraitItem","","",null,null],[13,"MethodTraitItem","","",226,null],[13,"TypeTraitItem","","",226,null],[4,"ImplOrTraitItemId","","",null,null],[13,"MethodTraitItemId","","",227,null],[13,"TypeTraitItemId","","",227,null],[3,"Method","","",null,null],[12,"name","","",228,null],[12,"generics","","",228,null],[12,"predicates","","",228,null],[12,"fty","","",228,null],[12,"explicit_self","","",228,null],[12,"vis","","",228,null],[12,"def_id","","",228,null],[12,"container","","",228,null],[12,"provided_source","","",228,null],[3,"AssociatedType","","",null,null],[12,"name","","",229,null],[12,"vis","","",229,null],[12,"def_id","","",229,null],[12,"container","","",229,null],[3,"mt","","",null,null],[12,"ty","","",230,null],[12,"mutbl","","",230,null],[3,"field_ty","","",null,null],[12,"name","","",231,null],[12,"id","","",231,null],[12,"vis","","",231,null],[12,"origin","","",231,null],[3,"creader_cache_key","","",null,null],[12,"cnum","","",232,null],[12,"pos","","",232,null],[12,"len","","",232,null],[3,"ItemVariances","","",null,null],[12,"types","","",233,null],[12,"regions","","",233,null],[4,"Variance","","",null,null],[13,"Covariant","","",234,null],[13,"Invariant","","",234,null],[13,"Contravariant","","",234,null],[13,"Bivariant","","",234,null],[4,"AutoAdjustment","","",null,null],[13,"AdjustReifyFnPointer","","",235,null],[13,"AdjustUnsafeFnPointer","","",235,null],[13,"AdjustDerefRef","","",235,null],[3,"AutoDerefRef","","Represents coercing a pointer to a different kind of pointer - where 'kind'\nhere means either or both of raw vs borrowed vs unique and fat vs thin.",null,null],[12,"autoderefs","","Step 1. Apply a number of dereferences, producing an lvalue.",236,null],[12,"autoref","","Step 2. Optionally produce a pointer/reference from the value.",236,null],[12,"unsize","","Step 3. Unsize a pointer/reference value, e.g. `&[T; n]` to\n`&[T]`. The stored type is the target pointer type. Note that\nthe source could be a thin or fat pointer.",236,null],[4,"AutoRef","","",null,null],[13,"AutoPtr","","Convert from T to &T.",237,null],[13,"AutoUnsafe","","Convert from T to *T.\nValue to thin pointer.",237,null],[3,"param_index","","",null,null],[12,"space","","",238,null],[12,"index","","",238,null],[4,"MethodOrigin","","",null,null],[13,"MethodStatic","","",25,null],[13,"MethodStaticClosure","","",25,null],[13,"MethodTypeParam","","",25,null],[13,"MethodTraitObject","","",25,null],[3,"MethodParam","","",null,null],[12,"trait_ref","","",239,null],[12,"method_num","","",239,null],[12,"impl_def_id","","The impl for the trait from which the method comes. This\nshould only be used for certain linting/heuristic purposes\nsince there is no guarantee that this is Some in every\nsituation that it could/should be.",239,null],[3,"MethodObject","","",null,null],[12,"trait_ref","","",240,null],[12,"object_trait_id","","",240,null],[12,"method_num","","",240,null],[12,"vtable_index","","",240,null],[3,"MethodCallee","","",null,null],[12,"origin","","",241,null],[12,"ty","","",241,null],[12,"substs","","",241,null],[3,"MethodCall","","With method calls, we store some extra information in\nside tables (i.e method_map). We use\nMethodCall as a key to index into these tables instead of\njust directly using the expression's NodeId. The reason\nfor this being that we may apply adjustments (coercions)\nwith the resulting expression also needing to use the\nside tables. The problem with this is that we don't\nassign a separate NodeId to this new expression\nand so it would clash with the base expression if both\nneeded to add to the side tables. Thus to disambiguate\nwe also keep track of whether there's an adjustment in\nour key.",null,null],[12,"expr_id","","",242,null],[12,"autoderef","","",242,null],[6,"MethodMap","","",null,null],[6,"vtable_param_res","","",null,null],[6,"vtable_res","","",null,null],[4,"vtable_origin","","",null,null],[13,"vtable_static","","",243,null],[13,"vtable_param","","",243,null],[13,"vtable_closure","","",243,null],[13,"vtable_error","","",243,null],[6,"ObjectCastMap","","",null,null],[3,"TransmuteRestriction","","A restriction that certain types must be the same size. The use of\n`transmute` gives rise to these restrictions. These generally\ncannot be checked until trans; therefore, each call to `transmute`\nwill push one or more such restriction into the\n`transmute_restrictions` vector during `intrinsicck`. They are\nthen checked during `trans` by the fn `check_intrinsics`.",null,null],[12,"span","","The span whence the restriction comes.",88,null],[12,"original_from","","The type being transmuted from.",88,null],[12,"original_to","","The type being transmuted to.",88,null],[12,"substituted_from","","The type being transmuted from, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",88,null],[12,"substituted_to","","The type being transmuted to, with all type parameters\nsubstituted for an arbitrary representative. Not to be shown\nto the end user.",88,null],[12,"id","","NodeId of the transmute intrinsic.",88,null],[3,"CtxtArenas","","Internal storage",null,null],[3,"CommonTypes","","",null,null],[12,"bool","","",438,null],[12,"char","","",438,null],[12,"isize","","",438,null],[12,"i8","","",438,null],[12,"i16","","",438,null],[12,"i32","","",438,null],[12,"i64","","",438,null],[12,"usize","","",438,null],[12,"u8","","",438,null],[12,"u16","","",438,null],[12,"u32","","",438,null],[12,"u64","","",438,null],[12,"f32","","",438,null],[12,"f64","","",438,null],[12,"err","","",438,null],[3,"ctxt","","The data structure to keep track of all the information that typechecker\ngenerates so that so that it can be reused and doesn't have to be redone\nlater on.",null,null],[12,"types","","Common types, pre-interned for your convenience.",245,null],[12,"sess","","",245,null],[12,"def_map","","",245,null],[12,"named_region_map","","",245,null],[12,"region_maps","","",245,null],[12,"item_substs","","Stores the type parameters which were substituted to obtain the type\nof this node.  This only applies to nodes that refer to entities\nparameterized by type parameters, such as generic fns, types, or\nother items.",245,null],[12,"impl_or_trait_items","","Maps from a trait item to the trait item \"descriptor\"",245,null],[12,"trait_item_def_ids","","Maps from a trait def-id to a list of the def-ids of its trait items",245,null],[12,"trait_items_cache","","A cache for the trait_items() routine",245,null],[12,"impl_trait_cache","","",245,null],[12,"impl_trait_refs","","",245,null],[12,"trait_defs","","",245,null],[12,"predicates","","Maps from the def-id of an item (trait/struct/enum/fn) to its\nassociated predicates.",245,null],[12,"super_predicates","","Maps from the def-id of a trait to the list of\nsuper-predicates. This is a subset of the full list of\npredicates. We store these in a separate map because we must\nevaluate them even during type conversion, often before the\nfull predicates are available (note that supertraits have\nadditional acyclicity requirements).",245,null],[12,"object_cast_map","","Maps from node-id of a trait object cast (like `foo as\nBox<Trait>`) to the trait reference.",245,null],[12,"map","","",245,null],[12,"freevars","","",245,null],[12,"tcache","","",245,null],[12,"rcache","","",245,null],[12,"short_names_cache","","",245,null],[12,"tc_cache","","",245,null],[12,"ast_ty_to_ty_cache","","",245,null],[12,"enum_var_cache","","",245,null],[12,"ty_param_defs","","",245,null],[12,"adjustments","","",245,null],[12,"normalized_cache","","",245,null],[12,"lang_items","","",245,null],[12,"provided_method_sources","","A mapping of fake provided method def_ids to the default implementation",245,null],[12,"struct_fields","","",245,null],[12,"item_variance_map","","Maps from def-id of a type or region parameter to its\n(inferred) variance.",245,null],[12,"variance_computed","","True if the variance has been computed yet; false otherwise.",245,null],[12,"destructor_for_type","","A mapping from the def ID of an enum or struct type to the def ID\nof the method that implements its destructor. If the type is not\npresent in this map, it does not have a destructor. This map is\npopulated during the coherence phase of typechecking.",245,null],[12,"destructors","","A method will be in this list if and only if it is a destructor.",245,null],[12,"trait_impls","","Maps a trait onto a list of impls of that trait.",245,null],[12,"inherent_impls","","Maps a DefId of a type to a list of its inherent impls.\nContains implementations of methods that are inherent to a type.\nMethods in these implementations don't need to be exported.",245,null],[12,"impl_items","","Maps a DefId of an impl to a list of its items.\nNote that this contains all of the impls that we know about,\nincluding ones in other crates. It's not clear that this is the best\nway to do it.",245,null],[12,"used_unsafe","","Set of used unsafe nodes (functions or blocks). Unsafe nodes not\npresent in this set can be warned about.",245,null],[12,"used_mut_nodes","","Set of nodes which mark locals as mutable which end up getting used at\nsome point. Local variable definitions not in this set can be warned\nabout.",245,null],[12,"populated_external_types","","The set of external nominal types whose implementations have been read.\nThis is used for lazy resolution of methods.",245,null],[12,"populated_external_traits","","The set of external traits whose implementations have been read. This\nis used for lazy resolution of traits.",245,null],[12,"populated_external_primitive_impls","","The set of external primitive inherent implementations that have been read.",245,null],[12,"upvar_capture_map","","Borrows",245,null],[12,"extern_const_statics","","These two caches are used by const_eval when decoding external statics\nand variants that are found.",245,null],[12,"extern_const_variants","","",245,null],[12,"method_map","","",245,null],[12,"dependency_formats","","",245,null],[12,"closure_kinds","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",245,null],[12,"closure_tys","","Records the type of each closure. The def ID is the ID of the\nexpression defining the closure.",245,null],[12,"node_lint_levels","","",245,null],[12,"transmute_restrictions","","The types that must be asserted to be the same size for `transmute`\nto be valid. We gather up these restrictions in the intrinsicck pass\nand check them in trans.",245,null],[12,"stability","","Maps any item's def-id to its stability index.",245,null],[12,"associated_types","","Maps def IDs to true if and only if they're associated types.",245,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that do not have to do with the parameters in scope.",245,null],[12,"repr_hint_cache","","Caches the representation hints for struct definitions.",245,null],[12,"type_impls_copy_cache","","Caches whether types are known to impl Copy. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",245,null],[12,"type_impls_sized_cache","","Caches whether types are known to impl Sized. Note that type\nparameters are never placed into this cache, because their\nresults are dependent on the parameter environment.",245,null],[12,"object_safety_cache","","Caches whether traits are object safe",245,null],[12,"const_qualif_map","","Maps Expr NodeId's to their constant qualification.",245,null],[3,"TypeFlags","","",null,null],[17,"NO_TYPE_FLAGS","","",null,null],[17,"HAS_PARAMS","","",null,null],[17,"HAS_SELF","","",null,null],[17,"HAS_TY_INFER","","",null,null],[17,"HAS_RE_INFER","","",null,null],[17,"HAS_RE_LATE_BOUND","","",null,null],[17,"HAS_REGIONS","","",null,null],[17,"HAS_TY_ERR","","",null,null],[17,"HAS_PROJECTION","","",null,null],[17,"NEEDS_SUBST","","",null,null],[3,"TyS","","",null,null],[12,"sty","","",247,null],[12,"flags","","",247,null],[6,"Ty","","",null,null],[3,"InternedTy","","An entry in the type interner.",null,null],[5,"type_has_params","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_self","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_ty_infer","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_needs_infer","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_projection","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_late_bound_regions","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_has_escaping_regions","","An \"escaping region\" is a bound region whose binder is not part of `t`.",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_escapes_depth","","",null,{"inputs":[{"name":"tys"},{"name":"u32"}],"output":{"name":"bool"}}],[3,"BareFnTy","","",null,null],[12,"unsafety","","",249,null],[12,"abi","","",249,null],[12,"sig","","",249,null],[3,"ClosureTy","","",null,null],[12,"unsafety","","",250,null],[12,"abi","","",250,null],[12,"sig","","",250,null],[4,"FnOutput","","",null,null],[13,"FnConverging","","",251,null],[13,"FnDiverging","","",251,null],[6,"PolyFnOutput","","",null,null],[3,"FnSig","","Signature of a function type, which I have arbitrarily\ndecided to use to refer to the input/output types.",null,null],[12,"inputs","","",252,null],[12,"output","","",252,null],[12,"variadic","","",252,null],[6,"PolyFnSig","","",null,null],[3,"ParamTy","","",null,null],[12,"space","","",253,null],[12,"idx","","",253,null],[12,"name","","",253,null],[3,"DebruijnIndex","","A [De Bruijn index][dbi] is a standard means of representing\nregions (and perhaps later types) in a higher-ranked setting. In\nparticular, imagine a type like this:",null,null],[12,"depth","","",254,null],[4,"Region","","Representation of regions:",null,null],[13,"ReEarlyBound","","",16,null],[13,"ReLateBound","","",16,null],[13,"ReFree","","When checking a function body, the types of all arguments and so forth\nthat refer to bound region parameters are modified to refer to free\nregion parameters.",16,null],[13,"ReScope","","A concrete region naming some statically determined extent\n(e.g. an expression or sequence of statements) within the\ncurrent function.",16,null],[13,"ReStatic","","Static data that has an \"infinite\" lifetime. Top in the region lattice.",16,null],[13,"ReInfer","","A region variable.  Should not exist after typeck.",16,null],[13,"ReEmpty","","Empty lifetime is for data that is never accessed.\nBottom in the region lattice. We treat ReEmpty somewhat\nspecially; at least right now, we do not generate instances of\nit during the GLB computations, but rather\ngenerate an error instead. This is to improve error messages.\nThe only way to get an instance of ReEmpty is to have a region\nvariable with no constraints.",16,null],[3,"EarlyBoundRegion","","",null,null],[12,"param_id","","",255,null],[12,"space","","",255,null],[12,"index","","",255,null],[12,"name","","",255,null],[3,"UpvarId","","Upvars do not get their own node-id. Instead, we use the pair of\nthe original var id (that is, the root variable that is referenced\nby the upvar) and the id of the closure expression.",null,null],[12,"var_id","","",256,null],[12,"closure_expr_id","","",256,null],[4,"BorrowKind","","",null,null],[13,"ImmBorrow","","Data must be immutable and is aliasable.",257,null],[13,"UniqueImmBorrow","","Data must be immutable but not aliasable.  This kind of borrow\ncannot currently be expressed by the user and is used only in\nimplicit closure bindings. It is needed when you the closure\nis borrowing or mutating a mutable referent, e.g.:",257,null],[13,"MutBorrow","","Data is mutable and not aliasable.",257,null],[4,"UpvarCapture","","Information describing the capture of an upvar. This is computed\nduring `typeck`, specifically by `regionck`.",null,null],[13,"ByValue","","Upvar is captured by value. This is always true when the\nclosure is labeled `move`, but can also be true in other cases\ndepending on inference.",24,null],[13,"ByRef","","Upvar is captured by reference.",24,null],[3,"UpvarBorrow","","",null,null],[12,"kind","","The kind of borrow: by-ref upvars have access to shared\nimmutable borrows, which are not part of the normal language\nsyntax.",23,null],[12,"region","","Region of the resulting reference.",23,null],[6,"UpvarCaptureMap","","",null,null],[3,"FreeRegion","","A \"free\" region `fr` can be interpreted as \"some region\nat least as big as the scope `fr.scope`\".",null,null],[12,"scope","","",17,null],[12,"bound_region","","",17,null],[4,"BoundRegion","","",null,null],[13,"BrAnon","","An anonymous region parameter for a given fn (&T)",20,null],[13,"BrNamed","","Named region parameters for functions (a in &'a T)",20,null],[13,"BrFresh","","Fresh bound identifiers created during GLB computations.",20,null],[13,"BrEnv","","",20,null],[4,"sty","","",null,null],[13,"ty_bool","","",258,null],[13,"ty_char","","",258,null],[13,"ty_int","","",258,null],[13,"ty_uint","","",258,null],[13,"ty_float","","",258,null],[13,"ty_enum","","Substs here, possibly against intuition, *may* contain `ty_param`s.\nThat is, even after substitution it is possible that there are type\nvariables. This happens when the `ty_enum` corresponds to an enum\ndefinition and not a concrete use of it. To get the correct `ty_enum`\nfrom the tcx, use the `NodeId` from the `ast::Ty` and look it up in\nthe `ast_ty_to_ty_cache`. This is probably true for `ty_struct` as\nwell.",258,null],[13,"ty_uniq","","",258,null],[13,"ty_str","","",258,null],[13,"ty_vec","","",258,null],[13,"ty_ptr","","",258,null],[13,"ty_rptr","","",258,null],[13,"ty_bare_fn","","",258,null],[13,"ty_trait","","",258,null],[13,"ty_struct","","",258,null],[13,"ty_closure","","",258,null],[13,"ty_tup","","",258,null],[13,"ty_projection","","",258,null],[13,"ty_param","","",258,null],[13,"ty_infer","","",258,null],[13,"ty_err","","",258,null],[3,"TyTrait","","",null,null],[12,"principal","","",259,null],[12,"bounds","","",259,null],[3,"TraitRef","","A complete reference to a trait. These take numerous guises in syntax,\nbut perhaps the most recognizable form is in a where clause:",null,null],[12,"def_id","","",260,null],[12,"substs","","",260,null],[6,"PolyTraitRef","","",null,null],[3,"Binder","","Binder is a binder for higher-ranked lifetimes. It is part of the\ncompiler's representation for things like `for<'a> Fn(&'a isize)`\n(which would be represented by the type `PolyTraitRef ==\nBinder<TraitRef>`). Note that when we skolemize, instantiate,\nerase, or otherwise \"discharge\" these bound regions, we change the\ntype from `Binder<T>` to just `T` (see\ne.g. `liberate_late_bound_regions`).",null,null],[4,"IntVarValue","","",null,null],[13,"IntType","","",126,null],[13,"UintType","","",126,null],[4,"terr_vstore_kind","","",null,null],[13,"terr_vec","","",261,null],[13,"terr_str","","",261,null],[13,"terr_fn","","",261,null],[13,"terr_trait","","",261,null],[3,"expected_found","","",null,null],[12,"expected","","",262,null],[12,"found","","",262,null],[4,"type_err","","",null,null],[13,"terr_mismatch","","",263,null],[13,"terr_unsafety_mismatch","","",263,null],[13,"terr_abi_mismatch","","",263,null],[13,"terr_mutability","","",263,null],[13,"terr_box_mutability","","",263,null],[13,"terr_ptr_mutability","","",263,null],[13,"terr_ref_mutability","","",263,null],[13,"terr_vec_mutability","","",263,null],[13,"terr_tuple_size","","",263,null],[13,"terr_fixed_array_size","","",263,null],[13,"terr_ty_param_size","","",263,null],[13,"terr_arg_count","","",263,null],[13,"terr_regions_does_not_outlive","","",263,null],[13,"terr_regions_not_same","","",263,null],[13,"terr_regions_no_overlap","","",263,null],[13,"terr_regions_insufficiently_polymorphic","","",263,null],[13,"terr_regions_overly_polymorphic","","",263,null],[13,"terr_sorts","","",263,null],[13,"terr_integer_as_char","","",263,null],[13,"terr_int_mismatch","","",263,null],[13,"terr_float_mismatch","","",263,null],[13,"terr_traits","","",263,null],[13,"terr_builtin_bounds","","",263,null],[13,"terr_variadic_mismatch","","",263,null],[13,"terr_cyclic_ty","","",263,null],[13,"terr_convergence_mismatch","","",263,null],[13,"terr_projection_name_mismatched","","",263,null],[13,"terr_projection_bounds_length","","",263,null],[3,"ParamBounds","","Bounds suitable for a named type parameter like `A` in `fn foo<A>`\nas well as the existential type parameter in an object type.",null,null],[12,"region_bounds","","",264,null],[12,"builtin_bounds","","",264,null],[12,"trait_bounds","","",264,null],[12,"projection_bounds","","",264,null],[3,"ExistentialBounds","","Bounds suitable for an existentially quantified type parameter\nsuch as those that appear in object types or closure types. The\nmajor difference between this case and `ParamBounds` is that\ngeneral purpose trait bounds are omitted and there must be\n*exactly one* region.",null,null],[12,"region_bound","","",265,null],[12,"builtin_bounds","","",265,null],[12,"projection_bounds","","",265,null],[6,"BuiltinBounds","","",null,null],[4,"BuiltinBound","","",null,null],[13,"BoundSend","","",266,null],[13,"BoundSized","","",266,null],[13,"BoundCopy","","",266,null],[13,"BoundSync","","",266,null],[5,"empty_builtin_bounds","","",null,{"inputs":[],"output":{"name":"enumset"}}],[5,"all_builtin_bounds","","",null,{"inputs":[],"output":{"name":"enumset"}}],[5,"region_existential_bound","","An existential bound that does not implement any traits.",null,{"inputs":[{"name":"region"}],"output":{"name":"existentialbounds"}}],[3,"TyVid","","",null,null],[12,"index","","",267,null],[3,"IntVid","","",null,null],[12,"index","","",125,null],[3,"FloatVid","","",null,null],[12,"index","","",127,null],[3,"RegionVid","","",null,null],[12,"index","","",268,null],[4,"InferTy","","",null,null],[13,"TyVar","","",269,null],[13,"IntVar","","",269,null],[13,"FloatVar","","",269,null],[13,"FreshTy","","A `FreshTy` is one that is generated as a replacement for an\nunbound type variable. This is convenient for caching etc. See\n`middle::infer::freshen` for more details.",269,null],[13,"FreshIntTy","","",269,null],[4,"UnconstrainedNumeric","","",null,null],[13,"UnconstrainedFloat","","",270,null],[13,"UnconstrainedInt","","",270,null],[13,"Neither","","",270,null],[4,"InferRegion","","",null,null],[13,"ReVar","","",271,null],[13,"ReSkolemized","","",271,null],[4,"ObjectLifetimeDefault","","Default region to use for the bound of objects that are\nsupplied as the value for this type parameter. This is derived\nfrom `T:'a` annotations appearing in the type definition.  If\nthis is `None`, then the default is inherited from the\nsurrounding context. See RFC #599 for details.",null,null],[13,"Ambiguous","","Require an explicit annotation. Occurs when multiple\n`T:'a` constraints are found.",272,null],[13,"Specific","","Use the given region as the default.",272,null],[3,"TypeParameterDef","","",null,null],[12,"name","","",273,null],[12,"def_id","","",273,null],[12,"space","","",273,null],[12,"index","","",273,null],[12,"default","","",273,null],[12,"object_lifetime_default","","",273,null],[3,"RegionParameterDef","","",null,null],[12,"name","","",274,null],[12,"def_id","","",274,null],[12,"space","","",274,null],[12,"index","","",274,null],[12,"bounds","","",274,null],[3,"Generics","","Information about the formal type/lifetime parameters associated\nwith an item or method. Analogous to ast::Generics.",null,null],[12,"types","","",275,null],[12,"regions","","",275,null],[3,"GenericPredicates","","Bounds on generics.",null,null],[12,"predicates","","",276,null],[4,"Predicate","","",null,null],[13,"Trait","","Corresponds to `where Foo : Bar<A,B,C>`. `Foo` here would be\nthe `Self` type of the trait reference and `A`, `B`, and `C`\nwould be the parameters in the `TypeSpace`.",277,null],[13,"Equate","","where `T1 == T2`.",277,null],[13,"RegionOutlives","","where 'a : 'b",277,null],[13,"TypeOutlives","","where T : 'a",277,null],[13,"Projection","","where <T as TraitRef>::Name == X, approximately.\nSee `ProjectionPredicate` struct for details.",277,null],[3,"TraitPredicate","","",null,null],[12,"trait_ref","","",278,null],[6,"PolyTraitPredicate","","",null,null],[3,"EquatePredicate","","",null,null],[6,"PolyEquatePredicate","","",null,null],[3,"OutlivesPredicate","","",null,null],[6,"PolyOutlivesPredicate","","",null,null],[6,"PolyRegionOutlivesPredicate","","",null,null],[6,"PolyTypeOutlivesPredicate","","",null,null],[3,"ProjectionPredicate","","This kind of predicate has no *direct* correspondent in the\nsyntax, but it roughly corresponds to the syntactic forms:",null,null],[12,"projection_ty","","",281,null],[12,"ty","","",281,null],[6,"PolyProjectionPredicate","","",null,null],[3,"ProjectionTy","","Represents the projection of an associated type. In explicit UFCS\nform this would be written `<T as Trait<..>>::N`.",null,null],[12,"trait_ref","","The trait reference `T as Trait<..>`.",282,null],[12,"item_name","","The name `N` of the associated type.",282,null],[8,"ToPolyTraitRef","","",null,null],[10,"to_poly_trait_ref","","",439,{"inputs":[{"name":"topolytraitref"}],"output":{"name":"binder"}}],[8,"AsPredicate","","",null,null],[10,"as_predicate","","",440,{"inputs":[{"name":"aspredicate"}],"output":{"name":"predicate"}}],[3,"InstantiatedPredicates","","Represents the bounds declared on a particular set of type\nparameters.  Should eventually be generalized into a flag list of\nwhere clauses.  You can obtain a `InstantiatedPredicates` list from a\n`GenericPredicates` by using the `instantiate` method. Note that this method\nreflects an important semantic invariant of `InstantiatedPredicates`: while\nthe `GenericPredicates` are expressed in terms of the bound type\nparameters of the impl/trait/whatever, an `InstantiatedPredicates` instance\nrepresented a set of bounds for some particular instantiation,\nmeaning that the generic parameters have been substituted with\ntheir values.",null,null],[12,"predicates","","",283,null],[3,"ParameterEnvironment","","When type checking, we use the `ParameterEnvironment` to track\ndetails about the type/lifetime parameters that are in scope.\nIt primarily stores the bounds information.",null,null],[12,"tcx","","",284,null],[12,"free_substs","","See `construct_free_substs` for details.",284,null],[12,"implicit_region_bound","","Each type parameter has an implicit region bound that\nindicates it must outlive at least the function body (the user\nmay specify stronger requirements). This field indicates the\nregion of the callee.",284,null],[12,"caller_bounds","","Obligations that the caller must satisfy. This is basically\nthe set of bounds on the in-scope type parameters, translated\ninto Obligations.",284,null],[12,"selection_cache","","Caches the results of trait selection. This cache is used\nfor things that have to do with the parameters in scope.",284,null],[3,"TypeScheme","","A \"type scheme\", in ML terminology, is a type combined with some\nset of generic types that the type is, well, generic over. In Rust\nterms, it is the \"type\" of a fn item or struct -- this type will\ninclude various generic parameters that must be substituted when\nthe item/struct is referenced. That is called converting the type\nscheme to a monotype.",null,null],[12,"generics","","",285,null],[12,"ty","","",285,null],[3,"TraitDef","","As `TypeScheme` but for a trait ref.",null,null],[12,"unsafety","","",364,null],[12,"paren_sugar","","If `true`, then this trait had the `#[rustc_paren_sugar]`\nattribute, indicating that it should be used with `Foo()`\nsugar. This is a temporary thing -- eventually any trait wil\nbe usable with the sugar (or without it).",364,null],[12,"generics","","Generic type definitions. Note that `Self` is listed in here\nas having a single bound, the trait itself (e.g., in the trait\n`Eq`, there is a single bound `Self : Eq`). This is so that\ndefault methods get to assume that the `Self` parameters\nimplements the trait.",364,null],[12,"trait_ref","","",364,null],[12,"associated_type_names","","A list of the associated types defined in this trait. Useful\nfor resolving `X::Foo` type markers.",364,null],[3,"ItemSubsts","","Records the substitutions used to translate the polytype for an\nitem into the monotype of an item reference.",null,null],[12,"substs","","",286,null],[4,"ClosureKind","","",null,null],[13,"FnClosureKind","","",166,null],[13,"FnMutClosureKind","","",166,null],[13,"FnOnceClosureKind","","",166,null],[8,"ClosureTyper","","",null,null],[11,"tcx","","",441,{"inputs":[{"name":"closuretyper"}],"output":{"name":"ctxt"}}],[10,"param_env","","",441,{"inputs":[{"name":"closuretyper"}],"output":{"name":"parameterenvironment"}}],[10,"closure_kind","","Is this a `Fn`, `FnMut` or `FnOnce` closure? During typeck,\nreturns `None` if the kind of this closure has not yet been\ninferred.",441,{"inputs":[{"name":"closuretyper"},{"name":"defid"}],"output":{"name":"option"}}],[10,"closure_type","","Returns the argument/return types of this closure.",441,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[10,"closure_upvars","","Returns the set of all upvars and their transformed\ntypes. During typeck, maybe return `None` if the upvar types\nhave not yet been inferred.",441,{"inputs":[{"name":"closuretyper"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"mk_ctxt","","",null,{"inputs":[{"name":"session"},{"name":"ctxtarenas"},{"name":"refcell"},{"name":"hashmap"},{"name":"map"},{"name":"refcell"},{"name":"regionmaps"},{"name":"languageitems"},{"name":"index"}],"output":{"name":"ctxt"}}],[5,"mk_t","","",null,{"inputs":[{"name":"ctxt"},{"name":"sty"}],"output":{"name":"tys"}}],[5,"mk_mach_int","","",null,{"inputs":[{"name":"ctxt"},{"name":"intty"}],"output":{"name":"tys"}}],[5,"mk_mach_uint","","",null,{"inputs":[{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"tys"}}],[5,"mk_mach_float","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatty"}],"output":{"name":"tys"}}],[5,"mk_str","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_str_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mutability"}],"output":{"name":"tys"}}],[5,"mk_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_uniq","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_mut_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_imm_rptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_mut_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_imm_ptr","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"mk_nil_ptr","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_vec","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"option"}],"output":{"name":"tys"}}],[5,"mk_slice","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"},{"name":"mt"}],"output":{"name":"tys"}}],[5,"mk_tup","","",null,{"inputs":[{"name":"ctxt"},{"name":"vec"}],"output":{"name":"tys"}}],[5,"mk_nil","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_bool","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_bare_fn","","",null,{"inputs":[{"name":"ctxt"},{"name":"option"},{"name":"barefnty"}],"output":{"name":"tys"}}],[5,"mk_ctor_fn","","",null,null],[5,"mk_trait","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"},{"name":"existentialbounds"}],"output":{"name":"tys"}}],[5,"sort_bounds_list","","",null,null],[5,"mk_projection","","",null,{"inputs":[{"name":"ctxt"},{"name":"rc"},{"name":"name"}],"output":{"name":"tys"}}],[5,"mk_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_closure","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"mk_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"tyvid"}],"output":{"name":"tys"}}],[5,"mk_int_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"intvid"}],"output":{"name":"tys"}}],[5,"mk_float_var","","",null,{"inputs":[{"name":"ctxt"},{"name":"floatvid"}],"output":{"name":"tys"}}],[5,"mk_infer","","",null,{"inputs":[{"name":"ctxt"},{"name":"inferty"}],"output":{"name":"tys"}}],[5,"mk_param","","",null,{"inputs":[{"name":"ctxt"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"tys"}}],[5,"mk_self_type","","",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"tys"}}],[5,"mk_param_from_def","","",null,{"inputs":[{"name":"ctxt"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[5,"walk_ty","","",null,null],[5,"maybe_walk_ty","","Walks `ty` and any types appearing within `ty`, invoking the\ncallback `f` on each type. If the callback returns false, then the\nchildren of the current type are ignored.",null,null],[5,"fold_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"f"}],"output":{"name":"tys"}}],[5,"type_is_nil","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_error","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_needs_subst","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"trait_ref_contains_error","","",null,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[5,"type_is_ty_var","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bool","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_self","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_vec","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_structural","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_simd","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"sequence_element_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"simd_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"simd_size","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"usize"}}],[5,"type_is_region_ptr","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_unsafe_ptr","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_unique","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_scalar","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_floating_point","","Returns true if this type is a floating point type and false otherwise.",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[3,"TypeContents","","Type contents is how the type checker reasons about kinds.\nThey track what kinds of things are found within a type.  You can\nthink of them as kind of an \"anti-kind\".  They track the kinds of values\nand thinks that are contained in types.  Having a larger contents for\na type tends to rule that type *out* from various kinds.  For example,\na type that contains a reference is not sendable.",null,null],[12,"bits","","",287,null],[5,"type_interior_is_unsafe","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_contents","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"typecontents"}}],[5,"type_moves_by_default","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_sized","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"is_ffi_safe","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"is_instantiable","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[4,"Representability","","Describes whether a type is representable. For types that are not\nrepresentable, 'SelfRecursive' and 'ContainsRecursive' are used to\ndistinguish between types that are recursive with themselves and types that\ncontain a different recursive type. These cases can therefore be treated\ndifferently when reporting errors.",null,null],[13,"Representable","","",288,null],[13,"ContainsRecursive","","",288,null],[13,"SelfRecursive","","",288,null],[5,"is_type_representable","","Check whether a type is representable. This means it cannot contain unboxed\nstructural recursion. This check is needed for structs and enums.",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"tys"}],"output":{"name":"representability"}}],[5,"type_is_trait","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_trait_info","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[5,"type_is_integral","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_fresh","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_uint","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_char","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_bare_fn_item","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_fp","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_numeric","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_signed","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_machine","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"type_is_c_like_enum","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"deref","","",null,{"inputs":[{"name":"tys"},{"name":"bool"}],"output":{"name":"option"}}],[5,"type_content","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"tys"}}],[5,"index","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[5,"array_element_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"option"}}],[5,"positional_element_ty","","Returns the type of element at index `i` in tuple or tuple-like type `t`.\nFor an enum `t`, `variant` is None only if `t` is a univariant enum.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"usize"},{"name":"option"}],"output":{"name":"option"}}],[5,"named_element_ty","","Returns the type of element at field `n` in struct or struct-like type `t`.\nFor an enum `t`, `variant` must be some def id.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"name"},{"name":"option"}],"output":{"name":"option"}}],[5,"impl_id_to_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"rc"}}],[5,"node_id_to_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"tys"}}],[5,"node_id_to_type_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"option"}}],[5,"node_id_item_substs","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"itemsubsts"}}],[5,"fn_is_variadic","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"ty_fn_sig","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"ty_fn_abi","","Returns the ABI of the given function.",null,{"inputs":[{"name":"tys"}],"output":{"name":"abi"}}],[5,"ty_fn_args","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"ty_fn_ret","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"binder"}}],[5,"is_fn_ty","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"bool"}}],[5,"ty_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"tys"}],"output":{"name":"region"}}],[5,"free_region_from_def","","",null,{"inputs":[{"name":"destructionscopedata"},{"name":"regionparameterdef"}],"output":{"name":"region"}}],[5,"pat_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"tys"}}],[5,"pat_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"option"}}],[5,"expr_ty","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"tys"}}],[5,"expr_ty_opt","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"option"}}],[5,"expr_ty_adjusted","","Returns the type of `expr`, considering any `AutoAdjustment`\nentry recorded for that expression.",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"tys"}}],[5,"expr_span","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"span"}}],[5,"local_var_name_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"internedstring"}}],[5,"adjust_ty","","See `expr_ty_adjusted`",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"u32"},{"name":"tys"},{"name":"option"},{"name":"f"}],"output":{"name":"tys"}}],[5,"adjust_ty_for_autoref","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"option"}],"output":{"name":"tys"}}],[5,"resolve_expr","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"def"}}],[5,"expr_is_lval","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"bool"}}],[4,"ExprKind","","We categorize expressions into three kinds.  The distinction between\nlvalue/rvalue is fundamental to the language.  The distinction between the\ntwo kinds of rvalues is an artifact of trans which reflects how we will\ngenerate code for that kind of expression.  See trans/expr.rs for more\ninformation.",null,null],[13,"LvalueExpr","","",289,null],[13,"RvalueDpsExpr","","",289,null],[13,"RvalueDatumExpr","","",289,null],[13,"RvalueStmtExpr","","",289,null],[5,"expr_kind","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"exprkind"}}],[5,"stmt_node_id","","",null,{"inputs":[{"name":"spanned"}],"output":{"name":"u32"}}],[5,"field_idx_strict","","",null,null],[5,"impl_or_trait_item_idx","","",null,null],[5,"ty_sort_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"type_err_to_str","","Explains the source of a type err in a short, human readable way. This is meant to be placed\nin parentheses after some larger message. You should also invoke `note_and_explain_type_err()`\nafterwards to present additional details, particularly when it comes to lifetime-related\nerrors.",null,{"inputs":[{"name":"ctxt"},{"name":"type_err"}],"output":{"name":"string"}}],[5,"note_and_explain_type_err","","",null,null],[5,"provided_source","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"provided_trait_methods","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"usize"}],"output":{"name":"implortraititem"}}],[5,"trait_items","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_impl_polarity","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_or_trait_item","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"implortraititem"}}],[5,"is_associated_type","","Returns true if the given ID refers to an associated type and false if it\nrefers to anything else.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"associated_type_parameter_index","","Returns the parameter index that the given associated type corresponds to.",null,{"inputs":[{"name":"ctxt"},{"name":"traitdef"},{"name":"defid"}],"output":{"name":"usize"}}],[5,"trait_item_def_ids","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"impl_trait_ref","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_ref_to_def_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"}],"output":{"name":"defid"}}],[5,"try_add_builtin_trait","","Checks whether `trait_ref` refers to one of the builtin\ntraits, like `Send`, and adds the corresponding\nbound to the set `builtin_bounds` if so. Returns true if `trait_ref`\nis a builtin trait.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"enumset"}],"output":{"name":"bool"}}],[5,"ty_to_def_id","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[3,"VariantInfo","","",null,null],[12,"args","","",290,null],[12,"arg_names","","",290,null],[12,"ctor_ty","","",290,null],[12,"name","","",290,null],[12,"id","","",290,null],[12,"disr_val","","",290,null],[12,"vis","","",290,null],[5,"substd_enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"item_path_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"string"}}],[4,"DtorKind","","",null,null],[13,"NoDtor","","",291,null],[13,"TraitDtor","","",291,null],[5,"ty_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"dtorkind"}}],[5,"has_dtor","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"with_path","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"f"}],"output":{"name":"t"}}],[5,"enum_is_univariant","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"type_is_empty","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[5,"enum_repr_type","","Returns `(normalized_type, ty)`, where `normalized_type` is the\nIntType representation of one of {i64,i32,i16,i8,u64,u32,u16,u8},\nand `ty` is the original type (i.e. may include `isize` or\n`usize`).",null,null],[5,"enum_variants","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"enum_variant_with_id","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_item_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"typescheme"}}],[5,"lookup_trait_def","","Given the did of a trait, returns its canonical trait ref.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_predicates","","Given the did of an item, returns its full set of predicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"lookup_super_predicates","","Given the did of a trait, returns its superpredicates.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"genericpredicates"}}],[5,"predicates","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"parambounds"}],"output":{"name":"vec"}}],[5,"get_attrs","","Get the attributes of a definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"cow"}}],[5,"has_attr","","Determine whether an item is annotated with an attribute",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"str"}],"output":{"name":"bool"}}],[5,"lookup_packed","","Determine whether an item is annotated with `#[repr(packed)]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_simd","","Determine whether an item is annotated with `#[simd]`",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"lookup_repr_hints","","Obtain the representation annotation for a struct definition.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"lookup_field_type","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"defid"},{"name":"substs"}],"output":{"name":"tys"}}],[5,"lookup_struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"vec"}}],[5,"is_tuple_struct","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"struct_fields","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"vec"}}],[5,"tup_fields","","",null,null],[5,"struct_tail","","Returns the deeply last field of nested structures, or the same type,\nif not a structure at all. Corresponds to the only possible unsized\nfield, and its type can be used to determine unsizing strategy.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"struct_lockstep_tails","","Same as applying struct_tail on `source` and `target`, but only\nkeeps going as long as the two types are instances of the same\nstructure definitions.\nFor `(Foo<Foo<T>>, Foo<Trait>)`, the result will be `(Foo<T>, Trait)`,\nwhereas struct_tail produces `T`, and `Trait`, respectively.",null,null],[3,"ClosureUpvar","","",null,null],[12,"def","","",293,null],[12,"span","","",293,null],[12,"ty","","",293,null],[5,"closure_upvars","","",null,{"inputs":[{"name":"typer"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[5,"eval_repeat_count","","",null,{"inputs":[{"name":"ctxt"},{"name":"expr"}],"output":{"name":"usize"}}],[5,"each_bound_trait_and_supertraits","","",null,null],[5,"required_region_bounds","","Given a set of predicates that apply to an object type, returns\nthe region bounds that the (erased) `Self` type must\noutlive. Precisely *because* the `Self` type is erased, the\nparameter `erased_self_ty` must be supplied to indicate what type\nhas been used to represent `Self` in the predicates\nthemselves. This should really be a unique type; `FreshTy(0)` is a\npopular choice.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"vec"}],"output":{"name":"vec"}}],[5,"item_variances","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"rc"}}],[5,"trait_has_default_impl","","",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"bool"}}],[5,"record_trait_has_default_impl","","Records a trait-to-implementation mapping.",null,null],[5,"record_trait_implementation","","Records a trait-to-implementation mapping.",null,null],[5,"populate_implementations_for_primitive_if_necessary","","Load primitive inherent implementations if necessary",null,null],[5,"populate_implementations_for_type_if_necessary","","Populates the type context with all the implementations for the given type\nif necessary.",null,null],[5,"populate_implementations_for_trait_if_necessary","","Populates the type context with all the implementations for the given\ntrait if necessary.",null,null],[5,"trait_id_of_impl","","Given the def_id of an impl, return the def_id of the trait it implements.\nIf it implements no trait, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"impl_of_method","","If the given def ID describes a method belonging to an impl, return the\nID of the impl that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_of_item","","If the given def ID describes an item belonging to a trait (either a\ndefault method or an implementation of a trait method), return the ID of\nthe trait that the method belongs to. Otherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"trait_item_of_item","","If the given def ID describes an item belonging to a trait, (either a\ndefault method or an implementation of a trait method), return the ID of\nthe method inside trait definition (this means that if the given def ID\nis already that of the original trait method, then the return value is\nthe same).\nOtherwise, return `None`.",null,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"option"}}],[5,"hash_crate_independent","","Creates a hash of the type `Ty` which will be the same no matter what crate\ncontext it's calculated within. This is used by the `type_id` intrinsic.",null,{"inputs":[{"name":"ctxt"},{"name":"tys"},{"name":"svh"}],"output":{"name":"u64"}}],[5,"empty_parameter_environment","","Construct a parameter environment suitable for static contexts or other contexts where there\nare no free type/lifetime parameters in scope.",null,{"inputs":[{"name":"ctxt"}],"output":{"name":"parameterenvironment"}}],[5,"construct_free_substs","","Constructs and returns a substitution that can be applied to move from\nthe \"outer\" view of a type or method to the \"inner\" view.\nIn general, this means converting from bound parameters to\nfree parameters. Since we currently represent bound/free type\nparameters in the same way, this only has an effect on regions.",null,{"inputs":[{"name":"ctxt"},{"name":"generics"},{"name":"u32"}],"output":{"name":"substs"}}],[5,"construct_parameter_environment","","See `ParameterEnvironment` struct def'n for details",null,{"inputs":[{"name":"ctxt"},{"name":"span"},{"name":"generics"},{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[4,"ExplicitSelfCategory","","The category of explicit self.",null,null],[13,"StaticExplicitSelfCategory","","",294,null],[13,"ByValueExplicitSelfCategory","","",294,null],[13,"ByReferenceExplicitSelfCategory","","",294,null],[13,"ByBoxExplicitSelfCategory","","",294,null],[5,"accumulate_lifetimes_in_type","","Pushes all the lifetimes in the given type onto the given list. A\n\"lifetime in a type\" is a lifetime specified by a reference or a lifetime\nin a list of type substitutions. This does *not* traverse into nominal\ntypes, nor does it resolve fictitious types.",null,null],[3,"Freevar","","A free variable referred to in a function.",null,null],[12,"def","","The variable being accessed free.",22,null],[12,"span","","",22,null],[6,"FreevarMap","","",null,null],[6,"CaptureModeMap","","",null,null],[6,"TraitMap","","",null,null],[6,"GlobMap","","",null,null],[5,"with_freevars","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"f"}],"output":{"name":"t"}}],[5,"liberate_late_bound_regions","","Replace any late-bound regions bound in `value` with free variants attached to scope-id\n`scope_id`.",null,{"inputs":[{"name":"ctxt"},{"name":"destructionscopedata"},{"name":"binder"}],"output":{"name":"t"}}],[5,"count_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"usize"}}],[5,"binds_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"bool"}}],[5,"flatten_late_bound_regions","","Flattens two binding levels into one. So `for<'a> for<'b> Foo`\nbecomes `for<'a,'b> Foo`.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"no_late_bound_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"option"}}],[5,"erase_late_bound_regions","","Replace any late-bound regions bound in `value` with `'static`. Useful in trans but also\nmethod lookup and a few other places where precise region relationships are not required.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"t"}}],[5,"anonymize_late_bound_regions","","Rewrite any late-bound regions so that they are anonymous.  Region numbers are\nassigned starting at 1 and increasing monotonically in the order traversed\nby the fold operation.",null,{"inputs":[{"name":"ctxt"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"replace_late_bound_regions","","Replaces the late-bound-regions in `value` that are bound by `value`.",null,null],[5,"make_substs_for_receiver_types","","Substitutes the values for the receiver's type parameters\nthat are found in method, leaving the method's type parameters\nintact.",null,{"inputs":[{"name":"ctxt"},{"name":"traitref"},{"name":"method"}],"output":{"name":"substs"}}],[4,"CopyImplementationError","","",null,null],[13,"FieldDoesNotImplementCopy","","",295,null],[13,"VariantDoesNotImplementCopy","","",295,null],[13,"TypeIsStructural","","",295,null],[13,"TypeHasDestructor","","",295,null],[5,"can_type_implement_copy","","",null,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"result"}}],[8,"RegionEscape","","",null,null],[11,"has_escaping_regions","","",442,{"inputs":[{"name":"regionescape"}],"output":{"name":"bool"}}],[10,"has_regions_escaping_depth","","",442,{"inputs":[{"name":"regionescape"},{"name":"u32"}],"output":{"name":"bool"}}],[8,"HasProjectionTypes","","",null,null],[10,"has_projection_types","","",443,{"inputs":[{"name":"hasprojectiontypes"}],"output":{"name":"bool"}}],[8,"ReferencesError","","",null,null],[10,"references_error","","",444,{"inputs":[{"name":"referenceserror"}],"output":{"name":"bool"}}],[0,"ty_fold","rustc_lint::middle","Generalized type folding mechanism. The setup is a bit convoluted\nbut allows for convenient usage. Let T be an instance of some\n\"foldable type\" (one which implements `TypeFoldable`) and F be an\ninstance of a \"folder\" (a type which implements `TypeFolder`). Then\nthe setup is intended to be:",null,null],[8,"TypeFoldable","rustc_lint::middle::ty_fold","The TypeFoldable trait is implemented for every type that can be folded.\nBasically, every type that has a corresponding method in TypeFolder.",null,null],[10,"fold_with","","",445,{"inputs":[{"name":"typefoldable"},{"name":"f"}],"output":{"name":"self"}}],[8,"TypeFolder","","The TypeFolder trait defines the actual *folding*. There is a\nmethod defined for every foldable type. Each of these has a\ndefault implementation that does an \"identity\" fold. Within each\nidentity fold, it should invoke `foo.fold_with(self)` to fold each\nsub-item.",null,null],[10,"tcx","","",446,{"inputs":[{"name":"typefolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","Invoked by the `super_*` routines when we enter a region\nbinding level (for example, when entering a function\nsignature). This is used by clients that want to track the\nDebruijn index nesting level.",446,null],[11,"exit_region_binder","","Invoked by the `super_*` routines when we exit a region\nbinding level. This is used by clients that want to\ntrack the Debruijn index nesting level.",446,null],[11,"fold_binder","","",446,{"inputs":[{"name":"typefolder"},{"name":"binder"}],"output":{"name":"binder"}}],[11,"fold_ty","","",446,{"inputs":[{"name":"typefolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_mt","","",446,{"inputs":[{"name":"typefolder"},{"name":"mt"}],"output":{"name":"mt"}}],[11,"fold_trait_ref","","",446,{"inputs":[{"name":"typefolder"},{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fold_substs","","",446,{"inputs":[{"name":"typefolder"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"fold_fn_sig","","",446,{"inputs":[{"name":"typefolder"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"fold_output","","",446,{"inputs":[{"name":"typefolder"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"fold_bare_fn_ty","","",446,{"inputs":[{"name":"typefolder"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fold_closure_ty","","",446,{"inputs":[{"name":"typefolder"},{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fold_region","","",446,{"inputs":[{"name":"typefolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_existential_bounds","","",446,{"inputs":[{"name":"typefolder"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"fold_autoref","","",446,{"inputs":[{"name":"typefolder"},{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fold_item_substs","","",446,{"inputs":[{"name":"typefolder"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[5,"super_fold_binder","","",null,{"inputs":[{"name":"t"},{"name":"binder"}],"output":{"name":"binder"}}],[5,"super_fold_ty","","",null,{"inputs":[{"name":"t"},{"name":"tys"}],"output":{"name":"tys"}}],[5,"super_fold_substs","","",null,{"inputs":[{"name":"t"},{"name":"substs"}],"output":{"name":"substs"}}],[5,"super_fold_fn_sig","","",null,{"inputs":[{"name":"t"},{"name":"fnsig"}],"output":{"name":"fnsig"}}],[5,"super_fold_output","","",null,{"inputs":[{"name":"t"},{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[5,"super_fold_bare_fn_ty","","",null,{"inputs":[{"name":"t"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[5,"super_fold_closure_ty","","",null,{"inputs":[{"name":"t"},{"name":"closurety"}],"output":{"name":"closurety"}}],[5,"super_fold_trait_ref","","",null,{"inputs":[{"name":"t"},{"name":"traitref"}],"output":{"name":"traitref"}}],[5,"super_fold_mt","","",null,{"inputs":[{"name":"t"},{"name":"mt"}],"output":{"name":"mt"}}],[5,"super_fold_existential_bounds","","",null,{"inputs":[{"name":"t"},{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[5,"super_fold_autoref","","",null,{"inputs":[{"name":"t"},{"name":"autoref"}],"output":{"name":"autoref"}}],[5,"super_fold_item_substs","","",null,{"inputs":[{"name":"t"},{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[3,"BottomUpFolder","","",null,null],[12,"tcx","","",302,null],[12,"fldop","","",302,null],[3,"RegionFolder","","Folds over the substructure of a type, visiting its component\ntypes and all regions that occur *free* within it.",null,null],[5,"collect_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"vec"}}],[5,"fold_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"},{"name":"f"}],"output":{"name":"t"}}],[3,"RegionEraser","","",null,null],[5,"erase_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"t"}],"output":{"name":"t"}}],[5,"shift_region","","",null,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"region"}}],[5,"shift_regions","","",null,{"inputs":[{"name":"ctxt"},{"name":"u32"},{"name":"t"}],"output":{"name":"t"}}],[0,"ty_match","rustc_lint::middle","",null,null],[3,"Match","rustc_lint::middle::ty_match","A type \"A\" *matches* \"B\" if the fresh types in B could be\nsubstituted with values so as to make it equal to A. Matching is\nintended to be used only on freshened types, and it basically\nindicates if the non-freshened versions of A and B could have been\nunified.",null,null],[0,"ty_relate","rustc_lint::middle","Generalized type relating mechanism. A type relation R relates a\npair of values (A, B). A and B are usually types or regions but\ncan be other things. Examples of type relations are subtyping,\ntype equality, etc.",null,null],[6,"RelateResult","rustc_lint::middle::ty_relate","",null,null],[8,"TypeRelation","","",null,null],[10,"tcx","","",447,{"inputs":[{"name":"typerelation"}],"output":{"name":"ctxt"}}],[10,"tag","","Returns a static string we can use for printouts.",447,{"inputs":[{"name":"typerelation"}],"output":{"name":"str"}}],[10,"a_is_expected","","Returns true if the value `a` is the \"expected\" type in the\nrelation. Just affects error messages.",447,{"inputs":[{"name":"typerelation"}],"output":{"name":"bool"}}],[11,"relate","","Generic relation routine suitable for most anything.",447,{"inputs":[{"name":"typerelation"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[10,"relate_with_variance","","Switch variance for the purpose of relating `a` and `b`.",447,{"inputs":[{"name":"typerelation"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[10,"tys","","",447,{"inputs":[{"name":"typerelation"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[10,"regions","","",447,{"inputs":[{"name":"typerelation"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[10,"binders","","",447,{"inputs":[{"name":"typerelation"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[8,"Relate","","",null,null],[10,"relate","","",448,{"inputs":[{"name":"relate"},{"name":"r"},{"name":"self"},{"name":"self"}],"output":{"name":"result"}}],[5,"super_relate_tys","","The main \"type relation\" routine. Note that this does not handle\ninference artifacts, so you should filter those out before calling\nit.",null,{"inputs":[{"name":"r"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[5,"expected_found","","",null,{"inputs":[{"name":"r"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[5,"expected_found_bool","","",null,{"inputs":[{"name":"bool"},{"name":"t"},{"name":"t"}],"output":{"name":"expected_found"}}],[0,"ty_walk","rustc_lint::middle","An iterator over the type substructure.",null,null],[3,"TypeWalker","rustc_lint::middle::ty_walk","",null,null],[5,"walk_shallow","","",null,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[0,"weak_lang_items","rustc_lint::middle","Validity checking for weak lang items",null,null],[5,"check_crate","rustc_lint::middle::weak_lang_items","Checks the crate for usage of weak lang items, returning a vector of all the\nlanguage items required by this crate, but not defined yet.",null,null],[5,"link_name","","",null,null],[0,"session","rustc_lint","",null,null],[0,"config","rustc_lint::session","Contains infrastructure for configuring the compiler, including parsing\ncommand line options.",null,null],[3,"Config","rustc_lint::session::config","",null,null],[12,"target","","",449,null],[12,"int_type","","",449,null],[12,"uint_type","","",449,null],[4,"OptLevel","","",null,null],[13,"No","","",331,null],[13,"Less","","",331,null],[13,"Default","","",331,null],[13,"Aggressive","","",331,null],[4,"DebugInfoLevel","","",null,null],[13,"NoDebugInfo","","",332,null],[13,"LimitedDebugInfo","","",332,null],[13,"FullDebugInfo","","",332,null],[4,"OutputType","","",null,null],[13,"OutputTypeBitcode","","",333,null],[13,"OutputTypeAssembly","","",333,null],[13,"OutputTypeLlvmAssembly","","",333,null],[13,"OutputTypeObject","","",333,null],[13,"OutputTypeExe","","",333,null],[13,"OutputTypeDepInfo","","",333,null],[3,"Options","","",null,null],[12,"crate_types","","",334,null],[12,"gc","","",334,null],[12,"optimize","","",334,null],[12,"debug_assertions","","",334,null],[12,"debuginfo","","",334,null],[12,"lint_opts","","",334,null],[12,"describe_lints","","",334,null],[12,"output_types","","",334,null],[12,"search_paths","","",334,null],[12,"libs","","",334,null],[12,"maybe_sysroot","","",334,null],[12,"target_triple","","",334,null],[12,"cfg","","",334,null],[12,"test","","",334,null],[12,"parse_only","","",334,null],[12,"no_trans","","",334,null],[12,"treat_err_as_bug","","",334,null],[12,"no_analysis","","",334,null],[12,"debugging_opts","","",334,null],[12,"write_dependency_info","","Whether to write dependency files. It's (enabled, optional filename).",334,null],[12,"prints","","",334,null],[12,"cg","","",334,null],[12,"color","","",334,null],[12,"show_span","","",334,null],[12,"externs","","",334,null],[12,"crate_name","","",334,null],[12,"alt_std_name","","An optional name to use as the crate for std during std injection,\nwritten `extern crate std = \"name\"`. Default to \"std\". Used by\nout-of-tree drivers.",334,null],[12,"unstable_features","","Indicates how the compiler should treat unstable features",334,null],[4,"UnstableFeatures","","",null,null],[13,"Disallow","","Hard errors for unstable features are active, as on\nbeta/stable channels.",335,null],[13,"Default","","Use the default lint levels",335,null],[13,"Cheat","","Errors are bypassed for bootstrapping. This is required any time\nduring the build that feature-related lints are set to warn or above\nbecause the build turns on warnings-as-errors and uses lots of unstable\nfeatures. As a result, this this is always required for building Rust\nitself.",335,null],[4,"PrintRequest","","",null,null],[13,"FileNames","","",336,null],[13,"Sysroot","","",336,null],[13,"CrateName","","",336,null],[4,"Input","","",null,null],[13,"File","","Load source from file",337,null],[13,"Str","","The string is the source",337,null],[3,"OutputFilenames","","",null,null],[12,"out_directory","","",338,null],[12,"out_filestem","","",338,null],[12,"single_output_file","","",338,null],[12,"extra","","",338,null],[5,"host_triple","","",null,{"inputs":[],"output":{"name":"str"}}],[5,"basic_options","","Some reasonable defaults",null,{"inputs":[],"output":{"name":"options"}}],[4,"EntryFnType","","",null,null],[13,"EntryMain","","",339,null],[13,"EntryStart","","",339,null],[13,"EntryNone","","",339,null],[4,"CrateType","","",null,null],[13,"CrateTypeExecutable","","",340,null],[13,"CrateTypeDylib","","",340,null],[13,"CrateTypeRlib","","",340,null],[13,"CrateTypeStaticlib","","",340,null],[4,"Passes","","",null,null],[13,"SomePasses","","",341,null],[13,"AllPasses","","",341,null],[3,"CodegenOptions","","",null,null],[12,"ar","","",342,null],[12,"linker","","",342,null],[12,"link_args","","",342,null],[12,"lto","","",342,null],[12,"target_cpu","","",342,null],[12,"target_feature","","",342,null],[12,"passes","","",342,null],[12,"llvm_args","","",342,null],[12,"save_temps","","",342,null],[12,"rpath","","",342,null],[12,"no_prepopulate_passes","","",342,null],[12,"no_vectorize_loops","","",342,null],[12,"no_vectorize_slp","","",342,null],[12,"soft_float","","",342,null],[12,"prefer_dynamic","","",342,null],[12,"no_integrated_as","","",342,null],[12,"no_redzone","","",342,null],[12,"relocation_model","","",342,null],[12,"code_model","","",342,null],[12,"metadata","","",342,null],[12,"extra_filename","","",342,null],[12,"codegen_units","","",342,null],[12,"remark","","",342,null],[12,"no_stack_check","","",342,null],[12,"debuginfo","","",342,null],[12,"opt_level","","",342,null],[12,"debug_assertions","","",342,null],[5,"basic_codegen_options","","",null,{"inputs":[],"output":{"name":"codegenoptions"}}],[5,"build_codegen_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"codegenoptions"}}],[6,"CodegenSetter","","",null,null],[17,"CG_OPTIONS","","",null,null],[3,"DebuggingOptions","","",null,null],[12,"verbose","","",343,null],[12,"time_passes","","",343,null],[12,"count_llvm_insns","","",343,null],[12,"time_llvm_passes","","",343,null],[12,"trans_stats","","",343,null],[12,"asm_comments","","",343,null],[12,"no_verify","","",343,null],[12,"borrowck_stats","","",343,null],[12,"no_landing_pads","","",343,null],[12,"debug_llvm","","",343,null],[12,"count_type_sizes","","",343,null],[12,"meta_stats","","",343,null],[12,"print_link_args","","",343,null],[12,"gc","","",343,null],[12,"print_llvm_passes","","",343,null],[12,"ast_json","","",343,null],[12,"ast_json_noexpand","","",343,null],[12,"ls","","",343,null],[12,"save_analysis","","",343,null],[12,"print_move_fragments","","",343,null],[12,"flowgraph_print_loans","","",343,null],[12,"flowgraph_print_moves","","",343,null],[12,"flowgraph_print_assigns","","",343,null],[12,"flowgraph_print_all","","",343,null],[12,"print_region_graph","","",343,null],[12,"parse_only","","",343,null],[12,"no_trans","","",343,null],[12,"treat_err_as_bug","","",343,null],[12,"no_analysis","","",343,null],[12,"extra_plugins","","",343,null],[12,"unstable_options","","",343,null],[12,"print_enum_sizes","","",343,null],[12,"force_overflow_checks","","",343,null],[12,"force_dropflag_checks","","",343,null],[5,"basic_debugging_options","","",null,{"inputs":[],"output":{"name":"debuggingoptions"}}],[5,"build_debugging_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"debuggingoptions"}}],[6,"DebuggingSetter","","",null,null],[17,"DB_OPTIONS","","",null,null],[5,"default_lib_output","","",null,{"inputs":[],"output":{"name":"cratetype"}}],[5,"default_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"vec"}}],[5,"append_configuration","","",null,null],[5,"build_configuration","","",null,{"inputs":[{"name":"session"}],"output":{"name":"vec"}}],[5,"build_target_config","","",null,{"inputs":[{"name":"options"},{"name":"spanhandler"}],"output":{"name":"config"}}],[5,"short_optgroups","","Returns the \"short\" subset of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"optgroups","","Returns all of the stable rustc command line options.",null,{"inputs":[],"output":{"name":"vec"}}],[4,"OptionStability","","",null,null],[13,"Stable","","",344,null],[13,"Unstable","","",344,null],[3,"RustcOptGroup","","",null,null],[12,"opt_group","","",345,null],[12,"stability","","",345,null],[5,"rustc_short_optgroups","","Returns the \"short\" subset of the rustc command line options,\nincluding metadata for each option, such as whether the option is\npart of the stable long-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"rustc_optgroups","","Returns all rustc command line options, including metadata for\neach option, such as whether the option is part of the stable\nlong-term interface for rustc.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"parse_cfgspecs","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[5,"build_session_options","","",null,{"inputs":[{"name":"matches"}],"output":{"name":"options"}}],[5,"get_unstable_features_setting","","",null,{"inputs":[],"output":{"name":"unstablefeatures"}}],[5,"parse_crate_types_from_list","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"result"}}],[0,"search_paths","rustc_lint::session","",null,null],[3,"SearchPaths","rustc_lint::session::search_paths","",null,null],[3,"Iter","","",null,null],[4,"PathKind","","",null,null],[13,"Native","","",347,null],[13,"Crate","","",347,null],[13,"Dependency","","",347,null],[13,"Framework","","",347,null],[13,"ExternFlag","","",347,null],[13,"All","","",347,null],[3,"Session","rustc_lint::session","",null,null],[12,"target","","",349,null],[12,"host","","",349,null],[12,"opts","","",349,null],[12,"cstore","","",349,null],[12,"parse_sess","","",349,null],[12,"entry_fn","","",349,null],[12,"entry_type","","",349,null],[12,"plugin_registrar_fn","","",349,null],[12,"default_sysroot","","",349,null],[12,"local_crate_source_file","","",349,null],[12,"working_dir","","",349,null],[12,"lint_store","","",349,null],[12,"lints","","",349,null],[12,"plugin_llvm_passes","","",349,null],[12,"crate_types","","",349,null],[12,"crate_metadata","","",349,null],[12,"features","","",349,null],[12,"recursion_limit","","The maximum recursion limit for potentially infinitely recursive\noperations such as auto-dereference and monomorphization.",349,null],[12,"can_print_warnings","","",349,null],[5,"build_session","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"registry"}],"output":{"name":"session"}}],[5,"build_session_","","",null,{"inputs":[{"name":"options"},{"name":"option"},{"name":"spanhandler"}],"output":{"name":"session"}}],[5,"expect","","",null,{"inputs":[{"name":"session"},{"name":"option"},{"name":"m"}],"output":{"name":"t"}}],[5,"early_error","","",null,null],[5,"early_warn","","",null,null],[0,"util","rustc_lint","",null,null],[0,"common","rustc_lint::util","",null,null],[17,"FN_OUTPUT_NAME","rustc_lint::util::common","",null,null],[3,"ErrorReported","","",null,null],[5,"time","","",null,{"inputs":[{"name":"bool"},{"name":"str"},{"name":"u"},{"name":"f"}],"output":{"name":"t"}}],[5,"indent","","",null,{"inputs":[{"name":"f"}],"output":{"name":"r"}}],[3,"Indenter","","",null,null],[5,"indenter","","",null,{"inputs":[],"output":{"name":"indenter"}}],[5,"loop_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"block_query","","",null,{"inputs":[{"name":"block"},{"name":"p"}],"output":{"name":"bool"}}],[5,"can_reach","","K: Eq + Hash<S>, V, S, H: Hasher<S>",null,{"inputs":[{"name":"hashmap"},{"name":"t"},{"name":"t"}],"output":{"name":"bool"}}],[5,"memoized","","Memoizes a one-argument closure using the given RefCell containing\na type implementing MutableMap to serve as a cache.",null,{"inputs":[{"name":"refcell"},{"name":"t"},{"name":"f"}],"output":{"name":"u"}}],[5,"path2cstr","","",null,{"inputs":[{"name":"path"}],"output":{"name":"cstring"}}],[0,"ppaux","rustc_lint::util","",null,null],[8,"Repr","rustc_lint::util::ppaux","Produces a string suitable for debugging output.",null,null],[10,"repr","","",450,{"inputs":[{"name":"repr"},{"name":"ctxt"}],"output":{"name":"string"}}],[8,"UserString","","Produces a string suitable for showing to the user.",null,null],[10,"user_string","","",451,{"inputs":[{"name":"userstring"},{"name":"ctxt"}],"output":{"name":"string"}}],[5,"note_and_explain_region","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"region"},{"name":"str"}],"output":{"name":"option"}}],[5,"explain_region_and_span","","",null,null],[5,"bound_region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"bound_region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"boundregion"}],"output":{"name":"string"}}],[5,"region_ptr_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"string"}}],[5,"region_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"str"},{"name":"bool"},{"name":"region"}],"output":{"name":"string"}}],[5,"mutability_to_string","","",null,{"inputs":[{"name":"mutability"}],"output":{"name":"string"}}],[5,"mt_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"mt"}],"output":{"name":"string"}}],[5,"vec_map_to_string","","",null,null],[5,"ty_to_string","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[5,"explicit_self_category_to_str","","",null,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"str"}}],[5,"parameterized","","",null,null],[5,"ty_to_short_str","","",null,{"inputs":[{"name":"ctxt"},{"name":"tys"}],"output":{"name":"string"}}],[0,"nodemap","rustc_lint::util","An efficient hash map for node IDs",null,null],[6,"FnvHashMap","rustc_lint::util::nodemap","",null,null],[6,"FnvHashSet","","",null,null],[6,"NodeMap","","",null,null],[6,"DefIdMap","","",null,null],[6,"NodeSet","","",null,null],[6,"DefIdSet","","",null,null],[5,"FnvHashMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"FnvHashSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[5,"NodeMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"DefIdMap","","",null,{"inputs":[],"output":{"name":"hashmap"}}],[5,"NodeSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[5,"DefIdSet","","",null,{"inputs":[],"output":{"name":"hashset"}}],[3,"FnvHasher","","A speedy hash algorithm for node ids and def ids. The hashmap in\nlibcollections by default uses SipHash which isn't quite as speedy as we\nwant. In the compiler we're not really worried about DOS attempts, so we\njust default to a non-cryptographic hash.",null,null],[0,"snapshot_vec","rustc_lint::util","A utility class for implementing \"snapshottable\" things; a snapshottable data structure permits\nyou to take a snapshot (via `start_snapshot`) and then, after making some changes, elect either\nto rollback to the start of the snapshot or commit those changes.",null,null],[4,"UndoLog","rustc_lint::util::snapshot_vec","",null,null],[13,"OpenSnapshot","","Indicates where a snapshot started.",452,null],[13,"CommittedSnapshot","","Indicates a snapshot that has been committed.",452,null],[13,"NewElem","","New variable with given index was created.",452,null],[13,"SetElem","","Variable with given index was changed *from* the given value.",452,null],[13,"Other","","Extensible set of actions",452,null],[3,"SnapshotVec","","",null,null],[3,"Snapshot","","",null,null],[8,"SnapshotVecDelegate","","",null,null],[16,"Value","rustc_lint::util::snapshot_vec::SnapshotVecDelegate","",null,null],[16,"Undo","","",null,null],[10,"reverse","rustc_lint::util::snapshot_vec","",453,null],[0,"lev_distance","rustc_lint::util","",null,null],[5,"lev_distance","rustc_lint::util::lev_distance","",null,{"inputs":[{"name":"str"},{"name":"str"}],"output":{"name":"usize"}}],[0,"num","rustc_lint::util","",null,null],[8,"ToPrimitive","rustc_lint::util::num","",null,null],[10,"to_i8","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i16","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i32","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_i64","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u8","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u16","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u32","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[10,"to_u64","","",454,{"inputs":[{"name":"toprimitive"}],"output":{"name":"option"}}],[0,"fs","rustc_lint::util","",null,null],[5,"realpath","rustc_lint::util::fs","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[0,"sha2","rustc_lint::util","This module implements only the Sha256 function since that is all that is needed for internal\nuse. This implementation is not intended for external use or for any use where security is\nimportant.",null,null],[8,"Digest","rustc_lint::util::sha2","The Digest trait specifies an interface common to digest functions, such as SHA-1 and the SHA-2\nfamily of digest functions.",null,null],[10,"input","","Provide message data.",455,null],[10,"result","","Retrieve the digest result. This method may be called multiple times.",455,null],[10,"reset","","Reset the digest. This method must be called after result() and before supplying more\ndata.",455,null],[10,"output_bits","","Get the output size in bits.",455,{"inputs":[{"name":"digest"}],"output":{"name":"usize"}}],[11,"input_str","","Convenience function that feeds a string into a digest.",455,null],[11,"result_bytes","","Convenience function that retrieves the result of a digest as a\nnewly allocated vec of bytes.",455,{"inputs":[{"name":"digest"}],"output":{"name":"vec"}}],[11,"result_str","","Convenience function that retrieves the result of a digest as a\nString in hexadecimal format.",455,{"inputs":[{"name":"digest"}],"output":{"name":"string"}}],[11,"new_in","rustc_back::tempdir","Attempts to make a temporary directory inside of `tmpdir` whose name\nwill have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",456,{"inputs":[{"name":"tempdir"},{"name":"p"},{"name":"str"}],"output":{"name":"result"}}],[11,"new","","Attempts to make a temporary directory inside of `env::temp_dir()` whose\nname will have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",456,{"inputs":[{"name":"tempdir"},{"name":"str"}],"output":{"name":"result"}}],[11,"into_path","","Unwrap the wrapped `std::path::Path` from the `TempDir` wrapper.\nThis discards the wrapper so that the automatic deletion of the\ntemporary directory is prevented.",456,{"inputs":[{"name":"tempdir"}],"output":{"name":"pathbuf"}}],[11,"path","","Access the wrapped `std::path::Path` to the temporary directory.",456,{"inputs":[{"name":"tempdir"}],"output":{"name":"path"}}],[11,"close","","Close and remove the temporary directory",456,{"inputs":[{"name":"tempdir"}],"output":{"name":"result"}}],[11,"drop","","",456,null],[11,"clone","rustc_back::target::apple_ios_base","",457,{"inputs":[{"name":"arch"}],"output":{"name":"arch"}}],[11,"to_string","","",457,{"inputs":[{"name":"arch"}],"output":{"name":"str"}}],[11,"fmt","rustc_back::target","",458,{"inputs":[{"name":"target"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",458,{"inputs":[{"name":"target"}],"output":{"name":"target"}}],[11,"fmt","","",459,{"inputs":[{"name":"targetoptions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",459,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for\ncompilation, will certainly not work.",459,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",458,{"inputs":[{"name":"target"},{"name":"abi"}],"output":{"name":"abi"}}],[11,"from_json","","Load a target descriptor from a JSON object.",458,{"inputs":[{"name":"target"},{"name":"json"}],"output":{"name":"target"}}],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target\ntriple. Note that it could also just be a bare filename already, so also\ncheck for that. If one of the hardcoded targets we know about, just\nreturn it directly.",458,{"inputs":[{"name":"target"},{"name":"str"}],"output":{"name":"result"}}],[3,"Sha256","rustc_lint::util::sha2","The SHA-256 hash algorithm",null,null],[5,"register_builtins","rustc_lint","Tell the `LintStore` about all the built-in lints (the ones\ndefined in this crate and the ones defined in\n`rustc::lint::builtin`).",null,{"inputs":[{"name":"lintstore"},{"name":"option"}],"output":null}]],"paths":[[3,"Lint"],[3,"Svh"],[4,"SawAbiComponent"],[4,"SawExprComponent"],[4,"SawStmtComponent"],[3,"Ident"],[3,"Name"],[3,"StrictVersionHashVisitor"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"DecodeContext"],[3,"DefId"],[4,"Option"],[3,"Span"],[3,"NestedItemsDropper"],[4,"Def"],[4,"Region"],[3,"FreeRegion"],[4,"CodeExtent"],[3,"DestructionScopeData"],[4,"BoundRegion"],[3,"Decoder"],[3,"Freevar"],[3,"UpvarBorrow"],[4,"UpvarCapture"],[4,"MethodOrigin"],[3,"EncodeContext"],[3,"Encoder"],[3,"SideTableEncodingIdVisitor"],[3,"Doc"],[3,"LoopScope"],[3,"LabelledCFG"],[4,"CFGNodeData"],[3,"CFG"],[3,"ConstQualif"],[4,"Mode"],[3,"CheckCrateVisitor"],[3,"CheckCrateVisitor"],[3,"CheckItemRecursionVisitor"],[4,"Context"],[3,"CheckLoopVisitor"],[3,"Matrix"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"MatchCheckCtxt"],[3,"StaticInliner"],[3,"RenamingRecorder"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[3,"RvalueContext"],[3,"RvalueContextDelegate"],[4,"const_val"],[3,"ConstEvalErr"],[4,"ErrKind"],[4,"IntTy"],[4,"UintTy"],[4,"EntryOrExit"],[3,"DataFlowContext"],[4,"KillFrom"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[3,"PathResolution"],[3,"Export"],[4,"MethodProvenance"],[4,"UnsafeContext"],[3,"EffectCheckVisitor"],[3,"EntryContext"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[3,"ExprUseVisitor"],[4,"SimplifiedType"],[3,"FreeRegionMap"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"Graph"],[3,"DepthFirstTraversal"],[3,"IntrinsicCheckingVisitor"],[3,"TransmuteRestriction"],[3,"Bivariate"],[3,"CombineFields"],[3,"Generalizer"],[4,"Result"],[3,"Equate"],[3,"InferCtxt"],[3,"Rc"],[3,"Binder"],[3,"Glb"],[3,"Lub"],[4,"Node"],[4,"Edge"],[3,"ConstraintGraph"],[4,"Constraint"],[4,"GenericKind"],[3,"TwoRegions"],[4,"UndoLogEntry"],[4,"CombineMapType"],[4,"RegionResolutionError"],[3,"SameRegions"],[3,"RegionSnapshot"],[3,"RegionVarBindings"],[4,"Classification"],[4,"VarValue"],[4,"Verify"],[3,"RegionAndOrigin"],[3,"OpportunisticTypeResolver"],[3,"FullTypeResolver"],[3,"TypeFreshener"],[3,"Sub"],[4,"RelationDir"],[3,"TypeVariableTable"],[3,"Delegate"],[4,"VarValue"],[3,"Delegate"],[3,"UnificationTable"],[3,"IntVid"],[4,"IntVarValue"],[3,"FloatVid"],[4,"FloatTy"],[4,"TypeOrigin"],[4,"ValuePairs"],[3,"TypeTrace"],[4,"SubregionOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"fixup_err"],[4,"Implication"],[4,"LangItem"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[3,"Variable"],[3,"LiveNode"],[4,"LiveNodeKind"],[3,"IrMaps"],[3,"LocalInfo"],[4,"VarKind"],[3,"Liveness"],[3,"Users"],[3,"Specials"],[4,"categorization"],[3,"Upvar"],[4,"PointerKind"],[4,"InteriorKind"],[4,"FieldName"],[4,"InteriorOffsetKind"],[4,"ElementKind"],[4,"MutabilityCategory"],[4,"Note"],[3,"cmt_"],[4,"deref_kind"],[3,"Expr"],[3,"Pat"],[3,"MemCategorizationContext"],[4,"InteriorSafety"],[4,"Aliasability"],[4,"AliasableReason"],[4,"ClosureKind"],[4,"LastPrivate"],[4,"PrivateDep"],[4,"ImportUse"],[3,"ReachableContext"],[3,"BlockRemainder"],[4,"InnermostDeclaringBlock"],[3,"DeclaringStatementContext"],[4,"InnermostEnclosingExpr"],[3,"Context"],[3,"RegionMaps"],[3,"RegionResolutionVisitor"],[4,"DefRegion"],[3,"LifetimeContext"],[4,"ShadowKind"],[4,"ScopeChain"],[3,"Annotator"],[3,"Index"],[3,"Checker"],[3,"Substs"],[4,"RegionSubsts"],[4,"ParamSpace"],[3,"VecPerParamSpace"],[3,"EnumeratedItems"],[3,"SubstFolder"],[3,"InferIsLocal"],[3,"RegionObligation"],[3,"FulfillmentContext"],[3,"MismatchedProjectionTypes"],[4,"ProjectionTyCandidate"],[3,"AssociatedTypeNormalizer"],[3,"Normalized"],[4,"ProjectionTyError"],[4,"MethodViolationCode"],[4,"ObjectSafetyViolation"],[3,"SelectionCache"],[4,"MethodMatchedData"],[4,"SelectionCandidate"],[4,"EvaluationResult"],[3,"SelectionContext"],[3,"TraitObligationStackList"],[3,"TraitObligationStack"],[4,"MethodMatchResult"],[3,"Elaborator"],[3,"SupertraitDefIds"],[3,"FilterToTraits"],[3,"VtableImplData"],[3,"VtableObjectData"],[3,"Obligation"],[4,"Vtable"],[3,"VtableBuiltinData"],[3,"VtableDefaultImplData"],[4,"SelectionError"],[3,"FulfillmentError"],[4,"FulfillmentErrorCode"],[3,"ObligationCause"],[4,"ObligationCauseCode"],[3,"DerivedObligationCause"],[3,"field"],[4,"ImplOrTraitItemContainer"],[4,"ImplOrTraitItem"],[4,"ImplOrTraitItemId"],[3,"Method"],[3,"AssociatedType"],[3,"mt"],[3,"field_ty"],[3,"creader_cache_key"],[3,"ItemVariances"],[4,"Variance"],[4,"AutoAdjustment"],[3,"AutoDerefRef"],[4,"AutoRef"],[3,"param_index"],[3,"MethodParam"],[3,"MethodObject"],[3,"MethodCallee"],[3,"MethodCall"],[4,"vtable_origin"],[3,"CtxtArenas"],[3,"ctxt"],[3,"TypeFlags"],[3,"TyS"],[3,"InternedTy"],[3,"BareFnTy"],[3,"ClosureTy"],[4,"FnOutput"],[3,"FnSig"],[3,"ParamTy"],[3,"DebruijnIndex"],[3,"EarlyBoundRegion"],[3,"UpvarId"],[4,"BorrowKind"],[4,"sty"],[3,"TyTrait"],[3,"TraitRef"],[4,"terr_vstore_kind"],[3,"expected_found"],[4,"type_err"],[3,"ParamBounds"],[3,"ExistentialBounds"],[4,"BuiltinBound"],[3,"TyVid"],[3,"RegionVid"],[4,"InferTy"],[4,"UnconstrainedNumeric"],[4,"InferRegion"],[4,"ObjectLifetimeDefault"],[3,"TypeParameterDef"],[3,"RegionParameterDef"],[3,"Generics"],[3,"GenericPredicates"],[4,"Predicate"],[3,"TraitPredicate"],[3,"EquatePredicate"],[3,"OutlivesPredicate"],[3,"ProjectionPredicate"],[3,"ProjectionTy"],[3,"InstantiatedPredicates"],[3,"ParameterEnvironment"],[3,"TypeScheme"],[3,"ItemSubsts"],[3,"TypeContents"],[4,"Representability"],[4,"ExprKind"],[3,"VariantInfo"],[4,"DtorKind"],[4,"IntType"],[3,"ClosureUpvar"],[4,"ExplicitSelfCategory"],[4,"CopyImplementationError"],[3,"Vec"],[3,"Box"],[4,"Unsafety"],[4,"Abi"],[3,"OwnedSlice"],[3,"EnumSet"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionEraser"],[3,"Match"],[3,"TypeWalker"],[3,"Context"],[4,"astencode_tag"],[3,"LinkMeta"],[4,"DefIdSource"],[3,"entry"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[4,"Family"],[4,"DefLike"],[3,"CrateDep"],[3,"CrateReader"],[4,"PMDSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[3,"CrateSource"],[3,"CStore"],[3,"crate_metadata"],[4,"MetadataBlob"],[3,"MethodInfo"],[3,"Context"],[3,"ArchiveMetadata"],[4,"FileMatch"],[3,"FileSearch"],[3,"MacroLoader"],[4,"OptLevel"],[4,"DebugInfoLevel"],[4,"OutputType"],[3,"Options"],[4,"UnstableFeatures"],[4,"PrintRequest"],[4,"Input"],[3,"OutputFilenames"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[4,"OptionStability"],[3,"RustcOptGroup"],[3,"SearchPaths"],[4,"PathKind"],[3,"Iter"],[3,"Session"],[3,"Registry"],[3,"RegistrarFinder"],[3,"LintId"],[4,"Level"],[4,"LintSource"],[3,"HardwiredLints"],[3,"LintStore"],[3,"Context"],[3,"GatherNodeLevels"],[3,"ErrorReported"],[3,"Indenter"],[3,"LoopQueryVisitor"],[3,"BlockQueryVisitor"],[3,"P"],[3,"TraitDef"],[3,"TraitItem"],[3,"Path"],[3,"Ty"],[3,"Item"],[3,"Lifetime"],[3,"Spanned"],[4,"ExplicitSelf_"],[4,"Visibility"],[4,"Mutability"],[4,"IntTy"],[4,"UintTy"],[3,"HashMap"],[3,"FnvHasher"],[3,"SnapshotVec"],[3,"FixedBuffer64"],[3,"Sha256"],[3,"ArchiveRO"],[4,"OptimizationDiagnosticKind"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"Diagnostic"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[3,"Attribute"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[3,"AttrBuilder"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[4,"DIDescriptorFlags"],[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[8,"LintPass"],[3,"ctxt"],[4,"InlinedItemRef"],[3,"EncodeParams"],[3,"ImportedFileMap"],[4,"FoundAst"],[3,"Library"],[3,"CratePaths"],[8,"vtable_decoder_helpers"],[3,"CFGEdgeData"],[8,"BitwiseOperator"],[8,"DataFlowOperator"],[8,"Delegate"],[3,"Node"],[8,"RelateResultCompare"],[8,"ErrorReporting"],[8,"Resolvable"],[8,"LatticeDir"],[8,"UnifyKey"],[3,"Node"],[8,"ToType"],[8,"ast_node"],[8,"Typer"],[3,"SeparateVecsPerParamSpace"],[8,"Subst"],[4,"OrphanCheckErr"],[3,"CrateAnalysis"],[3,"CommonTypes"],[8,"ToPolyTraitRef"],[8,"AsPredicate"],[8,"ClosureTyper"],[8,"RegionEscape"],[8,"HasProjectionTypes"],[8,"ReferencesError"],[8,"TypeFoldable"],[8,"TypeFolder"],[8,"TypeRelation"],[8,"Relate"],[3,"Config"],[8,"Repr"],[8,"UserString"],[4,"UndoLog"],[8,"SnapshotVecDelegate"],[8,"ToPrimitive"],[8,"Digest"],[3,"TempDir"],[4,"Arch"],[3,"Target"],[3,"TargetOptions"]]};
searchIndex['rustc_privacy'] = {"items":[[0,"","rustc_privacy","",null,null],[5,"check_crate","","",null,null]],"paths":[]};
searchIndex['rustc_llvm'] = {"items":[[0,"","rustc_llvm","",null,null],[3,"Attribute","","",null,null],[3,"AttrBuilder","","",null,null],[3,"TargetData","","",null,null],[12,"lltd","","",0,null],[3,"ObjectFile","","",null,null],[12,"llof","","",1,null],[3,"SectionIter","","",null,null],[12,"llsi","","",2,null],[4,"CallConv","","",null,null],[13,"CCallConv","","",3,null],[13,"FastCallConv","","",3,null],[13,"ColdCallConv","","",3,null],[13,"X86StdcallCallConv","","",3,null],[13,"X86FastcallCallConv","","",3,null],[13,"X86_64_Win64","","",3,null],[4,"Visibility","","",null,null],[13,"LLVMDefaultVisibility","","",4,null],[13,"HiddenVisibility","","",4,null],[13,"ProtectedVisibility","","",4,null],[4,"Linkage","","",null,null],[13,"ExternalLinkage","","",5,null],[13,"AvailableExternallyLinkage","","",5,null],[13,"LinkOnceAnyLinkage","","",5,null],[13,"LinkOnceODRLinkage","","",5,null],[13,"WeakAnyLinkage","","",5,null],[13,"WeakODRLinkage","","",5,null],[13,"AppendingLinkage","","",5,null],[13,"InternalLinkage","","",5,null],[13,"PrivateLinkage","","",5,null],[13,"ExternalWeakLinkage","","",5,null],[13,"CommonLinkage","","",5,null],[4,"DiagnosticSeverity","","",null,null],[13,"Error","","",6,null],[13,"Warning","","",6,null],[13,"Remark","","",6,null],[13,"Note","","",6,null],[4,"OtherAttribute","","",null,null],[13,"SanitizeAddressAttribute","","",7,null],[13,"MinSizeAttribute","","",7,null],[13,"NoDuplicateAttribute","","",7,null],[13,"StackProtectStrongAttribute","","",7,null],[13,"SanitizeThreadAttribute","","",7,null],[13,"SanitizeMemoryAttribute","","",7,null],[13,"NoBuiltinAttribute","","",7,null],[13,"ReturnedAttribute","","",7,null],[13,"ColdAttribute","","",7,null],[13,"BuiltinAttribute","","",7,null],[13,"OptimizeNoneAttribute","","",7,null],[13,"InAllocaAttribute","","",7,null],[13,"NonNullAttribute","","",7,null],[4,"SpecialAttribute","","",null,null],[13,"DereferenceableAttribute","","",8,null],[4,"AttributeSet","","",null,null],[13,"ReturnIndex","","",9,null],[13,"FunctionIndex","","",9,null],[4,"IntPredicate","","",null,null],[13,"IntEQ","","",10,null],[13,"IntNE","","",10,null],[13,"IntUGT","","",10,null],[13,"IntUGE","","",10,null],[13,"IntULT","","",10,null],[13,"IntULE","","",10,null],[13,"IntSGT","","",10,null],[13,"IntSGE","","",10,null],[13,"IntSLT","","",10,null],[13,"IntSLE","","",10,null],[4,"RealPredicate","","",null,null],[13,"RealPredicateFalse","","",11,null],[13,"RealOEQ","","",11,null],[13,"RealOGT","","",11,null],[13,"RealOGE","","",11,null],[13,"RealOLT","","",11,null],[13,"RealOLE","","",11,null],[13,"RealONE","","",11,null],[13,"RealORD","","",11,null],[13,"RealUNO","","",11,null],[13,"RealUEQ","","",11,null],[13,"RealUGT","","",11,null],[13,"RealUGE","","",11,null],[13,"RealULT","","",11,null],[13,"RealULE","","",11,null],[13,"RealUNE","","",11,null],[13,"RealPredicateTrue","","",11,null],[4,"TypeKind","","",null,null],[13,"Void","","",12,null],[13,"Half","","",12,null],[13,"Float","","",12,null],[13,"Double","","",12,null],[13,"X86_FP80","","",12,null],[13,"FP128","","",12,null],[13,"PPC_FP128","","",12,null],[13,"Label","","",12,null],[13,"Integer","","",12,null],[13,"Function","","",12,null],[13,"Struct","","",12,null],[13,"Array","","",12,null],[13,"Pointer","","",12,null],[13,"Vector","","",12,null],[13,"Metadata","","",12,null],[13,"X86_MMX","","",12,null],[4,"AtomicBinOp","","",null,null],[13,"AtomicXchg","","",13,null],[13,"AtomicAdd","","",13,null],[13,"AtomicSub","","",13,null],[13,"AtomicAnd","","",13,null],[13,"AtomicNand","","",13,null],[13,"AtomicOr","","",13,null],[13,"AtomicXor","","",13,null],[13,"AtomicMax","","",13,null],[13,"AtomicMin","","",13,null],[13,"AtomicUMax","","",13,null],[13,"AtomicUMin","","",13,null],[4,"AtomicOrdering","","",null,null],[13,"NotAtomic","","",14,null],[13,"Unordered","","",14,null],[13,"Monotonic","","",14,null],[13,"Acquire","","",14,null],[13,"Release","","",14,null],[13,"AcquireRelease","","",14,null],[13,"SequentiallyConsistent","","",14,null],[4,"FileType","","",null,null],[13,"AssemblyFileType","","",15,null],[13,"ObjectFileType","","",15,null],[4,"MetadataType","","",null,null],[13,"MD_dbg","","",16,null],[13,"MD_tbaa","","",16,null],[13,"MD_prof","","",16,null],[13,"MD_fpmath","","",16,null],[13,"MD_range","","",16,null],[13,"MD_tbaa_struct","","",16,null],[13,"MD_invariant_load","","",16,null],[13,"MD_alias_scope","","",16,null],[13,"MD_noalias","","",16,null],[13,"MD_nontemporal","","",16,null],[13,"MD_mem_parallel_loop_access","","",16,null],[13,"MD_nonnull","","",16,null],[4,"AsmDialect","","",null,null],[13,"AD_ATT","","",17,null],[13,"AD_Intel","","",17,null],[4,"CodeGenOptLevel","","",null,null],[13,"CodeGenLevelNone","","",18,null],[13,"CodeGenLevelLess","","",18,null],[13,"CodeGenLevelDefault","","",18,null],[13,"CodeGenLevelAggressive","","",18,null],[4,"RelocMode","","",null,null],[13,"RelocDefault","","",19,null],[13,"RelocStatic","","",19,null],[13,"RelocPIC","","",19,null],[13,"RelocDynamicNoPic","","",19,null],[4,"CodeGenModel","","",null,null],[13,"CodeModelDefault","","",20,null],[13,"CodeModelJITDefault","","",20,null],[13,"CodeModelSmall","","",20,null],[13,"CodeModelKernel","","",20,null],[13,"CodeModelMedium","","",20,null],[13,"CodeModelLarge","","",20,null],[4,"DiagnosticKind","","",null,null],[13,"DK_InlineAsm","","",21,null],[13,"DK_StackSize","","",21,null],[13,"DK_DebugMetadataVersion","","",21,null],[13,"DK_SampleProfile","","",21,null],[13,"DK_OptimizationRemark","","",21,null],[13,"DK_OptimizationRemarkMissed","","",21,null],[13,"DK_OptimizationRemarkAnalysis","","",21,null],[13,"DK_OptimizationFailure","","",21,null],[4,"Module_opaque","","",null,null],[4,"Context_opaque","","",null,null],[4,"Type_opaque","","",null,null],[4,"Value_opaque","","",null,null],[4,"Metadata_opaque","","",null,null],[4,"BasicBlock_opaque","","",null,null],[4,"Builder_opaque","","",null,null],[4,"ExecutionEngine_opaque","","",null,null],[4,"RustJITMemoryManager_opaque","","",null,null],[4,"MemoryBuffer_opaque","","",null,null],[4,"PassManager_opaque","","",null,null],[4,"PassManagerBuilder_opaque","","",null,null],[4,"Use_opaque","","",null,null],[4,"TargetData_opaque","","",null,null],[4,"ObjectFile_opaque","","",null,null],[4,"SectionIterator_opaque","","",null,null],[4,"Pass_opaque","","",null,null],[4,"TargetMachine_opaque","","",null,null],[4,"Archive_opaque","","",null,null],[4,"Twine_opaque","","",null,null],[4,"DiagnosticInfo_opaque","","",null,null],[4,"DebugLoc_opaque","","",null,null],[4,"SMDiagnostic_opaque","","",null,null],[4,"RustString_opaque","","",null,null],[5,"SetInstructionCallConv","","",null,{"inputs":[{"name":"valueref"},{"name":"callconv"}],"output":null}],[5,"SetFunctionCallConv","","",null,{"inputs":[{"name":"valueref"},{"name":"callconv"}],"output":null}],[5,"SetLinkage","","",null,{"inputs":[{"name":"valueref"},{"name":"linkage"}],"output":null}],[5,"SetUnnamedAddr","","",null,{"inputs":[{"name":"valueref"},{"name":"bool"}],"output":null}],[5,"set_thread_local","","",null,{"inputs":[{"name":"valueref"},{"name":"bool"}],"output":null}],[5,"ConstICmp","","",null,{"inputs":[{"name":"intpredicate"},{"name":"valueref"},{"name":"valueref"}],"output":{"name":"valueref"}}],[5,"ConstFCmp","","",null,{"inputs":[{"name":"realpredicate"},{"name":"valueref"},{"name":"valueref"}],"output":{"name":"valueref"}}],[5,"SetFunctionAttribute","","",null,{"inputs":[{"name":"valueref"},{"name":"attribute"}],"output":null}],[5,"mk_target_data","","",null,{"inputs":[{"name":"str"}],"output":{"name":"targetdata"}}],[5,"mk_section_iter","","",null,{"inputs":[{"name":"objectfileref"}],"output":{"name":"sectioniter"}}],[5,"get_param","","Safe wrapper around `LLVMGetParam`, because segfaults are no fun.",null,{"inputs":[{"name":"valueref"},{"name":"c_uint"}],"output":{"name":"valueref"}}],[5,"rust_llvm_string_write_impl","","Appending to a Rust string -- used by raw_rust_string_ostream.",null,null],[5,"build_string","","",null,{"inputs":[{"name":"f"}],"output":{"name":"option"}}],[5,"twine_to_string","","",null,{"inputs":[{"name":"twineref"}],"output":{"name":"string"}}],[5,"debug_loc_to_string","","",null,{"inputs":[{"name":"contextref"},{"name":"debuglocref"}],"output":{"name":"string"}}],[5,"LLVMContextCreate","","",null,null],[5,"LLVMContextDispose","","",null,null],[5,"LLVMGetMDKindIDInContext","","",null,null],[5,"LLVMModuleCreateWithNameInContext","","",null,null],[5,"LLVMGetModuleContext","","",null,null],[5,"LLVMDisposeModule","","",null,null],[5,"LLVMGetDataLayout","","Data layout. See Module::getDataLayout.",null,null],[5,"LLVMSetDataLayout","","",null,null],[5,"LLVMGetTarget","","Target triple. See Module::getTargetTriple.",null,null],[5,"LLVMSetTarget","","",null,null],[5,"LLVMDumpModule","","See Module::dump.",null,null],[5,"LLVMSetModuleInlineAsm","","See Module::setModuleInlineAsm.",null,null],[5,"LLVMGetTypeKind","","See llvm::LLVMTypeKind::getTypeID.",null,null],[5,"LLVMGetTypeContext","","See llvm::LLVMType::getContext.",null,null],[5,"LLVMInt1TypeInContext","","",null,null],[5,"LLVMInt8TypeInContext","","",null,null],[5,"LLVMInt16TypeInContext","","",null,null],[5,"LLVMInt32TypeInContext","","",null,null],[5,"LLVMInt64TypeInContext","","",null,null],[5,"LLVMIntTypeInContext","","",null,null],[5,"LLVMGetIntTypeWidth","","",null,null],[5,"LLVMFloatTypeInContext","","",null,null],[5,"LLVMDoubleTypeInContext","","",null,null],[5,"LLVMX86FP80TypeInContext","","",null,null],[5,"LLVMFP128TypeInContext","","",null,null],[5,"LLVMPPCFP128TypeInContext","","",null,null],[5,"LLVMFunctionType","","",null,null],[5,"LLVMIsFunctionVarArg","","",null,null],[5,"LLVMGetReturnType","","",null,null],[5,"LLVMCountParamTypes","","",null,null],[5,"LLVMGetParamTypes","","",null,null],[5,"LLVMStructTypeInContext","","",null,null],[5,"LLVMCountStructElementTypes","","",null,null],[5,"LLVMGetStructElementTypes","","",null,null],[5,"LLVMIsPackedStruct","","",null,null],[5,"LLVMRustArrayType","","",null,null],[5,"LLVMPointerType","","",null,null],[5,"LLVMVectorType","","",null,null],[5,"LLVMGetElementType","","",null,null],[5,"LLVMGetArrayLength","","",null,null],[5,"LLVMGetPointerAddressSpace","","",null,null],[5,"LLVMGetPointerToGlobal","","",null,null],[5,"LLVMGetVectorSize","","",null,null],[5,"LLVMVoidTypeInContext","","",null,null],[5,"LLVMLabelTypeInContext","","",null,null],[5,"LLVMMetadataTypeInContext","","",null,null],[5,"LLVMTypeOf","","",null,null],[5,"LLVMGetValueName","","",null,null],[5,"LLVMSetValueName","","",null,null],[5,"LLVMDumpValue","","",null,null],[5,"LLVMReplaceAllUsesWith","","",null,null],[5,"LLVMHasMetadata","","",null,null],[5,"LLVMGetMetadata","","",null,null],[5,"LLVMSetMetadata","","",null,null],[5,"LLVMGetFirstUse","","",null,null],[5,"LLVMGetNextUse","","",null,null],[5,"LLVMGetUser","","",null,null],[5,"LLVMGetUsedValue","","",null,null],[5,"LLVMGetNumOperands","","",null,null],[5,"LLVMGetOperand","","",null,null],[5,"LLVMSetOperand","","",null,null],[5,"LLVMConstNull","","",null,null],[5,"LLVMConstAllOnes","","",null,null],[5,"LLVMConstICmp","","",null,null],[5,"LLVMConstFCmp","","",null,null],[5,"LLVMGetUndef","","",null,null],[5,"LLVMIsConstant","","",null,null],[5,"LLVMIsNull","","",null,null],[5,"LLVMIsUndef","","",null,null],[5,"LLVMConstPointerNull","","",null,null],[5,"LLVMMDStringInContext","","",null,null],[5,"LLVMMDNodeInContext","","",null,null],[5,"LLVMAddNamedMetadataOperand","","",null,null],[5,"LLVMConstInt","","",null,null],[5,"LLVMConstIntOfString","","",null,null],[5,"LLVMConstIntOfStringAndSize","","",null,null],[5,"LLVMConstReal","","",null,null],[5,"LLVMConstRealOfString","","",null,null],[5,"LLVMConstRealOfStringAndSize","","",null,null],[5,"LLVMConstIntGetZExtValue","","",null,null],[5,"LLVMConstIntGetSExtValue","","",null,null],[5,"LLVMConstStringInContext","","",null,null],[5,"LLVMConstStructInContext","","",null,null],[5,"LLVMConstArray","","",null,null],[5,"LLVMConstVector","","",null,null],[5,"LLVMAlignOf","","",null,null],[5,"LLVMSizeOf","","",null,null],[5,"LLVMConstNeg","","",null,null],[5,"LLVMConstNSWNeg","","",null,null],[5,"LLVMConstNUWNeg","","",null,null],[5,"LLVMConstFNeg","","",null,null],[5,"LLVMConstNot","","",null,null],[5,"LLVMConstAdd","","",null,null],[5,"LLVMConstNSWAdd","","",null,null],[5,"LLVMConstNUWAdd","","",null,null],[5,"LLVMConstFAdd","","",null,null],[5,"LLVMConstSub","","",null,null],[5,"LLVMConstNSWSub","","",null,null],[5,"LLVMConstNUWSub","","",null,null],[5,"LLVMConstFSub","","",null,null],[5,"LLVMConstMul","","",null,null],[5,"LLVMConstNSWMul","","",null,null],[5,"LLVMConstNUWMul","","",null,null],[5,"LLVMConstFMul","","",null,null],[5,"LLVMConstUDiv","","",null,null],[5,"LLVMConstSDiv","","",null,null],[5,"LLVMConstExactSDiv","","",null,null],[5,"LLVMConstFDiv","","",null,null],[5,"LLVMConstURem","","",null,null],[5,"LLVMConstSRem","","",null,null],[5,"LLVMConstFRem","","",null,null],[5,"LLVMConstAnd","","",null,null],[5,"LLVMConstOr","","",null,null],[5,"LLVMConstXor","","",null,null],[5,"LLVMConstShl","","",null,null],[5,"LLVMConstLShr","","",null,null],[5,"LLVMConstAShr","","",null,null],[5,"LLVMConstGEP","","",null,null],[5,"LLVMConstInBoundsGEP","","",null,null],[5,"LLVMConstTrunc","","",null,null],[5,"LLVMConstSExt","","",null,null],[5,"LLVMConstZExt","","",null,null],[5,"LLVMConstFPTrunc","","",null,null],[5,"LLVMConstFPExt","","",null,null],[5,"LLVMConstUIToFP","","",null,null],[5,"LLVMConstSIToFP","","",null,null],[5,"LLVMConstFPToUI","","",null,null],[5,"LLVMConstFPToSI","","",null,null],[5,"LLVMConstPtrToInt","","",null,null],[5,"LLVMConstIntToPtr","","",null,null],[5,"LLVMConstBitCast","","",null,null],[5,"LLVMConstZExtOrBitCast","","",null,null],[5,"LLVMConstSExtOrBitCast","","",null,null],[5,"LLVMConstTruncOrBitCast","","",null,null],[5,"LLVMConstPointerCast","","",null,null],[5,"LLVMConstIntCast","","",null,null],[5,"LLVMConstFPCast","","",null,null],[5,"LLVMConstSelect","","",null,null],[5,"LLVMConstExtractElement","","",null,null],[5,"LLVMConstInsertElement","","",null,null],[5,"LLVMConstShuffleVector","","",null,null],[5,"LLVMConstExtractValue","","",null,null],[5,"LLVMConstInsertValue","","",null,null],[5,"LLVMConstInlineAsm","","",null,null],[5,"LLVMBlockAddress","","",null,null],[5,"LLVMGetGlobalParent","","",null,null],[5,"LLVMIsDeclaration","","",null,null],[5,"LLVMGetLinkage","","",null,null],[5,"LLVMSetLinkage","","",null,null],[5,"LLVMGetSection","","",null,null],[5,"LLVMSetSection","","",null,null],[5,"LLVMGetVisibility","","",null,null],[5,"LLVMSetVisibility","","",null,null],[5,"LLVMGetAlignment","","",null,null],[5,"LLVMSetAlignment","","",null,null],[5,"LLVMIsAGlobalVariable","","",null,null],[5,"LLVMAddGlobal","","",null,null],[5,"LLVMAddGlobalInAddressSpace","","",null,null],[5,"LLVMGetNamedGlobal","","",null,null],[5,"LLVMGetOrInsertGlobal","","",null,null],[5,"LLVMGetFirstGlobal","","",null,null],[5,"LLVMGetLastGlobal","","",null,null],[5,"LLVMGetNextGlobal","","",null,null],[5,"LLVMGetPreviousGlobal","","",null,null],[5,"LLVMDeleteGlobal","","",null,null],[5,"LLVMGetInitializer","","",null,null],[5,"LLVMSetInitializer","","",null,null],[5,"LLVMIsThreadLocal","","",null,null],[5,"LLVMSetThreadLocal","","",null,null],[5,"LLVMIsGlobalConstant","","",null,null],[5,"LLVMSetGlobalConstant","","",null,null],[5,"LLVMGetNamedValue","","",null,null],[5,"LLVMAddAlias","","",null,null],[5,"LLVMAddFunction","","",null,null],[5,"LLVMGetNamedFunction","","",null,null],[5,"LLVMGetFirstFunction","","",null,null],[5,"LLVMGetLastFunction","","",null,null],[5,"LLVMGetNextFunction","","",null,null],[5,"LLVMGetPreviousFunction","","",null,null],[5,"LLVMDeleteFunction","","",null,null],[5,"LLVMGetOrInsertFunction","","",null,null],[5,"LLVMGetIntrinsicID","","",null,null],[5,"LLVMGetFunctionCallConv","","",null,null],[5,"LLVMSetFunctionCallConv","","",null,null],[5,"LLVMGetGC","","",null,null],[5,"LLVMSetGC","","",null,null],[5,"LLVMAddDereferenceableAttr","","",null,null],[5,"LLVMAddFunctionAttribute","","",null,null],[5,"LLVMAddFunctionAttrString","","",null,null],[5,"LLVMRemoveFunctionAttrString","","",null,null],[5,"LLVMGetFunctionAttr","","",null,null],[5,"LLVMRemoveFunctionAttr","","",null,null],[5,"LLVMCountParams","","",null,null],[5,"LLVMGetParams","","",null,null],[5,"LLVMGetParam","","",null,null],[5,"LLVMGetParamParent","","",null,null],[5,"LLVMGetFirstParam","","",null,null],[5,"LLVMGetLastParam","","",null,null],[5,"LLVMGetNextParam","","",null,null],[5,"LLVMGetPreviousParam","","",null,null],[5,"LLVMAddAttribute","","",null,null],[5,"LLVMRemoveAttribute","","",null,null],[5,"LLVMGetAttribute","","",null,null],[5,"LLVMSetParamAlignment","","",null,null],[5,"LLVMBasicBlockAsValue","","",null,null],[5,"LLVMValueIsBasicBlock","","",null,null],[5,"LLVMValueAsBasicBlock","","",null,null],[5,"LLVMGetBasicBlockParent","","",null,null],[5,"LLVMCountBasicBlocks","","",null,null],[5,"LLVMGetBasicBlocks","","",null,null],[5,"LLVMGetFirstBasicBlock","","",null,null],[5,"LLVMGetLastBasicBlock","","",null,null],[5,"LLVMGetNextBasicBlock","","",null,null],[5,"LLVMGetPreviousBasicBlock","","",null,null],[5,"LLVMGetEntryBasicBlock","","",null,null],[5,"LLVMAppendBasicBlockInContext","","",null,null],[5,"LLVMInsertBasicBlockInContext","","",null,null],[5,"LLVMDeleteBasicBlock","","",null,null],[5,"LLVMMoveBasicBlockAfter","","",null,null],[5,"LLVMMoveBasicBlockBefore","","",null,null],[5,"LLVMGetInstructionParent","","",null,null],[5,"LLVMGetFirstInstruction","","",null,null],[5,"LLVMGetLastInstruction","","",null,null],[5,"LLVMGetNextInstruction","","",null,null],[5,"LLVMGetPreviousInstruction","","",null,null],[5,"LLVMInstructionEraseFromParent","","",null,null],[5,"LLVMSetInstructionCallConv","","",null,null],[5,"LLVMGetInstructionCallConv","","",null,null],[5,"LLVMAddInstrAttribute","","",null,null],[5,"LLVMRemoveInstrAttribute","","",null,null],[5,"LLVMSetInstrParamAlignment","","",null,null],[5,"LLVMAddCallSiteAttribute","","",null,null],[5,"LLVMAddDereferenceableCallSiteAttr","","",null,null],[5,"LLVMIsTailCall","","",null,null],[5,"LLVMSetTailCall","","",null,null],[5,"LLVMGetVolatile","","",null,null],[5,"LLVMSetVolatile","","",null,null],[5,"LLVMAddIncoming","","",null,null],[5,"LLVMCountIncoming","","",null,null],[5,"LLVMGetIncomingValue","","",null,null],[5,"LLVMGetIncomingBlock","","",null,null],[5,"LLVMCreateBuilderInContext","","",null,null],[5,"LLVMPositionBuilder","","",null,null],[5,"LLVMPositionBuilderBefore","","",null,null],[5,"LLVMPositionBuilderAtEnd","","",null,null],[5,"LLVMGetInsertBlock","","",null,null],[5,"LLVMClearInsertionPosition","","",null,null],[5,"LLVMInsertIntoBuilder","","",null,null],[5,"LLVMInsertIntoBuilderWithName","","",null,null],[5,"LLVMDisposeBuilder","","",null,null],[5,"LLVMRustCreateJITMemoryManager","","",null,null],[5,"LLVMBuildExecutionEngine","","",null,null],[5,"LLVMDisposeExecutionEngine","","",null,null],[5,"LLVMExecutionEngineFinalizeObject","","",null,null],[5,"LLVMRustLoadDynamicLibrary","","",null,null],[5,"LLVMExecutionEngineAddModule","","",null,null],[5,"LLVMExecutionEngineRemoveModule","","",null,null],[5,"LLVMSetCurrentDebugLocation","","",null,null],[5,"LLVMGetCurrentDebugLocation","","",null,null],[5,"LLVMSetInstDebugLocation","","",null,null],[5,"LLVMBuildRetVoid","","",null,null],[5,"LLVMBuildRet","","",null,null],[5,"LLVMBuildAggregateRet","","",null,null],[5,"LLVMBuildBr","","",null,null],[5,"LLVMBuildCondBr","","",null,null],[5,"LLVMBuildSwitch","","",null,null],[5,"LLVMBuildIndirectBr","","",null,null],[5,"LLVMBuildInvoke","","",null,null],[5,"LLVMBuildLandingPad","","",null,null],[5,"LLVMBuildResume","","",null,null],[5,"LLVMBuildUnreachable","","",null,null],[5,"LLVMAddCase","","",null,null],[5,"LLVMAddDestination","","",null,null],[5,"LLVMAddClause","","",null,null],[5,"LLVMSetCleanup","","",null,null],[5,"LLVMBuildAdd","","",null,null],[5,"LLVMBuildNSWAdd","","",null,null],[5,"LLVMBuildNUWAdd","","",null,null],[5,"LLVMBuildFAdd","","",null,null],[5,"LLVMBuildSub","","",null,null],[5,"LLVMBuildNSWSub","","",null,null],[5,"LLVMBuildNUWSub","","",null,null],[5,"LLVMBuildFSub","","",null,null],[5,"LLVMBuildMul","","",null,null],[5,"LLVMBuildNSWMul","","",null,null],[5,"LLVMBuildNUWMul","","",null,null],[5,"LLVMBuildFMul","","",null,null],[5,"LLVMBuildUDiv","","",null,null],[5,"LLVMBuildSDiv","","",null,null],[5,"LLVMBuildExactSDiv","","",null,null],[5,"LLVMBuildFDiv","","",null,null],[5,"LLVMBuildURem","","",null,null],[5,"LLVMBuildSRem","","",null,null],[5,"LLVMBuildFRem","","",null,null],[5,"LLVMBuildShl","","",null,null],[5,"LLVMBuildLShr","","",null,null],[5,"LLVMBuildAShr","","",null,null],[5,"LLVMBuildAnd","","",null,null],[5,"LLVMBuildOr","","",null,null],[5,"LLVMBuildXor","","",null,null],[5,"LLVMBuildBinOp","","",null,null],[5,"LLVMBuildNeg","","",null,null],[5,"LLVMBuildNSWNeg","","",null,null],[5,"LLVMBuildNUWNeg","","",null,null],[5,"LLVMBuildFNeg","","",null,null],[5,"LLVMBuildNot","","",null,null],[5,"LLVMBuildMalloc","","",null,null],[5,"LLVMBuildArrayMalloc","","",null,null],[5,"LLVMBuildAlloca","","",null,null],[5,"LLVMBuildArrayAlloca","","",null,null],[5,"LLVMBuildFree","","",null,null],[5,"LLVMBuildLoad","","",null,null],[5,"LLVMBuildStore","","",null,null],[5,"LLVMBuildGEP","","",null,null],[5,"LLVMBuildInBoundsGEP","","",null,null],[5,"LLVMBuildStructGEP","","",null,null],[5,"LLVMBuildGlobalString","","",null,null],[5,"LLVMBuildGlobalStringPtr","","",null,null],[5,"LLVMBuildTrunc","","",null,null],[5,"LLVMBuildZExt","","",null,null],[5,"LLVMBuildSExt","","",null,null],[5,"LLVMBuildFPToUI","","",null,null],[5,"LLVMBuildFPToSI","","",null,null],[5,"LLVMBuildUIToFP","","",null,null],[5,"LLVMBuildSIToFP","","",null,null],[5,"LLVMBuildFPTrunc","","",null,null],[5,"LLVMBuildFPExt","","",null,null],[5,"LLVMBuildPtrToInt","","",null,null],[5,"LLVMBuildIntToPtr","","",null,null],[5,"LLVMBuildBitCast","","",null,null],[5,"LLVMBuildZExtOrBitCast","","",null,null],[5,"LLVMBuildSExtOrBitCast","","",null,null],[5,"LLVMBuildTruncOrBitCast","","",null,null],[5,"LLVMBuildCast","","",null,null],[5,"LLVMBuildPointerCast","","",null,null],[5,"LLVMBuildIntCast","","",null,null],[5,"LLVMBuildFPCast","","",null,null],[5,"LLVMBuildICmp","","",null,null],[5,"LLVMBuildFCmp","","",null,null],[5,"LLVMBuildPhi","","",null,null],[5,"LLVMBuildCall","","",null,null],[5,"LLVMBuildSelect","","",null,null],[5,"LLVMBuildVAArg","","",null,null],[5,"LLVMBuildExtractElement","","",null,null],[5,"LLVMBuildInsertElement","","",null,null],[5,"LLVMBuildShuffleVector","","",null,null],[5,"LLVMBuildExtractValue","","",null,null],[5,"LLVMBuildInsertValue","","",null,null],[5,"LLVMBuildIsNull","","",null,null],[5,"LLVMBuildIsNotNull","","",null,null],[5,"LLVMBuildPtrDiff","","",null,null],[5,"LLVMBuildAtomicLoad","","",null,null],[5,"LLVMBuildAtomicStore","","",null,null],[5,"LLVMBuildAtomicCmpXchg","","",null,null],[5,"LLVMBuildAtomicRMW","","",null,null],[5,"LLVMBuildAtomicFence","","",null,null],[5,"LLVMIsATerminatorInst","","",null,null],[5,"LLVMIsAStoreInst","","",null,null],[5,"LLVMWriteBitcodeToFile","","Writes a module to the specified path. Returns 0 on success.",null,null],[5,"LLVMCreateTargetData","","Creates target data from a target layout string.",null,null],[5,"LLVMAddTargetData","","Adds the target data to the given pass manager. The pass manager\nreferences the target data only weakly.",null,null],[5,"LLVMStoreSizeOfType","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMSizeOfTypeInBits","","Number of bytes clobbered when doing a Store to *T.",null,null],[5,"LLVMABISizeOfType","","Distance between successive elements in an array of T. Includes ABI padding.",null,null],[5,"LLVMPreferredAlignmentOfType","","Returns the preferred alignment of a type.",null,null],[5,"LLVMABIAlignmentOfType","","Returns the minimum alignment of a type.",null,null],[5,"LLVMOffsetOfElement","","Computes the byte offset of the indexed struct element for a\ntarget.",null,null],[5,"LLVMCallFrameAlignmentOfType","","Returns the minimum alignment of a type when part of a call frame.",null,null],[5,"LLVMDisposeTargetData","","Disposes target data.",null,null],[5,"LLVMCreatePassManager","","Creates a pass manager.",null,null],[5,"LLVMCreateFunctionPassManagerForModule","","Creates a function-by-function pass manager",null,null],[5,"LLVMDisposePassManager","","Disposes a pass manager.",null,null],[5,"LLVMRunPassManager","","Runs a pass manager on a module.",null,null],[5,"LLVMRunFunctionPassManager","","Runs the function passes on the provided function.",null,null],[5,"LLVMInitializeFunctionPassManager","","Initializes all the function passes scheduled in the manager",null,null],[5,"LLVMFinalizeFunctionPassManager","","Finalizes all the function passes scheduled in the manager",null,null],[5,"LLVMInitializePasses","","",null,null],[5,"LLVMAddVerifierPass","","Adds a verification pass.",null,null],[5,"LLVMAddGlobalOptimizerPass","","",null,null],[5,"LLVMAddIPSCCPPass","","",null,null],[5,"LLVMAddDeadArgEliminationPass","","",null,null],[5,"LLVMAddInstructionCombiningPass","","",null,null],[5,"LLVMAddCFGSimplificationPass","","",null,null],[5,"LLVMAddFunctionInliningPass","","",null,null],[5,"LLVMAddFunctionAttrsPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPass","","",null,null],[5,"LLVMAddScalarReplAggregatesPassSSA","","",null,null],[5,"LLVMAddJumpThreadingPass","","",null,null],[5,"LLVMAddConstantPropagationPass","","",null,null],[5,"LLVMAddReassociatePass","","",null,null],[5,"LLVMAddLoopRotatePass","","",null,null],[5,"LLVMAddLICMPass","","",null,null],[5,"LLVMAddLoopUnswitchPass","","",null,null],[5,"LLVMAddLoopDeletionPass","","",null,null],[5,"LLVMAddLoopUnrollPass","","",null,null],[5,"LLVMAddGVNPass","","",null,null],[5,"LLVMAddMemCpyOptPass","","",null,null],[5,"LLVMAddSCCPPass","","",null,null],[5,"LLVMAddDeadStoreEliminationPass","","",null,null],[5,"LLVMAddStripDeadPrototypesPass","","",null,null],[5,"LLVMAddConstantMergePass","","",null,null],[5,"LLVMAddArgumentPromotionPass","","",null,null],[5,"LLVMAddTailCallEliminationPass","","",null,null],[5,"LLVMAddIndVarSimplifyPass","","",null,null],[5,"LLVMAddAggressiveDCEPass","","",null,null],[5,"LLVMAddGlobalDCEPass","","",null,null],[5,"LLVMAddCorrelatedValuePropagationPass","","",null,null],[5,"LLVMAddPruneEHPass","","",null,null],[5,"LLVMAddSimplifyLibCallsPass","","",null,null],[5,"LLVMAddLoopIdiomPass","","",null,null],[5,"LLVMAddEarlyCSEPass","","",null,null],[5,"LLVMAddTypeBasedAliasAnalysisPass","","",null,null],[5,"LLVMAddBasicAliasAnalysisPass","","",null,null],[5,"LLVMPassManagerBuilderCreate","","",null,null],[5,"LLVMPassManagerBuilderDispose","","",null,null],[5,"LLVMPassManagerBuilderSetOptLevel","","",null,null],[5,"LLVMPassManagerBuilderSetSizeLevel","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnitAtATime","","",null,null],[5,"LLVMPassManagerBuilderSetDisableUnrollLoops","","",null,null],[5,"LLVMPassManagerBuilderSetDisableSimplifyLibCalls","","",null,null],[5,"LLVMPassManagerBuilderUseInlinerWithThreshold","","",null,null],[5,"LLVMPassManagerBuilderPopulateModulePassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateFunctionPassManager","","",null,null],[5,"LLVMPassManagerBuilderPopulateLTOPassManager","","",null,null],[5,"LLVMDisposeMemoryBuffer","","Destroys a memory buffer.",null,null],[5,"LLVMCreateObjectFile","","Opens an object file.",null,null],[5,"LLVMDisposeObjectFile","","Closes an object file.",null,null],[5,"LLVMGetSections","","Enumerates the sections in an object file.",null,null],[5,"LLVMDisposeSectionIterator","","Destroys a section iterator.",null,null],[5,"LLVMIsSectionIteratorAtEnd","","Returns true if the section iterator is at the end of the section\nlist:",null,null],[5,"LLVMMoveToNextSection","","Moves the section iterator to point to the next section.",null,null],[5,"LLVMGetSectionSize","","Returns the current section size.",null,null],[5,"LLVMGetSectionContents","","Returns the current section contents as a string buffer.",null,null],[5,"LLVMRustCreateMemoryBufferWithContentsOfFile","","Reads the given file and returns it as a memory buffer. Use\nLLVMDisposeMemoryBuffer() to get rid of it.",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRange","","Borrows the contents of the memory buffer (doesn't copy it)",null,null],[5,"LLVMCreateMemoryBufferWithMemoryRangeCopy","","",null,null],[5,"LLVMIsMultithreaded","","",null,null],[5,"LLVMStartMultithreaded","","",null,null],[5,"LLVMRustGetLastError","","Returns a string describing the last error caused by an LLVMRust* call.",null,null],[5,"LLVMRustPrintPassTimings","","Print the pass timings since static dtors aren't picking them up.",null,null],[5,"LLVMStructCreateNamed","","",null,null],[5,"LLVMStructSetBody","","",null,null],[5,"LLVMConstNamedStruct","","",null,null],[5,"LLVMSetDebug","","Enables LLVM debug output.",null,null],[5,"LLVMInlineAsm","","Prepares inline assembly.",null,null],[7,"LLVMRustDebugMetadataVersion","","",null,null],[5,"LLVMRustAddModuleFlag","","",null,null],[5,"LLVMDIBuilderCreate","","",null,null],[5,"LLVMDIBuilderDispose","","",null,null],[5,"LLVMDIBuilderFinalize","","",null,null],[5,"LLVMDIBuilderCreateCompileUnit","","",null,null],[5,"LLVMDIBuilderCreateFile","","",null,null],[5,"LLVMDIBuilderCreateSubroutineType","","",null,null],[5,"LLVMDIBuilderCreateFunction","","",null,null],[5,"LLVMDIBuilderCreateBasicType","","",null,null],[5,"LLVMDIBuilderCreatePointerType","","",null,null],[5,"LLVMDIBuilderCreateStructType","","",null,null],[5,"LLVMDIBuilderCreateMemberType","","",null,null],[5,"LLVMDIBuilderCreateLexicalBlock","","",null,null],[5,"LLVMDIBuilderCreateStaticVariable","","",null,null],[5,"LLVMDIBuilderCreateVariable","","",null,null],[5,"LLVMDIBuilderCreateArrayType","","",null,null],[5,"LLVMDIBuilderCreateVectorType","","",null,null],[5,"LLVMDIBuilderGetOrCreateSubrange","","",null,null],[5,"LLVMDIBuilderGetOrCreateArray","","",null,null],[5,"LLVMDIBuilderInsertDeclareAtEnd","","",null,null],[5,"LLVMDIBuilderInsertDeclareBefore","","",null,null],[5,"LLVMDIBuilderCreateEnumerator","","",null,null],[5,"LLVMDIBuilderCreateEnumerationType","","",null,null],[5,"LLVMDIBuilderCreateUnionType","","",null,null],[5,"LLVMSetUnnamedAddr","","",null,null],[5,"LLVMDIBuilderCreateTemplateTypeParameter","","",null,null],[5,"LLVMDIBuilderCreateOpDeref","","",null,null],[5,"LLVMDIBuilderCreateOpPlus","","",null,null],[5,"LLVMDIBuilderCreateNameSpace","","",null,null],[5,"LLVMDIBuilderCreateDebugLocation","","",null,null],[5,"LLVMDICompositeTypeSetTypeArray","","",null,null],[5,"LLVMWriteTypeToString","","",null,null],[5,"LLVMWriteValueToString","","",null,null],[5,"LLVMIsAArgument","","",null,null],[5,"LLVMIsAAllocaInst","","",null,null],[5,"LLVMIsAConstantInt","","",null,null],[5,"LLVMInitializeX86TargetInfo","","",null,null],[5,"LLVMInitializeX86Target","","",null,null],[5,"LLVMInitializeX86TargetMC","","",null,null],[5,"LLVMInitializeX86AsmPrinter","","",null,null],[5,"LLVMInitializeX86AsmParser","","",null,null],[5,"LLVMInitializeARMTargetInfo","","",null,null],[5,"LLVMInitializeARMTarget","","",null,null],[5,"LLVMInitializeARMTargetMC","","",null,null],[5,"LLVMInitializeARMAsmPrinter","","",null,null],[5,"LLVMInitializeARMAsmParser","","",null,null],[5,"LLVMInitializeAArch64TargetInfo","","",null,null],[5,"LLVMInitializeAArch64Target","","",null,null],[5,"LLVMInitializeAArch64TargetMC","","",null,null],[5,"LLVMInitializeAArch64AsmPrinter","","",null,null],[5,"LLVMInitializeAArch64AsmParser","","",null,null],[5,"LLVMInitializeMipsTargetInfo","","",null,null],[5,"LLVMInitializeMipsTarget","","",null,null],[5,"LLVMInitializeMipsTargetMC","","",null,null],[5,"LLVMInitializeMipsAsmPrinter","","",null,null],[5,"LLVMInitializeMipsAsmParser","","",null,null],[5,"LLVMInitializePowerPCTargetInfo","","",null,null],[5,"LLVMInitializePowerPCTarget","","",null,null],[5,"LLVMInitializePowerPCTargetMC","","",null,null],[5,"LLVMInitializePowerPCAsmPrinter","","",null,null],[5,"LLVMInitializePowerPCAsmParser","","",null,null],[5,"LLVMRustAddPass","","",null,null],[5,"LLVMRustCreateTargetMachine","","",null,null],[5,"LLVMRustDisposeTargetMachine","","",null,null],[5,"LLVMRustAddAnalysisPasses","","",null,null],[5,"LLVMRustAddBuilderLibraryInfo","","",null,null],[5,"LLVMRustAddLibraryInfo","","",null,null],[5,"LLVMRustRunFunctionPassManager","","",null,null],[5,"LLVMRustWriteOutputFile","","",null,null],[5,"LLVMRustPrintModule","","",null,null],[5,"LLVMRustSetLLVMOptions","","",null,null],[5,"LLVMRustPrintPasses","","",null,null],[5,"LLVMRustSetNormalizedTarget","","",null,null],[5,"LLVMRustAddAlwaysInlinePass","","",null,null],[5,"LLVMRustLinkInExternalBitcode","","",null,null],[5,"LLVMRustRunRestrictionPass","","",null,null],[5,"LLVMRustMarkAllFunctionsNounwind","","",null,null],[5,"LLVMRustOpenArchive","","",null,null],[5,"LLVMRustArchiveReadSection","","",null,null],[5,"LLVMRustDestroyArchive","","",null,null],[5,"LLVMRustSetDLLExportStorageClass","","",null,null],[5,"LLVMVersionMajor","","",null,null],[5,"LLVMVersionMinor","","",null,null],[5,"LLVMRustGetSectionName","","",null,null],[5,"LLVMWriteTwineToString","","",null,null],[5,"LLVMContextSetDiagnosticHandler","","",null,null],[5,"LLVMUnpackOptimizationDiagnostic","","",null,null],[5,"LLVMUnpackInlineAsmDiagnostic","","",null,null],[5,"LLVMWriteDiagnosticInfoToString","","",null,null],[5,"LLVMGetDiagInfoSeverity","","",null,null],[5,"LLVMGetDiagInfoKind","","",null,null],[5,"LLVMWriteDebugLocToString","","",null,null],[5,"LLVMSetInlineAsmDiagnosticHandler","","",null,null],[5,"LLVMWriteSMDiagnosticToString","","",null,null],[0,"archive_ro","","A wrapper around LLVM's archive (.a) code",null,null],[3,"ArchiveRO","rustc_llvm::archive_ro","",null,null],[11,"open","","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",22,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",22,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",22,{"inputs":[{"name":"archivero"}],"output":null}],[0,"diagnostic","rustc_llvm","LLVM diagnostic reports.",null,null],[3,"OptimizationDiagnostic","rustc_llvm::diagnostic","",null,null],[12,"kind","","",23,null],[12,"pass_name","","",23,null],[12,"function","","",23,null],[12,"debug_loc","","",23,null],[12,"message","","",23,null],[3,"InlineAsmDiagnostic","","",null,null],[12,"cookie","","",24,null],[12,"message","","",24,null],[12,"instruction","","",24,null],[4,"OptimizationDiagnosticKind","","",null,null],[13,"OptimizationRemark","","",25,null],[13,"OptimizationMissed","","",25,null],[13,"OptimizationAnalysis","","",25,null],[13,"OptimizationFailure","","",25,null],[4,"Diagnostic","","",null,null],[13,"Optimization","","",26,null],[13,"InlineAsm","","",26,null],[13,"UnknownDiagnostic","","LLVM has other types that we do not wrap here.",26,null],[11,"clone","","",25,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",25,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",23,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",24,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",26,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",26,{"inputs":[{"name":"diagnostic"},{"name":"diagnosticinforef"}],"output":{"name":"diagnostic"}}],[0,"debuginfo","rustc_llvm","",null,null],[4,"DIBuilder_opaque","rustc_llvm::debuginfo","",null,null],[4,"DIDescriptorFlags","","",null,null],[13,"FlagPrivate","","",27,null],[13,"FlagProtected","","",27,null],[13,"FlagFwdDecl","","",27,null],[13,"FlagAppleBlock","","",27,null],[13,"FlagBlockByrefStruct","","",27,null],[13,"FlagVirtual","","",27,null],[13,"FlagArtificial","","",27,null],[13,"FlagExplicit","","",27,null],[13,"FlagPrototyped","","",27,null],[13,"FlagObjcClassComplete","","",27,null],[13,"FlagObjectPointer","","",27,null],[13,"FlagVector","","",27,null],[13,"FlagStaticMember","","",27,null],[13,"FlagIndirectVariable","","",27,null],[13,"FlagLValueReference","","",27,null],[13,"FlagRValueReference","","",27,null],[6,"DIBuilderRef","","",null,null],[6,"DIDescriptor","","",null,null],[6,"DIScope","","",null,null],[6,"DILocation","","",null,null],[6,"DIFile","","",null,null],[6,"DILexicalBlock","","",null,null],[6,"DISubprogram","","",null,null],[6,"DINameSpace","","",null,null],[6,"DIType","","",null,null],[6,"DIBasicType","","",null,null],[6,"DIDerivedType","","",null,null],[6,"DICompositeType","","",null,null],[6,"DIVariable","","",null,null],[6,"DIGlobalVariable","","",null,null],[6,"DIArray","","",null,null],[6,"DISubrange","","",null,null],[6,"DIEnumerator","","",null,null],[6,"DITemplateTypeParameter","","",null,null],[11,"clone","","",27,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[6,"Opcode","rustc_llvm","",null,null],[6,"Bool","","",null,null],[6,"ModuleRef","","",null,null],[6,"ContextRef","","",null,null],[6,"TypeRef","","",null,null],[6,"ValueRef","","",null,null],[6,"MetadataRef","","",null,null],[6,"BasicBlockRef","","",null,null],[6,"BuilderRef","","",null,null],[6,"ExecutionEngineRef","","",null,null],[6,"RustJITMemoryManagerRef","","",null,null],[6,"MemoryBufferRef","","",null,null],[6,"PassManagerRef","","",null,null],[6,"PassManagerBuilderRef","","",null,null],[6,"UseRef","","",null,null],[6,"TargetDataRef","","",null,null],[6,"ObjectFileRef","","",null,null],[6,"SectionIteratorRef","","",null,null],[6,"PassRef","","",null,null],[6,"TargetMachineRef","","",null,null],[6,"ArchiveRef","","",null,null],[6,"TwineRef","","",null,null],[6,"DiagnosticInfoRef","","",null,null],[6,"DebugLocRef","","",null,null],[6,"SMDiagnosticRef","","",null,null],[6,"DiagnosticHandler","","",null,null],[6,"InlineAsmDiagHandler","","",null,null],[6,"RustStringRef","","",null,null],[17,"True","","",null,null],[17,"False","","",null,null],[17,"ZExtAttribute","","",null,null],[17,"SExtAttribute","","",null,null],[17,"NoReturnAttribute","","",null,null],[17,"InRegAttribute","","",null,null],[17,"StructRetAttribute","","",null,null],[17,"NoUnwindAttribute","","",null,null],[17,"NoAliasAttribute","","",null,null],[17,"ByValAttribute","","",null,null],[17,"NestAttribute","","",null,null],[17,"ReadNoneAttribute","","",null,null],[17,"ReadOnlyAttribute","","",null,null],[17,"NoInlineAttribute","","",null,null],[17,"AlwaysInlineAttribute","","",null,null],[17,"OptimizeForSizeAttribute","","",null,null],[17,"StackProtectAttribute","","",null,null],[17,"StackProtectReqAttribute","","",null,null],[17,"AlignmentAttribute","","",null,null],[17,"NoCaptureAttribute","","",null,null],[17,"NoRedZoneAttribute","","",null,null],[17,"NoImplicitFloatAttribute","","",null,null],[17,"NakedAttribute","","",null,null],[17,"InlineHintAttribute","","",null,null],[17,"StackAttribute","","",null,null],[17,"ReturnsTwiceAttribute","","",null,null],[17,"UWTableAttribute","","",null,null],[17,"NonLazyBindAttribute","","",null,null],[8,"AttrHelper","","",null,null],[10,"apply_llfn","","",28,{"inputs":[{"name":"attrhelper"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[10,"apply_callsite","","",28,{"inputs":[{"name":"attrhelper"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"eq","","",3,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",3,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",4,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",5,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",6,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",29,null],[11,"cmp","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",29,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",29,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",29,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",29,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",29,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",29,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",29,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",29,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":null}],[6,"Output","","",null,null],[11,"bitor","","Returns the union of the two sets of flags.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","","",null,null],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","","",null,null],[11,"bitand","","Returns the intersection between the two sets of flags.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","","",null,null],[11,"sub","","Returns the set difference of the two sets of flags.",29,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","","",null,null],[11,"not","","Returns the complement of this set of flags.",29,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",7,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",8,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",9,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",29,{"inputs":[{"name":"attribute"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"apply_callsite","","",29,{"inputs":[{"name":"attribute"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"apply_llfn","","",7,{"inputs":[{"name":"otherattribute"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"apply_callsite","","",7,{"inputs":[{"name":"otherattribute"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"apply_llfn","","",8,{"inputs":[{"name":"specialattribute"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"apply_callsite","","",8,{"inputs":[{"name":"specialattribute"},{"name":"c_uint"},{"name":"valueref"}],"output":null}],[11,"new","","",30,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",30,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",30,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",30,{"inputs":[{"name":"attrbuilder"},{"name":"valueref"}],"output":null}],[11,"apply_callsite","","",30,{"inputs":[{"name":"attrbuilder"},{"name":"valueref"}],"output":null}],[11,"clone","","",10,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",11,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",12,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",13,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",14,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",15,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",16,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",17,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",18,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",19,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",20,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",21,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"drop","","",0,{"inputs":[{"name":"targetdata"}],"output":null}],[11,"new","","",1,{"inputs":[{"name":"objectfile"},{"name":"memorybufferref"}],"output":{"name":"option"}}],[11,"drop","","",1,{"inputs":[{"name":"objectfile"}],"output":null}],[11,"drop","","",2,{"inputs":[{"name":"sectioniter"}],"output":null}]],"paths":[[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[3,"ArchiveRO"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"OptimizationDiagnosticKind"],[4,"Diagnostic"],[4,"DIDescriptorFlags"],[8,"AttrHelper"],[3,"Attribute"],[3,"AttrBuilder"]]};
searchIndex['rustc_back'] = {"items":[[0,"","rustc_back","Some stuff used by rustc that doesn't have many dependencies",null,null],[0,"abi","","",null,null],[17,"BOX_FIELD_DROP_GLUE","rustc_back::abi","",null,null],[17,"BOX_FIELD_BODY","","",null,null],[17,"FAT_PTR_ADDR","","The first half of a fat pointer.\n- For a closure, this is the code address.\n- For an object or trait instance, this is the address of the box.\n- For a slice, this is the base address.",null,null],[17,"FAT_PTR_EXTRA","","The second half of a fat pointer.\n- For a closure, this is the address of the environment.\n- For an object or trait instance, this is the address of the vtable.\n- For a slice, this is the length.",null,null],[0,"archive","rustc_back","A helper class for dealing with static archives",null,null],[3,"ArchiveConfig","rustc_back::archive","",null,null],[12,"handler","","",0,null],[12,"dst","","",0,null],[12,"lib_search_paths","","",0,null],[12,"slib_prefix","","",0,null],[12,"slib_suffix","","",0,null],[12,"maybe_ar_prog","","",0,null],[3,"Archive","","",null,null],[3,"ArchiveBuilder","","Helper for adding many files to an archive with a single invocation of\n`ar`.",null,null],[5,"find_library","","",null,null],[17,"METADATA_FILENAME","","",null,null],[11,"open","","Opens an existing static archive",1,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",1,{"inputs":[{"name":"archive"},{"name":"str"}],"output":null}],[11,"files","","Lists all files in an archive",1,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",1,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",2,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",2,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",2,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",2,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",2,{"inputs":[{"name":"archivebuilder"}],"output":null}],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",2,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[0,"tempdir","rustc_back","",null,null],[3,"TempDir","rustc_back::tempdir","A wrapper for a path to temporary directory implementing automatic\nscope-based deletion.",null,null],[11,"new_in","","Attempts to make a temporary directory inside of `tmpdir` whose name\nwill have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",3,{"inputs":[{"name":"tempdir"},{"name":"p"},{"name":"str"}],"output":{"name":"result"}}],[11,"new","","Attempts to make a temporary directory inside of `env::temp_dir()` whose\nname will have the prefix `prefix`. The directory will be automatically\ndeleted once the returned wrapper is destroyed.",3,{"inputs":[{"name":"tempdir"},{"name":"str"}],"output":{"name":"result"}}],[11,"into_path","","Unwrap the wrapped `std::path::Path` from the `TempDir` wrapper.\nThis discards the wrapper so that the automatic deletion of the\ntemporary directory is prevented.",3,{"inputs":[{"name":"tempdir"}],"output":{"name":"pathbuf"}}],[11,"path","","Access the wrapped `std::path::Path` to the temporary directory.",3,{"inputs":[{"name":"tempdir"}],"output":{"name":"path"}}],[11,"close","","Close and remove the temporary directory",3,{"inputs":[{"name":"tempdir"}],"output":{"name":"result"}}],[11,"drop","","",3,{"inputs":[{"name":"tempdir"}],"output":null}],[0,"arm","rustc_back","",null,null],[5,"get_target_strs","rustc_back::arm","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"fs","rustc_back","",null,null],[5,"realpath","rustc_back::fs","",null,{"inputs":[{"name":"path"}],"output":{"name":"result"}}],[0,"mips","rustc_back","",null,null],[5,"get_target_strs","rustc_back::mips","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"mipsel","rustc_back","",null,null],[5,"get_target_strs","rustc_back::mipsel","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"rpath","rustc_back","",null,null],[3,"RPathConfig","rustc_back::rpath","",null,null],[12,"used_crates","","",4,null],[12,"out_filename","","",4,null],[12,"is_like_osx","","",4,null],[12,"has_rpath","","",4,null],[12,"get_install_prefix_lib_path","","",4,null],[12,"realpath","","",4,null],[5,"get_rpath_flags","","",null,{"inputs":[{"name":"rpathconfig"}],"output":{"name":"vec"}}],[0,"sha2","rustc_back","This module implements only the Sha256 function since that is all that is needed for internal\nuse. This implementation is not intended for external use or for any use where security is\nimportant.",null,null],[3,"Sha256","rustc_back::sha2","The SHA-256 hash algorithm",null,null],[8,"Digest","","The Digest trait specifies an interface common to digest functions, such as SHA-1 and the SHA-2\nfamily of digest functions.",null,null],[10,"input","","Provide message data.",5,null],[10,"result","","Retrieve the digest result. This method may be called multiple times.",5,null],[10,"reset","","Reset the digest. This method must be called after result() and before supplying more\ndata.",5,{"inputs":[{"name":"digest"}],"output":null}],[10,"output_bits","","Get the output size in bits.",5,{"inputs":[{"name":"digest"}],"output":{"name":"usize"}}],[11,"input_str","","Convenience function that feeds a string into a digest.",5,{"inputs":[{"name":"digest"},{"name":"str"}],"output":null}],[11,"result_bytes","","Convenience function that retrieves the result of a digest as a\nnewly allocated vec of bytes.",5,{"inputs":[{"name":"digest"}],"output":{"name":"vec"}}],[11,"result_str","","Convenience function that retrieves the result of a digest as a\nString in hexadecimal format.",5,{"inputs":[{"name":"digest"}],"output":{"name":"string"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",6,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",6,null],[11,"result","","",6,null],[11,"reset","","",6,{"inputs":[{"name":"sha256"}],"output":null}],[11,"output_bits","","",6,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[0,"svh","rustc_back","Calculation and management of a Strict Version Hash for crates",null,null],[3,"Svh","rustc_back::svh","",null,null],[11,"fmt","","",7,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",7,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",7,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",7,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",7,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",7,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"target_strs","rustc_back","",null,null],[3,"t","rustc_back::target_strs","",null,null],[12,"module_asm","","",8,null],[12,"data_layout","","",8,null],[12,"target_triple","","",8,null],[12,"cc_args","","",8,null],[0,"x86","rustc_back","",null,null],[5,"get_target_strs","rustc_back::x86","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"x86_64","rustc_back","",null,null],[5,"get_target_strs","rustc_back::x86_64","",null,{"inputs":[{"name":"string"},{"name":"os"}],"output":{"name":"t"}}],[0,"target","rustc_back","[Flexible target specification.](https://github.com/rust-lang/rfcs/pull/131)",null,null],[3,"Target","rustc_back::target","Everything `rustc` knows about how to compile for a specific target.",null,null],[12,"data_layout","","[Data layout](http://llvm.org/docs/LangRef.html#data-layout) to pass to LLVM.",9,null],[12,"llvm_target","","Target triple to pass to LLVM.",9,null],[12,"target_endian","","String to use as the `target_endian` `cfg` variable.",9,null],[12,"target_pointer_width","","String to use as the `target_pointer_width` `cfg` variable.",9,null],[12,"target_os","","OS name to use for conditional compilation.",9,null],[12,"arch","","Architecture to use for ABI considerations. Valid options: \"x86\", \"x86_64\", \"arm\",\n\"aarch64\", \"mips\", and \"powerpc\". \"mips\" includes \"mipsel\".",9,null],[12,"options","","Optional settings with defaults.",9,null],[3,"TargetOptions","","Optional aspects of a target specification.",null,null],[12,"linker","","Linker to invoke. Defaults to \"cc\".",10,null],[12,"pre_link_args","","Linker arguments that are unconditionally passed *before* any user-defined libraries.",10,null],[12,"post_link_args","","Linker arguments that are unconditionally passed *after* any user-defined libraries.",10,null],[12,"cpu","","Default CPU to pass to LLVM. Corresponds to `llc -mcpu=$cpu`. Defaults to \"default\".",10,null],[12,"features","","Default target features to pass to LLVM. These features will *always* be passed, and cannot\nbe disabled even via `-C`. Corresponds to `llc -mattr=$features`.",10,null],[12,"dynamic_linking","","Whether dynamic linking is available on this target. Defaults to false.",10,null],[12,"executables","","Whether executables are available on this target. iOS, for example, only allows static\nlibraries. Defaults to false.",10,null],[12,"morestack","","Whether LLVM's segmented stack prelude is supported by whatever runtime is available.\nWill emit stack checks and calls to __morestack. Defaults to false.",10,null],[12,"relocation_model","","Relocation model to use in object file. Corresponds to `llc\n-relocation-model=$relocation_model`. Defaults to \"pic\".",10,null],[12,"code_model","","Code model to use. Corresponds to `llc -code-model=$code_model`. Defaults to \"default\".",10,null],[12,"disable_redzone","","Do not emit code that uses the \"red zone\", if the ABI has one. Defaults to false.",10,null],[12,"eliminate_frame_pointer","","Eliminate frame pointers from stack frames if possible. Defaults to true.",10,null],[12,"function_sections","","Emit each function in its own section. Defaults to true.",10,null],[12,"dll_prefix","","String to prepend to the name of every dynamic library. Defaults to \"lib\".",10,null],[12,"dll_suffix","","String to append to the name of every dynamic library. Defaults to \".so\".",10,null],[12,"exe_suffix","","String to append to the name of every executable.",10,null],[12,"staticlib_prefix","","String to prepend to the name of every static library. Defaults to \"lib\".",10,null],[12,"staticlib_suffix","","String to append to the name of every static library. Defaults to \".a\".",10,null],[12,"is_like_osx","","Whether the target toolchain is like OSX's. Only useful for compiling against iOS/OS X, in\nparticular running dsymutil and some other stuff like `-dead_strip`. Defaults to false.",10,null],[12,"is_like_windows","","Whether the target toolchain is like Windows'. Only useful for compiling against Windows,\nonly really used for figuring out how to find libraries, since Windows uses its own\nlibrary naming convention. Defaults to false.",10,null],[12,"is_like_android","","Whether the target toolchain is like Android's. Only useful for compiling against Android.\nDefaults to false.",10,null],[12,"linker_is_gnu","","Whether the linker support GNU-like arguments such as -O. Defaults to false.",10,null],[12,"has_rpath","","Whether the linker support rpaths or not. Defaults to false.",10,null],[12,"no_compiler_rt","","Whether to disable linking to compiler-rt. Defaults to false, as LLVM will emit references\nto the functions that compiler-rt provides.",10,null],[12,"position_independent_executables","","Dynamically linked executables can be compiled as position independent if the default\nrelocation model of position independent code is not changed. This is a requirement to take\nadvantage of ASLR, as otherwise the functions in the executable are not randomized and can\nbe used during an exploit of a vulnerability in any code.",10,null],[11,"fmt","","",9,{"inputs":[{"name":"target"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",9,{"inputs":[{"name":"target"}],"output":{"name":"target"}}],[11,"fmt","","",10,{"inputs":[{"name":"targetoptions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",10,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"default","","Create a set of \"sane defaults\" for any target. This is still incomplete, and if used for\ncompilation, will certainly not work.",10,{"inputs":[{"name":"targetoptions"}],"output":{"name":"targetoptions"}}],[11,"adjust_abi","","Given a function ABI, turn \"System\" into the correct ABI for this target.",9,{"inputs":[{"name":"target"},{"name":"abi"}],"output":{"name":"abi"}}],[11,"from_json","","Load a target descriptor from a JSON object.",9,{"inputs":[{"name":"target"},{"name":"json"}],"output":{"name":"target"}}],[11,"search","","Search RUST_TARGET_PATH for a JSON file specifying the given target\ntriple. Note that it could also just be a bare filename already, so also\ncheck for that. If one of the hardcoded targets we know about, just\nreturn it directly.",9,{"inputs":[{"name":"target"},{"name":"str"}],"output":{"name":"result"}}]],"paths":[[3,"ArchiveConfig"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"TempDir"],[3,"RPathConfig"],[8,"Digest"],[3,"Sha256"],[3,"Svh"],[3,"t"],[3,"Target"],[3,"TargetOptions"]]};
searchIndex['rustc_resolve'] = {"items":[[0,"","rustc_resolve","",null,null],[3,"Module","","One node in the tree of modules.",null,null],[3,"DefModifiers","","",null,null],[3,"NameBindings","","",null,null],[3,"Resolver","","The main resolver class.",null,null],[3,"CrateMap","","",null,null],[12,"def_map","","",0,null],[12,"freevars","","",0,null],[12,"export_map","","",0,null],[12,"trait_map","","",0,null],[12,"external_exports","","",0,null],[12,"glob_map","","",0,null],[4,"MakeGlobMap","","",null,null],[13,"Yes","","",1,null],[13,"No","","",1,null],[5,"resolve_crate","","Entry point to crate resolution.",null,{"inputs":[{"name":"session"},{"name":"map"},{"name":"languageitems"},{"name":"crate"},{"name":"makeglobmap"}],"output":{"name":"cratemap"}}],[0,"diagnostics","","",null,null],[7,"DIAGNOSTICS","rustc_resolve::diagnostics","",null,null],[17,"PUBLIC","rustc_resolve","",null,null],[17,"IMPORTABLE","","",null,null],[11,"visit_item","","",2,{"inputs":[{"name":"resolver"},{"name":"item"}],"output":null}],[11,"visit_arm","","",2,{"inputs":[{"name":"resolver"},{"name":"arm"}],"output":null}],[11,"visit_block","","",2,{"inputs":[{"name":"resolver"},{"name":"block"}],"output":null}],[11,"visit_expr","","",2,{"inputs":[{"name":"resolver"},{"name":"expr"}],"output":null}],[11,"visit_local","","",2,{"inputs":[{"name":"resolver"},{"name":"local"}],"output":null}],[11,"visit_ty","","",2,{"inputs":[{"name":"resolver"},{"name":"ty"}],"output":null}],[11,"visit_generics","","",2,{"inputs":[{"name":"resolver"},{"name":"generics"}],"output":null}],[11,"visit_poly_trait_ref","","",2,{"inputs":[{"name":"resolver"},{"name":"polytraitref"},{"name":"traitboundmodifier"}],"output":null}],[11,"visit_variant","","",2,{"inputs":[{"name":"resolver"},{"name":"variant"},{"name":"generics"}],"output":null}],[11,"visit_foreign_item","","",2,{"inputs":[{"name":"resolver"},{"name":"foreignitem"}],"output":null}],[11,"visit_fn","","",2,{"inputs":[{"name":"resolver"},{"name":"fnkind"},{"name":"fndecl"},{"name":"block"},{"name":"span"},{"name":"nodeid"}],"output":null}],[11,"fmt","","",3,{"inputs":[{"name":"module"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",4,null],[11,"cmp","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"option"}}],[11,"lt","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"le","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"gt","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"ge","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[11,"eq","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"fmt","","",4,{"inputs":[{"name":"defmodifiers"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[11,"all","","Returns the set containing all flags.",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[11,"bits","","Returns the raw value of the flags currently stored.",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",4,{"inputs":[{"name":"defmodifiers"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",4,{"inputs":[{"name":"defmodifiers"},{"name":"u8"}],"output":{"name":"defmodifiers"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":null}],[11,"remove","","Removes the specified flags in-place.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":null}],[11,"toggle","","Toggles the specified flags in-place.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":null}],[6,"Output","","",null,null],[11,"bitor","","Returns the union of the two sets of flags.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[6,"Output","","",null,null],[11,"bitxor","","Returns the left flags, but with all the right flags toggled.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[6,"Output","","",null,null],[11,"bitand","","Returns the intersection between the two sets of flags.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[6,"Output","","",null,null],[11,"sub","","Returns the set difference of the two sets of flags.",4,{"inputs":[{"name":"defmodifiers"},{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[6,"Output","","",null,null],[11,"not","","Returns the complement of this set of flags.",4,{"inputs":[{"name":"defmodifiers"}],"output":{"name":"defmodifiers"}}],[11,"fmt","","",5,{"inputs":[{"name":"namebindings"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",1,{"inputs":[{"name":"makeglobmap"}],"output":{"name":"makeglobmap"}}],[11,"eq","","",1,{"inputs":[{"name":"makeglobmap"},{"name":"makeglobmap"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"makeglobmap"},{"name":"makeglobmap"}],"output":{"name":"bool"}}]],"paths":[[3,"CrateMap"],[4,"MakeGlobMap"],[3,"Resolver"],[3,"Module"],[3,"DefModifiers"],[3,"NameBindings"]]};
searchIndex['rustc_driver'] = {"items":[[0,"","rustc_driver","The Rust compiler.",null,null],[0,"diagnostic","","",null,null],[11,"new","syntax::util::interner","",0,{"inputs":[{"name":"interner"}],"output":{"name":"interner"}}],[11,"prefill","","",0,null],[11,"intern","","",0,{"inputs":[{"name":"interner"},{"name":"t"}],"output":{"name":"name"}}],[11,"gensym","","",0,{"inputs":[{"name":"interner"},{"name":"t"}],"output":{"name":"name"}}],[11,"get","","",0,{"inputs":[{"name":"interner"},{"name":"name"}],"output":{"name":"t"}}],[11,"len","","",0,{"inputs":[{"name":"interner"}],"output":{"name":"usize"}}],[11,"find","","",0,{"inputs":[{"name":"interner"},{"name":"q"}],"output":{"name":"option"}}],[11,"clear","","",0,null],[11,"partial_cmp","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"option"}}],[11,"lt","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"le","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"gt","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"ge","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"hash","","",1,null],[11,"eq","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"rcstr"}],"output":{"name":"rcstr"}}],[11,"new","","",1,{"inputs":[{"name":"rcstr"},{"name":"str"}],"output":{"name":"rcstr"}}],[11,"cmp","","",1,{"inputs":[{"name":"rcstr"},{"name":"rcstr"}],"output":{"name":"ordering"}}],[11,"fmt","","",1,{"inputs":[{"name":"rcstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"rcstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"borrow","","",1,{"inputs":[{"name":"rcstr"}],"output":{"name":"str"}}],[6,"Target","rustc_driver::diagnostic","",null,null],[11,"deref","syntax::util::interner","",1,{"inputs":[{"name":"rcstr"}],"output":{"name":"str"}}],[11,"new","","",2,{"inputs":[{"name":"strinterner"}],"output":{"name":"strinterner"}}],[11,"prefill","","",2,null],[11,"intern","","",2,{"inputs":[{"name":"strinterner"},{"name":"str"}],"output":{"name":"name"}}],[11,"gensym","","",2,{"inputs":[{"name":"strinterner"},{"name":"str"}],"output":{"name":"name"}}],[11,"gensym_copy","","Create a gensym with the same name as an existing\nentry.",2,{"inputs":[{"name":"strinterner"},{"name":"name"}],"output":{"name":"name"}}],[11,"get","","",2,{"inputs":[{"name":"strinterner"},{"name":"name"}],"output":{"name":"rcstr"}}],[11,"len","","",2,{"inputs":[{"name":"strinterner"}],"output":{"name":"usize"}}],[11,"find","","",2,{"inputs":[{"name":"strinterner"},{"name":"q"}],"output":{"name":"option"}}],[11,"clear","","",2,null],[11,"reset","","",2,null],[11,"from_iter","syntax::util::small_vector","",3,{"inputs":[{"name":"smallvector"},{"name":"i"}],"output":{"name":"smallvector"}}],[11,"extend","","",3,null],[11,"zero","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"smallvector"}}],[11,"one","","",3,{"inputs":[{"name":"smallvector"},{"name":"t"}],"output":{"name":"smallvector"}}],[11,"many","","",3,{"inputs":[{"name":"smallvector"},{"name":"vec"}],"output":{"name":"smallvector"}}],[11,"as_slice","","",3,null],[11,"pop","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"option"}}],[11,"push","","",3,null],[11,"push_all","","",3,null],[11,"get","","",3,{"inputs":[{"name":"smallvector"},{"name":"usize"}],"output":{"name":"t"}}],[11,"expect_one","","",3,{"inputs":[{"name":"smallvector"},{"name":"str"}],"output":{"name":"t"}}],[11,"move_iter","","Deprecated: use `into_iter`.",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"intoiter"}}],[11,"into_iter","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"intoiter"}}],[11,"len","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"usize"}}],[11,"is_empty","","",3,{"inputs":[{"name":"smallvector"}],"output":{"name":"bool"}}],[6,"Item","rustc_driver::diagnostic","",null,null],[11,"next","syntax::util::small_vector","",4,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",4,null],[11,"move_map","","",3,{"inputs":[{"name":"smallvector"},{"name":"f"}],"output":{"name":"smallvector"}}],[11,"clone","syntax::diagnostics::registry","",5,{"inputs":[{"name":"registry"}],"output":{"name":"registry"}}],[11,"new","","",5,null],[11,"find_description","","",5,{"inputs":[{"name":"registry"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","syntax::ext::base","",6,{"inputs":[{"name":"annotatable"}],"output":{"name":"annotatable"}}],[11,"fmt","","",6,{"inputs":[{"name":"annotatable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"attrs","","",6,null],[11,"fold_attrs","","",6,{"inputs":[{"name":"annotatable"},{"name":"vec"}],"output":{"name":"annotatable"}}],[11,"expect_item","","",6,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"expect_trait_item","","",6,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"expect_impl_item","","",6,{"inputs":[{"name":"annotatable"}],"output":{"name":"p"}}],[11,"default","","",7,{"inputs":[{"name":"maceager"}],"output":{"name":"maceager"}}],[11,"expr","","",7,{"inputs":[{"name":"maceager"},{"name":"p"}],"output":{"name":"box"}}],[11,"pat","","",7,{"inputs":[{"name":"maceager"},{"name":"p"}],"output":{"name":"box"}}],[11,"items","","",7,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"impl_items","","",7,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"stmts","","",7,{"inputs":[{"name":"maceager"},{"name":"smallvector"}],"output":{"name":"box"}}],[11,"make_expr","","",7,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_items","","",7,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_impl_items","","",7,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_stmts","","",7,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"make_pat","","",7,{"inputs":[{"name":"maceager"}],"output":{"name":"option"}}],[11,"clone","","",8,{"inputs":[{"name":"dummyresult"}],"output":{"name":"dummyresult"}}],[11,"any","","Create a default MacResult that can be anything.",8,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"box"}}],[11,"expr","","Create a default MacResult that can only be an expression.",8,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"box"}}],[11,"raw_expr","","A plain dummy expression.",8,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"p"}}],[11,"raw_pat","","A plain dummy pattern.",8,{"inputs":[{"name":"dummyresult"},{"name":"span"}],"output":{"name":"pat"}}],[11,"make_expr","","",8,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_pat","","",8,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_items","","",8,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_impl_items","","",8,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"make_stmts","","",8,{"inputs":[{"name":"dummyresult"}],"output":{"name":"option"}}],[11,"new","","",9,{"inputs":[{"name":"blockinfo"}],"output":{"name":"blockinfo"}}],[11,"new","","",10,{"inputs":[{"name":"extctxt"},{"name":"parsesess"},{"name":"vec"},{"name":"expansionconfig"}],"output":{"name":"extctxt"}}],[11,"expand_expr","","",10,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"expander","","Returns a `Folder` for deeply expanding all macros in a AST node.",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"macroexpander"}}],[11,"new_parser_from_tts","","",10,null],[11,"codemap","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"codemap"}}],[11,"parse_sess","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"parsesess"}}],[11,"cfg","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"call_site","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"backtrace","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"expnid"}}],[11,"original_span","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"original_span_in_file","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"span"}}],[11,"mod_push","","",10,null],[11,"mod_pop","","",10,null],[11,"mod_path","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"bt_push","","",10,null],[11,"bt_pop","","",10,null],[11,"insert_macro","","",10,null],[11,"span_fatal","","Emit `msg` attached to `sp`, and stop compilation immediately.",10,null],[11,"span_err","","Emit `msg` attached to `sp`, without immediately stopping\ncompilation.",10,null],[11,"span_warn","","",10,null],[11,"span_unimpl","","",10,null],[11,"span_bug","","",10,null],[11,"span_note","","",10,null],[11,"span_help","","",10,null],[11,"fileline_help","","",10,null],[11,"bug","","",10,null],[11,"trace_macros","","",10,{"inputs":[{"name":"extctxt"}],"output":{"name":"bool"}}],[11,"set_trace_macros","","",10,null],[11,"ident_of","","",10,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"ident"}}],[11,"ident_of_std","","",10,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"ident"}}],[11,"name_of","","",10,{"inputs":[{"name":"extctxt"},{"name":"str"}],"output":{"name":"name"}}],[11,"push_frame","","",11,null],[11,"pop_frame","","",11,null],[11,"find","","",11,{"inputs":[{"name":"syntaxenv"},{"name":"name"}],"output":{"name":"option"}}],[11,"insert","","",11,null],[11,"info","","",11,{"inputs":[{"name":"syntaxenv"}],"output":{"name":"blockinfo"}}],[11,"path","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[11,"path_ident","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"path"}}],[11,"path_global","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"path"}}],[11,"path_all","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"vec"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"path"}}],[11,"qpath","","Constructs a qualified path.",10,null],[11,"qpath_all","","Constructs a qualified path.",10,null],[11,"ty_mt","","",10,{"inputs":[{"name":"extctxt"},{"name":"p"},{"name":"mutability"}],"output":{"name":"mutty"}}],[11,"ty","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ty_"}],"output":{"name":"p"}}],[11,"ty_path","","",10,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"p"}}],[11,"ty_sum","","",10,{"inputs":[{"name":"extctxt"},{"name":"path"},{"name":"ownedslice"}],"output":{"name":"p"}}],[11,"ty_ident","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"ty_rptr","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"option"},{"name":"mutability"}],"output":{"name":"p"}}],[11,"ty_ptr","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"mutability"}],"output":{"name":"p"}}],[11,"ty_option","","",10,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"ty_field_imm","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"typefield"}}],[11,"ty_infer","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"typaram","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"ownedslice"},{"name":"option"}],"output":{"name":"typaram"}}],[11,"ty_vars","","",10,{"inputs":[{"name":"extctxt"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"ty_vars_global","","",10,{"inputs":[{"name":"extctxt"},{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"trait_ref","","",10,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"traitref"}}],[11,"poly_trait_ref","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"}],"output":{"name":"polytraitref"}}],[11,"typarambound","","",10,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"typarambound"}}],[11,"lifetime","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"name"}],"output":{"name":"lifetime"}}],[11,"lifetime_def","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"name"},{"name":"vec"}],"output":{"name":"lifetimedef"}}],[11,"stmt_expr","","",10,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"stmt_let","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[11,"stmt_let_typed","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"block","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[11,"stmt_item","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"block_expr","","",10,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"block_all","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"option"}],"output":{"name":"p"}}],[11,"expr","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"expr_"}],"output":{"name":"p"}}],[11,"expr_path","","",10,{"inputs":[{"name":"extctxt"},{"name":"path"}],"output":{"name":"p"}}],[11,"expr_qpath","","Constructs a QPath expression.",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"qself"},{"name":"path"}],"output":{"name":"p"}}],[11,"expr_ident","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"expr_self","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_binary","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"binop_"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_deref","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_unary","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"unop"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_field_access","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"expr_tup_field_access","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"usize"}],"output":{"name":"p"}}],[11,"expr_addr_of","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_mut_addr_of","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_call","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_call_ident","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_call_global","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_method_call","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_block","","",10,{"inputs":[{"name":"extctxt"},{"name":"p"}],"output":{"name":"p"}}],[11,"field_imm","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"field"}}],[11,"expr_struct","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_struct_ident","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_lit","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"lit_"}],"output":{"name":"p"}}],[11,"expr_usize","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"usize"}],"output":{"name":"p"}}],[11,"expr_int","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"isize"}],"output":{"name":"p"}}],[11,"expr_u32","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"u32"}],"output":{"name":"p"}}],[11,"expr_u8","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"u8"}],"output":{"name":"p"}}],[11,"expr_bool","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"bool"}],"output":{"name":"p"}}],[11,"expr_vec","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_vec_ng","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_vec_slice","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_str","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"expr_cast","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_some","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_none","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_break","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_tuple","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_fail","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"expr_unreachable","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"expr_ok","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_err","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"expr_try","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"pat_"}],"output":{"name":"p"}}],[11,"pat_wild","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"pat_lit","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_ident","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"}],"output":{"name":"p"}}],[11,"pat_ident_binding_mode","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"bindingmode"}],"output":{"name":"p"}}],[11,"pat_enum","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_struct","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"path"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_tuple","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"pat_some","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_none","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"p"}}],[11,"pat_ok","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"pat_err","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"arm","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"arm"}}],[11,"arm_unreachable","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"}],"output":{"name":"arm"}}],[11,"expr_match","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"vec"}],"output":{"name":"p"}}],[11,"expr_if","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"},{"name":"option"}],"output":{"name":"p"}}],[11,"expr_loop","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_fn_decl","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda0","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda1","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"lambda_expr","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_expr_0","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"p"}}],[11,"lambda_expr_1","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"},{"name":"ident"}],"output":{"name":"p"}}],[11,"lambda_stmts","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"lambda_stmts_0","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"}],"output":{"name":"p"}}],[11,"lambda_stmts_1","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"vec"},{"name":"ident"}],"output":{"name":"p"}}],[11,"arg","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"arg"}}],[11,"fn_decl","","",10,{"inputs":[{"name":"extctxt"},{"name":"vec"},{"name":"p"}],"output":{"name":"p"}}],[11,"item","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"item_"}],"output":{"name":"p"}}],[11,"item_fn_poly","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"generics"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_fn","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"variant","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"vec"}],"output":{"name":"spanned"}}],[11,"item_enum_poly","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"enumdef"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_enum","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"enumdef"}],"output":{"name":"p"}}],[11,"item_struct","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"structdef"}],"output":{"name":"p"}}],[11,"item_struct_poly","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"structdef"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_mod","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"span"},{"name":"ident"},{"name":"vec"},{"name":"vec"}],"output":{"name":"p"}}],[11,"item_static","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"mutability"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_const","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_ty_poly","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"},{"name":"generics"}],"output":{"name":"p"}}],[11,"item_ty","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"p"}],"output":{"name":"p"}}],[11,"attribute","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"p"}],"output":{"name":"spanned"}}],[11,"meta_word","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"}],"output":{"name":"p"}}],[11,"meta_list","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"},{"name":"vec"}],"output":{"name":"p"}}],[11,"meta_name_value","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"internedstring"},{"name":"lit_"}],"output":{"name":"p"}}],[11,"item_use","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"p"}],"output":{"name":"p"}}],[11,"item_use_simple","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"path"}],"output":{"name":"p"}}],[11,"item_use_simple_","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"ident"},{"name":"path"}],"output":{"name":"p"}}],[11,"item_use_list","","",10,null],[11,"item_use_glob","","",10,{"inputs":[{"name":"extctxt"},{"name":"span"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"p"}}],[11,"clone","syntax::ext::deriving::ord","",12,{"inputs":[{"name":"orderingop"}],"output":{"name":"orderingop"}}],[11,"clone","syntax::ext::deriving::generic::ty","",13,{"inputs":[{"name":"ptrty"}],"output":{"name":"ptrty"}}],[11,"clone","","",14,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"new","","",14,{"inputs":[{"name":"path"},{"name":"vec"}],"output":{"name":"path"}}],[11,"new_local","","",14,{"inputs":[{"name":"path"},{"name":"str"}],"output":{"name":"path"}}],[11,"new_","","",14,{"inputs":[{"name":"path"},{"name":"vec"},{"name":"option"},{"name":"vec"},{"name":"bool"}],"output":{"name":"path"}}],[11,"to_ty","","",14,{"inputs":[{"name":"path"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"p"}}],[11,"to_path","","",14,{"inputs":[{"name":"path"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",15,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[11,"to_ty","","",15,{"inputs":[{"name":"ty"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"p"}}],[11,"to_path","","",15,{"inputs":[{"name":"ty"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"path"}}],[11,"clone","","",16,{"inputs":[{"name":"lifetimebounds"}],"output":{"name":"lifetimebounds"}}],[11,"empty","","",16,{"inputs":[{"name":"lifetimebounds"}],"output":{"name":"lifetimebounds"}}],[11,"to_generics","","",16,{"inputs":[{"name":"lifetimebounds"},{"name":"extctxt"},{"name":"span"},{"name":"ident"},{"name":"generics"}],"output":{"name":"generics"}}],[11,"expand","syntax::ext::deriving::generic","",17,null],[11,"eq","","",18,{"inputs":[{"name":"structtype"},{"name":"structtype"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"structtype"},{"name":"structtype"}],"output":{"name":"bool"}}],[11,"clone","syntax::ext::expand","",19,{"inputs":[{"name":"patidentfinder"}],"output":{"name":"patidentfinder"}}],[11,"visit_pat","","",19,null],[11,"fold_ident","","",20,{"inputs":[{"name":"identrenamer"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_mac","","",20,{"inputs":[{"name":"identrenamer"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"fold_pat","","",21,{"inputs":[{"name":"patidentrenamer"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mac","","",21,{"inputs":[{"name":"patidentrenamer"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"new","","",22,{"inputs":[{"name":"macroexpander"},{"name":"extctxt"}],"output":{"name":"macroexpander"}}],[11,"fold_expr","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_pat","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_item","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_item_underscore","","",22,{"inputs":[{"name":"macroexpander"},{"name":"item_"}],"output":{"name":"item_"}}],[11,"fold_stmt","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_block","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_arm","","",22,{"inputs":[{"name":"macroexpander"},{"name":"arm"}],"output":{"name":"arm"}}],[11,"fold_trait_item","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_impl_item","","",22,{"inputs":[{"name":"macroexpander"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"new_span","","",22,{"inputs":[{"name":"macroexpander"},{"name":"span"}],"output":{"name":"span"}}],[11,"default","","",23,{"inputs":[{"name":"expansionconfig"},{"name":"string"}],"output":{"name":"expansionconfig"}}],[11,"enable_quotes","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_asm","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_log_syntax","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_concat_idents","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_trace_macros","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_allow_internal_unstable","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"enable_custom_derive","","",23,{"inputs":[{"name":"expansionconfig"}],"output":{"name":"bool"}}],[11,"fold_ident","","",24,{"inputs":[{"name":"marker"},{"name":"ident"}],"output":{"name":"ident"}}],[11,"fold_mac","","",24,{"inputs":[{"name":"marker"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"visit_mac","","",25,null],[11,"eq","syntax::ext::format","",26,{"inputs":[{"name":"argumenttype"},{"name":"argumenttype"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"argumenttype"},{"name":"argumenttype"}],"output":{"name":"bool"}}],[11,"clone","syntax::ext::mtwt","",27,{"inputs":[{"name":"syntaxcontext_"}],"output":{"name":"syntaxcontext_"}}],[11,"fmt","","",27,{"inputs":[{"name":"syntaxcontext_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",27,null],[11,"decode","","",27,{"inputs":[{"name":"syntaxcontext_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",27,{"inputs":[{"name":"syntaxcontext_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",27,{"inputs":[{"name":"syntaxcontext_"},{"name":"syntaxcontext_"}],"output":{"name":"bool"}}],[11,"ne","","",27,{"inputs":[{"name":"syntaxcontext_"},{"name":"syntaxcontext_"}],"output":{"name":"bool"}}],[11,"to_tokens","syntax::ast","",28,{"inputs":[{"name":"tokentree"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","collections::vec","",29,{"inputs":[{"name":"vec"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::codemap","",30,{"inputs":[{"name":"spanned"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","core::option","",31,{"inputs":[{"name":"option"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_source","syntax::ast","",32,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",32,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"to_source","","",33,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",33,{"inputs":[{"name":"path"}],"output":{"name":"string"}}],[11,"to_source","","",34,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",34,{"inputs":[{"name":"ty"}],"output":{"name":"string"}}],[11,"to_source","","",35,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",35,{"inputs":[{"name":"block"}],"output":{"name":"string"}}],[11,"to_source","","",36,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",36,{"inputs":[{"name":"arg"}],"output":{"name":"string"}}],[11,"to_source","","",37,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",37,{"inputs":[{"name":"generics"}],"output":{"name":"string"}}],[11,"to_source","","",38,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",38,{"inputs":[{"name":"whereclause"}],"output":{"name":"string"}}],[11,"to_source","syntax::ptr","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",39,{"inputs":[{"name":"p"}],"output":{"name":"string"}}],[11,"to_source","syntax::ast","",40,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",40,{"inputs":[{"name":"arm"}],"output":{"name":"string"}}],[11,"to_source","","",41,{"inputs":[{"name":"attribute_"}],"output":{"name":"string"}}],[11,"to_source_with_hygiene","","",41,{"inputs":[{"name":"attribute_"}],"output":{"name":"string"}}],[11,"to_tokens","","",32,{"inputs":[{"name":"ident"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",33,{"inputs":[{"name":"path"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ptr","",39,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",39,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",39,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",39,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",40,{"inputs":[{"name":"arm"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",34,{"inputs":[{"name":"ty"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",37,{"inputs":[{"name":"generics"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",38,{"inputs":[{"name":"whereclause"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ptr","",39,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",39,{"inputs":[{"name":"p"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","syntax::ast","",35,{"inputs":[{"name":"block"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",36,{"inputs":[{"name":"arg"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"to_tokens","","",41,{"inputs":[{"name":"attribute_"},{"name":"extctxt"}],"output":{"name":"vec"}}],[11,"parse_item","syntax::ext::base","",10,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_stmt","","",10,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_expr","","",10,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"p"}}],[11,"parse_tts","","",10,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"vec"}}],[11,"parse_tts_with_hygiene","","",10,{"inputs":[{"name":"extctxt"},{"name":"string"}],"output":{"name":"vec"}}],[11,"clone","syntax::ext::tt::transcribe","",42,{"inputs":[{"name":"ttframe"}],"output":{"name":"ttframe"}}],[11,"clone","","",43,{"inputs":[{"name":"ttreader"}],"output":{"name":"ttreader"}}],[11,"clone","","",44,{"inputs":[{"name":"lockstepitersize"}],"output":{"name":"lockstepitersize"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"add","syntax::ext::tt::transcribe","",44,{"inputs":[{"name":"lockstepitersize"},{"name":"lockstepitersize"}],"output":{"name":"lockstepitersize"}}],[11,"clone","syntax::ext::tt::macro_parser","",45,{"inputs":[{"name":"tokentreeortokentreevec"}],"output":{"name":"tokentreeortokentreevec"}}],[11,"clone","","",46,{"inputs":[{"name":"matcherttframe"}],"output":{"name":"matcherttframe"}}],[11,"clone","","",47,{"inputs":[{"name":"matcherpos"}],"output":{"name":"matcherpos"}}],[11,"make_expr","syntax::ext::tt::macro_rules","",48,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_pat","","",48,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_items","","",48,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_impl_items","","",48,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"make_stmts","","",48,{"inputs":[{"name":"parseranymacro"}],"output":{"name":"option"}}],[11,"expand","","",49,null],[11,"cmp","syntax::ast","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"option"}}],[11,"lt","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"le","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"gt","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"ge","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"hash","","",32,null],[11,"clone","","",32,{"inputs":[{"name":"ident"}],"output":{"name":"ident"}}],[11,"new","","Construct an identifier with the given name and an empty context:",32,{"inputs":[{"name":"ident"},{"name":"name"}],"output":{"name":"ident"}}],[11,"as_str","","",32,{"inputs":[{"name":"ident"}],"output":{"name":"str"}}],[11,"encode_with_hygiene","","",32,{"inputs":[{"name":"ident"}],"output":{"name":"string"}}],[11,"fmt","","",32,{"inputs":[{"name":"ident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",32,{"inputs":[{"name":"ident"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",50,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",50,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"ident"},{"name":"ident"}],"output":{"name":"bool"}}],[11,"clone","","",50,{"inputs":[{"name":"name"}],"output":{"name":"name"}}],[11,"decode","","",50,{"inputs":[{"name":"name"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",50,{"inputs":[{"name":"name"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",50,null],[11,"partial_cmp","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"option"}}],[11,"lt","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"le","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"gt","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ge","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"eq","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ne","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"cmp","","",50,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"ordering"}}],[11,"as_str","","",50,{"inputs":[{"name":"name"}],"output":{"name":"str"}}],[11,"usize","","",50,{"inputs":[{"name":"name"}],"output":{"name":"usize"}}],[11,"ident","","",50,{"inputs":[{"name":"name"}],"output":{"name":"ident"}}],[11,"encode","","",32,{"inputs":[{"name":"ident"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",32,{"inputs":[{"name":"ident"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",51,{"inputs":[{"name":"lifetime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",51,null],[11,"decode","","",51,{"inputs":[{"name":"lifetime"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",51,{"inputs":[{"name":"lifetime"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",51,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"ne","","",51,{"inputs":[{"name":"lifetime"},{"name":"lifetime"}],"output":{"name":"bool"}}],[11,"clone","","",51,{"inputs":[{"name":"lifetime"}],"output":{"name":"lifetime"}}],[11,"fmt","","",52,{"inputs":[{"name":"lifetimedef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",52,null],[11,"decode","","",52,{"inputs":[{"name":"lifetimedef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",52,{"inputs":[{"name":"lifetimedef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",52,{"inputs":[{"name":"lifetimedef"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"lifetimedef"},{"name":"lifetimedef"}],"output":{"name":"bool"}}],[11,"clone","","",52,{"inputs":[{"name":"lifetimedef"}],"output":{"name":"lifetimedef"}}],[11,"fmt","","",33,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",33,null],[11,"decode","","",33,{"inputs":[{"name":"path"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",33,{"inputs":[{"name":"path"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",33,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"clone","","",33,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"fmt","","",53,{"inputs":[{"name":"pathsegment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",53,null],[11,"decode","","",53,{"inputs":[{"name":"pathsegment"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",53,{"inputs":[{"name":"pathsegment"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",53,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"ne","","",53,{"inputs":[{"name":"pathsegment"},{"name":"pathsegment"}],"output":{"name":"bool"}}],[11,"clone","","",53,{"inputs":[{"name":"pathsegment"}],"output":{"name":"pathsegment"}}],[11,"fmt","","",54,{"inputs":[{"name":"pathparameters"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",54,null],[11,"decode","","",54,{"inputs":[{"name":"pathparameters"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",54,{"inputs":[{"name":"pathparameters"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",54,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"ne","","",54,{"inputs":[{"name":"pathparameters"},{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"clone","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"none","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"pathparameters"}}],[11,"is_empty","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"has_lifetimes","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"has_types","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"bool"}}],[11,"types","","Returns the types that the user wrote. Note that these do not necessarily map to the type\nparameters in the parenthesized case.",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"lifetimes","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"bindings","","",54,{"inputs":[{"name":"pathparameters"}],"output":{"name":"vec"}}],[11,"fmt","","",55,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",55,null],[11,"decode","","",55,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",55,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"anglebracketedparameterdata"},{"name":"anglebracketedparameterdata"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"anglebracketedparameterdata"}],"output":{"name":"anglebracketedparameterdata"}}],[11,"fmt","","",56,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",56,null],[11,"decode","","",56,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",56,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",56,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"parenthesizedparameterdata"},{"name":"parenthesizedparameterdata"}],"output":{"name":"bool"}}],[11,"clone","","",56,{"inputs":[{"name":"parenthesizedparameterdata"}],"output":{"name":"parenthesizedparameterdata"}}],[11,"fmt","","",57,{"inputs":[{"name":"defid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",57,null],[11,"decode","","",57,{"inputs":[{"name":"defid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",57,{"inputs":[{"name":"defid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ne","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"option"}}],[11,"lt","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"le","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"gt","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"ge","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"bool"}}],[11,"cmp","","",57,{"inputs":[{"name":"defid"},{"name":"defid"}],"output":{"name":"ordering"}}],[11,"clone","","",57,{"inputs":[{"name":"defid"}],"output":{"name":"defid"}}],[11,"local_id","","Read the node id, asserting that this def-id is krate-local.",57,{"inputs":[{"name":"defid"}],"output":{"name":"u32"}}],[11,"fmt","","",58,{"inputs":[{"name":"typarambound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",58,null],[11,"decode","","",58,{"inputs":[{"name":"typarambound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",58,{"inputs":[{"name":"typarambound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",58,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"typarambound"},{"name":"typarambound"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"typarambound"}],"output":{"name":"typarambound"}}],[11,"fmt","","",59,{"inputs":[{"name":"traitboundmodifier"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",59,null],[11,"decode","","",59,{"inputs":[{"name":"traitboundmodifier"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",59,{"inputs":[{"name":"traitboundmodifier"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",59,{"inputs":[{"name":"traitboundmodifier"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"traitboundmodifier"},{"name":"traitboundmodifier"}],"output":{"name":"bool"}}],[11,"clone","","",59,{"inputs":[{"name":"traitboundmodifier"}],"output":{"name":"traitboundmodifier"}}],[11,"fmt","","",60,{"inputs":[{"name":"typaram"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",60,null],[11,"decode","","",60,{"inputs":[{"name":"typaram"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",60,{"inputs":[{"name":"typaram"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",60,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"ne","","",60,{"inputs":[{"name":"typaram"},{"name":"typaram"}],"output":{"name":"bool"}}],[11,"clone","","",60,{"inputs":[{"name":"typaram"}],"output":{"name":"typaram"}}],[11,"fmt","","",37,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",37,null],[11,"decode","","",37,{"inputs":[{"name":"generics"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",37,{"inputs":[{"name":"generics"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",37,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"generics"},{"name":"generics"}],"output":{"name":"bool"}}],[11,"clone","","",37,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_lt_parameterized","","",37,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"is_type_parameterized","","",37,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"is_parameterized","","",37,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"fmt","","",38,{"inputs":[{"name":"whereclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",38,null],[11,"decode","","",38,{"inputs":[{"name":"whereclause"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",38,{"inputs":[{"name":"whereclause"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",38,{"inputs":[{"name":"whereclause"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"whereclause"},{"name":"whereclause"}],"output":{"name":"bool"}}],[11,"clone","","",38,{"inputs":[{"name":"whereclause"}],"output":{"name":"whereclause"}}],[11,"fmt","","",61,{"inputs":[{"name":"wherepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",61,null],[11,"decode","","",61,{"inputs":[{"name":"wherepredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",61,{"inputs":[{"name":"wherepredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",61,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",61,{"inputs":[{"name":"wherepredicate"},{"name":"wherepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",61,{"inputs":[{"name":"wherepredicate"}],"output":{"name":"wherepredicate"}}],[11,"fmt","","",62,{"inputs":[{"name":"whereboundpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",62,null],[11,"decode","","",62,{"inputs":[{"name":"whereboundpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",62,{"inputs":[{"name":"whereboundpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",62,{"inputs":[{"name":"whereboundpredicate"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",62,{"inputs":[{"name":"whereboundpredicate"},{"name":"whereboundpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",62,{"inputs":[{"name":"whereboundpredicate"}],"output":{"name":"whereboundpredicate"}}],[11,"fmt","","",63,{"inputs":[{"name":"whereregionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",63,null],[11,"decode","","",63,{"inputs":[{"name":"whereregionpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",63,{"inputs":[{"name":"whereregionpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",63,{"inputs":[{"name":"whereregionpredicate"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",63,{"inputs":[{"name":"whereregionpredicate"},{"name":"whereregionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",63,{"inputs":[{"name":"whereregionpredicate"}],"output":{"name":"whereregionpredicate"}}],[11,"fmt","","",64,{"inputs":[{"name":"whereeqpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",64,null],[11,"decode","","",64,{"inputs":[{"name":"whereeqpredicate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",64,{"inputs":[{"name":"whereeqpredicate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",64,{"inputs":[{"name":"whereeqpredicate"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",64,{"inputs":[{"name":"whereeqpredicate"},{"name":"whereeqpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",64,{"inputs":[{"name":"whereeqpredicate"}],"output":{"name":"whereeqpredicate"}}],[11,"fmt","","",65,{"inputs":[{"name":"crate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",65,null],[11,"decode","","",65,{"inputs":[{"name":"crate"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",65,{"inputs":[{"name":"crate"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",65,{"inputs":[{"name":"crate"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"crate"},{"name":"crate"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"crate"}],"output":{"name":"crate"}}],[11,"fmt","","",66,{"inputs":[{"name":"metaitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",66,null],[11,"decode","","",66,{"inputs":[{"name":"metaitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",66,{"inputs":[{"name":"metaitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",66,{"inputs":[{"name":"metaitem_"}],"output":{"name":"metaitem_"}}],[11,"eq","","",66,{"inputs":[{"name":"metaitem_"},{"name":"metaitem_"}],"output":{"name":"bool"}}],[11,"fmt","","",35,{"inputs":[{"name":"block"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",35,null],[11,"decode","","",35,{"inputs":[{"name":"block"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",35,{"inputs":[{"name":"block"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",35,{"inputs":[{"name":"block"},{"name":"block"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"block"},{"name":"block"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"block"}],"output":{"name":"block"}}],[11,"fmt","","",67,{"inputs":[{"name":"pat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",67,null],[11,"decode","","",67,{"inputs":[{"name":"pat"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",67,{"inputs":[{"name":"pat"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",67,{"inputs":[{"name":"pat"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"pat"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"pat"}],"output":{"name":"pat"}}],[11,"fmt","","",68,{"inputs":[{"name":"fieldpat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",68,null],[11,"decode","","",68,{"inputs":[{"name":"fieldpat"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",68,{"inputs":[{"name":"fieldpat"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",68,{"inputs":[{"name":"fieldpat"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"fieldpat"},{"name":"fieldpat"}],"output":{"name":"bool"}}],[11,"clone","","",68,{"inputs":[{"name":"fieldpat"}],"output":{"name":"fieldpat"}}],[11,"fmt","","",69,{"inputs":[{"name":"bindingmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",69,null],[11,"decode","","",69,{"inputs":[{"name":"bindingmode"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",69,{"inputs":[{"name":"bindingmode"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",69,{"inputs":[{"name":"bindingmode"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"ne","","",69,{"inputs":[{"name":"bindingmode"},{"name":"bindingmode"}],"output":{"name":"bool"}}],[11,"clone","","",69,{"inputs":[{"name":"bindingmode"}],"output":{"name":"bindingmode"}}],[11,"fmt","","",70,{"inputs":[{"name":"patwildkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",70,null],[11,"decode","","",70,{"inputs":[{"name":"patwildkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",70,{"inputs":[{"name":"patwildkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",70,{"inputs":[{"name":"patwildkind"},{"name":"patwildkind"}],"output":{"name":"bool"}}],[11,"ne","","",70,{"inputs":[{"name":"patwildkind"},{"name":"patwildkind"}],"output":{"name":"bool"}}],[11,"clone","","",70,{"inputs":[{"name":"patwildkind"}],"output":{"name":"patwildkind"}}],[11,"fmt","","",71,{"inputs":[{"name":"pat_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",71,null],[11,"decode","","",71,{"inputs":[{"name":"pat_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",71,{"inputs":[{"name":"pat_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"pat_"},{"name":"pat_"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"pat_"},{"name":"pat_"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"pat_"}],"output":{"name":"pat_"}}],[11,"fmt","","",72,{"inputs":[{"name":"mutability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",72,null],[11,"decode","","",72,{"inputs":[{"name":"mutability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",72,{"inputs":[{"name":"mutability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"mutability"},{"name":"mutability"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"mutability"}],"output":{"name":"mutability"}}],[11,"fmt","","",73,{"inputs":[{"name":"binop_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",73,null],[11,"decode","","",73,{"inputs":[{"name":"binop_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",73,{"inputs":[{"name":"binop_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"binop_"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"binop_"},{"name":"binop_"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"binop_"}],"output":{"name":"binop_"}}],[11,"fmt","","",74,{"inputs":[{"name":"unop"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",74,null],[11,"decode","","",74,{"inputs":[{"name":"unop"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",74,{"inputs":[{"name":"unop"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"unop"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"unop"},{"name":"unop"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"unop"}],"output":{"name":"unop"}}],[11,"fmt","","",75,{"inputs":[{"name":"stmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",75,null],[11,"decode","","",75,{"inputs":[{"name":"stmt_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",75,{"inputs":[{"name":"stmt_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"stmt_"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"stmt_"},{"name":"stmt_"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"stmt_"}],"output":{"name":"stmt_"}}],[11,"fmt","","",76,{"inputs":[{"name":"macstmtstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",76,null],[11,"decode","","",76,{"inputs":[{"name":"macstmtstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",76,{"inputs":[{"name":"macstmtstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",76,{"inputs":[{"name":"macstmtstyle"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"macstmtstyle"},{"name":"macstmtstyle"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"macstmtstyle"}],"output":{"name":"macstmtstyle"}}],[11,"fmt","","",77,{"inputs":[{"name":"localsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",77,null],[11,"decode","","",77,{"inputs":[{"name":"localsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",77,{"inputs":[{"name":"localsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",77,{"inputs":[{"name":"localsource"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"ne","","",77,{"inputs":[{"name":"localsource"},{"name":"localsource"}],"output":{"name":"bool"}}],[11,"clone","","",77,{"inputs":[{"name":"localsource"}],"output":{"name":"localsource"}}],[11,"fmt","","",78,{"inputs":[{"name":"local"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",78,null],[11,"decode","","",78,{"inputs":[{"name":"local"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",78,{"inputs":[{"name":"local"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",78,{"inputs":[{"name":"local"},{"name":"local"}],"output":{"name":"bool"}}],[11,"ne","","",78,{"inputs":[{"name":"local"},{"name":"local"}],"output":{"name":"bool"}}],[11,"clone","","",78,{"inputs":[{"name":"local"}],"output":{"name":"local"}}],[11,"fmt","","",79,{"inputs":[{"name":"decl_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",79,null],[11,"decode","","",79,{"inputs":[{"name":"decl_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",79,{"inputs":[{"name":"decl_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",79,{"inputs":[{"name":"decl_"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"decl_"},{"name":"decl_"}],"output":{"name":"bool"}}],[11,"clone","","",79,{"inputs":[{"name":"decl_"}],"output":{"name":"decl_"}}],[11,"fmt","","",40,{"inputs":[{"name":"arm"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",40,null],[11,"decode","","",40,{"inputs":[{"name":"arm"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",40,{"inputs":[{"name":"arm"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",40,{"inputs":[{"name":"arm"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"ne","","",40,{"inputs":[{"name":"arm"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"clone","","",40,{"inputs":[{"name":"arm"}],"output":{"name":"arm"}}],[11,"fmt","","",80,{"inputs":[{"name":"field"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",80,null],[11,"decode","","",80,{"inputs":[{"name":"field"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",80,{"inputs":[{"name":"field"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",80,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",80,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",80,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",81,{"inputs":[{"name":"blockcheckmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",81,null],[11,"decode","","",81,{"inputs":[{"name":"blockcheckmode"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",81,{"inputs":[{"name":"blockcheckmode"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",81,{"inputs":[{"name":"blockcheckmode"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"ne","","",81,{"inputs":[{"name":"blockcheckmode"},{"name":"blockcheckmode"}],"output":{"name":"bool"}}],[11,"clone","","",81,{"inputs":[{"name":"blockcheckmode"}],"output":{"name":"blockcheckmode"}}],[11,"fmt","","",82,{"inputs":[{"name":"unsafesource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",82,null],[11,"decode","","",82,{"inputs":[{"name":"unsafesource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",82,{"inputs":[{"name":"unsafesource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",82,{"inputs":[{"name":"unsafesource"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"unsafesource"},{"name":"unsafesource"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"unsafesource"}],"output":{"name":"unsafesource"}}],[11,"fmt","","",83,{"inputs":[{"name":"expr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",83,null],[11,"decode","","",83,{"inputs":[{"name":"expr"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",83,{"inputs":[{"name":"expr"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",83,{"inputs":[{"name":"expr"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"expr"},{"name":"expr"}],"output":{"name":"bool"}}],[11,"clone","","",83,{"inputs":[{"name":"expr"}],"output":{"name":"expr"}}],[11,"fmt","","",84,{"inputs":[{"name":"expr_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",84,null],[11,"decode","","",84,{"inputs":[{"name":"expr_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",84,{"inputs":[{"name":"expr_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",84,{"inputs":[{"name":"expr_"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"ne","","",84,{"inputs":[{"name":"expr_"},{"name":"expr_"}],"output":{"name":"bool"}}],[11,"clone","","",84,{"inputs":[{"name":"expr_"}],"output":{"name":"expr_"}}],[11,"fmt","","",85,{"inputs":[{"name":"qself"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",85,null],[11,"decode","","",85,{"inputs":[{"name":"qself"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",85,{"inputs":[{"name":"qself"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",85,{"inputs":[{"name":"qself"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"ne","","",85,{"inputs":[{"name":"qself"},{"name":"qself"}],"output":{"name":"bool"}}],[11,"clone","","",85,{"inputs":[{"name":"qself"}],"output":{"name":"qself"}}],[11,"fmt","","",86,{"inputs":[{"name":"matchsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",86,null],[11,"decode","","",86,{"inputs":[{"name":"matchsource"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",86,{"inputs":[{"name":"matchsource"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",86,{"inputs":[{"name":"matchsource"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"ne","","",86,{"inputs":[{"name":"matchsource"},{"name":"matchsource"}],"output":{"name":"bool"}}],[11,"clone","","",86,{"inputs":[{"name":"matchsource"}],"output":{"name":"matchsource"}}],[11,"fmt","","",87,{"inputs":[{"name":"captureclause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",87,null],[11,"decode","","",87,{"inputs":[{"name":"captureclause"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",87,{"inputs":[{"name":"captureclause"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",87,{"inputs":[{"name":"captureclause"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"ne","","",87,{"inputs":[{"name":"captureclause"},{"name":"captureclause"}],"output":{"name":"bool"}}],[11,"clone","","",87,{"inputs":[{"name":"captureclause"}],"output":{"name":"captureclause"}}],[11,"fmt","","",88,{"inputs":[{"name":"delimited"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",88,null],[11,"decode","","",88,{"inputs":[{"name":"delimited"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",88,{"inputs":[{"name":"delimited"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",88,{"inputs":[{"name":"delimited"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"ne","","",88,{"inputs":[{"name":"delimited"},{"name":"delimited"}],"output":{"name":"bool"}}],[11,"clone","","",88,{"inputs":[{"name":"delimited"}],"output":{"name":"delimited"}}],[11,"open_token","","Returns the opening delimiter as a token.",88,{"inputs":[{"name":"delimited"}],"output":{"name":"token"}}],[11,"close_token","","Returns the closing delimiter as a token.",88,{"inputs":[{"name":"delimited"}],"output":{"name":"token"}}],[11,"open_tt","","Returns the opening delimiter as a token tree.",88,{"inputs":[{"name":"delimited"}],"output":{"name":"tokentree"}}],[11,"close_tt","","Returns the closing delimiter as a token tree.",88,{"inputs":[{"name":"delimited"}],"output":{"name":"tokentree"}}],[11,"fmt","","",89,{"inputs":[{"name":"sequencerepetition"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",89,null],[11,"decode","","",89,{"inputs":[{"name":"sequencerepetition"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",89,{"inputs":[{"name":"sequencerepetition"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",89,{"inputs":[{"name":"sequencerepetition"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"ne","","",89,{"inputs":[{"name":"sequencerepetition"},{"name":"sequencerepetition"}],"output":{"name":"bool"}}],[11,"clone","","",89,{"inputs":[{"name":"sequencerepetition"}],"output":{"name":"sequencerepetition"}}],[11,"fmt","","",90,{"inputs":[{"name":"kleeneop"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",90,null],[11,"decode","","",90,{"inputs":[{"name":"kleeneop"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",90,{"inputs":[{"name":"kleeneop"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",90,{"inputs":[{"name":"kleeneop"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"ne","","",90,{"inputs":[{"name":"kleeneop"},{"name":"kleeneop"}],"output":{"name":"bool"}}],[11,"clone","","",90,{"inputs":[{"name":"kleeneop"}],"output":{"name":"kleeneop"}}],[11,"fmt","","",28,{"inputs":[{"name":"tokentree"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",28,null],[11,"decode","","",28,{"inputs":[{"name":"tokentree"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",28,{"inputs":[{"name":"tokentree"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",28,{"inputs":[{"name":"tokentree"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"ne","","",28,{"inputs":[{"name":"tokentree"},{"name":"tokentree"}],"output":{"name":"bool"}}],[11,"clone","","",28,{"inputs":[{"name":"tokentree"}],"output":{"name":"tokentree"}}],[11,"len","","",28,{"inputs":[{"name":"tokentree"}],"output":{"name":"usize"}}],[11,"get_tt","","",28,{"inputs":[{"name":"tokentree"},{"name":"usize"}],"output":{"name":"tokentree"}}],[11,"get_span","","Returns the `Span` corresponding to this token tree.",28,{"inputs":[{"name":"tokentree"}],"output":{"name":"span"}}],[11,"parse","","Use this token tree as a matcher to parse given tts.",28,null],[11,"fmt","","",91,{"inputs":[{"name":"mac_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",91,null],[11,"decode","","",91,{"inputs":[{"name":"mac_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",91,{"inputs":[{"name":"mac_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",91,{"inputs":[{"name":"mac_"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"ne","","",91,{"inputs":[{"name":"mac_"},{"name":"mac_"}],"output":{"name":"bool"}}],[11,"clone","","",91,{"inputs":[{"name":"mac_"}],"output":{"name":"mac_"}}],[11,"fmt","","",92,{"inputs":[{"name":"strstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",92,null],[11,"decode","","",92,{"inputs":[{"name":"strstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",92,{"inputs":[{"name":"strstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",92,{"inputs":[{"name":"strstyle"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"ne","","",92,{"inputs":[{"name":"strstyle"},{"name":"strstyle"}],"output":{"name":"bool"}}],[11,"clone","","",92,{"inputs":[{"name":"strstyle"}],"output":{"name":"strstyle"}}],[11,"fmt","","",93,{"inputs":[{"name":"sign"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",93,null],[11,"decode","","",93,{"inputs":[{"name":"sign"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",93,{"inputs":[{"name":"sign"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",93,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"ne","","",93,{"inputs":[{"name":"sign"},{"name":"sign"}],"output":{"name":"bool"}}],[11,"clone","","",93,{"inputs":[{"name":"sign"}],"output":{"name":"sign"}}],[11,"new","","",93,{"inputs":[{"name":"sign"},{"name":"t"}],"output":{"name":"sign"}}],[11,"fmt","","",94,{"inputs":[{"name":"litinttype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",94,null],[11,"decode","","",94,{"inputs":[{"name":"litinttype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",94,{"inputs":[{"name":"litinttype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",94,{"inputs":[{"name":"litinttype"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"ne","","",94,{"inputs":[{"name":"litinttype"},{"name":"litinttype"}],"output":{"name":"bool"}}],[11,"clone","","",94,{"inputs":[{"name":"litinttype"}],"output":{"name":"litinttype"}}],[11,"suffix_len","","",94,{"inputs":[{"name":"litinttype"}],"output":{"name":"usize"}}],[11,"fmt","","",95,{"inputs":[{"name":"lit_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",95,null],[11,"decode","","",95,{"inputs":[{"name":"lit_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",95,{"inputs":[{"name":"lit_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",95,{"inputs":[{"name":"lit_"},{"name":"lit_"}],"output":{"name":"bool"}}],[11,"ne","","",95,{"inputs":[{"name":"lit_"},{"name":"lit_"}],"output":{"name":"bool"}}],[11,"clone","","",95,{"inputs":[{"name":"lit_"}],"output":{"name":"lit_"}}],[11,"fmt","","",96,{"inputs":[{"name":"mutty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",96,null],[11,"decode","","",96,{"inputs":[{"name":"mutty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",96,{"inputs":[{"name":"mutty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",96,{"inputs":[{"name":"mutty"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"ne","","",96,{"inputs":[{"name":"mutty"},{"name":"mutty"}],"output":{"name":"bool"}}],[11,"clone","","",96,{"inputs":[{"name":"mutty"}],"output":{"name":"mutty"}}],[11,"fmt","","",97,{"inputs":[{"name":"typefield"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",97,null],[11,"decode","","",97,{"inputs":[{"name":"typefield"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",97,{"inputs":[{"name":"typefield"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",97,{"inputs":[{"name":"typefield"},{"name":"typefield"}],"output":{"name":"bool"}}],[11,"ne","","",97,{"inputs":[{"name":"typefield"},{"name":"typefield"}],"output":{"name":"bool"}}],[11,"clone","","",97,{"inputs":[{"name":"typefield"}],"output":{"name":"typefield"}}],[11,"fmt","","",98,{"inputs":[{"name":"methodsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",98,null],[11,"decode","","",98,{"inputs":[{"name":"methodsig"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",98,{"inputs":[{"name":"methodsig"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",98,{"inputs":[{"name":"methodsig"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"ne","","",98,{"inputs":[{"name":"methodsig"},{"name":"methodsig"}],"output":{"name":"bool"}}],[11,"clone","","",98,{"inputs":[{"name":"methodsig"}],"output":{"name":"methodsig"}}],[11,"fmt","","",99,{"inputs":[{"name":"traititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",99,null],[11,"decode","","",99,{"inputs":[{"name":"traititem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",99,{"inputs":[{"name":"traititem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",99,{"inputs":[{"name":"traititem"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"traititem"},{"name":"traititem"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"traititem"}],"output":{"name":"traititem"}}],[11,"fmt","","",100,{"inputs":[{"name":"traititem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",100,null],[11,"decode","","",100,{"inputs":[{"name":"traititem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",100,{"inputs":[{"name":"traititem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",100,{"inputs":[{"name":"traititem_"},{"name":"traititem_"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"traititem_"},{"name":"traititem_"}],"output":{"name":"bool"}}],[11,"clone","","",100,{"inputs":[{"name":"traititem_"}],"output":{"name":"traititem_"}}],[11,"fmt","","",101,{"inputs":[{"name":"implitem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",101,null],[11,"decode","","",101,{"inputs":[{"name":"implitem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",101,{"inputs":[{"name":"implitem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",101,{"inputs":[{"name":"implitem"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"implitem"},{"name":"implitem"}],"output":{"name":"bool"}}],[11,"clone","","",101,{"inputs":[{"name":"implitem"}],"output":{"name":"implitem"}}],[11,"fmt","","",102,{"inputs":[{"name":"implitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",102,null],[11,"decode","","",102,{"inputs":[{"name":"implitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",102,{"inputs":[{"name":"implitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",102,{"inputs":[{"name":"implitem_"},{"name":"implitem_"}],"output":{"name":"bool"}}],[11,"ne","","",102,{"inputs":[{"name":"implitem_"},{"name":"implitem_"}],"output":{"name":"bool"}}],[11,"clone","","",102,{"inputs":[{"name":"implitem_"}],"output":{"name":"implitem_"}}],[11,"hash","","",103,null],[11,"decode","","",103,{"inputs":[{"name":"intty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",103,{"inputs":[{"name":"intty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",103,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",103,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",103,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",103,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"suffix_len","","",103,{"inputs":[{"name":"intty"}],"output":{"name":"usize"}}],[11,"hash","","",104,null],[11,"decode","","",104,{"inputs":[{"name":"uintty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",104,{"inputs":[{"name":"uintty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",104,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",104,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"suffix_len","","",104,{"inputs":[{"name":"uintty"}],"output":{"name":"usize"}}],[11,"fmt","","",104,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",104,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",105,null],[11,"decode","","",105,{"inputs":[{"name":"floatty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",105,{"inputs":[{"name":"floatty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",105,{"inputs":[{"name":"floatty"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"floatty"},{"name":"floatty"}],"output":{"name":"bool"}}],[11,"clone","","",105,{"inputs":[{"name":"floatty"}],"output":{"name":"floatty"}}],[11,"fmt","","",105,{"inputs":[{"name":"floatty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",105,{"inputs":[{"name":"floatty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"suffix_len","","",105,{"inputs":[{"name":"floatty"}],"output":{"name":"usize"}}],[11,"fmt","","",106,{"inputs":[{"name":"typebinding"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",106,null],[11,"decode","","",106,{"inputs":[{"name":"typebinding"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",106,{"inputs":[{"name":"typebinding"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",106,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"ne","","",106,{"inputs":[{"name":"typebinding"},{"name":"typebinding"}],"output":{"name":"bool"}}],[11,"clone","","",106,{"inputs":[{"name":"typebinding"}],"output":{"name":"typebinding"}}],[11,"fmt","","",34,{"inputs":[{"name":"ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",34,null],[11,"decode","","",34,{"inputs":[{"name":"ty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"ty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",34,{"inputs":[{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"ty"},{"name":"ty"}],"output":{"name":"bool"}}],[11,"clone","","",34,{"inputs":[{"name":"ty"}],"output":{"name":"ty"}}],[11,"fmt","","",107,{"inputs":[{"name":"primty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",107,null],[11,"decode","","",107,{"inputs":[{"name":"primty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",107,{"inputs":[{"name":"primty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",107,{"inputs":[{"name":"primty"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"ne","","",107,{"inputs":[{"name":"primty"},{"name":"primty"}],"output":{"name":"bool"}}],[11,"clone","","",107,{"inputs":[{"name":"primty"}],"output":{"name":"primty"}}],[11,"fmt","","",108,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",108,null],[11,"decode","","",108,{"inputs":[{"name":"barefnty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",108,{"inputs":[{"name":"barefnty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",108,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",108,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",108,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",109,{"inputs":[{"name":"ty_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",109,null],[11,"decode","","",109,{"inputs":[{"name":"ty_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",109,{"inputs":[{"name":"ty_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",109,{"inputs":[{"name":"ty_"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"ne","","",109,{"inputs":[{"name":"ty_"},{"name":"ty_"}],"output":{"name":"bool"}}],[11,"clone","","",109,{"inputs":[{"name":"ty_"}],"output":{"name":"ty_"}}],[11,"fmt","","",110,{"inputs":[{"name":"asmdialect"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",110,null],[11,"decode","","",110,{"inputs":[{"name":"asmdialect"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",110,{"inputs":[{"name":"asmdialect"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",110,{"inputs":[{"name":"asmdialect"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"ne","","",110,{"inputs":[{"name":"asmdialect"},{"name":"asmdialect"}],"output":{"name":"bool"}}],[11,"clone","","",110,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"fmt","","",111,{"inputs":[{"name":"inlineasm"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",111,null],[11,"decode","","",111,{"inputs":[{"name":"inlineasm"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",111,{"inputs":[{"name":"inlineasm"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",111,{"inputs":[{"name":"inlineasm"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"ne","","",111,{"inputs":[{"name":"inlineasm"},{"name":"inlineasm"}],"output":{"name":"bool"}}],[11,"clone","","",111,{"inputs":[{"name":"inlineasm"}],"output":{"name":"inlineasm"}}],[11,"fmt","","",36,{"inputs":[{"name":"arg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",36,null],[11,"decode","","",36,{"inputs":[{"name":"arg"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",36,{"inputs":[{"name":"arg"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"arg"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"arg"},{"name":"arg"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"arg"}],"output":{"name":"arg"}}],[11,"new_self","","",36,{"inputs":[{"name":"arg"},{"name":"span"},{"name":"mutability"},{"name":"ident"}],"output":{"name":"arg"}}],[11,"fmt","","",112,{"inputs":[{"name":"fndecl"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",112,null],[11,"decode","","",112,{"inputs":[{"name":"fndecl"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",112,{"inputs":[{"name":"fndecl"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",112,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"ne","","",112,{"inputs":[{"name":"fndecl"},{"name":"fndecl"}],"output":{"name":"bool"}}],[11,"clone","","",112,{"inputs":[{"name":"fndecl"}],"output":{"name":"fndecl"}}],[11,"fmt","","",113,{"inputs":[{"name":"unsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",113,null],[11,"decode","","",113,{"inputs":[{"name":"unsafety"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",113,{"inputs":[{"name":"unsafety"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",113,{"inputs":[{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"ne","","",113,{"inputs":[{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"bool"}}],[11,"clone","","",113,{"inputs":[{"name":"unsafety"}],"output":{"name":"unsafety"}}],[11,"fmt","","",113,{"inputs":[{"name":"unsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",114,null],[11,"decode","","",114,{"inputs":[{"name":"implpolarity"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",114,{"inputs":[{"name":"implpolarity"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",114,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"ne","","",114,{"inputs":[{"name":"implpolarity"},{"name":"implpolarity"}],"output":{"name":"bool"}}],[11,"clone","","",114,{"inputs":[{"name":"implpolarity"}],"output":{"name":"implpolarity"}}],[11,"fmt","","",114,{"inputs":[{"name":"implpolarity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",115,{"inputs":[{"name":"functionretty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",115,null],[11,"decode","","",115,{"inputs":[{"name":"functionretty"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",115,{"inputs":[{"name":"functionretty"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",115,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"ne","","",115,{"inputs":[{"name":"functionretty"},{"name":"functionretty"}],"output":{"name":"bool"}}],[11,"clone","","",115,{"inputs":[{"name":"functionretty"}],"output":{"name":"functionretty"}}],[11,"span","","",115,{"inputs":[{"name":"functionretty"}],"output":{"name":"span"}}],[11,"fmt","","",116,{"inputs":[{"name":"explicitself_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",116,null],[11,"decode","","",116,{"inputs":[{"name":"explicitself_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",116,{"inputs":[{"name":"explicitself_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",116,{"inputs":[{"name":"explicitself_"},{"name":"explicitself_"}],"output":{"name":"bool"}}],[11,"ne","","",116,{"inputs":[{"name":"explicitself_"},{"name":"explicitself_"}],"output":{"name":"bool"}}],[11,"clone","","",116,{"inputs":[{"name":"explicitself_"}],"output":{"name":"explicitself_"}}],[11,"fmt","","",117,{"inputs":[{"name":"mod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",117,null],[11,"decode","","",117,{"inputs":[{"name":"mod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",117,{"inputs":[{"name":"mod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",117,{"inputs":[{"name":"mod"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"ne","","",117,{"inputs":[{"name":"mod"},{"name":"mod"}],"output":{"name":"bool"}}],[11,"clone","","",117,{"inputs":[{"name":"mod"}],"output":{"name":"mod"}}],[11,"fmt","","",118,{"inputs":[{"name":"foreignmod"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",118,null],[11,"decode","","",118,{"inputs":[{"name":"foreignmod"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",118,{"inputs":[{"name":"foreignmod"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",118,{"inputs":[{"name":"foreignmod"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"ne","","",118,{"inputs":[{"name":"foreignmod"},{"name":"foreignmod"}],"output":{"name":"bool"}}],[11,"clone","","",118,{"inputs":[{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fmt","","",119,{"inputs":[{"name":"variantarg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",119,null],[11,"decode","","",119,{"inputs":[{"name":"variantarg"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",119,{"inputs":[{"name":"variantarg"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",119,{"inputs":[{"name":"variantarg"},{"name":"variantarg"}],"output":{"name":"bool"}}],[11,"ne","","",119,{"inputs":[{"name":"variantarg"},{"name":"variantarg"}],"output":{"name":"bool"}}],[11,"clone","","",119,{"inputs":[{"name":"variantarg"}],"output":{"name":"variantarg"}}],[11,"fmt","","",120,{"inputs":[{"name":"variantkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",120,null],[11,"decode","","",120,{"inputs":[{"name":"variantkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",120,{"inputs":[{"name":"variantkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",120,{"inputs":[{"name":"variantkind"},{"name":"variantkind"}],"output":{"name":"bool"}}],[11,"ne","","",120,{"inputs":[{"name":"variantkind"},{"name":"variantkind"}],"output":{"name":"bool"}}],[11,"clone","","",120,{"inputs":[{"name":"variantkind"}],"output":{"name":"variantkind"}}],[11,"fmt","","",121,{"inputs":[{"name":"enumdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",121,null],[11,"decode","","",121,{"inputs":[{"name":"enumdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",121,{"inputs":[{"name":"enumdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",121,{"inputs":[{"name":"enumdef"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"ne","","",121,{"inputs":[{"name":"enumdef"},{"name":"enumdef"}],"output":{"name":"bool"}}],[11,"clone","","",121,{"inputs":[{"name":"enumdef"}],"output":{"name":"enumdef"}}],[11,"fmt","","",122,{"inputs":[{"name":"variant_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",122,null],[11,"decode","","",122,{"inputs":[{"name":"variant_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",122,{"inputs":[{"name":"variant_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",122,{"inputs":[{"name":"variant_"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"ne","","",122,{"inputs":[{"name":"variant_"},{"name":"variant_"}],"output":{"name":"bool"}}],[11,"clone","","",122,{"inputs":[{"name":"variant_"}],"output":{"name":"variant_"}}],[11,"fmt","","",123,{"inputs":[{"name":"pathlistitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",123,null],[11,"decode","","",123,{"inputs":[{"name":"pathlistitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",123,{"inputs":[{"name":"pathlistitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",123,{"inputs":[{"name":"pathlistitem_"},{"name":"pathlistitem_"}],"output":{"name":"bool"}}],[11,"ne","","",123,{"inputs":[{"name":"pathlistitem_"},{"name":"pathlistitem_"}],"output":{"name":"bool"}}],[11,"clone","","",123,{"inputs":[{"name":"pathlistitem_"}],"output":{"name":"pathlistitem_"}}],[11,"id","","",123,{"inputs":[{"name":"pathlistitem_"}],"output":{"name":"u32"}}],[11,"fmt","","",124,{"inputs":[{"name":"viewpath_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",124,null],[11,"decode","","",124,{"inputs":[{"name":"viewpath_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",124,{"inputs":[{"name":"viewpath_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",124,{"inputs":[{"name":"viewpath_"},{"name":"viewpath_"}],"output":{"name":"bool"}}],[11,"ne","","",124,{"inputs":[{"name":"viewpath_"},{"name":"viewpath_"}],"output":{"name":"bool"}}],[11,"clone","","",124,{"inputs":[{"name":"viewpath_"}],"output":{"name":"viewpath_"}}],[11,"fmt","","",125,{"inputs":[{"name":"attrstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",125,null],[11,"decode","","",125,{"inputs":[{"name":"attrstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",125,{"inputs":[{"name":"attrstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",125,{"inputs":[{"name":"attrstyle"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"attrstyle"},{"name":"attrstyle"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"attrstyle"}],"output":{"name":"attrstyle"}}],[11,"fmt","","",126,{"inputs":[{"name":"attrid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",126,null],[11,"decode","","",126,{"inputs":[{"name":"attrid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",126,{"inputs":[{"name":"attrid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",126,{"inputs":[{"name":"attrid"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"attrid"},{"name":"attrid"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"attrid"}],"output":{"name":"attrid"}}],[11,"fmt","","",41,{"inputs":[{"name":"attribute_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",41,null],[11,"decode","","",41,{"inputs":[{"name":"attribute_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",41,{"inputs":[{"name":"attribute_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",41,{"inputs":[{"name":"attribute_"},{"name":"attribute_"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"attribute_"},{"name":"attribute_"}],"output":{"name":"bool"}}],[11,"clone","","",41,{"inputs":[{"name":"attribute_"}],"output":{"name":"attribute_"}}],[11,"fmt","","",127,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",127,null],[11,"decode","","",127,{"inputs":[{"name":"traitref"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",127,{"inputs":[{"name":"traitref"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",127,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"fmt","","",128,{"inputs":[{"name":"polytraitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",128,null],[11,"decode","","",128,{"inputs":[{"name":"polytraitref"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",128,{"inputs":[{"name":"polytraitref"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",128,{"inputs":[{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"ne","","",128,{"inputs":[{"name":"polytraitref"},{"name":"polytraitref"}],"output":{"name":"bool"}}],[11,"clone","","",128,{"inputs":[{"name":"polytraitref"}],"output":{"name":"polytraitref"}}],[11,"fmt","","",129,{"inputs":[{"name":"visibility"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",129,null],[11,"decode","","",129,{"inputs":[{"name":"visibility"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",129,{"inputs":[{"name":"visibility"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",129,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"bool"}}],[11,"clone","","",129,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"inherit_from","","",129,{"inputs":[{"name":"visibility"},{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"fmt","","",130,{"inputs":[{"name":"structfield_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",130,null],[11,"decode","","",130,{"inputs":[{"name":"structfield_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",130,{"inputs":[{"name":"structfield_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",130,{"inputs":[{"name":"structfield_"},{"name":"structfield_"}],"output":{"name":"bool"}}],[11,"ne","","",130,{"inputs":[{"name":"structfield_"},{"name":"structfield_"}],"output":{"name":"bool"}}],[11,"clone","","",130,{"inputs":[{"name":"structfield_"}],"output":{"name":"structfield_"}}],[11,"ident","","",130,{"inputs":[{"name":"structfield_"}],"output":{"name":"option"}}],[11,"fmt","","",131,{"inputs":[{"name":"structfieldkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",131,null],[11,"decode","","",131,{"inputs":[{"name":"structfieldkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",131,{"inputs":[{"name":"structfieldkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",131,{"inputs":[{"name":"structfieldkind"},{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"ne","","",131,{"inputs":[{"name":"structfieldkind"},{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"clone","","",131,{"inputs":[{"name":"structfieldkind"}],"output":{"name":"structfieldkind"}}],[11,"is_unnamed","","",131,{"inputs":[{"name":"structfieldkind"}],"output":{"name":"bool"}}],[11,"fmt","","",132,{"inputs":[{"name":"structdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",132,null],[11,"decode","","",132,{"inputs":[{"name":"structdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",132,{"inputs":[{"name":"structdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",132,{"inputs":[{"name":"structdef"},{"name":"structdef"}],"output":{"name":"bool"}}],[11,"ne","","",132,{"inputs":[{"name":"structdef"},{"name":"structdef"}],"output":{"name":"bool"}}],[11,"clone","","",132,{"inputs":[{"name":"structdef"}],"output":{"name":"structdef"}}],[11,"fmt","","",133,{"inputs":[{"name":"item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",133,null],[11,"decode","","",133,{"inputs":[{"name":"item"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",133,{"inputs":[{"name":"item"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",133,{"inputs":[{"name":"item"},{"name":"item"}],"output":{"name":"bool"}}],[11,"ne","","",133,{"inputs":[{"name":"item"},{"name":"item"}],"output":{"name":"bool"}}],[11,"clone","","",133,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[11,"fmt","","",134,{"inputs":[{"name":"item_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",134,null],[11,"decode","","",134,{"inputs":[{"name":"item_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",134,{"inputs":[{"name":"item_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",134,{"inputs":[{"name":"item_"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"ne","","",134,{"inputs":[{"name":"item_"},{"name":"item_"}],"output":{"name":"bool"}}],[11,"clone","","",134,{"inputs":[{"name":"item_"}],"output":{"name":"item_"}}],[11,"descriptive_variant","","",134,{"inputs":[{"name":"item_"}],"output":{"name":"str"}}],[11,"fmt","","",135,{"inputs":[{"name":"foreignitem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",135,null],[11,"decode","","",135,{"inputs":[{"name":"foreignitem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",135,{"inputs":[{"name":"foreignitem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",135,{"inputs":[{"name":"foreignitem"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"ne","","",135,{"inputs":[{"name":"foreignitem"},{"name":"foreignitem"}],"output":{"name":"bool"}}],[11,"clone","","",135,{"inputs":[{"name":"foreignitem"}],"output":{"name":"foreignitem"}}],[11,"fmt","","",136,{"inputs":[{"name":"foreignitem_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",136,null],[11,"decode","","",136,{"inputs":[{"name":"foreignitem_"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",136,{"inputs":[{"name":"foreignitem_"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",136,{"inputs":[{"name":"foreignitem_"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"ne","","",136,{"inputs":[{"name":"foreignitem_"},{"name":"foreignitem_"}],"output":{"name":"bool"}}],[11,"clone","","",136,{"inputs":[{"name":"foreignitem_"}],"output":{"name":"foreignitem_"}}],[11,"descriptive_variant","","",136,{"inputs":[{"name":"foreignitem_"}],"output":{"name":"str"}}],[11,"fmt","","",137,{"inputs":[{"name":"inlineditem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",137,null],[11,"decode","","",137,{"inputs":[{"name":"inlineditem"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",137,{"inputs":[{"name":"inlineditem"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",137,{"inputs":[{"name":"inlineditem"},{"name":"inlineditem"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"inlineditem"},{"name":"inlineditem"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"inlineditem"}],"output":{"name":"inlineditem"}}],[11,"fmt","","",138,{"inputs":[{"name":"macrodef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",138,null],[11,"decode","","",138,{"inputs":[{"name":"macrodef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",138,{"inputs":[{"name":"macrodef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",138,{"inputs":[{"name":"macrodef"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"macrodef"},{"name":"macrodef"}],"output":{"name":"bool"}}],[11,"clone","","",138,{"inputs":[{"name":"macrodef"}],"output":{"name":"macrodef"}}],[11,"hash","syntax::parse::parser","",139,null],[11,"cmp","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"option"}}],[11,"lt","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"le","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"gt","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ge","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"clone","","",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"eq","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"all","","Returns the set containing all flags.",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"bits","","Returns the raw value of the flags currently stored.",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",139,{"inputs":[{"name":"restrictions"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",139,{"inputs":[{"name":"restrictions"},{"name":"u8"}],"output":{"name":"restrictions"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",139,null],[11,"remove","","Removes the specified flags in-place.",139,null],[11,"toggle","","Toggles the specified flags in-place.",139,null],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"bitor","syntax::parse::parser","Returns the union of the two sets of flags.",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"bitxor","syntax::parse::parser","Returns the left flags, but with all the right flags toggled.",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"bitand","syntax::parse::parser","Returns the intersection between the two sets of flags.",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"sub","syntax::parse::parser","Returns the set difference of the two sets of flags.",139,{"inputs":[{"name":"restrictions"},{"name":"restrictions"}],"output":{"name":"restrictions"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"not","syntax::parse::parser","Returns the complement of this set of flags.",139,{"inputs":[{"name":"restrictions"}],"output":{"name":"restrictions"}}],[11,"eq","","",140,{"inputs":[{"name":"pathparsingmode"},{"name":"pathparsingmode"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"pathparsingmode"},{"name":"pathparsingmode"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"pathparsingmode"}],"output":{"name":"pathparsingmode"}}],[11,"eq","","",141,{"inputs":[{"name":"boundparsingmode"},{"name":"boundparsingmode"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"boundparsingmode"},{"name":"boundparsingmode"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"boundparsingmode"}],"output":{"name":"boundparsingmode"}}],[11,"clone","","",142,{"inputs":[{"name":"tokentype"}],"output":{"name":"tokentype"}}],[11,"eq","","",142,{"inputs":[{"name":"tokentype"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"tokentype"},{"name":"tokentype"}],"output":{"name":"bool"}}],[11,"new","","",143,{"inputs":[{"name":"parser"},{"name":"parsesess"},{"name":"vec"},{"name":"box"}],"output":{"name":"parser"}}],[11,"parse_expr","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_item","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"parse_pat","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_arm","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"arm"}}],[11,"parse_ty","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_stmt","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"token_to_string","","Convert a token to a string using self's reader",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"string"}}],[11,"this_token_to_string","","Convert the current token to a string using self's reader",143,{"inputs":[{"name":"parser"}],"output":{"name":"string"}}],[11,"unexpected_last","","",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"fatalerror"}}],[11,"unexpected","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"fatalerror"}}],[11,"expect","","Expect and consume the token t. Signal an error if\nthe next token is not t.",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"expect_one_of","","Expect next token to be edible or inedible token.  If edible,\nthen consume it; if inedible, then return without consuming\nanything.  Signal a fatal error if next token is unexpected.",143,null],[11,"check_for_erroneous_unit_struct_expecting","","Check for erroneous `ident { }`; if matches, signal error and\nrecover (without consuming any expected input token).  Returns\ntrue if and only if input was consumed for recovery.",143,null],[11,"commit_expr","","Commit to parsing a complete expression `e` expected to be\nfollowed by some token from the set edible + inedible.  Recover\nfrom anticipated input errors, discarding erroneous characters.",143,null],[11,"commit_expr_expecting","","",143,{"inputs":[{"name":"parser"},{"name":"expr"},{"name":"token"}],"output":{"name":"result"}}],[11,"commit_stmt","","Commit to parsing a complete statement `s`, which expects to be\nfollowed by some token from the set edible + inedible.  Check\nfor recoverable input errors, discarding erroneous characters.",143,null],[11,"commit_stmt_expecting","","",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"parse_ident","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ident_or_self_type","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path_list_item","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"check","","Check if the next token is `tok`, and return `true` if so.",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"bool"}}],[11,"eat","","Consume token 'tok' if it exists. Returns true if the given\ntoken was present, false otherwise.",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"check_keyword","","",143,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"eat_keyword","","If the next token is the given keyword, eat it and return\ntrue. Otherwise, return false.",143,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"result"}}],[11,"eat_keyword_noexpect","","",143,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"result"}}],[11,"expect_keyword","","If the given word is not a keyword, signal an error.\nIf the next token is not the given word, signal an error.\nOtherwise, eat it.",143,{"inputs":[{"name":"parser"},{"name":"keyword"}],"output":{"name":"result"}}],[11,"check_strict_keywords","","Signal an error if the given string is a strict keyword",143,null],[11,"check_reserved_keywords","","Signal an error if the current token is a reserved keyword",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"expect_no_suffix","","",143,null],[11,"expect_gt","","Expect and consume a GT. if a >> is seen, replace it\nwith a single > and continue. If a GT is not seen,\nsignal an error.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_seq_to_before_gt_or_return","","",143,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_before_gt","","Parse a sequence bracketed by '<' and '>', stopping\nbefore the '>'.",143,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_gt","","",143,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_gt_or_return","","",143,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_end","","Parse a sequence, including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",143,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq_to_before_end","","Parse a sequence, not including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",143,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_unspanned_seq","","Parse a sequence, including the closing delimiter. The function\nf must consume tokens until reaching the next separator or\nclosing bracket.",143,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_enum_variant_seq","","Parse a sequence parameter of enum variant. For consistency purposes,\nthese should not be empty.",143,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"parse_seq","","",143,{"inputs":[{"name":"parser"},{"name":"token"},{"name":"token"},{"name":"seqsep"},{"name":"f"}],"output":{"name":"result"}}],[11,"bump","","Advance the parser by one token",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"bump_and_get","","Advance the parser by one token and return the bumped token.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"replace_token","","EFFECT: replace the current token and span with the given one",143,null],[11,"buffer_length","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"isize"}}],[11,"look_ahead","","",143,{"inputs":[{"name":"parser"},{"name":"usize"},{"name":"f"}],"output":{"name":"r"}}],[11,"fatal","","",143,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal","","",143,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_help","","",143,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_note","","",143,null],[11,"span_help","","",143,null],[11,"fileline_help","","",143,null],[11,"bug","","",143,null],[11,"warn","","",143,null],[11,"span_warn","","",143,null],[11,"span_err","","",143,null],[11,"span_bug","","",143,null],[11,"abort_if_errors","","",143,null],[11,"id_to_interned_str","","",143,{"inputs":[{"name":"parser"},{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"token_is_bare_fn_keyword","","Is the current token one of the keywords that signals a bare function\ntype?",143,{"inputs":[{"name":"parser"}],"output":{"name":"bool"}}],[11,"get_lifetime","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"ident"}}],[11,"parse_for_in_type","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_path","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_bare_fn","","parse a TyBareFn type:",143,{"inputs":[{"name":"parser"},{"name":"vec"}],"output":{"name":"result"}}],[11,"parse_obsolete_closure_kind","","Parses an obsolete closure kind (`&:`, `&mut:`, or `:`).",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_unsafety","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_trait_items","","Parse the items in a trait declaration",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_mt","","Parse a possibly mutable type",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ret_ty","","Parse optional return type [ -> TY ] in function decl",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_sum","","Parse a type in a context where `T1+T2` is allowed.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ty_nopanic","","Parse a type.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_borrowed_pointee","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_ptr","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"is_named_argument","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"bool"}}],[11,"parse_arg_general","","This version of parse arg doesn't necessarily require\nidentifier names.",143,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"result"}}],[11,"parse_arg","","Parse a single function argument",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_fn_block_arg","","Parse an argument in a lambda header e.g. |arg, arg|",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"maybe_parse_fixed_length_of_vec","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"lit_from_token","","Matches token_lit = LIT_INTEGER | ...",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"parse_lit","","Matches lit = true | false | token_lit",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_literal_maybe_minus","","matches '-' lit | lit",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path","","Parses a path and optional type parameter bounds, depending on the\nmode. The `mode` parameter determines whether lifetimes, types, and/or\nbounds are permitted and whether `::` must precede type parameter\ngroups.",143,{"inputs":[{"name":"parser"},{"name":"pathparsingmode"}],"output":{"name":"result"}}],[11,"parse_path_segments_without_colons","","Examples:\n- `a::b<T,U>::c<V,W>`\n- `a::b<T,U>::c(V) -> W`\n- `a::b<T,U>::c(V)`",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path_segments_with_colons","","Examples:\n- `a::b::<T,U>::c`",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_path_segments_without_types","","Examples:\n- `a::b::c`",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_opt_lifetime","","parses 0 or 1 lifetime",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lifetime","","Parses a single lifetime\nMatches lifetime = LIFETIME",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lifetime_defs","","Parses `lifetime_defs = [ lifetime_defs { ',' lifetime_defs } ]` where `lifetime_def  =\nlifetime [':' lifetimes]`",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lifetimes","","matches lifetimes = ( lifetime ) | ( lifetime , lifetimes ) actually, it matches the empty\none too, but putting that in there messes up the grammar....",143,{"inputs":[{"name":"parser"},{"name":"token"}],"output":{"name":"result"}}],[11,"parse_mutability","","Parse mutability declaration (mut/const/imm)",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_field","","Parse ident COLON expr",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"mk_expr","","",143,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"bytepos"},{"name":"expr_"}],"output":{"name":"p"}}],[11,"mk_unary","","",143,{"inputs":[{"name":"parser"},{"name":"unop"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_binary","","",143,{"inputs":[{"name":"parser"},{"name":"spanned"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_call","","",143,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"vec"}],"output":{"name":"expr_"}}],[11,"mk_index","","",143,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_range","","",143,{"inputs":[{"name":"parser"},{"name":"option"},{"name":"option"}],"output":{"name":"expr_"}}],[11,"mk_field","","",143,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"spanned"}],"output":{"name":"expr_"}}],[11,"mk_tup_field","","",143,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"spanned"}],"output":{"name":"expr_"}}],[11,"mk_assign_op","","",143,{"inputs":[{"name":"parser"},{"name":"spanned"},{"name":"p"},{"name":"p"}],"output":{"name":"expr_"}}],[11,"mk_mac_expr","","",143,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"bytepos"},{"name":"mac_"}],"output":{"name":"p"}}],[11,"mk_lit_u32","","",143,{"inputs":[{"name":"parser"},{"name":"u32"}],"output":{"name":"p"}}],[11,"parse_bottom_expr","","At the bottom (top?) of the precedence hierarchy,\nparse things like parenthesized exprs,\nmacros, return, etc.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_block_expr","","Parse a block or unsafe block",143,{"inputs":[{"name":"parser"},{"name":"bytepos"},{"name":"blockcheckmode"}],"output":{"name":"result"}}],[11,"parse_dot_or_call_expr","","parse a.b or a(13) or a[4] or just a",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_dot_or_call_expr_with","","",143,{"inputs":[{"name":"parser"},{"name":"p"}],"output":{"name":"result"}}],[11,"check_unknown_macro_variable","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_sep_and_kleene_op","","Parse an optional separator followed by a Kleene-style\nrepetition token (+ or *).",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_token_tree","","parse a single token tree from the input.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_all_token_trees","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_prefix_expr","","Parse a prefix-operator expr",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_binops","","Parse an expression of binops",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_more_binops","","Parse an expression of binops of at least min_prec precedence",143,{"inputs":[{"name":"parser"},{"name":"p"},{"name":"usize"}],"output":{"name":"result"}}],[11,"parse_assign_expr","","Parse an assignment expression....\nactually, this seems to be the main entry point for\nparsing an arbitrary expression.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_assign_expr_with","","",143,{"inputs":[{"name":"parser"},{"name":"p"}],"output":{"name":"result"}}],[11,"parse_if_expr","","Parse an 'if' or 'if let' expression ('if' token already eaten)",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_if_let_expr","","Parse an 'if let' expression ('if' token already eaten)",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_lambda_expr","","",143,{"inputs":[{"name":"parser"},{"name":"captureclause"}],"output":{"name":"result"}}],[11,"parse_else_expr","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_for_expr","","Parse a 'for' .. 'in' expression ('for' token already eaten)",143,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_while_expr","","Parse a 'while' or 'while let' expression ('while' token already eaten)",143,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_while_let_expr","","Parse a 'while let' expression ('while' token already eaten)",143,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_loop_expr","","",143,{"inputs":[{"name":"parser"},{"name":"option"}],"output":{"name":"result"}}],[11,"parse_arm_nopanic","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_expr_nopanic","","Parse an expression",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_expr_res","","Parse an expression, subject to the given restrictions",143,{"inputs":[{"name":"parser"},{"name":"restrictions"}],"output":{"name":"result"}}],[11,"parse_pat_nopanic","","Parse a pattern.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_stmt_nopanic","","Parse a statement. may include decl.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_block","","Parse a block. No inner attrs are allowed.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_generics","","Parse a set of optional generic type parameter declarations. Where\nclauses are not parsed here, and must be added later via\n`parse_where_clause()`.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_where_clause","","Parses an optional `where` clause and places it in `generics`.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_fn_decl","","Parse the argument list and result type of a function declaration",143,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"result"}}],[11,"parse_impl_item","","Parse an impl item.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_record_struct_body","","",143,{"inputs":[{"name":"parser"},{"name":"ident"}],"output":{"name":"result"}}],[11,"parse_tuple_struct_body","","",143,{"inputs":[{"name":"parser"},{"name":"ident"},{"name":"generics"}],"output":{"name":"result"}}],[11,"parse_single_struct_field","","Parse a structure field declaration",143,{"inputs":[{"name":"parser"},{"name":"visibility"},{"name":"vec"}],"output":{"name":"result"}}],[11,"parse_item_nopanic","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_crate_mod","","Parses a source module as a crate. This is the main\nentry point for the parser.",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_optional_str","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"parse_str","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"result"}}],[11,"eq","syntax::parse::lexer::comments","",144,{"inputs":[{"name":"commentstyle"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"ne","","",144,{"inputs":[{"name":"commentstyle"},{"name":"commentstyle"}],"output":{"name":"bool"}}],[11,"clone","","",144,{"inputs":[{"name":"commentstyle"}],"output":{"name":"commentstyle"}}],[11,"clone","","",145,{"inputs":[{"name":"comment"}],"output":{"name":"comment"}}],[11,"clone","","",146,{"inputs":[{"name":"literal"}],"output":{"name":"literal"}}],[11,"fmt","syntax::parse::lexer","",147,{"inputs":[{"name":"tokenandspan"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",147,{"inputs":[{"name":"tokenandspan"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"ne","","",147,{"inputs":[{"name":"tokenandspan"},{"name":"tokenandspan"}],"output":{"name":"bool"}}],[11,"clone","","",147,{"inputs":[{"name":"tokenandspan"}],"output":{"name":"tokenandspan"}}],[11,"is_eof","","",148,{"inputs":[{"name":"stringreader"}],"output":{"name":"bool"}}],[11,"next_token","","Return the next token. EFFECT: advances the string_reader.",148,{"inputs":[{"name":"stringreader"}],"output":{"name":"tokenandspan"}}],[11,"fatal","","",148,null],[11,"err","","",148,null],[11,"peek","","",148,{"inputs":[{"name":"stringreader"}],"output":{"name":"tokenandspan"}}],[11,"is_eof","syntax::ext::tt::transcribe","",43,{"inputs":[{"name":"ttreader"}],"output":{"name":"bool"}}],[11,"next_token","","",43,{"inputs":[{"name":"ttreader"}],"output":{"name":"tokenandspan"}}],[11,"fatal","","",43,null],[11,"err","","",43,null],[11,"peek","","",43,{"inputs":[{"name":"ttreader"}],"output":{"name":"tokenandspan"}}],[11,"new_raw","syntax::parse::lexer","For comments.rs, which hackily pokes into pos and curr",148,{"inputs":[{"name":"stringreader"},{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[11,"new","","",148,{"inputs":[{"name":"stringreader"},{"name":"spanhandler"},{"name":"rc"}],"output":{"name":"stringreader"}}],[11,"curr_is","","",148,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"fatal_span","","Report a fatal lexical error with a given span.",148,null],[11,"err_span","","Report a lexical error with a given span.",148,null],[11,"with_str_from","","Calls `f` with a string slice of the source text spanning from `start`\nup to but excluding `self.last_pos`, meaning the slice does not include\nthe character `self.curr`.",148,{"inputs":[{"name":"stringreader"},{"name":"bytepos"},{"name":"f"}],"output":{"name":"t"}}],[11,"name_from","","Create a Name from a given offset to the current offset, each\nadjusted 1 towards each other (assumes that on either side there is a\nsingle-byte delimiter).",148,{"inputs":[{"name":"stringreader"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"name_from_to","","As name_from, with an explicit endpoint.",148,{"inputs":[{"name":"stringreader"},{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"name"}}],[11,"bump","","Advance the StringReader by one character. If a newline is\ndiscovered, add it to the FileMap's list of line start offsets.",148,null],[11,"nextch","","",148,{"inputs":[{"name":"stringreader"}],"output":{"name":"option"}}],[11,"nextch_is","","",148,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"nextnextch","","",148,{"inputs":[{"name":"stringreader"}],"output":{"name":"option"}}],[11,"nextnextch_is","","",148,{"inputs":[{"name":"stringreader"},{"name":"char"}],"output":{"name":"bool"}}],[11,"fmt","syntax::parse::token","",149,{"inputs":[{"name":"binoptoken"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",149,null],[11,"eq","","",149,{"inputs":[{"name":"binoptoken"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"ne","","",149,{"inputs":[{"name":"binoptoken"},{"name":"binoptoken"}],"output":{"name":"bool"}}],[11,"decode","","",149,{"inputs":[{"name":"binoptoken"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",149,{"inputs":[{"name":"binoptoken"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",149,{"inputs":[{"name":"binoptoken"}],"output":{"name":"binoptoken"}}],[11,"fmt","","",150,{"inputs":[{"name":"delimtoken"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",150,null],[11,"eq","","",150,{"inputs":[{"name":"delimtoken"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"ne","","",150,{"inputs":[{"name":"delimtoken"},{"name":"delimtoken"}],"output":{"name":"bool"}}],[11,"decode","","",150,{"inputs":[{"name":"delimtoken"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",150,{"inputs":[{"name":"delimtoken"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",150,{"inputs":[{"name":"delimtoken"}],"output":{"name":"delimtoken"}}],[11,"fmt","","",151,{"inputs":[{"name":"identstyle"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",151,null],[11,"eq","","",151,{"inputs":[{"name":"identstyle"},{"name":"identstyle"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"identstyle"},{"name":"identstyle"}],"output":{"name":"bool"}}],[11,"decode","","",151,{"inputs":[{"name":"identstyle"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",151,{"inputs":[{"name":"identstyle"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",151,{"inputs":[{"name":"identstyle"}],"output":{"name":"identstyle"}}],[11,"fmt","","",152,{"inputs":[{"name":"specialmacrovar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",152,null],[11,"eq","","",152,{"inputs":[{"name":"specialmacrovar"},{"name":"specialmacrovar"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"specialmacrovar"},{"name":"specialmacrovar"}],"output":{"name":"bool"}}],[11,"decode","","",152,{"inputs":[{"name":"specialmacrovar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",152,{"inputs":[{"name":"specialmacrovar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",152,{"inputs":[{"name":"specialmacrovar"}],"output":{"name":"specialmacrovar"}}],[11,"as_str","","",152,{"inputs":[{"name":"specialmacrovar"}],"output":{"name":"str"}}],[11,"fmt","","",153,{"inputs":[{"name":"lit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",153,null],[11,"eq","","",153,{"inputs":[{"name":"lit"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"lit"},{"name":"lit"}],"output":{"name":"bool"}}],[11,"decode","","",153,{"inputs":[{"name":"lit"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",153,{"inputs":[{"name":"lit"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",153,{"inputs":[{"name":"lit"}],"output":{"name":"lit"}}],[11,"short_name","","",153,{"inputs":[{"name":"lit"}],"output":{"name":"str"}}],[11,"fmt","","",154,{"inputs":[{"name":"token"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",154,null],[11,"eq","","",154,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"decode","","",154,{"inputs":[{"name":"token"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",154,{"inputs":[{"name":"token"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",154,{"inputs":[{"name":"token"}],"output":{"name":"token"}}],[11,"is_like_gt","","Returns `true` if the token starts with '>'.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"can_begin_expr","","Returns `true` if the token can appear at the start of an expression.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_lit","","Returns `true` if the token is any literal",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_ident","","Returns `true` if the token is an identifier.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_path","","Returns `true` if the token is an interpolated path.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_plain_ident","","Returns `true` if the token is a path that is not followed by a `::`\ntoken.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_lifetime","","Returns `true` if the token is a lifetime.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_mutability","","Returns `true` if the token is either the `mut` or `const` keyword.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"to_binop","","Maps a token to its corresponding binary operator.",154,{"inputs":[{"name":"token"}],"output":{"name":"option"}}],[11,"is_keyword","","Returns `true` if the token is a given keyword, `kw`.",154,{"inputs":[{"name":"token"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_keyword_allow_following_colon","","",154,{"inputs":[{"name":"token"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"is_any_keyword","","Returns `true` if the token is either a special identifier, or a strict\nor reserved keyword.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_strict_keyword","","Returns `true` if the token may not appear as an identifier.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_reserved_keyword","","Returns `true` if the token is a keyword that has been reserved for\npossible future use.",154,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"mtwt_eq","","Hygienic identifier equality comparison.",154,{"inputs":[{"name":"token"},{"name":"token"}],"output":{"name":"bool"}}],[11,"hash","","",155,null],[11,"eq","","",155,{"inputs":[{"name":"nonterminal"},{"name":"nonterminal"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"nonterminal"},{"name":"nonterminal"}],"output":{"name":"bool"}}],[11,"decode","","",155,{"inputs":[{"name":"nonterminal"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",155,{"inputs":[{"name":"nonterminal"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",155,{"inputs":[{"name":"nonterminal"}],"output":{"name":"nonterminal"}}],[11,"fmt","","",155,{"inputs":[{"name":"nonterminal"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","syntax::parse::token::keywords","",156,{"inputs":[{"name":"keyword"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"keyword"},{"name":"keyword"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"keyword"}],"output":{"name":"keyword"}}],[11,"to_name","","",156,{"inputs":[{"name":"keyword"}],"output":{"name":"name"}}],[11,"cmp","syntax::parse::token","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"option"}}],[11,"lt","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"le","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"gt","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"ge","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"hash","","",157,null],[11,"eq","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"internedstring"},{"name":"internedstring"}],"output":{"name":"bool"}}],[11,"clone","","",157,{"inputs":[{"name":"internedstring"}],"output":{"name":"internedstring"}}],[11,"new","","",157,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"internedstring"}}],[6,"Target","rustc_driver::diagnostic","",null,null],[11,"deref","syntax::parse::token","",157,{"inputs":[{"name":"internedstring"}],"output":{"name":"str"}}],[11,"fmt","","",157,{"inputs":[{"name":"internedstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"internedstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",157,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"internedstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"decode","","",157,{"inputs":[{"name":"internedstring"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",157,{"inputs":[{"name":"internedstring"},{"name":"s"}],"output":{"name":"result"}}],[11,"parse_outer_attributes","syntax::parse::parser","Parse attributes that appear before an item",143,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_attribute","","Matches `attribute = # ! [ meta_item ]`",143,{"inputs":[{"name":"parser"},{"name":"bool"}],"output":{"name":"spanned"}}],[11,"parse_inner_attributes","","Parse attributes that appear after the opening of an item. These should\nbe preceded by an exclamation mark, but we accept and warn about one\nterminated by a semicolon.\nmatches inner_attrs*",143,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_meta_item","","matches meta_item = IDENT\n| IDENT = lit\n| IDENT meta_seq",143,{"inputs":[{"name":"parser"}],"output":{"name":"p"}}],[11,"parse_meta_seq","","matches meta_seq = ( COMMASEP(meta_item) )",143,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"parse_optional_meta","","",143,{"inputs":[{"name":"parser"}],"output":{"name":"vec"}}],[11,"hash","syntax::parse::obsolete","",158,null],[11,"eq","","",158,{"inputs":[{"name":"obsoletesyntax"},{"name":"obsoletesyntax"}],"output":{"name":"bool"}}],[11,"ne","","",158,{"inputs":[{"name":"obsoletesyntax"},{"name":"obsoletesyntax"}],"output":{"name":"bool"}}],[11,"clone","","",158,{"inputs":[{"name":"obsoletesyntax"}],"output":{"name":"obsoletesyntax"}}],[11,"obsolete","syntax::parse::parser","Reports an obsolete syntax non-fatal error.",143,null],[11,"obsolete_expr","","Reports an obsolete syntax non-fatal error, and returns\na placeholder expression",143,{"inputs":[{"name":"parser"},{"name":"span"},{"name":"obsoletesyntax"}],"output":{"name":"p"}}],[11,"report","","",143,null],[11,"is_obsolete_ident","","",143,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eat_obsolete_ident","","",143,{"inputs":[{"name":"parser"},{"name":"str"}],"output":{"name":"bool"}}],[11,"next_node_id","syntax::parse","",159,{"inputs":[{"name":"parsesess"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",159,{"inputs":[{"name":"parsesess"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"fmt","syntax::abi","",160,{"inputs":[{"name":"os"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",160,{"inputs":[{"name":"os"},{"name":"os"}],"output":{"name":"bool"}}],[11,"ne","","",160,{"inputs":[{"name":"os"},{"name":"os"}],"output":{"name":"bool"}}],[11,"clone","","",160,{"inputs":[{"name":"os"}],"output":{"name":"os"}}],[11,"fmt","","",161,{"inputs":[{"name":"abi"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",161,{"inputs":[{"name":"abi"}],"output":{"name":"abi"}}],[11,"decode","","",161,{"inputs":[{"name":"abi"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",161,{"inputs":[{"name":"abi"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",161,null],[11,"eq","","",161,{"inputs":[{"name":"abi"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"ne","","",161,{"inputs":[{"name":"abi"},{"name":"abi"}],"output":{"name":"bool"}}],[11,"fmt","","",162,{"inputs":[{"name":"architecture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",162,{"inputs":[{"name":"architecture"},{"name":"architecture"}],"output":{"name":"bool"}}],[11,"ne","","",162,{"inputs":[{"name":"architecture"},{"name":"architecture"}],"output":{"name":"bool"}}],[11,"clone","","",162,{"inputs":[{"name":"architecture"}],"output":{"name":"architecture"}}],[11,"clone","","",163,{"inputs":[{"name":"abidata"}],"output":{"name":"abidata"}}],[11,"clone","","",164,{"inputs":[{"name":"abiarchitecture"}],"output":{"name":"abiarchitecture"}}],[11,"index","","",161,{"inputs":[{"name":"abi"}],"output":{"name":"usize"}}],[11,"data","","",161,{"inputs":[{"name":"abi"}],"output":{"name":"abidata"}}],[11,"name","","",161,{"inputs":[{"name":"abi"}],"output":{"name":"str"}}],[11,"fmt","","",161,{"inputs":[{"name":"abi"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",160,{"inputs":[{"name":"os"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","syntax::ast_map::blocks","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnlikenode"}}],[11,"is_fn_like","syntax::ast","",133,{"inputs":[{"name":"item"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",99,{"inputs":[{"name":"traititem"}],"output":{"name":"bool"}}],[11,"is_fn_like","","",83,{"inputs":[{"name":"expr"}],"output":{"name":"bool"}}],[11,"clone","syntax::ast_map::blocks","",166,{"inputs":[{"name":"code"}],"output":{"name":"code"}}],[11,"id","","",166,{"inputs":[{"name":"code"}],"output":{"name":"u32"}}],[11,"from_node","","Attempts to construct a Code from presumed FnLike or Block node input.",166,{"inputs":[{"name":"code"},{"name":"node"}],"output":{"name":"option"}}],[11,"to_fn_parts","","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnparts"}}],[11,"body","","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"block"}}],[11,"decl","","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fndecl"}}],[11,"span","","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"span"}}],[11,"id","","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"u32"}}],[11,"kind","","",165,{"inputs":[{"name":"fnlikenode"}],"output":{"name":"fnkind"}}],[11,"fmt","syntax::ast_map","",167,{"inputs":[{"name":"pathelem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",167,{"inputs":[{"name":"pathelem"},{"name":"pathelem"}],"output":{"name":"bool"}}],[11,"ne","","",167,{"inputs":[{"name":"pathelem"},{"name":"pathelem"}],"output":{"name":"bool"}}],[11,"clone","","",167,{"inputs":[{"name":"pathelem"}],"output":{"name":"pathelem"}}],[11,"name","","",167,{"inputs":[{"name":"pathelem"}],"output":{"name":"name"}}],[11,"fmt","","",167,{"inputs":[{"name":"pathelem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",168,{"inputs":[{"name":"linkedpathnode"}],"output":{"name":"linkedpathnode"}}],[11,"clone","","",169,{"inputs":[{"name":"linkedpath"}],"output":{"name":"linkedpath"}}],[11,"empty","","",169,{"inputs":[{"name":"linkedpath"}],"output":{"name":"linkedpath"}}],[11,"from","","",169,{"inputs":[{"name":"linkedpath"},{"name":"linkedpathnode"}],"output":{"name":"linkedpath"}}],[6,"Item","rustc_driver::diagnostic","",null,null],[11,"next","syntax::ast_map","",169,{"inputs":[{"name":"linkedpath"}],"output":{"name":"option"}}],[11,"fmt","","",170,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",170,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",171,{"inputs":[{"name":"mapentry"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",171,{"inputs":[{"name":"mapentry"}],"output":{"name":"mapentry"}}],[11,"fmt","","",172,{"inputs":[{"name":"inlinedparent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",173,{"inputs":[{"name":"forest"},{"name":"crate"}],"output":{"name":"forest"}}],[11,"krate","","",173,{"inputs":[{"name":"forest"}],"output":{"name":"crate"}}],[11,"krate","","",174,{"inputs":[{"name":"map"}],"output":{"name":"crate"}}],[11,"get","","Retrieve the Node corresponding to `id`, panicking if it cannot\nbe found.",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"node"}}],[11,"find","","Retrieve the Node corresponding to `id`, returning None if\ncannot be found.",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"option"}}],[11,"get_parent","","Retrieve the parent NodeId for `id`, or `id` itself if no\nparent is registered in this map.",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"get_parent_did","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"defid"}}],[11,"get_foreign_abi","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"abi"}}],[11,"get_foreign_vis","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"visibility"}}],[11,"expect_item","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"item"}}],[11,"expect_struct","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"structdef"}}],[11,"expect_variant","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"spanned"}}],[11,"expect_foreign_item","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"foreignitem"}}],[11,"expect_expr","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"expr"}}],[11,"get_path_elem","","returns the name associated with the given NodeId's AST",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"pathelem"}}],[11,"with_path","","",174,{"inputs":[{"name":"map"},{"name":"u32"},{"name":"f"}],"output":{"name":"t"}}],[11,"path_to_string","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"string"}}],[11,"attrs","","Given a node ID, get a list of of attributes associated with the AST\ncorresponding to the Node ID",174,null],[11,"nodes_matching_suffix","","Returns an iterator that yields the node id's with paths that\nmatch `parts`.  (Requires `parts` is non-empty.)",174,null],[11,"opt_span","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"option"}}],[11,"span","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"span"}}],[11,"def_id_span","","",174,{"inputs":[{"name":"map"},{"name":"defid"},{"name":"span"}],"output":{"name":"span"}}],[11,"node_to_string","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"string"}}],[11,"node_to_user_string","","",174,{"inputs":[{"name":"map"},{"name":"u32"}],"output":{"name":"string"}}],[6,"Item","rustc_driver::diagnostic","",null,null],[11,"next","syntax::ast_map","",175,{"inputs":[{"name":"nodesmatchingsuffix"}],"output":{"name":"option"}}],[11,"name","syntax::codemap","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"name"}}],[11,"name","syntax::ast","",133,{"inputs":[{"name":"item"}],"output":{"name":"name"}}],[11,"name","","",135,{"inputs":[{"name":"foreignitem"}],"output":{"name":"name"}}],[11,"name","","",122,{"inputs":[{"name":"variant_"}],"output":{"name":"name"}}],[11,"name","","",99,{"inputs":[{"name":"traititem"}],"output":{"name":"name"}}],[11,"name","","",101,{"inputs":[{"name":"implitem"}],"output":{"name":"name"}}],[11,"new_id","syntax::ast_map","",176,{"inputs":[{"name":"idandspanupdater"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"new_span","","",176,{"inputs":[{"name":"idandspanupdater"},{"name":"span"}],"output":{"name":"span"}}],[11,"visit_item","","",177,null],[11,"visit_trait_item","","",177,null],[11,"visit_impl_item","","",177,null],[11,"visit_pat","","",177,null],[11,"visit_expr","","",177,null],[11,"visit_stmt","","",177,null],[11,"visit_fn","","",177,null],[11,"visit_ty","","",177,null],[11,"visit_block","","",177,null],[11,"visit_lifetime_ref","","",177,null],[11,"visit_lifetime_def","","",177,null],[11,"print_node","syntax::print::pprust","",178,{"inputs":[{"name":"state"},{"name":"node"}],"output":{"name":"result"}}],[11,"fmt","syntax::ast_util","",179,{"inputs":[{"name":"idrange"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",179,{"inputs":[{"name":"idrange"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",179,{"inputs":[{"name":"idrange"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",179,{"inputs":[{"name":"idrange"}],"output":{"name":"idrange"}}],[11,"max","","",179,{"inputs":[{"name":"idrange"}],"output":{"name":"idrange"}}],[11,"empty","","",179,{"inputs":[{"name":"idrange"}],"output":{"name":"bool"}}],[11,"add","","",179,null],[11,"visit_mod","","",180,null],[11,"visit_foreign_item","","",180,null],[11,"visit_item","","",180,null],[11,"visit_local","","",180,null],[11,"visit_block","","",180,null],[11,"visit_stmt","","",180,null],[11,"visit_pat","","",180,null],[11,"visit_expr","","",180,null],[11,"visit_ty","","",180,null],[11,"visit_generics","","",180,null],[11,"visit_fn","","",180,null],[11,"visit_struct_field","","",180,null],[11,"visit_struct_def","","",180,null],[11,"visit_trait_item","","",180,null],[11,"visit_impl_item","","",180,null],[11,"visit_lifetime_ref","","",180,null],[11,"visit_lifetime_def","","",180,null],[11,"visit_trait_ref","","",180,null],[11,"visit_id","","",181,null],[11,"check_name","syntax::codemap","",30,{"inputs":[{"name":"spanned"},{"name":"str"}],"output":{"name":"bool"}}],[11,"name","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"internedstring"}}],[11,"value_str","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"meta_item_list","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"span","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"span"}}],[11,"name","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"internedstring"}}],[11,"value_str","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"meta_item_list","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"option"}}],[11,"span","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"span"}}],[11,"name","syntax::ptr","",39,{"inputs":[{"name":"p"}],"output":{"name":"internedstring"}}],[11,"value_str","","",39,{"inputs":[{"name":"p"}],"output":{"name":"option"}}],[11,"meta_item_list","","",39,{"inputs":[{"name":"p"}],"output":{"name":"option"}}],[11,"span","","",39,{"inputs":[{"name":"p"}],"output":{"name":"span"}}],[11,"meta","syntax::codemap","Extract the MetaItem from inside this Attribute.",30,{"inputs":[{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"with_desugared_doc","","Convert self to a normal #[doc=\"foo\"] comment, if it is a\ncomment like `///` or `/** */`. (Returns self unchanged for\nnon-sugared doc attributes.)",30,{"inputs":[{"name":"spanned"},{"name":"f"}],"output":{"name":"t"}}],[11,"eq","syntax::attr","",182,{"inputs":[{"name":"inlineattr"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"ne","","",182,{"inputs":[{"name":"inlineattr"},{"name":"inlineattr"}],"output":{"name":"bool"}}],[11,"clone","","",182,{"inputs":[{"name":"inlineattr"}],"output":{"name":"inlineattr"}}],[11,"fmt","","",183,{"inputs":[{"name":"stability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",183,{"inputs":[{"name":"stability"}],"output":{"name":"stability"}}],[11,"decode","","",183,{"inputs":[{"name":"stability"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",183,{"inputs":[{"name":"stability"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",184,{"inputs":[{"name":"stabilitylevel"}],"output":{"name":"stabilitylevel"}}],[11,"partial_cmp","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"option"}}],[11,"lt","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"le","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"gt","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ge","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"eq","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"ne","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"stabilitylevel"}],"output":{"name":"bool"}}],[11,"decode","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",184,{"inputs":[{"name":"stabilitylevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",185,{"inputs":[{"name":"reprattr"}],"output":{"name":"reprattr"}}],[11,"decode","","",185,{"inputs":[{"name":"reprattr"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",185,{"inputs":[{"name":"reprattr"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",185,{"inputs":[{"name":"reprattr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",185,{"inputs":[{"name":"reprattr"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"reprattr"},{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"is_ffi_safe","","",185,{"inputs":[{"name":"reprattr"}],"output":{"name":"bool"}}],[11,"clone","","",186,{"inputs":[{"name":"inttype"}],"output":{"name":"inttype"}}],[11,"decode","","",186,{"inputs":[{"name":"inttype"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",186,{"inputs":[{"name":"inttype"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",186,{"inputs":[{"name":"inttype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",186,{"inputs":[{"name":"inttype"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"ne","","",186,{"inputs":[{"name":"inttype"},{"name":"inttype"}],"output":{"name":"bool"}}],[11,"hash","","",186,null],[11,"is_signed","","",186,{"inputs":[{"name":"inttype"}],"output":{"name":"bool"}}],[11,"fmt","syntax::codemap","",187,{"inputs":[{"name":"bytepos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"option"}}],[11,"lt","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"le","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"gt","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ge","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"hash","","",187,null],[11,"eq","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"ne","","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bool"}}],[11,"clone","","",187,{"inputs":[{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"fmt","","",188,{"inputs":[{"name":"charpos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"option"}}],[11,"lt","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"le","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"gt","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ge","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"hash","","",188,null],[11,"eq","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"ne","","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"bool"}}],[11,"clone","","",188,{"inputs":[{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"from_usize","","",187,{"inputs":[{"name":"bytepos"},{"name":"usize"}],"output":{"name":"bytepos"}}],[11,"to_usize","","",187,{"inputs":[{"name":"bytepos"}],"output":{"name":"usize"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"add","syntax::codemap","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"sub","syntax::codemap","",187,{"inputs":[{"name":"bytepos"},{"name":"bytepos"}],"output":{"name":"bytepos"}}],[11,"encode","","",187,{"inputs":[{"name":"bytepos"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",187,{"inputs":[{"name":"bytepos"},{"name":"d"}],"output":{"name":"result"}}],[11,"from_usize","","",188,{"inputs":[{"name":"charpos"},{"name":"usize"}],"output":{"name":"charpos"}}],[11,"to_usize","","",188,{"inputs":[{"name":"charpos"}],"output":{"name":"usize"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"add","syntax::codemap","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"charpos"}}],[6,"Output","rustc_driver::diagnostic","",null,null],[11,"sub","syntax::codemap","",188,{"inputs":[{"name":"charpos"},{"name":"charpos"}],"output":{"name":"charpos"}}],[11,"hash","","",189,null],[11,"fmt","","",189,{"inputs":[{"name":"span"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",189,{"inputs":[{"name":"span"}],"output":{"name":"span"}}],[11,"fmt","","",30,{"inputs":[{"name":"spanned"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",30,null],[11,"decode","","",30,{"inputs":[{"name":"spanned"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",30,{"inputs":[{"name":"spanned"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",30,{"inputs":[{"name":"spanned"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"spanned"},{"name":"spanned"}],"output":{"name":"bool"}}],[11,"clone","","",30,{"inputs":[{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"eq","","",189,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"ne","","",189,{"inputs":[{"name":"span"},{"name":"span"}],"output":{"name":"bool"}}],[11,"encode","","",189,{"inputs":[{"name":"span"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",189,{"inputs":[{"name":"span"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",190,{"inputs":[{"name":"loc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",191,{"inputs":[{"name":"locwithopt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",192,{"inputs":[{"name":"filemapandline"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",193,{"inputs":[{"name":"filemapandbytepos"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",194,{"inputs":[{"name":"macroformat"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",194,null],[11,"clone","","",194,{"inputs":[{"name":"macroformat"}],"output":{"name":"macroformat"}}],[11,"fmt","","",195,{"inputs":[{"name":"nameandspan"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",195,null],[11,"clone","","",195,{"inputs":[{"name":"nameandspan"}],"output":{"name":"nameandspan"}}],[11,"fmt","","",196,{"inputs":[{"name":"expninfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",196,null],[11,"decode","","",197,{"inputs":[{"name":"expnid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",197,{"inputs":[{"name":"expnid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",197,null],[11,"fmt","","",197,{"inputs":[{"name":"expnid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",197,{"inputs":[{"name":"expnid"}],"output":{"name":"expnid"}}],[11,"eq","","",197,{"inputs":[{"name":"expnid"},{"name":"expnid"}],"output":{"name":"bool"}}],[11,"ne","","",197,{"inputs":[{"name":"expnid"},{"name":"expnid"}],"output":{"name":"bool"}}],[11,"from_llvm_cookie","","",197,{"inputs":[{"name":"expnid"},{"name":"u32"}],"output":{"name":"expnid"}}],[11,"to_llvm_cookie","","",197,{"inputs":[{"name":"expnid"}],"output":{"name":"i32"}}],[11,"eq","","",198,{"inputs":[{"name":"lineinfo"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"ne","","",198,{"inputs":[{"name":"lineinfo"},{"name":"lineinfo"}],"output":{"name":"bool"}}],[11,"fmt","","",198,{"inputs":[{"name":"lineinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",198,{"inputs":[{"name":"lineinfo"}],"output":{"name":"lineinfo"}}],[11,"eq","","",199,{"inputs":[{"name":"multibytechar"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"ne","","",199,{"inputs":[{"name":"multibytechar"},{"name":"multibytechar"}],"output":{"name":"bool"}}],[11,"decode","","",199,{"inputs":[{"name":"multibytechar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",199,{"inputs":[{"name":"multibytechar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",199,{"inputs":[{"name":"multibytechar"}],"output":{"name":"multibytechar"}}],[11,"encode","","",200,{"inputs":[{"name":"filemap"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",200,{"inputs":[{"name":"filemap"},{"name":"d"}],"output":{"name":"result"}}],[11,"fmt","","",200,{"inputs":[{"name":"filemap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"next_line","","EFFECT: register a start-of-line offset in the\ntable of line-beginnings.\nUNCHECKED INVARIANT: these offsets must be added in the right\norder and must be in the right places; there is shared knowledge\nabout what ends a line between this file and parse.rs\nWARNING: pos param here is the offset relative to start of CodeMap,\nand CodeMap will append a newline when adding a filemap without a newline at the end,\nso the safe way to call this is with value calculated as\nfilemap.start_pos + newline_offset_relative_to_the_start_of_filemap.",200,null],[11,"get_line","","get a line from the list of pre-computed line-beginnings.\nline-number here is 0-based.",200,{"inputs":[{"name":"filemap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"record_multibyte_char","","",200,null],[11,"is_real_file","","",200,{"inputs":[{"name":"filemap"}],"output":{"name":"bool"}}],[11,"is_imported","","",200,{"inputs":[{"name":"filemap"}],"output":{"name":"bool"}}],[11,"new","","",201,{"inputs":[{"name":"codemap"}],"output":{"name":"codemap"}}],[11,"new_filemap","","",201,{"inputs":[{"name":"codemap"},{"name":"string"},{"name":"string"}],"output":{"name":"rc"}}],[11,"new_imported_filemap","","Allocates a new FileMap representing a source file from an external\ncrate. The source code of such an \"imported filemap\" is not available,\nbut we still know enough to generate accurate debuginfo location\ninformation for things inlined from other crates.",201,{"inputs":[{"name":"codemap"},{"name":"string"},{"name":"usize"},{"name":"vec"},{"name":"vec"}],"output":{"name":"rc"}}],[11,"mk_substr_filename","","",201,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"lookup_char_pos","","Lookup source information about a BytePos",201,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"loc"}}],[11,"lookup_char_pos_adj","","",201,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"locwithopt"}}],[11,"span_to_string","","",201,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_filename","","",201,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"string"}}],[11,"span_to_lines","","",201,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"filelines"}}],[11,"span_to_snippet","","",201,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"result"}}],[11,"get_filemap","","",201,{"inputs":[{"name":"codemap"},{"name":"str"}],"output":{"name":"rc"}}],[11,"lookup_byte_offset","","For a global BytePos compute the local offset within the containing FileMap",201,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"filemapandbytepos"}}],[11,"bytepos_to_file_charpos","","Converts an absolute BytePos to a CharPos relative to the filemap and above.",201,{"inputs":[{"name":"codemap"},{"name":"bytepos"}],"output":{"name":"charpos"}}],[11,"record_expansion","","",201,{"inputs":[{"name":"codemap"},{"name":"expninfo"}],"output":{"name":"expnid"}}],[11,"with_expn_info","","",201,{"inputs":[{"name":"codemap"},{"name":"expnid"},{"name":"f"}],"output":{"name":"t"}}],[11,"span_allows_unstable","","Check if a span is \"internal\" to a macro in which #[unstable]\nitems can be used (that is, a macro marked with\n`#[allow_internal_unstable]`).",201,{"inputs":[{"name":"codemap"},{"name":"span"}],"output":{"name":"bool"}}],[11,"fmt","","",202,{"inputs":[{"name":"spansnippeterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",202,{"inputs":[{"name":"spansnippeterror"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"ne","","",202,{"inputs":[{"name":"spansnippeterror"},{"name":"spansnippeterror"}],"output":{"name":"bool"}}],[11,"clone","","",202,{"inputs":[{"name":"spansnippeterror"}],"output":{"name":"spansnippeterror"}}],[11,"fmt","","",203,{"inputs":[{"name":"distinctsources"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",203,{"inputs":[{"name":"distinctsources"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"ne","","",203,{"inputs":[{"name":"distinctsources"},{"name":"distinctsources"}],"output":{"name":"bool"}}],[11,"clone","","",203,{"inputs":[{"name":"distinctsources"}],"output":{"name":"distinctsources"}}],[11,"fmt","","",204,{"inputs":[{"name":"malformedcodemappositions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",204,{"inputs":[{"name":"malformedcodemappositions"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"ne","","",204,{"inputs":[{"name":"malformedcodemappositions"},{"name":"malformedcodemappositions"}],"output":{"name":"bool"}}],[11,"clone","","",204,{"inputs":[{"name":"malformedcodemappositions"}],"output":{"name":"malformedcodemappositions"}}],[11,"fold_mod","syntax::config","",205,{"inputs":[{"name":"context"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_block","","",205,{"inputs":[{"name":"context"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_foreign_mod","","",205,{"inputs":[{"name":"context"},{"name":"foreignmod"}],"output":{"name":"foreignmod"}}],[11,"fold_item_underscore","","",205,{"inputs":[{"name":"context"},{"name":"item_"}],"output":{"name":"item_"}}],[11,"fold_expr","","",205,{"inputs":[{"name":"context"},{"name":"p"}],"output":{"name":"p"}}],[11,"fold_mac","","",205,{"inputs":[{"name":"context"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"fold_item","","",205,{"inputs":[{"name":"context"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_attribute","","",206,{"inputs":[{"name":"cfgattrfolder"},{"name":"spanned"}],"output":{"name":"option"}}],[11,"fold_mac","","",206,{"inputs":[{"name":"cfgattrfolder"},{"name":"spanned"}],"output":{"name":"spanned"}}],[11,"clone","syntax::diagnostic","",207,{"inputs":[{"name":"renderspan"}],"output":{"name":"renderspan"}}],[11,"clone","","",208,{"inputs":[{"name":"colorconfig"}],"output":{"name":"colorconfig"}}],[11,"clone","","",209,{"inputs":[{"name":"fatalerror"}],"output":{"name":"fatalerror"}}],[11,"clone","","",210,{"inputs":[{"name":"explicitbug"}],"output":{"name":"explicitbug"}}],[11,"span_fatal","","",211,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_fatal_with_code","","",211,{"inputs":[{"name":"spanhandler"},{"name":"span"},{"name":"str"},{"name":"str"}],"output":{"name":"fatalerror"}}],[11,"span_err","","",211,null],[11,"span_err_with_code","","",211,null],[11,"span_warn","","",211,null],[11,"span_warn_with_code","","",211,null],[11,"span_note","","",211,null],[11,"span_end_note","","",211,null],[11,"span_help","","",211,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",211,null],[11,"fileline_note","","",211,null],[11,"fileline_help","","",211,null],[11,"span_bug","","",211,null],[11,"span_unimpl","","",211,null],[11,"handler","","",211,{"inputs":[{"name":"spanhandler"}],"output":{"name":"handler"}}],[11,"fatal","","",212,null],[11,"err","","",212,null],[11,"bump_err_count","","",212,null],[11,"err_count","","",212,{"inputs":[{"name":"handler"}],"output":{"name":"usize"}}],[11,"has_errors","","",212,{"inputs":[{"name":"handler"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",212,null],[11,"warn","","",212,null],[11,"note","","",212,null],[11,"help","","",212,null],[11,"bug","","",212,null],[11,"unimpl","","",212,null],[11,"emit","","",212,null],[11,"emit_with_code","","",212,null],[11,"custom_emit","","",212,null],[11,"fmt","","",213,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",213,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"eq","","",213,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"fmt","","",213,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"stderr","","",214,{"inputs":[{"name":"emitterwriter"},{"name":"colorconfig"},{"name":"option"}],"output":{"name":"emitterwriter"}}],[11,"new","","",214,{"inputs":[{"name":"emitterwriter"},{"name":"box"},{"name":"option"}],"output":{"name":"emitterwriter"}}],[11,"write","","",215,null],[11,"flush","","",215,{"inputs":[{"name":"destination"}],"output":{"name":"result"}}],[11,"emit","","",214,null],[11,"custom_emit","","",214,null],[11,"fmt","syntax::feature_gate","",216,{"inputs":[{"name":"attributetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",216,{"inputs":[{"name":"attributetype"}],"output":{"name":"attributetype"}}],[11,"eq","","",216,{"inputs":[{"name":"attributetype"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"ne","","",216,{"inputs":[{"name":"attributetype"},{"name":"attributetype"}],"output":{"name":"bool"}}],[11,"new","","",217,{"inputs":[{"name":"features"}],"output":{"name":"features"}}],[11,"visit_mac","","",218,null],[11,"visit_attribute","","",218,null],[11,"visit_attribute","","",219,null],[11,"visit_name","","",219,null],[11,"visit_item","","",219,null],[11,"visit_foreign_item","","",219,null],[11,"visit_expr","","",219,null],[11,"visit_pat","","",219,null],[11,"visit_fn","","",219,null],[11,"move_map","collections::vec","",29,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"move_map","syntax::owned_slice","",220,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"cmp","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"option"}}],[11,"lt","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"le","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"gt","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"ge","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"eq","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"ne","","",220,{"inputs":[{"name":"ownedslice"},{"name":"ownedslice"}],"output":{"name":"bool"}}],[11,"hash","","",220,null],[11,"fmt","","",220,{"inputs":[{"name":"ownedslice"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",220,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"from_vec","","",220,{"inputs":[{"name":"ownedslice"},{"name":"vec"}],"output":{"name":"ownedslice"}}],[11,"into_vec","","",220,{"inputs":[{"name":"ownedslice"}],"output":{"name":"vec"}}],[11,"as_slice","","",220,null],[11,"move_iter","","",220,{"inputs":[{"name":"ownedslice"}],"output":{"name":"intoiter"}}],[11,"map","","",220,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[6,"Target","rustc_driver::diagnostic","",null,null],[11,"deref","syntax::owned_slice","",220,null],[11,"default","","",220,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"clone","","",220,{"inputs":[{"name":"ownedslice"}],"output":{"name":"ownedslice"}}],[11,"from_iter","","",220,{"inputs":[{"name":"ownedslice"},{"name":"i"}],"output":{"name":"ownedslice"}}],[11,"encode","","",220,{"inputs":[{"name":"ownedslice"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",220,{"inputs":[{"name":"ownedslice"},{"name":"d"}],"output":{"name":"result"}}],[11,"and_then","syntax::ptr","Move out of the pointer.\nIntended for chaining transformations not covered by `map`.",39,{"inputs":[{"name":"p"},{"name":"f"}],"output":{"name":"u"}}],[11,"map","","Transform the inner value, consuming `self` and producing a new `P<T>`.",39,{"inputs":[{"name":"p"},{"name":"f"}],"output":{"name":"p"}}],[6,"Target","rustc_driver::diagnostic","",null,null],[11,"deref","syntax::ptr","",39,{"inputs":[{"name":"p"}],"output":{"name":"t"}}],[11,"clone","","",39,{"inputs":[{"name":"p"}],"output":{"name":"p"}}],[11,"eq","","",39,{"inputs":[{"name":"p"},{"name":"p"}],"output":{"name":"bool"}}],[11,"fmt","","",39,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",39,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",39,{"inputs":[{"name":"p"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",39,null],[11,"decode","","",39,{"inputs":[{"name":"p"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",39,{"inputs":[{"name":"p"},{"name":"s"}],"output":{"name":"result"}}],[6,"Err","rustc_driver::diagnostic","",null,null],[11,"from_str","syntax::show_span","",221,{"inputs":[{"name":"mode"},{"name":"str"}],"output":{"name":"result"}}],[11,"visit_expr","","",222,null],[11,"visit_pat","","",222,null],[11,"visit_ty","","",222,null],[11,"visit_mac","","",222,null],[11,"fold_crate","syntax::std_inject","",223,{"inputs":[{"name":"standardlibraryinjector"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_crate","","",224,{"inputs":[{"name":"preludeinjector"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_item","","",224,{"inputs":[{"name":"preludeinjector"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_mod","","",224,{"inputs":[{"name":"preludeinjector"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"fold_crate","syntax::test","",225,{"inputs":[{"name":"testharnessgenerator"},{"name":"crate"}],"output":{"name":"crate"}}],[11,"fold_item","","",225,{"inputs":[{"name":"testharnessgenerator"},{"name":"p"}],"output":{"name":"smallvector"}}],[11,"fold_mod","","",225,{"inputs":[{"name":"testharnessgenerator"},{"name":"mod"}],"output":{"name":"mod"}}],[11,"eq","","",226,{"inputs":[{"name":"hastestsignature"},{"name":"hastestsignature"}],"output":{"name":"bool"}}],[11,"ne","","",226,{"inputs":[{"name":"hastestsignature"},{"name":"hastestsignature"}],"output":{"name":"bool"}}],[11,"clone","syntax::visit","",227,{"inputs":[{"name":"fnkind"}],"output":{"name":"fnkind"}}],[11,"eq","syntax::print::pp","",228,{"inputs":[{"name":"breaks"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"ne","","",228,{"inputs":[{"name":"breaks"},{"name":"breaks"}],"output":{"name":"bool"}}],[11,"clone","","",228,{"inputs":[{"name":"breaks"}],"output":{"name":"breaks"}}],[11,"clone","","",229,{"inputs":[{"name":"breaktoken"}],"output":{"name":"breaktoken"}}],[11,"clone","","",230,{"inputs":[{"name":"begintoken"}],"output":{"name":"begintoken"}}],[11,"clone","","",231,{"inputs":[{"name":"token"}],"output":{"name":"token"}}],[11,"is_eof","","",231,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"is_hardbreak_tok","","",231,{"inputs":[{"name":"token"}],"output":{"name":"bool"}}],[11,"clone","","",232,{"inputs":[{"name":"printstackbreak"}],"output":{"name":"printstackbreak"}}],[11,"clone","","",233,{"inputs":[{"name":"printstackelem"}],"output":{"name":"printstackelem"}}],[11,"last_token","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"token"}}],[11,"replace_last_token","","",234,null],[11,"pretty_print","","",234,{"inputs":[{"name":"printer"},{"name":"token"}],"output":{"name":"result"}}],[11,"check_stream","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[11,"scan_push","","",234,null],[11,"scan_pop","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"scan_top","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"scan_pop_bottom","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"usize"}}],[11,"advance_right","","",234,null],[11,"advance_left","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"result"}}],[11,"check_stack","","",234,null],[11,"print_newline","","",234,{"inputs":[{"name":"printer"},{"name":"isize"}],"output":{"name":"result"}}],[11,"indent","","",234,null],[11,"get_top","","",234,{"inputs":[{"name":"printer"}],"output":{"name":"printstackelem"}}],[11,"print_str","","",234,{"inputs":[{"name":"printer"},{"name":"str"}],"output":{"name":"result"}}],[11,"print","","",234,{"inputs":[{"name":"printer"},{"name":"token"},{"name":"isize"}],"output":{"name":"result"}}],[11,"clone","syntax::print::pprust","",235,{"inputs":[{"name":"noann"}],"output":{"name":"noann"}}],[11,"clone","","",236,{"inputs":[{"name":"currentcommentandliteral"}],"output":{"name":"currentcommentandliteral"}}],[11,"new_from_input","","",178,{"inputs":[{"name":"state"},{"name":"codemap"},{"name":"spanhandler"},{"name":"string"},{"name":"read"},{"name":"box"},{"name":"ppann"},{"name":"bool"}],"output":{"name":"state"}}],[11,"new","","",178,{"inputs":[{"name":"state"},{"name":"codemap"},{"name":"box"},{"name":"ppann"},{"name":"option"},{"name":"option"}],"output":{"name":"state"}}],[11,"ibox","","",178,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"end","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"cbox","","",178,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"rbox","","",178,{"inputs":[{"name":"state"},{"name":"usize"},{"name":"breaks"}],"output":{"name":"result"}}],[11,"nbsp","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"word_nbsp","","",178,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"word_space","","",178,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"popen","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"pclose","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"head","","",178,{"inputs":[{"name":"state"},{"name":"str"}],"output":{"name":"result"}}],[11,"bopen","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"bclose_","","",178,{"inputs":[{"name":"state"},{"name":"span"},{"name":"usize"}],"output":{"name":"result"}}],[11,"bclose_maybe_open","","",178,{"inputs":[{"name":"state"},{"name":"span"},{"name":"usize"},{"name":"bool"}],"output":{"name":"result"}}],[11,"bclose","","",178,{"inputs":[{"name":"state"},{"name":"span"}],"output":{"name":"result"}}],[11,"is_begin","","",178,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"is_end","","",178,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"is_bol","","",178,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"in_cbox","","",178,{"inputs":[{"name":"state"}],"output":{"name":"bool"}}],[11,"hardbreak_if_not_bol","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"space_if_not_bol","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"break_offset_if_not_bol","","",178,{"inputs":[{"name":"state"},{"name":"usize"},{"name":"isize"}],"output":{"name":"result"}}],[11,"synth_comment","","",178,{"inputs":[{"name":"state"},{"name":"string"}],"output":{"name":"result"}}],[11,"commasep","","",178,null],[11,"commasep_cmnt","","",178,null],[11,"commasep_exprs","","",178,null],[11,"print_mod","","",178,null],[11,"print_foreign_mod","","",178,null],[11,"print_opt_lifetime","","",178,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_type","","",178,{"inputs":[{"name":"state"},{"name":"ty"}],"output":{"name":"result"}}],[11,"print_foreign_item","","",178,{"inputs":[{"name":"state"},{"name":"foreignitem"}],"output":{"name":"result"}}],[11,"print_item","","Pretty-print an item",178,{"inputs":[{"name":"state"},{"name":"item"}],"output":{"name":"result"}}],[11,"print_enum_def","","",178,{"inputs":[{"name":"state"},{"name":"enumdef"},{"name":"generics"},{"name":"ident"},{"name":"span"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_variants","","",178,null],[11,"print_visibility","","",178,{"inputs":[{"name":"state"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_struct","","",178,{"inputs":[{"name":"state"},{"name":"structdef"},{"name":"generics"},{"name":"ident"},{"name":"span"}],"output":{"name":"result"}}],[11,"print_tt","","This doesn't deserve to be called \"pretty\" printing, but it should be\nmeaning-preserving. A quick hack that might help would be to look at the\nspans embedded in the TTs to decide where to put spaces and newlines.\nBut it'd be better to parse these according to the grammar of the\nappropriate macro, transcribe back into the grammar we just parsed from,\nand then pretty-print the resulting AST nodes (so, e.g., we print\nexpression arguments as expressions). It can be done! I think.",178,{"inputs":[{"name":"state"},{"name":"tokentree"}],"output":{"name":"result"}}],[11,"print_tts","","",178,null],[11,"print_variant","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_method_sig","","",178,{"inputs":[{"name":"state"},{"name":"ident"},{"name":"methodsig"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_trait_item","","",178,{"inputs":[{"name":"state"},{"name":"traititem"}],"output":{"name":"result"}}],[11,"print_impl_item","","",178,{"inputs":[{"name":"state"},{"name":"implitem"}],"output":{"name":"result"}}],[11,"print_outer_attributes","","",178,null],[11,"print_inner_attributes","","",178,null],[11,"print_attribute","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_stmt","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_block","","",178,{"inputs":[{"name":"state"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed","","",178,{"inputs":[{"name":"state"},{"name":"block"}],"output":{"name":"result"}}],[11,"print_block_unclosed_indent","","",178,{"inputs":[{"name":"state"},{"name":"block"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_block_with_attrs","","",178,null],[11,"print_block_maybe_unclosed","","",178,null],[11,"print_if","","",178,{"inputs":[{"name":"state"},{"name":"expr"},{"name":"block"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_if_let","","",178,{"inputs":[{"name":"state"},{"name":"pat"},{"name":"expr"},{"name":"block"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_mac","","",178,{"inputs":[{"name":"state"},{"name":"spanned"},{"name":"delimtoken"}],"output":{"name":"result"}}],[11,"print_expr_maybe_paren","","",178,{"inputs":[{"name":"state"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_expr","","",178,{"inputs":[{"name":"state"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_local_decl","","",178,{"inputs":[{"name":"state"},{"name":"local"}],"output":{"name":"result"}}],[11,"print_decl","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_ident","","",178,{"inputs":[{"name":"state"},{"name":"ident"}],"output":{"name":"result"}}],[11,"print_usize","","",178,{"inputs":[{"name":"state"},{"name":"usize"}],"output":{"name":"result"}}],[11,"print_name","","",178,{"inputs":[{"name":"state"},{"name":"name"}],"output":{"name":"result"}}],[11,"print_for_decl","","",178,{"inputs":[{"name":"state"},{"name":"local"},{"name":"expr"}],"output":{"name":"result"}}],[11,"print_pat","","",178,{"inputs":[{"name":"state"},{"name":"pat"}],"output":{"name":"result"}}],[11,"print_fn","","",178,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"unsafety"},{"name":"abi"},{"name":"option"},{"name":"generics"},{"name":"option"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_fn_args","","",178,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_args_and_ret","","",178,{"inputs":[{"name":"state"},{"name":"fndecl"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_block_args","","",178,{"inputs":[{"name":"state"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_capture_clause","","",178,{"inputs":[{"name":"state"},{"name":"captureclause"}],"output":{"name":"result"}}],[11,"print_bounds","","",178,null],[11,"print_lifetime","","",178,{"inputs":[{"name":"state"},{"name":"lifetime"}],"output":{"name":"result"}}],[11,"print_lifetime_def","","",178,{"inputs":[{"name":"state"},{"name":"lifetimedef"}],"output":{"name":"result"}}],[11,"print_generics","","",178,{"inputs":[{"name":"state"},{"name":"generics"}],"output":{"name":"result"}}],[11,"print_ty_param","","",178,{"inputs":[{"name":"state"},{"name":"typaram"}],"output":{"name":"result"}}],[11,"print_where_clause","","",178,{"inputs":[{"name":"state"},{"name":"whereclause"}],"output":{"name":"result"}}],[11,"print_meta_item","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_view_path","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"print_mutability","","",178,{"inputs":[{"name":"state"},{"name":"mutability"}],"output":{"name":"result"}}],[11,"print_mt","","",178,{"inputs":[{"name":"state"},{"name":"mutty"}],"output":{"name":"result"}}],[11,"print_arg","","",178,{"inputs":[{"name":"state"},{"name":"arg"}],"output":{"name":"result"}}],[11,"print_fn_output","","",178,{"inputs":[{"name":"state"},{"name":"fndecl"}],"output":{"name":"result"}}],[11,"print_ty_fn","","",178,{"inputs":[{"name":"state"},{"name":"abi"},{"name":"unsafety"},{"name":"fndecl"},{"name":"option"},{"name":"generics"},{"name":"option"}],"output":{"name":"result"}}],[11,"maybe_print_trailing_comment","","",178,{"inputs":[{"name":"state"},{"name":"span"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_remaining_comments","","",178,{"inputs":[{"name":"state"}],"output":{"name":"result"}}],[11,"print_literal","","",178,{"inputs":[{"name":"state"},{"name":"spanned"}],"output":{"name":"result"}}],[11,"next_lit","","",178,{"inputs":[{"name":"state"},{"name":"bytepos"}],"output":{"name":"option"}}],[11,"maybe_print_comment","","",178,{"inputs":[{"name":"state"},{"name":"bytepos"}],"output":{"name":"result"}}],[11,"print_comment","","",178,{"inputs":[{"name":"state"},{"name":"comment"}],"output":{"name":"result"}}],[11,"print_string","","",178,{"inputs":[{"name":"state"},{"name":"str"},{"name":"strstyle"}],"output":{"name":"result"}}],[11,"next_comment","","",178,{"inputs":[{"name":"state"}],"output":{"name":"option"}}],[11,"print_opt_abi_and_extern_if_nondefault","","",178,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_extern_opt_abi","","",178,{"inputs":[{"name":"state"},{"name":"option"}],"output":{"name":"result"}}],[11,"print_fn_header_info","","",178,{"inputs":[{"name":"state"},{"name":"unsafety"},{"name":"abi"},{"name":"visibility"}],"output":{"name":"result"}}],[11,"print_unsafety","","",178,{"inputs":[{"name":"state"},{"name":"unsafety"}],"output":{"name":"result"}}],[4,"RenderSpan","rustc_driver::diagnostic","",null,null],[13,"FullSpan","","A FullSpan renders with both with an initial line for the\nmessage, prefixed by file:linenum, followed by a summary of\nthe source code covered by the span.",207,null],[13,"EndSpan","","Similar to a FullSpan, but the cited position is the end of\nthe span, instead of the start. Used, at least, for telling\ncompiletest/runtest to look at the last line of the span\n(since `end_highlight_lines` displays an arrow to the end\nof the span).",207,null],[13,"Suggestion","","A suggestion renders with both with an initial line for the\nmessage, prefixed by file:linenum, followed by a summary\nof hypothetical source code, where the `String` is spliced\ninto the lines in place of the code covered by the span.",207,null],[13,"FileLine","","A FileLine renders with just a line for the message prefixed\nby file:linenum.",207,null],[4,"ColorConfig","","",null,null],[13,"Auto","","",208,null],[13,"Always","","",208,null],[13,"Never","","",208,null],[8,"Emitter","","",null,null],[10,"emit","","",237,null],[10,"custom_emit","","",237,null],[3,"FatalError","","Used as a return value to signify a fatal error occurred. (It is also\nused as the argument to panic at the moment, but that will eventually\nnot be true.)",null,null],[3,"ExplicitBug","","Signifies that the compiler died with an explicit call to `.bug`\nor `.span_bug` rather than a failed assertion, etc.",null,null],[3,"SpanHandler","","A span-handler is like a handler but also\naccepts span information for source-location\nreporting.",null,null],[12,"handler","","",211,null],[12,"cm","","",211,null],[3,"Handler","","A handler deals with errors; certain errors\n(fatal, bug, unimpl) may cause immediate exit,\nothers log errors for later reporting.",null,null],[12,"can_emit_warnings","","",212,null],[5,"mk_span_handler","","",null,{"inputs":[{"name":"handler"},{"name":"codemap"}],"output":{"name":"spanhandler"}}],[5,"default_handler","","",null,{"inputs":[{"name":"colorconfig"},{"name":"option"},{"name":"bool"}],"output":{"name":"handler"}}],[5,"mk_handler","","",null,{"inputs":[{"name":"bool"},{"name":"box"}],"output":{"name":"handler"}}],[4,"Level","","",null,null],[13,"Bug","","",213,null],[13,"Fatal","","",213,null],[13,"Error","","",213,null],[13,"Warning","","",213,null],[13,"Note","","",213,null],[13,"Help","","",213,null],[3,"EmitterWriter","","",null,null],[5,"expect","","",null,{"inputs":[{"name":"spanhandler"},{"name":"option"},{"name":"m"}],"output":{"name":"t"}}],[3,"RustcDefaultCalls","rustc_driver","",null,null],[4,"Compilation","","",null,null],[13,"Stop","","",238,null],[13,"Continue","","",238,null],[5,"run","","",null,{"inputs":[{"name":"vec"}],"output":{"name":"isize"}}],[5,"run_compiler","","",null,null],[5,"release_str","","Returns a version string such as \"0.12.0-dev\".",null,{"inputs":[],"output":{"name":"option"}}],[5,"commit_hash_str","","Returns the full SHA1 hash of HEAD of the Git repo from which rustc was built.",null,{"inputs":[],"output":{"name":"option"}}],[5,"commit_date_str","","Returns the \"commit date\" of HEAD of the Git repo from which rustc was built as a static string.",null,{"inputs":[],"output":{"name":"option"}}],[5,"build_date_str","","",null,{"inputs":[],"output":{"name":"option"}}],[5,"version","","Prints version information and returns None on success or an error\nmessage on panic.",null,{"inputs":[{"name":"str"},{"name":"matches"}],"output":null}],[5,"handle_options","","Process command line options. Emits messages as appropriate. If compilation\nshould continue, returns a getopts::Matches object parsed from args, otherwise\nreturns None.",null,{"inputs":[{"name":"vec"}],"output":{"name":"option"}}],[5,"monitor","","Run a procedure which will detect panics in the compiler and print nicer\nerror messages rather than just failing the test.",null,{"inputs":[{"name":"f"}],"output":null}],[5,"diagnostics_registry","","",null,{"inputs":[],"output":{"name":"registry"}}],[5,"main","","",null,{"inputs":[],"output":null}],[0,"driver","","",null,null],[3,"CompileController","rustc_driver::driver","CompileController is used to customise compilation, it allows compilation to\nbe stopped and/or to call arbitrary code at various points in compilation.\nIt also allows for various flags to be set to influence what information gets\ncollected during compilation.",null,null],[12,"after_parse","","",239,null],[12,"after_expand","","",239,null],[12,"after_write_deps","","",239,null],[12,"after_analysis","","",239,null],[12,"after_llvm","","",239,null],[12,"make_glob_map","","",239,null],[3,"PhaseController","","",null,null],[12,"stop","","",240,null],[12,"callback","","",240,null],[3,"CompileState","","State that is passed to a callback. What state is available depends on when\nduring compilation the callback is made. See the various constructor methods\n(`state_*`) in the impl to see which data is provided for any given entry point.",null,null],[12,"input","","",241,null],[12,"session","","",241,null],[12,"cfg","","",241,null],[12,"krate","","",241,null],[12,"crate_name","","",241,null],[12,"output_filenames","","",241,null],[12,"out_dir","","",241,null],[12,"expanded_crate","","",241,null],[12,"ast_map","","",241,null],[12,"analysis","","",241,null],[12,"tcx","","",241,null],[12,"trans","","",241,null],[5,"compile_input","","",null,{"inputs":[{"name":"session"},{"name":"crateconfig"},{"name":"input"},{"name":"option"},{"name":"option"},{"name":"option"},{"name":"compilecontroller"}],"output":null}],[5,"anon_src","","The name used for source code that doesn't originate in a file\n(e.g. source from stdin or a string)",null,{"inputs":[],"output":{"name":"string"}}],[5,"source_name","","",null,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[5,"phase_1_parse_input","","",null,{"inputs":[{"name":"session"},{"name":"crateconfig"},{"name":"input"}],"output":{"name":"crate"}}],[5,"phase_2_configure_and_expand","","Run the \"early phases\" of the compiler: initial `cfg` processing,\nloading compiler plugins (including those from `addl_plugins`),\nsyntax expansion, secondary `cfg` expansion, synthesis of a test\nharness if one is to be provided and injection of a dependency on the\nstandard library and prelude.",null,{"inputs":[{"name":"session"},{"name":"crate"},{"name":"str"},{"name":"option"}],"output":{"name":"option"}}],[5,"assign_node_ids_and_map","","",null,{"inputs":[{"name":"session"},{"name":"forest"}],"output":{"name":"map"}}],[5,"phase_3_run_analysis_passes","","Run the resolution, typechecking, region checking and other\nmiscellaneous analysis passes on the crate. Return various\nstructures carrying the results of the analysis.",null,{"inputs":[{"name":"session"},{"name":"map"},{"name":"ctxtarenas"},{"name":"string"},{"name":"makeglobmap"}],"output":{"name":"crateanalysis"}}],[5,"phase_4_translate_to_llvm","","Run the translation phase to LLVM, after which the AST and analysis can\nbe discarded.",null,null],[5,"phase_5_run_llvm_passes","","Run LLVM itself, producing a bitcode file, assembly file or object file\nas a side effect.",null,{"inputs":[{"name":"session"},{"name":"cratetranslation"},{"name":"outputfilenames"}],"output":null}],[5,"phase_6_link_output","","Run the linker on any artifacts that resulted from the LLVM run.\nThis should produce either a finished executable or library.",null,{"inputs":[{"name":"session"},{"name":"cratetranslation"},{"name":"outputfilenames"}],"output":null}],[5,"collect_crate_types","","",null,null],[5,"collect_crate_metadata","","",null,null],[5,"build_output_filenames","","",null,null],[11,"basic","","",239,{"inputs":[{"name":"compilecontroller"}],"output":{"name":"compilecontroller"}}],[11,"basic","","",240,{"inputs":[{"name":"phasecontroller"}],"output":{"name":"phasecontroller"}}],[0,"pretty","rustc_driver","The various pretty print routines.",null,null],[4,"PpSourceMode","rustc_driver::pretty","",null,null],[13,"PpmNormal","","",242,null],[13,"PpmEveryBodyLoops","","",242,null],[13,"PpmExpanded","","",242,null],[13,"PpmTyped","","",242,null],[13,"PpmIdentified","","",242,null],[13,"PpmExpandedIdentified","","",242,null],[13,"PpmExpandedHygiene","","",242,null],[4,"PpFlowGraphMode","","",null,null],[13,"Default","","",243,null],[13,"UnlabelledEdges","","Drops the labels from the edges in the flowgraph output. This\nis mostly for use in the --xpretty flowgraph run-make tests,\nsince the labels are largely uninteresting in those cases and\nhave become a pain to maintain.",243,null],[4,"PpMode","","",null,null],[13,"PpmSource","","",244,null],[13,"PpmFlowGraph","","",244,null],[4,"UserIdentifiedItem","","",null,null],[13,"ItemViaNode","","",245,null],[13,"ItemViaPath","","",245,null],[5,"parse_pretty","","",null,null],[5,"pretty_print_input","","",null,{"inputs":[{"name":"session"},{"name":"crateconfig"},{"name":"input"},{"name":"ppmode"},{"name":"option"},{"name":"option"}],"output":null}],[11,"fmt","","",242,{"inputs":[{"name":"ppsourcemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",242,{"inputs":[{"name":"ppsourcemode"},{"name":"ppsourcemode"}],"output":{"name":"bool"}}],[11,"ne","","",242,{"inputs":[{"name":"ppsourcemode"},{"name":"ppsourcemode"}],"output":{"name":"bool"}}],[11,"clone","","",242,{"inputs":[{"name":"ppsourcemode"}],"output":{"name":"ppsourcemode"}}],[11,"fmt","","",243,{"inputs":[{"name":"ppflowgraphmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",243,{"inputs":[{"name":"ppflowgraphmode"},{"name":"ppflowgraphmode"}],"output":{"name":"bool"}}],[11,"ne","","",243,{"inputs":[{"name":"ppflowgraphmode"},{"name":"ppflowgraphmode"}],"output":{"name":"bool"}}],[11,"clone","","",243,{"inputs":[{"name":"ppflowgraphmode"}],"output":{"name":"ppflowgraphmode"}}],[11,"fmt","","",244,{"inputs":[{"name":"ppmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",244,{"inputs":[{"name":"ppmode"},{"name":"ppmode"}],"output":{"name":"bool"}}],[11,"ne","","",244,{"inputs":[{"name":"ppmode"},{"name":"ppmode"}],"output":{"name":"bool"}}],[11,"clone","","",244,{"inputs":[{"name":"ppmode"}],"output":{"name":"ppmode"}}],[11,"fmt","","",245,{"inputs":[{"name":"useridentifieditem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",245,{"inputs":[{"name":"useridentifieditem"}],"output":{"name":"useridentifieditem"}}],[6,"Err","","",null,null],[11,"from_str","","",245,{"inputs":[{"name":"useridentifieditem"},{"name":"str"}],"output":{"name":"result"}}],[8,"CompilerCalls","rustc_driver","",null,null],[10,"early_callback","","",246,{"inputs":[{"name":"compilercalls"},{"name":"matches"},{"name":"registry"}],"output":{"name":"compilation"}}],[10,"late_callback","","",246,{"inputs":[{"name":"compilercalls"},{"name":"matches"},{"name":"session"},{"name":"input"},{"name":"option"},{"name":"option"}],"output":{"name":"compilation"}}],[11,"some_input","","",246,null],[10,"no_input","","",246,{"inputs":[{"name":"compilercalls"},{"name":"matches"},{"name":"options"},{"name":"option"},{"name":"option"},{"name":"registry"}],"output":{"name":"option"}}],[11,"parse_pretty","","",246,{"inputs":[{"name":"compilercalls"},{"name":"session"},{"name":"matches"}],"output":{"name":"option"}}],[10,"build_controller","","",246,{"inputs":[{"name":"compilercalls"},{"name":"session"}],"output":{"name":"compilecontroller"}}],[11,"eq","","",238,{"inputs":[{"name":"compilation"},{"name":"compilation"}],"output":{"name":"bool"}}],[11,"ne","","",238,{"inputs":[{"name":"compilation"},{"name":"compilation"}],"output":{"name":"bool"}}],[11,"fmt","","",238,{"inputs":[{"name":"compilation"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"compilation"}],"output":{"name":"compilation"}}],[11,"and_then","","",238,{"inputs":[{"name":"compilation"},{"name":"f"}],"output":{"name":"compilation"}}],[11,"clone","","",247,{"inputs":[{"name":"rustcdefaultcalls"}],"output":{"name":"rustcdefaultcalls"}}],[11,"early_callback","","",247,{"inputs":[{"name":"rustcdefaultcalls"},{"name":"matches"},{"name":"registry"}],"output":{"name":"compilation"}}],[11,"no_input","","",247,{"inputs":[{"name":"rustcdefaultcalls"},{"name":"matches"},{"name":"options"},{"name":"option"},{"name":"option"},{"name":"registry"}],"output":{"name":"option"}}],[11,"parse_pretty","","",247,{"inputs":[{"name":"rustcdefaultcalls"},{"name":"session"},{"name":"matches"}],"output":{"name":"option"}}],[11,"late_callback","","",247,{"inputs":[{"name":"rustcdefaultcalls"},{"name":"matches"},{"name":"session"},{"name":"input"},{"name":"option"},{"name":"option"}],"output":{"name":"compilation"}}],[11,"build_controller","","",247,{"inputs":[{"name":"rustcdefaultcalls"},{"name":"session"}],"output":{"name":"compilecontroller"}}],[11,"list_metadata","","",247,{"inputs":[{"name":"rustcdefaultcalls"},{"name":"session"},{"name":"matches"},{"name":"input"}],"output":{"name":"compilation"}}]],"paths":[[3,"Interner"],[3,"RcStr"],[3,"StrInterner"],[3,"SmallVector"],[3,"IntoIter"],[3,"Registry"],[4,"Annotatable"],[3,"MacEager"],[3,"DummyResult"],[3,"BlockInfo"],[3,"ExtCtxt"],[3,"SyntaxEnv"],[4,"OrderingOp"],[4,"PtrTy"],[3,"Path"],[4,"Ty"],[3,"LifetimeBounds"],[3,"TraitDef"],[4,"StructType"],[3,"PatIdentFinder"],[3,"IdentRenamer"],[3,"PatIdentRenamer"],[3,"MacroExpander"],[3,"ExpansionConfig"],[3,"Marker"],[3,"MacroExterminator"],[4,"ArgumentType"],[4,"SyntaxContext_"],[4,"TokenTree"],[3,"Vec"],[3,"Spanned"],[4,"Option"],[3,"Ident"],[3,"Path"],[3,"Ty"],[3,"Block"],[3,"Arg"],[3,"Generics"],[3,"WhereClause"],[3,"P"],[3,"Arm"],[3,"Attribute_"],[3,"TtFrame"],[3,"TtReader"],[4,"LockstepIterSize"],[4,"TokenTreeOrTokenTreeVec"],[3,"MatcherTtFrame"],[3,"MatcherPos"],[3,"ParserAnyMacro"],[3,"MacroRulesMacroExpander"],[3,"Name"],[3,"Lifetime"],[3,"LifetimeDef"],[3,"PathSegment"],[4,"PathParameters"],[3,"AngleBracketedParameterData"],[3,"ParenthesizedParameterData"],[3,"DefId"],[4,"TyParamBound"],[4,"TraitBoundModifier"],[3,"TyParam"],[4,"WherePredicate"],[3,"WhereBoundPredicate"],[3,"WhereRegionPredicate"],[3,"WhereEqPredicate"],[3,"Crate"],[4,"MetaItem_"],[3,"Pat"],[3,"FieldPat"],[4,"BindingMode"],[4,"PatWildKind"],[4,"Pat_"],[4,"Mutability"],[4,"BinOp_"],[4,"UnOp"],[4,"Stmt_"],[4,"MacStmtStyle"],[4,"LocalSource"],[3,"Local"],[4,"Decl_"],[3,"Field"],[4,"BlockCheckMode"],[4,"UnsafeSource"],[3,"Expr"],[4,"Expr_"],[3,"QSelf"],[4,"MatchSource"],[4,"CaptureClause"],[3,"Delimited"],[3,"SequenceRepetition"],[4,"KleeneOp"],[4,"Mac_"],[4,"StrStyle"],[4,"Sign"],[4,"LitIntType"],[4,"Lit_"],[3,"MutTy"],[3,"TypeField"],[3,"MethodSig"],[3,"TraitItem"],[4,"TraitItem_"],[3,"ImplItem"],[4,"ImplItem_"],[4,"IntTy"],[4,"UintTy"],[4,"FloatTy"],[3,"TypeBinding"],[4,"PrimTy"],[3,"BareFnTy"],[4,"Ty_"],[4,"AsmDialect"],[3,"InlineAsm"],[3,"FnDecl"],[4,"Unsafety"],[4,"ImplPolarity"],[4,"FunctionRetTy"],[4,"ExplicitSelf_"],[3,"Mod"],[3,"ForeignMod"],[3,"VariantArg"],[4,"VariantKind"],[3,"EnumDef"],[3,"Variant_"],[4,"PathListItem_"],[4,"ViewPath_"],[4,"AttrStyle"],[3,"AttrId"],[3,"TraitRef"],[3,"PolyTraitRef"],[4,"Visibility"],[3,"StructField_"],[4,"StructFieldKind"],[3,"StructDef"],[3,"Item"],[4,"Item_"],[3,"ForeignItem"],[4,"ForeignItem_"],[4,"InlinedItem"],[3,"MacroDef"],[3,"Restrictions"],[4,"PathParsingMode"],[4,"BoundParsingMode"],[4,"TokenType"],[3,"Parser"],[4,"CommentStyle"],[3,"Comment"],[3,"Literal"],[3,"TokenAndSpan"],[3,"StringReader"],[4,"BinOpToken"],[4,"DelimToken"],[4,"IdentStyle"],[4,"SpecialMacroVar"],[4,"Lit"],[4,"Token"],[4,"Nonterminal"],[4,"Keyword"],[3,"InternedString"],[4,"ObsoleteSyntax"],[3,"ParseSess"],[4,"Os"],[4,"Abi"],[4,"Architecture"],[3,"AbiData"],[4,"AbiArchitecture"],[3,"FnLikeNode"],[4,"Code"],[4,"PathElem"],[3,"LinkedPathNode"],[3,"LinkedPath"],[4,"Node"],[4,"MapEntry"],[3,"InlinedParent"],[3,"Forest"],[3,"Map"],[3,"NodesMatchingSuffix"],[3,"IdAndSpanUpdater"],[3,"NodeCollector"],[3,"State"],[3,"IdRange"],[3,"IdVisitor"],[3,"IdRangeComputingVisitor"],[4,"InlineAttr"],[3,"Stability"],[4,"StabilityLevel"],[4,"ReprAttr"],[4,"IntType"],[3,"BytePos"],[3,"CharPos"],[3,"Span"],[3,"Loc"],[3,"LocWithOpt"],[3,"FileMapAndLine"],[3,"FileMapAndBytePos"],[4,"MacroFormat"],[3,"NameAndSpan"],[3,"ExpnInfo"],[3,"ExpnId"],[3,"LineInfo"],[3,"MultiByteChar"],[3,"FileMap"],[3,"CodeMap"],[4,"SpanSnippetError"],[3,"DistinctSources"],[3,"MalformedCodemapPositions"],[3,"Context"],[3,"CfgAttrFolder"],[4,"RenderSpan"],[4,"ColorConfig"],[3,"FatalError"],[3,"ExplicitBug"],[3,"SpanHandler"],[3,"Handler"],[4,"Level"],[3,"EmitterWriter"],[4,"Destination"],[4,"AttributeType"],[3,"Features"],[3,"MacroVisitor"],[3,"PostExpansionVisitor"],[3,"OwnedSlice"],[4,"Mode"],[3,"ShowSpanVisitor"],[3,"StandardLibraryInjector"],[3,"PreludeInjector"],[3,"TestHarnessGenerator"],[4,"HasTestSignature"],[4,"FnKind"],[4,"Breaks"],[3,"BreakToken"],[3,"BeginToken"],[4,"Token"],[4,"PrintStackBreak"],[3,"PrintStackElem"],[3,"Printer"],[3,"NoAnn"],[3,"CurrentCommentAndLiteral"],[8,"Emitter"],[4,"Compilation"],[3,"CompileController"],[3,"PhaseController"],[3,"CompileState"],[4,"PpSourceMode"],[4,"PpFlowGraphMode"],[4,"PpMode"],[4,"UserIdentifiedItem"],[8,"CompilerCalls"],[3,"RustcDefaultCalls"]]};
searchIndex['rustc_borrowck'] = {"items":[[0,"","rustc_borrowck","",null,null],[3,"FnPartsWithCFG","","This and a `ty::ctxt` is all you need to run the dataflow analyses\nused in the borrow checker.",null,null],[12,"fn_parts","","",0,null],[12,"cfg","","",0,null],[5,"check_crate","","",null,{"inputs":[{"name":"ctxt"}],"output":null}],[5,"build_borrowck_dataflow_data_for_fn","","Accessor for introspective clients inspecting `AnalysisData` and\nthe `BorrowckCtxt` itself , e.g. the flowgraph visualizer.",null,null],[0,"diagnostics","","",null,null],[7,"DIAGNOSTICS","rustc_borrowck::diagnostics","",null,null],[11,"from_fn_like","rustc_borrowck","",0,{"inputs":[{"name":"fnpartswithcfg"},{"name":"fnlikenode"},{"name":"cfg"}],"output":{"name":"fnpartswithcfg"}}],[0,"graphviz","","This module provides linkage between rustc::middle::graph and\nlibgraphviz traits, specialized to attaching borrowck analysis\ndata to rendered labels.",null,null],[11,"fmt","rustc_back::svh","",1,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"svh"},{"name":"svh"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"svh"}],"output":{"name":"svh"}}],[11,"new","","",1,{"inputs":[{"name":"svh"},{"name":"str"}],"output":{"name":"svh"}}],[11,"as_str","","",1,{"inputs":[{"name":"svh"}],"output":{"name":"str"}}],[11,"calculate","","",1,{"inputs":[{"name":"svh"},{"name":"vec"},{"name":"crate"}],"output":{"name":"svh"}}],[11,"fmt","","",1,{"inputs":[{"name":"svh"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","rustc_back::svh::svh_visitor","",2,null],[11,"hash","","",3,null],[11,"hash","","",4,null],[11,"get_content","syntax::ast","",5,{"inputs":[{"name":"ident"}],"output":{"name":"internedstring"}}],[11,"get_content","","",6,{"inputs":[{"name":"name"}],"output":{"name":"internedstring"}}],[11,"visit_mac","rustc_back::svh::svh_visitor","",7,null],[11,"visit_struct_def","","",7,null],[11,"visit_variant","","",7,null],[11,"visit_opt_lifetime_ref","","",7,null],[11,"visit_ident","","",7,null],[11,"visit_lifetime_ref","","",7,null],[11,"visit_lifetime_def","","",7,null],[11,"visit_expr","","",7,null],[11,"visit_stmt","","",7,null],[11,"visit_foreign_item","","",7,null],[11,"visit_item","","",7,null],[11,"visit_mod","","",7,null],[11,"visit_decl","","",7,null],[11,"visit_ty","","",7,null],[11,"visit_generics","","",7,null],[11,"visit_fn","","",7,null],[11,"visit_trait_item","","",7,null],[11,"visit_impl_item","","",7,null],[11,"visit_struct_field","","",7,null],[11,"visit_explicit_self","","",7,null],[11,"visit_path","","",7,null],[11,"visit_block","","",7,null],[11,"visit_pat","","",7,null],[11,"visit_local","","",7,null],[11,"visit_arm","","",7,null],[11,"open","rustc_back::archive","Opens an existing static archive",8,{"inputs":[{"name":"archive"},{"name":"archiveconfig"}],"output":{"name":"archive"}}],[11,"remove_file","","Removes a file from this archive",8,null],[11,"files","","Lists all files in an archive",8,{"inputs":[{"name":"archive"}],"output":{"name":"vec"}}],[11,"extend","","Creates an `ArchiveBuilder` for adding files to this archive.",8,{"inputs":[{"name":"archive"}],"output":{"name":"archivebuilder"}}],[11,"create","","Create a new static archive, ready for adding files.",9,{"inputs":[{"name":"archivebuilder"},{"name":"archiveconfig"}],"output":{"name":"archivebuilder"}}],[11,"add_native_library","","Adds all of the contents of a native library to this archive. This will\nsearch in the relevant locations for a library named `name`.",9,{"inputs":[{"name":"archivebuilder"},{"name":"str"}],"output":{"name":"result"}}],[11,"add_rlib","","Adds all of the contents of the rlib at the specified path to this\narchive.",9,{"inputs":[{"name":"archivebuilder"},{"name":"path"},{"name":"str"},{"name":"bool"}],"output":{"name":"result"}}],[11,"add_file","","Adds an arbitrary file to this archive",9,{"inputs":[{"name":"archivebuilder"},{"name":"path"}],"output":{"name":"result"}}],[11,"update_symbols","","Indicate that the next call to `build` should updates all symbols in\nthe archive (run 'ar s' over it).",9,null],[11,"build","","Combine the provided files, rlibs, and native libraries into a single\n`Archive`.",9,{"inputs":[{"name":"archivebuilder"}],"output":{"name":"archive"}}],[11,"tr_id","rustc::middle::astencode","Translates an internal id, meaning a node id that is known to refer to some part of the\nitem currently being inlined, such as a local variable or argument.  All naked node-ids\nthat appear in types have this property, since if something might refer to an external item\nwe would use a def-id to allow for the possibility that the item resides in another crate.",10,{"inputs":[{"name":"decodecontext"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"tr_def_id","","Translates an EXTERNAL def-id, converting the crate number from the one used in the encoded\ndata to the current crate numbers..  By external, I mean that it be translated to a\nreference to the item in its original crate, as opposed to being translated to a reference\nto the inlined version of the item.  This is typically, but not always, what you want,\nbecause most def-ids refer to external things like types or other fns that may or may not\nbe inlined.  Note that even when the inlined function is referencing itself recursively, we\nwould want `tr_def_id` for that reference--- conceptually the function calls the original,\nnon-inlined version, and trans deals with linking that recursive call to the inlined copy.",10,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_intern_def_id","","Translates an INTERNAL def-id, meaning a def-id that is\nknown to refer to some part of the item currently being\ninlined.  In that case, we want to convert the def-id to\nrefer to the current crate and to the new, inlined node-id.",10,{"inputs":[{"name":"decodecontext"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"tr_span","","Translates a `Span` from an extern crate to the corresponding `Span`\nwithin the local crate's codemap. `creader::import_codemap()` will\nalready have allocated any additionally needed FileMaps in the local\ncodemap as a side-effect of creating the crate_metadata's\n`codemap_import_info`.",10,{"inputs":[{"name":"decodecontext"},{"name":"span"}],"output":{"name":"span"}}],[11,"tr_intern","syntax::ast","",11,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","","",11,{"inputs":[{"name":"defid"},{"name":"decodecontext"}],"output":{"name":"defid"}}],[11,"tr","core::option","",12,{"inputs":[{"name":"option"},{"name":"decodecontext"}],"output":{"name":"option"}}],[11,"tr","syntax::codemap","",13,{"inputs":[{"name":"span"},{"name":"decodecontext"}],"output":{"name":"span"}}],[11,"fold_block","rustc::middle::astencode","",14,{"inputs":[{"name":"nesteditemsdropper"},{"name":"p"}],"output":{"name":"p"}}],[11,"tr","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"decodecontext"}],"output":{"name":"def"}}],[11,"tr","rustc::middle::ty","",16,{"inputs":[{"name":"region"},{"name":"decodecontext"}],"output":{"name":"region"}}],[11,"tr","","",17,{"inputs":[{"name":"freeregion"},{"name":"decodecontext"}],"output":{"name":"freeregion"}}],[11,"tr","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"decodecontext"}],"output":{"name":"codeextent"}}],[11,"tr","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"decodecontext"}],"output":{"name":"destructionscopedata"}}],[11,"tr","rustc::middle::ty","",20,{"inputs":[{"name":"boundregion"},{"name":"decodecontext"}],"output":{"name":"boundregion"}}],[11,"read_freevar_entry","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"read_capture_mode","","",21,{"inputs":[{"name":"decoder"}],"output":{"name":"captureclause"}}],[11,"tr","rustc::middle::ty","",22,{"inputs":[{"name":"freevar"},{"name":"decodecontext"}],"output":{"name":"freevar"}}],[11,"tr","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"decodecontext"}],"output":{"name":"upvarborrow"}}],[11,"tr","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"decodecontext"}],"output":{"name":"upvarcapture"}}],[11,"read_method_callee","rbml::reader","",21,null],[11,"tr","rustc::middle::ty","",25,{"inputs":[{"name":"methodorigin"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_vec_per_param_space","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_res_with_key","","",21,null],[11,"read_vtable_res","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vecperparamspace"}}],[11,"read_vtable_param_res","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_vtable_origin","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vtable_origin"}}],[11,"ty_str_ctxt","rustc::metadata::encoder","",26,{"inputs":[{"name":"encodecontext"}],"output":{"name":"ctxt"}}],[11,"emit_closure_type","rbml::writer","",27,null],[11,"emit_method_origin","","",27,null],[11,"emit_ty","","",27,null],[11,"emit_tys","","",27,null],[11,"emit_trait_ref","","",27,null],[11,"emit_type_param_def","","",27,null],[11,"emit_predicate","","",27,null],[11,"emit_type_scheme","","",27,null],[11,"emit_existential_bounds","","",27,null],[11,"emit_builtin_bounds","","",27,null],[11,"emit_substs","","",27,null],[11,"emit_auto_adjustment","","",27,null],[11,"emit_autoref","","",27,null],[11,"emit_auto_deref_ref","","",27,null],[11,"tag","","",27,null],[11,"id","","",27,null],[11,"visit_id","rustc::middle::astencode","",28,null],[11,"as_int","rbml","",29,{"inputs":[{"name":"doc"}],"output":{"name":"isize"}}],[11,"opt_child","","",29,{"inputs":[{"name":"doc"},{"name":"astencode_tag"}],"output":{"name":"option"}}],[11,"read_ty_nodcx","rbml::reader","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"tys"}}],[11,"read_tys_nodcx","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"vec"}}],[11,"read_substs_nodcx","","",21,{"inputs":[{"name":"decoder"},{"name":"ctxt"},{"name":"crate_metadata"}],"output":{"name":"substs"}}],[11,"read_method_origin","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"methodorigin"}}],[11,"read_ty","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"tys"}}],[11,"read_tys","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"vec"}}],[11,"read_trait_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"rc"}}],[11,"read_poly_trait_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"binder"}}],[11,"read_type_param_def","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typeparameterdef"}}],[11,"read_predicate","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"predicate"}}],[11,"read_type_scheme","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"typescheme"}}],[11,"read_existential_bounds","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"existentialbounds"}}],[11,"read_substs","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"substs"}}],[11,"read_auto_adjustment","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoadjustment"}}],[11,"read_auto_deref_ref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoderefref"}}],[11,"read_autoref","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"autoref"}}],[11,"read_closure_kind","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurekind"}}],[11,"read_closure_ty","","",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"}],"output":{"name":"closurety"}}],[11,"convert_def_id","","Converts a def-id that appears in a type.  The correct\ntranslation will depend on what kind of def-id this is.\nThis is a subtle point: type definitions are not\ninlined into the current crate, so if the def-id names\na nominal type or type alias, then it should be\ntranslated to refer to the source crate.",21,{"inputs":[{"name":"decoder"},{"name":"decodecontext"},{"name":"defidsource"},{"name":"defid"}],"output":{"name":"defid"}}],[11,"clone","rustc::middle::cfg::construct","",30,{"inputs":[{"name":"loopscope"}],"output":{"name":"loopscope"}}],[11,"graph_id","rustc::middle::cfg::graphviz","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"id"}}],[11,"node_id","","",31,null],[11,"node_label","","",31,null],[11,"edge_label","","",31,{"inputs":[{"name":"labelledcfg"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"edges","","",31,{"inputs":[{"name":"labelledcfg"}],"output":{"name":"cow"}}],[11,"source","","",31,null],[11,"target","","",31,null],[11,"eq","rustc::middle::cfg","",32,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"cfgnodedata"},{"name":"cfgnodedata"}],"output":{"name":"bool"}}],[11,"clone","","",32,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"cfgnodedata"}}],[11,"id","","",32,{"inputs":[{"name":"cfgnodedata"}],"output":{"name":"u32"}}],[11,"new","","",33,{"inputs":[{"name":"cfg"},{"name":"ctxt"},{"name":"block"}],"output":{"name":"cfg"}}],[11,"node_is_reachable","","",33,{"inputs":[{"name":"cfg"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"hash","rustc::middle::check_const","",34,null],[11,"cmp","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"option"}}],[11,"lt","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"le","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"gt","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ge","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"clone","","",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"ne","","",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"decode","","",34,{"inputs":[{"name":"constqualif"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",34,{"inputs":[{"name":"constqualif"},{"name":"__s"}],"output":{"name":"result"}}],[11,"empty","","Returns an empty set of flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"all","","Returns the set containing all flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"bits","","Returns the raw value of the flags currently stored.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"u8"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",34,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",34,{"inputs":[{"name":"constqualif"},{"name":"u8"}],"output":{"name":"constqualif"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",34,null],[11,"remove","","Removes the specified flags in-place.",34,null],[11,"toggle","","Toggles the specified flags in-place.",34,null],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitor","rustc::middle::check_const","Returns the union of the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitxor","rustc::middle::check_const","Returns the left flags, but with all the right flags toggled.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitand","rustc::middle::check_const","Returns the intersection between the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"sub","rustc::middle::check_const","Returns the set difference of the two sets of flags.",34,{"inputs":[{"name":"constqualif"},{"name":"constqualif"}],"output":{"name":"constqualif"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"not","rustc::middle::check_const","Returns the complement of this set of flags.",34,{"inputs":[{"name":"constqualif"}],"output":{"name":"constqualif"}}],[11,"eq","","",35,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"mode"},{"name":"mode"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"mode"}],"output":{"name":"mode"}}],[11,"visit_item","","",36,null],[11,"visit_fn","","",36,null],[11,"visit_pat","","",36,null],[11,"visit_expr","","",36,null],[11,"consume","","",36,null],[11,"borrow","","",36,null],[11,"decl_without_init","","",36,null],[11,"mutate","","",36,null],[11,"matched_pat","","",36,null],[11,"consume_pat","","",36,null],[11,"visit_item","rustc::middle::check_static_recursion","",37,null],[11,"visit_item","","",38,null],[11,"visit_expr","","",38,null],[11,"eq","rustc::middle::check_loop","",39,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"context"},{"name":"context"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"clone","","",40,{"inputs":[{"name":"checkloopvisitor"}],"output":{"name":"checkloopvisitor"}}],[11,"visit_item","","",40,null],[11,"visit_expr","","",40,null],[11,"fmt","rustc::middle::check_match","",41,{"inputs":[{"name":"matrix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",41,{"inputs":[{"name":"matrix"},{"name":"t"}],"output":{"name":"matrix"}}],[11,"eq","","",42,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"ne","","",42,{"inputs":[{"name":"constructor"},{"name":"constructor"}],"output":{"name":"bool"}}],[11,"clone","","",42,{"inputs":[{"name":"constructor"}],"output":{"name":"constructor"}}],[11,"eq","","",43,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"ne","","",43,{"inputs":[{"name":"usefulness"},{"name":"usefulness"}],"output":{"name":"bool"}}],[11,"clone","","",43,{"inputs":[{"name":"usefulness"}],"output":{"name":"usefulness"}}],[11,"clone","","",44,{"inputs":[{"name":"witnesspreference"}],"output":{"name":"witnesspreference"}}],[11,"visit_expr","","",45,null],[11,"visit_local","","",45,null],[11,"visit_fn","","",45,null],[11,"new","","",46,{"inputs":[{"name":"staticinliner"},{"name":"ctxt"},{"name":"option"}],"output":{"name":"staticinliner"}}],[11,"visit_id","","",47,null],[11,"fold_pat","","",46,{"inputs":[{"name":"staticinliner"},{"name":"p"}],"output":{"name":"p"}}],[11,"matched_pat","","",48,null],[11,"consume","","",48,null],[11,"consume_pat","","",48,null],[11,"borrow","","",48,null],[11,"decl_without_init","","",48,null],[11,"mutate","","",48,null],[11,"visit_pat","","",49,null],[11,"visit_fn","rustc::middle::check_rvalues","",50,null],[11,"consume","","",51,null],[11,"matched_pat","","",51,null],[11,"consume_pat","","",51,null],[11,"borrow","","",51,null],[11,"decl_without_init","","",51,null],[11,"mutate","","",51,null],[11,"eq","rustc::middle::const_eval","",52,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"ne","","",52,{"inputs":[{"name":"const_val"},{"name":"const_val"}],"output":{"name":"bool"}}],[11,"clone","","",52,{"inputs":[{"name":"const_val"}],"output":{"name":"const_val"}}],[11,"clone","","",53,{"inputs":[{"name":"constevalerr"}],"output":{"name":"constevalerr"}}],[11,"clone","","",54,{"inputs":[{"name":"errkind"}],"output":{"name":"errkind"}}],[11,"description","","",53,{"inputs":[{"name":"constevalerr"}],"output":{"name":"cow"}}],[11,"fmt","","",55,{"inputs":[{"name":"intty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",55,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"ne","","",55,{"inputs":[{"name":"intty"},{"name":"intty"}],"output":{"name":"bool"}}],[11,"clone","","",55,{"inputs":[{"name":"intty"}],"output":{"name":"intty"}}],[11,"fmt","","",56,{"inputs":[{"name":"uintty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",56,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"uintty"},{"name":"uintty"}],"output":{"name":"bool"}}],[11,"clone","","",56,{"inputs":[{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"from","","",55,{"inputs":[{"name":"intty"},{"name":"ctxt"},{"name":"intty"}],"output":{"name":"intty"}}],[11,"from","","",56,{"inputs":[{"name":"uintty"},{"name":"ctxt"},{"name":"uintty"}],"output":{"name":"uintty"}}],[11,"fmt","rustc::middle::dataflow","",57,{"inputs":[{"name":"entryorexit"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",57,{"inputs":[{"name":"entryorexit"}],"output":{"name":"entryorexit"}}],[11,"clone","","",58,{"inputs":[{"name":"dataflowcontext"}],"output":{"name":"dataflowcontext"}}],[11,"pre","","",58,{"inputs":[{"name":"dataflowcontext"},{"name":"state"},{"name":"annnode"}],"output":{"name":"result"}}],[11,"fmt","","",59,{"inputs":[{"name":"killfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",59,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"ne","","",59,{"inputs":[{"name":"killfrom"},{"name":"killfrom"}],"output":{"name":"bool"}}],[11,"clone","","",59,{"inputs":[{"name":"killfrom"}],"output":{"name":"killfrom"}}],[11,"new","","",58,{"inputs":[{"name":"dataflowcontext"},{"name":"ctxt"},{"name":"str"},{"name":"option"},{"name":"cfg"},{"name":"o"},{"name":"idrange"},{"name":"usize"}],"output":{"name":"dataflowcontext"}}],[11,"add_gen","","Indicates that `id` generates `bit`",58,null],[11,"add_kill","","Indicates that `id` kills `bit`",58,null],[11,"each_bit_on_entry","","Iterates through each bit that is set on entry to `id`.\nOnly useful after `propagate()` has been called.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_bit_for_node","","Iterates through each bit that is set on entry/exit to `cfgidx`.\nOnly useful after `propagate()` has been called.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"entryorexit"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_gen_bit","","Iterates through each bit in the gen set for `id`.",58,{"inputs":[{"name":"dataflowcontext"},{"name":"u32"},{"name":"f"}],"output":{"name":"bool"}}],[11,"add_kills_from_flow_exits","","Whenever you have a `break` or `continue` statement, flow\nexits through any number of enclosing scopes on its way to\nthe new destination. This function infers the kill bits of\nthose control operators based on the kill bits associated\nwith those scopes.",58,null],[11,"propagate","","Performs the data flow analysis.",58,null],[11,"join","","",60,{"inputs":[{"name":"union"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"join","","",61,{"inputs":[{"name":"subtract"},{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[11,"visit_struct_def","rustc::middle::dead","",62,null],[11,"visit_expr","","",62,null],[11,"visit_pat","","",62,null],[11,"visit_path","","",62,null],[11,"visit_item","","",62,null],[11,"visit_item","","",63,null],[11,"visit_item","","",64,null],[11,"visit_foreign_item","","",64,null],[11,"visit_fn","","",64,null],[11,"visit_struct_field","","",64,null],[11,"visit_trait_item","","",64,null],[11,"fmt","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",15,null],[11,"decode","","",15,{"inputs":[{"name":"def"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",15,{"inputs":[{"name":"def"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"def"},{"name":"def"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"def"}],"output":{"name":"def"}}],[11,"fmt","","",65,{"inputs":[{"name":"pathresolution"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"pathresolution"}}],[11,"full_def","","Get the definition, if fully resolved, otherwise panic.",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"def"}}],[11,"def_id","","Get the DefId, if fully resolved, otherwise panic.",65,{"inputs":[{"name":"pathresolution"}],"output":{"name":"defid"}}],[11,"new","","",65,{"inputs":[{"name":"pathresolution"},{"name":"def"},{"name":"lastprivate"},{"name":"usize"}],"output":{"name":"pathresolution"}}],[11,"clone","","",66,{"inputs":[{"name":"export"}],"output":{"name":"export"}}],[11,"fmt","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",67,null],[11,"decode","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"ne","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"methodprovenance"}],"output":{"name":"bool"}}],[11,"clone","","",67,{"inputs":[{"name":"methodprovenance"}],"output":{"name":"methodprovenance"}}],[11,"map","","",67,{"inputs":[{"name":"methodprovenance"},{"name":"f"}],"output":{"name":"methodprovenance"}}],[11,"local_node_id","","",15,{"inputs":[{"name":"def"}],"output":{"name":"u32"}}],[11,"def_id","","",15,{"inputs":[{"name":"def"}],"output":{"name":"defid"}}],[11,"variant_def_ids","","",15,{"inputs":[{"name":"def"}],"output":{"name":"option"}}],[11,"eq","rustc::middle::effect","",68,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"ne","","",68,{"inputs":[{"name":"unsafecontext"},{"name":"unsafecontext"}],"output":{"name":"bool"}}],[11,"clone","","",68,{"inputs":[{"name":"unsafecontext"}],"output":{"name":"unsafecontext"}}],[11,"visit_fn","","",69,null],[11,"visit_block","","",69,null],[11,"visit_expr","","",69,null],[11,"visit_item","rustc::middle::entry","",70,null],[11,"fmt","rustc::middle::expr_use_visitor","",71,{"inputs":[{"name":"loancause"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",71,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"ne","","",71,{"inputs":[{"name":"loancause"},{"name":"loancause"}],"output":{"name":"bool"}}],[11,"clone","","",71,{"inputs":[{"name":"loancause"}],"output":{"name":"loancause"}}],[11,"fmt","","",72,{"inputs":[{"name":"consumemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",72,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"ne","","",72,{"inputs":[{"name":"consumemode"},{"name":"consumemode"}],"output":{"name":"bool"}}],[11,"clone","","",72,{"inputs":[{"name":"consumemode"}],"output":{"name":"consumemode"}}],[11,"fmt","","",73,{"inputs":[{"name":"movereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",73,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"ne","","",73,{"inputs":[{"name":"movereason"},{"name":"movereason"}],"output":{"name":"bool"}}],[11,"clone","","",73,{"inputs":[{"name":"movereason"}],"output":{"name":"movereason"}}],[11,"fmt","","",74,{"inputs":[{"name":"matchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",74,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"ne","","",74,{"inputs":[{"name":"matchmode"},{"name":"matchmode"}],"output":{"name":"bool"}}],[11,"clone","","",74,{"inputs":[{"name":"matchmode"}],"output":{"name":"matchmode"}}],[11,"fmt","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"ne","","",75,{"inputs":[{"name":"trackmatchmode"},{"name":"trackmatchmode"}],"output":{"name":"bool"}}],[11,"clone","","",75,{"inputs":[{"name":"trackmatchmode"}],"output":{"name":"trackmatchmode"}}],[11,"fmt","","",76,{"inputs":[{"name":"mutatemode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",76,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"ne","","",76,{"inputs":[{"name":"mutatemode"},{"name":"mutatemode"}],"output":{"name":"bool"}}],[11,"clone","","",76,{"inputs":[{"name":"mutatemode"}],"output":{"name":"mutatemode"}}],[11,"clone","","",77,{"inputs":[{"name":"overloadedcalltype"}],"output":{"name":"overloadedcalltype"}}],[11,"new","","",78,{"inputs":[{"name":"exprusevisitor"},{"name":"delegate"},{"name":"typer"}],"output":{"name":"exprusevisitor"}}],[11,"walk_fn","","",78,null],[11,"consume_expr","","",78,null],[11,"walk_expr","","",78,null],[11,"hash","rustc::middle::fast_reject","",79,null],[11,"eq","","",79,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"ne","","",79,{"inputs":[{"name":"simplifiedtype"},{"name":"simplifiedtype"}],"output":{"name":"bool"}}],[11,"clone","","",79,{"inputs":[{"name":"simplifiedtype"}],"output":{"name":"simplifiedtype"}}],[11,"clone","rustc::middle::free_region","",80,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"new","","",80,{"inputs":[{"name":"freeregionmap"}],"output":{"name":"freeregionmap"}}],[11,"relate_free_regions_from_implications","","",80,null],[11,"relate_free_regions_from_predicates","","",80,null],[11,"relate_free_regions","","",80,null],[11,"sub_free_region","","Determines whether two free regions have a subregion relationship\nby walking the graph encoded in `map`.  Note that\nit is possible that `sub != sup` and `sub <= sup` and `sup <= sub`\n(that is, the user can give two different names to the same lifetime).",80,{"inputs":[{"name":"freeregionmap"},{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"is_subregion_of","","Determines whether one region is a subregion of another.  This is intended to run *after\ninference* and sadly the logic is somewhat duplicated with the code in infer.rs.",80,{"inputs":[{"name":"freeregionmap"},{"name":"ctxt"},{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"fmt","rustc::middle::graph","",81,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",82,{"inputs":[{"name":"nodeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",82,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"nodeindex"},{"name":"nodeindex"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"nodeindex"}],"output":{"name":"nodeindex"}}],[11,"fmt","","",83,{"inputs":[{"name":"edgeindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",83,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"ne","","",83,{"inputs":[{"name":"edgeindex"},{"name":"edgeindex"}],"output":{"name":"bool"}}],[11,"clone","","",83,{"inputs":[{"name":"edgeindex"}],"output":{"name":"edgeindex"}}],[11,"fmt","","",84,{"inputs":[{"name":"direction"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",84,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"node_id","","Returns unique id (unique with respect to the graph holding associated node).",82,{"inputs":[{"name":"nodeindex"}],"output":{"name":"usize"}}],[11,"edge_id","","Returns unique id (unique with respect to the graph holding associated edge).",83,{"inputs":[{"name":"edgeindex"}],"output":{"name":"usize"}}],[11,"new","","",85,{"inputs":[{"name":"graph"}],"output":{"name":"graph"}}],[11,"with_capacity","","",85,{"inputs":[{"name":"graph"},{"name":"usize"},{"name":"usize"}],"output":{"name":"graph"}}],[11,"all_nodes","","",85,null],[11,"all_edges","","",85,null],[11,"next_node_index","","",85,{"inputs":[{"name":"graph"}],"output":{"name":"nodeindex"}}],[11,"add_node","","",85,{"inputs":[{"name":"graph"},{"name":"n"}],"output":{"name":"nodeindex"}}],[11,"mut_node_data","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node_data","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"n"}}],[11,"node","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"node"}}],[11,"next_edge_index","","",85,{"inputs":[{"name":"graph"}],"output":{"name":"edgeindex"}}],[11,"add_edge","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"nodeindex"},{"name":"e"}],"output":{"name":"edgeindex"}}],[11,"mut_edge_data","","",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge_data","","",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"e"}}],[11,"edge","","",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"}],"output":{"name":"edge"}}],[11,"first_adjacent","","Accesses the index of the first edge adjacent to `node`.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"next_adjacent","","Accesses the next edge in a given direction.\nThis is useful if you wish to modify the graph while walking\nthe linked list of edges.",85,{"inputs":[{"name":"graph"},{"name":"edgeindex"},{"name":"direction"}],"output":{"name":"edgeindex"}}],[11,"each_node","","Iterates over all edges defined in the graph.",85,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_edge","","Iterates over all edges defined in the graph",85,{"inputs":[{"name":"graph"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_outgoing_edge","","Iterates over all outgoing edges from the node `from`",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_incoming_edge","","Iterates over all incoming edges to the node `target`",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"f"}],"output":{"name":"bool"}}],[11,"each_adjacent_edge","","Iterates over all edges adjacent to the node `node`\nin the direction `dir` (either `Outgoing` or `Incoming)",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"},{"name":"direction"},{"name":"f"}],"output":{"name":"bool"}}],[11,"iterate_until_fixed_point","","",85,null],[11,"depth_traverse","","",85,{"inputs":[{"name":"graph"},{"name":"nodeindex"}],"output":{"name":"depthfirsttraversal"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::graph","",86,{"inputs":[{"name":"depthfirsttraversal"}],"output":{"name":"option"}}],[11,"source","","",81,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"target","","",81,{"inputs":[{"name":"edge"}],"output":{"name":"nodeindex"}}],[11,"visit_fn","rustc::middle::intrinsicck","",87,null],[11,"visit_expr","","",87,null],[11,"repr","rustc::middle::ty","",88,{"inputs":[{"name":"transmuterestriction"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","rustc::middle::infer::bivariate","",89,{"inputs":[{"name":"bivariate"},{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"tag","","",89,{"inputs":[{"name":"bivariate"}],"output":{"name":"str"}}],[11,"tcx","","",89,{"inputs":[{"name":"bivariate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",89,{"inputs":[{"name":"bivariate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",89,{"inputs":[{"name":"bivariate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",89,{"inputs":[{"name":"bivariate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",89,{"inputs":[{"name":"bivariate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",89,{"inputs":[{"name":"bivariate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"clone","rustc::middle::infer::combine","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"tcx","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"ctxt"}}],[11,"switch_expected","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"combinefields"}}],[11,"equate","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"bivariate","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"bivariate"}}],[11,"sub","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"lub","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"glb","","",90,{"inputs":[{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"instantiate","","",90,{"inputs":[{"name":"combinefields"},{"name":"tys"},{"name":"relationdir"},{"name":"tyvid"}],"output":{"name":"result"}}],[11,"tcx","","",91,{"inputs":[{"name":"generalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",91,{"inputs":[{"name":"generalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",91,{"inputs":[{"name":"generalizer"},{"name":"region"}],"output":{"name":"region"}}],[11,"compare","core::result","",92,{"inputs":[{"name":"result"},{"name":"t"},{"name":"f"}],"output":{"name":"result"}}],[11,"new","rustc::middle::infer::equate","",93,{"inputs":[{"name":"equate"},{"name":"combinefields"}],"output":{"name":"equate"}}],[11,"tag","","",93,{"inputs":[{"name":"equate"}],"output":{"name":"str"}}],[11,"tcx","","",93,{"inputs":[{"name":"equate"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",93,{"inputs":[{"name":"equate"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",93,{"inputs":[{"name":"equate"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",93,{"inputs":[{"name":"equate"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",93,{"inputs":[{"name":"equate"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",93,{"inputs":[{"name":"equate"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"report_region_errors","rustc::middle::infer","",94,null],[11,"process_errors","","",94,{"inputs":[{"name":"inferctxt"},{"name":"vec"}],"output":{"name":"vec"}}],[11,"report_type_error","","",94,null],[11,"report_and_explain_type_error","","",94,null],[11,"values_str","","Returns a string of the form \"expected `{}`, found `{}`\", or None if this is a derived\nerror.",94,{"inputs":[{"name":"inferctxt"},{"name":"valuepairs"}],"output":{"name":"option"}}],[11,"expected_found_str","","",94,{"inputs":[{"name":"inferctxt"},{"name":"expected_found"}],"output":{"name":"option"}}],[11,"report_generic_bound_failure","","",94,null],[11,"report_concrete_failure","","",94,null],[11,"report_sub_sup_conflict","","",94,null],[11,"report_sup_sup_conflict","","",94,null],[11,"report_processed_errors","","",94,null],[11,"give_suggestion","","",94,null],[11,"give_expl_lifetime_param","","",94,null],[11,"report_inference_failure","","",94,null],[11,"note_region_origin","","",94,null],[11,"resolve","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"inferctxt"}],"output":{"name":"rc"}}],[11,"contains_error","","",95,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"resolve","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"inferctxt"}],"output":{"name":"binder"}}],[11,"contains_error","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"new","rustc::middle::infer::glb","",97,{"inputs":[{"name":"glb"},{"name":"combinefields"}],"output":{"name":"glb"}}],[11,"tag","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"str"}}],[11,"tcx","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",97,{"inputs":[{"name":"glb"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",97,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",97,{"inputs":[{"name":"glb"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",97,{"inputs":[{"name":"glb"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",97,{"inputs":[{"name":"glb"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",97,{"inputs":[{"name":"glb"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"higher_ranked_sub","rustc::middle::infer::combine","",90,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_lub","","",90,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"higher_ranked_glb","","",90,{"inputs":[{"name":"combinefields"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"tainted_regions","rustc::middle::infer","",94,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"region_vars_confined_to_snapshot","","Returns the set of region variables that do not affect any\ntypes/regions which existed before `snapshot` was\nstarted. This is used in the sub/lub/glb computations. The\nidea here is that when we are computing lub/glb of two\nregions, we sometimes create intermediate region variables.\nThose region variables may touch some of the skolemized or\nother \"forbidden\" regions we created to replace bound\nregions, but they don't really represent an \"external\"\nconstraint.",94,{"inputs":[{"name":"inferctxt"},{"name":"combinedsnapshot"}],"output":{"name":"vec"}}],[11,"new","rustc::middle::infer::lub","",98,{"inputs":[{"name":"lub"},{"name":"combinefields"}],"output":{"name":"lub"}}],[11,"tag","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"str"}}],[11,"tcx","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",98,{"inputs":[{"name":"lub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",98,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",98,{"inputs":[{"name":"lub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",98,{"inputs":[{"name":"lub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"infcx","","",98,{"inputs":[{"name":"lub"}],"output":{"name":"inferctxt"}}],[11,"relate_bound","","",98,{"inputs":[{"name":"lub"},{"name":"tys"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::region_inference::graphviz","",99,{"inputs":[{"name":"node"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",99,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"node"},{"name":"node"}],"output":{"name":"bool"}}],[11,"hash","","",99,null],[11,"clone","","",99,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"fmt","","",100,{"inputs":[{"name":"edge"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",100,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"edge"},{"name":"edge"}],"output":{"name":"bool"}}],[11,"clone","","",100,{"inputs":[{"name":"edge"}],"output":{"name":"edge"}}],[11,"graph_id","","",101,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"id"}}],[11,"node_id","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",101,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"edges","","",101,{"inputs":[{"name":"constraintgraph"}],"output":{"name":"cow"}}],[11,"source","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",101,{"inputs":[{"name":"constraintgraph"},{"name":"edge"}],"output":{"name":"node"}}],[11,"fmt","rustc::middle::infer::region_inference","",102,{"inputs":[{"name":"constraint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",102,null],[11,"eq","","",102,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"ne","","",102,{"inputs":[{"name":"constraint"},{"name":"constraint"}],"output":{"name":"bool"}}],[11,"clone","","",102,{"inputs":[{"name":"constraint"}],"output":{"name":"constraint"}}],[11,"eq","","",103,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"ne","","",103,{"inputs":[{"name":"generickind"},{"name":"generickind"}],"output":{"name":"bool"}}],[11,"fmt","","",103,{"inputs":[{"name":"generickind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",103,{"inputs":[{"name":"generickind"}],"output":{"name":"generickind"}}],[11,"hash","","",104,null],[11,"eq","","",104,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"ne","","",104,{"inputs":[{"name":"tworegions"},{"name":"tworegions"}],"output":{"name":"bool"}}],[11,"clone","","",104,{"inputs":[{"name":"tworegions"}],"output":{"name":"tworegions"}}],[11,"eq","","",105,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"ne","","",105,{"inputs":[{"name":"undologentry"},{"name":"undologentry"}],"output":{"name":"bool"}}],[11,"clone","","",105,{"inputs":[{"name":"undologentry"}],"output":{"name":"undologentry"}}],[11,"eq","","",106,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"ne","","",106,{"inputs":[{"name":"combinemaptype"},{"name":"combinemaptype"}],"output":{"name":"bool"}}],[11,"clone","","",106,{"inputs":[{"name":"combinemaptype"}],"output":{"name":"combinemaptype"}}],[11,"fmt","","",107,{"inputs":[{"name":"regionresolutionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"regionresolutionerror"}],"output":{"name":"regionresolutionerror"}}],[11,"fmt","","",108,{"inputs":[{"name":"sameregions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"sameregions"}],"output":{"name":"sameregions"}}],[11,"contains","","",108,{"inputs":[{"name":"sameregions"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"push","","",108,null],[11,"fmt","","",109,{"inputs":[{"name":"regionsnapshot"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"ctxt"}],"output":{"name":"regionvarbindings"}}],[11,"start_snapshot","","",110,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"regionsnapshot"}}],[11,"commit","","",110,null],[11,"rollback_to","","",110,null],[11,"num_vars","","",110,{"inputs":[{"name":"regionvarbindings"}],"output":{"name":"u32"}}],[11,"new_region_var","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvariableorigin"}],"output":{"name":"regionvid"}}],[11,"new_skolemized","","Creates a new skolemized region. Skolemized regions are fresh\nregions used when performing higher-ranked computations. They\nmust be used in a very particular way and are never supposed\nto \"escape\" out into error messages or the code at large.",110,{"inputs":[{"name":"regionvarbindings"},{"name":"boundregion"},{"name":"regionsnapshot"}],"output":{"name":"region"}}],[11,"new_bound","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"add_given","","",110,null],[11,"make_eqregion","","",110,null],[11,"make_subregion","","",110,null],[11,"verify_generic_bound","","See `Verify::VerifyGenericBound`",110,null],[11,"lub_regions","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"glb_regions","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"subregionorigin"},{"name":"region"},{"name":"region"}],"output":{"name":"region"}}],[11,"resolve_var","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionvid"}],"output":{"name":"region"}}],[11,"combine_vars","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"combinemaptype"},{"name":"region"},{"name":"region"},{"name":"subregionorigin"},{"name":"f"}],"output":{"name":"region"}}],[11,"vars_created_since_snapshot","","",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"}],"output":{"name":"vec"}}],[11,"tainted","","Computes all regions that have been related to `r0` in any way since the mark `mark` was\nmade---`r0` itself will be the first entry. This is used when checking whether skolemized\nregions are being improperly related to other regions.",110,{"inputs":[{"name":"regionvarbindings"},{"name":"regionsnapshot"},{"name":"region"}],"output":{"name":"vec"}}],[11,"resolve_regions","","This function performs the actual region resolution.  It must be\ncalled after all constraints have been added.  It performs a\nfixed-point iteration to find region values which satisfy all\nconstraints, assuming such values can be found; if they cannot,\nerrors are reported.",110,{"inputs":[{"name":"regionvarbindings"},{"name":"freeregionmap"},{"name":"u32"}],"output":{"name":"vec"}}],[11,"fmt","","",111,{"inputs":[{"name":"classification"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",111,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"ne","","",111,{"inputs":[{"name":"classification"},{"name":"classification"}],"output":{"name":"bool"}}],[11,"clone","","",111,{"inputs":[{"name":"classification"}],"output":{"name":"classification"}}],[11,"clone","","",112,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"repr","","",102,{"inputs":[{"name":"constraint"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",113,{"inputs":[{"name":"verify"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",112,{"inputs":[{"name":"varvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",114,{"inputs":[{"name":"regionandorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",103,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",103,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"to_ty","","",103,{"inputs":[{"name":"generickind"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::resolve","",115,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"inferctxt"}],"output":{"name":"opportunistictyperesolver"}}],[11,"tcx","","",115,{"inputs":[{"name":"opportunistictyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",115,{"inputs":[{"name":"opportunistictyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"tcx","","",116,{"inputs":[{"name":"fulltyperesolver"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",116,{"inputs":[{"name":"fulltyperesolver"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"fold_region","","",116,{"inputs":[{"name":"fulltyperesolver"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::infer::freshen","",117,{"inputs":[{"name":"typefreshener"},{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"tcx","","",117,{"inputs":[{"name":"typefreshener"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",117,{"inputs":[{"name":"typefreshener"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",117,{"inputs":[{"name":"typefreshener"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","rustc::middle::infer::sub","",118,{"inputs":[{"name":"sub"},{"name":"combinefields"}],"output":{"name":"sub"}}],[11,"tag","","",118,{"inputs":[{"name":"sub"}],"output":{"name":"str"}}],[11,"tcx","","",118,{"inputs":[{"name":"sub"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",118,{"inputs":[{"name":"sub"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",118,{"inputs":[{"name":"sub"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"tys","","",118,{"inputs":[{"name":"sub"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"regions","","",118,{"inputs":[{"name":"sub"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"binders","","",118,{"inputs":[{"name":"sub"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"fmt","rustc::middle::infer::type_variable","",119,{"inputs":[{"name":"relationdir"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",119,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"ne","","",119,{"inputs":[{"name":"relationdir"},{"name":"relationdir"}],"output":{"name":"bool"}}],[11,"clone","","",119,{"inputs":[{"name":"relationdir"}],"output":{"name":"relationdir"}}],[11,"new","","",120,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"typevariabletable"}}],[11,"var_diverges","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"relate_vars","","Records that `a <: b`, `a :> b`, or `a == b`, depending on `dir`.",120,null],[11,"instantiate_and_push","","Instantiates `vid` with the type `ty` and then pushes an entry onto `stack` for each of the\nrelations of `vid` to other variables. The relations will have the form `(ty, dir, vid1)`\nwhere `vid1` is some other variable id.",120,null],[11,"new_var","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"probe","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"tyvid"}],"output":{"name":"option"}}],[11,"replace_if_possible","","",120,{"inputs":[{"name":"typevariabletable"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"snapshot","","",120,{"inputs":[{"name":"typevariabletable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","",120,null],[11,"commit","","",120,null],[11,"types_escaping_snapshot","","Find the set of type variables that existed *before* `s`\nbut which have only been unified since `s` started, and\nreturn the types with which they were unified. So if we had\na type variable `V0`, then we started the snapshot, then we\ncreated a type variable `V1`, unifed `V0` with `T0`, and\nunified `V1` with `T1`, this function would return `{T0}`.",120,{"inputs":[{"name":"typevariabletable"},{"name":"snapshot"}],"output":{"name":"vec"}}],[6,"Value","rustc_borrowck::graphviz","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::type_variable","",121,null],[11,"fmt","rustc::middle::infer::unify","",122,{"inputs":[{"name":"varvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",122,{"inputs":[{"name":"varvalue"}],"output":{"name":"varvalue"}}],[11,"eq","","",122,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"ne","","",122,{"inputs":[{"name":"varvalue"},{"name":"varvalue"}],"output":{"name":"bool"}}],[11,"clone","","",123,{"inputs":[{"name":"delegate"}],"output":{"name":"delegate"}}],[11,"new","","",124,{"inputs":[{"name":"unificationtable"}],"output":{"name":"unificationtable"}}],[11,"snapshot","","Starts a new snapshot. Each snapshot must be either\nrolled back or committed in a \"LIFO\" (stack) order.",124,{"inputs":[{"name":"unificationtable"}],"output":{"name":"snapshot"}}],[11,"rollback_to","","Reverses all changes since the last snapshot. Also\nremoves any keys that have been created since then.",124,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",124,null],[11,"new_key","","",124,null],[6,"Value","rustc_borrowck::graphviz","",null,null],[6,"Undo","","",null,null],[11,"reverse","rustc::middle::infer::unify","",123,null],[11,"unify_var_var","","",124,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"k"}],"output":{"name":"result"}}],[11,"unify_var_value","","Sets the value of the key `a_id` to `b`. Because simple keys do not have any subtyping\nrelationships, if `a_id` already has a value, it must be the same as `b`.",124,{"inputs":[{"name":"unificationtable"},{"name":"k"},{"name":"v"}],"output":{"name":"result"}}],[11,"has_value","","",124,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"bool"}}],[11,"probe","","",124,{"inputs":[{"name":"unificationtable"},{"name":"k"}],"output":{"name":"option"}}],[6,"Value","rustc_borrowck::graphviz","",null,null],[11,"index","rustc::middle::ty","",125,{"inputs":[{"name":"intvid"}],"output":{"name":"u32"}}],[11,"from_index","","",125,{"inputs":[{"name":"intvid"},{"name":"u32"}],"output":{"name":"intvid"}}],[11,"tag","","",125,{"inputs":[{"name":"intvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"tys"}}],[6,"Value","rustc_borrowck::graphviz","",null,null],[11,"index","rustc::middle::ty","",127,{"inputs":[{"name":"floatvid"}],"output":{"name":"u32"}}],[11,"from_index","","",127,{"inputs":[{"name":"floatvid"},{"name":"u32"}],"output":{"name":"floatvid"}}],[11,"tag","","",127,{"inputs":[{"name":"floatvid"},{"name":"option"}],"output":{"name":"str"}}],[11,"to_type","syntax::ast","",128,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"fmt","rustc::middle::infer","",129,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",129,{"inputs":[{"name":"typeorigin"}],"output":{"name":"typeorigin"}}],[11,"fmt","","",129,{"inputs":[{"name":"typeorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",130,{"inputs":[{"name":"valuepairs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",130,{"inputs":[{"name":"valuepairs"}],"output":{"name":"valuepairs"}}],[11,"fmt","","",131,{"inputs":[{"name":"typetrace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",131,{"inputs":[{"name":"typetrace"}],"output":{"name":"typetrace"}}],[11,"fmt","","",132,{"inputs":[{"name":"subregionorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",132,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"subregionorigin"}}],[11,"fmt","","",133,{"inputs":[{"name":"lateboundregionconversiontime"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",133,{"inputs":[{"name":"lateboundregionconversiontime"}],"output":{"name":"lateboundregionconversiontime"}}],[11,"fmt","","",134,{"inputs":[{"name":"regionvariableorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",134,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"regionvariableorigin"}}],[11,"fmt","","",135,{"inputs":[{"name":"fixup_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",135,{"inputs":[{"name":"fixup_err"}],"output":{"name":"fixup_err"}}],[11,"freshen","","",94,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"type_var_diverges","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"freshener","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"typefreshener"}}],[11,"type_is_unconstrained_numeric","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"unconstrainednumeric"}}],[11,"equate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"equate"}}],[11,"sub","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"sub"}}],[11,"lub","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"lub"}}],[11,"glb","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typetrace"}],"output":{"name":"glb"}}],[11,"commit_unconditionally","","Execute `f` and commit the bindings",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"commit_if_ok","","Execute `f` and commit the bindings if closure `f` returns `Ok(_)`",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"commit_regions_if_ok","","Execute `f` and commit only the region bindings if successful.\nThe function f must be very careful not to leak any non-region\nvariables that get created.",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"result"}}],[11,"probe","","Execute `f` then unroll any bindings it creates",94,{"inputs":[{"name":"inferctxt"},{"name":"f"}],"output":{"name":"r"}}],[11,"add_given","","",94,null],[11,"sub_types","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"eq_types","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"sub_trait_refs","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"sub_poly_trait_refs","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"},{"name":"typeorigin"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"construct_skolemized_subst","","See `higher_ranked::construct_skolemized_subst`",94,null],[11,"skolemize_late_bound_regions","","See `higher_ranked::skolemize_late_bound_regions`",94,null],[11,"leak_check","","See `higher_ranked::leak_check`",94,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"}],"output":{"name":"result"}}],[11,"plug_leaks","","See `higher_ranked::plug_leaks`",94,{"inputs":[{"name":"inferctxt"},{"name":"hashmap"},{"name":"combinedsnapshot"},{"name":"t"}],"output":{"name":"t"}}],[11,"equality_predicate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"region_outlives_predicate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"binder"}],"output":{"name":"result"}}],[11,"next_ty_var_id","","",94,{"inputs":[{"name":"inferctxt"},{"name":"bool"}],"output":{"name":"tyvid"}}],[11,"next_ty_var","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_diverging_ty_var","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"tys"}}],[11,"next_ty_vars","","",94,{"inputs":[{"name":"inferctxt"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"next_int_var_id","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"intvid"}}],[11,"next_float_var_id","","",94,{"inputs":[{"name":"inferctxt"}],"output":{"name":"floatvid"}}],[11,"next_region_var","","",94,{"inputs":[{"name":"inferctxt"},{"name":"regionvariableorigin"}],"output":{"name":"region"}}],[11,"region_vars_for_defs","","",94,null],[11,"fresh_substs_for_generics","","Given a set of generics defined on a type or impl, returns a substitution mapping each\ntype/region parameter to a fresh inference variable.",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"}],"output":{"name":"substs"}}],[11,"fresh_substs_for_trait","","Given a set of generics defined on a trait, returns a substitution mapping each output\ntype/region parameter to a fresh inference variable, and mapping the self type to\n`self_ty`.",94,{"inputs":[{"name":"inferctxt"},{"name":"span"},{"name":"generics"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"fresh_bound_region","","",94,{"inputs":[{"name":"inferctxt"},{"name":"debruijnindex"}],"output":{"name":"region"}}],[11,"resolve_regions_and_report_errors","","",94,null],[11,"ty_to_string","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"string"}}],[11,"tys_to_string","","",94,null],[11,"trait_ref_to_string","","",94,{"inputs":[{"name":"inferctxt"},{"name":"rc"}],"output":{"name":"string"}}],[11,"shallow_resolve","","",94,{"inputs":[{"name":"inferctxt"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"resolve_type_vars_if_possible","","Where possible, replaces type/int/float variables in\n`value` with their final value. Note that region variables\nare unaffected. If a type variable has not been unified, it\nis left as is.  This is an idempotent operation that does\nnot affect inference state in any way and so you can do it\nat will.",94,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"t"}}],[11,"fully_resolve","","Attempts to resolve all type/region variables in\n`value`. Region inference must have been run already (e.g.,\nby calling `resolve_regions_and_report_errors`).  If some\nvariable was never unified, an `Err` results.",94,{"inputs":[{"name":"inferctxt"},{"name":"t"}],"output":{"name":"result"}}],[11,"type_error_message_str","","",94,null],[11,"type_error_message_str_with_expected","","",94,null],[11,"type_error_message","","",94,null],[11,"report_mismatched_types","","",94,null],[11,"replace_late_bound_regions_with_fresh_var","","",94,null],[11,"verify_generic_bound","","See `verify_generic_bound` method in `region_inference`",94,null],[11,"can_equate","","",94,{"inputs":[{"name":"inferctxt"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"span","","",131,{"inputs":[{"name":"typetrace"}],"output":{"name":"span"}}],[11,"types","","",131,{"inputs":[{"name":"typetrace"},{"name":"typeorigin"},{"name":"bool"},{"name":"tys"},{"name":"tys"}],"output":{"name":"typetrace"}}],[11,"dummy","","",131,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"typetrace"}}],[11,"repr","","",131,{"inputs":[{"name":"typetrace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",129,{"inputs":[{"name":"typeorigin"}],"output":{"name":"span"}}],[11,"repr","","",129,{"inputs":[{"name":"typeorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",132,{"inputs":[{"name":"subregionorigin"}],"output":{"name":"span"}}],[11,"repr","","",132,{"inputs":[{"name":"subregionorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"span","","",134,{"inputs":[{"name":"regionvariableorigin"}],"output":{"name":"span"}}],[11,"repr","","",134,{"inputs":[{"name":"regionvariableorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::implicator","",136,{"inputs":[{"name":"implication"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"hash","rustc::middle::lang_items","",137,null],[11,"eq","","",137,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"ne","","",137,{"inputs":[{"name":"langitem"},{"name":"langitem"}],"output":{"name":"bool"}}],[11,"clone","","",137,{"inputs":[{"name":"langitem"}],"output":{"name":"langitem"}}],[11,"from_u32","","",137,{"inputs":[{"name":"langitem"},{"name":"u32"}],"output":{"name":"option"}}],[11,"new","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"languageitems"}}],[11,"items","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"enumerate"}}],[11,"item_name","","",138,{"inputs":[{"name":"languageitems"},{"name":"usize"}],"output":{"name":"str"}}],[11,"require","","",138,{"inputs":[{"name":"languageitems"},{"name":"langitem"}],"output":{"name":"result"}}],[11,"from_builtin_kind","","",138,{"inputs":[{"name":"languageitems"},{"name":"builtinbound"}],"output":{"name":"result"}}],[11,"to_builtin_kind","","",138,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"fn_trait_kind","","",138,{"inputs":[{"name":"languageitems"},{"name":"defid"}],"output":{"name":"option"}}],[11,"char_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"slice_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"const_ptr_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mut_ptr_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i8_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i16_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i32_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"i64_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"isize_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u8_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u16_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u32_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"u64_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"usize_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f32_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"f64_impl","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"send_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sized_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"copy_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sync_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"drop_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"add_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"sub_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"mul_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"div_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"rem_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"neg_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"not_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitxor_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitand_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"bitor_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shl_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"shr_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"index_mut_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_from_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_to_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"range_full_struct","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"unsafe_cell_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"deref_mut_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_mut_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"fn_once_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eq_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"ord_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"str_eq_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_bounds_check_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"panic_fmt","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_malloc_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_free_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"strdup_uniq_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"start_fn","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"eh_personality","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"exchange_heap","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"owned_box","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"phantom_data","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_type","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"covariant_lifetime","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"contravariant_lifetime","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"invariant_lifetime","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"no_copy_bound","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"managed_bound","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"non_zero","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"stack_exhausted","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"debug_trait","","",138,{"inputs":[{"name":"languageitems"}],"output":{"name":"option"}}],[11,"visit_item","","",139,null],[11,"new","","",139,{"inputs":[{"name":"languageitemcollector"},{"name":"session"}],"output":{"name":"languageitemcollector"}}],[11,"collect_item","","",139,null],[11,"collect_local_language_items","","",139,null],[11,"collect_external_language_items","","",139,null],[11,"collect","","",139,null],[11,"eq","rustc::middle::liveness","",140,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"ne","","",140,{"inputs":[{"name":"variable"},{"name":"variable"}],"output":{"name":"bool"}}],[11,"clone","","",140,{"inputs":[{"name":"variable"}],"output":{"name":"variable"}}],[11,"eq","","",141,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"ne","","",141,{"inputs":[{"name":"livenode"},{"name":"livenode"}],"output":{"name":"bool"}}],[11,"clone","","",141,{"inputs":[{"name":"livenode"}],"output":{"name":"livenode"}}],[11,"fmt","","",142,{"inputs":[{"name":"livenodekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",142,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"ne","","",142,{"inputs":[{"name":"livenodekind"},{"name":"livenodekind"}],"output":{"name":"bool"}}],[11,"clone","","",142,{"inputs":[{"name":"livenodekind"}],"output":{"name":"livenodekind"}}],[11,"visit_fn","","",143,null],[11,"visit_local","","",143,null],[11,"visit_expr","","",143,null],[11,"visit_arm","","",143,null],[11,"fmt","","",141,{"inputs":[{"name":"livenode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",140,{"inputs":[{"name":"variable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",144,{"inputs":[{"name":"localinfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",144,{"inputs":[{"name":"localinfo"}],"output":{"name":"localinfo"}}],[11,"fmt","","",145,{"inputs":[{"name":"varkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",145,{"inputs":[{"name":"varkind"}],"output":{"name":"varkind"}}],[11,"visit_fn","","",146,null],[11,"visit_local","","",146,null],[11,"visit_expr","","",146,null],[11,"visit_arm","","",146,null],[11,"clone","","",147,{"inputs":[{"name":"users"}],"output":{"name":"users"}}],[11,"clone","","",148,{"inputs":[{"name":"specials"}],"output":{"name":"specials"}}],[11,"fmt","rustc::middle::mem_categorization","",149,{"inputs":[{"name":"categorization"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",149,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"ne","","",149,{"inputs":[{"name":"categorization"},{"name":"categorization"}],"output":{"name":"bool"}}],[11,"clone","","",149,{"inputs":[{"name":"categorization"}],"output":{"name":"categorization"}}],[11,"fmt","","",150,{"inputs":[{"name":"upvar"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",150,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"ne","","",150,{"inputs":[{"name":"upvar"},{"name":"upvar"}],"output":{"name":"bool"}}],[11,"clone","","",150,{"inputs":[{"name":"upvar"}],"output":{"name":"upvar"}}],[11,"fmt","","",151,{"inputs":[{"name":"pointerkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",151,null],[11,"eq","","",151,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"pointerkind"},{"name":"pointerkind"}],"output":{"name":"bool"}}],[11,"clone","","",151,{"inputs":[{"name":"pointerkind"}],"output":{"name":"pointerkind"}}],[11,"fmt","","",152,{"inputs":[{"name":"interiorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",152,null],[11,"eq","","",152,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"interiorkind"},{"name":"interiorkind"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"interiorkind"}],"output":{"name":"interiorkind"}}],[11,"fmt","","",153,{"inputs":[{"name":"fieldname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",153,null],[11,"eq","","",153,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"fieldname"},{"name":"fieldname"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"fieldname"}],"output":{"name":"fieldname"}}],[11,"fmt","","",154,{"inputs":[{"name":"interioroffsetkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",154,null],[11,"eq","","",154,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"interioroffsetkind"},{"name":"interioroffsetkind"}],"output":{"name":"bool"}}],[11,"clone","","",154,{"inputs":[{"name":"interioroffsetkind"}],"output":{"name":"interioroffsetkind"}}],[11,"fmt","","",155,{"inputs":[{"name":"elementkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",155,null],[11,"eq","","",155,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"elementkind"},{"name":"elementkind"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"elementkind"}],"output":{"name":"elementkind"}}],[11,"fmt","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",156,null],[11,"eq","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"fmt","","",157,{"inputs":[{"name":"note"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",157,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"ne","","",157,{"inputs":[{"name":"note"},{"name":"note"}],"output":{"name":"bool"}}],[11,"clone","","",157,{"inputs":[{"name":"note"}],"output":{"name":"note"}}],[11,"fmt","","",158,{"inputs":[{"name":"cmt_"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",158,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"ne","","",158,{"inputs":[{"name":"cmt_"},{"name":"cmt_"}],"output":{"name":"bool"}}],[11,"clone","","",158,{"inputs":[{"name":"cmt_"}],"output":{"name":"cmt_"}}],[11,"clone","","",159,{"inputs":[{"name":"deref_kind"}],"output":{"name":"deref_kind"}}],[11,"id","syntax::ast","",160,{"inputs":[{"name":"expr"}],"output":{"name":"u32"}}],[11,"span","","",160,{"inputs":[{"name":"expr"}],"output":{"name":"span"}}],[11,"id","","",161,{"inputs":[{"name":"pat"}],"output":{"name":"u32"}}],[11,"span","","",161,{"inputs":[{"name":"pat"}],"output":{"name":"span"}}],[11,"clone","rustc::middle::mem_categorization","",162,{"inputs":[{"name":"memcategorizationcontext"}],"output":{"name":"memcategorizationcontext"}}],[11,"from_mutbl","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"mutability"}],"output":{"name":"mutabilitycategory"}}],[11,"from_borrow_kind","","",156,{"inputs":[{"name":"mutabilitycategory"},{"name":"borrowkind"}],"output":{"name":"mutabilitycategory"}}],[11,"inherit","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"mutabilitycategory"}}],[11,"is_mutable","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"is_immutable","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"bool"}}],[11,"to_user_str","","",156,{"inputs":[{"name":"mutabilitycategory"}],"output":{"name":"str"}}],[11,"new","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"typer"}],"output":{"name":"memcategorizationcontext"}}],[11,"cat_expr","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_expr_autoderefd","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"},{"name":"usize"}],"output":{"name":"result"}}],[11,"cat_expr_unadjusted","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"expr"}],"output":{"name":"result"}}],[11,"cat_def","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"},{"name":"def"}],"output":{"name":"result"}}],[11,"temporary_scope","","Returns the lifetime of a temporary created by expr with id `id`.\nThis could be `'static` if `id` is part of a constant expression.",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"}],"output":{"name":"region"}}],[11,"cat_rvalue_node","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_rvalue","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"u32"},{"name":"span"},{"name":"region"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_field","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"name"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_tup_field","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"usize"},{"name":"tys"}],"output":{"name":"rc"}}],[11,"cat_index","","Creates a cmt for an indexing operation (`[]`).",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"interioroffsetkind"}],"output":{"name":"result"}}],[11,"cat_slice_pattern","","Given a pattern P like: `[_, ..Q, _]`, where `vec_cmt` is the cmt for `P`, `slice_pat` is\nthe pattern `Q`, returns:",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"}],"output":{"name":"result"}}],[11,"cat_imm_interior","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"interiorkind"}],"output":{"name":"rc"}}],[11,"cat_downcast","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"n"},{"name":"rc"},{"name":"tys"},{"name":"defid"}],"output":{"name":"rc"}}],[11,"cat_pattern","","",162,{"inputs":[{"name":"memcategorizationcontext"},{"name":"rc"},{"name":"pat"},{"name":"f"}],"output":{"name":"result"}}],[11,"fmt","","",163,{"inputs":[{"name":"interiorsafety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",163,{"inputs":[{"name":"interiorsafety"}],"output":{"name":"interiorsafety"}}],[11,"fmt","","",164,{"inputs":[{"name":"aliasability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",164,{"inputs":[{"name":"aliasability"}],"output":{"name":"aliasability"}}],[11,"fmt","","",165,{"inputs":[{"name":"aliasablereason"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",165,{"inputs":[{"name":"aliasablereason"}],"output":{"name":"aliasablereason"}}],[11,"guarantor","","Returns `self` after stripping away any owned pointer derefs or\ninterior content. The return value is basically the `cmt` which\ndetermines how long the value in `self` remains live.",158,{"inputs":[{"name":"cmt_"}],"output":{"name":"rc"}}],[11,"freely_aliasable","","Returns `FreelyAliasable(_)` if this lvalue represents a freely aliasable pointer type.",158,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"aliasability"}}],[11,"upvar","","",158,{"inputs":[{"name":"cmt_"}],"output":{"name":"option"}}],[11,"descriptive_string","","",158,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",158,{"inputs":[{"name":"cmt_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",149,{"inputs":[{"name":"categorization"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",151,{"inputs":[{"name":"pointerkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",152,{"inputs":[{"name":"interiorkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",166,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::mem_categorization","",150,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",150,{"inputs":[{"name":"upvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::privacy","",167,{"inputs":[{"name":"lastprivate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",167,{"inputs":[{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"fmt","","",168,{"inputs":[{"name":"privatedep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",168,{"inputs":[{"name":"privatedep"}],"output":{"name":"privatedep"}}],[11,"fmt","","",169,{"inputs":[{"name":"importuse"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",169,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"ne","","",169,{"inputs":[{"name":"importuse"},{"name":"importuse"}],"output":{"name":"bool"}}],[11,"clone","","",169,{"inputs":[{"name":"importuse"}],"output":{"name":"importuse"}}],[11,"or","","",167,{"inputs":[{"name":"lastprivate"},{"name":"lastprivate"}],"output":{"name":"lastprivate"}}],[11,"visit_expr","rustc::middle::reachable","",170,null],[11,"visit_item","","",170,null],[11,"fmt","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",18,{"inputs":[{"name":"codeextent"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",18,{"inputs":[{"name":"codeextent"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",18,null],[11,"cmp","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"lt","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"le","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"gt","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ge","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"eq","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"ne","","",18,{"inputs":[{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"clone","","",18,{"inputs":[{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"fmt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",19,null],[11,"cmp","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"option"}}],[11,"lt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"le","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"gt","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ge","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"eq","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"ne","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"destructionscopedata"}],"output":{"name":"bool"}}],[11,"clone","","",19,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"destructionscopedata"}}],[11,"new","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"u32"}],"output":{"name":"destructionscopedata"}}],[11,"to_code_extent","","",19,{"inputs":[{"name":"destructionscopedata"}],"output":{"name":"codeextent"}}],[11,"fmt","","",171,{"inputs":[{"name":"blockremainder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",171,{"inputs":[{"name":"blockremainder"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",171,{"inputs":[{"name":"blockremainder"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",171,null],[11,"cmp","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"option"}}],[11,"lt","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"le","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"gt","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ge","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"eq","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"ne","","",171,{"inputs":[{"name":"blockremainder"},{"name":"blockremainder"}],"output":{"name":"bool"}}],[11,"clone","","",171,{"inputs":[{"name":"blockremainder"}],"output":{"name":"blockremainder"}}],[11,"from_node_id","","Creates a scope that represents the dynamic extent associated\nwith `node_id`.",18,{"inputs":[{"name":"codeextent"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"node_id","","Returns a node id associated with this scope.",18,{"inputs":[{"name":"codeextent"}],"output":{"name":"u32"}}],[11,"map_id","","Maps this scope to a potentially new one according to the\nNodeId transformer `f_id`.",18,{"inputs":[{"name":"codeextent"},{"name":"f"}],"output":{"name":"codeextent"}}],[11,"span","","Returns the span of this CodeExtent.  Note that in general the\nreturned span may not correspond to the span of any node id in\nthe AST.",18,{"inputs":[{"name":"codeextent"},{"name":"map"}],"output":{"name":"option"}}],[11,"clone","","",172,{"inputs":[{"name":"innermostdeclaringblock"}],"output":{"name":"innermostdeclaringblock"}}],[11,"fmt","","",172,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",172,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"ne","","",172,{"inputs":[{"name":"innermostdeclaringblock"},{"name":"innermostdeclaringblock"}],"output":{"name":"bool"}}],[11,"clone","","",173,{"inputs":[{"name":"declaringstatementcontext"}],"output":{"name":"declaringstatementcontext"}}],[11,"fmt","","",173,{"inputs":[{"name":"declaringstatementcontext"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",173,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"ne","","",173,{"inputs":[{"name":"declaringstatementcontext"},{"name":"declaringstatementcontext"}],"output":{"name":"bool"}}],[11,"clone","","",174,{"inputs":[{"name":"innermostenclosingexpr"}],"output":{"name":"innermostenclosingexpr"}}],[11,"fmt","","",174,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",174,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"ne","","",174,{"inputs":[{"name":"innermostenclosingexpr"},{"name":"innermostenclosingexpr"}],"output":{"name":"bool"}}],[11,"clone","","",175,{"inputs":[{"name":"context"}],"output":{"name":"context"}}],[11,"fmt","","",175,{"inputs":[{"name":"context"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"each_encl_scope","","",176,null],[11,"each_var_scope","","",176,null],[11,"each_rvalue_scope","","",176,null],[11,"each_terminating_scope","","",176,null],[11,"record_encl_scope","","",176,null],[11,"opt_encl_scope","","Returns the narrowest scope that encloses `id`, if any.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"option"}}],[11,"encl_scope","","Returns the narrowest scope that encloses `id`, if any.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"var_scope","","Returns the lifetime of the local variable `var_id`",176,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"codeextent"}}],[11,"temporary_scope","","Returns the scope when temp created by expr_id will be cleaned up",176,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"option"}}],[11,"var_region","","Returns the lifetime of the variable `id`.",176,{"inputs":[{"name":"regionmaps"},{"name":"u32"}],"output":{"name":"region"}}],[11,"scopes_intersect","","",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"is_subscope_of","","Returns true if `subscope` is equal to or is lexically nested inside `superscope` and false\notherwise.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"bool"}}],[11,"nearest_common_ancestor","","Finds the nearest common ancestor (if any) of two scopes.  That is, finds the smallest\nscope which is greater than or equal to both `scope_a` and `scope_b`.",176,{"inputs":[{"name":"regionmaps"},{"name":"codeextent"},{"name":"codeextent"}],"output":{"name":"codeextent"}}],[11,"visit_block","","",177,null],[11,"visit_item","","",177,null],[11,"visit_fn","","",177,null],[11,"visit_arm","","",177,null],[11,"visit_pat","","",177,null],[11,"visit_stmt","","",177,null],[11,"visit_expr","","",177,null],[11,"visit_local","","",177,null],[11,"fmt","rustc::middle::resolve_lifetime","",178,{"inputs":[{"name":"defregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",178,{"inputs":[{"name":"defregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",178,{"inputs":[{"name":"defregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",178,null],[11,"eq","","",178,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"ne","","",178,{"inputs":[{"name":"defregion"},{"name":"defregion"}],"output":{"name":"bool"}}],[11,"clone","","",178,{"inputs":[{"name":"defregion"}],"output":{"name":"defregion"}}],[11,"visit_item","","",179,null],[11,"visit_fn","","",179,null],[11,"visit_ty","","",179,null],[11,"visit_trait_item","","",179,null],[11,"visit_block","","",179,null],[11,"visit_lifetime_ref","","",179,null],[11,"visit_generics","","",179,null],[11,"visit_poly_trait_ref","","",179,null],[11,"eq","","",180,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"ne","","",180,{"inputs":[{"name":"shadowkind"},{"name":"shadowkind"}],"output":{"name":"bool"}}],[11,"clone","","",180,{"inputs":[{"name":"shadowkind"}],"output":{"name":"shadowkind"}}],[11,"fmt","","",181,{"inputs":[{"name":"scopechain"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"visit_item","rustc::middle::stability","",182,null],[11,"visit_fn","","",182,null],[11,"visit_trait_item","","",182,null],[11,"visit_impl_item","","",182,null],[11,"visit_variant","","",182,null],[11,"visit_struct_field","","",182,null],[11,"visit_foreign_item","","",182,null],[11,"build","","Construct the stability index for a crate being compiled.",183,null],[11,"new","","",183,{"inputs":[{"name":"index"},{"name":"crate"}],"output":{"name":"index"}}],[11,"visit_item","","",184,null],[11,"visit_expr","","",184,null],[11,"visit_path","","",184,null],[11,"visit_pat","","",184,null],[11,"fmt","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",185,null],[11,"eq","","",185,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"substs"},{"name":"substs"}],"output":{"name":"bool"}}],[11,"clone","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"fmt","","",186,{"inputs":[{"name":"regionsubsts"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",186,null],[11,"eq","","",186,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"ne","","",186,{"inputs":[{"name":"regionsubsts"},{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"clone","","",186,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"regionsubsts"}}],[11,"new","","",185,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"new_type","","",185,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"new_trait","","",185,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erased","","",185,{"inputs":[{"name":"substs"},{"name":"vecperparamspace"}],"output":{"name":"substs"}}],[11,"empty","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"trans_empty","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"is_noop","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"type_for_def","","",185,{"inputs":[{"name":"substs"},{"name":"typeparameterdef"}],"output":{"name":"tys"}}],[11,"has_regions_escaping_depth","","",185,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"self_ty","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"option"}}],[11,"with_self_ty","","",185,{"inputs":[{"name":"substs"},{"name":"tys"}],"output":{"name":"substs"}}],[11,"erase_regions","","",185,{"inputs":[{"name":"substs"}],"output":{"name":"substs"}}],[11,"regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",185,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"mut_regions","","Since ErasedRegions are only to be used in trans, most of the compiler can use this method\nto easily access the set of region substitutions.",185,{"inputs":[{"name":"substs"}],"output":{"name":"vecperparamspace"}}],[11,"with_method","","",185,{"inputs":[{"name":"substs"},{"name":"vec"},{"name":"vec"}],"output":{"name":"substs"}}],[11,"is_erased","","",186,{"inputs":[{"name":"regionsubsts"}],"output":{"name":"bool"}}],[11,"fmt","","",187,{"inputs":[{"name":"paramspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",187,{"inputs":[{"name":"paramspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",187,{"inputs":[{"name":"paramspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",187,null],[11,"clone","","",187,{"inputs":[{"name":"paramspace"}],"output":{"name":"paramspace"}}],[11,"eq","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ne","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"cmp","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"lt","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"le","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"gt","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"ge","","",187,{"inputs":[{"name":"paramspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"all","","",187,null],[11,"to_uint","","",187,{"inputs":[{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"from_uint","","",187,{"inputs":[{"name":"paramspace"},{"name":"usize"}],"output":{"name":"paramspace"}}],[11,"decode","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",188,null],[11,"clone","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"eq","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"ne","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"fmt","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"empty","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vecperparamspace"}}],[11,"params_from_type","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"new","","`t` is the type space.\n`s` is the self space.\n`a` is the assoc space.\n`f` is the fn space.",188,{"inputs":[{"name":"vecperparamspace"},{"name":"vec"},{"name":"vec"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"push","","Appends `value` to the vector associated with `space`.",188,null],[11,"extend","","Appends `values` to the vector associated with `space`.",188,null],[11,"pop","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"option"}}],[11,"truncate","","",188,null],[11,"replace","","",188,null],[11,"get_self","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"option"}}],[11,"len","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"usize"}}],[11,"is_empty_in","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"get_slice","","",188,null],[11,"get_mut_slice","","",188,null],[11,"opt_get","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"usize"}],"output":{"name":"t"}}],[11,"iter","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"iter"}}],[11,"into_iter","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[11,"iter_enumerated","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"enumerateditems"}}],[11,"as_slice","","",188,null],[11,"into_vec","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"vec"}}],[11,"all_vecs","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"all","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"any","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"bool"}}],[11,"is_empty","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"map","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_enumerated","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"p"}],"output":{"name":"vecperparamspace"}}],[11,"map_move","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"split","","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"separatevecsperparamspace"}}],[11,"with_vec","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"paramspace"},{"name":"vec"}],"output":{"name":"vecperparamspace"}}],[11,"clone","","",189,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"enumerateditems"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::subst","",189,{"inputs":[{"name":"enumerateditems"}],"output":{"name":"option"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","rustc::middle::subst","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"intoiter"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[6,"IntoIter","","",null,null],[11,"tcx","rustc::middle::subst","",190,{"inputs":[{"name":"substfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",190,null],[11,"exit_region_binder","","",190,null],[11,"fold_region","","",190,{"inputs":[{"name":"substfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"fold_ty","","",190,{"inputs":[{"name":"substfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","rustc::middle::traits::coherence","",191,{"inputs":[{"name":"inferislocal"}],"output":{"name":"inferislocal"}}],[11,"clone","rustc::middle::traits::fulfill","",192,{"inputs":[{"name":"regionobligation"}],"output":{"name":"regionobligation"}}],[11,"new","","",193,{"inputs":[{"name":"fulfillmentcontext"}],"output":{"name":"fulfillmentcontext"}}],[11,"normalize_projection_type","","\"Normalize\" a projection type `<SomeType as SomeTrait>::X` by\ncreating a fresh type variable `$0` as well as a projection\npredicate `<SomeType as SomeTrait>::X == $0`. When the\ninference engine runs, it will attempt to find an impl of\n`SomeTrait` or a where clause that lets us unify `$0` with\nsomething concrete. If this fails, we'll unify `$0` with\n`projection_ty` again.",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"},{"name":"projectionty"},{"name":"obligationcause"}],"output":{"name":"tys"}}],[11,"register_builtin_bound","","",193,null],[11,"register_region_obligation","","",193,null],[11,"register_predicate_obligation","","",193,null],[11,"region_obligations","","",193,null],[11,"select_all_or_error","","",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_new_obligations","","Attempts to select obligations that were registered since the call to a selection routine.\nThis is used by the type checker to eagerly attempt to resolve obligations in hopes of\ngaining type information. It'd be equally valid to use `select_where_possible` but it\nresults in `O(n^2)` performance (#18208).",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"select_where_possible","","",193,{"inputs":[{"name":"fulfillmentcontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"result"}}],[11,"pending_obligations","","",193,null],[11,"repr","","",192,{"inputs":[{"name":"regionobligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::project","",194,{"inputs":[{"name":"mismatchedprojectiontypes"}],"output":{"name":"mismatchedprojectiontypes"}}],[11,"eq","","",195,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"ne","","",195,{"inputs":[{"name":"projectiontycandidate"},{"name":"projectiontycandidate"}],"output":{"name":"bool"}}],[11,"tcx","","",196,{"inputs":[{"name":"associatedtypenormalizer"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",196,{"inputs":[{"name":"associatedtypenormalizer"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"clone","","",197,{"inputs":[{"name":"normalized"}],"output":{"name":"normalized"}}],[11,"with","","",197,{"inputs":[{"name":"normalized"},{"name":"u"}],"output":{"name":"normalized"}}],[11,"repr","","",198,{"inputs":[{"name":"projectiontyerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",195,{"inputs":[{"name":"projectiontycandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","","",197,{"inputs":[{"name":"normalized"},{"name":"f"}],"output":{"name":"normalized"}}],[11,"repr","","",197,{"inputs":[{"name":"normalized"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","rustc::middle::traits::object_safety","",199,{"inputs":[{"name":"methodviolationcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",199,{"inputs":[{"name":"methodviolationcode"}],"output":{"name":"methodviolationcode"}}],[11,"repr","","",200,{"inputs":[{"name":"objectsafetyviolation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","rustc::middle::traits::select","",201,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"fmt","","",202,{"inputs":[{"name":"methodmatcheddata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",202,{"inputs":[{"name":"methodmatcheddata"}],"output":{"name":"methodmatcheddata"}}],[11,"clone","","",203,{"inputs":[{"name":"selectioncandidate"}],"output":{"name":"selectioncandidate"}}],[11,"fmt","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"ne","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"selectioncandidate"}],"output":{"name":"bool"}}],[11,"fmt","","",204,{"inputs":[{"name":"evaluationresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",205,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"intercrate","","",205,{"inputs":[{"name":"selectioncontext"},{"name":"inferctxt"},{"name":"closuretyper"}],"output":{"name":"selectioncontext"}}],[11,"infcx","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"inferctxt"}}],[11,"tcx","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"ctxt"}}],[11,"param_env","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"parameterenvironment"}}],[11,"closure_typer","","",205,{"inputs":[{"name":"selectioncontext"}],"output":{"name":"closuretyper"}}],[11,"select","","Attempts to satisfy the obligation. If successful, this will affect the surrounding\ntype environment by performing unification.",205,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"result"}}],[11,"evaluate_obligation","","Evaluates whether the obligation `obligation` can be satisfied (by any means).",205,{"inputs":[{"name":"selectioncontext"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"evaluate_impl","","Evaluates whether the impl with id `impl_def_id` could be applied to the self type\n`obligation_self_ty`. This can be used either for trait or inherent impls.",205,{"inputs":[{"name":"selectioncontext"},{"name":"defid"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"repr","","",203,{"inputs":[{"name":"selectioncandidate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"new","","",201,{"inputs":[{"name":"selectioncache"}],"output":{"name":"selectioncache"}}],[11,"clone","","",206,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"traitobligationstacklist"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::traits::select","",206,{"inputs":[{"name":"traitobligationstacklist"}],"output":{"name":"option"}}],[11,"repr","","",207,{"inputs":[{"name":"traitobligationstack"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"may_apply","","",208,{"inputs":[{"name":"methodmatchresult"}],"output":{"name":"bool"}}],[11,"filter_to_traits","rustc::middle::traits::util","",209,{"inputs":[{"name":"elaborator"}],"output":{"name":"filtertotraits"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::traits::util","",209,{"inputs":[{"name":"elaborator"}],"output":{"name":"option"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::traits::util","",210,{"inputs":[{"name":"supertraitdefids"}],"output":{"name":"option"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::traits::util","",211,{"inputs":[{"name":"filtertotraits"}],"output":{"name":"option"}}],[11,"fmt","rustc::middle::traits","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","","",214,{"inputs":[{"name":"obligation"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",215,{"inputs":[{"name":"vtable"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",218,{"inputs":[{"name":"selectionerror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",219,{"inputs":[{"name":"fulfillmenterror"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",220,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",220,{"inputs":[{"name":"fulfillmenterrorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"repr","rustc::middle::traits::project","",194,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fmt","","",194,{"inputs":[{"name":"mismatchedprojectiontypes"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","rustc::middle::traits","",214,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"ne","","",214,{"inputs":[{"name":"obligation"},{"name":"obligation"}],"output":{"name":"bool"}}],[11,"clone","","",214,{"inputs":[{"name":"obligation"}],"output":{"name":"obligation"}}],[11,"eq","","",221,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",221,{"inputs":[{"name":"obligationcause"},{"name":"obligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",221,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"eq","","",222,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"ne","","",222,{"inputs":[{"name":"obligationcausecode"},{"name":"obligationcausecode"}],"output":{"name":"bool"}}],[11,"clone","","",222,{"inputs":[{"name":"obligationcausecode"}],"output":{"name":"obligationcausecode"}}],[11,"eq","","",223,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"ne","","",223,{"inputs":[{"name":"derivedobligationcause"},{"name":"derivedobligationcause"}],"output":{"name":"bool"}}],[11,"clone","","",223,{"inputs":[{"name":"derivedobligationcause"}],"output":{"name":"derivedobligationcause"}}],[11,"fmt","","",218,{"inputs":[{"name":"selectionerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",218,{"inputs":[{"name":"selectionerror"}],"output":{"name":"selectionerror"}}],[11,"clone","","",220,{"inputs":[{"name":"fulfillmenterrorcode"}],"output":{"name":"fulfillmenterrorcode"}}],[11,"clone","","",215,{"inputs":[{"name":"vtable"}],"output":{"name":"vtable"}}],[11,"fmt","","",215,{"inputs":[{"name":"vtable"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"ne","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"vtableimpldata"}],"output":{"name":"bool"}}],[11,"clone","","",212,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"vtableimpldata"}}],[11,"clone","","",217,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fmt","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",216,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"vtablebuiltindata"}}],[11,"fmt","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",213,{"inputs":[{"name":"vtableobjectdata"}],"output":{"name":"vtableobjectdata"}}],[11,"eq","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"ne","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"vtableobjectdata"}],"output":{"name":"bool"}}],[11,"new","","",214,{"inputs":[{"name":"obligation"},{"name":"obligationcause"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"misc","","",214,{"inputs":[{"name":"obligation"},{"name":"span"},{"name":"u32"},{"name":"o"}],"output":{"name":"obligation"}}],[11,"with","","",214,{"inputs":[{"name":"obligation"},{"name":"p"}],"output":{"name":"obligation"}}],[11,"new","","",221,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"},{"name":"obligationcausecode"}],"output":{"name":"obligationcause"}}],[11,"misc","","",221,{"inputs":[{"name":"obligationcause"},{"name":"span"},{"name":"u32"}],"output":{"name":"obligationcause"}}],[11,"dummy","","",221,{"inputs":[{"name":"obligationcause"}],"output":{"name":"obligationcause"}}],[11,"iter_nested","","",215,{"inputs":[{"name":"vtable"}],"output":{"name":"iter"}}],[11,"map_nested","","",215,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"map_move_nested","","",215,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"iter_nested","","",212,{"inputs":[{"name":"vtableimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"map_move_nested","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"iter_nested","","",217,{"inputs":[{"name":"vtabledefaultimpldata"}],"output":{"name":"iter"}}],[11,"map_nested","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"map_move_nested","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"iter_nested","","",216,{"inputs":[{"name":"vtablebuiltindata"}],"output":{"name":"iter"}}],[11,"map_nested","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"map_move_nested","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"hash","rustc::middle::ty","",224,null],[11,"eq","","",224,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"ne","","",224,{"inputs":[{"name":"field"},{"name":"field"}],"output":{"name":"bool"}}],[11,"clone","","",224,{"inputs":[{"name":"field"}],"output":{"name":"field"}}],[11,"fmt","","",225,{"inputs":[{"name":"implortraititemcontainer"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",225,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"implortraititemcontainer"}}],[11,"id","","",225,{"inputs":[{"name":"implortraititemcontainer"}],"output":{"name":"defid"}}],[11,"fmt","","",226,{"inputs":[{"name":"implortraititem"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititem"}}],[11,"def_id","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"defid"}}],[11,"name","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"name"}}],[11,"container","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"implortraititemcontainer"}}],[11,"as_opt_method","","",226,{"inputs":[{"name":"implortraititem"}],"output":{"name":"option"}}],[11,"fmt","","",227,{"inputs":[{"name":"implortraititemid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",227,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"implortraititemid"}}],[11,"def_id","","",227,{"inputs":[{"name":"implortraititemid"}],"output":{"name":"defid"}}],[11,"fmt","","",228,{"inputs":[{"name":"method"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",228,{"inputs":[{"name":"method"}],"output":{"name":"method"}}],[11,"new","","",228,{"inputs":[{"name":"method"},{"name":"name"},{"name":"generics"},{"name":"genericpredicates"},{"name":"barefnty"},{"name":"explicitselfcategory"},{"name":"visibility"},{"name":"defid"},{"name":"implortraititemcontainer"},{"name":"option"}],"output":{"name":"method"}}],[11,"container_id","","",228,{"inputs":[{"name":"method"}],"output":{"name":"defid"}}],[11,"fmt","","",229,{"inputs":[{"name":"associatedtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",229,{"inputs":[{"name":"associatedtype"}],"output":{"name":"associatedtype"}}],[11,"fmt","","",230,{"inputs":[{"name":"mt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",230,null],[11,"eq","","",230,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"ne","","",230,{"inputs":[{"name":"mt"},{"name":"mt"}],"output":{"name":"bool"}}],[11,"clone","","",230,{"inputs":[{"name":"mt"}],"output":{"name":"mt"}}],[11,"fmt","","",231,{"inputs":[{"name":"field_ty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",231,{"inputs":[{"name":"field_ty"}],"output":{"name":"field_ty"}}],[11,"hash","","",232,null],[11,"eq","","",232,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"ne","","",232,{"inputs":[{"name":"creader_cache_key"},{"name":"creader_cache_key"}],"output":{"name":"bool"}}],[11,"clone","","",232,{"inputs":[{"name":"creader_cache_key"}],"output":{"name":"creader_cache_key"}}],[11,"encode","","",233,{"inputs":[{"name":"itemvariances"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",233,{"inputs":[{"name":"itemvariances"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",233,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"ne","","",233,{"inputs":[{"name":"itemvariances"},{"name":"itemvariances"}],"output":{"name":"bool"}}],[11,"clone","","",233,{"inputs":[{"name":"itemvariances"}],"output":{"name":"itemvariances"}}],[11,"fmt","","",234,{"inputs":[{"name":"variance"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"encode","","",234,{"inputs":[{"name":"variance"},{"name":"__s"}],"output":{"name":"result"}}],[11,"decode","","",234,{"inputs":[{"name":"variance"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",234,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"ne","","",234,{"inputs":[{"name":"variance"},{"name":"variance"}],"output":{"name":"bool"}}],[11,"clone","","",234,{"inputs":[{"name":"variance"}],"output":{"name":"variance"}}],[11,"fmt","","",235,{"inputs":[{"name":"autoadjustment"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",235,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"autoadjustment"}}],[11,"fmt","","",236,{"inputs":[{"name":"autoderefref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",236,{"inputs":[{"name":"autoderefref"}],"output":{"name":"autoderefref"}}],[11,"fmt","","",237,{"inputs":[{"name":"autoref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",237,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"ne","","",237,{"inputs":[{"name":"autoref"},{"name":"autoref"}],"output":{"name":"bool"}}],[11,"clone","","",237,{"inputs":[{"name":"autoref"}],"output":{"name":"autoref"}}],[11,"fmt","","",238,{"inputs":[{"name":"param_index"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"option"}}],[11,"lt","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"le","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"gt","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ge","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"eq","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"ne","","",238,{"inputs":[{"name":"param_index"},{"name":"param_index"}],"output":{"name":"bool"}}],[11,"decode","","",238,{"inputs":[{"name":"param_index"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",238,{"inputs":[{"name":"param_index"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"param_index"}],"output":{"name":"param_index"}}],[11,"fmt","","",25,{"inputs":[{"name":"methodorigin"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"methodorigin"}],"output":{"name":"methodorigin"}}],[11,"fmt","","",239,{"inputs":[{"name":"methodparam"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",239,{"inputs":[{"name":"methodparam"}],"output":{"name":"methodparam"}}],[11,"fmt","","",240,{"inputs":[{"name":"methodobject"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",240,{"inputs":[{"name":"methodobject"}],"output":{"name":"methodobject"}}],[11,"clone","","",241,{"inputs":[{"name":"methodcallee"}],"output":{"name":"methodcallee"}}],[11,"fmt","","",242,{"inputs":[{"name":"methodcall"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",242,null],[11,"eq","","",242,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"ne","","",242,{"inputs":[{"name":"methodcall"},{"name":"methodcall"}],"output":{"name":"bool"}}],[11,"clone","","",242,{"inputs":[{"name":"methodcall"}],"output":{"name":"methodcall"}}],[11,"expr","","",242,{"inputs":[{"name":"methodcall"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"autoderef","","",242,{"inputs":[{"name":"methodcall"},{"name":"u32"},{"name":"u32"}],"output":{"name":"methodcall"}}],[11,"clone","","",243,{"inputs":[{"name":"vtable_origin"}],"output":{"name":"vtable_origin"}}],[11,"clone","","",88,{"inputs":[{"name":"transmuterestriction"}],"output":{"name":"transmuterestriction"}}],[11,"new","","",244,{"inputs":[{"name":"ctxtarenas"}],"output":{"name":"ctxtarenas"}}],[11,"node_types","","",245,{"inputs":[{"name":"ctxt"}],"output":{"name":"ref"}}],[11,"node_type_insert","","",245,null],[11,"store_free_region_map","","",245,null],[11,"free_region_map","","",245,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"freeregionmap"}}],[11,"hash","","",246,null],[11,"cmp","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"option"}}],[11,"lt","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"le","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"gt","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ge","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"clone","","",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"eq","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"ne","","",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"all","","Returns the set containing all flags.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"bits","","Returns the raw value of the flags currently stored.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",246,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",246,{"inputs":[{"name":"typeflags"},{"name":"u32"}],"output":{"name":"typeflags"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",246,null],[11,"remove","","Removes the specified flags in-place.",246,null],[11,"toggle","","Toggles the specified flags in-place.",246,null],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitor","rustc::middle::ty","Returns the union of the two sets of flags.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitxor","rustc::middle::ty","Returns the left flags, but with all the right flags toggled.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitand","rustc::middle::ty","Returns the intersection between the two sets of flags.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"sub","rustc::middle::ty","Returns the set difference of the two sets of flags.",246,{"inputs":[{"name":"typeflags"},{"name":"typeflags"}],"output":{"name":"typeflags"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"not","rustc::middle::ty","Returns the complement of this set of flags.",246,{"inputs":[{"name":"typeflags"}],"output":{"name":"typeflags"}}],[11,"print_debug_stats","","",245,null],[11,"fmt","","",247,{"inputs":[{"name":"tys"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",246,{"inputs":[{"name":"typeflags"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",247,{"inputs":[{"name":"tys"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"hash","","",247,null],[11,"eq","","",248,{"inputs":[{"name":"internedty"},{"name":"internedty"}],"output":{"name":"bool"}}],[11,"hash","","",248,null],[11,"borrow","","",248,{"inputs":[{"name":"internedty"}],"output":{"name":"sty"}}],[11,"fmt","","",249,{"inputs":[{"name":"barefnty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",249,null],[11,"eq","","",249,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"ne","","",249,{"inputs":[{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"clone","","",249,{"inputs":[{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"fmt","","",250,{"inputs":[{"name":"closurety"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",250,null],[11,"eq","","",250,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"ne","","",250,{"inputs":[{"name":"closurety"},{"name":"closurety"}],"output":{"name":"bool"}}],[11,"clone","","",250,{"inputs":[{"name":"closurety"}],"output":{"name":"closurety"}}],[11,"fmt","","",251,{"inputs":[{"name":"fnoutput"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",251,null],[11,"eq","","",251,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"ne","","",251,{"inputs":[{"name":"fnoutput"},{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"clone","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"fnoutput"}}],[11,"diverges","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"unwrap","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"tys"}}],[11,"unwrap_or","","",251,{"inputs":[{"name":"fnoutput"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"diverges","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"hash","","",252,null],[11,"eq","","",252,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"ne","","",252,{"inputs":[{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"clone","","",252,{"inputs":[{"name":"fnsig"}],"output":{"name":"fnsig"}}],[11,"inputs","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"input","","",96,{"inputs":[{"name":"binder"},{"name":"usize"}],"output":{"name":"binder"}}],[11,"output","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"variadic","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"fmt","","",253,{"inputs":[{"name":"paramty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",253,null],[11,"eq","","",253,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"ne","","",253,{"inputs":[{"name":"paramty"},{"name":"paramty"}],"output":{"name":"bool"}}],[11,"clone","","",253,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"fmt","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",254,null],[11,"eq","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"ne","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"debruijnindex"}],"output":{"name":"bool"}}],[11,"clone","","",254,{"inputs":[{"name":"debruijnindex"}],"output":{"name":"debruijnindex"}}],[11,"fmt","","",16,{"inputs":[{"name":"region"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"region"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",16,{"inputs":[{"name":"region"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",16,null],[11,"eq","","",16,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"region"},{"name":"region"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"region"}],"output":{"name":"region"}}],[11,"fmt","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",255,null],[11,"eq","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"ne","","",255,{"inputs":[{"name":"earlyboundregion"},{"name":"earlyboundregion"}],"output":{"name":"bool"}}],[11,"clone","","",255,{"inputs":[{"name":"earlyboundregion"}],"output":{"name":"earlyboundregion"}}],[11,"fmt","","",256,{"inputs":[{"name":"upvarid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",256,null],[11,"eq","","",256,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"ne","","",256,{"inputs":[{"name":"upvarid"},{"name":"upvarid"}],"output":{"name":"bool"}}],[11,"clone","","",256,{"inputs":[{"name":"upvarid"}],"output":{"name":"upvarid"}}],[11,"decode","","",257,{"inputs":[{"name":"borrowkind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",257,{"inputs":[{"name":"borrowkind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",257,{"inputs":[{"name":"borrowkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",257,null],[11,"eq","","",257,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"ne","","",257,{"inputs":[{"name":"borrowkind"},{"name":"borrowkind"}],"output":{"name":"bool"}}],[11,"clone","","",257,{"inputs":[{"name":"borrowkind"}],"output":{"name":"borrowkind"}}],[11,"fmt","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"upvarcapture"}],"output":{"name":"upvarcapture"}}],[11,"eq","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"upvarcapture"}],"output":{"name":"bool"}}],[11,"fmt","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",23,{"inputs":[{"name":"upvarborrow"}],"output":{"name":"upvarborrow"}}],[11,"eq","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"upvarborrow"}],"output":{"name":"bool"}}],[11,"is_bound","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"escapes_depth","","",16,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"fmt","","",17,{"inputs":[{"name":"freeregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",17,{"inputs":[{"name":"freeregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",17,{"inputs":[{"name":"freeregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",17,null],[11,"cmp","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"option"}}],[11,"lt","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"le","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"gt","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ge","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"eq","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"freeregion"},{"name":"freeregion"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"freeregion"}],"output":{"name":"freeregion"}}],[11,"fmt","","",20,{"inputs":[{"name":"boundregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"decode","","",20,{"inputs":[{"name":"boundregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",20,{"inputs":[{"name":"boundregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"hash","","",20,null],[11,"cmp","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"option"}}],[11,"lt","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"le","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"gt","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ge","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"eq","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"boundregion"},{"name":"boundregion"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"boundregion"}],"output":{"name":"boundregion"}}],[11,"fmt","","",258,{"inputs":[{"name":"sty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",258,null],[11,"eq","","",258,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"ne","","",258,{"inputs":[{"name":"sty"},{"name":"sty"}],"output":{"name":"bool"}}],[11,"clone","","",258,{"inputs":[{"name":"sty"}],"output":{"name":"sty"}}],[11,"fmt","","",259,{"inputs":[{"name":"tytrait"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",259,null],[11,"eq","","",259,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"ne","","",259,{"inputs":[{"name":"tytrait"},{"name":"tytrait"}],"output":{"name":"bool"}}],[11,"clone","","",259,{"inputs":[{"name":"tytrait"}],"output":{"name":"tytrait"}}],[11,"principal_def_id","","",259,{"inputs":[{"name":"tytrait"}],"output":{"name":"defid"}}],[11,"principal_trait_ref_with_self_ty","","Object types don't have a self-type specified. Therefore, when\nwe convert the principal trait-ref into a normal trait-ref,\nyou must give *some* self-type. A common choice is `mk_err()`\nor some skolemized type.",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"binder"}}],[11,"projection_bounds_with_self_ty","","",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"},{"name":"tys"}],"output":{"name":"vec"}}],[11,"fmt","","",260,{"inputs":[{"name":"traitref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",260,null],[11,"eq","","",260,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"ne","","",260,{"inputs":[{"name":"traitref"},{"name":"traitref"}],"output":{"name":"bool"}}],[11,"clone","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"traitref"}}],[11,"self_ty","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"tys"}}],[11,"def_id","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"substs","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"substs"}}],[11,"input_types","","",96,null],[11,"to_poly_trait_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"fmt","","",96,{"inputs":[{"name":"binder"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",96,null],[11,"eq","","",96,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"ne","","",96,{"inputs":[{"name":"binder"},{"name":"binder"}],"output":{"name":"bool"}}],[11,"clone","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"skip_binder","","Skips the binder and returns the \"bound\" value. This is a\nrisky thing to do because it's easy to get confused about\ndebruijn indices and the like. It is usually better to\ndischarge the binder using `no_late_bound_regions` or\n`replace_late_bound_regions` or something like\nthat. `skip_binder` is only valid when you are either\nextracting data that has nothing to do with bound regions, you\nare doing some sort of test that does not involve bound\nregions, or you are being very careful about your depth\naccounting.",96,{"inputs":[{"name":"binder"}],"output":{"name":"t"}}],[11,"as_ref","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"map_bound_ref","","",96,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"map_bound","","",96,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"eq","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"ne","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"intvarvalue"}],"output":{"name":"bool"}}],[11,"clone","","",126,{"inputs":[{"name":"intvarvalue"}],"output":{"name":"intvarvalue"}}],[11,"fmt","","",261,{"inputs":[{"name":"terr_vstore_kind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",261,{"inputs":[{"name":"terr_vstore_kind"}],"output":{"name":"terr_vstore_kind"}}],[11,"fmt","","",262,{"inputs":[{"name":"expected_found"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",262,{"inputs":[{"name":"expected_found"}],"output":{"name":"expected_found"}}],[11,"fmt","","",263,{"inputs":[{"name":"type_err"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",263,{"inputs":[{"name":"type_err"}],"output":{"name":"type_err"}}],[11,"fmt","","",264,{"inputs":[{"name":"parambounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",264,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"hash","","",264,null],[11,"eq","","",264,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"ne","","",264,{"inputs":[{"name":"parambounds"},{"name":"parambounds"}],"output":{"name":"bool"}}],[11,"fmt","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",265,{"inputs":[{"name":"existentialbounds"}],"output":{"name":"existentialbounds"}}],[11,"hash","","",265,null],[11,"eq","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"ne","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"bool"}}],[11,"fmt","","",266,{"inputs":[{"name":"builtinbound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",266,null],[11,"decode","","",266,{"inputs":[{"name":"builtinbound"},{"name":"__d"}],"output":{"name":"result"}}],[11,"eq","","",266,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"ne","","",266,{"inputs":[{"name":"builtinbound"},{"name":"builtinbound"}],"output":{"name":"bool"}}],[11,"encode","","",266,{"inputs":[{"name":"builtinbound"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",266,{"inputs":[{"name":"builtinbound"}],"output":{"name":"builtinbound"}}],[11,"to_usize","","",266,{"inputs":[{"name":"builtinbound"}],"output":{"name":"usize"}}],[11,"from_usize","","",266,{"inputs":[{"name":"builtinbound"},{"name":"usize"}],"output":{"name":"builtinbound"}}],[11,"hash","","",267,null],[11,"eq","","",267,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"ne","","",267,{"inputs":[{"name":"tyvid"},{"name":"tyvid"}],"output":{"name":"bool"}}],[11,"clone","","",267,{"inputs":[{"name":"tyvid"}],"output":{"name":"tyvid"}}],[11,"hash","","",125,null],[11,"eq","","",125,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"ne","","",125,{"inputs":[{"name":"intvid"},{"name":"intvid"}],"output":{"name":"bool"}}],[11,"clone","","",125,{"inputs":[{"name":"intvid"}],"output":{"name":"intvid"}}],[11,"hash","","",127,null],[11,"eq","","",127,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"floatvid"},{"name":"floatvid"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"floatvid"}],"output":{"name":"floatvid"}}],[11,"hash","","",268,null],[11,"decode","","",268,{"inputs":[{"name":"regionvid"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",268,{"inputs":[{"name":"regionvid"},{"name":"__s"}],"output":{"name":"result"}}],[11,"eq","","",268,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"ne","","",268,{"inputs":[{"name":"regionvid"},{"name":"regionvid"}],"output":{"name":"bool"}}],[11,"clone","","",268,{"inputs":[{"name":"regionvid"}],"output":{"name":"regionvid"}}],[11,"hash","","",269,null],[11,"eq","","",269,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"ne","","",269,{"inputs":[{"name":"inferty"},{"name":"inferty"}],"output":{"name":"bool"}}],[11,"clone","","",269,{"inputs":[{"name":"inferty"}],"output":{"name":"inferty"}}],[11,"fmt","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",270,null],[11,"eq","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"ne","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"unconstrainednumeric"}],"output":{"name":"bool"}}],[11,"decode","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",270,{"inputs":[{"name":"unconstrainednumeric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",270,{"inputs":[{"name":"unconstrainednumeric"}],"output":{"name":"unconstrainednumeric"}}],[11,"fmt","","",271,{"inputs":[{"name":"inferregion"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",271,null],[11,"decode","","",271,{"inputs":[{"name":"inferregion"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",271,{"inputs":[{"name":"inferregion"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",271,{"inputs":[{"name":"inferregion"}],"output":{"name":"inferregion"}}],[11,"eq","","",271,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"ne","","",271,{"inputs":[{"name":"inferregion"},{"name":"inferregion"}],"output":{"name":"bool"}}],[11,"fmt","","",267,{"inputs":[{"name":"tyvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",125,{"inputs":[{"name":"intvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",127,{"inputs":[{"name":"floatvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",268,{"inputs":[{"name":"regionvid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",252,{"inputs":[{"name":"fnsig"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",269,{"inputs":[{"name":"inferty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",272,{"inputs":[{"name":"objectlifetimedefault"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",272,{"inputs":[{"name":"objectlifetimedefault"}],"output":{"name":"objectlifetimedefault"}}],[11,"fmt","","",273,{"inputs":[{"name":"typeparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",273,{"inputs":[{"name":"typeparameterdef"}],"output":{"name":"typeparameterdef"}}],[11,"fmt","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",274,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"regionparameterdef"}}],[11,"decode","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"__s"}],"output":{"name":"result"}}],[11,"to_early_bound_region","","",274,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"region"}}],[11,"to_bound_region","","",274,{"inputs":[{"name":"regionparameterdef"}],"output":{"name":"boundregion"}}],[11,"fmt","","",275,{"inputs":[{"name":"generics"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",275,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"empty","","",275,{"inputs":[{"name":"generics"}],"output":{"name":"generics"}}],[11,"is_empty","","",275,{"inputs":[{"name":"generics"}],"output":{"name":"bool"}}],[11,"has_type_params","","",275,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"has_region_params","","",275,{"inputs":[{"name":"generics"},{"name":"paramspace"}],"output":{"name":"bool"}}],[11,"fmt","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",276,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"empty","","",276,{"inputs":[{"name":"genericpredicates"}],"output":{"name":"genericpredicates"}}],[11,"instantiate","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"substs"}],"output":{"name":"instantiatedpredicates"}}],[11,"instantiate_supertrait","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"instantiatedpredicates"}}],[11,"fmt","","",277,{"inputs":[{"name":"predicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",277,null],[11,"eq","","",277,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"ne","","",277,{"inputs":[{"name":"predicate"},{"name":"predicate"}],"output":{"name":"bool"}}],[11,"clone","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"predicate"}}],[11,"subst_supertrait","","Performs a substituion suitable for going from a\npoly-trait-ref to supertraits that must hold if that\npoly-trait-ref holds. This is slightly different from a normal\nsubstitution in terms of what happens with bound regions.  See\nlengthy comment below for details.",277,{"inputs":[{"name":"predicate"},{"name":"ctxt"},{"name":"binder"}],"output":{"name":"predicate"}}],[11,"fmt","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",278,null],[11,"eq","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"traitpredicate"}}],[11,"def_id","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"defid"}}],[11,"input_types","","",278,null],[11,"self_ty","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"tys"}}],[11,"def_id","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"defid"}}],[11,"fmt","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",279,null],[11,"eq","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"ne","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"clone","","",279,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"equatepredicate"}}],[11,"fmt","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",280,null],[11,"eq","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"ne","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"clone","","",280,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"outlivespredicate"}}],[11,"fmt","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",281,null],[11,"eq","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"ne","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"clone","","",281,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"projectionpredicate"}}],[11,"item_name","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"name"}}],[11,"sort_key","","",96,null],[11,"fmt","","",282,{"inputs":[{"name":"projectionty"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",282,null],[11,"eq","","",282,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"ne","","",282,{"inputs":[{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"clone","","",282,{"inputs":[{"name":"projectionty"}],"output":{"name":"projectionty"}}],[11,"sort_key","","",282,null],[11,"to_poly_trait_ref","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","rustc::middle::ty","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"to_poly_trait_ref","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"binder"}}],[11,"as_predicate","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"predicate"}}],[11,"as_predicate","rustc::middle::ty","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"as_predicate","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"predicate"}}],[11,"walk_tys","","Iterates over the types in this predicate. Note that in all\ncases this is skipping over a binder, so late-bound regions\nwith depth 0 are bound by the predicate.",277,{"inputs":[{"name":"predicate"}],"output":{"name":"intoiter"}}],[11,"has_escaping_regions","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"to_opt_poly_trait_ref","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"option"}}],[11,"fmt","","",283,{"inputs":[{"name":"instantiatedpredicates"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"empty","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"instantiatedpredicates"}}],[11,"has_escaping_regions","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"is_empty","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"new","","",260,{"inputs":[{"name":"traitref"},{"name":"defid"},{"name":"substs"}],"output":{"name":"traitref"}}],[11,"self_ty","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"tys"}}],[11,"input_types","","",260,null],[11,"clone","","",284,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"with_caller_bounds","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"vec"}],"output":{"name":"parameterenvironment"}}],[11,"for_item","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"},{"name":"u32"}],"output":{"name":"parameterenvironment"}}],[11,"fmt","","",285,{"inputs":[{"name":"typescheme"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",285,{"inputs":[{"name":"typescheme"}],"output":{"name":"typescheme"}}],[11,"clone","","",286,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"decode","","",166,{"inputs":[{"name":"closurekind"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",166,{"inputs":[{"name":"closurekind"},{"name":"__s"}],"output":{"name":"result"}}],[11,"fmt","","",166,{"inputs":[{"name":"closurekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ne","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"cmp","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"option"}}],[11,"lt","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"le","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"gt","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"ge","","",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"clone","","",166,{"inputs":[{"name":"closurekind"}],"output":{"name":"closurekind"}}],[11,"trait_did","","",166,{"inputs":[{"name":"closurekind"},{"name":"ctxt"}],"output":{"name":"defid"}}],[11,"extends","","True if this a type that impls this closure kind\nmust also implement `other`.",166,{"inputs":[{"name":"closurekind"},{"name":"closurekind"}],"output":{"name":"bool"}}],[11,"mk_substs","","",245,{"inputs":[{"name":"ctxt"},{"name":"substs"}],"output":{"name":"substs"}}],[11,"safe_to_unsafe_fn_ty","","Create an unsafe fn ty based on a safe fn ty.",245,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"tys"}}],[11,"mk_bare_fn","","",245,{"inputs":[{"name":"ctxt"},{"name":"barefnty"}],"output":{"name":"barefnty"}}],[11,"mk_region","","",245,{"inputs":[{"name":"ctxt"},{"name":"region"}],"output":{"name":"region"}}],[11,"closure_kind","","",245,{"inputs":[{"name":"ctxt"},{"name":"defid"}],"output":{"name":"closurekind"}}],[11,"closure_type","","",245,{"inputs":[{"name":"ctxt"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"type_parameter_def","","",245,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"typeparameterdef"}}],[11,"pat_contains_ref_binding","","",245,{"inputs":[{"name":"ctxt"},{"name":"pat"}],"output":{"name":"bool"}}],[11,"arm_contains_ref_binding","","",245,{"inputs":[{"name":"ctxt"},{"name":"arm"}],"output":{"name":"bool"}}],[11,"walk","","Iterator that walks `self` and any types reachable from\n`self`, in depth-first order. Note that just walks the types\nthat appear in `self`, it does not descend into the fields of\nstructs or variants. For example:",247,{"inputs":[{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"walk_shallow","","Iterator that walks the immediate children of `self`.  Hence\n`Foo<Bar<i32>, u32>` yields the sequence `[Bar<i32>, u32]`\n(but not `i32`, like `walk`).",247,{"inputs":[{"name":"tys"}],"output":{"name":"intoiter"}}],[11,"as_opt_param_ty","","",247,{"inputs":[{"name":"tys"}],"output":{"name":"option"}}],[11,"is_param","","",247,{"inputs":[{"name":"tys"},{"name":"paramspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"new","","",253,{"inputs":[{"name":"paramty"},{"name":"paramspace"},{"name":"u32"},{"name":"name"}],"output":{"name":"paramty"}}],[11,"for_self","","",253,{"inputs":[{"name":"paramty"}],"output":{"name":"paramty"}}],[11,"for_def","","",253,{"inputs":[{"name":"paramty"},{"name":"typeparameterdef"}],"output":{"name":"paramty"}}],[11,"to_ty","","",253,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"is_self","","",253,{"inputs":[{"name":"paramty"}],"output":{"name":"bool"}}],[11,"empty","","",286,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"itemsubsts"}}],[11,"is_noop","","",286,{"inputs":[{"name":"itemsubsts"}],"output":{"name":"bool"}}],[11,"empty","","",264,{"inputs":[{"name":"parambounds"}],"output":{"name":"parambounds"}}],[11,"clone","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"when","","",287,{"inputs":[{"name":"typecontents"},{"name":"bool"}],"output":{"name":"typecontents"}}],[11,"intersects","","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_managed","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"owns_owned","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"is_sized","","",287,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"interior_param","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsafe","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"interior_unsized","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[11,"needs_drop","","",287,{"inputs":[{"name":"typecontents"},{"name":"ctxt"}],"output":{"name":"bool"}}],[11,"owned_pointer","","Includes only those bits that still apply when indirected through a `Box` pointer",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"reference","","Includes only those bits that still apply when indirected through a reference (`&`)",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"managed_pointer","","Includes only those bits that still apply when indirected through a managed pointer (`@`)",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"unsafe_pointer","","Includes only those bits that still apply when indirected through an unsafe pointer (`*`)",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"union","","",287,null],[11,"has_dtor","","",287,{"inputs":[{"name":"typecontents"}],"output":{"name":"bool"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitor","rustc::middle::ty","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitand","rustc::middle::ty","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"sub","rustc::middle::ty","",287,{"inputs":[{"name":"typecontents"},{"name":"typecontents"}],"output":{"name":"typecontents"}}],[11,"fmt","","",287,{"inputs":[{"name":"typecontents"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",288,{"inputs":[{"name":"representability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ne","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"cmp","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"option"}}],[11,"lt","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"le","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"gt","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"ge","","",288,{"inputs":[{"name":"representability"},{"name":"representability"}],"output":{"name":"bool"}}],[11,"clone","","",288,{"inputs":[{"name":"representability"}],"output":{"name":"representability"}}],[11,"clone","","",289,{"inputs":[{"name":"exprkind"}],"output":{"name":"exprkind"}}],[11,"repr","","",263,{"inputs":[{"name":"type_err"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",290,{"inputs":[{"name":"variantinfo"}],"output":{"name":"variantinfo"}}],[11,"from_ast_variant","","Creates a new VariantInfo from the corresponding ast representation.",290,{"inputs":[{"name":"variantinfo"},{"name":"ctxt"},{"name":"spanned"},{"name":"u64"}],"output":{"name":"variantinfo"}}],[11,"clone","","",291,{"inputs":[{"name":"dtorkind"}],"output":{"name":"dtorkind"}}],[11,"is_present","","",291,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"has_drop_flag","","",291,{"inputs":[{"name":"dtorkind"}],"output":{"name":"bool"}}],[11,"to_ty","syntax::attr","",292,{"inputs":[{"name":"inttype"},{"name":"ctxt"}],"output":{"name":"tys"}}],[11,"i64_to_disr","","",292,{"inputs":[{"name":"inttype"},{"name":"i64"}],"output":{"name":"option"}}],[11,"u64_to_disr","","",292,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_incr","","",292,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"option"}}],[11,"disr_string","","",292,{"inputs":[{"name":"inttype"},{"name":"u64"}],"output":{"name":"string"}}],[11,"disr_wrap_incr","","",292,{"inputs":[{"name":"inttype"},{"name":"option"}],"output":{"name":"u64"}}],[11,"clone","rustc::middle::ty","",293,{"inputs":[{"name":"closureupvar"}],"output":{"name":"closureupvar"}}],[11,"to_string","","",234,{"inputs":[{"name":"variance"}],"output":{"name":"str"}}],[11,"from_mutbl","","",257,{"inputs":[{"name":"borrowkind"},{"name":"mutability"}],"output":{"name":"borrowkind"}}],[11,"to_mutbl_lossy","","Returns a mutability `m` such that an `&m T` pointer could be used to obtain this borrow\nkind. Because borrow kinds are richer than mutabilities, we sometimes have to pick a\nmutability that is stronger than necessary so that it at least *would permit* the borrow in\nquestion.",257,{"inputs":[{"name":"borrowkind"}],"output":{"name":"mutability"}}],[11,"to_user_str","","",257,{"inputs":[{"name":"borrowkind"}],"output":{"name":"str"}}],[11,"is_method_call","","",245,{"inputs":[{"name":"ctxt"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"upvar_capture","","",245,{"inputs":[{"name":"ctxt"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"node_ty","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"result"}}],[11,"expr_ty_adjusted","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"expr"}],"output":{"name":"result"}}],[11,"node_method_ty","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"node_method_origin","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"methodcall"}],"output":{"name":"option"}}],[11,"adjustments","","",284,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"refcell"}}],[11,"is_method_call","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"temporary_scope","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"u32"}],"output":{"name":"option"}}],[11,"upvar_capture","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"upvarid"}],"output":{"name":"option"}}],[11,"type_moves_by_default","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"span"},{"name":"tys"}],"output":{"name":"bool"}}],[11,"param_env","","",284,{"inputs":[{"name":"parameterenvironment"}],"output":{"name":"parameterenvironment"}}],[11,"closure_kind","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"}],"output":{"name":"option"}}],[11,"closure_type","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"closurety"}}],[11,"closure_upvars","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"defid"},{"name":"substs"}],"output":{"name":"option"}}],[11,"fmt","","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"ne","","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"explicitselfcategory"}],"output":{"name":"bool"}}],[11,"clone","","",294,{"inputs":[{"name":"explicitselfcategory"}],"output":{"name":"explicitselfcategory"}}],[11,"decode","","",22,{"inputs":[{"name":"freevar"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",22,{"inputs":[{"name":"freevar"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",22,{"inputs":[{"name":"freevar"}],"output":{"name":"freevar"}}],[11,"is_identity","","",235,{"inputs":[{"name":"autoadjustment"}],"output":{"name":"bool"}}],[11,"is_identity","","",236,{"inputs":[{"name":"autoderefref"}],"output":{"name":"bool"}}],[11,"new","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"shifted","","",254,{"inputs":[{"name":"debruijnindex"},{"name":"u32"}],"output":{"name":"debruijnindex"}}],[11,"repr","","",235,{"inputs":[{"name":"autoadjustment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",236,{"inputs":[{"name":"autoderefref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",237,{"inputs":[{"name":"autoref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",277,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",243,{"inputs":[{"name":"vtable_origin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"clone","","",295,{"inputs":[{"name":"copyimplementationerror"}],"output":{"name":"copyimplementationerror"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",285,{"inputs":[{"name":"typescheme"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",16,{"inputs":[{"name":"region"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",277,{"inputs":[{"name":"predicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::traits","",214,{"inputs":[{"name":"obligation"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",260,{"inputs":[{"name":"traitref"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::subst","",186,{"inputs":[{"name":"regionsubsts"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"has_regions_escaping_depth","","",282,{"inputs":[{"name":"projectionty"},{"name":"u32"}],"output":{"name":"bool"}}],[11,"repr","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"has_projection_types","collections::vec","",296,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",188,{"inputs":[{"name":"vecperparamspace"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",250,{"inputs":[{"name":"closurety"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",293,{"inputs":[{"name":"closureupvar"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",283,{"inputs":[{"name":"instantiatedpredicates"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",279,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",280,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",281,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",282,{"inputs":[{"name":"projectionty"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::subst","",185,{"inputs":[{"name":"substs"}],"output":{"name":"bool"}}],[11,"has_projection_types","core::option","",12,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"has_projection_types","alloc::boxed","",297,{"inputs":[{"name":"box"}],"output":{"name":"bool"}}],[11,"has_projection_types","rustc::middle::ty","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",251,{"inputs":[{"name":"fnoutput"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",252,{"inputs":[{"name":"fnsig"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",224,{"inputs":[{"name":"field"}],"output":{"name":"bool"}}],[11,"has_projection_types","","",249,{"inputs":[{"name":"barefnty"}],"output":{"name":"bool"}}],[11,"references_error","","",96,{"inputs":[{"name":"binder"}],"output":{"name":"bool"}}],[11,"references_error","alloc::rc","",95,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[11,"references_error","rustc::middle::ty","",278,{"inputs":[{"name":"traitpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",281,{"inputs":[{"name":"projectionpredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",260,{"inputs":[{"name":"traitref"}],"output":{"name":"bool"}}],[11,"references_error","","",277,{"inputs":[{"name":"predicate"}],"output":{"name":"bool"}}],[11,"references_error","","",280,{"inputs":[{"name":"outlivespredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",279,{"inputs":[{"name":"equatepredicate"}],"output":{"name":"bool"}}],[11,"references_error","","",16,{"inputs":[{"name":"region"}],"output":{"name":"bool"}}],[11,"repr","","",250,{"inputs":[{"name":"closurety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",293,{"inputs":[{"name":"closureupvar"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",224,{"inputs":[{"name":"field"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",272,{"inputs":[{"name":"objectlifetimedefault"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"fold_with","syntax::ast","",298,{"inputs":[{"name":"unsafety"},{"name":"f"}],"output":{"name":"unsafety"}}],[11,"fold_with","syntax::abi","",299,{"inputs":[{"name":"abi"},{"name":"f"}],"output":{"name":"abi"}}],[11,"fold_with","core::option","",12,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"fold_with","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"f"}],"output":{"name":"rc"}}],[11,"fold_with","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"f"}],"output":{"name":"box"}}],[11,"fold_with","collections::vec","",296,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"fold_with","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"f"}],"output":{"name":"binder"}}],[11,"fold_with","syntax::owned_slice","",300,{"inputs":[{"name":"ownedslice"},{"name":"f"}],"output":{"name":"ownedslice"}}],[11,"fold_with","rustc::middle::subst","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"f"}],"output":{"name":"vecperparamspace"}}],[11,"fold_with","rustc::middle::ty","",249,{"inputs":[{"name":"barefnty"},{"name":"f"}],"output":{"name":"barefnty"}}],[11,"fold_with","","",250,{"inputs":[{"name":"closurety"},{"name":"f"}],"output":{"name":"closurety"}}],[11,"fold_with","","",230,{"inputs":[{"name":"mt"},{"name":"f"}],"output":{"name":"mt"}}],[11,"fold_with","","",251,{"inputs":[{"name":"fnoutput"},{"name":"f"}],"output":{"name":"fnoutput"}}],[11,"fold_with","","",252,{"inputs":[{"name":"fnsig"},{"name":"f"}],"output":{"name":"fnsig"}}],[11,"fold_with","","",260,{"inputs":[{"name":"traitref"},{"name":"f"}],"output":{"name":"traitref"}}],[11,"fold_with","","",224,{"inputs":[{"name":"field"},{"name":"f"}],"output":{"name":"field"}}],[11,"fold_with","","",16,{"inputs":[{"name":"region"},{"name":"f"}],"output":{"name":"region"}}],[11,"fold_with","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"f"}],"output":{"name":"substs"}}],[11,"fold_with","rustc::middle::ty","",286,{"inputs":[{"name":"itemsubsts"},{"name":"f"}],"output":{"name":"itemsubsts"}}],[11,"fold_with","","",237,{"inputs":[{"name":"autoref"},{"name":"f"}],"output":{"name":"autoref"}}],[11,"fold_with","","",25,{"inputs":[{"name":"methodorigin"},{"name":"f"}],"output":{"name":"methodorigin"}}],[11,"fold_with","","",243,{"inputs":[{"name":"vtable_origin"},{"name":"f"}],"output":{"name":"vtable_origin"}}],[11,"fold_with","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"f"}],"output":{"name":"enumset"}}],[11,"fold_with","rustc::middle::ty","",265,{"inputs":[{"name":"existentialbounds"},{"name":"f"}],"output":{"name":"existentialbounds"}}],[11,"fold_with","","",264,{"inputs":[{"name":"parambounds"},{"name":"f"}],"output":{"name":"parambounds"}}],[11,"fold_with","","",273,{"inputs":[{"name":"typeparameterdef"},{"name":"f"}],"output":{"name":"typeparameterdef"}}],[11,"fold_with","","",272,{"inputs":[{"name":"objectlifetimedefault"},{"name":"f"}],"output":{"name":"objectlifetimedefault"}}],[11,"fold_with","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"f"}],"output":{"name":"regionparameterdef"}}],[11,"fold_with","","",275,{"inputs":[{"name":"generics"},{"name":"f"}],"output":{"name":"generics"}}],[11,"fold_with","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"f"}],"output":{"name":"genericpredicates"}}],[11,"fold_with","","",277,{"inputs":[{"name":"predicate"},{"name":"f"}],"output":{"name":"predicate"}}],[11,"fold_with","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"f"}],"output":{"name":"projectionpredicate"}}],[11,"fold_with","","",282,{"inputs":[{"name":"projectionty"},{"name":"f"}],"output":{"name":"projectionty"}}],[11,"fold_with","","",283,{"inputs":[{"name":"instantiatedpredicates"},{"name":"f"}],"output":{"name":"instantiatedpredicates"}}],[11,"fold_with","rustc::middle::traits","",214,{"inputs":[{"name":"obligation"},{"name":"f"}],"output":{"name":"obligation"}}],[11,"fold_with","","",212,{"inputs":[{"name":"vtableimpldata"},{"name":"f"}],"output":{"name":"vtableimpldata"}}],[11,"fold_with","","",217,{"inputs":[{"name":"vtabledefaultimpldata"},{"name":"f"}],"output":{"name":"vtabledefaultimpldata"}}],[11,"fold_with","","",216,{"inputs":[{"name":"vtablebuiltindata"},{"name":"f"}],"output":{"name":"vtablebuiltindata"}}],[11,"fold_with","","",215,{"inputs":[{"name":"vtable"},{"name":"f"}],"output":{"name":"vtable"}}],[11,"fold_with","","",213,{"inputs":[{"name":"vtableobjectdata"},{"name":"f"}],"output":{"name":"vtableobjectdata"}}],[11,"fold_with","rustc::middle::ty","",279,{"inputs":[{"name":"equatepredicate"},{"name":"f"}],"output":{"name":"equatepredicate"}}],[11,"fold_with","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"f"}],"output":{"name":"traitpredicate"}}],[11,"fold_with","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"f"}],"output":{"name":"outlivespredicate"}}],[11,"fold_with","","",293,{"inputs":[{"name":"closureupvar"},{"name":"f"}],"output":{"name":"closureupvar"}}],[11,"fold_with","","",284,{"inputs":[{"name":"parameterenvironment"},{"name":"f"}],"output":{"name":"parameterenvironment"}}],[11,"tcx","rustc::middle::ty_fold","",302,{"inputs":[{"name":"bottomupfolder"}],"output":{"name":"ctxt"}}],[11,"fold_ty","","",302,{"inputs":[{"name":"bottomupfolder"},{"name":"tys"}],"output":{"name":"tys"}}],[11,"new","","",303,{"inputs":[{"name":"regionfolder"},{"name":"ctxt"},{"name":"f"}],"output":{"name":"regionfolder"}}],[11,"tcx","","",303,{"inputs":[{"name":"regionfolder"}],"output":{"name":"ctxt"}}],[11,"enter_region_binder","","",303,null],[11,"exit_region_binder","","",303,null],[11,"fold_region","","",303,{"inputs":[{"name":"regionfolder"},{"name":"region"}],"output":{"name":"region"}}],[11,"tcx","","",304,{"inputs":[{"name":"regioneraser"}],"output":{"name":"ctxt"}}],[11,"fold_region","","",304,{"inputs":[{"name":"regioneraser"},{"name":"region"}],"output":{"name":"region"}}],[11,"new","rustc::middle::ty_match","",305,{"inputs":[{"name":"match"},{"name":"ctxt"}],"output":{"name":"match"}}],[11,"tag","","",305,{"inputs":[{"name":"match"}],"output":{"name":"str"}}],[11,"tcx","","",305,{"inputs":[{"name":"match"}],"output":{"name":"ctxt"}}],[11,"a_is_expected","","",305,{"inputs":[{"name":"match"}],"output":{"name":"bool"}}],[11,"relate_with_variance","","",305,{"inputs":[{"name":"match"},{"name":"variance"},{"name":"t"},{"name":"t"}],"output":{"name":"result"}}],[11,"regions","","",305,{"inputs":[{"name":"match"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"tys","","",305,{"inputs":[{"name":"match"},{"name":"tys"},{"name":"tys"}],"output":{"name":"result"}}],[11,"binders","","",305,{"inputs":[{"name":"match"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",230,{"inputs":[{"name":"mt"},{"name":"r"},{"name":"mt"},{"name":"mt"}],"output":{"name":"result"}}],[11,"relate","","",249,{"inputs":[{"name":"barefnty"},{"name":"r"},{"name":"barefnty"},{"name":"barefnty"}],"output":{"name":"result"}}],[11,"relate","","",252,{"inputs":[{"name":"fnsig"},{"name":"r"},{"name":"fnsig"},{"name":"fnsig"}],"output":{"name":"result"}}],[11,"relate","syntax::ast","",298,{"inputs":[{"name":"unsafety"},{"name":"r"},{"name":"unsafety"},{"name":"unsafety"}],"output":{"name":"result"}}],[11,"relate","syntax::abi","",299,{"inputs":[{"name":"abi"},{"name":"r"},{"name":"abi"},{"name":"abi"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",282,{"inputs":[{"name":"projectionty"},{"name":"r"},{"name":"projectionty"},{"name":"projectionty"}],"output":{"name":"result"}}],[11,"relate","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"r"},{"name":"projectionpredicate"},{"name":"projectionpredicate"}],"output":{"name":"result"}}],[11,"relate","collections::vec","",296,{"inputs":[{"name":"vec"},{"name":"r"},{"name":"vec"},{"name":"vec"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",265,{"inputs":[{"name":"existentialbounds"},{"name":"r"},{"name":"existentialbounds"},{"name":"existentialbounds"}],"output":{"name":"result"}}],[11,"relate","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"r"},{"name":"enumset"},{"name":"enumset"}],"output":{"name":"result"}}],[11,"relate","rustc::middle::ty","",260,{"inputs":[{"name":"traitref"},{"name":"r"},{"name":"traitref"},{"name":"traitref"}],"output":{"name":"result"}}],[11,"relate","","",16,{"inputs":[{"name":"region"},{"name":"r"},{"name":"region"},{"name":"region"}],"output":{"name":"result"}}],[11,"relate","","",96,{"inputs":[{"name":"binder"},{"name":"r"},{"name":"binder"},{"name":"binder"}],"output":{"name":"result"}}],[11,"relate","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"r"},{"name":"rc"},{"name":"rc"}],"output":{"name":"result"}}],[11,"relate","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"r"},{"name":"box"},{"name":"box"}],"output":{"name":"result"}}],[11,"new","rustc::middle::ty_walk","",306,{"inputs":[{"name":"typewalker"},{"name":"tys"}],"output":{"name":"typewalker"}}],[11,"skip_current_subtree","","Skips the subtree of types corresponding to the last type\nreturned by `next()`.",306,null],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::middle::ty_walk","",306,{"inputs":[{"name":"typewalker"}],"output":{"name":"option"}}],[11,"visit_foreign_item","rustc::middle::weak_lang_items","",307,null],[11,"eq","rustc::metadata::common","",308,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"ne","","",308,{"inputs":[{"name":"astencode_tag"},{"name":"astencode_tag"}],"output":{"name":"bool"}}],[11,"clone","","",308,{"inputs":[{"name":"astencode_tag"}],"output":{"name":"astencode_tag"}}],[11,"from_u32","","",308,{"inputs":[{"name":"astencode_tag"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","","",309,{"inputs":[{"name":"linkmeta"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",309,{"inputs":[{"name":"linkmeta"}],"output":{"name":"linkmeta"}}],[11,"fmt","rustc::metadata::tydecode","",310,{"inputs":[{"name":"defidsource"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",310,{"inputs":[{"name":"defidsource"}],"output":{"name":"defidsource"}}],[11,"clone","rustc::metadata::encoder","",311,{"inputs":[{"name":"entry"}],"output":{"name":"entry"}}],[11,"visit_expr","","",312,null],[11,"visit_item","","",312,null],[11,"visit_foreign_item","","",312,null],[11,"visit_item","","",313,null],[11,"eq","rustc::metadata::decoder","",314,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"ne","","",314,{"inputs":[{"name":"family"},{"name":"family"}],"output":{"name":"bool"}}],[11,"fmt","","",315,{"inputs":[{"name":"deflike"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",315,{"inputs":[{"name":"deflike"}],"output":{"name":"deflike"}}],[11,"clone","","",316,{"inputs":[{"name":"cratedep"}],"output":{"name":"cratedep"}}],[11,"visit_item","rustc::metadata::creader","",317,null],[11,"as_slice","","",318,null],[11,"new","","",317,{"inputs":[{"name":"cratereader"},{"name":"session"}],"output":{"name":"cratereader"}}],[11,"read_crates","","",317,null],[11,"read_exported_macros","","Read exported macros.",317,{"inputs":[{"name":"cratereader"},{"name":"item"}],"output":{"name":"vec"}}],[11,"find_plugin_registrar","","Look for a plugin registrar. Returns library path and symbol name.",317,{"inputs":[{"name":"cratereader"},{"name":"span"},{"name":"str"}],"output":{"name":"option"}}],[11,"clone","rustc::metadata::cstore","",319,{"inputs":[{"name":"linkagepreference"}],"output":{"name":"linkagepreference"}}],[11,"eq","","",319,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"ne","","",319,{"inputs":[{"name":"linkagepreference"},{"name":"linkagepreference"}],"output":{"name":"bool"}}],[11,"fmt","","",319,{"inputs":[{"name":"linkagepreference"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",320,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"ne","","",320,{"inputs":[{"name":"nativelibrarykind"},{"name":"nativelibrarykind"}],"output":{"name":"bool"}}],[11,"clone","","",320,{"inputs":[{"name":"nativelibrarykind"}],"output":{"name":"nativelibrarykind"}}],[11,"from_u32","","",320,{"inputs":[{"name":"nativelibrarykind"},{"name":"u32"}],"output":{"name":"option"}}],[11,"clone","","",321,{"inputs":[{"name":"cratesource"}],"output":{"name":"cratesource"}}],[11,"eq","","",321,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"ne","","",321,{"inputs":[{"name":"cratesource"},{"name":"cratesource"}],"output":{"name":"bool"}}],[11,"new","","",322,{"inputs":[{"name":"cstore"},{"name":"rc"}],"output":{"name":"cstore"}}],[11,"next_crate_num","","",322,{"inputs":[{"name":"cstore"}],"output":{"name":"u32"}}],[11,"get_crate_data","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"rc"}}],[11,"get_crate_hash","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"svh"}}],[11,"set_crate_data","","",322,null],[11,"iter_crate_data","","",322,null],[11,"iter_crate_data_origins","","Like `iter_crate_data`, but passes source paths (if available) as well.",322,null],[11,"add_used_crate_source","","",322,null],[11,"get_used_crate_source","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"reset","","",322,null],[11,"get_used_crates","","",322,{"inputs":[{"name":"cstore"},{"name":"linkagepreference"}],"output":{"name":"vec"}}],[11,"add_used_library","","",322,null],[11,"get_used_libraries","","",322,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_used_link_args","","",322,null],[11,"get_used_link_args","","",322,{"inputs":[{"name":"cstore"}],"output":{"name":"refcell"}}],[11,"add_extern_mod_stmt_cnum","","",322,null],[11,"find_extern_mod_stmt_cnum","","",322,{"inputs":[{"name":"cstore"},{"name":"u32"}],"output":{"name":"option"}}],[11,"data","","",323,null],[11,"name","","",323,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"string"}}],[11,"hash","","",323,{"inputs":[{"name":"crate_metadata"}],"output":{"name":"svh"}}],[11,"as_slice","","",324,null],[11,"clone","rustc::metadata::csearch","",325,{"inputs":[{"name":"methodinfo"}],"output":{"name":"methodinfo"}}],[11,"maybe_load_library_crate","rustc::metadata::loader","",326,{"inputs":[{"name":"context"}],"output":{"name":"option"}}],[11,"load_library_crate","","",326,{"inputs":[{"name":"context"}],"output":{"name":"library"}}],[11,"report_load_errs","","",326,null],[11,"as_slice","","",327,null],[11,"clone","rustc::metadata::filesearch","",328,{"inputs":[{"name":"filematch"}],"output":{"name":"filematch"}}],[11,"for_each_lib_search_path","","",329,null],[11,"get_lib_path","","",329,{"inputs":[{"name":"filesearch"}],"output":{"name":"pathbuf"}}],[11,"search","","",329,null],[11,"new","","",329,{"inputs":[{"name":"filesearch"},{"name":"path"},{"name":"str"},{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"get_dylib_search_paths","","",329,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"get_tools_search_paths","","",329,{"inputs":[{"name":"filesearch"}],"output":{"name":"vec"}}],[11,"visit_item","rustc::metadata::macro_import","",330,null],[11,"visit_mac","","",330,null],[11,"eq","rustc::session::config","",331,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"ne","","",331,{"inputs":[{"name":"optlevel"},{"name":"optlevel"}],"output":{"name":"bool"}}],[11,"clone","","",331,{"inputs":[{"name":"optlevel"}],"output":{"name":"optlevel"}}],[11,"eq","","",332,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"ne","","",332,{"inputs":[{"name":"debuginfolevel"},{"name":"debuginfolevel"}],"output":{"name":"bool"}}],[11,"clone","","",332,{"inputs":[{"name":"debuginfolevel"}],"output":{"name":"debuginfolevel"}}],[11,"cmp","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"option"}}],[11,"lt","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"le","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"gt","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ge","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"eq","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"ne","","",333,{"inputs":[{"name":"outputtype"},{"name":"outputtype"}],"output":{"name":"bool"}}],[11,"clone","","",333,{"inputs":[{"name":"outputtype"}],"output":{"name":"outputtype"}}],[11,"clone","","",334,{"inputs":[{"name":"options"}],"output":{"name":"options"}}],[11,"clone","","",335,{"inputs":[{"name":"unstablefeatures"}],"output":{"name":"unstablefeatures"}}],[11,"eq","","",336,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"ne","","",336,{"inputs":[{"name":"printrequest"},{"name":"printrequest"}],"output":{"name":"bool"}}],[11,"clone","","",336,{"inputs":[{"name":"printrequest"}],"output":{"name":"printrequest"}}],[11,"filestem","","",337,{"inputs":[{"name":"input"}],"output":{"name":"string"}}],[11,"clone","","",338,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"outputfilenames"}}],[11,"path","","",338,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"temp_path","","",338,{"inputs":[{"name":"outputfilenames"},{"name":"outputtype"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","",338,{"inputs":[{"name":"outputfilenames"},{"name":"str"}],"output":{"name":"pathbuf"}}],[11,"filestem","","",338,{"inputs":[{"name":"outputfilenames"}],"output":{"name":"string"}}],[11,"eq","","",339,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"ne","","",339,{"inputs":[{"name":"entryfntype"},{"name":"entryfntype"}],"output":{"name":"bool"}}],[11,"clone","","",339,{"inputs":[{"name":"entryfntype"}],"output":{"name":"entryfntype"}}],[11,"fmt","","",340,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",340,null],[11,"cmp","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"ordering"}}],[11,"clone","","",340,{"inputs":[{"name":"cratetype"}],"output":{"name":"cratetype"}}],[11,"partial_cmp","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"option"}}],[11,"lt","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"le","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"gt","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ge","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"eq","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"ne","","",340,{"inputs":[{"name":"cratetype"},{"name":"cratetype"}],"output":{"name":"bool"}}],[11,"clone","","",341,{"inputs":[{"name":"passes"}],"output":{"name":"passes"}}],[11,"is_empty","","",341,{"inputs":[{"name":"passes"}],"output":{"name":"bool"}}],[11,"clone","","",342,{"inputs":[{"name":"codegenoptions"}],"output":{"name":"codegenoptions"}}],[11,"clone","","",343,{"inputs":[{"name":"debuggingoptions"}],"output":{"name":"debuggingoptions"}}],[11,"fmt","","",344,{"inputs":[{"name":"optionstability"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",344,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"optionstability"},{"name":"optionstability"}],"output":{"name":"bool"}}],[11,"clone","","",344,{"inputs":[{"name":"optionstability"}],"output":{"name":"optionstability"}}],[11,"eq","","",345,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"ne","","",345,{"inputs":[{"name":"rustcoptgroup"},{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"clone","","",345,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"rustcoptgroup"}}],[11,"is_stable","","",345,{"inputs":[{"name":"rustcoptgroup"}],"output":{"name":"bool"}}],[11,"fmt","","",340,{"inputs":[{"name":"cratetype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","rustc::session::search_paths","",346,{"inputs":[{"name":"searchpaths"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",346,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"fmt","","",347,{"inputs":[{"name":"pathkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",347,{"inputs":[{"name":"pathkind"}],"output":{"name":"pathkind"}}],[11,"eq","","",347,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"ne","","",347,{"inputs":[{"name":"pathkind"},{"name":"pathkind"}],"output":{"name":"bool"}}],[11,"new","","",346,{"inputs":[{"name":"searchpaths"}],"output":{"name":"searchpaths"}}],[11,"add_path","","",346,null],[11,"iter","","",346,{"inputs":[{"name":"searchpaths"},{"name":"pathkind"}],"output":{"name":"iter"}}],[6,"Item","rustc_borrowck::graphviz","",null,null],[11,"next","rustc::session::search_paths","",348,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"span_fatal","rustc::session","",349,null],[11,"span_fatal_with_code","","",349,null],[11,"fatal","","",349,null],[11,"span_err","","",349,null],[11,"span_err_with_code","","",349,null],[11,"err","","",349,null],[11,"err_count","","",349,{"inputs":[{"name":"session"}],"output":{"name":"usize"}}],[11,"has_errors","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"abort_if_errors","","",349,null],[11,"span_warn","","",349,null],[11,"span_warn_with_code","","",349,null],[11,"warn","","",349,null],[11,"opt_span_warn","","",349,null],[11,"span_note","","",349,null],[11,"span_end_note","","",349,null],[11,"span_suggestion","","Prints out a message with a suggested edit of the code.",349,null],[11,"span_help","","",349,null],[11,"fileline_note","","",349,null],[11,"fileline_help","","",349,null],[11,"note","","",349,null],[11,"help","","",349,null],[11,"opt_span_bug","","",349,null],[11,"span_bug","","",349,null],[11,"bug","","",349,null],[11,"span_unimpl","","",349,null],[11,"unimpl","","",349,null],[11,"add_lint","","",349,null],[11,"next_node_id","","",349,{"inputs":[{"name":"session"}],"output":{"name":"u32"}}],[11,"reserve_node_ids","","",349,{"inputs":[{"name":"session"},{"name":"u32"}],"output":{"name":"u32"}}],[11,"diagnostic","","",349,{"inputs":[{"name":"session"}],"output":{"name":"spanhandler"}}],[11,"codemap","","",349,{"inputs":[{"name":"session"}],"output":{"name":"codemap"}}],[11,"impossible_case","","",349,null],[11,"verbose","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_passes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_llvm_insns","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"count_type_sizes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"time_llvm_passes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"trans_stats","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"meta_stats","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"asm_comments","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_verify","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"borrowck_stats","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_llvm_passes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"lto","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"no_landing_pads","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"unstable_options","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"print_enum_sizes","","",349,{"inputs":[{"name":"session"}],"output":{"name":"bool"}}],[11,"sysroot","","",349,{"inputs":[{"name":"session"}],"output":{"name":"path"}}],[11,"target_filesearch","","",349,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"host_filesearch","","",349,{"inputs":[{"name":"session"},{"name":"pathkind"}],"output":{"name":"filesearch"}}],[11,"args","rustc::plugin::registry","Get the plugin's arguments, if any.",350,{"inputs":[{"name":"registry"}],"output":{"name":"vec"}}],[11,"register_syntax_extension","","Register a syntax extension of any kind.",350,null],[11,"register_macro","","Register a macro of the usual kind.",350,null],[11,"register_lint_pass","","Register a compiler lint pass.",350,null],[11,"register_lint_group","","Register a lint group.",350,null],[11,"register_llvm_pass","","Register an LLVM pass.",350,null],[11,"visit_item","rustc::plugin::build","",351,null],[11,"fmt","rustc::lint","",352,{"inputs":[{"name":"lint"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",352,{"inputs":[{"name":"lint"}],"output":{"name":"lint"}}],[11,"name_lower","","Get the lint's name, with ASCII letters converted to lowercase.",352,{"inputs":[{"name":"lint"}],"output":{"name":"string"}}],[11,"clone","","",353,{"inputs":[{"name":"lintid"}],"output":{"name":"lintid"}}],[11,"eq","","",353,{"inputs":[{"name":"lintid"},{"name":"lintid"}],"output":{"name":"bool"}}],[11,"hash","","",353,null],[11,"of","","Get the `LintId` for a `Lint`.",353,{"inputs":[{"name":"lintid"},{"name":"lint"}],"output":{"name":"lintid"}}],[11,"as_str","","Get the name of the lint.",353,{"inputs":[{"name":"lintid"}],"output":{"name":"string"}}],[11,"fmt","","",354,{"inputs":[{"name":"level"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"option"}}],[11,"lt","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"le","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"gt","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ge","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"eq","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"ne","","",354,{"inputs":[{"name":"level"},{"name":"level"}],"output":{"name":"bool"}}],[11,"clone","","",354,{"inputs":[{"name":"level"}],"output":{"name":"level"}}],[11,"as_str","","Convert a level to a lower-case string.",354,{"inputs":[{"name":"level"}],"output":{"name":"str"}}],[11,"from_str","","Convert a lower-case string to a level.",354,{"inputs":[{"name":"level"},{"name":"str"}],"output":{"name":"option"}}],[11,"eq","","",355,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"ne","","",355,{"inputs":[{"name":"lintsource"},{"name":"lintsource"}],"output":{"name":"bool"}}],[11,"clone","","",355,{"inputs":[{"name":"lintsource"}],"output":{"name":"lintsource"}}],[11,"clone","rustc::lint::builtin","",356,{"inputs":[{"name":"hardwiredlints"}],"output":{"name":"hardwiredlints"}}],[11,"get_lints","","",356,null],[11,"new","rustc::lint::context","",357,{"inputs":[{"name":"lintstore"}],"output":{"name":"lintstore"}}],[11,"get_lints","","",357,null],[11,"get_lint_groups","","",357,{"inputs":[{"name":"lintstore"}],"output":{"name":"vec"}}],[11,"register_pass","","",357,null],[11,"register_group","","",357,null],[11,"register_renamed","","",357,null],[11,"process_command_line","","",357,null],[11,"sess","","Get the overall compiler `Session` object.",358,{"inputs":[{"name":"context"}],"output":{"name":"session"}}],[11,"current_level","","Get the level of `lint` at the current position of the lint\ntraversal.",358,{"inputs":[{"name":"context"},{"name":"lint"}],"output":{"name":"level"}}],[11,"lint","","Emit a lint at the appropriate level, with no associated span.",358,null],[11,"span_lint","","Emit a lint at the appropriate level, for a particular span.",358,null],[11,"visit_item","","",358,null],[11,"visit_foreign_item","","",358,null],[11,"visit_pat","","",358,null],[11,"visit_expr","","",358,null],[11,"visit_stmt","","",358,null],[11,"visit_fn","","",358,null],[11,"visit_struct_def","","",358,null],[11,"visit_struct_field","","",358,null],[11,"visit_variant","","",358,null],[11,"visit_ty","","",358,null],[11,"visit_ident","","",358,null],[11,"visit_mod","","",358,null],[11,"visit_local","","",358,null],[11,"visit_block","","",358,null],[11,"visit_arm","","",358,null],[11,"visit_decl","","",358,null],[11,"visit_expr_post","","",358,null],[11,"visit_generics","","",358,null],[11,"visit_trait_item","","",358,null],[11,"visit_impl_item","","",358,null],[11,"visit_opt_lifetime_ref","","",358,null],[11,"visit_lifetime_ref","","",358,null],[11,"visit_lifetime_def","","",358,null],[11,"visit_explicit_self","","",358,null],[11,"visit_mac","","",358,null],[11,"visit_path","","",358,null],[11,"visit_attribute","","",358,null],[11,"visit_id","","",358,null],[11,"get_lints","","",359,null],[11,"check_item","","",359,null],[11,"fmt","rustc::util::common","",360,{"inputs":[{"name":"errorreported"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",360,{"inputs":[{"name":"errorreported"}],"output":{"name":"errorreported"}}],[11,"drop","","",361,null],[11,"visit_expr","","",362,null],[11,"visit_expr","","",363,null],[11,"repr","core::option","",12,{"inputs":[{"name":"option"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ptr","",364,{"inputs":[{"name":"p"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","core::result","",92,{"inputs":[{"name":"result"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","alloc::boxed","",297,{"inputs":[{"name":"box"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::owned_slice","",300,{"inputs":[{"name":"ownedslice"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::vec","",296,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",296,{"inputs":[{"name":"vec"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::def","",15,{"inputs":[{"name":"def"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",259,{"inputs":[{"name":"tytrait"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",273,{"inputs":[{"name":"typeparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",274,{"inputs":[{"name":"regionparameterdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",247,{"inputs":[{"name":"tys"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",230,{"inputs":[{"name":"mt"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",185,{"inputs":[{"name":"substs"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",188,{"inputs":[{"name":"vecperparamspace"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",286,{"inputs":[{"name":"itemsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::subst","",186,{"inputs":[{"name":"regionsubsts"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",264,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",260,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",365,{"inputs":[{"name":"traitdef"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",366,{"inputs":[{"name":"traititem"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",160,{"inputs":[{"name":"expr"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",367,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",367,{"inputs":[{"name":"path"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",368,{"inputs":[{"name":"ty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",369,{"inputs":[{"name":"item"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",370,{"inputs":[{"name":"lifetime"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",371,{"inputs":[{"name":"spanned"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",161,{"inputs":[{"name":"pat"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",20,{"inputs":[{"name":"boundregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",16,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",16,{"inputs":[{"name":"region"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",17,{"inputs":[{"name":"freeregion"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::region","",18,{"inputs":[{"name":"codeextent"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",19,{"inputs":[{"name":"destructionscopedata"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",11,{"inputs":[{"name":"defid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",285,{"inputs":[{"name":"typescheme"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",275,{"inputs":[{"name":"generics"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",276,{"inputs":[{"name":"genericpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",283,{"inputs":[{"name":"instantiatedpredicates"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",233,{"inputs":[{"name":"itemvariances"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",234,{"inputs":[{"name":"variance"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",228,{"inputs":[{"name":"method"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",6,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",6,{"inputs":[{"name":"name"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",5,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",372,{"inputs":[{"name":"explicitself_"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",373,{"inputs":[{"name":"visibility"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",249,{"inputs":[{"name":"barefnty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",252,{"inputs":[{"name":"fnsig"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",251,{"inputs":[{"name":"fnoutput"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",241,{"inputs":[{"name":"methodcallee"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",25,{"inputs":[{"name":"methodorigin"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",239,{"inputs":[{"name":"methodparam"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",240,{"inputs":[{"name":"methodobject"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",266,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",266,{"inputs":[{"name":"builtinbound"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::codemap","",13,{"inputs":[{"name":"span"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","alloc::rc","",95,{"inputs":[{"name":"rc"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",264,{"inputs":[{"name":"parambounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",265,{"inputs":[{"name":"existentialbounds"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","collections::enum_set","",301,{"inputs":[{"name":"enumset"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","rustc::middle::ty","",96,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",260,{"inputs":[{"name":"traitref"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","syntax::ast","",5,{"inputs":[{"name":"ident"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::abi","",299,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",299,{"inputs":[{"name":"abi"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",256,{"inputs":[{"name":"upvarid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",374,{"inputs":[{"name":"mutability"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",257,{"inputs":[{"name":"borrowkind"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",23,{"inputs":[{"name":"upvarborrow"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",24,{"inputs":[{"name":"upvarcapture"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",125,{"inputs":[{"name":"intvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",127,{"inputs":[{"name":"floatvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",268,{"inputs":[{"name":"regionvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",267,{"inputs":[{"name":"tyvid"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",126,{"inputs":[{"name":"intvarvalue"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",375,{"inputs":[{"name":"intty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",376,{"inputs":[{"name":"uintty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",128,{"inputs":[{"name":"floatty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",294,{"inputs":[{"name":"explicitselfcategory"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",253,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",253,{"inputs":[{"name":"paramty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",96,{"inputs":[{"name":"binder"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","std::collections::hash::map","",377,{"inputs":[{"name":"hashmap"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","rustc::middle::ty","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",280,{"inputs":[{"name":"outlivespredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",279,{"inputs":[{"name":"equatepredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",278,{"inputs":[{"name":"traitpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",281,{"inputs":[{"name":"projectionpredicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","","",282,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",282,{"inputs":[{"name":"projectionty"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"user_string","","",277,{"inputs":[{"name":"predicate"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"repr","syntax::ast","",298,{"inputs":[{"name":"unsafety"},{"name":"ctxt"}],"output":{"name":"string"}}],[11,"default","rustc::util::nodemap","",378,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"fnvhasher"}}],[11,"write","","",378,null],[11,"finish","","",378,{"inputs":[{"name":"fnvhasher"}],"output":{"name":"u64"}}],[11,"new","rustc::util::snapshot_vec","",379,{"inputs":[{"name":"snapshotvec"},{"name":"d"}],"output":{"name":"snapshotvec"}}],[11,"record","","",379,null],[11,"push","","",379,null],[11,"get","","",379,null],[11,"get_mut","","Returns a mutable pointer into the vec; whatever changes you make here cannot be undone\nautomatically, so you should be sure call `record()` with some sort of suitable undo\naction.",379,null],[11,"set","","Updates the element at the given index. The old value will saved (and perhaps restored) if\na snapshot is active.",379,null],[11,"start_snapshot","","",379,{"inputs":[{"name":"snapshotvec"}],"output":{"name":"snapshot"}}],[11,"actions_since_snapshot","","",379,null],[11,"rollback_to","","",379,null],[11,"commit","","Commits all changes since the last snapshot. Of course, they\ncan still be undone if there is a snapshot further out.",379,null],[11,"input","rustc_back::sha2","",380,null],[11,"reset","","",380,null],[11,"zero_until","","",380,null],[11,"next","","",380,null],[11,"full_buffer","","",380,null],[11,"position","","",380,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"remaining","","",380,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"size","","",380,{"inputs":[{"name":"fixedbuffer64"}],"output":{"name":"usize"}}],[11,"new","","Construct a new instance of a SHA-256 digest.",381,{"inputs":[{"name":"sha256"}],"output":{"name":"sha256"}}],[11,"input","","",381,null],[11,"result","","",381,null],[11,"reset","","",381,null],[11,"output_bits","","",381,{"inputs":[{"name":"sha256"}],"output":{"name":"usize"}}],[11,"open","rustc_llvm::archive_ro","Opens a static archive for read-only purposes. This is more optimized\nthan the `open` method because it uses LLVM's internal `Archive` class\nrather than shelling out to `ar` for everything.",382,{"inputs":[{"name":"archivero"},{"name":"path"}],"output":{"name":"option"}}],[11,"read","","Reads a file in the archive",382,{"inputs":[{"name":"archivero"},{"name":"str"}],"output":{"name":"option"}}],[11,"drop","","",382,null],[11,"clone","rustc_llvm::diagnostic","",383,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"optimizationdiagnostickind"}}],[11,"describe","","",383,{"inputs":[{"name":"optimizationdiagnostickind"}],"output":{"name":"str"}}],[11,"clone","","",384,{"inputs":[{"name":"optimizationdiagnostic"}],"output":{"name":"optimizationdiagnostic"}}],[11,"clone","","",385,{"inputs":[{"name":"inlineasmdiagnostic"}],"output":{"name":"inlineasmdiagnostic"}}],[11,"clone","","",386,{"inputs":[{"name":"diagnostic"}],"output":{"name":"diagnostic"}}],[11,"unpack","","",386,null],[11,"eq","rustc_llvm","",387,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"ne","","",387,{"inputs":[{"name":"callconv"},{"name":"callconv"}],"output":{"name":"bool"}}],[11,"clone","","",387,{"inputs":[{"name":"callconv"}],"output":{"name":"callconv"}}],[11,"clone","","",388,{"inputs":[{"name":"visibility"}],"output":{"name":"visibility"}}],[11,"clone","","",389,{"inputs":[{"name":"linkage"}],"output":{"name":"linkage"}}],[11,"fmt","","",390,{"inputs":[{"name":"diagnosticseverity"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",390,{"inputs":[{"name":"diagnosticseverity"}],"output":{"name":"diagnosticseverity"}}],[11,"hash","","",391,null],[11,"cmp","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"option"}}],[11,"lt","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"le","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"gt","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ge","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"clone","","",391,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"eq","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"ne","","",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"empty","","Returns an empty set of flags.",391,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"all","","Returns the set containing all flags.",391,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"bits","","Returns the raw value of the flags currently stored.",391,{"inputs":[{"name":"attribute"}],"output":{"name":"u32"}}],[11,"from_bits","","Convert from underlying bit representation, unless that\nrepresentation contains bits that do not correspond to a flag.",391,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"option"}}],[11,"from_bits_truncate","","Convert from underlying bit representation, dropping any bits\nthat do not correspond to flags.",391,{"inputs":[{"name":"attribute"},{"name":"u32"}],"output":{"name":"attribute"}}],[11,"is_empty","","Returns `true` if no flags are currently stored.",391,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"is_all","","Returns `true` if all flags are currently set.",391,{"inputs":[{"name":"attribute"}],"output":{"name":"bool"}}],[11,"intersects","","Returns `true` if there are flags common to both `self` and `other`.",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` all of the flags in `other` are contained within `self`.",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"bool"}}],[11,"insert","","Inserts the specified flags in-place.",391,null],[11,"remove","","Removes the specified flags in-place.",391,null],[11,"toggle","","Toggles the specified flags in-place.",391,null],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitor","rustc_llvm","Returns the union of the two sets of flags.",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitxor","rustc_llvm","Returns the left flags, but with all the right flags toggled.",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"bitand","rustc_llvm","Returns the intersection between the two sets of flags.",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"sub","rustc_llvm","Returns the set difference of the two sets of flags.",391,{"inputs":[{"name":"attribute"},{"name":"attribute"}],"output":{"name":"attribute"}}],[6,"Output","rustc_borrowck::graphviz","",null,null],[11,"not","rustc_llvm","Returns the complement of this set of flags.",391,{"inputs":[{"name":"attribute"}],"output":{"name":"attribute"}}],[11,"clone","","",392,{"inputs":[{"name":"otherattribute"}],"output":{"name":"otherattribute"}}],[11,"clone","","",393,{"inputs":[{"name":"specialattribute"}],"output":{"name":"specialattribute"}}],[11,"clone","","",394,{"inputs":[{"name":"attributeset"}],"output":{"name":"attributeset"}}],[11,"apply_llfn","","",391,null],[11,"apply_callsite","","",391,null],[11,"apply_llfn","","",392,null],[11,"apply_callsite","","",392,null],[11,"apply_llfn","","",393,null],[11,"apply_callsite","","",393,null],[11,"new","","",395,{"inputs":[{"name":"attrbuilder"}],"output":{"name":"attrbuilder"}}],[11,"arg","","",395,{"inputs":[{"name":"attrbuilder"},{"name":"usize"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"ret","","",395,{"inputs":[{"name":"attrbuilder"},{"name":"t"}],"output":{"name":"attrbuilder"}}],[11,"apply_llfn","","",395,null],[11,"apply_callsite","","",395,null],[11,"clone","","",396,{"inputs":[{"name":"intpredicate"}],"output":{"name":"intpredicate"}}],[11,"clone","","",397,{"inputs":[{"name":"realpredicate"}],"output":{"name":"realpredicate"}}],[11,"fmt","","",398,{"inputs":[{"name":"typekind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",398,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"ne","","",398,{"inputs":[{"name":"typekind"},{"name":"typekind"}],"output":{"name":"bool"}}],[11,"clone","","",398,{"inputs":[{"name":"typekind"}],"output":{"name":"typekind"}}],[11,"clone","","",399,{"inputs":[{"name":"atomicbinop"}],"output":{"name":"atomicbinop"}}],[11,"clone","","",400,{"inputs":[{"name":"atomicordering"}],"output":{"name":"atomicordering"}}],[11,"clone","","",401,{"inputs":[{"name":"filetype"}],"output":{"name":"filetype"}}],[11,"clone","","",402,{"inputs":[{"name":"metadatatype"}],"output":{"name":"metadatatype"}}],[11,"clone","","",403,{"inputs":[{"name":"asmdialect"}],"output":{"name":"asmdialect"}}],[11,"eq","","",404,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"ne","","",404,{"inputs":[{"name":"codegenoptlevel"},{"name":"codegenoptlevel"}],"output":{"name":"bool"}}],[11,"clone","","",404,{"inputs":[{"name":"codegenoptlevel"}],"output":{"name":"codegenoptlevel"}}],[11,"eq","","",405,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"ne","","",405,{"inputs":[{"name":"relocmode"},{"name":"relocmode"}],"output":{"name":"bool"}}],[11,"clone","","",405,{"inputs":[{"name":"relocmode"}],"output":{"name":"relocmode"}}],[11,"clone","","",406,{"inputs":[{"name":"codegenmodel"}],"output":{"name":"codegenmodel"}}],[11,"clone","","",407,{"inputs":[{"name":"diagnostickind"}],"output":{"name":"diagnostickind"}}],[11,"clone","rustc_llvm::debuginfo","",408,{"inputs":[{"name":"didescriptorflags"}],"output":{"name":"didescriptorflags"}}],[11,"drop","rustc_llvm","",409,null],[11,"new","","",410,null],[11,"drop","","",410,null],[11,"drop","","",411,null],[6,"Node","rustc_borrowck::graphviz","",null,null],[6,"Edge","","",null,null],[3,"DataflowLabeller","","",null,null],[12,"inner","","",412,null],[12,"variants","","",412,null],[12,"borrowck_ctxt","","",412,null],[12,"analysis_data","","",412,null],[4,"Variant","","",null,null],[13,"Loans","","",413,null],[13,"Moves","","",413,null],[13,"Assigns","","",413,null],[11,"clone","","",413,{"inputs":[{"name":"variant"}],"output":{"name":"variant"}}],[11,"fmt","","",413,{"inputs":[{"name":"variant"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"short_name","","",413,{"inputs":[{"name":"variant"}],"output":{"name":"str"}}],[11,"graph_id","","",412,{"inputs":[{"name":"dataflowlabeller"}],"output":{"name":"id"}}],[11,"node_id","","",412,{"inputs":[{"name":"dataflowlabeller"},{"name":"node"}],"output":{"name":"id"}}],[11,"node_label","","",412,{"inputs":[{"name":"dataflowlabeller"},{"name":"node"}],"output":{"name":"labeltext"}}],[11,"edge_label","","",412,{"inputs":[{"name":"dataflowlabeller"},{"name":"edge"}],"output":{"name":"labeltext"}}],[11,"nodes","","",412,{"inputs":[{"name":"dataflowlabeller"}],"output":{"name":"nodes"}}],[11,"edges","","",412,{"inputs":[{"name":"dataflowlabeller"}],"output":{"name":"edges"}}],[11,"source","","",412,{"inputs":[{"name":"dataflowlabeller"},{"name":"edge"}],"output":{"name":"node"}}],[11,"target","","",412,{"inputs":[{"name":"dataflowlabeller"},{"name":"edge"}],"output":{"name":"node"}}]],"paths":[[3,"FnPartsWithCFG"],[3,"Svh"],[4,"SawAbiComponent"],[4,"SawExprComponent"],[4,"SawStmtComponent"],[3,"Ident"],[3,"Name"],[3,"StrictVersionHashVisitor"],[3,"Archive"],[3,"ArchiveBuilder"],[3,"DecodeContext"],[3,"DefId"],[4,"Option"],[3,"Span"],[3,"NestedItemsDropper"],[4,"Def"],[4,"Region"],[3,"FreeRegion"],[4,"CodeExtent"],[3,"DestructionScopeData"],[4,"BoundRegion"],[3,"Decoder"],[3,"Freevar"],[3,"UpvarBorrow"],[4,"UpvarCapture"],[4,"MethodOrigin"],[3,"EncodeContext"],[3,"Encoder"],[3,"SideTableEncodingIdVisitor"],[3,"Doc"],[3,"LoopScope"],[3,"LabelledCFG"],[4,"CFGNodeData"],[3,"CFG"],[3,"ConstQualif"],[4,"Mode"],[3,"CheckCrateVisitor"],[3,"CheckCrateVisitor"],[3,"CheckItemRecursionVisitor"],[4,"Context"],[3,"CheckLoopVisitor"],[3,"Matrix"],[4,"Constructor"],[4,"Usefulness"],[4,"WitnessPreference"],[3,"MatchCheckCtxt"],[3,"StaticInliner"],[3,"RenamingRecorder"],[3,"MutationChecker"],[3,"AtBindingPatternVisitor"],[3,"RvalueContext"],[3,"RvalueContextDelegate"],[4,"const_val"],[3,"ConstEvalErr"],[4,"ErrKind"],[4,"IntTy"],[4,"UintTy"],[4,"EntryOrExit"],[3,"DataFlowContext"],[4,"KillFrom"],[3,"Union"],[3,"Subtract"],[3,"MarkSymbolVisitor"],[3,"LifeSeeder"],[3,"DeadVisitor"],[3,"PathResolution"],[3,"Export"],[4,"MethodProvenance"],[4,"UnsafeContext"],[3,"EffectCheckVisitor"],[3,"EntryContext"],[4,"LoanCause"],[4,"ConsumeMode"],[4,"MoveReason"],[4,"MatchMode"],[4,"TrackMatchMode"],[4,"MutateMode"],[4,"OverloadedCallType"],[3,"ExprUseVisitor"],[4,"SimplifiedType"],[3,"FreeRegionMap"],[3,"Edge"],[3,"NodeIndex"],[3,"EdgeIndex"],[3,"Direction"],[3,"Graph"],[3,"DepthFirstTraversal"],[3,"IntrinsicCheckingVisitor"],[3,"TransmuteRestriction"],[3,"Bivariate"],[3,"CombineFields"],[3,"Generalizer"],[4,"Result"],[3,"Equate"],[3,"InferCtxt"],[3,"Rc"],[3,"Binder"],[3,"Glb"],[3,"Lub"],[4,"Node"],[4,"Edge"],[3,"ConstraintGraph"],[4,"Constraint"],[4,"GenericKind"],[3,"TwoRegions"],[4,"UndoLogEntry"],[4,"CombineMapType"],[4,"RegionResolutionError"],[3,"SameRegions"],[3,"RegionSnapshot"],[3,"RegionVarBindings"],[4,"Classification"],[4,"VarValue"],[4,"Verify"],[3,"RegionAndOrigin"],[3,"OpportunisticTypeResolver"],[3,"FullTypeResolver"],[3,"TypeFreshener"],[3,"Sub"],[4,"RelationDir"],[3,"TypeVariableTable"],[3,"Delegate"],[4,"VarValue"],[3,"Delegate"],[3,"UnificationTable"],[3,"IntVid"],[4,"IntVarValue"],[3,"FloatVid"],[4,"FloatTy"],[4,"TypeOrigin"],[4,"ValuePairs"],[3,"TypeTrace"],[4,"SubregionOrigin"],[4,"LateBoundRegionConversionTime"],[4,"RegionVariableOrigin"],[4,"fixup_err"],[4,"Implication"],[4,"LangItem"],[3,"LanguageItems"],[3,"LanguageItemCollector"],[3,"Variable"],[3,"LiveNode"],[4,"LiveNodeKind"],[3,"IrMaps"],[3,"LocalInfo"],[4,"VarKind"],[3,"Liveness"],[3,"Users"],[3,"Specials"],[4,"categorization"],[3,"Upvar"],[4,"PointerKind"],[4,"InteriorKind"],[4,"FieldName"],[4,"InteriorOffsetKind"],[4,"ElementKind"],[4,"MutabilityCategory"],[4,"Note"],[3,"cmt_"],[4,"deref_kind"],[3,"Expr"],[3,"Pat"],[3,"MemCategorizationContext"],[4,"InteriorSafety"],[4,"Aliasability"],[4,"AliasableReason"],[4,"ClosureKind"],[4,"LastPrivate"],[4,"PrivateDep"],[4,"ImportUse"],[3,"ReachableContext"],[3,"BlockRemainder"],[4,"InnermostDeclaringBlock"],[3,"DeclaringStatementContext"],[4,"InnermostEnclosingExpr"],[3,"Context"],[3,"RegionMaps"],[3,"RegionResolutionVisitor"],[4,"DefRegion"],[3,"LifetimeContext"],[4,"ShadowKind"],[4,"ScopeChain"],[3,"Annotator"],[3,"Index"],[3,"Checker"],[3,"Substs"],[4,"RegionSubsts"],[4,"ParamSpace"],[3,"VecPerParamSpace"],[3,"EnumeratedItems"],[3,"SubstFolder"],[3,"InferIsLocal"],[3,"RegionObligation"],[3,"FulfillmentContext"],[3,"MismatchedProjectionTypes"],[4,"ProjectionTyCandidate"],[3,"AssociatedTypeNormalizer"],[3,"Normalized"],[4,"ProjectionTyError"],[4,"MethodViolationCode"],[4,"ObjectSafetyViolation"],[3,"SelectionCache"],[4,"MethodMatchedData"],[4,"SelectionCandidate"],[4,"EvaluationResult"],[3,"SelectionContext"],[3,"TraitObligationStackList"],[3,"TraitObligationStack"],[4,"MethodMatchResult"],[3,"Elaborator"],[3,"SupertraitDefIds"],[3,"FilterToTraits"],[3,"VtableImplData"],[3,"VtableObjectData"],[3,"Obligation"],[4,"Vtable"],[3,"VtableBuiltinData"],[3,"VtableDefaultImplData"],[4,"SelectionError"],[3,"FulfillmentError"],[4,"FulfillmentErrorCode"],[3,"ObligationCause"],[4,"ObligationCauseCode"],[3,"DerivedObligationCause"],[3,"field"],[4,"ImplOrTraitItemContainer"],[4,"ImplOrTraitItem"],[4,"ImplOrTraitItemId"],[3,"Method"],[3,"AssociatedType"],[3,"mt"],[3,"field_ty"],[3,"creader_cache_key"],[3,"ItemVariances"],[4,"Variance"],[4,"AutoAdjustment"],[3,"AutoDerefRef"],[4,"AutoRef"],[3,"param_index"],[3,"MethodParam"],[3,"MethodObject"],[3,"MethodCallee"],[3,"MethodCall"],[4,"vtable_origin"],[3,"CtxtArenas"],[3,"ctxt"],[3,"TypeFlags"],[3,"TyS"],[3,"InternedTy"],[3,"BareFnTy"],[3,"ClosureTy"],[4,"FnOutput"],[3,"FnSig"],[3,"ParamTy"],[3,"DebruijnIndex"],[3,"EarlyBoundRegion"],[3,"UpvarId"],[4,"BorrowKind"],[4,"sty"],[3,"TyTrait"],[3,"TraitRef"],[4,"terr_vstore_kind"],[3,"expected_found"],[4,"type_err"],[3,"ParamBounds"],[3,"ExistentialBounds"],[4,"BuiltinBound"],[3,"TyVid"],[3,"RegionVid"],[4,"InferTy"],[4,"UnconstrainedNumeric"],[4,"InferRegion"],[4,"ObjectLifetimeDefault"],[3,"TypeParameterDef"],[3,"RegionParameterDef"],[3,"Generics"],[3,"GenericPredicates"],[4,"Predicate"],[3,"TraitPredicate"],[3,"EquatePredicate"],[3,"OutlivesPredicate"],[3,"ProjectionPredicate"],[3,"ProjectionTy"],[3,"InstantiatedPredicates"],[3,"ParameterEnvironment"],[3,"TypeScheme"],[3,"ItemSubsts"],[3,"TypeContents"],[4,"Representability"],[4,"ExprKind"],[3,"VariantInfo"],[4,"DtorKind"],[4,"IntType"],[3,"ClosureUpvar"],[4,"ExplicitSelfCategory"],[4,"CopyImplementationError"],[3,"Vec"],[3,"Box"],[4,"Unsafety"],[4,"Abi"],[3,"OwnedSlice"],[3,"EnumSet"],[3,"BottomUpFolder"],[3,"RegionFolder"],[3,"RegionEraser"],[3,"Match"],[3,"TypeWalker"],[3,"Context"],[4,"astencode_tag"],[3,"LinkMeta"],[4,"DefIdSource"],[3,"entry"],[3,"EncodeVisitor"],[3,"ImplVisitor"],[4,"Family"],[4,"DefLike"],[3,"CrateDep"],[3,"CrateReader"],[4,"PMDSource"],[4,"LinkagePreference"],[4,"NativeLibraryKind"],[3,"CrateSource"],[3,"CStore"],[3,"crate_metadata"],[4,"MetadataBlob"],[3,"MethodInfo"],[3,"Context"],[3,"ArchiveMetadata"],[4,"FileMatch"],[3,"FileSearch"],[3,"MacroLoader"],[4,"OptLevel"],[4,"DebugInfoLevel"],[4,"OutputType"],[3,"Options"],[4,"UnstableFeatures"],[4,"PrintRequest"],[4,"Input"],[3,"OutputFilenames"],[4,"EntryFnType"],[4,"CrateType"],[4,"Passes"],[3,"CodegenOptions"],[3,"DebuggingOptions"],[4,"OptionStability"],[3,"RustcOptGroup"],[3,"SearchPaths"],[4,"PathKind"],[3,"Iter"],[3,"Session"],[3,"Registry"],[3,"RegistrarFinder"],[3,"Lint"],[3,"LintId"],[4,"Level"],[4,"LintSource"],[3,"HardwiredLints"],[3,"LintStore"],[3,"Context"],[3,"GatherNodeLevels"],[3,"ErrorReported"],[3,"Indenter"],[3,"LoopQueryVisitor"],[3,"BlockQueryVisitor"],[3,"P"],[3,"TraitDef"],[3,"TraitItem"],[3,"Path"],[3,"Ty"],[3,"Item"],[3,"Lifetime"],[3,"Spanned"],[4,"ExplicitSelf_"],[4,"Visibility"],[4,"Mutability"],[4,"IntTy"],[4,"UintTy"],[3,"HashMap"],[3,"FnvHasher"],[3,"SnapshotVec"],[3,"FixedBuffer64"],[3,"Sha256"],[3,"ArchiveRO"],[4,"OptimizationDiagnosticKind"],[3,"OptimizationDiagnostic"],[3,"InlineAsmDiagnostic"],[4,"Diagnostic"],[4,"CallConv"],[4,"Visibility"],[4,"Linkage"],[4,"DiagnosticSeverity"],[3,"Attribute"],[4,"OtherAttribute"],[4,"SpecialAttribute"],[4,"AttributeSet"],[3,"AttrBuilder"],[4,"IntPredicate"],[4,"RealPredicate"],[4,"TypeKind"],[4,"AtomicBinOp"],[4,"AtomicOrdering"],[4,"FileType"],[4,"MetadataType"],[4,"AsmDialect"],[4,"CodeGenOptLevel"],[4,"RelocMode"],[4,"CodeGenModel"],[4,"DiagnosticKind"],[4,"DIDescriptorFlags"],[3,"TargetData"],[3,"ObjectFile"],[3,"SectionIter"],[3,"DataflowLabeller"],[4,"Variant"]]};
searchIndex['serialize'] = {"items":[[0,"","serialize","Support code for encoding and decoding types.",null,null],[11,"encode","collections::string","",0,{"inputs":[{"name":"string"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",0,{"inputs":[{"name":"string"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","alloc::boxed","",1,{"inputs":[{"name":"box"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",1,{"inputs":[{"name":"box"},{"name":"d"}],"output":{"name":"result"}}],[11,"decode","","",1,{"inputs":[{"name":"box"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","alloc::rc","",2,{"inputs":[{"name":"rc"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",2,{"inputs":[{"name":"rc"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::vec","",3,{"inputs":[{"name":"vec"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",3,{"inputs":[{"name":"vec"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","core::option","",4,{"inputs":[{"name":"option"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",4,{"inputs":[{"name":"option"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","std::path","",5,{"inputs":[{"name":"pathbuf"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",5,{"inputs":[{"name":"pathbuf"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","core::cell","",6,{"inputs":[{"name":"cell"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",6,{"inputs":[{"name":"cell"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","","",7,{"inputs":[{"name":"refcell"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",7,{"inputs":[{"name":"refcell"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","alloc::arc","",8,{"inputs":[{"name":"arc"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",8,{"inputs":[{"name":"arc"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::linked_list","",9,{"inputs":[{"name":"linkedlist"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",9,{"inputs":[{"name":"linkedlist"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::vec_deque","",10,{"inputs":[{"name":"vecdeque"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",10,{"inputs":[{"name":"vecdeque"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::btree::map","",11,{"inputs":[{"name":"btreemap"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",11,{"inputs":[{"name":"btreemap"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::btree::set","",12,{"inputs":[{"name":"btreeset"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",12,{"inputs":[{"name":"btreeset"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::enum_set","",13,{"inputs":[{"name":"enumset"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",13,{"inputs":[{"name":"enumset"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","std::collections::hash::map","",14,{"inputs":[{"name":"hashmap"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",14,{"inputs":[{"name":"hashmap"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","std::collections::hash::set","",15,{"inputs":[{"name":"hashset"},{"name":"e"}],"output":{"name":"result"}}],[11,"decode","","",15,{"inputs":[{"name":"hashset"},{"name":"d"}],"output":{"name":"result"}}],[11,"encode","collections::vec_map","",16,{"inputs":[{"name":"vecmap"},{"name":"s"}],"output":{"name":"result"}}],[11,"decode","","",16,{"inputs":[{"name":"vecmap"},{"name":"d"}],"output":{"name":"result"}}],[0,"hex","serialize","Hex binary-to-text encoding",null,null],[4,"FromHexError","serialize::hex","Errors that can occur when decoding a hex encoded string",null,null],[13,"InvalidHexCharacter","","The input contained a character not part of the hex format",17,null],[13,"InvalidHexLength","","The input had an invalid length",17,null],[8,"ToHex","","A trait for converting a value to hexadecimal encoding",null,null],[10,"to_hex","","Converts the value of `self` to a hex value, returning the owned\nstring.",18,{"inputs":[{"name":"tohex"}],"output":{"name":"string"}}],[8,"FromHex","","A trait for converting hexadecimal encoded values",null,null],[10,"from_hex","","Converts the value of `self`, interpreted as hexadecimal encoded data,\ninto an owned vector of bytes, returning the vector.",19,{"inputs":[{"name":"fromhex"}],"output":{"name":"result"}}],[11,"fmt","","",17,{"inputs":[{"name":"fromhexerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",17,{"inputs":[{"name":"fromhexerror"}],"output":{"name":"fromhexerror"}}],[11,"fmt","","",17,{"inputs":[{"name":"fromhexerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",17,{"inputs":[{"name":"fromhexerror"}],"output":{"name":"str"}}],[0,"json","serialize","JSON parsing and serialization",null,null],[3,"PrettyJson","serialize::json","",null,null],[3,"AsJson","","",null,null],[3,"AsPrettyJson","","",null,null],[3,"Encoder","","A structure for implementing serialization to JSON.",null,null],[3,"PrettyEncoder","","Another encoder for JSON, but prints out human-readable JSON instead of\ncompact data",null,null],[3,"Stack","","A Stack represents the current position of the parser in the logical\nstructure of the JSON stream.\nFor example foo.bar[3].x",null,null],[3,"Parser","","A streaming JSON parser implemented as an iterator of JsonEvent, consuming\nan iterator of char.",null,null],[3,"Builder","","A Builder consumes a json::Parser to create a generic Json structure.",null,null],[3,"Decoder","","A structure to decode JSON to values in rust.",null,null],[4,"Json","","Represents a json value",null,null],[13,"I64","","",20,null],[13,"U64","","",20,null],[13,"F64","","",20,null],[13,"String","","",20,null],[13,"Boolean","","",20,null],[13,"Array","","",20,null],[13,"Object","","",20,null],[13,"Null","","",20,null],[4,"ErrorCode","","The errors that can arise while parsing a JSON stream.",null,null],[13,"InvalidSyntax","","",21,null],[13,"InvalidNumber","","",21,null],[13,"EOFWhileParsingObject","","",21,null],[13,"EOFWhileParsingArray","","",21,null],[13,"EOFWhileParsingValue","","",21,null],[13,"EOFWhileParsingString","","",21,null],[13,"KeyMustBeAString","","",21,null],[13,"ExpectedColon","","",21,null],[13,"TrailingCharacters","","",21,null],[13,"TrailingComma","","",21,null],[13,"InvalidEscape","","",21,null],[13,"InvalidUnicodeCodePoint","","",21,null],[13,"LoneLeadingSurrogateInHexEscape","","",21,null],[13,"UnexpectedEndOfHexEscape","","",21,null],[13,"UnrecognizedHex","","",21,null],[13,"NotFourDigit","","",21,null],[13,"NotUtf8","","",21,null],[4,"ParserError","","",null,null],[13,"SyntaxError","","msg, line, col",22,null],[13,"IoError","","",22,null],[4,"DecoderError","","",null,null],[13,"ParseError","","",23,null],[13,"ExpectedError","","",23,null],[13,"MissingFieldError","","",23,null],[13,"UnknownVariantError","","",23,null],[13,"ApplicationError","","",23,null],[4,"EncoderError","","",null,null],[13,"FmtError","","",24,null],[13,"BadHashmapKey","","",24,null],[4,"JsonEvent","","The output of the streaming parser.",null,null],[13,"ObjectStart","","",25,null],[13,"ObjectEnd","","",25,null],[13,"ArrayStart","","",25,null],[13,"ArrayEnd","","",25,null],[13,"BooleanValue","","",25,null],[13,"I64Value","","",25,null],[13,"U64Value","","",25,null],[13,"F64Value","","",25,null],[13,"StringValue","","",25,null],[13,"NullValue","","",25,null],[13,"Error","","",25,null],[4,"StackElement","","StackElements compose a Stack.\nFor example, StackElement::Key(\"foo\"), StackElement::Key(\"bar\"),\nStackElement::Index(3) and StackElement::Key(\"x\") are the\nStackElements compositing the stack that represents foo.bar[3].x",null,null],[13,"Index","","",26,null],[13,"Key","","",26,null],[5,"error_str","","Returns a readable error string for a given error code.",null,{"inputs":[{"name":"errorcode"}],"output":{"name":"str"}}],[5,"decode","","Shortcut function to decode a JSON `&str` into an object",null,{"inputs":[{"name":"str"}],"output":{"name":"decoderesult"}}],[5,"encode","","Shortcut function to encode a `T` into a JSON `String`",null,{"inputs":[{"name":"t"}],"output":{"name":"result"}}],[5,"as_json","","Create an `AsJson` wrapper which can be used to print a value as JSON\non-the-fly via `write!`",null,{"inputs":[{"name":"t"}],"output":{"name":"asjson"}}],[5,"as_pretty_json","","Create an `AsPrettyJson` wrapper which can be used to print a value as JSON\non-the-fly via `write!`",null,{"inputs":[{"name":"t"}],"output":{"name":"asprettyjson"}}],[5,"from_reader","","Decodes a json value from an `&mut old_io::Reader`",null,{"inputs":[{"name":"read"}],"output":{"name":"result"}}],[5,"from_str","","Decodes a json value from a string",null,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[6,"Array","","",null,null],[6,"Object","","",null,null],[6,"BuilderError","","",null,null],[6,"EncodeResult","","",null,null],[6,"DecodeResult","","",null,null],[8,"ToJson","","A trait for converting values to JSON",null,null],[10,"to_json","","Converts the value of `self` to an instance of JSON",27,{"inputs":[{"name":"tojson"}],"output":{"name":"json"}}],[11,"fmt","","",20,{"inputs":[{"name":"json"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"option"}}],[11,"lt","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"bool"}}],[11,"le","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"bool"}}],[11,"gt","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"bool"}}],[11,"ge","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"bool"}}],[11,"eq","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"bool"}}],[11,"ne","","",20,{"inputs":[{"name":"json"},{"name":"json"}],"output":{"name":"bool"}}],[11,"clone","","",20,{"inputs":[{"name":"json"}],"output":{"name":"json"}}],[11,"fmt","","",21,{"inputs":[{"name":"errorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",21,{"inputs":[{"name":"errorcode"},{"name":"errorcode"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"errorcode"},{"name":"errorcode"}],"output":{"name":"bool"}}],[11,"clone","","",21,{"inputs":[{"name":"errorcode"}],"output":{"name":"errorcode"}}],[11,"fmt","","",22,{"inputs":[{"name":"parsererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",22,{"inputs":[{"name":"parsererror"},{"name":"parsererror"}],"output":{"name":"bool"}}],[11,"ne","","",22,{"inputs":[{"name":"parsererror"},{"name":"parsererror"}],"output":{"name":"bool"}}],[11,"clone","","",22,{"inputs":[{"name":"parsererror"}],"output":{"name":"parsererror"}}],[11,"fmt","","",23,{"inputs":[{"name":"decodererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",23,{"inputs":[{"name":"decodererror"},{"name":"decodererror"}],"output":{"name":"bool"}}],[11,"ne","","",23,{"inputs":[{"name":"decodererror"},{"name":"decodererror"}],"output":{"name":"bool"}}],[11,"clone","","",23,{"inputs":[{"name":"decodererror"}],"output":{"name":"decodererror"}}],[11,"fmt","","",24,{"inputs":[{"name":"encodererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"encodererror"}],"output":{"name":"encodererror"}}],[11,"fmt","","",21,{"inputs":[{"name":"errorcode"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",22,{"inputs":[{"name":"parsererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",23,{"inputs":[{"name":"decodererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",23,{"inputs":[{"name":"decodererror"}],"output":{"name":"str"}}],[11,"fmt","","",24,{"inputs":[{"name":"encodererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",24,{"inputs":[{"name":"encodererror"}],"output":{"name":"str"}}],[11,"from","","",24,{"inputs":[{"name":"encodererror"},{"name":"error"}],"output":{"name":"encodererror"}}],[11,"new","","Creates a new JSON encoder whose output will be written to the writer\nspecified.",28,{"inputs":[{"name":"encoder"},{"name":"write"}],"output":{"name":"encoder"}}],[6,"Error","","",null,null],[11,"emit_nil","","",28,{"inputs":[{"name":"encoder"}],"output":{"name":"encoderesult"}}],[11,"emit_uint","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"emit_u64","","",28,{"inputs":[{"name":"encoder"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"emit_u32","","",28,{"inputs":[{"name":"encoder"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"emit_u16","","",28,{"inputs":[{"name":"encoder"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"emit_u8","","",28,{"inputs":[{"name":"encoder"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"emit_int","","",28,{"inputs":[{"name":"encoder"},{"name":"isize"}],"output":{"name":"encoderesult"}}],[11,"emit_i64","","",28,{"inputs":[{"name":"encoder"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"emit_i32","","",28,{"inputs":[{"name":"encoder"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"emit_i16","","",28,{"inputs":[{"name":"encoder"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"emit_i8","","",28,{"inputs":[{"name":"encoder"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"emit_bool","","",28,{"inputs":[{"name":"encoder"},{"name":"bool"}],"output":{"name":"encoderesult"}}],[11,"emit_f64","","",28,{"inputs":[{"name":"encoder"},{"name":"f64"}],"output":{"name":"encoderesult"}}],[11,"emit_f32","","",28,{"inputs":[{"name":"encoder"},{"name":"f32"}],"output":{"name":"encoderesult"}}],[11,"emit_char","","",28,{"inputs":[{"name":"encoder"},{"name":"char"}],"output":{"name":"encoderesult"}}],[11,"emit_str","","",28,{"inputs":[{"name":"encoder"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"emit_enum","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant_arg","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant_field","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct_field","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_arg","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct","","",28,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct_arg","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option","","",28,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option_none","","",28,{"inputs":[{"name":"encoder"}],"output":{"name":"encoderesult"}}],[11,"emit_option_some","","",28,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq_elt","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_key","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_val","","",28,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"new","","Creates a new encoder whose output will be written to the specified writer",29,{"inputs":[{"name":"prettyencoder"},{"name":"write"}],"output":{"name":"prettyencoder"}}],[11,"set_indent","","Set the number of spaces to indent for each level.\nThis is safe to set during encoding.",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"}],"output":null}],[6,"Error","","",null,null],[11,"emit_nil","","",29,{"inputs":[{"name":"prettyencoder"}],"output":{"name":"encoderesult"}}],[11,"emit_uint","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"emit_u64","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"emit_u32","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"emit_u16","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"emit_u8","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"emit_int","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"isize"}],"output":{"name":"encoderesult"}}],[11,"emit_i64","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"emit_i32","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"emit_i16","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"emit_i8","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"emit_bool","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"bool"}],"output":{"name":"encoderesult"}}],[11,"emit_f64","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"f64"}],"output":{"name":"encoderesult"}}],[11,"emit_f32","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"f32"}],"output":{"name":"encoderesult"}}],[11,"emit_char","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"char"}],"output":{"name":"encoderesult"}}],[11,"emit_str","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"emit_enum","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant_arg","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant_field","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct_field","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_arg","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct_arg","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option_none","","",29,{"inputs":[{"name":"prettyencoder"}],"output":{"name":"encoderesult"}}],[11,"emit_option_some","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq_elt","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_key","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_val","","",29,{"inputs":[{"name":"prettyencoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"encode","","",20,{"inputs":[{"name":"json"},{"name":"e"}],"output":{"name":"result"}}],[11,"pretty","","Borrow this json object as a pretty object to generate a pretty\nrepresentation for it via `Display`.",20,{"inputs":[{"name":"json"}],"output":{"name":"prettyjson"}}],[11,"find","","If the Json value is an Object, returns the value associated with the provided key.\nOtherwise, returns None.",20,{"inputs":[{"name":"json"},{"name":"str"}],"output":{"name":"option"}}],[11,"find_path","","Attempts to get a nested Json Object for each key in `keys`.\nIf any key is found not to exist, find_path will return None.\nOtherwise, it will return the Json value associated with the final key.",20,null],[11,"search","","If the Json value is an Object, performs a depth-first search until\na value associated with the provided key is found. If no value is found\nor the Json value is not an Object, returns None.",20,{"inputs":[{"name":"json"},{"name":"str"}],"output":{"name":"option"}}],[11,"is_object","","Returns true if the Json value is an Object. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"as_object","","If the Json value is an Object, returns the associated BTreeMap.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"is_array","","Returns true if the Json value is an Array. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"as_array","","If the Json value is an Array, returns the associated vector.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"is_string","","Returns true if the Json value is a String. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"as_string","","If the Json value is a String, returns the associated str.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"is_number","","Returns true if the Json value is a Number. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"is_i64","","Returns true if the Json value is a i64. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"is_u64","","Returns true if the Json value is a u64. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"is_f64","","Returns true if the Json value is a f64. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"as_i64","","If the Json value is a number, return or cast it to a i64.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"as_u64","","If the Json value is a number, return or cast it to a u64.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"as_f64","","If the Json value is a number, return or cast it to a f64.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"is_boolean","","Returns true if the Json value is a Boolean. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"as_boolean","","If the Json value is a Boolean, returns the associated bool.\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[11,"is_null","","Returns true if the Json value is a Null. Returns false otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"bool"}}],[11,"as_null","","If the Json value is a Null, returns ().\nReturns None otherwise.",20,{"inputs":[{"name":"json"}],"output":{"name":"option"}}],[6,"Output","","",null,null],[11,"index","","",20,{"inputs":[{"name":"json"},{"name":"str"}],"output":{"name":"json"}}],[6,"Output","","",null,null],[11,"index","","",20,{"inputs":[{"name":"json"},{"name":"usize"}],"output":{"name":"json"}}],[11,"fmt","","",25,{"inputs":[{"name":"jsonevent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",25,{"inputs":[{"name":"jsonevent"}],"output":{"name":"jsonevent"}}],[11,"eq","","",25,{"inputs":[{"name":"jsonevent"},{"name":"jsonevent"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"jsonevent"},{"name":"jsonevent"}],"output":{"name":"bool"}}],[11,"fmt","","",26,{"inputs":[{"name":"stackelement"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",26,{"inputs":[{"name":"stackelement"}],"output":{"name":"stackelement"}}],[11,"eq","","",26,{"inputs":[{"name":"stackelement"},{"name":"stackelement"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"stackelement"},{"name":"stackelement"}],"output":{"name":"bool"}}],[11,"new","","",30,{"inputs":[{"name":"stack"}],"output":{"name":"stack"}}],[11,"len","","Returns The number of elements in the Stack.",30,{"inputs":[{"name":"stack"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the stack is empty.",30,{"inputs":[{"name":"stack"}],"output":{"name":"bool"}}],[11,"get","","Provides access to the StackElement at a given index.\nlower indices are at the bottom of the stack while higher indices are\nat the top.",30,{"inputs":[{"name":"stack"},{"name":"usize"}],"output":{"name":"stackelement"}}],[11,"is_equal_to","","Compares this stack with an array of StackElements.",30,null],[11,"starts_with","","Returns true if the bottom-most elements of this stack are the same as\nthe ones passed as parameter.",30,null],[11,"ends_with","","Returns true if the top-most elements of this stack are the same as\nthe ones passed as parameter.",30,null],[11,"top","","Returns the top-most element (if any).",30,{"inputs":[{"name":"stack"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",31,{"inputs":[{"name":"parser"}],"output":{"name":"option"}}],[11,"new","","Creates the JSON parser.",31,{"inputs":[{"name":"parser"},{"name":"t"}],"output":{"name":"parser"}}],[11,"stack","","Provides access to the current position in the logical structure of the\nJSON stream.",31,{"inputs":[{"name":"parser"}],"output":{"name":"stack"}}],[11,"new","","Create a JSON Builder.",32,{"inputs":[{"name":"builder"},{"name":"t"}],"output":{"name":"builder"}}],[11,"build","","",32,{"inputs":[{"name":"builder"}],"output":{"name":"result"}}],[11,"new","","Creates a new decoder instance for decoding the specified JSON value.",33,{"inputs":[{"name":"decoder"},{"name":"json"}],"output":{"name":"decoder"}}],[6,"Error","","",null,null],[11,"read_nil","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_uint","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u8","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u16","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u32","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u64","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_int","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i8","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i16","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i32","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i64","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_f32","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_f64","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_bool","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_char","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_str","","",33,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_enum","","",33,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_enum_variant","","",33,null],[11,"read_enum_variant_arg","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_enum_struct_variant","","",33,null],[11,"read_enum_struct_variant_field","","",33,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_struct","","",33,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_struct_field","","",33,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_arg","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_struct","","",33,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_struct_arg","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_option","","",33,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_seq","","",33,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_seq_elt","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map","","",33,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map_elt_key","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map_elt_val","","",33,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"error","","",33,{"inputs":[{"name":"decoder"},{"name":"str"}],"output":{"name":"decodererror"}}],[11,"to_json","","",20,{"inputs":[{"name":"json"}],"output":{"name":"json"}}],[11,"to_json","collections::string","",0,{"inputs":[{"name":"string"}],"output":{"name":"json"}}],[11,"to_json","collections::vec","",3,{"inputs":[{"name":"vec"}],"output":{"name":"json"}}],[11,"to_json","collections::btree::map","",11,{"inputs":[{"name":"btreemap"}],"output":{"name":"json"}}],[11,"to_json","std::collections::hash::map","",14,{"inputs":[{"name":"hashmap"}],"output":{"name":"json"}}],[11,"to_json","core::option","",4,{"inputs":[{"name":"option"}],"output":{"name":"json"}}],[11,"fmt","serialize::json","Encodes a json value into a string",20,{"inputs":[{"name":"json"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","Encodes a json value into a string",34,{"inputs":[{"name":"prettyjson"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","Encodes a json value into a string",35,{"inputs":[{"name":"asjson"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"indent","","Set the indentation level for the emitted JSON",36,{"inputs":[{"name":"asprettyjson"},{"name":"usize"}],"output":{"name":"asprettyjson"}}],[11,"fmt","","Encodes a json value into a string",36,{"inputs":[{"name":"asprettyjson"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Err","","",null,null],[11,"from_str","","",20,{"inputs":[{"name":"json"},{"name":"str"}],"output":{"name":"result"}}],[8,"Decoder","serialize","",null,null],[16,"Error","serialize::Decoder","",null,null],[10,"read_nil","serialize","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_uint","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_u64","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_u32","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_u16","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_u8","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_int","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_i64","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_i32","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_i16","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_i8","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_bool","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_f64","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_f32","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_char","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_str","","",37,{"inputs":[{"name":"decoder"}],"output":{"name":"result"}}],[10,"read_enum","","",37,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_enum_variant","","",37,null],[10,"read_enum_variant_arg","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_enum_struct_variant","","",37,null],[10,"read_enum_struct_variant_field","","",37,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_struct","","",37,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_struct_field","","",37,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_tuple","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_tuple_arg","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_tuple_struct","","",37,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_tuple_struct_arg","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_option","","",37,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_seq","","",37,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_seq_elt","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_map","","",37,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_map_elt_key","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"read_map_elt_val","","",37,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"error","","",37,{"inputs":[{"name":"decoder"},{"name":"str"}],"output":{"name":"error"}}],[8,"Encoder","","",null,null],[16,"Error","serialize::Encoder","",null,null],[10,"emit_nil","serialize","",38,{"inputs":[{"name":"encoder"}],"output":{"name":"result"}}],[10,"emit_uint","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"}],"output":{"name":"result"}}],[10,"emit_u64","","",38,{"inputs":[{"name":"encoder"},{"name":"u64"}],"output":{"name":"result"}}],[10,"emit_u32","","",38,{"inputs":[{"name":"encoder"},{"name":"u32"}],"output":{"name":"result"}}],[10,"emit_u16","","",38,{"inputs":[{"name":"encoder"},{"name":"u16"}],"output":{"name":"result"}}],[10,"emit_u8","","",38,{"inputs":[{"name":"encoder"},{"name":"u8"}],"output":{"name":"result"}}],[10,"emit_int","","",38,{"inputs":[{"name":"encoder"},{"name":"isize"}],"output":{"name":"result"}}],[10,"emit_i64","","",38,{"inputs":[{"name":"encoder"},{"name":"i64"}],"output":{"name":"result"}}],[10,"emit_i32","","",38,{"inputs":[{"name":"encoder"},{"name":"i32"}],"output":{"name":"result"}}],[10,"emit_i16","","",38,{"inputs":[{"name":"encoder"},{"name":"i16"}],"output":{"name":"result"}}],[10,"emit_i8","","",38,{"inputs":[{"name":"encoder"},{"name":"i8"}],"output":{"name":"result"}}],[10,"emit_bool","","",38,{"inputs":[{"name":"encoder"},{"name":"bool"}],"output":{"name":"result"}}],[10,"emit_f64","","",38,{"inputs":[{"name":"encoder"},{"name":"f64"}],"output":{"name":"result"}}],[10,"emit_f32","","",38,{"inputs":[{"name":"encoder"},{"name":"f32"}],"output":{"name":"result"}}],[10,"emit_char","","",38,{"inputs":[{"name":"encoder"},{"name":"char"}],"output":{"name":"result"}}],[10,"emit_str","","",38,{"inputs":[{"name":"encoder"},{"name":"str"}],"output":{"name":"result"}}],[10,"emit_enum","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_enum_variant","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_enum_variant_arg","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_enum_struct_variant","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_enum_struct_variant_field","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_struct","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_struct_field","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_tuple","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_tuple_arg","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_tuple_struct","","",38,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_tuple_struct_arg","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_option","","",38,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_option_none","","",38,{"inputs":[{"name":"encoder"}],"output":{"name":"result"}}],[10,"emit_option_some","","",38,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_seq","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_seq_elt","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_map","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_map_elt_key","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[10,"emit_map_elt_val","","",38,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"result"}}],[8,"Decodable","","",null,null],[10,"decode","","",39,{"inputs":[{"name":"decodable"},{"name":"d"}],"output":{"name":"result"}}],[8,"Encodable","","",null,null],[10,"encode","","",40,{"inputs":[{"name":"encodable"},{"name":"s"}],"output":{"name":"result"}}],[8,"DecoderHelpers","","",null,null],[10,"read_to_vec","","",41,{"inputs":[{"name":"decoderhelpers"},{"name":"f"}],"output":{"name":"result"}}],[8,"EncoderHelpers","","",null,null],[10,"emit_from_vec","","",42,null]],"paths":[[3,"String"],[3,"Box"],[3,"Rc"],[3,"Vec"],[4,"Option"],[3,"PathBuf"],[3,"Cell"],[3,"RefCell"],[3,"Arc"],[3,"LinkedList"],[3,"VecDeque"],[3,"BTreeMap"],[3,"BTreeSet"],[3,"EnumSet"],[3,"HashMap"],[3,"HashSet"],[3,"VecMap"],[4,"FromHexError"],[8,"ToHex"],[8,"FromHex"],[4,"Json"],[4,"ErrorCode"],[4,"ParserError"],[4,"DecoderError"],[4,"EncoderError"],[4,"JsonEvent"],[4,"StackElement"],[8,"ToJson"],[3,"Encoder"],[3,"PrettyEncoder"],[3,"Stack"],[3,"Parser"],[3,"Builder"],[3,"Decoder"],[3,"PrettyJson"],[3,"AsJson"],[3,"AsPrettyJson"],[8,"Decoder"],[8,"Encoder"],[8,"Decodable"],[8,"Encodable"],[8,"DecoderHelpers"],[8,"EncoderHelpers"]]};
searchIndex['rbml'] = {"items":[[0,"","rbml","Really Bad Markup Language (rbml) is an internal serialization format of rustc.\nThis is not intended to be used by users.",null,null],[3,"Doc","","Common data structures",null,null],[12,"data","","",0,null],[12,"start","","",0,null],[12,"end","","",0,null],[3,"TaggedDoc","","",null,null],[12,"doc","","",1,null],[4,"EbmlEncoderTag","","",null,null],[13,"EsU8","","",2,null],[13,"EsU16","","",2,null],[13,"EsU32","","",2,null],[13,"EsU64","","",2,null],[13,"EsI8","","",2,null],[13,"EsI16","","",2,null],[13,"EsI32","","",2,null],[13,"EsI64","","",2,null],[13,"EsBool","","",2,null],[13,"EsChar","","",2,null],[13,"EsF32","","",2,null],[13,"EsF64","","",2,null],[13,"EsSub8","","",2,null],[13,"EsSub32","","",2,null],[13,"EsStr","","",2,null],[13,"EsEnum","","",2,null],[13,"EsVec","","",2,null],[13,"EsVecElt","","",2,null],[13,"EsMap","","",2,null],[13,"EsMapKey","","",2,null],[13,"EsMapVal","","",2,null],[13,"EsOpaque","","",2,null],[4,"Error","","",null,null],[13,"IntTooBig","","",3,null],[13,"InvalidTag","","",3,null],[13,"Expected","","",3,null],[13,"IoError","","",3,null],[13,"ApplicationError","","",3,null],[0,"reader","","",null,null],[3,"Res","rbml::reader","",null,null],[12,"val","","",4,null],[12,"next","","",4,null],[3,"Decoder","","",null,null],[5,"tag_at","","",null,null],[5,"vuint_at","","",null,null],[5,"tag_len_at","","",null,null],[5,"doc_at","","",null,null],[5,"maybe_get_doc","","",null,{"inputs":[{"name":"doc"},{"name":"usize"}],"output":{"name":"option"}}],[5,"get_doc","","",null,{"inputs":[{"name":"doc"},{"name":"usize"}],"output":{"name":"doc"}}],[5,"docs","","",null,{"inputs":[{"name":"doc"},{"name":"f"}],"output":{"name":"bool"}}],[5,"tagged_docs","","",null,{"inputs":[{"name":"doc"},{"name":"usize"},{"name":"f"}],"output":{"name":"bool"}}],[5,"with_doc_data","","",null,{"inputs":[{"name":"doc"},{"name":"f"}],"output":{"name":"t"}}],[5,"doc_as_u8","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"u8"}}],[5,"doc_as_u16","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"u16"}}],[5,"doc_as_u32","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"u32"}}],[5,"doc_as_u64","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"u64"}}],[5,"doc_as_i8","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"i8"}}],[5,"doc_as_i16","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"i16"}}],[5,"doc_as_i32","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"i32"}}],[5,"doc_as_i64","","",null,{"inputs":[{"name":"doc"}],"output":{"name":"i64"}}],[6,"DecodeResult","","",null,null],[11,"clone","","",4,{"inputs":[{"name":"res"}],"output":{"name":"res"}}],[11,"new","","",5,{"inputs":[{"name":"decoder"},{"name":"doc"}],"output":{"name":"decoder"}}],[11,"read_opaque","","",5,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[6,"Error","","",null,null],[11,"read_nil","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u64","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u32","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u16","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_u8","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_uint","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i64","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i32","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i16","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_i8","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_int","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_bool","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_f64","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_f32","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_char","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_str","","",5,{"inputs":[{"name":"decoder"}],"output":{"name":"decoderesult"}}],[11,"read_enum","","",5,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_enum_variant","","",5,null],[11,"read_enum_variant_arg","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_enum_struct_variant","","",5,null],[11,"read_enum_struct_variant_field","","",5,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_struct","","",5,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_struct_field","","",5,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_arg","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_struct","","",5,{"inputs":[{"name":"decoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_tuple_struct_arg","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_option","","",5,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_seq","","",5,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_seq_elt","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map","","",5,{"inputs":[{"name":"decoder"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map_elt_key","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"read_map_elt_val","","",5,{"inputs":[{"name":"decoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"decoderesult"}}],[11,"error","","",5,{"inputs":[{"name":"decoder"},{"name":"str"}],"output":{"name":"error"}}],[0,"writer","rbml","",null,null],[3,"Encoder","rbml::writer","",null,null],[12,"writer","","",6,null],[6,"EncodeResult","","",null,null],[11,"new","","",6,{"inputs":[{"name":"encoder"},{"name":"cursor"}],"output":{"name":"encoder"}}],[11,"unsafe_clone","","FIXME(pcwalton): Workaround for badness in trans. DO NOT USE ME.",6,{"inputs":[{"name":"encoder"}],"output":{"name":"encoder"}}],[11,"start_tag","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"end_tag","","",6,{"inputs":[{"name":"encoder"}],"output":{"name":"encoderesult"}}],[11,"wr_tag","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_bytes","","",6,null],[11,"wr_tagged_u64","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_u32","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_u16","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_u8","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_i64","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_i32","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_i16","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_i8","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"wr_tagged_str","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"wr_bytes","","",6,null],[11,"wr_str","","",6,{"inputs":[{"name":"encoder"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"mark_stable_position","","Returns the current position while marking it stable, i.e.\ngenerated bytes so far wouldn't be affected by relaxation.",6,{"inputs":[{"name":"encoder"}],"output":{"name":"u64"}}],[11,"emit_opaque","","",6,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[6,"Error","","",null,null],[11,"emit_nil","","",6,{"inputs":[{"name":"encoder"}],"output":{"name":"encoderesult"}}],[11,"emit_uint","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"}],"output":{"name":"encoderesult"}}],[11,"emit_u64","","",6,{"inputs":[{"name":"encoder"},{"name":"u64"}],"output":{"name":"encoderesult"}}],[11,"emit_u32","","",6,{"inputs":[{"name":"encoder"},{"name":"u32"}],"output":{"name":"encoderesult"}}],[11,"emit_u16","","",6,{"inputs":[{"name":"encoder"},{"name":"u16"}],"output":{"name":"encoderesult"}}],[11,"emit_u8","","",6,{"inputs":[{"name":"encoder"},{"name":"u8"}],"output":{"name":"encoderesult"}}],[11,"emit_int","","",6,{"inputs":[{"name":"encoder"},{"name":"isize"}],"output":{"name":"encoderesult"}}],[11,"emit_i64","","",6,{"inputs":[{"name":"encoder"},{"name":"i64"}],"output":{"name":"encoderesult"}}],[11,"emit_i32","","",6,{"inputs":[{"name":"encoder"},{"name":"i32"}],"output":{"name":"encoderesult"}}],[11,"emit_i16","","",6,{"inputs":[{"name":"encoder"},{"name":"i16"}],"output":{"name":"encoderesult"}}],[11,"emit_i8","","",6,{"inputs":[{"name":"encoder"},{"name":"i8"}],"output":{"name":"encoderesult"}}],[11,"emit_bool","","",6,{"inputs":[{"name":"encoder"},{"name":"bool"}],"output":{"name":"encoderesult"}}],[11,"emit_f64","","",6,{"inputs":[{"name":"encoder"},{"name":"f64"}],"output":{"name":"encoderesult"}}],[11,"emit_f32","","",6,{"inputs":[{"name":"encoder"},{"name":"f32"}],"output":{"name":"encoderesult"}}],[11,"emit_char","","",6,{"inputs":[{"name":"encoder"},{"name":"char"}],"output":{"name":"encoderesult"}}],[11,"emit_str","","",6,{"inputs":[{"name":"encoder"},{"name":"str"}],"output":{"name":"encoderesult"}}],[11,"emit_enum","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_variant_arg","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_enum_struct_variant_field","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_struct_field","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_arg","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct","","",6,{"inputs":[{"name":"encoder"},{"name":"str"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_tuple_struct_arg","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option","","",6,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_option_none","","",6,{"inputs":[{"name":"encoder"}],"output":{"name":"encoderesult"}}],[11,"emit_option_some","","",6,{"inputs":[{"name":"encoder"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_seq_elt","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_key","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"emit_map_elt_val","","",6,{"inputs":[{"name":"encoder"},{"name":"usize"},{"name":"f"}],"output":{"name":"encoderesult"}}],[11,"clone","rbml","",0,{"inputs":[{"name":"doc"}],"output":{"name":"doc"}}],[11,"new","","",0,null],[11,"get","","",0,{"inputs":[{"name":"doc"},{"name":"usize"}],"output":{"name":"doc"}}],[11,"is_empty","","",0,{"inputs":[{"name":"doc"}],"output":{"name":"bool"}}],[11,"as_str_slice","","",0,{"inputs":[{"name":"doc"}],"output":{"name":"str"}}],[11,"as_str","","",0,{"inputs":[{"name":"doc"}],"output":{"name":"string"}}],[11,"fmt","","",2,{"inputs":[{"name":"ebmlencodertag"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",2,{"inputs":[{"name":"ebmlencodertag"}],"output":{"name":"ebmlencodertag"}}],[11,"fmt","","",3,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}]],"paths":[[3,"Doc"],[3,"TaggedDoc"],[4,"EbmlEncoderTag"],[4,"Error"],[3,"Res"],[3,"Decoder"],[3,"Encoder"]]};
searchIndex['rand'] = {"items":[[0,"","rand","Interface to random number generators in Rust.",null,null],[3,"Generator","","Iterator which will generate a stream of random items.",null,null],[3,"AsciiGenerator","","Iterator which will continuously generate random ascii characters.",null,null],[3,"XorShiftRng","","An Xorshift[1] random number\ngenerator.",null,null],[3,"Open01","","A wrapper for generating floating point numbers uniformly in the\nopen interval `(0,1)` (not including either endpoint).",null,null],[3,"Closed01","","A wrapper for generating floating point numbers uniformly in the\nclosed interval `[0,1]` (including both endpoints).",null,null],[0,"distributions","","Sampling from random distributions.",null,null],[3,"RandSample","rand::distributions","A wrapper for generating types that implement `Rand` via the\n`Sample` & `IndependentSample` traits.",null,null],[3,"Weighted","","A value with a particular weight for use with `WeightedChoice`.",null,null],[12,"weight","","The numerical weight of this item",0,null],[12,"item","","The actual item which is being weighted",0,null],[3,"WeightedChoice","","A distribution that selects from a finite collection of weighted items.",null,null],[0,"range","","Generating numbers between two others.",null,null],[3,"Range","rand::distributions::range","Sample values uniformly between two bounds.",null,null],[8,"SampleRange","","The helper trait for types that have a sensible way to sample\nuniformly between two values. This should not be used directly,\nand is only to facilitate `Range`.",null,null],[10,"construct_range","","Construct the `Range` object that `sample_range`\nrequires. This should not ever be called directly, only via\n`Range::new`, which will check that `low < high`, so this\nfunction doesn't have to repeat the check.",1,{"inputs":[{"name":"samplerange"},{"name":"self"},{"name":"self"}],"output":{"name":"range"}}],[10,"sample_range","","Sample a value from the given `Range` with the given `Rng` as\na source of randomness.",1,{"inputs":[{"name":"samplerange"},{"name":"range"},{"name":"r"}],"output":{"name":"self"}}],[11,"new","","Create a new `Range` instance that samples uniformly from\n`[low, high)`. Panics if `low >= high`.",2,{"inputs":[{"name":"range"},{"name":"x"},{"name":"x"}],"output":{"name":"range"}}],[11,"sample","","",2,{"inputs":[{"name":"range"},{"name":"r"}],"output":{"name":"sup"}}],[11,"ind_sample","","",2,{"inputs":[{"name":"range"},{"name":"r"}],"output":{"name":"sup"}}],[0,"gamma","rand::distributions","The Gamma and derived distributions.",null,null],[3,"Gamma","rand::distributions::gamma","The Gamma distribution `Gamma(shape, scale)` distribution.",null,null],[3,"ChiSquared","","The chi-squared distribution `χ²(k)`, where `k` is the degrees of\nfreedom.",null,null],[3,"FisherF","","The Fisher F distribution `F(m, n)`.",null,null],[3,"StudentT","","The Student t distribution, `t(nu)`, where `nu` is the degrees of\nfreedom.",null,null],[11,"new","","Construct an object representing the `Gamma(shape, scale)`\ndistribution.",3,{"inputs":[{"name":"gamma"},{"name":"f64"},{"name":"f64"}],"output":{"name":"gamma"}}],[11,"sample","","",3,{"inputs":[{"name":"gamma"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",3,{"inputs":[{"name":"gamma"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new chi-squared distribution with degrees-of-freedom\n`k`. Panics if `k < 0`.",4,{"inputs":[{"name":"chisquared"},{"name":"f64"}],"output":{"name":"chisquared"}}],[11,"sample","","",4,{"inputs":[{"name":"chisquared"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",4,{"inputs":[{"name":"chisquared"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new `FisherF` distribution, with the given\nparameter. Panics if either `m` or `n` are not positive.",5,{"inputs":[{"name":"fisherf"},{"name":"f64"},{"name":"f64"}],"output":{"name":"fisherf"}}],[11,"sample","","",5,{"inputs":[{"name":"fisherf"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",5,{"inputs":[{"name":"fisherf"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new Student t distribution with `n` degrees of\nfreedom. Panics if `n <= 0`.",6,{"inputs":[{"name":"studentt"},{"name":"f64"}],"output":{"name":"studentt"}}],[11,"sample","","",6,{"inputs":[{"name":"studentt"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",6,{"inputs":[{"name":"studentt"},{"name":"r"}],"output":{"name":"f64"}}],[0,"normal","rand::distributions","The normal and derived distributions.",null,null],[3,"StandardNormal","rand::distributions::normal","A wrapper around an `f64` to generate N(0, 1) random numbers\n(a.k.a.  a standard normal, or Gaussian).",null,null],[3,"Normal","","The normal distribution `N(mean, std_dev**2)`.",null,null],[3,"LogNormal","","The log-normal distribution `ln N(mean, std_dev**2)`.",null,null],[11,"clone","","",7,{"inputs":[{"name":"standardnormal"}],"output":{"name":"standardnormal"}}],[11,"rand","","",7,{"inputs":[{"name":"standardnormal"},{"name":"r"}],"output":{"name":"standardnormal"}}],[11,"clone","","",8,{"inputs":[{"name":"normal"}],"output":{"name":"normal"}}],[11,"new","","Construct a new `Normal` distribution with the given mean and\nstandard deviation.",8,{"inputs":[{"name":"normal"},{"name":"f64"},{"name":"f64"}],"output":{"name":"normal"}}],[11,"sample","","",8,{"inputs":[{"name":"normal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",8,{"inputs":[{"name":"normal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","","",9,{"inputs":[{"name":"lognormal"}],"output":{"name":"lognormal"}}],[11,"new","","Construct a new `LogNormal` distribution with the given mean\nand standard deviation.",9,{"inputs":[{"name":"lognormal"},{"name":"f64"},{"name":"f64"}],"output":{"name":"lognormal"}}],[11,"sample","","",9,{"inputs":[{"name":"lognormal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",9,{"inputs":[{"name":"lognormal"},{"name":"r"}],"output":{"name":"f64"}}],[0,"exponential","rand::distributions","The exponential distribution.",null,null],[3,"Exp1","rand::distributions::exponential","A wrapper around an `f64` to generate Exp(1) random numbers.",null,null],[3,"Exp","","The exponential distribution `Exp(lambda)`.",null,null],[11,"clone","","",10,{"inputs":[{"name":"exp1"}],"output":{"name":"exp1"}}],[11,"rand","","",10,{"inputs":[{"name":"exp1"},{"name":"r"}],"output":{"name":"exp1"}}],[11,"clone","","",11,{"inputs":[{"name":"exp"}],"output":{"name":"exp"}}],[11,"new","","Construct a new `Exp` with the given shape parameter\n`lambda`. Panics if `lambda <= 0`.",11,{"inputs":[{"name":"exp"},{"name":"f64"}],"output":{"name":"exp"}}],[11,"sample","","",11,{"inputs":[{"name":"exp"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",11,{"inputs":[{"name":"exp"},{"name":"r"}],"output":{"name":"f64"}}],[8,"Sample","rand::distributions","Types that can be used to create a random instance of `Support`.",null,null],[10,"sample","","Generate a random value of `Support`, using `rng` as the\nsource of randomness.",12,{"inputs":[{"name":"sample"},{"name":"r"}],"output":{"name":"support"}}],[8,"IndependentSample","","`Sample`s that do not require keeping track of state.",null,null],[10,"ind_sample","","Generate a random value.",13,{"inputs":[{"name":"independentsample"},{"name":"r"}],"output":{"name":"support"}}],[11,"new","","",14,{"inputs":[{"name":"randsample"}],"output":{"name":"randsample"}}],[11,"sample","","",14,{"inputs":[{"name":"randsample"},{"name":"r"}],"output":{"name":"sup"}}],[11,"ind_sample","","",14,{"inputs":[{"name":"randsample"},{"name":"r"}],"output":{"name":"sup"}}],[11,"new","","Create a new `WeightedChoice`.",15,null],[11,"sample","","",15,{"inputs":[{"name":"weightedchoice"},{"name":"r"}],"output":{"name":"t"}}],[11,"ind_sample","","",15,{"inputs":[{"name":"weightedchoice"},{"name":"r"}],"output":{"name":"t"}}],[0,"isaac","rand","The ISAAC random number generator.",null,null],[3,"IsaacRng","rand::isaac","A random number generator that uses the ISAAC algorithm[1].",null,null],[3,"Isaac64Rng","","A random number generator that uses ISAAC-64[1], the 64-bit\nvariant of the ISAAC algorithm.",null,null],[11,"new_unseeded","","Create an ISAAC random number generator using the default\nfixed seed.",16,{"inputs":[{"name":"isaacrng"}],"output":{"name":"isaacrng"}}],[11,"clone","","",16,{"inputs":[{"name":"isaacrng"}],"output":{"name":"isaacrng"}}],[11,"next_u32","","",16,{"inputs":[{"name":"isaacrng"}],"output":{"name":"u32"}}],[11,"reseed","","",16,null],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can\nbe any length, although the maximum number of elements used is\n256 and any more will be silently ignored. A generator\nconstructed with a given seed will generate the same sequence\nof values as all other generators constructed with that seed.",16,null],[11,"rand","","",16,{"inputs":[{"name":"isaacrng"},{"name":"r"}],"output":{"name":"isaacrng"}}],[11,"new_unseeded","","Create a 64-bit ISAAC random number generator using the\ndefault fixed seed.",17,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"isaac64rng"}}],[11,"clone","","",17,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"isaac64rng"}}],[11,"next_u32","","",17,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"u32"}}],[11,"next_u64","","",17,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"u64"}}],[11,"reseed","","",17,null],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can\nbe any length, although the maximum number of elements used is\n256 and any more will be silently ignored. A generator\nconstructed with a given seed will generate the same sequence\nof values as all other generators constructed with that seed.",17,null],[11,"rand","","",17,{"inputs":[{"name":"isaac64rng"},{"name":"r"}],"output":{"name":"isaac64rng"}}],[0,"chacha","rand","The ChaCha random number generator.",null,null],[3,"ChaChaRng","rand::chacha","A random number generator that uses the ChaCha20 algorithm [1].",null,null],[11,"clone","","",18,{"inputs":[{"name":"chacharng"}],"output":{"name":"chacharng"}}],[11,"new_unseeded","","Create an ChaCha random number generator using the default\nfixed key of 8 zero words.",18,{"inputs":[{"name":"chacharng"}],"output":{"name":"chacharng"}}],[11,"set_counter","","Sets the internal 128-bit ChaCha counter to\na user-provided value. This permits jumping\narbitrarily ahead (or backwards) in the pseudorandom stream.",18,{"inputs":[{"name":"chacharng"},{"name":"u64"},{"name":"u64"}],"output":null}],[11,"next_u32","","",18,{"inputs":[{"name":"chacharng"}],"output":{"name":"u32"}}],[11,"reseed","","",18,null],[11,"from_seed","","Create a ChaCha generator from a seed,\nobtained from a variable-length u32 array.\nOnly up to 8 words are used; if less than 8\nwords are used, the remaining are set to zero.",18,null],[11,"rand","","",18,{"inputs":[{"name":"chacharng"},{"name":"r"}],"output":{"name":"chacharng"}}],[0,"reseeding","rand","A wrapper around another RNG that reseeds it after it\ngenerates a certain number of random bytes.",null,null],[3,"ReseedingRng","rand::reseeding","A wrapper around any RNG which reseeds the underlying RNG after it\nhas generated a certain number of random bytes.",null,null],[12,"reseeder","","Controls the behaviour when reseeding the RNG.",19,null],[3,"ReseedWithDefault","","Reseed an RNG using a `Default` instance. This reseeds by\nreplacing the RNG with the result of a `Default::default` call.",null,null],[8,"Reseeder","","Something that can be used to reseed an RNG via `ReseedingRng`.",null,null],[10,"reseed","","Reseed the given RNG.",20,{"inputs":[{"name":"reseeder"},{"name":"r"}],"output":null}],[11,"new","","Create a new `ReseedingRng` with the given parameters.",19,{"inputs":[{"name":"reseedingrng"},{"name":"r"},{"name":"usize"},{"name":"rsdr"}],"output":{"name":"reseedingrng"}}],[11,"reseed_if_necessary","","Reseed the internal RNG if the number of bytes that have been\ngenerated exceed the threshold.",19,{"inputs":[{"name":"reseedingrng"}],"output":null}],[11,"next_u32","","",19,{"inputs":[{"name":"reseedingrng"}],"output":{"name":"u32"}}],[11,"next_u64","","",19,{"inputs":[{"name":"reseedingrng"}],"output":{"name":"u64"}}],[11,"fill_bytes","","",19,null],[11,"reseed","","",19,null],[11,"from_seed","","Create a new `ReseedingRng` from the given reseeder and\nseed. This uses a default value for `generation_threshold`.",19,null],[11,"clone","","",21,{"inputs":[{"name":"reseedwithdefault"}],"output":{"name":"reseedwithdefault"}}],[11,"reseed","","",21,{"inputs":[{"name":"reseedwithdefault"},{"name":"r"}],"output":null}],[11,"default","","",21,{"inputs":[{"name":"reseedwithdefault"}],"output":{"name":"reseedwithdefault"}}],[11,"rand","rand","",22,{"inputs":[{"name":"open01"},{"name":"r"}],"output":{"name":"open01"}}],[11,"rand","","",23,{"inputs":[{"name":"closed01"},{"name":"r"}],"output":{"name":"closed01"}}],[11,"rand","","",22,{"inputs":[{"name":"open01"},{"name":"r"}],"output":{"name":"open01"}}],[11,"rand","","",23,{"inputs":[{"name":"closed01"},{"name":"r"}],"output":{"name":"closed01"}}],[11,"rand","core::option","",24,{"inputs":[{"name":"option"},{"name":"r"}],"output":{"name":"option"}}],[8,"Rand","rand","A type that can be randomly generated using an `Rng`.",null,null],[10,"rand","","Generates a random instance of this type using the specified source of\nrandomness.",25,{"inputs":[{"name":"rand"},{"name":"r"}],"output":{"name":"self"}}],[8,"Rng","","A random number generator.",null,null],[10,"next_u32","","Return the next random u32.",26,{"inputs":[{"name":"rng"}],"output":{"name":"u32"}}],[11,"next_u64","","Return the next random u64.",26,{"inputs":[{"name":"rng"}],"output":{"name":"u64"}}],[11,"next_f32","","Return the next random f32 selected from the half-open\ninterval `[0, 1)`.",26,{"inputs":[{"name":"rng"}],"output":{"name":"f32"}}],[11,"next_f64","","Return the next random f64 selected from the half-open\ninterval `[0, 1)`.",26,{"inputs":[{"name":"rng"}],"output":{"name":"f64"}}],[11,"fill_bytes","","Fill `dest` with random data.",26,null],[11,"gen","","Return a random value of a `Rand` type.",26,{"inputs":[{"name":"rng"}],"output":{"name":"t"}}],[11,"gen_iter","","Return an iterator that will yield an infinite number of randomly\ngenerated items.",26,{"inputs":[{"name":"rng"}],"output":{"name":"generator"}}],[11,"gen_range","","Generate a random value in the range [`low`, `high`).",26,{"inputs":[{"name":"rng"},{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[11,"gen_weighted_bool","","Return a bool with a 1 in n chance of true",26,{"inputs":[{"name":"rng"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"gen_ascii_chars","","Return an iterator of random characters from the set A-Z,a-z,0-9.",26,{"inputs":[{"name":"rng"}],"output":{"name":"asciigenerator"}}],[11,"choose","","Return a random element from `values`.",26,null],[11,"shuffle","","Shuffle a mutable slice in place.",26,null],[8,"SeedableRng","","A random number generator that can be explicitly seeded to produce\nthe same stream of randomness multiple times.",null,null],[10,"reseed","","Reseed an RNG with the given seed.",27,{"inputs":[{"name":"seedablerng"},{"name":"seed"}],"output":null}],[10,"from_seed","","Create a new RNG with the given seed.",27,{"inputs":[{"name":"seedablerng"},{"name":"seed"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",28,{"inputs":[{"name":"generator"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",29,{"inputs":[{"name":"asciigenerator"}],"output":{"name":"option"}}],[11,"clone","","",30,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"xorshiftrng"}}],[11,"new_unseeded","","Creates a new XorShiftRng instance which is not seeded.",30,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"xorshiftrng"}}],[11,"next_u32","","",30,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"u32"}}],[11,"reseed","","Reseed an XorShiftRng. This will panic if `seed` is entirely 0.",30,null],[11,"from_seed","","Create a new XorShiftRng. This will panic if `seed` is entirely 0.",30,null],[11,"rand","","",30,{"inputs":[{"name":"xorshiftrng"},{"name":"r"}],"output":{"name":"xorshiftrng"}}]],"paths":[[3,"Weighted"],[8,"SampleRange"],[3,"Range"],[3,"Gamma"],[3,"ChiSquared"],[3,"FisherF"],[3,"StudentT"],[3,"StandardNormal"],[3,"Normal"],[3,"LogNormal"],[3,"Exp1"],[3,"Exp"],[8,"Sample"],[8,"IndependentSample"],[3,"RandSample"],[3,"WeightedChoice"],[3,"IsaacRng"],[3,"Isaac64Rng"],[3,"ChaChaRng"],[3,"ReseedingRng"],[8,"Reseeder"],[3,"ReseedWithDefault"],[3,"Open01"],[3,"Closed01"],[4,"Option"],[8,"Rand"],[8,"Rng"],[8,"SeedableRng"],[3,"Generator"],[3,"AsciiGenerator"],[3,"XorShiftRng"]]};
searchIndex['graphviz'] = {"items":[[0,"","graphviz","Generate files suitable for use with [Graphviz](http://www.graphviz.org/)",null,null],[3,"Id","","`Id` is a Graphviz `ID`.",null,null],[4,"LabelText","","The text for a graphviz label on a node or edge.",null,null],[13,"LabelStr","","This kind of label preserves the text directly as is.",0,null],[13,"EscStr","","This kind of label uses the graphviz label escString type:\nhttp://www.graphviz.org/content/attrs#kescString",0,null],[4,"RenderOption","","",null,null],[13,"NoEdgeLabels","","",1,null],[13,"NoNodeLabels","","",1,null],[5,"default_options","","Returns vec holding all the default render options.",null,{"inputs":[],"output":{"name":"vec"}}],[5,"render","","Renders directed graph `g` into the writer `w` in DOT syntax.\n(Simple wrapper around `render_opts` that passes a default set of options.)",null,{"inputs":[{"name":"g"},{"name":"w"}],"output":{"name":"result"}}],[5,"render_opts","","Renders directed graph `g` into the writer `w` in DOT syntax.\n(Main entry point for the library.)",null,null],[6,"Nodes","","",null,null],[6,"Edges","","",null,null],[8,"Labeller","","Each instance of a type that implements `Label<C>` maps to a\nunique identifier with respect to `C`, which is used to identify\nit in the generated .dot file. They can also provide more\nelaborate (and non-unique) label text that is used in the graphviz\nrendered output.\nThe graph instance is responsible for providing the DOT compatible\nidentifiers for the nodes and (optionally) rendered labels for the nodes and\nedges, as well as an identifier for the graph itself.",null,null],[10,"graph_id","","Must return a DOT compatible identifier naming the graph.",2,{"inputs":[{"name":"labeller"}],"output":{"name":"id"}}],[10,"node_id","","Maps `n` to a unique identifier with respect to `self`. The\nimplementer is responsible for ensuring that the returned name\nis a valid DOT identifier.",2,{"inputs":[{"name":"labeller"},{"name":"n"}],"output":{"name":"id"}}],[11,"node_label","","Maps `n` to a label that will be used in the rendered output.\nThe label need not be unique, and may be the empty string; the\ndefault is just the output from `node_id`.",2,{"inputs":[{"name":"labeller"},{"name":"n"}],"output":{"name":"labeltext"}}],[11,"edge_label","","Maps `e` to a label that will be used in the rendered output.\nThe label need not be unique, and may be the empty string; the\ndefault is in fact the empty string.",2,{"inputs":[{"name":"labeller"},{"name":"e"}],"output":{"name":"labeltext"}}],[8,"GraphWalk","","GraphWalk is an abstraction over a directed graph = (nodes,edges)\nmade up of node handles `N` and edge handles `E`, where each `E`\ncan be mapped to its source and target nodes.",null,null],[10,"nodes","","Returns all the nodes in this graph.",3,{"inputs":[{"name":"graphwalk"}],"output":{"name":"nodes"}}],[10,"edges","","Returns all of the edges in this graph.",3,{"inputs":[{"name":"graphwalk"}],"output":{"name":"edges"}}],[10,"source","","The source node for `edge`.",3,{"inputs":[{"name":"graphwalk"},{"name":"e"}],"output":{"name":"n"}}],[10,"target","","The target node for `edge`.",3,{"inputs":[{"name":"graphwalk"},{"name":"e"}],"output":{"name":"n"}}],[11,"new","","Creates an `Id` named `name`.",4,{"inputs":[{"name":"id"},{"name":"name"}],"output":{"name":"result"}}],[11,"as_slice","","",4,{"inputs":[{"name":"id"}],"output":{"name":"str"}}],[11,"name","","",4,{"inputs":[{"name":"id"}],"output":{"name":"cow"}}],[11,"label","","",0,{"inputs":[{"name":"labeltext"},{"name":"s"}],"output":{"name":"labeltext"}}],[11,"escaped","","",0,{"inputs":[{"name":"labeltext"},{"name":"s"}],"output":{"name":"labeltext"}}],[11,"escape","","Renders text as string suitable for a label in a .dot file.",0,{"inputs":[{"name":"labeltext"}],"output":{"name":"string"}}],[11,"prefix_line","","Puts `prefix` on a line above this label, with a blank line separator.",0,{"inputs":[{"name":"labeltext"},{"name":"labeltext"}],"output":{"name":"labeltext"}}],[11,"suffix_line","","Puts `suffix` on a line below this label, with a blank line separator.",0,{"inputs":[{"name":"labeltext"},{"name":"labeltext"}],"output":{"name":"labeltext"}}],[11,"fmt","","",1,{"inputs":[{"name":"renderoption"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"renderoption"},{"name":"renderoption"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"renderoption"},{"name":"renderoption"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"renderoption"}],"output":{"name":"renderoption"}}]],"paths":[[4,"LabelText"],[4,"RenderOption"],[8,"Labeller"],[8,"GraphWalk"],[3,"Id"]]};
searchIndex['rustc_bitflags'] = {"items":[[0,"","rustc_bitflags","A typesafe bitmask flag generator.",null,null],[14,"bitflags!","","The `bitflags!` macro generates a `struct` that holds a set of C-style\nbitmask flags. It is useful for creating typesafe wrappers for C APIs.",null,null]],"paths":[]};
searchIndex['test'] = {"items":[[0,"","test","Support code for rustc's built in unit-test and micro-benchmarking\nframework.",null,null],[3,"Bencher","","Manager of the benchmarking runs.",null,null],[12,"bytes","","",0,null],[3,"TestDesc","","",null,null],[12,"name","","",1,null],[12,"ignore","","",1,null],[12,"should_panic","","",1,null],[3,"TestDescAndFn","","",null,null],[12,"desc","","",2,null],[12,"testfn","","",2,null],[3,"Metric","","",null,null],[3,"MetricMap","","",null,null],[3,"TestOpts","","",null,null],[12,"filter","","",3,null],[12,"run_ignored","","",3,null],[12,"run_tests","","",3,null],[12,"run_benchmarks","","",3,null],[12,"logfile","","",3,null],[12,"nocapture","","",3,null],[12,"color","","",3,null],[3,"BenchSamples","","",null,null],[4,"TestName","","",null,null],[13,"StaticTestName","","",4,null],[13,"DynTestName","","",4,null],[4,"TestFn","","",null,null],[13,"StaticTestFn","","",5,null],[13,"StaticBenchFn","","",5,null],[13,"StaticMetricFn","","",5,null],[13,"DynTestFn","","",5,null],[13,"DynMetricFn","","",5,null],[13,"DynBenchFn","","",5,null],[4,"ShouldPanic","","",null,null],[13,"No","","",6,null],[13,"Yes","","",6,null],[4,"ColorConfig","","",null,null],[13,"AutoColor","","",7,null],[13,"AlwaysColor","","",7,null],[13,"NeverColor","","",7,null],[4,"TestResult","","",null,null],[13,"TrOk","","",8,null],[13,"TrFailed","","",8,null],[13,"TrIgnored","","",8,null],[13,"TrMetrics","","",8,null],[13,"TrBench","","",8,null],[5,"test_main","","",null,null],[5,"test_main_static","","",null,null],[5,"parse_opts","","",null,null],[5,"fmt_bench_samples","","",null,{"inputs":[{"name":"benchsamples"}],"output":{"name":"string"}}],[5,"run_tests_console","","",null,{"inputs":[{"name":"testopts"},{"name":"vec"}],"output":{"name":"result"}}],[5,"filter_tests","","",null,{"inputs":[{"name":"testopts"},{"name":"vec"}],"output":{"name":"vec"}}],[5,"run_test","","",null,{"inputs":[{"name":"testopts"},{"name":"bool"},{"name":"testdescandfn"},{"name":"sender"}],"output":null}],[5,"black_box","","A function that is opaque to the optimizer, to allow benchmarks to\npretend to use outputs to assist in avoiding dead-code\nelimination.",null,{"inputs":[{"name":"t"}],"output":{"name":"t"}}],[0,"test","","",null,null],[0,"stats","","",null,null],[3,"Summary","test::stats","Extracted collection of all the summary statistics of a sample set.",null,null],[12,"sum","","",9,null],[12,"min","","",9,null],[12,"max","","",9,null],[12,"mean","","",9,null],[12,"median","","",9,null],[12,"var","","",9,null],[12,"std_dev","","",9,null],[12,"std_dev_pct","","",9,null],[12,"median_abs_dev","","",9,null],[12,"median_abs_dev_pct","","",9,null],[12,"quartiles","","",9,null],[12,"iqr","","",9,null],[5,"winsorize","","Winsorize a set of samples, replacing values above the `100-pct` percentile\nand below the `pct` percentile with those percentiles themselves. This is a\nway of minimizing the effect of outliers, at the cost of biasing the sample.\nIt differs from trimming in that it does not change the number of samples,\njust changes the values of those that are outliers.",null,null],[8,"Stats","","Trait that provides simple descriptive statistics on a univariate set of numeric samples.",null,null],[10,"sum","","Sum of the samples.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"min","","Minimum value of the samples.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"max","","Maximum value of the samples.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"mean","","Arithmetic mean (average) of the samples: sum divided by sample-count.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"median","","Median of the samples: value separating the lower half of the samples from the higher half.\nEqual to `self.percentile(50.0)`.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"var","","Variance of the samples: bias-corrected mean of the squares of the differences of each\nsample from the sample mean. Note that this calculates the _sample variance_ rather than the\npopulation variance, which is assumed to be unknown. It therefore corrects the `(n-1)/n`\nbias that would appear if we calculated a population variance, by dividing by `(n-1)` rather\nthan `n`.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"std_dev","","Standard deviation: the square root of the sample variance.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"std_dev_pct","","Standard deviation as a percent of the mean value. See `std_dev` and `mean`.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"median_abs_dev","","Scaled median of the absolute deviations of each sample from the sample median. This is a\nrobust (distribution-agnostic) estimator of sample variability. Use this in preference to\n`std_dev` if you cannot assume your sample is normally distributed. Note that this is scaled\nby the constant `1.4826` to allow its use as a consistent estimator for the standard\ndeviation.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"median_abs_dev_pct","","Median absolute deviation as a percent of the median. See `median_abs_dev` and `median`.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[10,"percentile","","Percentile: the value below which `pct` percent of the values in `self` fall. For example,\npercentile(95.0) will return the value `v` such that 95% of the samples `s` in `self`\nsatisfy `s <= v`.",10,{"inputs":[{"name":"stats"},{"name":"f64"}],"output":{"name":"f64"}}],[10,"quartiles","","Quartiles of the sample: three values that divide the sample into four equal groups, each\nwith 1/4 of the data. The middle value is the median. See `median` and `percentile`. This\nfunction may calculate the 3 quartiles more efficiently than 3 calls to `percentile`, but\nis otherwise equivalent.",10,null],[10,"iqr","","Inter-quartile range: the difference between the 25th percentile (1st quartile) and the 75th\npercentile (3rd quartile). See `quartiles`.",10,{"inputs":[{"name":"stats"}],"output":{"name":"f64"}}],[11,"eq","","",9,{"inputs":[{"name":"summary"},{"name":"summary"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"summary"},{"name":"summary"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"summary"}],"output":{"name":"summary"}}],[11,"new","","Construct a new summary of a sample set.",9,null],[0,"bench","test","",null,null],[5,"benchmark","test::bench","",null,{"inputs":[{"name":"f"}],"output":{"name":"benchsamples"}}],[6,"OptRes","test","Result of parsing the options.",null,null],[6,"MonitorMsg","","",null,null],[8,"TDynBenchFn","","Represents a benchmark function.",null,null],[10,"run","","",11,{"inputs":[{"name":"tdynbenchfn"},{"name":"bencher"}],"output":null}],[11,"fmt","","",4,{"inputs":[{"name":"testname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",4,null],[11,"eq","","",4,{"inputs":[{"name":"testname"},{"name":"testname"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"testname"},{"name":"testname"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"testname"}],"output":{"name":"testname"}}],[11,"fmt","","",4,{"inputs":[{"name":"testname"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",5,{"inputs":[{"name":"testfn"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"bencher"}],"output":{"name":"bencher"}}],[11,"hash","","",6,null],[11,"eq","","",6,{"inputs":[{"name":"shouldpanic"},{"name":"shouldpanic"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"shouldpanic"},{"name":"shouldpanic"}],"output":{"name":"bool"}}],[11,"fmt","","",6,{"inputs":[{"name":"shouldpanic"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"shouldpanic"}],"output":{"name":"shouldpanic"}}],[11,"hash","","",1,null],[11,"eq","","",1,{"inputs":[{"name":"testdesc"},{"name":"testdesc"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"testdesc"},{"name":"testdesc"}],"output":{"name":"bool"}}],[11,"fmt","","",1,{"inputs":[{"name":"testdesc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",1,{"inputs":[{"name":"testdesc"}],"output":{"name":"testdesc"}}],[11,"fmt","","",2,{"inputs":[{"name":"testdescandfn"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",12,{"inputs":[{"name":"metric"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"metric"},{"name":"metric"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"metric"},{"name":"metric"}],"output":{"name":"bool"}}],[11,"decode","","",12,{"inputs":[{"name":"metric"},{"name":"__d"}],"output":{"name":"result"}}],[11,"encode","","",12,{"inputs":[{"name":"metric"},{"name":"__s"}],"output":{"name":"result"}}],[11,"clone","","",12,{"inputs":[{"name":"metric"}],"output":{"name":"metric"}}],[11,"new","","",12,{"inputs":[{"name":"metric"},{"name":"f64"},{"name":"f64"}],"output":{"name":"metric"}}],[11,"eq","","",13,{"inputs":[{"name":"metricmap"},{"name":"metricmap"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"metricmap"},{"name":"metricmap"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"metricmap"}],"output":{"name":"metricmap"}}],[11,"clone","","",7,{"inputs":[{"name":"colorconfig"}],"output":{"name":"colorconfig"}}],[11,"eq","","",14,{"inputs":[{"name":"benchsamples"},{"name":"benchsamples"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"benchsamples"},{"name":"benchsamples"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"benchsamples"}],"output":{"name":"benchsamples"}}],[11,"eq","","",8,{"inputs":[{"name":"testresult"},{"name":"testresult"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"testresult"},{"name":"testresult"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"testresult"}],"output":{"name":"testresult"}}],[11,"new","","",13,{"inputs":[{"name":"metricmap"}],"output":{"name":"metricmap"}}],[11,"insert_metric","","Insert a named `value` (+/- `noise`) metric into the map. The value\nmust be non-negative. The `noise` indicates the uncertainty of the\nmetric, which doubles as the \"noise range\" of acceptable\npairwise-regressions on this named value, when comparing from one\nmetric to the next using `compare_to_old`.",13,{"inputs":[{"name":"metricmap"},{"name":"str"},{"name":"f64"},{"name":"f64"}],"output":null}],[11,"fmt_metrics","","",13,{"inputs":[{"name":"metricmap"}],"output":{"name":"string"}}],[11,"iter","","Callback for benchmark functions to run in their body.",0,{"inputs":[{"name":"bencher"},{"name":"f"}],"output":null}],[11,"ns_elapsed","","",0,{"inputs":[{"name":"bencher"}],"output":{"name":"u64"}}],[11,"ns_per_iter","","",0,{"inputs":[{"name":"bencher"}],"output":{"name":"u64"}}],[11,"bench_n","","",0,{"inputs":[{"name":"bencher"},{"name":"u64"},{"name":"f"}],"output":null}],[11,"auto_bench","","",0,{"inputs":[{"name":"bencher"},{"name":"f"}],"output":{"name":"summary"}}]],"paths":[[3,"Bencher"],[3,"TestDesc"],[3,"TestDescAndFn"],[3,"TestOpts"],[4,"TestName"],[4,"TestFn"],[4,"ShouldPanic"],[4,"ColorConfig"],[4,"TestResult"],[3,"Summary"],[8,"Stats"],[8,"TDynBenchFn"],[3,"Metric"],[3,"MetricMap"],[3,"BenchSamples"]]};
searchIndex['log'] = {"items":[[0,"","log","Utilities for program-wide and customizable logging",null,null],[3,"LogLevel","","Wraps the log level with fmt implementations.",null,null],[3,"LogRecord","","A LogRecord is created by the logging macros, and passed as the only\nargument to Loggers.",null,null],[12,"module_path","","The module path of where the LogRecord originated.",0,null],[12,"level","","The LogLevel of this record.",0,null],[12,"args","","The arguments from the log line.",0,null],[12,"file","","The file of where the LogRecord originated.",0,null],[12,"line","","The line number of where the LogRecord originated.",0,null],[5,"set_logger","","Replaces the thread-local logger with the specified logger, returning the old\nlogger.",null,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[0,"macros","","Logging macros",null,null],[17,"MAX_LOG_LEVEL","","Maximum logging level of a module that can be specified. Common logging\nlevels are found in the DEBUG/INFO/WARN/ERROR constants.",null,null],[17,"DEBUG","","Debug log level",null,null],[17,"INFO","","Info log level",null,null],[17,"WARN","","Warn log level",null,null],[17,"ERROR","","Error log level",null,null],[8,"Logger","","A trait used to represent an interface to a thread-local logger. Each thread\ncan have its own custom logger which can respond to logging messages\nhowever it likes.",null,null],[10,"log","","Logs a single message described by the `record`.",1,{"inputs":[{"name":"logger"},{"name":"logrecord"}],"output":null}],[11,"fmt","","",2,{"inputs":[{"name":"loglevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"option"}}],[11,"lt","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"bool"}}],[11,"le","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"bool"}}],[11,"gt","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"bool"}}],[11,"ge","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"bool"}}],[11,"eq","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"loglevel"},{"name":"loglevel"}],"output":{"name":"bool"}}],[11,"clone","","",2,{"inputs":[{"name":"loglevel"}],"output":{"name":"loglevel"}}],[11,"fmt","","",2,{"inputs":[{"name":"loglevel"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"logrecord"},{"name":"formatter"}],"output":{"name":"result"}}],[14,"log!","","The standard logging macro",null,null],[14,"error!","","A convenience macro for logging at the error log level.",null,null],[14,"warn!","","A convenience macro for logging at the warning log level.",null,null],[14,"info!","","A convenience macro for logging at the info log level.",null,null],[14,"debug!","","A convenience macro for logging at the debug log level. This macro can also\nbe omitted at compile time by passing `--cfg ndebug` to the compiler. If\nthis option is not passed, then debug statements will be compiled.",null,null],[14,"log_enabled!","","A macro to test whether a log level is enabled for the current module.",null,null]],"paths":[[3,"LogRecord"],[8,"Logger"],[3,"LogLevel"]]};
searchIndex['term'] = {"items":[[0,"","term","Terminal formatting library.",null,null],[3,"WriterWrapper","","A hack to work around the fact that `Box<Write + Send>` does not\ncurrently implement `Write`.",null,null],[5,"stdout","","Return a Terminal wrapping stdout, or None if a terminal couldn't be\nopened.",null,{"inputs":[],"output":{"name":"option"}}],[5,"stderr","","Return a Terminal wrapping stderr, or None if a terminal couldn't be\nopened.",null,{"inputs":[],"output":{"name":"option"}}],[0,"terminfo","","Terminfo database interface.",null,null],[3,"TermInfo","term::terminfo","A parsed terminfo database entry.",null,null],[12,"names","","Names for the terminal",0,null],[12,"bools","","Map of capability name to boolean value",0,null],[12,"numbers","","Map of capability name to numeric value",0,null],[12,"strings","","Map of capability name to raw (unexpanded) string",0,null],[3,"TerminfoTerminal","","A Terminal that knows how many colors it supports, with a reference to its\nparsed Terminfo database record.",null,null],[0,"searcher","","ncurses-compatible database discovery",null,null],[5,"get_dbpath_for_term","term::terminfo::searcher","Return path to database entry for `term`",null,{"inputs":[{"name":"str"}],"output":{"name":"option"}}],[5,"open","","Return open file for `term`",null,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[0,"parser","term::terminfo","TermInfo format parsing.\nncurses-compatible compiled terminfo format parsing (term(5))",null,null],[0,"compiled","term::terminfo::parser","ncurses-compatible compiled terminfo format parsing (term(5))",null,null],[5,"parse","term::terminfo::parser::compiled","Parse a compiled terminfo entry, using long capability names if `longnames` is true",null,{"inputs":[{"name":"read"},{"name":"bool"}],"output":{"name":"result"}}],[5,"msys_terminfo","","Create a dummy TermInfo struct for msys terminals",null,{"inputs":[],"output":{"name":"box"}}],[7,"boolfnames","","",null,null],[7,"boolnames","","",null,null],[7,"numfnames","","",null,null],[7,"numnames","","",null,null],[7,"stringfnames","","",null,null],[7,"stringnames","","",null,null],[0,"parm","term::terminfo","Parameterized string expansion",null,null],[3,"Variables","term::terminfo::parm","Container for static and dynamic variable arrays",null,null],[4,"Param","","Types of parameters a capability can use",null,null],[13,"Words","","",1,null],[13,"Number","","",1,null],[5,"expand","","Expand a parameterized capability",null,null],[11,"clone","","",1,{"inputs":[{"name":"param"}],"output":{"name":"param"}}],[11,"new","","Return a new zero-initialized Variables",2,{"inputs":[{"name":"variables"}],"output":{"name":"variables"}}],[11,"fmt","term::terminfo","",0,{"inputs":[{"name":"terminfo"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fg","","",3,{"inputs":[{"name":"terminfoterminal"},{"name":"color"}],"output":{"name":"result"}}],[11,"bg","","",3,{"inputs":[{"name":"terminfoterminal"},{"name":"color"}],"output":{"name":"result"}}],[11,"attr","","",3,{"inputs":[{"name":"terminfoterminal"},{"name":"attr"}],"output":{"name":"result"}}],[11,"supports_attr","","",3,{"inputs":[{"name":"terminfoterminal"},{"name":"attr"}],"output":{"name":"bool"}}],[11,"reset","","",3,{"inputs":[{"name":"terminfoterminal"}],"output":{"name":"result"}}],[11,"get_ref","","",3,{"inputs":[{"name":"terminfoterminal"}],"output":{"name":"t"}}],[11,"get_mut","","",3,{"inputs":[{"name":"terminfoterminal"}],"output":{"name":"t"}}],[11,"unwrap","","",3,{"inputs":[{"name":"terminfoterminal"}],"output":{"name":"t"}}],[11,"new","","Returns `None` whenever the terminal cannot be created for some\nreason.",3,{"inputs":[{"name":"terminfoterminal"},{"name":"t"}],"output":{"name":"option"}}],[11,"write","","",3,null],[11,"flush","","",3,{"inputs":[{"name":"terminfoterminal"}],"output":{"name":"result"}}],[0,"color","term","Terminal color definitions",null,null],[6,"Color","term::color","Number for a terminal color",null,null],[17,"BLACK","","",null,null],[17,"RED","","",null,null],[17,"GREEN","","",null,null],[17,"YELLOW","","",null,null],[17,"BLUE","","",null,null],[17,"MAGENTA","","",null,null],[17,"CYAN","","",null,null],[17,"WHITE","","",null,null],[17,"BRIGHT_BLACK","","",null,null],[17,"BRIGHT_RED","","",null,null],[17,"BRIGHT_GREEN","","",null,null],[17,"BRIGHT_YELLOW","","",null,null],[17,"BRIGHT_BLUE","","",null,null],[17,"BRIGHT_MAGENTA","","",null,null],[17,"BRIGHT_CYAN","","",null,null],[17,"BRIGHT_WHITE","","",null,null],[0,"attr","term","Terminal attributes",null,null],[4,"Attr","term::attr","Terminal attributes for use with term.attr().",null,null],[13,"Bold","","Bold (or possibly bright) mode",4,null],[13,"Dim","","Dim mode, also called faint or half-bright. Often not supported",4,null],[13,"Italic","","Italics mode. Often not supported",4,null],[13,"Underline","","Underline mode",4,null],[13,"Blink","","Blink mode",4,null],[13,"Standout","","Standout mode. Often implemented as Reverse, sometimes coupled with Bold",4,null],[13,"Reverse","","Reverse mode, inverts the foreground and background colors",4,null],[13,"Secure","","Secure mode, also called invis mode. Hides the printed text",4,null],[13,"ForegroundColor","","Convenience attribute to set the foreground color",4,null],[13,"BackgroundColor","","Convenience attribute to set the background color",4,null],[11,"clone","","",4,{"inputs":[{"name":"attr"}],"output":{"name":"attr"}}],[8,"Terminal","term","A terminal with similar capabilities to an ANSI Terminal\n(foreground/background colors etc).",null,null],[10,"fg","","Sets the foreground color to the given color.",5,{"inputs":[{"name":"terminal"},{"name":"color"}],"output":{"name":"result"}}],[10,"bg","","Sets the background color to the given color.",5,{"inputs":[{"name":"terminal"},{"name":"color"}],"output":{"name":"result"}}],[10,"attr","","Sets the given terminal attribute, if supported.  Returns `Ok(true)`\nif the attribute was supported, `Ok(false)` otherwise, and `Err(e)` if\nthere was an I/O error.",5,{"inputs":[{"name":"terminal"},{"name":"attr"}],"output":{"name":"result"}}],[10,"supports_attr","","Returns whether the given terminal attribute is supported.",5,{"inputs":[{"name":"terminal"},{"name":"attr"}],"output":{"name":"bool"}}],[10,"reset","","Resets all terminal attributes and color to the default.\nReturns `Ok()`.",5,{"inputs":[{"name":"terminal"}],"output":{"name":"result"}}],[10,"get_ref","","Gets an immutable reference to the stream inside",5,{"inputs":[{"name":"terminal"}],"output":{"name":"t"}}],[10,"get_mut","","Gets a mutable reference to the stream inside",5,{"inputs":[{"name":"terminal"}],"output":{"name":"t"}}],[8,"UnwrappableTerminal","","A terminal which can be unwrapped.",null,null],[10,"unwrap","","Returns the contained stream, destroying the `Terminal`",6,{"inputs":[{"name":"unwrappableterminal"}],"output":{"name":"t"}}],[11,"write","","",7,null],[11,"flush","","",7,{"inputs":[{"name":"writerwrapper"}],"output":{"name":"result"}}]],"paths":[[3,"TermInfo"],[4,"Param"],[3,"Variables"],[3,"TerminfoTerminal"],[4,"Attr"],[8,"Terminal"],[8,"UnwrappableTerminal"],[3,"WriterWrapper"]]};
searchIndex['getopts'] = {"items":[[0,"","getopts","Simple getopt alternative.",null,null],[3,"Opt","","A description of a possible option.",null,null],[12,"name","","Name of the option",0,null],[12,"hasarg","","Whether it has an argument",0,null],[12,"occur","","How often it can occur",0,null],[12,"aliases","","Which options it aliases",0,null],[3,"OptGroup","","One group of options, e.g., both `-h` and `--help`, along with\ntheir shared description and properties.",null,null],[12,"short_name","","Short name of the option, e.g. `h` for a `-h` option",1,null],[12,"long_name","","Long name of the option, e.g. `help` for a `--help` option",1,null],[12,"hint","","Hint for argument, e.g. `FILE` for a `-o FILE` option",1,null],[12,"desc","","Description for usage help text",1,null],[12,"hasarg","","Whether option has an argument",1,null],[12,"occur","","How often it can occur",1,null],[3,"Matches","","The result of checking command line arguments. Contains a vector\nof matches and a vector of free strings.",null,null],[12,"free","","Free string fragments",2,null],[4,"Name","","Name of an option. Either a string or a single char.",null,null],[13,"Long","","A string representing the long name of an option.\nFor example: \"help\"",3,null],[13,"Short","","A char representing the short name of an option.\nFor example: 'h'",3,null],[4,"HasArg","","Describes whether an option has an argument.",null,null],[13,"Yes","","The option requires an argument.",4,null],[13,"No","","The option takes no argument.",4,null],[13,"Maybe","","The option argument is optional.",4,null],[4,"Occur","","Describes how often an option may occur.",null,null],[13,"Req","","The option occurs once.",5,null],[13,"Optional","","The option occurs at most once.",5,null],[13,"Multi","","The option occurs zero or more times.",5,null],[4,"Fail","","The type returned when the command line does not conform to the\nexpected format. Use the `Debug` implementation to output detailed\ninformation.",null,null],[13,"ArgumentMissing","","The option requires an argument but none was passed.",6,null],[13,"UnrecognizedOption","","The passed option is not declared among the possible options.",6,null],[13,"OptionMissing","","A required option is not present.",6,null],[13,"OptionDuplicated","","A single occurrence option is being used multiple times.",6,null],[13,"UnexpectedArgument","","There's an argument being passed to a non-argument option.",6,null],[4,"FailType","","The type of failure that occurred.",null,null],[13,"ArgumentMissing_","","",7,null],[13,"UnrecognizedOption_","","",7,null],[13,"OptionMissing_","","",7,null],[13,"OptionDuplicated_","","",7,null],[13,"UnexpectedArgument_","","",7,null],[5,"reqopt","","Create a long option that is required and takes an argument.",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"optgroup"}}],[5,"optopt","","Create a long option that is optional and takes an argument.",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"optgroup"}}],[5,"optflag","","Create a long option that is optional and does not take an argument.",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"optgroup"}}],[5,"optflagmulti","","Create a long option that can occur more than once and does not\ntake an argument.",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"optgroup"}}],[5,"optflagopt","","Create a long option that is optional and takes an optional argument.",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"optgroup"}}],[5,"optmulti","","Create a long option that is optional, takes an argument, and may occur\nmultiple times.",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"}],"output":{"name":"optgroup"}}],[5,"opt","","Create a generic option group, stating all parameters explicitly",null,{"inputs":[{"name":"str"},{"name":"str"},{"name":"str"},{"name":"str"},{"name":"hasarg"},{"name":"occur"}],"output":{"name":"optgroup"}}],[5,"getopts","","Parse command line arguments according to the provided options.",null,null],[5,"usage","","Derive a usage message from a set of long options.",null,null],[5,"short_usage","","Derive a short one-line usage summary from a set of long options.",null,null],[6,"Result","","The result of parsing a command line with a set of options.",null,null],[11,"fmt","","",3,{"inputs":[{"name":"name"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",3,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"name"},{"name":"name"}],"output":{"name":"bool"}}],[11,"clone","","",3,{"inputs":[{"name":"name"}],"output":{"name":"name"}}],[11,"fmt","","",4,{"inputs":[{"name":"hasarg"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"hasarg"},{"name":"hasarg"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"hasarg"},{"name":"hasarg"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"hasarg"}],"output":{"name":"hasarg"}}],[11,"fmt","","",5,{"inputs":[{"name":"occur"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",5,{"inputs":[{"name":"occur"},{"name":"occur"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"occur"},{"name":"occur"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"occur"}],"output":{"name":"occur"}}],[11,"fmt","","",0,{"inputs":[{"name":"opt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",0,{"inputs":[{"name":"opt"},{"name":"opt"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"opt"},{"name":"opt"}],"output":{"name":"bool"}}],[11,"clone","","",0,{"inputs":[{"name":"opt"}],"output":{"name":"opt"}}],[11,"fmt","","",1,{"inputs":[{"name":"optgroup"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"optgroup"},{"name":"optgroup"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"optgroup"},{"name":"optgroup"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"optgroup"}],"output":{"name":"optgroup"}}],[11,"fmt","","",2,{"inputs":[{"name":"matches"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",2,{"inputs":[{"name":"matches"},{"name":"matches"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"matches"},{"name":"matches"}],"output":{"name":"bool"}}],[11,"clone","","",2,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[11,"fmt","","",6,{"inputs":[{"name":"fail"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",6,{"inputs":[{"name":"fail"},{"name":"fail"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"fail"},{"name":"fail"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"fail"}],"output":{"name":"fail"}}],[11,"fmt","","",7,{"inputs":[{"name":"failtype"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",7,{"inputs":[{"name":"failtype"},{"name":"failtype"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"failtype"},{"name":"failtype"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"failtype"}],"output":{"name":"failtype"}}],[11,"long_to_short","","Translate OptGroup into Opt.\n(Both short and long names correspond to different Opts).",1,{"inputs":[{"name":"optgroup"}],"output":{"name":"opt"}}],[11,"opt_present","","Returns true if an option was matched.",2,{"inputs":[{"name":"matches"},{"name":"str"}],"output":{"name":"bool"}}],[11,"opt_count","","Returns the number of times an option was matched.",2,{"inputs":[{"name":"matches"},{"name":"str"}],"output":{"name":"usize"}}],[11,"opts_present","","Returns true if any of several options were matched.",2,null],[11,"opts_str","","Returns the string argument supplied to one of several matching options or `None`.",2,null],[11,"opt_strs","","Returns a vector of the arguments provided to all matches of the given\noption.",2,{"inputs":[{"name":"matches"},{"name":"str"}],"output":{"name":"vec"}}],[11,"opt_str","","Returns the string argument supplied to a matching option or `None`.",2,{"inputs":[{"name":"matches"},{"name":"str"}],"output":{"name":"option"}}],[11,"opt_default","","Returns the matching string, a default, or none.",2,{"inputs":[{"name":"matches"},{"name":"str"},{"name":"str"}],"output":{"name":"option"}}],[11,"to_err_msg","","Convert a `Fail` enum into an error string.",6,{"inputs":[{"name":"fail"}],"output":{"name":"string"}}],[11,"fmt","","",6,{"inputs":[{"name":"fail"},{"name":"formatter"}],"output":{"name":"result"}}]],"paths":[[3,"Opt"],[3,"OptGroup"],[3,"Matches"],[4,"Name"],[4,"HasArg"],[4,"Occur"],[4,"Fail"],[4,"FailType"]]};
searchIndex['arena'] = {"items":[[0,"","arena","The arena, a fast but limited type of allocator.",null,null],[3,"Arena","","A slower reflection-based arena that can allocate objects of any type.",null,null],[3,"TypedArena","","A faster arena that can hold objects of only one type.",null,null],[11,"new","","Allocates a new Arena with 32 bytes preallocated.",0,{"inputs":[{"name":"arena"}],"output":{"name":"arena"}}],[11,"new_with_size","","Allocates a new Arena with `initial_size` bytes preallocated.",0,{"inputs":[{"name":"arena"},{"name":"usize"}],"output":{"name":"arena"}}],[11,"drop","","",0,{"inputs":[{"name":"arena"}],"output":null}],[11,"alloc","","Allocates a new item in the arena, using `op` to initialize the value,\nand returns a reference to it.",0,{"inputs":[{"name":"arena"},{"name":"f"}],"output":{"name":"t"}}],[11,"new","","Creates a new `TypedArena` with preallocated space for eight objects.",1,{"inputs":[{"name":"typedarena"}],"output":{"name":"typedarena"}}],[11,"with_capacity","","Creates a new `TypedArena` with preallocated space for the given number of\nobjects.",1,{"inputs":[{"name":"typedarena"},{"name":"usize"}],"output":{"name":"typedarena"}}],[11,"alloc","","Allocates an object in the `TypedArena`, returning a reference to it.",1,{"inputs":[{"name":"typedarena"},{"name":"t"}],"output":{"name":"t"}}],[11,"drop","","",1,{"inputs":[{"name":"typedarena"}],"output":null}]],"paths":[[3,"Arena"],[3,"TypedArena"]]};
searchIndex['flate'] = {"items":[[0,"","flate","Simple [DEFLATE][def]-based compression. This is a wrapper around the\n[`miniz`][mz] library, which is a one-file pure-C implementation of zlib.",null,null],[3,"Error","","",null,null],[3,"Bytes","","",null,null],[5,"deflate_bytes","","Compress a buffer, without writing any sort of header on the output.",null,null],[5,"deflate_bytes_zlib","","Compress a buffer, using a header that zlib can understand.",null,null],[5,"inflate_bytes","","Decompress a buffer, without parsing any sort of header on the input.",null,null],[5,"inflate_bytes_zlib","","Decompress a buffer that starts with a zlib header.",null,null],[11,"partial_cmp","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"option"}}],[11,"lt","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"bool"}}],[11,"le","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"bool"}}],[11,"gt","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"bool"}}],[11,"ge","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"bool"}}],[11,"eq","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"bool"}}],[11,"cmp","","",0,{"inputs":[{"name":"error"},{"name":"error"}],"output":{"name":"ordering"}}],[11,"hash","","",0,null],[11,"clone","","",0,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"fmt","","",0,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","","",null,null],[11,"deref","","",1,null],[11,"drop","","",1,{"inputs":[{"name":"bytes"}],"output":null}]],"paths":[[3,"Error"],[3,"Bytes"]]};
searchIndex['core'] = {"items":[[0,"","core","# The Rust Core Library",null,null],[0,"isize","","Operations and constants for pointer-sized signed integers (`isize` type)",null,null],[17,"BITS","core::isize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i8","core","Operations and constants for signed 8-bits integers (`i8` type)",null,null],[17,"BITS","core::i8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i16","core","Operations and constants for signed 16-bits integers (`i16` type)",null,null],[17,"BITS","core::i16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i32","core","Operations and constants for signed 32-bits integers (`i32` type)",null,null],[17,"BITS","core::i32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i64","core","Operations and constants for signed 64-bits integers (`i64` type)",null,null],[17,"BITS","core::i64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"usize","core","Operations and constants for pointer-sized unsigned integers (`usize` type)",null,null],[17,"BITS","core::usize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u8","core","Operations and constants for unsigned 8-bits integers (`u8` type)",null,null],[17,"BITS","core::u8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u16","core","Operations and constants for unsigned 16-bits integers (`u16` type)",null,null],[17,"BITS","core::u16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u32","core","Operations and constants for unsigned 32-bits integers (`u32` type)",null,null],[17,"BITS","core::u32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u64","core","Operations and constants for unsigned 64-bits integer (`u64` type)",null,null],[17,"BITS","core::u64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"f32","core","Operations and constants for 32-bits floats (`f32` type)",null,null],[0,"consts","core::f32","Basic mathematial constants.",null,null],[17,"PI","core::f32::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[17,"RADIX","core::f32","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN","","Smallest finite f32 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f32 value",null,null],[17,"MAX","","Largest finite f32 value",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[0,"f64","core","Operations and constants for 64-bits floats (`f64` type)",null,null],[0,"consts","core::f64","Basic mathematial constants.",null,null],[17,"PI","core::f64::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[17,"RADIX","core::f64","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN","","Smallest finite f64 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f64 value",null,null],[17,"MAX","","Largest finite f64 value",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[0,"num","core","Numeric traits and functions for the built-in numeric types.",null,null],[3,"Wrapping","core::num","Provides intentionally-wrapped arithmetic on `T`.",null,null],[3,"ParseIntError","","An error which can be returned when parsing an integer.",null,null],[3,"ParseFloatError","","An error which can be returned when parsing a float.",null,null],[12,"kind","","",0,null],[4,"FpCategory","","Used for representing the classification of floating point numbers",null,null],[13,"Nan","","\"Not a Number\", often obtained by dividing by zero",1,null],[13,"Infinite","","Positive or negative infinity",1,null],[13,"Zero","","Positive or negative zero",1,null],[13,"Subnormal","","De-normalized floating point representation (less precise than `Normal`)",1,null],[13,"Normal","","A regular floating point number",1,null],[4,"FloatErrorKind","","",null,null],[13,"Empty","","",2,null],[13,"Invalid","","",2,null],[0,"wrapping","","",null,null],[8,"OverflowingOps","core::num::wrapping","",null,null],[10,"overflowing_add","","",3,null],[10,"overflowing_sub","","",3,null],[10,"overflowing_mul","","",3,null],[10,"overflowing_div","","",3,null],[10,"overflowing_rem","","",3,null],[10,"overflowing_shl","","",3,null],[10,"overflowing_shr","","",3,null],[6,"Output","","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shl","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"shr","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"add","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"sub","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"mul","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"not","core::num","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitxor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitor","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","core::num::wrapping","",null,null],[11,"bitand","core::num","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[8,"Zero","","Types that have a \"zero\" value.",null,null],[10,"zero","","The \"zero\" (usually, additive identity) for this type.",5,{"inputs":[{"name":"zero"}],"output":{"name":"self"}}],[8,"One","","Types that have a \"one\" value.",null,null],[10,"one","","The \"one\" (usually, multiplicative identity) for this type.",6,{"inputs":[{"name":"one"}],"output":{"name":"self"}}],[11,"fmt","","",4,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",4,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"fmt","","",1,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[11,"eq","","",7,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",7,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",7,{"inputs":[{"name":"parseinterror"}],"output":{"name":"str"}}],[11,"fmt","","",7,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",0,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",0,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",0,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",2,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",2,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",2,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",0,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"str"}}],[11,"fmt","","",0,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"prelude","core","The core prelude",null,null],[0,"intrinsics","","rustc compiler intrinsics.",null,null],[5,"atomic_cxchg","core::intrinsics","",null,null],[5,"atomic_cxchg_acq","","",null,null],[5,"atomic_cxchg_rel","","",null,null],[5,"atomic_cxchg_acqrel","","",null,null],[5,"atomic_cxchg_relaxed","","",null,null],[5,"atomic_load","","",null,null],[5,"atomic_load_acq","","",null,null],[5,"atomic_load_relaxed","","",null,null],[5,"atomic_load_unordered","","",null,null],[5,"atomic_store","","",null,null],[5,"atomic_store_rel","","",null,null],[5,"atomic_store_relaxed","","",null,null],[5,"atomic_store_unordered","","",null,null],[5,"atomic_xchg","","",null,null],[5,"atomic_xchg_acq","","",null,null],[5,"atomic_xchg_rel","","",null,null],[5,"atomic_xchg_acqrel","","",null,null],[5,"atomic_xchg_relaxed","","",null,null],[5,"atomic_xadd","","",null,null],[5,"atomic_xadd_acq","","",null,null],[5,"atomic_xadd_rel","","",null,null],[5,"atomic_xadd_acqrel","","",null,null],[5,"atomic_xadd_relaxed","","",null,null],[5,"atomic_xsub","","",null,null],[5,"atomic_xsub_acq","","",null,null],[5,"atomic_xsub_rel","","",null,null],[5,"atomic_xsub_acqrel","","",null,null],[5,"atomic_xsub_relaxed","","",null,null],[5,"atomic_and","","",null,null],[5,"atomic_and_acq","","",null,null],[5,"atomic_and_rel","","",null,null],[5,"atomic_and_acqrel","","",null,null],[5,"atomic_and_relaxed","","",null,null],[5,"atomic_nand","","",null,null],[5,"atomic_nand_acq","","",null,null],[5,"atomic_nand_rel","","",null,null],[5,"atomic_nand_acqrel","","",null,null],[5,"atomic_nand_relaxed","","",null,null],[5,"atomic_or","","",null,null],[5,"atomic_or_acq","","",null,null],[5,"atomic_or_rel","","",null,null],[5,"atomic_or_acqrel","","",null,null],[5,"atomic_or_relaxed","","",null,null],[5,"atomic_xor","","",null,null],[5,"atomic_xor_acq","","",null,null],[5,"atomic_xor_rel","","",null,null],[5,"atomic_xor_acqrel","","",null,null],[5,"atomic_xor_relaxed","","",null,null],[5,"atomic_max","","",null,null],[5,"atomic_max_acq","","",null,null],[5,"atomic_max_rel","","",null,null],[5,"atomic_max_acqrel","","",null,null],[5,"atomic_max_relaxed","","",null,null],[5,"atomic_min","","",null,null],[5,"atomic_min_acq","","",null,null],[5,"atomic_min_rel","","",null,null],[5,"atomic_min_acqrel","","",null,null],[5,"atomic_min_relaxed","","",null,null],[5,"atomic_umin","","",null,null],[5,"atomic_umin_acq","","",null,null],[5,"atomic_umin_rel","","",null,null],[5,"atomic_umin_acqrel","","",null,null],[5,"atomic_umin_relaxed","","",null,null],[5,"atomic_umax","","",null,null],[5,"atomic_umax_acq","","",null,null],[5,"atomic_umax_rel","","",null,null],[5,"atomic_umax_acqrel","","",null,null],[5,"atomic_umax_relaxed","","",null,null],[5,"atomic_fence","","",null,null],[5,"atomic_fence_acq","","",null,null],[5,"atomic_fence_rel","","",null,null],[5,"atomic_fence_acqrel","","",null,null],[5,"abort","","Aborts the execution of the process.",null,null],[5,"unreachable","","Tells LLVM that this point in the code is not reachable,\nenabling further optimizations.",null,null],[5,"assume","","Informs the optimizer that a condition is always true.\nIf the condition is false, the behavior is undefined.",null,null],[5,"breakpoint","","Executes a breakpoint trap, for inspection by a debugger.",null,null],[5,"size_of","","The size of a type in bytes.",null,null],[5,"move_val_init","","Moves a value to an uninitialized memory location.",null,null],[5,"min_align_of","","",null,null],[5,"pref_align_of","","",null,null],[5,"type_name","","Gets a static string slice containing the name of a type.",null,null],[5,"type_id","","Gets an identifier which is globally unique to the specified type. This\nfunction will return the same value for a type regardless of whichever\ncrate it is invoked in.",null,null],[5,"init_dropped","","Creates a value initialized to so that its drop flag,\nif any, says that it has been dropped.",null,null],[5,"init","","Creates a value initialized to zero.",null,null],[5,"uninit","","Creates an uninitialized value.",null,null],[5,"forget","","Moves a value out of scope without running drop glue.",null,null],[5,"transmute","","Unsafely transforms a value of one type into a value of another type.",null,null],[5,"return_address","","Gives the address for the return value of the enclosing function.",null,null],[5,"needs_drop","","Returns `true` if the actual type given as `T` requires drop\nglue; returns `false` if the actual type provided for `T`\nimplements `Copy`.",null,null],[5,"owns_managed","","Returns `true` if a type is managed (will be allocated on the local heap)",null,null],[5,"offset","","Calculates the offset from a pointer. The offset *must* be in-bounds of\nthe object, or one-byte-past-the-end. An arithmetic overflow is also\nundefined behaviour.",null,null],[5,"copy_nonoverlapping","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may *not* overlap.",null,null],[5,"copy","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may overlap.",null,null],[5,"write_bytes","","Invokes memset on the specified pointer, setting `count * size_of::<T>()`\nbytes of memory starting at `dst` to `c`.",null,null],[5,"volatile_copy_nonoverlapping_memory","","Equivalent to the appropriate `llvm.memcpy.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_copy_memory","","Equivalent to the appropriate `llvm.memmove.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_set_memory","","Equivalent to the appropriate `llvm.memset.p0i8.*` intrinsic, with a\nsize of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`.",null,null],[5,"volatile_load","","Perform a volatile load from the `src` pointer.",null,null],[5,"volatile_store","","Perform a volatile store to the `dst` pointer.",null,null],[5,"sqrtf32","","Returns the square root of an `f32`",null,null],[5,"sqrtf64","","Returns the square root of an `f64`",null,null],[5,"powif32","","Raises an `f32` to an integer power.",null,null],[5,"powif64","","Raises an `f64` to an integer power.",null,null],[5,"sinf32","","Returns the sine of an `f32`.",null,null],[5,"sinf64","","Returns the sine of an `f64`.",null,null],[5,"cosf32","","Returns the cosine of an `f32`.",null,null],[5,"cosf64","","Returns the cosine of an `f64`.",null,null],[5,"powf32","","Raises an `f32` to an `f32` power.",null,null],[5,"powf64","","Raises an `f64` to an `f64` power.",null,null],[5,"expf32","","Returns the exponential of an `f32`.",null,null],[5,"expf64","","Returns the exponential of an `f64`.",null,null],[5,"exp2f32","","Returns 2 raised to the power of an `f32`.",null,null],[5,"exp2f64","","Returns 2 raised to the power of an `f64`.",null,null],[5,"logf32","","Returns the natural logarithm of an `f32`.",null,null],[5,"logf64","","Returns the natural logarithm of an `f64`.",null,null],[5,"log10f32","","Returns the base 10 logarithm of an `f32`.",null,null],[5,"log10f64","","Returns the base 10 logarithm of an `f64`.",null,null],[5,"log2f32","","Returns the base 2 logarithm of an `f32`.",null,null],[5,"log2f64","","Returns the base 2 logarithm of an `f64`.",null,null],[5,"fmaf32","","Returns `a * b + c` for `f32` values.",null,null],[5,"fmaf64","","Returns `a * b + c` for `f64` values.",null,null],[5,"fabsf32","","Returns the absolute value of an `f32`.",null,null],[5,"fabsf64","","Returns the absolute value of an `f64`.",null,null],[5,"copysignf32","","Copies the sign from `y` to `x` for `f32` values.",null,null],[5,"copysignf64","","Copies the sign from `y` to `x` for `f64` values.",null,null],[5,"floorf32","","Returns the largest integer less than or equal to an `f32`.",null,null],[5,"floorf64","","Returns the largest integer less than or equal to an `f64`.",null,null],[5,"ceilf32","","Returns the smallest integer greater than or equal to an `f32`.",null,null],[5,"ceilf64","","Returns the smallest integer greater than or equal to an `f64`.",null,null],[5,"truncf32","","Returns the integer part of an `f32`.",null,null],[5,"truncf64","","Returns the integer part of an `f64`.",null,null],[5,"rintf32","","Returns the nearest integer to an `f32`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,null],[5,"rintf64","","Returns the nearest integer to an `f64`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,null],[5,"nearbyintf32","","Returns the nearest integer to an `f32`.",null,null],[5,"nearbyintf64","","Returns the nearest integer to an `f64`.",null,null],[5,"roundf32","","Returns the nearest integer to an `f32`. Rounds half-way cases away from zero.",null,null],[5,"roundf64","","Returns the nearest integer to an `f64`. Rounds half-way cases away from zero.",null,null],[5,"ctpop8","","Returns the number of bits set in a `u8`.",null,null],[5,"ctpop16","","Returns the number of bits set in a `u16`.",null,null],[5,"ctpop32","","Returns the number of bits set in a `u32`.",null,null],[5,"ctpop64","","Returns the number of bits set in a `u64`.",null,null],[5,"ctlz8","","Returns the number of leading bits unset in a `u8`.",null,null],[5,"ctlz16","","Returns the number of leading bits unset in a `u16`.",null,null],[5,"ctlz32","","Returns the number of leading bits unset in a `u32`.",null,null],[5,"ctlz64","","Returns the number of leading bits unset in a `u64`.",null,null],[5,"cttz8","","Returns the number of trailing bits unset in a `u8`.",null,null],[5,"cttz16","","Returns the number of trailing bits unset in a `u16`.",null,null],[5,"cttz32","","Returns the number of trailing bits unset in a `u32`.",null,null],[5,"cttz64","","Returns the number of trailing bits unset in a `u64`.",null,null],[5,"bswap16","","Reverses the bytes in a `u16`.",null,null],[5,"bswap32","","Reverses the bytes in a `u32`.",null,null],[5,"bswap64","","Reverses the bytes in a `u64`.",null,null],[5,"i8_add_with_overflow","","Performs checked `i8` addition.",null,null],[5,"i16_add_with_overflow","","Performs checked `i16` addition.",null,null],[5,"i32_add_with_overflow","","Performs checked `i32` addition.",null,null],[5,"i64_add_with_overflow","","Performs checked `i64` addition.",null,null],[5,"u8_add_with_overflow","","Performs checked `u8` addition.",null,null],[5,"u16_add_with_overflow","","Performs checked `u16` addition.",null,null],[5,"u32_add_with_overflow","","Performs checked `u32` addition.",null,null],[5,"u64_add_with_overflow","","Performs checked `u64` addition.",null,null],[5,"i8_sub_with_overflow","","Performs checked `i8` subtraction.",null,null],[5,"i16_sub_with_overflow","","Performs checked `i16` subtraction.",null,null],[5,"i32_sub_with_overflow","","Performs checked `i32` subtraction.",null,null],[5,"i64_sub_with_overflow","","Performs checked `i64` subtraction.",null,null],[5,"u8_sub_with_overflow","","Performs checked `u8` subtraction.",null,null],[5,"u16_sub_with_overflow","","Performs checked `u16` subtraction.",null,null],[5,"u32_sub_with_overflow","","Performs checked `u32` subtraction.",null,null],[5,"u64_sub_with_overflow","","Performs checked `u64` subtraction.",null,null],[5,"i8_mul_with_overflow","","Performs checked `i8` multiplication.",null,null],[5,"i16_mul_with_overflow","","Performs checked `i16` multiplication.",null,null],[5,"i32_mul_with_overflow","","Performs checked `i32` multiplication.",null,null],[5,"i64_mul_with_overflow","","Performs checked `i64` multiplication.",null,null],[5,"u8_mul_with_overflow","","Performs checked `u8` multiplication.",null,null],[5,"u16_mul_with_overflow","","Performs checked `u16` multiplication.",null,null],[5,"u32_mul_with_overflow","","Performs checked `u32` multiplication.",null,null],[5,"u64_mul_with_overflow","","Performs checked `u64` multiplication.",null,null],[5,"overflowing_add","","Returns (a + b) mod 2^N, where N is the width of N in bits.",null,null],[5,"overflowing_sub","","Returns (a - b) mod 2^N, where N is the width of N in bits.",null,null],[5,"overflowing_mul","","Returns (a * b) mod 2^N, where N is the width of N in bits.",null,null],[5,"discriminant_value","","Returns the value of the discriminant for the variant in 'v',\ncast to a `u64`; if `T` has no discriminant, returns 0.",null,null],[0,"mem","core","Basic functions for dealing with memory",null,null],[5,"forget","core::mem","Leaks a value into the void, consuming ownership and never running its\ndestructor.",null,{"inputs":[{"name":"t"}],"output":null}],[5,"size_of","","Returns the size of a type in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"size_of_val","","Returns the size of the type that `_val` points to in bytes.",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"min_align_of","","Returns the ABI-required minimum alignment of a type",null,{"inputs":[],"output":{"name":"usize"}}],[5,"min_align_of_val","","Returns the ABI-required minimum alignment of the type of the value that `_val` points to",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"align_of","","Returns the alignment in memory for a type.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"align_of_val","","Returns the alignment of the type of the value that `_val` points to.",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"zeroed","","Creates a value initialized to zero.",null,{"inputs":[],"output":{"name":"t"}}],[5,"dropped","","Creates a value initialized to an unspecified series of bytes.",null,{"inputs":[],"output":{"name":"t"}}],[5,"uninitialized","","Creates an uninitialized value.",null,{"inputs":[],"output":{"name":"t"}}],[5,"swap","","Swap the values at two mutable locations of the same type, without deinitialising or copying\neither one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":null}],[5,"replace","","Replaces the value at a mutable location with a new one, returning the old value, without\ndeinitialising or copying either one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"drop","","Disposes of a value.",null,{"inputs":[{"name":"t"}],"output":null}],[5,"transmute_copy","","Interprets `src` as `&U`, and then reads `src` without moving the contained\nvalue.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[5,"copy_lifetime","","Transforms lifetime of the second pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[5,"copy_mut_lifetime","","Transforms lifetime of the second mutable pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[17,"POST_DROP_U8","","",null,null],[17,"POST_DROP_U32","","",null,null],[17,"POST_DROP_U64","","",null,null],[17,"POST_DROP_USIZE","","",null,null],[0,"nonzero","core","Exposes the NonZero lang item which provides optimization hints.",null,null],[3,"NonZero","core::nonzero","A wrapper type for raw pointers and integers that will never be\nNULL or 0 that might allow certain optimizations.",null,null],[8,"Zeroable","","Unsafe trait to indicate what types are usable with the NonZero struct",null,null],[11,"hash","","",8,null],[11,"fmt","","",8,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",8,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[6,"Target","","",null,null],[11,"deref","","",8,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[0,"ptr","core","Operations on unsafe pointers, `*const T`, and `*mut T`.",null,null],[3,"Unique","core::ptr","A wrapper around a raw `*mut T` that indicates that the possessor\nof this wrapper owns the referent. This in turn implies that the\n`Unique<T>` is `Send`/`Sync` if `T` is `Send`/`Sync`, unlike a raw\n`*mut T` (which conveys no particular ownership semantics).  It\nalso implies that the referent of the pointer should not be\nmodified without a unique path to the `Unique` reference. Useful\nfor building abstractions like `Vec<T>` or `Box<T>`, which\ninternally use raw pointers to manage the memory that they own.",null,null],[5,"null","","Creates a null raw pointer.",null,null],[5,"null_mut","","Creates a null mutable raw pointer.",null,null],[5,"swap","","Swaps the values at two mutable locations of the same type, without\ndeinitialising either. They may overlap, unlike `mem::swap` which is\notherwise equivalent.",null,null],[5,"replace","","Replaces the value at `dest` with `src`, returning the old\nvalue, without dropping either.",null,null],[5,"read","","Reads the value from `src` without moving it. This leaves the\nmemory in `src` unchanged.",null,null],[5,"read_and_zero","","Reads the value from `src` and nulls it out without dropping it.",null,null],[5,"read_and_drop","","Variant of read_and_zero that writes the specific drop-flag byte\n(which may be more appropriate than zero).",null,null],[5,"write","","Overwrites a memory location with the given value without reading or\ndropping the old value.",null,null],[11,"new","","Creates a new `Unique`.",9,null],[11,"get","","Dereferences the content.",9,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",9,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[6,"Target","","",null,null],[11,"deref","","",9,null],[11,"fmt","","",9,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"marker","core","Primitive traits and marker types representing basic 'kinds' of types.",null,null],[3,"NoCopy","core::marker","A type which is considered \"not POD\", meaning that it is not\nimplicitly copyable. This is typically embedded in other types to\nensure that they are never copied, even if they lack a destructor.",null,null],[3,"Managed","","A type which is considered managed by the GC. This is typically\nembedded in other types.",null,null],[3,"PhantomData","","`PhantomData<T>` allows you to describe that a type acts as if it stores a value of type `T`,\neven though it does not. This allows you to inform the compiler about certain safety properties\nof your code.",null,null],[8,"Send","","Types able to be transferred across thread boundaries.",null,null],[8,"Sized","","Types with a constant size known at compile-time.",null,null],[8,"Copy","","Types that can be copied by simply copying bits (i.e. `memcpy`).",null,null],[8,"Sync","","Types that can be safely shared between threads when aliased.",null,null],[8,"Reflect","","A marker trait indicates a type that can be reflected over. This\ntrait is implemented for all types. Its purpose is to ensure that\nwhen you write a generic function that will employ reflection,\nthat must be reflected (no pun intended) in the generic bounds of\nthat function. Here is an example:",null,null],[11,"cmp","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"cmp","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"option"}}],[11,"lt","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"le","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"gt","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ge","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"eq","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"managed"}],"output":{"name":"managed"}}],[11,"hash","","",12,{"inputs":[{"name":"phantomdata"},{"name":"h"}],"output":null}],[11,"eq","","",12,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",12,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",12,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",12,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[0,"ops","core","Overloadable operators",null,null],[3,"RangeFull","core::ops","An unbounded range.",null,null],[3,"Range","","A (half-open) range which is bounded at both ends.",null,null],[12,"start","","The lower bound of the range (inclusive).",13,null],[12,"end","","The upper bound of the range (exclusive).",13,null],[3,"RangeFrom","","A range which is only bounded below.",null,null],[12,"start","","The lower bound of the range (inclusive).",14,null],[3,"RangeTo","","A range which is only bounded above.",null,null],[12,"end","","The upper bound of the range (exclusive).",15,null],[8,"Drop","","The `Drop` trait is used to run some code when a value goes out of scope. This\nis sometimes called a 'destructor'.",null,null],[10,"drop","","The `drop` method, called when the value goes out of scope.",16,{"inputs":[{"name":"drop"}],"output":null}],[8,"Add","","The `Add` trait is used to specify the functionality of `+`.",null,null],[16,"Output","core::ops::Add","The resulting type after applying the `+` operator",null,null],[10,"add","core::ops","The method for the `+` operator",17,{"inputs":[{"name":"add"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Sub","","The `Sub` trait is used to specify the functionality of `-`.",null,null],[16,"Output","core::ops::Sub","The resulting type after applying the `-` operator",null,null],[10,"sub","core::ops","The method for the `-` operator",18,{"inputs":[{"name":"sub"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Mul","","The `Mul` trait is used to specify the functionality of `*`.",null,null],[16,"Output","core::ops::Mul","The resulting type after applying the `*` operator",null,null],[10,"mul","core::ops","The method for the `*` operator",19,{"inputs":[{"name":"mul"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Div","","The `Div` trait is used to specify the functionality of `/`.",null,null],[16,"Output","core::ops::Div","The resulting type after applying the `/` operator",null,null],[10,"div","core::ops","The method for the `/` operator",20,{"inputs":[{"name":"div"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Rem","","The `Rem` trait is used to specify the functionality of `%`.",null,null],[16,"Output","core::ops::Rem","The resulting type after applying the `%` operator",null,null],[10,"rem","core::ops","The method for the `%` operator",21,{"inputs":[{"name":"rem"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Neg","","The `Neg` trait is used to specify the functionality of unary `-`.",null,null],[16,"Output","core::ops::Neg","The resulting type after applying the `-` operator",null,null],[10,"neg","core::ops","The method for the unary `-` operator",22,{"inputs":[{"name":"neg"}],"output":{"name":"output"}}],[8,"Not","","The `Not` trait is used to specify the functionality of unary `!`.",null,null],[16,"Output","core::ops::Not","The resulting type after applying the `!` operator",null,null],[10,"not","core::ops","The method for the unary `!` operator",23,{"inputs":[{"name":"not"}],"output":{"name":"output"}}],[8,"BitAnd","","The `BitAnd` trait is used to specify the functionality of `&`.",null,null],[16,"Output","core::ops::BitAnd","The resulting type after applying the `&` operator",null,null],[10,"bitand","core::ops","The method for the `&` operator",24,{"inputs":[{"name":"bitand"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"BitOr","","The `BitOr` trait is used to specify the functionality of `|`.",null,null],[16,"Output","core::ops::BitOr","The resulting type after applying the `|` operator",null,null],[10,"bitor","core::ops","The method for the `|` operator",25,{"inputs":[{"name":"bitor"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"BitXor","","The `BitXor` trait is used to specify the functionality of `^`.",null,null],[16,"Output","core::ops::BitXor","The resulting type after applying the `^` operator",null,null],[10,"bitxor","core::ops","The method for the `^` operator",26,{"inputs":[{"name":"bitxor"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Shl","","The `Shl` trait is used to specify the functionality of `<<`.",null,null],[16,"Output","core::ops::Shl","The resulting type after applying the `<<` operator",null,null],[10,"shl","core::ops","The method for the `<<` operator",27,{"inputs":[{"name":"shl"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Shr","","The `Shr` trait is used to specify the functionality of `>>`.",null,null],[16,"Output","core::ops::Shr","The resulting type after applying the `>>` operator",null,null],[10,"shr","core::ops","The method for the `>>` operator",28,{"inputs":[{"name":"shr"},{"name":"rhs"}],"output":{"name":"output"}}],[8,"Index","","The `Index` trait is used to specify the functionality of indexing operations\nlike `arr[idx]` when used in an immutable context.",null,null],[16,"Output","core::ops::Index","The returned type after indexing",null,null],[10,"index","core::ops","The method for the indexing (`Foo[Bar]`) operation",29,{"inputs":[{"name":"index"},{"name":"idx"}],"output":{"name":"output"}}],[8,"IndexMut","","The `IndexMut` trait is used to specify the functionality of indexing\noperations like `arr[idx]`, when used in a mutable context.",null,null],[10,"index_mut","","The method for the indexing (`Foo[Bar]`) operation",30,{"inputs":[{"name":"indexmut"},{"name":"idx"}],"output":{"name":"output"}}],[8,"Deref","","The `Deref` trait is used to specify the functionality of dereferencing\noperations like `*v`.",null,null],[16,"Target","core::ops::Deref","The resulting type after dereferencing",null,null],[10,"deref","core::ops","The method called to dereference a value",31,{"inputs":[{"name":"deref"}],"output":{"name":"target"}}],[8,"DerefMut","","The `DerefMut` trait is used to specify the functionality of dereferencing\nmutably like `*v = 1;`",null,null],[10,"deref_mut","","The method called to mutably dereference a value",32,{"inputs":[{"name":"derefmut"}],"output":{"name":"target"}}],[8,"Fn","","A version of the call operator that takes an immutable receiver.",null,null],[10,"call","","This is called when the call operator is used.",33,{"inputs":[{"name":"fn"},{"name":"args"}],"output":{"name":"output"}}],[8,"FnMut","","A version of the call operator that takes a mutable receiver.",null,null],[10,"call_mut","","This is called when the call operator is used.",34,{"inputs":[{"name":"fnmut"},{"name":"args"}],"output":{"name":"output"}}],[8,"FnOnce","","A version of the call operator that takes a by-value receiver.",null,null],[16,"Output","core::ops::FnOnce","The returned type after the call operator is used.",null,null],[10,"call_once","core::ops","This is called when the call operator is used.",35,{"inputs":[{"name":"fnonce"},{"name":"args"}],"output":{"name":"output"}}],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"eq","","",36,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",36,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",13,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",14,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",15,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","","",null,null],[6,"Target","","",null,null],[0,"cmp","core","Functionality for ordering and comparison.",null,null],[4,"Ordering","core::cmp","An `Ordering` is the result of a comparison between two values.",null,null],[13,"Less","","An ordering where a compared value is less [than another].",37,null],[13,"Equal","","An ordering where a compared value is equal [to another].",37,null],[13,"Greater","","An ordering where a compared value is greater [than another].",37,null],[5,"min","","Compare and return the minimum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"max","","Compare and return the maximum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"partial_min","","Compare and return the minimum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[5,"partial_max","","Compare and return the maximum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[8,"PartialEq","","Trait for equality comparisons which are [partial equivalence relations](\nhttp://en.wikipedia.org/wiki/Partial_equivalence_relation).",null,null],[10,"eq","","This method tests for `self` and `other` values to be equal, and is used by `==`.",38,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ne","","This method tests for `!=`.",38,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[8,"Eq","","Trait for equality comparisons which are [equivalence relations](\nhttps://en.wikipedia.org/wiki/Equivalence_relation).",null,null],[8,"Ord","","Trait for types that form a [total order](https://en.wikipedia.org/wiki/Total_order).",null,null],[10,"cmp","","This method returns an `Ordering` between `self` and `other`.",39,{"inputs":[{"name":"ord"},{"name":"self"}],"output":{"name":"ordering"}}],[8,"PartialOrd","","Trait for values that can be compared for a sort-order.",null,null],[10,"partial_cmp","","This method returns an ordering between `self` and `other` values if one exists.",40,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"option"}}],[11,"lt","","This method tests less than (for `self` and `other`) and is used by the `<` operator.",40,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"le","","This method tests less than or equal to (for `self` and `other`) and is used by the `<=`\noperator.",40,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"gt","","This method tests greater than (for `self` and `other`) and is used by the `>` operator.",40,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ge","","This method tests greater than or equal to (for `self` and `other`) and is used by the `>=`\noperator.",40,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"fmt","","",37,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",37,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",37,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",37,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",37,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",37,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[0,"clone","core","The `Clone` trait for types that cannot be 'implicitly copied'",null,null],[8,"Clone","core::clone","A common trait for cloning an object.",null,null],[10,"clone","","Returns a copy of the value.",41,{"inputs":[{"name":"clone"}],"output":{"name":"self"}}],[11,"clone_from","","Performs copy-assignment from `source`.",41,{"inputs":[{"name":"clone"},{"name":"self"}],"output":null}],[0,"default","core","The `Default` trait for types which may have meaningful default values.",null,null],[8,"Default","core::default","A trait that types which have a useful default value should implement.",null,null],[10,"default","","Returns the \"default value\" for a type.",42,{"inputs":[{"name":"default"}],"output":{"name":"self"}}],[0,"convert","core","Traits for conversions between types.",null,null],[8,"AsRef","core::convert","A cheap, reference-to-reference conversion.",null,null],[10,"as_ref","","Performs the conversion.",43,{"inputs":[{"name":"asref"}],"output":{"name":"t"}}],[8,"AsMut","","A cheap, mutable reference-to-mutable reference conversion.",null,null],[10,"as_mut","","Performs the conversion.",44,{"inputs":[{"name":"asmut"}],"output":{"name":"t"}}],[8,"Into","","A conversion that consumes `self`, which may or may not be expensive.",null,null],[10,"into","","Performs the conversion.",45,{"inputs":[{"name":"into"}],"output":{"name":"t"}}],[8,"From","","Construct `Self` via a conversion.",null,null],[10,"from","","Performs the conversion.",46,{"inputs":[{"name":"from"},{"name":"t"}],"output":{"name":"self"}}],[0,"any","core","Traits for dynamic typing of any `'static` type (through runtime reflection)",null,null],[3,"TypeId","core::any","A `TypeId` represents a globally unique identifier for a type.",null,null],[8,"Any","","A type to emulate dynamic typing.",null,null],[10,"get_type_id","","Gets the `TypeId` of `self`.",47,{"inputs":[{"name":"any"}],"output":{"name":"typeid"}}],[11,"fmt","core","",47,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",47,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",47,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",47,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",47,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",47,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",47,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",47,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",48,null],[11,"fmt","","",48,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",48,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",48,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"of","","Returns the `TypeId` of the type this generic function has been\ninstantiated with",48,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[0,"array","core","Implementations of things like `Eq` for fixed-length arrays\nup to a certain length. Eventually we should able to generalize\nto all lengths.",null,null],[8,"FixedSizeArray","core::array","Utility trait implemented only on arrays of fixed size",null,null],[10,"as_slice","","Converts the array to immutable slice",49,null],[10,"as_mut_slice","","Converts the array to mutable slice",49,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[0,"atomic","core","Atomic types",null,null],[3,"AtomicBool","core::atomic","A boolean type which can be safely shared between threads.",null,null],[3,"AtomicIsize","","A signed integer type which can be safely shared between threads.",null,null],[3,"AtomicUsize","","An unsigned integer type which can be safely shared between threads.",null,null],[3,"AtomicPtr","","A raw pointer type which can be safely shared between threads.",null,null],[4,"Ordering","","Atomic memory orderings",null,null],[13,"Relaxed","","No ordering constraints, only atomic operations.",50,null],[13,"Release","","When coupled with a store, all previous writes become visible\nto another thread that performs a load with `Acquire` ordering\non the same value.",50,null],[13,"Acquire","","When coupled with a load, all subsequent loads will see data\nwritten before a store with `Release` ordering on the same value\nin another thread.",50,null],[13,"AcqRel","","When coupled with a load, uses `Acquire` ordering, and with a store\n`Release` ordering.",50,null],[13,"SeqCst","","Like `AcqRel` with the additional guarantee that all threads see all\nsequentially consistent operations in the same order.",50,null],[5,"fence","","An atomic fence.",null,{"inputs":[{"name":"ordering"}],"output":null}],[17,"ATOMIC_BOOL_INIT","","An `AtomicBool` initialized to `false`.",null,null],[17,"ATOMIC_ISIZE_INIT","","An `AtomicIsize` initialized to `0`.",null,null],[17,"ATOMIC_USIZE_INIT","","An `AtomicUsize` initialized to `0`.",null,null],[11,"default","","",51,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",52,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",53,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"clone","","",50,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",51,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":null}],[11,"swap","","Stores a value into the bool, returning the old value.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the bool if the current value is the same as the expected value.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",51,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",52,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":null}],[11,"swap","","Stores a value into the isize, returning the old value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the isize if the current value is the same as the expected value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",52,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",53,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":null}],[11,"swap","","Stores a value into the usize, returning the old value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the usize if the current value is the same as the expected value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",53,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",54,null],[11,"load","","Loads a value from the pointer.",54,null],[11,"store","","Stores a value into the pointer.",54,null],[11,"swap","","Stores a value into the pointer, returning the old value.",54,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the expected value.",54,null],[0,"cell","core","Shareable mutable containers.",null,null],[3,"Cell","core::cell","A mutable memory location that admits only `Copy` data.",null,null],[3,"RefCell","","A mutable memory location with dynamically checked borrow rules",null,null],[3,"Ref","","Wraps a borrowed reference to a value in a `RefCell` box.\nA wrapper type for an immutably borrowed value from a `RefCell<T>`.",null,null],[3,"RefMut","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",null,null],[3,"UnsafeCell","","The core primitive for interior mutability in Rust.",null,null],[12,"value","","Wrapped value",55,null],[4,"BorrowState","","An enumeration of values returned from the `state` method on a `RefCell<T>`.",null,null],[13,"Reading","","The cell is currently being read, there is at least one active `borrow`.",56,null],[13,"Writing","","The cell is currently being written to, there is an active `borrow_mut`.",56,null],[13,"Unused","","There are no outstanding borrows on this cell.",56,null],[5,"clone_ref","","Copies a `Ref`.",null,{"inputs":[{"name":"ref"}],"output":{"name":"ref"}}],[11,"new","","Creates a new `Cell` containing the given value.",57,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",57,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",57,{"inputs":[{"name":"cell"},{"name":"t"}],"output":null}],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",57,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",57,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",57,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",57,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",56,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",56,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",56,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",56,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",58,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",58,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",58,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",58,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",58,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",58,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",58,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",58,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",58,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[6,"Target","","",null,null],[11,"deref","","",59,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[6,"Target","","",null,null],[11,"deref","","",60,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",60,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",55,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",55,null],[11,"into_inner","","Unwraps the value.",55,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[0,"char","core","Character manipulation.",null,null],[3,"EscapeUnicode","core::char","An iterator over the characters that represent a `char`, as escaped by\nRust's unicode escaping rules.",null,null],[3,"EscapeDefault","","An iterator over the characters that represent a `char`, escaped\nfor maximum portability.",null,null],[5,"from_u32","","Converts a `u32` to an `Option<char>`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[5,"from_digit","","Converts a number to the character representing it.",null,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[5,"encode_utf8_raw","","Encodes a raw u32 value as UTF-8 into the provided byte buffer,\nand then returns the number of bytes written.",null,null],[5,"encode_utf16_raw","","Encodes a raw u32 value as UTF-16 into the provided `u16` buffer,\nand then returns the number of `u16`s written.",null,null],[17,"MAX","","The highest valid code point",null,null],[11,"clone","","",61,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[6,"Item","","",null,null],[11,"next","","",61,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",62,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[6,"Item","","",null,null],[11,"next","","",62,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[0,"panicking","core","Panic support for libcore",null,null],[5,"panic","core::panicking","",null,null],[5,"panic_fmt","","",null,null],[0,"iter","core","Composable external iterators",null,null],[3,"Rev","core::iter","An double-ended iterator with the direction inverted",null,null],[3,"Cloned","","An iterator that clones the elements of an underlying iterator",null,null],[3,"Cycle","","An iterator that repeats endlessly",null,null],[3,"Chain","","An iterator that strings two iterators together",null,null],[3,"Zip","","An iterator that iterates two other iterators simultaneously",null,null],[3,"Map","","An iterator that maps the values of `iter` with `f`",null,null],[3,"Filter","","An iterator that filters the elements of `iter` with `predicate`",null,null],[3,"FilterMap","","An iterator that uses `f` to both filter and map elements from `iter`",null,null],[3,"Enumerate","","An iterator that yields the current count and the element during iteration",null,null],[3,"Peekable","","An iterator with a `peek()` that returns an optional reference to the next element.",null,null],[3,"SkipWhile","","An iterator that rejects elements while `predicate` is true",null,null],[3,"TakeWhile","","An iterator that only accepts elements while `predicate` is true",null,null],[3,"Skip","","An iterator that skips over `n` elements of `iter`.",null,null],[3,"Take","","An iterator that only iterates over the first `n` iterations of `iter`.",null,null],[3,"Scan","","An iterator to maintain state while iterating another iterator",null,null],[12,"state","","The current internal state to be passed to the closure next.",63,null],[3,"FlatMap","","An iterator that maps each element to an iterator,\nand yields the elements of the produced iterators",null,null],[3,"Fuse","","An iterator that yields `None` forever after the underlying iterator\nyields `None` once.",null,null],[3,"Inspect","","An iterator that calls a function with a reference to each\nelement before yielding it.",null,null],[3,"Unfold","","An iterator that passes mutable state to a closure and yields the result.",null,null],[12,"state","","Internal state that will be passed to the closure on the next iteration",64,null],[3,"StepBy","","An adapter for stepping range iterators by a custom amount.",null,null],[3,"RangeInclusive","","An iterator over the range [start, stop]",null,null],[3,"Repeat","","An iterator that repeats an element endlessly",null,null],[4,"MinMaxResult","","`MinMaxResult` is an enum returned by `min_max`. See `Iterator::min_max` for\nmore detail.",null,null],[13,"NoElements","","Empty iterator",65,null],[13,"OneElement","","Iterator with one element, so the minimum and maximum are the same",65,null],[13,"MinMax","","More than one element in the iterator, the first element is not larger\nthan the second",65,null],[5,"range_inclusive","","Returns an iterator over the range [start, stop].",null,{"inputs":[{"name":"a"},{"name":"a"}],"output":{"name":"rangeinclusive"}}],[5,"iterate","","Creates a new iterator that produces an infinite sequence of\nrepeated applications of the given function `f`.",null,{"inputs":[{"name":"t"},{"name":"f"}],"output":{"name":"iterate"}}],[5,"repeat","","Creates a new iterator that endlessly repeats the element `elt`.",null,{"inputs":[{"name":"t"}],"output":{"name":"repeat"}}],[0,"order","","Functions for lexicographical ordering of sequences.",null,null],[5,"equals","core::iter::order","Compare `a` and `b` for equality using `Eq`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"cmp","","Order `a` and `b` lexicographically using `Ord`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"ordering"}}],[5,"partial_cmp","","Order `a` and `b` lexicographically using `PartialOrd`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"option"}}],[5,"eq","","Compare `a` and `b` for equality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ne","","Compares `a` and `b` for nonequality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"lt","","Returns `a` < `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"le","","Returns `a` <= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"gt","","Returns `a` > `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ge","","Returns `a` >= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[6,"Iterate","core::iter","An iterator that repeatedly applies a given function, starting\nfrom a given seed value.",null,null],[8,"Iterator","","An interface for dealing with \"external iterators\". These types of iterators\ncan be resumed at any time as all state is stored internally as opposed to\nbeing located on the call stack.",null,null],[16,"Item","core::iter::Iterator","The type of the elements being iterated",null,null],[10,"next","core::iter","Advances the iterator and returns the next value. Returns `None` when the\nend is reached.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"size_hint","","Returns a lower and upper bound on the remaining length of the iterator.",66,null],[11,"count","","Counts the number of elements in this iterator.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"usize"}}],[11,"last","","Loops through the entire iterator, returning the last element.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"nth","","Loops through `n` iterations, returning the `n`th element of the\niterator.",66,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"option"}}],[11,"chain","","Chain this iterator with another, returning a new iterator that will\nfinish iterating over the current iterator, and then iterate\nover the other specified iterator.",66,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"chain"}}],[11,"zip","","Creates an iterator that iterates over both this and the specified\niterators simultaneously, yielding the two elements as pairs. When\neither iterator returns `None`, all further invocations of `next()`\nwill return `None`.",66,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"zip"}}],[11,"map","","Creates a new iterator that will apply the specified function to each\nelement returned by the first, yielding the mapped element instead.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"map"}}],[11,"filter","","Creates an iterator that applies the predicate to each element returned\nby this iterator. The only elements that will be yielded are those that\nmake the predicate evaluate to `true`.",66,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"filter"}}],[11,"filter_map","","Creates an iterator that both filters and maps elements.\nIf the specified function returns `None`, the element is skipped.\nOtherwise the option is unwrapped and the new value is yielded.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"filtermap"}}],[11,"enumerate","","Creates an iterator that yields pairs `(i, val)` where `i` is the\ncurrent index of iteration and `val` is the value returned by the\niterator.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"enumerate"}}],[11,"peekable","","Creates an iterator that has a `.peek()` method\nthat returns an optional reference to the next element.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"peekable"}}],[11,"skip_while","","Creates an iterator that invokes the predicate on elements\nuntil it returns false. Once the predicate returns false, that\nelement and all further elements are yielded.",66,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"skipwhile"}}],[11,"take_while","","Creates an iterator that yields elements so long as the predicate\nreturns true. After the predicate returns false for the first time, no\nfurther elements will be yielded.",66,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"takewhile"}}],[11,"skip","","Creates an iterator that skips the first `n` elements of this iterator,\nand then yields all further items.",66,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"skip"}}],[11,"take","","Creates an iterator that yields the first `n` elements of this\niterator.",66,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"take"}}],[11,"scan","","Creates a new iterator that behaves in a similar fashion to fold.\nThere is a state which is passed between each iteration and can be\nmutated as necessary. The yielded values from the closure are yielded\nfrom the Scan instance when not `None`.",66,{"inputs":[{"name":"iterator"},{"name":"st"},{"name":"f"}],"output":{"name":"scan"}}],[11,"flat_map","","Creates an iterator that maps each element to an iterator,\nand yields the elements of the produced iterators.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"flatmap"}}],[11,"fuse","","Creates an iterator that yields `None` forever after the underlying\niterator yields `None`. Random-access iterator behavior is not\naffected, only single and double-ended iterator behavior.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"fuse"}}],[11,"inspect","","Creates an iterator that calls a function with a reference to each\nelement before yielding it. This is often useful for debugging an\niterator pipeline.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"inspect"}}],[11,"by_ref","","Creates a wrapper around a mutable reference to the iterator.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"self"}}],[11,"collect","","Loops through the entire iterator, collecting all of the elements into\na container implementing `FromIterator`.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"b"}}],[11,"partition","","Loops through the entire iterator, collecting all of the elements into\none of two containers, depending on a predicate. The elements of the\nfirst container satisfy the predicate, while the elements of the second\ndo not.",66,null],[11,"fold","","Performs a fold operation over the entire iterator, returning the\neventual state at the end of the iteration.",66,{"inputs":[{"name":"iterator"},{"name":"b"},{"name":"f"}],"output":{"name":"b"}}],[11,"all","","Tests whether the predicate holds true for all elements in the iterator.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"any","","Tests whether any element of an iterator satisfies the specified\npredicate.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"find","","Returns the first element satisfying the specified predicate.",66,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"position","","Returns the index of the first element satisfying the specified predicate",66,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"rposition","","Returns the index of the last element satisfying the specified predicate",66,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"max","","Consumes the entire iterator to return the maximum element.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min","","Consumes the entire iterator to return the minimum element.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min_max","","`min_max` finds the minimum and maximum elements in the iterator.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"minmaxresult"}}],[11,"max_by","","Returns the element that gives the maximum value from the\nspecified function.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"min_by","","Returns the element that gives the minimum value from the\nspecified function.",66,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"rev","","Change the direction of the iterator",66,{"inputs":[{"name":"iterator"}],"output":{"name":"rev"}}],[11,"unzip","","Converts an iterator of pairs into a pair of containers.",66,null],[11,"cloned","","Creates an iterator that clones the elements it yields. Useful for\nconverting an Iterator<&T> to an Iterator<T>.",66,{"inputs":[{"name":"iterator"}],"output":{"name":"cloned"}}],[11,"cycle","","Repeats an iterator endlessly",66,{"inputs":[{"name":"iterator"}],"output":{"name":"cycle"}}],[11,"reverse_in_place","","Use an iterator to reverse a container in place.",66,{"inputs":[{"name":"iterator"}],"output":null}],[11,"sum","","Iterates over the entire iterator, summing up all the elements",66,{"inputs":[{"name":"iterator"}],"output":{"name":"s"}}],[11,"product","","Iterates over the entire iterator, multiplying all the elements",66,{"inputs":[{"name":"iterator"}],"output":{"name":"p"}}],[8,"FromIterator","","Conversion from an `Iterator`",null,null],[10,"from_iter","","Builds a container with elements from something iterable.",67,{"inputs":[{"name":"fromiterator"},{"name":"t"}],"output":{"name":"self"}}],[8,"IntoIterator","","Conversion into an `Iterator`",null,null],[16,"Item","core::iter::IntoIterator","The type of the elements being iterated",null,null],[16,"IntoIter","","A container for iterating over elements of type `Item`",null,null],[10,"into_iter","core::iter","Consumes `Self` and returns an iterator over it",68,{"inputs":[{"name":"intoiterator"}],"output":{"name":"intoiter"}}],[8,"Extend","","A type growable from an `Iterator` implementation",null,null],[10,"extend","","Extends a container with the elements yielded by an arbitrary iterator",69,{"inputs":[{"name":"extend"},{"name":"t"}],"output":null}],[8,"DoubleEndedIterator","","A range iterator able to yield elements from both ends",null,null],[10,"next_back","","Yields an element from the end of the range, returning `None` if the\nrange is empty.",70,{"inputs":[{"name":"doubleendediterator"}],"output":{"name":"option"}}],[8,"RandomAccessIterator","","An object implementing random access indexing by `usize`",null,null],[10,"indexable","","Returns the number of indexable elements. At most `std::usize::MAX`\nelements are indexable, even if the iterator represents a longer range.",71,{"inputs":[{"name":"randomaccessiterator"}],"output":{"name":"usize"}}],[10,"idx","","Returns an element at an index, or `None` if the index is out of bounds",71,{"inputs":[{"name":"randomaccessiterator"},{"name":"usize"}],"output":{"name":"option"}}],[8,"ExactSizeIterator","","An iterator that knows its exact length",null,null],[11,"len","","Returns the exact length of the iterator.",72,{"inputs":[{"name":"exactsizeiterator"}],"output":{"name":"usize"}}],[8,"Step","","Objects that can be stepped over in both directions.",null,null],[10,"step","","Steps `self` if possible.",73,{"inputs":[{"name":"step"},{"name":"self"}],"output":{"name":"option"}}],[10,"steps_between","","Returns the number of steps between two step objects.",73,{"inputs":[{"name":"step"},{"name":"self"},{"name":"self"},{"name":"self"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"clone","","",74,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[6,"Item","","",null,null],[11,"next","","",74,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",74,null],[11,"next_back","","",74,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",74,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",74,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",65,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",65,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",65,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",75,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[6,"Item","","",null,null],[11,"next","","",75,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",75,null],[11,"next_back","","",75,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",75,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",75,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",76,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[6,"Item","","",null,null],[11,"next","","",76,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",76,null],[11,"indexable","","",76,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",76,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",77,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[6,"Item","","",null,null],[11,"next","","",77,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",77,null],[11,"next_back","","",77,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",77,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",77,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",78,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[6,"Item","","",null,null],[11,"next","","",78,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",78,null],[11,"next_back","","",78,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",78,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",78,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",79,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[6,"Item","","",null,null],[11,"next","","",79,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",79,null],[11,"next_back","","",79,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",79,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",79,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",80,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[6,"Item","","",null,null],[11,"next","","",80,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",80,null],[11,"next_back","","",80,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",81,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[6,"Item","","",null,null],[11,"next","","",81,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",81,null],[11,"next_back","","",81,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",82,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[6,"Item","","",null,null],[11,"next","","",82,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",82,null],[11,"next_back","","",82,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",82,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",82,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",83,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[6,"Item","","",null,null],[11,"next","","",83,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",83,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",83,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",83,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",84,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[6,"Item","","",null,null],[11,"next","","",84,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",84,null],[11,"clone","","",85,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[6,"Item","","",null,null],[11,"next","","",85,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",85,null],[11,"clone","","",86,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[6,"Item","","",null,null],[11,"next","","",86,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",86,null],[11,"indexable","","",86,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",86,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",87,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[6,"Item","","",null,null],[11,"next","","",87,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"size_hint","","",87,null],[11,"indexable","","",87,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",87,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",63,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[6,"Item","","",null,null],[11,"next","","",63,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",63,null],[11,"clone","","",88,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[6,"Item","","",null,null],[11,"next","","",88,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"next_back","","",88,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",89,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[6,"Item","","",null,null],[11,"next","","",89,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"next_back","","",89,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",89,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",89,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",89,{"inputs":[{"name":"fuse"}],"output":null}],[11,"clone","","",90,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[6,"Item","","",null,null],[11,"next","","",90,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",90,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",90,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",64,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",64,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[6,"Item","","",null,null],[11,"next","","",64,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",64,null],[11,"clone","","",91,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",14,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",13,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[6,"Item","core::iter","",null,null],[11,"next","","",91,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",91,null],[11,"clone","","",92,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[6,"Item","","",null,null],[11,"next","","",92,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",92,null],[11,"next_back","","",92,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",91,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","core::ops","",13,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",13,null],[11,"next_back","","",13,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[6,"Item","core::iter","",null,null],[11,"next","core::ops","",14,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",93,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[6,"Item","","",null,null],[11,"next","","",93,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",93,null],[11,"next_back","","",93,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",93,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",93,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[0,"option","core","Optional values",null,null],[3,"Iter","core::option","An iterator over a reference of the contained item in an Option.",null,null],[3,"IterMut","","An iterator over a mutable reference of the contained item in an Option.",null,null],[3,"IntoIter","","An iterator over the item contained inside an Option.",null,null],[4,"Option","","The `Option` type. See [the module level documentation](../index.html) for more.",null,null],[13,"None","","No value",94,null],[13,"Some","","Some value `T`",94,null],[11,"hash","","",94,null],[11,"fmt","","",94,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",94,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",94,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",94,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",94,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",94,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",94,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value or returns a default.",94,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value or computes a default.",94,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",94,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",94,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",94,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",94,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",94,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",94,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",94,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",94,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",94,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[11,"next","","",95,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",95,null],[11,"next_back","","",95,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",95,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",96,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",96,null],[11,"next_back","","",96,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",97,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",97,null],[11,"next_back","","",97,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",94,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[0,"raw","core","Contains struct definitions for the layout of compiler built-in types.",null,null],[3,"Slice","core::raw","The representation of a slice like `&[T]`.",null,null],[12,"data","","",98,null],[12,"len","","",98,null],[3,"TraitObject","","The representation of a trait object like `&SomeTrait`.",null,null],[12,"data","","",99,null],[12,"vtable","","",99,null],[8,"Repr","","This trait is meant to map equivalences between raw structs and their\ncorresponding rust values.",null,null],[11,"repr","","This function \"unwraps\" a rust value (without consuming it) into its raw\nstruct representation. This can be used to read/write different values\nfor the struct. This is a safe method because by default it does not\nenable write-access to the fields of the return value in safe code.",100,{"inputs":[{"name":"repr"}],"output":{"name":"t"}}],[11,"clone","","",98,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",99,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[0,"result","core","Error handling with the `Result` type",null,null],[3,"Iter","core::result","An iterator over a reference to the `Ok` variant of a `Result`.",null,null],[3,"IterMut","","An iterator over a mutable reference to the `Ok` variant of a `Result`.",null,null],[3,"IntoIter","","An iterator over the value in a `Ok` variant of a `Result`.",null,null],[4,"Result","","`Result` is a type that represents either success (`Ok`) or failure (`Err`).",null,null],[13,"Ok","","Contains the success value",101,null],[13,"Err","","Contains the error value",101,null],[5,"fold","","Performs a fold operation over the result values from an iterator.",null,{"inputs":[{"name":"iter"},{"name":"v"},{"name":"f"}],"output":{"name":"result"}}],[11,"hash","","",101,null],[11,"fmt","","",101,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",101,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",101,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",101,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",101,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",101,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",101,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",101,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",101,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",101,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",101,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",101,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",101,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",101,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",101,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",101,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",101,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",101,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",101,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Returns a consuming iterator over the possibly contained value.",101,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[11,"next","","",102,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",102,null],[11,"next_back","","",102,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",102,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",103,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",103,null],[11,"next_back","","",103,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",104,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",104,null],[11,"next_back","","",104,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",101,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[0,"simd","core","SIMD vectors.",null,null],[3,"i8x16","core::simd","",null,null],[3,"i16x8","","",null,null],[3,"i32x4","","",null,null],[3,"i64x2","","",null,null],[3,"u8x16","","",null,null],[3,"u16x8","","",null,null],[3,"u32x4","","",null,null],[3,"u64x2","","",null,null],[3,"f32x4","","",null,null],[3,"f64x2","","",null,null],[11,"fmt","","",105,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",105,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",106,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",106,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",107,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",107,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",108,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",108,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",109,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",109,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",110,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",110,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",111,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",111,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",112,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",112,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",113,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",113,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",114,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",114,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[0,"slice","core","Slice management and manipulation",null,null],[3,"Iter","core::slice","Immutable slice iterator",null,null],[3,"IterMut","","Mutable slice iterator.",null,null],[3,"Split","","An iterator over subslices separated by elements that match a predicate\nfunction.",null,null],[3,"SplitMut","","An iterator over the subslices of the vector which are separated\nby elements that match `pred`.",null,null],[3,"SplitN","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitN","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"SplitNMut","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitNMut","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"Windows","","An iterator over overlapping subslices of length `size`.",null,null],[3,"Chunks","","An iterator over a slice in (non-overlapping) chunks (`size` elements at a\ntime).",null,null],[3,"ChunksMut","","An iterator over a slice in (non-overlapping) mutable chunks (`size`\nelements at a time). When the slice len is not evenly divided by the chunk\nsize, the last slice of the iteration will be the remainder.",null,null],[5,"ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"mut_ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"from_raw_parts","","Forms a slice from a pointer and a length.",null,null],[5,"from_raw_parts_mut","","Performs the same functionality as `from_raw_parts`, except that a mutable\nslice is returned.",null,null],[0,"bytes","","Operations on `[u8]`.",null,null],[5,"copy_memory","core::slice::bytes","Copies data from `src` to `dst`",null,null],[8,"MutableByteVector","","A trait for operations on mutable `[u8]`s.",null,null],[10,"set_memory","","Sets all bytes of the receiver to the given value.",115,{"inputs":[{"name":"mutablebytevector"},{"name":"u8"}],"output":null}],[8,"IntSliceExt","core::slice","Extension methods for slices containing integers.",null,null],[10,"as_unsigned","","Converts the slice to an immutable slice of unsigned integers with the same width.",116,null],[10,"as_signed","","Converts the slice to an immutable slice of signed integers with the same width.",116,null],[10,"as_unsigned_mut","","Converts the slice to a mutable slice of unsigned integers with the same width.",116,null],[10,"as_signed_mut","","Converts the slice to a mutable slice of signed integers with the same width.",116,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"as_slice","","View the underlying data as a subslice of the original data.",117,null],[6,"Item","","",null,null],[11,"next","","",117,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",117,null],[11,"next_back","","",117,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",117,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",117,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",117,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",118,null],[6,"Item","","",null,null],[11,"next","","",118,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",118,null],[11,"next_back","","",118,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",119,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","","",null,null],[11,"next","","",119,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",119,null],[11,"next_back","","",119,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",120,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",120,null],[11,"next_back","","",120,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",121,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",121,null],[6,"Item","","",null,null],[11,"next","","",122,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",122,null],[6,"Item","","",null,null],[11,"next","","",123,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",123,null],[6,"Item","","",null,null],[11,"next","","",124,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",124,null],[11,"clone","","",125,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[6,"Item","","",null,null],[11,"next","","",125,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",125,null],[11,"next_back","","",125,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",125,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",125,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",126,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[6,"Item","","",null,null],[11,"next","","",126,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",126,null],[11,"next_back","","",126,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",126,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",126,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",127,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",127,null],[11,"next_back","","",127,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[0,"str","core","String manipulation",null,null],[3,"ParseBoolError","core::str","An error returned when parsing a `bool` from a string fails.",null,null],[3,"Utf8Error","","Errors which can occur when attempting to interpret a byte slice as a `str`.",null,null],[3,"Chars","","Iterator for the char (representing *Unicode Scalar Values*) of a string",null,null],[3,"CharIndices","","Iterator for a string's characters and their byte offsets.",null,null],[3,"Bytes","","External iterator for a string's bytes.\nUse with the `std::iter` module.",null,null],[3,"Split","","/// Created with the method `.split()`.",null,null],[3,"RSplit","","/// Created with the method `.rsplit()`.",null,null],[3,"SplitTerminator","","/// Created with the method `.split_terminator()`.",null,null],[3,"RSplitTerminator","","/// Created with the method `.rsplit_terminator()`.",null,null],[3,"SplitN","","/// Created with the method `.splitn()`.",null,null],[3,"RSplitN","","/// Created with the method `.rsplitn()`.",null,null],[3,"MatchIndices","","/// Created with the method `.match_indices()`.",null,null],[3,"RMatchIndices","","/// Created with the method `.rmatch_indices()`.",null,null],[3,"Matches","","/// Created with the method `.matches()`.",null,null],[3,"RMatches","","/// Created with the method `.rmatches()`.",null,null],[3,"Lines","","Created with the method `.lines()`.",null,null],[3,"LinesAny","","Created with the method `.lines_any()`.",null,null],[3,"CharRange","","Struct that contains a `char` and the index of the first byte of\nthe next `char` in a string.  This can be used as a data structure\nfor iterating over the UTF-8 bytes of a string.",null,null],[12,"ch","","Current `char`",128,null],[12,"next","","Index of the first byte of the next `char`",128,null],[5,"from_utf8","","Converts a slice of bytes to a string slice without performing any\nallocations.",null,null],[5,"from_utf8_unchecked","","Converts a slice of bytes to a string slice without checking\nthat the string contains valid UTF-8.",null,null],[5,"next_code_point","","Reads the next code point out of a byte iterator (assuming a\nUTF-8-like encoding).",null,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[5,"next_code_point_reverse","","Reads the last code point out of a byte iterator (assuming a\nUTF-8-like encoding).",null,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[5,"char_range_at_raw","","Pluck a code point out of a UTF-8-like byte slice and return the\nindex of the next code point.",null,null],[0,"pattern","","The string Pattern API.",null,null],[3,"StrSearcher","core::str::pattern","Associated type for `<&str as Pattern<'a>>::Searcher`.",null,null],[3,"CharSearcher","","Associated type for `<char as Pattern<'a>>::Searcher`.",null,null],[3,"CharSliceSearcher","","Associated type for `<&[char] as Pattern<'a>>::Searcher`.",null,null],[3,"CharPredicateSearcher","","Associated type for `<F as Pattern<'a>>::Searcher`.",null,null],[4,"SearchStep","","Result of calling `Searcher::next()` or `ReverseSearcher::next_back()`.",null,null],[13,"Match","","Expresses that a match of the pattern has been found at\n`haystack[a..b]`.",129,null],[13,"Reject","","Expresses that `haystack[a..b]` has been rejected as a possible match\nof the pattern.",129,null],[13,"Done","","Expresses that every byte of the haystack has been visted, ending\nthe iteration.",129,null],[8,"Pattern","","A string pattern.",null,null],[16,"Searcher","core::str::pattern::Pattern","Associated searcher for this pattern",null,null],[10,"into_searcher","core::str::pattern","Constructs the associated searcher from\n`self` and the `haystack` to search in.",130,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"searcher"}}],[11,"is_contained_in","","Checks whether the pattern matches anywhere in the haystack",130,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",130,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",130,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[8,"Searcher","","A searcher for a string pattern.",null,null],[10,"haystack","","Getter for the underlaying string to be searched in",131,{"inputs":[{"name":"searcher"}],"output":{"name":"str"}}],[10,"next","","Performs the next search step starting from the front.",131,{"inputs":[{"name":"searcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","Find the next `Match` result. See `next()`",131,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[11,"next_reject","","Find the next `Reject` result. See `next()`",131,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[8,"ReverseSearcher","","A reverse searcher for a string pattern.",null,null],[10,"next_back","","Performs the next search step starting from the back.",132,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","Find the next `Match` result. See `next_back()`",132,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","Find the next `Reject` result. See `next_back()`",132,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[8,"DoubleEndedSearcher","","A marker trait to express that a `ReverseSearcher`\ncan be used for a `DoubleEndedIterator` implementation.",null,null],[11,"fmt","","",129,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",129,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",129,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[6,"Searcher","","",null,null],[11,"haystack","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",133,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",134,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[6,"Searcher","","",null,null],[11,"clone","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",135,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[6,"Searcher","","",null,null],[11,"clone","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",136,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[6,"Searcher","","",null,null],[6,"Searcher","","",null,null],[8,"FromStr","core::str","A trait to abstract the idea of creating a new instance of a type from a\nstring.",null,null],[16,"Err","core::str::FromStr","The associated error which can be returned from parsing.",null,null],[10,"from_str","core::str","Parses a string `s` to return an optional value of this type. If the\nstring is ill-formatted, the None is returned.",137,{"inputs":[{"name":"fromstr"},{"name":"str"}],"output":{"name":"result"}}],[6,"Err","","",null,null],[11,"eq","","",138,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",138,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",138,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",138,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",138,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",139,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",139,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",139,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",139,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",139,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",139,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",140,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[6,"Item","","",null,null],[11,"next","","",140,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",140,null],[11,"next_back","","",140,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",141,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[6,"Item","","",null,null],[11,"next","","",141,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",141,null],[11,"next_back","","",141,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",142,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[6,"Item","","",null,null],[11,"next","","",142,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",142,null],[11,"next_back","","",142,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",142,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[6,"Item","","",null,null],[11,"next","","",143,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",143,{"inputs":[{"name":"split"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",144,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",144,{"inputs":[{"name":"rsplit"}],"output":{"name":"self"}}],[11,"next_back","","",143,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",144,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",145,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",145,{"inputs":[{"name":"splitterminator"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",146,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",146,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"self"}}],[11,"next_back","","",145,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",146,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",147,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",147,{"inputs":[{"name":"splitn"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",148,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",148,{"inputs":[{"name":"rsplitn"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",149,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",149,{"inputs":[{"name":"matchindices"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",150,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",150,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"self"}}],[11,"next_back","","",149,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",150,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",151,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",151,{"inputs":[{"name":"matches"}],"output":{"name":"self"}}],[6,"Item","","",null,null],[11,"next","","",152,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",152,{"inputs":[{"name":"rmatches"}],"output":{"name":"self"}}],[11,"next_back","","",151,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",152,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",153,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[6,"Item","","",null,null],[11,"next","","",153,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",153,null],[11,"next_back","","",153,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",154,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[6,"Item","","",null,null],[11,"next","","",154,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",154,null],[11,"next_back","","",154,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",128,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[0,"hash","core","Generic hashing support.",null,null],[3,"SipHasher","core::hash","An implementation of SipHash 2-4.",null,null],[5,"hash","","Hash a value with the default SipHasher algorithm (two initial keys of 0).",null,{"inputs":[{"name":"t"}],"output":{"name":"u64"}}],[11,"new","","Creates a new `SipHasher` with the two initial keys set to 0.",155,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",155,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",155,null],[11,"finish","","",155,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",155,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",155,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[8,"Hash","","A hashable type.",null,null],[10,"hash","","Feeds this value into the state given, updating the hasher as necessary.",156,{"inputs":[{"name":"hash"},{"name":"h"}],"output":null}],[11,"hash_slice","","Feeds a slice of this type into the state provided.",156,null],[8,"Hasher","","A trait which represents the ability to hash an arbitrary stream of bytes.",null,null],[10,"finish","","Completes a round of hashing, producing the output hash generated.",157,{"inputs":[{"name":"hasher"}],"output":{"name":"u64"}}],[10,"write","","Writes some data into this `Hasher`",157,null],[11,"write_u8","","Write a single `u8` into this hasher",157,{"inputs":[{"name":"hasher"},{"name":"u8"}],"output":null}],[11,"write_u16","","Write a single `u16` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"u16"}],"output":null}],[11,"write_u32","","Write a single `u32` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"u32"}],"output":null}],[11,"write_u64","","Write a single `u64` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"u64"}],"output":null}],[11,"write_usize","","Write a single `usize` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"usize"}],"output":null}],[11,"write_i8","","Write a single `i8` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"i8"}],"output":null}],[11,"write_i16","","Write a single `i16` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"i16"}],"output":null}],[11,"write_i32","","Write a single `i32` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"i32"}],"output":null}],[11,"write_i64","","Write a single `i64` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"i64"}],"output":null}],[11,"write_isize","","Write a single `isize` into this hasher.",157,{"inputs":[{"name":"hasher"},{"name":"isize"}],"output":null}],[0,"fmt","core","Utilities for formatting and printing strings",null,null],[3,"Radix","core::fmt","A radix with in the range of `2..36`.",null,null],[3,"RadixFmt","","A helper type for formatting radixes.",null,null],[3,"DebugStruct","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugTuple","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugSet","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugList","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"DebugMap","","A struct to help with `fmt::Debug` implementations.",null,null],[3,"Error","","The error type which is returned from formatting a message into a stream.",null,null],[3,"Formatter","","A struct to represent both where to emit formatting strings to and how they\nshould be formatted. A mutable version of this is passed to all formatting\ntraits.",null,null],[3,"Arguments","","This structure represents a safely precompiled version of a format string\nand its arguments. This cannot be generated at runtime because it cannot\nsafely be done so, so no constructors are given and the fields are private\nto prevent modification.",null,null],[5,"radix","","Constructs a radix formatter in the range of `2..36`.",null,{"inputs":[{"name":"t"},{"name":"u8"}],"output":{"name":"radixfmt"}}],[5,"write","","The `write` function takes an output stream, a precompiled format string,\nand a list of arguments. The arguments will be formatted according to the\nspecified format string into the output stream provided.",null,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"eq","","",158,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",158,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",158,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",159,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",159,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",160,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Consumes the `DebugStruct`, finishing output and returning any error\nencountered.",160,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",161,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Consumes the `DebugTuple`, finishing output and returning any error\nencountered.",161,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the set output.",162,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",162,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the set output.",163,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",163,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",164,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"finish","","Consumes the `DebugMap`, finishing output and returning any error\nencountered.",164,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[6,"Result","","The type returned by formatter methods.",null,null],[8,"Write","","A collection of methods that are required to format a message into a stream.",null,null],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write\nsucceeded.",165,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Glue for usage of the `write!` macro with implementers of this trait.",165,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[8,"Debug","","Format trait for the `:?` format. Useful for debugging, all types\nshould implement this.",null,null],[10,"fmt","","Formats the value using the given formatter.",166,{"inputs":[{"name":"debug"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Display","","When a value can be semantically expressed as a String, this trait may be\nused. It corresponds to the default format, `{}`.",null,null],[10,"fmt","","Formats the value using the given formatter.",167,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Octal","","Format trait for the `o` character",null,null],[10,"fmt","","Formats the value using the given formatter.",168,{"inputs":[{"name":"octal"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Binary","","Format trait for the `b` character",null,null],[10,"fmt","","Formats the value using the given formatter.",169,{"inputs":[{"name":"binary"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerHex","","Format trait for the `x` character",null,null],[10,"fmt","","Formats the value using the given formatter.",170,{"inputs":[{"name":"lowerhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperHex","","Format trait for the `X` character",null,null],[10,"fmt","","Formats the value using the given formatter.",171,{"inputs":[{"name":"upperhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Pointer","","Format trait for the `p` character",null,null],[10,"fmt","","Formats the value using the given formatter.",172,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerExp","","Format trait for the `e` character",null,null],[10,"fmt","","Formats the value using the given formatter.",173,{"inputs":[{"name":"lowerexp"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperExp","","Format trait for the `E` character",null,null],[10,"fmt","","Formats the value using the given formatter.",174,{"inputs":[{"name":"upperexp"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",175,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",175,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",176,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",176,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",176,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pad_integral","","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",177,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",177,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",177,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",177,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",177,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",177,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",177,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",177,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",177,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",177,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",177,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",177,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",177,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",177,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"fmt","","",175,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",12,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",57,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",58,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",59,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",60,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[14,"panic!","core","Entry point of thread panic, for details, see std::macros",null,null],[14,"assert!","","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"assert_eq!","","Asserts that two expressions are equal to each other.",null,null],[14,"debug_assert!","","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"debug_assert_eq!","","Asserts that two expressions are equal to each other, testing equality in\nboth directions.",null,null],[14,"try!","","Short circuiting evaluation on Err",null,null],[14,"write!","","Use the `format!` syntax to write data into a buffer of type `&mut Writer`.\nSee `std::fmt` for more information.",null,null],[14,"writeln!","","Equivalent to the `write!` macro, except that a newline is appended after\nthe message is written.",null,null],[14,"unreachable!","","A utility macro for indicating unreachable code.",null,null],[14,"unimplemented!","","A standardised placeholder for marking unfinished code. It panics with the\nmessage `\"not yet implemented\"` when executed.",null,null],[14,"__impl_slice_eq1!","","",null,null],[14,"__impl_slice_eq2!","","",null,null],[15,"isize","","Operations and constants for pointer-sized signed integers (`isize` type)",null,null],[15,"i8","","Operations and constants for signed 8-bits integers (`i8` type)",null,null],[15,"i16","","Operations and constants for signed 16-bits integers (`i16` type)",null,null],[15,"i32","","Operations and constants for signed 32-bits integers (`i32` type)",null,null],[15,"i64","","Operations and constants for signed 64-bits integers (`i64` type)",null,null],[15,"usize","","Operations and constants for pointer-sized unsigned integers (`usize` type)",null,null],[15,"u8","","Operations and constants for unsigned 8-bits integers (`u8` type)",null,null],[15,"u16","","Operations and constants for unsigned 16-bits integers (`u16` type)",null,null],[15,"u32","","Operations and constants for unsigned 32-bits integers (`u32` type)",null,null],[15,"u64","","Operations and constants for unsigned 64-bits integer (`u64` type)",null,null],[15,"f32","","Operations and constants for 32-bits floats (`f32` type)",null,null],[15,"f64","","Operations and constants for 64-bits floats (`f64` type)",null,null],[15,"pointer","","Operations on unsafe pointers, `*const T`, and `*mut T`.",null,null],[15,"array","","Implementations of things like `Eq` for fixed-length arrays\nup to a certain length. Eventually we should able to generalize\nto all lengths.",null,null],[15,"char","","Character manipulation.",null,null],[15,"slice","","Slice management and manipulation",null,null],[15,"str","","String manipulation",null,null],[15,"bool","","",null,null],[15,"tuple","","Operations on tuples",null,null],[11,"overflowing_add","","",178,null],[11,"overflowing_sub","","",178,null],[11,"overflowing_mul","","",178,null],[11,"overflowing_div","","",178,null],[11,"overflowing_rem","","",178,null],[11,"overflowing_shl","","",178,null],[11,"overflowing_shr","","",178,null],[11,"overflowing_add","","",179,null],[11,"overflowing_sub","","",179,null],[11,"overflowing_mul","","",179,null],[11,"overflowing_div","","",179,null],[11,"overflowing_rem","","",179,null],[11,"overflowing_shl","","",179,null],[11,"overflowing_shr","","",179,null],[11,"overflowing_add","","",180,null],[11,"overflowing_sub","","",180,null],[11,"overflowing_mul","","",180,null],[11,"overflowing_div","","",180,null],[11,"overflowing_rem","","",180,null],[11,"overflowing_shl","","",180,null],[11,"overflowing_shr","","",180,null],[11,"overflowing_add","","",181,null],[11,"overflowing_sub","","",181,null],[11,"overflowing_mul","","",181,null],[11,"overflowing_div","","",181,null],[11,"overflowing_rem","","",181,null],[11,"overflowing_shl","","",181,null],[11,"overflowing_shr","","",181,null],[11,"overflowing_add","","",182,null],[11,"overflowing_sub","","",182,null],[11,"overflowing_mul","","",182,null],[11,"overflowing_div","","",182,null],[11,"overflowing_rem","","",182,null],[11,"overflowing_shl","","",182,null],[11,"overflowing_shr","","",182,null],[11,"overflowing_add","","",183,null],[11,"overflowing_sub","","",183,null],[11,"overflowing_mul","","",183,null],[11,"overflowing_div","","",183,null],[11,"overflowing_rem","","",183,null],[11,"overflowing_shl","","",183,null],[11,"overflowing_shr","","",183,null],[11,"overflowing_add","","",184,null],[11,"overflowing_sub","","",184,null],[11,"overflowing_mul","","",184,null],[11,"overflowing_div","","",184,null],[11,"overflowing_rem","","",184,null],[11,"overflowing_shl","","",184,null],[11,"overflowing_shr","","",184,null],[11,"overflowing_add","","",185,null],[11,"overflowing_sub","","",185,null],[11,"overflowing_mul","","",185,null],[11,"overflowing_div","","",185,null],[11,"overflowing_rem","","",185,null],[11,"overflowing_shl","","",185,null],[11,"overflowing_shr","","",185,null],[11,"overflowing_add","","",186,null],[11,"overflowing_sub","","",186,null],[11,"overflowing_mul","","",186,null],[11,"overflowing_div","","",186,null],[11,"overflowing_rem","","",186,null],[11,"overflowing_shl","","",186,null],[11,"overflowing_shr","","",186,null],[11,"overflowing_add","","",187,null],[11,"overflowing_sub","","",187,null],[11,"overflowing_mul","","",187,null],[11,"overflowing_div","","",187,null],[11,"overflowing_rem","","",187,null],[11,"overflowing_shl","","",187,null],[11,"overflowing_shr","","",187,null],[11,"zero","","",182,null],[11,"one","","",182,null],[11,"zero","","",183,null],[11,"one","","",183,null],[11,"zero","","",184,null],[11,"one","","",184,null],[11,"zero","","",185,null],[11,"one","","",185,null],[11,"zero","","",186,null],[11,"one","","",186,null],[11,"zero","","",178,null],[11,"one","","",178,null],[11,"zero","","",179,null],[11,"one","","",179,null],[11,"zero","","",180,null],[11,"one","","",180,null],[11,"zero","","",181,null],[11,"one","","",181,null],[11,"zero","","",187,null],[11,"one","","",187,null],[11,"zero","","",188,null],[11,"one","","",188,null],[11,"zero","","",189,null],[11,"one","","",189,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",178,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",178,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",178,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",178,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",178,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",178,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",178,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",178,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",178,null],[11,"swap_bytes","","Reverses the byte order of the integer.",178,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",178,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",178,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",178,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",178,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",178,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",178,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",178,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",178,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",178,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",178,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",178,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",178,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",178,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",178,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",178,null],[11,"signum","","Returns a number representing sign of `self`.",178,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",178,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",178,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",179,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",179,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",179,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",179,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",179,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",179,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",179,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",179,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",179,null],[11,"swap_bytes","","Reverses the byte order of the integer.",179,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",179,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",179,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",179,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",179,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",179,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",179,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",179,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",179,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",179,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",179,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",179,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",179,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",179,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",179,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",179,null],[11,"signum","","Returns a number representing sign of `self`.",179,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",179,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",179,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",180,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",180,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",180,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",180,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",180,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",180,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",180,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",180,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",180,null],[11,"swap_bytes","","Reverses the byte order of the integer.",180,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",180,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",180,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",180,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",180,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",180,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",180,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",180,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",180,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",180,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",180,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",180,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",180,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",180,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",180,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",180,null],[11,"signum","","Returns a number representing sign of `self`.",180,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",180,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",180,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",181,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",181,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",181,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",181,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",181,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",181,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",181,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",181,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",181,null],[11,"swap_bytes","","Reverses the byte order of the integer.",181,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",181,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",181,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",181,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",181,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",181,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",181,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",181,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",181,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",181,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",181,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",181,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",181,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",181,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",181,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",181,null],[11,"signum","","Returns a number representing sign of `self`.",181,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",181,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",181,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",187,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",187,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",187,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",187,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",187,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",187,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",187,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",187,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",187,null],[11,"swap_bytes","","Reverses the byte order of the integer.",187,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",187,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",187,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",187,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",187,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",187,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",187,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",187,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",187,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",187,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",187,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",187,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",187,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",187,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",187,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",187,null],[11,"signum","","Returns a number representing sign of `self`.",187,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",187,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",187,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",182,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",182,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",182,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",182,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",182,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",182,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",182,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",182,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",182,null],[11,"swap_bytes","","Reverses the byte order of the integer.",182,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",182,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",182,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",182,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",182,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",182,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",182,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",182,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",182,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",182,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",182,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",182,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",182,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",182,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",182,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",182,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",182,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",182,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",183,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",183,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",183,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",183,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",183,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",183,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",183,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",183,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",183,null],[11,"swap_bytes","","Reverses the byte order of the integer.",183,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",183,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",183,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",183,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",183,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",183,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",183,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",183,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",183,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",183,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",183,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",183,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",183,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",183,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",183,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",183,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",183,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",183,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",184,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",184,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",184,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",184,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",184,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",184,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",184,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",184,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",184,null],[11,"swap_bytes","","Reverses the byte order of the integer.",184,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",184,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",184,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",184,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",184,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",184,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",184,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",184,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",184,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",184,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",184,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",184,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",184,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",184,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",184,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",184,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",184,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",184,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",185,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",185,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",185,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",185,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",185,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",185,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",185,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",185,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",185,null],[11,"swap_bytes","","Reverses the byte order of the integer.",185,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",185,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",185,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",185,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",185,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",185,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",185,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",185,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",185,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",185,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",185,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",185,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",185,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",185,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",185,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",185,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",185,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",185,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",186,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",186,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",186,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",186,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",186,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",186,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",186,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",186,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",186,null],[11,"swap_bytes","","Reverses the byte order of the integer.",186,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",186,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",186,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",186,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",186,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",186,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",186,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",186,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",186,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",186,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",186,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",186,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",186,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",186,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",186,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",186,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",186,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",186,null],[11,"from_str","","Converts a string in base 10 to a float.\nAccepts an optional decimal exponent.",188,null],[11,"from_str","","Converts a string in base 10 to a float.\nAccepts an optional decimal exponent.",189,null],[11,"from_str","","",187,null],[11,"from_str","","",178,null],[11,"from_str","","",179,null],[11,"from_str","","",180,null],[11,"from_str","","",181,null],[11,"from_str","","",186,null],[11,"from_str","","",182,null],[11,"from_str","","",183,null],[11,"from_str","","",184,null],[11,"from_str","","",185,null],[11,"is_null","","Returns true if the pointer is null.",190,null],[11,"as_ref","","Returns `None` if the pointer is null, or else returns a reference to\nthe value wrapped in `Some`.",190,null],[11,"offset","","Calculates the offset from a pointer. `count` is in units of T; e.g. a\n`count` of 3 represents a pointer offset of `3 * sizeof::<T>()` bytes.",190,null],[11,"is_null","","Returns true if the pointer is null.",190,null],[11,"as_ref","","Returns `None` if the pointer is null, or else returns a reference to\nthe value wrapped in `Some`.",190,null],[11,"offset","","Calculates the offset from a pointer. `count` is in units of T; e.g. a\n`count` of 3 represents a pointer offset of `3 * sizeof::<T>()` bytes.",190,null],[11,"as_mut","","Returns `None` if the pointer is null, or else returns a mutable\nreference to the value wrapped in `Some`.",190,null],[11,"eq","","",190,null],[11,"eq","","",190,null],[11,"clone","","",190,null],[11,"clone","","",190,null],[11,"cmp","","",190,null],[11,"partial_cmp","","",190,null],[11,"lt","","",190,null],[11,"le","","",190,null],[11,"gt","","",190,null],[11,"ge","","",190,null],[11,"cmp","","",190,null],[11,"partial_cmp","","",190,null],[11,"lt","","",190,null],[11,"le","","",190,null],[11,"gt","","",190,null],[11,"ge","","",190,null],[11,"add","","",186,null],[11,"add","","",186,null],[11,"add","","",186,null],[11,"add","","",186,null],[11,"add","","",182,null],[11,"add","","",182,null],[11,"add","","",182,null],[11,"add","","",182,null],[11,"add","","",183,null],[11,"add","","",183,null],[11,"add","","",183,null],[11,"add","","",183,null],[11,"add","","",184,null],[11,"add","","",184,null],[11,"add","","",184,null],[11,"add","","",184,null],[11,"add","","",185,null],[11,"add","","",185,null],[11,"add","","",185,null],[11,"add","","",185,null],[11,"add","","",187,null],[11,"add","","",187,null],[11,"add","","",187,null],[11,"add","","",187,null],[11,"add","","",178,null],[11,"add","","",178,null],[11,"add","","",178,null],[11,"add","","",178,null],[11,"add","","",179,null],[11,"add","","",179,null],[11,"add","","",179,null],[11,"add","","",179,null],[11,"add","","",180,null],[11,"add","","",180,null],[11,"add","","",180,null],[11,"add","","",180,null],[11,"add","","",181,null],[11,"add","","",181,null],[11,"add","","",181,null],[11,"add","","",181,null],[11,"add","","",188,null],[11,"add","","",188,null],[11,"add","","",188,null],[11,"add","","",188,null],[11,"add","","",189,null],[11,"add","","",189,null],[11,"add","","",189,null],[11,"add","","",189,null],[11,"sub","","",186,null],[11,"sub","","",186,null],[11,"sub","","",186,null],[11,"sub","","",186,null],[11,"sub","","",182,null],[11,"sub","","",182,null],[11,"sub","","",182,null],[11,"sub","","",182,null],[11,"sub","","",183,null],[11,"sub","","",183,null],[11,"sub","","",183,null],[11,"sub","","",183,null],[11,"sub","","",184,null],[11,"sub","","",184,null],[11,"sub","","",184,null],[11,"sub","","",184,null],[11,"sub","","",185,null],[11,"sub","","",185,null],[11,"sub","","",185,null],[11,"sub","","",185,null],[11,"sub","","",187,null],[11,"sub","","",187,null],[11,"sub","","",187,null],[11,"sub","","",187,null],[11,"sub","","",178,null],[11,"sub","","",178,null],[11,"sub","","",178,null],[11,"sub","","",178,null],[11,"sub","","",179,null],[11,"sub","","",179,null],[11,"sub","","",179,null],[11,"sub","","",179,null],[11,"sub","","",180,null],[11,"sub","","",180,null],[11,"sub","","",180,null],[11,"sub","","",180,null],[11,"sub","","",181,null],[11,"sub","","",181,null],[11,"sub","","",181,null],[11,"sub","","",181,null],[11,"sub","","",188,null],[11,"sub","","",188,null],[11,"sub","","",188,null],[11,"sub","","",188,null],[11,"sub","","",189,null],[11,"sub","","",189,null],[11,"sub","","",189,null],[11,"sub","","",189,null],[11,"mul","","",186,null],[11,"mul","","",186,null],[11,"mul","","",186,null],[11,"mul","","",186,null],[11,"mul","","",182,null],[11,"mul","","",182,null],[11,"mul","","",182,null],[11,"mul","","",182,null],[11,"mul","","",183,null],[11,"mul","","",183,null],[11,"mul","","",183,null],[11,"mul","","",183,null],[11,"mul","","",184,null],[11,"mul","","",184,null],[11,"mul","","",184,null],[11,"mul","","",184,null],[11,"mul","","",185,null],[11,"mul","","",185,null],[11,"mul","","",185,null],[11,"mul","","",185,null],[11,"mul","","",187,null],[11,"mul","","",187,null],[11,"mul","","",187,null],[11,"mul","","",187,null],[11,"mul","","",178,null],[11,"mul","","",178,null],[11,"mul","","",178,null],[11,"mul","","",178,null],[11,"mul","","",179,null],[11,"mul","","",179,null],[11,"mul","","",179,null],[11,"mul","","",179,null],[11,"mul","","",180,null],[11,"mul","","",180,null],[11,"mul","","",180,null],[11,"mul","","",180,null],[11,"mul","","",181,null],[11,"mul","","",181,null],[11,"mul","","",181,null],[11,"mul","","",181,null],[11,"mul","","",188,null],[11,"mul","","",188,null],[11,"mul","","",188,null],[11,"mul","","",188,null],[11,"mul","","",189,null],[11,"mul","","",189,null],[11,"mul","","",189,null],[11,"mul","","",189,null],[11,"div","","",186,null],[11,"div","","",186,null],[11,"div","","",186,null],[11,"div","","",186,null],[11,"div","","",182,null],[11,"div","","",182,null],[11,"div","","",182,null],[11,"div","","",182,null],[11,"div","","",183,null],[11,"div","","",183,null],[11,"div","","",183,null],[11,"div","","",183,null],[11,"div","","",184,null],[11,"div","","",184,null],[11,"div","","",184,null],[11,"div","","",184,null],[11,"div","","",185,null],[11,"div","","",185,null],[11,"div","","",185,null],[11,"div","","",185,null],[11,"div","","",187,null],[11,"div","","",187,null],[11,"div","","",187,null],[11,"div","","",187,null],[11,"div","","",178,null],[11,"div","","",178,null],[11,"div","","",178,null],[11,"div","","",178,null],[11,"div","","",179,null],[11,"div","","",179,null],[11,"div","","",179,null],[11,"div","","",179,null],[11,"div","","",180,null],[11,"div","","",180,null],[11,"div","","",180,null],[11,"div","","",180,null],[11,"div","","",181,null],[11,"div","","",181,null],[11,"div","","",181,null],[11,"div","","",181,null],[11,"div","","",188,null],[11,"div","","",188,null],[11,"div","","",188,null],[11,"div","","",188,null],[11,"div","","",189,null],[11,"div","","",189,null],[11,"div","","",189,null],[11,"div","","",189,null],[11,"rem","","",186,null],[11,"rem","","",186,null],[11,"rem","","",186,null],[11,"rem","","",186,null],[11,"rem","","",182,null],[11,"rem","","",182,null],[11,"rem","","",182,null],[11,"rem","","",182,null],[11,"rem","","",183,null],[11,"rem","","",183,null],[11,"rem","","",183,null],[11,"rem","","",183,null],[11,"rem","","",184,null],[11,"rem","","",184,null],[11,"rem","","",184,null],[11,"rem","","",184,null],[11,"rem","","",185,null],[11,"rem","","",185,null],[11,"rem","","",185,null],[11,"rem","","",185,null],[11,"rem","","",187,null],[11,"rem","","",187,null],[11,"rem","","",187,null],[11,"rem","","",187,null],[11,"rem","","",178,null],[11,"rem","","",178,null],[11,"rem","","",178,null],[11,"rem","","",178,null],[11,"rem","","",179,null],[11,"rem","","",179,null],[11,"rem","","",179,null],[11,"rem","","",179,null],[11,"rem","","",180,null],[11,"rem","","",180,null],[11,"rem","","",180,null],[11,"rem","","",180,null],[11,"rem","","",181,null],[11,"rem","","",181,null],[11,"rem","","",181,null],[11,"rem","","",181,null],[11,"rem","","",188,null],[11,"rem","","",188,null],[11,"rem","","",188,null],[11,"rem","","",188,null],[11,"rem","","",189,null],[11,"rem","","",189,null],[11,"rem","","",189,null],[11,"rem","","",189,null],[11,"neg","","",187,null],[11,"neg","","",187,null],[11,"neg","","",178,null],[11,"neg","","",178,null],[11,"neg","","",179,null],[11,"neg","","",179,null],[11,"neg","","",180,null],[11,"neg","","",180,null],[11,"neg","","",181,null],[11,"neg","","",181,null],[11,"neg","","",188,null],[11,"neg","","",188,null],[11,"neg","","",189,null],[11,"neg","","",189,null],[11,"not","","",191,null],[11,"not","","",191,null],[11,"not","","",186,null],[11,"not","","",186,null],[11,"not","","",182,null],[11,"not","","",182,null],[11,"not","","",183,null],[11,"not","","",183,null],[11,"not","","",184,null],[11,"not","","",184,null],[11,"not","","",185,null],[11,"not","","",185,null],[11,"not","","",187,null],[11,"not","","",187,null],[11,"not","","",178,null],[11,"not","","",178,null],[11,"not","","",179,null],[11,"not","","",179,null],[11,"not","","",180,null],[11,"not","","",180,null],[11,"not","","",181,null],[11,"not","","",181,null],[11,"bitand","","",191,null],[11,"bitand","","",191,null],[11,"bitand","","",191,null],[11,"bitand","","",191,null],[11,"bitand","","",186,null],[11,"bitand","","",186,null],[11,"bitand","","",186,null],[11,"bitand","","",186,null],[11,"bitand","","",182,null],[11,"bitand","","",182,null],[11,"bitand","","",182,null],[11,"bitand","","",182,null],[11,"bitand","","",183,null],[11,"bitand","","",183,null],[11,"bitand","","",183,null],[11,"bitand","","",183,null],[11,"bitand","","",184,null],[11,"bitand","","",184,null],[11,"bitand","","",184,null],[11,"bitand","","",184,null],[11,"bitand","","",185,null],[11,"bitand","","",185,null],[11,"bitand","","",185,null],[11,"bitand","","",185,null],[11,"bitand","","",187,null],[11,"bitand","","",187,null],[11,"bitand","","",187,null],[11,"bitand","","",187,null],[11,"bitand","","",178,null],[11,"bitand","","",178,null],[11,"bitand","","",178,null],[11,"bitand","","",178,null],[11,"bitand","","",179,null],[11,"bitand","","",179,null],[11,"bitand","","",179,null],[11,"bitand","","",179,null],[11,"bitand","","",180,null],[11,"bitand","","",180,null],[11,"bitand","","",180,null],[11,"bitand","","",180,null],[11,"bitand","","",181,null],[11,"bitand","","",181,null],[11,"bitand","","",181,null],[11,"bitand","","",181,null],[11,"bitor","","",191,null],[11,"bitor","","",191,null],[11,"bitor","","",191,null],[11,"bitor","","",191,null],[11,"bitor","","",186,null],[11,"bitor","","",186,null],[11,"bitor","","",186,null],[11,"bitor","","",186,null],[11,"bitor","","",182,null],[11,"bitor","","",182,null],[11,"bitor","","",182,null],[11,"bitor","","",182,null],[11,"bitor","","",183,null],[11,"bitor","","",183,null],[11,"bitor","","",183,null],[11,"bitor","","",183,null],[11,"bitor","","",184,null],[11,"bitor","","",184,null],[11,"bitor","","",184,null],[11,"bitor","","",184,null],[11,"bitor","","",185,null],[11,"bitor","","",185,null],[11,"bitor","","",185,null],[11,"bitor","","",185,null],[11,"bitor","","",187,null],[11,"bitor","","",187,null],[11,"bitor","","",187,null],[11,"bitor","","",187,null],[11,"bitor","","",178,null],[11,"bitor","","",178,null],[11,"bitor","","",178,null],[11,"bitor","","",178,null],[11,"bitor","","",179,null],[11,"bitor","","",179,null],[11,"bitor","","",179,null],[11,"bitor","","",179,null],[11,"bitor","","",180,null],[11,"bitor","","",180,null],[11,"bitor","","",180,null],[11,"bitor","","",180,null],[11,"bitor","","",181,null],[11,"bitor","","",181,null],[11,"bitor","","",181,null],[11,"bitor","","",181,null],[11,"bitxor","","",191,null],[11,"bitxor","","",191,null],[11,"bitxor","","",191,null],[11,"bitxor","","",191,null],[11,"bitxor","","",186,null],[11,"bitxor","","",186,null],[11,"bitxor","","",186,null],[11,"bitxor","","",186,null],[11,"bitxor","","",182,null],[11,"bitxor","","",182,null],[11,"bitxor","","",182,null],[11,"bitxor","","",182,null],[11,"bitxor","","",183,null],[11,"bitxor","","",183,null],[11,"bitxor","","",183,null],[11,"bitxor","","",183,null],[11,"bitxor","","",184,null],[11,"bitxor","","",184,null],[11,"bitxor","","",184,null],[11,"bitxor","","",184,null],[11,"bitxor","","",185,null],[11,"bitxor","","",185,null],[11,"bitxor","","",185,null],[11,"bitxor","","",185,null],[11,"bitxor","","",187,null],[11,"bitxor","","",187,null],[11,"bitxor","","",187,null],[11,"bitxor","","",187,null],[11,"bitxor","","",178,null],[11,"bitxor","","",178,null],[11,"bitxor","","",178,null],[11,"bitxor","","",178,null],[11,"bitxor","","",179,null],[11,"bitxor","","",179,null],[11,"bitxor","","",179,null],[11,"bitxor","","",179,null],[11,"bitxor","","",180,null],[11,"bitxor","","",180,null],[11,"bitxor","","",180,null],[11,"bitxor","","",180,null],[11,"bitxor","","",181,null],[11,"bitxor","","",181,null],[11,"bitxor","","",181,null],[11,"bitxor","","",181,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",182,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",183,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",184,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",185,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",186,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",178,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",179,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",180,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",181,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shl","","",187,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",182,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",183,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",184,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",185,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",186,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",178,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",179,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",180,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",181,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"shr","","",187,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"eq","","",191,null],[11,"ne","","",191,null],[11,"eq","","",193,null],[11,"ne","","",193,null],[11,"eq","","",186,null],[11,"ne","","",186,null],[11,"eq","","",182,null],[11,"ne","","",182,null],[11,"eq","","",183,null],[11,"ne","","",183,null],[11,"eq","","",184,null],[11,"ne","","",184,null],[11,"eq","","",185,null],[11,"ne","","",185,null],[11,"eq","","",187,null],[11,"ne","","",187,null],[11,"eq","","",178,null],[11,"ne","","",178,null],[11,"eq","","",179,null],[11,"ne","","",179,null],[11,"eq","","",180,null],[11,"ne","","",180,null],[11,"eq","","",181,null],[11,"ne","","",181,null],[11,"eq","","",188,null],[11,"ne","","",188,null],[11,"eq","","",189,null],[11,"ne","","",189,null],[11,"partial_cmp","","",192,null],[11,"partial_cmp","","",191,null],[11,"partial_cmp","","",193,null],[11,"lt","","",193,null],[11,"le","","",193,null],[11,"ge","","",193,null],[11,"gt","","",193,null],[11,"partial_cmp","","",186,null],[11,"lt","","",186,null],[11,"le","","",186,null],[11,"ge","","",186,null],[11,"gt","","",186,null],[11,"partial_cmp","","",182,null],[11,"lt","","",182,null],[11,"le","","",182,null],[11,"ge","","",182,null],[11,"gt","","",182,null],[11,"partial_cmp","","",183,null],[11,"lt","","",183,null],[11,"le","","",183,null],[11,"ge","","",183,null],[11,"gt","","",183,null],[11,"partial_cmp","","",184,null],[11,"lt","","",184,null],[11,"le","","",184,null],[11,"ge","","",184,null],[11,"gt","","",184,null],[11,"partial_cmp","","",185,null],[11,"lt","","",185,null],[11,"le","","",185,null],[11,"ge","","",185,null],[11,"gt","","",185,null],[11,"partial_cmp","","",187,null],[11,"lt","","",187,null],[11,"le","","",187,null],[11,"ge","","",187,null],[11,"gt","","",187,null],[11,"partial_cmp","","",178,null],[11,"lt","","",178,null],[11,"le","","",178,null],[11,"ge","","",178,null],[11,"gt","","",178,null],[11,"partial_cmp","","",179,null],[11,"lt","","",179,null],[11,"le","","",179,null],[11,"ge","","",179,null],[11,"gt","","",179,null],[11,"partial_cmp","","",180,null],[11,"lt","","",180,null],[11,"le","","",180,null],[11,"ge","","",180,null],[11,"gt","","",180,null],[11,"partial_cmp","","",181,null],[11,"lt","","",181,null],[11,"le","","",181,null],[11,"ge","","",181,null],[11,"gt","","",181,null],[11,"partial_cmp","","",188,null],[11,"lt","","",188,null],[11,"le","","",188,null],[11,"ge","","",188,null],[11,"gt","","",188,null],[11,"partial_cmp","","",189,null],[11,"lt","","",189,null],[11,"le","","",189,null],[11,"ge","","",189,null],[11,"gt","","",189,null],[11,"cmp","","",192,null],[11,"cmp","","",191,null],[11,"cmp","","",193,null],[11,"cmp","","",186,null],[11,"cmp","","",182,null],[11,"cmp","","",183,null],[11,"cmp","","",184,null],[11,"cmp","","",185,null],[11,"cmp","","",187,null],[11,"cmp","","",178,null],[11,"cmp","","",179,null],[11,"cmp","","",180,null],[11,"cmp","","",181,null],[11,"clone","","Returns a deep copy of the value.",187,null],[11,"clone","","Returns a deep copy of the value.",178,null],[11,"clone","","Returns a deep copy of the value.",179,null],[11,"clone","","Returns a deep copy of the value.",180,null],[11,"clone","","Returns a deep copy of the value.",181,null],[11,"clone","","Returns a deep copy of the value.",186,null],[11,"clone","","Returns a deep copy of the value.",182,null],[11,"clone","","Returns a deep copy of the value.",183,null],[11,"clone","","Returns a deep copy of the value.",184,null],[11,"clone","","Returns a deep copy of the value.",185,null],[11,"clone","","Returns a deep copy of the value.",188,null],[11,"clone","","Returns a deep copy of the value.",189,null],[11,"clone","","Returns a deep copy of the value.",192,null],[11,"clone","","Returns a deep copy of the value.",191,null],[11,"clone","","Returns a deep copy of the value.",193,null],[11,"default","","",192,null],[11,"default","","",191,null],[11,"default","","",193,null],[11,"default","","",186,null],[11,"default","","",182,null],[11,"default","","",183,null],[11,"default","","",184,null],[11,"default","","",185,null],[11,"default","","",187,null],[11,"default","","",178,null],[11,"default","","",179,null],[11,"default","","",180,null],[11,"default","","",181,null],[11,"default","","",188,null],[11,"default","","",189,null],[11,"as_ref","","",194,null],[11,"as_mut","","",194,null],[11,"as_ref","","",195,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"as_slice","","",196,null],[11,"as_mut_slice","","",196,null],[11,"as_ref","","",196,null],[11,"as_mut","","",196,null],[11,"clone","","",196,null],[11,"hash","","",196,null],[11,"fmt","","",196,null],[11,"into_iter","","",196,null],[11,"into_iter","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"eq","","",196,null],[11,"ne","","",196,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"partial_cmp","","",196,null],[11,"lt","","",196,null],[11,"le","","",196,null],[11,"ge","","",196,null],[11,"gt","","",196,null],[11,"cmp","","",196,null],[11,"step","","",186,null],[11,"steps_between","","",186,null],[11,"step","","",182,null],[11,"steps_between","","",182,null],[11,"step","","",183,null],[11,"steps_between","","",183,null],[11,"step","","",184,null],[11,"steps_between","","",184,null],[11,"step","","",187,null],[11,"steps_between","","",187,null],[11,"step","","",178,null],[11,"steps_between","","",178,null],[11,"step","","",179,null],[11,"steps_between","","",179,null],[11,"step","","",180,null],[11,"steps_between","","",180,null],[11,"step","","",185,null],[11,"steps_between","","",185,null],[11,"step","","",181,null],[11,"steps_between","","",181,null],[11,"set_memory","","",194,null],[11,"index","","",194,null],[11,"index_mut","","",194,null],[11,"index","","",194,null],[11,"index","","",194,null],[11,"index","","",194,null],[11,"index","","",194,null],[11,"index_mut","","",194,null],[11,"index_mut","","",194,null],[11,"index_mut","","",194,null],[11,"index_mut","","",194,null],[11,"default","","",194,null],[11,"into_iter","","",194,null],[11,"into_iter","","",194,null],[11,"eq","","",194,null],[11,"ne","","",194,null],[11,"cmp","","",194,null],[11,"partial_cmp","","",194,null],[11,"lt","","",194,null],[11,"le","","",194,null],[11,"ge","","",194,null],[11,"gt","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"as_unsigned","","",194,null],[11,"as_signed","","",194,null],[11,"as_unsigned_mut","","",194,null],[11,"as_signed_mut","","",194,null],[11,"into_searcher","","",195,null],[11,"into_searcher","","",193,null],[11,"is_contained_in","","",193,null],[11,"is_prefix_of","","",193,null],[11,"is_suffix_of","","",193,null],[11,"into_searcher","","",194,null],[11,"is_contained_in","","",194,null],[11,"is_prefix_of","","",194,null],[11,"is_suffix_of","","",194,null],[11,"cmp","","",195,null],[11,"eq","","",195,null],[11,"ne","","",195,null],[11,"partial_cmp","","",195,null],[11,"index","","",195,null],[11,"index","","",195,null],[11,"index","","",195,null],[11,"index","","",195,null],[11,"from_str","","Parse a `bool` from a string.",191,null],[11,"as_ref","","",195,null],[11,"default","","",195,null],[11,"hash","","",182,null],[11,"hash_slice","","",182,null],[11,"hash","","",183,null],[11,"hash_slice","","",183,null],[11,"hash","","",184,null],[11,"hash_slice","","",184,null],[11,"hash","","",185,null],[11,"hash_slice","","",185,null],[11,"hash","","",186,null],[11,"hash_slice","","",186,null],[11,"hash","","",178,null],[11,"hash_slice","","",178,null],[11,"hash","","",179,null],[11,"hash_slice","","",179,null],[11,"hash","","",180,null],[11,"hash_slice","","",180,null],[11,"hash","","",181,null],[11,"hash_slice","","",181,null],[11,"hash","","",187,null],[11,"hash_slice","","",187,null],[11,"hash","","",191,null],[11,"hash","","",193,null],[11,"hash","","",195,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",192,null],[11,"hash","","",194,null],[11,"hash","","",190,null],[11,"hash","","",190,null],[11,"fmt","","",187,null],[11,"fmt","","",187,null],[11,"fmt","","",187,null],[11,"fmt","","",187,null],[11,"fmt","","",187,null],[11,"fmt","","",187,null],[11,"fmt","","",186,null],[11,"fmt","","",186,null],[11,"fmt","","",186,null],[11,"fmt","","",186,null],[11,"fmt","","",186,null],[11,"fmt","","",186,null],[11,"fmt","","",178,null],[11,"fmt","","",178,null],[11,"fmt","","",178,null],[11,"fmt","","",178,null],[11,"fmt","","",178,null],[11,"fmt","","",178,null],[11,"fmt","","",182,null],[11,"fmt","","",182,null],[11,"fmt","","",182,null],[11,"fmt","","",182,null],[11,"fmt","","",182,null],[11,"fmt","","",182,null],[11,"fmt","","",179,null],[11,"fmt","","",179,null],[11,"fmt","","",179,null],[11,"fmt","","",179,null],[11,"fmt","","",179,null],[11,"fmt","","",179,null],[11,"fmt","","",183,null],[11,"fmt","","",183,null],[11,"fmt","","",183,null],[11,"fmt","","",183,null],[11,"fmt","","",183,null],[11,"fmt","","",183,null],[11,"fmt","","",180,null],[11,"fmt","","",180,null],[11,"fmt","","",180,null],[11,"fmt","","",180,null],[11,"fmt","","",180,null],[11,"fmt","","",180,null],[11,"fmt","","",184,null],[11,"fmt","","",184,null],[11,"fmt","","",184,null],[11,"fmt","","",184,null],[11,"fmt","","",184,null],[11,"fmt","","",184,null],[11,"fmt","","",181,null],[11,"fmt","","",181,null],[11,"fmt","","",181,null],[11,"fmt","","",181,null],[11,"fmt","","",181,null],[11,"fmt","","",181,null],[11,"fmt","","",185,null],[11,"fmt","","",185,null],[11,"fmt","","",185,null],[11,"fmt","","",185,null],[11,"fmt","","",185,null],[11,"fmt","","",185,null],[11,"fmt","","",191,null],[11,"fmt","","",191,null],[11,"fmt","","",195,null],[11,"fmt","","",195,null],[11,"fmt","","",193,null],[11,"fmt","","",193,null],[11,"fmt","","",190,null],[11,"fmt","","",190,null],[11,"fmt","","",188,null],[11,"fmt","","",188,null],[11,"fmt","","",188,null],[11,"fmt","","",188,null],[11,"fmt","","",189,null],[11,"fmt","","",189,null],[11,"fmt","","",189,null],[11,"fmt","","",189,null],[11,"fmt","","",190,null],[11,"fmt","","",190,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",192,null],[11,"fmt","","",194,null],[11,"fmt","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null],[11,"clone","","",192,null],[11,"eq","","",192,null],[11,"ne","","",192,null],[11,"partial_cmp","","",192,null],[11,"lt","","",192,null],[11,"le","","",192,null],[11,"ge","","",192,null],[11,"gt","","",192,null],[11,"cmp","","",192,null],[11,"default","","",192,null]],"paths":[[3,"ParseFloatError"],[4,"FpCategory"],[4,"FloatErrorKind"],[8,"OverflowingOps"],[3,"Wrapping"],[8,"Zero"],[8,"One"],[3,"ParseIntError"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"Managed"],[3,"PhantomData"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[8,"Drop"],[8,"Add"],[8,"Sub"],[8,"Mul"],[8,"Div"],[8,"Rem"],[8,"Neg"],[8,"Not"],[8,"BitAnd"],[8,"BitOr"],[8,"BitXor"],[8,"Shl"],[8,"Shr"],[8,"Index"],[8,"IndexMut"],[8,"Deref"],[8,"DerefMut"],[8,"Fn"],[8,"FnMut"],[8,"FnOnce"],[3,"RangeFull"],[4,"Ordering"],[8,"PartialEq"],[8,"Ord"],[8,"PartialOrd"],[8,"Clone"],[8,"Default"],[8,"AsRef"],[8,"AsMut"],[8,"Into"],[8,"From"],[8,"Any"],[3,"TypeId"],[8,"FixedSizeArray"],[4,"Ordering"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[3,"AtomicPtr"],[3,"UnsafeCell"],[4,"BorrowState"],[3,"Cell"],[3,"RefCell"],[3,"Ref"],[3,"RefMut"],[3,"EscapeUnicode"],[3,"EscapeDefault"],[3,"Scan"],[3,"Unfold"],[4,"MinMaxResult"],[8,"Iterator"],[8,"FromIterator"],[8,"IntoIterator"],[8,"Extend"],[8,"DoubleEndedIterator"],[8,"RandomAccessIterator"],[8,"ExactSizeIterator"],[8,"Step"],[3,"Rev"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[4,"Option"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[8,"Repr"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[8,"MutableByteVector"],[8,"IntSliceExt"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[3,"CharRange"],[4,"SearchStep"],[8,"Pattern"],[8,"Searcher"],[8,"ReverseSearcher"],[3,"StrSearcher"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[8,"FromStr"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"SipHasher"],[8,"Hash"],[8,"Hasher"],[3,"Radix"],[3,"RadixFmt"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[8,"Write"],[8,"Debug"],[8,"Display"],[8,"Octal"],[8,"Binary"],[8,"LowerHex"],[8,"UpperHex"],[8,"Pointer"],[8,"LowerExp"],[8,"UpperExp"],[3,"Error"],[3,"Arguments"],[3,"Formatter"],[15,"i8"],[15,"i16"],[15,"i32"],[15,"i64"],[15,"u8"],[15,"u16"],[15,"u32"],[15,"u64"],[15,"usize"],[15,"isize"],[15,"f32"],[15,"f64"],[15,"pointer"],[15,"bool"],[15,"tuple"],[15,"char"],[15,"slice"],[15,"str"],[15,"array"]]};
searchIndex['std'] = {"items":[[0,"","std","# The Rust Standard Library",null,null],[0,"any","","Traits for dynamic typing of any `'static` type (through runtime reflection)",null,null],[8,"Any","std::any","A type to emulate dynamic typing.",null,null],[10,"get_type_id","","Gets the `TypeId` of `self`.",0,{"inputs":[{"name":"any"}],"output":{"name":"typeid"}}],[11,"of","core::any","Returns the `TypeId` of the type this generic function has been\ninstantiated with",1,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"fmt","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shl","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"shr","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"add","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"sub","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"mul","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"not","core::num","",2,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitxor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitor","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","std::any","",null,null],[11,"bitand","core::num","",2,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"fmt","","",3,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",3,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",3,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[6,"Err","std::any","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[11,"eq","core::num","",4,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",4,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",5,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"interrorkind"}],"output":{"name":"interrorkind"}}],[11,"fmt","","",5,{"inputs":[{"name":"interrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",4,{"inputs":[{"name":"parseinterror"}],"output":{"name":"str"}}],[11,"fmt","","",4,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",7,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",7,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",7,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",7,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",6,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"str"}}],[11,"fmt","","",6,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","core::nonzero","",8,null],[11,"fmt","","",8,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",8,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[6,"Target","std::any","",null,null],[11,"deref","core::nonzero","",8,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[11,"new","core::ptr","Creates a new `Unique`.",9,null],[11,"get","","Dereferences the content.",9,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",9,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[6,"Target","std::any","",null,null],[11,"deref","core::ptr","",9,null],[11,"fmt","","",9,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","core::marker","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",10,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",10,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"cmp","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"option"}}],[11,"lt","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"le","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"gt","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ge","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"eq","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"managed"}],"output":{"name":"managed"}}],[11,"hash","","",12,null],[11,"eq","","",12,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",12,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",12,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",12,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[6,"Output","std::any","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"eq","core::ops","",13,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",13,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",14,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",15,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",16,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",16,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",16,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",16,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","std::any","",null,null],[6,"Target","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"fmt","core::cmp","",17,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",17,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",17,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",17,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",17,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[11,"fmt","std","",0,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",0,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",0,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",0,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",1,null],[11,"fmt","","",1,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[6,"Item","std::any","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"default","core::atomic","",18,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",19,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",20,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"clone","","",21,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",18,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",18,null],[11,"swap","","Stores a value into the bool, returning the old value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the bool if the current value is the same as the expected value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",19,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",19,null],[11,"swap","","Stores a value into the isize, returning the old value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the isize if the current value is the same as the expected value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",20,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",20,null],[11,"swap","","Stores a value into the usize, returning the old value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the usize if the current value is the same as the expected value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",22,null],[11,"load","","Loads a value from the pointer.",22,null],[11,"store","","Stores a value into the pointer.",22,null],[11,"swap","","Stores a value into the pointer, returning the old value.",22,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the expected value.",22,null],[11,"new","core::cell","Creates a new `Cell` containing the given value.",23,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",23,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",23,null],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",23,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",23,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",23,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",23,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",24,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",24,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",25,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",25,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",25,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",25,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",25,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"drop","","",26,null],[11,"clone","","",26,{"inputs":[{"name":"borrowref"}],"output":{"name":"borrowref"}}],[6,"Target","std::any","",null,null],[11,"deref","core::cell","",27,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"drop","","",28,null],[6,"Target","std::any","",null,null],[11,"deref","core::cell","",29,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",29,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",30,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",30,null],[11,"into_inner","","Unwraps the value.",30,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"clone","core::char","",31,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"clone","","",32,{"inputs":[{"name":"escapeunicodestate"}],"output":{"name":"escapeunicodestate"}}],[6,"Item","std::any","",null,null],[11,"next","core::char","",31,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",33,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"clone","","",34,{"inputs":[{"name":"escapedefaultstate"}],"output":{"name":"escapedefaultstate"}}],[6,"Item","std::any","",null,null],[11,"next","core::char","",33,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"clone","core::iter","",35,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",35,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",35,null],[11,"next_back","","",35,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",35,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",35,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",36,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",36,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",37,null],[11,"next_back","","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",37,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",38,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",38,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",38,null],[11,"indexable","","",38,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",38,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",39,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",39,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",39,null],[11,"next_back","","",39,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",39,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",39,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",40,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",40,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",40,null],[11,"next_back","","",40,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",40,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",40,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",41,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",41,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",41,null],[11,"next_back","","",41,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",41,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",41,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",42,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",42,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",42,null],[11,"next_back","","",42,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",43,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",43,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",43,null],[11,"next_back","","",43,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",44,null],[11,"next_back","","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",44,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",45,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",45,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",45,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",45,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",45,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",46,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",46,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",46,null],[11,"clone","","",47,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",47,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",47,null],[11,"clone","","",48,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",48,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",48,null],[11,"indexable","","",48,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",48,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",49,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",49,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"size_hint","","",49,null],[11,"indexable","","",49,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",49,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",50,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",50,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",50,null],[11,"clone","","",51,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",51,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",51,null],[11,"next_back","","",51,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"size_hint","","",52,null],[11,"next_back","","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",52,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",52,null],[11,"clone","","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",53,null],[11,"next_back","","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",53,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",54,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",54,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",54,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",54,null],[11,"clone","","",55,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",15,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",14,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",55,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",55,null],[11,"clone","","",56,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",56,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",56,null],[11,"next_back","","",56,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",55,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::ops","",14,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",14,null],[11,"next_back","","",14,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::ops","",15,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[6,"Item","std::any","",null,null],[11,"next","core::iter","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",57,null],[11,"next_back","","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",57,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"hash","core::option","",58,null],[11,"fmt","","",58,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",58,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",58,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",58,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",58,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",58,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",58,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value or returns a default.",58,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value or computes a default.",58,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",58,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",58,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",58,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",58,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",58,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","core::option","Returns a consuming iterator over the possibly contained value.",58,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"clone","","",59,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[6,"Item","std::any","",null,null],[11,"next","core::option","",59,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"size_hint","","",59,null],[11,"next_back","","",59,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::option","",60,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",60,null],[11,"next_back","","",60,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",60,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::any","",null,null],[11,"next","core::option","",61,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",61,null],[11,"next_back","","",61,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::option","",62,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"next_back","","",62,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",58,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[11,"clone","core::raw","",63,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",64,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[11,"hash","core::result","",65,null],[11,"fmt","","",65,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",65,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",65,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",65,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",65,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",65,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",65,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",65,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",65,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",65,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",65,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",65,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",65,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",65,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",65,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",65,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",65,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[6,"Item","std::any","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","core::result","Returns a consuming iterator over the possibly contained value.",65,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[6,"Item","std::any","",null,null],[11,"next","core::result","",66,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",66,null],[11,"next_back","","",66,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",66,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::any","",null,null],[11,"next","core::result","",67,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",67,null],[11,"next_back","","",67,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::result","",68,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",68,null],[11,"next_back","","",68,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",65,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[11,"fmt","core::simd","",69,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",69,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",70,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",70,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",71,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",71,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",72,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",72,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",73,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",73,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",74,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",74,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",75,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",75,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",76,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",76,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",77,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",77,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",78,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",78,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[6,"Output","std::any","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"as_slice","core::slice","View the underlying data as a subslice of the original data.",79,null],[6,"Item","std::any","",null,null],[11,"next","core::slice","",79,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",79,null],[11,"next_back","","",79,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",79,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",79,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",79,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",80,null],[6,"Item","std::any","",null,null],[11,"next","core::slice","",80,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",80,null],[11,"next_back","","",80,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",81,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","std::any","",null,null],[11,"next","core::slice","",81,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",81,null],[11,"next_back","","",81,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",81,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",82,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::slice","",82,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",82,null],[11,"next_back","","",82,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::slice","",83,{"inputs":[{"name":"genericsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",83,null],[6,"Item","std::any","",null,null],[11,"next","core::slice","",84,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",84,null],[6,"Item","std::any","",null,null],[11,"next","core::slice","",85,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",85,null],[6,"Item","std::any","",null,null],[11,"next","core::slice","",86,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",86,null],[6,"Item","std::any","",null,null],[11,"next","core::slice","",87,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",87,null],[11,"clone","","",88,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[6,"Item","std::any","",null,null],[11,"next","core::slice","",88,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"next_back","","",88,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",88,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",88,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[6,"Item","std::any","",null,null],[11,"next","core::slice","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"next_back","","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",89,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::slice","",90,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"fmt","core::str::pattern","",91,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",91,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",91,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",91,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"chareqsearcher"}}],[6,"Searcher","std::any","",null,null],[11,"into_searcher","core::str::pattern","",93,{"inputs":[{"name":"chareqpattern"},{"name":"str"}],"output":{"name":"chareqsearcher"}}],[11,"haystack","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"str"}}],[11,"next","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"eq","","",95,{"inputs":[{"name":"state"},{"name":"state"}],"output":{"name":"bool"}}],[11,"ne","","",95,{"inputs":[{"name":"state"},{"name":"state"}],"output":{"name":"bool"}}],[11,"clone","","",95,{"inputs":[{"name":"state"}],"output":{"name":"state"}}],[6,"Searcher","std::any","",null,null],[11,"haystack","core::str::pattern","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[6,"Searcher","std::any","",null,null],[11,"clone","core::str::pattern","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[6,"Searcher","std::any","",null,null],[11,"clone","core::str::pattern","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[6,"Searcher","std::any","",null,null],[6,"Searcher","","",null,null],[6,"Err","","",null,null],[11,"eq","core::str","",99,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",99,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",99,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",100,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",100,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",100,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",100,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",100,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",101,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",101,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",101,null],[11,"next_back","","",101,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",102,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",102,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",102,null],[11,"next_back","","",102,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"clone","","",104,{"inputs":[{"name":"bytesderef"}],"output":{"name":"bytesderef"}}],[11,"call","","",104,null],[11,"call_mut","","",104,null],[6,"Output","std::any","",null,null],[11,"call_once","core::str","",104,null],[6,"Item","std::any","",null,null],[11,"next","core::str","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",103,null],[11,"next_back","","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"clone","","",105,{"inputs":[{"name":"splitinternal"}],"output":{"name":"splitinternal"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",106,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",106,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",107,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",107,{"inputs":[{"name":"rsplit"}],"output":{"name":"rsplit"}}],[11,"next_back","","",106,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",107,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",108,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",108,{"inputs":[{"name":"splitterminator"}],"output":{"name":"splitterminator"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",109,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",109,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"rsplitterminator"}}],[11,"next_back","","",108,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",109,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",110,{"inputs":[{"name":"splitninternal"}],"output":{"name":"splitninternal"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",111,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",111,{"inputs":[{"name":"splitn"}],"output":{"name":"splitn"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",112,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",112,{"inputs":[{"name":"rsplitn"}],"output":{"name":"rsplitn"}}],[11,"clone","","",113,{"inputs":[{"name":"matchindicesinternal"}],"output":{"name":"matchindicesinternal"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",114,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",114,{"inputs":[{"name":"matchindices"}],"output":{"name":"matchindices"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",115,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",115,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"rmatchindices"}}],[11,"next_back","","",114,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",115,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",116,{"inputs":[{"name":"matchesinternal"}],"output":{"name":"matchesinternal"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",117,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",117,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",118,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",118,{"inputs":[{"name":"rmatches"}],"output":{"name":"rmatches"}}],[11,"next_back","","",117,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",118,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",119,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[6,"Item","std::any","",null,null],[11,"next","core::str","",119,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",119,null],[11,"next_back","","",119,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",120,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"clone","","",121,{"inputs":[{"name":"linesanymap"}],"output":{"name":"linesanymap"}}],[11,"call","","",121,null],[11,"call_mut","","",121,null],[6,"Output","std::any","",null,null],[11,"call_once","core::str","",121,null],[6,"Item","std::any","",null,null],[11,"next","core::str","",120,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",120,null],[11,"next_back","","",120,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",122,{"inputs":[{"name":"twowaysearcher"}],"output":{"name":"twowaysearcher"}}],[11,"clone","","",123,{"inputs":[{"name":"oldsearcher"}],"output":{"name":"oldsearcher"}}],[11,"clone","","",124,{"inputs":[{"name":"oldmatchindices"}],"output":{"name":"oldmatchindices"}}],[11,"clone","","",125,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[6,"Output","std::any","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"new","core::hash::sip","Creates a new `SipHasher` with the two initial keys set to 0.",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",126,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",126,null],[11,"finish","","",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"eq","core::fmt::num","",127,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"binary"}],"output":{"name":"binary"}}],[11,"eq","","",128,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"ne","","",128,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"clone","","",128,{"inputs":[{"name":"octal"}],"output":{"name":"octal"}}],[11,"eq","","",129,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"clone","","",129,{"inputs":[{"name":"decimal"}],"output":{"name":"decimal"}}],[11,"eq","","",130,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"ne","","",130,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"clone","","",130,{"inputs":[{"name":"lowerhex"}],"output":{"name":"lowerhex"}}],[11,"eq","","",131,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"ne","","",131,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"clone","","",131,{"inputs":[{"name":"upperhex"}],"output":{"name":"upperhex"}}],[11,"eq","","",132,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",132,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",132,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",133,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","core::fmt::builders","",134,{"inputs":[{"name":"padadapter"},{"name":"str"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",135,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Consumes the `DebugStruct`, finishing output and returning any error\nencountered.",135,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",136,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Consumes the `DebugTuple`, finishing output and returning any error\nencountered.",136,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"finish","","",137,null],[11,"entry","","Adds a new entry to the set output.",138,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",138,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the set output.",139,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",139,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",140,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"finish","","Consumes the `DebugMap`, finishing output and returning any error\nencountered.",140,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[11,"clone","core::fmt::rt::v1","",141,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clone","","",142,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",143,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",143,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",143,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"clone","","",144,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[11,"clone","","",145,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"fmt","core::fmt","",146,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",146,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",147,{"inputs":[{"name":"flagv1"}],"output":{"name":"flagv1"}}],[11,"clone","","",148,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",148,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",148,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pad_integral","","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",149,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",149,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",149,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",149,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",149,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",149,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",149,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",149,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",149,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",149,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",149,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",149,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",149,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",149,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"fmt","","",146,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",12,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",23,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",25,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",27,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",29,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"TypeId","std::any","A `TypeId` represents a globally unique identifier for a type.",null,null],[0,"cell","std","Shareable mutable containers.",null,null],[3,"Cell","std::cell","A mutable memory location that admits only `Copy` data.",null,null],[3,"RefCell","","A mutable memory location with dynamically checked borrow rules",null,null],[4,"BorrowState","","An enumeration of values returned from the `state` method on a `RefCell<T>`.",null,null],[13,"Reading","","The cell is currently being read, there is at least one active `borrow`.",24,null],[13,"Writing","","The cell is currently being written to, there is an active `borrow_mut`.",24,null],[13,"Unused","","There are no outstanding borrows on this cell.",24,null],[3,"Ref","","Wraps a borrowed reference to a value in a `RefCell` box.\nA wrapper type for an immutably borrowed value from a `RefCell<T>`.",null,null],[5,"clone_ref","","Copies a `Ref`.",null,{"inputs":[{"name":"ref"}],"output":{"name":"ref"}}],[3,"RefMut","","A wrapper type for a mutably borrowed value from a `RefCell<T>`.",null,null],[3,"UnsafeCell","","The core primitive for interior mutability in Rust.",null,null],[12,"value","","Wrapped value",30,null],[0,"clone","std","The `Clone` trait for types that cannot be 'implicitly copied'",null,null],[8,"Clone","std::clone","A common trait for cloning an object.",null,null],[10,"clone","","Returns a copy of the value.",150,{"inputs":[{"name":"clone"}],"output":{"name":"self"}}],[11,"clone_from","","Performs copy-assignment from `source`.",150,null],[0,"cmp","std","Functionality for ordering and comparison.",null,null],[8,"PartialEq","std::cmp","Trait for equality comparisons which are [partial equivalence relations](\nhttp://en.wikipedia.org/wiki/Partial_equivalence_relation).",null,null],[10,"eq","","This method tests for `self` and `other` values to be equal, and is used by `==`.",151,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ne","","This method tests for `!=`.",151,{"inputs":[{"name":"partialeq"},{"name":"rhs"}],"output":{"name":"bool"}}],[8,"Eq","","Trait for equality comparisons which are [equivalence relations](\nhttps://en.wikipedia.org/wiki/Equivalence_relation).",null,null],[4,"Ordering","","An `Ordering` is the result of a comparison between two values.",null,null],[13,"Less","","An ordering where a compared value is less [than another].",17,null],[13,"Equal","","An ordering where a compared value is equal [to another].",17,null],[13,"Greater","","An ordering where a compared value is greater [than another].",17,null],[8,"Ord","","Trait for types that form a [total order](https://en.wikipedia.org/wiki/Total_order).",null,null],[10,"cmp","","This method returns an `Ordering` between `self` and `other`.",152,{"inputs":[{"name":"ord"},{"name":"self"}],"output":{"name":"ordering"}}],[8,"PartialOrd","","Trait for values that can be compared for a sort-order.",null,null],[10,"partial_cmp","","This method returns an ordering between `self` and `other` values if one exists.",153,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"option"}}],[11,"lt","","This method tests less than (for `self` and `other`) and is used by the `<` operator.",153,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"le","","This method tests less than or equal to (for `self` and `other`) and is used by the `<=`\noperator.",153,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"gt","","This method tests greater than (for `self` and `other`) and is used by the `>` operator.",153,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[11,"ge","","This method tests greater than or equal to (for `self` and `other`) and is used by the `>=`\noperator.",153,{"inputs":[{"name":"partialord"},{"name":"rhs"}],"output":{"name":"bool"}}],[5,"min","","Compare and return the minimum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"max","","Compare and return the maximum of two values.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"partial_min","","Compare and return the minimum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[5,"partial_max","","Compare and return the maximum of two values if there is one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"option"}}],[0,"convert","std","Traits for conversions between types.",null,null],[8,"AsRef","std::convert","A cheap, reference-to-reference conversion.",null,null],[10,"as_ref","","Performs the conversion.",154,{"inputs":[{"name":"asref"}],"output":{"name":"t"}}],[8,"AsMut","","A cheap, mutable reference-to-mutable reference conversion.",null,null],[10,"as_mut","","Performs the conversion.",155,{"inputs":[{"name":"asmut"}],"output":{"name":"t"}}],[8,"Into","","A conversion that consumes `self`, which may or may not be expensive.",null,null],[10,"into","","Performs the conversion.",156,{"inputs":[{"name":"into"}],"output":{"name":"t"}}],[8,"From","","Construct `Self` via a conversion.",null,null],[10,"from","","Performs the conversion.",157,{"inputs":[{"name":"from"},{"name":"t"}],"output":{"name":"self"}}],[0,"default","std","The `Default` trait for types which may have meaningful default values.",null,null],[8,"Default","std::default","A trait that types which have a useful default value should implement.",null,null],[10,"default","","Returns the \"default value\" for a type.",158,{"inputs":[{"name":"default"}],"output":{"name":"self"}}],[0,"hash","std","Generic hashing support.",null,null],[8,"Hash","std::hash","A hashable type.",null,null],[10,"hash","","Feeds this value into the state given, updating the hasher as necessary.",159,null],[11,"hash_slice","","Feeds a slice of this type into the state provided.",159,null],[8,"Hasher","","A trait which represents the ability to hash an arbitrary stream of bytes.",null,null],[10,"finish","","Completes a round of hashing, producing the output hash generated.",160,{"inputs":[{"name":"hasher"}],"output":{"name":"u64"}}],[10,"write","","Writes some data into this `Hasher`",160,null],[11,"write_u8","","Write a single `u8` into this hasher",160,null],[11,"write_u16","","Write a single `u16` into this hasher.",160,null],[11,"write_u32","","Write a single `u32` into this hasher.",160,null],[11,"write_u64","","Write a single `u64` into this hasher.",160,null],[11,"write_usize","","Write a single `usize` into this hasher.",160,null],[11,"write_i8","","Write a single `i8` into this hasher.",160,null],[11,"write_i16","","Write a single `i16` into this hasher.",160,null],[11,"write_i32","","Write a single `i32` into this hasher.",160,null],[11,"write_i64","","Write a single `i64` into this hasher.",160,null],[11,"write_isize","","Write a single `isize` into this hasher.",160,null],[5,"hash","","Hash a value with the default SipHasher algorithm (two initial keys of 0).",null,{"inputs":[{"name":"t"}],"output":{"name":"u64"}}],[3,"SipHasher","","An implementation of SipHash 2-4.",null,null],[0,"intrinsics","std","rustc compiler intrinsics.",null,null],[5,"atomic_cxchg","std::intrinsics","",null,null],[5,"atomic_cxchg_acq","","",null,null],[5,"atomic_cxchg_rel","","",null,null],[5,"atomic_cxchg_acqrel","","",null,null],[5,"atomic_cxchg_relaxed","","",null,null],[5,"atomic_load","","",null,null],[5,"atomic_load_acq","","",null,null],[5,"atomic_load_relaxed","","",null,null],[5,"atomic_load_unordered","","",null,null],[5,"atomic_store","","",null,null],[5,"atomic_store_rel","","",null,null],[5,"atomic_store_relaxed","","",null,null],[5,"atomic_store_unordered","","",null,null],[5,"atomic_xchg","","",null,null],[5,"atomic_xchg_acq","","",null,null],[5,"atomic_xchg_rel","","",null,null],[5,"atomic_xchg_acqrel","","",null,null],[5,"atomic_xchg_relaxed","","",null,null],[5,"atomic_xadd","","",null,null],[5,"atomic_xadd_acq","","",null,null],[5,"atomic_xadd_rel","","",null,null],[5,"atomic_xadd_acqrel","","",null,null],[5,"atomic_xadd_relaxed","","",null,null],[5,"atomic_xsub","","",null,null],[5,"atomic_xsub_acq","","",null,null],[5,"atomic_xsub_rel","","",null,null],[5,"atomic_xsub_acqrel","","",null,null],[5,"atomic_xsub_relaxed","","",null,null],[5,"atomic_and","","",null,null],[5,"atomic_and_acq","","",null,null],[5,"atomic_and_rel","","",null,null],[5,"atomic_and_acqrel","","",null,null],[5,"atomic_and_relaxed","","",null,null],[5,"atomic_nand","","",null,null],[5,"atomic_nand_acq","","",null,null],[5,"atomic_nand_rel","","",null,null],[5,"atomic_nand_acqrel","","",null,null],[5,"atomic_nand_relaxed","","",null,null],[5,"atomic_or","","",null,null],[5,"atomic_or_acq","","",null,null],[5,"atomic_or_rel","","",null,null],[5,"atomic_or_acqrel","","",null,null],[5,"atomic_or_relaxed","","",null,null],[5,"atomic_xor","","",null,null],[5,"atomic_xor_acq","","",null,null],[5,"atomic_xor_rel","","",null,null],[5,"atomic_xor_acqrel","","",null,null],[5,"atomic_xor_relaxed","","",null,null],[5,"atomic_max","","",null,null],[5,"atomic_max_acq","","",null,null],[5,"atomic_max_rel","","",null,null],[5,"atomic_max_acqrel","","",null,null],[5,"atomic_max_relaxed","","",null,null],[5,"atomic_min","","",null,null],[5,"atomic_min_acq","","",null,null],[5,"atomic_min_rel","","",null,null],[5,"atomic_min_acqrel","","",null,null],[5,"atomic_min_relaxed","","",null,null],[5,"atomic_umin","","",null,null],[5,"atomic_umin_acq","","",null,null],[5,"atomic_umin_rel","","",null,null],[5,"atomic_umin_acqrel","","",null,null],[5,"atomic_umin_relaxed","","",null,null],[5,"atomic_umax","","",null,null],[5,"atomic_umax_acq","","",null,null],[5,"atomic_umax_rel","","",null,null],[5,"atomic_umax_acqrel","","",null,null],[5,"atomic_umax_relaxed","","",null,null],[5,"atomic_fence","","",null,null],[5,"atomic_fence_acq","","",null,null],[5,"atomic_fence_rel","","",null,null],[5,"atomic_fence_acqrel","","",null,null],[5,"abort","","Aborts the execution of the process.",null,null],[5,"unreachable","","Tells LLVM that this point in the code is not reachable,\nenabling further optimizations.",null,null],[5,"assume","","Informs the optimizer that a condition is always true.\nIf the condition is false, the behavior is undefined.",null,null],[5,"breakpoint","","Executes a breakpoint trap, for inspection by a debugger.",null,null],[5,"size_of","","The size of a type in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"move_val_init","","Moves a value to an uninitialized memory location.",null,null],[5,"min_align_of","","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"pref_align_of","","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"type_name","","Gets a static string slice containing the name of a type.",null,{"inputs":[],"output":{"name":"str"}}],[5,"type_id","","Gets an identifier which is globally unique to the specified type. This\nfunction will return the same value for a type regardless of whichever\ncrate it is invoked in.",null,{"inputs":[],"output":{"name":"u64"}}],[5,"init_dropped","","Creates a value initialized to so that its drop flag,\nif any, says that it has been dropped.",null,{"inputs":[],"output":{"name":"t"}}],[5,"init","","Creates a value initialized to zero.",null,{"inputs":[],"output":{"name":"t"}}],[5,"uninit","","Creates an uninitialized value.",null,{"inputs":[],"output":{"name":"t"}}],[5,"forget","","Moves a value out of scope without running drop glue.",null,null],[5,"transmute","","Unsafely transforms a value of one type into a value of another type.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[5,"return_address","","Gives the address for the return value of the enclosing function.",null,null],[5,"needs_drop","","Returns `true` if the actual type given as `T` requires drop\nglue; returns `false` if the actual type provided for `T`\nimplements `Copy`.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"owns_managed","","Returns `true` if a type is managed (will be allocated on the local heap)",null,{"inputs":[],"output":{"name":"bool"}}],[5,"offset","","Calculates the offset from a pointer. The offset *must* be in-bounds of\nthe object, or one-byte-past-the-end. An arithmetic overflow is also\nundefined behaviour.",null,null],[5,"copy_nonoverlapping","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may *not* overlap.",null,null],[5,"copy","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may overlap.",null,null],[5,"write_bytes","","Invokes memset on the specified pointer, setting `count * size_of::<T>()`\nbytes of memory starting at `dst` to `c`.",null,null],[5,"volatile_copy_nonoverlapping_memory","","Equivalent to the appropriate `llvm.memcpy.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_copy_memory","","Equivalent to the appropriate `llvm.memmove.p0i8.0i8.*` intrinsic, with\na size of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`",null,null],[5,"volatile_set_memory","","Equivalent to the appropriate `llvm.memset.p0i8.*` intrinsic, with a\nsize of `count` * `size_of::<T>()` and an alignment of\n`min_align_of::<T>()`.",null,null],[5,"volatile_load","","Perform a volatile load from the `src` pointer.",null,null],[5,"volatile_store","","Perform a volatile store to the `dst` pointer.",null,null],[5,"sqrtf32","","Returns the square root of an `f32`",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"sqrtf64","","Returns the square root of an `f64`",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"powif32","","Raises an `f32` to an integer power.",null,{"inputs":[{"name":"f32"},{"name":"i32"}],"output":{"name":"f32"}}],[5,"powif64","","Raises an `f64` to an integer power.",null,{"inputs":[{"name":"f64"},{"name":"i32"}],"output":{"name":"f64"}}],[5,"sinf32","","Returns the sine of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"sinf64","","Returns the sine of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"cosf32","","Returns the cosine of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"cosf64","","Returns the cosine of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"powf32","","Raises an `f32` to an `f32` power.",null,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[5,"powf64","","Raises an `f64` to an `f64` power.",null,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[5,"expf32","","Returns the exponential of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"expf64","","Returns the exponential of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"exp2f32","","Returns 2 raised to the power of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"exp2f64","","Returns 2 raised to the power of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"logf32","","Returns the natural logarithm of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"logf64","","Returns the natural logarithm of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"log10f32","","Returns the base 10 logarithm of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"log10f64","","Returns the base 10 logarithm of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"log2f32","","Returns the base 2 logarithm of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"log2f64","","Returns the base 2 logarithm of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"fmaf32","","Returns `a * b + c` for `f32` values.",null,{"inputs":[{"name":"f32"},{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[5,"fmaf64","","Returns `a * b + c` for `f64` values.",null,{"inputs":[{"name":"f64"},{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[5,"fabsf32","","Returns the absolute value of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"fabsf64","","Returns the absolute value of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"copysignf32","","Copies the sign from `y` to `x` for `f32` values.",null,{"inputs":[{"name":"f32"},{"name":"f32"}],"output":{"name":"f32"}}],[5,"copysignf64","","Copies the sign from `y` to `x` for `f64` values.",null,{"inputs":[{"name":"f64"},{"name":"f64"}],"output":{"name":"f64"}}],[5,"floorf32","","Returns the largest integer less than or equal to an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"floorf64","","Returns the largest integer less than or equal to an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"ceilf32","","Returns the smallest integer greater than or equal to an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"ceilf64","","Returns the smallest integer greater than or equal to an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"truncf32","","Returns the integer part of an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"truncf64","","Returns the integer part of an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"rintf32","","Returns the nearest integer to an `f32`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"rintf64","","Returns the nearest integer to an `f64`. May raise an inexact floating-point exception\nif the argument is not an integer.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"nearbyintf32","","Returns the nearest integer to an `f32`.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"nearbyintf64","","Returns the nearest integer to an `f64`.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"roundf32","","Returns the nearest integer to an `f32`. Rounds half-way cases away from zero.",null,{"inputs":[{"name":"f32"}],"output":{"name":"f32"}}],[5,"roundf64","","Returns the nearest integer to an `f64`. Rounds half-way cases away from zero.",null,{"inputs":[{"name":"f64"}],"output":{"name":"f64"}}],[5,"ctpop8","","Returns the number of bits set in a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[5,"ctpop16","","Returns the number of bits set in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"ctpop32","","Returns the number of bits set in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"ctpop64","","Returns the number of bits set in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"ctlz8","","Returns the number of leading bits unset in a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[5,"ctlz16","","Returns the number of leading bits unset in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"ctlz32","","Returns the number of leading bits unset in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"ctlz64","","Returns the number of leading bits unset in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"cttz8","","Returns the number of trailing bits unset in a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"u8"}}],[5,"cttz16","","Returns the number of trailing bits unset in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"cttz32","","Returns the number of trailing bits unset in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"cttz64","","Returns the number of trailing bits unset in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"bswap16","","Reverses the bytes in a `u16`.",null,{"inputs":[{"name":"u16"}],"output":{"name":"u16"}}],[5,"bswap32","","Reverses the bytes in a `u32`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"u32"}}],[5,"bswap64","","Reverses the bytes in a `u64`.",null,{"inputs":[{"name":"u64"}],"output":{"name":"u64"}}],[5,"i8_add_with_overflow","","Performs checked `i8` addition.",null,null],[5,"i16_add_with_overflow","","Performs checked `i16` addition.",null,null],[5,"i32_add_with_overflow","","Performs checked `i32` addition.",null,null],[5,"i64_add_with_overflow","","Performs checked `i64` addition.",null,null],[5,"u8_add_with_overflow","","Performs checked `u8` addition.",null,null],[5,"u16_add_with_overflow","","Performs checked `u16` addition.",null,null],[5,"u32_add_with_overflow","","Performs checked `u32` addition.",null,null],[5,"u64_add_with_overflow","","Performs checked `u64` addition.",null,null],[5,"i8_sub_with_overflow","","Performs checked `i8` subtraction.",null,null],[5,"i16_sub_with_overflow","","Performs checked `i16` subtraction.",null,null],[5,"i32_sub_with_overflow","","Performs checked `i32` subtraction.",null,null],[5,"i64_sub_with_overflow","","Performs checked `i64` subtraction.",null,null],[5,"u8_sub_with_overflow","","Performs checked `u8` subtraction.",null,null],[5,"u16_sub_with_overflow","","Performs checked `u16` subtraction.",null,null],[5,"u32_sub_with_overflow","","Performs checked `u32` subtraction.",null,null],[5,"u64_sub_with_overflow","","Performs checked `u64` subtraction.",null,null],[5,"i8_mul_with_overflow","","Performs checked `i8` multiplication.",null,null],[5,"i16_mul_with_overflow","","Performs checked `i16` multiplication.",null,null],[5,"i32_mul_with_overflow","","Performs checked `i32` multiplication.",null,null],[5,"i64_mul_with_overflow","","Performs checked `i64` multiplication.",null,null],[5,"u8_mul_with_overflow","","Performs checked `u8` multiplication.",null,null],[5,"u16_mul_with_overflow","","Performs checked `u16` multiplication.",null,null],[5,"u32_mul_with_overflow","","Performs checked `u32` multiplication.",null,null],[5,"u64_mul_with_overflow","","Performs checked `u64` multiplication.",null,null],[5,"overflowing_add","","Returns (a + b) mod 2^N, where N is the width of N in bits.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"overflowing_sub","","Returns (a - b) mod 2^N, where N is the width of N in bits.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"overflowing_mul","","Returns (a * b) mod 2^N, where N is the width of N in bits.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"discriminant_value","","Returns the value of the discriminant for the variant in 'v',\ncast to a `u64`; if `T` has no discriminant, returns 0.",null,{"inputs":[{"name":"t"}],"output":{"name":"u64"}}],[0,"iter","std","Composable external iterators",null,null],[8,"Iterator","std::iter","An interface for dealing with \"external iterators\". These types of iterators\ncan be resumed at any time as all state is stored internally as opposed to\nbeing located on the call stack.",null,null],[16,"Item","std::iter::Iterator","The type of the elements being iterated",null,null],[10,"next","std::iter","Advances the iterator and returns the next value. Returns `None` when the\nend is reached.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"size_hint","","Returns a lower and upper bound on the remaining length of the iterator.",161,null],[11,"count","","Counts the number of elements in this iterator.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"usize"}}],[11,"last","","Loops through the entire iterator, returning the last element.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"nth","","Loops through `n` iterations, returning the `n`th element of the\niterator.",161,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"option"}}],[11,"chain","","Chain this iterator with another, returning a new iterator that will\nfinish iterating over the current iterator, and then iterate\nover the other specified iterator.",161,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"chain"}}],[11,"zip","","Creates an iterator that iterates over both this and the specified\niterators simultaneously, yielding the two elements as pairs. When\neither iterator returns `None`, all further invocations of `next()`\nwill return `None`.",161,{"inputs":[{"name":"iterator"},{"name":"u"}],"output":{"name":"zip"}}],[11,"map","","Creates a new iterator that will apply the specified function to each\nelement returned by the first, yielding the mapped element instead.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"map"}}],[11,"filter","","Creates an iterator that applies the predicate to each element returned\nby this iterator. The only elements that will be yielded are those that\nmake the predicate evaluate to `true`.",161,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"filter"}}],[11,"filter_map","","Creates an iterator that both filters and maps elements.\nIf the specified function returns `None`, the element is skipped.\nOtherwise the option is unwrapped and the new value is yielded.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"filtermap"}}],[11,"enumerate","","Creates an iterator that yields pairs `(i, val)` where `i` is the\ncurrent index of iteration and `val` is the value returned by the\niterator.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"enumerate"}}],[11,"peekable","","Creates an iterator that has a `.peek()` method\nthat returns an optional reference to the next element.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"peekable"}}],[11,"skip_while","","Creates an iterator that invokes the predicate on elements\nuntil it returns false. Once the predicate returns false, that\nelement and all further elements are yielded.",161,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"skipwhile"}}],[11,"take_while","","Creates an iterator that yields elements so long as the predicate\nreturns true. After the predicate returns false for the first time, no\nfurther elements will be yielded.",161,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"takewhile"}}],[11,"skip","","Creates an iterator that skips the first `n` elements of this iterator,\nand then yields all further items.",161,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"skip"}}],[11,"take","","Creates an iterator that yields the first `n` elements of this\niterator.",161,{"inputs":[{"name":"iterator"},{"name":"usize"}],"output":{"name":"take"}}],[11,"scan","","Creates a new iterator that behaves in a similar fashion to fold.\nThere is a state which is passed between each iteration and can be\nmutated as necessary. The yielded values from the closure are yielded\nfrom the Scan instance when not `None`.",161,{"inputs":[{"name":"iterator"},{"name":"st"},{"name":"f"}],"output":{"name":"scan"}}],[11,"flat_map","","Creates an iterator that maps each element to an iterator,\nand yields the elements of the produced iterators.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"flatmap"}}],[11,"fuse","","Creates an iterator that yields `None` forever after the underlying\niterator yields `None`. Random-access iterator behavior is not\naffected, only single and double-ended iterator behavior.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"fuse"}}],[11,"inspect","","Creates an iterator that calls a function with a reference to each\nelement before yielding it. This is often useful for debugging an\niterator pipeline.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"inspect"}}],[11,"by_ref","","Creates a wrapper around a mutable reference to the iterator.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"self"}}],[11,"collect","","Loops through the entire iterator, collecting all of the elements into\na container implementing `FromIterator`.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"b"}}],[11,"partition","","Loops through the entire iterator, collecting all of the elements into\none of two containers, depending on a predicate. The elements of the\nfirst container satisfy the predicate, while the elements of the second\ndo not.",161,null],[11,"fold","","Performs a fold operation over the entire iterator, returning the\neventual state at the end of the iteration.",161,{"inputs":[{"name":"iterator"},{"name":"b"},{"name":"f"}],"output":{"name":"b"}}],[11,"all","","Tests whether the predicate holds true for all elements in the iterator.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"any","","Tests whether any element of an iterator satisfies the specified\npredicate.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"bool"}}],[11,"find","","Returns the first element satisfying the specified predicate.",161,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"position","","Returns the index of the first element satisfying the specified predicate",161,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"rposition","","Returns the index of the last element satisfying the specified predicate",161,{"inputs":[{"name":"iterator"},{"name":"p"}],"output":{"name":"option"}}],[11,"max","","Consumes the entire iterator to return the maximum element.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min","","Consumes the entire iterator to return the minimum element.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"option"}}],[11,"min_max","","`min_max` finds the minimum and maximum elements in the iterator.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"minmaxresult"}}],[11,"max_by","","Returns the element that gives the maximum value from the\nspecified function.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"min_by","","Returns the element that gives the minimum value from the\nspecified function.",161,{"inputs":[{"name":"iterator"},{"name":"f"}],"output":{"name":"option"}}],[11,"rev","","Change the direction of the iterator",161,{"inputs":[{"name":"iterator"}],"output":{"name":"rev"}}],[11,"unzip","","Converts an iterator of pairs into a pair of containers.",161,null],[11,"cloned","","Creates an iterator that clones the elements it yields. Useful for\nconverting an Iterator<&T> to an Iterator<T>.",161,{"inputs":[{"name":"iterator"}],"output":{"name":"cloned"}}],[11,"cycle","","Repeats an iterator endlessly",161,{"inputs":[{"name":"iterator"}],"output":{"name":"cycle"}}],[11,"reverse_in_place","","Use an iterator to reverse a container in place.",161,null],[11,"sum","","Iterates over the entire iterator, summing up all the elements",161,{"inputs":[{"name":"iterator"}],"output":{"name":"s"}}],[11,"product","","Iterates over the entire iterator, multiplying all the elements",161,{"inputs":[{"name":"iterator"}],"output":{"name":"p"}}],[8,"FromIterator","","Conversion from an `Iterator`",null,null],[10,"from_iter","","Builds a container with elements from something iterable.",162,{"inputs":[{"name":"fromiterator"},{"name":"t"}],"output":{"name":"self"}}],[8,"IntoIterator","","Conversion into an `Iterator`",null,null],[16,"Item","std::iter::IntoIterator","The type of the elements being iterated",null,null],[16,"IntoIter","","A container for iterating over elements of type `Item`",null,null],[10,"into_iter","std::iter","Consumes `Self` and returns an iterator over it",163,null],[8,"Extend","","A type growable from an `Iterator` implementation",null,null],[10,"extend","","Extends a container with the elements yielded by an arbitrary iterator",164,null],[8,"DoubleEndedIterator","","A range iterator able to yield elements from both ends",null,null],[10,"next_back","","Yields an element from the end of the range, returning `None` if the\nrange is empty.",165,{"inputs":[{"name":"doubleendediterator"}],"output":{"name":"option"}}],[8,"RandomAccessIterator","","An object implementing random access indexing by `usize`",null,null],[10,"indexable","","Returns the number of indexable elements. At most `std::usize::MAX`\nelements are indexable, even if the iterator represents a longer range.",166,{"inputs":[{"name":"randomaccessiterator"}],"output":{"name":"usize"}}],[10,"idx","","Returns an element at an index, or `None` if the index is out of bounds",166,{"inputs":[{"name":"randomaccessiterator"},{"name":"usize"}],"output":{"name":"option"}}],[8,"ExactSizeIterator","","An iterator that knows its exact length",null,null],[11,"len","","Returns the exact length of the iterator.",167,{"inputs":[{"name":"exactsizeiterator"}],"output":{"name":"usize"}}],[3,"Rev","","An double-ended iterator with the direction inverted",null,null],[4,"MinMaxResult","","`MinMaxResult` is an enum returned by `min_max`. See `Iterator::min_max` for\nmore detail.",null,null],[13,"NoElements","","Empty iterator",36,null],[13,"OneElement","","Iterator with one element, so the minimum and maximum are the same",36,null],[13,"MinMax","","More than one element in the iterator, the first element is not larger\nthan the second",36,null],[3,"Cloned","","An iterator that clones the elements of an underlying iterator",null,null],[3,"Cycle","","An iterator that repeats endlessly",null,null],[3,"Chain","","An iterator that strings two iterators together",null,null],[3,"Zip","","An iterator that iterates two other iterators simultaneously",null,null],[3,"Map","","An iterator that maps the values of `iter` with `f`",null,null],[3,"Filter","","An iterator that filters the elements of `iter` with `predicate`",null,null],[3,"FilterMap","","An iterator that uses `f` to both filter and map elements from `iter`",null,null],[3,"Enumerate","","An iterator that yields the current count and the element during iteration",null,null],[3,"Peekable","","An iterator with a `peek()` that returns an optional reference to the next element.",null,null],[3,"SkipWhile","","An iterator that rejects elements while `predicate` is true",null,null],[3,"TakeWhile","","An iterator that only accepts elements while `predicate` is true",null,null],[3,"Skip","","An iterator that skips over `n` elements of `iter`.",null,null],[3,"Take","","An iterator that only iterates over the first `n` iterations of `iter`.",null,null],[3,"Scan","","An iterator to maintain state while iterating another iterator",null,null],[12,"state","","The current internal state to be passed to the closure next.",50,null],[3,"FlatMap","","An iterator that maps each element to an iterator,\nand yields the elements of the produced iterators",null,null],[3,"Fuse","","An iterator that yields `None` forever after the underlying iterator\nyields `None` once.",null,null],[3,"Inspect","","An iterator that calls a function with a reference to each\nelement before yielding it.",null,null],[3,"Unfold","","An iterator that passes mutable state to a closure and yields the result.",null,null],[12,"state","","Internal state that will be passed to the closure on the next iteration",54,null],[8,"Step","","Objects that can be stepped over in both directions.",null,null],[10,"step","","Steps `self` if possible.",168,{"inputs":[{"name":"step"},{"name":"self"}],"output":{"name":"option"}}],[10,"steps_between","","Returns the number of steps between two step objects.",168,{"inputs":[{"name":"step"},{"name":"self"},{"name":"self"},{"name":"self"}],"output":{"name":"option"}}],[3,"StepBy","","An adapter for stepping range iterators by a custom amount.",null,null],[3,"RangeInclusive","","An iterator over the range [start, stop]",null,null],[5,"range_inclusive","","Returns an iterator over the range [start, stop].",null,{"inputs":[{"name":"a"},{"name":"a"}],"output":{"name":"rangeinclusive"}}],[3,"Repeat","","An iterator that repeats an element endlessly",null,null],[6,"Iterate","","",null,null],[5,"iterate","","Creates a new iterator that produces an infinite sequence of\nrepeated applications of the given function `f`.",null,{"inputs":[{"name":"t"},{"name":"f"}],"output":{"name":"unfold"}}],[5,"repeat","","Creates a new iterator that endlessly repeats the element `elt`.",null,{"inputs":[{"name":"t"}],"output":{"name":"repeat"}}],[0,"order","","Functions for lexicographical ordering of sequences.",null,null],[5,"equals","std::iter::order","Compare `a` and `b` for equality using `Eq`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"cmp","","Order `a` and `b` lexicographically using `Ord`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"ordering"}}],[5,"partial_cmp","","Order `a` and `b` lexicographically using `PartialOrd`",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"option"}}],[5,"eq","","Compare `a` and `b` for equality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ne","","Compares `a` and `b` for nonequality (Using partial equality, `PartialEq`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"lt","","Returns `a` < `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"le","","Returns `a` <= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"gt","","Returns `a` > `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[5,"ge","","Returns `a` >= `b` lexicographically (Using partial order, `PartialOrd`)",null,{"inputs":[{"name":"l"},{"name":"r"}],"output":{"name":"bool"}}],[0,"marker","std","Primitive traits and marker types representing basic 'kinds' of types.",null,null],[8,"Send","std::marker","Types able to be transferred across thread boundaries.",null,null],[8,"Sized","","Types with a constant size known at compile-time.",null,null],[8,"Copy","","Types that can be copied by simply copying bits (i.e. `memcpy`).",null,null],[8,"Sync","","Types that can be safely shared between threads when aliased.",null,null],[3,"NoCopy","","A type which is considered \"not POD\", meaning that it is not\nimplicitly copyable. This is typically embedded in other types to\nensure that they are never copied, even if they lack a destructor.",null,null],[3,"Managed","","A type which is considered managed by the GC. This is typically\nembedded in other types.",null,null],[3,"PhantomData","","`PhantomData<T>` allows you to describe that a type acts as if it stores a value of type `T`,\neven though it does not. This allows you to inform the compiler about certain safety properties\nof your code.",null,null],[8,"Reflect","","A marker trait indicates a type that can be reflected over. This\ntrait is implemented for all types. Its purpose is to ensure that\nwhen you write a generic function that will employ reflection,\nthat must be reflected (no pun intended) in the generic bounds of\nthat function. Here is an example:",null,null],[0,"mem","std","Basic functions for dealing with memory",null,null],[5,"forget","std::mem","Leaks a value into the void, consuming ownership and never running its\ndestructor.",null,null],[5,"size_of","","Returns the size of a type in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"size_of_val","","Returns the size of the type that `_val` points to in bytes.",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"min_align_of","","Returns the ABI-required minimum alignment of a type",null,{"inputs":[],"output":{"name":"usize"}}],[5,"min_align_of_val","","Returns the ABI-required minimum alignment of the type of the value that `_val` points to",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"align_of","","Returns the alignment in memory for a type.",null,{"inputs":[],"output":{"name":"usize"}}],[5,"align_of_val","","Returns the alignment of the type of the value that `_val` points to.",null,{"inputs":[{"name":"t"}],"output":{"name":"usize"}}],[5,"zeroed","","Creates a value initialized to zero.",null,{"inputs":[],"output":{"name":"t"}}],[5,"dropped","","Creates a value initialized to an unspecified series of bytes.",null,{"inputs":[],"output":{"name":"t"}}],[5,"uninitialized","","Creates an uninitialized value.",null,{"inputs":[],"output":{"name":"t"}}],[5,"swap","","Swap the values at two mutable locations of the same type, without deinitialising or copying\neither one.",null,null],[5,"replace","","Replaces the value at a mutable location with a new one, returning the old value, without\ndeinitialising or copying either one.",null,{"inputs":[{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[5,"drop","","Disposes of a value.",null,null],[17,"POST_DROP_U8","","",null,null],[17,"POST_DROP_U32","","",null,null],[17,"POST_DROP_U64","","",null,null],[17,"POST_DROP_USIZE","","",null,null],[5,"transmute_copy","","Interprets `src` as `&U`, and then reads `src` without moving the contained\nvalue.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[5,"copy_lifetime","","Transforms lifetime of the second pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[5,"copy_mut_lifetime","","Transforms lifetime of the second mutable pointer to match the first.",null,{"inputs":[{"name":"s"},{"name":"t"}],"output":{"name":"t"}}],[5,"transmute","","Unsafely transforms a value of one type into a value of another type.",null,{"inputs":[{"name":"t"}],"output":{"name":"u"}}],[0,"ops","std","Overloadable operators",null,null],[8,"Drop","std::ops","The `Drop` trait is used to run some code when a value goes out of scope. This\nis sometimes called a 'destructor'.",null,null],[10,"drop","","The `drop` method, called when the value goes out of scope.",169,null],[8,"Add","","The `Add` trait is used to specify the functionality of `+`.",null,null],[16,"Output","std::ops::Add","The resulting type after applying the `+` operator",null,null],[10,"add","std::ops","The method for the `+` operator",170,null],[8,"Sub","","The `Sub` trait is used to specify the functionality of `-`.",null,null],[16,"Output","std::ops::Sub","The resulting type after applying the `-` operator",null,null],[10,"sub","std::ops","The method for the `-` operator",171,null],[8,"Mul","","The `Mul` trait is used to specify the functionality of `*`.",null,null],[16,"Output","std::ops::Mul","The resulting type after applying the `*` operator",null,null],[10,"mul","std::ops","The method for the `*` operator",172,null],[8,"Div","","The `Div` trait is used to specify the functionality of `/`.",null,null],[16,"Output","std::ops::Div","The resulting type after applying the `/` operator",null,null],[10,"div","std::ops","The method for the `/` operator",173,null],[8,"Rem","","The `Rem` trait is used to specify the functionality of `%`.",null,null],[16,"Output","std::ops::Rem","The resulting type after applying the `%` operator",null,null],[10,"rem","std::ops","The method for the `%` operator",174,null],[8,"Neg","","The `Neg` trait is used to specify the functionality of unary `-`.",null,null],[16,"Output","std::ops::Neg","The resulting type after applying the `-` operator",null,null],[10,"neg","std::ops","The method for the unary `-` operator",175,null],[8,"Not","","The `Not` trait is used to specify the functionality of unary `!`.",null,null],[16,"Output","std::ops::Not","The resulting type after applying the `!` operator",null,null],[10,"not","std::ops","The method for the unary `!` operator",176,null],[8,"BitAnd","","The `BitAnd` trait is used to specify the functionality of `&`.",null,null],[16,"Output","std::ops::BitAnd","The resulting type after applying the `&` operator",null,null],[10,"bitand","std::ops","The method for the `&` operator",177,null],[8,"BitOr","","The `BitOr` trait is used to specify the functionality of `|`.",null,null],[16,"Output","std::ops::BitOr","The resulting type after applying the `|` operator",null,null],[10,"bitor","std::ops","The method for the `|` operator",178,null],[8,"BitXor","","The `BitXor` trait is used to specify the functionality of `^`.",null,null],[16,"Output","std::ops::BitXor","The resulting type after applying the `^` operator",null,null],[10,"bitxor","std::ops","The method for the `^` operator",179,null],[8,"Shl","","The `Shl` trait is used to specify the functionality of `<<`.",null,null],[16,"Output","std::ops::Shl","The resulting type after applying the `<<` operator",null,null],[10,"shl","std::ops","The method for the `<<` operator",180,null],[8,"Shr","","The `Shr` trait is used to specify the functionality of `>>`.",null,null],[16,"Output","std::ops::Shr","The resulting type after applying the `>>` operator",null,null],[10,"shr","std::ops","The method for the `>>` operator",181,null],[8,"Index","","The `Index` trait is used to specify the functionality of indexing operations\nlike `arr[idx]` when used in an immutable context.",null,null],[16,"Output","std::ops::Index","The returned type after indexing",null,null],[10,"index","std::ops","The method for the indexing (`Foo[Bar]`) operation",182,null],[8,"IndexMut","","The `IndexMut` trait is used to specify the functionality of indexing\noperations like `arr[idx]`, when used in a mutable context.",null,null],[10,"index_mut","","The method for the indexing (`Foo[Bar]`) operation",183,null],[3,"RangeFull","","An unbounded range.",null,null],[3,"Range","","A (half-open) range which is bounded at both ends.",null,null],[12,"start","","The lower bound of the range (inclusive).",14,null],[12,"end","","The upper bound of the range (exclusive).",14,null],[3,"RangeFrom","","A range which is only bounded below.",null,null],[12,"start","","The lower bound of the range (inclusive).",15,null],[3,"RangeTo","","A range which is only bounded above.",null,null],[12,"end","","The upper bound of the range (exclusive).",16,null],[8,"Deref","","The `Deref` trait is used to specify the functionality of dereferencing\noperations like `*v`.",null,null],[16,"Target","std::ops::Deref","The resulting type after dereferencing",null,null],[10,"deref","std::ops","The method called to dereference a value",184,null],[8,"DerefMut","","The `DerefMut` trait is used to specify the functionality of dereferencing\nmutably like `*v = 1;`",null,null],[10,"deref_mut","","The method called to mutably dereference a value",185,null],[8,"Fn","","A version of the call operator that takes an immutable receiver.",null,null],[10,"call","","This is called when the call operator is used.",186,null],[8,"FnMut","","A version of the call operator that takes a mutable receiver.",null,null],[10,"call_mut","","This is called when the call operator is used.",187,null],[8,"FnOnce","","A version of the call operator that takes a by-value receiver.",null,null],[16,"Output","std::ops::FnOnce","The returned type after the call operator is used.",null,null],[10,"call_once","std::ops","This is called when the call operator is used.",188,null],[0,"ptr","std","Operations on unsafe pointers, `*const T`, and `*mut T`.",null,null],[5,"null","std::ptr","Creates a null raw pointer.",null,null],[5,"null_mut","","Creates a null mutable raw pointer.",null,null],[5,"swap","","Swaps the values at two mutable locations of the same type, without\ndeinitialising either. They may overlap, unlike `mem::swap` which is\notherwise equivalent.",null,null],[5,"replace","","Replaces the value at `dest` with `src`, returning the old\nvalue, without dropping either.",null,null],[5,"read","","Reads the value from `src` without moving it. This leaves the\nmemory in `src` unchanged.",null,null],[5,"read_and_zero","","Reads the value from `src` and nulls it out without dropping it.",null,null],[5,"read_and_drop","","Variant of read_and_zero that writes the specific drop-flag byte\n(which may be more appropriate than zero).",null,null],[5,"write","","Overwrites a memory location with the given value without reading or\ndropping the old value.",null,null],[3,"Unique","","A wrapper around a raw `*mut T` that indicates that the possessor\nof this wrapper owns the referent. This in turn implies that the\n`Unique<T>` is `Send`/`Sync` if `T` is `Send`/`Sync`, unlike a raw\n`*mut T` (which conveys no particular ownership semantics).  It\nalso implies that the referent of the pointer should not be\nmodified without a unique path to the `Unique` reference. Useful\nfor building abstractions like `Vec<T>` or `Box<T>`, which\ninternally use raw pointers to manage the memory that they own.",null,null],[5,"copy_nonoverlapping","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may *not* overlap.",null,null],[5,"copy","","Copies `count * size_of<T>` bytes from `src` to `dst`. The source\nand destination may overlap.",null,null],[5,"write_bytes","","Invokes memset on the specified pointer, setting `count * size_of::<T>()`\nbytes of memory starting at `dst` to `c`.",null,null],[0,"raw","std","Contains struct definitions for the layout of compiler built-in types.",null,null],[3,"Slice","std::raw","The representation of a slice like `&[T]`.",null,null],[12,"data","","",63,null],[12,"len","","",63,null],[3,"TraitObject","","The representation of a trait object like `&SomeTrait`.",null,null],[12,"data","","",64,null],[12,"vtable","","",64,null],[8,"Repr","","This trait is meant to map equivalences between raw structs and their\ncorresponding rust values.",null,null],[11,"repr","","This function \"unwraps\" a rust value (without consuming it) into its raw\nstruct representation. This can be used to read/write different values\nfor the struct. This is a safe method because by default it does not\nenable write-access to the fields of the return value in safe code.",189,{"inputs":[{"name":"repr"}],"output":{"name":"t"}}],[0,"simd","std","SIMD vectors.",null,null],[3,"i8x16","std::simd","",null,null],[3,"i16x8","","",null,null],[3,"i32x4","","",null,null],[3,"i64x2","","",null,null],[3,"u8x16","","",null,null],[3,"u16x8","","",null,null],[3,"u32x4","","",null,null],[3,"u64x2","","",null,null],[3,"f32x4","","",null,null],[3,"f64x2","","",null,null],[0,"result","std","Error handling with the `Result` type",null,null],[4,"Result","std::result","`Result` is a type that represents either success (`Ok`) or failure (`Err`).",null,null],[13,"Ok","","Contains the success value",65,null],[13,"Err","","Contains the error value",65,null],[3,"Iter","","An iterator over a reference to the `Ok` variant of a `Result`.",null,null],[3,"IterMut","","An iterator over a mutable reference to the `Ok` variant of a `Result`.",null,null],[3,"IntoIter","","An iterator over the value in a `Ok` variant of a `Result`.",null,null],[5,"fold","","Performs a fold operation over the result values from an iterator.",null,{"inputs":[{"name":"iter"},{"name":"v"},{"name":"f"}],"output":{"name":"result"}}],[0,"option","std","Optional values",null,null],[4,"Option","std::option","The `Option` type. See [the module level documentation](../index.html) for more.",null,null],[13,"None","","No value",58,null],[13,"Some","","Some value `T`",58,null],[3,"Iter","","An iterator over a reference of the contained item in an Option.",null,null],[3,"IterMut","","An iterator over a mutable reference of the contained item in an Option.",null,null],[3,"IntoIter","","An iterator over the item contained inside an Option.",null,null],[0,"boxed","std","A pointer type for heap allocation.",null,null],[7,"HEAP","std::boxed","A value that represents the heap. This is the default place that the `box`\nkeyword allocates into when no place is supplied.",null,null],[11,"new","alloc::boxed","Allocates memory on the heap and then moves `x` into it.",190,{"inputs":[{"name":"box"},{"name":"t"}],"output":{"name":"box"}}],[11,"from_raw","","Constructs a box from the raw pointer.",190,null],[11,"downcast","","Attempt to downcast the box to a concrete type.",190,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",190,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"default","","",190,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"default","","",190,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone","","Returns a new box with a `clone()` of this box's contents.",190,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone_from","","Copies `source`'s contents into `self` without creating a new allocation.",190,null],[11,"eq","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ne","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"option"}}],[11,"lt","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"le","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ge","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"gt","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"cmp","","",190,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"ordering"}}],[11,"hash","","",190,null],[11,"fmt","","",190,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",190,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",190,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","std::boxed","",null,null],[11,"deref","alloc::boxed","",190,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"deref_mut","","",190,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[6,"Item","std::boxed","",null,null],[11,"next","alloc::boxed","",190,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"size_hint","","",190,null],[11,"next_back","","",190,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[6,"Output","std::boxed","",null,null],[6,"Output","","",null,null],[11,"call_once","alloc::boxed","",190,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[6,"Output","std::boxed","",null,null],[11,"call_once","alloc::boxed","",190,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"fmt","alloc::arc","",191,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Constructs a new `Arc<T>`.",192,{"inputs":[{"name":"arc"},{"name":"t"}],"output":{"name":"arc"}}],[11,"downgrade","","Downgrades the `Arc<T>` to a `Weak<T>` reference.",192,{"inputs":[{"name":"arc"}],"output":{"name":"weak"}}],[11,"clone","","Makes a clone of the `Arc<T>`.",192,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[6,"Target","std::boxed","",null,null],[11,"deref","alloc::arc","",192,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"make_unique","","Make a mutable reference from the given `Arc<T>`.",192,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Arc<T>`.",192,null],[11,"upgrade","","Upgrades a weak reference to a strong reference.",191,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"clone","","Makes a clone of the `Weak<T>`.",191,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"drop","","Drops the `Weak<T>`.",191,null],[11,"eq","","Equality for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Arc<T>`s.",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"cmp","","",192,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"ordering"}}],[11,"fmt","","",192,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",192,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",192,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",192,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"hash","","",192,null],[11,"new","alloc::rc","Constructs a new `Rc<T>`.",193,{"inputs":[{"name":"rc"},{"name":"t"}],"output":{"name":"rc"}}],[11,"downgrade","","Downgrades the `Rc<T>` to a `Weak<T>` reference.",193,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"make_unique","","Make a mutable reference from the given `Rc<T>`.",193,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[6,"Target","std::boxed","",null,null],[11,"deref","alloc::rc","",193,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Rc<T>`.",193,null],[11,"clone","","Makes a clone of the `Rc<T>`.",193,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",193,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"cmp","","Comparison for two `Rc<T>`s.",193,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"hash","","",193,null],[11,"fmt","","",193,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",193,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",193,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",194,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Weak<T>`.",194,null],[11,"clone","","Makes a clone of the `Weak<T>`.",194,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"fmt","","",194,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Box","std::boxed","A pointer type for heap allocation.",null,null],[5,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",null,null],[8,"FnBox","","`FnBox` is a version of the `FnOnce` intended for use with boxed\nclosure objects. The idea is that where one would normally store a\n`Box<FnOnce()>` in a data structure, you should use\n`Box<FnBox()>`. The two traits behave essentially the same, except\nthat a `FnBox` closure can only be called if it is boxed. (Note\nthat `FnBox` may be deprecated in the future if `Box<FnOnce()>`\nclosures become directly usable.)",null,null],[16,"Output","std::boxed::FnBox","",null,null],[10,"call_box","std::boxed","",195,null],[0,"rc","std","Thread-local reference-counted boxes (the `Rc<T>` type).",null,null],[3,"Rc","std::rc","A reference-counted pointer type over an immutable value.",null,null],[5,"weak_count","","Get the number of weak references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"strong_count","","Get the number of strong references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share the\nsame inner value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[5,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"result"}}],[5,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"option"}}],[3,"Weak","","A weak version of `Rc<T>`.",null,null],[0,"borrow","std","A module for working with borrowed data.",null,null],[8,"Borrow","std::borrow","A trait for borrowing data.",null,null],[10,"borrow","","Immutably borrows from an owned value.",196,{"inputs":[{"name":"borrow"}],"output":{"name":"borrowed"}}],[8,"BorrowMut","","A trait for mutably borrowing data.",null,null],[10,"borrow_mut","","Mutably borrows from an owned value.",197,{"inputs":[{"name":"borrowmut"}],"output":{"name":"borrowed"}}],[8,"ToOwned","","A generalization of `Clone` to borrowed data.",null,null],[16,"Owned","std::borrow::ToOwned","",null,null],[10,"to_owned","std::borrow","Creates owned data from borrowed data, usually by cloning.",198,null],[11,"to_mut","collections::borrow","Acquires a mutable reference to the owned form of the data.",199,null],[11,"into_owned","","Extracts the owned data.",199,null],[11,"clone","collections::binary_heap","",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"default","","",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"new","","Creates an empty `BinaryHeap` as a max-heap.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"with_capacity","","Creates an empty `BinaryHeap` with a specific capacity.\nThis preallocates enough memory for `capacity` elements,\nso that the `BinaryHeap` does not have to be reallocated\nuntil it contains at least that many values.",200,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":{"name":"binaryheap"}}],[11,"from_vec","","Creates a `BinaryHeap` from a vector. This is sometimes called\n`heapifying` the vector.",200,{"inputs":[{"name":"binaryheap"},{"name":"vec"}],"output":{"name":"binaryheap"}}],[11,"iter","","Returns an iterator visiting all values in the underlying vector, in\narbitrary order.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"iter"}}],[11,"peek","","Returns the greatest item in the binary heap, or `None` if it is empty.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"capacity","","Returns the number of elements the binary heap can hold without reallocating.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `BinaryHeap`. Does nothing if the capacity is already sufficient.",200,null],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the\n`BinaryHeap`. The collection may reserve more space to avoid frequent reallocations.",200,null],[11,"shrink_to_fit","","Discards as much additional capacity as possible.",200,null],[11,"pop","","Removes the greatest item from the binary heap and returns it, or `None` if it\nis empty.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"push","","Pushes an item onto the binary heap.",200,null],[11,"push_pop","","Pushes an item onto the binary heap, then pops the greatest item off the queue in\nan optimized fashion.",200,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"t"}}],[11,"replace","","Pops the greatest item off the binary heap, then pushes an item onto the queue in\nan optimized fashion. The push is done regardless of whether the binary heap\nwas empty.",200,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"option"}}],[11,"into_vec","","Consumes the `BinaryHeap` and returns the underlying vector\nin arbitrary order.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"into_sorted_vec","","Consumes the `BinaryHeap` and returns a vector in sorted\n(ascending) order.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"len","","Returns the length of the binary heap.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"is_empty","","Checks if the binary heap is empty.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"bool"}}],[11,"drain","","Clears the binary heap, returning an iterator over the removed elements.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"drain"}}],[11,"clear","","Drops all items from the binary heap.",200,null],[11,"clone","","",201,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::binary_heap","",201,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",201,null],[11,"next_back","","",201,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::binary_heap","",202,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",202,null],[11,"next_back","","",202,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::binary_heap","",203,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",203,null],[11,"next_back","","",203,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"from_iter","","",200,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":{"name":"binaryheap"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::binary_heap","Creates a consuming iterator, that is, one that moves each value out of\nthe binary heap in arbitrary order. The binary heap cannot be used\nafter calling this.",200,{"inputs":[{"name":"binaryheap"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::binary_heap","",200,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::bit","",204,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"new","","Creates an empty `BitVec`.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_elem","","Creates a `BitVec` that holds `nbits` elements, setting each element\nto `bit`.",204,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":{"name":"bitvec"}}],[11,"with_capacity","","Constructs a new, empty `BitVec` with the specified capacity.",204,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bitvec"}}],[11,"from_bytes","","Transforms a byte-vector into a `BitVec`. Each byte becomes eight bits,\nwith the most significant bits of each byte coming first. Each\nbit becomes `true` if equal to 1 or `false` if equal to 0.",204,null],[11,"from_fn","","Creates a `BitVec` of the specified length where the value at each index\nis `f(index)`.",204,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"f"}],"output":{"name":"bitvec"}}],[11,"get","","Retrieves the value at index `i`, or `None` if the index is out of bounds.",204,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"option"}}],[11,"set","","Sets the value of a bit at an index `i`.",204,null],[11,"set_all","","Sets all bits to 1.",204,null],[11,"negate","","Flips all bits.",204,null],[11,"union","","Calculates the union of two bitvectors. This acts like the bitwise `or`\nfunction.",204,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"intersect","","Calculates the intersection of two bitvectors. This acts like the\nbitwise `and` function.",204,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"difference","","Calculates the difference between two bitvectors.",204,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"all","","Returns `true` if all bits are 1.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over the elements of the vector in order.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"iter"}}],[11,"none","","Returns `true` if all bits are 0.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"any","","Returns `true` if any bit is 1.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"to_bytes","","Organises the bits into bytes, such that the first bit in the\n`BitVec` becomes the high-order bit of the first byte. If the\nsize of the `BitVec` is not a multiple of eight then trailing bits\nwill be filled-in with `false`.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"vec"}}],[11,"eq_vec","","Compares a `BitVec` to a slice of `bool`s.\nBoth the `BitVec` and slice must have the same length.",204,null],[11,"truncate","","Shortens a `BitVec`, dropping excess elements.",204,null],[11,"reserve","","Reserves capacity for at least `additional` more bits to be inserted in the given\n`BitVec`. The collection may reserve more space to avoid frequent reallocations.",204,null],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bits to be inserted in the\ngiven `BitVec`. Does nothing if the capacity is already sufficient.",204,null],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"grow","","Grows the `BitVec` in-place, adding `n` copies of `value` to the `BitVec`.",204,null],[11,"pop","","Removes the last bit from the BitVec, and returns it. Returns None if the BitVec is empty.",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"option"}}],[11,"push","","Pushes a `bool` onto the end.",204,null],[11,"len","","Returns the total number of bits in this vector",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if there are no bits in this vector",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this vector.",204,null],[11,"default","","",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_iter","","",204,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":{"name":"bitvec"}}],[11,"extend","","",204,null],[11,"clone","","",204,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"clone_from","","",204,null],[11,"partial_cmp","","",204,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"option"}}],[11,"cmp","","",204,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"ordering"}}],[11,"fmt","","",204,{"inputs":[{"name":"bitvec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",204,null],[11,"eq","","",204,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clone","","",205,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",205,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",205,null],[11,"next_back","","",205,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",205,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",205,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"clone","collections::bit","",206,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"default","","",206,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"from_iter","","",206,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":{"name":"bitset"}}],[11,"extend","","",206,null],[11,"partial_cmp","","",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"option"}}],[11,"cmp","","",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"ordering"}}],[11,"eq","","",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"new","","Creates a new empty `BitSet`.",206,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"with_capacity","","Creates a new `BitSet` with initially no contents, able to\nhold `nbits` elements without resizing.",206,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bitset"}}],[11,"from_bit_vec","","Creates a new `BitSet` from the given bit vector.",206,{"inputs":[{"name":"bitset"},{"name":"bitvec"}],"output":{"name":"bitset"}}],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",206,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `BitSet` to contain `len` distinct elements. In the case\nof `BitSet` this means reallocations will not occur as long as all inserted elements\nare less than `len`.",206,null],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `BitSet` to contain `len` distinct elements.\nIn the case of `BitSet` this means reallocations will not occur as long as all inserted\nelements are less than `len`.",206,null],[11,"into_bit_vec","","Consumes this set to return the underlying bit vector.",206,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"get_ref","","Returns a reference to the underlying bit vector.",206,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"shrink_to_fit","","Truncates the underlying vector to the least length required.",206,null],[11,"iter","","Iterator over each usize stored in the `BitSet`.",206,{"inputs":[{"name":"bitset"}],"output":{"name":"setiter"}}],[11,"union","","Iterator over each usize stored in `self` union `other`.\nSee [union_with](#method.union_with) for an efficient in-place version.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"union"}}],[11,"intersection","","Iterator over each usize stored in `self` intersect `other`.\nSee [intersect_with](#method.intersect_with) for an efficient in-place version.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"intersection"}}],[11,"difference","","Iterator over each usize stored in the `self` setminus `other`.\nSee [difference_with](#method.difference_with) for an efficient in-place version.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Iterator over each usize stored in the symmetric difference of `self` and `other`.\nSee [symmetric_difference_with](#method.symmetric_difference_with) for\nan efficient in-place version.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"symmetricdifference"}}],[11,"union_with","","Unions in-place with the specified other bit vector.",206,null],[11,"intersect_with","","Intersects in-place with the specified other bit vector.",206,null],[11,"difference_with","","Makes this bit vector the difference with the specified other bit vector\nin-place.",206,null],[11,"symmetric_difference_with","","Makes this bit vector the symmetric difference with the specified other\nbit vector in-place.",206,null],[11,"len","","Returns the number of set bits in this set.",206,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns whether there are no bits set in this set",206,{"inputs":[{"name":"bitset"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this set",206,null],[11,"contains","","Returns `true` if this set contains the specified integer.",206,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",206,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",206,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",206,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"fmt","","",206,{"inputs":[{"name":"bitset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",206,null],[11,"clone","","",207,{"inputs":[{"name":"setiter"}],"output":{"name":"setiter"}}],[11,"clone","","",208,{"inputs":[{"name":"twobitpositions"}],"output":{"name":"twobitpositions"}}],[11,"clone","","",209,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[11,"clone","","",210,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[11,"clone","","",211,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[11,"clone","","",212,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",207,{"inputs":[{"name":"setiter"}],"output":{"name":"option"}}],[11,"size_hint","","",207,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",208,{"inputs":[{"name":"twobitpositions"}],"output":{"name":"option"}}],[11,"size_hint","","",208,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",209,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"size_hint","","",209,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",210,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"size_hint","","",210,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",211,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"size_hint","","",211,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::bit","",212,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"size_hint","","",212,null],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[11,"next","collections::btree::node","",213,{"inputs":[{"name":"rawitems"}],"output":{"name":"option"}}],[11,"next_back","","",213,{"inputs":[{"name":"rawitems"}],"output":{"name":"option"}}],[11,"drop","","",213,null],[11,"drop","","",214,null],[11,"as_slices","","",214,null],[11,"as_slices_mut","","",214,null],[11,"as_slices_internal","","",214,{"inputs":[{"name":"node"}],"output":{"name":"nodeslice"}}],[11,"as_slices_internal_mut","","",214,{"inputs":[{"name":"node"}],"output":{"name":"mutnodeslice"}}],[11,"keys","","",214,null],[11,"keys_mut","","",214,null],[11,"vals","","",214,null],[11,"vals_mut","","",214,null],[11,"edges","","",214,null],[11,"edges_mut","","",214,null],[11,"clone","","",214,{"inputs":[{"name":"node"}],"output":{"name":"node"}}],[11,"clone","","",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"search","","Searches for the given key in the node. If it finds an exact match,\n`Found` will be yielded with the matching index. If it doesn't find an exact match,\n`GoDown` will be yielded with the index of the subtree the key must lie in.",214,{"inputs":[{"name":"node"},{"name":"noderef"},{"name":"q"}],"output":{"name":"searchresult"}}],[11,"make_leaf_root","","Make a leaf root from scratch",214,{"inputs":[{"name":"node"},{"name":"usize"}],"output":{"name":"node"}}],[11,"make_internal_root","","Make an internal root and swap it with an old root",214,null],[11,"len","","How many key-value pairs the node contains",214,{"inputs":[{"name":"node"}],"output":{"name":"usize"}}],[11,"is_empty","","Does the node not contain any key-value pairs",214,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"capacity","","How many key-value pairs the node can fit",214,{"inputs":[{"name":"node"}],"output":{"name":"usize"}}],[11,"is_leaf","","If the node has any children",214,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"is_underfull","","if the node has too few elements",214,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"is_full","","if the node cannot fit any more elements",214,{"inputs":[{"name":"node"}],"output":{"name":"bool"}}],[11,"node","","Returns a reference to the node that contains the pointed-to edge or key/value pair. This\nis very different from `edge` and `edge_mut` because those return children of the node\nreturned by `node`.",215,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"as_raw","","Converts a handle into one that stores the same information using a raw pointer. This can\nbe useful in conjunction with `from_raw` when the type system is insufficient for\ndetermining the lifetimes of the nodes.",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"from_raw","","Converts from a handle stored with a raw pointer, which isn't directly usable, to a handle\nstored with a reference. This is an unsafe inverse of `as_raw`, and together they allow\nunsafely extending the lifetime of the reference to the `Node`.",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"from_raw_mut","","Converts from a handle stored with a raw pointer, which isn't directly usable, to a handle\nstored with a mutable reference. This is an unsafe inverse of `as_raw`, and together they\nallow unsafely extending the lifetime of the reference to the `Node`.",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"into_edge","","Turns the handle into a reference to the edge it points at. This is necessary because the\nreturned pointer has a larger lifetime than what would be returned by `edge` or `edge_mut`,\nmaking it more suitable for moving down a chain of nodes.",215,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"into_edge_mut","","Turns the handle into a mutable reference to the edge it points at. This is necessary\nbecause the returned pointer has a larger lifetime than what would be returned by\n`edge_mut`, making it more suitable for moving down a chain of nodes.",215,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"force","","Figure out whether this handle is pointing to something in a leaf node or to something in\nan internal node, clarifying the type according to the result.",215,{"inputs":[{"name":"handle"}],"output":{"name":"forceresult"}}],[11,"insert_as_leaf","","Tries to insert this key-value pair at the given index in this leaf node\nIf the node is full, we have to split it.",215,null],[11,"edge_mut","","Returns a mutable reference to the edge pointed-to by this handle. This should not be\nconfused with `node`, which references the parent node of what is returned here.",215,{"inputs":[{"name":"handle"}],"output":{"name":"node"}}],[11,"insert_as_internal","","Tries to insert this key-value pair at the given index in this internal node\nIf the node is full, we have to split it.",215,{"inputs":[{"name":"handle"},{"name":"k"},{"name":"v"},{"name":"node"}],"output":{"name":"insertionresult"}}],[11,"handle_underflow","","Handle an underflow in this node's child. We favour handling \"to the left\" because we know\nwe're empty, but our neighbour can be full. Handling to the left means when we choose to\nsteal, we pop off the end of our neighbour (always fast) and \"unshift\" ourselves\n(always slow, but at least faster since we know we're half-empty).\nHandling \"to the right\" reverses these roles. Of course, we merge whenever possible\nbecause we want dense nodes, and merging is about equal work regardless of direction.",215,null],[11,"into_kv","","Turns the handle into references to the key and value it points at. This is necessary\nbecause the returned pointers have larger lifetimes than what would be returned by `key`\nor `val`.",215,null],[11,"into_kv_mut","","Turns the handle into mutable references to the key and value it points at. This is\nnecessary because the returned pointers have larger lifetimes than what would be returned\nby `key_mut` or `val_mut`.",215,null],[11,"into_left_edge","","Convert this handle into one pointing at the edge immediately to the left of the key/value\npair pointed-to by this handle. This is useful because it returns a reference with larger\nlifetime than `left_edge`.",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"key_mut","","Returns a mutable reference to the key pointed-to by this handle. This doesn't return a\nreference with a lifetime as large as `into_kv_mut`, but it also does not consume the\nhandle.",215,{"inputs":[{"name":"handle"}],"output":{"name":"k"}}],[11,"val_mut","","Returns a mutable reference to the value pointed-to by this handle. This doesn't return a\nreference with a lifetime as large as `into_kv_mut`, but it also does not consume the\nhandle.",215,{"inputs":[{"name":"handle"}],"output":{"name":"v"}}],[11,"left_edge","","Gets the handle pointing to the edge immediately to the left of the key/value pair pointed\nto by this handle.",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"right_edge","","Gets the handle pointing to the edge immediately to the right of the key/value pair pointed\nto by this handle.",215,{"inputs":[{"name":"handle"}],"output":{"name":"handle"}}],[11,"remove_as_leaf","","Removes the key/value pair at the handle's location.",215,null],[11,"kv_handle","","Returns the mutable handle pointing to the key/value pair at a given index.",214,{"inputs":[{"name":"node"},{"name":"usize"}],"output":{"name":"handle"}}],[11,"iter","","",214,{"inputs":[{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"iter_mut","","",214,{"inputs":[{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"into_iter","","",214,{"inputs":[{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"hoist_lone_child","","When a node has no keys or values and only a single edge, extract that edge.",214,null],[11,"clone","","",216,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"elemsandedges"}}],[6,"Item","std::borrow","",null,null],[6,"Edge","","",null,null],[11,"next_kv","collections::btree::node","",216,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_kv_back","","",216,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_edge","","",216,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[11,"next_edge_back","","",216,{"inputs":[{"name":"elemsandedges"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[6,"Edge","","",null,null],[11,"next_kv","collections::btree::node","",217,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"next_kv_back","","",217,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"next_edge","","",217,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"next_edge_back","","",217,{"inputs":[{"name":"movetraversalimpl"}],"output":{"name":"option"}}],[11,"drop","","",217,null],[11,"clone","","",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"abstraversal"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::node","",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_back","","",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_edge_item","","Advances the iterator and returns the item if it's an edge. Returns None\nand does nothing if the first item is not an edge.",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_edge_item_back","","Advances the iterator and returns the item if it's an edge. Returns None\nand does nothing if the last item is not an edge.",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_kv_item","","Advances the iterator and returns the item if it's a key-value pair. Returns None\nand does nothing if the first item is not a key-value pair.",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"next_kv_item_back","","Advances the iterator and returns the item if it's a key-value pair. Returns None\nand does nothing if the last item is not a key-value pair.",218,{"inputs":[{"name":"abstraversal"}],"output":{"name":"option"}}],[11,"slice_from","","Returns a sub-slice with elements starting with `min_key`.",219,{"inputs":[{"name":"nodeslice"},{"name":"k"}],"output":{"name":"nodeslice"}}],[11,"slice_to","","Returns a sub-slice with elements up to and including `max_key`.",219,{"inputs":[{"name":"nodeslice"},{"name":"k"}],"output":{"name":"nodeslice"}}],[11,"iter","","Returns an iterator over key/value pairs and edges in a slice.",219,{"inputs":[{"name":"nodeslice"}],"output":{"name":"abstraversal"}}],[11,"slice_from","","Returns a sub-slice with elements starting with `min_key`.",220,{"inputs":[{"name":"mutnodeslice"},{"name":"k"}],"output":{"name":"mutnodeslice"}}],[11,"slice_to","","Returns a sub-slice with elements up to and including `max_key`.",220,{"inputs":[{"name":"mutnodeslice"},{"name":"k"}],"output":{"name":"mutnodeslice"}}],[11,"iter_mut","","Returns an iterator over key/value pairs and edges in a slice.",220,{"inputs":[{"name":"mutnodeslice"}],"output":{"name":"abstraversal"}}],[11,"clone","collections::btree::map","",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"clone","","",222,{"inputs":[{"name":"absiter"}],"output":{"name":"absiter"}}],[11,"new","","Makes a new empty BTreeMap with a reasonable choice for B.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"with_b","","Makes a new empty BTreeMap with the given B.",221,{"inputs":[{"name":"btreemap"},{"name":"usize"}],"output":{"name":"btreemap"}}],[11,"clear","","Clears the map, removing all values.",221,null],[11,"get","","Returns a reference to the value corresponding to the key.",221,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",221,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",221,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",221,{"inputs":[{"name":"btreemap"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",221,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::btree::map","Gets an owning iterator over the entries of the map.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Target","","",null,null],[11,"deref","collections::btree::map::stack","",223,{"inputs":[{"name":"idref"}],"output":{"name":"t"}}],[11,"deref_mut","","",223,{"inputs":[{"name":"idref"}],"output":{"name":"t"}}],[11,"new","","Creates a new PartialSearchStack from a BTreeMap by initializing the stack with the\nroot of the tree.",224,{"inputs":[{"name":"partialsearchstack"},{"name":"btreemap"}],"output":{"name":"partialsearchstack"}}],[11,"with","","Breaks up the stack into a `Pusher` and the next `Node`, allowing the given closure\nto interact with, search, and finally push the `Node` onto the stack. The passed in\nclosure must be polymorphic on the `'id` lifetime parameter, as this statically\nensures that only `Handle`s from the correct `Node` can be pushed.",224,{"inputs":[{"name":"partialsearchstack"},{"name":"f"}],"output":{"name":"t"}}],[11,"push","","Pushes the requested child of the stack's current top on top of the stack. If the child\nexists, then a new PartialSearchStack is yielded. Otherwise, a VacantSearchStack is\nyielded.",225,{"inputs":[{"name":"pusher"},{"name":"handle"}],"output":{"name":"partialsearchstack"}}],[11,"seal","","Converts the PartialSearchStack into a SearchStack.",225,{"inputs":[{"name":"pusher"},{"name":"handle"}],"output":{"name":"searchstack"}}],[11,"peek","","Gets a reference to the value the stack points to.",226,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"peek_mut","","Gets a mutable reference to the value the stack points to.",226,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"into_top","","Converts the stack into a mutable reference to the value it points to, with a lifetime\ntied to the original tree.",226,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"remove","","Removes the key and value in the top element of the stack, then handles underflows as\ndescribed in BTree's pop function.",226,{"inputs":[{"name":"searchstack"}],"output":{"name":"v"}}],[11,"insert","","Inserts the key and value into the top element in the stack, and if that node has to\nsplit recursively inserts the split contents into the next element stack until\nsplits stop.",226,{"inputs":[{"name":"searchstack"},{"name":"k"},{"name":"v"}],"output":{"name":"v"}}],[11,"from_iter","collections::btree::map","",221,{"inputs":[{"name":"btreemap"},{"name":"t"}],"output":{"name":"btreemap"}}],[11,"extend","","",221,null],[11,"hash","","",221,null],[11,"default","","",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"eq","","",221,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",221,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"option"}}],[11,"cmp","","",221,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"ordering"}}],[11,"fmt","","",221,{"inputs":[{"name":"btreemap"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::btree::map","",221,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"v"}}],[11,"traverse","collections::btree::node","",218,{"inputs":[{"name":"abstraversal"},{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"traverse","","",218,{"inputs":[{"name":"abstraversal"},{"name":"node"}],"output":{"name":"abstraversal"}}],[11,"traverse","","",218,{"inputs":[{"name":"abstraversal"},{"name":"node"}],"output":{"name":"abstraversal"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",222,{"inputs":[{"name":"absiter"}],"output":{"name":"option"}}],[11,"size_hint","","",222,null],[11,"next_back","","",222,{"inputs":[{"name":"absiter"}],"output":{"name":"option"}}],[11,"clone","","",227,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",227,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",227,null],[11,"next_back","","",227,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",228,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",228,null],[11,"next_back","","",228,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",229,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",229,null],[11,"next_back","","",229,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"clone","","",230,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",230,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",230,null],[11,"next_back","","",230,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"clone","","",231,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",231,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",231,null],[11,"next_back","","",231,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"clone","","",232,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",232,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next_back","","",232,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::map","",233,{"inputs":[{"name":"rangemut"}],"output":{"name":"option"}}],[11,"next_back","","",233,{"inputs":[{"name":"rangemut"}],"output":{"name":"option"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",234,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",234,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",234,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",235,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",236,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",236,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",236,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",236,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",236,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"iter","","Gets an iterator over the entries of the map.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Gets a mutable iterator over the entries of the map.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"itermut"}}],[11,"keys","","Gets an iterator over the keys of the map.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"keys"}}],[11,"values","","Gets an iterator over the values of the map.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"values"}}],[11,"len","","Returns the number of elements in the map.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",221,{"inputs":[{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",221,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"range_mut","","Constructs a mutable double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",221,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"rangemut"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",221,{"inputs":[{"name":"btreemap"},{"name":"k"}],"output":{"name":"entry"}}],[11,"partial_cmp","collections::btree::set","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"option"}}],[11,"lt","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"le","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"gt","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ge","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"cmp","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"ordering"}}],[11,"eq","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ne","","",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"hash","","",237,null],[11,"clone","","",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"new","","Makes a new BTreeSet with a reasonable choice of B.",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"with_b","","Makes a new BTreeSet with the given B.",237,{"inputs":[{"name":"btreeset"},{"name":"usize"}],"output":{"name":"btreeset"}}],[11,"iter","","Gets an iterator over the BTreeSet's contents.",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"iter"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the set, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",237,{"inputs":[{"name":"btreeset"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"difference","","Visits the values representing the difference, in ascending order.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Visits the values representing the symmetric difference, in ascending order.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"symmetricdifference"}}],[11,"intersection","","Visits the values representing the intersection, in ascending order.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"intersection"}}],[11,"union","","Visits the values representing the union, in ascending order.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"union"}}],[11,"len","","Returns the number of elements in the set.",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the set contains no elements.",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"clear","","Clears the set, removing all values.",237,null],[11,"contains","","Returns `true` if the set contains a value.",237,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",237,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",237,{"inputs":[{"name":"btreeset"},{"name":"t"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",237,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"from_iter","","",237,{"inputs":[{"name":"btreeset"},{"name":"i"}],"output":{"name":"btreeset"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::btree::set","Gets an iterator for moving out the BtreeSet's contents.",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::btree::set","",237,null],[11,"default","","",237,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[6,"Output","std::borrow","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"fmt","collections::btree::set","",237,{"inputs":[{"name":"btreeset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",238,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",238,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",238,null],[11,"next_back","","",238,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",239,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",239,null],[11,"next_back","","",239,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"clone","","",240,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",240,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"next_back","","",240,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"clone","","",241,{"inputs":[{"name":"difference"}],"output":{"name":"difference"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",241,{"inputs":[{"name":"difference"}],"output":{"name":"option"}}],[11,"clone","","",242,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"symmetricdifference"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",242,{"inputs":[{"name":"symmetricdifference"}],"output":{"name":"option"}}],[11,"clone","","",243,{"inputs":[{"name":"intersection"}],"output":{"name":"intersection"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",243,{"inputs":[{"name":"intersection"}],"output":{"name":"option"}}],[11,"clone","","",244,{"inputs":[{"name":"union"}],"output":{"name":"union"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::btree::set","",244,{"inputs":[{"name":"union"}],"output":{"name":"option"}}],[11,"borrow","std::rc","",193,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"borrow","alloc::arc","",192,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"borrow","collections::borrow","",199,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[6,"Owned","std::borrow","",null,null],[11,"clone","collections::borrow","",199,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[6,"Target","std::borrow","",null,null],[11,"deref","collections::borrow","",199,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[11,"cmp","","",199,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"ordering"}}],[11,"eq","","",199,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",199,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"option"}}],[11,"fmt","","",199,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",199,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",199,null],[11,"into_cow","","",199,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"as_ref","","",199,{"inputs":[{"name":"cow"}],"output":{"name":"t"}}],[11,"hash","collections::enum_set","",245,null],[11,"cmp","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"option"}}],[11,"lt","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"le","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"gt","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ge","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"eq","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ne","","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clone","","",245,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"fmt","","",245,{"inputs":[{"name":"enumset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Returns an empty `EnumSet`.",245,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"len","","Returns the number of elements in the given `EnumSet`.",245,{"inputs":[{"name":"enumset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the `EnumSet` is empty.",245,{"inputs":[{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clear","","",245,null],[11,"is_disjoint","","Returns `false` if the `EnumSet` contains any enum of the given `EnumSet`.",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if a given `EnumSet` is included in this `EnumSet`.",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if this `EnumSet` is included in the given `EnumSet`.",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"union","","Returns the union of both `EnumSets`.",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"intersection","","Returns the intersection of both `EnumSets`.",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"insert","","Adds an enum to the `EnumSet`, and returns `true` if it wasn't there before",245,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"remove","","Removes an enum from the EnumSet",245,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` if an `EnumSet` contains a given enum.",245,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over an `EnumSet`.",245,{"inputs":[{"name":"enumset"}],"output":{"name":"iter"}}],[6,"Output","std::borrow","",null,null],[11,"sub","collections::enum_set","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[6,"Output","std::borrow","",null,null],[11,"bitor","collections::enum_set","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[6,"Output","std::borrow","",null,null],[11,"bitand","collections::enum_set","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[6,"Output","std::borrow","",null,null],[11,"bitxor","collections::enum_set","",245,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"clone","","",246,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::enum_set","",246,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",246,null],[11,"from_iter","","",245,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":{"name":"enumset"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::enum_set","",245,null],[11,"clone","collections::linked_list","",247,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"clone","","",248,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"clone","","",249,{"inputs":[{"name":"rawlink"}],"output":{"name":"rawlink"}}],[11,"default","","",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"new","","Creates an empty `LinkedList`.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"append","","Moves all elements from `other` to the end of the list.",250,null],[11,"iter","","Provides a forward iterator.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"iter"}}],[11,"iter_mut","","Provides a forward iterator with mutable references.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"itermut"}}],[11,"is_empty","","Returns `true` if the `LinkedList` is empty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"len","","Returns the length of the `LinkedList`.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"usize"}}],[11,"clear","","Removes all elements from the `LinkedList`.",250,null],[11,"front","","Provides a reference to the front element, or `None` if the list is\nempty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the list\nis empty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the list is\nempty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the list\nis empty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_front","","Adds an element first in the list.",250,null],[11,"pop_front","","Removes the first element and returns it, or `None` if the list is\nempty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_back","","Appends an element to the back of a list",250,null],[11,"pop_back","","Removes the last element from a list and returns it, or `None` if\nit is empty.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"split_off","","Splits the list into two at the given index. Returns everything after the given index,\nincluding the index.",250,{"inputs":[{"name":"linkedlist"},{"name":"usize"}],"output":{"name":"linkedlist"}}],[11,"drop","","",250,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::linked_list","",247,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",247,null],[11,"next_back","","",247,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::linked_list","",251,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",251,null],[11,"next_back","","",251,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"insert_next","","Inserts `elt` just after the element most recently returned by `.next()`.\nThe inserted element does not appear in the iteration.",251,null],[11,"peek_next","","Provides a reference to the next element, without changing the iterator.",251,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::linked_list","",248,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",248,null],[11,"next_back","","",248,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","",250,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":{"name":"linkedlist"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::linked_list","Consumes the list into an iterator yielding elements by value.",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::linked_list","",250,null],[11,"eq","","",250,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"ne","","",250,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",250,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"cmp","","",250,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"ordering"}}],[11,"clone","","",250,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"fmt","","",250,{"inputs":[{"name":"linkedlist"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",250,null],[11,"clone","collections::slice","",252,{"inputs":[{"name":"elementswaps"}],"output":{"name":"elementswaps"}}],[11,"new","","Creates an `ElementSwaps` iterator for a sequence of `length` elements.",252,{"inputs":[{"name":"elementswaps"},{"name":"usize"}],"output":{"name":"elementswaps"}}],[11,"borrow","collections::vec","",253,null],[11,"borrow_mut","","",253,null],[6,"Owned","std::borrow","",null,null],[11,"clone","collections::slice","",254,{"inputs":[{"name":"direction"}],"output":{"name":"direction"}}],[11,"clone","","",255,{"inputs":[{"name":"sizedirection"}],"output":{"name":"sizedirection"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::slice","",252,{"inputs":[{"name":"elementswaps"}],"output":{"name":"option"}}],[11,"size_hint","","",252,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::slice","",256,{"inputs":[{"name":"permutations"}],"output":{"name":"option"}}],[11,"size_hint","","",256,null],[11,"clone","collections::str","",257,{"inputs":[{"name":"decompositiontype"}],"output":{"name":"decompositiontype"}}],[11,"clone","","",258,{"inputs":[{"name":"decompositions"}],"output":{"name":"decompositions"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::str","",258,{"inputs":[{"name":"decompositions"}],"output":{"name":"option"}}],[11,"size_hint","","",258,null],[11,"clone","","",259,{"inputs":[{"name":"recompositionstate"}],"output":{"name":"recompositionstate"}}],[11,"clone","","",260,{"inputs":[{"name":"recompositions"}],"output":{"name":"recompositions"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::str","",260,{"inputs":[{"name":"recompositions"}],"output":{"name":"option"}}],[11,"clone","","",261,{"inputs":[{"name":"utf16units"}],"output":{"name":"utf16units"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::str","",261,{"inputs":[{"name":"utf16units"}],"output":{"name":"option"}}],[11,"size_hint","","",261,null],[11,"borrow","collections::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[6,"Owned","std::borrow","",null,null],[11,"cmp","collections::string","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"option"}}],[11,"lt","","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"le","","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"gt","","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ge","","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"clone","","",262,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",263,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",264,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new string buffer initialized with the empty string.",262,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"with_capacity","","Creates a new string buffer with the given capacity.\nThe string will be able to hold exactly `capacity` bytes without\nreallocating. If `capacity` is 0, the string will not allocate.",262,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"string"}}],[11,"from_str","","Creates a new string buffer from the given string.",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from_utf8","","Returns the vector as a string buffer, if possible, taking care not to\ncopy it.",262,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"result"}}],[11,"from_utf8_lossy","","Converts a vector of bytes to a new UTF-8 string.\nAny invalid UTF-8 sequences are replaced with U+FFFD REPLACEMENT CHARACTER.",262,null],[11,"from_utf16","","Decode a UTF-16 encoded vector `v` into a `String`, returning `None`\nif `v` contains any invalid data.",262,null],[11,"from_utf16_lossy","","Decode a UTF-16 encoded vector `v` into a string, replacing\ninvalid data with the replacement character (U+FFFD).",262,null],[11,"from_raw_parts","","Creates a new `String` from a length, capacity, and pointer.",262,null],[11,"from_utf8_unchecked","","Converts a vector of bytes to a new `String` without checking if\nit contains valid UTF-8. This is unsafe because it assumes that\nthe UTF-8-ness of the vector has already been validated.",262,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"string"}}],[11,"into_bytes","","Returns the underlying byte buffer, encoded as UTF-8.",262,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"as_str","","Extracts a string slice containing the entire string.",262,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"push_str","","Pushes the given string onto this string buffer.",262,null],[11,"capacity","","Returns the number of bytes that this string buffer can hold without\nreallocating.",262,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more bytes to be inserted\nin the given `String`. The collection may reserve more space to avoid\nfrequent reallocations.",262,null],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bytes to be\ninserted in the given `String`. Does nothing if the capacity is already\nsufficient.",262,null],[11,"shrink_to_fit","","Shrinks the capacity of this string buffer to match its length.",262,null],[11,"push","","Adds the given character to the end of the string.",262,null],[11,"as_bytes","","Works with the underlying buffer as a byte slice.",262,null],[11,"truncate","","Shortens a string to the specified length.",262,null],[11,"pop","","Removes the last character from the string buffer and returns it.\nReturns `None` if this string buffer is empty.",262,{"inputs":[{"name":"string"}],"output":{"name":"option"}}],[11,"remove","","Removes the character from the string buffer at byte position `idx` and\nreturns it.",262,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"char"}}],[11,"insert","","Inserts a character into the string buffer at byte position `idx`.",262,null],[11,"as_mut_vec","","Views the string buffer as a mutable sequence of bytes.",262,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"len","","Returns the number of bytes in this string.",262,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the string contains no bytes",262,{"inputs":[{"name":"string"}],"output":{"name":"bool"}}],[11,"clear","","Truncates the string, returning it to 0 length.",262,null],[11,"into_bytes","","Consumes this error, returning the bytes that were attempted to make a\n`String` with.",263,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"vec"}}],[11,"utf8_error","","Accesss the underlying UTF8-error that was the cause of this error.",263,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"utf8error"}}],[11,"fmt","","",263,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",264,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",262,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"from_iter","","",262,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"extend","","",262,null],[11,"extend","","",262,null],[6,"Searcher","std::borrow","",null,null],[11,"eq","collections::string","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",262,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",199,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",199,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",199,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",199,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","collections::string","",262,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"ne","","",262,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",199,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",199,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"default","collections::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",262,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",262,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",262,null],[6,"Output","std::borrow","",null,null],[11,"add","collections::string","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::string","",262,{"inputs":[{"name":"string"},{"name":"range"}],"output":{"name":"str"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::string","",262,{"inputs":[{"name":"string"},{"name":"rangeto"}],"output":{"name":"str"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::string","",262,{"inputs":[{"name":"string"},{"name":"rangefrom"}],"output":{"name":"str"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::string","",262,{"inputs":[{"name":"string"},{"name":"rangefull"}],"output":{"name":"str"}}],[6,"Target","std::borrow","",null,null],[11,"deref","collections::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[6,"Target","std::borrow","",null,null],[11,"deref","collections::string","",265,{"inputs":[{"name":"derefstring"}],"output":{"name":"string"}}],[11,"eq","","",266,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"ne","","",266,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"fmt","","",266,{"inputs":[{"name":"parseerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",266,{"inputs":[{"name":"parseerror"}],"output":{"name":"parseerror"}}],[6,"Err","std::borrow","",null,null],[11,"from_str","collections::string","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"as_ref","","",262,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"as_ref","","",262,null],[11,"from","","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from","collections::borrow","",199,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"cow"}}],[11,"from","","",199,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"cow"}}],[11,"into","collections::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"into_cow","","",262,{"inputs":[{"name":"string"}],"output":{"name":"cow"}}],[11,"write_str","","",262,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"new","collections::vec","Constructs a new, empty `Vec<T>`.",253,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"with_capacity","","Constructs a new, empty `Vec<T>` with the specified capacity.",253,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"from_raw_parts","","Creates a `Vec<T>` directly from the raw components of another vector.",253,null],[11,"from_raw_buf","","Creates a vector by copying the elements from a raw pointer.",253,null],[11,"capacity","","Returns the number of elements the vector can hold without\nreallocating.",253,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the given `Vec<T>`. The collection may reserve more space to avoid\nfrequent reallocations.",253,null],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to\nbe inserted in the given `Vec<T>`. Does nothing if the capacity is already\nsufficient.",253,null],[11,"shrink_to_fit","","Shrinks the capacity of the vector as much as possible.",253,null],[11,"into_boxed_slice","","Converts the vector into Box<[T]>.",253,{"inputs":[{"name":"vec"}],"output":{"name":"box"}}],[11,"truncate","","Shorten a vector, dropping excess elements.",253,null],[11,"as_slice","","Extracts a slice containing the entire vector.",253,null],[11,"as_mut_slice","","Deprecated: use `&mut s[..]` instead.",253,null],[11,"set_len","","Sets the length of a vector.",253,null],[11,"swap_remove","","Removes an element from anywhere in the vector and return it, replacing\nit with the last element.",253,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"insert","","Inserts an element at position `index` within the vector, shifting all\nelements after position `i` one position to the right.",253,null],[11,"remove","","Removes and returns the element at position `index` within the vector,\nshifting all elements after position `index` one position to the left.",253,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"retain","","Retains only the elements specified by the predicate.",253,null],[11,"push","","Appends an element to the back of a collection.",253,null],[11,"pop","","Removes the last element from a vector and returns it, or `None` if it is empty.",253,{"inputs":[{"name":"vec"}],"output":{"name":"option"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",253,null],[11,"drain","","Creates a draining iterator that clears the `Vec` and iterates over\nthe removed items from start to end.",253,{"inputs":[{"name":"vec"}],"output":{"name":"drain"}}],[11,"clear","","Clears the vector, removing all values.",253,null],[11,"len","","Returns the number of elements in the vector.",253,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns `true` if the vector contains no elements.",253,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"map_in_place","","Converts a `Vec<T>` to a `Vec<U>` where `T` and `U` have the same\nsize and in case they are not zero-sized the same minimal alignment.",253,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"split_off","","Splits the collection into two at the given index.",253,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"resize","","Resizes the `Vec` in-place so that `len()` is equal to `new_len`.",253,null],[11,"push_all","","Appends all elements in a slice to the `Vec`.",253,null],[11,"dedup","","Removes consecutive repeated elements in the vector.",253,null],[11,"clone","","",253,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"clone_from","","",253,null],[11,"hash","","",253,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec","",253,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index_mut","","",253,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec","",253,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec","",253,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec","",253,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec","",253,null],[11,"index_mut","","",253,null],[11,"index_mut","","",253,null],[11,"index_mut","","",253,null],[11,"index_mut","","",253,null],[6,"Target","std::borrow","",null,null],[11,"deref","collections::vec","",253,null],[11,"deref_mut","","",253,null],[11,"from_iter","","",253,{"inputs":[{"name":"vec"},{"name":"i"}],"output":{"name":"vec"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::vec","Creates a consuming iterator, that is, one that moves each value out of\nthe vector (from start to end). The vector cannot be used after calling\nthis.",253,{"inputs":[{"name":"vec"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::vec","",253,null],[11,"eq","","",253,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",253,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","collections::borrow","",199,null],[11,"ne","","",199,null],[11,"eq","","",199,null],[11,"ne","","",199,null],[11,"eq","","",199,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",199,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","collections::vec","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"eq","","",253,null],[11,"ne","","",253,null],[11,"partial_cmp","","",253,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"option"}}],[11,"cmp","","",253,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"ordering"}}],[11,"drop","","",253,null],[11,"default","","",253,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"fmt","","",253,{"inputs":[{"name":"vec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_ref","","",253,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"as_ref","","",253,null],[11,"from","","",253,null],[11,"from","","",253,{"inputs":[{"name":"vec"},{"name":"str"}],"output":{"name":"vec"}}],[11,"from_iter","collections::borrow","",199,{"inputs":[{"name":"cow"},{"name":"i"}],"output":{"name":"cow"}}],[11,"into_cow","collections::vec","",253,{"inputs":[{"name":"vec"}],"output":{"name":"cow"}}],[11,"into_inner","","Drops all items that have not yet been moved and returns the empty vector.",267,{"inputs":[{"name":"intoiter"}],"output":{"name":"vec"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec","",267,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",267,null],[11,"next_back","","",267,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",267,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec","",268,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",268,null],[11,"next_back","","",268,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"drop","","",268,null],[6,"Target","std::borrow","",null,null],[11,"deref","collections::vec","",269,{"inputs":[{"name":"derefvec"}],"output":{"name":"vec"}}],[11,"drop","","",269,null],[11,"drop","","",270,null],[11,"drop","","",271,null],[11,"clone","collections::vec_deque","",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"drop","","",272,null],[11,"default","","",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"new","","Creates an empty `VecDeque`.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"with_capacity","","Creates an empty `VecDeque` with space for at least `n` elements.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"vecdeque"}}],[11,"get","","Retrieves an element in the `VecDeque` by index.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get_mut","","Retrieves an element in the `VecDeque` mutably by index.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap","","Swaps elements at indices `i` and `j`.",272,null],[11,"capacity","","Returns the number of elements the `VecDeque` can hold without\nreallocating.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `VecDeque`. Does nothing if the capacity is already sufficient.",272,null],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the given\n`Ringbuf`. The collection may reserve more space to avoid frequent reallocations.",272,null],[11,"shrink_to_fit","","Shrinks the capacity of the ringbuf as much as possible.",272,null],[11,"truncate","","Shortens a ringbuf, dropping excess elements from the back.",272,null],[11,"iter","","Returns a front-to-back iterator.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a front-to-back iterator that returns mutable references.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"itermut"}}],[11,"as_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",272,null],[11,"as_mut_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",272,null],[11,"len","","Returns the number of elements in the `VecDeque`.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the buffer contains no elements",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"drain","","Creates a draining iterator that clears the `VecDeque` and iterates over\nthe removed items from start to end.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"drain"}}],[11,"clear","","Clears the buffer, removing all values.",272,null],[11,"front","","Provides a reference to the front element, or `None` if the sequence is\nempty.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the\nsequence is empty.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the sequence is\nempty.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the\nsequence is empty.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"pop_front","","Removes the first element and returns it, or `None` if the sequence is\nempty.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"push_front","","Inserts an element first in the sequence.",272,null],[11,"push_back","","Appends an element to the back of a buffer",272,null],[11,"pop_back","","Removes the last element from a buffer and returns it, or `None` if\nit is empty.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"swap_back_remove","","Removes an element from anywhere in the ringbuf and returns it, replacing it with the last\nelement.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap_front_remove","","Removes an element from anywhere in the ringbuf and returns it, replacing it with the first\nelement.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts an element at position `i` within the ringbuf. Whichever\nend is closer to the insertion point will be moved to make room,\nand all the affected elements will be moved to new positions.",272,null],[11,"remove","","Removes and returns the element at position `i` from the ringbuf.\nWhichever end is closer to the removal point will be moved to make\nroom, and all the affected elements will be moved to new positions.\nReturns `None` if `i` is out of bounds.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"split_off","","Splits the collection into two at the given index.",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"vecdeque"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",272,null],[11,"resize","","Modifies the ringbuf in-place so that `len()` is equal to new_len,\neither by removing excess elements or by appending copies of a value to the back.",272,null],[11,"clone","","",273,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_deque","",273,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",273,null],[11,"next_back","","",273,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",273,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",273,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_deque","",274,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",274,null],[11,"next_back","","",274,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",275,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_deque","",275,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",275,null],[11,"next_back","","",275,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",276,null],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_deque","",276,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",276,null],[11,"next_back","","",276,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"eq","","",272,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",272,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"cmp","","",272,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"ordering"}}],[11,"hash","","",272,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec_deque","",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"index_mut","","",272,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"from_iter","","",272,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":{"name":"vecdeque"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::vec_deque","Consumes the list into a front-to-back iterator yielding elements by\nvalue.",272,{"inputs":[{"name":"vecdeque"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::vec_deque","",272,null],[11,"fmt","","",272,{"inputs":[{"name":"vecdeque"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","collections::vec_map","",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone","","",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone_from","","",277,null],[11,"hash","","",277,null],[11,"new","","Creates an empty `VecMap`.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"with_capacity","","Creates an empty `VecMap` with space for at least `capacity`\nelements before resizing.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"vecmap"}}],[11,"capacity","","Returns the number of elements the `VecMap` can hold without\nreallocating.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long\nas all inserted keys are less than `len`.",277,null],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long as all inserted\nkeys are less than `len`.",277,null],[11,"keys","","Returns an iterator visiting all keys in ascending order of the keys.\nThe iterator's element type is `usize`.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"keys"}}],[11,"values","","Returns an iterator visiting all values in ascending order of the keys.\nThe iterator's element type is `&'r V`.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"values"}}],[11,"iter","","Returns an iterator visiting all key-value pairs in ascending order of the keys.\nThe iterator's element type is `(usize, &'r V)`.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns an iterator visiting all key-value pairs in ascending order of the keys,\nwith mutable references to the values.\nThe iterator's element type is `(usize, &'r mut V)`.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"itermut"}}],[11,"append","","Moves all elements from `other` into the map while overwriting existing keys.",277,null],[11,"split_off","","Splits the collection into two at the given key.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"vecmap"}}],[11,"drain","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, emptying (but not consuming) the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`. Keeps the allocated memory for reuse.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"drain"}}],[11,"len","","Returns the number of elements in the map.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"clear","","Clears the map, removing all key-value pairs.",277,null],[11,"get","","Returns a reference to the value corresponding to the key.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"entry"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",278,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",278,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",278,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",279,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",280,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",280,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",280,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",280,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",280,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"eq","","",277,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",277,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"option"}}],[11,"cmp","","",277,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"ordering"}}],[11,"fmt","","",277,{"inputs":[{"name":"vecmap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",277,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":{"name":"vecmap"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","collections::vec_map","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, consuming the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`.",277,{"inputs":[{"name":"vecmap"}],"output":{"name":"intoiter"}}],[6,"Item","std::borrow","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","collections::vec_map","",277,null],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec_map","",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[6,"Output","std::borrow","",null,null],[11,"index","collections::vec_map","",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",277,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"clone","","",281,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_map","",281,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",281,null],[11,"next_back","","",281,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_map","",282,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",282,null],[11,"next_back","","",282,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",283,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"clone","","",284,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_map","",285,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",285,null],[11,"next_back","","",285,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_map","",283,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",283,null],[11,"next_back","","",283,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_map","",284,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",284,null],[11,"next_back","","",284,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[6,"Item","std::borrow","",null,null],[11,"next","collections::vec_map","",286,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",286,null],[11,"next_back","","",286,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"eq","collections","",287,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"ne","","",287,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"hash","","",287,null],[11,"fmt","","",287,{"inputs":[{"name":"bound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",287,{"inputs":[{"name":"bound"}],"output":{"name":"bound"}}],[4,"Cow","std::borrow","A clone-on-write smart pointer.",null,null],[13,"Borrowed","","Borrowed data.",199,null],[13,"Owned","","Owned data.",199,null],[8,"IntoCow","","Trait for moving into a `Cow`.",null,null],[10,"into_cow","","Moves `self` into `Cow`",288,{"inputs":[{"name":"intocow"}],"output":{"name":"cow"}}],[0,"fmt","std","Utilities for formatting and printing strings",null,null],[5,"format","std::fmt","The format function takes a precompiled format string and a list of\narguments, to return the resulting formatted string.",null,{"inputs":[{"name":"arguments"}],"output":{"name":"string"}}],[8,"Display","","When a value can be semantically expressed as a String, this trait may be\nused. It corresponds to the default format, `{}`.",null,null],[10,"fmt","","Formats the value using the given formatter.",289,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Formatter","","A struct to represent both where to emit formatting strings to and how they\nshould be formatted. A mutable version of this is passed to all formatting\ntraits.",null,null],[8,"LowerExp","","Format trait for the `e` character",null,null],[10,"fmt","","Formats the value using the given formatter.",290,{"inputs":[{"name":"lowerexp"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperHex","","Format trait for the `X` character",null,null],[10,"fmt","","Formats the value using the given formatter.",291,{"inputs":[{"name":"upperhex"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Arguments","","This structure represents a safely precompiled version of a format string\nand its arguments. This cannot be generated at runtime because it cannot\nsafely be done so, so no constructors are given and the fields are private\nto prevent modification.",null,null],[8,"Pointer","","Format trait for the `p` character",null,null],[10,"fmt","","Formats the value using the given formatter.",292,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Octal","","Format trait for the `o` character",null,null],[10,"fmt","","Formats the value using the given formatter.",293,{"inputs":[{"name":"octal"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Debug","","Format trait for the `:?` format. Useful for debugging, all types\nshould implement this.",null,null],[10,"fmt","","Formats the value using the given formatter.",294,{"inputs":[{"name":"debug"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperExp","","Format trait for the `E` character",null,null],[10,"fmt","","Formats the value using the given formatter.",295,{"inputs":[{"name":"upperexp"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Write","","A collection of methods that are required to format a message into a stream.",null,null],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write\nsucceeded.",296,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Glue for usage of the `write!` macro with implementers of this trait.",296,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[8,"LowerHex","","Format trait for the `x` character",null,null],[10,"fmt","","Formats the value using the given formatter.",297,{"inputs":[{"name":"lowerhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Binary","","Format trait for the `b` character",null,null],[10,"fmt","","Formats the value using the given formatter.",298,{"inputs":[{"name":"binary"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Error","","The error type which is returned from formatting a message into a stream.",null,null],[3,"RadixFmt","","A helper type for formatting radixes.",null,null],[6,"Result","","",null,null],[5,"radix","","Constructs a radix formatter in the range of `2..36`.",null,{"inputs":[{"name":"t"},{"name":"u8"}],"output":{"name":"radixfmt"}}],[5,"write","","The `write` function takes an output stream, a precompiled format string,\nand a list of arguments. The arguments will be formatted according to the\nspecified format string into the output stream provided.",null,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[3,"Radix","","A radix with in the range of `2..36`.",null,null],[0,"slice","std","Utilities for slice manipulation",null,null],[8,"SliceConcatExt","std::slice","An extension trait for concatenating slices",null,null],[10,"concat","","Flattens a slice of `T` into a single value `U`.",299,{"inputs":[{"name":"sliceconcatext"}],"output":{"name":"u"}}],[10,"connect","","Flattens a slice of `T` into a single value `U`, placing a given separator between each.",299,{"inputs":[{"name":"sliceconcatext"},{"name":"t"}],"output":{"name":"u"}}],[3,"ElementSwaps","","An iterator that yields the element swaps needed to produce\na sequence of all possible permutations for an indexed sequence of\nelements. Each permutation is only a single swap apart.",null,null],[3,"Permutations","","An iterator that uses `ElementSwaps` to iterate through\nall possible permutations of a vector.",null,null],[3,"SplitN","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"Iter","","Immutable slice iterator",null,null],[5,"from_raw_parts_mut","","Performs the same functionality as `from_raw_parts`, except that a mutable\nslice is returned.",null,null],[8,"IntSliceExt","","Extension methods for slices containing integers.",null,null],[10,"as_unsigned","","Converts the slice to an immutable slice of unsigned integers with the same width.",300,null],[10,"as_signed","","Converts the slice to an immutable slice of signed integers with the same width.",300,null],[10,"as_unsigned_mut","","Converts the slice to a mutable slice of unsigned integers with the same width.",300,null],[10,"as_signed_mut","","Converts the slice to a mutable slice of signed integers with the same width.",300,null],[3,"IterMut","","Mutable slice iterator.",null,null],[5,"mut_ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[0,"bytes","","Operations on `[u8]`.",null,null],[8,"MutableByteVector","std::slice::bytes","A trait for operations on mutable `[u8]`s.",null,null],[10,"set_memory","","Sets all bytes of the receiver to the given value.",301,null],[5,"copy_memory","","Copies data from `src` to `dst`",null,null],[3,"Chunks","std::slice","An iterator over a slice in (non-overlapping) chunks (`size` elements at a\ntime).",null,null],[3,"SplitMut","","An iterator over the subslices of the vector which are separated\nby elements that match `pred`.",null,null],[5,"from_raw_parts","","Forms a slice from a pointer and a length.",null,null],[3,"SplitNMut","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"Windows","","An iterator over overlapping subslices of length `size`.",null,null],[3,"RSplitNMut","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"RSplitN","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"ChunksMut","","An iterator over a slice in (non-overlapping) mutable chunks (`size`\nelements at a time). When the slice len is not evenly divided by the chunk\nsize, the last slice of the iteration will be the remainder.",null,null],[3,"Split","","An iterator over subslices separated by elements that match a predicate\nfunction.",null,null],[5,"ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[0,"str","std","Unicode string manipulation (the `str` type).",null,null],[3,"Decompositions","std::str","External iterator for a string decomposition's characters.",null,null],[3,"Recompositions","","External iterator for a string recomposition's characters.",null,null],[3,"Utf16Units","","External iterator for a string's UTF16 codeunits.",null,null],[3,"RSplit","","/// Created with the method `.rsplit()`.",null,null],[5,"from_utf8","","Converts a slice of bytes to a string slice without performing any\nallocations.",null,null],[3,"Bytes","","External iterator for a string's bytes.\nUse with the `std::iter` module.",null,null],[11,"clone","unicode::tables::grapheme","",302,{"inputs":[{"name":"graphemecat"}],"output":{"name":"graphemecat"}}],[11,"clone","unicode::u_str","",303,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"graphemeindices"}}],[6,"Item","std::str","",null,null],[11,"next","unicode::u_str","",303,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"size_hint","","",303,null],[11,"next_back","","",303,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"clone","","",304,{"inputs":[{"name":"graphemes"}],"output":{"name":"graphemes"}}],[11,"eq","","",305,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[11,"ne","","",305,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[6,"Item","std::str","",null,null],[11,"size_hint","unicode::u_str","",304,null],[11,"next","","",304,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"next_back","","",304,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"clone","","",306,{"inputs":[{"name":"utf16items"}],"output":{"name":"utf16items"}}],[11,"fmt","","",307,{"inputs":[{"name":"utf16item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",307,{"inputs":[{"name":"utf16item"}],"output":{"name":"utf16item"}}],[11,"eq","","",307,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"ne","","",307,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"to_char_lossy","","Convert `self` to a `char`, taking `LoneSurrogate`s to the\nreplacement character (U+FFFD).",307,{"inputs":[{"name":"utf16item"}],"output":{"name":"char"}}],[6,"Item","std::str","",null,null],[11,"next","unicode::u_str","",306,{"inputs":[{"name":"utf16items"}],"output":{"name":"option"}}],[11,"size_hint","","",306,null],[11,"clone","","",308,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"utf16encoder"}}],[11,"new","","Create an UTF-16 encoder from any `char` iterator.",308,{"inputs":[{"name":"utf16encoder"},{"name":"i"}],"output":{"name":"utf16encoder"}}],[6,"Item","std::str","",null,null],[11,"next","unicode::u_str","",308,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"option"}}],[11,"size_hint","","",308,null],[6,"Item","std::str","",null,null],[11,"next","unicode::u_str","",309,{"inputs":[{"name":"words"}],"output":{"name":"option"}}],[11,"next_back","","",309,{"inputs":[{"name":"words"}],"output":{"name":"option"}}],[6,"Item","std::str","",null,null],[11,"next","unicode::char","",310,{"inputs":[{"name":"tolowercase"}],"output":{"name":"option"}}],[6,"Item","std::str","",null,null],[11,"next","unicode::char","",311,{"inputs":[{"name":"touppercase"}],"output":{"name":"option"}}],[3,"GraphemeIndices","std::str","External iterator for grapheme clusters and byte offsets.",null,null],[3,"ParseBoolError","","An error returned when parsing a `bool` from a string fails.",null,null],[3,"SplitN","","/// Created with the method `.splitn()`.",null,null],[3,"CharRange","","Struct that contains a `char` and the index of the first byte of\nthe next `char` in a string.  This can be used as a data structure\nfor iterating over the UTF-8 bytes of a string.",null,null],[12,"ch","","Current `char`",125,null],[12,"next","","Index of the first byte of the next `char`",125,null],[3,"Matches","","/// Created with the method `.matches()`.",null,null],[5,"from_utf8_unchecked","","Converts a slice of bytes to a string slice without checking\nthat the string contains valid UTF-8.",null,null],[3,"RMatches","","/// Created with the method `.rmatches()`.",null,null],[3,"Lines","","Created with the method `.lines()`.",null,null],[3,"SplitTerminator","","/// Created with the method `.split_terminator()`.",null,null],[0,"pattern","","The string Pattern API.",null,null],[8,"Pattern","std::str::pattern","A string pattern.",null,null],[16,"Searcher","std::str::pattern::Pattern","Associated searcher for this pattern",null,null],[10,"into_searcher","std::str::pattern","Constructs the associated searcher from\n`self` and the `haystack` to search in.",312,null],[11,"is_contained_in","","Checks whether the pattern matches anywhere in the haystack",312,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",312,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",312,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[4,"SearchStep","","Result of calling `Searcher::next()` or `ReverseSearcher::next_back()`.",null,null],[13,"Match","","Expresses that a match of the pattern has been found at\n`haystack[a..b]`.",91,null],[13,"Reject","","Expresses that `haystack[a..b]` has been rejected as a possible match\nof the pattern.",91,null],[13,"Done","","Expresses that every byte of the haystack has been visted, ending\nthe iteration.",91,null],[8,"Searcher","","A searcher for a string pattern.",null,null],[10,"haystack","","Getter for the underlaying string to be searched in",313,{"inputs":[{"name":"searcher"}],"output":{"name":"str"}}],[10,"next","","Performs the next search step starting from the front.",313,{"inputs":[{"name":"searcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","Find the next `Match` result. See `next()`",313,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[11,"next_reject","","Find the next `Reject` result. See `next()`",313,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[8,"ReverseSearcher","","A reverse searcher for a string pattern.",null,null],[10,"next_back","","Performs the next search step starting from the back.",314,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","Find the next `Match` result. See `next_back()`",314,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","Find the next `Reject` result. See `next_back()`",314,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[8,"DoubleEndedSearcher","","A marker trait to express that a `ReverseSearcher`\ncan be used for a `DoubleEndedIterator` implementation.",null,null],[3,"StrSearcher","","Associated type for `<&str as Pattern<'a>>::Searcher`.",null,null],[3,"CharSearcher","","Associated type for `<char as Pattern<'a>>::Searcher`.",null,null],[3,"CharSliceSearcher","","Associated type for `<&[char] as Pattern<'a>>::Searcher`.",null,null],[3,"CharPredicateSearcher","","Associated type for `<F as Pattern<'a>>::Searcher`.",null,null],[3,"RSplitN","std::str","/// Created with the method `.rsplitn()`.",null,null],[8,"FromStr","","A trait to abstract the idea of creating a new instance of a type from a\nstring.",null,null],[16,"Err","std::str::FromStr","The associated error which can be returned from parsing.",null,null],[10,"from_str","std::str","Parses a string `s` to return an optional value of this type. If the\nstring is ill-formatted, the None is returned.",315,{"inputs":[{"name":"fromstr"},{"name":"str"}],"output":{"name":"result"}}],[3,"Words","","An iterator over the words of a string, separated by a sequence of whitespace",null,null],[3,"Split","","/// Created with the method `.split()`.",null,null],[3,"Graphemes","","External iterator for a string's\n[grapheme clusters](http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries).",null,null],[3,"LinesAny","","Created with the method `.lines_any()`.",null,null],[3,"Utf8Error","","Errors which can occur when attempting to interpret a byte slice as a `str`.",null,null],[3,"MatchIndices","","/// Created with the method `.match_indices()`.",null,null],[3,"RSplitTerminator","","/// Created with the method `.rsplit_terminator()`.",null,null],[3,"Chars","","Iterator for the char (representing *Unicode Scalar Values*) of a string",null,null],[3,"CharIndices","","Iterator for a string's characters and their byte offsets.",null,null],[3,"RMatchIndices","","/// Created with the method `.rmatch_indices()`.",null,null],[0,"string","std","An owned, growable string that enforces that its contents are valid UTF-8.",null,null],[3,"String","std::string","A growable string stored as a UTF-8 encoded buffer.",null,null],[3,"FromUtf8Error","","A possible error value from the `String::from_utf8` function.",null,null],[3,"FromUtf16Error","","A possible error value from the `String::from_utf16` function.",null,null],[3,"DerefString","","Wrapper type providing a `&String` reference via `Deref`.",null,null],[5,"as_string","","Converts a string slice to a wrapper type providing a `&String` reference.",null,{"inputs":[{"name":"str"}],"output":{"name":"derefstring"}}],[3,"ParseError","","Error returned from `String::from_str`",null,null],[8,"ToString","","A generic trait for converting a value to a string",null,null],[10,"to_string","","Converts the value of `self` to an owned string",316,{"inputs":[{"name":"tostring"}],"output":{"name":"string"}}],[0,"vec","std","A growable list type with heap-allocated contents, written `Vec<T>` but\npronounced 'vector.'",null,null],[3,"Vec","std::vec","A growable list type, written `Vec<T>` but pronounced 'vector.'",null,null],[3,"IntoIter","","An iterator that moves out of a vector.",null,null],[3,"Drain","","An iterator that drains a vector.",null,null],[3,"DerefVec","","Wrapper type providing a `&Vec<T>` reference via `Deref`.",null,null],[5,"as_vec","","Converts a slice to a wrapper type providing a `&Vec<T>` reference.",null,null],[0,"char","std","Character manipulation (`char` type, Unicode Scalar Value)",null,null],[3,"ToLowercase","std::char","An iterator over the lowercase mapping of a given character, returned from\nthe [`to_lowercase` method](../primitive.char.html#method.to_lowercase) on\ncharacters.",null,null],[3,"ToUppercase","","An iterator over the uppercase mapping of a given character, returned from\nthe [`to_uppercase` method](../primitive.char.html#method.to_uppercase) on\ncharacters.",null,null],[5,"decompose_canonical","","Compute canonical Unicode decomposition for character",null,null],[17,"MAX","","The highest valid code point",null,null],[3,"EscapeUnicode","","An iterator over the characters that represent a `char`, as escaped by\nRust's unicode escaping rules.",null,null],[3,"EscapeDefault","","An iterator over the characters that represent a `char`, escaped\nfor maximum portability.",null,null],[5,"from_u32","","Converts a `u32` to an `Option<char>`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[5,"canonical_combining_class","","",null,{"inputs":[{"name":"char"}],"output":{"name":"u8"}}],[5,"compose","","",null,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"option"}}],[5,"from_digit","","Converts a number to the character representing it.",null,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[17,"UNICODE_VERSION","","The version of [Unicode](http://www.unicode.org/)\nthat the unicode parts of `CharExt` and `UnicodeStrPrelude` traits are based on.",null,null],[5,"decompose_compatible","","Compute canonical or compatible Unicode decomposition for character",null,null],[0,"error","std","Traits for working with Errors.",null,null],[8,"Error","std::error","Base functionality for all errors in Rust.",null,null],[10,"description","","A short description of the error.",317,{"inputs":[{"name":"error"}],"output":{"name":"str"}}],[11,"cause","","The lower-level cause of this error, if any.",317,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"from","std::boxed","",190,{"inputs":[{"name":"box"},{"name":"e"}],"output":{"name":"box"}}],[11,"from","","",190,{"inputs":[{"name":"box"},{"name":"e"}],"output":{"name":"box"}}],[11,"from","","",190,{"inputs":[{"name":"box"},{"name":"string"}],"output":{"name":"box"}}],[11,"from","","",190,{"inputs":[{"name":"box"},{"name":"str"}],"output":{"name":"box"}}],[11,"description","std::str","",99,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"str"}}],[11,"description","","",100,{"inputs":[{"name":"utf8error"}],"output":{"name":"str"}}],[11,"description","core::num","",4,{"inputs":[{"name":"parseinterror"}],"output":{"name":"str"}}],[11,"description","std::string","",263,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"str"}}],[11,"description","","",264,{"inputs":[{"name":"fromutf16error"}],"output":{"name":"str"}}],[11,"is","std","Returns true if the boxed type is the same as `T`",317,{"inputs":[{"name":"error"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",317,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",317,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",317,{"inputs":[{"name":"error"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",317,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",317,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",317,{"inputs":[{"name":"error"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",317,{"inputs":[{"name":"error"}],"output":{"name":"result"}}],[0,"prelude","","The Rust Prelude",null,null],[0,"v1","std::prelude","The first version of the prelude of The Rust Standard Library.",null,null],[0,"isize","std","Operations and constants for pointer-sized signed integers (`isize` type)",null,null],[17,"BITS","std::isize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i8","std","Operations and constants for signed 8-bits integers (`i8` type)",null,null],[17,"BITS","std::i8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i16","std","Operations and constants for signed 16-bits integers (`i16` type)",null,null],[17,"BITS","std::i16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i32","std","Operations and constants for signed 32-bits integers (`i32` type)",null,null],[17,"BITS","std::i32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"i64","std","Operations and constants for signed 64-bits integers (`i64` type)",null,null],[17,"BITS","std::i64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"usize","std","Operations and constants for pointer-sized unsigned integers (`usize` type)",null,null],[17,"BITS","std::usize","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u8","std","Operations and constants for unsigned 8-bits integers (`u8` type)",null,null],[17,"BITS","std::u8","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u16","std","Operations and constants for unsigned 16-bits integers (`u16` type)",null,null],[17,"BITS","std::u16","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u32","std","Operations and constants for unsigned 32-bits integers (`u32` type)",null,null],[17,"BITS","std::u32","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"u64","std","Operations and constants for unsigned 64-bits integer (`u64` type)",null,null],[17,"BITS","std::u64","",null,null],[17,"BYTES","","",null,null],[17,"MIN","","",null,null],[17,"MAX","","",null,null],[0,"f32","std","Operations and constants for 32-bits floats (`f32` type)",null,null],[17,"RADIX","std::f32","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[17,"MIN","","Smallest finite f32 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f32 value",null,null],[17,"MAX","","Largest finite f32 value",null,null],[0,"consts","","Basic mathematial constants.",null,null],[17,"PI","std::f32::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[0,"f64","std","Operations and constants for 64-bits floats (`f64` type)",null,null],[17,"RADIX","std::f64","",null,null],[17,"MANTISSA_DIGITS","","",null,null],[17,"DIGITS","","",null,null],[17,"EPSILON","","",null,null],[17,"MIN_EXP","","",null,null],[17,"MAX_EXP","","",null,null],[17,"MIN_10_EXP","","",null,null],[17,"MAX_10_EXP","","",null,null],[17,"NAN","","",null,null],[17,"INFINITY","","",null,null],[17,"NEG_INFINITY","","",null,null],[17,"MIN","","Smallest finite f64 value",null,null],[17,"MIN_POSITIVE","","Smallest positive, normalized f64 value",null,null],[17,"MAX","","Largest finite f64 value",null,null],[0,"consts","","Basic mathematial constants.",null,null],[17,"PI","std::f64::consts","Archimedes' constant",null,null],[17,"PI_2","","pi * 2.0",null,null],[17,"FRAC_PI_2","","pi/2.0",null,null],[17,"FRAC_PI_3","","pi/3.0",null,null],[17,"FRAC_PI_4","","pi/4.0",null,null],[17,"FRAC_PI_6","","pi/6.0",null,null],[17,"FRAC_PI_8","","pi/8.0",null,null],[17,"FRAC_1_PI","","1.0/pi",null,null],[17,"FRAC_2_PI","","2.0/pi",null,null],[17,"FRAC_2_SQRT_PI","","2.0/sqrt(pi)",null,null],[17,"SQRT_2","","sqrt(2.0)",null,null],[17,"FRAC_1_SQRT_2","","1.0/sqrt(2.0)",null,null],[17,"E","","Euler's number",null,null],[17,"LOG2_E","","log2(e)",null,null],[17,"LOG10_E","","log10(e)",null,null],[17,"LN_2","","ln(2.0)",null,null],[17,"LN_10","","ln(10.0)",null,null],[0,"ascii","std","Operations on ASCII strings and characters",null,null],[3,"EscapeDefault","std::ascii","An iterator over the escaped version of a byte, constructed via\n`std::ascii::escape_default`.",null,null],[5,"escape_default","","Returns an iterator that produces an escaped version of a `u8`.",null,{"inputs":[{"name":"u8"}],"output":{"name":"escapedefault"}}],[8,"OwnedAsciiExt","","Extension methods for ASCII-subset only operations on owned strings",null,null],[10,"into_ascii_uppercase","","Converts the string to ASCII upper case:\nASCII letters 'a' to 'z' are mapped to 'A' to 'Z',\nbut non-ASCII letters are unchanged.",318,{"inputs":[{"name":"ownedasciiext"}],"output":{"name":"self"}}],[10,"into_ascii_lowercase","","Converts the string to ASCII lower case:\nASCII letters 'A' to 'Z' are mapped to 'a' to 'z',\nbut non-ASCII letters are unchanged.",318,{"inputs":[{"name":"ownedasciiext"}],"output":{"name":"self"}}],[8,"AsciiExt","","Extension methods for ASCII-subset only operations on string slices.",null,null],[16,"Owned","std::ascii::AsciiExt","Container type for copied ASCII characters.",null,null],[10,"is_ascii","std::ascii","Checks if within the ASCII range.",319,{"inputs":[{"name":"asciiext"}],"output":{"name":"bool"}}],[10,"to_ascii_uppercase","","Makes a copy of the string in ASCII upper case.",319,{"inputs":[{"name":"asciiext"}],"output":{"name":"owned"}}],[10,"to_ascii_lowercase","","Makes a copy of the string in ASCII lower case.",319,{"inputs":[{"name":"asciiext"}],"output":{"name":"owned"}}],[10,"eq_ignore_ascii_case","","Checks that two strings are an ASCII case-insensitive match.",319,{"inputs":[{"name":"asciiext"},{"name":"self"}],"output":{"name":"bool"}}],[10,"make_ascii_uppercase","","Converts this type to its ASCII upper case equivalent in-place.",319,{"inputs":[{"name":"asciiext"}],"output":null}],[10,"make_ascii_lowercase","","Converts this type to its ASCII lower case equivalent in-place.",319,{"inputs":[{"name":"asciiext"}],"output":null}],[6,"Owned","","",null,null],[11,"into_ascii_uppercase","std::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"into_ascii_lowercase","","",262,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[6,"Owned","std::ascii","",null,null],[11,"into_ascii_uppercase","std::vec","",253,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"into_ascii_lowercase","","",253,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[6,"Owned","std::ascii","",null,null],[6,"Owned","","",null,null],[6,"Item","","",null,null],[11,"next","","",320,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[11,"size_hint","","",320,null],[11,"next_back","","",320,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[0,"thunk","std","",null,null],[6,"Thunk","std::thunk","",null,null],[0,"num","std","Numeric traits and functions for generic mathematics",null,null],[8,"Zero","std::num","Types that have a \"zero\" value.",null,null],[10,"zero","","The \"zero\" (usually, additive identity) for this type.",321,{"inputs":[{"name":"zero"}],"output":{"name":"self"}}],[8,"One","","Types that have a \"one\" value.",null,null],[10,"one","","The \"one\" (usually, multiplicative identity) for this type.",322,{"inputs":[{"name":"one"}],"output":{"name":"self"}}],[4,"FpCategory","","Used for representing the classification of floating point numbers",null,null],[13,"Nan","","\"Not a Number\", often obtained by dividing by zero",3,null],[13,"Infinite","","Positive or negative infinity",3,null],[13,"Zero","","Positive or negative zero",3,null],[13,"Subnormal","","De-normalized floating point representation (less precise than `Normal`)",3,null],[13,"Normal","","A regular floating point number",3,null],[3,"ParseIntError","","An error which can be returned when parsing an integer.",null,null],[0,"wrapping","","",null,null],[8,"OverflowingOps","std::num::wrapping","",null,null],[10,"overflowing_add","","",323,null],[10,"overflowing_sub","","",323,null],[10,"overflowing_mul","","",323,null],[10,"overflowing_div","","",323,null],[10,"overflowing_rem","","",323,null],[10,"overflowing_shl","","",323,null],[10,"overflowing_shr","","",323,null],[3,"Wrapping","std::num","Provides intentionally-wrapped arithmetic on `T`.",null,null],[3,"ParseFloatError","","An error which can be returned when parsing a float.",null,null],[11,"eq","","",324,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",324,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",324,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",324,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",324,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"str"}}],[11,"fmt","","",324,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"thread","std","Native threads",null,null],[3,"LocalKey","std::thread","A thread local storage key which owns its contents.",null,null],[3,"ScopedKey","","Type representing a thread local storage key corresponding to a reference\nto the type parameter `T`.",null,null],[3,"Builder","","Thread configuration. Provides detailed control over the properties\nand behavior of new threads.",null,null],[3,"Thread","","A handle to a thread.",null,null],[3,"JoinHandle","","An owned permission to join on a thread (block on its termination).",null,null],[3,"JoinGuard","","An RAII-style guard that will block until thread termination when dropped.",null,null],[4,"LocalKeyState","","Indicator of the state of a thread local storage key.",null,null],[13,"Uninitialized","","All keys are in this state whenever a thread starts. Keys will\ntransition to the `Valid` state once the first call to `with` happens\nand the initialization expression succeeds.",325,null],[13,"Valid","","Once a key has been accessed successfully, it will enter the `Valid`\nstate. Keys in the `Valid` state will remain so until the thread exits,\nat which point the destructor will be run and the key will enter the\n`Destroyed` state.",325,null],[13,"Destroyed","","When a thread exits, the destructors for keys will be run (if\nnecessary). While a destructor is running, and possibly after a\ndestructor has run, a key is in the `Destroyed` state.",325,null],[5,"spawn","","Spawns a new thread, returning a `JoinHandle` for it.",null,{"inputs":[{"name":"f"}],"output":{"name":"joinhandle"}}],[5,"scoped","","Spawns a new *scoped* thread, returning a `JoinGuard` for it.",null,{"inputs":[{"name":"f"}],"output":{"name":"joinguard"}}],[5,"current","","Gets a handle to the thread that invokes it.",null,{"inputs":[],"output":{"name":"thread"}}],[5,"yield_now","","Cooperatively gives up a timeslice to the OS scheduler.",null,{"inputs":[],"output":null}],[5,"panicking","","Determines whether the current thread is unwinding because of panic.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"catch_panic","","Invokes a closure, capturing the cause of panic if one occurs.",null,{"inputs":[{"name":"f"}],"output":{"name":"result"}}],[5,"sleep_ms","","Puts the current thread to sleep for the specified amount of time.",null,{"inputs":[{"name":"u32"}],"output":null}],[5,"park","","Blocks unless or until the current thread's token is made available (may wake spuriously).",null,{"inputs":[],"output":null}],[5,"park_timeout_ms","","Blocks unless or until the current thread's token is made available or\nthe specified duration has been reached (may wake spuriously).",null,{"inputs":[{"name":"u32"}],"output":null}],[11,"clone","","",325,{"inputs":[{"name":"localkeystate"}],"output":{"name":"localkeystate"}}],[11,"eq","","",325,{"inputs":[{"name":"localkeystate"},{"name":"localkeystate"}],"output":{"name":"bool"}}],[11,"ne","","",325,{"inputs":[{"name":"localkeystate"},{"name":"localkeystate"}],"output":{"name":"bool"}}],[11,"with","","Acquires a reference to the value in this TLS key.",326,{"inputs":[{"name":"localkey"},{"name":"f"}],"output":{"name":"r"}}],[11,"state","","Query the current state of this key.",326,{"inputs":[{"name":"localkey"}],"output":{"name":"localkeystate"}}],[11,"set","","Inserts a value into this scoped thread local storage slot for a\nduration of a closure.",327,{"inputs":[{"name":"scopedkey"},{"name":"t"},{"name":"f"}],"output":{"name":"r"}}],[11,"with","","Gets a value out of this scoped variable.",327,{"inputs":[{"name":"scopedkey"},{"name":"f"}],"output":{"name":"r"}}],[11,"is_set","","Test whether this TLS key has been `set` for the current thread.",327,{"inputs":[{"name":"scopedkey"}],"output":{"name":"bool"}}],[6,"Result","","Indicates the manner in which a thread exited.",null,null],[11,"new","","Generates the base configuration for spawning a thread, from which\nconfiguration methods can be chained.",328,{"inputs":[{"name":"builder"}],"output":{"name":"builder"}}],[11,"name","","Names the thread-to-be. Currently the name is used for identification\nonly in panic messages.",328,{"inputs":[{"name":"builder"},{"name":"string"}],"output":{"name":"builder"}}],[11,"stack_size","","Sets the size of the stack for the new thread.",328,{"inputs":[{"name":"builder"},{"name":"usize"}],"output":{"name":"builder"}}],[11,"spawn","","Spawns a new thread, and returns a join handle for it.",328,{"inputs":[{"name":"builder"},{"name":"f"}],"output":{"name":"result"}}],[11,"scoped","","Spawns a new child thread that must be joined within a given\nscope, and returns a `JoinGuard`.",328,{"inputs":[{"name":"builder"},{"name":"f"}],"output":{"name":"result"}}],[11,"clone","","",329,{"inputs":[{"name":"thread"}],"output":{"name":"thread"}}],[11,"unpark","","Atomically makes the handle's token available if it is not already.",329,{"inputs":[{"name":"thread"}],"output":null}],[11,"name","","Gets the thread's name.",329,{"inputs":[{"name":"thread"}],"output":{"name":"option"}}],[11,"fmt","","",329,{"inputs":[{"name":"thread"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","",329,{"inputs":[{"name":"thread"},{"name":"option"}],"output":{"name":"thread"}}],[11,"thread","","Extracts a handle to the underlying thread",330,{"inputs":[{"name":"joinhandle"}],"output":{"name":"thread"}}],[11,"join","","Waits for the associated thread to finish.",330,{"inputs":[{"name":"joinhandle"}],"output":{"name":"result"}}],[11,"drop","","",330,{"inputs":[{"name":"joinhandle"}],"output":null}],[11,"thread","","Extracts a handle to the thread this guard will join on.",331,{"inputs":[{"name":"joinguard"}],"output":{"name":"thread"}}],[11,"join","","Waits for the associated thread to finish, returning the result of the\nthread's calculation.",331,{"inputs":[{"name":"joinguard"}],"output":{"name":"t"}}],[11,"drop","","",331,{"inputs":[{"name":"joinguard"}],"output":null}],[0,"collections","std","Collection types.",null,null],[4,"Bound","std::collections","An endpoint of a range of keys.",null,null],[13,"Included","","An inclusive bound.",287,null],[13,"Excluded","","An exclusive bound.",287,null],[13,"Unbounded","","An infinite endpoint. Indicates that there is no bound in this direction.",287,null],[3,"BinaryHeap","","A priority queue implemented with a binary heap.",null,null],[3,"BitVec","","The bitvector type.",null,null],[3,"BitSet","","An implementation of a set using a bit vector as an underlying\nrepresentation for holding unsigned numerical elements.",null,null],[3,"BTreeMap","","A map based on a B-Tree.",null,null],[3,"BTreeSet","","A set based on a B-Tree.",null,null],[3,"LinkedList","","A doubly-linked list.",null,null],[3,"VecDeque","","`VecDeque` is a growable ring buffer, which can be used as a\ndouble-ended queue efficiently.",null,null],[3,"VecMap","","A map optimized for small integer keys.",null,null],[0,"binary_heap","","A priority queue implemented with a binary heap.",null,null],[3,"BinaryHeap","std::collections::binary_heap","A priority queue implemented with a binary heap.",null,null],[3,"Iter","","`BinaryHeap` iterator.",null,null],[3,"IntoIter","","An iterator that moves out of a `BinaryHeap`.",null,null],[3,"Drain","","An iterator that drains a `BinaryHeap`.",null,null],[0,"bit_vec","std::collections","",null,null],[3,"Iter","std::collections::bit_vec","An iterator for `BitVec`.",null,null],[3,"BitVec","","The bitvector type.",null,null],[0,"bit_set","std::collections","",null,null],[3,"SetIter","std::collections::bit_set","An iterator for `BitSet`.",null,null],[3,"SymmetricDifference","","",null,null],[3,"Intersection","","",null,null],[3,"Union","","",null,null],[3,"BitSet","","An implementation of a set using a bit vector as an underlying\nrepresentation for holding unsigned numerical elements.",null,null],[3,"Difference","","",null,null],[0,"btree_map","std::collections","",null,null],[3,"Keys","std::collections::btree_map","An iterator over a BTreeMap's keys.",null,null],[3,"IntoIter","","An owning iterator over a BTreeMap's entries.",null,null],[3,"BTreeMap","","A map based on a B-Tree.",null,null],[3,"Iter","","An iterator over a BTreeMap's entries.",null,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",234,null],[13,"Occupied","","An occupied Entry",234,null],[3,"IterMut","","A mutable iterator over a BTreeMap's entries.",null,null],[3,"Values","","An iterator over a BTreeMap's values.",null,null],[3,"RangeMut","","A mutable iterator over a sub-range of BTreeMap's entries.",null,null],[3,"Range","","An iterator over a sub-range of BTreeMap's entries.",null,null],[0,"btree_set","std::collections","",null,null],[3,"Iter","std::collections::btree_set","An iterator over a BTreeSet's items.",null,null],[3,"Range","","An iterator over a sub-range of BTreeSet's items.",null,null],[3,"IntoIter","","An owning iterator over a BTreeSet's items.",null,null],[3,"BTreeSet","","A set based on a B-Tree.",null,null],[3,"Difference","","A lazy iterator producing elements in the set difference (in-order).",null,null],[3,"Intersection","","A lazy iterator producing elements in the set intersection (in-order).",null,null],[3,"Union","","A lazy iterator producing elements in the set union (in-order).",null,null],[3,"SymmetricDifference","","A lazy iterator producing elements in the set symmetric difference (in-order).",null,null],[0,"linked_list","std::collections","A doubly-linked list with owned nodes.",null,null],[3,"LinkedList","std::collections::linked_list","A doubly-linked list.",null,null],[3,"Iter","","An iterator over references to the items of a `LinkedList`.",null,null],[3,"IterMut","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[3,"IntoIter","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[0,"vec_deque","std::collections","VecDeque is a double-ended queue, which is implemented with the help of a\ngrowing ring buffer.",null,null],[3,"VecDeque","std::collections::vec_deque","`VecDeque` is a growable ring buffer, which can be used as a\ndouble-ended queue efficiently.",null,null],[3,"Iter","","`VecDeque` iterator.",null,null],[3,"IterMut","","`VecDeque` mutable iterator.",null,null],[3,"IntoIter","","A by-value VecDeque iterator",null,null],[3,"Drain","","A draining VecDeque iterator",null,null],[0,"vec_map","std::collections","A simple map based on a vector for small integer keys. Space requirements\nare O(highest integer key).",null,null],[3,"VecMap","std::collections::vec_map","A map optimized for small integer keys.",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",278,null],[13,"Occupied","","An occupied Entry",278,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[3,"Iter","","An iterator over the key-value pairs of a map.",null,null],[3,"IterMut","","An iterator over the key-value pairs of a map, with the\nvalues being mutable.",null,null],[3,"Keys","","An iterator over the keys of a map.",null,null],[3,"Values","","An iterator over the values of a map.",null,null],[3,"IntoIter","","A consuming iterator over the key-value pairs of a map.",null,null],[3,"Drain","","",null,null],[3,"HashMap","std::collections","A hash map implementation which uses linear probing with Robin\nHood bucket stealing.",null,null],[3,"HashSet","","An implementation of a hash set using the underlying representation of a\nHashMap where the value is (). As with the `HashMap` type, a `HashSet`\nrequires that the elements implement the `Eq` and `Hash` traits. This can\nfrequently be achieved by using `#[derive(Eq, Hash)]`. If you implement\nthese yourself, it is important that the following property holds:",null,null],[11,"clone","","",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"hashmap"}}],[11,"new","","Creates an empty HashMap.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"hashmap"}}],[11,"with_capacity","","Creates an empty hash map with the given initial capacity.",332,{"inputs":[{"name":"hashmap"},{"name":"usize"}],"output":{"name":"hashmap"}}],[11,"with_hash_state","","Creates an empty hashmap which will use the given hasher to hash keys.",332,{"inputs":[{"name":"hashmap"},{"name":"s"}],"output":{"name":"hashmap"}}],[11,"with_capacity_and_hash_state","","Creates an empty HashMap with space for at least `capacity`\nelements, using `hasher` to hash the keys.",332,{"inputs":[{"name":"hashmap"},{"name":"usize"},{"name":"s"}],"output":{"name":"hashmap"}}],[11,"capacity","","Returns the number of elements the map can hold without reallocating.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the `HashMap`. The collection may reserve more space to avoid\nfrequent reallocations.",332,{"inputs":[{"name":"hashmap"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the map as much as possible. It will drop\ndown as much as possible while maintaining the internal rules\nand possibly leaving some space in accordance with the resize policy.",332,{"inputs":[{"name":"hashmap"}],"output":null}],[11,"keys","","An iterator visiting all keys in arbitrary order.\nIterator element type is `&'a K`.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"keys"}}],[11,"values","","An iterator visiting all values in arbitrary order.\nIterator element type is `&'a V`.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"values"}}],[11,"iter","","An iterator visiting all key-value pairs in arbitrary order.\nIterator element type is `(&'a K, &'a V)`.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"iter"}}],[11,"iter_mut","","An iterator visiting all key-value pairs in arbitrary order,\nwith mutable references to the values.\nIterator element type is `(&'a K, &'a mut V)`.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"itermut"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",332,{"inputs":[{"name":"hashmap"},{"name":"k"}],"output":{"name":"entry"}}],[11,"len","","Returns the number of elements in the map.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"bool"}}],[11,"drain","","Clears the map, returning all key-value pairs as an iterator. Keeps the\nallocated memory for reuse.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"drain"}}],[11,"clear","","Clears the map, removing all key-value pairs. Keeps the allocated memory\nfor reuse.",332,{"inputs":[{"name":"hashmap"}],"output":null}],[11,"get","","Returns a reference to the value corresponding to the key.",332,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",332,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",332,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",332,{"inputs":[{"name":"hashmap"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",332,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"option"}}],[11,"eq","","",332,{"inputs":[{"name":"hashmap"},{"name":"hashmap"}],"output":{"name":"bool"}}],[11,"fmt","","",332,{"inputs":[{"name":"hashmap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"hashmap"}}],[11,"index","","",332,{"inputs":[{"name":"hashmap"},{"name":"q"}],"output":{"name":"v"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each key-value\npair out of the map in arbitrary order. The map cannot be used after\ncalling this.",332,{"inputs":[{"name":"hashmap"}],"output":{"name":"intoiter"}}],[11,"from_iter","","",332,{"inputs":[{"name":"hashmap"},{"name":"t"}],"output":{"name":"hashmap"}}],[11,"extend","","",332,{"inputs":[{"name":"hashmap"},{"name":"t"}],"output":null}],[11,"clone","","",333,{"inputs":[{"name":"hashset"}],"output":{"name":"hashset"}}],[11,"new","","Creates an empty HashSet.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"hashset"}}],[11,"with_capacity","","Creates an empty HashSet with space for at least `n` elements in\nthe hash table.",333,{"inputs":[{"name":"hashset"},{"name":"usize"}],"output":{"name":"hashset"}}],[11,"with_hash_state","","Creates a new empty hash set which will use the given hasher to hash\nkeys.",333,{"inputs":[{"name":"hashset"},{"name":"s"}],"output":{"name":"hashset"}}],[11,"with_capacity_and_hash_state","","Creates an empty HashSet with space for at least `capacity`\nelements in the hash table, using `hasher` to hash the keys.",333,{"inputs":[{"name":"hashset"},{"name":"usize"},{"name":"s"}],"output":{"name":"hashset"}}],[11,"capacity","","Returns the number of elements the set can hold without reallocating.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the `HashSet`. The collection may reserve more space to avoid\nfrequent reallocations.",333,{"inputs":[{"name":"hashset"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the set as much as possible. It will drop\ndown as much as possible while maintaining the internal rules\nand possibly leaving some space in accordance with the resize policy.",333,{"inputs":[{"name":"hashset"}],"output":null}],[11,"iter","","An iterator visiting all elements in arbitrary order.\nIterator element type is &'a T.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"iter"}}],[11,"difference","","Visit the values representing the difference.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Visit the values representing the symmetric difference.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"symmetricdifference"}}],[11,"intersection","","Visit the values representing the intersection.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"intersection"}}],[11,"union","","Visit the values representing the union.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"union"}}],[11,"len","","Returns the number of elements in the set.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the set contains no elements.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"bool"}}],[11,"drain","","Clears the set, returning all elements in an iterator.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"drain"}}],[11,"clear","","Clears the set, removing all values.",333,{"inputs":[{"name":"hashset"}],"output":null}],[11,"contains","","Returns `true` if the set contains a value.",333,{"inputs":[{"name":"hashset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",333,{"inputs":[{"name":"hashset"},{"name":"t"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",333,{"inputs":[{"name":"hashset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"eq","","",333,{"inputs":[{"name":"hashset"},{"name":"hashset"}],"output":{"name":"bool"}}],[11,"fmt","","",333,{"inputs":[{"name":"hashset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",333,{"inputs":[{"name":"hashset"},{"name":"i"}],"output":{"name":"hashset"}}],[11,"extend","","",333,{"inputs":[{"name":"hashset"},{"name":"i"}],"output":null}],[11,"default","","",333,{"inputs":[{"name":"hashset"}],"output":{"name":"hashset"}}],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out\nof the set in arbitrary order. The set cannot be used after calling\nthis.",333,{"inputs":[{"name":"hashset"}],"output":{"name":"intoiter"}}],[0,"hash_map","","A hashmap",null,null],[3,"HashMap","std::collections::hash_map","A hash map implementation which uses linear probing with Robin\nHood bucket stealing.",null,null],[3,"Iter","","HashMap iterator.",null,null],[3,"IterMut","","HashMap mutable values iterator.",null,null],[3,"IntoIter","","HashMap move iterator.",null,null],[3,"Keys","","HashMap keys iterator.",null,null],[3,"Values","","HashMap values iterator.",null,null],[3,"Drain","","HashMap drain iterator.",null,null],[3,"OccupiedEntry","","A view into a single occupied location in a HashMap.",null,null],[3,"VacantEntry","","A view into a single empty location in a HashMap.",null,null],[3,"RandomState","","`RandomState` is the default state for `HashMap` types.",null,null],[4,"Entry","","A view into a single location in a map, which may be vacant or occupied.",null,null],[13,"Occupied","","An occupied Entry.",334,null],[13,"Vacant","","A vacant Entry.",334,null],[17,"INITIAL_CAPACITY","","",null,null],[0,"hash_set","std::collections","A hashset",null,null],[3,"HashSet","std::collections::hash_set","An implementation of a hash set using the underlying representation of a\nHashMap where the value is (). As with the `HashMap` type, a `HashSet`\nrequires that the elements implement the `Eq` and `Hash` traits. This can\nfrequently be achieved by using `#[derive(Eq, Hash)]`. If you implement\nthese yourself, it is important that the following property holds:",null,null],[3,"Iter","","HashSet iterator",null,null],[3,"IntoIter","","HashSet move iterator",null,null],[3,"Drain","","HashSet drain iterator",null,null],[3,"Intersection","","Intersection iterator",null,null],[3,"Difference","","Difference iterator",null,null],[3,"SymmetricDifference","","Symmetric difference iterator.",null,null],[3,"Union","","Set union iterator.",null,null],[0,"hash_state","std::collections","Experimental support for providing custom hash algorithms to a HashMap and\nHashSet.",null,null],[3,"DefaultState","std::collections::hash_state","A structure which is a factory for instances of `Hasher` which implement the\ndefault trait.",null,null],[8,"HashState","","A trait representing stateful hashes which can be used to hash keys in a\n`HashMap`.",null,null],[16,"Hasher","std::collections::hash_state::HashState","Type of the hasher that will be created.",null,null],[10,"hasher","std::collections::hash_state","Creates a new hasher based on the given state of this object.",335,{"inputs":[{"name":"hashstate"}],"output":{"name":"hasher"}}],[0,"dynamic_lib","std","Dynamic library facilities.",null,null],[3,"DynamicLibrary","std::dynamic_lib","",null,null],[11,"drop","","",336,{"inputs":[{"name":"dynamiclibrary"}],"output":null}],[11,"open","","Lazily open a dynamic library. When passed None it gives a\nhandle to the calling process",336,{"inputs":[{"name":"dynamiclibrary"},{"name":"option"}],"output":{"name":"result"}}],[11,"prepend_search_path","","Prepends a path to this process's search path for dynamic libraries",336,{"inputs":[{"name":"dynamiclibrary"},{"name":"path"}],"output":null}],[11,"create_path","","From a slice of paths, create a new vector which is suitable to be an\nenvironment variable for this platforms dylib search path.",336,null],[11,"envvar","","Returns the environment variable for this process's dynamic library\nsearch path",336,{"inputs":[{"name":"dynamiclibrary"}],"output":{"name":"str"}}],[11,"search_path","","Returns the current search path for dynamic libraries being used by this\nprocess",336,{"inputs":[{"name":"dynamiclibrary"}],"output":{"name":"vec"}}],[11,"symbol","","Accesses the value at the symbol of the dynamic library.",336,{"inputs":[{"name":"dynamiclibrary"},{"name":"str"}],"output":{"name":"result"}}],[0,"env","std","Inspection and manipulation of the process's environment.",null,null],[3,"Vars","std::env","An iterator over a snapshot of the environment variables of this process.",null,null],[3,"VarsOs","","An iterator over a snapshot of the environment variables of this process.",null,null],[3,"SplitPaths","","An iterator over `Path` instances for parsing an environment variable\naccording to platform-specific conventions.",null,null],[3,"JoinPathsError","","Error type returned from `std::env::join_paths` when paths fail to be\njoined.",null,null],[3,"Args","","An iterator over the arguments of a process, yielding a `String` value\nfor each argument.",null,null],[3,"ArgsOs","","An iterator over the arguments of a process, yielding an `OsString` value\nfor each argument.",null,null],[4,"VarError","","Possible errors from the `env::var` method.",null,null],[13,"NotPresent","","The specified environment variable was not present in the current\nprocess's environment.",337,null],[13,"NotUnicode","","The specified environment variable was found, but it did not contain\nvalid unicode data. The found data is returned as a payload of this\nvariant.",337,null],[5,"current_dir","","Returns the current working directory as a `Path`.",null,{"inputs":[],"output":{"name":"result"}}],[5,"set_current_dir","","Changes the current working directory to the specified path, returning\nwhether the change was completed successfully or not.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"vars","","Returns an iterator of (variable, value) pairs of strings, for all the\nenvironment variables of the current process.",null,{"inputs":[],"output":{"name":"vars"}}],[5,"vars_os","","Returns an iterator of (variable, value) pairs of OS strings, for all the\nenvironment variables of the current process.",null,{"inputs":[],"output":{"name":"varsos"}}],[5,"var","","Fetches the environment variable `key` from the current process.",null,{"inputs":[{"name":"k"}],"output":{"name":"result"}}],[5,"var_os","","Fetches the environment variable `key` from the current process, returning\nNone if the variable isn't set.",null,{"inputs":[{"name":"k"}],"output":{"name":"option"}}],[5,"set_var","","Sets the environment variable `k` to the value `v` for the currently running\nprocess.",null,{"inputs":[{"name":"k"},{"name":"v"}],"output":null}],[5,"remove_var","","Removes an environment variable from the environment of the currently running process.",null,{"inputs":[{"name":"k"}],"output":null}],[5,"split_paths","","Parses input according to platform conventions for the `PATH`\nenvironment variable.",null,{"inputs":[{"name":"t"}],"output":{"name":"splitpaths"}}],[5,"join_paths","","Joins a collection of `Path`s appropriately for the `PATH`\nenvironment variable.",null,{"inputs":[{"name":"i"}],"output":{"name":"result"}}],[5,"home_dir","","Optionally returns the path to the current user's home directory if known.",null,{"inputs":[],"output":{"name":"option"}}],[5,"temp_dir","","Returns the path to a temporary directory.",null,{"inputs":[],"output":{"name":"pathbuf"}}],[5,"current_exe","","Optionally returns the filesystem path to the current executable which is\nrunning but with the executable name.",null,{"inputs":[],"output":{"name":"result"}}],[5,"set_exit_status","","Sets the process exit code",null,{"inputs":[{"name":"i32"}],"output":null}],[5,"get_exit_status","","Fetches the process's current exit code. This defaults to 0 and can change\nby calling `set_exit_status`.",null,{"inputs":[],"output":{"name":"i32"}}],[5,"args","","Returns the arguments which this program was started with (normally passed\nvia the command line).",null,{"inputs":[],"output":{"name":"args"}}],[5,"args_os","","Returns the arguments which this program was started with (normally passed\nvia the command line).",null,{"inputs":[],"output":{"name":"argsos"}}],[5,"page_size","","Returns the page size of the current architecture in bytes.",null,{"inputs":[],"output":{"name":"usize"}}],[0,"consts","","Constants associated with the current target",null,null],[17,"ARCH","std::env::consts","A string describing the architecture of the CPU that this is currently\nin use.",null,null],[17,"FAMILY","","The family of the operating system. In this case, `unix`.",null,null],[17,"OS","","A string describing the specific operating system in use: in this\ncase, `linux`.",null,null],[17,"DLL_PREFIX","","Specifies the filename prefix used for shared libraries on this\nplatform: in this case, `lib`.",null,null],[17,"DLL_SUFFIX","","Specifies the filename suffix used for shared libraries on this\nplatform: in this case, `.so`.",null,null],[17,"DLL_EXTENSION","","Specifies the file extension used for shared libraries on this\nplatform that goes after the dot: in this case, `so`.",null,null],[17,"EXE_SUFFIX","","Specifies the filename suffix used for executable binaries on this\nplatform: in this case, the empty string.",null,null],[17,"EXE_EXTENSION","","Specifies the file extension, if any, used for executable binaries\non this platform: in this case, the empty string.",null,null],[6,"Item","std::env","",null,null],[11,"next","","",338,{"inputs":[{"name":"vars"}],"output":{"name":"option"}}],[11,"size_hint","","",338,null],[6,"Item","","",null,null],[11,"next","","",339,{"inputs":[{"name":"varsos"}],"output":{"name":"option"}}],[11,"size_hint","","",339,null],[11,"clone","","",337,{"inputs":[{"name":"varerror"}],"output":{"name":"varerror"}}],[11,"eq","","",337,{"inputs":[{"name":"varerror"},{"name":"varerror"}],"output":{"name":"bool"}}],[11,"ne","","",337,{"inputs":[{"name":"varerror"},{"name":"varerror"}],"output":{"name":"bool"}}],[11,"fmt","","",337,{"inputs":[{"name":"varerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",337,{"inputs":[{"name":"varerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",337,{"inputs":[{"name":"varerror"}],"output":{"name":"str"}}],[6,"Item","","",null,null],[11,"next","","",340,{"inputs":[{"name":"splitpaths"}],"output":{"name":"option"}}],[11,"size_hint","","",340,null],[11,"fmt","","",341,{"inputs":[{"name":"joinpathserror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",341,{"inputs":[{"name":"joinpathserror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",341,{"inputs":[{"name":"joinpathserror"}],"output":{"name":"str"}}],[6,"Item","","",null,null],[11,"next","","",342,{"inputs":[{"name":"args"}],"output":{"name":"option"}}],[11,"size_hint","","",342,null],[11,"len","","",342,{"inputs":[{"name":"args"}],"output":{"name":"usize"}}],[6,"Item","","",null,null],[11,"next","","",343,{"inputs":[{"name":"argsos"}],"output":{"name":"option"}}],[11,"size_hint","","",343,null],[11,"len","","",343,{"inputs":[{"name":"argsos"}],"output":{"name":"usize"}}],[0,"ffi","std","Utilities related to FFI bindings.",null,null],[3,"CString","std::ffi","A type representing an owned C-compatible string",null,null],[3,"CStr","","Representation of a borrowed C string.",null,null],[3,"NulError","","An error returned from `CString::new` to indicate that a nul byte was found\nin the vector provided.",null,null],[3,"OsString","","Owned, mutable OS strings.",null,null],[3,"OsStr","","Slices into OS strings.",null,null],[11,"hash","","",344,null],[11,"cmp","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"option"}}],[11,"lt","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"le","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"gt","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"ge","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"eq","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"ne","","",344,{"inputs":[{"name":"cstring"},{"name":"cstring"}],"output":{"name":"bool"}}],[11,"clone","","",344,{"inputs":[{"name":"cstring"}],"output":{"name":"cstring"}}],[11,"hash","","",345,null],[11,"fmt","","",346,{"inputs":[{"name":"nulerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",346,{"inputs":[{"name":"nulerror"},{"name":"nulerror"}],"output":{"name":"bool"}}],[11,"ne","","",346,{"inputs":[{"name":"nulerror"},{"name":"nulerror"}],"output":{"name":"bool"}}],[11,"clone","","",346,{"inputs":[{"name":"nulerror"}],"output":{"name":"nulerror"}}],[11,"new","","Creates a new C-compatible string from a container of bytes.",344,{"inputs":[{"name":"cstring"},{"name":"t"}],"output":{"name":"result"}}],[11,"from_vec_unchecked","","Creates a C-compatible string from a byte vector without checking for\ninterior 0 bytes.",344,{"inputs":[{"name":"cstring"},{"name":"vec"}],"output":{"name":"cstring"}}],[11,"as_bytes","","Returns the contents of this `CString` as a slice of bytes.",344,null],[11,"as_bytes_with_nul","","Equivalent to the `as_bytes` function except that the returned slice\nincludes the trailing nul byte.",344,null],[11,"deref","","",344,{"inputs":[{"name":"cstring"}],"output":{"name":"cstr"}}],[11,"fmt","","",344,{"inputs":[{"name":"cstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"nul_position","","Returns the position of the nul byte in the slice that was provided to\n`CString::new`.",346,{"inputs":[{"name":"nulerror"}],"output":{"name":"usize"}}],[11,"into_vec","","Consumes this error, returning the underlying vector of bytes which\ngenerated the error in the first place.",346,{"inputs":[{"name":"nulerror"}],"output":{"name":"vec"}}],[11,"description","","",346,{"inputs":[{"name":"nulerror"}],"output":{"name":"str"}}],[11,"fmt","","",346,{"inputs":[{"name":"nulerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_ptr","","Casts a raw C string to a safe C string wrapper.",345,null],[11,"as_ptr","","Returns the inner pointer to this C string.",345,null],[11,"to_bytes","","Converts this C string to a byte slice.",345,null],[11,"to_bytes_with_nul","","Converts this C string to a byte slice containing the trailing 0 byte.",345,null],[11,"eq","","",345,{"inputs":[{"name":"cstr"},{"name":"cstr"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",345,{"inputs":[{"name":"cstr"},{"name":"cstr"}],"output":{"name":"option"}}],[11,"cmp","","",345,{"inputs":[{"name":"cstr"},{"name":"cstr"}],"output":{"name":"ordering"}}],[11,"clone","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"osstring"}}],[11,"new","","Constructs a new empty `OsString`.",347,{"inputs":[{"name":"osstring"}],"output":{"name":"osstring"}}],[11,"from_bytes","","Constructs an `OsString` from a byte sequence.",347,{"inputs":[{"name":"osstring"},{"name":"b"}],"output":{"name":"option"}}],[11,"as_os_str","","Converts to an `OsStr` slice.",347,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"into_string","","Converts the `OsString` into a `String` if it contains valid Unicode data.",347,{"inputs":[{"name":"osstring"}],"output":{"name":"result"}}],[11,"push","","Extends the string with the given `&OsStr` slice.",347,{"inputs":[{"name":"osstring"},{"name":"t"}],"output":null}],[11,"from","","",347,{"inputs":[{"name":"osstring"},{"name":"string"}],"output":{"name":"osstring"}}],[11,"from","","",347,{"inputs":[{"name":"osstring"},{"name":"t"}],"output":{"name":"osstring"}}],[11,"index","","",347,{"inputs":[{"name":"osstring"},{"name":"rangefull"}],"output":{"name":"osstr"}}],[11,"deref","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"fmt","","",347,{"inputs":[{"name":"osstring"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"eq","","",347,{"inputs":[{"name":"osstring"},{"name":"str"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"option"}}],[11,"lt","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"le","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"gt","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"ge","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",347,{"inputs":[{"name":"osstring"},{"name":"str"}],"output":{"name":"option"}}],[11,"cmp","","",347,{"inputs":[{"name":"osstring"},{"name":"osstring"}],"output":{"name":"ordering"}}],[11,"hash","","",347,{"inputs":[{"name":"osstring"},{"name":"h"}],"output":null}],[11,"new","","Coerces into an `OsStr` slice.",348,{"inputs":[{"name":"osstr"},{"name":"s"}],"output":{"name":"osstr"}}],[11,"to_str","","Yields a `&str` slice if the `OsStr` is valid unicode.",348,{"inputs":[{"name":"osstr"}],"output":{"name":"option"}}],[11,"to_string_lossy","","Converts an `OsStr` to a `Cow<str>`.",348,{"inputs":[{"name":"osstr"}],"output":{"name":"cow"}}],[11,"to_os_string","","Copies the slice into an owned `OsString`.",348,{"inputs":[{"name":"osstr"}],"output":{"name":"osstring"}}],[11,"to_bytes","","Yields this `OsStr` as a byte slice.",348,{"inputs":[{"name":"osstr"}],"output":{"name":"option"}}],[11,"to_cstring","","Creates a `CString` containing this `OsStr` data.",348,{"inputs":[{"name":"osstr"}],"output":{"name":"option"}}],[11,"eq","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"eq","","",348,{"inputs":[{"name":"osstr"},{"name":"str"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"option"}}],[11,"lt","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"le","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"gt","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"ge","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",348,{"inputs":[{"name":"osstr"},{"name":"str"}],"output":{"name":"option"}}],[11,"cmp","","",348,{"inputs":[{"name":"osstr"},{"name":"osstr"}],"output":{"name":"ordering"}}],[11,"hash","","",348,{"inputs":[{"name":"osstr"},{"name":"h"}],"output":null}],[11,"fmt","","",348,{"inputs":[{"name":"osstr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"borrow","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"to_owned","","",348,{"inputs":[{"name":"osstr"}],"output":{"name":"osstring"}}],[11,"as_ref","","",348,{"inputs":[{"name":"osstr"}],"output":{"name":"osstr"}}],[11,"as_ref","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"osstr"}}],[11,"as_ref","std::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"osstr"}}],[0,"fs","std","Filesystem manipulation operations",null,null],[3,"File","std::fs","A reference to an open file on the filesystem.",null,null],[3,"Metadata","","Metadata information about a file.",null,null],[3,"ReadDir","","Iterator over the entries in a directory.",null,null],[3,"DirEntry","","Entries returned by the `ReadDir` iterator.",null,null],[3,"WalkDir","","An iterator that recursively walks over the contents of a directory.",null,null],[3,"OpenOptions","","Options and flags which can be used to configure how a file is opened.",null,null],[3,"Permissions","","Representation of the various permissions on a file.",null,null],[5,"remove_file","","Removes a file from the underlying filesystem.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"metadata","","Given a path, query the file system to get information about a file,\ndirectory, etc.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"rename","","Rename a file or directory to a new name.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"copy","","Copies the contents of one file to another. This function will also\ncopy the permission bits of the original file to the destination file.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"hard_link","","Creates a new hard link on the filesystem.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"soft_link","","Creates a new soft link on the filesystem.",null,{"inputs":[{"name":"p"},{"name":"q"}],"output":{"name":"result"}}],[5,"read_link","","Reads a soft link, returning the file that the link points to.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"create_dir","","Creates a new, empty directory at the provided path",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"create_dir_all","","Recursively create a directory and all of its parent components if they\nare missing.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"remove_dir","","Removes an existing, empty directory.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"remove_dir_all","","Removes a directory at this path, after removing all its contents. Use\ncarefully!",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"read_dir","","Returns an iterator over the entries within a directory.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"walk_dir","","Returns an iterator that will recursively walk the directory structure\nrooted at `path`.",null,{"inputs":[{"name":"p"}],"output":{"name":"result"}}],[5,"set_file_times","","Changes the timestamps for a file's last modification and access time.",null,{"inputs":[{"name":"p"},{"name":"u64"},{"name":"u64"}],"output":{"name":"result"}}],[5,"set_permissions","","Changes the permissions found on a file or a directory.",null,{"inputs":[{"name":"p"},{"name":"permissions"}],"output":{"name":"result"}}],[8,"PathExt","","Utility methods for paths.",null,null],[10,"metadata","","Gets information on the file, directory, etc at this path.",349,{"inputs":[{"name":"pathext"}],"output":{"name":"result"}}],[10,"exists","","Boolean value indicator whether the underlying file exists on the local\nfilesystem. Returns false in exactly the cases where `fs::stat` fails.",349,{"inputs":[{"name":"pathext"}],"output":{"name":"bool"}}],[10,"is_file","","Whether the underlying implementation (be it a file path, or something\nelse) points at a \"regular file\" on the FS. Will return false for paths\nto non-existent locations or directories or other non-regular files\n(named pipes, etc). Follows links when making this determination.",349,{"inputs":[{"name":"pathext"}],"output":{"name":"bool"}}],[10,"is_dir","","Whether the underlying implementation (be it a file path, or something\nelse) is pointing at a directory in the underlying FS. Will return\nfalse for paths to non-existent locations or if the item is not a\ndirectory (eg files, named pipes, etc). Follows links when making this\ndetermination.",349,{"inputs":[{"name":"pathext"}],"output":{"name":"bool"}}],[11,"clone","","",350,{"inputs":[{"name":"openoptions"}],"output":{"name":"openoptions"}}],[11,"fmt","","",351,{"inputs":[{"name":"permissions"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",351,{"inputs":[{"name":"permissions"},{"name":"permissions"}],"output":{"name":"bool"}}],[11,"ne","","",351,{"inputs":[{"name":"permissions"},{"name":"permissions"}],"output":{"name":"bool"}}],[11,"clone","","",351,{"inputs":[{"name":"permissions"}],"output":{"name":"permissions"}}],[11,"open","","Attempts to open a file in read-only mode.",352,{"inputs":[{"name":"file"},{"name":"p"}],"output":{"name":"result"}}],[11,"create","","Opens a file in write-only mode.",352,{"inputs":[{"name":"file"},{"name":"p"}],"output":{"name":"result"}}],[11,"path","","Returns the original path that was used to open this file.",352,{"inputs":[{"name":"file"}],"output":{"name":"option"}}],[11,"sync_all","","Attempts to sync all OS-internal metadata to disk.",352,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"sync_data","","This function is similar to `sync_all`, except that it may not\nsynchronize file metadata to the filesystem.",352,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"set_len","","Truncates or extends the underlying file, updating the size of\nthis file to become `size`.",352,{"inputs":[{"name":"file"},{"name":"u64"}],"output":{"name":"result"}}],[11,"metadata","","Queries metadata about the underlying file.",352,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"read","","",352,null],[11,"write","","",352,null],[11,"flush","","",352,{"inputs":[{"name":"file"}],"output":{"name":"result"}}],[11,"seek","","",352,{"inputs":[{"name":"file"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"new","","Creates a blank net set of options ready for configuration.",350,{"inputs":[{"name":"openoptions"}],"output":{"name":"openoptions"}}],[11,"read","","Sets the option for read access.",350,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"write","","Sets the option for write access.",350,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"append","","Sets the option for the append mode.",350,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"truncate","","Sets the option for truncating a previous file.",350,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"create","","Sets the option for creating a new file.",350,{"inputs":[{"name":"openoptions"},{"name":"bool"}],"output":{"name":"openoptions"}}],[11,"open","","Opens a file at `path` with the options specified by `self`.",350,{"inputs":[{"name":"openoptions"},{"name":"p"}],"output":{"name":"result"}}],[11,"is_dir","","Returns whether this metadata is for a directory.",353,{"inputs":[{"name":"metadata"}],"output":{"name":"bool"}}],[11,"is_file","","Returns whether this metadata is for a regular file.",353,{"inputs":[{"name":"metadata"}],"output":{"name":"bool"}}],[11,"len","","Returns the size of the file, in bytes, this metadata is for.",353,{"inputs":[{"name":"metadata"}],"output":{"name":"u64"}}],[11,"permissions","","Returns the permissions of the file this metadata is for.",353,{"inputs":[{"name":"metadata"}],"output":{"name":"permissions"}}],[11,"accessed","","Returns the most recent access time for a file.",353,{"inputs":[{"name":"metadata"}],"output":{"name":"u64"}}],[11,"modified","","Returns the most recent modification time for a file.",353,{"inputs":[{"name":"metadata"}],"output":{"name":"u64"}}],[11,"readonly","","Returns whether these permissions describe a readonly file.",351,{"inputs":[{"name":"permissions"}],"output":{"name":"bool"}}],[11,"set_readonly","","Modifies the readonly flag for this set of permissions.",351,{"inputs":[{"name":"permissions"},{"name":"bool"}],"output":null}],[6,"Item","","",null,null],[11,"next","","",354,{"inputs":[{"name":"readdir"}],"output":{"name":"option"}}],[11,"path","","Returns the full path to the file that this entry represents.",355,{"inputs":[{"name":"direntry"}],"output":{"name":"pathbuf"}}],[6,"Item","","",null,null],[11,"next","","",356,{"inputs":[{"name":"walkdir"}],"output":{"name":"option"}}],[0,"io","std","Traits, helpers, and type definitions for core I/O functionality.",null,null],[3,"BufReader","std::io","Wraps a `Read` and buffers input from it",null,null],[3,"BufWriter","","Wraps a Writer and buffers output to it",null,null],[3,"BufStream","","Wraps a Stream and buffers input and output to and from it.",null,null],[3,"LineWriter","","Wraps a Writer and buffers output to it, flushing whenever a newline\n(`0x0a`, `'\\n'`) is detected.",null,null],[3,"IntoInnerError","","An error returned by `into_inner` which combines an error that\nhappened while writing out the buffer, and the buffered writer object\nwhich may be used to recover from the condition.",null,null],[3,"Cursor","","A `Cursor` is a type which wraps a non-I/O object to provide a `Seek`\nimplementation.",null,null],[3,"Error","","The error type for I/O operations of the `Read`, `Write`, `Seek`, and\nassociated traits.",null,null],[3,"Sink","","A writer which will move data into the void.",null,null],[3,"Empty","","A reader which is always at EOF.",null,null],[3,"Repeat","","A reader which infinitely yields one byte.",null,null],[3,"Stdin","","A handle to the standard input stream of a process.",null,null],[3,"Stdout","","A handle to the global standard output stream of the current process.",null,null],[3,"Stderr","","A handle to the standard error stream of a process.",null,null],[3,"StdoutLock","","A locked reference to the a `Stdout` handle.",null,null],[3,"StderrLock","","A locked reference to the a `Stderr` handle.",null,null],[3,"StdinLock","","A locked reference to the a `Stdin` handle.",null,null],[3,"Broadcast","","A `Write` adaptor which will write data to multiple locations.",null,null],[3,"Chain","","Adaptor to chain together two instances of `Read`.",null,null],[3,"Take","","Reader adaptor which limits the bytes read from an underlying reader.",null,null],[3,"Tee","","An adaptor which will emit all read data to a specified writer as well.",null,null],[3,"Bytes","","A bridge from implementations of `Read` to an `Iterator` of `u8`.",null,null],[3,"Chars","","A bridge from implementations of `Read` to an `Iterator` of `char`.",null,null],[3,"Split","","An iterator over the contents of an instance of `BufRead` split on a\nparticular byte.",null,null],[3,"Lines","","An iterator over the lines of an instance of `BufRead` split on a newline\nbyte.",null,null],[4,"ErrorKind","","A list specifying general categories of I/O error.",null,null],[13,"NotFound","","An entity was not found, often a file.",357,null],[13,"PermissionDenied","","The operation lacked the necessary privileges to complete.",357,null],[13,"ConnectionRefused","","The connection was refused by the remote server.",357,null],[13,"ConnectionReset","","The connection was reset by the remote server.",357,null],[13,"ConnectionAborted","","The connection was aborted (terminated) by the remote server.",357,null],[13,"NotConnected","","The network operation failed because it was not connected yet.",357,null],[13,"AddrInUse","","A socket address could not be bound because the address is already in\nuse elsewhere.",357,null],[13,"AddrNotAvailable","","A nonexistent interface was requested or the requested address was not\nlocal.",357,null],[13,"BrokenPipe","","The operation failed because a pipe was closed.",357,null],[13,"AlreadyExists","","An entity already exists, often a file.",357,null],[13,"WouldBlock","","The operation needs to block to complete, but the blocking operation was\nrequested to not occur.",357,null],[13,"InvalidInput","","A parameter was incorrect.",357,null],[13,"TimedOut","","The I/O operation's timeout expired, causing it to be canceled.",357,null],[13,"WriteZero","","An error returned when an operation could not be completed because a\ncall to `write` returned `Ok(0)`.",357,null],[13,"Interrupted","","This operation was interrupted.",357,null],[13,"Other","","Any I/O error not part of this list.",357,null],[4,"SeekFrom","","Enumeration of possible methods to seek within an I/O object.",null,null],[13,"Start","","Set the offset to the provided number of bytes.",358,null],[13,"End","","Set the offset to the size of this object plus the specified number of\nbytes.",358,null],[13,"Current","","Set the offset to the current position plus the specified number of\nbytes.",358,null],[4,"CharsError","","An enumeration of possible errors that can be generated from the `Chars`\nadapter.",null,null],[13,"NotUtf8","","Variant representing that the underlying stream was read successfully\nbut it did not contain valid utf8 data.",359,null],[13,"Other","","Variant representing that an I/O error occurred.",359,null],[5,"copy","","Copies the entire contents of a reader into a writer.",null,{"inputs":[{"name":"r"},{"name":"w"}],"output":{"name":"result"}}],[5,"sink","","Creates an instance of a writer which will successfully consume all data.",null,{"inputs":[],"output":{"name":"sink"}}],[5,"empty","","Creates an instance of an empty reader.",null,{"inputs":[],"output":{"name":"empty"}}],[5,"repeat","","Creates an instance of a reader that infinitely repeats one byte.",null,{"inputs":[{"name":"u8"}],"output":{"name":"repeat"}}],[5,"stdin","","Creates a new handle to the global standard input stream of this process.",null,{"inputs":[],"output":{"name":"stdin"}}],[5,"stdout","","Constructs a new reference to the standard output of the current process.",null,{"inputs":[],"output":{"name":"stdout"}}],[5,"stderr","","Constructs a new reference to the standard error stream of a process.",null,{"inputs":[],"output":{"name":"stderr"}}],[0,"prelude","","The I/O Prelude",null,null],[11,"new","","Creates a new `BufReader` with a default buffer capacity",360,{"inputs":[{"name":"bufreader"},{"name":"r"}],"output":{"name":"bufreader"}}],[11,"with_capacity","","Creates a new `BufReader` with the specified buffer capacity",360,{"inputs":[{"name":"bufreader"},{"name":"usize"},{"name":"r"}],"output":{"name":"bufreader"}}],[11,"get_ref","","Gets a reference to the underlying reader.",360,{"inputs":[{"name":"bufreader"}],"output":{"name":"r"}}],[11,"get_mut","","Gets a mutable reference to the underlying reader.",360,{"inputs":[{"name":"bufreader"}],"output":{"name":"r"}}],[11,"into_inner","","Unwraps this `BufReader`, returning the underlying reader.",360,{"inputs":[{"name":"bufreader"}],"output":{"name":"r"}}],[11,"read","","",360,null],[11,"fill_buf","","",360,{"inputs":[{"name":"bufreader"}],"output":{"name":"result"}}],[11,"consume","","",360,{"inputs":[{"name":"bufreader"},{"name":"usize"}],"output":null}],[11,"fmt","","",360,{"inputs":[{"name":"bufreader"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"seek","","Seek to an offset, in bytes, in the underlying reader.",360,{"inputs":[{"name":"bufreader"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"fmt","","",361,{"inputs":[{"name":"intoinnererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new `BufWriter` with a default buffer capacity",362,{"inputs":[{"name":"bufwriter"},{"name":"w"}],"output":{"name":"bufwriter"}}],[11,"with_capacity","","Creates a new `BufWriter` with the specified buffer capacity",362,{"inputs":[{"name":"bufwriter"},{"name":"usize"},{"name":"w"}],"output":{"name":"bufwriter"}}],[11,"get_ref","","Gets a reference to the underlying writer.",362,{"inputs":[{"name":"bufwriter"}],"output":{"name":"w"}}],[11,"get_mut","","Gets a mutable reference to the underlying write.",362,{"inputs":[{"name":"bufwriter"}],"output":{"name":"w"}}],[11,"into_inner","","Unwraps this `BufWriter`, returning the underlying writer.",362,{"inputs":[{"name":"bufwriter"}],"output":{"name":"result"}}],[11,"write","","",362,null],[11,"flush","","",362,{"inputs":[{"name":"bufwriter"}],"output":{"name":"result"}}],[11,"fmt","","",362,{"inputs":[{"name":"bufwriter"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"seek","","Seek to the offset, in bytes, in the underlying writer.",362,{"inputs":[{"name":"bufwriter"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"drop","","",362,{"inputs":[{"name":"bufwriter"}],"output":null}],[11,"error","","Returns the error which caused the call to `into_inner` to fail.",361,{"inputs":[{"name":"intoinnererror"}],"output":{"name":"error"}}],[11,"into_inner","","Returns the buffered writer instance which generated the error.",361,{"inputs":[{"name":"intoinnererror"}],"output":{"name":"w"}}],[11,"from","","",363,{"inputs":[{"name":"error"},{"name":"intoinnererror"}],"output":{"name":"error"}}],[11,"description","","",361,{"inputs":[{"name":"intoinnererror"}],"output":{"name":"str"}}],[11,"fmt","","",361,{"inputs":[{"name":"intoinnererror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new `LineWriter`",364,{"inputs":[{"name":"linewriter"},{"name":"w"}],"output":{"name":"linewriter"}}],[11,"with_capacity","","Creates a new `LineWriter` with a specified capacity for the internal\nbuffer.",364,{"inputs":[{"name":"linewriter"},{"name":"usize"},{"name":"w"}],"output":{"name":"linewriter"}}],[11,"get_ref","","Gets a reference to the underlying writer.",364,{"inputs":[{"name":"linewriter"}],"output":{"name":"w"}}],[11,"get_mut","","Gets a mutable reference to the underlying writer.",364,{"inputs":[{"name":"linewriter"}],"output":{"name":"w"}}],[11,"into_inner","","Unwraps this `LineWriter`, returning the underlying writer.",364,{"inputs":[{"name":"linewriter"}],"output":{"name":"result"}}],[11,"write","","",364,null],[11,"flush","","",364,{"inputs":[{"name":"linewriter"}],"output":{"name":"result"}}],[11,"fmt","","",364,{"inputs":[{"name":"linewriter"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"with_capacities","","Creates a new buffered stream with explicitly listed capacities for the\nreader/writer buffer.",365,{"inputs":[{"name":"bufstream"},{"name":"usize"},{"name":"usize"},{"name":"s"}],"output":{"name":"bufstream"}}],[11,"new","","Creates a new buffered stream with the default reader/writer buffer\ncapacities.",365,{"inputs":[{"name":"bufstream"},{"name":"s"}],"output":{"name":"bufstream"}}],[11,"get_ref","","Gets a reference to the underlying stream.",365,{"inputs":[{"name":"bufstream"}],"output":{"name":"s"}}],[11,"get_mut","","Gets a mutable reference to the underlying stream.",365,{"inputs":[{"name":"bufstream"}],"output":{"name":"s"}}],[11,"into_inner","","Unwraps this `BufStream`, returning the underlying stream.",365,{"inputs":[{"name":"bufstream"}],"output":{"name":"result"}}],[11,"fill_buf","","",365,{"inputs":[{"name":"bufstream"}],"output":{"name":"result"}}],[11,"consume","","",365,{"inputs":[{"name":"bufstream"},{"name":"usize"}],"output":null}],[11,"read","","",365,null],[11,"write","","",365,null],[11,"flush","","",365,{"inputs":[{"name":"bufstream"}],"output":{"name":"result"}}],[11,"fmt","","",365,{"inputs":[{"name":"bufstream"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",366,{"inputs":[{"name":"cursor"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",366,{"inputs":[{"name":"cursor"}],"output":{"name":"cursor"}}],[11,"new","","Creates a new cursor wrapping the provided underlying I/O object.",366,{"inputs":[{"name":"cursor"},{"name":"t"}],"output":{"name":"cursor"}}],[11,"into_inner","","Consumes this cursor, returning the underlying value.",366,{"inputs":[{"name":"cursor"}],"output":{"name":"t"}}],[11,"get_ref","","Gets a reference to the underlying value in this cursor.",366,{"inputs":[{"name":"cursor"}],"output":{"name":"t"}}],[11,"get_mut","","Gets a mutable reference to the underlying value in this cursor.",366,{"inputs":[{"name":"cursor"}],"output":{"name":"t"}}],[11,"position","","Returns the current value of this cursor",366,{"inputs":[{"name":"cursor"}],"output":{"name":"u64"}}],[11,"set_position","","Sets the value of this cursor",366,{"inputs":[{"name":"cursor"},{"name":"u64"}],"output":null}],[11,"seek","","",366,{"inputs":[{"name":"cursor"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"seek","","",366,{"inputs":[{"name":"cursor"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"seek","","",366,{"inputs":[{"name":"cursor"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"read","","",366,null],[11,"read","","",366,null],[11,"read","","",366,null],[11,"fill_buf","","",366,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"consume","","",366,{"inputs":[{"name":"cursor"},{"name":"usize"}],"output":null}],[11,"fill_buf","","",366,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"consume","","",366,{"inputs":[{"name":"cursor"},{"name":"usize"}],"output":null}],[11,"fill_buf","","",366,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"consume","","",366,{"inputs":[{"name":"cursor"},{"name":"usize"}],"output":null}],[11,"write","","",366,null],[11,"flush","","",366,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"write","","",366,null],[11,"flush","","",366,{"inputs":[{"name":"cursor"}],"output":{"name":"result"}}],[11,"fmt","","",363,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",357,{"inputs":[{"name":"errorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",357,{"inputs":[{"name":"errorkind"}],"output":{"name":"errorkind"}}],[11,"eq","","",357,{"inputs":[{"name":"errorkind"},{"name":"errorkind"}],"output":{"name":"bool"}}],[11,"ne","","",357,{"inputs":[{"name":"errorkind"},{"name":"errorkind"}],"output":{"name":"bool"}}],[11,"new","","Creates a new I/O error from a known kind of error as well as an\narbitrary error payload.",363,{"inputs":[{"name":"error"},{"name":"errorkind"},{"name":"e"}],"output":{"name":"error"}}],[11,"last_os_error","","Returns an error representing the last OS error which occurred.",363,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"from_raw_os_error","","Creates a new instance of an `Error` from a particular OS error code.",363,{"inputs":[{"name":"error"},{"name":"i32"}],"output":{"name":"error"}}],[11,"raw_os_error","","Returns the OS error that this error represents (if any).",363,{"inputs":[{"name":"error"}],"output":{"name":"option"}}],[11,"kind","","Returns the corresponding `ErrorKind` for this error.",363,{"inputs":[{"name":"error"}],"output":{"name":"errorkind"}}],[11,"fmt","","",363,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",363,{"inputs":[{"name":"error"}],"output":{"name":"str"}}],[11,"read","std::boxed","",190,null],[11,"read_to_end","","",190,{"inputs":[{"name":"box"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_to_string","","",190,{"inputs":[{"name":"box"},{"name":"string"}],"output":{"name":"result"}}],[11,"write","","",190,null],[11,"flush","","",190,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"write_all","","",190,null],[11,"write_fmt","","",190,{"inputs":[{"name":"box"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"seek","","",190,{"inputs":[{"name":"box"},{"name":"seekfrom"}],"output":{"name":"result"}}],[11,"fill_buf","","",190,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"consume","","",190,{"inputs":[{"name":"box"},{"name":"usize"}],"output":null}],[11,"read_until","","",190,{"inputs":[{"name":"box"},{"name":"u8"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_line","","",190,{"inputs":[{"name":"box"},{"name":"string"}],"output":{"name":"result"}}],[11,"write","std::vec","",253,null],[11,"write_all","","",253,null],[11,"flush","","",253,{"inputs":[{"name":"vec"}],"output":{"name":"result"}}],[11,"read","std::io","",367,null],[11,"fill_buf","","",367,{"inputs":[{"name":"empty"}],"output":{"name":"result"}}],[11,"consume","","",367,{"inputs":[{"name":"empty"},{"name":"usize"}],"output":null}],[11,"read","","",368,null],[11,"write","","",369,null],[11,"flush","","",369,{"inputs":[{"name":"sink"}],"output":{"name":"result"}}],[11,"lock","","Locks this handle to the standard input stream, returning a readable\nguard.",370,{"inputs":[{"name":"stdin"}],"output":{"name":"stdinlock"}}],[11,"read_line","","Locks this handle and reads a line of input into the specified buffer.",370,{"inputs":[{"name":"stdin"},{"name":"string"}],"output":{"name":"result"}}],[11,"read","","",370,null],[11,"read_to_end","","",370,{"inputs":[{"name":"stdin"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_to_string","","",370,{"inputs":[{"name":"stdin"},{"name":"string"}],"output":{"name":"result"}}],[11,"read","","",371,null],[11,"fill_buf","","",371,{"inputs":[{"name":"stdinlock"}],"output":{"name":"result"}}],[11,"consume","","",371,{"inputs":[{"name":"stdinlock"},{"name":"usize"}],"output":null}],[11,"lock","","Locks this handle to the standard output stream, returning a writable\nguard.",372,{"inputs":[{"name":"stdout"}],"output":{"name":"stdoutlock"}}],[11,"write","","",372,null],[11,"flush","","",372,{"inputs":[{"name":"stdout"}],"output":{"name":"result"}}],[11,"write_all","","",372,null],[11,"write_fmt","","",372,{"inputs":[{"name":"stdout"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"write","","",373,null],[11,"flush","","",373,{"inputs":[{"name":"stdoutlock"}],"output":{"name":"result"}}],[11,"lock","","Locks this handle to the standard error stream, returning a writable\nguard.",374,{"inputs":[{"name":"stderr"}],"output":{"name":"stderrlock"}}],[11,"write","","",374,null],[11,"flush","","",374,{"inputs":[{"name":"stderr"}],"output":{"name":"result"}}],[11,"write_all","","",374,null],[11,"write_fmt","","",374,{"inputs":[{"name":"stderr"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"write","","",375,null],[11,"flush","","",375,{"inputs":[{"name":"stderrlock"}],"output":{"name":"result"}}],[6,"Result","","A type for results generated by I/O related functions where the `Err` type\nis hard-wired to `io::Error`.",null,null],[8,"Read","","A trait for objects which are byte-oriented sources.",null,null],[10,"read","","Pull some bytes from this source into the specified buffer, returning\nhow many bytes were read.",376,null],[11,"read_to_end","","Read all bytes until EOF in this source, placing them into `buf`.",376,{"inputs":[{"name":"read"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_to_string","","Read all bytes until EOF in this source, placing them into `buf`.",376,{"inputs":[{"name":"read"},{"name":"string"}],"output":{"name":"result"}}],[11,"by_ref","","Creates a \"by reference\" adaptor for this instance of `Read`.",376,{"inputs":[{"name":"read"}],"output":{"name":"self"}}],[11,"bytes","","Transforms this `Read` instance to an `Iterator` over its bytes.",376,{"inputs":[{"name":"read"}],"output":{"name":"bytes"}}],[11,"chars","","Transforms this `Read` instance to an `Iterator` over `char`s.",376,{"inputs":[{"name":"read"}],"output":{"name":"chars"}}],[11,"chain","","Creates an adaptor which will chain this stream with another.",376,{"inputs":[{"name":"read"},{"name":"r"}],"output":{"name":"chain"}}],[11,"take","","Creates an adaptor which will read at most `limit` bytes from it.",376,{"inputs":[{"name":"read"},{"name":"u64"}],"output":{"name":"take"}}],[11,"tee","","Creates a reader adaptor which will write all read data into the given\noutput stream.",376,{"inputs":[{"name":"read"},{"name":"w"}],"output":{"name":"tee"}}],[8,"Write","","A trait for objects which are byte-oriented sinks.",null,null],[10,"write","","Write a buffer into this object, returning how many bytes were written.",377,null],[10,"flush","","Flush this output stream, ensuring that all intermediately buffered\ncontents reach their destination.",377,{"inputs":[{"name":"write"}],"output":{"name":"result"}}],[11,"write_all","","Attempts to write an entire buffer into this write.",377,null],[11,"write_fmt","","Writes a formatted string into this writer, returning any error\nencountered.",377,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"by_ref","","Creates a \"by reference\" adaptor for this instance of `Write`.",377,{"inputs":[{"name":"write"}],"output":{"name":"self"}}],[11,"broadcast","","Creates a new writer which will write all data to both this writer and\nanother writer.",377,{"inputs":[{"name":"write"},{"name":"w"}],"output":{"name":"broadcast"}}],[8,"Seek","","An object implementing `Seek` internally has some form of cursor which can\nbe moved within a stream of bytes.",null,null],[10,"seek","","Seek to an offset, in bytes, in a stream",378,{"inputs":[{"name":"seek"},{"name":"seekfrom"}],"output":{"name":"result"}}],[8,"BufRead","","A Buffer is a type of reader which has some form of internal buffering to\nallow certain kinds of reading operations to be more optimized than others.",null,null],[10,"fill_buf","","Fills the internal buffer of this object, returning the buffer contents.",379,{"inputs":[{"name":"bufread"}],"output":{"name":"result"}}],[10,"consume","","Tells this buffer that `amt` bytes have been consumed from the buffer,\nso they should no longer be returned in calls to `read`.",379,{"inputs":[{"name":"bufread"},{"name":"usize"}],"output":null}],[11,"read_until","","Read all bytes until the delimiter `byte` is reached.",379,{"inputs":[{"name":"bufread"},{"name":"u8"},{"name":"vec"}],"output":{"name":"result"}}],[11,"read_line","","Read all bytes until a newline byte (the 0xA byte) is reached, and\nappend them to the provided buffer.",379,{"inputs":[{"name":"bufread"},{"name":"string"}],"output":{"name":"result"}}],[11,"split","","Returns an iterator over the contents of this reader split on the byte\n`byte`.",379,{"inputs":[{"name":"bufread"},{"name":"u8"}],"output":{"name":"split"}}],[11,"lines","","Returns an iterator over the lines of this reader.",379,{"inputs":[{"name":"bufread"}],"output":{"name":"lines"}}],[11,"fmt","","",358,{"inputs":[{"name":"seekfrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",358,{"inputs":[{"name":"seekfrom"}],"output":{"name":"seekfrom"}}],[11,"eq","","",358,{"inputs":[{"name":"seekfrom"},{"name":"seekfrom"}],"output":{"name":"bool"}}],[11,"ne","","",358,{"inputs":[{"name":"seekfrom"},{"name":"seekfrom"}],"output":{"name":"bool"}}],[11,"write","","",380,null],[11,"flush","","",380,{"inputs":[{"name":"broadcast"}],"output":{"name":"result"}}],[11,"read","","",381,null],[11,"limit","","Returns the number of bytes that can be read before this instance will\nreturn EOF.",382,{"inputs":[{"name":"take"}],"output":{"name":"u64"}}],[11,"read","","",382,null],[11,"fill_buf","","",382,{"inputs":[{"name":"take"}],"output":{"name":"result"}}],[11,"consume","","",382,{"inputs":[{"name":"take"},{"name":"usize"}],"output":null}],[11,"read","","",383,null],[6,"Item","","",null,null],[11,"next","","",384,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"fmt","","",359,{"inputs":[{"name":"charserror"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Item","","",null,null],[11,"next","","",385,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"description","","",359,{"inputs":[{"name":"charserror"}],"output":{"name":"str"}}],[11,"cause","","",359,{"inputs":[{"name":"charserror"}],"output":{"name":"option"}}],[11,"fmt","","",359,{"inputs":[{"name":"charserror"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Item","","",null,null],[11,"next","","",386,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",387,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[0,"net","std","Networking primitives for TCP/UDP communication.",null,null],[3,"Ipv4Addr","std::net","Representation of an IPv4 address.",null,null],[3,"Ipv6Addr","","Representation of an IPv6 address.",null,null],[3,"SocketAddrV4","","An IPv4 socket address which is a (ip, port) combination.",null,null],[3,"SocketAddrV6","","An IPv6 socket address.",null,null],[3,"TcpStream","","A structure which represents a TCP stream between a local socket and a\nremote socket.",null,null],[3,"TcpListener","","A structure representing a socket server.",null,null],[3,"UdpSocket","","A User Datagram Protocol socket.",null,null],[3,"AddrParseError","","An error returned when parsing an IP address or a socket address.",null,null],[3,"LookupHost","","An iterator over `SocketAddr` values returned from a host lookup operation.",null,null],[4,"IpAddr","","An IP address, either a IPv4 or IPv6 address.",null,null],[13,"V4","","Representation of an IPv4 address.",388,null],[13,"V6","","Representation of an IPv6 address.",388,null],[4,"Ipv6MulticastScope","","",null,null],[13,"InterfaceLocal","","",389,null],[13,"LinkLocal","","",389,null],[13,"RealmLocal","","",389,null],[13,"AdminLocal","","",389,null],[13,"SiteLocal","","",389,null],[13,"OrganizationLocal","","",389,null],[13,"Global","","",389,null],[4,"SocketAddr","","Representation of a socket address for networking applications.",null,null],[13,"V4","","An IPv4 socket address which is a (ip, port) combination.",390,null],[13,"V6","","An IPv6 socket address",390,null],[4,"Shutdown","","Possible values which can be passed to the `shutdown` method of `TcpStream`\nand `UdpSocket`.",null,null],[13,"Read","","Indicates that the reading portion of this stream/socket should be shut\ndown. All currently blocked and future reads will return `Ok(0)`.",391,null],[13,"Write","","Indicates that the writing portion of this stream/socket should be shut\ndown. All currently blocked and future writes will return an error.",391,null],[13,"Both","","Shut down both the reading and writing portions of this stream.",391,null],[5,"lookup_host","","Resolve the host specified by `host` as a number of `SocketAddr` instances.",null,{"inputs":[{"name":"str"}],"output":{"name":"result"}}],[5,"lookup_addr","","Resolve the given address to a hostname.",null,{"inputs":[{"name":"ipaddr"}],"output":{"name":"result"}}],[11,"cmp","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"option"}}],[11,"lt","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"le","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"gt","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"ge","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"hash","","",388,null],[11,"fmt","","",388,{"inputs":[{"name":"ipaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"ne","","",388,{"inputs":[{"name":"ipaddr"},{"name":"ipaddr"}],"output":{"name":"bool"}}],[11,"clone","","",388,{"inputs":[{"name":"ipaddr"}],"output":{"name":"ipaddr"}}],[11,"fmt","","",389,{"inputs":[{"name":"ipv6multicastscope"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",389,null],[11,"clone","","",389,{"inputs":[{"name":"ipv6multicastscope"}],"output":{"name":"ipv6multicastscope"}}],[11,"eq","","",389,{"inputs":[{"name":"ipv6multicastscope"},{"name":"ipv6multicastscope"}],"output":{"name":"bool"}}],[11,"ne","","",389,{"inputs":[{"name":"ipv6multicastscope"},{"name":"ipv6multicastscope"}],"output":{"name":"bool"}}],[11,"new","","Creates a new IPv4 address from four eight-bit octets.",392,{"inputs":[{"name":"ipv4addr"},{"name":"u8"},{"name":"u8"},{"name":"u8"},{"name":"u8"}],"output":{"name":"ipv4addr"}}],[11,"octets","","Returns the four eight-bit integers that make up this address.",392,null],[11,"is_unspecified","","Returns true for the special 'unspecified' address 0.0.0.0.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_loopback","","Returns true if this is a loopback address (127.0.0.0/8).",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_private","","Returns true if this is a private address.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_link_local","","Returns true if the address is link-local (169.254.0.0/16).",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_global","","Returns true if the address appears to be globally routable.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_multicast","","Returns true if this is a multicast address.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_broadcast","","Returns true if this is a broadcast address.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"is_documentation","","Returns true if this address is in a range designated for documentation.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"to_ipv6_compatible","","Converts this address to an IPv4-compatible IPv6 address.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"ipv6addr"}}],[11,"to_ipv6_mapped","","Converts this address to an IPv4-mapped IPv6 address.",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"ipv6addr"}}],[11,"fmt","","",388,{"inputs":[{"name":"ipaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",392,{"inputs":[{"name":"ipv4addr"}],"output":{"name":"ipv4addr"}}],[11,"eq","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"ipv4addr"}],"output":{"name":"bool"}}],[11,"hash","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"h"}],"output":null}],[11,"partial_cmp","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"ipv4addr"}],"output":{"name":"option"}}],[11,"cmp","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"ipv4addr"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new IPv6 address from eight 16-bit segments.",393,{"inputs":[{"name":"ipv6addr"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"},{"name":"u16"}],"output":{"name":"ipv6addr"}}],[11,"segments","","Returns the eight 16-bit segments that make up this address.",393,null],[11,"is_unspecified","","Returns true for the special 'unspecified' address ::.",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_loopback","","Returns true if this is a loopback address (::1).",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_global","","Returns true if the address appears to be globally routable.",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unique_local","","Returns true if this is a unique local address (IPv6).",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unicast_link_local","","Returns true if the address is unicast and link-local (fe80::/10).",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unicast_site_local","","Returns true if this is a deprecated unicast site-local address (IPv6\nfec0::/10).",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"is_unicast_global","","Returns true if the address is a globally routable unicast address.",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"multicast_scope","","Returns the address's multicast scope if the address is multicast.",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"option"}}],[11,"is_multicast","","Returns true if this is a multicast address.",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"to_ipv4","","Converts this address to an IPv4 address. Returns None if this address is\nneither IPv4-compatible or IPv4-mapped.",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"option"}}],[11,"fmt","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",393,{"inputs":[{"name":"ipv6addr"}],"output":{"name":"ipv6addr"}}],[11,"eq","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"ipv6addr"}],"output":{"name":"bool"}}],[11,"hash","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"h"}],"output":null}],[11,"partial_cmp","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"ipv6addr"}],"output":{"name":"option"}}],[11,"cmp","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"ipv6addr"}],"output":{"name":"ordering"}}],[11,"fmt","","",390,{"inputs":[{"name":"socketaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",390,null],[11,"eq","","",390,{"inputs":[{"name":"socketaddr"},{"name":"socketaddr"}],"output":{"name":"bool"}}],[11,"ne","","",390,{"inputs":[{"name":"socketaddr"},{"name":"socketaddr"}],"output":{"name":"bool"}}],[11,"clone","","",390,{"inputs":[{"name":"socketaddr"}],"output":{"name":"socketaddr"}}],[11,"new","","Creates a new socket address from the (ip, port) pair.",390,{"inputs":[{"name":"socketaddr"},{"name":"ipaddr"},{"name":"u16"}],"output":{"name":"socketaddr"}}],[11,"ip","","Returns the IP address associated with this socket address.",390,{"inputs":[{"name":"socketaddr"}],"output":{"name":"ipaddr"}}],[11,"port","","Returns the port number associated with this socket address.",390,{"inputs":[{"name":"socketaddr"}],"output":{"name":"u16"}}],[11,"new","","Creates a new socket address from the (ip, port) pair.",394,{"inputs":[{"name":"socketaddrv4"},{"name":"ipv4addr"},{"name":"u16"}],"output":{"name":"socketaddrv4"}}],[11,"ip","","Returns the IP address associated with this socket address.",394,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"ipv4addr"}}],[11,"port","","Returns the port number associated with this socket address.",394,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"u16"}}],[11,"new","","Creates a new socket address from the ip/port/flowinfo/scope_id\ncomponents.",395,{"inputs":[{"name":"socketaddrv6"},{"name":"ipv6addr"},{"name":"u16"},{"name":"u32"},{"name":"u32"}],"output":{"name":"socketaddrv6"}}],[11,"ip","","Returns the IP address associated with this socket address.",395,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"ipv6addr"}}],[11,"port","","Returns the port number associated with this socket address.",395,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"u16"}}],[11,"flowinfo","","Returns scope ID associated with this address, corresponding to the\n`sin6_flowinfo` field in C.",395,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"u32"}}],[11,"scope_id","","Returns scope ID associated with this address, corresponding to the\n`sin6_scope_id` field in C.",395,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"u32"}}],[11,"fmt","","",390,{"inputs":[{"name":"socketaddr"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",394,{"inputs":[{"name":"socketaddrv4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",394,{"inputs":[{"name":"socketaddrv4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",395,{"inputs":[{"name":"socketaddrv6"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",395,{"inputs":[{"name":"socketaddrv6"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",394,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"socketaddrv4"}}],[11,"clone","","",395,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"socketaddrv6"}}],[11,"eq","","",394,{"inputs":[{"name":"socketaddrv4"},{"name":"socketaddrv4"}],"output":{"name":"bool"}}],[11,"eq","","",395,{"inputs":[{"name":"socketaddrv6"},{"name":"socketaddrv6"}],"output":{"name":"bool"}}],[11,"hash","","",394,{"inputs":[{"name":"socketaddrv4"},{"name":"h"}],"output":null}],[11,"hash","","",395,{"inputs":[{"name":"socketaddrv6"},{"name":"h"}],"output":null}],[11,"to_socket_addrs","","",390,{"inputs":[{"name":"socketaddr"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",394,{"inputs":[{"name":"socketaddrv4"}],"output":{"name":"result"}}],[11,"to_socket_addrs","","",395,{"inputs":[{"name":"socketaddrv6"}],"output":{"name":"result"}}],[11,"connect","","Opens a TCP connection to a remote host.",396,{"inputs":[{"name":"tcpstream"},{"name":"a"}],"output":{"name":"result"}}],[11,"peer_addr","","Returns the socket address of the remote peer of this TCP connection.",396,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"local_addr","","Returns the socket address of the local half of this TCP connection.",396,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"shutdown","","Shuts down the read, write, or both halves of this connection.",396,{"inputs":[{"name":"tcpstream"},{"name":"shutdown"}],"output":{"name":"result"}}],[11,"try_clone","","Creates a new independently owned handle to the underlying socket.",396,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"set_nodelay","","Sets the nodelay flag on this connection to the boolean specified.",396,{"inputs":[{"name":"tcpstream"},{"name":"bool"}],"output":{"name":"result"}}],[11,"set_keepalive","","Sets the keepalive timeout to the timeout specified.",396,{"inputs":[{"name":"tcpstream"},{"name":"option"}],"output":{"name":"result"}}],[11,"read","","",396,null],[11,"write","","",396,null],[11,"flush","","",396,{"inputs":[{"name":"tcpstream"}],"output":{"name":"result"}}],[11,"bind","","Creates a new `TcpListener` which will be bound to the specified\naddress.",397,{"inputs":[{"name":"tcplistener"},{"name":"a"}],"output":{"name":"result"}}],[11,"local_addr","","Returns the local socket address of this listener.",397,{"inputs":[{"name":"tcplistener"}],"output":{"name":"result"}}],[11,"try_clone","","Creates a new independently owned handle to the underlying socket.",397,{"inputs":[{"name":"tcplistener"}],"output":{"name":"result"}}],[11,"accept","","Accept a new incoming connection from this listener.",397,{"inputs":[{"name":"tcplistener"}],"output":{"name":"result"}}],[11,"incoming","","Returns an iterator over the connections being received on this\nlistener.",397,{"inputs":[{"name":"tcplistener"}],"output":{"name":"incoming"}}],[11,"bind","","Creates a UDP socket from the given address.",398,{"inputs":[{"name":"udpsocket"},{"name":"a"}],"output":{"name":"result"}}],[11,"recv_from","","Receives data from the socket. On success, returns the number of bytes\nread and the address from whence the data came.",398,null],[11,"send_to","","Sends data on the socket to the given address. On success, returns the\nnumber of bytes written.",398,null],[11,"local_addr","","Returns the socket address that this socket was created from.",398,{"inputs":[{"name":"udpsocket"}],"output":{"name":"result"}}],[11,"try_clone","","Creates a new independently owned handle to the underlying socket.",398,{"inputs":[{"name":"udpsocket"}],"output":{"name":"result"}}],[11,"set_broadcast","","Sets the broadcast flag on or off.",398,{"inputs":[{"name":"udpsocket"},{"name":"bool"}],"output":{"name":"result"}}],[11,"set_multicast_loop","","Sets the multicast loop flag to the specified value.",398,{"inputs":[{"name":"udpsocket"},{"name":"bool"}],"output":{"name":"result"}}],[11,"join_multicast","","Joins a multicast IP address (becomes a member of it).",398,{"inputs":[{"name":"udpsocket"},{"name":"ipaddr"}],"output":{"name":"result"}}],[11,"leave_multicast","","Leaves a multicast IP address (drops membership from it).",398,{"inputs":[{"name":"udpsocket"},{"name":"ipaddr"}],"output":{"name":"result"}}],[11,"set_multicast_time_to_live","","Sets the multicast TTL.",398,{"inputs":[{"name":"udpsocket"},{"name":"i32"}],"output":{"name":"result"}}],[11,"set_time_to_live","","Sets this socket's TTL.",398,{"inputs":[{"name":"udpsocket"},{"name":"i32"}],"output":{"name":"result"}}],[11,"from_str","","",388,{"inputs":[{"name":"ipaddr"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",392,{"inputs":[{"name":"ipv4addr"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",393,{"inputs":[{"name":"ipv6addr"},{"name":"str"}],"output":{"name":"result"}}],[11,"from_str","","",390,{"inputs":[{"name":"socketaddr"},{"name":"str"}],"output":{"name":"result"}}],[11,"eq","","",399,{"inputs":[{"name":"addrparseerror"},{"name":"addrparseerror"}],"output":{"name":"bool"}}],[11,"ne","","",399,{"inputs":[{"name":"addrparseerror"},{"name":"addrparseerror"}],"output":{"name":"bool"}}],[11,"clone","","",399,{"inputs":[{"name":"addrparseerror"}],"output":{"name":"addrparseerror"}}],[11,"fmt","","",399,{"inputs":[{"name":"addrparseerror"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"ToSocketAddrs","","A trait for objects which can be converted or resolved to one or more\n`SocketAddr` values.",null,null],[16,"Iter","std::net::ToSocketAddrs","Returned iterator over socket addresses which this type may correspond\nto.",null,null],[10,"to_socket_addrs","std::net","Converts this object to an iterator of resolved `SocketAddr`s.",400,{"inputs":[{"name":"tosocketaddrs"}],"output":{"name":"result"}}],[11,"eq","","",391,{"inputs":[{"name":"shutdown"},{"name":"shutdown"}],"output":{"name":"bool"}}],[11,"ne","","",391,{"inputs":[{"name":"shutdown"},{"name":"shutdown"}],"output":{"name":"bool"}}],[11,"clone","","",391,{"inputs":[{"name":"shutdown"}],"output":{"name":"shutdown"}}],[6,"Item","","",null,null],[11,"next","","",401,{"inputs":[{"name":"lookuphost"}],"output":{"name":"option"}}],[0,"os","std","OS-specific functionality",null,null],[0,"unix","std::os","Experimental extensions to `std` for Unix platforms.",null,null],[0,"io","std::os::unix","Unix-specific extensions to general I/O primitives",null,null],[6,"RawFd","std::os::unix::io","Raw file descriptors.",null,null],[8,"AsRawFd","","A trait to extract the raw unix file descriptor from an underlying\nobject.",null,null],[10,"as_raw_fd","","Extracts the raw file descriptor.",402,{"inputs":[{"name":"asrawfd"}],"output":{"name":"rawfd"}}],[8,"FromRawFd","","A trait to express the ability to construct an object from a raw file\ndescriptor.",null,null],[10,"from_raw_fd","","Constructs a new instances of `Self` from the given raw file\ndescriptor.",403,{"inputs":[{"name":"fromrawfd"},{"name":"rawfd"}],"output":{"name":"self"}}],[11,"as_raw_fd","std::fs","",352,{"inputs":[{"name":"file"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",352,{"inputs":[{"name":"file"},{"name":"rawfd"}],"output":{"name":"file"}}],[11,"as_raw_fd","std::net","",396,{"inputs":[{"name":"tcpstream"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",397,{"inputs":[{"name":"tcplistener"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",398,{"inputs":[{"name":"udpsocket"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",396,{"inputs":[{"name":"tcpstream"},{"name":"rawfd"}],"output":{"name":"tcpstream"}}],[11,"from_raw_fd","","",397,{"inputs":[{"name":"tcplistener"},{"name":"rawfd"}],"output":{"name":"tcplistener"}}],[11,"from_raw_fd","","",398,{"inputs":[{"name":"udpsocket"},{"name":"rawfd"}],"output":{"name":"udpsocket"}}],[0,"ffi","std::os::unix","Unix-specific extension to the primitives in the `std::ffi` module",null,null],[8,"OsStringExt","std::os::unix::ffi","Unix-specific extensions to `OsString`.",null,null],[10,"from_vec","","Creates an `OsString` from a byte vector.",404,{"inputs":[{"name":"osstringext"},{"name":"vec"}],"output":{"name":"self"}}],[10,"into_vec","","Yields the underlying byte vector of this `OsString`.",404,{"inputs":[{"name":"osstringext"}],"output":{"name":"vec"}}],[8,"OsStrExt","","Unix-specific extensions to `OsStr`.",null,null],[10,"from_bytes","","",405,null],[10,"as_bytes","","Gets the underlying byte view of the `OsStr` slice.",405,null],[11,"from_vec","std::ffi","",347,{"inputs":[{"name":"osstring"},{"name":"vec"}],"output":{"name":"osstring"}}],[11,"into_vec","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"vec"}}],[11,"from_bytes","","",348,null],[11,"as_bytes","","",348,null],[0,"fs","std::os::unix","Unix-specific extensions to primitives in the `std::fs` module.",null,null],[8,"PermissionsExt","std::os::unix::fs","Unix-specific extensions to `Permissions`",null,null],[10,"mode","","",406,{"inputs":[{"name":"permissionsext"}],"output":{"name":"i32"}}],[10,"set_mode","","",406,{"inputs":[{"name":"permissionsext"},{"name":"i32"}],"output":null}],[8,"OpenOptionsExt","","Unix-specific extensions to `OpenOptions`",null,null],[10,"mode","","Sets the mode bits that a new file will be created with.",407,{"inputs":[{"name":"openoptionsext"},{"name":"i32"}],"output":{"name":"self"}}],[11,"mode","std::fs","",351,{"inputs":[{"name":"permissions"}],"output":{"name":"i32"}}],[11,"set_mode","","",351,{"inputs":[{"name":"permissions"},{"name":"i32"}],"output":null}],[11,"mode","","",350,{"inputs":[{"name":"openoptions"},{"name":"i32"}],"output":{"name":"openoptions"}}],[0,"process","std::os::unix","Unix-specific extensions to primitives in the `std::process` module.",null,null],[8,"CommandExt","std::os::unix::process","Unix-specific extensions to the `std::process::Command` builder",null,null],[10,"uid","","Sets the child process's user id. This translates to a\n`setuid` call in the child process. Failure in the `setuid`\ncall will cause the spawn to fail.",408,{"inputs":[{"name":"commandext"},{"name":"uid_t"}],"output":{"name":"command"}}],[10,"gid","","Similar to `uid`, but sets the group id of the child process. This has\nthe same semantics as the `uid` field.",408,{"inputs":[{"name":"commandext"},{"name":"gid_t"}],"output":{"name":"command"}}],[8,"ExitStatusExt","","Unix-specific extensions to `std::process::ExitStatus`",null,null],[10,"signal","","If the process was terminated by a signal, returns that signal.",409,{"inputs":[{"name":"exitstatusext"}],"output":{"name":"option"}}],[0,"prelude","std::os::unix","A prelude for conveniently writing platform-specific code.",null,null],[6,"RawFd","std::os::unix::prelude","Raw file descriptors.",null,null],[8,"AsRawFd","","A trait to extract the raw unix file descriptor from an underlying\nobject.",null,null],[10,"as_raw_fd","","Extracts the raw file descriptor.",402,{"inputs":[{"name":"asrawfd"}],"output":{"name":"rawfd"}}],[8,"OsStrExt","","Unix-specific extensions to `OsStr`.",null,null],[10,"from_bytes","","",405,null],[10,"as_bytes","","Gets the underlying byte view of the `OsStr` slice.",405,null],[8,"OsStringExt","","Unix-specific extensions to `OsString`.",null,null],[10,"from_vec","","Creates an `OsString` from a byte vector.",404,{"inputs":[{"name":"osstringext"},{"name":"vec"}],"output":{"name":"self"}}],[10,"into_vec","","Yields the underlying byte vector of this `OsString`.",404,{"inputs":[{"name":"osstringext"}],"output":{"name":"vec"}}],[8,"PermissionsExt","","Unix-specific extensions to `Permissions`",null,null],[10,"mode","","",406,{"inputs":[{"name":"permissionsext"}],"output":{"name":"i32"}}],[10,"set_mode","","",406,{"inputs":[{"name":"permissionsext"},{"name":"i32"}],"output":null}],[8,"OpenOptionsExt","","Unix-specific extensions to `OpenOptions`",null,null],[10,"mode","","Sets the mode bits that a new file will be created with.",407,{"inputs":[{"name":"openoptionsext"},{"name":"i32"}],"output":{"name":"self"}}],[8,"CommandExt","","Unix-specific extensions to the `std::process::Command` builder",null,null],[10,"uid","","Sets the child process's user id. This translates to a\n`setuid` call in the child process. Failure in the `setuid`\ncall will cause the spawn to fail.",408,{"inputs":[{"name":"commandext"},{"name":"uid_t"}],"output":{"name":"command"}}],[10,"gid","","Similar to `uid`, but sets the group id of the child process. This has\nthe same semantics as the `uid` field.",408,{"inputs":[{"name":"commandext"},{"name":"gid_t"}],"output":{"name":"command"}}],[8,"ExitStatusExt","","Unix-specific extensions to `std::process::ExitStatus`",null,null],[10,"signal","","If the process was terminated by a signal, returns that signal.",409,{"inputs":[{"name":"exitstatusext"}],"output":{"name":"option"}}],[0,"path","std","Cross-platform path manipulation.",null,null],[3,"PrefixComponent","std::path","A Windows path prefix, e.g. `C:` or `\\server\\share`.",null,null],[3,"Components","","The core iterator giving the components of a path.",null,null],[3,"Iter","","An iterator over the components of a path, as `OsStr` slices.",null,null],[3,"PathBuf","","An owned, mutable path (akin to `String`).",null,null],[3,"Path","","A slice of a path (akin to `str`).",null,null],[3,"Display","","Helper struct for safely printing paths with `format!()` and `{}`",null,null],[4,"Prefix","","Path prefixes (Windows only).",null,null],[13,"Verbatim","","Prefix `\\\\?\\`, together with the given component immediately following it.",410,null],[13,"VerbatimUNC","","Prefix `\\\\?\\UNC\\`, with the \"server\" and \"share\" components following it.",410,null],[13,"VerbatimDisk","","Prefix like `\\\\?\\C:\\`, for the given drive letter",410,null],[13,"DeviceNS","","Prefix `\\\\.\\`, together with the given component immediately following it.",410,null],[13,"UNC","","Prefix `\\\\server\\share`, with the given \"server\" and \"share\" components.",410,null],[13,"Disk","","Prefix `C:` for the given disk drive.",410,null],[4,"Component","","A single component of a path.",null,null],[13,"Prefix","","A Windows path prefix, e.g. `C:` or `\\server\\share`.",411,null],[13,"RootDir","","The root directory component, appears after any prefix and before anything else",411,null],[13,"CurDir","","A reference to the current directory, i.e. `.`",411,null],[13,"ParentDir","","A reference to the parent directory, i.e. `..`",411,null],[13,"Normal","","A normal component, i.e. `a` and `b` in `a/b`",411,null],[5,"is_separator","","Determines whether the character is one of the permitted path\nseparators for the current platform.",null,{"inputs":[{"name":"char"}],"output":{"name":"bool"}}],[17,"MAIN_SEPARATOR","","The primary sperator for the current platform",null,null],[11,"eq","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"ne","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"cmp","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"option"}}],[11,"lt","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"le","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"gt","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"ge","","",410,{"inputs":[{"name":"prefix"},{"name":"prefix"}],"output":{"name":"bool"}}],[11,"hash","","",410,null],[11,"fmt","","",410,{"inputs":[{"name":"prefix"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",410,{"inputs":[{"name":"prefix"}],"output":{"name":"prefix"}}],[11,"is_verbatim","","Determines if the prefix is verbatim, i.e. begins `\\\\?\\`.",410,{"inputs":[{"name":"prefix"}],"output":{"name":"bool"}}],[11,"fmt","","",412,{"inputs":[{"name":"prefixcomponent"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",412,null],[11,"clone","","",412,{"inputs":[{"name":"prefixcomponent"}],"output":{"name":"prefixcomponent"}}],[11,"kind","","The parsed prefix data.",412,{"inputs":[{"name":"prefixcomponent"}],"output":{"name":"prefix"}}],[11,"as_os_str","","The raw `OsStr` slice for this prefix.",412,{"inputs":[{"name":"prefixcomponent"}],"output":{"name":"osstr"}}],[11,"eq","","",412,{"inputs":[{"name":"prefixcomponent"},{"name":"prefixcomponent"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",412,{"inputs":[{"name":"prefixcomponent"},{"name":"prefixcomponent"}],"output":{"name":"option"}}],[11,"cmp","","",412,{"inputs":[{"name":"prefixcomponent"},{"name":"prefixcomponent"}],"output":{"name":"ordering"}}],[11,"fmt","","",411,{"inputs":[{"name":"component"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",411,null],[11,"cmp","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"option"}}],[11,"lt","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"le","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"gt","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"ge","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"eq","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"ne","","",411,{"inputs":[{"name":"component"},{"name":"component"}],"output":{"name":"bool"}}],[11,"clone","","",411,{"inputs":[{"name":"component"}],"output":{"name":"component"}}],[11,"as_os_str","","Extracts the underlying `OsStr` slice",411,{"inputs":[{"name":"component"}],"output":{"name":"osstr"}}],[11,"as_ref","","",411,{"inputs":[{"name":"component"}],"output":{"name":"osstr"}}],[11,"clone","","",413,{"inputs":[{"name":"components"}],"output":{"name":"components"}}],[11,"clone","","",414,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"as_path","","Extracts a slice corresponding to the portion of the path remaining for iteration.",413,{"inputs":[{"name":"components"}],"output":{"name":"path"}}],[11,"peek","","Examine the next component without consuming it.",413,{"inputs":[{"name":"components"}],"output":{"name":"option"}}],[11,"as_ref","","",413,{"inputs":[{"name":"components"}],"output":{"name":"path"}}],[11,"as_ref","","",413,{"inputs":[{"name":"components"}],"output":{"name":"osstr"}}],[11,"as_path","","Extracts a slice corresponding to the portion of the path remaining for iteration.",414,{"inputs":[{"name":"iter"}],"output":{"name":"path"}}],[11,"as_ref","","",414,{"inputs":[{"name":"iter"}],"output":{"name":"path"}}],[11,"as_ref","","",414,{"inputs":[{"name":"iter"}],"output":{"name":"osstr"}}],[6,"Item","","",null,null],[11,"next","","",414,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"next_back","","",414,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",413,{"inputs":[{"name":"components"}],"output":{"name":"option"}}],[11,"next_back","","",413,{"inputs":[{"name":"components"}],"output":{"name":"option"}}],[11,"eq","","",413,{"inputs":[{"name":"components"},{"name":"components"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",413,{"inputs":[{"name":"components"},{"name":"components"}],"output":{"name":"option"}}],[11,"cmp","","",413,{"inputs":[{"name":"components"},{"name":"components"}],"output":{"name":"ordering"}}],[11,"hash","","",415,null],[11,"clone","","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"pathbuf"}}],[11,"new","","Allocates an empty `PathBuf`.",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"pathbuf"}}],[11,"as_path","","Coerces to a `Path` slice.",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[11,"push","","Extends `self` with `path`.",415,{"inputs":[{"name":"pathbuf"},{"name":"p"}],"output":null}],[11,"pop","","Truncate `self` to `self.parent()`.",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"bool"}}],[11,"set_file_name","","Updates `self.file_name()` to `file_name`.",415,{"inputs":[{"name":"pathbuf"},{"name":"s"}],"output":null}],[11,"set_extension","","Updates `self.extension()` to `extension`.",415,{"inputs":[{"name":"pathbuf"},{"name":"s"}],"output":{"name":"bool"}}],[11,"into_os_string","","Consumes the `PathBuf`, yielding its internal `OsString` storage.",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"osstring"}}],[11,"from","","",415,{"inputs":[{"name":"pathbuf"},{"name":"t"}],"output":{"name":"pathbuf"}}],[11,"from","","",415,{"inputs":[{"name":"pathbuf"},{"name":"osstring"}],"output":{"name":"pathbuf"}}],[11,"from","","",415,{"inputs":[{"name":"pathbuf"},{"name":"string"}],"output":{"name":"pathbuf"}}],[11,"from_iter","","",415,{"inputs":[{"name":"pathbuf"},{"name":"i"}],"output":{"name":"pathbuf"}}],[11,"extend","","",415,{"inputs":[{"name":"pathbuf"},{"name":"i"}],"output":null}],[11,"fmt","","",415,{"inputs":[{"name":"pathbuf"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","","",null,null],[11,"deref","","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[11,"borrow","","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[11,"into_cow","","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"cow"}}],[6,"Owned","","",null,null],[11,"to_owned","","",416,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[11,"eq","","",415,{"inputs":[{"name":"pathbuf"},{"name":"pathbuf"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",415,{"inputs":[{"name":"pathbuf"},{"name":"pathbuf"}],"output":{"name":"option"}}],[11,"cmp","","",415,{"inputs":[{"name":"pathbuf"},{"name":"pathbuf"}],"output":{"name":"ordering"}}],[11,"as_ref","","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"osstr"}}],[11,"into","","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"osstring"}}],[11,"hash","","",416,null],[11,"new","","Directly wrap a string slice as a `Path` slice.",416,{"inputs":[{"name":"path"},{"name":"s"}],"output":{"name":"path"}}],[11,"as_os_str","","Yields the underlying `OsStr` slice.",416,{"inputs":[{"name":"path"}],"output":{"name":"osstr"}}],[11,"to_str","","Yields a `&str` slice if the `Path` is valid unicode.",416,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"to_string_lossy","","Converts a `Path` to a `Cow<str>`.",416,{"inputs":[{"name":"path"}],"output":{"name":"cow"}}],[11,"to_path_buf","","Converts a `Path` to an owned `PathBuf`.",416,{"inputs":[{"name":"path"}],"output":{"name":"pathbuf"}}],[11,"is_absolute","","A path is *absolute* if it is independent of the current directory.",416,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"is_relative","","A path is *relative* if it is not absolute.",416,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"prefix","","Returns the *prefix* of a path, if any.",416,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"has_root","","A path has a root if the body of the path begins with the directory separator.",416,{"inputs":[{"name":"path"}],"output":{"name":"bool"}}],[11,"parent","","The path without its final component, if any.",416,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"file_name","","The final component of the path, if it is a normal file.",416,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"relative_from","","Returns a path that, when joined onto `base`, yields `self`.",416,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"option"}}],[11,"starts_with","","Determines whether `base` is a prefix of `self`.",416,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"bool"}}],[11,"ends_with","","Determines whether `child` is a suffix of `self`.",416,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"bool"}}],[11,"file_stem","","Extracts the stem (non-extension) portion of `self.file()`.",416,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"extension","","Extracts the extension of `self.file()`, if possible.",416,{"inputs":[{"name":"path"}],"output":{"name":"option"}}],[11,"join","","Creates an owned `PathBuf` with `path` adjoined to `self`.",416,{"inputs":[{"name":"path"},{"name":"p"}],"output":{"name":"pathbuf"}}],[11,"with_file_name","","Creates an owned `PathBuf` like `self` but with the given file name.",416,{"inputs":[{"name":"path"},{"name":"s"}],"output":{"name":"pathbuf"}}],[11,"with_extension","","Creates an owned `PathBuf` like `self` but with the given extension.",416,{"inputs":[{"name":"path"},{"name":"s"}],"output":{"name":"pathbuf"}}],[11,"components","","Produce an iterator over the components of the path.",416,{"inputs":[{"name":"path"}],"output":{"name":"components"}}],[11,"iter","","Produce an iterator over the path's components viewed as `OsStr` slices.",416,{"inputs":[{"name":"path"}],"output":{"name":"iter"}}],[11,"display","","Returns an object that implements `Display` for safely printing paths\nthat may contain non-Unicode data.",416,{"inputs":[{"name":"path"}],"output":{"name":"display"}}],[11,"as_ref","","",416,{"inputs":[{"name":"path"}],"output":{"name":"osstr"}}],[11,"fmt","","",416,{"inputs":[{"name":"path"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",417,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",417,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",416,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",416,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"option"}}],[11,"cmp","","",416,{"inputs":[{"name":"path"},{"name":"path"}],"output":{"name":"ordering"}}],[11,"as_ref","","",416,{"inputs":[{"name":"path"}],"output":{"name":"path"}}],[11,"as_ref","std::ffi","",348,{"inputs":[{"name":"osstr"}],"output":{"name":"path"}}],[11,"as_ref","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"path"}}],[11,"as_ref","std::string","",262,{"inputs":[{"name":"string"}],"output":{"name":"path"}}],[11,"as_ref","std::path","",415,{"inputs":[{"name":"pathbuf"}],"output":{"name":"path"}}],[0,"process","std","Working with processes.",null,null],[3,"Child","std::process","Representation of a running or exited child process.",null,null],[12,"stdin","","The handle for writing to the child's stdin, if it has been captured",418,null],[12,"stdout","","The handle for reading from the child's stdout, if it has been captured",418,null],[12,"stderr","","The handle for reading from the child's stderr, if it has been captured",418,null],[3,"ChildStdin","","A handle to a child procesess's stdin",null,null],[3,"ChildStdout","","A handle to a child procesess's stdout",null,null],[3,"ChildStderr","","A handle to a child procesess's stderr",null,null],[3,"Command","","The `Command` type acts as a process builder, providing fine-grained control\nover how a new process should be spawned. A default configuration can be\ngenerated using `Command::new(program)`, where `program` gives a path to the\nprogram to be executed. Additional builder methods allow the configuration\nto be changed (for example, by adding arguments) prior to spawning:",null,null],[3,"Output","","The output of a finished process.",null,null],[12,"status","","The status (exit code) of the process.",419,null],[12,"stdout","","The data that the process wrote to stdout.",419,null],[12,"stderr","","The data that the process wrote to stderr.",419,null],[3,"Stdio","","Describes what to do with a standard I/O stream for a child process.",null,null],[3,"ExitStatus","","Describes the result of a process after it has terminated.",null,null],[5,"exit","","Terminates the current process with the specified exit code.",null,{"inputs":[{"name":"i32"}],"output":null}],[11,"write","","",420,null],[11,"flush","","",420,{"inputs":[{"name":"childstdin"}],"output":{"name":"result"}}],[11,"read","","",421,null],[11,"read","","",422,null],[11,"new","","Constructs a new `Command` for launching the program at\npath `program`, with the following default configuration:",423,{"inputs":[{"name":"command"},{"name":"s"}],"output":{"name":"command"}}],[11,"arg","","Add an argument to pass to the program.",423,{"inputs":[{"name":"command"},{"name":"s"}],"output":{"name":"command"}}],[11,"args","","Add multiple arguments to pass to the program.",423,null],[11,"env","","Inserts or updates an environment variable mapping.",423,{"inputs":[{"name":"command"},{"name":"k"},{"name":"v"}],"output":{"name":"command"}}],[11,"env_remove","","Removes an environment variable mapping.",423,{"inputs":[{"name":"command"},{"name":"k"}],"output":{"name":"command"}}],[11,"env_clear","","Clears the entire environment map for the child process.",423,{"inputs":[{"name":"command"}],"output":{"name":"command"}}],[11,"current_dir","","Sets the working directory for the child process.",423,{"inputs":[{"name":"command"},{"name":"p"}],"output":{"name":"command"}}],[11,"stdin","","Configuration for the child process's stdin handle (file descriptor 0).",423,{"inputs":[{"name":"command"},{"name":"stdio"}],"output":{"name":"command"}}],[11,"stdout","","Configuration for the child process's stdout handle (file descriptor 1).",423,{"inputs":[{"name":"command"},{"name":"stdio"}],"output":{"name":"command"}}],[11,"stderr","","Configuration for the child process's stderr handle (file descriptor 2).",423,{"inputs":[{"name":"command"},{"name":"stdio"}],"output":{"name":"command"}}],[11,"spawn","","Executes the command as a child process, returning a handle to it.",423,{"inputs":[{"name":"command"}],"output":{"name":"result"}}],[11,"output","","Executes the command as a child process, waiting for it to finish and\ncollecting all of its output.",423,{"inputs":[{"name":"command"}],"output":{"name":"result"}}],[11,"status","","Executes a command as a child process, waiting for it to finish and\ncollecting its exit status.",423,{"inputs":[{"name":"command"}],"output":{"name":"result"}}],[11,"fmt","","Format the program and arguments of a Command for display. Any\nnon-utf8 data is lossily converted using the utf8 replacement\ncharacter.",423,{"inputs":[{"name":"command"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",419,{"inputs":[{"name":"output"}],"output":{"name":"output"}}],[11,"eq","","",419,{"inputs":[{"name":"output"},{"name":"output"}],"output":{"name":"bool"}}],[11,"ne","","",419,{"inputs":[{"name":"output"},{"name":"output"}],"output":{"name":"bool"}}],[11,"piped","","A new pipe should be arranged to connect the parent and child processes.",424,{"inputs":[{"name":"stdio"}],"output":{"name":"stdio"}}],[11,"inherit","","The child inherits from the corresponding parent descriptor.",424,{"inputs":[{"name":"stdio"}],"output":{"name":"stdio"}}],[11,"null","","This stream will be ignored. This is the equivalent of attaching the\nstream to `/dev/null`",424,{"inputs":[{"name":"stdio"}],"output":{"name":"stdio"}}],[11,"fmt","","",425,{"inputs":[{"name":"exitstatus"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",425,{"inputs":[{"name":"exitstatus"}],"output":{"name":"exitstatus"}}],[11,"eq","","",425,{"inputs":[{"name":"exitstatus"},{"name":"exitstatus"}],"output":{"name":"bool"}}],[11,"ne","","",425,{"inputs":[{"name":"exitstatus"},{"name":"exitstatus"}],"output":{"name":"bool"}}],[11,"success","","Was termination successful? Signal termination not considered a success,\nand success is defined as a zero exit status.",425,{"inputs":[{"name":"exitstatus"}],"output":{"name":"bool"}}],[11,"code","","Returns the exit code of the process, if any.",425,{"inputs":[{"name":"exitstatus"}],"output":{"name":"option"}}],[11,"fmt","","",425,{"inputs":[{"name":"exitstatus"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"kill","","Forces the child to exit. This is equivalent to sending a\nSIGKILL on unix platforms.",418,{"inputs":[{"name":"child"}],"output":{"name":"result"}}],[11,"wait","","Waits for the child to exit completely, returning the status that it\nexited with. This function will continue to have the same return value\nafter it has been called at least once.",418,{"inputs":[{"name":"child"}],"output":{"name":"result"}}],[11,"wait_with_output","","Simultaneously waits for the child to exit and collect all remaining\noutput on the stdout/stderr handles, returning a `Output`\ninstance.",418,{"inputs":[{"name":"child"}],"output":{"name":"result"}}],[0,"sync","std","Useful synchronization primitives",null,null],[3,"Arc","std::sync","An atomically reference counted wrapper for shared state.",null,null],[3,"Weak","","A weak pointer to an `Arc`.",null,null],[0,"atomic","","Atomic types",null,null],[3,"AtomicBool","std::sync::atomic","A boolean type which can be safely shared between threads.",null,null],[3,"AtomicIsize","","A signed integer type which can be safely shared between threads.",null,null],[3,"AtomicUsize","","An unsigned integer type which can be safely shared between threads.",null,null],[3,"AtomicPtr","","A raw pointer type which can be safely shared between threads.",null,null],[4,"Ordering","","Atomic memory orderings",null,null],[13,"Relaxed","","No ordering constraints, only atomic operations.",21,null],[13,"Release","","When coupled with a store, all previous writes become visible\nto another thread that performs a load with `Acquire` ordering\non the same value.",21,null],[13,"Acquire","","When coupled with a load, all subsequent loads will see data\nwritten before a store with `Release` ordering on the same value\nin another thread.",21,null],[13,"AcqRel","","When coupled with a load, uses `Acquire` ordering, and with a store\n`Release` ordering.",21,null],[13,"SeqCst","","Like `AcqRel` with the additional guarantee that all threads see all\nsequentially consistent operations in the same order.",21,null],[17,"ATOMIC_BOOL_INIT","","An `AtomicBool` initialized to `false`.",null,null],[17,"ATOMIC_ISIZE_INIT","","An `AtomicIsize` initialized to `0`.",null,null],[17,"ATOMIC_USIZE_INIT","","An `AtomicUsize` initialized to `0`.",null,null],[5,"fence","","An atomic fence.",null,null],[3,"Barrier","std::sync","A barrier enables multiple threads to synchronize the beginning\nof some computation.",null,null],[3,"BarrierWaitResult","","A result returned from wait.",null,null],[3,"Condvar","","A Condition Variable",null,null],[3,"StaticCondvar","","Statically allocated condition variables.",null,null],[3,"Mutex","","A mutual exclusion primitive useful for protecting shared data",null,null],[3,"MutexGuard","","An RAII implementation of a \"scoped lock\" of a mutex. When this structure is\ndropped (falls out of scope), the lock will be unlocked.",null,null],[3,"StaticMutex","","The static mutex type is provided to allow for static allocation of mutexes.",null,null],[3,"Once","","A synchronization primitive which can be used to run a one-time global\ninitialization. Useful for one-time initialization for FFI or related\nfunctionality. This type can only be constructed with the `ONCE_INIT`\nvalue.",null,null],[3,"PoisonError","","A type of error which can be returned whenever a lock is acquired.",null,null],[3,"RwLockReadGuard","","RAII structure used to release the shared read access of a lock when\ndropped.",null,null],[3,"RwLockWriteGuard","","RAII structure used to release the exclusive write access of a lock when\ndropped.",null,null],[3,"RwLock","","A reader-writer lock",null,null],[3,"StaticRwLock","","Structure representing a statically allocated RwLock.",null,null],[3,"Semaphore","","A counting, blocking, semaphore.",null,null],[3,"SemaphoreGuard","","An RAII guard which will release a resource acquired from a semaphore when\ndropped.",null,null],[3,"Future","","A type encapsulating the result of a computation which may not be complete",null,null],[4,"TryLockError","","An enumeration of possible errors which can occur while calling the\n`try_lock` method.",null,null],[13,"Poisoned","","The lock could not be acquired because another thread failed while holding\nthe lock.",426,null],[13,"WouldBlock","","The lock could not be acquired at this time because the operation would\notherwise block.",426,null],[0,"mpsc","","Multi-producer, single-consumer FIFO queue communication primitives.",null,null],[3,"Select","std::sync::mpsc","The \"receiver set\" of the select interface. This structure is used to manage\na set of receivers which are being selected over.",null,null],[3,"Handle","","A handle to a receiver which is currently a member of a `Select` set of\nreceivers.  This handle is used to keep the receiver in the set as well as\ninteract with the underlying receiver.",null,null],[3,"Receiver","","The receiving-half of Rust's channel type. This half can only be owned by\none thread",null,null],[3,"Iter","","An iterator over messages on a receiver, this iterator will block\nwhenever `next` is called, waiting for a new message, and `None` will be\nreturned when the corresponding channel has hung up.",null,null],[3,"Sender","","The sending-half of Rust's asynchronous channel type. This half can only be\nowned by one thread, but it can be cloned to send to other threads.",null,null],[3,"SyncSender","","The sending-half of Rust's synchronous channel type. This half can only be\nowned by one thread, but it can be cloned to send to other threads.",null,null],[3,"SendError","","An error returned from the `send` function on channels.",null,null],[3,"RecvError","","An error returned from the `recv` function on a `Receiver`.",null,null],[4,"TryRecvError","","This enumeration is the list of the possible reasons that `try_recv` could\nnot return data when called.",null,null],[13,"Empty","","This channel is currently empty, but the sender(s) have not yet\ndisconnected, so data may yet become available.",427,null],[13,"Disconnected","","This channel's sending half has become disconnected, and there will\nnever be any more data received on this channel",427,null],[4,"TrySendError","","This enumeration is the list of the possible error outcomes for the\n`SyncSender::try_send` method.",null,null],[13,"Full","","The data could not be sent on the channel because it would require that\nthe callee block to send the data.",428,null],[13,"Disconnected","","This channel's receiving half has disconnected, so the data could not be\nsent. The data is returned back to the callee in this case.",428,null],[5,"channel","","Creates a new asynchronous channel, returning the sender/receiver halves.",null,null],[5,"sync_channel","","Creates a new synchronous, bounded channel.",null,null],[11,"new","","Creates a new selection structure. This set is initially empty.",429,{"inputs":[{"name":"select"}],"output":{"name":"select"}}],[11,"handle","","Creates a new handle into this receiver set for a new receiver. Note\nthat this does *not* add the receiver to the receiver set, for that you\nmust call the `add` method on the handle itself.",429,{"inputs":[{"name":"select"},{"name":"receiver"}],"output":{"name":"handle"}}],[11,"wait","","Waits for an event on this receiver set. The returned value is *not* an\nindex, but rather an id. This id can be queried against any active\n`Handle` structures (each one has an `id` method). The handle with\nthe matching `id` will have some sort of event available on it. The\nevent could either be that data is available or the corresponding\nchannel has been closed.",429,{"inputs":[{"name":"select"}],"output":{"name":"usize"}}],[11,"id","","Retrieves the id of this handle.",430,{"inputs":[{"name":"handle"}],"output":{"name":"usize"}}],[11,"recv","","Blocks to receive a value on the underlying receiver, returning `Some` on\nsuccess or `None` if the channel disconnects. This function has the same\nsemantics as `Receiver.recv`",430,{"inputs":[{"name":"handle"}],"output":{"name":"result"}}],[11,"add","","Adds this handle to the receiver set that the handle was created from. This\nmethod can be called multiple times, but it has no effect if `add` was\ncalled previously.",430,{"inputs":[{"name":"handle"}],"output":null}],[11,"remove","","Removes this handle from the `Select` set. This method is unsafe because\nit has no guarantee that the `Handle` was not moved since `add` was\ncalled.",430,{"inputs":[{"name":"handle"}],"output":null}],[11,"drop","","",429,{"inputs":[{"name":"select"}],"output":null}],[11,"drop","","",430,{"inputs":[{"name":"handle"}],"output":null}],[11,"clone","","",431,{"inputs":[{"name":"senderror"}],"output":{"name":"senderror"}}],[11,"eq","","",431,{"inputs":[{"name":"senderror"},{"name":"senderror"}],"output":{"name":"bool"}}],[11,"ne","","",431,{"inputs":[{"name":"senderror"},{"name":"senderror"}],"output":{"name":"bool"}}],[11,"fmt","","",432,{"inputs":[{"name":"recverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",432,{"inputs":[{"name":"recverror"}],"output":{"name":"recverror"}}],[11,"eq","","",432,{"inputs":[{"name":"recverror"},{"name":"recverror"}],"output":{"name":"bool"}}],[11,"ne","","",432,{"inputs":[{"name":"recverror"},{"name":"recverror"}],"output":{"name":"bool"}}],[11,"fmt","","",427,{"inputs":[{"name":"tryrecverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",427,{"inputs":[{"name":"tryrecverror"}],"output":{"name":"tryrecverror"}}],[11,"eq","","",427,{"inputs":[{"name":"tryrecverror"},{"name":"tryrecverror"}],"output":{"name":"bool"}}],[11,"ne","","",427,{"inputs":[{"name":"tryrecverror"},{"name":"tryrecverror"}],"output":{"name":"bool"}}],[11,"clone","","",428,{"inputs":[{"name":"trysenderror"}],"output":{"name":"trysenderror"}}],[11,"eq","","",428,{"inputs":[{"name":"trysenderror"},{"name":"trysenderror"}],"output":{"name":"bool"}}],[11,"ne","","",428,{"inputs":[{"name":"trysenderror"},{"name":"trysenderror"}],"output":{"name":"bool"}}],[11,"send","","Attempts to send a value on this channel, returning it back if it could\nnot be sent.",433,{"inputs":[{"name":"sender"},{"name":"t"}],"output":{"name":"result"}}],[11,"clone","","",433,{"inputs":[{"name":"sender"}],"output":{"name":"sender"}}],[11,"drop","","",433,{"inputs":[{"name":"sender"}],"output":null}],[11,"send","","Sends a value on this synchronous channel.",434,{"inputs":[{"name":"syncsender"},{"name":"t"}],"output":{"name":"result"}}],[11,"try_send","","Attempts to send a value on this channel without blocking.",434,{"inputs":[{"name":"syncsender"},{"name":"t"}],"output":{"name":"result"}}],[11,"clone","","",434,{"inputs":[{"name":"syncsender"}],"output":{"name":"syncsender"}}],[11,"drop","","",434,{"inputs":[{"name":"syncsender"}],"output":null}],[11,"try_recv","","Attempts to return a pending value on this receiver without blocking",435,{"inputs":[{"name":"receiver"}],"output":{"name":"result"}}],[11,"recv","","Attempts to wait for a value on this receiver, returning an error if the\ncorresponding channel has hung up.",435,{"inputs":[{"name":"receiver"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator that will block waiting for messages, but never\n`panic!`. It will return `None` when the channel has hung up.",435,{"inputs":[{"name":"receiver"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",436,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"drop","","",435,{"inputs":[{"name":"receiver"}],"output":null}],[11,"fmt","","",431,{"inputs":[{"name":"senderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",431,{"inputs":[{"name":"senderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",431,{"inputs":[{"name":"senderror"}],"output":{"name":"str"}}],[11,"cause","","",431,{"inputs":[{"name":"senderror"}],"output":{"name":"option"}}],[11,"fmt","","",428,{"inputs":[{"name":"trysenderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",428,{"inputs":[{"name":"trysenderror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",428,{"inputs":[{"name":"trysenderror"}],"output":{"name":"str"}}],[11,"cause","","",428,{"inputs":[{"name":"trysenderror"}],"output":{"name":"option"}}],[11,"fmt","","",432,{"inputs":[{"name":"recverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",432,{"inputs":[{"name":"recverror"}],"output":{"name":"str"}}],[11,"cause","","",432,{"inputs":[{"name":"recverror"}],"output":{"name":"option"}}],[11,"fmt","","",427,{"inputs":[{"name":"tryrecverror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",427,{"inputs":[{"name":"tryrecverror"}],"output":{"name":"str"}}],[11,"cause","","",427,{"inputs":[{"name":"tryrecverror"}],"output":{"name":"option"}}],[11,"new","std::sync","Creates a new barrier that can block a given number of threads.",437,{"inputs":[{"name":"barrier"},{"name":"usize"}],"output":{"name":"barrier"}}],[11,"wait","","Blocks the current thread until all threads has rendezvoused here.",437,{"inputs":[{"name":"barrier"}],"output":{"name":"barrierwaitresult"}}],[11,"is_leader","","Returns whether this thread from `wait` is the \"leader thread\".",438,{"inputs":[{"name":"barrierwaitresult"}],"output":{"name":"bool"}}],[11,"new","","Creates a new condition variable which is ready to be waited on and\nnotified.",439,{"inputs":[{"name":"condvar"}],"output":{"name":"condvar"}}],[11,"wait","","Blocks the current thread until this condition variable receives a\nnotification.",439,{"inputs":[{"name":"condvar"},{"name":"mutexguard"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_ms","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",439,{"inputs":[{"name":"condvar"},{"name":"mutexguard"},{"name":"u32"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_with","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",439,{"inputs":[{"name":"condvar"},{"name":"mutexguard"},{"name":"duration"},{"name":"f"}],"output":{"name":"lockresult"}}],[11,"notify_one","","Wakes up one blocked thread on this condvar.",439,{"inputs":[{"name":"condvar"}],"output":null}],[11,"notify_all","","Wakes up all blocked threads on this condvar.",439,{"inputs":[{"name":"condvar"}],"output":null}],[11,"drop","","",439,{"inputs":[{"name":"condvar"}],"output":null}],[11,"wait","","Blocks the current thread until this condition variable receives a\nnotification.",440,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_ms","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",440,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"},{"name":"u32"}],"output":{"name":"lockresult"}}],[11,"wait_timeout_with","","Waits on this condition variable for a notification, timing out after a\nspecified duration.",440,{"inputs":[{"name":"staticcondvar"},{"name":"mutexguard"},{"name":"duration"},{"name":"f"}],"output":{"name":"lockresult"}}],[11,"notify_one","","Wakes up one blocked thread on this condvar.",440,{"inputs":[{"name":"staticcondvar"}],"output":null}],[11,"notify_all","","Wakes up all blocked threads on this condvar.",440,{"inputs":[{"name":"staticcondvar"}],"output":null}],[11,"destroy","","Deallocates all resources associated with this static condvar.",440,{"inputs":[{"name":"staticcondvar"}],"output":null}],[11,"get","","Get the value of the future.",441,{"inputs":[{"name":"future"}],"output":{"name":"a"}}],[11,"into_inner","","Gets the value from this future, forcing evaluation.",441,{"inputs":[{"name":"future"}],"output":{"name":"a"}}],[11,"get_ref","","Executes the future's closure and then returns a reference\nto the result.  The reference lasts as long as\nthe future.",441,{"inputs":[{"name":"future"}],"output":{"name":"a"}}],[11,"from_value","","Create a future from a value.",441,{"inputs":[{"name":"future"},{"name":"a"}],"output":{"name":"future"}}],[11,"from_fn","","Create a future from a function.",441,{"inputs":[{"name":"future"},{"name":"f"}],"output":{"name":"future"}}],[11,"from_receiver","","Create a future from a port",441,{"inputs":[{"name":"future"},{"name":"receiver"}],"output":{"name":"future"}}],[11,"spawn","","Create a future from a unique closure.",441,{"inputs":[{"name":"future"},{"name":"f"}],"output":{"name":"future"}}],[11,"new","","Creates a new mutex in an unlocked state ready for use.",442,{"inputs":[{"name":"mutex"},{"name":"t"}],"output":{"name":"mutex"}}],[11,"lock","","Acquires a mutex, blocking the current thread until it is able to do so.",442,{"inputs":[{"name":"mutex"}],"output":{"name":"lockresult"}}],[11,"try_lock","","Attempts to acquire this lock.",442,{"inputs":[{"name":"mutex"}],"output":{"name":"trylockresult"}}],[11,"is_poisoned","","Determines whether the lock is poisoned.",442,{"inputs":[{"name":"mutex"}],"output":{"name":"bool"}}],[11,"drop","","",442,{"inputs":[{"name":"mutex"}],"output":null}],[11,"fmt","","",442,{"inputs":[{"name":"mutex"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"lock","","Acquires this lock, see `Mutex::lock`",443,{"inputs":[{"name":"staticmutex"}],"output":{"name":"lockresult"}}],[11,"try_lock","","Attempts to grab this lock, see `Mutex::try_lock`",443,{"inputs":[{"name":"staticmutex"}],"output":{"name":"trylockresult"}}],[11,"destroy","","Deallocates resources associated with this static mutex.",443,{"inputs":[{"name":"staticmutex"}],"output":null}],[11,"deref","","",444,{"inputs":[{"name":"mutexguard"}],"output":{"name":"t"}}],[11,"deref_mut","","",444,{"inputs":[{"name":"mutexguard"}],"output":{"name":"t"}}],[11,"drop","","",444,{"inputs":[{"name":"mutexguard"}],"output":null}],[11,"call_once","","Performs an initialization routine once and only once. The given closure\nwill be executed if this is the first time `call_once` has been called,\nand otherwise the routine will *not* be invoked.",445,{"inputs":[{"name":"once"},{"name":"f"}],"output":null}],[11,"new","","Creates a new instance of an `RwLock<T>` which is unlocked.",446,{"inputs":[{"name":"rwlock"},{"name":"t"}],"output":{"name":"rwlock"}}],[11,"read","","Locks this rwlock with shared read access, blocking the current thread\nuntil it can be acquired.",446,{"inputs":[{"name":"rwlock"}],"output":{"name":"lockresult"}}],[11,"try_read","","Attempts to acquire this lock with shared read access.",446,{"inputs":[{"name":"rwlock"}],"output":{"name":"trylockresult"}}],[11,"write","","Locks this rwlock with exclusive write access, blocking the current\nthread until it can be acquired.",446,{"inputs":[{"name":"rwlock"}],"output":{"name":"lockresult"}}],[11,"try_write","","Attempts to lock this rwlock with exclusive write access.",446,{"inputs":[{"name":"rwlock"}],"output":{"name":"trylockresult"}}],[11,"is_poisoned","","Determines whether the lock is poisoned.",446,{"inputs":[{"name":"rwlock"}],"output":{"name":"bool"}}],[11,"drop","","",446,{"inputs":[{"name":"rwlock"}],"output":null}],[11,"fmt","","",446,{"inputs":[{"name":"rwlock"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"read","","Locks this rwlock with shared read access, blocking the current thread\nuntil it can be acquired.",447,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"lockresult"}}],[11,"try_read","","Attempts to acquire this lock with shared read access.",447,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"trylockresult"}}],[11,"write","","Locks this rwlock with exclusive write access, blocking the current\nthread until it can be acquired.",447,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"lockresult"}}],[11,"try_write","","Attempts to lock this rwlock with exclusive write access.",447,{"inputs":[{"name":"staticrwlock"}],"output":{"name":"trylockresult"}}],[11,"destroy","","Deallocates all resources associated with this static lock.",447,{"inputs":[{"name":"staticrwlock"}],"output":null}],[11,"deref","","",448,{"inputs":[{"name":"rwlockreadguard"}],"output":{"name":"t"}}],[11,"deref","","",449,{"inputs":[{"name":"rwlockwriteguard"}],"output":{"name":"t"}}],[11,"deref_mut","","",449,{"inputs":[{"name":"rwlockwriteguard"}],"output":{"name":"t"}}],[11,"drop","","",448,{"inputs":[{"name":"rwlockreadguard"}],"output":null}],[11,"drop","","",449,{"inputs":[{"name":"rwlockwriteguard"}],"output":null}],[11,"new","","Creates a new semaphore with the initial count specified.",450,{"inputs":[{"name":"semaphore"},{"name":"isize"}],"output":{"name":"semaphore"}}],[11,"acquire","","Acquires a resource of this semaphore, blocking the current thread until\nit can do so.",450,{"inputs":[{"name":"semaphore"}],"output":null}],[11,"release","","Release a resource from this semaphore.",450,{"inputs":[{"name":"semaphore"}],"output":null}],[11,"access","","Acquires a resource of this semaphore, returning an RAII guard to\nrelease the semaphore when dropped.",450,{"inputs":[{"name":"semaphore"}],"output":{"name":"semaphoreguard"}}],[11,"drop","","",451,{"inputs":[{"name":"semaphoreguard"}],"output":null}],[6,"TryLockResult","","A type alias for the result of a nonblocking locking method.",null,null],[6,"LockResult","","A type alias for the result of a lock method which can be poisoned.",null,null],[17,"CONDVAR_INIT","","Constant initializer for a statically allocated condition variable.",null,null],[17,"MUTEX_INIT","","Static initialization of a mutex. This constant can be used to initialize\nother mutex constants.",null,null],[17,"ONCE_INIT","","Initialization value for static `Once` values.",null,null],[17,"RW_LOCK_INIT","","Constant initialization for a statically-initialized rwlock.",null,null],[0,"time","std","Temporal quantification.",null,null],[0,"duration","std::time","Temporal quantification",null,null],[3,"Duration","std::time::duration","ISO 8601 time duration with nanosecond precision.\nThis also allows for the negative duration; see individual methods for details.",null,null],[17,"MIN","","The minimum possible `Duration`: `i64::MIN` milliseconds.",null,null],[17,"MAX","","The maximum possible `Duration`: `i64::MAX` milliseconds.",null,null],[11,"fmt","","",452,{"inputs":[{"name":"duration"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"option"}}],[11,"lt","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"le","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"gt","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"ge","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"eq","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"ne","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"bool"}}],[11,"clone","","",452,{"inputs":[{"name":"duration"}],"output":{"name":"duration"}}],[11,"weeks","","Makes a new `Duration` with given number of weeks.\nEquivalent to `Duration::seconds(weeks * 7 * 24 * 60 * 60)` with overflow checks.\nPanics when the duration is out of bounds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"days","","Makes a new `Duration` with given number of days.\nEquivalent to `Duration::seconds(days * 24 * 60 * 60)` with overflow checks.\nPanics when the duration is out of bounds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"hours","","Makes a new `Duration` with given number of hours.\nEquivalent to `Duration::seconds(hours * 60 * 60)` with overflow checks.\nPanics when the duration is out of bounds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"minutes","","Makes a new `Duration` with given number of minutes.\nEquivalent to `Duration::seconds(minutes * 60)` with overflow checks.\nPanics when the duration is out of bounds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"seconds","","Makes a new `Duration` with given number of seconds.\nPanics when the duration is more than `i64::MAX` milliseconds\nor less than `i64::MIN` milliseconds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"milliseconds","","Makes a new `Duration` with given number of milliseconds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"microseconds","","Makes a new `Duration` with given number of microseconds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"nanoseconds","","Makes a new `Duration` with given number of nanoseconds.",452,{"inputs":[{"name":"duration"},{"name":"i64"}],"output":{"name":"duration"}}],[11,"span","","Runs a closure, returning the duration of time it took to run the\nclosure.",452,{"inputs":[{"name":"duration"},{"name":"f"}],"output":{"name":"duration"}}],[11,"num_weeks","","Returns the total number of whole weeks in the duration.",452,{"inputs":[{"name":"duration"}],"output":{"name":"i64"}}],[11,"num_days","","Returns the total number of whole days in the duration.",452,{"inputs":[{"name":"duration"}],"output":{"name":"i64"}}],[11,"num_hours","","Returns the total number of whole hours in the duration.",452,{"inputs":[{"name":"duration"}],"output":{"name":"i64"}}],[11,"num_minutes","","Returns the total number of whole minutes in the duration.",452,{"inputs":[{"name":"duration"}],"output":{"name":"i64"}}],[11,"num_seconds","","Returns the total number of whole seconds in the duration.",452,{"inputs":[{"name":"duration"}],"output":{"name":"i64"}}],[11,"num_milliseconds","","Returns the total number of whole milliseconds in the duration,",452,{"inputs":[{"name":"duration"}],"output":{"name":"i64"}}],[11,"num_microseconds","","Returns the total number of whole microseconds in the duration,\nor `None` on overflow (exceeding 2^63 microseconds in either direction).",452,{"inputs":[{"name":"duration"}],"output":{"name":"option"}}],[11,"num_nanoseconds","","Returns the total number of whole nanoseconds in the duration,\nor `None` on overflow (exceeding 2^63 nanoseconds in either direction).",452,{"inputs":[{"name":"duration"}],"output":{"name":"option"}}],[11,"checked_add","","Add two durations, returning `None` if overflow occurred.",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"option"}}],[11,"checked_sub","","Subtract two durations, returning `None` if overflow occurred.",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"option"}}],[11,"min_value","","The minimum possible `Duration`: `i64::MIN` milliseconds.",452,{"inputs":[{"name":"duration"}],"output":{"name":"duration"}}],[11,"max_value","","The maximum possible `Duration`: `i64::MAX` milliseconds.",452,{"inputs":[{"name":"duration"}],"output":{"name":"duration"}}],[11,"zero","","A duration where the stored seconds and nanoseconds are equal to zero.",452,{"inputs":[{"name":"duration"}],"output":{"name":"duration"}}],[11,"is_zero","","Returns `true` if the duration equals `Duration::zero()`.",452,{"inputs":[{"name":"duration"}],"output":{"name":"bool"}}],[6,"Output","","",null,null],[11,"neg","","",452,{"inputs":[{"name":"duration"}],"output":{"name":"duration"}}],[6,"Output","","",null,null],[11,"add","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"duration"}}],[6,"Output","","",null,null],[11,"sub","","",452,{"inputs":[{"name":"duration"},{"name":"duration"}],"output":{"name":"duration"}}],[6,"Output","","",null,null],[11,"mul","","",452,{"inputs":[{"name":"duration"},{"name":"i32"}],"output":{"name":"duration"}}],[6,"Output","","",null,null],[11,"div","","",452,{"inputs":[{"name":"duration"},{"name":"i32"}],"output":{"name":"duration"}}],[11,"fmt","","",452,{"inputs":[{"name":"duration"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","std::sync","",453,{"inputs":[{"name":"poisonerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",453,{"inputs":[{"name":"poisonerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",453,{"inputs":[{"name":"poisonerror"}],"output":{"name":"str"}}],[11,"new","","Creates a `PoisonError`.",453,{"inputs":[{"name":"poisonerror"},{"name":"t"}],"output":{"name":"poisonerror"}}],[11,"into_inner","","Consumes this error indicating that a lock is poisoned, returning the\nunderlying guard to allow access regardless.",453,{"inputs":[{"name":"poisonerror"}],"output":{"name":"t"}}],[11,"get_ref","","Reaches into this error indicating that a lock is poisoned, returning a\nreference to the underlying guard to allow access regardless.",453,{"inputs":[{"name":"poisonerror"}],"output":{"name":"t"}}],[11,"get_mut","","Reaches into this error indicating that a lock is poisoned, returning a\nmutable reference to the underlying guard to allow access regardless.",453,{"inputs":[{"name":"poisonerror"}],"output":{"name":"t"}}],[11,"from","","",426,{"inputs":[{"name":"trylockerror"},{"name":"poisonerror"}],"output":{"name":"trylockerror"}}],[11,"fmt","","",426,{"inputs":[{"name":"trylockerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",426,{"inputs":[{"name":"trylockerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",426,{"inputs":[{"name":"trylockerror"}],"output":{"name":"str"}}],[11,"cause","","",426,{"inputs":[{"name":"trylockerror"}],"output":{"name":"option"}}],[11,"as_raw_fd","std::fs","",352,{"inputs":[{"name":"file"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",352,{"inputs":[{"name":"file"},{"name":"rawfd"}],"output":{"name":"file"}}],[11,"as_raw_fd","std::net","",396,{"inputs":[{"name":"tcpstream"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",397,{"inputs":[{"name":"tcplistener"}],"output":{"name":"rawfd"}}],[11,"as_raw_fd","","",398,{"inputs":[{"name":"udpsocket"}],"output":{"name":"rawfd"}}],[11,"from_raw_fd","","",396,{"inputs":[{"name":"tcpstream"},{"name":"rawfd"}],"output":{"name":"tcpstream"}}],[11,"from_raw_fd","","",397,{"inputs":[{"name":"tcplistener"},{"name":"rawfd"}],"output":{"name":"tcplistener"}}],[11,"from_raw_fd","","",398,{"inputs":[{"name":"udpsocket"},{"name":"rawfd"}],"output":{"name":"udpsocket"}}],[11,"from_vec","std::ffi","",347,{"inputs":[{"name":"osstring"},{"name":"vec"}],"output":{"name":"osstring"}}],[11,"into_vec","","",347,{"inputs":[{"name":"osstring"}],"output":{"name":"vec"}}],[11,"from_bytes","","",348,null],[11,"as_bytes","","",348,null],[11,"mode","std::fs","",351,{"inputs":[{"name":"permissions"}],"output":{"name":"i32"}}],[11,"set_mode","","",351,{"inputs":[{"name":"permissions"},{"name":"i32"}],"output":null}],[11,"mode","","",350,{"inputs":[{"name":"openoptions"},{"name":"i32"}],"output":{"name":"openoptions"}}],[11,"uid","std::process","",423,{"inputs":[{"name":"command"},{"name":"uid_t"}],"output":{"name":"command"}}],[11,"gid","","",423,{"inputs":[{"name":"command"},{"name":"gid_t"}],"output":{"name":"command"}}],[11,"signal","","",425,{"inputs":[{"name":"exitstatus"}],"output":{"name":"option"}}],[0,"rt","std","Runtime services",null,null],[0,"heap","std::rt","",null,null],[5,"allocate","std::rt::heap","Return a pointer to `size` bytes of memory aligned to `align`.",null,null],[5,"reallocate","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"reallocate_inplace","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"deallocate","","Deallocates the memory referenced by `ptr`.",null,null],[5,"usable_size","","Returns the usable size of an allocation created with the specified the\n`size` and `align`.",null,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[5,"stats_print","","Prints implementation-defined allocator statistics.",null,null],[17,"EMPTY","","An arbitrary non-null address to represent zero-size allocations.",null,null],[5,"at_exit","std::rt","Enqueues a procedure to run when the main thread exits.",null,{"inputs":[{"name":"f"}],"output":{"name":"result"}}],[5,"cleanup","","One-time runtime cleanup.",null,{"inputs":[],"output":null}],[0,"backtrace","","Simple backtrace functionality (to print on panic)",null,null],[5,"write","std::rt::backtrace","",null,{"inputs":[{"name":"write"}],"output":{"name":"result"}}],[5,"log_enabled","","",null,{"inputs":[],"output":{"name":"bool"}}],[0,"util","std::rt","",null,null],[5,"running_on_valgrind","std::rt::util","Dynamically inquire about whether we're running under V.\nYou should usually not use this unless your test definitely\ncan't run correctly un-altered. Valgrind is there to help\nyou notice weirdness in normal, un-doctored code paths!",null,{"inputs":[],"output":{"name":"bool"}}],[5,"limit_thread_creation_due_to_osx_and_valgrind","","Valgrind has a fixed-sized array (size around 2000) of segment descriptors\nwired into it; this is a hard limit and requires rebuilding valgrind if you\nwant to go beyond it. Normally this is not a problem, but in some tests, we\nproduce a lot of threads casually.  Making lots of threads alone might not\nbe a problem _either_, except on OSX, the segments produced for new threads\n_take a while_ to get reclaimed by the OS. Combined with the fact that libuv\nschedulers fork off a separate thread for polling fsevents on OSX, we get a\nperfect storm of creating \"too many mappings\" for valgrind to handle when\nrunning certain stress tests in the runtime.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"min_stack","","",null,{"inputs":[],"output":{"name":"usize"}}],[5,"dumb_print","","",null,{"inputs":[{"name":"arguments"}],"output":null}],[5,"abort","","",null,{"inputs":[{"name":"arguments"}],"output":null}],[5,"report_overflow","","",null,{"inputs":[],"output":null}],[17,"ENFORCE_SANITY","","",null,null],[0,"unwind","std::rt","Implementation of Rust stack unwinding",null,null],[5,"try","std::rt::unwind","Invoke a closure, capturing the cause of panic if one occurs.",null,{"inputs":[{"name":"f"}],"output":{"name":"result"}}],[5,"panicking","","Determines whether the current thread is unwinding because of panic.",null,{"inputs":[],"output":{"name":"bool"}}],[5,"rust_begin_unwind","","Entry point of panic from the libcore crate.",null,{"inputs":[{"name":"arguments"},{"name":"str"},{"name":"u32"}],"output":null}],[5,"begin_unwind_fmt","","The entry point for unwinding with a formatted message.",null,null],[5,"begin_unwind","","This is the entry point of unwinding for panic!() and assert!().",null,null],[5,"register","","Register a callback to be invoked when a thread unwinds.",null,{"inputs":[{"name":"callback"}],"output":{"name":"bool"}}],[6,"Callback","","",null,null],[0,"args","std::rt","Global storage for command line arguments",null,null],[5,"init","std::rt::args","One-time global initialization.",null,null],[5,"cleanup","","One-time global cleanup.",null,{"inputs":[],"output":null}],[5,"take","","Take the global arguments from global storage.",null,{"inputs":[],"output":{"name":"option"}}],[5,"put","","Give the global arguments to global storage.",null,{"inputs":[{"name":"vec"}],"output":null}],[5,"clone","","Make a clone of the global arguments.",null,{"inputs":[],"output":{"name":"option"}}],[17,"DEFAULT_ERROR_CODE","std::rt","The default error code of the rust runtime if the main thread panics instead\nof exiting cleanly.",null,null],[11,"next_u64","std::rand","Return the next random u64.",454,{"inputs":[{"name":"rng"}],"output":{"name":"u64"}}],[11,"next_f32","","Return the next random f32 selected from the half-open\ninterval `[0, 1)`.",454,{"inputs":[{"name":"rng"}],"output":{"name":"f32"}}],[11,"next_f64","","Return the next random f64 selected from the half-open\ninterval `[0, 1)`.",454,{"inputs":[{"name":"rng"}],"output":{"name":"f64"}}],[11,"fill_bytes","","Fill `dest` with random data.",454,null],[11,"gen","","Return a random value of a `Rand` type.",454,{"inputs":[{"name":"rng"}],"output":{"name":"t"}}],[11,"gen_iter","","Return an iterator that will yield an infinite number of randomly\ngenerated items.",454,{"inputs":[{"name":"rng"}],"output":{"name":"generator"}}],[11,"gen_range","","Generate a random value in the range [`low`, `high`).",454,{"inputs":[{"name":"rng"},{"name":"t"},{"name":"t"}],"output":{"name":"t"}}],[11,"gen_weighted_bool","","Return a bool with a 1 in n chance of true",454,{"inputs":[{"name":"rng"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"gen_ascii_chars","","Return an iterator of random characters from the set A-Z,a-z,0-9.",454,{"inputs":[{"name":"rng"}],"output":{"name":"asciigenerator"}}],[11,"choose","","Return a random element from `values`.",454,null],[11,"shuffle","","Shuffle a mutable slice in place.",454,null],[11,"new_unseeded","rand","Creates a new XorShiftRng instance which is not seeded.",455,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"xorshiftrng"}}],[11,"new","rand::distributions::range","Create a new `Range` instance that samples uniformly from\n`[low, high)`. Panics if `low >= high`.",456,{"inputs":[{"name":"range"},{"name":"x"},{"name":"x"}],"output":{"name":"range"}}],[11,"sample","","",456,{"inputs":[{"name":"range"},{"name":"r"}],"output":{"name":"sup"}}],[11,"ind_sample","","",456,{"inputs":[{"name":"range"},{"name":"r"}],"output":{"name":"sup"}}],[11,"new","rand::distributions::gamma","Construct an object representing the `Gamma(shape, scale)`\ndistribution.",457,{"inputs":[{"name":"gamma"},{"name":"f64"},{"name":"f64"}],"output":{"name":"gamma"}}],[11,"sample","","",457,{"inputs":[{"name":"gamma"},{"name":"r"}],"output":{"name":"f64"}}],[11,"sample","","",458,{"inputs":[{"name":"gammasmallshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"sample","","",459,{"inputs":[{"name":"gammalargeshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",457,{"inputs":[{"name":"gamma"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",458,{"inputs":[{"name":"gammasmallshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",459,{"inputs":[{"name":"gammalargeshape"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new chi-squared distribution with degrees-of-freedom\n`k`. Panics if `k < 0`.",460,{"inputs":[{"name":"chisquared"},{"name":"f64"}],"output":{"name":"chisquared"}}],[11,"sample","","",460,{"inputs":[{"name":"chisquared"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",460,{"inputs":[{"name":"chisquared"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new `FisherF` distribution, with the given\nparameter. Panics if either `m` or `n` are not positive.",461,{"inputs":[{"name":"fisherf"},{"name":"f64"},{"name":"f64"}],"output":{"name":"fisherf"}}],[11,"sample","","",461,{"inputs":[{"name":"fisherf"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",461,{"inputs":[{"name":"fisherf"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","","Create a new Student t distribution with `n` degrees of\nfreedom. Panics if `n <= 0`.",462,{"inputs":[{"name":"studentt"},{"name":"f64"}],"output":{"name":"studentt"}}],[11,"sample","","",462,{"inputs":[{"name":"studentt"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",462,{"inputs":[{"name":"studentt"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","rand::distributions::normal","",463,{"inputs":[{"name":"standardnormal"}],"output":{"name":"standardnormal"}}],[11,"rand","","",463,{"inputs":[{"name":"standardnormal"},{"name":"r"}],"output":{"name":"standardnormal"}}],[11,"clone","","",464,{"inputs":[{"name":"normal"}],"output":{"name":"normal"}}],[11,"new","","Construct a new `Normal` distribution with the given mean and\nstandard deviation.",464,{"inputs":[{"name":"normal"},{"name":"f64"},{"name":"f64"}],"output":{"name":"normal"}}],[11,"sample","","",464,{"inputs":[{"name":"normal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",464,{"inputs":[{"name":"normal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","","",465,{"inputs":[{"name":"lognormal"}],"output":{"name":"lognormal"}}],[11,"new","","Construct a new `LogNormal` distribution with the given mean\nand standard deviation.",465,{"inputs":[{"name":"lognormal"},{"name":"f64"},{"name":"f64"}],"output":{"name":"lognormal"}}],[11,"sample","","",465,{"inputs":[{"name":"lognormal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",465,{"inputs":[{"name":"lognormal"},{"name":"r"}],"output":{"name":"f64"}}],[11,"clone","rand::distributions::exponential","",466,{"inputs":[{"name":"exp1"}],"output":{"name":"exp1"}}],[11,"rand","","",466,{"inputs":[{"name":"exp1"},{"name":"r"}],"output":{"name":"exp1"}}],[11,"clone","","",467,{"inputs":[{"name":"exp"}],"output":{"name":"exp"}}],[11,"new","","Construct a new `Exp` with the given shape parameter\n`lambda`. Panics if `lambda <= 0`.",467,{"inputs":[{"name":"exp"},{"name":"f64"}],"output":{"name":"exp"}}],[11,"sample","","",467,{"inputs":[{"name":"exp"},{"name":"r"}],"output":{"name":"f64"}}],[11,"ind_sample","","",467,{"inputs":[{"name":"exp"},{"name":"r"}],"output":{"name":"f64"}}],[11,"new","rand::distributions","",468,{"inputs":[{"name":"randsample"}],"output":{"name":"randsample"}}],[11,"sample","","",468,{"inputs":[{"name":"randsample"},{"name":"r"}],"output":{"name":"sup"}}],[11,"ind_sample","","",468,{"inputs":[{"name":"randsample"},{"name":"r"}],"output":{"name":"sup"}}],[11,"new","","Create a new `WeightedChoice`.",469,null],[11,"sample","","",469,{"inputs":[{"name":"weightedchoice"},{"name":"r"}],"output":{"name":"t"}}],[11,"ind_sample","","",469,{"inputs":[{"name":"weightedchoice"},{"name":"r"}],"output":{"name":"t"}}],[11,"new_unseeded","rand::isaac","Create an ISAAC random number generator using the default\nfixed seed.",470,{"inputs":[{"name":"isaacrng"}],"output":{"name":"isaacrng"}}],[11,"clone","","",470,{"inputs":[{"name":"isaacrng"}],"output":{"name":"isaacrng"}}],[11,"next_u32","","",470,{"inputs":[{"name":"isaacrng"}],"output":{"name":"u32"}}],[11,"reseed","","",470,null],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can\nbe any length, although the maximum number of elements used is\n256 and any more will be silently ignored. A generator\nconstructed with a given seed will generate the same sequence\nof values as all other generators constructed with that seed.",470,null],[11,"rand","","",470,{"inputs":[{"name":"isaacrng"},{"name":"r"}],"output":{"name":"isaacrng"}}],[11,"new_unseeded","","Create a 64-bit ISAAC random number generator using the\ndefault fixed seed.",471,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"isaac64rng"}}],[11,"clone","","",471,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"isaac64rng"}}],[11,"next_u32","","",471,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"u32"}}],[11,"next_u64","","",471,{"inputs":[{"name":"isaac64rng"}],"output":{"name":"u64"}}],[11,"reseed","","",471,null],[11,"from_seed","","Create an ISAAC random number generator with a seed. This can\nbe any length, although the maximum number of elements used is\n256 and any more will be silently ignored. A generator\nconstructed with a given seed will generate the same sequence\nof values as all other generators constructed with that seed.",471,null],[11,"rand","","",471,{"inputs":[{"name":"isaac64rng"},{"name":"r"}],"output":{"name":"isaac64rng"}}],[11,"clone","rand::chacha","",472,{"inputs":[{"name":"chacharng"}],"output":{"name":"chacharng"}}],[11,"new_unseeded","","Create an ChaCha random number generator using the default\nfixed key of 8 zero words.",472,{"inputs":[{"name":"chacharng"}],"output":{"name":"chacharng"}}],[11,"set_counter","","Sets the internal 128-bit ChaCha counter to\na user-provided value. This permits jumping\narbitrarily ahead (or backwards) in the pseudorandom stream.",472,null],[11,"next_u32","","",472,{"inputs":[{"name":"chacharng"}],"output":{"name":"u32"}}],[11,"reseed","","",472,null],[11,"from_seed","","Create a ChaCha generator from a seed,\nobtained from a variable-length u32 array.\nOnly up to 8 words are used; if less than 8\nwords are used, the remaining are set to zero.",472,null],[11,"rand","","",472,{"inputs":[{"name":"chacharng"},{"name":"r"}],"output":{"name":"chacharng"}}],[11,"new","rand::reseeding","Create a new `ReseedingRng` with the given parameters.",473,{"inputs":[{"name":"reseedingrng"},{"name":"r"},{"name":"usize"},{"name":"rsdr"}],"output":{"name":"reseedingrng"}}],[11,"reseed_if_necessary","","Reseed the internal RNG if the number of bytes that have been\ngenerated exceed the threshold.",473,null],[11,"next_u32","","",473,{"inputs":[{"name":"reseedingrng"}],"output":{"name":"u32"}}],[11,"next_u64","","",473,{"inputs":[{"name":"reseedingrng"}],"output":{"name":"u64"}}],[11,"fill_bytes","","",473,null],[11,"reseed","","",473,null],[11,"from_seed","","Create a new `ReseedingRng` from the given reseeder and\nseed. This uses a default value for `generation_threshold`.",473,null],[11,"clone","","",474,{"inputs":[{"name":"reseedwithdefault"}],"output":{"name":"reseedwithdefault"}}],[11,"reseed","","",474,null],[11,"default","","",474,{"inputs":[{"name":"reseedwithdefault"}],"output":{"name":"reseedwithdefault"}}],[11,"rand","rand","",475,{"inputs":[{"name":"open01"},{"name":"r"}],"output":{"name":"open01"}}],[11,"rand","","",476,{"inputs":[{"name":"closed01"},{"name":"r"}],"output":{"name":"closed01"}}],[11,"rand","","",475,{"inputs":[{"name":"open01"},{"name":"r"}],"output":{"name":"open01"}}],[11,"rand","","",476,{"inputs":[{"name":"closed01"},{"name":"r"}],"output":{"name":"closed01"}}],[11,"rand","std::option","",58,{"inputs":[{"name":"option"},{"name":"r"}],"output":{"name":"option"}}],[11,"next","rand","",477,{"inputs":[{"name":"generator"}],"output":{"name":"option"}}],[11,"next","","",478,{"inputs":[{"name":"asciigenerator"}],"output":{"name":"option"}}],[11,"clone","","",455,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"xorshiftrng"}}],[11,"next_u32","","",455,{"inputs":[{"name":"xorshiftrng"}],"output":{"name":"u32"}}],[11,"reseed","","Reseed an XorShiftRng. This will panic if `seed` is entirely 0.",455,null],[11,"from_seed","","Create a new XorShiftRng. This will panic if `seed` is entirely 0.",455,null],[11,"rand","","",455,{"inputs":[{"name":"xorshiftrng"},{"name":"r"}],"output":{"name":"xorshiftrng"}}],[14,"assert!","std","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"assert_eq!","","Asserts that two expressions are equal to each other.",null,null],[14,"debug_assert!","","Ensure that a boolean expression is `true` at runtime.",null,null],[14,"debug_assert_eq!","","Asserts that two expressions are equal to each other, testing equality in\nboth directions.",null,null],[14,"write!","","Use the `format!` syntax to write data into a buffer of type `&mut Writer`.\nSee `std::fmt` for more information.",null,null],[14,"writeln!","","Equivalent to the `write!` macro, except that a newline is appended after\nthe message is written.",null,null],[14,"unreachable!","","A utility macro for indicating unreachable code.",null,null],[14,"unimplemented!","","A standardised placeholder for marking unfinished code. It panics with the\nmessage `\"not yet implemented\"` when executed.",null,null],[14,"vec!","","Creates a `Vec` containing the arguments.",null,null],[14,"format!","","Use the syntax described in `std::fmt` to create a value of type `String`.\nSee `std::fmt` for more information.",null,null],[14,"panic!","","The entry point for panic of Rust threads.",null,null],[14,"print!","","Macro for printing to the standard output.",null,null],[14,"println!","","Macro for printing to the standard output.",null,null],[14,"try!","","Helper macro for unwrapping `Result` values while returning early with an\nerror if the value of the expression is `Err`.",null,null],[14,"select!","","A macro to select an event from a number of receivers.",null,null],[14,"format_args!","","The core macro for formatted string creation & output.",null,null],[14,"env!","","Inspect an environment variable at compile time.",null,null],[14,"option_env!","","Optionally inspect an environment variable at compile time.",null,null],[14,"concat_idents!","","Concatenate identifiers into one identifier.",null,null],[14,"concat!","","Concatenates literals into a static string slice.",null,null],[14,"line!","","A macro which expands to the line number on which it was invoked.",null,null],[14,"column!","","A macro which expands to the column number on which it was invoked.",null,null],[14,"file!","","A macro which expands to the file name from which it was invoked.",null,null],[14,"stringify!","","A macro which stringifies its argument.",null,null],[14,"include_str!","","Includes a utf8-encoded file as a string.",null,null],[14,"include_bytes!","","Includes a file as a byte slice.",null,null],[14,"module_path!","","Expands to a string that represents the current module path.",null,null],[14,"cfg!","","Boolean evaluation of configuration flags.",null,null],[14,"include!","","Parse the current given file as an expression.",null,null],[14,"thread_local!","","Declare a new thread local storage key of type `std::thread::LocalKey`.",null,null],[14,"scoped_thread_local!","","Declare a new scoped thread local storage key.",null,null],[15,"pointer","","Operations on unsafe pointers, `*const T`, and `*mut T`.",null,null],[15,"slice","","Utilities for slice manipulation",null,null],[15,"str","","Unicode string manipulation (the `str` type).",null,null],[15,"char","","Character manipulation (`char` type, Unicode Scalar Value)",null,null],[15,"isize","","Operations and constants for pointer-sized signed integers (`isize` type)",null,null],[15,"i8","","Operations and constants for signed 8-bits integers (`i8` type)",null,null],[15,"i16","","Operations and constants for signed 16-bits integers (`i16` type)",null,null],[15,"i32","","Operations and constants for signed 32-bits integers (`i32` type)",null,null],[15,"i64","","Operations and constants for signed 64-bits integers (`i64` type)",null,null],[15,"usize","","Operations and constants for pointer-sized unsigned integers (`usize` type)",null,null],[15,"u8","","Operations and constants for unsigned 8-bits integers (`u8` type)",null,null],[15,"u16","","Operations and constants for unsigned 16-bits integers (`u16` type)",null,null],[15,"u32","","Operations and constants for unsigned 32-bits integers (`u32` type)",null,null],[15,"u64","","Operations and constants for unsigned 64-bits integer (`u64` type)",null,null],[15,"f32","","Operations and constants for 32-bits floats (`f32` type)",null,null],[15,"f64","","Operations and constants for 64-bits floats (`f64` type)",null,null],[15,"array","","The fixed-size array type (`[T; n]`).",null,null],[15,"bool","","The boolean type",null,null],[15,"tuple","","Operations on tuples",null,null],[11,"overflowing_add","","",479,null],[11,"overflowing_sub","","",479,null],[11,"overflowing_mul","","",479,null],[11,"overflowing_div","","",479,null],[11,"overflowing_rem","","",479,null],[11,"overflowing_shl","","",479,null],[11,"overflowing_shr","","",479,null],[11,"overflowing_add","","",480,null],[11,"overflowing_sub","","",480,null],[11,"overflowing_mul","","",480,null],[11,"overflowing_div","","",480,null],[11,"overflowing_rem","","",480,null],[11,"overflowing_shl","","",480,null],[11,"overflowing_shr","","",480,null],[11,"overflowing_add","","",481,null],[11,"overflowing_sub","","",481,null],[11,"overflowing_mul","","",481,null],[11,"overflowing_div","","",481,null],[11,"overflowing_rem","","",481,null],[11,"overflowing_shl","","",481,null],[11,"overflowing_shr","","",481,null],[11,"overflowing_add","","",482,null],[11,"overflowing_sub","","",482,null],[11,"overflowing_mul","","",482,null],[11,"overflowing_div","","",482,null],[11,"overflowing_rem","","",482,null],[11,"overflowing_shl","","",482,null],[11,"overflowing_shr","","",482,null],[11,"overflowing_add","","",483,null],[11,"overflowing_sub","","",483,null],[11,"overflowing_mul","","",483,null],[11,"overflowing_div","","",483,null],[11,"overflowing_rem","","",483,null],[11,"overflowing_shl","","",483,null],[11,"overflowing_shr","","",483,null],[11,"overflowing_add","","",484,null],[11,"overflowing_sub","","",484,null],[11,"overflowing_mul","","",484,null],[11,"overflowing_div","","",484,null],[11,"overflowing_rem","","",484,null],[11,"overflowing_shl","","",484,null],[11,"overflowing_shr","","",484,null],[11,"overflowing_add","","",485,null],[11,"overflowing_sub","","",485,null],[11,"overflowing_mul","","",485,null],[11,"overflowing_div","","",485,null],[11,"overflowing_rem","","",485,null],[11,"overflowing_shl","","",485,null],[11,"overflowing_shr","","",485,null],[11,"overflowing_add","","",486,null],[11,"overflowing_sub","","",486,null],[11,"overflowing_mul","","",486,null],[11,"overflowing_div","","",486,null],[11,"overflowing_rem","","",486,null],[11,"overflowing_shl","","",486,null],[11,"overflowing_shr","","",486,null],[11,"overflowing_add","","",487,null],[11,"overflowing_sub","","",487,null],[11,"overflowing_mul","","",487,null],[11,"overflowing_div","","",487,null],[11,"overflowing_rem","","",487,null],[11,"overflowing_shl","","",487,null],[11,"overflowing_shr","","",487,null],[11,"overflowing_add","","",488,null],[11,"overflowing_sub","","",488,null],[11,"overflowing_mul","","",488,null],[11,"overflowing_div","","",488,null],[11,"overflowing_rem","","",488,null],[11,"overflowing_shl","","",488,null],[11,"overflowing_shr","","",488,null],[11,"zero","","",483,null],[11,"one","","",483,null],[11,"zero","","",484,null],[11,"one","","",484,null],[11,"zero","","",485,null],[11,"one","","",485,null],[11,"zero","","",486,null],[11,"one","","",486,null],[11,"zero","","",487,null],[11,"one","","",487,null],[11,"zero","","",479,null],[11,"one","","",479,null],[11,"zero","","",480,null],[11,"one","","",480,null],[11,"zero","","",481,null],[11,"one","","",481,null],[11,"zero","","",482,null],[11,"one","","",482,null],[11,"zero","","",488,null],[11,"one","","",488,null],[11,"zero","","",489,null],[11,"one","","",489,null],[11,"zero","","",490,null],[11,"one","","",490,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",479,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",479,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",479,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",479,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",479,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",479,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",479,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",479,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",479,null],[11,"swap_bytes","","Reverses the byte order of the integer.",479,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",479,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",479,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",479,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",479,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",479,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",479,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",479,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",479,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",479,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",479,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",479,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",479,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",479,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",479,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",479,null],[11,"signum","","Returns a number representing sign of `self`.",479,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",479,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",479,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",480,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",480,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",480,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",480,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",480,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",480,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",480,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",480,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",480,null],[11,"swap_bytes","","Reverses the byte order of the integer.",480,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",480,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",480,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",480,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",480,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",480,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",480,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",480,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",480,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",480,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",480,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",480,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",480,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",480,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",480,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",480,null],[11,"signum","","Returns a number representing sign of `self`.",480,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",480,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",480,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",481,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",481,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",481,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",481,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",481,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",481,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",481,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",481,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",481,null],[11,"swap_bytes","","Reverses the byte order of the integer.",481,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",481,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",481,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",481,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",481,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",481,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",481,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",481,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",481,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",481,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",481,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",481,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",481,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",481,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",481,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",481,null],[11,"signum","","Returns a number representing sign of `self`.",481,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",481,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",481,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",482,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",482,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",482,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",482,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",482,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",482,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",482,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",482,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",482,null],[11,"swap_bytes","","Reverses the byte order of the integer.",482,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",482,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",482,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",482,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",482,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",482,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",482,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",482,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",482,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",482,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",482,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",482,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",482,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",482,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",482,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",482,null],[11,"signum","","Returns a number representing sign of `self`.",482,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",482,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",482,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",488,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",488,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",488,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",488,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",488,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",488,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",488,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",488,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",488,null],[11,"swap_bytes","","Reverses the byte order of the integer.",488,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",488,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",488,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",488,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",488,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",488,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",488,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",488,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",488,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",488,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",488,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",488,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",488,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",488,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",488,null],[11,"abs","","Computes the absolute value of `self`. `Int::min_value()` will be\nreturned if the number is `Int::min_value()`.",488,null],[11,"signum","","Returns a number representing sign of `self`.",488,null],[11,"is_positive","","Returns `true` if `self` is positive and `false` if the number\nis zero or negative.",488,null],[11,"is_negative","","Returns `true` if `self` is negative and `false` if the number\nis zero or positive.",488,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",483,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",483,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",483,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",483,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",483,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",483,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",483,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",483,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",483,null],[11,"swap_bytes","","Reverses the byte order of the integer.",483,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",483,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",483,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",483,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",483,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",483,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",483,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",483,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",483,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",483,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",483,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",483,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",483,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",483,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",483,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",483,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",483,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",483,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",484,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",484,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",484,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",484,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",484,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",484,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",484,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",484,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",484,null],[11,"swap_bytes","","Reverses the byte order of the integer.",484,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",484,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",484,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",484,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",484,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",484,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",484,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",484,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",484,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",484,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",484,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",484,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",484,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",484,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",484,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",484,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",484,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",484,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",485,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",485,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",485,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",485,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",485,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",485,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",485,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",485,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",485,null],[11,"swap_bytes","","Reverses the byte order of the integer.",485,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",485,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",485,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",485,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",485,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",485,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",485,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",485,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",485,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",485,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",485,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",485,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",485,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",485,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",485,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",485,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",485,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",485,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",486,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",486,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",486,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",486,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",486,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",486,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",486,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",486,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",486,null],[11,"swap_bytes","","Reverses the byte order of the integer.",486,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",486,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",486,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",486,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",486,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",486,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",486,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",486,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",486,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",486,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",486,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",486,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",486,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",486,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",486,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",486,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",486,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",486,null],[11,"min_value","","Returns the smallest value that can be represented by this integer type.",487,null],[11,"max_value","","Returns the largest value that can be represented by this integer type.",487,null],[11,"from_str_radix","","Converts a string slice in a given base to an integer.",487,null],[11,"count_ones","","Returns the number of ones in the binary representation of `self`.",487,null],[11,"count_zeros","","Returns the number of zeros in the binary representation of `self`.",487,null],[11,"leading_zeros","","Returns the number of leading zeros in the binary representation\nof `self`.",487,null],[11,"trailing_zeros","","Returns the number of trailing zeros in the binary representation\nof `self`.",487,null],[11,"rotate_left","","Shifts the bits to the left by a specified amount, `n`,\nwrapping the truncated bits to the end of the resulting integer.",487,null],[11,"rotate_right","","Shifts the bits to the right by a specified amount, `n`,\nwrapping the truncated bits to the beginning of the resulting\ninteger.",487,null],[11,"swap_bytes","","Reverses the byte order of the integer.",487,null],[11,"from_be","","Converts an integer from big endian to the target's endianness.",487,null],[11,"from_le","","Converts an integer from little endian to the target's endianness.",487,null],[11,"to_be","","Converts `self` to big endian from the target's endianness.",487,null],[11,"to_le","","Converts `self` to little endian from the target's endianness.",487,null],[11,"checked_add","","Checked integer addition. Computes `self + other`, returning `None`\nif overflow occurred.",487,null],[11,"checked_sub","","Checked integer subtraction. Computes `self - other`, returning\n`None` if underflow occurred.",487,null],[11,"checked_mul","","Checked integer multiplication. Computes `self * other`, returning\n`None` if underflow or overflow occurred.",487,null],[11,"checked_div","","Checked integer division. Computes `self / other`, returning `None`\nif `other == 0` or the operation results in underflow or overflow.",487,null],[11,"saturating_add","","Saturating integer addition. Computes `self + other`, saturating at\nthe numeric bounds instead of overflowing.",487,null],[11,"saturating_sub","","Saturating integer subtraction. Computes `self - other`, saturating\nat the numeric bounds instead of overflowing.",487,null],[11,"wrapping_add","","Wrapping (modular) addition. Computes `self + other`,\nwrapping around at the boundary of the type.",487,null],[11,"wrapping_sub","","Wrapping (modular) subtraction. Computes `self - other`,\nwrapping around at the boundary of the type.",487,null],[11,"wrapping_mul","","Wrapping (modular) multiplication. Computes `self *\nother`, wrapping around at the boundary of the type.",487,null],[11,"pow","","Raises self to the power of `exp`, using exponentiation by squaring.",487,null],[11,"is_power_of_two","","Returns `true` iff `self == 2^k` for some `k`.",487,null],[11,"next_power_of_two","","Returns the smallest power of two greater than or equal to `self`.\nUnspecified behavior on overflow.",487,null],[11,"checked_next_power_of_two","","Returns the smallest power of two greater than or equal to `n`. If\nthe next power of two is greater than the type's maximum value,\n`None` is returned, otherwise the power of two is wrapped in `Some`.",487,null],[11,"from_str","","Converts a string in base 10 to a float.\nAccepts an optional decimal exponent.",489,null],[11,"from_str","","Converts a string in base 10 to a float.\nAccepts an optional decimal exponent.",490,null],[11,"from_str","","",488,null],[11,"from_str","","",479,null],[11,"from_str","","",480,null],[11,"from_str","","",481,null],[11,"from_str","","",482,null],[11,"from_str","","",487,null],[11,"from_str","","",483,null],[11,"from_str","","",484,null],[11,"from_str","","",485,null],[11,"from_str","","",486,null],[11,"is_null","","Returns true if the pointer is null.",491,null],[11,"as_ref","","Returns `None` if the pointer is null, or else returns a reference to\nthe value wrapped in `Some`.",491,null],[11,"offset","","Calculates the offset from a pointer. `count` is in units of T; e.g. a\n`count` of 3 represents a pointer offset of `3 * sizeof::<T>()` bytes.",491,null],[11,"is_null","","Returns true if the pointer is null.",491,null],[11,"as_ref","","Returns `None` if the pointer is null, or else returns a reference to\nthe value wrapped in `Some`.",491,null],[11,"offset","","Calculates the offset from a pointer. `count` is in units of T; e.g. a\n`count` of 3 represents a pointer offset of `3 * sizeof::<T>()` bytes.",491,null],[11,"as_mut","","Returns `None` if the pointer is null, or else returns a mutable\nreference to the value wrapped in `Some`.",491,null],[11,"eq","","",491,null],[11,"eq","","",491,null],[11,"clone","","",491,null],[11,"clone","","",491,null],[11,"cmp","","",491,null],[11,"partial_cmp","","",491,null],[11,"lt","","",491,null],[11,"le","","",491,null],[11,"gt","","",491,null],[11,"ge","","",491,null],[11,"cmp","","",491,null],[11,"partial_cmp","","",491,null],[11,"lt","","",491,null],[11,"le","","",491,null],[11,"gt","","",491,null],[11,"ge","","",491,null],[11,"add","","",487,null],[11,"add","","",487,null],[11,"add","","",487,null],[11,"add","","",487,null],[11,"add","","",483,null],[11,"add","","",483,null],[11,"add","","",483,null],[11,"add","","",483,null],[11,"add","","",484,null],[11,"add","","",484,null],[11,"add","","",484,null],[11,"add","","",484,null],[11,"add","","",485,null],[11,"add","","",485,null],[11,"add","","",485,null],[11,"add","","",485,null],[11,"add","","",486,null],[11,"add","","",486,null],[11,"add","","",486,null],[11,"add","","",486,null],[11,"add","","",488,null],[11,"add","","",488,null],[11,"add","","",488,null],[11,"add","","",488,null],[11,"add","","",479,null],[11,"add","","",479,null],[11,"add","","",479,null],[11,"add","","",479,null],[11,"add","","",480,null],[11,"add","","",480,null],[11,"add","","",480,null],[11,"add","","",480,null],[11,"add","","",481,null],[11,"add","","",481,null],[11,"add","","",481,null],[11,"add","","",481,null],[11,"add","","",482,null],[11,"add","","",482,null],[11,"add","","",482,null],[11,"add","","",482,null],[11,"add","","",489,null],[11,"add","","",489,null],[11,"add","","",489,null],[11,"add","","",489,null],[11,"add","","",490,null],[11,"add","","",490,null],[11,"add","","",490,null],[11,"add","","",490,null],[11,"sub","","",487,null],[11,"sub","","",487,null],[11,"sub","","",487,null],[11,"sub","","",487,null],[11,"sub","","",483,null],[11,"sub","","",483,null],[11,"sub","","",483,null],[11,"sub","","",483,null],[11,"sub","","",484,null],[11,"sub","","",484,null],[11,"sub","","",484,null],[11,"sub","","",484,null],[11,"sub","","",485,null],[11,"sub","","",485,null],[11,"sub","","",485,null],[11,"sub","","",485,null],[11,"sub","","",486,null],[11,"sub","","",486,null],[11,"sub","","",486,null],[11,"sub","","",486,null],[11,"sub","","",488,null],[11,"sub","","",488,null],[11,"sub","","",488,null],[11,"sub","","",488,null],[11,"sub","","",479,null],[11,"sub","","",479,null],[11,"sub","","",479,null],[11,"sub","","",479,null],[11,"sub","","",480,null],[11,"sub","","",480,null],[11,"sub","","",480,null],[11,"sub","","",480,null],[11,"sub","","",481,null],[11,"sub","","",481,null],[11,"sub","","",481,null],[11,"sub","","",481,null],[11,"sub","","",482,null],[11,"sub","","",482,null],[11,"sub","","",482,null],[11,"sub","","",482,null],[11,"sub","","",489,null],[11,"sub","","",489,null],[11,"sub","","",489,null],[11,"sub","","",489,null],[11,"sub","","",490,null],[11,"sub","","",490,null],[11,"sub","","",490,null],[11,"sub","","",490,null],[11,"mul","","",487,null],[11,"mul","","",487,null],[11,"mul","","",487,null],[11,"mul","","",487,null],[11,"mul","","",483,null],[11,"mul","","",483,null],[11,"mul","","",483,null],[11,"mul","","",483,null],[11,"mul","","",484,null],[11,"mul","","",484,null],[11,"mul","","",484,null],[11,"mul","","",484,null],[11,"mul","","",485,null],[11,"mul","","",485,null],[11,"mul","","",485,null],[11,"mul","","",485,null],[11,"mul","","",486,null],[11,"mul","","",486,null],[11,"mul","","",486,null],[11,"mul","","",486,null],[11,"mul","","",488,null],[11,"mul","","",488,null],[11,"mul","","",488,null],[11,"mul","","",488,null],[11,"mul","","",479,null],[11,"mul","","",479,null],[11,"mul","","",479,null],[11,"mul","","",479,null],[11,"mul","","",480,null],[11,"mul","","",480,null],[11,"mul","","",480,null],[11,"mul","","",480,null],[11,"mul","","",481,null],[11,"mul","","",481,null],[11,"mul","","",481,null],[11,"mul","","",481,null],[11,"mul","","",482,null],[11,"mul","","",482,null],[11,"mul","","",482,null],[11,"mul","","",482,null],[11,"mul","","",489,null],[11,"mul","","",489,null],[11,"mul","","",489,null],[11,"mul","","",489,null],[11,"mul","","",490,null],[11,"mul","","",490,null],[11,"mul","","",490,null],[11,"mul","","",490,null],[11,"div","","",487,null],[11,"div","","",487,null],[11,"div","","",487,null],[11,"div","","",487,null],[11,"div","","",483,null],[11,"div","","",483,null],[11,"div","","",483,null],[11,"div","","",483,null],[11,"div","","",484,null],[11,"div","","",484,null],[11,"div","","",484,null],[11,"div","","",484,null],[11,"div","","",485,null],[11,"div","","",485,null],[11,"div","","",485,null],[11,"div","","",485,null],[11,"div","","",486,null],[11,"div","","",486,null],[11,"div","","",486,null],[11,"div","","",486,null],[11,"div","","",488,null],[11,"div","","",488,null],[11,"div","","",488,null],[11,"div","","",488,null],[11,"div","","",479,null],[11,"div","","",479,null],[11,"div","","",479,null],[11,"div","","",479,null],[11,"div","","",480,null],[11,"div","","",480,null],[11,"div","","",480,null],[11,"div","","",480,null],[11,"div","","",481,null],[11,"div","","",481,null],[11,"div","","",481,null],[11,"div","","",481,null],[11,"div","","",482,null],[11,"div","","",482,null],[11,"div","","",482,null],[11,"div","","",482,null],[11,"div","","",489,null],[11,"div","","",489,null],[11,"div","","",489,null],[11,"div","","",489,null],[11,"div","","",490,null],[11,"div","","",490,null],[11,"div","","",490,null],[11,"div","","",490,null],[11,"rem","","",487,null],[11,"rem","","",487,null],[11,"rem","","",487,null],[11,"rem","","",487,null],[11,"rem","","",483,null],[11,"rem","","",483,null],[11,"rem","","",483,null],[11,"rem","","",483,null],[11,"rem","","",484,null],[11,"rem","","",484,null],[11,"rem","","",484,null],[11,"rem","","",484,null],[11,"rem","","",485,null],[11,"rem","","",485,null],[11,"rem","","",485,null],[11,"rem","","",485,null],[11,"rem","","",486,null],[11,"rem","","",486,null],[11,"rem","","",486,null],[11,"rem","","",486,null],[11,"rem","","",488,null],[11,"rem","","",488,null],[11,"rem","","",488,null],[11,"rem","","",488,null],[11,"rem","","",479,null],[11,"rem","","",479,null],[11,"rem","","",479,null],[11,"rem","","",479,null],[11,"rem","","",480,null],[11,"rem","","",480,null],[11,"rem","","",480,null],[11,"rem","","",480,null],[11,"rem","","",481,null],[11,"rem","","",481,null],[11,"rem","","",481,null],[11,"rem","","",481,null],[11,"rem","","",482,null],[11,"rem","","",482,null],[11,"rem","","",482,null],[11,"rem","","",482,null],[11,"rem","","",489,null],[11,"rem","","",489,null],[11,"rem","","",489,null],[11,"rem","","",489,null],[11,"rem","","",490,null],[11,"rem","","",490,null],[11,"rem","","",490,null],[11,"rem","","",490,null],[11,"neg","","",488,null],[11,"neg","","",488,null],[11,"neg","","",479,null],[11,"neg","","",479,null],[11,"neg","","",480,null],[11,"neg","","",480,null],[11,"neg","","",481,null],[11,"neg","","",481,null],[11,"neg","","",482,null],[11,"neg","","",482,null],[11,"neg","","",489,null],[11,"neg","","",489,null],[11,"neg","","",490,null],[11,"neg","","",490,null],[11,"not","","",492,null],[11,"not","","",492,null],[11,"not","","",487,null],[11,"not","","",487,null],[11,"not","","",483,null],[11,"not","","",483,null],[11,"not","","",484,null],[11,"not","","",484,null],[11,"not","","",485,null],[11,"not","","",485,null],[11,"not","","",486,null],[11,"not","","",486,null],[11,"not","","",488,null],[11,"not","","",488,null],[11,"not","","",479,null],[11,"not","","",479,null],[11,"not","","",480,null],[11,"not","","",480,null],[11,"not","","",481,null],[11,"not","","",481,null],[11,"not","","",482,null],[11,"not","","",482,null],[11,"bitand","","",492,null],[11,"bitand","","",492,null],[11,"bitand","","",492,null],[11,"bitand","","",492,null],[11,"bitand","","",487,null],[11,"bitand","","",487,null],[11,"bitand","","",487,null],[11,"bitand","","",487,null],[11,"bitand","","",483,null],[11,"bitand","","",483,null],[11,"bitand","","",483,null],[11,"bitand","","",483,null],[11,"bitand","","",484,null],[11,"bitand","","",484,null],[11,"bitand","","",484,null],[11,"bitand","","",484,null],[11,"bitand","","",485,null],[11,"bitand","","",485,null],[11,"bitand","","",485,null],[11,"bitand","","",485,null],[11,"bitand","","",486,null],[11,"bitand","","",486,null],[11,"bitand","","",486,null],[11,"bitand","","",486,null],[11,"bitand","","",488,null],[11,"bitand","","",488,null],[11,"bitand","","",488,null],[11,"bitand","","",488,null],[11,"bitand","","",479,null],[11,"bitand","","",479,null],[11,"bitand","","",479,null],[11,"bitand","","",479,null],[11,"bitand","","",480,null],[11,"bitand","","",480,null],[11,"bitand","","",480,null],[11,"bitand","","",480,null],[11,"bitand","","",481,null],[11,"bitand","","",481,null],[11,"bitand","","",481,null],[11,"bitand","","",481,null],[11,"bitand","","",482,null],[11,"bitand","","",482,null],[11,"bitand","","",482,null],[11,"bitand","","",482,null],[11,"bitor","","",492,null],[11,"bitor","","",492,null],[11,"bitor","","",492,null],[11,"bitor","","",492,null],[11,"bitor","","",487,null],[11,"bitor","","",487,null],[11,"bitor","","",487,null],[11,"bitor","","",487,null],[11,"bitor","","",483,null],[11,"bitor","","",483,null],[11,"bitor","","",483,null],[11,"bitor","","",483,null],[11,"bitor","","",484,null],[11,"bitor","","",484,null],[11,"bitor","","",484,null],[11,"bitor","","",484,null],[11,"bitor","","",485,null],[11,"bitor","","",485,null],[11,"bitor","","",485,null],[11,"bitor","","",485,null],[11,"bitor","","",486,null],[11,"bitor","","",486,null],[11,"bitor","","",486,null],[11,"bitor","","",486,null],[11,"bitor","","",488,null],[11,"bitor","","",488,null],[11,"bitor","","",488,null],[11,"bitor","","",488,null],[11,"bitor","","",479,null],[11,"bitor","","",479,null],[11,"bitor","","",479,null],[11,"bitor","","",479,null],[11,"bitor","","",480,null],[11,"bitor","","",480,null],[11,"bitor","","",480,null],[11,"bitor","","",480,null],[11,"bitor","","",481,null],[11,"bitor","","",481,null],[11,"bitor","","",481,null],[11,"bitor","","",481,null],[11,"bitor","","",482,null],[11,"bitor","","",482,null],[11,"bitor","","",482,null],[11,"bitor","","",482,null],[11,"bitxor","","",492,null],[11,"bitxor","","",492,null],[11,"bitxor","","",492,null],[11,"bitxor","","",492,null],[11,"bitxor","","",487,null],[11,"bitxor","","",487,null],[11,"bitxor","","",487,null],[11,"bitxor","","",487,null],[11,"bitxor","","",483,null],[11,"bitxor","","",483,null],[11,"bitxor","","",483,null],[11,"bitxor","","",483,null],[11,"bitxor","","",484,null],[11,"bitxor","","",484,null],[11,"bitxor","","",484,null],[11,"bitxor","","",484,null],[11,"bitxor","","",485,null],[11,"bitxor","","",485,null],[11,"bitxor","","",485,null],[11,"bitxor","","",485,null],[11,"bitxor","","",486,null],[11,"bitxor","","",486,null],[11,"bitxor","","",486,null],[11,"bitxor","","",486,null],[11,"bitxor","","",488,null],[11,"bitxor","","",488,null],[11,"bitxor","","",488,null],[11,"bitxor","","",488,null],[11,"bitxor","","",479,null],[11,"bitxor","","",479,null],[11,"bitxor","","",479,null],[11,"bitxor","","",479,null],[11,"bitxor","","",480,null],[11,"bitxor","","",480,null],[11,"bitxor","","",480,null],[11,"bitxor","","",480,null],[11,"bitxor","","",481,null],[11,"bitxor","","",481,null],[11,"bitxor","","",481,null],[11,"bitxor","","",481,null],[11,"bitxor","","",482,null],[11,"bitxor","","",482,null],[11,"bitxor","","",482,null],[11,"bitxor","","",482,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",483,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",484,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",485,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",486,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",487,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",479,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",480,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",481,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",482,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shl","","",488,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",483,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",484,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",485,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",486,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",487,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",479,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",480,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",481,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",482,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"shr","","",488,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"eq","","",492,null],[11,"ne","","",492,null],[11,"eq","","",494,null],[11,"ne","","",494,null],[11,"eq","","",487,null],[11,"ne","","",487,null],[11,"eq","","",483,null],[11,"ne","","",483,null],[11,"eq","","",484,null],[11,"ne","","",484,null],[11,"eq","","",485,null],[11,"ne","","",485,null],[11,"eq","","",486,null],[11,"ne","","",486,null],[11,"eq","","",488,null],[11,"ne","","",488,null],[11,"eq","","",479,null],[11,"ne","","",479,null],[11,"eq","","",480,null],[11,"ne","","",480,null],[11,"eq","","",481,null],[11,"ne","","",481,null],[11,"eq","","",482,null],[11,"ne","","",482,null],[11,"eq","","",489,null],[11,"ne","","",489,null],[11,"eq","","",490,null],[11,"ne","","",490,null],[11,"partial_cmp","","",493,null],[11,"partial_cmp","","",492,null],[11,"partial_cmp","","",494,null],[11,"lt","","",494,null],[11,"le","","",494,null],[11,"ge","","",494,null],[11,"gt","","",494,null],[11,"partial_cmp","","",487,null],[11,"lt","","",487,null],[11,"le","","",487,null],[11,"ge","","",487,null],[11,"gt","","",487,null],[11,"partial_cmp","","",483,null],[11,"lt","","",483,null],[11,"le","","",483,null],[11,"ge","","",483,null],[11,"gt","","",483,null],[11,"partial_cmp","","",484,null],[11,"lt","","",484,null],[11,"le","","",484,null],[11,"ge","","",484,null],[11,"gt","","",484,null],[11,"partial_cmp","","",485,null],[11,"lt","","",485,null],[11,"le","","",485,null],[11,"ge","","",485,null],[11,"gt","","",485,null],[11,"partial_cmp","","",486,null],[11,"lt","","",486,null],[11,"le","","",486,null],[11,"ge","","",486,null],[11,"gt","","",486,null],[11,"partial_cmp","","",488,null],[11,"lt","","",488,null],[11,"le","","",488,null],[11,"ge","","",488,null],[11,"gt","","",488,null],[11,"partial_cmp","","",479,null],[11,"lt","","",479,null],[11,"le","","",479,null],[11,"ge","","",479,null],[11,"gt","","",479,null],[11,"partial_cmp","","",480,null],[11,"lt","","",480,null],[11,"le","","",480,null],[11,"ge","","",480,null],[11,"gt","","",480,null],[11,"partial_cmp","","",481,null],[11,"lt","","",481,null],[11,"le","","",481,null],[11,"ge","","",481,null],[11,"gt","","",481,null],[11,"partial_cmp","","",482,null],[11,"lt","","",482,null],[11,"le","","",482,null],[11,"ge","","",482,null],[11,"gt","","",482,null],[11,"partial_cmp","","",489,null],[11,"lt","","",489,null],[11,"le","","",489,null],[11,"ge","","",489,null],[11,"gt","","",489,null],[11,"partial_cmp","","",490,null],[11,"lt","","",490,null],[11,"le","","",490,null],[11,"ge","","",490,null],[11,"gt","","",490,null],[11,"cmp","","",493,null],[11,"cmp","","",492,null],[11,"cmp","","",494,null],[11,"cmp","","",487,null],[11,"cmp","","",483,null],[11,"cmp","","",484,null],[11,"cmp","","",485,null],[11,"cmp","","",486,null],[11,"cmp","","",488,null],[11,"cmp","","",479,null],[11,"cmp","","",480,null],[11,"cmp","","",481,null],[11,"cmp","","",482,null],[11,"clone","","Returns a deep copy of the value.",488,null],[11,"clone","","Returns a deep copy of the value.",479,null],[11,"clone","","Returns a deep copy of the value.",480,null],[11,"clone","","Returns a deep copy of the value.",481,null],[11,"clone","","Returns a deep copy of the value.",482,null],[11,"clone","","Returns a deep copy of the value.",487,null],[11,"clone","","Returns a deep copy of the value.",483,null],[11,"clone","","Returns a deep copy of the value.",484,null],[11,"clone","","Returns a deep copy of the value.",485,null],[11,"clone","","Returns a deep copy of the value.",486,null],[11,"clone","","Returns a deep copy of the value.",489,null],[11,"clone","","Returns a deep copy of the value.",490,null],[11,"clone","","Returns a deep copy of the value.",493,null],[11,"clone","","Returns a deep copy of the value.",492,null],[11,"clone","","Returns a deep copy of the value.",494,null],[11,"default","","",493,null],[11,"default","","",492,null],[11,"default","","",494,null],[11,"default","","",487,null],[11,"default","","",483,null],[11,"default","","",484,null],[11,"default","","",485,null],[11,"default","","",486,null],[11,"default","","",488,null],[11,"default","","",479,null],[11,"default","","",480,null],[11,"default","","",481,null],[11,"default","","",482,null],[11,"default","","",489,null],[11,"default","","",490,null],[11,"as_ref","","",495,null],[11,"as_mut","","",495,null],[11,"as_ref","","",496,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"as_slice","","",497,null],[11,"as_mut_slice","","",497,null],[11,"as_ref","","",497,null],[11,"as_mut","","",497,null],[11,"clone","","",497,null],[11,"hash","","",497,null],[11,"fmt","","",497,null],[11,"into_iter","","",497,null],[11,"into_iter","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"eq","","",497,null],[11,"ne","","",497,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"partial_cmp","","",497,null],[11,"lt","","",497,null],[11,"le","","",497,null],[11,"ge","","",497,null],[11,"gt","","",497,null],[11,"cmp","","",497,null],[11,"step","","",487,null],[11,"steps_between","","",487,null],[11,"step","","",483,null],[11,"steps_between","","",483,null],[11,"step","","",484,null],[11,"steps_between","","",484,null],[11,"step","","",485,null],[11,"steps_between","","",485,null],[11,"step","","",488,null],[11,"steps_between","","",488,null],[11,"step","","",479,null],[11,"steps_between","","",479,null],[11,"step","","",480,null],[11,"steps_between","","",480,null],[11,"step","","",481,null],[11,"steps_between","","",481,null],[11,"step","","",486,null],[11,"steps_between","","",486,null],[11,"step","","",482,null],[11,"steps_between","","",482,null],[11,"index","","",495,null],[11,"index_mut","","",495,null],[11,"index","","",495,null],[11,"index","","",495,null],[11,"index","","",495,null],[11,"index","","",495,null],[11,"index_mut","","",495,null],[11,"index_mut","","",495,null],[11,"index_mut","","",495,null],[11,"index_mut","","",495,null],[11,"default","","",495,null],[11,"into_iter","","",495,null],[11,"into_iter","","",495,null],[11,"set_memory","","",495,null],[11,"eq","","",495,null],[11,"ne","","",495,null],[11,"cmp","","",495,null],[11,"partial_cmp","","",495,null],[11,"lt","","",495,null],[11,"le","","",495,null],[11,"ge","","",495,null],[11,"gt","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"as_unsigned","","",495,null],[11,"as_signed","","",495,null],[11,"as_unsigned_mut","","",495,null],[11,"as_signed_mut","","",495,null],[11,"into_searcher","","",496,null],[11,"into_searcher","","",494,null],[11,"is_contained_in","","",494,null],[11,"is_prefix_of","","",494,null],[11,"is_suffix_of","","",494,null],[11,"into_searcher","","",495,null],[11,"is_contained_in","","",495,null],[11,"is_prefix_of","","",495,null],[11,"is_suffix_of","","",495,null],[11,"from_str","","Parse a `bool` from a string.",492,null],[11,"cmp","","",496,null],[11,"eq","","",496,null],[11,"ne","","",496,null],[11,"partial_cmp","","",496,null],[11,"index","","",496,null],[11,"index","","",496,null],[11,"index","","",496,null],[11,"index","","",496,null],[11,"as_ref","","",496,null],[11,"default","","",496,null],[11,"hash","","",483,null],[11,"hash_slice","","",483,null],[11,"hash","","",484,null],[11,"hash_slice","","",484,null],[11,"hash","","",485,null],[11,"hash_slice","","",485,null],[11,"hash","","",486,null],[11,"hash_slice","","",486,null],[11,"hash","","",487,null],[11,"hash_slice","","",487,null],[11,"hash","","",479,null],[11,"hash_slice","","",479,null],[11,"hash","","",480,null],[11,"hash_slice","","",480,null],[11,"hash","","",481,null],[11,"hash_slice","","",481,null],[11,"hash","","",482,null],[11,"hash_slice","","",482,null],[11,"hash","","",488,null],[11,"hash_slice","","",488,null],[11,"hash","","",492,null],[11,"hash","","",494,null],[11,"hash","","",496,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",493,null],[11,"hash","","",495,null],[11,"hash","","",491,null],[11,"hash","","",491,null],[11,"fmt","","",488,null],[11,"fmt","","",488,null],[11,"fmt","","",488,null],[11,"fmt","","",488,null],[11,"fmt","","",488,null],[11,"fmt","","",488,null],[11,"fmt","","",487,null],[11,"fmt","","",487,null],[11,"fmt","","",487,null],[11,"fmt","","",487,null],[11,"fmt","","",487,null],[11,"fmt","","",487,null],[11,"fmt","","",479,null],[11,"fmt","","",479,null],[11,"fmt","","",479,null],[11,"fmt","","",479,null],[11,"fmt","","",479,null],[11,"fmt","","",479,null],[11,"fmt","","",483,null],[11,"fmt","","",483,null],[11,"fmt","","",483,null],[11,"fmt","","",483,null],[11,"fmt","","",483,null],[11,"fmt","","",483,null],[11,"fmt","","",480,null],[11,"fmt","","",480,null],[11,"fmt","","",480,null],[11,"fmt","","",480,null],[11,"fmt","","",480,null],[11,"fmt","","",480,null],[11,"fmt","","",484,null],[11,"fmt","","",484,null],[11,"fmt","","",484,null],[11,"fmt","","",484,null],[11,"fmt","","",484,null],[11,"fmt","","",484,null],[11,"fmt","","",481,null],[11,"fmt","","",481,null],[11,"fmt","","",481,null],[11,"fmt","","",481,null],[11,"fmt","","",481,null],[11,"fmt","","",481,null],[11,"fmt","","",485,null],[11,"fmt","","",485,null],[11,"fmt","","",485,null],[11,"fmt","","",485,null],[11,"fmt","","",485,null],[11,"fmt","","",485,null],[11,"fmt","","",482,null],[11,"fmt","","",482,null],[11,"fmt","","",482,null],[11,"fmt","","",482,null],[11,"fmt","","",482,null],[11,"fmt","","",482,null],[11,"fmt","","",486,null],[11,"fmt","","",486,null],[11,"fmt","","",486,null],[11,"fmt","","",486,null],[11,"fmt","","",486,null],[11,"fmt","","",486,null],[11,"fmt","","",492,null],[11,"fmt","","",492,null],[11,"fmt","","",496,null],[11,"fmt","","",496,null],[11,"fmt","","",494,null],[11,"fmt","","",494,null],[11,"fmt","","",491,null],[11,"fmt","","",491,null],[11,"fmt","","",489,null],[11,"fmt","","",489,null],[11,"fmt","","",489,null],[11,"fmt","","",489,null],[11,"fmt","","",490,null],[11,"fmt","","",490,null],[11,"fmt","","",490,null],[11,"fmt","","",490,null],[11,"fmt","","",491,null],[11,"fmt","","",491,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",493,null],[11,"fmt","","",495,null],[11,"fmt","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"clone","","",493,null],[11,"eq","","",493,null],[11,"ne","","",493,null],[11,"partial_cmp","","",493,null],[11,"lt","","",493,null],[11,"le","","",493,null],[11,"ge","","",493,null],[11,"gt","","",493,null],[11,"cmp","","",493,null],[11,"default","","",493,null],[11,"sort_by","","Sorts the slice, in place, using `compare` to compare\nelements.",495,null],[11,"move_from","","Consumes `src` and moves as many elements as it can into `self`\nfrom the range [start,end).",495,null],[11,"split_at","","Divides one slice into two at an index.",495,null],[11,"iter","","Returns an iterator over the slice.",495,null],[11,"split","","Returns an iterator over subslices separated by elements that match\n`pred`.  The matched element is not contained in the subslices.",495,null],[11,"splitn","","Returns an iterator over subslices separated by elements that match\n`pred`, limited to returning at most `n` items.  The matched element is\nnot contained in the subslices.",495,null],[11,"rsplitn","","Returns an iterator over subslices separated by elements that match\n`pred` limited to returning at most `n` items. This starts at the end of\nthe slice and works backwards.  The matched element is not contained in\nthe subslices.",495,null],[11,"windows","","Returns an iterator over all contiguous windows of length\n`size`. The windows overlap. If the slice is shorter than\n`size`, the iterator returns no values.",495,null],[11,"chunks","","Returns an iterator over `size` elements of the slice at a\ntime. The chunks do not overlap. If `size` does not divide the\nlength of the slice, then the last chunk will not have length\n`size`.",495,null],[11,"get","","Returns the element of a slice at the given index, or `None` if the\nindex is out of bounds.",495,null],[11,"first","","Returns the first element of a slice, or `None` if it is empty.",495,null],[11,"tail","","Returns all but the first element of a slice.",495,null],[11,"init","","Returns all but the last element of a slice.",495,null],[11,"last","","Returns the last element of a slice, or `None` if it is empty.",495,null],[11,"get_unchecked","","Returns a pointer to the element at the given index, without doing\nbounds checking.",495,null],[11,"as_ptr","","Returns an unsafe pointer to the slice's buffer",495,null],[11,"binary_search_by","","Binary search a sorted slice with a comparator function.",495,null],[11,"len","","Returns the number of elements in the slice.",495,null],[11,"is_empty","","Returns true if the slice has a length of 0",495,null],[11,"get_mut","","Returns a mutable reference to the element at the given index,\nor `None` if the index is out of bounds",495,null],[11,"iter_mut","","Returns an iterator that allows modifying each value",495,null],[11,"first_mut","","Returns a mutable pointer to the first element of a slice, or `None` if it is empty",495,null],[11,"tail_mut","","Returns all but the first element of a mutable slice",495,null],[11,"init_mut","","Returns all but the last element of a mutable slice",495,null],[11,"last_mut","","Returns a mutable pointer to the last item in the slice.",495,null],[11,"split_mut","","Returns an iterator over mutable subslices separated by elements that\nmatch `pred`.  The matched element is not contained in the subslices.",495,null],[11,"splitn_mut","","Returns an iterator over subslices separated by elements that match\n`pred`, limited to returning at most `n` items.  The matched element is\nnot contained in the subslices.",495,null],[11,"rsplitn_mut","","Returns an iterator over subslices separated by elements that match\n`pred` limited to returning at most `n` items. This starts at the end of\nthe slice and works backwards.  The matched element is not contained in\nthe subslices.",495,null],[11,"chunks_mut","","Returns an iterator over `chunk_size` elements of the slice at a time.\nThe chunks are mutable and do not overlap. If `chunk_size` does\nnot divide the length of the slice, then the last chunk will not\nhave length `chunk_size`.",495,null],[11,"swap","","Swaps two elements in a slice.",495,null],[11,"split_at_mut","","Divides one `&mut` into two at an index.",495,null],[11,"reverse","","Reverse the order of elements in a slice, in place.",495,null],[11,"get_unchecked_mut","","Returns an unsafe mutable pointer to the element in index",495,null],[11,"as_mut_ptr","","Returns an unsafe mutable pointer to the slice's buffer.",495,null],[11,"to_vec","","Copies `self` into a new `Vec`.",495,null],[11,"permutations","","Creates an iterator that yields every possible permutation of the\nvector in succession.",495,null],[11,"clone_from_slice","","Copies as many elements from `src` as it can into `self` (the\nshorter of `self.len()` and `src.len()`). Returns the number\nof elements copied.",495,null],[11,"sort","","Sorts the slice, in place.",495,null],[11,"binary_search","","Binary search a sorted slice for a given element.",495,null],[11,"next_permutation","","Mutates the slice to the next lexicographic permutation.",495,null],[11,"prev_permutation","","Mutates the slice to the previous lexicographic permutation.",495,null],[11,"position_elem","","Find the first index containing a matching value.",495,null],[11,"rposition_elem","","Find the last index containing a matching value.",495,null],[11,"contains","","Returns true if the slice contains an element with the given value.",495,null],[11,"starts_with","","Returns true if `needle` is a prefix of the slice.",495,null],[11,"ends_with","","Returns true if `needle` is a suffix of the slice.",495,null],[11,"into_vec","","Converts `self` into a vector without clones or allocation.",495,null],[11,"concat","","",495,null],[11,"connect","","",495,null],[11,"to_owned","","",495,null],[11,"concat","","",495,null],[11,"connect","","",495,null],[11,"to_owned","","",496,null],[11,"escape_default","","Escapes each char in `s` with `char::escape_default`.",496,null],[11,"escape_unicode","","Escapes each char in `s` with `char::escape_unicode`.",496,null],[11,"replace","","Replaces all occurrences of one string with another.",496,null],[11,"nfd_chars","","Returns an iterator over the string in Unicode Normalization Form D\n(canonical decomposition).",496,null],[11,"nfkd_chars","","Returns an iterator over the string in Unicode Normalization Form KD\n(compatibility decomposition).",496,null],[11,"nfc_chars","","An Iterator over the string in Unicode Normalization Form C\n(canonical decomposition followed by canonical composition).",496,null],[11,"nfkc_chars","","An Iterator over the string in Unicode Normalization Form KC\n(compatibility decomposition followed by canonical composition).",496,null],[11,"contains","","Returns `true` if `self` contains another `&str`.",496,null],[11,"chars","","An iterator over the codepoints of `self`.",496,null],[11,"bytes","","An iterator over the bytes of `self`.",496,null],[11,"char_indices","","An iterator over the characters of `self` and their byte offsets.",496,null],[11,"split","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern.",496,null],[11,"rsplit","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern and yielded in reverse order.",496,null],[11,"split_terminator","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern.",496,null],[11,"rsplit_terminator","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern and yielded in reverse order.",496,null],[11,"splitn","","An iterator over substrings of `self`, separated by a pattern,\nrestricted to returning\nat most `count` items.",496,null],[11,"rsplitn","","An iterator over substrings of `self`, separated by a pattern,\nstarting from the end of the string, restricted to returning\nat most `count` items.",496,null],[11,"matches","","An iterator over the matches of a pattern within `self`.",496,null],[11,"rmatches","","An iterator over the matches of a pattern within `self`, yielded in\nreverse order.",496,null],[11,"match_indices","","An iterator over the start and end indices of the disjoint matches\nof a pattern within `self`.",496,null],[11,"rmatch_indices","","An iterator over the start and end indices of the disjoint matches of\na pattern within\n`self`, yielded in reverse order.",496,null],[11,"lines","","An iterator over the lines of a string, separated by `\\n`.",496,null],[11,"lines_any","","An iterator over the lines of a string, separated by either\n`\\n` or `\\r\\n`.",496,null],[11,"slice_chars","","Returns a slice of the string from the character range [`begin`..`end`).",496,null],[11,"slice_unchecked","","Takes a bytewise slice from a string.",496,null],[11,"starts_with","","Returns `true` if the given `&str` is a prefix of the string.",496,null],[11,"ends_with","","Returns true if the given `&str` is a suffix of the string.",496,null],[11,"trim_matches","","Returns a string with all pre- and suffixes that match a pattern\nrepeatedly removed.",496,null],[11,"trim_left_matches","","Returns a string with all prefixes that match a pattern\nrepeatedly removed.",496,null],[11,"trim_right_matches","","Returns a string with all suffixes that match a pattern\nrepeatedly removed.",496,null],[11,"is_char_boundary","","Checks that `index`-th byte lies at the start and/or end of a\nUTF-8 code point sequence.",496,null],[11,"char_range_at","","Given a byte position, return the next char and its index.",496,null],[11,"char_range_at_reverse","","Given a byte position, return the previous `char` and its position.",496,null],[11,"char_at","","Given a byte position, return the `char` at that position.",496,null],[11,"char_at_reverse","","Given a byte position, return the `char` at that position, counting\nfrom the end.",496,null],[11,"as_bytes","","Converts `self` to a byte slice.",496,null],[11,"find","","Returns the byte index of the first character of `self` that matches\nthe pattern, if it\nexists.",496,null],[11,"rfind","","Returns the byte index of the last character of `self` that\nmatches the pattern, if it\nexists.",496,null],[11,"slice_shift_char","","Retrieves the first character from a `&str` and returns it.",496,null],[11,"subslice_offset","","Returns the byte offset of an inner slice relative to an enclosing\nouter slice.",496,null],[11,"as_ptr","","Returns an unsafe pointer to the `&str`'s buffer.",496,null],[11,"utf16_units","","Returns an iterator of `u16` over the string encoded as UTF-16.",496,null],[11,"len","","Returns the length of `self` in bytes.",496,null],[11,"is_empty","","Returns true if this slice has a length of zero bytes.",496,null],[11,"parse","","Parses `self` into the specified type.",496,null],[11,"graphemes","","Returns an iterator over the [grapheme clusters][graphemes] of `self`.",496,null],[11,"grapheme_indices","","Returns an iterator over the grapheme clusters of `self` and their\nbyte offsets. See\n`graphemes()` for more information.",496,null],[11,"words","","An iterator over the non-empty words of `self`.",496,null],[11,"width","","Returns a string's displayed width in columns.",496,null],[11,"trim","","Returns a `&str` with leading and trailing whitespace removed.",496,null],[11,"trim_left","","Returns a `&str` with leading whitespace removed.",496,null],[11,"trim_right","","Returns a `&str` with trailing whitespace removed.",496,null],[11,"to_lowercase","","Returns the lowercase equivalent of this string.",496,null],[11,"to_uppercase","","Returns the uppercase equivalent of this string.",496,null],[11,"eq","","",496,null],[11,"ne","","",496,null],[11,"eq","","",496,null],[11,"ne","","",496,null],[11,"eq","","",496,null],[11,"ne","","",496,null],[11,"eq","","",496,null],[11,"ne","","",496,null],[11,"into_cow","","",496,null],[11,"into_cow","","",495,null],[11,"graphemes","","",496,null],[11,"grapheme_indices","","",496,null],[11,"words","","",496,null],[11,"is_whitespace","","",496,null],[11,"is_alphanumeric","","",496,null],[11,"width","","",496,null],[11,"trim","","",496,null],[11,"trim_left","","",496,null],[11,"trim_right","","",496,null],[11,"is_digit","","Checks if a `char` parses as a numeric digit in the given radix.",494,null],[11,"to_digit","","Converts a character to the corresponding digit.",494,null],[11,"escape_unicode","","Returns an iterator that yields the hexadecimal Unicode escape of a\ncharacter, as `char`s.",494,null],[11,"escape_default","","Returns an iterator that yields the 'default' ASCII and\nC++11-like literal escape of a character, as `char`s.",494,null],[11,"len_utf8","","Returns the number of bytes this character would need if encoded in\nUTF-8.",494,null],[11,"len_utf16","","Returns the number of 16-bit code units this character would need if\nencoded in UTF-16.",494,null],[11,"encode_utf8","","Encodes this character as UTF-8 into the provided byte buffer, and then\nreturns the number of bytes written.",494,null],[11,"encode_utf16","","Encodes this character as UTF-16 into the provided `u16` buffer, and\nthen returns the number of `u16`s written.",494,null],[11,"is_alphabetic","","Returns whether the specified character is considered a Unicode\nalphabetic code point.",494,null],[11,"is_xid_start","","Returns whether the specified character satisfies the 'XID_Start'\nUnicode property.",494,null],[11,"is_xid_continue","","Returns whether the specified `char` satisfies the 'XID_Continue'\nUnicode property.",494,null],[11,"is_lowercase","","Indicates whether a character is in lowercase.",494,null],[11,"is_uppercase","","Indicates whether a character is in uppercase.",494,null],[11,"is_whitespace","","Indicates whether a character is whitespace.",494,null],[11,"is_alphanumeric","","Indicates whether a character is alphanumeric.",494,null],[11,"is_control","","Indicates whether a character is a control code point.",494,null],[11,"is_numeric","","Indicates whether the character is numeric (Nd, Nl, or No).",494,null],[11,"to_lowercase","","Converts a character to its lowercase equivalent.",494,null],[11,"to_uppercase","","Converts a character to its uppercase equivalent.",494,null],[11,"width","","Returns this character's displayed width in columns, or `None` if it is a\ncontrol character other than `'\\x00'`.",494,null],[11,"description","std::num","",324,null],[11,"from_str_radix","std","Parses a float as with a given radix",489,null],[11,"is_nan","","Returns `true` if this value is `NaN` and false otherwise.",489,null],[11,"is_infinite","","Returns `true` if this value is positive infinity or negative infinity and\nfalse otherwise.",489,null],[11,"is_finite","","Returns `true` if this number is neither infinite nor `NaN`.",489,null],[11,"is_normal","","Returns `true` if the number is neither zero, infinite,\n[subnormal][subnormal], or `NaN`.",489,null],[11,"classify","","Returns the floating point category of the number. If only one property\nis going to be tested, it is generally faster to use the specific\npredicate instead.",489,null],[11,"integer_decode","","Returns the mantissa, base 2 exponent, and sign as integers, respectively.\nThe original number can be recovered by `sign * mantissa * 2 ^ exponent`.\nThe floating point encoding is documented in the [Reference][floating-point].",489,null],[11,"floor","","Returns the largest integer less than or equal to a number.",489,null],[11,"ceil","","Returns the smallest integer greater than or equal to a number.",489,null],[11,"round","","Returns the nearest integer to a number. Round half-way cases away from\n`0.0`.",489,null],[11,"trunc","","Returns the integer part of a number.",489,null],[11,"fract","","Returns the fractional part of a number.",489,null],[11,"abs","","Computes the absolute value of `self`. Returns `NAN` if the\nnumber is `NAN`.",489,null],[11,"signum","","Returns a number that represents the sign of `self`.",489,null],[11,"is_sign_positive","","Returns `true` if `self`'s sign bit is positive, including\n`+0.0` and `INFINITY`.",489,null],[11,"is_sign_negative","","Returns `true` if `self`'s sign is negative, including `-0.0`\nand `NEG_INFINITY`.",489,null],[11,"mul_add","","Fused multiply-add. Computes `(self * a) + b` with only one rounding\nerror. This produces a more accurate result with better performance than\na separate multiplication operation followed by an add.",489,null],[11,"recip","","Takes the reciprocal (inverse) of a number, `1/x`.",489,null],[11,"powi","","Raises a number to an integer power.",489,null],[11,"powf","","Raises a number to a floating point power.",489,null],[11,"sqrt","","Takes the square root of a number.",489,null],[11,"exp","","Returns `e^(self)`, (the exponential function).",489,null],[11,"exp2","","Returns `2^(self)`.",489,null],[11,"ln","","Returns the natural logarithm of the number.",489,null],[11,"log","","Returns the logarithm of the number with respect to an arbitrary base.",489,null],[11,"log2","","Returns the base 2 logarithm of the number.",489,null],[11,"log10","","Returns the base 10 logarithm of the number.",489,null],[11,"to_degrees","","Converts radians to degrees.",489,null],[11,"to_radians","","Converts degrees to radians.",489,null],[11,"ldexp","","Constructs a floating point number of `x*2^exp`.",489,null],[11,"frexp","","Breaks the number into a normalized fraction and a base-2 exponent,\nsatisfying:",489,null],[11,"next_after","","Returns the next representable floating-point value in the direction of\n`other`.",489,null],[11,"max","","Returns the maximum of the two numbers.",489,null],[11,"min","","Returns the minimum of the two numbers.",489,null],[11,"abs_sub","","The positive difference of two numbers.",489,null],[11,"cbrt","","Takes the cubic root of a number.",489,null],[11,"hypot","","Calculates the length of the hypotenuse of a right-angle triangle given\nlegs of length `x` and `y`.",489,null],[11,"sin","","Computes the sine of a number (in radians).",489,null],[11,"cos","","Computes the cosine of a number (in radians).",489,null],[11,"tan","","Computes the tangent of a number (in radians).",489,null],[11,"asin","","Computes the arcsine of a number. Return value is in radians in\nthe range [-pi/2, pi/2] or NaN if the number is outside the range\n[-1, 1].",489,null],[11,"acos","","Computes the arccosine of a number. Return value is in radians in\nthe range [0, pi] or NaN if the number is outside the range\n[-1, 1].",489,null],[11,"atan","","Computes the arctangent of a number. Return value is in radians in the\nrange [-pi/2, pi/2];",489,null],[11,"atan2","","Computes the four quadrant arctangent of `self` (`y`) and `other` (`x`).",489,null],[11,"sin_cos","","Simultaneously computes the sine and cosine of the number, `x`. Returns\n`(sin(x), cos(x))`.",489,null],[11,"exp_m1","","Returns `e^(self) - 1` in a way that is accurate even if the\nnumber is close to zero.",489,null],[11,"ln_1p","","Returns `ln(1+n)` (natural logarithm) more accurately than if\nthe operations were performed separately.",489,null],[11,"sinh","","Hyperbolic sine function.",489,null],[11,"cosh","","Hyperbolic cosine function.",489,null],[11,"tanh","","Hyperbolic tangent function.",489,null],[11,"asinh","","Inverse hyperbolic sine function.",489,null],[11,"acosh","","Inverse hyperbolic cosine function.",489,null],[11,"atanh","","Inverse hyperbolic tangent function.",489,null],[11,"from_str_radix","","Parses a float as with a given radix",490,null],[11,"is_nan","","Returns `true` if this value is `NaN` and false otherwise.",490,null],[11,"is_infinite","","Returns `true` if this value is positive infinity or negative infinity and\nfalse otherwise.",490,null],[11,"is_finite","","Returns `true` if this number is neither infinite nor `NaN`.",490,null],[11,"is_normal","","Returns `true` if the number is neither zero, infinite,\n[subnormal][subnormal], or `NaN`.",490,null],[11,"classify","","Returns the floating point category of the number. If only one property\nis going to be tested, it is generally faster to use the specific\npredicate instead.",490,null],[11,"integer_decode","","Returns the mantissa, base 2 exponent, and sign as integers, respectively.\nThe original number can be recovered by `sign * mantissa * 2 ^ exponent`.\nThe floating point encoding is documented in the [Reference][floating-point].",490,null],[11,"floor","","Returns the largest integer less than or equal to a number.",490,null],[11,"ceil","","Returns the smallest integer greater than or equal to a number.",490,null],[11,"round","","Returns the nearest integer to a number. Round half-way cases away from\n`0.0`.",490,null],[11,"trunc","","Returns the integer part of a number.",490,null],[11,"fract","","Returns the fractional part of a number.",490,null],[11,"abs","","Computes the absolute value of `self`. Returns `NAN` if the\nnumber is `NAN`.",490,null],[11,"signum","","Returns a number that represents the sign of `self`.",490,null],[11,"is_sign_positive","","Returns `true` if `self`'s sign bit is positive, including\n`+0.0` and `INFINITY`.",490,null],[11,"is_positive","","",490,null],[11,"is_sign_negative","","Returns `true` if `self`'s sign is negative, including `-0.0`\nand `NEG_INFINITY`.",490,null],[11,"is_negative","","",490,null],[11,"mul_add","","Fused multiply-add. Computes `(self * a) + b` with only one rounding\nerror. This produces a more accurate result with better performance than\na separate multiplication operation followed by an add.",490,null],[11,"recip","","Takes the reciprocal (inverse) of a number, `1/x`.",490,null],[11,"powi","","Raises a number to an integer power.",490,null],[11,"powf","","Raises a number to a floating point power.",490,null],[11,"sqrt","","Takes the square root of a number.",490,null],[11,"exp","","Returns `e^(self)`, (the exponential function).",490,null],[11,"exp2","","Returns `2^(self)`.",490,null],[11,"ln","","Returns the natural logarithm of the number.",490,null],[11,"log","","Returns the logarithm of the number with respect to an arbitrary base.",490,null],[11,"log2","","Returns the base 2 logarithm of the number.",490,null],[11,"log10","","Returns the base 10 logarithm of the number.",490,null],[11,"to_degrees","","Converts radians to degrees.",490,null],[11,"to_radians","","Converts degrees to radians.",490,null],[11,"ldexp","","Constructs a floating point number of `x*2^exp`.",490,null],[11,"frexp","","Breaks the number into a normalized fraction and a base-2 exponent,\nsatisfying:",490,null],[11,"next_after","","Returns the next representable floating-point value in the direction of\n`other`.",490,null],[11,"max","","Returns the maximum of the two numbers.",490,null],[11,"min","","Returns the minimum of the two numbers.",490,null],[11,"abs_sub","","The positive difference of two numbers.",490,null],[11,"cbrt","","Takes the cubic root of a number.",490,null],[11,"hypot","","Calculates the length of the hypotenuse of a right-angle triangle given\nlegs of length `x` and `y`.",490,null],[11,"sin","","Computes the sine of a number (in radians).",490,null],[11,"cos","","Computes the cosine of a number (in radians).",490,null],[11,"tan","","Computes the tangent of a number (in radians).",490,null],[11,"asin","","Computes the arcsine of a number. Return value is in radians in\nthe range [-pi/2, pi/2] or NaN if the number is outside the range\n[-1, 1].",490,null],[11,"acos","","Computes the arccosine of a number. Return value is in radians in\nthe range [0, pi] or NaN if the number is outside the range\n[-1, 1].",490,null],[11,"atan","","Computes the arctangent of a number. Return value is in radians in the\nrange [-pi/2, pi/2];",490,null],[11,"atan2","","Computes the four quadrant arctangent of `self` (`y`) and `other` (`x`).",490,null],[11,"sin_cos","","Simultaneously computes the sine and cosine of the number, `x`. Returns\n`(sin(x), cos(x))`.",490,null],[11,"exp_m1","","Returns `e^(self) - 1` in a way that is accurate even if the\nnumber is close to zero.",490,null],[11,"ln_1p","","Returns `ln(1+n)` (natural logarithm) more accurately than if\nthe operations were performed separately.",490,null],[11,"sinh","","Hyperbolic sine function.",490,null],[11,"cosh","","Hyperbolic cosine function.",490,null],[11,"tanh","","Hyperbolic tangent function.",490,null],[11,"asinh","","Inverse hyperbolic sine function.",490,null],[11,"acosh","","Inverse hyperbolic cosine function.",490,null],[11,"atanh","","Inverse hyperbolic tangent function.",490,null],[11,"is_ascii","","",496,null],[11,"to_ascii_uppercase","","",496,null],[11,"to_ascii_lowercase","","",496,null],[11,"eq_ignore_ascii_case","","",496,null],[11,"make_ascii_uppercase","","",496,null],[11,"make_ascii_lowercase","","",496,null],[11,"is_ascii","","",495,null],[11,"to_ascii_uppercase","","",495,null],[11,"to_ascii_lowercase","","",495,null],[11,"eq_ignore_ascii_case","","",495,null],[11,"make_ascii_uppercase","","",495,null],[11,"make_ascii_lowercase","","",495,null],[11,"is_ascii","","",483,null],[11,"to_ascii_uppercase","","",483,null],[11,"to_ascii_lowercase","","",483,null],[11,"eq_ignore_ascii_case","","",483,null],[11,"make_ascii_uppercase","","",483,null],[11,"make_ascii_lowercase","","",483,null],[11,"is_ascii","","",494,null],[11,"to_ascii_uppercase","","",494,null],[11,"to_ascii_lowercase","","",494,null],[11,"eq_ignore_ascii_case","","",494,null],[11,"make_ascii_uppercase","","",494,null],[11,"make_ascii_lowercase","","",494,null],[11,"clone","std::collections::hash_map","",498,null],[11,"clone","","",499,null],[11,"clone","","",500,null],[11,"next","","",498,null],[11,"size_hint","","",498,null],[11,"len","","",498,null],[11,"next","","",501,null],[11,"size_hint","","",501,null],[11,"len","","",501,null],[11,"next","","",502,null],[11,"size_hint","","",502,null],[11,"len","","",502,null],[11,"next","","",499,null],[11,"size_hint","","",499,null],[11,"len","","",499,null],[11,"next","","",500,null],[11,"size_hint","","",500,null],[11,"len","","",500,null],[11,"next","","",503,null],[11,"size_hint","","",503,null],[11,"len","","",503,null],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",334,null],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",334,null],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",334,null],[11,"get","","Gets a reference to the value in the entry.",504,null],[11,"get_mut","","Gets a mutable reference to the value in the entry.",504,null],[11,"into_mut","","Converts the OccupiedEntry into a mutable reference to the value in the entry\nwith a lifetime bound to the map itself",504,null],[11,"insert","","Sets the value of the entry, and returns the entry's old value",504,null],[11,"remove","","Takes the value out of the entry, and returns it",504,null],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it",505,null],[11,"clone","","",506,null],[11,"new","","Constructs a new `RandomState` that is initialized with random keys.",506,null],[11,"hasher","","",506,null],[11,"default","","",506,null],[11,"clone","std::collections::hash_set","",507,null],[11,"next","","",507,null],[11,"size_hint","","",507,null],[11,"len","","",507,null],[11,"next","","",508,null],[11,"size_hint","","",508,null],[11,"len","","",508,null],[11,"next","","",509,null],[11,"size_hint","","",509,null],[11,"len","","",509,null],[11,"clone","","",510,null],[11,"next","","",510,null],[11,"size_hint","","",510,null],[11,"clone","","",511,null],[11,"next","","",511,null],[11,"size_hint","","",511,null],[11,"clone","","",512,null],[11,"next","","",512,null],[11,"size_hint","","",512,null],[11,"clone","","",513,null],[11,"next","","",513,null],[11,"size_hint","","",513,null],[11,"hasher","std::collections::hash_state","",514,null],[11,"clone","","",514,null],[11,"default","","",514,null],[11,"from","std::io","",363,null],[11,"eq","std","",496,null],[11,"eq","","",496,null],[11,"as_ref","","",496,null],[11,"metadata","std::path","",416,null],[11,"exists","","",416,null],[11,"is_file","","",416,null],[11,"is_dir","","",416,null],[11,"read","std","",495,null],[11,"fill_buf","","",495,null],[11,"consume","","",495,null],[11,"write","","",495,null],[11,"write_all","","",495,null],[11,"flush","","",495,null],[11,"to_socket_addrs","","",493,null],[11,"to_socket_addrs","","",493,null],[11,"to_socket_addrs","","",493,null],[11,"to_socket_addrs","","",493,null],[11,"to_socket_addrs","","",496,null],[11,"uid","std::process","",423,null],[11,"gid","","",423,null],[11,"signal","","",425,null],[11,"as_ref","std","",496,null],[11,"construct_range","","",479,null],[11,"sample_range","","",479,null],[11,"construct_range","","",480,null],[11,"sample_range","","",480,null],[11,"construct_range","","",481,null],[11,"sample_range","","",481,null],[11,"construct_range","","",482,null],[11,"sample_range","","",482,null],[11,"construct_range","","",488,null],[11,"sample_range","","",488,null],[11,"construct_range","","",483,null],[11,"sample_range","","",483,null],[11,"construct_range","","",484,null],[11,"sample_range","","",484,null],[11,"construct_range","","",485,null],[11,"sample_range","","",485,null],[11,"construct_range","","",486,null],[11,"sample_range","","",486,null],[11,"construct_range","","",487,null],[11,"sample_range","","",487,null],[11,"construct_range","","",489,null],[11,"sample_range","","",489,null],[11,"construct_range","","",490,null],[11,"sample_range","","",490,null],[11,"rand","","",488,null],[11,"rand","","",479,null],[11,"rand","","",480,null],[11,"rand","","",481,null],[11,"rand","","",482,null],[11,"rand","","",487,null],[11,"rand","","",483,null],[11,"rand","","",484,null],[11,"rand","","",485,null],[11,"rand","","",486,null],[11,"rand","","Generate a floating point number in the half-open\ninterval `[0,1)`.",490,null],[11,"rand","","Generate a floating point number in the half-open\ninterval `[0,1)`.",489,null],[11,"rand","","",494,null],[11,"rand","","",492,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null],[11,"rand","","",493,null]],"paths":[[8,"Any"],[3,"TypeId"],[3,"Wrapping"],[4,"FpCategory"],[3,"ParseIntError"],[4,"IntErrorKind"],[3,"ParseFloatError"],[4,"FloatErrorKind"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"Managed"],[3,"PhantomData"],[3,"RangeFull"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[4,"Ordering"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[4,"Ordering"],[3,"AtomicPtr"],[3,"Cell"],[4,"BorrowState"],[3,"RefCell"],[3,"BorrowRef"],[3,"Ref"],[3,"BorrowRefMut"],[3,"RefMut"],[3,"UnsafeCell"],[3,"EscapeUnicode"],[4,"EscapeUnicodeState"],[3,"EscapeDefault"],[4,"EscapeDefaultState"],[3,"Rev"],[4,"MinMaxResult"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"Scan"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"Unfold"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[4,"Option"],[3,"Item"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"GenericSplitN"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[4,"SearchStep"],[3,"CharEqSearcher"],[3,"CharEqPattern"],[3,"StrSearcher"],[4,"State"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"BytesDeref"],[3,"SplitInternal"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitNInternal"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndicesInternal"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"MatchesInternal"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"LinesAnyMap"],[3,"TwoWaySearcher"],[4,"OldSearcher"],[3,"OldMatchIndices"],[3,"CharRange"],[3,"SipHasher"],[3,"Binary"],[3,"Octal"],[3,"Decimal"],[3,"LowerHex"],[3,"UpperHex"],[3,"Radix"],[3,"RadixFmt"],[3,"PadAdapter"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugInner"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[3,"Error"],[4,"FlagV1"],[3,"Arguments"],[3,"Formatter"],[8,"Clone"],[8,"PartialEq"],[8,"Ord"],[8,"PartialOrd"],[8,"AsRef"],[8,"AsMut"],[8,"Into"],[8,"From"],[8,"Default"],[8,"Hash"],[8,"Hasher"],[8,"Iterator"],[8,"FromIterator"],[8,"IntoIterator"],[8,"Extend"],[8,"DoubleEndedIterator"],[8,"RandomAccessIterator"],[8,"ExactSizeIterator"],[8,"Step"],[8,"Drop"],[8,"Add"],[8,"Sub"],[8,"Mul"],[8,"Div"],[8,"Rem"],[8,"Neg"],[8,"Not"],[8,"BitAnd"],[8,"BitOr"],[8,"BitXor"],[8,"Shl"],[8,"Shr"],[8,"Index"],[8,"IndexMut"],[8,"Deref"],[8,"DerefMut"],[8,"Fn"],[8,"FnMut"],[8,"FnOnce"],[8,"Repr"],[3,"Box"],[3,"Weak"],[3,"Arc"],[3,"Rc"],[3,"Weak"],[8,"FnBox"],[8,"Borrow"],[8,"BorrowMut"],[8,"ToOwned"],[4,"Cow"],[3,"BinaryHeap"],[3,"Iter"],[3,"IntoIter"],[3,"Drain"],[3,"BitVec"],[3,"Iter"],[3,"BitSet"],[3,"SetIter"],[3,"TwoBitPositions"],[3,"Union"],[3,"Intersection"],[3,"Difference"],[3,"SymmetricDifference"],[3,"RawItems"],[3,"Node"],[3,"Handle"],[3,"ElemsAndEdges"],[3,"MoveTraversalImpl"],[3,"AbsTraversal"],[3,"NodeSlice"],[3,"MutNodeSlice"],[3,"BTreeMap"],[3,"AbsIter"],[3,"IdRef"],[3,"PartialSearchStack"],[3,"Pusher"],[3,"SearchStack"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Keys"],[3,"Values"],[3,"Range"],[3,"RangeMut"],[4,"Entry"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"BTreeSet"],[3,"Iter"],[3,"IntoIter"],[3,"Range"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Intersection"],[3,"Union"],[3,"EnumSet"],[3,"Iter"],[3,"Iter"],[3,"IntoIter"],[3,"Rawlink"],[3,"LinkedList"],[3,"IterMut"],[3,"ElementSwaps"],[3,"Vec"],[4,"Direction"],[3,"SizeDirection"],[3,"Permutations"],[4,"DecompositionType"],[3,"Decompositions"],[4,"RecompositionState"],[3,"Recompositions"],[3,"Utf16Units"],[3,"String"],[3,"FromUtf8Error"],[3,"FromUtf16Error"],[3,"DerefString"],[3,"ParseError"],[3,"IntoIter"],[3,"Drain"],[3,"DerefVec"],[3,"PartialVecNonZeroSized"],[3,"PartialVecZeroSized"],[3,"VecDeque"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Drain"],[3,"VecMap"],[4,"Entry"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"Iter"],[3,"IterMut"],[3,"Keys"],[3,"Values"],[3,"Drain"],[3,"IntoIter"],[4,"Bound"],[8,"IntoCow"],[8,"Display"],[8,"LowerExp"],[8,"UpperHex"],[8,"Pointer"],[8,"Octal"],[8,"Debug"],[8,"UpperExp"],[8,"Write"],[8,"LowerHex"],[8,"Binary"],[8,"SliceConcatExt"],[8,"IntSliceExt"],[8,"MutableByteVector"],[4,"GraphemeCat"],[3,"GraphemeIndices"],[3,"Graphemes"],[4,"GraphemeState"],[3,"Utf16Items"],[4,"Utf16Item"],[3,"Utf16Encoder"],[3,"Words"],[3,"ToLowercase"],[3,"ToUppercase"],[8,"Pattern"],[8,"Searcher"],[8,"ReverseSearcher"],[8,"FromStr"],[8,"ToString"],[8,"Error"],[8,"OwnedAsciiExt"],[8,"AsciiExt"],[3,"EscapeDefault"],[8,"Zero"],[8,"One"],[8,"OverflowingOps"],[3,"ParseFloatError"],[4,"LocalKeyState"],[3,"LocalKey"],[3,"ScopedKey"],[3,"Builder"],[3,"Thread"],[3,"JoinHandle"],[3,"JoinGuard"],[3,"HashMap"],[3,"HashSet"],[4,"Entry"],[8,"HashState"],[3,"DynamicLibrary"],[4,"VarError"],[3,"Vars"],[3,"VarsOs"],[3,"SplitPaths"],[3,"JoinPathsError"],[3,"Args"],[3,"ArgsOs"],[3,"CString"],[3,"CStr"],[3,"NulError"],[3,"OsString"],[3,"OsStr"],[8,"PathExt"],[3,"OpenOptions"],[3,"Permissions"],[3,"File"],[3,"Metadata"],[3,"ReadDir"],[3,"DirEntry"],[3,"WalkDir"],[4,"ErrorKind"],[4,"SeekFrom"],[4,"CharsError"],[3,"BufReader"],[3,"IntoInnerError"],[3,"BufWriter"],[3,"Error"],[3,"LineWriter"],[3,"BufStream"],[3,"Cursor"],[3,"Empty"],[3,"Repeat"],[3,"Sink"],[3,"Stdin"],[3,"StdinLock"],[3,"Stdout"],[3,"StdoutLock"],[3,"Stderr"],[3,"StderrLock"],[8,"Read"],[8,"Write"],[8,"Seek"],[8,"BufRead"],[3,"Broadcast"],[3,"Chain"],[3,"Take"],[3,"Tee"],[3,"Bytes"],[3,"Chars"],[3,"Split"],[3,"Lines"],[4,"IpAddr"],[4,"Ipv6MulticastScope"],[4,"SocketAddr"],[4,"Shutdown"],[3,"Ipv4Addr"],[3,"Ipv6Addr"],[3,"SocketAddrV4"],[3,"SocketAddrV6"],[3,"TcpStream"],[3,"TcpListener"],[3,"UdpSocket"],[3,"AddrParseError"],[8,"ToSocketAddrs"],[3,"LookupHost"],[8,"AsRawFd"],[8,"FromRawFd"],[8,"OsStringExt"],[8,"OsStrExt"],[8,"PermissionsExt"],[8,"OpenOptionsExt"],[8,"CommandExt"],[8,"ExitStatusExt"],[4,"Prefix"],[4,"Component"],[3,"PrefixComponent"],[3,"Components"],[3,"Iter"],[3,"PathBuf"],[3,"Path"],[3,"Display"],[3,"Child"],[3,"Output"],[3,"ChildStdin"],[3,"ChildStdout"],[3,"ChildStderr"],[3,"Command"],[3,"Stdio"],[3,"ExitStatus"],[4,"TryLockError"],[4,"TryRecvError"],[4,"TrySendError"],[3,"Select"],[3,"Handle"],[3,"SendError"],[3,"RecvError"],[3,"Sender"],[3,"SyncSender"],[3,"Receiver"],[3,"Iter"],[3,"Barrier"],[3,"BarrierWaitResult"],[3,"Condvar"],[3,"StaticCondvar"],[3,"Future"],[3,"Mutex"],[3,"StaticMutex"],[3,"MutexGuard"],[3,"Once"],[3,"RwLock"],[3,"StaticRwLock"],[3,"RwLockReadGuard"],[3,"RwLockWriteGuard"],[3,"Semaphore"],[3,"SemaphoreGuard"],[3,"Duration"],[3,"PoisonError"],[8,"Rng"],[3,"XorShiftRng"],[3,"Range"],[3,"Gamma"],[3,"GammaSmallShape"],[3,"GammaLargeShape"],[3,"ChiSquared"],[3,"FisherF"],[3,"StudentT"],[3,"StandardNormal"],[3,"Normal"],[3,"LogNormal"],[3,"Exp1"],[3,"Exp"],[3,"RandSample"],[3,"WeightedChoice"],[3,"IsaacRng"],[3,"Isaac64Rng"],[3,"ChaChaRng"],[3,"ReseedingRng"],[3,"ReseedWithDefault"],[3,"Open01"],[3,"Closed01"],[3,"Generator"],[3,"AsciiGenerator"],[15,"i8"],[15,"i16"],[15,"i32"],[15,"i64"],[15,"u8"],[15,"u16"],[15,"u32"],[15,"u64"],[15,"usize"],[15,"isize"],[15,"f32"],[15,"f64"],[15,"pointer"],[15,"bool"],[15,"tuple"],[15,"char"],[15,"slice"],[15,"str"],[15,"array"],[3,"Iter"],[3,"Keys"],[3,"Values"],[3,"IterMut"],[3,"IntoIter"],[3,"Drain"],[3,"OccupiedEntry"],[3,"VacantEntry"],[3,"RandomState"],[3,"Iter"],[3,"IntoIter"],[3,"Drain"],[3,"Intersection"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Union"],[3,"DefaultState"]]};
searchIndex['collections'] = {"items":[[0,"","collections","Collection types.",null,null],[0,"boxed","","A pointer type for heap allocation.",null,null],[7,"HEAP","collections::boxed","A value that represents the heap. This is the default place that the `box`\nkeyword allocates into when no place is supplied.",null,null],[11,"new","alloc::boxed","Allocates memory on the heap and then moves `x` into it.",0,{"inputs":[{"name":"box"},{"name":"t"}],"output":{"name":"box"}}],[11,"from_raw","","Constructs a box from the raw pointer.",0,null],[11,"downcast","","Attempt to downcast the box to a concrete type.",0,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",0,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"default","","",0,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"default","","",0,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone","","Returns a new box with a `clone()` of this box's contents.",0,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone_from","","Copies `source`'s contents into `self` without creating a new allocation.",0,null],[11,"eq","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"option"}}],[11,"lt","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"le","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ge","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"gt","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"cmp","","",0,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"ordering"}}],[11,"hash","","",0,null],[11,"fmt","","",0,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",0,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","collections::boxed","",null,null],[11,"deref","alloc::boxed","",0,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"deref_mut","","",0,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[6,"Item","collections::boxed","",null,null],[11,"next","alloc::boxed","",0,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"size_hint","","",0,null],[11,"next_back","","",0,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[6,"Output","collections::boxed","",null,null],[6,"Output","","",null,null],[11,"call_once","alloc::boxed","",0,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[6,"Output","collections::boxed","",null,null],[11,"call_once","alloc::boxed","",0,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[11,"fmt","alloc::arc","",1,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Constructs a new `Arc<T>`.",2,{"inputs":[{"name":"arc"},{"name":"t"}],"output":{"name":"arc"}}],[11,"downgrade","","Downgrades the `Arc<T>` to a `Weak<T>` reference.",2,{"inputs":[{"name":"arc"}],"output":{"name":"weak"}}],[11,"clone","","Makes a clone of the `Arc<T>`.",2,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[6,"Target","collections::boxed","",null,null],[11,"deref","alloc::arc","",2,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"make_unique","","Make a mutable reference from the given `Arc<T>`.",2,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Arc<T>`.",2,null],[11,"upgrade","","Upgrades a weak reference to a strong reference.",1,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"clone","","Makes a clone of the `Weak<T>`.",1,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"drop","","Drops the `Weak<T>`.",1,null],[11,"eq","","Equality for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Arc<T>`s.",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"cmp","","",2,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"ordering"}}],[11,"fmt","","",2,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",2,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",2,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"hash","","",2,null],[11,"new","alloc::rc","Constructs a new `Rc<T>`.",3,{"inputs":[{"name":"rc"},{"name":"t"}],"output":{"name":"rc"}}],[11,"downgrade","","Downgrades the `Rc<T>` to a `Weak<T>` reference.",3,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"make_unique","","Make a mutable reference from the given `Rc<T>`.",3,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[6,"Target","collections::boxed","",null,null],[11,"deref","alloc::rc","",3,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Rc<T>`.",3,null],[11,"clone","","Makes a clone of the `Rc<T>`.",3,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",3,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"cmp","","Comparison for two `Rc<T>`s.",3,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"hash","","",3,null],[11,"fmt","","",3,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",4,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Weak<T>`.",4,null],[11,"clone","","Makes a clone of the `Weak<T>`.",4,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"fmt","","",4,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Box","collections::boxed","A pointer type for heap allocation.",null,null],[5,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",null,null],[8,"FnBox","","`FnBox` is a version of the `FnOnce` intended for use with boxed\nclosure objects. The idea is that where one would normally store a\n`Box<FnOnce()>` in a data structure, you should use\n`Box<FnBox()>`. The two traits behave essentially the same, except\nthat a `FnBox` closure can only be called if it is boxed. (Note\nthat `FnBox` may be deprecated in the future if `Box<FnOnce()>`\nclosures become directly usable.)",null,null],[16,"Output","collections::boxed::FnBox","",null,null],[10,"call_box","collections::boxed","",5,null],[3,"BitVec","collections","The bitvector type.",null,null],[3,"BitSet","","An implementation of a set using a bit vector as an underlying\nrepresentation for holding unsigned numerical elements.",null,null],[3,"BTreeMap","","A map based on a B-Tree.",null,null],[3,"BTreeSet","","A set based on a B-Tree.",null,null],[4,"Bound","","An endpoint of a range of keys.",null,null],[13,"Included","","An inclusive bound.",6,null],[13,"Excluded","","An exclusive bound.",6,null],[13,"Unbounded","","An infinite endpoint. Indicates that there is no bound in this direction.",6,null],[0,"binary_heap","","A priority queue implemented with a binary heap.",null,null],[3,"BinaryHeap","collections::binary_heap","A priority queue implemented with a binary heap.",null,null],[3,"Iter","","`BinaryHeap` iterator.",null,null],[3,"IntoIter","","An iterator that moves out of a `BinaryHeap`.",null,null],[3,"Drain","","An iterator that drains a `BinaryHeap`.",null,null],[11,"clone","","",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"default","","",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"new","","Creates an empty `BinaryHeap` as a max-heap.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"binaryheap"}}],[11,"with_capacity","","Creates an empty `BinaryHeap` with a specific capacity.\nThis preallocates enough memory for `capacity` elements,\nso that the `BinaryHeap` does not have to be reallocated\nuntil it contains at least that many values.",7,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":{"name":"binaryheap"}}],[11,"from_vec","","Creates a `BinaryHeap` from a vector. This is sometimes called\n`heapifying` the vector.",7,{"inputs":[{"name":"binaryheap"},{"name":"vec"}],"output":{"name":"binaryheap"}}],[11,"iter","","Returns an iterator visiting all values in the underlying vector, in\narbitrary order.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"iter"}}],[11,"peek","","Returns the greatest item in the binary heap, or `None` if it is empty.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"capacity","","Returns the number of elements the binary heap can hold without reallocating.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `BinaryHeap`. Does nothing if the capacity is already sufficient.",7,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":null}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the\n`BinaryHeap`. The collection may reserve more space to avoid frequent reallocations.",7,{"inputs":[{"name":"binaryheap"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Discards as much additional capacity as possible.",7,{"inputs":[{"name":"binaryheap"}],"output":null}],[11,"pop","","Removes the greatest item from the binary heap and returns it, or `None` if it\nis empty.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"option"}}],[11,"push","","Pushes an item onto the binary heap.",7,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":null}],[11,"push_pop","","Pushes an item onto the binary heap, then pops the greatest item off the queue in\nan optimized fashion.",7,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"t"}}],[11,"replace","","Pops the greatest item off the binary heap, then pushes an item onto the queue in\nan optimized fashion. The push is done regardless of whether the binary heap\nwas empty.",7,{"inputs":[{"name":"binaryheap"},{"name":"t"}],"output":{"name":"option"}}],[11,"into_vec","","Consumes the `BinaryHeap` and returns the underlying vector\nin arbitrary order.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"into_sorted_vec","","Consumes the `BinaryHeap` and returns a vector in sorted\n(ascending) order.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"vec"}}],[11,"len","","Returns the length of the binary heap.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"usize"}}],[11,"is_empty","","Checks if the binary heap is empty.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"bool"}}],[11,"drain","","Clears the binary heap, returning an iterator over the removed elements.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"drain"}}],[11,"clear","","Drops all items from the binary heap.",7,{"inputs":[{"name":"binaryheap"}],"output":null}],[11,"clone","","",8,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",8,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",8,null],[11,"next_back","","",8,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",9,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",9,null],[11,"next_back","","",9,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",10,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",10,null],[11,"next_back","","",10,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"from_iter","","",7,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":{"name":"binaryheap"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out of\nthe binary heap in arbitrary order. The binary heap cannot be used\nafter calling this.",7,{"inputs":[{"name":"binaryheap"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","","",7,{"inputs":[{"name":"binaryheap"},{"name":"i"}],"output":null}],[11,"index","collections","",11,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"new","","Creates an empty `BitVec`.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_elem","","Creates a `BitVec` that holds `nbits` elements, setting each element\nto `bit`.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":{"name":"bitvec"}}],[11,"with_capacity","","Constructs a new, empty `BitVec` with the specified capacity.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"bitvec"}}],[11,"from_bytes","","Transforms a byte-vector into a `BitVec`. Each byte becomes eight bits,\nwith the most significant bits of each byte coming first. Each\nbit becomes `true` if equal to 1 or `false` if equal to 0.",11,null],[11,"from_fn","","Creates a `BitVec` of the specified length where the value at each index\nis `f(index)`.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"f"}],"output":{"name":"bitvec"}}],[11,"get","","Retrieves the value at index `i`, or `None` if the index is out of bounds.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":{"name":"option"}}],[11,"set","","Sets the value of a bit at an index `i`.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":null}],[11,"set_all","","Sets all bits to 1.",11,{"inputs":[{"name":"bitvec"}],"output":null}],[11,"negate","","Flips all bits.",11,{"inputs":[{"name":"bitvec"}],"output":null}],[11,"union","","Calculates the union of two bitvectors. This acts like the bitwise `or`\nfunction.",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"intersect","","Calculates the intersection of two bitvectors. This acts like the\nbitwise `and` function.",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"difference","","Calculates the difference between two bitvectors.",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"all","","Returns `true` if all bits are 1.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over the elements of the vector in order.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"iter"}}],[11,"none","","Returns `true` if all bits are 0.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"any","","Returns `true` if any bit is 1.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"to_bytes","","Organises the bits into bytes, such that the first bit in the\n`BitVec` becomes the high-order bit of the first byte. If the\nsize of the `BitVec` is not a multiple of eight then trailing bits\nwill be filled-in with `false`.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"vec"}}],[11,"eq_vec","","Compares a `BitVec` to a slice of `bool`s.\nBoth the `BitVec` and slice must have the same length.",11,null],[11,"truncate","","Shortens a `BitVec`, dropping excess elements.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":null}],[11,"reserve","","Reserves capacity for at least `additional` more bits to be inserted in the given\n`BitVec`. The collection may reserve more space to avoid frequent reallocations.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":null}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bits to be inserted in the\ngiven `BitVec`. Does nothing if the capacity is already sufficient.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"}],"output":null}],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"grow","","Grows the `BitVec` in-place, adding `n` copies of `value` to the `BitVec`.",11,{"inputs":[{"name":"bitvec"},{"name":"usize"},{"name":"bool"}],"output":null}],[11,"pop","","Removes the last bit from the BitVec, and returns it. Returns None if the BitVec is empty.",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"option"}}],[11,"push","","Pushes a `bool` onto the end.",11,{"inputs":[{"name":"bitvec"},{"name":"bool"}],"output":null}],[11,"len","","Returns the total number of bits in this vector",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if there are no bits in this vector",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this vector.",11,{"inputs":[{"name":"bitvec"}],"output":null}],[11,"default","","",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"from_iter","","",11,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":{"name":"bitvec"}}],[11,"extend","","",11,{"inputs":[{"name":"bitvec"},{"name":"i"}],"output":null}],[11,"clone","","",11,{"inputs":[{"name":"bitvec"}],"output":{"name":"bitvec"}}],[11,"clone_from","","",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":null}],[11,"partial_cmp","","",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"option"}}],[11,"cmp","","",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"ordering"}}],[11,"fmt","","",11,{"inputs":[{"name":"bitvec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",11,{"inputs":[{"name":"bitvec"},{"name":"h"}],"output":null}],[11,"eq","","",11,{"inputs":[{"name":"bitvec"},{"name":"bitvec"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"default","","",12,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"from_iter","","",12,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":{"name":"bitset"}}],[11,"extend","","",12,{"inputs":[{"name":"bitset"},{"name":"i"}],"output":null}],[11,"partial_cmp","","",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"option"}}],[11,"cmp","","",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"ordering"}}],[11,"eq","","",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"new","","Creates a new empty `BitSet`.",12,{"inputs":[{"name":"bitset"}],"output":{"name":"bitset"}}],[11,"with_capacity","","Creates a new `BitSet` with initially no contents, able to\nhold `nbits` elements without resizing.",12,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bitset"}}],[11,"from_bit_vec","","Creates a new `BitSet` from the given bit vector.",12,{"inputs":[{"name":"bitset"},{"name":"bitvec"}],"output":{"name":"bitset"}}],[11,"capacity","","Returns the capacity in bits for this bit vector. Inserting any\nelement less than this amount will not trigger a resizing.",12,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `BitSet` to contain `len` distinct elements. In the case\nof `BitSet` this means reallocations will not occur as long as all inserted elements\nare less than `len`.",12,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":null}],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `BitSet` to contain `len` distinct elements.\nIn the case of `BitSet` this means reallocations will not occur as long as all inserted\nelements are less than `len`.",12,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":null}],[11,"into_bit_vec","","Consumes this set to return the underlying bit vector.",12,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"get_ref","","Returns a reference to the underlying bit vector.",12,{"inputs":[{"name":"bitset"}],"output":{"name":"bitvec"}}],[11,"shrink_to_fit","","Truncates the underlying vector to the least length required.",12,{"inputs":[{"name":"bitset"}],"output":null}],[11,"iter","","Iterator over each usize stored in the `BitSet`.",12,{"inputs":[{"name":"bitset"}],"output":{"name":"iter"}}],[11,"union","","Iterator over each usize stored in `self` union `other`.\nSee [union_with](#method.union_with) for an efficient in-place version.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"union"}}],[11,"intersection","","Iterator over each usize stored in `self` intersect `other`.\nSee [intersect_with](#method.intersect_with) for an efficient in-place version.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"intersection"}}],[11,"difference","","Iterator over each usize stored in the `self` setminus `other`.\nSee [difference_with](#method.difference_with) for an efficient in-place version.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Iterator over each usize stored in the symmetric difference of `self` and `other`.\nSee [symmetric_difference_with](#method.symmetric_difference_with) for\nan efficient in-place version.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"symmetricdifference"}}],[11,"union_with","","Unions in-place with the specified other bit vector.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"intersect_with","","Intersects in-place with the specified other bit vector.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"difference_with","","Makes this bit vector the difference with the specified other bit vector\nin-place.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"symmetric_difference_with","","Makes this bit vector the symmetric difference with the specified other\nbit vector in-place.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":null}],[11,"len","","Returns the number of set bits in this set.",12,{"inputs":[{"name":"bitset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns whether there are no bits set in this set",12,{"inputs":[{"name":"bitset"}],"output":{"name":"bool"}}],[11,"clear","","Clears all bits in this set",12,{"inputs":[{"name":"bitset"}],"output":null}],[11,"contains","","Returns `true` if this set contains the specified integer.",12,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",12,{"inputs":[{"name":"bitset"},{"name":"bitset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",12,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",12,{"inputs":[{"name":"bitset"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"fmt","","",12,{"inputs":[{"name":"bitset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",12,{"inputs":[{"name":"bitset"},{"name":"h"}],"output":null}],[11,"clone","","",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"new","","Makes a new empty BTreeMap with a reasonable choice for B.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"with_b","","Makes a new empty BTreeMap with the given B.",13,{"inputs":[{"name":"btreemap"},{"name":"usize"}],"output":{"name":"btreemap"}}],[11,"clear","","Clears the map, removing all values.",13,{"inputs":[{"name":"btreemap"}],"output":null}],[11,"get","","Returns a reference to the value corresponding to the key.",13,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",13,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",13,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",13,{"inputs":[{"name":"btreemap"},{"name":"k"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",13,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"option"}}],[11,"into_iter","","Gets an owning iterator over the entries of the map.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"intoiter"}}],[11,"from_iter","","",13,{"inputs":[{"name":"btreemap"},{"name":"t"}],"output":{"name":"btreemap"}}],[11,"extend","","",13,{"inputs":[{"name":"btreemap"},{"name":"t"}],"output":null}],[11,"hash","","",13,{"inputs":[{"name":"btreemap"},{"name":"h"}],"output":null}],[11,"default","","",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"btreemap"}}],[11,"eq","","",13,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",13,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"option"}}],[11,"cmp","","",13,{"inputs":[{"name":"btreemap"},{"name":"btreemap"}],"output":{"name":"ordering"}}],[11,"fmt","","",13,{"inputs":[{"name":"btreemap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"index","","",13,{"inputs":[{"name":"btreemap"},{"name":"q"}],"output":{"name":"v"}}],[11,"iter","","Gets an iterator over the entries of the map.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Gets a mutable iterator over the entries of the map.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"itermut"}}],[11,"keys","","Gets an iterator over the keys of the map.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"keys"}}],[11,"values","","Gets an iterator over the values of the map.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"values"}}],[11,"len","","Returns the number of elements in the map.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",13,{"inputs":[{"name":"btreemap"}],"output":{"name":"bool"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",13,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"range_mut","","Constructs a mutable double-ended iterator over a sub-range of elements in the map, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",13,{"inputs":[{"name":"btreemap"},{"name":"bound"},{"name":"bound"}],"output":{"name":"rangemut"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",13,{"inputs":[{"name":"btreemap"},{"name":"k"}],"output":{"name":"entry"}}],[11,"partial_cmp","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"option"}}],[11,"lt","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"le","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"gt","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ge","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"cmp","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"ordering"}}],[11,"eq","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"hash","","",14,null],[11,"clone","","",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"new","","Makes a new BTreeSet with a reasonable choice of B.",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"with_b","","Makes a new BTreeSet with the given B.",14,{"inputs":[{"name":"btreeset"},{"name":"usize"}],"output":{"name":"btreeset"}}],[11,"iter","","Gets an iterator over the BTreeSet's contents.",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"iter"}}],[11,"range","","Constructs a double-ended iterator over a sub-range of elements in the set, starting\nat min, and ending at max. If min is `Unbounded`, then it will be treated as \"negative\ninfinity\", and if max is `Unbounded`, then it will be treated as \"positive infinity\".\nThus range(Unbounded, Unbounded) will yield the whole collection.",14,{"inputs":[{"name":"btreeset"},{"name":"bound"},{"name":"bound"}],"output":{"name":"range"}}],[11,"difference","","Visits the values representing the difference, in ascending order.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"difference"}}],[11,"symmetric_difference","","Visits the values representing the symmetric difference, in ascending order.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"symmetricdifference"}}],[11,"intersection","","Visits the values representing the intersection, in ascending order.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"intersection"}}],[11,"union","","Visits the values representing the union, in ascending order.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"union"}}],[11,"len","","Returns the number of elements in the set.",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the set contains no elements.",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"clear","","Clears the set, removing all values.",14,{"inputs":[{"name":"btreeset"}],"output":null}],[11,"contains","","Returns `true` if the set contains a value.",14,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"is_disjoint","","Returns `true` if the set has no elements in common with `other`.\nThis is equivalent to checking for an empty intersection.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if the set is a subset of another.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if the set is a superset of another.",14,{"inputs":[{"name":"btreeset"},{"name":"btreeset"}],"output":{"name":"bool"}}],[11,"insert","","Adds a value to the set. Returns `true` if the value was not already\npresent in the set.",14,{"inputs":[{"name":"btreeset"},{"name":"t"}],"output":{"name":"bool"}}],[11,"remove","","Removes a value from the set. Returns `true` if the value was\npresent in the set.",14,{"inputs":[{"name":"btreeset"},{"name":"q"}],"output":{"name":"bool"}}],[11,"from_iter","","",14,{"inputs":[{"name":"btreeset"},{"name":"i"}],"output":{"name":"btreeset"}}],[11,"into_iter","","Gets an iterator for moving out the BtreeSet's contents.",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"intoiter"}}],[11,"extend","","",14,{"inputs":[{"name":"btreeset"},{"name":"iter"}],"output":null}],[11,"default","","",14,{"inputs":[{"name":"btreeset"}],"output":{"name":"btreeset"}}],[11,"fmt","","",14,{"inputs":[{"name":"btreeset"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"borrow","","A module for working with borrowed data.",null,null],[4,"Cow","collections::borrow","A clone-on-write smart pointer.",null,null],[13,"Borrowed","","Borrowed data.",15,null],[13,"Owned","","Owned data.",15,null],[8,"Borrow","","A trait for borrowing data.",null,null],[10,"borrow","","Immutably borrows from an owned value.",16,{"inputs":[{"name":"borrow"}],"output":{"name":"borrowed"}}],[8,"BorrowMut","","A trait for mutably borrowing data.",null,null],[10,"borrow_mut","","Mutably borrows from an owned value.",17,{"inputs":[{"name":"borrowmut"}],"output":{"name":"borrowed"}}],[8,"ToOwned","","A generalization of `Clone` to borrowed data.",null,null],[16,"Owned","collections::borrow::ToOwned","",null,null],[10,"to_owned","collections::borrow","Creates owned data from borrowed data, usually by cloning.",18,{"inputs":[{"name":"toowned"}],"output":{"name":"owned"}}],[8,"IntoCow","","Trait for moving into a `Cow`.",null,null],[10,"into_cow","","Moves `self` into `Cow`",19,{"inputs":[{"name":"intocow"}],"output":{"name":"cow"}}],[11,"borrow","alloc::rc","",3,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"borrow","alloc::arc","",2,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"borrow","collections::borrow","",15,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[6,"Owned","","",null,null],[11,"clone","","",15,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"to_mut","","Acquires a mutable reference to the owned form of the data.",15,null],[11,"into_owned","","Extracts the owned data.",15,null],[6,"Target","","",null,null],[11,"deref","","",15,{"inputs":[{"name":"cow"}],"output":{"name":"b"}}],[11,"cmp","","",15,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"ordering"}}],[11,"eq","","",15,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",15,{"inputs":[{"name":"cow"},{"name":"cow"}],"output":{"name":"option"}}],[11,"fmt","","",15,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",15,{"inputs":[{"name":"cow"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",15,{"inputs":[{"name":"cow"},{"name":"h"}],"output":null}],[11,"into_cow","","",15,{"inputs":[{"name":"cow"}],"output":{"name":"cow"}}],[11,"as_ref","","",15,{"inputs":[{"name":"cow"}],"output":{"name":"t"}}],[0,"enum_set","collections","A structure for holding a set of enum variants.",null,null],[3,"EnumSet","collections::enum_set","A specialized set implementation to use enum types.",null,null],[3,"Iter","","An iterator over an EnumSet",null,null],[8,"CLike","","An interface for casting C-like enum to usize and back.\nA typically implementation is as below.",null,null],[10,"to_usize","","Converts a C-like enum to a `usize`.",20,{"inputs":[{"name":"clike"}],"output":{"name":"usize"}}],[10,"from_usize","","Converts a `usize` to a C-like enum.",20,{"inputs":[{"name":"clike"},{"name":"usize"}],"output":{"name":"self"}}],[11,"hash","","",21,null],[11,"cmp","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"option"}}],[11,"lt","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"le","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"gt","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ge","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"eq","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"ne","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clone","","",21,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"fmt","","",21,{"inputs":[{"name":"enumset"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Returns an empty `EnumSet`.",21,{"inputs":[{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"len","","Returns the number of elements in the given `EnumSet`.",21,{"inputs":[{"name":"enumset"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the `EnumSet` is empty.",21,{"inputs":[{"name":"enumset"}],"output":{"name":"bool"}}],[11,"clear","","",21,{"inputs":[{"name":"enumset"}],"output":null}],[11,"is_disjoint","","Returns `false` if the `EnumSet` contains any enum of the given `EnumSet`.",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_superset","","Returns `true` if a given `EnumSet` is included in this `EnumSet`.",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"is_subset","","Returns `true` if this `EnumSet` is included in the given `EnumSet`.",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"bool"}}],[11,"union","","Returns the union of both `EnumSets`.",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"intersection","","Returns the intersection of both `EnumSets`.",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"insert","","Adds an enum to the `EnumSet`, and returns `true` if it wasn't there before",21,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"remove","","Removes an enum from the EnumSet",21,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"contains","","Returns `true` if an `EnumSet` contains a given enum.",21,{"inputs":[{"name":"enumset"},{"name":"e"}],"output":{"name":"bool"}}],[11,"iter","","Returns an iterator over an `EnumSet`.",21,{"inputs":[{"name":"enumset"}],"output":{"name":"iter"}}],[6,"Output","","",null,null],[11,"sub","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[6,"Output","","",null,null],[11,"bitor","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[6,"Output","","",null,null],[11,"bitand","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[6,"Output","","",null,null],[11,"bitxor","","",21,{"inputs":[{"name":"enumset"},{"name":"enumset"}],"output":{"name":"enumset"}}],[11,"clone","","",22,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",22,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",22,null],[11,"from_iter","","",21,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":{"name":"enumset"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","","",21,{"inputs":[{"name":"enumset"},{"name":"i"}],"output":null}],[0,"fmt","collections","Utilities for formatting and printing strings",null,null],[11,"pad_integral","core::fmt","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",23,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",23,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",23,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",23,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",23,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",23,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",23,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",23,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",23,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",23,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",23,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",23,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",23,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",23,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"fmt","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shl","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"shr","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"add","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"sub","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"mul","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"not","core::num","",24,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitxor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitor","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","collections::fmt","",null,null],[11,"bitand","core::num","",24,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"fmt","","",25,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",25,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",25,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",25,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[6,"Err","collections::fmt","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[11,"eq","core::num","",26,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",26,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",26,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",26,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",27,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",27,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",27,{"inputs":[{"name":"interrorkind"}],"output":{"name":"interrorkind"}}],[11,"fmt","","",27,{"inputs":[{"name":"interrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",26,{"inputs":[{"name":"parseinterror"}],"output":{"name":"str"}}],[11,"fmt","","",26,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",28,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",28,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",28,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",28,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",29,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",29,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",29,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",29,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",28,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"str"}}],[11,"fmt","","",28,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","core::nonzero","",30,null],[11,"fmt","","",30,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",30,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",30,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",30,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[6,"Target","collections::fmt","",null,null],[11,"deref","core::nonzero","",30,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[11,"new","core::ptr","Creates a new `Unique`.",31,null],[11,"get","","Dereferences the content.",31,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",31,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[6,"Target","collections::fmt","",null,null],[11,"deref","core::ptr","",31,null],[11,"fmt","","",31,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","core::marker","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",32,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",32,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"cmp","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"option"}}],[11,"lt","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"le","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"gt","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ge","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"eq","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ne","","",33,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"clone","","",33,{"inputs":[{"name":"managed"}],"output":{"name":"managed"}}],[11,"hash","","",34,null],[11,"eq","","",34,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",34,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",34,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",34,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[6,"Output","collections::fmt","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"eq","core::ops","",35,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",35,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",35,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",35,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",36,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",37,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",37,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",37,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",37,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",38,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",38,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",38,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",38,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","collections::fmt","",null,null],[6,"Target","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"fmt","core::cmp","",39,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",39,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",39,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",39,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",39,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",39,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",39,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[11,"fmt","collections","",40,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",40,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",40,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",40,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",40,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",40,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",40,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",40,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",41,null],[11,"fmt","","",41,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",41,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",41,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",41,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"of","","Returns the `TypeId` of the type this generic function has been\ninstantiated with",41,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[6,"Item","collections::fmt","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"default","core::atomic","",42,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",43,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",44,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"clone","","",45,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",42,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",42,null],[11,"swap","","Stores a value into the bool, returning the old value.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the bool if the current value is the same as the expected value.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",42,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",43,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",43,null],[11,"swap","","Stores a value into the isize, returning the old value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the isize if the current value is the same as the expected value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",43,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",44,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",44,null],[11,"swap","","Stores a value into the usize, returning the old value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the usize if the current value is the same as the expected value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",44,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",46,null],[11,"load","","Loads a value from the pointer.",46,null],[11,"store","","Stores a value into the pointer.",46,null],[11,"swap","","Stores a value into the pointer, returning the old value.",46,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the expected value.",46,null],[11,"new","core::cell","Creates a new `Cell` containing the given value.",47,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",47,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",47,null],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",47,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",47,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",47,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",47,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",48,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",48,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",48,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",48,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",49,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",49,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",49,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",49,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",49,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",49,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",49,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",49,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",49,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"drop","","",50,null],[11,"clone","","",50,{"inputs":[{"name":"borrowref"}],"output":{"name":"borrowref"}}],[6,"Target","collections::fmt","",null,null],[11,"deref","core::cell","",51,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"drop","","",52,null],[6,"Target","collections::fmt","",null,null],[11,"deref","core::cell","",53,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",53,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",54,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",54,null],[11,"into_inner","","Unwraps the value.",54,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"clone","core::char","",55,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"clone","","",56,{"inputs":[{"name":"escapeunicodestate"}],"output":{"name":"escapeunicodestate"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::char","",55,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",57,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"clone","","",58,{"inputs":[{"name":"escapedefaultstate"}],"output":{"name":"escapedefaultstate"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::char","",57,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"clone","core::iter","",59,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",59,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",59,null],[11,"next_back","","",59,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",59,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",59,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",60,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",60,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",60,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",60,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",60,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",61,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",61,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",61,null],[11,"next_back","","",61,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",61,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",61,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",62,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",62,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"indexable","","",62,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",62,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",63,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",63,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",63,null],[11,"next_back","","",63,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",63,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",63,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",64,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",64,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",64,null],[11,"next_back","","",64,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",64,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",64,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",65,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",65,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",65,null],[11,"next_back","","",65,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",65,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",65,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",66,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",66,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",66,null],[11,"next_back","","",66,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",67,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",67,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",67,null],[11,"next_back","","",67,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",68,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",68,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",68,null],[11,"next_back","","",68,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",68,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",68,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",69,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",69,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",69,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",69,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",69,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",70,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",70,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",70,null],[11,"clone","","",71,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",71,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",71,null],[11,"clone","","",72,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",72,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",72,null],[11,"indexable","","",72,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",72,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",73,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",73,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"size_hint","","",73,null],[11,"indexable","","",73,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",73,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",74,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",74,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",74,null],[11,"clone","","",75,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",75,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",75,null],[11,"next_back","","",75,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",76,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",76,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"size_hint","","",76,null],[11,"next_back","","",76,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",76,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",76,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",76,null],[11,"clone","","",77,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",77,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",77,null],[11,"next_back","","",77,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",77,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",77,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",78,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",78,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",78,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",78,null],[11,"clone","","",79,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",37,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",36,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",79,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",79,null],[11,"clone","","",80,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",80,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",80,null],[11,"next_back","","",80,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",79,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::ops","",36,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",36,null],[11,"next_back","","",36,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::ops","",37,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",81,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::iter","",81,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",81,null],[11,"next_back","","",81,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",81,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",81,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"hash","core::option","",82,null],[11,"fmt","","",82,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",82,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",82,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",82,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",82,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",82,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",82,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",82,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",82,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",82,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",82,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",82,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value or returns a default.",82,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value or computes a default.",82,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",82,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",82,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",82,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",82,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",82,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",82,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",82,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",82,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",82,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",82,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",82,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",82,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","core::option","Returns a consuming iterator over the possibly contained value.",82,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"clone","","",83,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::option","",83,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"size_hint","","",83,null],[11,"next_back","","",83,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::option","",84,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",84,null],[11,"next_back","","",84,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",84,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::option","",85,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",85,null],[11,"next_back","","",85,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::option","",86,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",86,null],[11,"next_back","","",86,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",82,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[11,"clone","core::raw","",87,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",88,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[11,"hash","core::result","",89,null],[11,"fmt","","",89,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",89,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",89,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",89,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",89,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",89,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",89,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",89,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",89,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",89,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",89,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",89,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",89,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",89,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",89,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",89,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",89,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",89,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",89,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",89,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",89,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[6,"Item","collections::fmt","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","core::result","Returns a consuming iterator over the possibly contained value.",89,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::result","",90,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",90,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::result","",91,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",91,null],[11,"next_back","","",91,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::result","",92,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",92,null],[11,"next_back","","",92,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",89,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[11,"fmt","core::simd","",93,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",93,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",94,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",94,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",95,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",95,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",96,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",96,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",97,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",97,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",98,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",98,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",99,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",99,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",100,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",100,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",101,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",101,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",102,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",102,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[6,"Output","collections::fmt","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"as_slice","core::slice","View the underlying data as a subslice of the original data.",103,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",103,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",103,null],[11,"next_back","","",103,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",103,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",103,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",103,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",104,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",104,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",104,null],[11,"next_back","","",104,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",105,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",105,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",105,null],[11,"next_back","","",105,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",105,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",106,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",106,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",106,null],[11,"next_back","","",106,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",107,{"inputs":[{"name":"genericsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",107,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",108,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",108,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",109,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",109,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",110,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",110,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",111,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",111,null],[11,"clone","","",112,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",112,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",112,null],[11,"next_back","","",112,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",112,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",112,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",113,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",113,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",113,null],[11,"next_back","","",113,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",113,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",113,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::slice","",114,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",114,null],[11,"next_back","","",114,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"fmt","core::str::pattern","",115,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",115,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",115,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",115,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",116,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"chareqsearcher"}}],[6,"Searcher","collections::fmt","",null,null],[11,"into_searcher","core::str::pattern","",117,{"inputs":[{"name":"chareqpattern"},{"name":"str"}],"output":{"name":"chareqsearcher"}}],[11,"haystack","","",116,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"str"}}],[11,"next","","",116,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",116,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",118,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"eq","","",119,{"inputs":[{"name":"state"},{"name":"state"}],"output":{"name":"bool"}}],[11,"ne","","",119,{"inputs":[{"name":"state"},{"name":"state"}],"output":{"name":"bool"}}],[11,"clone","","",119,{"inputs":[{"name":"state"}],"output":{"name":"state"}}],[6,"Searcher","collections::fmt","",null,null],[11,"haystack","core::str::pattern","",118,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",118,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",118,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",120,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[6,"Searcher","collections::fmt","",null,null],[11,"clone","core::str::pattern","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",121,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[6,"Searcher","collections::fmt","",null,null],[11,"clone","core::str::pattern","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",122,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[6,"Searcher","collections::fmt","",null,null],[6,"Searcher","","",null,null],[6,"Err","","",null,null],[11,"eq","core::str","",123,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",123,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",123,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",123,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",123,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",124,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",124,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",124,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",124,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",124,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",124,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",125,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",125,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",125,null],[11,"next_back","","",125,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",126,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",126,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",126,null],[11,"next_back","","",126,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",127,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"clone","","",128,{"inputs":[{"name":"bytesderef"}],"output":{"name":"bytesderef"}}],[11,"call","","",128,null],[11,"call_mut","","",128,null],[6,"Output","collections::fmt","",null,null],[11,"call_once","core::str","",128,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",127,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",127,null],[11,"next_back","","",127,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",127,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"clone","","",129,{"inputs":[{"name":"splitinternal"}],"output":{"name":"splitinternal"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",130,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",130,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",131,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",131,{"inputs":[{"name":"rsplit"}],"output":{"name":"rsplit"}}],[11,"next_back","","",130,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",131,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",132,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",132,{"inputs":[{"name":"splitterminator"}],"output":{"name":"splitterminator"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",133,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",133,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"rsplitterminator"}}],[11,"next_back","","",132,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",133,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",134,{"inputs":[{"name":"splitninternal"}],"output":{"name":"splitninternal"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",135,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",135,{"inputs":[{"name":"splitn"}],"output":{"name":"splitn"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",136,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",136,{"inputs":[{"name":"rsplitn"}],"output":{"name":"rsplitn"}}],[11,"clone","","",137,{"inputs":[{"name":"matchindicesinternal"}],"output":{"name":"matchindicesinternal"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",138,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",138,{"inputs":[{"name":"matchindices"}],"output":{"name":"matchindices"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",139,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",139,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"rmatchindices"}}],[11,"next_back","","",138,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",139,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",140,{"inputs":[{"name":"matchesinternal"}],"output":{"name":"matchesinternal"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",141,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",141,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",142,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",142,{"inputs":[{"name":"rmatches"}],"output":{"name":"rmatches"}}],[11,"next_back","","",141,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",142,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",143,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",143,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",143,null],[11,"next_back","","",143,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",144,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"clone","","",145,{"inputs":[{"name":"linesanymap"}],"output":{"name":"linesanymap"}}],[11,"call","","",145,null],[11,"call_mut","","",145,null],[6,"Output","collections::fmt","",null,null],[11,"call_once","core::str","",145,null],[6,"Item","collections::fmt","",null,null],[11,"next","core::str","",144,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",144,null],[11,"next_back","","",144,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",146,{"inputs":[{"name":"twowaysearcher"}],"output":{"name":"twowaysearcher"}}],[11,"clone","","",147,{"inputs":[{"name":"oldsearcher"}],"output":{"name":"oldsearcher"}}],[11,"clone","","",148,{"inputs":[{"name":"oldmatchindices"}],"output":{"name":"oldmatchindices"}}],[11,"clone","","",149,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[6,"Output","collections::fmt","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"new","core::hash::sip","Creates a new `SipHasher` with the two initial keys set to 0.",150,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",150,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",150,null],[11,"finish","","",150,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",150,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",150,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"eq","core::fmt::num","",151,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"ne","","",151,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"clone","","",151,{"inputs":[{"name":"binary"}],"output":{"name":"binary"}}],[11,"eq","","",152,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"ne","","",152,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"clone","","",152,{"inputs":[{"name":"octal"}],"output":{"name":"octal"}}],[11,"eq","","",153,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"ne","","",153,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"clone","","",153,{"inputs":[{"name":"decimal"}],"output":{"name":"decimal"}}],[11,"eq","","",154,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"ne","","",154,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"clone","","",154,{"inputs":[{"name":"lowerhex"}],"output":{"name":"lowerhex"}}],[11,"eq","","",155,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"ne","","",155,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"clone","","",155,{"inputs":[{"name":"upperhex"}],"output":{"name":"upperhex"}}],[11,"eq","","",156,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",156,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",156,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",157,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",157,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","core::fmt::builders","",158,{"inputs":[{"name":"padadapter"},{"name":"str"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",159,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Consumes the `DebugStruct`, finishing output and returning any error\nencountered.",159,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",160,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Consumes the `DebugTuple`, finishing output and returning any error\nencountered.",160,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"finish","","",161,null],[11,"entry","","Adds a new entry to the set output.",162,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",162,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the set output.",163,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",163,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",164,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"finish","","Consumes the `DebugMap`, finishing output and returning any error\nencountered.",164,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[11,"clone","core::fmt::rt::v1","",165,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clone","","",166,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",167,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",167,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",167,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"clone","","",168,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[11,"clone","","",169,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"fmt","core::fmt","",170,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",170,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",171,{"inputs":[{"name":"flagv1"}],"output":{"name":"flagv1"}}],[11,"clone","","",172,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",172,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",172,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",170,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",34,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",47,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",49,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",51,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",53,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Formatter","collections::fmt","A struct to represent both where to emit formatting strings to and how they\nshould be formatted. A mutable version of this is passed to all formatting\ntraits.",null,null],[6,"Result","","",null,null],[8,"Write","","A collection of methods that are required to format a message into a stream.",null,null],[10,"write_str","","Writes a slice of bytes into this writer, returning whether the write\nsucceeded.",173,{"inputs":[{"name":"write"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Glue for usage of the `write!` macro with implementers of this trait.",173,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[8,"Octal","","Format trait for the `o` character",null,null],[10,"fmt","","Formats the value using the given formatter.",174,{"inputs":[{"name":"octal"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Binary","","Format trait for the `b` character",null,null],[10,"fmt","","Formats the value using the given formatter.",175,{"inputs":[{"name":"binary"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Display","","When a value can be semantically expressed as a String, this trait may be\nused. It corresponds to the default format, `{}`.",null,null],[10,"fmt","","Formats the value using the given formatter.",176,{"inputs":[{"name":"display"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Debug","","Format trait for the `:?` format. Useful for debugging, all types\nshould implement this.",null,null],[10,"fmt","","Formats the value using the given formatter.",177,{"inputs":[{"name":"debug"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerHex","","Format trait for the `x` character",null,null],[10,"fmt","","Formats the value using the given formatter.",178,{"inputs":[{"name":"lowerhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperHex","","Format trait for the `X` character",null,null],[10,"fmt","","Formats the value using the given formatter.",179,{"inputs":[{"name":"upperhex"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"Pointer","","Format trait for the `p` character",null,null],[10,"fmt","","Formats the value using the given formatter.",180,{"inputs":[{"name":"pointer"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"LowerExp","","Format trait for the `e` character",null,null],[10,"fmt","","Formats the value using the given formatter.",181,{"inputs":[{"name":"lowerexp"},{"name":"formatter"}],"output":{"name":"result"}}],[8,"UpperExp","","Format trait for the `E` character",null,null],[10,"fmt","","Formats the value using the given formatter.",182,{"inputs":[{"name":"upperexp"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"Error","","The error type which is returned from formatting a message into a stream.",null,null],[3,"Arguments","","This structure represents a safely precompiled version of a format string\nand its arguments. This cannot be generated at runtime because it cannot\nsafely be done so, so no constructors are given and the fields are private\nto prevent modification.",null,null],[5,"write","","The `write` function takes an output stream, a precompiled format string,\nand a list of arguments. The arguments will be formatted according to the\nspecified format string into the output stream provided.",null,{"inputs":[{"name":"write"},{"name":"arguments"}],"output":{"name":"result"}}],[5,"radix","","Constructs a radix formatter in the range of `2..36`.",null,{"inputs":[{"name":"t"},{"name":"u8"}],"output":{"name":"radixfmt"}}],[3,"Radix","","A radix with in the range of `2..36`.",null,null],[3,"RadixFmt","","A helper type for formatting radixes.",null,null],[5,"format","","The format function takes a precompiled format string and a list of\narguments, to return the resulting formatted string.",null,{"inputs":[{"name":"arguments"}],"output":{"name":"string"}}],[0,"linked_list","collections","A doubly-linked list with owned nodes.",null,null],[3,"LinkedList","collections::linked_list","A doubly-linked list.",null,null],[3,"Iter","","An iterator over references to the items of a `LinkedList`.",null,null],[3,"IterMut","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[3,"IntoIter","","An iterator over mutable references to the items of a `LinkedList`.",null,null],[11,"clone","","",183,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"clone","","",184,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[11,"default","","",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"new","","Creates an empty `LinkedList`.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"append","","Moves all elements from `other` to the end of the list.",185,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":null}],[11,"iter","","Provides a forward iterator.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"iter"}}],[11,"iter_mut","","Provides a forward iterator with mutable references.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"itermut"}}],[11,"is_empty","","Returns `true` if the `LinkedList` is empty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"len","","Returns the length of the `LinkedList`.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"usize"}}],[11,"clear","","Removes all elements from the `LinkedList`.",185,{"inputs":[{"name":"linkedlist"}],"output":null}],[11,"front","","Provides a reference to the front element, or `None` if the list is\nempty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the list\nis empty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the list is\nempty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the list\nis empty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_front","","Adds an element first in the list.",185,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":null}],[11,"pop_front","","Removes the first element and returns it, or `None` if the list is\nempty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"push_back","","Appends an element to the back of a list",185,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":null}],[11,"pop_back","","Removes the last element from a list and returns it, or `None` if\nit is empty.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"split_off","","Splits the list into two at the given index. Returns everything after the given index,\nincluding the index.",185,{"inputs":[{"name":"linkedlist"},{"name":"usize"}],"output":{"name":"linkedlist"}}],[11,"drop","","",185,{"inputs":[{"name":"linkedlist"}],"output":null}],[6,"Item","","",null,null],[11,"next","","",183,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",183,null],[11,"next_back","","",183,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",186,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",186,null],[11,"next_back","","",186,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"insert_next","","Inserts `elt` just after the element most recently returned by `.next()`.\nThe inserted element does not appear in the iteration.",186,{"inputs":[{"name":"itermut"},{"name":"a"}],"output":null}],[11,"peek_next","","Provides a reference to the next element, without changing the iterator.",186,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",184,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",184,null],[11,"next_back","","",184,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","",185,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":{"name":"linkedlist"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Consumes the list into an iterator yielding elements by value.",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","","",185,{"inputs":[{"name":"linkedlist"},{"name":"t"}],"output":null}],[11,"eq","","",185,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"ne","","",185,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",185,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"option"}}],[11,"cmp","","",185,{"inputs":[{"name":"linkedlist"},{"name":"linkedlist"}],"output":{"name":"ordering"}}],[11,"clone","","",185,{"inputs":[{"name":"linkedlist"}],"output":{"name":"linkedlist"}}],[11,"fmt","","",185,{"inputs":[{"name":"linkedlist"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",185,{"inputs":[{"name":"linkedlist"},{"name":"h"}],"output":null}],[0,"slice","collections","Utilities for slice manipulation",null,null],[3,"Chunks","collections::slice","An iterator over a slice in (non-overlapping) chunks (`size` elements at a\ntime).",null,null],[3,"Windows","","An iterator over overlapping subslices of length `size`.",null,null],[3,"Iter","","Immutable slice iterator",null,null],[3,"IterMut","","Mutable slice iterator.",null,null],[8,"IntSliceExt","","Extension methods for slices containing integers.",null,null],[10,"as_unsigned","","Converts the slice to an immutable slice of unsigned integers with the same width.",187,null],[10,"as_signed","","Converts the slice to an immutable slice of signed integers with the same width.",187,null],[10,"as_unsigned_mut","","Converts the slice to a mutable slice of unsigned integers with the same width.",187,null],[10,"as_signed_mut","","Converts the slice to a mutable slice of signed integers with the same width.",187,null],[3,"SplitMut","","An iterator over the subslices of the vector which are separated\nby elements that match `pred`.",null,null],[3,"ChunksMut","","An iterator over a slice in (non-overlapping) mutable chunks (`size`\nelements at a time). When the slice len is not evenly divided by the chunk\nsize, the last slice of the iteration will be the remainder.",null,null],[3,"Split","","An iterator over subslices separated by elements that match a predicate\nfunction.",null,null],[3,"SplitN","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitN","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[3,"SplitNMut","","An iterator over subslices separated by elements that match a predicate\nfunction, limited to a given number of splits.",null,null],[3,"RSplitNMut","","An iterator over subslices separated by elements that match a\npredicate function, limited to a given number of splits, starting\nfrom the end of the slice.",null,null],[0,"bytes","","Operations on `[u8]`.",null,null],[8,"MutableByteVector","collections::slice::bytes","A trait for operations on mutable `[u8]`s.",null,null],[10,"set_memory","","Sets all bytes of the receiver to the given value.",188,null],[5,"copy_memory","","Copies data from `src` to `dst`",null,null],[5,"mut_ref_slice","collections::slice","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"ref_slice","","Converts a pointer to A into a slice of length 1 (without copying).",null,null],[5,"from_raw_parts","","Forms a slice from a pointer and a length.",null,null],[5,"from_raw_parts_mut","","Performs the same functionality as `from_raw_parts`, except that a mutable\nslice is returned.",null,null],[3,"ElementSwaps","","An iterator that yields the element swaps needed to produce\na sequence of all possible permutations for an indexed sequence of\nelements. Each permutation is only a single swap apart.",null,null],[3,"Permutations","","An iterator that uses `ElementSwaps` to iterate through\nall possible permutations of a vector.",null,null],[8,"SliceConcatExt","","An extension trait for concatenating slices",null,null],[10,"concat","","Flattens a slice of `T` into a single value `U`.",189,{"inputs":[{"name":"sliceconcatext"}],"output":{"name":"u"}}],[10,"connect","","Flattens a slice of `T` into a single value `U`, placing a given separator between each.",189,{"inputs":[{"name":"sliceconcatext"},{"name":"t"}],"output":{"name":"u"}}],[11,"clone","","",190,{"inputs":[{"name":"elementswaps"}],"output":{"name":"elementswaps"}}],[11,"new","","Creates an `ElementSwaps` iterator for a sequence of `length` elements.",190,{"inputs":[{"name":"elementswaps"},{"name":"usize"}],"output":{"name":"elementswaps"}}],[6,"Owned","","",null,null],[6,"Item","","",null,null],[11,"next","","",190,{"inputs":[{"name":"elementswaps"}],"output":{"name":"option"}}],[11,"size_hint","","",190,null],[6,"Item","","",null,null],[11,"next","","",191,{"inputs":[{"name":"permutations"}],"output":{"name":"option"}}],[11,"size_hint","","",191,null],[0,"str","collections","Unicode string manipulation (the `str` type).",null,null],[8,"FromStr","collections::str","A trait to abstract the idea of creating a new instance of a type from a\nstring.",null,null],[16,"Err","collections::str::FromStr","The associated error which can be returned from parsing.",null,null],[10,"from_str","collections::str","Parses a string `s` to return an optional value of this type. If the\nstring is ill-formatted, the None is returned.",192,{"inputs":[{"name":"fromstr"},{"name":"str"}],"output":{"name":"result"}}],[3,"Utf8Error","","Errors which can occur when attempting to interpret a byte slice as a `str`.",null,null],[3,"Lines","","Created with the method `.lines()`.",null,null],[3,"LinesAny","","Created with the method `.lines_any()`.",null,null],[3,"CharRange","","Struct that contains a `char` and the index of the first byte of\nthe next `char` in a string.  This can be used as a data structure\nfor iterating over the UTF-8 bytes of a string.",null,null],[12,"ch","","Current `char`",149,null],[12,"next","","Index of the first byte of the next `char`",149,null],[3,"Split","","/// Created with the method `.split()`.",null,null],[3,"RSplit","","/// Created with the method `.rsplit()`.",null,null],[3,"SplitN","","/// Created with the method `.splitn()`.",null,null],[3,"RSplitN","","/// Created with the method `.rsplitn()`.",null,null],[3,"SplitTerminator","","/// Created with the method `.split_terminator()`.",null,null],[3,"RSplitTerminator","","/// Created with the method `.rsplit_terminator()`.",null,null],[3,"Matches","","/// Created with the method `.matches()`.",null,null],[3,"RMatches","","/// Created with the method `.rmatches()`.",null,null],[3,"MatchIndices","","/// Created with the method `.match_indices()`.",null,null],[3,"RMatchIndices","","/// Created with the method `.rmatch_indices()`.",null,null],[5,"from_utf8","","Converts a slice of bytes to a string slice without performing any\nallocations.",null,null],[3,"Chars","","Iterator for the char (representing *Unicode Scalar Values*) of a string",null,null],[3,"CharIndices","","Iterator for a string's characters and their byte offsets.",null,null],[3,"Bytes","","External iterator for a string's bytes.\nUse with the `std::iter` module.",null,null],[5,"from_utf8_unchecked","","Converts a slice of bytes to a string slice without checking\nthat the string contains valid UTF-8.",null,null],[3,"ParseBoolError","","An error returned when parsing a `bool` from a string fails.",null,null],[11,"clone","unicode::tables::grapheme","",193,{"inputs":[{"name":"graphemecat"}],"output":{"name":"graphemecat"}}],[11,"clone","unicode::u_str","",194,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"graphemeindices"}}],[6,"Item","collections::str","",null,null],[11,"next","unicode::u_str","",194,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"size_hint","","",194,null],[11,"next_back","","",194,{"inputs":[{"name":"graphemeindices"}],"output":{"name":"option"}}],[11,"clone","","",195,{"inputs":[{"name":"graphemes"}],"output":{"name":"graphemes"}}],[11,"eq","","",196,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[11,"ne","","",196,{"inputs":[{"name":"graphemestate"},{"name":"graphemestate"}],"output":{"name":"bool"}}],[6,"Item","collections::str","",null,null],[11,"size_hint","unicode::u_str","",195,null],[11,"next","","",195,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"next_back","","",195,{"inputs":[{"name":"graphemes"}],"output":{"name":"option"}}],[11,"clone","","",197,{"inputs":[{"name":"utf16items"}],"output":{"name":"utf16items"}}],[11,"fmt","","",198,{"inputs":[{"name":"utf16item"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",198,{"inputs":[{"name":"utf16item"}],"output":{"name":"utf16item"}}],[11,"eq","","",198,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"ne","","",198,{"inputs":[{"name":"utf16item"},{"name":"utf16item"}],"output":{"name":"bool"}}],[11,"to_char_lossy","","Convert `self` to a `char`, taking `LoneSurrogate`s to the\nreplacement character (U+FFFD).",198,{"inputs":[{"name":"utf16item"}],"output":{"name":"char"}}],[6,"Item","collections::str","",null,null],[11,"next","unicode::u_str","",197,{"inputs":[{"name":"utf16items"}],"output":{"name":"option"}}],[11,"size_hint","","",197,null],[11,"clone","","",199,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"utf16encoder"}}],[11,"new","","Create an UTF-16 encoder from any `char` iterator.",199,{"inputs":[{"name":"utf16encoder"},{"name":"i"}],"output":{"name":"utf16encoder"}}],[6,"Item","collections::str","",null,null],[11,"next","unicode::u_str","",199,{"inputs":[{"name":"utf16encoder"}],"output":{"name":"option"}}],[11,"size_hint","","",199,null],[6,"Item","collections::str","",null,null],[11,"next","unicode::u_str","",200,{"inputs":[{"name":"words"}],"output":{"name":"option"}}],[11,"next_back","","",200,{"inputs":[{"name":"words"}],"output":{"name":"option"}}],[6,"Item","collections::str","",null,null],[11,"next","unicode::char","",201,{"inputs":[{"name":"tolowercase"}],"output":{"name":"option"}}],[6,"Item","collections::str","",null,null],[11,"next","unicode::char","",202,{"inputs":[{"name":"touppercase"}],"output":{"name":"option"}}],[3,"Words","collections::str","An iterator over the words of a string, separated by a sequence of whitespace",null,null],[3,"Graphemes","","External iterator for a string's\n[grapheme clusters](http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries).",null,null],[3,"GraphemeIndices","","External iterator for grapheme clusters and byte offsets.",null,null],[0,"pattern","","The string Pattern API.",null,null],[8,"Pattern","collections::str::pattern","A string pattern.",null,null],[16,"Searcher","collections::str::pattern::Pattern","Associated searcher for this pattern",null,null],[10,"into_searcher","collections::str::pattern","Constructs the associated searcher from\n`self` and the `haystack` to search in.",203,null],[11,"is_contained_in","","Checks whether the pattern matches anywhere in the haystack",203,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_prefix_of","","Checks whether the pattern matches at the front of the haystack",203,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[11,"is_suffix_of","","Checks whether the pattern matches at the back of the haystack",203,{"inputs":[{"name":"pattern"},{"name":"str"}],"output":{"name":"bool"}}],[4,"SearchStep","","Result of calling `Searcher::next()` or `ReverseSearcher::next_back()`.",null,null],[13,"Match","","Expresses that a match of the pattern has been found at\n`haystack[a..b]`.",115,null],[13,"Reject","","Expresses that `haystack[a..b]` has been rejected as a possible match\nof the pattern.",115,null],[13,"Done","","Expresses that every byte of the haystack has been visted, ending\nthe iteration.",115,null],[8,"Searcher","","A searcher for a string pattern.",null,null],[10,"haystack","","Getter for the underlaying string to be searched in",204,{"inputs":[{"name":"searcher"}],"output":{"name":"str"}}],[10,"next","","Performs the next search step starting from the front.",204,{"inputs":[{"name":"searcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","Find the next `Match` result. See `next()`",204,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[11,"next_reject","","Find the next `Reject` result. See `next()`",204,{"inputs":[{"name":"searcher"}],"output":{"name":"option"}}],[8,"ReverseSearcher","","A reverse searcher for a string pattern.",null,null],[10,"next_back","","Performs the next search step starting from the back.",205,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","Find the next `Match` result. See `next_back()`",205,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","Find the next `Reject` result. See `next_back()`",205,{"inputs":[{"name":"reversesearcher"}],"output":{"name":"option"}}],[8,"DoubleEndedSearcher","","A marker trait to express that a `ReverseSearcher`\ncan be used for a `DoubleEndedIterator` implementation.",null,null],[3,"StrSearcher","","Associated type for `<&str as Pattern<'a>>::Searcher`.",null,null],[3,"CharSearcher","","Associated type for `<char as Pattern<'a>>::Searcher`.",null,null],[3,"CharSliceSearcher","","Associated type for `<&[char] as Pattern<'a>>::Searcher`.",null,null],[3,"CharPredicateSearcher","","Associated type for `<F as Pattern<'a>>::Searcher`.",null,null],[3,"Decompositions","collections::str","External iterator for a string decomposition's characters.",null,null],[3,"Recompositions","","External iterator for a string recomposition's characters.",null,null],[3,"Utf16Units","","External iterator for a string's UTF16 codeunits.",null,null],[11,"clone","","",206,{"inputs":[{"name":"decompositions"}],"output":{"name":"decompositions"}}],[6,"Item","","",null,null],[11,"next","","",206,{"inputs":[{"name":"decompositions"}],"output":{"name":"option"}}],[11,"size_hint","","",206,null],[11,"clone","","",207,{"inputs":[{"name":"recompositions"}],"output":{"name":"recompositions"}}],[6,"Item","","",null,null],[11,"next","","",207,{"inputs":[{"name":"recompositions"}],"output":{"name":"option"}}],[11,"clone","","",208,{"inputs":[{"name":"utf16units"}],"output":{"name":"utf16units"}}],[6,"Item","","",null,null],[11,"next","","",208,{"inputs":[{"name":"utf16units"}],"output":{"name":"option"}}],[11,"size_hint","","",208,null],[6,"Owned","","",null,null],[0,"string","collections","An owned, growable string that enforces that its contents are valid UTF-8.",null,null],[3,"String","collections::string","A growable string stored as a UTF-8 encoded buffer.",null,null],[3,"FromUtf8Error","","A possible error value from the `String::from_utf8` function.",null,null],[3,"FromUtf16Error","","A possible error value from the `String::from_utf16` function.",null,null],[3,"DerefString","","Wrapper type providing a `&String` reference via `Deref`.",null,null],[3,"ParseError","","Error returned from `String::from_str`",null,null],[5,"as_string","","Converts a string slice to a wrapper type providing a `&String` reference.",null,{"inputs":[{"name":"str"}],"output":{"name":"derefstring"}}],[8,"ToString","","A generic trait for converting a value to a string",null,null],[10,"to_string","","Converts the value of `self` to an owned string",209,{"inputs":[{"name":"tostring"}],"output":{"name":"string"}}],[11,"cmp","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"option"}}],[11,"lt","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"le","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"gt","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ge","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"clone","","",210,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",211,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",212,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Creates a new string buffer initialized with the empty string.",210,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"with_capacity","","Creates a new string buffer with the given capacity.\nThe string will be able to hold exactly `capacity` bytes without\nreallocating. If `capacity` is 0, the string will not allocate.",210,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"string"}}],[11,"from_str","","Creates a new string buffer from the given string.",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from_utf8","","Returns the vector as a string buffer, if possible, taking care not to\ncopy it.",210,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"result"}}],[11,"from_utf8_lossy","","Converts a vector of bytes to a new UTF-8 string.\nAny invalid UTF-8 sequences are replaced with U+FFFD REPLACEMENT CHARACTER.",210,null],[11,"from_utf16","","Decode a UTF-16 encoded vector `v` into a `String`, returning `None`\nif `v` contains any invalid data.",210,null],[11,"from_utf16_lossy","","Decode a UTF-16 encoded vector `v` into a string, replacing\ninvalid data with the replacement character (U+FFFD).",210,null],[11,"from_raw_parts","","Creates a new `String` from a length, capacity, and pointer.",210,null],[11,"from_utf8_unchecked","","Converts a vector of bytes to a new `String` without checking if\nit contains valid UTF-8. This is unsafe because it assumes that\nthe UTF-8-ness of the vector has already been validated.",210,{"inputs":[{"name":"string"},{"name":"vec"}],"output":{"name":"string"}}],[11,"into_bytes","","Returns the underlying byte buffer, encoded as UTF-8.",210,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"as_str","","Extracts a string slice containing the entire string.",210,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"push_str","","Pushes the given string onto this string buffer.",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":null}],[11,"capacity","","Returns the number of bytes that this string buffer can hold without\nreallocating.",210,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more bytes to be inserted\nin the given `String`. The collection may reserve more space to avoid\nfrequent reallocations.",210,{"inputs":[{"name":"string"},{"name":"usize"}],"output":null}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more bytes to be\ninserted in the given `String`. Does nothing if the capacity is already\nsufficient.",210,{"inputs":[{"name":"string"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of this string buffer to match its length.",210,{"inputs":[{"name":"string"}],"output":null}],[11,"push","","Adds the given character to the end of the string.",210,{"inputs":[{"name":"string"},{"name":"char"}],"output":null}],[11,"as_bytes","","Works with the underlying buffer as a byte slice.",210,null],[11,"truncate","","Shortens a string to the specified length.",210,{"inputs":[{"name":"string"},{"name":"usize"}],"output":null}],[11,"pop","","Removes the last character from the string buffer and returns it.\nReturns `None` if this string buffer is empty.",210,{"inputs":[{"name":"string"}],"output":{"name":"option"}}],[11,"remove","","Removes the character from the string buffer at byte position `idx` and\nreturns it.",210,{"inputs":[{"name":"string"},{"name":"usize"}],"output":{"name":"char"}}],[11,"insert","","Inserts a character into the string buffer at byte position `idx`.",210,{"inputs":[{"name":"string"},{"name":"usize"},{"name":"char"}],"output":null}],[11,"as_mut_vec","","Views the string buffer as a mutable sequence of bytes.",210,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"len","","Returns the number of bytes in this string.",210,{"inputs":[{"name":"string"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the string contains no bytes",210,{"inputs":[{"name":"string"}],"output":{"name":"bool"}}],[11,"clear","","Truncates the string, returning it to 0 length.",210,{"inputs":[{"name":"string"}],"output":null}],[11,"into_bytes","","Consumes this error, returning the bytes that were attempted to make a\n`String` with.",211,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"vec"}}],[11,"utf8_error","","Accesss the underlying UTF8-error that was the cause of this error.",211,{"inputs":[{"name":"fromutf8error"}],"output":{"name":"utf8error"}}],[11,"fmt","","",211,{"inputs":[{"name":"fromutf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",212,{"inputs":[{"name":"fromutf16error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",210,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"from_iter","","",210,{"inputs":[{"name":"string"},{"name":"i"}],"output":{"name":"string"}}],[11,"extend","","",210,{"inputs":[{"name":"string"},{"name":"i"}],"output":null}],[11,"extend","","",210,{"inputs":[{"name":"string"},{"name":"i"}],"output":null}],[6,"Searcher","","",null,null],[11,"eq","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",210,{"inputs":[{"name":"string"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",15,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"eq","","",15,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"bool"}}],[11,"eq","collections::string","",210,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"ne","","",210,{"inputs":[{"name":"string"},{"name":"cow"}],"output":{"name":"bool"}}],[11,"eq","collections::borrow","",15,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"bool"}}],[11,"default","collections::string","",210,{"inputs":[{"name":"string"}],"output":{"name":"string"}}],[11,"fmt","","",210,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",210,{"inputs":[{"name":"string"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","","",210,{"inputs":[{"name":"string"},{"name":"h"}],"output":null}],[6,"Output","","",null,null],[11,"add","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[6,"Output","","",null,null],[11,"index","","",210,{"inputs":[{"name":"string"},{"name":"range"}],"output":{"name":"str"}}],[6,"Output","","",null,null],[11,"index","","",210,{"inputs":[{"name":"string"},{"name":"rangeto"}],"output":{"name":"str"}}],[6,"Output","","",null,null],[11,"index","","",210,{"inputs":[{"name":"string"},{"name":"rangefrom"}],"output":{"name":"str"}}],[6,"Output","","",null,null],[11,"index","","",210,{"inputs":[{"name":"string"},{"name":"rangefull"}],"output":{"name":"str"}}],[6,"Target","","",null,null],[11,"deref","","",210,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[6,"Target","","",null,null],[11,"deref","","",213,{"inputs":[{"name":"derefstring"}],"output":{"name":"string"}}],[11,"eq","","",214,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"ne","","",214,{"inputs":[{"name":"parseerror"},{"name":"parseerror"}],"output":{"name":"bool"}}],[11,"fmt","","",214,{"inputs":[{"name":"parseerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",214,{"inputs":[{"name":"parseerror"}],"output":{"name":"parseerror"}}],[6,"Err","","",null,null],[11,"from_str","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[11,"as_ref","","",210,{"inputs":[{"name":"string"}],"output":{"name":"str"}}],[11,"as_ref","","",210,null],[11,"from","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"string"}}],[11,"from","collections::borrow","",15,{"inputs":[{"name":"cow"},{"name":"str"}],"output":{"name":"cow"}}],[11,"from","","",15,{"inputs":[{"name":"cow"},{"name":"string"}],"output":{"name":"cow"}}],[11,"into","collections::string","",210,{"inputs":[{"name":"string"}],"output":{"name":"vec"}}],[11,"into_cow","","",210,{"inputs":[{"name":"string"}],"output":{"name":"cow"}}],[11,"write_str","","",210,{"inputs":[{"name":"string"},{"name":"str"}],"output":{"name":"result"}}],[0,"vec","collections","A growable list type with heap-allocated contents, written `Vec<T>` but\npronounced 'vector.'",null,null],[3,"Vec","collections::vec","A growable list type, written `Vec<T>` but pronounced 'vector.'",null,null],[3,"IntoIter","","An iterator that moves out of a vector.",null,null],[3,"Drain","","An iterator that drains a vector.",null,null],[3,"DerefVec","","Wrapper type providing a `&Vec<T>` reference via `Deref`.",null,null],[5,"as_vec","","Converts a slice to a wrapper type providing a `&Vec<T>` reference.",null,null],[11,"new","","Constructs a new, empty `Vec<T>`.",215,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"with_capacity","","Constructs a new, empty `Vec<T>` with the specified capacity.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"vec"}}],[11,"from_raw_parts","","Creates a `Vec<T>` directly from the raw components of another vector.",215,null],[11,"from_raw_buf","","Creates a vector by copying the elements from a raw pointer.",215,null],[11,"capacity","","Returns the number of elements the vector can hold without\nreallocating.",215,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted\nin the given `Vec<T>`. The collection may reserve more space to avoid\nfrequent reallocations.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to\nbe inserted in the given `Vec<T>`. Does nothing if the capacity is already\nsufficient.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the vector as much as possible.",215,{"inputs":[{"name":"vec"}],"output":null}],[11,"into_boxed_slice","","Converts the vector into Box<[T]>.",215,{"inputs":[{"name":"vec"}],"output":{"name":"box"}}],[11,"truncate","","Shorten a vector, dropping excess elements.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"as_slice","","Extracts a slice containing the entire vector.",215,null],[11,"as_mut_slice","","Deprecated: use `&mut s[..]` instead.",215,null],[11,"set_len","","Sets the length of a vector.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":null}],[11,"swap_remove","","Removes an element from anywhere in the vector and return it, replacing\nit with the last element.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"insert","","Inserts an element at position `index` within the vector, shifting all\nelements after position `i` one position to the right.",215,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"remove","","Removes and returns the element at position `index` within the vector,\nshifting all elements after position `index` one position to the left.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"retain","","Retains only the elements specified by the predicate.",215,{"inputs":[{"name":"vec"},{"name":"f"}],"output":null}],[11,"push","","Appends an element to the back of a collection.",215,{"inputs":[{"name":"vec"},{"name":"t"}],"output":null}],[11,"pop","","Removes the last element from a vector and returns it, or `None` if it is empty.",215,{"inputs":[{"name":"vec"}],"output":{"name":"option"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",215,{"inputs":[{"name":"vec"},{"name":"self"}],"output":null}],[11,"drain","","Creates a draining iterator that clears the `Vec` and iterates over\nthe removed items from start to end.",215,{"inputs":[{"name":"vec"}],"output":{"name":"drain"}}],[11,"clear","","Clears the vector, removing all values.",215,{"inputs":[{"name":"vec"}],"output":null}],[11,"len","","Returns the number of elements in the vector.",215,{"inputs":[{"name":"vec"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns `true` if the vector contains no elements.",215,{"inputs":[{"name":"vec"}],"output":{"name":"bool"}}],[11,"map_in_place","","Converts a `Vec<T>` to a `Vec<U>` where `T` and `U` have the same\nsize and in case they are not zero-sized the same minimal alignment.",215,{"inputs":[{"name":"vec"},{"name":"f"}],"output":{"name":"vec"}}],[11,"split_off","","Splits the collection into two at the given index.",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"self"}}],[11,"resize","","Resizes the `Vec` in-place so that `len()` is equal to `new_len`.",215,{"inputs":[{"name":"vec"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"push_all","","Appends all elements in a slice to the `Vec`.",215,null],[11,"dedup","","Removes consecutive repeated elements in the vector.",215,{"inputs":[{"name":"vec"}],"output":null}],[11,"clone","","",215,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"clone_from","","",215,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":null}],[11,"hash","","",215,{"inputs":[{"name":"vec"},{"name":"h"}],"output":null}],[6,"Output","","",null,null],[11,"index","","",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[11,"index_mut","","",215,{"inputs":[{"name":"vec"},{"name":"usize"}],"output":{"name":"t"}}],[6,"Output","","",null,null],[11,"index","","",215,null],[6,"Output","","",null,null],[11,"index","","",215,null],[6,"Output","","",null,null],[11,"index","","",215,null],[6,"Output","","",null,null],[11,"index","","",215,null],[11,"index_mut","","",215,null],[11,"index_mut","","",215,null],[11,"index_mut","","",215,null],[11,"index_mut","","",215,null],[6,"Target","","",null,null],[11,"deref","","",215,null],[11,"deref_mut","","",215,null],[11,"from_iter","","",215,{"inputs":[{"name":"vec"},{"name":"i"}],"output":{"name":"vec"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Creates a consuming iterator, that is, one that moves each value out of\nthe vector (from start to end). The vector cannot be used after calling\nthis.",215,{"inputs":[{"name":"vec"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","","",215,{"inputs":[{"name":"vec"},{"name":"i"}],"output":null}],[11,"eq","","",215,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",215,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","collections::borrow","",15,null],[11,"ne","","",15,null],[11,"eq","","",15,null],[11,"ne","","",15,null],[11,"eq","","",15,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"cow"},{"name":"vec"}],"output":{"name":"bool"}}],[11,"eq","collections::vec","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"eq","","",215,null],[11,"ne","","",215,null],[11,"partial_cmp","","",215,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"option"}}],[11,"cmp","","",215,{"inputs":[{"name":"vec"},{"name":"vec"}],"output":{"name":"ordering"}}],[11,"drop","","",215,{"inputs":[{"name":"vec"}],"output":null}],[11,"default","","",215,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"fmt","","",215,{"inputs":[{"name":"vec"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"as_ref","","",215,{"inputs":[{"name":"vec"}],"output":{"name":"vec"}}],[11,"as_ref","","",215,null],[11,"from","","",215,null],[11,"from","","",215,{"inputs":[{"name":"vec"},{"name":"str"}],"output":{"name":"vec"}}],[11,"from_iter","collections::borrow","",15,{"inputs":[{"name":"cow"},{"name":"i"}],"output":{"name":"cow"}}],[11,"into_cow","collections::vec","",215,{"inputs":[{"name":"vec"}],"output":{"name":"cow"}}],[11,"into_inner","","Drops all items that have not yet been moved and returns the empty vector.",216,{"inputs":[{"name":"intoiter"}],"output":{"name":"vec"}}],[6,"Item","","",null,null],[11,"next","","",216,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",216,null],[11,"next_back","","",216,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",216,{"inputs":[{"name":"intoiter"}],"output":null}],[6,"Item","","",null,null],[11,"next","","",217,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",217,null],[11,"next_back","","",217,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"drop","","",217,{"inputs":[{"name":"drain"}],"output":null}],[6,"Target","","",null,null],[11,"deref","","",218,{"inputs":[{"name":"derefvec"}],"output":{"name":"vec"}}],[11,"drop","","",218,{"inputs":[{"name":"derefvec"}],"output":null}],[0,"vec_deque","collections","VecDeque is a double-ended queue, which is implemented with the help of a\ngrowing ring buffer.",null,null],[3,"VecDeque","collections::vec_deque","`VecDeque` is a growable ring buffer, which can be used as a\ndouble-ended queue efficiently.",null,null],[3,"Iter","","`VecDeque` iterator.",null,null],[3,"IterMut","","`VecDeque` mutable iterator.",null,null],[3,"IntoIter","","A by-value VecDeque iterator",null,null],[3,"Drain","","A draining VecDeque iterator",null,null],[11,"clone","","",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"drop","","",219,{"inputs":[{"name":"vecdeque"}],"output":null}],[11,"default","","",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"new","","Creates an empty `VecDeque`.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"vecdeque"}}],[11,"with_capacity","","Creates an empty `VecDeque` with space for at least `n` elements.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"vecdeque"}}],[11,"get","","Retrieves an element in the `VecDeque` by index.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"get_mut","","Retrieves an element in the `VecDeque` mutably by index.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap","","Swaps elements at indices `i` and `j`.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"},{"name":"usize"}],"output":null}],[11,"capacity","","Returns the number of elements the `VecDeque` can hold without\nreallocating.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"reserve_exact","","Reserves the minimum capacity for exactly `additional` more elements to be inserted in the\ngiven `VecDeque`. Does nothing if the capacity is already sufficient.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":null}],[11,"reserve","","Reserves capacity for at least `additional` more elements to be inserted in the given\n`Ringbuf`. The collection may reserve more space to avoid frequent reallocations.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":null}],[11,"shrink_to_fit","","Shrinks the capacity of the ringbuf as much as possible.",219,{"inputs":[{"name":"vecdeque"}],"output":null}],[11,"truncate","","Shortens a ringbuf, dropping excess elements from the back.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":null}],[11,"iter","","Returns a front-to-back iterator.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a front-to-back iterator that returns mutable references.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"itermut"}}],[11,"as_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",219,null],[11,"as_mut_slices","","Returns a pair of slices which contain, in order, the contents of the\n`VecDeque`.",219,null],[11,"len","","Returns the number of elements in the `VecDeque`.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the buffer contains no elements",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"drain","","Creates a draining iterator that clears the `VecDeque` and iterates over\nthe removed items from start to end.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"drain"}}],[11,"clear","","Clears the buffer, removing all values.",219,{"inputs":[{"name":"vecdeque"}],"output":null}],[11,"front","","Provides a reference to the front element, or `None` if the sequence is\nempty.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"front_mut","","Provides a mutable reference to the front element, or `None` if the\nsequence is empty.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back","","Provides a reference to the back element, or `None` if the sequence is\nempty.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"back_mut","","Provides a mutable reference to the back element, or `None` if the\nsequence is empty.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"pop_front","","Removes the first element and returns it, or `None` if the sequence is\nempty.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"push_front","","Inserts an element first in the sequence.",219,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":null}],[11,"push_back","","Appends an element to the back of a buffer",219,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":null}],[11,"pop_back","","Removes the last element from a buffer and returns it, or `None` if\nit is empty.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"swap_back_remove","","Removes an element from anywhere in the ringbuf and returns it, replacing it with the last\nelement.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"swap_front_remove","","Removes an element from anywhere in the ringbuf and returns it, replacing it with the first\nelement.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts an element at position `i` within the ringbuf. Whichever\nend is closer to the insertion point will be moved to make room,\nand all the affected elements will be moved to new positions.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"remove","","Removes and returns the element at position `i` from the ringbuf.\nWhichever end is closer to the removal point will be moved to make\nroom, and all the affected elements will be moved to new positions.\nReturns `None` if `i` is out of bounds.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"option"}}],[11,"split_off","","Splits the collection into two at the given index.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"self"}}],[11,"append","","Moves all the elements of `other` into `Self`, leaving `other` empty.",219,{"inputs":[{"name":"vecdeque"},{"name":"self"}],"output":null}],[11,"resize","","Modifies the ringbuf in-place so that `len()` is equal to new_len,\neither by removing excess elements or by appending copies of a value to the back.",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"},{"name":"t"}],"output":null}],[11,"clone","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",220,null],[11,"next_back","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"indexable","","",220,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",220,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",221,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",221,null],[11,"next_back","","",221,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",222,{"inputs":[{"name":"intoiter"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[11,"next","","",222,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",222,null],[11,"next_back","","",222,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"drop","","",223,{"inputs":[{"name":"drain"}],"output":null}],[6,"Item","","",null,null],[11,"next","","",223,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",223,null],[11,"next_back","","",223,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"eq","","",219,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",219,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"option"}}],[11,"cmp","","",219,{"inputs":[{"name":"vecdeque"},{"name":"vecdeque"}],"output":{"name":"ordering"}}],[11,"hash","","",219,{"inputs":[{"name":"vecdeque"},{"name":"h"}],"output":null}],[6,"Output","","",null,null],[11,"index","","",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"index_mut","","",219,{"inputs":[{"name":"vecdeque"},{"name":"usize"}],"output":{"name":"a"}}],[11,"from_iter","","",219,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":{"name":"vecdeque"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Consumes the list into a front-to-back iterator yielding elements by\nvalue.",219,{"inputs":[{"name":"vecdeque"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","","",219,{"inputs":[{"name":"vecdeque"},{"name":"t"}],"output":null}],[11,"fmt","","",219,{"inputs":[{"name":"vecdeque"},{"name":"formatter"}],"output":{"name":"result"}}],[0,"vec_map","collections","A simple map based on a vector for small integer keys. Space requirements\nare O(highest integer key).",null,null],[3,"VecMap","collections::vec_map","A map optimized for small integer keys.",null,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[3,"Iter","","An iterator over the key-value pairs of a map.",null,null],[3,"IterMut","","An iterator over the key-value pairs of a map, with the\nvalues being mutable.",null,null],[3,"Keys","","An iterator over the keys of a map.",null,null],[3,"Values","","An iterator over the values of a map.",null,null],[3,"IntoIter","","A consuming iterator over the key-value pairs of a map.",null,null],[3,"Drain","","",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",224,null],[13,"Occupied","","An occupied Entry",224,null],[11,"default","","",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone","","",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"clone_from","","",225,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":null}],[11,"hash","","",225,{"inputs":[{"name":"vecmap"},{"name":"h"}],"output":null}],[11,"new","","Creates an empty `VecMap`.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"vecmap"}}],[11,"with_capacity","","Creates an empty `VecMap` with space for at least `capacity`\nelements before resizing.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"vecmap"}}],[11,"capacity","","Returns the number of elements the `VecMap` can hold without\nreallocating.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"reserve_len","","Reserves capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long\nas all inserted keys are less than `len`.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":null}],[11,"reserve_len_exact","","Reserves the minimum capacity for the given `VecMap` to contain `len` distinct keys.\nIn the case of `VecMap` this means reallocations will not occur as long as all inserted\nkeys are less than `len`.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":null}],[11,"keys","","Returns an iterator visiting all keys in ascending order of the keys.\nThe iterator's element type is `usize`.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"keys"}}],[11,"values","","Returns an iterator visiting all values in ascending order of the keys.\nThe iterator's element type is `&'r V`.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"values"}}],[11,"iter","","Returns an iterator visiting all key-value pairs in ascending order of the keys.\nThe iterator's element type is `(usize, &'r V)`.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns an iterator visiting all key-value pairs in ascending order of the keys,\nwith mutable references to the values.\nThe iterator's element type is `(usize, &'r mut V)`.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"itermut"}}],[11,"append","","Moves all elements from `other` into the map while overwriting existing keys.",225,{"inputs":[{"name":"vecmap"},{"name":"self"}],"output":null}],[11,"split_off","","Splits the collection into two at the given key.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"self"}}],[11,"drain","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, emptying (but not consuming) the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`. Keeps the allocated memory for reuse.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"drain"}}],[11,"len","","Returns the number of elements in the map.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"usize"}}],[11,"is_empty","","Returns true if the map contains no elements.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"clear","","Clears the map, removing all key-value pairs.",225,{"inputs":[{"name":"vecmap"}],"output":null}],[11,"get","","Returns a reference to the value corresponding to the key.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"contains_key","","Returns true if the map contains a value for the specified key.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"bool"}}],[11,"get_mut","","Returns a mutable reference to the value corresponding to the key.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"insert","","Inserts a key-value pair into the map. If the key already had a value\npresent in the map, that value is returned. Otherwise, `None` is returned.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"},{"name":"v"}],"output":{"name":"option"}}],[11,"remove","","Removes a key from the map, returning the value at the key if the key\nwas previously in the map.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"option"}}],[11,"entry","","Gets the given key's corresponding entry in the map for in-place manipulation.",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"entry"}}],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",224,{"inputs":[{"name":"entry"}],"output":{"name":"result"}}],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",224,{"inputs":[{"name":"entry"},{"name":"v"}],"output":{"name":"v"}}],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",224,{"inputs":[{"name":"entry"},{"name":"f"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",226,{"inputs":[{"name":"vacantentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"get","","Gets a reference to the value in the entry.",227,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"get_mut","","Gets a mutable reference to the value in the entry.",227,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"into_mut","","Converts the entry into a mutable reference to its value.",227,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",227,{"inputs":[{"name":"occupiedentry"},{"name":"v"}],"output":{"name":"v"}}],[11,"remove","","Takes the value of the entry out of the map, and returns it.",227,{"inputs":[{"name":"occupiedentry"}],"output":{"name":"v"}}],[11,"eq","","",225,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",225,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"option"}}],[11,"cmp","","",225,{"inputs":[{"name":"vecmap"},{"name":"vecmap"}],"output":{"name":"ordering"}}],[11,"fmt","","",225,{"inputs":[{"name":"vecmap"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"from_iter","","",225,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":{"name":"vecmap"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","","Returns an iterator visiting all key-value pairs in ascending order of\nthe keys, consuming the original `VecMap`.\nThe iterator's element type is `(usize, &'r V)`.",225,{"inputs":[{"name":"vecmap"}],"output":{"name":"intoiter"}}],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"extend","","",225,{"inputs":[{"name":"vecmap"},{"name":"i"}],"output":null}],[6,"Output","","",null,null],[11,"index","","",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[6,"Output","","",null,null],[11,"index","","",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"index_mut","","",225,{"inputs":[{"name":"vecmap"},{"name":"usize"}],"output":{"name":"v"}}],[11,"clone","","",228,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","","",null,null],[11,"next","","",228,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",228,null],[11,"next_back","","",228,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",229,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",229,null],[11,"next_back","","",229,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",230,{"inputs":[{"name":"keys"}],"output":{"name":"keys"}}],[11,"clone","","",231,{"inputs":[{"name":"values"}],"output":{"name":"values"}}],[6,"Item","","",null,null],[11,"next","","",232,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[11,"size_hint","","",232,null],[11,"next_back","","",232,{"inputs":[{"name":"drain"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",230,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[11,"size_hint","","",230,null],[11,"next_back","","",230,{"inputs":[{"name":"keys"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",231,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[11,"size_hint","","",231,null],[11,"next_back","","",231,{"inputs":[{"name":"values"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",233,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",233,null],[11,"next_back","","",233,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[0,"bit_vec","collections","",null,null],[3,"Iter","collections::bit_vec","An iterator for `BitVec`.",null,null],[0,"bit_set","collections","",null,null],[3,"Union","collections::bit_set","",null,null],[3,"Intersection","","",null,null],[3,"Difference","","",null,null],[3,"SymmetricDifference","","",null,null],[3,"Iter","","An iterator for `BitSet`.",null,null],[0,"btree_map","collections","",null,null],[3,"BTreeMap","collections::btree_map","A map based on a B-Tree.",null,null],[3,"Iter","","An iterator over a BTreeMap's entries.",null,null],[3,"IterMut","","A mutable iterator over a BTreeMap's entries.",null,null],[3,"IntoIter","","An owning iterator over a BTreeMap's entries.",null,null],[3,"Keys","","An iterator over a BTreeMap's keys.",null,null],[3,"Values","","An iterator over a BTreeMap's values.",null,null],[3,"Range","","An iterator over a sub-range of BTreeMap's entries.",null,null],[3,"RangeMut","","A mutable iterator over a sub-range of BTreeMap's entries.",null,null],[3,"VacantEntry","","A vacant Entry.",null,null],[3,"OccupiedEntry","","An occupied Entry.",null,null],[4,"Entry","","A view into a single entry in a map, which may either be vacant or occupied.",null,null],[13,"Vacant","","A vacant Entry",234,null],[13,"Occupied","","An occupied Entry",234,null],[0,"btree_set","collections","",null,null],[3,"BTreeSet","collections::btree_set","A set based on a B-Tree.",null,null],[3,"Iter","","An iterator over a BTreeSet's items.",null,null],[3,"IntoIter","","An owning iterator over a BTreeSet's items.",null,null],[3,"Range","","An iterator over a sub-range of BTreeSet's items.",null,null],[3,"Difference","","A lazy iterator producing elements in the set difference (in-order).",null,null],[3,"SymmetricDifference","","A lazy iterator producing elements in the set symmetric difference (in-order).",null,null],[3,"Intersection","","A lazy iterator producing elements in the set intersection (in-order).",null,null],[3,"Union","","A lazy iterator producing elements in the set union (in-order).",null,null],[11,"eq","collections","",6,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"bound"},{"name":"bound"}],"output":{"name":"bool"}}],[11,"hash","","",6,null],[11,"fmt","","",6,{"inputs":[{"name":"bound"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",6,{"inputs":[{"name":"bound"}],"output":{"name":"bound"}}],[14,"vec!","","Creates a `Vec` containing the arguments.",null,null],[14,"format!","","Use the syntax described in `std::fmt` to create a value of type `String`.\nSee `std::fmt` for more information.",null,null],[15,"slice","","Utilities for slice manipulation",null,null],[15,"str","","Unicode string manipulation (the `str` type).",null,null],[11,"clone","collections::bit_vec","",235,null],[11,"next","","",235,null],[11,"size_hint","","",235,null],[11,"next_back","","",235,null],[11,"indexable","","",235,null],[11,"idx","","",235,null],[11,"clone","collections::bit_set","",236,null],[11,"clone","","",237,null],[11,"clone","","",238,null],[11,"clone","","",239,null],[11,"clone","","",240,null],[11,"next","","",236,null],[11,"size_hint","","",236,null],[11,"next","","",237,null],[11,"size_hint","","",237,null],[11,"next","","",238,null],[11,"size_hint","","",238,null],[11,"next","","",239,null],[11,"size_hint","","",239,null],[11,"next","","",240,null],[11,"size_hint","","",240,null],[11,"clone","collections::btree_map","",241,null],[11,"next","","",241,null],[11,"size_hint","","",241,null],[11,"next_back","","",241,null],[11,"next","","",242,null],[11,"size_hint","","",242,null],[11,"next_back","","",242,null],[11,"next","","",243,null],[11,"size_hint","","",243,null],[11,"next_back","","",243,null],[11,"clone","","",244,null],[11,"next","","",244,null],[11,"size_hint","","",244,null],[11,"next_back","","",244,null],[11,"clone","","",245,null],[11,"next","","",245,null],[11,"size_hint","","",245,null],[11,"next_back","","",245,null],[11,"clone","","",246,null],[11,"next","","",246,null],[11,"next_back","","",246,null],[11,"next","","",247,null],[11,"next_back","","",247,null],[11,"get","","Returns a mutable reference to the entry if occupied, or the VacantEntry if vacant",234,null],[11,"or_insert","","Ensures a value is in the entry by inserting the default if empty, and returns\na mutable reference to the value in the entry.",234,null],[11,"or_insert_with","","Ensures a value is in the entry by inserting the result of the default function if empty,\nand returns a mutable reference to the value in the entry.",234,null],[11,"insert","","Sets the value of the entry with the VacantEntry's key,\nand returns a mutable reference to it.",248,null],[11,"get","","Gets a reference to the value in the entry.",249,null],[11,"get_mut","","Gets a mutable reference to the value in the entry.",249,null],[11,"into_mut","","Converts the entry into a mutable reference to its value.",249,null],[11,"insert","","Sets the value of the entry with the OccupiedEntry's key,\nand returns the entry's old value.",249,null],[11,"remove","","Takes the value of the entry out of the map, and returns it.",249,null],[11,"clone","collections::btree_set","",250,null],[11,"next","","",250,null],[11,"size_hint","","",250,null],[11,"next_back","","",250,null],[11,"next","","",251,null],[11,"size_hint","","",251,null],[11,"next_back","","",251,null],[11,"clone","","",252,null],[11,"next","","",252,null],[11,"next_back","","",252,null],[11,"clone","","",253,null],[11,"next","","",253,null],[11,"clone","","",254,null],[11,"next","","",254,null],[11,"clone","","",255,null],[11,"next","","",255,null],[11,"clone","","",256,null],[11,"next","","",256,null],[11,"as_ref","collections","",257,null],[11,"as_mut","","",257,null],[11,"as_ref","","",258,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"index","","",257,null],[11,"index_mut","","",257,null],[11,"index","","",257,null],[11,"index","","",257,null],[11,"index","","",257,null],[11,"index","","",257,null],[11,"index_mut","","",257,null],[11,"index_mut","","",257,null],[11,"index_mut","","",257,null],[11,"index_mut","","",257,null],[11,"default","","",257,null],[11,"into_iter","","",257,null],[11,"into_iter","","",257,null],[11,"set_memory","","",257,null],[11,"eq","","",257,null],[11,"ne","","",257,null],[11,"cmp","","",257,null],[11,"partial_cmp","","",257,null],[11,"lt","","",257,null],[11,"le","","",257,null],[11,"ge","","",257,null],[11,"gt","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"as_unsigned","","",257,null],[11,"as_signed","","",257,null],[11,"as_unsigned_mut","","",257,null],[11,"as_signed_mut","","",257,null],[11,"into_searcher","","",258,null],[11,"into_searcher","","",257,null],[11,"is_contained_in","","",257,null],[11,"is_prefix_of","","",257,null],[11,"is_suffix_of","","",257,null],[11,"cmp","","",258,null],[11,"eq","","",258,null],[11,"ne","","",258,null],[11,"partial_cmp","","",258,null],[11,"index","","",258,null],[11,"index","","",258,null],[11,"index","","",258,null],[11,"index","","",258,null],[11,"as_ref","","",258,null],[11,"default","","",258,null],[11,"hash","","",258,null],[11,"hash","","",257,null],[11,"fmt","","",258,null],[11,"fmt","","",258,null],[11,"fmt","","",257,null],[11,"sort_by","","Sorts the slice, in place, using `compare` to compare\nelements.",257,null],[11,"move_from","","Consumes `src` and moves as many elements as it can into `self`\nfrom the range [start,end).",257,null],[11,"split_at","","Divides one slice into two at an index.",257,null],[11,"iter","","Returns an iterator over the slice.",257,null],[11,"split","","Returns an iterator over subslices separated by elements that match\n`pred`.  The matched element is not contained in the subslices.",257,null],[11,"splitn","","Returns an iterator over subslices separated by elements that match\n`pred`, limited to returning at most `n` items.  The matched element is\nnot contained in the subslices.",257,null],[11,"rsplitn","","Returns an iterator over subslices separated by elements that match\n`pred` limited to returning at most `n` items. This starts at the end of\nthe slice and works backwards.  The matched element is not contained in\nthe subslices.",257,null],[11,"windows","","Returns an iterator over all contiguous windows of length\n`size`. The windows overlap. If the slice is shorter than\n`size`, the iterator returns no values.",257,null],[11,"chunks","","Returns an iterator over `size` elements of the slice at a\ntime. The chunks do not overlap. If `size` does not divide the\nlength of the slice, then the last chunk will not have length\n`size`.",257,null],[11,"get","","Returns the element of a slice at the given index, or `None` if the\nindex is out of bounds.",257,null],[11,"first","","Returns the first element of a slice, or `None` if it is empty.",257,null],[11,"tail","","Returns all but the first element of a slice.",257,null],[11,"init","","Returns all but the last element of a slice.",257,null],[11,"last","","Returns the last element of a slice, or `None` if it is empty.",257,null],[11,"get_unchecked","","Returns a pointer to the element at the given index, without doing\nbounds checking.",257,null],[11,"as_ptr","","Returns an unsafe pointer to the slice's buffer",257,null],[11,"binary_search_by","","Binary search a sorted slice with a comparator function.",257,null],[11,"len","","Returns the number of elements in the slice.",257,null],[11,"is_empty","","Returns true if the slice has a length of 0",257,null],[11,"get_mut","","Returns a mutable reference to the element at the given index,\nor `None` if the index is out of bounds",257,null],[11,"iter_mut","","Returns an iterator that allows modifying each value",257,null],[11,"first_mut","","Returns a mutable pointer to the first element of a slice, or `None` if it is empty",257,null],[11,"tail_mut","","Returns all but the first element of a mutable slice",257,null],[11,"init_mut","","Returns all but the last element of a mutable slice",257,null],[11,"last_mut","","Returns a mutable pointer to the last item in the slice.",257,null],[11,"split_mut","","Returns an iterator over mutable subslices separated by elements that\nmatch `pred`.  The matched element is not contained in the subslices.",257,null],[11,"splitn_mut","","Returns an iterator over subslices separated by elements that match\n`pred`, limited to returning at most `n` items.  The matched element is\nnot contained in the subslices.",257,null],[11,"rsplitn_mut","","Returns an iterator over subslices separated by elements that match\n`pred` limited to returning at most `n` items. This starts at the end of\nthe slice and works backwards.  The matched element is not contained in\nthe subslices.",257,null],[11,"chunks_mut","","Returns an iterator over `chunk_size` elements of the slice at a time.\nThe chunks are mutable and do not overlap. If `chunk_size` does\nnot divide the length of the slice, then the last chunk will not\nhave length `chunk_size`.",257,null],[11,"swap","","Swaps two elements in a slice.",257,null],[11,"split_at_mut","","Divides one `&mut` into two at an index.",257,null],[11,"reverse","","Reverse the order of elements in a slice, in place.",257,null],[11,"get_unchecked_mut","","Returns an unsafe mutable pointer to the element in index",257,null],[11,"as_mut_ptr","","Returns an unsafe mutable pointer to the slice's buffer.",257,null],[11,"to_vec","","Copies `self` into a new `Vec`.",257,null],[11,"permutations","","Creates an iterator that yields every possible permutation of the\nvector in succession.",257,null],[11,"clone_from_slice","","Copies as many elements from `src` as it can into `self` (the\nshorter of `self.len()` and `src.len()`). Returns the number\nof elements copied.",257,null],[11,"sort","","Sorts the slice, in place.",257,null],[11,"binary_search","","Binary search a sorted slice for a given element.",257,null],[11,"next_permutation","","Mutates the slice to the next lexicographic permutation.",257,null],[11,"prev_permutation","","Mutates the slice to the previous lexicographic permutation.",257,null],[11,"position_elem","","Find the first index containing a matching value.",257,null],[11,"rposition_elem","","Find the last index containing a matching value.",257,null],[11,"contains","","Returns true if the slice contains an element with the given value.",257,null],[11,"starts_with","","Returns true if `needle` is a prefix of the slice.",257,null],[11,"ends_with","","Returns true if `needle` is a suffix of the slice.",257,null],[11,"into_vec","","Converts `self` into a vector without clones or allocation.",257,null],[11,"concat","","",257,null],[11,"connect","","",257,null],[11,"borrow","collections::vec","",215,null],[11,"borrow_mut","","",215,null],[11,"to_owned","collections","",257,null],[11,"graphemes","","",258,null],[11,"grapheme_indices","","",258,null],[11,"words","","",258,null],[11,"is_whitespace","","",258,null],[11,"is_alphanumeric","","",258,null],[11,"width","","",258,null],[11,"trim","","",258,null],[11,"trim_left","","",258,null],[11,"trim_right","","",258,null],[11,"concat","","",257,null],[11,"connect","","",257,null],[11,"borrow","collections::string","",210,null],[11,"to_owned","collections","",258,null],[11,"escape_default","","Escapes each char in `s` with `char::escape_default`.",258,null],[11,"escape_unicode","","Escapes each char in `s` with `char::escape_unicode`.",258,null],[11,"replace","","Replaces all occurrences of one string with another.",258,null],[11,"nfd_chars","","Returns an iterator over the string in Unicode Normalization Form D\n(canonical decomposition).",258,null],[11,"nfkd_chars","","Returns an iterator over the string in Unicode Normalization Form KD\n(compatibility decomposition).",258,null],[11,"nfc_chars","","An Iterator over the string in Unicode Normalization Form C\n(canonical decomposition followed by canonical composition).",258,null],[11,"nfkc_chars","","An Iterator over the string in Unicode Normalization Form KC\n(compatibility decomposition followed by canonical composition).",258,null],[11,"contains","","Returns `true` if `self` contains another `&str`.",258,null],[11,"chars","","An iterator over the codepoints of `self`.",258,null],[11,"bytes","","An iterator over the bytes of `self`.",258,null],[11,"char_indices","","An iterator over the characters of `self` and their byte offsets.",258,null],[11,"split","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern.",258,null],[11,"rsplit","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern and yielded in reverse order.",258,null],[11,"split_terminator","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern.",258,null],[11,"rsplit_terminator","","An iterator over substrings of `self`, separated by characters\nmatched by a pattern and yielded in reverse order.",258,null],[11,"splitn","","An iterator over substrings of `self`, separated by a pattern,\nrestricted to returning\nat most `count` items.",258,null],[11,"rsplitn","","An iterator over substrings of `self`, separated by a pattern,\nstarting from the end of the string, restricted to returning\nat most `count` items.",258,null],[11,"matches","","An iterator over the matches of a pattern within `self`.",258,null],[11,"rmatches","","An iterator over the matches of a pattern within `self`, yielded in\nreverse order.",258,null],[11,"match_indices","","An iterator over the start and end indices of the disjoint matches\nof a pattern within `self`.",258,null],[11,"rmatch_indices","","An iterator over the start and end indices of the disjoint matches of\na pattern within\n`self`, yielded in reverse order.",258,null],[11,"lines","","An iterator over the lines of a string, separated by `\\n`.",258,null],[11,"lines_any","","An iterator over the lines of a string, separated by either\n`\\n` or `\\r\\n`.",258,null],[11,"slice_chars","","Returns a slice of the string from the character range [`begin`..`end`).",258,null],[11,"slice_unchecked","","Takes a bytewise slice from a string.",258,null],[11,"starts_with","","Returns `true` if the given `&str` is a prefix of the string.",258,null],[11,"ends_with","","Returns true if the given `&str` is a suffix of the string.",258,null],[11,"trim_matches","","Returns a string with all pre- and suffixes that match a pattern\nrepeatedly removed.",258,null],[11,"trim_left_matches","","Returns a string with all prefixes that match a pattern\nrepeatedly removed.",258,null],[11,"trim_right_matches","","Returns a string with all suffixes that match a pattern\nrepeatedly removed.",258,null],[11,"is_char_boundary","","Checks that `index`-th byte lies at the start and/or end of a\nUTF-8 code point sequence.",258,null],[11,"char_range_at","","Given a byte position, return the next char and its index.",258,null],[11,"char_range_at_reverse","","Given a byte position, return the previous `char` and its position.",258,null],[11,"char_at","","Given a byte position, return the `char` at that position.",258,null],[11,"char_at_reverse","","Given a byte position, return the `char` at that position, counting\nfrom the end.",258,null],[11,"as_bytes","","Converts `self` to a byte slice.",258,null],[11,"find","","Returns the byte index of the first character of `self` that matches\nthe pattern, if it\nexists.",258,null],[11,"rfind","","Returns the byte index of the last character of `self` that\nmatches the pattern, if it\nexists.",258,null],[11,"slice_shift_char","","Retrieves the first character from a `&str` and returns it.",258,null],[11,"subslice_offset","","Returns the byte offset of an inner slice relative to an enclosing\nouter slice.",258,null],[11,"as_ptr","","Returns an unsafe pointer to the `&str`'s buffer.",258,null],[11,"utf16_units","","Returns an iterator of `u16` over the string encoded as UTF-16.",258,null],[11,"len","","Returns the length of `self` in bytes.",258,null],[11,"is_empty","","Returns true if this slice has a length of zero bytes.",258,null],[11,"parse","","Parses `self` into the specified type.",258,null],[11,"graphemes","","Returns an iterator over the [grapheme clusters][graphemes] of `self`.",258,null],[11,"grapheme_indices","","Returns an iterator over the grapheme clusters of `self` and their\nbyte offsets. See\n`graphemes()` for more information.",258,null],[11,"words","","An iterator over the non-empty words of `self`.",258,null],[11,"width","","Returns a string's displayed width in columns.",258,null],[11,"trim","","Returns a `&str` with leading and trailing whitespace removed.",258,null],[11,"trim_left","","Returns a `&str` with leading whitespace removed.",258,null],[11,"trim_right","","Returns a `&str` with trailing whitespace removed.",258,null],[11,"to_lowercase","","Returns the lowercase equivalent of this string.",258,null],[11,"to_uppercase","","Returns the uppercase equivalent of this string.",258,null],[11,"eq","","",258,null],[11,"ne","","",258,null],[11,"eq","","",258,null],[11,"ne","","",258,null],[11,"eq","","",258,null],[11,"ne","","",258,null],[11,"eq","","",258,null],[11,"ne","","",258,null],[11,"into_cow","","",258,null],[11,"into_cow","","",257,null]],"paths":[[3,"Box"],[3,"Weak"],[3,"Arc"],[3,"Rc"],[3,"Weak"],[8,"FnBox"],[4,"Bound"],[3,"BinaryHeap"],[3,"Iter"],[3,"IntoIter"],[3,"Drain"],[3,"BitVec"],[3,"BitSet"],[3,"BTreeMap"],[3,"BTreeSet"],[4,"Cow"],[8,"Borrow"],[8,"BorrowMut"],[8,"ToOwned"],[8,"IntoCow"],[8,"CLike"],[3,"EnumSet"],[3,"Iter"],[3,"Formatter"],[3,"Wrapping"],[4,"FpCategory"],[3,"ParseIntError"],[4,"IntErrorKind"],[3,"ParseFloatError"],[4,"FloatErrorKind"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"Managed"],[3,"PhantomData"],[3,"RangeFull"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[4,"Ordering"],[8,"Any"],[3,"TypeId"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[4,"Ordering"],[3,"AtomicPtr"],[3,"Cell"],[4,"BorrowState"],[3,"RefCell"],[3,"BorrowRef"],[3,"Ref"],[3,"BorrowRefMut"],[3,"RefMut"],[3,"UnsafeCell"],[3,"EscapeUnicode"],[4,"EscapeUnicodeState"],[3,"EscapeDefault"],[4,"EscapeDefaultState"],[3,"Rev"],[4,"MinMaxResult"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"Scan"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"Unfold"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[4,"Option"],[3,"Item"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"GenericSplitN"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[4,"SearchStep"],[3,"CharEqSearcher"],[3,"CharEqPattern"],[3,"StrSearcher"],[4,"State"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"BytesDeref"],[3,"SplitInternal"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitNInternal"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndicesInternal"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"MatchesInternal"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"LinesAnyMap"],[3,"TwoWaySearcher"],[4,"OldSearcher"],[3,"OldMatchIndices"],[3,"CharRange"],[3,"SipHasher"],[3,"Binary"],[3,"Octal"],[3,"Decimal"],[3,"LowerHex"],[3,"UpperHex"],[3,"Radix"],[3,"RadixFmt"],[3,"PadAdapter"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugInner"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[3,"Error"],[4,"FlagV1"],[3,"Arguments"],[8,"Write"],[8,"Octal"],[8,"Binary"],[8,"Display"],[8,"Debug"],[8,"LowerHex"],[8,"UpperHex"],[8,"Pointer"],[8,"LowerExp"],[8,"UpperExp"],[3,"Iter"],[3,"IntoIter"],[3,"LinkedList"],[3,"IterMut"],[8,"IntSliceExt"],[8,"MutableByteVector"],[8,"SliceConcatExt"],[3,"ElementSwaps"],[3,"Permutations"],[8,"FromStr"],[4,"GraphemeCat"],[3,"GraphemeIndices"],[3,"Graphemes"],[4,"GraphemeState"],[3,"Utf16Items"],[4,"Utf16Item"],[3,"Utf16Encoder"],[3,"Words"],[3,"ToLowercase"],[3,"ToUppercase"],[8,"Pattern"],[8,"Searcher"],[8,"ReverseSearcher"],[3,"Decompositions"],[3,"Recompositions"],[3,"Utf16Units"],[8,"ToString"],[3,"String"],[3,"FromUtf8Error"],[3,"FromUtf16Error"],[3,"DerefString"],[3,"ParseError"],[3,"Vec"],[3,"IntoIter"],[3,"Drain"],[3,"DerefVec"],[3,"VecDeque"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Drain"],[4,"Entry"],[3,"VecMap"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"Iter"],[3,"IterMut"],[3,"Keys"],[3,"Values"],[3,"Drain"],[3,"IntoIter"],[4,"Entry"],[3,"Iter"],[3,"Iter"],[3,"Union"],[3,"Intersection"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Keys"],[3,"Values"],[3,"Range"],[3,"RangeMut"],[3,"VacantEntry"],[3,"OccupiedEntry"],[3,"Iter"],[3,"IntoIter"],[3,"Range"],[3,"Difference"],[3,"SymmetricDifference"],[3,"Intersection"],[3,"Union"],[15,"slice"],[15,"str"]]};
searchIndex['unicode'] = {"items":[[0,"","unicode","# The Unicode Library",null,null],[0,"char","","Character manipulation (`char` type, Unicode Scalar Value)",null,null],[17,"MAX","unicode::char","The highest valid code point",null,null],[5,"from_u32","","Converts a `u32` to an `Option<char>`.",null,{"inputs":[{"name":"u32"}],"output":{"name":"option"}}],[5,"from_digit","","Converts a number to the character representing it.",null,{"inputs":[{"name":"u32"},{"name":"u32"}],"output":{"name":"option"}}],[11,"fmt","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"cmp","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"option"}}],[11,"lt","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"le","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"gt","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ge","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"eq","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[11,"ne","","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"bool"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shl","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"shr","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"usize"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"add","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"sub","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"mul","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"not","core::num","",0,{"inputs":[{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitxor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitor","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[6,"Output","unicode::char","",null,null],[11,"bitand","core::num","",0,{"inputs":[{"name":"wrapping"},{"name":"wrapping"}],"output":{"name":"wrapping"}}],[11,"fmt","","",1,{"inputs":[{"name":"fpcategory"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",1,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"fpcategory"},{"name":"fpcategory"}],"output":{"name":"bool"}}],[11,"clone","","",1,{"inputs":[{"name":"fpcategory"}],"output":{"name":"fpcategory"}}],[6,"Err","unicode::char","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[6,"Err","","",null,null],[11,"eq","core::num","",2,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"ne","","",2,{"inputs":[{"name":"parseinterror"},{"name":"parseinterror"}],"output":{"name":"bool"}}],[11,"clone","","",2,{"inputs":[{"name":"parseinterror"}],"output":{"name":"parseinterror"}}],[11,"fmt","","",2,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",3,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",3,{"inputs":[{"name":"interrorkind"},{"name":"interrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",3,{"inputs":[{"name":"interrorkind"}],"output":{"name":"interrorkind"}}],[11,"fmt","","",3,{"inputs":[{"name":"interrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",2,{"inputs":[{"name":"parseinterror"}],"output":{"name":"str"}}],[11,"fmt","","",2,{"inputs":[{"name":"parseinterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",4,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"ne","","",4,{"inputs":[{"name":"parsefloaterror"},{"name":"parsefloaterror"}],"output":{"name":"bool"}}],[11,"clone","","",4,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"parsefloaterror"}}],[11,"fmt","","",4,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",5,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"ne","","",5,{"inputs":[{"name":"floaterrorkind"},{"name":"floaterrorkind"}],"output":{"name":"bool"}}],[11,"clone","","",5,{"inputs":[{"name":"floaterrorkind"}],"output":{"name":"floaterrorkind"}}],[11,"fmt","","",5,{"inputs":[{"name":"floaterrorkind"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"description","","",4,{"inputs":[{"name":"parsefloaterror"}],"output":{"name":"str"}}],[11,"fmt","","",4,{"inputs":[{"name":"parsefloaterror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"hash","core::nonzero","",6,null],[11,"fmt","","",6,{"inputs":[{"name":"nonzero"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"partial_cmp","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"option"}}],[11,"lt","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"le","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"gt","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ge","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"cmp","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"ordering"}}],[11,"eq","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"ne","","",6,{"inputs":[{"name":"nonzero"},{"name":"nonzero"}],"output":{"name":"bool"}}],[11,"clone","","",6,{"inputs":[{"name":"nonzero"}],"output":{"name":"nonzero"}}],[11,"new","","Creates an instance of NonZero with the provided value.\nYou must indeed ensure that the value is actually \"non-zero\".",6,{"inputs":[{"name":"nonzero"},{"name":"t"}],"output":{"name":"nonzero"}}],[6,"Target","unicode::char","",null,null],[11,"deref","core::nonzero","",6,{"inputs":[{"name":"nonzero"}],"output":{"name":"t"}}],[11,"new","core::ptr","Creates a new `Unique`.",7,null],[11,"get","","Dereferences the content.",7,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[11,"get_mut","","Mutably dereferences the content.",7,{"inputs":[{"name":"unique"}],"output":{"name":"t"}}],[6,"Target","unicode::char","",null,null],[11,"deref","core::ptr","",7,null],[11,"fmt","","",7,{"inputs":[{"name":"unique"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","core::marker","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"option"}}],[11,"lt","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"le","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"gt","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ge","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"eq","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"ne","","",8,{"inputs":[{"name":"nocopy"},{"name":"nocopy"}],"output":{"name":"bool"}}],[11,"clone","","",8,{"inputs":[{"name":"nocopy"}],"output":{"name":"nocopy"}}],[11,"cmp","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"option"}}],[11,"lt","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"le","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"gt","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ge","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"eq","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"ne","","",9,{"inputs":[{"name":"managed"},{"name":"managed"}],"output":{"name":"bool"}}],[11,"clone","","",9,{"inputs":[{"name":"managed"}],"output":{"name":"managed"}}],[11,"hash","","",10,null],[11,"eq","","",10,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",10,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"option"}}],[11,"cmp","","",10,{"inputs":[{"name":"phantomdata"},{"name":"phantomdata"}],"output":{"name":"ordering"}}],[11,"clone","","",10,{"inputs":[{"name":"phantomdata"}],"output":{"name":"phantomdata"}}],[6,"Output","unicode::char","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"eq","core::ops","",11,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"ne","","",11,{"inputs":[{"name":"rangefull"},{"name":"rangefull"}],"output":{"name":"bool"}}],[11,"clone","","",11,{"inputs":[{"name":"rangefull"}],"output":{"name":"rangefull"}}],[11,"fmt","","",11,{"inputs":[{"name":"rangefull"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",12,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"ne","","",12,{"inputs":[{"name":"range"},{"name":"range"}],"output":{"name":"bool"}}],[11,"clone","","",12,{"inputs":[{"name":"range"}],"output":{"name":"range"}}],[11,"fmt","","",12,{"inputs":[{"name":"range"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",13,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"ne","","",13,{"inputs":[{"name":"rangefrom"},{"name":"rangefrom"}],"output":{"name":"bool"}}],[11,"clone","","",13,{"inputs":[{"name":"rangefrom"}],"output":{"name":"rangefrom"}}],[11,"fmt","","",13,{"inputs":[{"name":"rangefrom"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",14,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"ne","","",14,{"inputs":[{"name":"rangeto"},{"name":"rangeto"}],"output":{"name":"bool"}}],[11,"clone","","",14,{"inputs":[{"name":"rangeto"}],"output":{"name":"rangeto"}}],[11,"fmt","","",14,{"inputs":[{"name":"rangeto"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","unicode::char","",null,null],[6,"Target","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"fmt","core::cmp","",15,{"inputs":[{"name":"ordering"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",15,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"ne","","",15,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"clone","","",15,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"reverse","","Reverse the `Ordering`.",15,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"cmp","","",15,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",15,{"inputs":[{"name":"ordering"},{"name":"ordering"}],"output":{"name":"option"}}],[11,"fmt","unicode","",16,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",16,{"inputs":[{"name":"any"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"is","","Returns true if the boxed type is the same as `T`",16,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Returns some reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",16,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Returns some mutable reference to the boxed value if it is of type `T`, or\n`None` if it isn't.",16,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"is","","Forwards to the method defined on the type `Any`.",16,{"inputs":[{"name":"any"}],"output":{"name":"bool"}}],[11,"downcast_ref","","Forwards to the method defined on the type `Any`.",16,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"downcast_mut","","Forwards to the method defined on the type `Any`.",16,{"inputs":[{"name":"any"}],"output":{"name":"option"}}],[11,"hash","core::any","",17,null],[11,"fmt","","",17,{"inputs":[{"name":"typeid"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",17,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"ne","","",17,{"inputs":[{"name":"typeid"},{"name":"typeid"}],"output":{"name":"bool"}}],[11,"clone","","",17,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[11,"of","","Returns the `TypeId` of the type this generic function has been\ninstantiated with",17,{"inputs":[{"name":"typeid"}],"output":{"name":"typeid"}}],[6,"Item","unicode::char","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"default","core::atomic","",18,{"inputs":[{"name":"atomicbool"}],"output":{"name":"atomicbool"}}],[11,"default","","",19,{"inputs":[{"name":"atomicisize"}],"output":{"name":"atomicisize"}}],[11,"default","","",20,{"inputs":[{"name":"atomicusize"}],"output":{"name":"atomicusize"}}],[11,"clone","","",21,{"inputs":[{"name":"ordering"}],"output":{"name":"ordering"}}],[11,"new","","Creates a new `AtomicBool`.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"}],"output":{"name":"atomicbool"}}],[11,"load","","Loads a value from the bool.",18,{"inputs":[{"name":"atomicbool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"store","","Stores a value into the bool.",18,null],[11,"swap","","Stores a value into the bool, returning the old value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"compare_and_swap","","Stores a value into the bool if the current value is the same as the expected value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_and","","Logical \"and\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_nand","","Logical \"nand\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_or","","Logical \"or\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"fetch_xor","","Logical \"xor\" with a boolean value.",18,{"inputs":[{"name":"atomicbool"},{"name":"bool"},{"name":"ordering"}],"output":{"name":"bool"}}],[11,"new","","Creates a new `AtomicIsize`.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"}],"output":{"name":"atomicisize"}}],[11,"load","","Loads a value from the isize.",19,{"inputs":[{"name":"atomicisize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"store","","Stores a value into the isize.",19,null],[11,"swap","","Stores a value into the isize, returning the old value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"compare_and_swap","","Stores a value into the isize if the current value is the same as the expected value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_add","","Add an isize to the current value, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_sub","","Subtract an isize from the current value, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_and","","Bitwise and with the current isize, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_or","","Bitwise or with the current isize, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"fetch_xor","","Bitwise xor with the current isize, returning the previous value.",19,{"inputs":[{"name":"atomicisize"},{"name":"isize"},{"name":"ordering"}],"output":{"name":"isize"}}],[11,"new","","Creates a new `AtomicUsize`.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"}],"output":{"name":"atomicusize"}}],[11,"load","","Loads a value from the usize.",20,{"inputs":[{"name":"atomicusize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"store","","Stores a value into the usize.",20,null],[11,"swap","","Stores a value into the usize, returning the old value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"compare_and_swap","","Stores a value into the usize if the current value is the same as the expected value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_add","","Add to the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_sub","","Subtract from the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_and","","Bitwise and with the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_or","","Bitwise or with the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"fetch_xor","","Bitwise xor with the current usize, returning the previous value.",20,{"inputs":[{"name":"atomicusize"},{"name":"usize"},{"name":"ordering"}],"output":{"name":"usize"}}],[11,"new","","Creates a new `AtomicPtr`.",22,null],[11,"load","","Loads a value from the pointer.",22,null],[11,"store","","Stores a value into the pointer.",22,null],[11,"swap","","Stores a value into the pointer, returning the old value.",22,null],[11,"compare_and_swap","","Stores a value into the pointer if the current value is the same as the expected value.",22,null],[11,"new","core::cell","Creates a new `Cell` containing the given value.",23,{"inputs":[{"name":"cell"},{"name":"t"}],"output":{"name":"cell"}}],[11,"get","","Returns a copy of the contained value.",23,{"inputs":[{"name":"cell"}],"output":{"name":"t"}}],[11,"set","","Sets the contained value.",23,null],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",23,{"inputs":[{"name":"cell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",23,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"default","","",23,{"inputs":[{"name":"cell"}],"output":{"name":"cell"}}],[11,"eq","","",23,{"inputs":[{"name":"cell"},{"name":"cell"}],"output":{"name":"bool"}}],[11,"fmt","","",24,{"inputs":[{"name":"borrowstate"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",24,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"ne","","",24,{"inputs":[{"name":"borrowstate"},{"name":"borrowstate"}],"output":{"name":"bool"}}],[11,"clone","","",24,{"inputs":[{"name":"borrowstate"}],"output":{"name":"borrowstate"}}],[11,"new","","Creates a new `RefCell` containing `value`.",25,{"inputs":[{"name":"refcell"},{"name":"t"}],"output":{"name":"refcell"}}],[11,"into_inner","","Consumes the `RefCell`, returning the wrapped value.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"t"}}],[11,"borrow_state","","Query the current state of this `RefCell`",25,{"inputs":[{"name":"refcell"}],"output":{"name":"borrowstate"}}],[11,"borrow","","Immutably borrows the wrapped value.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"ref"}}],[11,"borrow_mut","","Mutably borrows the wrapped value.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"refmut"}}],[11,"as_unsafe_cell","","Gets a reference to the underlying `UnsafeCell`.",25,{"inputs":[{"name":"refcell"}],"output":{"name":"unsafecell"}}],[11,"clone","","",25,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"default","","",25,{"inputs":[{"name":"refcell"}],"output":{"name":"refcell"}}],[11,"eq","","",25,{"inputs":[{"name":"refcell"},{"name":"refcell"}],"output":{"name":"bool"}}],[11,"drop","","",26,null],[11,"clone","","",26,{"inputs":[{"name":"borrowref"}],"output":{"name":"borrowref"}}],[6,"Target","unicode::char","",null,null],[11,"deref","core::cell","",27,{"inputs":[{"name":"ref"}],"output":{"name":"t"}}],[11,"drop","","",28,null],[6,"Target","unicode::char","",null,null],[11,"deref","core::cell","",29,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"deref_mut","","",29,{"inputs":[{"name":"refmut"}],"output":{"name":"t"}}],[11,"new","","Constructs a new instance of `UnsafeCell` which will wrap the specified\nvalue.",30,{"inputs":[{"name":"unsafecell"},{"name":"t"}],"output":{"name":"unsafecell"}}],[11,"get","","Gets a mutable pointer to the wrapped value.",30,null],[11,"into_inner","","Unwraps the value.",30,{"inputs":[{"name":"unsafecell"}],"output":{"name":"t"}}],[11,"clone","core::char","",31,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"escapeunicode"}}],[11,"clone","","",32,{"inputs":[{"name":"escapeunicodestate"}],"output":{"name":"escapeunicodestate"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::char","",31,{"inputs":[{"name":"escapeunicode"}],"output":{"name":"option"}}],[11,"clone","","",33,{"inputs":[{"name":"escapedefault"}],"output":{"name":"escapedefault"}}],[11,"clone","","",34,{"inputs":[{"name":"escapedefaultstate"}],"output":{"name":"escapedefaultstate"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::char","",33,{"inputs":[{"name":"escapedefault"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"clone","core::iter","",35,{"inputs":[{"name":"rev"}],"output":{"name":"rev"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",35,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"size_hint","","",35,null],[11,"next_back","","",35,{"inputs":[{"name":"rev"}],"output":{"name":"option"}}],[11,"indexable","","",35,{"inputs":[{"name":"rev"}],"output":{"name":"usize"}}],[11,"idx","","",35,{"inputs":[{"name":"rev"},{"name":"usize"}],"output":{"name":"option"}}],[11,"fmt","","",36,{"inputs":[{"name":"minmaxresult"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",36,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"ne","","",36,{"inputs":[{"name":"minmaxresult"},{"name":"minmaxresult"}],"output":{"name":"bool"}}],[11,"clone","","",36,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"minmaxresult"}}],[11,"into_option","","`into_option` creates an `Option` of type `(T,T)`. The returned `Option`\nhas variant `None` if and only if the `MinMaxResult` has variant\n`NoElements`. Otherwise variant `Some(x,y)` is returned where `x <= y`.\nIf `MinMaxResult` has variant `OneElement(x)`, performing this operation\nwill make one clone of `x`.",36,{"inputs":[{"name":"minmaxresult"}],"output":{"name":"option"}}],[11,"clone","","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"cloned"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"size_hint","","",37,null],[11,"next_back","","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"option"}}],[11,"indexable","","",37,{"inputs":[{"name":"cloned"}],"output":{"name":"usize"}}],[11,"idx","","",37,{"inputs":[{"name":"cloned"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",38,{"inputs":[{"name":"cycle"}],"output":{"name":"cycle"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",38,{"inputs":[{"name":"cycle"}],"output":{"name":"option"}}],[11,"size_hint","","",38,null],[11,"indexable","","",38,{"inputs":[{"name":"cycle"}],"output":{"name":"usize"}}],[11,"idx","","",38,{"inputs":[{"name":"cycle"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",39,{"inputs":[{"name":"chain"}],"output":{"name":"chain"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",39,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"size_hint","","",39,null],[11,"next_back","","",39,{"inputs":[{"name":"chain"}],"output":{"name":"option"}}],[11,"indexable","","",39,{"inputs":[{"name":"chain"}],"output":{"name":"usize"}}],[11,"idx","","",39,{"inputs":[{"name":"chain"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",40,{"inputs":[{"name":"zip"}],"output":{"name":"zip"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",40,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"size_hint","","",40,null],[11,"next_back","","",40,{"inputs":[{"name":"zip"}],"output":{"name":"option"}}],[11,"indexable","","",40,{"inputs":[{"name":"zip"}],"output":{"name":"usize"}}],[11,"idx","","",40,{"inputs":[{"name":"zip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",41,{"inputs":[{"name":"map"}],"output":{"name":"map"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",41,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"size_hint","","",41,null],[11,"next_back","","",41,{"inputs":[{"name":"map"}],"output":{"name":"option"}}],[11,"indexable","","",41,{"inputs":[{"name":"map"}],"output":{"name":"usize"}}],[11,"idx","","",41,{"inputs":[{"name":"map"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",42,{"inputs":[{"name":"filter"}],"output":{"name":"filter"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",42,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"size_hint","","",42,null],[11,"next_back","","",42,{"inputs":[{"name":"filter"}],"output":{"name":"option"}}],[11,"clone","","",43,{"inputs":[{"name":"filtermap"}],"output":{"name":"filtermap"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",43,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"size_hint","","",43,null],[11,"next_back","","",43,{"inputs":[{"name":"filtermap"}],"output":{"name":"option"}}],[11,"clone","","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"enumerate"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"size_hint","","",44,null],[11,"next_back","","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"option"}}],[11,"indexable","","",44,{"inputs":[{"name":"enumerate"}],"output":{"name":"usize"}}],[11,"idx","","",44,{"inputs":[{"name":"enumerate"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",45,{"inputs":[{"name":"peekable"}],"output":{"name":"peekable"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",45,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"size_hint","","",45,null],[11,"peek","","Returns a reference to the next element of the iterator with out\nadvancing it, or None if the iterator is exhausted.",45,{"inputs":[{"name":"peekable"}],"output":{"name":"option"}}],[11,"is_empty","","Checks whether peekable iterator is empty or not.",45,{"inputs":[{"name":"peekable"}],"output":{"name":"bool"}}],[11,"clone","","",46,{"inputs":[{"name":"skipwhile"}],"output":{"name":"skipwhile"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",46,{"inputs":[{"name":"skipwhile"}],"output":{"name":"option"}}],[11,"size_hint","","",46,null],[11,"clone","","",47,{"inputs":[{"name":"takewhile"}],"output":{"name":"takewhile"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",47,{"inputs":[{"name":"takewhile"}],"output":{"name":"option"}}],[11,"size_hint","","",47,null],[11,"clone","","",48,{"inputs":[{"name":"skip"}],"output":{"name":"skip"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",48,{"inputs":[{"name":"skip"}],"output":{"name":"option"}}],[11,"size_hint","","",48,null],[11,"indexable","","",48,{"inputs":[{"name":"skip"}],"output":{"name":"usize"}}],[11,"idx","","",48,{"inputs":[{"name":"skip"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",49,{"inputs":[{"name":"take"}],"output":{"name":"take"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",49,{"inputs":[{"name":"take"}],"output":{"name":"option"}}],[11,"size_hint","","",49,null],[11,"indexable","","",49,{"inputs":[{"name":"take"}],"output":{"name":"usize"}}],[11,"idx","","",49,{"inputs":[{"name":"take"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",50,{"inputs":[{"name":"scan"}],"output":{"name":"scan"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",50,{"inputs":[{"name":"scan"}],"output":{"name":"option"}}],[11,"size_hint","","",50,null],[11,"clone","","",51,{"inputs":[{"name":"flatmap"}],"output":{"name":"flatmap"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",51,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"size_hint","","",51,null],[11,"next_back","","",51,{"inputs":[{"name":"flatmap"}],"output":{"name":"option"}}],[11,"clone","","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"fuse"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"size_hint","","",52,null],[11,"next_back","","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"option"}}],[11,"indexable","","",52,{"inputs":[{"name":"fuse"}],"output":{"name":"usize"}}],[11,"idx","","",52,{"inputs":[{"name":"fuse"},{"name":"usize"}],"output":{"name":"option"}}],[11,"reset_fuse","","Resets the `Fuse` such that the next call to `.next()` or\n`.next_back()` will call the underlying iterator again even if it\npreviously returned `None`.",52,null],[11,"clone","","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"inspect"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"size_hint","","",53,null],[11,"next_back","","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"option"}}],[11,"indexable","","",53,{"inputs":[{"name":"inspect"}],"output":{"name":"usize"}}],[11,"idx","","",53,{"inputs":[{"name":"inspect"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",54,{"inputs":[{"name":"unfold"}],"output":{"name":"unfold"}}],[11,"new","","Creates a new iterator with the specified closure as the \"iterator\nfunction\" and an initial state to eventually pass to the closure",54,{"inputs":[{"name":"unfold"},{"name":"st"},{"name":"f"}],"output":{"name":"unfold"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",54,{"inputs":[{"name":"unfold"}],"output":{"name":"option"}}],[11,"size_hint","","",54,null],[11,"clone","","",55,{"inputs":[{"name":"stepby"}],"output":{"name":"stepby"}}],[11,"step_by","core::ops","Creates an iterator starting at the same point, but stepping by\nthe given amount at each iteration.",13,{"inputs":[{"name":"rangefrom"},{"name":"a"}],"output":{"name":"stepby"}}],[11,"step_by","","Creates an iterator with the same range, but stepping by the\ngiven amount at each iteration.",12,{"inputs":[{"name":"range"},{"name":"a"}],"output":{"name":"stepby"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",55,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[11,"size_hint","","",55,null],[11,"clone","","",56,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"rangeinclusive"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",56,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[11,"size_hint","","",56,null],[11,"next_back","","",56,{"inputs":[{"name":"rangeinclusive"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",55,{"inputs":[{"name":"stepby"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::ops","",12,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[11,"size_hint","","",12,null],[11,"next_back","","",12,{"inputs":[{"name":"range"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::ops","",13,{"inputs":[{"name":"rangefrom"}],"output":{"name":"option"}}],[11,"clone","core::iter","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"repeat"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::iter","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"size_hint","","",57,null],[11,"next_back","","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"option"}}],[11,"indexable","","",57,{"inputs":[{"name":"repeat"}],"output":{"name":"usize"}}],[11,"idx","","",57,{"inputs":[{"name":"repeat"},{"name":"usize"}],"output":{"name":"option"}}],[11,"hash","core::option","",58,null],[11,"fmt","","",58,{"inputs":[{"name":"option"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"lt","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"le","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"gt","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ge","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"eq","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"ne","","",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"bool"}}],[11,"clone","","",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"is_some","","Returns `true` if the option is a `Some` value",58,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"is_none","","Returns `true` if the option is a `None` value",58,{"inputs":[{"name":"option"}],"output":{"name":"bool"}}],[11,"as_ref","","Converts from `Option<T>` to `Option<&T>`",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut","","Converts from `Option<T>` to `Option<&mut T>`",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_mut_slice","","Converts from `Option<T>` to `&mut [T]` (without copying)",58,null],[11,"expect","","Unwraps an option, yielding the content of a `Some`",58,{"inputs":[{"name":"option"},{"name":"str"}],"output":{"name":"t"}}],[11,"unwrap","","Moves the value `v` out of the `Option<T>` if it is `Some(v)`.",58,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"unwrap_or","","Returns the contained value or a default.",58,{"inputs":[{"name":"option"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Returns the contained value or computes it from a closure.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"t"}}],[11,"map","","Maps an `Option<T>` to `Option<U>` by applying a function to a contained value",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"map_or","","Applies a function to the contained value or returns a default.",58,{"inputs":[{"name":"option"},{"name":"u"},{"name":"f"}],"output":{"name":"u"}}],[11,"map_or_else","","Applies a function to the contained value or computes a default.",58,{"inputs":[{"name":"option"},{"name":"d"},{"name":"f"}],"output":{"name":"u"}}],[11,"ok_or","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err)`.",58,{"inputs":[{"name":"option"},{"name":"e"}],"output":{"name":"result"}}],[11,"ok_or_else","","Transforms the `Option<T>` into a `Result<T, E>`, mapping `Some(v)` to\n`Ok(v)` and `None` to `Err(err())`.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",58,{"inputs":[{"name":"option"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",58,{"inputs":[{"name":"option"}],"output":{"name":"itermut"}}],[11,"and","","Returns `None` if the option is `None`, otherwise returns `optb`.",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"and_then","","Returns `None` if the option is `None`, otherwise calls `f` with the\nwrapped value and returns the result.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"or","","Returns the option if it contains a value, otherwise returns `optb`.",58,{"inputs":[{"name":"option"},{"name":"option"}],"output":{"name":"option"}}],[11,"or_else","","Returns the option if it contains a value, otherwise calls `f` and\nreturns the result.",58,{"inputs":[{"name":"option"},{"name":"f"}],"output":{"name":"option"}}],[11,"take","","Takes the value out of the option, leaving a `None` in its place.",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"as_slice","","Converts from `Option<T>` to `&[T]` (without copying)",58,null],[11,"cloned","","Maps an Option<&T> to an Option<T> by cloning the contents of the Option.",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[11,"unwrap_or_default","","Returns the contained value or a default",58,{"inputs":[{"name":"option"}],"output":{"name":"t"}}],[11,"default","","",58,{"inputs":[{"name":"option"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","core::option","Returns a consuming iterator over the possibly contained value.",58,{"inputs":[{"name":"option"}],"output":{"name":"intoiter"}}],[11,"clone","","",59,{"inputs":[{"name":"item"}],"output":{"name":"item"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::option","",59,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[11,"size_hint","","",59,null],[11,"next_back","","",59,{"inputs":[{"name":"item"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::option","",60,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",60,null],[11,"next_back","","",60,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",60,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::option","",61,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",61,null],[11,"next_back","","",61,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::option","",62,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",62,null],[11,"next_back","","",62,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is `None`, no further\nelements are taken, and the `None` is returned. Should no `None` occur, a\ncontainer with the values of each `Option` is returned.",58,{"inputs":[{"name":"option"},{"name":"i"}],"output":{"name":"option"}}],[11,"clone","core::raw","",63,{"inputs":[{"name":"slice"}],"output":{"name":"slice"}}],[11,"clone","","",64,{"inputs":[{"name":"traitobject"}],"output":{"name":"traitobject"}}],[11,"hash","core::result","",65,null],[11,"fmt","","",65,{"inputs":[{"name":"result"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"cmp","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"ordering"}}],[11,"partial_cmp","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"option"}}],[11,"lt","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"le","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"gt","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ge","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"eq","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"ne","","",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"bool"}}],[11,"clone","","",65,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"is_ok","","Returns true if the result is `Ok`",65,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"is_err","","Returns true if the result is `Err`",65,{"inputs":[{"name":"result"}],"output":{"name":"bool"}}],[11,"ok","","Converts from `Result<T, E>` to `Option<T>`",65,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"err","","Converts from `Result<T, E>` to `Option<E>`",65,{"inputs":[{"name":"result"}],"output":{"name":"option"}}],[11,"as_ref","","Converts from `Result<T, E>` to `Result<&T, &E>`",65,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_mut","","Converts from `Result<T, E>` to `Result<&mut T, &mut E>`",65,{"inputs":[{"name":"result"}],"output":{"name":"result"}}],[11,"as_slice","","Converts from `Result<T, E>` to `&[T]` (without copying)",65,null],[11,"as_mut_slice","","Converts from `Result<T, E>` to `&mut [T]` (without copying)",65,null],[11,"map","","Maps a `Result<T, E>` to `Result<U, E>` by applying a function to an\ncontained `Ok` value, leaving an `Err` value untouched.",65,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"map_err","","Maps a `Result<T, E>` to `Result<T, F>` by applying a function to an\ncontained `Err` value, leaving an `Ok` value untouched.",65,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"iter","","Returns an iterator over the possibly contained value.",65,{"inputs":[{"name":"result"}],"output":{"name":"iter"}}],[11,"iter_mut","","Returns a mutable iterator over the possibly contained value.",65,{"inputs":[{"name":"result"}],"output":{"name":"itermut"}}],[11,"and","","Returns `res` if the result is `Ok`, otherwise returns the `Err` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"and_then","","Calls `op` if the result is `Ok`, otherwise returns the `Err` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"result"}}],[11,"or","","Returns `res` if the result is `Err`, otherwise returns the `Ok` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"result"}],"output":{"name":"result"}}],[11,"or_else","","Calls `op` if the result is `Err`, otherwise returns the `Ok` value of `self`.",65,{"inputs":[{"name":"result"},{"name":"o"}],"output":{"name":"result"}}],[11,"unwrap_or","","Unwraps a result, yielding the content of an `Ok`.\nElse it returns `optb`.",65,{"inputs":[{"name":"result"},{"name":"t"}],"output":{"name":"t"}}],[11,"unwrap_or_else","","Unwraps a result, yielding the content of an `Ok`.\nIf the value is an `Err` then it calls `op` with its value.",65,{"inputs":[{"name":"result"},{"name":"f"}],"output":{"name":"t"}}],[11,"unwrap","","Unwraps a result, yielding the content of an `Ok`.",65,{"inputs":[{"name":"result"}],"output":{"name":"t"}}],[11,"unwrap_err","","Unwraps a result, yielding the content of an `Err`.",65,{"inputs":[{"name":"result"}],"output":{"name":"e"}}],[6,"Item","unicode::char","",null,null],[6,"IntoIter","","",null,null],[11,"into_iter","core::result","Returns a consuming iterator over the possibly contained value.",65,{"inputs":[{"name":"result"}],"output":{"name":"intoiter"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::result","",66,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",66,null],[11,"next_back","","",66,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",66,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::result","",67,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",67,null],[11,"next_back","","",67,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::result","",68,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"size_hint","","",68,null],[11,"next_back","","",68,{"inputs":[{"name":"intoiter"}],"output":{"name":"option"}}],[11,"from_iter","","Takes each element in the `Iterator`: if it is an `Err`, no further\nelements are taken, and the `Err` is returned. Should no `Err` occur, a\ncontainer with the values of each `Result` is returned.",65,{"inputs":[{"name":"result"},{"name":"i"}],"output":{"name":"result"}}],[11,"fmt","core::simd","",69,{"inputs":[{"name":"i8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",69,{"inputs":[{"name":"i8x16"}],"output":{"name":"i8x16"}}],[11,"fmt","","",70,{"inputs":[{"name":"i16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",70,{"inputs":[{"name":"i16x8"}],"output":{"name":"i16x8"}}],[11,"fmt","","",71,{"inputs":[{"name":"i32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",71,{"inputs":[{"name":"i32x4"}],"output":{"name":"i32x4"}}],[11,"fmt","","",72,{"inputs":[{"name":"i64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",72,{"inputs":[{"name":"i64x2"}],"output":{"name":"i64x2"}}],[11,"fmt","","",73,{"inputs":[{"name":"u8x16"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",73,{"inputs":[{"name":"u8x16"}],"output":{"name":"u8x16"}}],[11,"fmt","","",74,{"inputs":[{"name":"u16x8"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",74,{"inputs":[{"name":"u16x8"}],"output":{"name":"u16x8"}}],[11,"fmt","","",75,{"inputs":[{"name":"u32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",75,{"inputs":[{"name":"u32x4"}],"output":{"name":"u32x4"}}],[11,"fmt","","",76,{"inputs":[{"name":"u64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",76,{"inputs":[{"name":"u64x2"}],"output":{"name":"u64x2"}}],[11,"fmt","","",77,{"inputs":[{"name":"f32x4"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",77,{"inputs":[{"name":"f32x4"}],"output":{"name":"f32x4"}}],[11,"fmt","","",78,{"inputs":[{"name":"f64x2"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",78,{"inputs":[{"name":"f64x2"}],"output":{"name":"f64x2"}}],[6,"Output","unicode::char","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[6,"Item","","",null,null],[6,"IntoIter","","",null,null],[11,"as_slice","core::slice","View the underlying data as a subslice of the original data.",79,null],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",79,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"size_hint","","",79,null],[11,"next_back","","",79,{"inputs":[{"name":"iter"}],"output":{"name":"option"}}],[11,"clone","","",79,{"inputs":[{"name":"iter"}],"output":{"name":"iter"}}],[11,"indexable","","",79,{"inputs":[{"name":"iter"}],"output":{"name":"usize"}}],[11,"idx","","",79,{"inputs":[{"name":"iter"},{"name":"usize"}],"output":{"name":"option"}}],[11,"into_slice","","View the underlying data as a subslice of the original data.",80,null],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",80,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"size_hint","","",80,null],[11,"next_back","","",80,{"inputs":[{"name":"itermut"}],"output":{"name":"option"}}],[11,"clone","","",81,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",81,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"size_hint","","",81,null],[11,"next_back","","",81,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",81,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"finish","","",82,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",82,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[11,"size_hint","","",82,null],[11,"next_back","","",82,{"inputs":[{"name":"splitmut"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",83,{"inputs":[{"name":"genericsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",83,null],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",84,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"size_hint","","",84,null],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",85,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"size_hint","","",85,null],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",86,{"inputs":[{"name":"splitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",86,null],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",87,{"inputs":[{"name":"rsplitnmut"}],"output":{"name":"option"}}],[11,"size_hint","","",87,null],[11,"clone","","",88,{"inputs":[{"name":"windows"}],"output":{"name":"windows"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",88,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"size_hint","","",88,null],[11,"next_back","","",88,{"inputs":[{"name":"windows"}],"output":{"name":"option"}}],[11,"indexable","","",88,{"inputs":[{"name":"windows"}],"output":{"name":"usize"}}],[11,"idx","","",88,{"inputs":[{"name":"windows"},{"name":"usize"}],"output":{"name":"option"}}],[11,"clone","","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"chunks"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"size_hint","","",89,null],[11,"next_back","","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"option"}}],[11,"indexable","","",89,{"inputs":[{"name":"chunks"}],"output":{"name":"usize"}}],[11,"idx","","",89,{"inputs":[{"name":"chunks"},{"name":"usize"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::slice","",90,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"size_hint","","",90,null],[11,"next_back","","",90,{"inputs":[{"name":"chunksmut"}],"output":{"name":"option"}}],[11,"fmt","core::str::pattern","",91,{"inputs":[{"name":"searchstep"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"eq","","",91,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"ne","","",91,{"inputs":[{"name":"searchstep"},{"name":"searchstep"}],"output":{"name":"bool"}}],[11,"clone","","",91,{"inputs":[{"name":"searchstep"}],"output":{"name":"searchstep"}}],[11,"clone","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"chareqsearcher"}}],[6,"Searcher","unicode::char","",null,null],[11,"into_searcher","core::str::pattern","",93,{"inputs":[{"name":"chareqpattern"},{"name":"str"}],"output":{"name":"chareqsearcher"}}],[11,"haystack","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"str"}}],[11,"next","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",92,{"inputs":[{"name":"chareqsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"strsearcher"}}],[11,"eq","","",95,{"inputs":[{"name":"state"},{"name":"state"}],"output":{"name":"bool"}}],[11,"ne","","",95,{"inputs":[{"name":"state"},{"name":"state"}],"output":{"name":"bool"}}],[11,"clone","","",95,{"inputs":[{"name":"state"}],"output":{"name":"state"}}],[6,"Searcher","unicode::char","",null,null],[11,"haystack","core::str::pattern","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"str"}}],[11,"next","","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"next_back","","",94,{"inputs":[{"name":"strsearcher"}],"output":{"name":"searchstep"}}],[11,"clone","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"charsearcher"}}],[11,"haystack","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"str"}}],[11,"next","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_back","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",96,{"inputs":[{"name":"charsearcher"}],"output":{"name":"option"}}],[6,"Searcher","unicode::char","",null,null],[11,"clone","core::str::pattern","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"charslicesearcher"}}],[11,"haystack","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"str"}}],[11,"next","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",97,{"inputs":[{"name":"charslicesearcher"}],"output":{"name":"option"}}],[6,"Searcher","unicode::char","",null,null],[11,"clone","core::str::pattern","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"charpredicatesearcher"}}],[11,"haystack","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"str"}}],[11,"next","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_back","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"searchstep"}}],[11,"next_match_back","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[11,"next_reject_back","","",98,{"inputs":[{"name":"charpredicatesearcher"}],"output":{"name":"option"}}],[6,"Searcher","unicode::char","",null,null],[6,"Searcher","","",null,null],[6,"Err","","",null,null],[11,"eq","core::str","",99,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"ne","","",99,{"inputs":[{"name":"parseboolerror"},{"name":"parseboolerror"}],"output":{"name":"bool"}}],[11,"clone","","",99,{"inputs":[{"name":"parseboolerror"}],"output":{"name":"parseboolerror"}}],[11,"fmt","","",99,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",99,{"inputs":[{"name":"parseboolerror"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",100,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",100,{"inputs":[{"name":"utf8error"}],"output":{"name":"utf8error"}}],[11,"eq","","",100,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"ne","","",100,{"inputs":[{"name":"utf8error"},{"name":"utf8error"}],"output":{"name":"bool"}}],[11,"valid_up_to","","Returns the index in the given string up to which valid UTF-8 was\nverified.",100,{"inputs":[{"name":"utf8error"}],"output":{"name":"usize"}}],[11,"fmt","","",100,{"inputs":[{"name":"utf8error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",101,{"inputs":[{"name":"chars"}],"output":{"name":"chars"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",101,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"size_hint","","",101,null],[11,"next_back","","",101,{"inputs":[{"name":"chars"}],"output":{"name":"option"}}],[11,"clone","","",102,{"inputs":[{"name":"charindices"}],"output":{"name":"charindices"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",102,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"size_hint","","",102,null],[11,"next_back","","",102,{"inputs":[{"name":"charindices"}],"output":{"name":"option"}}],[11,"clone","","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"bytes"}}],[11,"clone","","",104,{"inputs":[{"name":"bytesderef"}],"output":{"name":"bytesderef"}}],[11,"call","","",104,null],[11,"call_mut","","",104,null],[6,"Output","unicode::char","",null,null],[11,"call_once","core::str","",104,null],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"size_hint","","",103,null],[11,"next_back","","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"option"}}],[11,"len","","",103,{"inputs":[{"name":"bytes"}],"output":{"name":"usize"}}],[11,"clone","","",105,{"inputs":[{"name":"splitinternal"}],"output":{"name":"splitinternal"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",106,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"clone","","",106,{"inputs":[{"name":"split"}],"output":{"name":"split"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",107,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[11,"clone","","",107,{"inputs":[{"name":"rsplit"}],"output":{"name":"rsplit"}}],[11,"next_back","","",106,{"inputs":[{"name":"split"}],"output":{"name":"option"}}],[11,"next_back","","",107,{"inputs":[{"name":"rsplit"}],"output":{"name":"option"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",108,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"clone","","",108,{"inputs":[{"name":"splitterminator"}],"output":{"name":"splitterminator"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",109,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",109,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"rsplitterminator"}}],[11,"next_back","","",108,{"inputs":[{"name":"splitterminator"}],"output":{"name":"option"}}],[11,"next_back","","",109,{"inputs":[{"name":"rsplitterminator"}],"output":{"name":"option"}}],[11,"clone","","",110,{"inputs":[{"name":"splitninternal"}],"output":{"name":"splitninternal"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",111,{"inputs":[{"name":"splitn"}],"output":{"name":"option"}}],[11,"clone","","",111,{"inputs":[{"name":"splitn"}],"output":{"name":"splitn"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",112,{"inputs":[{"name":"rsplitn"}],"output":{"name":"option"}}],[11,"clone","","",112,{"inputs":[{"name":"rsplitn"}],"output":{"name":"rsplitn"}}],[11,"clone","","",113,{"inputs":[{"name":"matchindicesinternal"}],"output":{"name":"matchindicesinternal"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",114,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"clone","","",114,{"inputs":[{"name":"matchindices"}],"output":{"name":"matchindices"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",115,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",115,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"rmatchindices"}}],[11,"next_back","","",114,{"inputs":[{"name":"matchindices"}],"output":{"name":"option"}}],[11,"next_back","","",115,{"inputs":[{"name":"rmatchindices"}],"output":{"name":"option"}}],[11,"clone","","",116,{"inputs":[{"name":"matchesinternal"}],"output":{"name":"matchesinternal"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",117,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"clone","","",117,{"inputs":[{"name":"matches"}],"output":{"name":"matches"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",118,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",118,{"inputs":[{"name":"rmatches"}],"output":{"name":"rmatches"}}],[11,"next_back","","",117,{"inputs":[{"name":"matches"}],"output":{"name":"option"}}],[11,"next_back","","",118,{"inputs":[{"name":"rmatches"}],"output":{"name":"option"}}],[11,"clone","","",119,{"inputs":[{"name":"lines"}],"output":{"name":"lines"}}],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",119,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"size_hint","","",119,null],[11,"next_back","","",119,{"inputs":[{"name":"lines"}],"output":{"name":"option"}}],[11,"clone","","",120,{"inputs":[{"name":"linesany"}],"output":{"name":"linesany"}}],[11,"clone","","",121,{"inputs":[{"name":"linesanymap"}],"output":{"name":"linesanymap"}}],[11,"call","","",121,null],[11,"call_mut","","",121,null],[6,"Output","unicode::char","",null,null],[11,"call_once","core::str","",121,null],[6,"Item","unicode::char","",null,null],[11,"next","core::str","",120,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"size_hint","","",120,null],[11,"next_back","","",120,{"inputs":[{"name":"linesany"}],"output":{"name":"option"}}],[11,"clone","","",122,{"inputs":[{"name":"twowaysearcher"}],"output":{"name":"twowaysearcher"}}],[11,"clone","","",123,{"inputs":[{"name":"oldsearcher"}],"output":{"name":"oldsearcher"}}],[11,"clone","","",124,{"inputs":[{"name":"oldmatchindices"}],"output":{"name":"oldmatchindices"}}],[11,"clone","","",125,{"inputs":[{"name":"charrange"}],"output":{"name":"charrange"}}],[6,"Output","unicode::char","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"new","core::hash::sip","Creates a new `SipHasher` with the two initial keys set to 0.",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"new_with_keys","","Creates a `SipHasher` that is keyed off the provided keys.",126,{"inputs":[{"name":"siphasher"},{"name":"u64"},{"name":"u64"}],"output":{"name":"siphasher"}}],[11,"write","","",126,null],[11,"finish","","",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"u64"}}],[11,"clone","","",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"default","","",126,{"inputs":[{"name":"siphasher"}],"output":{"name":"siphasher"}}],[11,"eq","core::fmt::num","",127,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"ne","","",127,{"inputs":[{"name":"binary"},{"name":"binary"}],"output":{"name":"bool"}}],[11,"clone","","",127,{"inputs":[{"name":"binary"}],"output":{"name":"binary"}}],[11,"eq","","",128,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"ne","","",128,{"inputs":[{"name":"octal"},{"name":"octal"}],"output":{"name":"bool"}}],[11,"clone","","",128,{"inputs":[{"name":"octal"}],"output":{"name":"octal"}}],[11,"eq","","",129,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"ne","","",129,{"inputs":[{"name":"decimal"},{"name":"decimal"}],"output":{"name":"bool"}}],[11,"clone","","",129,{"inputs":[{"name":"decimal"}],"output":{"name":"decimal"}}],[11,"eq","","",130,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"ne","","",130,{"inputs":[{"name":"lowerhex"},{"name":"lowerhex"}],"output":{"name":"bool"}}],[11,"clone","","",130,{"inputs":[{"name":"lowerhex"}],"output":{"name":"lowerhex"}}],[11,"eq","","",131,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"ne","","",131,{"inputs":[{"name":"upperhex"},{"name":"upperhex"}],"output":{"name":"bool"}}],[11,"clone","","",131,{"inputs":[{"name":"upperhex"}],"output":{"name":"upperhex"}}],[11,"eq","","",132,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"ne","","",132,{"inputs":[{"name":"radix"},{"name":"radix"}],"output":{"name":"bool"}}],[11,"clone","","",132,{"inputs":[{"name":"radix"}],"output":{"name":"radix"}}],[11,"clone","","",133,{"inputs":[{"name":"radixfmt"}],"output":{"name":"radixfmt"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",133,{"inputs":[{"name":"radixfmt"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"write_str","core::fmt::builders","",134,{"inputs":[{"name":"padadapter"},{"name":"str"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated struct output.",135,{"inputs":[{"name":"debugstruct"},{"name":"str"},{"name":"debug"}],"output":{"name":"debugstruct"}}],[11,"finish","","Consumes the `DebugStruct`, finishing output and returning any error\nencountered.",135,{"inputs":[{"name":"debugstruct"}],"output":{"name":"result"}}],[11,"field","","Adds a new field to the generated tuple struct output.",136,{"inputs":[{"name":"debugtuple"},{"name":"debug"}],"output":{"name":"debugtuple"}}],[11,"finish","","Consumes the `DebugTuple`, finishing output and returning any error\nencountered.",136,{"inputs":[{"name":"debugtuple"}],"output":{"name":"result"}}],[11,"finish","","",137,null],[11,"entry","","Adds a new entry to the set output.",138,{"inputs":[{"name":"debugset"},{"name":"debug"}],"output":{"name":"debugset"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",138,{"inputs":[{"name":"debugset"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the set output.",139,{"inputs":[{"name":"debuglist"},{"name":"debug"}],"output":{"name":"debuglist"}}],[11,"finish","","Consumes the `DebugSet`, finishing output and returning any error\nencountered.",139,{"inputs":[{"name":"debuglist"}],"output":{"name":"result"}}],[11,"entry","","Adds a new entry to the map output.",140,{"inputs":[{"name":"debugmap"},{"name":"debug"},{"name":"debug"}],"output":{"name":"debugmap"}}],[11,"finish","","Consumes the `DebugMap`, finishing output and returning any error\nencountered.",140,{"inputs":[{"name":"debugmap"}],"output":{"name":"result"}}],[11,"clone","core::fmt::rt::v1","",141,{"inputs":[{"name":"argument"}],"output":{"name":"argument"}}],[11,"clone","","",142,{"inputs":[{"name":"formatspec"}],"output":{"name":"formatspec"}}],[11,"eq","","",143,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"ne","","",143,{"inputs":[{"name":"alignment"},{"name":"alignment"}],"output":{"name":"bool"}}],[11,"clone","","",143,{"inputs":[{"name":"alignment"}],"output":{"name":"alignment"}}],[11,"clone","","",144,{"inputs":[{"name":"count"}],"output":{"name":"count"}}],[11,"clone","","",145,{"inputs":[{"name":"position"}],"output":{"name":"position"}}],[11,"fmt","core::fmt","",146,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"clone","","",146,{"inputs":[{"name":"error"}],"output":{"name":"error"}}],[11,"clone","","",147,{"inputs":[{"name":"argumentv1"}],"output":{"name":"argumentv1"}}],[11,"clone","","",148,{"inputs":[{"name":"flagv1"}],"output":{"name":"flagv1"}}],[11,"clone","","",149,{"inputs":[{"name":"arguments"}],"output":{"name":"arguments"}}],[11,"fmt","","",149,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",149,{"inputs":[{"name":"arguments"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"pad_integral","","Performs the correct padding for an integer which has already been\nemitted into a str. The str should *not* contain the sign for the\ninteger, that will be added by this method.",150,{"inputs":[{"name":"formatter"},{"name":"bool"},{"name":"str"},{"name":"str"}],"output":{"name":"result"}}],[11,"pad","","This function takes a string slice and emits it to the internal buffer\nafter applying the relevant formatting flags specified. The flags\nrecognized for generic strings are:",150,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_str","","Writes some data to the underlying buffer contained within this\nformatter.",150,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"result"}}],[11,"write_fmt","","Writes some formatted information into this instance",150,{"inputs":[{"name":"formatter"},{"name":"arguments"}],"output":{"name":"result"}}],[11,"flags","","Flags for formatting (packed version of rt::Flag)",150,{"inputs":[{"name":"formatter"}],"output":{"name":"u32"}}],[11,"fill","","Character used as 'fill' whenever there is alignment",150,{"inputs":[{"name":"formatter"}],"output":{"name":"char"}}],[11,"align","","Flag indicating what form of alignment was requested",150,{"inputs":[{"name":"formatter"}],"output":{"name":"alignment"}}],[11,"width","","Optionally specified integer width that the output should be",150,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"precision","","Optionally specified precision for numeric types",150,{"inputs":[{"name":"formatter"}],"output":{"name":"option"}}],[11,"debug_struct","","Creates a `DebugStruct` builder designed to assist with creation of\n`fmt::Debug` implementations for structs.",150,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugstruct"}}],[11,"debug_tuple","","Creates a `DebugTuple` builder designed to assist with creation of\n`fmt::Debug` implementations for tuple structs.",150,{"inputs":[{"name":"formatter"},{"name":"str"}],"output":{"name":"debugtuple"}}],[11,"debug_list","","Creates a `DebugList` builder designed to assist with creation of\n`fmt::Debug` implementations for list-like structures.",150,{"inputs":[{"name":"formatter"}],"output":{"name":"debuglist"}}],[11,"debug_set","","Creates a `DebugSet` builder designed to assist with creation of\n`fmt::Debug` implementations for set-like structures.",150,{"inputs":[{"name":"formatter"}],"output":{"name":"debugset"}}],[11,"debug_map","","Creates a `DebugMap` builder designed to assist with creation of\n`fmt::Debug` implementations for map-like structures.",150,{"inputs":[{"name":"formatter"}],"output":{"name":"debugmap"}}],[11,"fmt","","",146,{"inputs":[{"name":"error"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::marker","",10,{"inputs":[{"name":"phantomdata"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","core::cell","",23,{"inputs":[{"name":"cell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",25,{"inputs":[{"name":"refcell"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",27,{"inputs":[{"name":"ref"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",29,{"inputs":[{"name":"refmut"},{"name":"formatter"}],"output":{"name":"result"}}],[3,"EscapeUnicode","unicode::char","An iterator over the characters that represent a `char`, as escaped by\nRust's unicode escaping rules.",null,null],[3,"EscapeDefault","","An iterator over the characters that represent a `char`, escaped\nfor maximum portability.",null,null],[3,"ToLowercase","","An iterator over the lowercase mapping of a given character, returned from\nthe [`to_lowercase` method](../primitive.char.html#method.to_lowercase) on\ncharacters.",null,null],[3,"ToUppercase","","An iterator over the uppercase mapping of a given character, returned from\nthe [`to_uppercase` method](../primitive.char.html#method.to_uppercase) on\ncharacters.",null,null],[5,"decompose_canonical","","Compute canonical Unicode decomposition for character",null,{"inputs":[{"name":"char"},{"name":"f"}],"output":null}],[5,"decompose_compatible","","Compute canonical or compatible Unicode decomposition for character",null,{"inputs":[{"name":"char"},{"name":"f"}],"output":null}],[5,"compose","","",null,{"inputs":[{"name":"char"},{"name":"char"}],"output":{"name":"option"}}],[5,"canonical_combining_class","","",null,{"inputs":[{"name":"char"}],"output":{"name":"u8"}}],[17,"UNICODE_VERSION","","The version of [Unicode](http://www.unicode.org/)\nthat the unicode parts of `CharExt` and `UnicodeStrPrelude` traits are based on.",null,null],[6,"Item","","",null,null],[11,"next","","",151,{"inputs":[{"name":"tolowercase"}],"output":{"name":"option"}}],[6,"Item","","",null,null],[11,"next","","",152,{"inputs":[{"name":"touppercase"}],"output":{"name":"option"}}],[0,"str","unicode","",null,null],[3,"Words","unicode::str","An iterator over the words of a string, separated by a sequence of whitespace",null,null],[3,"Graphemes","","External iterator for a string's\n[grapheme clusters](http://www.unicode.org/reports/tr29/#Grapheme_Cluster_Boundaries).",null,null],[3,"GraphemeIndices","","External iterator for grapheme clusters and byte offsets.",null,null],[3,"Utf16Items","","An iterator that decodes UTF-16 encoded codepoints from a vector\nof `u16`s.",null,null],[3,"Utf16Encoder","","Iterator adaptor for encoding `char`s to UTF-16.",null,null],[4,"Utf16Item","","The possibilities for values decoded from a `u16` stream.",null,null],[13,"ScalarValue","","A valid codepoint.",153,null],[13,"LoneSurrogate","","An invalid surrogate without its pair.",153,null],[5,"utf8_char_width","","Given a first byte, determine how many bytes are in this UTF-8 character",null,{"inputs":[{"name":"u8"}],"output":{"name":"usize"}}],[5,"is_utf16","","Determines if a vector of `u16` contains valid UTF-16",null,null],[5,"utf16_items","","Create an iterator over the UTF-16 encoded codepoints in `v`,\nreturning invalid surrogates as `LoneSurrogate`s.",null,null],[8,"UnicodeStr","","Methods for Unicode string slices",null,null],[10,"graphemes","","",154,{"inputs":[{"name":"unicodestr"},{"name":"bool"}],"output":{"name":"graphemes"}}],[10,"grapheme_indices","","",154,{"inputs":[{"name":"unicodestr"},{"name":"bool"}],"output":{"name":"graphemeindices"}}],[10,"words","","",154,{"inputs":[{"name":"unicodestr"}],"output":{"name":"words"}}],[10,"is_whitespace","","",154,{"inputs":[{"name":"unicodestr"}],"output":{"name":"bool"}}],[10,"is_alphanumeric","","",154,{"inputs":[{"name":"unicodestr"}],"output":{"name":"bool"}}],[10,"width","","",154,{"inputs":[{"name":"unicodestr"},{"name":"bool"}],"output":{"name":"usize"}}],[10,"trim","","",154,{"inputs":[{"name":"unicodestr"}],"output":{"name":"str"}}],[10,"trim_left","","",154,{"inputs":[{"name":"unicodestr"}],"output":{"name":"str"}}],[10,"trim_right","","",154,{"inputs":[{"name":"unicodestr"}],"output":{"name":"str"}}],[15,"char","unicode","Character manipulation (`char` type, Unicode Scalar Value)",null,null],[11,"clone","unicode::str","",155,null],[11,"next","","",155,null],[11,"size_hint","","",155,null],[11,"next_back","","",155,null],[11,"clone","","",156,null],[11,"size_hint","","",156,null],[11,"next","","",156,null],[11,"next_back","","",156,null],[11,"clone","","",157,null],[11,"fmt","","",153,null],[11,"clone","","",153,null],[11,"eq","","",153,null],[11,"ne","","",153,null],[11,"to_char_lossy","","Convert `self` to a `char`, taking `LoneSurrogate`s to the\nreplacement character (U+FFFD).",153,null],[11,"next","","",157,null],[11,"size_hint","","",157,null],[11,"clone","","",158,null],[11,"new","","Create an UTF-16 encoder from any `char` iterator.",158,null],[11,"next","","",158,null],[11,"size_hint","","",158,null],[11,"next","","",159,null],[11,"next_back","","",159,null],[11,"eq","unicode","",160,null],[11,"ne","","",160,null],[11,"partial_cmp","","",160,null],[11,"lt","","",160,null],[11,"le","","",160,null],[11,"ge","","",160,null],[11,"gt","","",160,null],[11,"cmp","","",160,null],[11,"clone","","Returns a deep copy of the value.",160,null],[11,"default","","",160,null],[11,"into_searcher","","",160,null],[11,"is_contained_in","","",160,null],[11,"is_prefix_of","","",160,null],[11,"is_suffix_of","","",160,null],[11,"hash","","",160,null],[11,"fmt","","",160,null],[11,"fmt","","",160,null],[11,"is_digit","","Checks if a `char` parses as a numeric digit in the given radix.",160,null],[11,"to_digit","","Converts a character to the corresponding digit.",160,null],[11,"escape_unicode","","Returns an iterator that yields the hexadecimal Unicode escape of a\ncharacter, as `char`s.",160,null],[11,"escape_default","","Returns an iterator that yields the 'default' ASCII and\nC++11-like literal escape of a character, as `char`s.",160,null],[11,"len_utf8","","Returns the number of bytes this character would need if encoded in\nUTF-8.",160,null],[11,"len_utf16","","Returns the number of 16-bit code units this character would need if\nencoded in UTF-16.",160,null],[11,"encode_utf8","","Encodes this character as UTF-8 into the provided byte buffer, and then\nreturns the number of bytes written.",160,null],[11,"encode_utf16","","Encodes this character as UTF-16 into the provided `u16` buffer, and\nthen returns the number of `u16`s written.",160,null],[11,"is_alphabetic","","Returns whether the specified character is considered a Unicode\nalphabetic code point.",160,null],[11,"is_xid_start","","Returns whether the specified character satisfies the 'XID_Start'\nUnicode property.",160,null],[11,"is_xid_continue","","Returns whether the specified `char` satisfies the 'XID_Continue'\nUnicode property.",160,null],[11,"is_lowercase","","Indicates whether a character is in lowercase.",160,null],[11,"is_uppercase","","Indicates whether a character is in uppercase.",160,null],[11,"is_whitespace","","Indicates whether a character is whitespace.",160,null],[11,"is_alphanumeric","","Indicates whether a character is alphanumeric.",160,null],[11,"is_control","","Indicates whether a character is a control code point.",160,null],[11,"is_numeric","","Indicates whether the character is numeric (Nd, Nl, or No).",160,null],[11,"to_lowercase","","Converts a character to its lowercase equivalent.",160,null],[11,"to_uppercase","","Converts a character to its uppercase equivalent.",160,null],[11,"width","","Returns this character's displayed width in columns, or `None` if it is a\ncontrol character other than `'\\x00'`.",160,null]],"paths":[[3,"Wrapping"],[4,"FpCategory"],[3,"ParseIntError"],[4,"IntErrorKind"],[3,"ParseFloatError"],[4,"FloatErrorKind"],[3,"NonZero"],[3,"Unique"],[3,"NoCopy"],[3,"Managed"],[3,"PhantomData"],[3,"RangeFull"],[3,"Range"],[3,"RangeFrom"],[3,"RangeTo"],[4,"Ordering"],[8,"Any"],[3,"TypeId"],[3,"AtomicBool"],[3,"AtomicIsize"],[3,"AtomicUsize"],[4,"Ordering"],[3,"AtomicPtr"],[3,"Cell"],[4,"BorrowState"],[3,"RefCell"],[3,"BorrowRef"],[3,"Ref"],[3,"BorrowRefMut"],[3,"RefMut"],[3,"UnsafeCell"],[3,"EscapeUnicode"],[4,"EscapeUnicodeState"],[3,"EscapeDefault"],[4,"EscapeDefaultState"],[3,"Rev"],[4,"MinMaxResult"],[3,"Cloned"],[3,"Cycle"],[3,"Chain"],[3,"Zip"],[3,"Map"],[3,"Filter"],[3,"FilterMap"],[3,"Enumerate"],[3,"Peekable"],[3,"SkipWhile"],[3,"TakeWhile"],[3,"Skip"],[3,"Take"],[3,"Scan"],[3,"FlatMap"],[3,"Fuse"],[3,"Inspect"],[3,"Unfold"],[3,"StepBy"],[3,"RangeInclusive"],[3,"Repeat"],[4,"Option"],[3,"Item"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"Slice"],[3,"TraitObject"],[4,"Result"],[3,"Iter"],[3,"IterMut"],[3,"IntoIter"],[3,"i8x16"],[3,"i16x8"],[3,"i32x4"],[3,"i64x2"],[3,"u8x16"],[3,"u16x8"],[3,"u32x4"],[3,"u64x2"],[3,"f32x4"],[3,"f64x2"],[3,"Iter"],[3,"IterMut"],[3,"Split"],[3,"SplitMut"],[3,"GenericSplitN"],[3,"SplitN"],[3,"RSplitN"],[3,"SplitNMut"],[3,"RSplitNMut"],[3,"Windows"],[3,"Chunks"],[3,"ChunksMut"],[4,"SearchStep"],[3,"CharEqSearcher"],[3,"CharEqPattern"],[3,"StrSearcher"],[4,"State"],[3,"CharSearcher"],[3,"CharSliceSearcher"],[3,"CharPredicateSearcher"],[3,"ParseBoolError"],[3,"Utf8Error"],[3,"Chars"],[3,"CharIndices"],[3,"Bytes"],[3,"BytesDeref"],[3,"SplitInternal"],[3,"Split"],[3,"RSplit"],[3,"SplitTerminator"],[3,"RSplitTerminator"],[3,"SplitNInternal"],[3,"SplitN"],[3,"RSplitN"],[3,"MatchIndicesInternal"],[3,"MatchIndices"],[3,"RMatchIndices"],[3,"MatchesInternal"],[3,"Matches"],[3,"RMatches"],[3,"Lines"],[3,"LinesAny"],[3,"LinesAnyMap"],[3,"TwoWaySearcher"],[4,"OldSearcher"],[3,"OldMatchIndices"],[3,"CharRange"],[3,"SipHasher"],[3,"Binary"],[3,"Octal"],[3,"Decimal"],[3,"LowerHex"],[3,"UpperHex"],[3,"Radix"],[3,"RadixFmt"],[3,"PadAdapter"],[3,"DebugStruct"],[3,"DebugTuple"],[3,"DebugInner"],[3,"DebugSet"],[3,"DebugList"],[3,"DebugMap"],[3,"Argument"],[3,"FormatSpec"],[4,"Alignment"],[4,"Count"],[4,"Position"],[3,"Error"],[3,"ArgumentV1"],[4,"FlagV1"],[3,"Arguments"],[3,"Formatter"],[3,"ToLowercase"],[3,"ToUppercase"],[4,"Utf16Item"],[8,"UnicodeStr"],[3,"GraphemeIndices"],[3,"Graphemes"],[3,"Utf16Items"],[3,"Utf16Encoder"],[3,"Words"],[15,"char"]]};
searchIndex['alloc'] = {"items":[[0,"","alloc","# The Rust core allocation library",null,null],[5,"oom","","Common out-of-memory routine",null,{"inputs":[],"output":null}],[0,"heap","","",null,null],[5,"allocate","alloc::heap","Return a pointer to `size` bytes of memory aligned to `align`.",null,null],[5,"reallocate","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"reallocate_inplace","","Resize the allocation referenced by `ptr` to `size` bytes.",null,null],[5,"deallocate","","Deallocates the memory referenced by `ptr`.",null,null],[5,"usable_size","","Returns the usable size of an allocation created with the specified the\n`size` and `align`.",null,{"inputs":[{"name":"usize"},{"name":"usize"}],"output":{"name":"usize"}}],[5,"stats_print","","Prints implementation-defined allocator statistics.",null,{"inputs":[],"output":null}],[17,"EMPTY","","An arbitrary non-null address to represent zero-size allocations.",null,null],[0,"boxed","alloc","A pointer type for heap allocation.",null,null],[3,"Box","alloc::boxed","A pointer type for heap allocation.",null,null],[5,"into_raw","","Consumes the `Box`, returning the wrapped raw pointer.",null,null],[7,"HEAP","","A value that represents the heap. This is the default place that the `box`\nkeyword allocates into when no place is supplied.",null,null],[8,"FnBox","","`FnBox` is a version of the `FnOnce` intended for use with boxed\nclosure objects. The idea is that where one would normally store a\n`Box<FnOnce()>` in a data structure, you should use\n`Box<FnBox()>`. The two traits behave essentially the same, except\nthat a `FnBox` closure can only be called if it is boxed. (Note\nthat `FnBox` may be deprecated in the future if `Box<FnOnce()>`\nclosures become directly usable.)",null,null],[16,"Output","alloc::boxed::FnBox","",null,null],[10,"call_box","alloc::boxed","",0,{"inputs":[{"name":"fnbox"},{"name":"a"}],"output":{"name":"output"}}],[11,"new","","Allocates memory on the heap and then moves `x` into it.",1,{"inputs":[{"name":"box"},{"name":"t"}],"output":{"name":"box"}}],[11,"from_raw","","Constructs a box from the raw pointer.",1,null],[11,"default","","",1,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"default","","",1,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone","","Returns a new box with a `clone()` of this box's contents.",1,{"inputs":[{"name":"box"}],"output":{"name":"box"}}],[11,"clone_from","","Copies `source`'s contents into `self` without creating a new allocation.",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":null}],[11,"eq","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ne","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"partial_cmp","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"option"}}],[11,"lt","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"le","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"ge","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"gt","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"bool"}}],[11,"cmp","","",1,{"inputs":[{"name":"box"},{"name":"box"}],"output":{"name":"ordering"}}],[11,"hash","","",1,{"inputs":[{"name":"box"},{"name":"h"}],"output":null}],[11,"downcast","","Attempt to downcast the box to a concrete type.",1,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"downcast","","Attempt to downcast the box to a concrete type.",1,{"inputs":[{"name":"box"}],"output":{"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",1,{"inputs":[{"name":"box"},{"name":"formatter"}],"output":{"name":"result"}}],[6,"Target","","",null,null],[11,"deref","","",1,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[11,"deref_mut","","",1,{"inputs":[{"name":"box"}],"output":{"name":"t"}}],[6,"Item","","",null,null],[11,"next","","",1,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[11,"size_hint","","",1,null],[11,"next_back","","",1,{"inputs":[{"name":"box"}],"output":{"name":"option"}}],[6,"Output","","",null,null],[6,"Output","","",null,null],[11,"call_once","","",1,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[6,"Output","","",null,null],[11,"call_once","","",1,{"inputs":[{"name":"box"},{"name":"a"}],"output":{"name":"r"}}],[0,"arc","alloc","Threadsafe reference-counted boxes (the `Arc<T>` type).",null,null],[3,"Arc","alloc::arc","An atomically reference counted wrapper for shared state.",null,null],[3,"Weak","","A weak pointer to an `Arc`.",null,null],[5,"weak_count","","Get the number of weak references to this value.",null,{"inputs":[{"name":"arc"}],"output":{"name":"usize"}}],[5,"strong_count","","Get the number of strong references to this value.",null,{"inputs":[{"name":"arc"}],"output":{"name":"usize"}}],[5,"get_mut","","Returns a mutable reference to the contained value if the `Arc<T>` is unique.",null,{"inputs":[{"name":"arc"}],"output":{"name":"option"}}],[11,"fmt","","",2,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"new","","Constructs a new `Arc<T>`.",3,{"inputs":[{"name":"arc"},{"name":"t"}],"output":{"name":"arc"}}],[11,"downgrade","","Downgrades the `Arc<T>` to a `Weak<T>` reference.",3,{"inputs":[{"name":"arc"}],"output":{"name":"weak"}}],[11,"clone","","Makes a clone of the `Arc<T>`.",3,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[6,"Target","","",null,null],[11,"deref","","",3,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"make_unique","","Make a mutable reference from the given `Arc<T>`.",3,{"inputs":[{"name":"arc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Arc<T>`.",3,{"inputs":[{"name":"arc"}],"output":null}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",2,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"clone","","Makes a clone of the `Weak<T>`.",2,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"drop","","Drops the `Weak<T>`.",2,{"inputs":[{"name":"weak"}],"output":null}],[11,"eq","","Equality for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Arc<T>`s.",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"bool"}}],[11,"cmp","","",3,{"inputs":[{"name":"arc"},{"name":"arc"}],"output":{"name":"ordering"}}],[11,"fmt","","",3,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",3,{"inputs":[{"name":"arc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"default","","",3,{"inputs":[{"name":"arc"}],"output":{"name":"arc"}}],[11,"hash","","",3,{"inputs":[{"name":"arc"},{"name":"h"}],"output":null}],[0,"rc","alloc","Thread-local reference-counted boxes (the `Rc<T>` type).",null,null],[3,"Rc","alloc::rc","A reference-counted pointer type over an immutable value.",null,null],[3,"Weak","","A weak version of `Rc<T>`.",null,null],[5,"weak_count","","Get the number of weak references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"strong_count","","Get the number of strong references to this value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"usize"}}],[5,"is_unique","","Returns true if there are no other `Rc` or `Weak<T>` values that share the\nsame inner value.",null,{"inputs":[{"name":"rc"}],"output":{"name":"bool"}}],[5,"try_unwrap","","Unwraps the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"result"}}],[5,"get_mut","","Returns a mutable reference to the contained value if the `Rc<T>` is unique.",null,{"inputs":[{"name":"rc"}],"output":{"name":"option"}}],[11,"new","","Constructs a new `Rc<T>`.",4,{"inputs":[{"name":"rc"},{"name":"t"}],"output":{"name":"rc"}}],[11,"downgrade","","Downgrades the `Rc<T>` to a `Weak<T>` reference.",4,{"inputs":[{"name":"rc"}],"output":{"name":"weak"}}],[11,"make_unique","","Make a mutable reference from the given `Rc<T>`.",4,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[6,"Target","","",null,null],[11,"deref","","",4,{"inputs":[{"name":"rc"}],"output":{"name":"t"}}],[11,"drop","","Drops the `Rc<T>`.",4,{"inputs":[{"name":"rc"}],"output":null}],[11,"clone","","Makes a clone of the `Rc<T>`.",4,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"default","","Creates a new `Rc<T>`, with the `Default` value for `T`.",4,{"inputs":[{"name":"rc"}],"output":{"name":"rc"}}],[11,"eq","","Equality for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ne","","Inequality for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"partial_cmp","","Partial comparison for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"option"}}],[11,"lt","","Less-than comparison for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"le","","'Less-than or equal to' comparison for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"gt","","Greater-than comparison for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"ge","","'Greater-than or equal to' comparison for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"bool"}}],[11,"cmp","","Comparison for two `Rc<T>`s.",4,{"inputs":[{"name":"rc"},{"name":"rc"}],"output":{"name":"ordering"}}],[11,"hash","","",4,{"inputs":[{"name":"rc"},{"name":"h"}],"output":null}],[11,"fmt","","",4,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",4,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"fmt","","",4,{"inputs":[{"name":"rc"},{"name":"formatter"}],"output":{"name":"result"}}],[11,"upgrade","","Upgrades a weak reference to a strong reference.",5,{"inputs":[{"name":"weak"}],"output":{"name":"option"}}],[11,"drop","","Drops the `Weak<T>`.",5,{"inputs":[{"name":"weak"}],"output":null}],[11,"clone","","Makes a clone of the `Weak<T>`.",5,{"inputs":[{"name":"weak"}],"output":{"name":"weak"}}],[11,"fmt","","",5,{"inputs":[{"name":"weak"},{"name":"formatter"}],"output":{"name":"result"}}]],"paths":[[8,"FnBox"],[3,"Box"],[3,"Weak"],[3,"Arc"],[3,"Rc"],[3,"Weak"]]};
searchIndex['libc'] = {"items":[[0,"","libc","Bindings for the C standard library and other platform libraries",null,null],[0,"types","","",null,null],[0,"common","libc::types","",null,null],[0,"c95","libc::types::common","",null,null],[4,"c_void","libc::types::common::c95","Type used to construct void pointers for use with C.",null,null],[13,"__variant1","","",0,null],[13,"__variant2","","",0,null],[4,"FILE","","",null,null],[4,"fpos_t","","",null,null],[0,"c99","libc::types::common","",null,null],[6,"int8_t","libc::types::common::c99","",null,null],[6,"int16_t","","",null,null],[6,"int32_t","","",null,null],[6,"int64_t","","",null,null],[6,"uint8_t","","",null,null],[6,"uint16_t","","",null,null],[6,"uint32_t","","",null,null],[6,"uint64_t","","",null,null],[0,"posix88","libc::types::common","",null,null],[4,"DIR","libc::types::common::posix88","",null,null],[4,"dirent_t","","",null,null],[0,"os","libc::types","",null,null],[0,"common","libc::types::os","",null,null],[0,"posix01","libc::types::os::common","",null,null],[3,"glob_t","libc::types::os::common::posix01","",null,null],[12,"gl_pathc","","",1,null],[12,"gl_pathv","","",1,null],[12,"gl_offs","","",1,null],[12,"__unused1","","",1,null],[12,"__unused2","","",1,null],[12,"__unused3","","",1,null],[12,"__unused4","","",1,null],[12,"__unused5","","",1,null],[3,"timeval","","",null,null],[12,"tv_sec","","",2,null],[12,"tv_usec","","",2,null],[3,"timespec","","",null,null],[12,"tv_sec","","",3,null],[12,"tv_nsec","","",3,null],[3,"rlimit","","",null,null],[12,"rlim_cur","","",4,null],[12,"rlim_max","","",4,null],[4,"timezone","","",null,null],[6,"pthread_t","","",null,null],[6,"rlim_t","","",null,null],[6,"sighandler_t","","",null,null],[11,"clone","","",1,{"inputs":[{"name":"glob_t"}],"output":{"name":"glob_t"}}],[11,"clone","","",2,{"inputs":[{"name":"timeval"}],"output":{"name":"timeval"}}],[11,"clone","","",3,{"inputs":[{"name":"timespec"}],"output":{"name":"timespec"}}],[11,"clone","","",4,{"inputs":[{"name":"rlimit"}],"output":{"name":"rlimit"}}],[0,"bsd43","libc::types::os::common","",null,null],[3,"rusage","libc::types::os::common::bsd43","",null,null],[12,"ru_utime","","",5,null],[12,"ru_stime","","",5,null],[12,"ru_maxrss","","",5,null],[12,"ru_ixrss","","",5,null],[12,"ru_idrss","","",5,null],[12,"ru_isrss","","",5,null],[12,"ru_minflt","","",5,null],[12,"ru_majflt","","",5,null],[12,"ru_nswap","","",5,null],[12,"ru_inblock","","",5,null],[12,"ru_oublock","","",5,null],[12,"ru_msgsnd","","",5,null],[12,"ru_msgrcv","","",5,null],[12,"ru_nsignals","","",5,null],[12,"ru_nvcsw","","",5,null],[12,"ru_nivcsw","","",5,null],[11,"clone","","",5,{"inputs":[{"name":"rusage"}],"output":{"name":"rusage"}}],[0,"bsd44","libc::types::os::common","",null,null],[3,"sockaddr","libc::types::os::common::bsd44","",null,null],[12,"sa_family","","",6,null],[12,"sa_data","","",6,null],[3,"sockaddr_storage","","",null,null],[12,"ss_family","","",7,null],[12,"__ss_align","","",7,null],[12,"__ss_pad2","","",7,null],[3,"sockaddr_in","","",null,null],[12,"sin_family","","",8,null],[12,"sin_port","","",8,null],[12,"sin_addr","","",8,null],[12,"sin_zero","","",8,null],[3,"in_addr","","",null,null],[12,"s_addr","","",9,null],[3,"sockaddr_in6","","",null,null],[12,"sin6_family","","",10,null],[12,"sin6_port","","",10,null],[12,"sin6_flowinfo","","",10,null],[12,"sin6_addr","","",10,null],[12,"sin6_scope_id","","",10,null],[3,"in6_addr","","",null,null],[12,"s6_addr","","",11,null],[3,"ip_mreq","","",null,null],[12,"imr_multiaddr","","",12,null],[12,"imr_interface","","",12,null],[3,"ip6_mreq","","",null,null],[12,"ipv6mr_multiaddr","","",13,null],[12,"ipv6mr_interface","","",13,null],[3,"addrinfo","","",null,null],[12,"ai_flags","","",14,null],[12,"ai_family","","",14,null],[12,"ai_socktype","","",14,null],[12,"ai_protocol","","",14,null],[12,"ai_addrlen","","",14,null],[12,"ai_addr","","",14,null],[12,"ai_canonname","","",14,null],[12,"ai_next","","",14,null],[3,"sockaddr_un","","",null,null],[12,"sun_family","","",15,null],[12,"sun_path","","",15,null],[3,"ifaddrs","","",null,null],[12,"ifa_next","","",16,null],[12,"ifa_name","","",16,null],[12,"ifa_flags","","",16,null],[12,"ifa_addr","","",16,null],[12,"ifa_netmask","","",16,null],[12,"ifa_ifu","","",16,null],[12,"ifa_data","","",16,null],[6,"socklen_t","","",null,null],[6,"sa_family_t","","",null,null],[6,"in_port_t","","",null,null],[6,"in_addr_t","","",null,null],[11,"clone","","",6,{"inputs":[{"name":"sockaddr"}],"output":{"name":"sockaddr"}}],[11,"clone","","",7,{"inputs":[{"name":"sockaddr_storage"}],"output":{"name":"sockaddr_storage"}}],[11,"clone","","",8,{"inputs":[{"name":"sockaddr_in"}],"output":{"name":"sockaddr_in"}}],[11,"clone","","",9,{"inputs":[{"name":"in_addr"}],"output":{"name":"in_addr"}}],[11,"clone","","",10,{"inputs":[{"name":"sockaddr_in6"}],"output":{"name":"sockaddr_in6"}}],[11,"clone","","",11,{"inputs":[{"name":"in6_addr"}],"output":{"name":"in6_addr"}}],[11,"clone","","",12,{"inputs":[{"name":"ip_mreq"}],"output":{"name":"ip_mreq"}}],[11,"clone","","",13,{"inputs":[{"name":"ip6_mreq"}],"output":{"name":"ip6_mreq"}}],[11,"clone","","",14,{"inputs":[{"name":"addrinfo"}],"output":{"name":"addrinfo"}}],[11,"clone","","",15,{"inputs":[{"name":"sockaddr_un"}],"output":{"name":"sockaddr_un"}}],[11,"clone","","",16,{"inputs":[{"name":"ifaddrs"}],"output":{"name":"ifaddrs"}}],[0,"arch","libc::types::os","",null,null],[0,"c95","libc::types::os::arch","",null,null],[6,"c_char","libc::types::os::arch::c95","",null,null],[6,"c_schar","","",null,null],[6,"c_uchar","","",null,null],[6,"c_short","","",null,null],[6,"c_ushort","","",null,null],[6,"c_int","","",null,null],[6,"c_uint","","",null,null],[6,"c_long","","",null,null],[6,"c_ulong","","",null,null],[6,"c_float","","",null,null],[6,"c_double","","",null,null],[6,"size_t","","",null,null],[6,"ptrdiff_t","","",null,null],[6,"clock_t","","",null,null],[6,"time_t","","",null,null],[6,"suseconds_t","","",null,null],[6,"wchar_t","","",null,null],[0,"c99","libc::types::os::arch","",null,null],[6,"c_longlong","libc::types::os::arch::c99","",null,null],[6,"c_ulonglong","","",null,null],[6,"intptr_t","","",null,null],[6,"uintptr_t","","",null,null],[6,"intmax_t","","",null,null],[6,"uintmax_t","","",null,null],[0,"posix88","libc::types::os::arch","",null,null],[6,"off_t","libc::types::os::arch::posix88","",null,null],[6,"dev_t","","",null,null],[6,"ino_t","","",null,null],[6,"pid_t","","",null,null],[6,"uid_t","","",null,null],[6,"gid_t","","",null,null],[6,"useconds_t","","",null,null],[6,"mode_t","","",null,null],[6,"ssize_t","","",null,null],[0,"posix01","libc::types::os::arch","",null,null],[3,"stat","libc::types::os::arch::posix01","",null,null],[12,"st_dev","","",17,null],[12,"st_ino","","",17,null],[12,"st_nlink","","",17,null],[12,"st_mode","","",17,null],[12,"st_uid","","",17,null],[12,"st_gid","","",17,null],[12,"__pad0","","",17,null],[12,"st_rdev","","",17,null],[12,"st_size","","",17,null],[12,"st_blksize","","",17,null],[12,"st_blocks","","",17,null],[12,"st_atime","","",17,null],[12,"st_atime_nsec","","",17,null],[12,"st_mtime","","",17,null],[12,"st_mtime_nsec","","",17,null],[12,"st_ctime","","",17,null],[12,"st_ctime_nsec","","",17,null],[12,"__unused","","",17,null],[3,"utimbuf","","",null,null],[12,"actime","","",18,null],[12,"modtime","","",18,null],[3,"pthread_attr_t","","",null,null],[12,"__size","","",19,null],[6,"nlink_t","","",null,null],[6,"blksize_t","","",null,null],[6,"blkcnt_t","","",null,null],[11,"clone","","",17,{"inputs":[{"name":"stat"}],"output":{"name":"stat"}}],[11,"clone","","",18,{"inputs":[{"name":"utimbuf"}],"output":{"name":"utimbuf"}}],[11,"clone","","",19,{"inputs":[{"name":"pthread_attr_t"}],"output":{"name":"pthread_attr_t"}}],[0,"extra","libc::types::os::arch","",null,null],[3,"sockaddr_ll","libc::types::os::arch::extra","",null,null],[12,"sll_family","","",20,null],[12,"sll_protocol","","",20,null],[12,"sll_ifindex","","",20,null],[12,"sll_hatype","","",20,null],[12,"sll_pkttype","","",20,null],[12,"sll_halen","","",20,null],[12,"sll_addr","","",20,null],[11,"clone","","",20,{"inputs":[{"name":"sockaddr_ll"}],"output":{"name":"sockaddr_ll"}}],[0,"consts","libc","",null,null],[0,"os","libc::consts","",null,null],[0,"c95","libc::consts::os","",null,null],[17,"EXIT_FAILURE","libc::consts::os::c95","",null,null],[17,"EXIT_SUCCESS","","",null,null],[17,"RAND_MAX","","",null,null],[17,"EOF","","",null,null],[17,"SEEK_SET","","",null,null],[17,"SEEK_CUR","","",null,null],[17,"SEEK_END","","",null,null],[17,"_IOFBF","","",null,null],[17,"_IONBF","","",null,null],[17,"_IOLBF","","",null,null],[17,"BUFSIZ","","",null,null],[17,"FOPEN_MAX","","",null,null],[17,"FILENAME_MAX","","",null,null],[17,"L_tmpnam","","",null,null],[17,"TMP_MAX","","",null,null],[0,"posix88","libc::consts::os","",null,null],[17,"O_RDONLY","libc::consts::os::posix88","",null,null],[17,"O_WRONLY","","",null,null],[17,"O_RDWR","","",null,null],[17,"O_APPEND","","",null,null],[17,"O_CREAT","","",null,null],[17,"O_EXCL","","",null,null],[17,"O_NOCTTY","","",null,null],[17,"O_TRUNC","","",null,null],[17,"S_IFIFO","","",null,null],[17,"S_IFCHR","","",null,null],[17,"S_IFBLK","","",null,null],[17,"S_IFDIR","","",null,null],[17,"S_IFREG","","",null,null],[17,"S_IFLNK","","",null,null],[17,"S_IFMT","","",null,null],[17,"S_IEXEC","","",null,null],[17,"S_IWRITE","","",null,null],[17,"S_IREAD","","",null,null],[17,"S_IRWXU","","",null,null],[17,"S_IXUSR","","",null,null],[17,"S_IWUSR","","",null,null],[17,"S_IRUSR","","",null,null],[17,"S_IRWXG","","",null,null],[17,"S_IXGRP","","",null,null],[17,"S_IWGRP","","",null,null],[17,"S_IRGRP","","",null,null],[17,"S_IRWXO","","",null,null],[17,"S_IXOTH","","",null,null],[17,"S_IWOTH","","",null,null],[17,"S_IROTH","","",null,null],[17,"F_OK","","",null,null],[17,"R_OK","","",null,null],[17,"W_OK","","",null,null],[17,"X_OK","","",null,null],[17,"STDIN_FILENO","","",null,null],[17,"STDOUT_FILENO","","",null,null],[17,"STDERR_FILENO","","",null,null],[17,"F_LOCK","","",null,null],[17,"F_TEST","","",null,null],[17,"F_TLOCK","","",null,null],[17,"F_ULOCK","","",null,null],[17,"SIGHUP","","",null,null],[17,"SIGINT","","",null,null],[17,"SIGQUIT","","",null,null],[17,"SIGILL","","",null,null],[17,"SIGABRT","","",null,null],[17,"SIGFPE","","",null,null],[17,"SIGKILL","","",null,null],[17,"SIGSEGV","","",null,null],[17,"SIGPIPE","","",null,null],[17,"SIGALRM","","",null,null],[17,"SIGTERM","","",null,null],[17,"PROT_NONE","","",null,null],[17,"PROT_READ","","",null,null],[17,"PROT_WRITE","","",null,null],[17,"PROT_EXEC","","",null,null],[17,"MAP_FILE","","",null,null],[17,"MAP_SHARED","","",null,null],[17,"MAP_PRIVATE","","",null,null],[17,"MAP_FIXED","","",null,null],[17,"MAP_ANON","","",null,null],[17,"MAP_FAILED","","",null,null],[17,"MCL_CURRENT","","",null,null],[17,"MCL_FUTURE","","",null,null],[17,"MS_ASYNC","","",null,null],[17,"MS_INVALIDATE","","",null,null],[17,"MS_SYNC","","",null,null],[17,"EPERM","","",null,null],[17,"ENOENT","","",null,null],[17,"ESRCH","","",null,null],[17,"EINTR","","",null,null],[17,"EIO","","",null,null],[17,"ENXIO","","",null,null],[17,"E2BIG","","",null,null],[17,"ENOEXEC","","",null,null],[17,"EBADF","","",null,null],[17,"ECHILD","","",null,null],[17,"EAGAIN","","",null,null],[17,"ENOMEM","","",null,null],[17,"EACCES","","",null,null],[17,"EFAULT","","",null,null],[17,"ENOTBLK","","",null,null],[17,"EBUSY","","",null,null],[17,"EEXIST","","",null,null],[17,"EXDEV","","",null,null],[17,"ENODEV","","",null,null],[17,"ENOTDIR","","",null,null],[17,"EISDIR","","",null,null],[17,"EINVAL","","",null,null],[17,"ENFILE","","",null,null],[17,"EMFILE","","",null,null],[17,"ENOTTY","","",null,null],[17,"ETXTBSY","","",null,null],[17,"EFBIG","","",null,null],[17,"ENOSPC","","",null,null],[17,"ESPIPE","","",null,null],[17,"EROFS","","",null,null],[17,"EMLINK","","",null,null],[17,"EPIPE","","",null,null],[17,"EDOM","","",null,null],[17,"ERANGE","","",null,null],[17,"EDEADLK","","",null,null],[17,"ENAMETOOLONG","","",null,null],[17,"ENOLCK","","",null,null],[17,"ENOSYS","","",null,null],[17,"ENOTEMPTY","","",null,null],[17,"ELOOP","","",null,null],[17,"EWOULDBLOCK","","",null,null],[17,"ENOMSG","","",null,null],[17,"EIDRM","","",null,null],[17,"ECHRNG","","",null,null],[17,"EL2NSYNC","","",null,null],[17,"EL3HLT","","",null,null],[17,"EL3RST","","",null,null],[17,"ELNRNG","","",null,null],[17,"EUNATCH","","",null,null],[17,"ENOCSI","","",null,null],[17,"EL2HLT","","",null,null],[17,"EBADE","","",null,null],[17,"EBADR","","",null,null],[17,"EXFULL","","",null,null],[17,"ENOANO","","",null,null],[17,"EBADRQC","","",null,null],[17,"EBADSLT","","",null,null],[17,"EDEADLOCK","","",null,null],[17,"EBFONT","","",null,null],[17,"ENOSTR","","",null,null],[17,"ENODATA","","",null,null],[17,"ETIME","","",null,null],[17,"ENOSR","","",null,null],[17,"ENONET","","",null,null],[17,"ENOPKG","","",null,null],[17,"EREMOTE","","",null,null],[17,"ENOLINK","","",null,null],[17,"EADV","","",null,null],[17,"ESRMNT","","",null,null],[17,"ECOMM","","",null,null],[17,"EPROTO","","",null,null],[17,"EMULTIHOP","","",null,null],[17,"EDOTDOT","","",null,null],[17,"EBADMSG","","",null,null],[17,"EOVERFLOW","","",null,null],[17,"ENOTUNIQ","","",null,null],[17,"EBADFD","","",null,null],[17,"EREMCHG","","",null,null],[17,"ELIBACC","","",null,null],[17,"ELIBBAD","","",null,null],[17,"ELIBSCN","","",null,null],[17,"ELIBMAX","","",null,null],[17,"ELIBEXEC","","",null,null],[17,"EILSEQ","","",null,null],[17,"ERESTART","","",null,null],[17,"ESTRPIPE","","",null,null],[17,"EUSERS","","",null,null],[17,"ENOTSOCK","","",null,null],[17,"EDESTADDRREQ","","",null,null],[17,"EMSGSIZE","","",null,null],[17,"EPROTOTYPE","","",null,null],[17,"ENOPROTOOPT","","",null,null],[17,"EPROTONOSUPPORT","","",null,null],[17,"ESOCKTNOSUPPORT","","",null,null],[17,"EOPNOTSUPP","","",null,null],[17,"EPFNOSUPPORT","","",null,null],[17,"EAFNOSUPPORT","","",null,null],[17,"EADDRINUSE","","",null,null],[17,"EADDRNOTAVAIL","","",null,null],[17,"ENETDOWN","","",null,null],[17,"ENETUNREACH","","",null,null],[17,"ENETRESET","","",null,null],[17,"ECONNABORTED","","",null,null],[17,"ECONNRESET","","",null,null],[17,"ENOBUFS","","",null,null],[17,"EISCONN","","",null,null],[17,"ENOTCONN","","",null,null],[17,"ESHUTDOWN","","",null,null],[17,"ETOOMANYREFS","","",null,null],[17,"ETIMEDOUT","","",null,null],[17,"ECONNREFUSED","","",null,null],[17,"EHOSTDOWN","","",null,null],[17,"EHOSTUNREACH","","",null,null],[17,"EALREADY","","",null,null],[17,"EINPROGRESS","","",null,null],[17,"ESTALE","","",null,null],[17,"EUCLEAN","","",null,null],[17,"ENOTNAM","","",null,null],[17,"ENAVAIL","","",null,null],[17,"EISNAM","","",null,null],[17,"EREMOTEIO","","",null,null],[17,"EDQUOT","","",null,null],[17,"ENOMEDIUM","","",null,null],[17,"EMEDIUMTYPE","","",null,null],[17,"ECANCELED","","",null,null],[17,"ENOKEY","","",null,null],[17,"EKEYEXPIRED","","",null,null],[17,"EKEYREVOKED","","",null,null],[17,"EKEYREJECTED","","",null,null],[17,"EOWNERDEAD","","",null,null],[17,"ENOTRECOVERABLE","","",null,null],[17,"ERFKILL","","",null,null],[17,"EHWPOISON","","",null,null],[0,"posix01","libc::consts::os","",null,null],[17,"F_DUPFD","libc::consts::os::posix01","",null,null],[17,"F_GETFD","","",null,null],[17,"F_SETFD","","",null,null],[17,"F_GETFL","","",null,null],[17,"F_SETFL","","",null,null],[17,"SIGTRAP","","",null,null],[17,"SIG_IGN","","",null,null],[17,"GLOB_ERR","","",null,null],[17,"GLOB_MARK","","",null,null],[17,"GLOB_NOSORT","","",null,null],[17,"GLOB_DOOFFS","","",null,null],[17,"GLOB_NOCHECK","","",null,null],[17,"GLOB_APPEND","","",null,null],[17,"GLOB_NOESCAPE","","",null,null],[17,"GLOB_NOSPACE","","",null,null],[17,"GLOB_ABORTED","","",null,null],[17,"GLOB_NOMATCH","","",null,null],[17,"POSIX_MADV_NORMAL","","",null,null],[17,"POSIX_MADV_RANDOM","","",null,null],[17,"POSIX_MADV_SEQUENTIAL","","",null,null],[17,"POSIX_MADV_WILLNEED","","",null,null],[17,"POSIX_MADV_DONTNEED","","",null,null],[17,"_SC_MQ_PRIO_MAX","","",null,null],[17,"_SC_IOV_MAX","","",null,null],[17,"_SC_GETGR_R_SIZE_MAX","","",null,null],[17,"_SC_GETPW_R_SIZE_MAX","","",null,null],[17,"_SC_LOGIN_NAME_MAX","","",null,null],[17,"_SC_TTY_NAME_MAX","","",null,null],[17,"_SC_THREADS","","",null,null],[17,"_SC_THREAD_SAFE_FUNCTIONS","","",null,null],[17,"_SC_THREAD_DESTRUCTOR_ITERATIONS","","",null,null],[17,"_SC_THREAD_KEYS_MAX","","",null,null],[17,"_SC_THREAD_STACK_MIN","","",null,null],[17,"_SC_THREAD_THREADS_MAX","","",null,null],[17,"_SC_THREAD_ATTR_STACKADDR","","",null,null],[17,"_SC_THREAD_ATTR_STACKSIZE","","",null,null],[17,"_SC_THREAD_PRIORITY_SCHEDULING","","",null,null],[17,"_SC_THREAD_PRIO_INHERIT","","",null,null],[17,"_SC_THREAD_PRIO_PROTECT","","",null,null],[17,"_SC_THREAD_PROCESS_SHARED","","",null,null],[17,"_SC_ATEXIT_MAX","","",null,null],[17,"_SC_XOPEN_VERSION","","",null,null],[17,"_SC_XOPEN_XCU_VERSION","","",null,null],[17,"_SC_XOPEN_UNIX","","",null,null],[17,"_SC_XOPEN_CRYPT","","",null,null],[17,"_SC_XOPEN_ENH_I18N","","",null,null],[17,"_SC_XOPEN_SHM","","",null,null],[17,"_SC_XOPEN_LEGACY","","",null,null],[17,"_SC_XOPEN_REALTIME","","",null,null],[17,"_SC_XOPEN_REALTIME_THREADS","","",null,null],[17,"PTHREAD_CREATE_JOINABLE","","",null,null],[17,"PTHREAD_CREATE_DETACHED","","",null,null],[17,"PTHREAD_STACK_MIN","","",null,null],[17,"CLOCK_REALTIME","","",null,null],[17,"CLOCK_MONOTONIC","","",null,null],[17,"RLIMIT_CPU","","",null,null],[17,"RLIMIT_FSIZE","","",null,null],[17,"RLIMIT_DATA","","",null,null],[17,"RLIMIT_STACK","","",null,null],[17,"RLIMIT_CORE","","",null,null],[17,"RLIMIT_RSS","","",null,null],[17,"RLIMIT_NOFILE","","",null,null],[17,"RLIMIT_AS","","",null,null],[17,"RLIMIT_NPROC","","",null,null],[17,"RLIMIT_MEMLOCK","","",null,null],[17,"RLIMIT_LOCKS","","",null,null],[17,"RLIMIT_SIGPENDING","","",null,null],[17,"RLIMIT_MSGQUEUE","","",null,null],[17,"RLIMIT_NICE","","",null,null],[17,"RLIMIT_RTPRIO","","",null,null],[17,"RLIMIT_RTTIME","","",null,null],[17,"RLIMIT_NLIMITS","","",null,null],[17,"RLIM_INFINITY","","",null,null],[17,"RLIM_SAVED_MAX","","",null,null],[17,"RLIM_SAVED_CUR","","",null,null],[17,"RUSAGE_SELF","","",null,null],[17,"RUSAGE_CHILDREN","","",null,null],[17,"RUSAGE_THREAD","","",null,null],[0,"bsd44","libc::consts::os","",null,null],[17,"MADV_NORMAL","libc::consts::os::bsd44","",null,null],[17,"MADV_RANDOM","","",null,null],[17,"MADV_SEQUENTIAL","","",null,null],[17,"MADV_WILLNEED","","",null,null],[17,"MADV_DONTNEED","","",null,null],[17,"MADV_REMOVE","","",null,null],[17,"MADV_DONTFORK","","",null,null],[17,"MADV_DOFORK","","",null,null],[17,"MADV_MERGEABLE","","",null,null],[17,"MADV_UNMERGEABLE","","",null,null],[17,"MADV_HWPOISON","","",null,null],[17,"IFF_LOOPBACK","","",null,null],[17,"AF_UNIX","","",null,null],[17,"AF_INET","","",null,null],[17,"AF_INET6","","",null,null],[17,"SOCK_STREAM","","",null,null],[17,"SOCK_DGRAM","","",null,null],[17,"SOCK_RAW","","",null,null],[17,"IPPROTO_TCP","","",null,null],[17,"IPPROTO_IP","","",null,null],[17,"IPPROTO_IPV6","","",null,null],[17,"IP_MULTICAST_TTL","","",null,null],[17,"IP_MULTICAST_LOOP","","",null,null],[17,"IP_TTL","","",null,null],[17,"IP_HDRINCL","","",null,null],[17,"IP_ADD_MEMBERSHIP","","",null,null],[17,"IP_DROP_MEMBERSHIP","","",null,null],[17,"IPV6_ADD_MEMBERSHIP","","",null,null],[17,"IPV6_DROP_MEMBERSHIP","","",null,null],[17,"TCP_NODELAY","","",null,null],[17,"SOL_SOCKET","","",null,null],[17,"SO_DEBUG","","",null,null],[17,"SO_REUSEADDR","","",null,null],[17,"SO_TYPE","","",null,null],[17,"SO_ERROR","","",null,null],[17,"SO_DONTROUTE","","",null,null],[17,"SO_BROADCAST","","",null,null],[17,"SO_SNDBUF","","",null,null],[17,"SO_RCVBUF","","",null,null],[17,"SO_KEEPALIVE","","",null,null],[17,"SO_OOBINLINE","","",null,null],[17,"SO_LINGER","","",null,null],[17,"SO_REUSEPORT","","",null,null],[17,"SO_RCVLOWAT","","",null,null],[17,"SO_SNDLOWAT","","",null,null],[17,"SO_RCVTIMEO","","",null,null],[17,"SO_SNDTIMEO","","",null,null],[17,"SO_ACCEPTCONN","","",null,null],[17,"SHUT_RD","","",null,null],[17,"SHUT_WR","","",null,null],[17,"SHUT_RDWR","","",null,null],[0,"extra","libc::consts::os","",null,null],[17,"AF_PACKET","libc::consts::os::extra","",null,null],[17,"IPPROTO_RAW","","",null,null],[17,"O_RSYNC","","",null,null],[17,"O_DSYNC","","",null,null],[17,"O_NONBLOCK","","",null,null],[17,"O_SYNC","","",null,null],[17,"PROT_GROWSDOWN","","",null,null],[17,"PROT_GROWSUP","","",null,null],[17,"MAP_TYPE","","",null,null],[17,"MAP_ANONYMOUS","","",null,null],[17,"MAP_32BIT","","",null,null],[17,"MAP_GROWSDOWN","","",null,null],[17,"MAP_DENYWRITE","","",null,null],[17,"MAP_EXECUTABLE","","",null,null],[17,"MAP_LOCKED","","",null,null],[17,"MAP_NORESERVE","","",null,null],[17,"MAP_POPULATE","","",null,null],[17,"MAP_NONBLOCK","","",null,null],[17,"MAP_STACK","","",null,null],[0,"sysconf","libc::consts::os","",null,null],[17,"_SC_ARG_MAX","libc::consts::os::sysconf","",null,null],[17,"_SC_CHILD_MAX","","",null,null],[17,"_SC_CLK_TCK","","",null,null],[17,"_SC_NGROUPS_MAX","","",null,null],[17,"_SC_OPEN_MAX","","",null,null],[17,"_SC_STREAM_MAX","","",null,null],[17,"_SC_TZNAME_MAX","","",null,null],[17,"_SC_JOB_CONTROL","","",null,null],[17,"_SC_SAVED_IDS","","",null,null],[17,"_SC_REALTIME_SIGNALS","","",null,null],[17,"_SC_PRIORITY_SCHEDULING","","",null,null],[17,"_SC_TIMERS","","",null,null],[17,"_SC_ASYNCHRONOUS_IO","","",null,null],[17,"_SC_PRIORITIZED_IO","","",null,null],[17,"_SC_SYNCHRONIZED_IO","","",null,null],[17,"_SC_FSYNC","","",null,null],[17,"_SC_MAPPED_FILES","","",null,null],[17,"_SC_MEMLOCK","","",null,null],[17,"_SC_MEMLOCK_RANGE","","",null,null],[17,"_SC_MEMORY_PROTECTION","","",null,null],[17,"_SC_MESSAGE_PASSING","","",null,null],[17,"_SC_SEMAPHORES","","",null,null],[17,"_SC_SHARED_MEMORY_OBJECTS","","",null,null],[17,"_SC_AIO_LISTIO_MAX","","",null,null],[17,"_SC_AIO_MAX","","",null,null],[17,"_SC_AIO_PRIO_DELTA_MAX","","",null,null],[17,"_SC_DELAYTIMER_MAX","","",null,null],[17,"_SC_MQ_OPEN_MAX","","",null,null],[17,"_SC_VERSION","","",null,null],[17,"_SC_PAGESIZE","","",null,null],[17,"_SC_RTSIG_MAX","","",null,null],[17,"_SC_SEM_NSEMS_MAX","","",null,null],[17,"_SC_SEM_VALUE_MAX","","",null,null],[17,"_SC_SIGQUEUE_MAX","","",null,null],[17,"_SC_TIMER_MAX","","",null,null],[17,"_SC_BC_BASE_MAX","","",null,null],[17,"_SC_BC_DIM_MAX","","",null,null],[17,"_SC_BC_SCALE_MAX","","",null,null],[17,"_SC_BC_STRING_MAX","","",null,null],[17,"_SC_COLL_WEIGHTS_MAX","","",null,null],[17,"_SC_EXPR_NEST_MAX","","",null,null],[17,"_SC_LINE_MAX","","",null,null],[17,"_SC_RE_DUP_MAX","","",null,null],[17,"_SC_2_VERSION","","",null,null],[17,"_SC_2_C_BIND","","",null,null],[17,"_SC_2_C_DEV","","",null,null],[17,"_SC_2_FORT_DEV","","",null,null],[17,"_SC_2_FORT_RUN","","",null,null],[17,"_SC_2_SW_DEV","","",null,null],[17,"_SC_2_LOCALEDEF","","",null,null],[17,"_SC_NPROCESSORS_ONLN","","",null,null],[17,"_SC_2_CHAR_TERM","","",null,null],[17,"_SC_2_C_VERSION","","",null,null],[17,"_SC_2_UPE","","",null,null],[17,"_SC_XBS5_ILP32_OFF32","","",null,null],[17,"_SC_XBS5_ILP32_OFFBIG","","",null,null],[17,"_SC_XBS5_LPBIG_OFFBIG","","",null,null],[0,"funcs","libc","",null,null],[0,"c95","libc::funcs","",null,null],[0,"ctype","libc::funcs::c95","",null,null],[5,"isalnum","libc::funcs::c95::ctype","",null,null],[5,"isalpha","","",null,null],[5,"iscntrl","","",null,null],[5,"isdigit","","",null,null],[5,"isgraph","","",null,null],[5,"islower","","",null,null],[5,"isprint","","",null,null],[5,"ispunct","","",null,null],[5,"isspace","","",null,null],[5,"isupper","","",null,null],[5,"isxdigit","","",null,null],[5,"tolower","","",null,null],[5,"toupper","","",null,null],[0,"stdio","libc::funcs::c95","",null,null],[5,"fopen","libc::funcs::c95::stdio","",null,null],[5,"freopen","","",null,null],[5,"fflush","","",null,null],[5,"fclose","","",null,null],[5,"remove","","",null,null],[5,"rename","","",null,null],[5,"tmpfile","","",null,null],[5,"setvbuf","","",null,null],[5,"setbuf","","",null,null],[5,"fgetc","","",null,null],[5,"fgets","","",null,null],[5,"fputc","","",null,null],[5,"fputs","","",null,null],[5,"puts","","",null,null],[5,"ungetc","","",null,null],[5,"fread","","",null,null],[5,"fwrite","","",null,null],[5,"fseek","","",null,null],[5,"ftell","","",null,null],[5,"rewind","","",null,null],[5,"fgetpos","","",null,null],[5,"fsetpos","","",null,null],[5,"feof","","",null,null],[5,"ferror","","",null,null],[5,"perror","","",null,null],[0,"stdlib","libc::funcs::c95","",null,null],[5,"abs","libc::funcs::c95::stdlib","",null,null],[5,"labs","","",null,null],[5,"atof","","",null,null],[5,"atoi","","",null,null],[5,"strtod","","",null,null],[5,"strtol","","",null,null],[5,"strtoul","","",null,null],[5,"calloc","","",null,null],[5,"malloc","","",null,null],[5,"realloc","","",null,null],[5,"free","","",null,null],[5,"exit","","Exits the running program in a possibly dangerous manner.",null,null],[5,"_exit","","",null,null],[5,"atexit","","",null,null],[5,"system","","",null,null],[5,"getenv","","",null,null],[5,"rand","","",null,null],[5,"srand","","",null,null],[0,"string","libc::funcs::c95","",null,null],[5,"strcpy","libc::funcs::c95::string","",null,null],[5,"strncpy","","",null,null],[5,"strcat","","",null,null],[5,"strncat","","",null,null],[5,"strcmp","","",null,null],[5,"strncmp","","",null,null],[5,"strcoll","","",null,null],[5,"strchr","","",null,null],[5,"strrchr","","",null,null],[5,"strspn","","",null,null],[5,"strcspn","","",null,null],[5,"strpbrk","","",null,null],[5,"strstr","","",null,null],[5,"strlen","","",null,null],[5,"strerror","","",null,null],[5,"strtok","","",null,null],[5,"strxfrm","","",null,null],[5,"wcslen","","",null,null],[5,"memcmp","","",null,null],[5,"memchr","","",null,null],[0,"posix88","libc::funcs","",null,null],[0,"stat_","libc::funcs::posix88","",null,null],[5,"chmod","libc::funcs::posix88::stat_","",null,null],[5,"fchmod","","",null,null],[5,"fstat","","",null,null],[5,"mkdir","","",null,null],[5,"mkfifo","","",null,null],[5,"stat","","",null,null],[0,"stdio","libc::funcs::posix88","",null,null],[5,"popen","libc::funcs::posix88::stdio","",null,null],[5,"pclose","","",null,null],[5,"fdopen","","",null,null],[5,"fileno","","",null,null],[0,"fcntl","libc::funcs::posix88","",null,null],[5,"open","libc::funcs::posix88::fcntl","",null,null],[5,"creat","","",null,null],[5,"fcntl","","",null,null],[0,"dirent","libc::funcs::posix88","",null,null],[5,"opendir","libc::funcs::posix88::dirent","",null,null],[5,"readdir_r","","",null,null],[5,"closedir","","",null,null],[5,"rewinddir","","",null,null],[5,"seekdir","","",null,null],[5,"telldir","","",null,null],[0,"unistd","libc::funcs::posix88","",null,null],[5,"access","libc::funcs::posix88::unistd","",null,null],[5,"alarm","","",null,null],[5,"chdir","","",null,null],[5,"chown","","",null,null],[5,"close","","",null,null],[5,"dup","","",null,null],[5,"dup2","","",null,null],[5,"execv","","",null,null],[5,"execve","","",null,null],[5,"execvp","","",null,null],[5,"fork","","",null,null],[5,"fpathconf","","",null,null],[5,"getcwd","","",null,null],[5,"getegid","","",null,null],[5,"geteuid","","",null,null],[5,"getgid","","",null,null],[5,"getgroups","","",null,null],[5,"getlogin","","",null,null],[5,"getopt","","",null,null],[5,"getpgrp","","",null,null],[5,"getpid","","",null,null],[5,"getppid","","",null,null],[5,"getuid","","",null,null],[5,"getsid","","",null,null],[5,"isatty","","",null,null],[5,"link","","",null,null],[5,"lseek","","",null,null],[5,"pathconf","","",null,null],[5,"pause","","",null,null],[5,"pipe","","",null,null],[5,"read","","",null,null],[5,"rmdir","","",null,null],[5,"setgid","","",null,null],[5,"setpgid","","",null,null],[5,"setsid","","",null,null],[5,"setuid","","",null,null],[5,"sleep","","",null,null],[5,"usleep","","",null,null],[5,"nanosleep","","",null,null],[5,"sysconf","","",null,null],[5,"tcgetpgrp","","",null,null],[5,"ttyname","","",null,null],[5,"unlink","","",null,null],[5,"write","","",null,null],[5,"pread","","",null,null],[5,"pwrite","","",null,null],[5,"utime","","",null,null],[17,"_PC_NAME_MAX","","",null,null],[0,"signal","libc::funcs::posix88","",null,null],[5,"kill","libc::funcs::posix88::signal","",null,null],[0,"mman","libc::funcs::posix88","",null,null],[5,"mlock","libc::funcs::posix88::mman","",null,null],[5,"munlock","","",null,null],[5,"mlockall","","",null,null],[5,"munlockall","","",null,null],[5,"mprotect","","",null,null],[5,"msync","","",null,null],[5,"shm_open","","",null,null],[5,"shm_unlink","","",null,null],[5,"mmap","","",null,null],[5,"munmap","","",null,null],[0,"net","libc::funcs::posix88","",null,null],[5,"if_nametoindex","libc::funcs::posix88::net","",null,null],[0,"posix01","libc::funcs","",null,null],[0,"stat_","libc::funcs::posix01","",null,null],[5,"lstat","libc::funcs::posix01::stat_","",null,null],[0,"unistd","libc::funcs::posix01","",null,null],[5,"readlink","libc::funcs::posix01::unistd","",null,null],[5,"fsync","","",null,null],[5,"fdatasync","","",null,null],[5,"setenv","","",null,null],[5,"unsetenv","","",null,null],[5,"putenv","","",null,null],[5,"symlink","","",null,null],[5,"ftruncate","","",null,null],[0,"signal","libc::funcs::posix01","",null,null],[5,"signal","libc::funcs::posix01::signal","",null,null],[0,"glob","libc::funcs::posix01","",null,null],[5,"glob","libc::funcs::posix01::glob","",null,null],[5,"globfree","","",null,null],[0,"mman","libc::funcs::posix01","",null,null],[5,"posix_madvise","libc::funcs::posix01::mman","",null,null],[0,"resource","libc::funcs::posix01","",null,null],[5,"getrlimit","libc::funcs::posix01::resource","",null,null],[5,"setrlimit","","",null,null],[5,"getrusage","","",null,null],[0,"bsd43","libc::funcs","",null,null],[5,"socket","libc::funcs::bsd43","",null,null],[5,"connect","","",null,null],[5,"bind","","",null,null],[5,"listen","","",null,null],[5,"accept","","",null,null],[5,"getpeername","","",null,null],[5,"getsockname","","",null,null],[5,"setsockopt","","",null,null],[5,"recv","","",null,null],[5,"send","","",null,null],[5,"recvfrom","","",null,null],[5,"sendto","","",null,null],[5,"getifaddrs","","",null,null],[5,"freeifaddrs","","",null,null],[5,"shutdown","","",null,null],[0,"bsd44","libc::funcs","",null,null],[5,"getdtablesize","libc::funcs::bsd44","",null,null],[5,"ioctl","","",null,null],[5,"madvise","","",null,null],[5,"mincore","","",null,null]],"paths":[[4,"c_void"],[3,"glob_t"],[3,"timeval"],[3,"timespec"],[3,"rlimit"],[3,"rusage"],[3,"sockaddr"],[3,"sockaddr_storage"],[3,"sockaddr_in"],[3,"in_addr"],[3,"sockaddr_in6"],[3,"in6_addr"],[3,"ip_mreq"],[3,"ip6_mreq"],[3,"addrinfo"],[3,"sockaddr_un"],[3,"ifaddrs"],[3,"stat"],[3,"utimbuf"],[3,"pthread_attr_t"],[3,"sockaddr_ll"]]};
initSearch(searchIndex);
